/// <reference path="../../pxtlib.d.ts" />
import { FieldAssetEditor } from "./field_asset";
export interface FieldTilemapOptions {
    initWidth: string;
    initHeight: string;
    disableResize: string;
    tileWidth: string | number;
    filter?: string;
    lightMode: boolean;
}
interface ParsedFieldTilemapOptions {
    initWidth: number;
    initHeight: number;
    disableResize: boolean;
    tileWidth: 4 | 8 | 16 | 32;
    filter?: string;
    lightMode: boolean;
}
export declare class FieldTilemap extends FieldAssetEditor<FieldTilemapOptions, ParsedFieldTilemapOptions> {
    protected initText: string;
    protected asset: pxt.ProjectTilemap;
    getInitText(): string;
    getTileset(): pxt.TileSet;
    protected getAssetType(): pxt.AssetType;
    protected createNewAsset(newText?: string): pxt.Asset;
    protected onEditorClose(newValue: pxt.ProjectTilemap): void;
    protected getValueText(): string;
    protected parseFieldOptions(opts: FieldTilemapOptions): ParsedFieldTilemapOptions;
}
export {};
