import * as Blockly from "blockly";
export declare const DUPLICATE_ON_DRAG_MUTATION_KEY = "duplicateondrag";
export declare function setDraggableShadowBlocks(ids: string[]): void;
/**
 * Configures duplicate on drag for a block's child inputs
 *
 * @param parentBlockType   The type of the parent block
 * @param inputName         The value input to duplicate blocks on when dragged. If not
 *                          specified, all child value inputs will be duplicated
 * @param childBlockType    The type of the child block to be duplicated. If not specified,
 *                          any block attached to the input will be duplicated on drag
 *                          regardless of type
 */
export declare function setDuplicateOnDrag(parentBlockType: string, inputName?: string, childBlockType?: string): void;
export declare function isAllowlistedShadow(block: Blockly.Block): boolean;
export declare function shouldDuplicateOnDrag(block: Blockly.Block): boolean;
