/// <reference path="../pxtlib.d.ts" />
/// <reference path="../../localtypings/pxteditor.d.ts" />
import * as Blockly from "blockly";
export interface BlocksRenderOptions {
    emPixels?: number;
    layout?: pxt.editor.BlockLayout;
    clean?: boolean;
    aspectRatio?: number;
    packageId?: string;
    package?: string;
    snippetMode?: boolean;
    useViewWidth?: boolean;
    splitSvg?: boolean;
    forceCompilation?: boolean;
    generateSourceMap?: boolean;
    assets?: pxt.Map<string>;
}
export declare function initRenderingWorkspace(): Blockly.WorkspaceSvg;
export declare function cleanRenderingWorkspace(): void;
export declare function renderWorkspace(options?: BlocksRenderOptions): Element;
export declare function render(blocksXml: string, options?: BlocksRenderOptions): Element;
export declare function blocksMetrics(ws: Blockly.WorkspaceSvg): {
    width: number;
    height: number;
};
