/// <reference path="../../pxtlib.d.ts" />
export declare class TestHost implements pxt.Host {
    name: string;
    packageFiles: pxt.Map<string>;
    extraDependencies: string[];
    private includeCommon;
    static files: pxt.Map<pxt.Map<string>>;
    constructor(name: string, packageFiles: pxt.Map<string>, extraDependencies: string[], includeCommon?: boolean);
    resolve(module: pxt.Package, filename: string): string;
    readFile(module: pxt.Package, filename: string): string;
    writeFile(module: pxt.Package, filename: string, contents: string): void;
    getHexInfoAsync(extInfo: pxtc.ExtensionInfo): Promise<pxtc.HexInfo>;
    cacheStoreAsync(id: string, val: string): Promise<void>;
    cacheGetAsync(id: string): Promise<string>;
    downloadPackageAsync(pkg: pxt.Package): Promise<void>;
    resolveVersionAsync(pkg: pxt.Package): Promise<string>;
    private get dependencies();
}
