# Commit

On GitHub, **saved changes** are called **commits**. Each commit has an associated commit message, which is a description explaining why a particular change was made. Commit messages capture the history of your changes, so other contributors can understand what you’ve done and why.

## Commit & push

Make any change in the code editor and you will notice that an up arrow is displayed
on the **GitHub** button. The arrow means that there are **local** changes. They are stored on your computer and they need to get saved on GitHub. Click on that button to open the **GitHub view**.

The GitHub view contains the [diffs](/github/diff) that represent every **local** change.
If the changes look correct, click on **commit & push changes** to create a **commit** of the changes and **push** them to GitHub. Once the commit is pushed, all of your code is safely stored in GitHub!

## Review & revert

It's good practice to **review** your **local** changes before commiting; just like you review your answer sheet before turning in a test. If you find some changes that are incorrect, you can decide to fix them right away, **revert** the entire file, or even just **commit** them so you can make any fixes later.

## See Also

[GitHub Commit Documentation](https://help.github.com/en/categories/committing-changes-to-your-project)
