# Sign up

If you don't have a GitHub account already, you'll need to create one before you can login. After you log in, you can make a repository and commit (save) projects and the changes to it.

## Sign in page

If you aren't logged in, you'll be sent to a GitHub sign in page when you press the GitHub button in the editor. This is where you enter your GitHub username and password. You will see this page when you login for the first time or if you haven't logged in for awhile.

![sign in page](/static/github/signup/signin.png)

## Create an account

If you can't login because you need an account, there is a link at the bottom you click to create one.

![Create account link](/static/github/signup/create-account-link.png)

### Create account page

The [Create an account](#) link will take you to the **"Create your account"** page where you will make a username, enter your email address, and create a password.

![Create account page](/static/github/signup/create-account-page.png)

### Make a username

You will need to think of a username for use for your new account. You can try to use your name or something else like a nickname.

![Invalid username](/static/github/signup/username-invalid.png)

There are many of users already on GitHub so the username you might want you use could already be assigned to someone else. You can try to use another name or add some extra characters to your first choice to help make it unique.

![Valid username](/static/github/signup/username-valid.png)

In the examples just shown, the user tried to use their name "Noelle" as a username. That username is already taken, so adding the "7" to the end of the username choice will make it unique.

### ~ hint

#### Teacher and student users

If you are a teacher, you may first want create your own GitHub account. You can then let students create their own accounts and assist them in choosing usernames if they have trouble creating one that is unique.

If your students will create their own repositories for [private assignments](/github/private-assignments), have them add your username as a collaborator to the repository.

### ~

### Enter email and create password

GitHub signup requires an email address. The email address is used for user verification and to later send user notifications.

A user password is also required and you create the password using the rules noted next to the password field.

![Enter email and password](/static/github/signup/email-password.png)

### ~ hint

#### Student email accounts

It's possible that not every student has their own email account. If your school doesn't issue email accounts for students, or might block mail from GitHub with an issued account, then the student will not be able to make a GitHub account. In that case, you will need to arrange that the student work with someone who has email and can create a GitHub account.

### ~