# Cloud Synchronization in MakeCode

## What is Cloud Sync?

Cloud Synchronization, or Cloud Sync, is a feature available to signed-in users that saves your MakeCode projects and tutorial progress to the cloud. This means you can access your work from any computer.

## How do I enable Cloud Sync?

All you need to do is sign in to MakeCode with an online account and Cloud Sync is automatically enabled - so any new project you create, tutorial you start, or any existing project you open will be automatically saved to the cloud. To learn more about how to sign-in, visit [Online Accounts and MakeCode](/identity/sign-in). 

## Does it cost money?

No. The Cloud Sync feature is free.

## What are the limits?

Individual projects must be less than 512K bytes in size to be synced to cloud. You may store up to 1000 projects in the cloud.

## When is a project saved to the cloud?

Projects are transferred to the cloud the next time they’re opened for editing. When you first sign in, your local projects remain local (saved in the browser’s cache). To transfer a project to the cloud, just open it in the editor. The projects that are saved to the cloud will appear with a Cloud icon on them.
 
![Home screen project cards](/static/identity/project-cards.png)

## How can I tell if my edits to a project have been saved to the cloud?

At the bottom of the editor, look for the cloud status indicator. You should notice it automatically saving to the cloud as you edit your project.

![Cloud status inidicator](/static/identity/saving.gif)

## What if I edit the project in two places?

If you’re editing a project in two places at the same time, you may make changes that conflict. When this happens, the editor that detected the conflict will resolve it by making a copy of the project and applying the conflicting change to the new one. At this point the two browsers will be editing different projects.

## Is anything else saved to cloud?

If you’ve set your High Contrast or Language settings, they will be cloud-synchronized too.

## When I sign out all my projects disappeared! What happened?

When you’re signed out, your cloud projects aren’t shown until you sign in again. Instead, you’ll see just one card on under **My Projects** for all of the projects saved in the cloud. You can just click on this card to sign in and see those projects again.

![Cloud projects card](/static/identity/cloud-projects.png)

## #target-specific