# Online Accounts and MakeCode

## What is an Online Account?

An online account is a user account with a reputable provider of online services. While MakeCode does not have its own accounts, MakeCode does allow you to sign-in using an online account with either Microsoft, Google, or Clever.

### Microsoft Account

A Microsoft account may either be a personal or a work/school user account. You can also create a Microsoft account using your existing email address. To learn more about Microsoft accounts and see if you have one, visit https://account.microsoft.com/account.

### Google Account

Google accounts may also be personal or work/school user accounts. To learn more about Google accounts and see if you have one, visit https://www.google.com/account/about.

### Clever Account

Clever is an educational identity provider used by many schools to aggregate student data and applications in a safe and secure manner. Schools with Clever can find the MakeCode apps in the Clever Library and users can login using their Clever accounts. To learn more about Clever, please visit https://www.clever.com.

## What’s the benefit of signing in to MakeCode?

MakeCode doesn’t require you to sign in with an online account to use the product. However, it is recommended in order to reliably save your work and progress to the cloud. This also allows you to access your projects from any computer. When you are logged-in, you can also create persistent project sharing links which allow you use a single published URL for a project, even if you make subsequent changes. To learn more, see [Cloud Synchronization in MakeCode](/identity/cloud-sync) and [Sharing your project](/share).

## Is it required?

No. Sign in only if you want to take advantage of features like saving your projects to the cloud.

## Does it cost money?

No. Using an online account with MakeCode is free.

## What will other users see?

Nothing. Your signed in status is visible only to you.

## What if I don’t have a Microsoft, Google or Clever account?

You can create a Microsoft or Google account using your current email address for free and check with your school if you already have a Clever account. But remember, you can still use MakeCode even without an account.

## Can I use my school or work account?

Yes. If your school or employer’s email system is managed by Microsoft, Google or Clever, then it will work in MakeCode subject to restrictions put in place by your IT department.

## When I sign in, what information does MakeCode collect about me?

The privacy and safety of our users is very important to us. Microsoft MakeCode adheres to Microsoft’s [Privacy Policies](https://makecode.com/privacy). We do not collect or use personal data beyond that needed to operate and support MakeCode features and services. Read the MakeCode [Privacy Frequently Asked Questions](https://makecode.com/privacy-faq) page for more information.

## How can I completely remove my data and profile information?

After you sign into MakeCode, you can delete your user profile and all associated data at any time by clicking on **'My Profile'** and selecting **'Delete Profile'**. This will remove you from our system and permanently delete all your cloud saved information.

When my profile is deleted, do all of my cloud projects just vanish?
No. At the time you delete your profile, all of your cloud saved projects are exported and saved locally to the current browser on the computer or device you are using.

## How does this work with GitHub?

GitHub provides a source code repository for your projects to help with version control. You can still sign into MakeCode with a Microsoft, Google or Clever Account and use Cloud Sync to store your projects in the cloud, even while using GitHub. To learn more, visit [GitHub with MakeCode](/github).

## We use Google school accounts and I’m having trouble accessing MakeCode, what do I need to do?

Google Workspace for Education made some changes in October 2023 that require schools to explicitly authorize any 3rd party applications. Please work with your IT Administrator to make the following changes in the Google Admin Console to enable use of MakeCode with Google accounts:

1. Sign in to your Google Admin console using an administrator account at https://admin.google.com
2. In the Admin console, go to **Menu | Security | Access and data control | API controls**
3. Click **Manage Third-Party App Access** 
4. For **Configured apps**, click **Add app**
5. Choose **OAuth App Name**, type in "MakeCode" and click Search
6. Select MakeCode and click **Continue**
7. Select **Trusted** app option
8. Click **Finish**

For more information about these changes, please see [Confirm your third-party app settings]( https://support.google.com/a/answer/13289151). For more information about Google Workspace settings, please visit the [Google Help Center]( https://support.google.com/a/answer/7281227).

## My school has Clever but I can’t find the MakeCode apps in the Library, what should I do?

If you can’t find the MakeCode apps in the Clever Library, it’s possible you’re in a district that allows apps for classroom use only on a case-by-case basis. Please contact your district IT administrator for help with allowing the MakeCode apps within your district.
