# Statements

The following JavaScript statements are supported:

## Variable declarations
* [`const` statement](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Statements/const)
* [`let` statement](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Statements/let)

## Block-structured statements

* [`{ }` block statement](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Statements/block)
* [`if-else` conditional statement](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Statements/if...else)
* [`while` loop](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Statements/while)
* [`do-while` loop](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Statements/do...while)
* [`for(;;)` loop](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Statements/for)
* [`switch` statement (on numbers only)](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Statements/switch)

## Control-flow commands

* [`break` statement](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Statements/break)
* [`continue` statement](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Statements/continue)
* [`return` statement](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Statements/return)
* [`debugger` statement for breakpoints](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Statements/debugger)

## Labeling statements

* [`label:` statement](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Statements/label)
* [`default` statement](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Statements/default)