# Sharing your project

There are a few different methods to share your MakeCode projects and for places to share your projects to.

## Anonymous Share Link

If you are not signed-in to MakeCode, you can create an anonymous link to your project that you can share with others. On the top right, click the Share icon:

![Share icon](/static/share/share-icon.png)

Give your project a Title and optionally, you can create a thumbnail image or animated GIF of your project.

![Share project](/static/share/share-project.png)

Clicking "Share Project" will create a link to your project.

![Share project anonomously](/static/share/anon-share-link.png)

This link is not published anywhere else and it is not tied to a specific user (it’s an "anonymous link"). If you lose the link, then there’s no way to get it back - you will have to share your project again to create a new link. These links are snapshots in time of a project, so if you make any subsequent changes to your project, you will have to Share your project again to create a new link with the changes. There is also no way to remove or "unpublish" an anonymous share link, except through the "Report Abuse" function (see below for more information).

## Persistent Share Link

If you sign-in to MakeCode, you can create a persistent share link for your project. This means that you can create one link to a project, share it with others, or include it in curriculum. Then, for any subsequent changes you make to the project, you can keep the same link. For more information on signing in to MakeCode, see [Online Accounts and MakeCode](/identity/sign-in).

Persistent share links start with an "S" followed by a series of numbers.

![Persistent share link](/static/share/persist-share-link.png)

If you want to update or publish changes to a shared project, click to share it again and select the "Update existing share link for this project" checkbox.

![Update link](/static/share/update-link.png)

## Sharing to Google Classroom or Microsoft Teams

As well as being able to share projects to popular social media sites, users can also share their projects to Learning Management Systems (LMS) like Google Classroom or Microsoft Teams. In the Share Project window, click on the appropriate icon and you will be prompted to sign into the LMS and select where you want to share to.

![Share project using LMS](/static/share/share-lms.png)

![Share project to MS Teams](/static/share/share-teams.png)

## Sharing to Mobile devices

For sharing projects to phones or other mobile devices, you can use your device’s camera to capture the QR code in the Share Project window.

![Share project with QR code](/static/share/share-qr-code.png)

## Embedding into a blog or web site

MakeCode projects can also be embedded into a blog or web site. In the Share Project window, click on the Embed icon and copy/paste the HTML content. You can choose to embed just the project code, a read-only view of the editor, or just the simulator part of the project.

![Share project with embedded HTML](/static/share/share-embed.png)

## Editing Shared Projects #editing

By default, all shared projects in MakeCode can be copied and edited. There is no way to share a read-only project, or a project where people can’t make a copy or can’t see the code. Any edits they make will not change the original project - if they want to share their changes back, they will have to create a new share link.

![Edit shared project button](/static/share/edit-shared-project.png)

## Report Abuse

All MakeCode shared projects pass through Microsoft standard scanning for security and safety compliance. In addition, the "Report Abuse" option is available on any shared project if you deem the contents of the project not appropriate (contains unsafe content or includes personally identifiable information). For these types of projects, the MakeCode Team will remove the project from our databases. 

![Report abuse link](/static/share/report-abuse.png)
