/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved. 
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0  
 
THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE, 
MERCHANTABLITY OR NON-INFRINGEMENT. 
 
See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
"use strict";var __assign=this&&this.__assign||Object.assign||function(e){for(var t,n=1,r=arguments.length;n<r;n++)for(var i in t=arguments[n])Object.prototype.hasOwnProperty.call(t,i)&&(e[i]=t[i]);return e},__extends=this&&this.__extends||function(){var e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}();!function(e){!function(e){e[e.Unknown=0]="Unknown",e[e.EndOfFileToken=1]="EndOfFileToken",e[e.SingleLineCommentTrivia=2]="SingleLineCommentTrivia",e[e.MultiLineCommentTrivia=3]="MultiLineCommentTrivia",e[e.NewLineTrivia=4]="NewLineTrivia",e[e.WhitespaceTrivia=5]="WhitespaceTrivia",e[e.ShebangTrivia=6]="ShebangTrivia",e[e.ConflictMarkerTrivia=7]="ConflictMarkerTrivia",e[e.NumericLiteral=8]="NumericLiteral",e[e.StringLiteral=9]="StringLiteral",e[e.JsxText=10]="JsxText",e[e.JsxTextAllWhiteSpaces=11]="JsxTextAllWhiteSpaces",e[e.RegularExpressionLiteral=12]="RegularExpressionLiteral",e[e.NoSubstitutionTemplateLiteral=13]="NoSubstitutionTemplateLiteral",e[e.TemplateHead=14]="TemplateHead",e[e.TemplateMiddle=15]="TemplateMiddle",e[e.TemplateTail=16]="TemplateTail",e[e.OpenBraceToken=17]="OpenBraceToken",e[e.CloseBraceToken=18]="CloseBraceToken",e[e.OpenParenToken=19]="OpenParenToken",e[e.CloseParenToken=20]="CloseParenToken",e[e.OpenBracketToken=21]="OpenBracketToken",e[e.CloseBracketToken=22]="CloseBracketToken",e[e.DotToken=23]="DotToken",e[e.DotDotDotToken=24]="DotDotDotToken",e[e.SemicolonToken=25]="SemicolonToken",e[e.CommaToken=26]="CommaToken",e[e.LessThanToken=27]="LessThanToken",e[e.LessThanSlashToken=28]="LessThanSlashToken",e[e.GreaterThanToken=29]="GreaterThanToken",e[e.LessThanEqualsToken=30]="LessThanEqualsToken",e[e.GreaterThanEqualsToken=31]="GreaterThanEqualsToken",e[e.EqualsEqualsToken=32]="EqualsEqualsToken",e[e.ExclamationEqualsToken=33]="ExclamationEqualsToken",e[e.EqualsEqualsEqualsToken=34]="EqualsEqualsEqualsToken",e[e.ExclamationEqualsEqualsToken=35]="ExclamationEqualsEqualsToken",e[e.EqualsGreaterThanToken=36]="EqualsGreaterThanToken",e[e.PlusToken=37]="PlusToken",e[e.MinusToken=38]="MinusToken",e[e.AsteriskToken=39]="AsteriskToken",e[e.AsteriskAsteriskToken=40]="AsteriskAsteriskToken",e[e.SlashToken=41]="SlashToken",e[e.PercentToken=42]="PercentToken",e[e.PlusPlusToken=43]="PlusPlusToken",e[e.MinusMinusToken=44]="MinusMinusToken",e[e.LessThanLessThanToken=45]="LessThanLessThanToken",e[e.GreaterThanGreaterThanToken=46]="GreaterThanGreaterThanToken",e[e.GreaterThanGreaterThanGreaterThanToken=47]="GreaterThanGreaterThanGreaterThanToken",e[e.AmpersandToken=48]="AmpersandToken",e[e.BarToken=49]="BarToken",e[e.CaretToken=50]="CaretToken",e[e.ExclamationToken=51]="ExclamationToken",e[e.TildeToken=52]="TildeToken",e[e.AmpersandAmpersandToken=53]="AmpersandAmpersandToken",e[e.BarBarToken=54]="BarBarToken",e[e.QuestionToken=55]="QuestionToken",e[e.ColonToken=56]="ColonToken",e[e.AtToken=57]="AtToken",e[e.EqualsToken=58]="EqualsToken",e[e.PlusEqualsToken=59]="PlusEqualsToken",e[e.MinusEqualsToken=60]="MinusEqualsToken",e[e.AsteriskEqualsToken=61]="AsteriskEqualsToken",e[e.AsteriskAsteriskEqualsToken=62]="AsteriskAsteriskEqualsToken",e[e.SlashEqualsToken=63]="SlashEqualsToken",e[e.PercentEqualsToken=64]="PercentEqualsToken",e[e.LessThanLessThanEqualsToken=65]="LessThanLessThanEqualsToken",e[e.GreaterThanGreaterThanEqualsToken=66]="GreaterThanGreaterThanEqualsToken",e[e.GreaterThanGreaterThanGreaterThanEqualsToken=67]="GreaterThanGreaterThanGreaterThanEqualsToken",e[e.AmpersandEqualsToken=68]="AmpersandEqualsToken",e[e.BarEqualsToken=69]="BarEqualsToken",e[e.CaretEqualsToken=70]="CaretEqualsToken",e[e.Identifier=71]="Identifier",e[e.BreakKeyword=72]="BreakKeyword",e[e.CaseKeyword=73]="CaseKeyword",e[e.CatchKeyword=74]="CatchKeyword",e[e.ClassKeyword=75]="ClassKeyword",e[e.ConstKeyword=76]="ConstKeyword",e[e.ContinueKeyword=77]="ContinueKeyword",e[e.DebuggerKeyword=78]="DebuggerKeyword",e[e.DefaultKeyword=79]="DefaultKeyword",e[e.DeleteKeyword=80]="DeleteKeyword",e[e.DoKeyword=81]="DoKeyword",e[e.ElseKeyword=82]="ElseKeyword",e[e.EnumKeyword=83]="EnumKeyword",e[e.ExportKeyword=84]="ExportKeyword",e[e.ExtendsKeyword=85]="ExtendsKeyword",e[e.FalseKeyword=86]="FalseKeyword",e[e.FinallyKeyword=87]="FinallyKeyword",e[e.ForKeyword=88]="ForKeyword",e[e.FunctionKeyword=89]="FunctionKeyword",e[e.IfKeyword=90]="IfKeyword",e[e.ImportKeyword=91]="ImportKeyword",e[e.InKeyword=92]="InKeyword",e[e.InstanceOfKeyword=93]="InstanceOfKeyword",e[e.NewKeyword=94]="NewKeyword",e[e.NullKeyword=95]="NullKeyword",e[e.ReturnKeyword=96]="ReturnKeyword",e[e.SuperKeyword=97]="SuperKeyword",e[e.SwitchKeyword=98]="SwitchKeyword",e[e.ThisKeyword=99]="ThisKeyword",e[e.ThrowKeyword=100]="ThrowKeyword",e[e.TrueKeyword=101]="TrueKeyword",e[e.TryKeyword=102]="TryKeyword",e[e.TypeOfKeyword=103]="TypeOfKeyword",e[e.VarKeyword=104]="VarKeyword",e[e.VoidKeyword=105]="VoidKeyword",e[e.WhileKeyword=106]="WhileKeyword",e[e.WithKeyword=107]="WithKeyword",e[e.ImplementsKeyword=108]="ImplementsKeyword",e[e.InterfaceKeyword=109]="InterfaceKeyword",e[e.LetKeyword=110]="LetKeyword",e[e.PackageKeyword=111]="PackageKeyword",e[e.PrivateKeyword=112]="PrivateKeyword",e[e.ProtectedKeyword=113]="ProtectedKeyword",e[e.PublicKeyword=114]="PublicKeyword",e[e.StaticKeyword=115]="StaticKeyword",e[e.YieldKeyword=116]="YieldKeyword",e[e.AbstractKeyword=117]="AbstractKeyword",e[e.AsKeyword=118]="AsKeyword",e[e.AnyKeyword=119]="AnyKeyword",e[e.AsyncKeyword=120]="AsyncKeyword",e[e.AwaitKeyword=121]="AwaitKeyword",e[e.BooleanKeyword=122]="BooleanKeyword",e[e.ConstructorKeyword=123]="ConstructorKeyword",e[e.DeclareKeyword=124]="DeclareKeyword",e[e.GetKeyword=125]="GetKeyword",e[e.IsKeyword=126]="IsKeyword",e[e.KeyOfKeyword=127]="KeyOfKeyword",e[e.ModuleKeyword=128]="ModuleKeyword",e[e.NamespaceKeyword=129]="NamespaceKeyword",e[e.NeverKeyword=130]="NeverKeyword",e[e.ReadonlyKeyword=131]="ReadonlyKeyword",e[e.RequireKeyword=132]="RequireKeyword",e[e.NumberKeyword=133]="NumberKeyword",e[e.ObjectKeyword=134]="ObjectKeyword",e[e.SetKeyword=135]="SetKeyword",e[e.StringKeyword=136]="StringKeyword",e[e.SymbolKeyword=137]="SymbolKeyword",e[e.TypeKeyword=138]="TypeKeyword",e[e.UndefinedKeyword=139]="UndefinedKeyword",e[e.FromKeyword=140]="FromKeyword",e[e.GlobalKeyword=141]="GlobalKeyword",e[e.OfKeyword=142]="OfKeyword",e[e.QualifiedName=143]="QualifiedName",e[e.ComputedPropertyName=144]="ComputedPropertyName",e[e.TypeParameter=145]="TypeParameter",e[e.Parameter=146]="Parameter",e[e.Decorator=147]="Decorator",e[e.PropertySignature=148]="PropertySignature",e[e.PropertyDeclaration=149]="PropertyDeclaration",e[e.MethodSignature=150]="MethodSignature",e[e.MethodDeclaration=151]="MethodDeclaration",e[e.Constructor=152]="Constructor",e[e.GetAccessor=153]="GetAccessor",e[e.SetAccessor=154]="SetAccessor",e[e.CallSignature=155]="CallSignature",e[e.ConstructSignature=156]="ConstructSignature",e[e.IndexSignature=157]="IndexSignature",e[e.TypePredicate=158]="TypePredicate",e[e.TypeReference=159]="TypeReference",e[e.FunctionType=160]="FunctionType",e[e.ConstructorType=161]="ConstructorType",e[e.TypeQuery=162]="TypeQuery",e[e.TypeLiteral=163]="TypeLiteral",e[e.ArrayType=164]="ArrayType",e[e.TupleType=165]="TupleType",e[e.UnionType=166]="UnionType",e[e.IntersectionType=167]="IntersectionType",e[e.ParenthesizedType=168]="ParenthesizedType",e[e.ThisType=169]="ThisType",e[e.TypeOperator=170]="TypeOperator",e[e.IndexedAccessType=171]="IndexedAccessType",e[e.MappedType=172]="MappedType",e[e.LiteralType=173]="LiteralType",e[e.ObjectBindingPattern=174]="ObjectBindingPattern",e[e.ArrayBindingPattern=175]="ArrayBindingPattern",e[e.BindingElement=176]="BindingElement",e[e.ArrayLiteralExpression=177]="ArrayLiteralExpression",e[e.ObjectLiteralExpression=178]="ObjectLiteralExpression",e[e.PropertyAccessExpression=179]="PropertyAccessExpression",e[e.ElementAccessExpression=180]="ElementAccessExpression",e[e.CallExpression=181]="CallExpression",e[e.NewExpression=182]="NewExpression",e[e.TaggedTemplateExpression=183]="TaggedTemplateExpression",e[e.TypeAssertionExpression=184]="TypeAssertionExpression",e[e.ParenthesizedExpression=185]="ParenthesizedExpression",e[e.FunctionExpression=186]="FunctionExpression",e[e.ArrowFunction=187]="ArrowFunction",e[e.DeleteExpression=188]="DeleteExpression",e[e.TypeOfExpression=189]="TypeOfExpression",e[e.VoidExpression=190]="VoidExpression",e[e.AwaitExpression=191]="AwaitExpression",e[e.PrefixUnaryExpression=192]="PrefixUnaryExpression",e[e.PostfixUnaryExpression=193]="PostfixUnaryExpression",e[e.BinaryExpression=194]="BinaryExpression",e[e.ConditionalExpression=195]="ConditionalExpression",e[e.TemplateExpression=196]="TemplateExpression",e[e.YieldExpression=197]="YieldExpression",e[e.SpreadElement=198]="SpreadElement",e[e.ClassExpression=199]="ClassExpression",e[e.OmittedExpression=200]="OmittedExpression",e[e.ExpressionWithTypeArguments=201]="ExpressionWithTypeArguments",e[e.AsExpression=202]="AsExpression",e[e.NonNullExpression=203]="NonNullExpression",e[e.MetaProperty=204]="MetaProperty",e[e.TemplateSpan=205]="TemplateSpan",e[e.SemicolonClassElement=206]="SemicolonClassElement",e[e.Block=207]="Block",e[e.VariableStatement=208]="VariableStatement",e[e.EmptyStatement=209]="EmptyStatement",e[e.ExpressionStatement=210]="ExpressionStatement",e[e.IfStatement=211]="IfStatement",e[e.DoStatement=212]="DoStatement",e[e.WhileStatement=213]="WhileStatement",e[e.ForStatement=214]="ForStatement",e[e.ForInStatement=215]="ForInStatement",e[e.ForOfStatement=216]="ForOfStatement",e[e.ContinueStatement=217]="ContinueStatement",e[e.BreakStatement=218]="BreakStatement",e[e.ReturnStatement=219]="ReturnStatement",e[e.WithStatement=220]="WithStatement",e[e.SwitchStatement=221]="SwitchStatement",e[e.LabeledStatement=222]="LabeledStatement",e[e.ThrowStatement=223]="ThrowStatement",e[e.TryStatement=224]="TryStatement",e[e.DebuggerStatement=225]="DebuggerStatement",e[e.VariableDeclaration=226]="VariableDeclaration",e[e.VariableDeclarationList=227]="VariableDeclarationList",e[e.FunctionDeclaration=228]="FunctionDeclaration",e[e.ClassDeclaration=229]="ClassDeclaration",e[e.InterfaceDeclaration=230]="InterfaceDeclaration",e[e.TypeAliasDeclaration=231]="TypeAliasDeclaration",e[e.EnumDeclaration=232]="EnumDeclaration",e[e.ModuleDeclaration=233]="ModuleDeclaration",e[e.ModuleBlock=234]="ModuleBlock",e[e.CaseBlock=235]="CaseBlock",e[e.NamespaceExportDeclaration=236]="NamespaceExportDeclaration",e[e.ImportEqualsDeclaration=237]="ImportEqualsDeclaration",e[e.ImportDeclaration=238]="ImportDeclaration",e[e.ImportClause=239]="ImportClause",e[e.NamespaceImport=240]="NamespaceImport",e[e.NamedImports=241]="NamedImports",e[e.ImportSpecifier=242]="ImportSpecifier",e[e.ExportAssignment=243]="ExportAssignment",e[e.ExportDeclaration=244]="ExportDeclaration",e[e.NamedExports=245]="NamedExports",e[e.ExportSpecifier=246]="ExportSpecifier",e[e.MissingDeclaration=247]="MissingDeclaration",e[e.ExternalModuleReference=248]="ExternalModuleReference",e[e.JsxElement=249]="JsxElement",e[e.JsxSelfClosingElement=250]="JsxSelfClosingElement",e[e.JsxOpeningElement=251]="JsxOpeningElement",e[e.JsxClosingElement=252]="JsxClosingElement",e[e.JsxAttribute=253]="JsxAttribute",e[e.JsxAttributes=254]="JsxAttributes",e[e.JsxSpreadAttribute=255]="JsxSpreadAttribute",e[e.JsxExpression=256]="JsxExpression",e[e.CaseClause=257]="CaseClause",e[e.DefaultClause=258]="DefaultClause",e[e.HeritageClause=259]="HeritageClause",e[e.CatchClause=260]="CatchClause",e[e.PropertyAssignment=261]="PropertyAssignment",e[e.ShorthandPropertyAssignment=262]="ShorthandPropertyAssignment",e[e.SpreadAssignment=263]="SpreadAssignment",e[e.EnumMember=264]="EnumMember",e[e.SourceFile=265]="SourceFile",e[e.Bundle=266]="Bundle",e[e.JSDocTypeExpression=267]="JSDocTypeExpression",e[e.JSDocAllType=268]="JSDocAllType",e[e.JSDocUnknownType=269]="JSDocUnknownType",e[e.JSDocNullableType=270]="JSDocNullableType",e[e.JSDocNonNullableType=271]="JSDocNonNullableType",e[e.JSDocOptionalType=272]="JSDocOptionalType",e[e.JSDocFunctionType=273]="JSDocFunctionType",e[e.JSDocVariadicType=274]="JSDocVariadicType",e[e.JSDocComment=275]="JSDocComment",e[e.JSDocTag=276]="JSDocTag",e[e.JSDocAugmentsTag=277]="JSDocAugmentsTag",e[e.JSDocClassTag=278]="JSDocClassTag",e[e.JSDocParameterTag=279]="JSDocParameterTag",e[e.JSDocReturnTag=280]="JSDocReturnTag",e[e.JSDocTypeTag=281]="JSDocTypeTag",e[e.JSDocTemplateTag=282]="JSDocTemplateTag",e[e.JSDocTypedefTag=283]="JSDocTypedefTag",e[e.JSDocPropertyTag=284]="JSDocPropertyTag",e[e.JSDocTypeLiteral=285]="JSDocTypeLiteral",e[e.SyntaxList=286]="SyntaxList",e[e.NotEmittedStatement=287]="NotEmittedStatement",e[e.PartiallyEmittedExpression=288]="PartiallyEmittedExpression",e[e.CommaListExpression=289]="CommaListExpression",e[e.MergeDeclarationMarker=290]="MergeDeclarationMarker",e[e.EndOfDeclarationMarker=291]="EndOfDeclarationMarker",e[e.Count=292]="Count",e[e.FirstAssignment=58]="FirstAssignment",e[e.LastAssignment=70]="LastAssignment",e[e.FirstCompoundAssignment=59]="FirstCompoundAssignment",e[e.LastCompoundAssignment=70]="LastCompoundAssignment",e[e.FirstReservedWord=72]="FirstReservedWord",e[e.LastReservedWord=107]="LastReservedWord",e[e.FirstKeyword=72]="FirstKeyword",e[e.LastKeyword=142]="LastKeyword",e[e.FirstFutureReservedWord=108]="FirstFutureReservedWord",e[e.LastFutureReservedWord=116]="LastFutureReservedWord",e[e.FirstTypeNode=158]="FirstTypeNode",e[e.LastTypeNode=173]="LastTypeNode",e[e.FirstPunctuation=17]="FirstPunctuation",e[e.LastPunctuation=70]="LastPunctuation",e[e.FirstToken=0]="FirstToken",e[e.LastToken=142]="LastToken",e[e.FirstTriviaToken=2]="FirstTriviaToken",e[e.LastTriviaToken=7]="LastTriviaToken",e[e.FirstLiteralToken=8]="FirstLiteralToken",e[e.LastLiteralToken=13]="LastLiteralToken",e[e.FirstTemplateToken=13]="FirstTemplateToken",e[e.LastTemplateToken=16]="LastTemplateToken",e[e.FirstBinaryOperator=27]="FirstBinaryOperator",e[e.LastBinaryOperator=70]="LastBinaryOperator",e[e.FirstNode=143]="FirstNode",e[e.FirstJSDocNode=267]="FirstJSDocNode",e[e.LastJSDocNode=285]="LastJSDocNode",e[e.FirstJSDocTagNode=276]="FirstJSDocTagNode",e[e.LastJSDocTagNode=285]="LastJSDocTagNode"}(e.SyntaxKind||(e.SyntaxKind={})),function(e){e[e.None=0]="None",e[e.Let=1]="Let",e[e.Const=2]="Const",e[e.NestedNamespace=4]="NestedNamespace",e[e.Synthesized=8]="Synthesized",e[e.Namespace=16]="Namespace",e[e.ExportContext=32]="ExportContext",e[e.ContainsThis=64]="ContainsThis",e[e.HasImplicitReturn=128]="HasImplicitReturn",e[e.HasExplicitReturn=256]="HasExplicitReturn",e[e.GlobalAugmentation=512]="GlobalAugmentation",e[e.HasAsyncFunctions=1024]="HasAsyncFunctions",e[e.DisallowInContext=2048]="DisallowInContext",e[e.YieldContext=4096]="YieldContext",e[e.DecoratorContext=8192]="DecoratorContext",e[e.AwaitContext=16384]="AwaitContext",e[e.ThisNodeHasError=32768]="ThisNodeHasError",e[e.JavaScriptFile=65536]="JavaScriptFile",e[e.ThisNodeOrAnySubNodesHasError=131072]="ThisNodeOrAnySubNodesHasError",e[e.HasAggregatedChildData=262144]="HasAggregatedChildData",e[e.PossiblyContainsDynamicImport=524288]="PossiblyContainsDynamicImport",e[e.JSDoc=1048576]="JSDoc",e[e.BlockScoped=3]="BlockScoped",e[e.ReachabilityCheckFlags=384]="ReachabilityCheckFlags",e[e.ReachabilityAndEmitFlags=1408]="ReachabilityAndEmitFlags",e[e.ContextFlags=96256]="ContextFlags",e[e.TypeExcludesFlags=20480]="TypeExcludesFlags"}(e.NodeFlags||(e.NodeFlags={})),function(e){e[e.None=0]="None",e[e.Export=1]="Export",e[e.Ambient=2]="Ambient",e[e.Public=4]="Public",e[e.Private=8]="Private",e[e.Protected=16]="Protected",e[e.Static=32]="Static",e[e.Readonly=64]="Readonly",e[e.Abstract=128]="Abstract",e[e.Async=256]="Async",e[e.Default=512]="Default",e[e.Const=2048]="Const",e[e.HasComputedFlags=536870912]="HasComputedFlags",e[e.AccessibilityModifier=28]="AccessibilityModifier",e[e.ParameterPropertyModifier=92]="ParameterPropertyModifier",e[e.NonPublicAccessibilityModifier=24]="NonPublicAccessibilityModifier",e[e.TypeScriptModifier=2270]="TypeScriptModifier",e[e.ExportDefault=513]="ExportDefault"}(e.ModifierFlags||(e.ModifierFlags={})),function(e){e[e.None=0]="None",e[e.IntrinsicNamedElement=1]="IntrinsicNamedElement",e[e.IntrinsicIndexedElement=2]="IntrinsicIndexedElement",e[e.IntrinsicElement=3]="IntrinsicElement"}(e.JsxFlags||(e.JsxFlags={})),function(e){e[e.Succeeded=1]="Succeeded",e[e.Failed=2]="Failed",e[e.FailedAndReported=3]="FailedAndReported"}(e.RelationComparisonResult||(e.RelationComparisonResult={})),function(e){e[e.None=0]="None",e[e.Auto=1]="Auto",e[e.Loop=2]="Loop",e[e.Unique=3]="Unique",e[e.Node=4]="Node"}(e.GeneratedIdentifierKind||(e.GeneratedIdentifierKind={})),function(e){e[e.None=0]="None",e[e.Scientific=2]="Scientific",e[e.Octal=4]="Octal",e[e.HexSpecifier=8]="HexSpecifier",e[e.BinarySpecifier=16]="BinarySpecifier",e[e.OctalSpecifier=32]="OctalSpecifier",e[e.BinaryOrOctalSpecifier=48]="BinaryOrOctalSpecifier"}(e.NumericLiteralFlags||(e.NumericLiteralFlags={})),function(e){e[e.Unreachable=1]="Unreachable",e[e.Start=2]="Start",e[e.BranchLabel=4]="BranchLabel",e[e.LoopLabel=8]="LoopLabel",e[e.Assignment=16]="Assignment",e[e.TrueCondition=32]="TrueCondition",e[e.FalseCondition=64]="FalseCondition",e[e.SwitchClause=128]="SwitchClause",e[e.ArrayMutation=256]="ArrayMutation",e[e.Referenced=512]="Referenced",e[e.Shared=1024]="Shared",e[e.PreFinally=2048]="PreFinally",e[e.AfterFinally=4096]="AfterFinally",e[e.Label=12]="Label",e[e.Condition=96]="Condition"}(e.FlowFlags||(e.FlowFlags={}));var t=function(){};e.OperationCanceledException=t,function(e){e[e.Not=0]="Not",e[e.SafeModules=1]="SafeModules",e[e.Completely=2]="Completely"}(e.StructureIsReused||(e.StructureIsReused={})),function(e){e[e.Success=0]="Success",e[e.DiagnosticsPresent_OutputsSkipped=1]="DiagnosticsPresent_OutputsSkipped",e[e.DiagnosticsPresent_OutputsGenerated=2]="DiagnosticsPresent_OutputsGenerated"}(e.ExitStatus||(e.ExitStatus={})),function(e){e[e.None=0]="None",e[e.NoTruncation=1]="NoTruncation",e[e.WriteArrayAsGenericType=2]="WriteArrayAsGenericType",e[e.WriteTypeArgumentsOfSignature=32]="WriteTypeArgumentsOfSignature",e[e.UseFullyQualifiedType=64]="UseFullyQualifiedType",e[e.SuppressAnyReturnType=256]="SuppressAnyReturnType",e[e.WriteTypeParametersInQualifiedName=512]="WriteTypeParametersInQualifiedName",e[e.AllowThisInObjectLiteral=1024]="AllowThisInObjectLiteral",e[e.AllowQualifedNameInPlaceOfIdentifier=2048]="AllowQualifedNameInPlaceOfIdentifier",e[e.AllowAnonymousIdentifier=8192]="AllowAnonymousIdentifier",e[e.AllowEmptyUnionOrIntersection=16384]="AllowEmptyUnionOrIntersection",e[e.AllowEmptyTuple=32768]="AllowEmptyTuple",e[e.IgnoreErrors=60416]="IgnoreErrors",e[e.InObjectTypeLiteral=1048576]="InObjectTypeLiteral",e[e.InTypeAlias=8388608]="InTypeAlias"}(e.NodeBuilderFlags||(e.NodeBuilderFlags={})),function(e){e[e.None=0]="None",e[e.WriteArrayAsGenericType=1]="WriteArrayAsGenericType",e[e.UseTypeOfFunction=4]="UseTypeOfFunction",e[e.NoTruncation=8]="NoTruncation",e[e.WriteArrowStyleSignature=16]="WriteArrowStyleSignature",e[e.WriteOwnNameForAnyLike=32]="WriteOwnNameForAnyLike",e[e.WriteTypeArgumentsOfSignature=64]="WriteTypeArgumentsOfSignature",e[e.InElementType=128]="InElementType",e[e.UseFullyQualifiedType=256]="UseFullyQualifiedType",e[e.InFirstTypeArgument=512]="InFirstTypeArgument",e[e.InTypeAlias=1024]="InTypeAlias",e[e.SuppressAnyReturnType=4096]="SuppressAnyReturnType",e[e.AddUndefined=8192]="AddUndefined",e[e.WriteClassExpressionAsTypeLiteral=16384]="WriteClassExpressionAsTypeLiteral",e[e.InArrayType=32768]="InArrayType",e[e.UseAliasDefinedOutsideCurrentScope=65536]="UseAliasDefinedOutsideCurrentScope"}(e.TypeFormatFlags||(e.TypeFormatFlags={})),function(e){e[e.None=0]="None",e[e.WriteTypeParametersOrArguments=1]="WriteTypeParametersOrArguments",e[e.UseOnlyExternalAliasing=2]="UseOnlyExternalAliasing"}(e.SymbolFormatFlags||(e.SymbolFormatFlags={})),function(e){e[e.Accessible=0]="Accessible",e[e.NotAccessible=1]="NotAccessible",e[e.CannotBeNamed=2]="CannotBeNamed"}(e.SymbolAccessibility||(e.SymbolAccessibility={})),function(e){e[e.UnionOrIntersection=0]="UnionOrIntersection",e[e.Spread=1]="Spread"}(e.SyntheticSymbolKind||(e.SyntheticSymbolKind={})),function(e){e[e.This=0]="This",e[e.Identifier=1]="Identifier"}(e.TypePredicateKind||(e.TypePredicateKind={})),function(e){e[e.Unknown=0]="Unknown",e[e.TypeWithConstructSignatureAndValue=1]="TypeWithConstructSignatureAndValue",e[e.VoidNullableOrNeverType=2]="VoidNullableOrNeverType",e[e.NumberLikeType=3]="NumberLikeType",e[e.StringLikeType=4]="StringLikeType",e[e.BooleanType=5]="BooleanType",e[e.ArrayLikeType=6]="ArrayLikeType",e[e.ESSymbolType=7]="ESSymbolType",e[e.Promise=8]="Promise",e[e.TypeWithCallSignature=9]="TypeWithCallSignature",e[e.ObjectType=10]="ObjectType"}(e.TypeReferenceSerializationKind||(e.TypeReferenceSerializationKind={})),function(e){e[e.None=0]="None",e[e.FunctionScopedVariable=1]="FunctionScopedVariable",e[e.BlockScopedVariable=2]="BlockScopedVariable",e[e.Property=4]="Property",e[e.EnumMember=8]="EnumMember",e[e.Function=16]="Function",e[e.Class=32]="Class",e[e.Interface=64]="Interface",e[e.ConstEnum=128]="ConstEnum",e[e.RegularEnum=256]="RegularEnum",e[e.ValueModule=512]="ValueModule",e[e.NamespaceModule=1024]="NamespaceModule",e[e.TypeLiteral=2048]="TypeLiteral",e[e.ObjectLiteral=4096]="ObjectLiteral",e[e.Method=8192]="Method",e[e.Constructor=16384]="Constructor",e[e.GetAccessor=32768]="GetAccessor",e[e.SetAccessor=65536]="SetAccessor",e[e.Signature=131072]="Signature",e[e.TypeParameter=262144]="TypeParameter",e[e.TypeAlias=524288]="TypeAlias",e[e.ExportValue=1048576]="ExportValue",e[e.Alias=2097152]="Alias",e[e.Prototype=4194304]="Prototype",e[e.ExportStar=8388608]="ExportStar",e[e.Optional=16777216]="Optional",e[e.Transient=33554432]="Transient",e[e.Enum=384]="Enum",e[e.Variable=3]="Variable",e[e.Value=107455]="Value",e[e.Type=793064]="Type",e[e.Namespace=1920]="Namespace",e[e.Module=1536]="Module",e[e.Accessor=98304]="Accessor",e[e.FunctionScopedVariableExcludes=107454]="FunctionScopedVariableExcludes",e[e.BlockScopedVariableExcludes=107455]="BlockScopedVariableExcludes",e[e.ParameterExcludes=107455]="ParameterExcludes",e[e.PropertyExcludes=0]="PropertyExcludes",e[e.EnumMemberExcludes=900095]="EnumMemberExcludes",e[e.FunctionExcludes=106927]="FunctionExcludes",e[e.ClassExcludes=899519]="ClassExcludes",e[e.InterfaceExcludes=792968]="InterfaceExcludes",e[e.RegularEnumExcludes=899327]="RegularEnumExcludes",e[e.ConstEnumExcludes=899967]="ConstEnumExcludes",e[e.ValueModuleExcludes=106639]="ValueModuleExcludes",e[e.NamespaceModuleExcludes=0]="NamespaceModuleExcludes",e[e.MethodExcludes=99263]="MethodExcludes",e[e.GetAccessorExcludes=41919]="GetAccessorExcludes",e[e.SetAccessorExcludes=74687]="SetAccessorExcludes",e[e.TypeParameterExcludes=530920]="TypeParameterExcludes",e[e.TypeAliasExcludes=793064]="TypeAliasExcludes",e[e.AliasExcludes=2097152]="AliasExcludes",e[e.ModuleMember=2623475]="ModuleMember",e[e.ExportHasLocal=944]="ExportHasLocal",e[e.HasExports=1952]="HasExports",e[e.HasMembers=6240]="HasMembers",e[e.BlockScoped=418]="BlockScoped",e[e.PropertyOrAccessor=98308]="PropertyOrAccessor",e[e.ClassMember=106500]="ClassMember",e[e.Classifiable=788448]="Classifiable"}(e.SymbolFlags||(e.SymbolFlags={})),function(e){e[e.Numeric=0]="Numeric",e[e.Literal=1]="Literal"}(e.EnumKind||(e.EnumKind={})),function(e){e[e.Instantiated=1]="Instantiated",e[e.SyntheticProperty=2]="SyntheticProperty",e[e.SyntheticMethod=4]="SyntheticMethod",e[e.Readonly=8]="Readonly",e[e.Partial=16]="Partial",e[e.HasNonUniformType=32]="HasNonUniformType",e[e.ContainsPublic=64]="ContainsPublic",e[e.ContainsProtected=128]="ContainsProtected",e[e.ContainsPrivate=256]="ContainsPrivate",e[e.ContainsStatic=512]="ContainsStatic",e[e.Synthetic=6]="Synthetic"}(e.CheckFlags||(e.CheckFlags={})),function(e){e.Call="__call",e.Constructor="__constructor",e.New="__new",e.Index="__index",e.ExportStar="__export",e.Global="__global",e.Missing="__missing",e.Type="__type",e.Object="__object",e.JSXAttributes="__jsxAttributes",e.Class="__class",e.Function="__function",e.Computed="__computed",e.Resolving="__resolving__",e.ExportEquals="export=",e.Default="default"}(e.InternalSymbolName||(e.InternalSymbolName={})),function(e){e[e.TypeChecked=1]="TypeChecked",e[e.LexicalThis=2]="LexicalThis",e[e.CaptureThis=4]="CaptureThis",e[e.CaptureNewTarget=8]="CaptureNewTarget",e[e.SuperInstance=256]="SuperInstance",e[e.SuperStatic=512]="SuperStatic",e[e.ContextChecked=1024]="ContextChecked",e[e.AsyncMethodWithSuper=2048]="AsyncMethodWithSuper",e[e.AsyncMethodWithSuperBinding=4096]="AsyncMethodWithSuperBinding",e[e.CaptureArguments=8192]="CaptureArguments",e[e.EnumValuesComputed=16384]="EnumValuesComputed",e[e.LexicalModuleMergesWithClass=32768]="LexicalModuleMergesWithClass",e[e.LoopWithCapturedBlockScopedBinding=65536]="LoopWithCapturedBlockScopedBinding",e[e.CapturedBlockScopedBinding=131072]="CapturedBlockScopedBinding",e[e.BlockScopedBindingInLoop=262144]="BlockScopedBindingInLoop",e[e.ClassWithBodyScopedClassBinding=524288]="ClassWithBodyScopedClassBinding",e[e.BodyScopedClassBinding=1048576]="BodyScopedClassBinding",e[e.NeedsLoopOutParameter=2097152]="NeedsLoopOutParameter",e[e.AssignmentsMarked=4194304]="AssignmentsMarked",e[e.ClassWithConstructorReference=8388608]="ClassWithConstructorReference",e[e.ConstructorReferenceInClass=16777216]="ConstructorReferenceInClass"}(e.NodeCheckFlags||(e.NodeCheckFlags={})),function(e){e[e.Any=1]="Any",e[e.String=2]="String",e[e.Number=4]="Number",e[e.Boolean=8]="Boolean",e[e.Enum=16]="Enum",e[e.StringLiteral=32]="StringLiteral",e[e.NumberLiteral=64]="NumberLiteral",e[e.BooleanLiteral=128]="BooleanLiteral",e[e.EnumLiteral=256]="EnumLiteral",e[e.ESSymbol=512]="ESSymbol",e[e.Void=1024]="Void",e[e.Undefined=2048]="Undefined",e[e.Null=4096]="Null",e[e.Never=8192]="Never",e[e.TypeParameter=16384]="TypeParameter",e[e.Object=32768]="Object",e[e.Union=65536]="Union",e[e.Intersection=131072]="Intersection",e[e.Index=262144]="Index",e[e.IndexedAccess=524288]="IndexedAccess",e[e.FreshLiteral=1048576]="FreshLiteral",e[e.ContainsWideningType=2097152]="ContainsWideningType",e[e.ContainsObjectLiteral=4194304]="ContainsObjectLiteral",e[e.ContainsAnyFunctionType=8388608]="ContainsAnyFunctionType",e[e.NonPrimitive=16777216]="NonPrimitive",e[e.JsxAttributes=33554432]="JsxAttributes",e[e.MarkerType=67108864]="MarkerType",e[e.Nullable=6144]="Nullable",e[e.Literal=224]="Literal",e[e.Unit=6368]="Unit",e[e.StringOrNumberLiteral=96]="StringOrNumberLiteral",e[e.DefinitelyFalsy=7392]="DefinitelyFalsy",e[e.PossiblyFalsy=7406]="PossiblyFalsy",e[e.Intrinsic=16793231]="Intrinsic",e[e.Primitive=8190]="Primitive",e[e.StringLike=262178]="StringLike",e[e.NumberLike=84]="NumberLike",e[e.BooleanLike=136]="BooleanLike",e[e.EnumLike=272]="EnumLike",e[e.UnionOrIntersection=196608]="UnionOrIntersection",e[e.StructuredType=229376]="StructuredType",e[e.StructuredOrTypeVariable=1032192]="StructuredOrTypeVariable",e[e.TypeVariable=540672]="TypeVariable",e[e.Narrowable=17810175]="Narrowable",e[e.NotUnionOrUnit=16810497]="NotUnionOrUnit",e[e.RequiresWidening=6291456]="RequiresWidening",e[e.PropagatingFlags=14680064]="PropagatingFlags"}(e.TypeFlags||(e.TypeFlags={})),function(e){e[e.Class=1]="Class",e[e.Interface=2]="Interface",e[e.Reference=4]="Reference",e[e.Tuple=8]="Tuple",e[e.Anonymous=16]="Anonymous",e[e.Mapped=32]="Mapped",e[e.Instantiated=64]="Instantiated",e[e.ObjectLiteral=128]="ObjectLiteral",e[e.EvolvingArray=256]="EvolvingArray",e[e.ObjectLiteralPatternWithComputedProperties=512]="ObjectLiteralPatternWithComputedProperties",e[e.ClassOrInterface=3]="ClassOrInterface"}(e.ObjectFlags||(e.ObjectFlags={})),function(e){e[e.Invariant=0]="Invariant",e[e.Covariant=1]="Covariant",e[e.Contravariant=2]="Contravariant",e[e.Bivariant=3]="Bivariant",e[e.Independent=4]="Independent"}(e.Variance||(e.Variance={})),function(e){e[e.Call=0]="Call",e[e.Construct=1]="Construct"}(e.SignatureKind||(e.SignatureKind={})),function(e){e[e.String=0]="String",e[e.Number=1]="Number"}(e.IndexKind||(e.IndexKind={})),function(e){e[e.Contravariant=1]="Contravariant",e[e.NakedTypeVariable=2]="NakedTypeVariable",e[e.MappedType=4]="MappedType",e[e.ReturnType=8]="ReturnType"}(e.InferencePriority||(e.InferencePriority={})),function(e){e[e.InferUnionTypes=1]="InferUnionTypes",e[e.NoDefault=2]="NoDefault",e[e.AnyDefault=4]="AnyDefault"}(e.InferenceFlags||(e.InferenceFlags={})),function(e){e[e.False=0]="False",e[e.Maybe=1]="Maybe",e[e.True=-1]="True"}(e.Ternary||(e.Ternary={})),function(e){e[e.None=0]="None",e[e.ExportsProperty=1]="ExportsProperty",e[e.ModuleExports=2]="ModuleExports",e[e.PrototypeProperty=3]="PrototypeProperty",e[e.ThisProperty=4]="ThisProperty",e[e.Property=5]="Property"}(e.SpecialPropertyAssignmentKind||(e.SpecialPropertyAssignmentKind={})),function(e){e[e.Warning=0]="Warning",e[e.Error=1]="Error",e[e.Message=2]="Message"}(e.DiagnosticCategory||(e.DiagnosticCategory={})),function(e){e[e.Classic=1]="Classic",e[e.NodeJs=2]="NodeJs"}(e.ModuleResolutionKind||(e.ModuleResolutionKind={})),function(e){e[e.None=0]="None",e[e.CommonJS=1]="CommonJS",e[e.AMD=2]="AMD",e[e.UMD=3]="UMD",e[e.System=4]="System",e[e.ES2015=5]="ES2015",e[e.ESNext=6]="ESNext"}(e.ModuleKind||(e.ModuleKind={})),function(e){e[e.None=0]="None",e[e.Preserve=1]="Preserve",e[e.React=2]="React",e[e.ReactNative=3]="ReactNative"}(e.JsxEmit||(e.JsxEmit={})),function(e){e[e.CarriageReturnLineFeed=0]="CarriageReturnLineFeed",e[e.LineFeed=1]="LineFeed"}(e.NewLineKind||(e.NewLineKind={})),function(e){e[e.Unknown=0]="Unknown",e[e.JS=1]="JS",e[e.JSX=2]="JSX",e[e.TS=3]="TS",e[e.TSX=4]="TSX",e[e.External=5]="External",e[e.JSON=6]="JSON"}(e.ScriptKind||(e.ScriptKind={})),function(e){e[e.ES3=0]="ES3",e[e.ES5=1]="ES5",e[e.ES2015=2]="ES2015",e[e.ES2016=3]="ES2016",e[e.ES2017=4]="ES2017",e[e.ESNext=5]="ESNext",e[e.Latest=5]="Latest"}(e.ScriptTarget||(e.ScriptTarget={})),function(e){e[e.Standard=0]="Standard",e[e.JSX=1]="JSX"}(e.LanguageVariant||(e.LanguageVariant={})),function(e){e[e.Simple=0]="Simple",e[e.Pretty=1]="Pretty"}(e.DiagnosticStyle||(e.DiagnosticStyle={})),function(e){e[e.None=0]="None",e[e.Recursive=1]="Recursive"}(e.WatchDirectoryFlags||(e.WatchDirectoryFlags={})),function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.backtick=96]="backtick",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.hash=35]="hash",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"}(e.CharacterCodes||(e.CharacterCodes={})),function(e){e.Ts=".ts",e.Tsx=".tsx",e.Dts=".d.ts",e.Js=".js",e.Jsx=".jsx",e.Json=".json"}(e.Extension||(e.Extension={})),function(e){e[e.None=0]="None",e[e.TypeScript=1]="TypeScript",e[e.ContainsTypeScript=2]="ContainsTypeScript",e[e.ContainsJsx=4]="ContainsJsx",e[e.ContainsESNext=8]="ContainsESNext",e[e.ContainsES2017=16]="ContainsES2017",e[e.ContainsES2016=32]="ContainsES2016",e[e.ES2015=64]="ES2015",e[e.ContainsES2015=128]="ContainsES2015",e[e.Generator=256]="Generator",e[e.ContainsGenerator=512]="ContainsGenerator",e[e.DestructuringAssignment=1024]="DestructuringAssignment",e[e.ContainsDestructuringAssignment=2048]="ContainsDestructuringAssignment",e[e.ContainsDecorators=4096]="ContainsDecorators",e[e.ContainsPropertyInitializer=8192]="ContainsPropertyInitializer",e[e.ContainsLexicalThis=16384]="ContainsLexicalThis",e[e.ContainsCapturedLexicalThis=32768]="ContainsCapturedLexicalThis",e[e.ContainsLexicalThisInComputedPropertyName=65536]="ContainsLexicalThisInComputedPropertyName",e[e.ContainsDefaultValueAssignments=131072]="ContainsDefaultValueAssignments",e[e.ContainsParameterPropertyAssignments=262144]="ContainsParameterPropertyAssignments",e[e.ContainsSpread=524288]="ContainsSpread",e[e.ContainsObjectSpread=1048576]="ContainsObjectSpread",e[e.ContainsRest=524288]="ContainsRest",e[e.ContainsObjectRest=1048576]="ContainsObjectRest",e[e.ContainsComputedPropertyName=2097152]="ContainsComputedPropertyName",e[e.ContainsBlockScopedBinding=4194304]="ContainsBlockScopedBinding",e[e.ContainsBindingPattern=8388608]="ContainsBindingPattern",e[e.ContainsYield=16777216]="ContainsYield",e[e.ContainsHoistedDeclarationOrCompletion=33554432]="ContainsHoistedDeclarationOrCompletion",e[e.ContainsDynamicImport=67108864]="ContainsDynamicImport",e[e.HasComputedFlags=536870912]="HasComputedFlags",e[e.AssertTypeScript=3]="AssertTypeScript",e[e.AssertJsx=4]="AssertJsx",e[e.AssertESNext=8]="AssertESNext",e[e.AssertES2017=16]="AssertES2017",e[e.AssertES2016=32]="AssertES2016",e[e.AssertES2015=192]="AssertES2015",e[e.AssertGenerator=768]="AssertGenerator",e[e.AssertDestructuringAssignment=3072]="AssertDestructuringAssignment",e[e.NodeExcludes=536872257]="NodeExcludes",e[e.ArrowFunctionExcludes=601249089]="ArrowFunctionExcludes",e[e.FunctionExcludes=601281857]="FunctionExcludes",e[e.ConstructorExcludes=601015617]="ConstructorExcludes",e[e.MethodOrAccessorExcludes=601015617]="MethodOrAccessorExcludes",e[e.ClassExcludes=539358529]="ClassExcludes",e[e.ModuleExcludes=574674241]="ModuleExcludes",e[e.TypeExcludes=-3]="TypeExcludes",e[e.ObjectLiteralExcludes=540087617]="ObjectLiteralExcludes",e[e.ArrayLiteralOrCallOrNewExcludes=537396545]="ArrayLiteralOrCallOrNewExcludes",e[e.VariableDeclarationListExcludes=546309441]="VariableDeclarationListExcludes",e[e.ParameterExcludes=536872257]="ParameterExcludes",e[e.CatchClauseExcludes=537920833]="CatchClauseExcludes",e[e.BindingPatternExcludes=537396545]="BindingPatternExcludes",e[e.TypeScriptClassSyntaxMask=274432]="TypeScriptClassSyntaxMask",e[e.ES2015FunctionSyntaxMask=163840]="ES2015FunctionSyntaxMask"}(e.TransformFlags||(e.TransformFlags={})),function(e){e[e.SingleLine=1]="SingleLine",e[e.AdviseOnEmitNode=2]="AdviseOnEmitNode",e[e.NoSubstitution=4]="NoSubstitution",e[e.CapturesThis=8]="CapturesThis",e[e.NoLeadingSourceMap=16]="NoLeadingSourceMap",e[e.NoTrailingSourceMap=32]="NoTrailingSourceMap",e[e.NoSourceMap=48]="NoSourceMap",e[e.NoNestedSourceMaps=64]="NoNestedSourceMaps",e[e.NoTokenLeadingSourceMaps=128]="NoTokenLeadingSourceMaps",e[e.NoTokenTrailingSourceMaps=256]="NoTokenTrailingSourceMaps",e[e.NoTokenSourceMaps=384]="NoTokenSourceMaps",e[e.NoLeadingComments=512]="NoLeadingComments",e[e.NoTrailingComments=1024]="NoTrailingComments",e[e.NoComments=1536]="NoComments",e[e.NoNestedComments=2048]="NoNestedComments",e[e.HelperName=4096]="HelperName",e[e.ExportName=8192]="ExportName",e[e.LocalName=16384]="LocalName",e[e.InternalName=32768]="InternalName",e[e.Indented=65536]="Indented",e[e.NoIndentation=131072]="NoIndentation",e[e.AsyncFunctionBody=262144]="AsyncFunctionBody",e[e.ReuseTempVariableScope=524288]="ReuseTempVariableScope",e[e.CustomPrologue=1048576]="CustomPrologue",e[e.NoHoisting=2097152]="NoHoisting",e[e.HasEndOfDeclarationMarker=4194304]="HasEndOfDeclarationMarker",e[e.Iterator=8388608]="Iterator",e[e.NoAsciiEscaping=16777216]="NoAsciiEscaping",e[e.TypeScriptClassWrapper=33554432]="TypeScriptClassWrapper"}(e.EmitFlags||(e.EmitFlags={})),function(e){e[e.Extends=1]="Extends",e[e.Assign=2]="Assign",e[e.Rest=4]="Rest",e[e.Decorate=8]="Decorate",e[e.Metadata=16]="Metadata",e[e.Param=32]="Param",e[e.Awaiter=64]="Awaiter",e[e.Generator=128]="Generator",e[e.Values=256]="Values",e[e.Read=512]="Read",e[e.Spread=1024]="Spread",e[e.Await=2048]="Await",e[e.AsyncGenerator=4096]="AsyncGenerator",e[e.AsyncDelegator=8192]="AsyncDelegator",e[e.AsyncValues=16384]="AsyncValues",e[e.ExportStar=32768]="ExportStar",e[e.MakeTemplateObject=65536]="MakeTemplateObject",e[e.FirstEmitHelper=1]="FirstEmitHelper",e[e.LastEmitHelper=65536]="LastEmitHelper",e[e.ForOfIncludes=256]="ForOfIncludes",e[e.ForAwaitOfIncludes=16384]="ForAwaitOfIncludes",e[e.AsyncGeneratorIncludes=6144]="AsyncGeneratorIncludes",e[e.AsyncDelegatorIncludes=26624]="AsyncDelegatorIncludes",e[e.SpreadIncludes=1536]="SpreadIncludes"}(e.ExternalEmitHelpers||(e.ExternalEmitHelpers={})),function(e){e[e.SourceFile=0]="SourceFile",e[e.Expression=1]="Expression",e[e.IdentifierName=2]="IdentifierName",e[e.MappedTypeParameter=3]="MappedTypeParameter",e[e.Unspecified=4]="Unspecified"}(e.EmitHint||(e.EmitHint={}))}(ts||(ts={})),function(e){e.timestamp="undefined"!=typeof performance&&performance.now?function(){return performance.now()}:Date.now?Date.now:function(){return+new Date}}(ts||(ts={})),function(e){!function(t){var n,r,i,a="function"==typeof onProfilerEvent&&!0===onProfilerEvent.profiler?onProfilerEvent:function(e){},o=!1,s=0;t.mark=function(t){o&&(r.set(t,e.timestamp()),n.set(t,(n.get(t)||0)+1),a(t))},t.measure=function(t,n,a){if(o){var c=a&&r.get(a)||e.timestamp(),u=n&&r.get(n)||s;i.set(t,(i.get(t)||0)+(c-u))}},t.getCount=function(e){return n&&n.get(e)||0},t.getDuration=function(e){return i&&i.get(e)||0},t.forEachMeasure=function(e){i.forEach((function(t,n){e(n,t)}))},t.enable=function(){n=e.createMap(),r=e.createMap(),i=e.createMap(),o=!0,s=e.timestamp()},t.disable=function(){o=!1}}(e.performance||(e.performance={}))}(ts||(ts={})),function(e){e.versionMajorMinor="2.6",e.version=e.versionMajorMinor+".1"}(ts||(ts={})),function(e){e.isExternalModuleNameRelative=function(t){return e.pathIsRelative(t)||e.isRootedDiskPath(t)}}(ts||(ts={})),function(e){function t(){var e=Object.create(null);return e.__=void 0,delete e.__,e}function n(){return new i}e.collator="object"==typeof Intl&&"function"==typeof Intl.Collator?new Intl.Collator(void 0,{usage:"sort",sensitivity:"accent"}):void 0,e.localeCompareIsCorrect=e.collator&&e.collator.compare("a","B")<0,e.createMap=n,e.createUnderscoreEscapedMap=function(){return new i},e.createSymbolTable=function(e){var t=n();if(e)for(var r=0,i=e;r<i.length;r++){var a=i[r];t.set(a.escapedName,a)}return t},e.createMapFromTemplate=function(e){var t=new i;for(var n in e)S.call(e,n)&&t.set(n,e[n]);return t};var r,i="undefined"!=typeof Map&&"entries"in Map.prototype?Map:(r=function(){function e(e,t){this.index=0,this.data=e,this.selector=t,this.keys=Object.keys(e)}return e.prototype.next=function(){var e=this.index;return e<this.keys.length?(this.index++,{value:this.selector(this.data,this.keys[e]),done:!1}):{value:void 0,done:!0}},e}(),function(){function e(){this.data=t(),this.size=0}return e.prototype.get=function(e){return this.data[e]},e.prototype.set=function(e,t){return this.has(e)||this.size++,this.data[e]=t,this},e.prototype.has=function(e){return e in this.data},e.prototype.delete=function(e){return!!this.has(e)&&(this.size--,delete this.data[e],!0)},e.prototype.clear=function(){this.data=t(),this.size=0},e.prototype.keys=function(){return new r(this.data,(function(e,t){return t}))},e.prototype.values=function(){return new r(this.data,(function(e,t){return e[t]}))},e.prototype.entries=function(){return new r(this.data,(function(e,t){return[t,e[t]]}))},e.prototype.forEach=function(e){for(var t in this.data)e(this.data[t],t)},e}());function a(e,t){if(e)for(var n=0;n<e.length;n++){var r=t(e[n],n);if(r)return r}}function o(e,t){for(var n=0;n<e.length;n++){var r=e[n];if(t(r,n))return r}}function s(e,t){for(var n=0;n<e.length;n++)if(t(e[n],n))return n;return-1}function c(e,t){if(e)for(var n=0,r=e;n<r.length;n++){if(r[n]===t)return!0}return!1}function u(e,t,n){for(var r=n||0;r<e.length;r++)if(c(t,e.charCodeAt(r)))return r;return-1}function _(e,t){for(var n=0,r=0;r<e.length;r++)t(e[r],r,e)&&(e[n]=e[r],n++);e.length=n}function l(e,t){var n;if(e){n=[];for(var r=0;r<e.length;r++)n.push(t(e[r],r))}return n}function d(e){var t;if(e){t=[];for(var n=0,r=e;n<r.length;n++){var i=r[n];i&&(w(i)?h(t,i):t.push(i))}}return t}function p(e,t){var n;if(e){n=[];for(var r=0;r<e.length;r++){var i=t(e[r],r);i&&(w(i)?h(n,i):n.push(i))}}return n}function f(e,t){if(e){if(!t)return e.length>0;for(var n=0,r=e;n<r.length;n++){if(t(r[n]))return!0}}return!1}function m(e,t){var n;if(e){n=[];e:for(var r=0,i=e;r<i.length;r++){for(var a=i[r],o=0,s=n;o<s.length;o++){var c=s[o];if(t?t(c,a):c===a)continue e}n.push(a)}}return n}function g(e,t,n){if(!e||!t)return e===t;if(e.length!==t.length)return!1;for(var r=0;r<e.length;r++){if(!(n?n(e[r],t[r]):e[r]===t[r]))return!1}return!0}function y(e,t){return t<0?e.length+t:t}function h(e,t,n,r){if(void 0===t||0===t.length)return e;if(void 0===e)return t.slice(n,r);n=void 0===n?0:y(t,n),r=void 0===r?t.length:y(t,r);for(var i=n;i<r&&i<t.length;i++){void 0!==t[i]&&e.push(t[i])}return e}function v(e,t){return!c(e,t)&&(e.push(t),!0)}function b(e,t){if(e&&(t=y(e,t))<e.length)return e[t]}function x(e){return b(e,-1)}function k(e,t,n,r,i){if(e&&e.length>0){var a=e.length;if(a>0){var o=void 0===r||r<0?0:r,s=void 0===i||o+i>a-1?a-1:o+i,c=void 0;for(arguments.length<=2?(c=e[o],o++):c=n;o<=s;)c=t(c,e[o],o),o++;return c}}return n}e.toPath=function(e,t,n){return n($(e)?q(e):ne(e,t))},function(e){e[e.LessThan=-1]="LessThan",e[e.EqualTo=0]="EqualTo",e[e.GreaterThan=1]="GreaterThan"}(e.Comparison||(e.Comparison={})),e.length=function(e){return e?e.length:0},e.forEach=a,e.firstDefined=function(e,t){for(var n=0;n<e.length;n++){var r=t(e[n],n);if(void 0!==r)return r}},e.findAncestor=function(e,t){for(;e;){var n=t(e);if("quit"===n)return;if(n)return e;e=e.parent}},e.zipWith=function(e,t,n){var r=[];Re.assert(e.length===t.length);for(var i=0;i<e.length;i++)r.push(n(e[i],t[i],i));return r},e.zipToMap=function(e,t){Re.assert(e.length===t.length);for(var r=n(),i=0;i<e.length;++i)r.set(e[i],t[i]);return r},e.every=function(e,t){if(e)for(var n=0;n<e.length;n++)if(!t(e[n],n))return!1;return!0},e.find=o,e.findLast=function(e,t){for(var n=e.length-1;n>=0;n--){var r=e[n];if(t(r,n))return r}},e.findIndex=s,e.findMap=function(e,t){for(var n=0;n<e.length;n++){var r=t(e[n],n);if(r)return r}Re.fail()},e.contains=c,e.indexOf=function(e,t){if(e)for(var n=0;n<e.length;n++)if(e[n]===t)return n;return-1},e.indexOfAnyCharCode=u,e.countWhere=function(e,t){var n=0;if(e)for(var r=0;r<e.length;r++){t(e[r],r)&&n++}return n},e.filter=function(e,t){if(e){for(var n=e.length,r=0;r<n&&t(e[r]);)r++;if(r<n){var i=e.slice(0,r);for(r++;r<n;){var a=e[r];t(a)&&i.push(a),r++}return i}}return e},e.filterMutate=_,e.clear=function(e){e.length=0},e.map=l,e.sameMap=function(e,t){var n;if(e)for(var r=0;r<e.length;r++)if(n)n.push(t(e[r],r));else{var i=e[r],a=t(i,r);i!==a&&(n=e.slice(0,r)).push(a)}return n||e},e.flatten=d,e.flatMap=p,e.flatMapIter=function(e,t){for(var n=[];;){var r=e.next(),i=r.value;if(r.done)break;var a=t(i);a&&(w(a)?n.push.apply(n,a):n.push(a))}return n},e.sameFlatMap=function(e,t){var n;if(e)for(var r=0;r<e.length;r++){var i=e[r],a=t(i,r);(n||i!==a||w(a))&&(n||(n=e.slice(0,r)),w(a)?h(n,a):n.push(a))}return n||e},e.mapDefined=function(e,t){var n=[];if(e)for(var r=0;r<e.length;r++){var i=t(e[r],r);void 0!==i&&n.push(i)}return n},e.mapDefinedIter=function(e,t){for(var n=[];;){var r=e.next(),i=r.value;if(r.done)break;var a=t(i);void 0!==a&&n.push(a)}return n},e.span=function(e,t){if(e){for(var n=0;n<e.length;n++)if(!t(e[n],n))return[e.slice(0,n),e.slice(n)];return[e.slice(0),[]]}},e.spanMap=function(e,t,n){var r;if(e){r=[];for(var i=e.length,a=void 0,o=void 0,s=0,c=0;s<i;){for(;c<i;){if(o=t(e[c],c),0===c)a=o;else if(o!==a)break;c++}if(s<c){var u=n(e.slice(s,c),a,s,c);u&&r.push(u),s=c}a=o,c++}}return r},e.mapEntries=function(e,t){if(e){var r=n();return e.forEach((function(e,n){var i=t(n,e),a=i[0],o=i[1];r.set(a,o)})),r}},e.some=f,e.concatenate=function(e,t){return f(t)?f(e)?e.concat(t):t:e},e.deduplicate=m,e.arrayIsEqualTo=g,e.changesAffectModuleResolution=function(e,t){return!(e&&e.module===t.module&&e.moduleResolution===t.moduleResolution&&e.noResolve===t.noResolve&&e.target===t.target&&e.noLib===t.noLib&&e.jsx===t.jsx&&e.allowJs===t.allowJs&&e.rootDir===t.rootDir&&e.configFilePath===t.configFilePath&&e.baseUrl===t.baseUrl&&e.maxNodeModuleJsDepth===t.maxNodeModuleJsDepth&&g(e.lib,t.lib)&&g(e.typeRoots,t.typeRoots)&&g(e.rootDirs,t.rootDirs)&&T(e.paths,t.paths))},e.compact=function(e){var t;if(e)for(var n=0;n<e.length;n++){var r=e[n];!t&&r||(t||(t=e.slice(0,n)),r&&t.push(r))}return t||e},e.relativeComplement=function(e,t,n,r,i){if(void 0===n&&(n=L),void 0===r&&(r=0),void 0===i&&(i=0),!t||!e||0===t.length||0===e.length)return t;var a=[];e:for(;i<t.length;i++){t:for(;r<e.length;r++)switch(n(t[i],e[r])){case-1:break t;case 0:continue e;case 1:continue t}a.push(t[i])}return a},e.sum=function(e,t){for(var n=0,r=0,i=e;r<i.length;r++){n+=i[r][t]}return n},e.append=function(e,t){return void 0===t?e:void 0===e?[t]:(e.push(t),e)},e.addRange=h,e.pushIfUnique=v,e.appendIfUnique=function(e,t){return e?(v(e,t),e):[t]},e.stableSort=function(e,t){return void 0===t&&(t=L),e.map((function(e,t){return t})).sort((function(n,r){return t(e[n],e[r])||L(n,r)})).map((function(t){return e[t]}))},e.rangeEquals=function(e,t,n,r){for(;n<r;){if(e[n]!==t[n])return!1;n++}return!0},e.elementAt=b,e.firstOrUndefined=function(e){return b(e,0)},e.first=function(e){return Re.assert(0!==e.length),e[0]},e.lastOrUndefined=x,e.last=function(e){return Re.assert(0!==e.length),e[e.length-1]},e.singleOrUndefined=function(e){return e&&1===e.length?e[0]:void 0},e.singleOrMany=function(e){return e&&1===e.length?e[0]:e},e.replaceElement=function(e,t,n){var r=e.slice(0);return r[t]=n,r},e.binarySearch=function(e,t,n,r){if(!e||0===e.length)return-1;var i=r||0,a=e.length-1;for(n=void 0!==n?n:function(e,t){return e<t?-1:e>t?1:0};i<=a;){var o=i+(a-i>>1),s=e[o];if(0===n(s,t))return o;n(s,t)>0?a=o-1:i=o+1}return~i},e.reduceLeft=k,e.reduceRight=function(e,t,n,r,i){if(e){var a=e.length;if(a>0){var o=void 0===r||r>a-1?a-1:r,s=void 0===i||o-i<0?0:o-i,c=void 0;for(arguments.length<=2?(c=e[o],o--):c=n;o>=s;)c=t(c,e[o],o),o--;return c}}return n};var S=Object.prototype.hasOwnProperty;function D(e,t){return S.call(e,t)}function C(e,t){e.forEach((function(e,n){t.set(n,e)}))}function T(e,t,n){if(e===t)return!0;if(!e||!t)return!1;for(var r in e)if(S.call(e,r)){if(void 0===!S.call(t,r))return!1;if(n?!n(e[r],t[r]):e[r]!==t[r])return!1}for(var r in t)if(S.call(t,r)&&!S.call(e,r))return!1;return!0}function E(e,t,r){for(var i=n(),a=0,o=e;a<o.length;a++){var s=o[a];i.set(t(s),r?r(s):s)}return i}function N(e,t){var n=this.get(e);return n?n.push(t):this.set(e,n=[t]),n}function A(e,t){var n=this.get(e);n&&(He(n,t),n.length||this.delete(e))}function w(e){return Array.isArray?Array.isArray(e):e instanceof Array}function P(e){return"string"==typeof e}function F(e){var t;return function(){return e&&(t=e(),e=void 0),t}}function O(e,t,n,r,i){if(i){for(var a=[],o=0;o<arguments.length;o++)a[o]=arguments[o];return function(e){return k(a,(function(e,t){return t(e)}),e)}}return r?function(i){return r(n(t(e(i))))}:n?function(r){return n(t(e(r)))}:t?function(n){return t(e(n))}:e?function(t){return e(t)}:function(e){return e}}function I(e,t,n){return n=n||0,e.replace(/{(\d+)}/g,(function(e,r){return t[+r+n]}))}function R(t){return e.localizedDiagnosticMessages&&e.localizedDiagnosticMessages[t.key]||t.message}function L(e,t){return e===t?0:void 0===e?-1:void 0===t?1:e<t?-1:1}function M(t,n,r){if(t===n)return 0;if(void 0===t)return-1;if(void 0===n)return 1;if(r){if(e.collator){var i=e.localeCompareIsCorrect?e.collator.compare(t,n):t.localeCompare(n,void 0,{usage:"sort",sensitivity:"accent"});return i<0?-1:i>0?1:0}if((t=t.toUpperCase())===(n=n.toUpperCase()))return 0}return t<n?-1:1}function B(e,t){return M(e,t,!0)}function J(e){return e.file?e.file.fileName:void 0}function z(e,t){return L(J(e),J(t))||L(e.start,t.start)||L(e.length,t.length)||L(e.code,t.code)||function(e,t){for(;e&&t;){var n=L(P(e)?e:e.messageText,P(t)?t:t.messageText);if(n)return n;e=P(e)?void 0:e.next,t=P(t)?void 0:t.next}if(!e&&!t)return 0;return e?1:-1}(e.messageText,t.messageText)||0}function j(e){if(e.length<2)return e;for(var t=[e[0]],n=e[0],r=1;r<e.length;r++){var i=e[r];0===z(i,n)||(t.push(i),n=i)}return t}function K(e){return e.replace(/\\/g,"/")}function U(e){if(47===e.charCodeAt(0)){if(47!==e.charCodeAt(1))return 1;var t=e.indexOf("/",2);if(t<0)return 2;var n=e.indexOf("/",t+1);return n<0?t+1:n+1}if(58===e.charCodeAt(1))return 47===e.charCodeAt(2)?3:2;if(0===e.lastIndexOf("file:///",0))return"file:///".length;var r=e.indexOf("://");return-1!==r?r+"://".length:0}e.hasProperty=D,e.getProperty=function(e,t){return S.call(e,t)?e[t]:void 0},e.getOwnKeys=function(e){var t=[];for(var n in e)S.call(e,n)&&t.push(n);return t},e.getOwnValues=function(e){var t=[];for(var n in e)S.call(e,n)&&t.push(e[n]);return t},e.arrayFrom=function(e,t){for(var n,r=[],i=e.next(),a=i.value,o=i.done;!o;a=(n=e.next()).value,o=n.done,n)r.push(t?t(a):a);return r},e.forEachEntry=function(e,t){for(var n,r=e.entries(),i=r.next(),a=i.value,o=i.done;!o;a=(n=r.next()).value,o=n.done,n){var s=a[0],c=t(a[1],s);if(c)return c}},e.forEachKey=function(e,t){for(var n,r=e.keys(),i=r.next(),a=i.value,o=i.done;!o;a=(n=r.next()).value,o=n.done,n){var s=t(a);if(s)return s}},e.copyEntries=C,e.assign=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];for(var r=0,i=t;r<i.length;r++){var a=i[r];for(var o in a)D(a,o)&&(e[o]=a[o])}return e},e.equalOwnProperties=T,e.arrayToMap=E,e.arrayToNumericMap=function(e,t){for(var n=[],r=0,i=e;r<i.length;r++){var a=i[r];n[t(a)]=a}return n},e.arrayToSet=function(e,t){return E(e,t||function(e){return e},(function(){return!0}))},e.cloneMap=function(e){var t=n();return C(e,t),t},e.clone=function(e){var t={};for(var n in e)S.call(e,n)&&(t[n]=e[n]);return t},e.extend=function(e,t){var n={};for(var r in t)S.call(t,r)&&(n[r]=t[r]);for(var r in e)S.call(e,r)&&(n[r]=e[r]);return n},e.createMultiMap=function(){var e=n();return e.add=N,e.remove=A,e},e.isArray=w,e.isString=P,e.tryCast=function(e,t){return void 0!==e&&t(e)?e:void 0},e.cast=function(e,t){if(void 0!==e&&t(e))return e;Re.fail("Invalid cast. The supplied value did not pass the test '"+Re.getFunctionName(t)+"'.")},e.noop=function(){},e.returnFalse=function(){return!1},e.returnTrue=function(){return!0},e.identity=function(e){return e},e.notImplemented=function(){throw new Error("Not implemented")},e.memoize=F,e.chain=function(e,t,n,r,i){if(i){for(var a=[],o=0;o<arguments.length;o++)a[o]=arguments[o];return function(e){return O.apply(void 0,l(a,(function(t){return t(e)})))}}return r?function(i){return O(e(i),t(i),n(i),r(i))}:n?function(r){return O(e(r),t(r),n(r))}:t?function(n){return O(e(n),t(n))}:e?function(t){return O(e(t))}:function(e){return function(e){return e}}},e.compose=O,e.formatStringFromArgs=I,e.localizedDiagnosticMessages=void 0,e.getLocaleSpecificMessage=R,e.createFileDiagnostic=function(e,t,n,r){Re.assertGreaterThanOrEqual(t,0),Re.assertGreaterThanOrEqual(n,0),e&&(Re.assertLessThanOrEqual(t,e.text.length),Re.assertLessThanOrEqual(t+n,e.text.length));var i=R(r);return arguments.length>4&&(i=I(i,arguments,4)),{file:e,start:t,length:n,messageText:i,category:r.category,code:r.code}},e.formatMessage=function(e,t){var n=R(t);return arguments.length>2&&(n=I(n,arguments,2)),n},e.createCompilerDiagnostic=function(e){var t=R(e);return arguments.length>1&&(t=I(t,arguments,1)),{file:void 0,start:void 0,length:void 0,messageText:t,category:e.category,code:e.code}},e.createCompilerDiagnosticFromMessageChain=function(e){return{file:void 0,start:void 0,length:void 0,code:e.code,category:e.category,messageText:e.next?e:e.messageText}},e.chainDiagnosticMessages=function(e,t){var n=R(t);return arguments.length>2&&(n=I(n,arguments,2)),{messageText:n,category:t.category,code:t.code,next:e}},e.concatenateDiagnosticMessageChains=function(e,t){for(var n=e;n.next;)n=n.next;return n.next=t,e},e.compareValues=L,e.compareStrings=M,e.compareStringsCaseInsensitive=B,e.compareDiagnostics=z,e.sortAndDeduplicateDiagnostics=function(e){return j(e.sort(z))},e.deduplicateSortedDiagnostics=j,e.normalizeSlashes=K,e.getRootLength=U,e.directorySeparator="/";function V(t,n){for(var r=[],i=0,a=t.substr(n).split(e.directorySeparator);i<a.length;i++){var o=a[i];"."!==o&&(".."===o&&r.length>0&&".."!==x(r)?r.pop():o&&r.push(o))}return r}function q(e){return W(e).path}function W(t){var n=U(t=K(t)),r=t.substr(0,n),i=V(t,n);if(i.length){var a=r+i.join(e.directorySeparator);return{path:H(t)?a+e.directorySeparator:a,parts:i}}return{path:r,parts:i}}function H(e){return 47===e.charCodeAt(e.length-1)}function G(t){return t.substr(0,Math.max(U(t),t.lastIndexOf(e.directorySeparator)))}function Q(e){return e&&!$(e)&&de(e,"://")}function X(e){return e.target||0}function Y(t){return"number"==typeof t.module?t.module:X(t)>=2?e.ModuleKind.ES2015:e.ModuleKind.CommonJS}function Z(e){for(var t=!1,n=0;n<e.length;n++)if(42===e.charCodeAt(n)){if(t)return!1;t=!0}return!0}function $(e){return e&&0!==U(e)}function ee(e,t){var n=V(e,t);return[e.substr(0,t)].concat(n)}function te(e,t){var n=U(e=K(e));return 0===n&&(n=U(e=se(K(t),e))),ee(e,n)}function ne(e,t){return re(te(e,t))}function re(t){if(t&&t.length)return t[0]+t.slice(1).join(e.directorySeparator)}function ie(t,n){return Q(t)?function(t){for(var n=t.length,r=t.indexOf("://")+"://".length;r<n&&47===t.charCodeAt(r);)r++;if(r===n)return[t];var i=t.indexOf(e.directorySeparator,r);return-1!==i?ee(t,r=i+1):[t+e.directorySeparator]}(t):te(t,n)}function ae(t,n,r,i,a){var o,s=ie(n,r),c=ie(t,r);for(c.length>1&&""===x(c)&&c.pop(),o=0;o<s.length&&o<c.length&&i(c[o])===i(s[o]);o++);if(o){for(var u="",_=s.slice(o,s.length);o<c.length;o++)""!==c[o]&&(u=u+".."+e.directorySeparator);return u+_.join(e.directorySeparator)}var l=re(s);return a&&$(l)&&(l="file:///"+l),l}function oe(t){if(void 0!==t){var n=t.lastIndexOf(e.directorySeparator);return n<0?t:t.substring(n+1)}}function se(t,n){return t&&t.length?n&&n.length?0!==U(n)?n:t.charAt(t.length-1)===e.directorySeparator?t+n:t+e.directorySeparator+n:t:n}function ce(t){return t.charAt(t.length-1)===e.directorySeparator?t.substr(0,t.length-1):t}function ue(e,t,n,r){if(void 0===e||void 0===t)return!1;if(e===t)return!0;if((e=ce(e))===(t=ce(t)))return!0;var i=te(e,n),a=te(t,n);if(a.length<i.length)return!1;for(var o=0;o<i.length;o++){if(0!==M(i[o],a[o],r))return!1}return!0}function _e(e,t){return 0===e.lastIndexOf(t,0)}function le(e,t){var n=e.length-t.length;return n>=0&&e.indexOf(t,n)===n}function de(e,t){return-1!==e.indexOf(t)}function pe(e){return de(oe(e),".")}function fe(e,t){return e.length>t.length&&le(e,t)}function me(e,t){for(var n=0,r=t;n<r.length;n++){if(fe(e,r[n]))return!0}return!1}e.normalizePath=q,e.normalizePathAndParts=W,e.pathEndsWithDirectorySeparator=H,e.getDirectoryPath=G,e.isUrl=Q,e.pathIsRelative=function(e){return/^\.\.?($|[\\/])/.test(e)},e.moduleHasNonRelativeName=function(t){return!e.isExternalModuleNameRelative(t)},e.getEmitScriptTarget=X,e.getEmitModuleKind=Y,e.getEmitModuleResolutionKind=function(t){var n=t.moduleResolution;return void 0===n&&(n=Y(t)===e.ModuleKind.CommonJS?e.ModuleResolutionKind.NodeJs:e.ModuleResolutionKind.Classic),n},e.hasZeroOrOneAsteriskCharacter=Z,e.isRootedDiskPath=$,e.convertToRelativePath=function(e,t,n){return $(e)?ae(t,e,t,n,!1):e},e.getNormalizedPathComponents=te,e.getNormalizedAbsolutePath=ne,e.getNormalizedPathFromPathComponents=re,e.getRelativePathToDirectoryOrUrl=ae,e.getBaseFileName=oe,e.combinePaths=se,e.removeTrailingDirectorySeparator=ce,e.ensureTrailingDirectorySeparator=function(t){return t.charAt(t.length-1)!==e.directorySeparator?t+e.directorySeparator:t},e.comparePaths=function(e,t,n,r){if(e===t)return 0;if(void 0===e)return-1;if(void 0===t)return 1;e=ce(e),t=ce(t);for(var i=te(e,n),a=te(t,n),o=Math.min(i.length,a.length),s=0;s<o;s++){var c=M(i[s],a[s],r);if(0!==c)return c}return L(i.length,a.length)},e.containsPath=ue,e.startsWith=_e,e.removePrefix=function(e,t){return _e(e,t)?e.substr(t.length):e},e.endsWith=le,e.stringContains=de,e.hasExtension=pe,e.fileExtensionIs=fe,e.fileExtensionIsOneOf=me;var ge=/[^\w\s\/]/g,ye=[42,63];e.commonPackageFolders=["node_modules","bower_components","jspm_packages"];var he="(?!("+e.commonPackageFolders.join("|")+")(/|$))",ve={singleAsteriskRegexFragment:"([^./]|(\\.(?!min\\.js$))?)*",doubleAsteriskRegexFragment:"(/"+he+"[^/.][^/]*)*?",replaceWildcardCharacter:function(e){return Te(e,ve.singleAsteriskRegexFragment)}},be={singleAsteriskRegexFragment:"[^/]*",doubleAsteriskRegexFragment:"(/"+he+"[^/.][^/]*)*?",replaceWildcardCharacter:function(e){return Te(e,be.singleAsteriskRegexFragment)}},xe={singleAsteriskRegexFragment:"[^/]*",doubleAsteriskRegexFragment:"(/.+?)?",replaceWildcardCharacter:function(e){return Te(e,xe.singleAsteriskRegexFragment)}},ke={files:ve,directories:be,exclude:xe};function Se(e,t,n){var r=De(e,t,n);if(r&&r.length)return"^("+r.map((function(e){return"("+e+")"})).join("|")+")"+("exclude"===n?"($|/)":"$")}function De(t,n,r){if(void 0!==t&&0!==t.length)return p(t,(function(t){return t&&function(t,n,r,i){var a=i.singleAsteriskRegexFragment,o=i.doubleAsteriskRegexFragment,s=i.replaceWildcardCharacter,c="",u=!1,_=!1,l=te(t,n),d=x(l);if("exclude"!==r&&"**"===d)return;l[0]=ce(l[0]),Ce(d)&&l.push("**","*");for(var p=0,f=0,m=l;f<m.length;f++){var g=m[f];if("**"===g){if(u)return;c+=o,u=!0}else if("directories"===r&&(c+="(",p++),_&&(c+=e.directorySeparator),"exclude"!==r){var y="";42===g.charCodeAt(0)?(y+="([^./]"+a+")?",g=g.substr(1)):63===g.charCodeAt(0)&&(y+="[^./]",g=g.substr(1)),(y+=g.replace(ge,s))!==g&&(c+=he),c+=y}else c+=g.replace(ge,s);_=!0}for(;p>0;)c+=")?",p--;return c}(t,n,r,ke[r])}))}function Ce(e){return!/[.*?]/.test(e)}function Te(e,t){return"*"===e?t:"?"===e?"[^/]":"\\"+e}function Ee(e,t,n,r,i){e=q(e);var a=se(i=q(i),e);return{includeFilePatterns:l(De(n,a,"files"),(function(e){return"^"+e+"$"})),includeFilePattern:Se(n,a,"files"),includeDirectoryPattern:Se(n,a,"directories"),excludePattern:Se(t,a,"exclude"),basePaths:Ae(e,n,r)}}function Ne(e,t,n,r,i,a,o,c){for(var u=Ee(e=q(e),n,r,i,a=q(a)),_=i?"":"i",l=u.includeFilePatterns&&u.includeFilePatterns.map((function(e){return new RegExp(e,_)})),p=u.includeDirectoryPattern&&new RegExp(u.includeDirectoryPattern,_),f=u.excludePattern&&new RegExp(u.excludePattern,_),m=l?l.map((function(){return[]})):[[]],g=i?M:B,y=0,h=u.basePaths;y<h.length;y++){var v=h[y];b(v,se(a,v),o)}return d(m);function b(e,n,r){for(var i=c(e),a=i.files,o=i.directories,u=function(r){var i=se(e,r),a=se(n,r);if(t&&!me(i,t))return"continue";if(f&&f.test(a))return"continue";if(l){var o=s(l,(function(e){return e.test(a)}));-1!==o&&m[o].push(i)}else m[0].push(i)},_=0,d=a=a.slice().sort(g);_<d.length;_++){u(v=d[_])}if(void 0===r||0!=--r)for(var y=0,h=o=o.slice().sort(g);y<h.length;y++){var v=h[y],x=se(e,v),k=se(n,v);p&&!p.test(k)||f&&f.test(k)||b(x,k,r)}}}function Ae(t,n,r){var i=[t];if(n){for(var a=[],o=0,s=n;o<s.length;o++){var c=s[o],u=$(c)?c:q(se(t,c));a.push(we(u))}a.sort(r?M:B);for(var _=function(n){e.every(i,(function(e){return!ue(e,n,t,!r)}))&&i.push(n)},l=0,d=a;l<d.length;l++){_(d[l])}}return i}function we(t){var n=u(t,ye);return n<0?pe(t)?ce(G(t)):t:t.substring(0,t.lastIndexOf(e.directorySeparator,n))}function Pe(e){switch(e.substr(e.lastIndexOf(".")).toLowerCase()){case".js":return 1;case".jsx":return 2;case".ts":return 3;case".tsx":return 4;case".json":return 6;default:return 0}}e.getRegularExpressionForWildcard=Se,e.isImplicitGlob=Ce,e.getFileMatcherPatterns=Ee,e.matchFiles=Ne,e.ensureScriptKind=function(e,t){return t||Pe(e)||3},e.getScriptKindFromFileName=Pe,e.supportedTypeScriptExtensions=[".ts",".tsx",".d.ts"],e.supportedTypescriptExtensionsForExtractExtension=[".d.ts",".ts",".tsx"],e.supportedJavascriptExtensions=[".js",".jsx"];var Fe=e.supportedTypeScriptExtensions.concat(e.supportedJavascriptExtensions);function Oe(t,n){var r=t&&t.allowJs;return n&&0!==n.length&&r?m(Fe.concat(n.map((function(e){return e.extension})))):r?Fe:e.supportedTypeScriptExtensions}function Ie(e,t){return e<2?0:e<t.length?2:t.length}e.getSupportedExtensions=Oe,e.hasJavaScriptFileExtension=function(t){return a(e.supportedJavascriptExtensions,(function(e){return fe(t,e)}))},e.hasTypeScriptFileExtension=function(t){return a(e.supportedTypeScriptExtensions,(function(e){return fe(t,e)}))},e.isSupportedSourceFileName=function(e,t,n){if(!e)return!1;for(var r=0,i=Oe(t,n);r<i.length;r++){if(fe(e,i[r]))return!0}return!1},function(e){e[e.TypeScriptFiles=0]="TypeScriptFiles",e[e.DeclarationAndJavaScriptFiles=2]="DeclarationAndJavaScriptFiles",e[e.Highest=0]="Highest",e[e.Lowest=2]="Lowest"}(e.ExtensionPriority||(e.ExtensionPriority={})),e.getExtensionPriority=function(e,t){for(var n=t.length-1;n>=0;n--)if(fe(e,t[n]))return Ie(n,t);return 0},e.adjustExtensionPriority=Ie,e.getNextLowestExtensionPriority=function(e,t){return e<2?2:t.length};var Re,Le=[".d.ts",".ts",".js",".tsx",".jsx"];function Me(e){for(var t=0,n=Le;t<n.length;t++){var r=Be(e,n[t]);if(void 0!==r)return r}return e}function Be(e,t){return fe(e,t)?Je(e,t):void 0}function Je(e,t){return e.substring(0,e.length-t.length)}function ze(e,t){this.flags=e,this.escapedName=t,this.declarations=void 0}function je(e,t){this.flags=t,Re.isDebugging&&(this.checker=e)}function Ke(){}function Ue(e,t,n){this.id=0,this.kind=e,this.pos=t,this.end=n,this.flags=0,this.modifierFlagsCache=0,this.transformFlags=0,this.parent=void 0,this.original=void 0}function Ve(e,t,n){this.fileName=e,this.text=t,this.skipTrivia=n||function(e){return e}}function qe(e,t){for(var n=t;n<e.length-1;n++)e[n]=e[n+1];e.pop()}function We(e,t){e[t]=e[e.length-1],e.pop()}function He(e,t){!function(e,t){for(var n=0;n<e.length;n++)if(t(e[n])){We(e,n);break}}(e,(function(e){return e===t}))}function Ge(e){return e?function(e){return e}:function(e){return e.toLowerCase()}}function Qe(e,t,n){for(var r=void 0,i=-1,a=0,o=e;a<o.length;a++){var s=o[a],c=t(s);Xe(c,n)&&c.prefix.length>i&&(i=c.prefix.length,r=s)}return r}function Xe(e,t){var n=e.prefix,r=e.suffix;return t.length>=n.length+r.length&&_e(t,n)&&le(t,r)}function Ye(e){Re.assert(Z(e));var t=e.indexOf("*");return-1===t?void 0:{prefix:e.substr(0,t),suffix:e.substr(t+1)}}function Ze(t){return o(e.supportedTypescriptExtensionsForExtractExtension,(function(e){return fe(t,e)}))||o(e.supportedJavascriptExtensions,(function(e){return fe(t,e)}))}e.removeFileExtension=Me,e.tryRemoveExtension=Be,e.removeExtension=Je,e.changeExtension=function(e,t){return Me(e)+t},e.objectAllocator={getNodeConstructor:function(){return Ue},getTokenConstructor:function(){return Ue},getIdentifierConstructor:function(){return Ue},getSourceFileConstructor:function(){return Ue},getSymbolConstructor:function(){return ze},getTypeConstructor:function(){return je},getSignatureConstructor:function(){return Ke},getSourceMapSourceConstructor:function(){return Ve}},function(e){e[e.None=0]="None",e[e.Normal=1]="Normal",e[e.Aggressive=2]="Aggressive",e[e.VeryAggressive=3]="VeryAggressive"}(e.AssertionLevel||(e.AssertionLevel={})),function(e){function t(e,n){var r=new Error(e?"Debug Failure. "+e:"Debug Failure.");throw Error.captureStackTrace&&Error.captureStackTrace(r,n||t),r}e.currentAssertionLevel=0,e.isDebugging=!1,e.shouldAssert=function(t){return e.currentAssertionLevel>=t},e.assert=function e(n,r,i,a){n||(i&&(r+="\r\nVerbose Debug Information: "+("string"==typeof i?i:i())),t(r?"False expression: "+r:"False expression.",a||e))},e.assertEqual=function(e,n,r,i){e!==n&&t("Expected "+e+" === "+n+". "+(r?i?r+" "+i:r:""))},e.assertLessThan=function(e,n,r){e>=n&&t("Expected "+e+" < "+n+". "+(r||""))},e.assertLessThanOrEqual=function(e,n){e>n&&t("Expected "+e+" <= "+n)},e.assertGreaterThanOrEqual=function(e,n){e<n&&t("Expected "+e+" >= "+n)},e.fail=t,e.assertNever=function e(n,r,i){return t(r||"Illegal value: "+n,i||e)},e.getFunctionName=function(e){if("function"!=typeof e)return"";if(e.hasOwnProperty("name"))return e.name;var t=Function.prototype.toString.call(e),n=/^function\s+([\w\$]+)\s*\(/.exec(t);return n?n[1]:""}}(Re=e.Debug||(e.Debug={})),e.orderedRemoveItem=function(e,t){for(var n=0;n<e.length;n++)if(e[n]===t)return qe(e,n),!0;return!1},e.orderedRemoveItemAt=qe,e.unorderedRemoveItemAt=We,e.unorderedRemoveItem=He,e.createGetCanonicalFileName=Ge,e.matchPatternOrExact=function(e,t){for(var n=[],r=0,i=e;r<i.length;r++){var a=i[r],o=Ye(a);if(o)n.push(o);else if(a===t)return a}return Qe(n,(function(e){return e}),t)},e.patternText=function(e){return e.prefix+"*"+e.suffix},e.matchedText=function(e,t){return Re.assert(Xe(e,t)),t.substr(e.prefix.length,t.length-e.suffix.length)},e.findBestPatternMatch=Qe,e.tryParsePattern=Ye,e.positionIsSynthesized=function(e){return!(e>=0)},e.extensionIsTypeScript=function(e){return".ts"===e||".tsx"===e||".d.ts"===e},e.extensionFromPath=function(e){var t=Ze(e);if(void 0!==t)return t;Re.fail("File "+e+" has unknown extension.")},e.isAnySupportedFileExtension=function(e){return void 0!==Ze(e)},e.tryGetExtensionFromPath=Ze,e.getAnyExtensionFromPath=function(e){var t=oe(e),n=t.lastIndexOf(".");if(n>=0)return t.substring(n)},e.isCheckJsEnabledForFile=function(e,t){return e.checkJsDirective?e.checkJsDirective.enabled:t.checkJs},e.and=function(e,t){return function(n){return e(n)&&t(n)}},e.assertTypeIsNever=function(e){},e.createCachedDirectoryStructureHost=function(t){var r=n(),i=F((function(){return t.getCurrentDirectory()})),a=Ge(t.useCaseSensitiveFileNames);return{useCaseSensitiveFileNames:t.useCaseSensitiveFileNames,newLine:t.newLine,readFile:function(e,n){return t.readFile(e,n)},write:function(e){return t.write(e)},writeFile:function(e,n,r){var i=c(o(e));i&&h(i,u(e),!0);return t.writeFile(e,n,r)},fileExists:function(e){var n=c(o(e));return n&&g(n.files,u(e))||t.fileExists(e)},directoryExists:function(e){var n=o(e);return r.has(n)||t.directoryExists(e)},createDirectory:function(e){var n=c(o(e)),r=u(e);n&&y(n.directories,r,!0);t.createDirectory(e)},getCurrentDirectory:i,getDirectories:function(e){var n=o(e),r=p(e,n);if(r)return r.directories.slice();return t.getDirectories(e)},readDirectory:function(e,n,r,a,c){var u=o(e),_=p(e,u);if(_)return Ne(e,n,r,a,t.useCaseSensitiveFileNames,i(),c,(function(e){var t=o(e);if(t===u)return _;return s(t)||d(e,t)}));return t.readDirectory(e,n,r,a,c)},addOrDeleteFileOrDirectory:function(e,n){if(s(n))t.directoryExists(e)||r.delete(n);else{var i=c(n);if(i){var a=u(e);if(i){var o={fileExists:t.fileExists(n),directoryExists:t.directoryExists(n)};return h(i,a,o.fileExists),y(i.directories,a,o.directoryExists),o}}}},addOrDeleteFile:function(t,n,r){if(r===e.FileWatcherEventKind.Changed)return;var i=c(n);i&&h(i,u(t),r===e.FileWatcherEventKind.Created)},clearCache:function(){r.clear()},exit:function(e){return t.exit(e)}};function o(t){return e.toPath(t,i(),a)}function s(e){return r.get(e)}function c(e){return s(G(e))}function u(e){return oe(q(e))}function d(e,n){var i={files:l(t.readDirectory(e,void 0,void 0,["*.*"]),u)||[],directories:t.getDirectories(e)||[]};return r.set(n,i),i}function p(e,t){var n=s(t);if(n)return n;try{return d(e,t)}catch(e){return void Re.assert(!r.has(t))}}function m(e,t){return a(e)===a(t)}function g(e,t){return f(e,(function(e){return m(e,t)}))}function y(e,t,n){if(g(e,t)){if(!n)return _(e,(function(e){return!m(e,t)}))}else if(n)return e.push(t)}function h(e,t,n){y(e.files,t,n)}}}(ts||(ts={})),function(e){var t;function n(){if("undefined"!=typeof process){var e=process.version;if(e){var t=e.indexOf(".");if(-1!==t)return parseInt(e.substring(1,t))}}}e.setStackTraceLimit=function(){Error.stackTraceLimit<100&&(Error.stackTraceLimit=100)},function(e){e[e.Created=0]="Created",e[e.Changed=1]="Changed",e[e.Deleted=2]="Deleted"}(t=e.FileWatcherEventKind||(e.FileWatcherEventKind={})),e.getNodeMajorVersion=n,e.sys=function(){function r(t,n){var i=e.getDirectoryPath(t),a=""!==i&&t!==i&&!n.directoryExists(i);a&&r(i,n),!a&&n.directoryExists(t)||n.createDirectory(t)}var i,a;if("undefined"!=typeof ChakraHost?(a=ChakraHost.realpath&&function(e){return ChakraHost.realpath(e)},i={newLine:ChakraHost.newLine||"\r\n",args:ChakraHost.args,useCaseSensitiveFileNames:!!ChakraHost.useCaseSensitiveFileNames,write:ChakraHost.echo,readFile:function(e,t){return ChakraHost.readFile(e)},writeFile:function(e,t,n){n&&(t="\ufeff"+t),ChakraHost.writeFile(e,t)},resolvePath:ChakraHost.resolvePath,fileExists:ChakraHost.fileExists,directoryExists:ChakraHost.directoryExists,createDirectory:ChakraHost.createDirectory,getExecutingFilePath:function(){return ChakraHost.executingFile},getCurrentDirectory:function(){return ChakraHost.currentDirectory},getDirectories:ChakraHost.getDirectories,getEnvironmentVariable:ChakraHost.getEnvironmentVariable||function(){return""},readDirectory:function(t,n,r,i,a){var o=e.getFileMatcherPatterns(t,r,i,!!ChakraHost.useCaseSensitiveFileNames,ChakraHost.currentDirectory);return ChakraHost.readDirectory(t,n,o.basePaths,o.excludePattern,o.includeFilePattern,o.includeDirectoryPattern)},exit:ChakraHost.quit,realpath:a}):"undefined"!=typeof process&&process.nextTick&&!process.browser&&"undefined"!=typeof require&&(i=function(){var r,i,a=require("fs"),o=require("path"),s=require("os"),c=require("crypto"),u=process.env.TSC_NONPOLLING_WATCHER,_=function(){var n=e.createMap(),r=e.createMultiMap();return{addFile:function(t,n){return a(t,n),i(e.getDirectoryPath(t)),{fileName:t,callback:n}},removeFile:function(t){var i,a,o,s,c;s=t.fileName,c=t.callback,r.remove(s,c),i=t.fileName,a=e.getDirectoryPath(i),(o=n.get(a))&&(o.referenceCount-=1,o.referenceCount<=0&&(o.close(),n.delete(a)))}};function i(i){var a=n.get(i);a?a.referenceCount+=1:((a=m(i||".",(function(n,a){return function(n,i,a){var o=e.isString(i)?e.getNormalizedAbsolutePath(i,a):void 0;if("change"===n||"rename"===n){var s=r.get(o);if(s)for(var c=0,u=s;c<u.length;c++)(0,u[c])(o,t.Changed)}}(n,a,i)}))).referenceCount=1,n.set(i,a))}function a(e,t){r.add(e,t)}}(),l=n()>=4,d=s.platform(),p="win32"!==d&&"win64"!==d&&!h((r=__filename,r.replace(/\w/g,(function(e){var t=e.toUpperCase();return e===t?e.toLowerCase():t}))));function f(e,n,r){return a.watchFile(e,{persistent:!0,interval:r||250},i),{close:function(){return a.unwatchFile(e,i)}};function i(r,i){var a=0==+r.mtime,o=0==+i.mtime,s=a&&!o,c=!a&&o?t.Created:s?t.Deleted:t.Changed;c===t.Changed&&+r.mtime<=+i.mtime||n(e,c)}}function m(e,n,r){var i,o=v(e)?s():c();return{close:function(){o.close()}};function s(){void 0===i&&(i=!l||"win32"!==process.platform&&"darwin"!==process.platform?{persistent:!0}:{persistent:!0,recursive:!!r});var t=a.watch(e,i,n);return t.on("error",(function(){v(e)||(o=c(),n("rename",""))})),t}function c(){return f(e,(function(r,i){i===t.Created&&v(e)&&(o.close(),o=s(),n("rename",""))}))}}function g(t){try{for(var n=a.readdirSync(t||".").sort(),r=[],i=[],o=0,s=n;o<s.length;o++){var c=s[o];if("."!==c&&".."!==c){var u=e.combinePaths(t,c),_=void 0;try{_=a.statSync(u)}catch(e){continue}_.isFile()?r.push(c):_.isDirectory()&&i.push(c)}}return{files:r,directories:i}}catch(e){return{files:[],directories:[]}}}function y(e,t){try{var n=a.statSync(e);switch(t){case 0:return n.isFile();case 1:return n.isDirectory()}}catch(e){return!1}}function h(e){return y(e,0)}function v(e){return y(e,1)}!function(e){e[e.File=0]="File",e[e.Directory=1]="Directory"}(i||(i={}));var b={args:process.argv.slice(2),newLine:s.EOL,useCaseSensitiveFileNames:p,write:function(e){process.stdout.write(e)},readFile:function(e,t){if(h(e)){var n=a.readFileSync(e),r=n.length;if(r>=2&&254===n[0]&&255===n[1]){r&=-2;for(var i=0;i<r;i+=2){var o=n[i];n[i]=n[i+1],n[i+1]=o}return n.toString("utf16le",2)}return r>=2&&255===n[0]&&254===n[1]?n.toString("utf16le",2):r>=3&&239===n[0]&&187===n[1]&&191===n[2]?n.toString("utf8",3):n.toString("utf8")}},writeFile:function(e,t,n){var r;n&&(t="\ufeff"+t);try{r=a.openSync(e,"w"),a.writeSync(r,t,void 0,"utf8")}finally{void 0!==r&&a.closeSync(r)}},watchFile:function(e,t,n){if(u){var r=_.addFile(e,t);return{close:function(){return _.removeFile(r)}}}return f(e,t,n)},watchDirectory:function(t,n,r){return m(t,(function(r,i){"rename"===r&&n(i?e.normalizePath(e.combinePaths(t,i)):i)}),r)},resolvePath:function(e){return o.resolve(e)},fileExists:h,directoryExists:v,createDirectory:function(e){b.directoryExists(e)||a.mkdirSync(e)},getExecutingFilePath:function(){return __filename},getCurrentDirectory:function(){return process.cwd()},getDirectories:function(t){return e.filter(a.readdirSync(t),(function(n){return y(e.combinePaths(t,n),1)}))},getEnvironmentVariable:function(e){return process.env[e]||""},readDirectory:function(t,n,r,i,a){return e.matchFiles(t,n,r,i,p,process.cwd(),a,g)},getModifiedTime:function(e){try{return a.statSync(e).mtime}catch(e){return}},createHash:function(e){var t=c.createHash("md5");return t.update(e),t.digest("hex")},getMemoryUsage:function(){return global.gc&&global.gc(),process.memoryUsage().heapUsed},getFileSize:function(e){try{var t=a.statSync(e);if(t.isFile())return t.size}catch(e){}return 0},exit:function(e){process.exit(e)},realpath:function(e){return a.realpathSync(e)},debugMode:e.some(process.execArgv,(function(e){return/^--(inspect|debug)(-brk)?(=\d+)?$/i.test(e)})),tryEnableSourceMapsForHost:function(){try{require("source-map-support").install()}catch(e){}},setTimeout:setTimeout,clearTimeout:clearTimeout};return b}()),i){var o=i.writeFile;i.writeFile=function(t,n,a){var s=e.getDirectoryPath(e.normalizeSlashes(t));s&&!i.directoryExists(s)&&r(s,i),o.call(i,t,n,a)}}return i}(),e.sys&&e.sys.getEnvironmentVariable&&(e.Debug.currentAssertionLevel=/^development$/i.test(e.sys.getEnvironmentVariable("NODE_ENV"))?1:0),e.sys&&e.sys.debugMode&&(e.Debug.isDebugging=!0)}(ts||(ts={})),function(e){function t(e,t,n,r){return{code:e,category:t,key:n,message:r}}e.Diagnostics={Unterminated_string_literal:t(1002,e.DiagnosticCategory.Error,"Unterminated_string_literal_1002","Unterminated string literal."),Identifier_expected:t(1003,e.DiagnosticCategory.Error,"Identifier_expected_1003","Identifier expected."),_0_expected:t(1005,e.DiagnosticCategory.Error,"_0_expected_1005","'{0}' expected."),A_file_cannot_have_a_reference_to_itself:t(1006,e.DiagnosticCategory.Error,"A_file_cannot_have_a_reference_to_itself_1006","A file cannot have a reference to itself."),Trailing_comma_not_allowed:t(1009,e.DiagnosticCategory.Error,"Trailing_comma_not_allowed_1009","Trailing comma not allowed."),Asterisk_Slash_expected:t(1010,e.DiagnosticCategory.Error,"Asterisk_Slash_expected_1010","'*/' expected."),Unexpected_token:t(1012,e.DiagnosticCategory.Error,"Unexpected_token_1012","Unexpected token."),A_rest_parameter_must_be_last_in_a_parameter_list:t(1014,e.DiagnosticCategory.Error,"A_rest_parameter_must_be_last_in_a_parameter_list_1014","A rest parameter must be last in a parameter list."),Parameter_cannot_have_question_mark_and_initializer:t(1015,e.DiagnosticCategory.Error,"Parameter_cannot_have_question_mark_and_initializer_1015","Parameter cannot have question mark and initializer."),A_required_parameter_cannot_follow_an_optional_parameter:t(1016,e.DiagnosticCategory.Error,"A_required_parameter_cannot_follow_an_optional_parameter_1016","A required parameter cannot follow an optional parameter."),An_index_signature_cannot_have_a_rest_parameter:t(1017,e.DiagnosticCategory.Error,"An_index_signature_cannot_have_a_rest_parameter_1017","An index signature cannot have a rest parameter."),An_index_signature_parameter_cannot_have_an_accessibility_modifier:t(1018,e.DiagnosticCategory.Error,"An_index_signature_parameter_cannot_have_an_accessibility_modifier_1018","An index signature parameter cannot have an accessibility modifier."),An_index_signature_parameter_cannot_have_a_question_mark:t(1019,e.DiagnosticCategory.Error,"An_index_signature_parameter_cannot_have_a_question_mark_1019","An index signature parameter cannot have a question mark."),An_index_signature_parameter_cannot_have_an_initializer:t(1020,e.DiagnosticCategory.Error,"An_index_signature_parameter_cannot_have_an_initializer_1020","An index signature parameter cannot have an initializer."),An_index_signature_must_have_a_type_annotation:t(1021,e.DiagnosticCategory.Error,"An_index_signature_must_have_a_type_annotation_1021","An index signature must have a type annotation."),An_index_signature_parameter_must_have_a_type_annotation:t(1022,e.DiagnosticCategory.Error,"An_index_signature_parameter_must_have_a_type_annotation_1022","An index signature parameter must have a type annotation."),An_index_signature_parameter_type_must_be_string_or_number:t(1023,e.DiagnosticCategory.Error,"An_index_signature_parameter_type_must_be_string_or_number_1023","An index signature parameter type must be 'string' or 'number'."),readonly_modifier_can_only_appear_on_a_property_declaration_or_index_signature:t(1024,e.DiagnosticCategory.Error,"readonly_modifier_can_only_appear_on_a_property_declaration_or_index_signature_1024","'readonly' modifier can only appear on a property declaration or index signature."),Accessibility_modifier_already_seen:t(1028,e.DiagnosticCategory.Error,"Accessibility_modifier_already_seen_1028","Accessibility modifier already seen."),_0_modifier_must_precede_1_modifier:t(1029,e.DiagnosticCategory.Error,"_0_modifier_must_precede_1_modifier_1029","'{0}' modifier must precede '{1}' modifier."),_0_modifier_already_seen:t(1030,e.DiagnosticCategory.Error,"_0_modifier_already_seen_1030","'{0}' modifier already seen."),_0_modifier_cannot_appear_on_a_class_element:t(1031,e.DiagnosticCategory.Error,"_0_modifier_cannot_appear_on_a_class_element_1031","'{0}' modifier cannot appear on a class element."),super_must_be_followed_by_an_argument_list_or_member_access:t(1034,e.DiagnosticCategory.Error,"super_must_be_followed_by_an_argument_list_or_member_access_1034","'super' must be followed by an argument list or member access."),Only_ambient_modules_can_use_quoted_names:t(1035,e.DiagnosticCategory.Error,"Only_ambient_modules_can_use_quoted_names_1035","Only ambient modules can use quoted names."),Statements_are_not_allowed_in_ambient_contexts:t(1036,e.DiagnosticCategory.Error,"Statements_are_not_allowed_in_ambient_contexts_1036","Statements are not allowed in ambient contexts."),A_declare_modifier_cannot_be_used_in_an_already_ambient_context:t(1038,e.DiagnosticCategory.Error,"A_declare_modifier_cannot_be_used_in_an_already_ambient_context_1038","A 'declare' modifier cannot be used in an already ambient context."),Initializers_are_not_allowed_in_ambient_contexts:t(1039,e.DiagnosticCategory.Error,"Initializers_are_not_allowed_in_ambient_contexts_1039","Initializers are not allowed in ambient contexts."),_0_modifier_cannot_be_used_in_an_ambient_context:t(1040,e.DiagnosticCategory.Error,"_0_modifier_cannot_be_used_in_an_ambient_context_1040","'{0}' modifier cannot be used in an ambient context."),_0_modifier_cannot_be_used_with_a_class_declaration:t(1041,e.DiagnosticCategory.Error,"_0_modifier_cannot_be_used_with_a_class_declaration_1041","'{0}' modifier cannot be used with a class declaration."),_0_modifier_cannot_be_used_here:t(1042,e.DiagnosticCategory.Error,"_0_modifier_cannot_be_used_here_1042","'{0}' modifier cannot be used here."),_0_modifier_cannot_appear_on_a_data_property:t(1043,e.DiagnosticCategory.Error,"_0_modifier_cannot_appear_on_a_data_property_1043","'{0}' modifier cannot appear on a data property."),_0_modifier_cannot_appear_on_a_module_or_namespace_element:t(1044,e.DiagnosticCategory.Error,"_0_modifier_cannot_appear_on_a_module_or_namespace_element_1044","'{0}' modifier cannot appear on a module or namespace element."),A_0_modifier_cannot_be_used_with_an_interface_declaration:t(1045,e.DiagnosticCategory.Error,"A_0_modifier_cannot_be_used_with_an_interface_declaration_1045","A '{0}' modifier cannot be used with an interface declaration."),A_declare_modifier_is_required_for_a_top_level_declaration_in_a_d_ts_file:t(1046,e.DiagnosticCategory.Error,"A_declare_modifier_is_required_for_a_top_level_declaration_in_a_d_ts_file_1046","A 'declare' modifier is required for a top level declaration in a .d.ts file."),A_rest_parameter_cannot_be_optional:t(1047,e.DiagnosticCategory.Error,"A_rest_parameter_cannot_be_optional_1047","A rest parameter cannot be optional."),A_rest_parameter_cannot_have_an_initializer:t(1048,e.DiagnosticCategory.Error,"A_rest_parameter_cannot_have_an_initializer_1048","A rest parameter cannot have an initializer."),A_set_accessor_must_have_exactly_one_parameter:t(1049,e.DiagnosticCategory.Error,"A_set_accessor_must_have_exactly_one_parameter_1049","A 'set' accessor must have exactly one parameter."),A_set_accessor_cannot_have_an_optional_parameter:t(1051,e.DiagnosticCategory.Error,"A_set_accessor_cannot_have_an_optional_parameter_1051","A 'set' accessor cannot have an optional parameter."),A_set_accessor_parameter_cannot_have_an_initializer:t(1052,e.DiagnosticCategory.Error,"A_set_accessor_parameter_cannot_have_an_initializer_1052","A 'set' accessor parameter cannot have an initializer."),A_set_accessor_cannot_have_rest_parameter:t(1053,e.DiagnosticCategory.Error,"A_set_accessor_cannot_have_rest_parameter_1053","A 'set' accessor cannot have rest parameter."),A_get_accessor_cannot_have_parameters:t(1054,e.DiagnosticCategory.Error,"A_get_accessor_cannot_have_parameters_1054","A 'get' accessor cannot have parameters."),Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value:t(1055,e.DiagnosticCategory.Error,"Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Prom_1055","Type '{0}' is not a valid async function return type in ES5/ES3 because it does not refer to a Promise-compatible constructor value."),Accessors_are_only_available_when_targeting_ECMAScript_5_and_higher:t(1056,e.DiagnosticCategory.Error,"Accessors_are_only_available_when_targeting_ECMAScript_5_and_higher_1056","Accessors are only available when targeting ECMAScript 5 and higher."),An_async_function_or_method_must_have_a_valid_awaitable_return_type:t(1057,e.DiagnosticCategory.Error,"An_async_function_or_method_must_have_a_valid_awaitable_return_type_1057","An async function or method must have a valid awaitable return type."),The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member:t(1058,e.DiagnosticCategory.Error,"The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_t_1058","The return type of an async function must either be a valid promise or must not contain a callable 'then' member."),A_promise_must_have_a_then_method:t(1059,e.DiagnosticCategory.Error,"A_promise_must_have_a_then_method_1059","A promise must have a 'then' method."),The_first_parameter_of_the_then_method_of_a_promise_must_be_a_callback:t(1060,e.DiagnosticCategory.Error,"The_first_parameter_of_the_then_method_of_a_promise_must_be_a_callback_1060","The first parameter of the 'then' method of a promise must be a callback."),Enum_member_must_have_initializer:t(1061,e.DiagnosticCategory.Error,"Enum_member_must_have_initializer_1061","Enum member must have initializer."),Type_is_referenced_directly_or_indirectly_in_the_fulfillment_callback_of_its_own_then_method:t(1062,e.DiagnosticCategory.Error,"Type_is_referenced_directly_or_indirectly_in_the_fulfillment_callback_of_its_own_then_method_1062","Type is referenced directly or indirectly in the fulfillment callback of its own 'then' method."),An_export_assignment_cannot_be_used_in_a_namespace:t(1063,e.DiagnosticCategory.Error,"An_export_assignment_cannot_be_used_in_a_namespace_1063","An export assignment cannot be used in a namespace."),The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type:t(1064,e.DiagnosticCategory.Error,"The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type_1064","The return type of an async function or method must be the global Promise<T> type."),In_ambient_enum_declarations_member_initializer_must_be_constant_expression:t(1066,e.DiagnosticCategory.Error,"In_ambient_enum_declarations_member_initializer_must_be_constant_expression_1066","In ambient enum declarations member initializer must be constant expression."),Unexpected_token_A_constructor_method_accessor_or_property_was_expected:t(1068,e.DiagnosticCategory.Error,"Unexpected_token_A_constructor_method_accessor_or_property_was_expected_1068","Unexpected token. A constructor, method, accessor, or property was expected."),_0_modifier_cannot_appear_on_a_type_member:t(1070,e.DiagnosticCategory.Error,"_0_modifier_cannot_appear_on_a_type_member_1070","'{0}' modifier cannot appear on a type member."),_0_modifier_cannot_appear_on_an_index_signature:t(1071,e.DiagnosticCategory.Error,"_0_modifier_cannot_appear_on_an_index_signature_1071","'{0}' modifier cannot appear on an index signature."),A_0_modifier_cannot_be_used_with_an_import_declaration:t(1079,e.DiagnosticCategory.Error,"A_0_modifier_cannot_be_used_with_an_import_declaration_1079","A '{0}' modifier cannot be used with an import declaration."),Invalid_reference_directive_syntax:t(1084,e.DiagnosticCategory.Error,"Invalid_reference_directive_syntax_1084","Invalid 'reference' directive syntax."),Octal_literals_are_not_available_when_targeting_ECMAScript_5_and_higher_Use_the_syntax_0:t(1085,e.DiagnosticCategory.Error,"Octal_literals_are_not_available_when_targeting_ECMAScript_5_and_higher_Use_the_syntax_0_1085","Octal literals are not available when targeting ECMAScript 5 and higher. Use the syntax '{0}'."),An_accessor_cannot_be_declared_in_an_ambient_context:t(1086,e.DiagnosticCategory.Error,"An_accessor_cannot_be_declared_in_an_ambient_context_1086","An accessor cannot be declared in an ambient context."),_0_modifier_cannot_appear_on_a_constructor_declaration:t(1089,e.DiagnosticCategory.Error,"_0_modifier_cannot_appear_on_a_constructor_declaration_1089","'{0}' modifier cannot appear on a constructor declaration."),_0_modifier_cannot_appear_on_a_parameter:t(1090,e.DiagnosticCategory.Error,"_0_modifier_cannot_appear_on_a_parameter_1090","'{0}' modifier cannot appear on a parameter."),Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement:t(1091,e.DiagnosticCategory.Error,"Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement_1091","Only a single variable declaration is allowed in a 'for...in' statement."),Type_parameters_cannot_appear_on_a_constructor_declaration:t(1092,e.DiagnosticCategory.Error,"Type_parameters_cannot_appear_on_a_constructor_declaration_1092","Type parameters cannot appear on a constructor declaration."),Type_annotation_cannot_appear_on_a_constructor_declaration:t(1093,e.DiagnosticCategory.Error,"Type_annotation_cannot_appear_on_a_constructor_declaration_1093","Type annotation cannot appear on a constructor declaration."),An_accessor_cannot_have_type_parameters:t(1094,e.DiagnosticCategory.Error,"An_accessor_cannot_have_type_parameters_1094","An accessor cannot have type parameters."),A_set_accessor_cannot_have_a_return_type_annotation:t(1095,e.DiagnosticCategory.Error,"A_set_accessor_cannot_have_a_return_type_annotation_1095","A 'set' accessor cannot have a return type annotation."),An_index_signature_must_have_exactly_one_parameter:t(1096,e.DiagnosticCategory.Error,"An_index_signature_must_have_exactly_one_parameter_1096","An index signature must have exactly one parameter."),_0_list_cannot_be_empty:t(1097,e.DiagnosticCategory.Error,"_0_list_cannot_be_empty_1097","'{0}' list cannot be empty."),Type_parameter_list_cannot_be_empty:t(1098,e.DiagnosticCategory.Error,"Type_parameter_list_cannot_be_empty_1098","Type parameter list cannot be empty."),Type_argument_list_cannot_be_empty:t(1099,e.DiagnosticCategory.Error,"Type_argument_list_cannot_be_empty_1099","Type argument list cannot be empty."),Invalid_use_of_0_in_strict_mode:t(1100,e.DiagnosticCategory.Error,"Invalid_use_of_0_in_strict_mode_1100","Invalid use of '{0}' in strict mode."),with_statements_are_not_allowed_in_strict_mode:t(1101,e.DiagnosticCategory.Error,"with_statements_are_not_allowed_in_strict_mode_1101","'with' statements are not allowed in strict mode."),delete_cannot_be_called_on_an_identifier_in_strict_mode:t(1102,e.DiagnosticCategory.Error,"delete_cannot_be_called_on_an_identifier_in_strict_mode_1102","'delete' cannot be called on an identifier in strict mode."),A_for_await_of_statement_is_only_allowed_within_an_async_function_or_async_generator:t(1103,e.DiagnosticCategory.Error,"A_for_await_of_statement_is_only_allowed_within_an_async_function_or_async_generator_1103","A 'for-await-of' statement is only allowed within an async function or async generator."),A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement:t(1104,e.DiagnosticCategory.Error,"A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement_1104","A 'continue' statement can only be used within an enclosing iteration statement."),A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement:t(1105,e.DiagnosticCategory.Error,"A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement_1105","A 'break' statement can only be used within an enclosing iteration or switch statement."),Jump_target_cannot_cross_function_boundary:t(1107,e.DiagnosticCategory.Error,"Jump_target_cannot_cross_function_boundary_1107","Jump target cannot cross function boundary."),A_return_statement_can_only_be_used_within_a_function_body:t(1108,e.DiagnosticCategory.Error,"A_return_statement_can_only_be_used_within_a_function_body_1108","A 'return' statement can only be used within a function body."),Expression_expected:t(1109,e.DiagnosticCategory.Error,"Expression_expected_1109","Expression expected."),Type_expected:t(1110,e.DiagnosticCategory.Error,"Type_expected_1110","Type expected."),A_default_clause_cannot_appear_more_than_once_in_a_switch_statement:t(1113,e.DiagnosticCategory.Error,"A_default_clause_cannot_appear_more_than_once_in_a_switch_statement_1113","A 'default' clause cannot appear more than once in a 'switch' statement."),Duplicate_label_0:t(1114,e.DiagnosticCategory.Error,"Duplicate_label_0_1114","Duplicate label '{0}'."),A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement:t(1115,e.DiagnosticCategory.Error,"A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement_1115","A 'continue' statement can only jump to a label of an enclosing iteration statement."),A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement:t(1116,e.DiagnosticCategory.Error,"A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement_1116","A 'break' statement can only jump to a label of an enclosing statement."),An_object_literal_cannot_have_multiple_properties_with_the_same_name_in_strict_mode:t(1117,e.DiagnosticCategory.Error,"An_object_literal_cannot_have_multiple_properties_with_the_same_name_in_strict_mode_1117","An object literal cannot have multiple properties with the same name in strict mode."),An_object_literal_cannot_have_multiple_get_Slashset_accessors_with_the_same_name:t(1118,e.DiagnosticCategory.Error,"An_object_literal_cannot_have_multiple_get_Slashset_accessors_with_the_same_name_1118","An object literal cannot have multiple get/set accessors with the same name."),An_object_literal_cannot_have_property_and_accessor_with_the_same_name:t(1119,e.DiagnosticCategory.Error,"An_object_literal_cannot_have_property_and_accessor_with_the_same_name_1119","An object literal cannot have property and accessor with the same name."),An_export_assignment_cannot_have_modifiers:t(1120,e.DiagnosticCategory.Error,"An_export_assignment_cannot_have_modifiers_1120","An export assignment cannot have modifiers."),Octal_literals_are_not_allowed_in_strict_mode:t(1121,e.DiagnosticCategory.Error,"Octal_literals_are_not_allowed_in_strict_mode_1121","Octal literals are not allowed in strict mode."),A_tuple_type_element_list_cannot_be_empty:t(1122,e.DiagnosticCategory.Error,"A_tuple_type_element_list_cannot_be_empty_1122","A tuple type element list cannot be empty."),Variable_declaration_list_cannot_be_empty:t(1123,e.DiagnosticCategory.Error,"Variable_declaration_list_cannot_be_empty_1123","Variable declaration list cannot be empty."),Digit_expected:t(1124,e.DiagnosticCategory.Error,"Digit_expected_1124","Digit expected."),Hexadecimal_digit_expected:t(1125,e.DiagnosticCategory.Error,"Hexadecimal_digit_expected_1125","Hexadecimal digit expected."),Unexpected_end_of_text:t(1126,e.DiagnosticCategory.Error,"Unexpected_end_of_text_1126","Unexpected end of text."),Invalid_character:t(1127,e.DiagnosticCategory.Error,"Invalid_character_1127","Invalid character."),Declaration_or_statement_expected:t(1128,e.DiagnosticCategory.Error,"Declaration_or_statement_expected_1128","Declaration or statement expected."),Statement_expected:t(1129,e.DiagnosticCategory.Error,"Statement_expected_1129","Statement expected."),case_or_default_expected:t(1130,e.DiagnosticCategory.Error,"case_or_default_expected_1130","'case' or 'default' expected."),Property_or_signature_expected:t(1131,e.DiagnosticCategory.Error,"Property_or_signature_expected_1131","Property or signature expected."),Enum_member_expected:t(1132,e.DiagnosticCategory.Error,"Enum_member_expected_1132","Enum member expected."),Variable_declaration_expected:t(1134,e.DiagnosticCategory.Error,"Variable_declaration_expected_1134","Variable declaration expected."),Argument_expression_expected:t(1135,e.DiagnosticCategory.Error,"Argument_expression_expected_1135","Argument expression expected."),Property_assignment_expected:t(1136,e.DiagnosticCategory.Error,"Property_assignment_expected_1136","Property assignment expected."),Expression_or_comma_expected:t(1137,e.DiagnosticCategory.Error,"Expression_or_comma_expected_1137","Expression or comma expected."),Parameter_declaration_expected:t(1138,e.DiagnosticCategory.Error,"Parameter_declaration_expected_1138","Parameter declaration expected."),Type_parameter_declaration_expected:t(1139,e.DiagnosticCategory.Error,"Type_parameter_declaration_expected_1139","Type parameter declaration expected."),Type_argument_expected:t(1140,e.DiagnosticCategory.Error,"Type_argument_expected_1140","Type argument expected."),String_literal_expected:t(1141,e.DiagnosticCategory.Error,"String_literal_expected_1141","String literal expected."),Line_break_not_permitted_here:t(1142,e.DiagnosticCategory.Error,"Line_break_not_permitted_here_1142","Line break not permitted here."),or_expected:t(1144,e.DiagnosticCategory.Error,"or_expected_1144","'{' or ';' expected."),Declaration_expected:t(1146,e.DiagnosticCategory.Error,"Declaration_expected_1146","Declaration expected."),Import_declarations_in_a_namespace_cannot_reference_a_module:t(1147,e.DiagnosticCategory.Error,"Import_declarations_in_a_namespace_cannot_reference_a_module_1147","Import declarations in a namespace cannot reference a module."),Cannot_use_imports_exports_or_module_augmentations_when_module_is_none:t(1148,e.DiagnosticCategory.Error,"Cannot_use_imports_exports_or_module_augmentations_when_module_is_none_1148","Cannot use imports, exports, or module augmentations when '--module' is 'none'."),File_name_0_differs_from_already_included_file_name_1_only_in_casing:t(1149,e.DiagnosticCategory.Error,"File_name_0_differs_from_already_included_file_name_1_only_in_casing_1149","File name '{0}' differs from already included file name '{1}' only in casing."),new_T_cannot_be_used_to_create_an_array_Use_new_Array_T_instead:t(1150,e.DiagnosticCategory.Error,"new_T_cannot_be_used_to_create_an_array_Use_new_Array_T_instead_1150","'new T[]' cannot be used to create an array. Use 'new Array<T>()' instead."),const_declarations_must_be_initialized:t(1155,e.DiagnosticCategory.Error,"const_declarations_must_be_initialized_1155","'const' declarations must be initialized."),const_declarations_can_only_be_declared_inside_a_block:t(1156,e.DiagnosticCategory.Error,"const_declarations_can_only_be_declared_inside_a_block_1156","'const' declarations can only be declared inside a block."),let_declarations_can_only_be_declared_inside_a_block:t(1157,e.DiagnosticCategory.Error,"let_declarations_can_only_be_declared_inside_a_block_1157","'let' declarations can only be declared inside a block."),Unterminated_template_literal:t(1160,e.DiagnosticCategory.Error,"Unterminated_template_literal_1160","Unterminated template literal."),Unterminated_regular_expression_literal:t(1161,e.DiagnosticCategory.Error,"Unterminated_regular_expression_literal_1161","Unterminated regular expression literal."),An_object_member_cannot_be_declared_optional:t(1162,e.DiagnosticCategory.Error,"An_object_member_cannot_be_declared_optional_1162","An object member cannot be declared optional."),A_yield_expression_is_only_allowed_in_a_generator_body:t(1163,e.DiagnosticCategory.Error,"A_yield_expression_is_only_allowed_in_a_generator_body_1163","A 'yield' expression is only allowed in a generator body."),Computed_property_names_are_not_allowed_in_enums:t(1164,e.DiagnosticCategory.Error,"Computed_property_names_are_not_allowed_in_enums_1164","Computed property names are not allowed in enums."),A_computed_property_name_in_an_ambient_context_must_directly_refer_to_a_built_in_symbol:t(1165,e.DiagnosticCategory.Error,"A_computed_property_name_in_an_ambient_context_must_directly_refer_to_a_built_in_symbol_1165","A computed property name in an ambient context must directly refer to a built-in symbol."),A_computed_property_name_in_a_class_property_declaration_must_directly_refer_to_a_built_in_symbol:t(1166,e.DiagnosticCategory.Error,"A_computed_property_name_in_a_class_property_declaration_must_directly_refer_to_a_built_in_symbol_1166","A computed property name in a class property declaration must directly refer to a built-in symbol."),A_computed_property_name_in_a_method_overload_must_directly_refer_to_a_built_in_symbol:t(1168,e.DiagnosticCategory.Error,"A_computed_property_name_in_a_method_overload_must_directly_refer_to_a_built_in_symbol_1168","A computed property name in a method overload must directly refer to a built-in symbol."),A_computed_property_name_in_an_interface_must_directly_refer_to_a_built_in_symbol:t(1169,e.DiagnosticCategory.Error,"A_computed_property_name_in_an_interface_must_directly_refer_to_a_built_in_symbol_1169","A computed property name in an interface must directly refer to a built-in symbol."),A_computed_property_name_in_a_type_literal_must_directly_refer_to_a_built_in_symbol:t(1170,e.DiagnosticCategory.Error,"A_computed_property_name_in_a_type_literal_must_directly_refer_to_a_built_in_symbol_1170","A computed property name in a type literal must directly refer to a built-in symbol."),A_comma_expression_is_not_allowed_in_a_computed_property_name:t(1171,e.DiagnosticCategory.Error,"A_comma_expression_is_not_allowed_in_a_computed_property_name_1171","A comma expression is not allowed in a computed property name."),extends_clause_already_seen:t(1172,e.DiagnosticCategory.Error,"extends_clause_already_seen_1172","'extends' clause already seen."),extends_clause_must_precede_implements_clause:t(1173,e.DiagnosticCategory.Error,"extends_clause_must_precede_implements_clause_1173","'extends' clause must precede 'implements' clause."),Classes_can_only_extend_a_single_class:t(1174,e.DiagnosticCategory.Error,"Classes_can_only_extend_a_single_class_1174","Classes can only extend a single class."),implements_clause_already_seen:t(1175,e.DiagnosticCategory.Error,"implements_clause_already_seen_1175","'implements' clause already seen."),Interface_declaration_cannot_have_implements_clause:t(1176,e.DiagnosticCategory.Error,"Interface_declaration_cannot_have_implements_clause_1176","Interface declaration cannot have 'implements' clause."),Binary_digit_expected:t(1177,e.DiagnosticCategory.Error,"Binary_digit_expected_1177","Binary digit expected."),Octal_digit_expected:t(1178,e.DiagnosticCategory.Error,"Octal_digit_expected_1178","Octal digit expected."),Unexpected_token_expected:t(1179,e.DiagnosticCategory.Error,"Unexpected_token_expected_1179","Unexpected token. '{' expected."),Property_destructuring_pattern_expected:t(1180,e.DiagnosticCategory.Error,"Property_destructuring_pattern_expected_1180","Property destructuring pattern expected."),Array_element_destructuring_pattern_expected:t(1181,e.DiagnosticCategory.Error,"Array_element_destructuring_pattern_expected_1181","Array element destructuring pattern expected."),A_destructuring_declaration_must_have_an_initializer:t(1182,e.DiagnosticCategory.Error,"A_destructuring_declaration_must_have_an_initializer_1182","A destructuring declaration must have an initializer."),An_implementation_cannot_be_declared_in_ambient_contexts:t(1183,e.DiagnosticCategory.Error,"An_implementation_cannot_be_declared_in_ambient_contexts_1183","An implementation cannot be declared in ambient contexts."),Modifiers_cannot_appear_here:t(1184,e.DiagnosticCategory.Error,"Modifiers_cannot_appear_here_1184","Modifiers cannot appear here."),Merge_conflict_marker_encountered:t(1185,e.DiagnosticCategory.Error,"Merge_conflict_marker_encountered_1185","Merge conflict marker encountered."),A_rest_element_cannot_have_an_initializer:t(1186,e.DiagnosticCategory.Error,"A_rest_element_cannot_have_an_initializer_1186","A rest element cannot have an initializer."),A_parameter_property_may_not_be_declared_using_a_binding_pattern:t(1187,e.DiagnosticCategory.Error,"A_parameter_property_may_not_be_declared_using_a_binding_pattern_1187","A parameter property may not be declared using a binding pattern."),Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement:t(1188,e.DiagnosticCategory.Error,"Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement_1188","Only a single variable declaration is allowed in a 'for...of' statement."),The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer:t(1189,e.DiagnosticCategory.Error,"The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer_1189","The variable declaration of a 'for...in' statement cannot have an initializer."),The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer:t(1190,e.DiagnosticCategory.Error,"The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer_1190","The variable declaration of a 'for...of' statement cannot have an initializer."),An_import_declaration_cannot_have_modifiers:t(1191,e.DiagnosticCategory.Error,"An_import_declaration_cannot_have_modifiers_1191","An import declaration cannot have modifiers."),Module_0_has_no_default_export:t(1192,e.DiagnosticCategory.Error,"Module_0_has_no_default_export_1192","Module '{0}' has no default export."),An_export_declaration_cannot_have_modifiers:t(1193,e.DiagnosticCategory.Error,"An_export_declaration_cannot_have_modifiers_1193","An export declaration cannot have modifiers."),Export_declarations_are_not_permitted_in_a_namespace:t(1194,e.DiagnosticCategory.Error,"Export_declarations_are_not_permitted_in_a_namespace_1194","Export declarations are not permitted in a namespace."),Catch_clause_variable_cannot_have_a_type_annotation:t(1196,e.DiagnosticCategory.Error,"Catch_clause_variable_cannot_have_a_type_annotation_1196","Catch clause variable cannot have a type annotation."),Catch_clause_variable_cannot_have_an_initializer:t(1197,e.DiagnosticCategory.Error,"Catch_clause_variable_cannot_have_an_initializer_1197","Catch clause variable cannot have an initializer."),An_extended_Unicode_escape_value_must_be_between_0x0_and_0x10FFFF_inclusive:t(1198,e.DiagnosticCategory.Error,"An_extended_Unicode_escape_value_must_be_between_0x0_and_0x10FFFF_inclusive_1198","An extended Unicode escape value must be between 0x0 and 0x10FFFF inclusive."),Unterminated_Unicode_escape_sequence:t(1199,e.DiagnosticCategory.Error,"Unterminated_Unicode_escape_sequence_1199","Unterminated Unicode escape sequence."),Line_terminator_not_permitted_before_arrow:t(1200,e.DiagnosticCategory.Error,"Line_terminator_not_permitted_before_arrow_1200","Line terminator not permitted before arrow."),Import_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_import_Asterisk_as_ns_from_mod_import_a_from_mod_import_d_from_mod_or_another_module_format_instead:t(1202,e.DiagnosticCategory.Error,"Import_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_import_Asterisk_as_1202","Import assignment cannot be used when targeting ECMAScript modules. Consider using 'import * as ns from \"mod\"', 'import {a} from \"mod\"', 'import d from \"mod\"', or another module format instead."),Export_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_export_default_or_another_module_format_instead:t(1203,e.DiagnosticCategory.Error,"Export_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_export_default_or__1203","Export assignment cannot be used when targeting ECMAScript modules. Consider using 'export default' or another module format instead."),Cannot_re_export_a_type_when_the_isolatedModules_flag_is_provided:t(1205,e.DiagnosticCategory.Error,"Cannot_re_export_a_type_when_the_isolatedModules_flag_is_provided_1205","Cannot re-export a type when the '--isolatedModules' flag is provided."),Decorators_are_not_valid_here:t(1206,e.DiagnosticCategory.Error,"Decorators_are_not_valid_here_1206","Decorators are not valid here."),Decorators_cannot_be_applied_to_multiple_get_Slashset_accessors_of_the_same_name:t(1207,e.DiagnosticCategory.Error,"Decorators_cannot_be_applied_to_multiple_get_Slashset_accessors_of_the_same_name_1207","Decorators cannot be applied to multiple get/set accessors of the same name."),Cannot_compile_namespaces_when_the_isolatedModules_flag_is_provided:t(1208,e.DiagnosticCategory.Error,"Cannot_compile_namespaces_when_the_isolatedModules_flag_is_provided_1208","Cannot compile namespaces when the '--isolatedModules' flag is provided."),Ambient_const_enums_are_not_allowed_when_the_isolatedModules_flag_is_provided:t(1209,e.DiagnosticCategory.Error,"Ambient_const_enums_are_not_allowed_when_the_isolatedModules_flag_is_provided_1209","Ambient const enums are not allowed when the '--isolatedModules' flag is provided."),Invalid_use_of_0_Class_definitions_are_automatically_in_strict_mode:t(1210,e.DiagnosticCategory.Error,"Invalid_use_of_0_Class_definitions_are_automatically_in_strict_mode_1210","Invalid use of '{0}'. Class definitions are automatically in strict mode."),A_class_declaration_without_the_default_modifier_must_have_a_name:t(1211,e.DiagnosticCategory.Error,"A_class_declaration_without_the_default_modifier_must_have_a_name_1211","A class declaration without the 'default' modifier must have a name."),Identifier_expected_0_is_a_reserved_word_in_strict_mode:t(1212,e.DiagnosticCategory.Error,"Identifier_expected_0_is_a_reserved_word_in_strict_mode_1212","Identifier expected. '{0}' is a reserved word in strict mode."),Identifier_expected_0_is_a_reserved_word_in_strict_mode_Class_definitions_are_automatically_in_strict_mode:t(1213,e.DiagnosticCategory.Error,"Identifier_expected_0_is_a_reserved_word_in_strict_mode_Class_definitions_are_automatically_in_stric_1213","Identifier expected. '{0}' is a reserved word in strict mode. Class definitions are automatically in strict mode."),Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode:t(1214,e.DiagnosticCategory.Error,"Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode_1214","Identifier expected. '{0}' is a reserved word in strict mode. Modules are automatically in strict mode."),Invalid_use_of_0_Modules_are_automatically_in_strict_mode:t(1215,e.DiagnosticCategory.Error,"Invalid_use_of_0_Modules_are_automatically_in_strict_mode_1215","Invalid use of '{0}'. Modules are automatically in strict mode."),Identifier_expected_esModule_is_reserved_as_an_exported_marker_when_transforming_ECMAScript_modules:t(1216,e.DiagnosticCategory.Error,"Identifier_expected_esModule_is_reserved_as_an_exported_marker_when_transforming_ECMAScript_modules_1216","Identifier expected. '__esModule' is reserved as an exported marker when transforming ECMAScript modules."),Export_assignment_is_not_supported_when_module_flag_is_system:t(1218,e.DiagnosticCategory.Error,"Export_assignment_is_not_supported_when_module_flag_is_system_1218","Export assignment is not supported when '--module' flag is 'system'."),Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_the_experimentalDecorators_option_to_remove_this_warning:t(1219,e.DiagnosticCategory.Error,"Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_t_1219","Experimental support for decorators is a feature that is subject to change in a future release. Set the 'experimentalDecorators' option to remove this warning."),Generators_are_only_available_when_targeting_ECMAScript_2015_or_higher:t(1220,e.DiagnosticCategory.Error,"Generators_are_only_available_when_targeting_ECMAScript_2015_or_higher_1220","Generators are only available when targeting ECMAScript 2015 or higher."),Generators_are_not_allowed_in_an_ambient_context:t(1221,e.DiagnosticCategory.Error,"Generators_are_not_allowed_in_an_ambient_context_1221","Generators are not allowed in an ambient context."),An_overload_signature_cannot_be_declared_as_a_generator:t(1222,e.DiagnosticCategory.Error,"An_overload_signature_cannot_be_declared_as_a_generator_1222","An overload signature cannot be declared as a generator."),_0_tag_already_specified:t(1223,e.DiagnosticCategory.Error,"_0_tag_already_specified_1223","'{0}' tag already specified."),Signature_0_must_be_a_type_predicate:t(1224,e.DiagnosticCategory.Error,"Signature_0_must_be_a_type_predicate_1224","Signature '{0}' must be a type predicate."),Cannot_find_parameter_0:t(1225,e.DiagnosticCategory.Error,"Cannot_find_parameter_0_1225","Cannot find parameter '{0}'."),Type_predicate_0_is_not_assignable_to_1:t(1226,e.DiagnosticCategory.Error,"Type_predicate_0_is_not_assignable_to_1_1226","Type predicate '{0}' is not assignable to '{1}'."),Parameter_0_is_not_in_the_same_position_as_parameter_1:t(1227,e.DiagnosticCategory.Error,"Parameter_0_is_not_in_the_same_position_as_parameter_1_1227","Parameter '{0}' is not in the same position as parameter '{1}'."),A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods:t(1228,e.DiagnosticCategory.Error,"A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods_1228","A type predicate is only allowed in return type position for functions and methods."),A_type_predicate_cannot_reference_a_rest_parameter:t(1229,e.DiagnosticCategory.Error,"A_type_predicate_cannot_reference_a_rest_parameter_1229","A type predicate cannot reference a rest parameter."),A_type_predicate_cannot_reference_element_0_in_a_binding_pattern:t(1230,e.DiagnosticCategory.Error,"A_type_predicate_cannot_reference_element_0_in_a_binding_pattern_1230","A type predicate cannot reference element '{0}' in a binding pattern."),An_export_assignment_can_only_be_used_in_a_module:t(1231,e.DiagnosticCategory.Error,"An_export_assignment_can_only_be_used_in_a_module_1231","An export assignment can only be used in a module."),An_import_declaration_can_only_be_used_in_a_namespace_or_module:t(1232,e.DiagnosticCategory.Error,"An_import_declaration_can_only_be_used_in_a_namespace_or_module_1232","An import declaration can only be used in a namespace or module."),An_export_declaration_can_only_be_used_in_a_module:t(1233,e.DiagnosticCategory.Error,"An_export_declaration_can_only_be_used_in_a_module_1233","An export declaration can only be used in a module."),An_ambient_module_declaration_is_only_allowed_at_the_top_level_in_a_file:t(1234,e.DiagnosticCategory.Error,"An_ambient_module_declaration_is_only_allowed_at_the_top_level_in_a_file_1234","An ambient module declaration is only allowed at the top level in a file."),A_namespace_declaration_is_only_allowed_in_a_namespace_or_module:t(1235,e.DiagnosticCategory.Error,"A_namespace_declaration_is_only_allowed_in_a_namespace_or_module_1235","A namespace declaration is only allowed in a namespace or module."),The_return_type_of_a_property_decorator_function_must_be_either_void_or_any:t(1236,e.DiagnosticCategory.Error,"The_return_type_of_a_property_decorator_function_must_be_either_void_or_any_1236","The return type of a property decorator function must be either 'void' or 'any'."),The_return_type_of_a_parameter_decorator_function_must_be_either_void_or_any:t(1237,e.DiagnosticCategory.Error,"The_return_type_of_a_parameter_decorator_function_must_be_either_void_or_any_1237","The return type of a parameter decorator function must be either 'void' or 'any'."),Unable_to_resolve_signature_of_class_decorator_when_called_as_an_expression:t(1238,e.DiagnosticCategory.Error,"Unable_to_resolve_signature_of_class_decorator_when_called_as_an_expression_1238","Unable to resolve signature of class decorator when called as an expression."),Unable_to_resolve_signature_of_parameter_decorator_when_called_as_an_expression:t(1239,e.DiagnosticCategory.Error,"Unable_to_resolve_signature_of_parameter_decorator_when_called_as_an_expression_1239","Unable to resolve signature of parameter decorator when called as an expression."),Unable_to_resolve_signature_of_property_decorator_when_called_as_an_expression:t(1240,e.DiagnosticCategory.Error,"Unable_to_resolve_signature_of_property_decorator_when_called_as_an_expression_1240","Unable to resolve signature of property decorator when called as an expression."),Unable_to_resolve_signature_of_method_decorator_when_called_as_an_expression:t(1241,e.DiagnosticCategory.Error,"Unable_to_resolve_signature_of_method_decorator_when_called_as_an_expression_1241","Unable to resolve signature of method decorator when called as an expression."),abstract_modifier_can_only_appear_on_a_class_method_or_property_declaration:t(1242,e.DiagnosticCategory.Error,"abstract_modifier_can_only_appear_on_a_class_method_or_property_declaration_1242","'abstract' modifier can only appear on a class, method, or property declaration."),_0_modifier_cannot_be_used_with_1_modifier:t(1243,e.DiagnosticCategory.Error,"_0_modifier_cannot_be_used_with_1_modifier_1243","'{0}' modifier cannot be used with '{1}' modifier."),Abstract_methods_can_only_appear_within_an_abstract_class:t(1244,e.DiagnosticCategory.Error,"Abstract_methods_can_only_appear_within_an_abstract_class_1244","Abstract methods can only appear within an abstract class."),Method_0_cannot_have_an_implementation_because_it_is_marked_abstract:t(1245,e.DiagnosticCategory.Error,"Method_0_cannot_have_an_implementation_because_it_is_marked_abstract_1245","Method '{0}' cannot have an implementation because it is marked abstract."),An_interface_property_cannot_have_an_initializer:t(1246,e.DiagnosticCategory.Error,"An_interface_property_cannot_have_an_initializer_1246","An interface property cannot have an initializer."),A_type_literal_property_cannot_have_an_initializer:t(1247,e.DiagnosticCategory.Error,"A_type_literal_property_cannot_have_an_initializer_1247","A type literal property cannot have an initializer."),A_class_member_cannot_have_the_0_keyword:t(1248,e.DiagnosticCategory.Error,"A_class_member_cannot_have_the_0_keyword_1248","A class member cannot have the '{0}' keyword."),A_decorator_can_only_decorate_a_method_implementation_not_an_overload:t(1249,e.DiagnosticCategory.Error,"A_decorator_can_only_decorate_a_method_implementation_not_an_overload_1249","A decorator can only decorate a method implementation, not an overload."),Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5:t(1250,e.DiagnosticCategory.Error,"Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_1250","Function declarations are not allowed inside blocks in strict mode when targeting 'ES3' or 'ES5'."),Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Class_definitions_are_automatically_in_strict_mode:t(1251,e.DiagnosticCategory.Error,"Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Class_d_1251","Function declarations are not allowed inside blocks in strict mode when targeting 'ES3' or 'ES5'. Class definitions are automatically in strict mode."),Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Modules_are_automatically_in_strict_mode:t(1252,e.DiagnosticCategory.Error,"Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Modules_1252","Function declarations are not allowed inside blocks in strict mode when targeting 'ES3' or 'ES5'. Modules are automatically in strict mode."),_0_tag_cannot_be_used_independently_as_a_top_level_JSDoc_tag:t(1253,e.DiagnosticCategory.Error,"_0_tag_cannot_be_used_independently_as_a_top_level_JSDoc_tag_1253","'{0}' tag cannot be used independently as a top level JSDoc tag."),A_const_initializer_in_an_ambient_context_must_be_a_string_or_numeric_literal:t(1254,e.DiagnosticCategory.Error,"A_const_initializer_in_an_ambient_context_must_be_a_string_or_numeric_literal_1254","A 'const' initializer in an ambient context must be a string or numeric literal."),with_statements_are_not_allowed_in_an_async_function_block:t(1300,e.DiagnosticCategory.Error,"with_statements_are_not_allowed_in_an_async_function_block_1300","'with' statements are not allowed in an async function block."),await_expression_is_only_allowed_within_an_async_function:t(1308,e.DiagnosticCategory.Error,"await_expression_is_only_allowed_within_an_async_function_1308","'await' expression is only allowed within an async function."),can_only_be_used_in_an_object_literal_property_inside_a_destructuring_assignment:t(1312,e.DiagnosticCategory.Error,"can_only_be_used_in_an_object_literal_property_inside_a_destructuring_assignment_1312","'=' can only be used in an object literal property inside a destructuring assignment."),The_body_of_an_if_statement_cannot_be_the_empty_statement:t(1313,e.DiagnosticCategory.Error,"The_body_of_an_if_statement_cannot_be_the_empty_statement_1313","The body of an 'if' statement cannot be the empty statement."),Global_module_exports_may_only_appear_in_module_files:t(1314,e.DiagnosticCategory.Error,"Global_module_exports_may_only_appear_in_module_files_1314","Global module exports may only appear in module files."),Global_module_exports_may_only_appear_in_declaration_files:t(1315,e.DiagnosticCategory.Error,"Global_module_exports_may_only_appear_in_declaration_files_1315","Global module exports may only appear in declaration files."),Global_module_exports_may_only_appear_at_top_level:t(1316,e.DiagnosticCategory.Error,"Global_module_exports_may_only_appear_at_top_level_1316","Global module exports may only appear at top level."),A_parameter_property_cannot_be_declared_using_a_rest_parameter:t(1317,e.DiagnosticCategory.Error,"A_parameter_property_cannot_be_declared_using_a_rest_parameter_1317","A parameter property cannot be declared using a rest parameter."),An_abstract_accessor_cannot_have_an_implementation:t(1318,e.DiagnosticCategory.Error,"An_abstract_accessor_cannot_have_an_implementation_1318","An abstract accessor cannot have an implementation."),A_default_export_can_only_be_used_in_an_ECMAScript_style_module:t(1319,e.DiagnosticCategory.Error,"A_default_export_can_only_be_used_in_an_ECMAScript_style_module_1319","A default export can only be used in an ECMAScript-style module."),Type_of_await_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member:t(1320,e.DiagnosticCategory.Error,"Type_of_await_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member_1320","Type of 'await' operand must either be a valid promise or must not contain a callable 'then' member."),Type_of_yield_operand_in_an_async_generator_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member:t(1321,e.DiagnosticCategory.Error,"Type_of_yield_operand_in_an_async_generator_must_either_be_a_valid_promise_or_must_not_contain_a_cal_1321","Type of 'yield' operand in an async generator must either be a valid promise or must not contain a callable 'then' member."),Type_of_iterated_elements_of_a_yield_Asterisk_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member:t(1322,e.DiagnosticCategory.Error,"Type_of_iterated_elements_of_a_yield_Asterisk_operand_must_either_be_a_valid_promise_or_must_not_con_1322","Type of iterated elements of a 'yield*' operand must either be a valid promise or must not contain a callable 'then' member."),Dynamic_import_cannot_be_used_when_targeting_ECMAScript_2015_modules:t(1323,e.DiagnosticCategory.Error,"Dynamic_import_cannot_be_used_when_targeting_ECMAScript_2015_modules_1323","Dynamic import cannot be used when targeting ECMAScript 2015 modules."),Dynamic_import_must_have_one_specifier_as_an_argument:t(1324,e.DiagnosticCategory.Error,"Dynamic_import_must_have_one_specifier_as_an_argument_1324","Dynamic import must have one specifier as an argument."),Specifier_of_dynamic_import_cannot_be_spread_element:t(1325,e.DiagnosticCategory.Error,"Specifier_of_dynamic_import_cannot_be_spread_element_1325","Specifier of dynamic import cannot be spread element."),Dynamic_import_cannot_have_type_arguments:t(1326,e.DiagnosticCategory.Error,"Dynamic_import_cannot_have_type_arguments_1326","Dynamic import cannot have type arguments"),String_literal_with_double_quotes_expected:t(1327,e.DiagnosticCategory.Error,"String_literal_with_double_quotes_expected_1327","String literal with double quotes expected."),Property_value_can_only_be_string_literal_numeric_literal_true_false_null_object_literal_or_array_literal:t(1328,e.DiagnosticCategory.Error,"Property_value_can_only_be_string_literal_numeric_literal_true_false_null_object_literal_or_array_li_1328","Property value can only be string literal, numeric literal, 'true', 'false', 'null', object literal or array literal."),_0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write_0:t(1329,e.DiagnosticCategory.Error,"_0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write__1329","'{0}' accepts too few arguments to be used as a decorator here. Did you mean to call it first and write '@{0}()'?"),Duplicate_identifier_0:t(2300,e.DiagnosticCategory.Error,"Duplicate_identifier_0_2300","Duplicate identifier '{0}'."),Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor:t(2301,e.DiagnosticCategory.Error,"Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor_2301","Initializer of instance member variable '{0}' cannot reference identifier '{1}' declared in the constructor."),Static_members_cannot_reference_class_type_parameters:t(2302,e.DiagnosticCategory.Error,"Static_members_cannot_reference_class_type_parameters_2302","Static members cannot reference class type parameters."),Circular_definition_of_import_alias_0:t(2303,e.DiagnosticCategory.Error,"Circular_definition_of_import_alias_0_2303","Circular definition of import alias '{0}'."),Cannot_find_name_0:t(2304,e.DiagnosticCategory.Error,"Cannot_find_name_0_2304","Cannot find name '{0}'."),Module_0_has_no_exported_member_1:t(2305,e.DiagnosticCategory.Error,"Module_0_has_no_exported_member_1_2305","Module '{0}' has no exported member '{1}'."),File_0_is_not_a_module:t(2306,e.DiagnosticCategory.Error,"File_0_is_not_a_module_2306","File '{0}' is not a module."),Cannot_find_module_0:t(2307,e.DiagnosticCategory.Error,"Cannot_find_module_0_2307","Cannot find module '{0}'."),Module_0_has_already_exported_a_member_named_1_Consider_explicitly_re_exporting_to_resolve_the_ambiguity:t(2308,e.DiagnosticCategory.Error,"Module_0_has_already_exported_a_member_named_1_Consider_explicitly_re_exporting_to_resolve_the_ambig_2308","Module {0} has already exported a member named '{1}'. Consider explicitly re-exporting to resolve the ambiguity."),An_export_assignment_cannot_be_used_in_a_module_with_other_exported_elements:t(2309,e.DiagnosticCategory.Error,"An_export_assignment_cannot_be_used_in_a_module_with_other_exported_elements_2309","An export assignment cannot be used in a module with other exported elements."),Type_0_recursively_references_itself_as_a_base_type:t(2310,e.DiagnosticCategory.Error,"Type_0_recursively_references_itself_as_a_base_type_2310","Type '{0}' recursively references itself as a base type."),A_class_may_only_extend_another_class:t(2311,e.DiagnosticCategory.Error,"A_class_may_only_extend_another_class_2311","A class may only extend another class."),An_interface_may_only_extend_a_class_or_another_interface:t(2312,e.DiagnosticCategory.Error,"An_interface_may_only_extend_a_class_or_another_interface_2312","An interface may only extend a class or another interface."),Type_parameter_0_has_a_circular_constraint:t(2313,e.DiagnosticCategory.Error,"Type_parameter_0_has_a_circular_constraint_2313","Type parameter '{0}' has a circular constraint."),Generic_type_0_requires_1_type_argument_s:t(2314,e.DiagnosticCategory.Error,"Generic_type_0_requires_1_type_argument_s_2314","Generic type '{0}' requires {1} type argument(s)."),Type_0_is_not_generic:t(2315,e.DiagnosticCategory.Error,"Type_0_is_not_generic_2315","Type '{0}' is not generic."),Global_type_0_must_be_a_class_or_interface_type:t(2316,e.DiagnosticCategory.Error,"Global_type_0_must_be_a_class_or_interface_type_2316","Global type '{0}' must be a class or interface type."),Global_type_0_must_have_1_type_parameter_s:t(2317,e.DiagnosticCategory.Error,"Global_type_0_must_have_1_type_parameter_s_2317","Global type '{0}' must have {1} type parameter(s)."),Cannot_find_global_type_0:t(2318,e.DiagnosticCategory.Error,"Cannot_find_global_type_0_2318","Cannot find global type '{0}'."),Named_property_0_of_types_1_and_2_are_not_identical:t(2319,e.DiagnosticCategory.Error,"Named_property_0_of_types_1_and_2_are_not_identical_2319","Named property '{0}' of types '{1}' and '{2}' are not identical."),Interface_0_cannot_simultaneously_extend_types_1_and_2:t(2320,e.DiagnosticCategory.Error,"Interface_0_cannot_simultaneously_extend_types_1_and_2_2320","Interface '{0}' cannot simultaneously extend types '{1}' and '{2}'."),Excessive_stack_depth_comparing_types_0_and_1:t(2321,e.DiagnosticCategory.Error,"Excessive_stack_depth_comparing_types_0_and_1_2321","Excessive stack depth comparing types '{0}' and '{1}'."),Type_0_is_not_assignable_to_type_1:t(2322,e.DiagnosticCategory.Error,"Type_0_is_not_assignable_to_type_1_2322","Type '{0}' is not assignable to type '{1}'."),Cannot_redeclare_exported_variable_0:t(2323,e.DiagnosticCategory.Error,"Cannot_redeclare_exported_variable_0_2323","Cannot redeclare exported variable '{0}'."),Property_0_is_missing_in_type_1:t(2324,e.DiagnosticCategory.Error,"Property_0_is_missing_in_type_1_2324","Property '{0}' is missing in type '{1}'."),Property_0_is_private_in_type_1_but_not_in_type_2:t(2325,e.DiagnosticCategory.Error,"Property_0_is_private_in_type_1_but_not_in_type_2_2325","Property '{0}' is private in type '{1}' but not in type '{2}'."),Types_of_property_0_are_incompatible:t(2326,e.DiagnosticCategory.Error,"Types_of_property_0_are_incompatible_2326","Types of property '{0}' are incompatible."),Property_0_is_optional_in_type_1_but_required_in_type_2:t(2327,e.DiagnosticCategory.Error,"Property_0_is_optional_in_type_1_but_required_in_type_2_2327","Property '{0}' is optional in type '{1}' but required in type '{2}'."),Types_of_parameters_0_and_1_are_incompatible:t(2328,e.DiagnosticCategory.Error,"Types_of_parameters_0_and_1_are_incompatible_2328","Types of parameters '{0}' and '{1}' are incompatible."),Index_signature_is_missing_in_type_0:t(2329,e.DiagnosticCategory.Error,"Index_signature_is_missing_in_type_0_2329","Index signature is missing in type '{0}'."),Index_signatures_are_incompatible:t(2330,e.DiagnosticCategory.Error,"Index_signatures_are_incompatible_2330","Index signatures are incompatible."),this_cannot_be_referenced_in_a_module_or_namespace_body:t(2331,e.DiagnosticCategory.Error,"this_cannot_be_referenced_in_a_module_or_namespace_body_2331","'this' cannot be referenced in a module or namespace body."),this_cannot_be_referenced_in_current_location:t(2332,e.DiagnosticCategory.Error,"this_cannot_be_referenced_in_current_location_2332","'this' cannot be referenced in current location."),this_cannot_be_referenced_in_constructor_arguments:t(2333,e.DiagnosticCategory.Error,"this_cannot_be_referenced_in_constructor_arguments_2333","'this' cannot be referenced in constructor arguments."),this_cannot_be_referenced_in_a_static_property_initializer:t(2334,e.DiagnosticCategory.Error,"this_cannot_be_referenced_in_a_static_property_initializer_2334","'this' cannot be referenced in a static property initializer."),super_can_only_be_referenced_in_a_derived_class:t(2335,e.DiagnosticCategory.Error,"super_can_only_be_referenced_in_a_derived_class_2335","'super' can only be referenced in a derived class."),super_cannot_be_referenced_in_constructor_arguments:t(2336,e.DiagnosticCategory.Error,"super_cannot_be_referenced_in_constructor_arguments_2336","'super' cannot be referenced in constructor arguments."),Super_calls_are_not_permitted_outside_constructors_or_in_nested_functions_inside_constructors:t(2337,e.DiagnosticCategory.Error,"Super_calls_are_not_permitted_outside_constructors_or_in_nested_functions_inside_constructors_2337","Super calls are not permitted outside constructors or in nested functions inside constructors."),super_property_access_is_permitted_only_in_a_constructor_member_function_or_member_accessor_of_a_derived_class:t(2338,e.DiagnosticCategory.Error,"super_property_access_is_permitted_only_in_a_constructor_member_function_or_member_accessor_of_a_der_2338","'super' property access is permitted only in a constructor, member function, or member accessor of a derived class."),Property_0_does_not_exist_on_type_1:t(2339,e.DiagnosticCategory.Error,"Property_0_does_not_exist_on_type_1_2339","Property '{0}' does not exist on type '{1}'."),Only_public_and_protected_methods_of_the_base_class_are_accessible_via_the_super_keyword:t(2340,e.DiagnosticCategory.Error,"Only_public_and_protected_methods_of_the_base_class_are_accessible_via_the_super_keyword_2340","Only public and protected methods of the base class are accessible via the 'super' keyword."),Property_0_is_private_and_only_accessible_within_class_1:t(2341,e.DiagnosticCategory.Error,"Property_0_is_private_and_only_accessible_within_class_1_2341","Property '{0}' is private and only accessible within class '{1}'."),An_index_expression_argument_must_be_of_type_string_number_symbol_or_any:t(2342,e.DiagnosticCategory.Error,"An_index_expression_argument_must_be_of_type_string_number_symbol_or_any_2342","An index expression argument must be of type 'string', 'number', 'symbol', or 'any'."),This_syntax_requires_an_imported_helper_named_1_but_module_0_has_no_exported_member_1:t(2343,e.DiagnosticCategory.Error,"This_syntax_requires_an_imported_helper_named_1_but_module_0_has_no_exported_member_1_2343","This syntax requires an imported helper named '{1}', but module '{0}' has no exported member '{1}'."),Type_0_does_not_satisfy_the_constraint_1:t(2344,e.DiagnosticCategory.Error,"Type_0_does_not_satisfy_the_constraint_1_2344","Type '{0}' does not satisfy the constraint '{1}'."),Argument_of_type_0_is_not_assignable_to_parameter_of_type_1:t(2345,e.DiagnosticCategory.Error,"Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_2345","Argument of type '{0}' is not assignable to parameter of type '{1}'."),Call_target_does_not_contain_any_signatures:t(2346,e.DiagnosticCategory.Error,"Call_target_does_not_contain_any_signatures_2346","Call target does not contain any signatures."),Untyped_function_calls_may_not_accept_type_arguments:t(2347,e.DiagnosticCategory.Error,"Untyped_function_calls_may_not_accept_type_arguments_2347","Untyped function calls may not accept type arguments."),Value_of_type_0_is_not_callable_Did_you_mean_to_include_new:t(2348,e.DiagnosticCategory.Error,"Value_of_type_0_is_not_callable_Did_you_mean_to_include_new_2348","Value of type '{0}' is not callable. Did you mean to include 'new'?"),Cannot_invoke_an_expression_whose_type_lacks_a_call_signature_Type_0_has_no_compatible_call_signatures:t(2349,e.DiagnosticCategory.Error,"Cannot_invoke_an_expression_whose_type_lacks_a_call_signature_Type_0_has_no_compatible_call_signatur_2349","Cannot invoke an expression whose type lacks a call signature. Type '{0}' has no compatible call signatures."),Only_a_void_function_can_be_called_with_the_new_keyword:t(2350,e.DiagnosticCategory.Error,"Only_a_void_function_can_be_called_with_the_new_keyword_2350","Only a void function can be called with the 'new' keyword."),Cannot_use_new_with_an_expression_whose_type_lacks_a_call_or_construct_signature:t(2351,e.DiagnosticCategory.Error,"Cannot_use_new_with_an_expression_whose_type_lacks_a_call_or_construct_signature_2351","Cannot use 'new' with an expression whose type lacks a call or construct signature."),Type_0_cannot_be_converted_to_type_1:t(2352,e.DiagnosticCategory.Error,"Type_0_cannot_be_converted_to_type_1_2352","Type '{0}' cannot be converted to type '{1}'."),Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1:t(2353,e.DiagnosticCategory.Error,"Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1_2353","Object literal may only specify known properties, and '{0}' does not exist in type '{1}'."),This_syntax_requires_an_imported_helper_but_module_0_cannot_be_found:t(2354,e.DiagnosticCategory.Error,"This_syntax_requires_an_imported_helper_but_module_0_cannot_be_found_2354","This syntax requires an imported helper but module '{0}' cannot be found."),A_function_whose_declared_type_is_neither_void_nor_any_must_return_a_value:t(2355,e.DiagnosticCategory.Error,"A_function_whose_declared_type_is_neither_void_nor_any_must_return_a_value_2355","A function whose declared type is neither 'void' nor 'any' must return a value."),An_arithmetic_operand_must_be_of_type_any_number_or_an_enum_type:t(2356,e.DiagnosticCategory.Error,"An_arithmetic_operand_must_be_of_type_any_number_or_an_enum_type_2356","An arithmetic operand must be of type 'any', 'number' or an enum type."),The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access:t(2357,e.DiagnosticCategory.Error,"The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access_2357","The operand of an increment or decrement operator must be a variable or a property access."),The_left_hand_side_of_an_instanceof_expression_must_be_of_type_any_an_object_type_or_a_type_parameter:t(2358,e.DiagnosticCategory.Error,"The_left_hand_side_of_an_instanceof_expression_must_be_of_type_any_an_object_type_or_a_type_paramete_2358","The left-hand side of an 'instanceof' expression must be of type 'any', an object type or a type parameter."),The_right_hand_side_of_an_instanceof_expression_must_be_of_type_any_or_of_a_type_assignable_to_the_Function_interface_type:t(2359,e.DiagnosticCategory.Error,"The_right_hand_side_of_an_instanceof_expression_must_be_of_type_any_or_of_a_type_assignable_to_the_F_2359","The right-hand side of an 'instanceof' expression must be of type 'any' or of a type assignable to the 'Function' interface type."),The_left_hand_side_of_an_in_expression_must_be_of_type_any_string_number_or_symbol:t(2360,e.DiagnosticCategory.Error,"The_left_hand_side_of_an_in_expression_must_be_of_type_any_string_number_or_symbol_2360","The left-hand side of an 'in' expression must be of type 'any', 'string', 'number', or 'symbol'."),The_right_hand_side_of_an_in_expression_must_be_of_type_any_an_object_type_or_a_type_parameter:t(2361,e.DiagnosticCategory.Error,"The_right_hand_side_of_an_in_expression_must_be_of_type_any_an_object_type_or_a_type_parameter_2361","The right-hand side of an 'in' expression must be of type 'any', an object type or a type parameter."),The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_or_an_enum_type:t(2362,e.DiagnosticCategory.Error,"The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_or_an_enum_type_2362","The left-hand side of an arithmetic operation must be of type 'any', 'number' or an enum type."),The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_or_an_enum_type:t(2363,e.DiagnosticCategory.Error,"The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_or_an_enum_type_2363","The right-hand side of an arithmetic operation must be of type 'any', 'number' or an enum type."),The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access:t(2364,e.DiagnosticCategory.Error,"The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access_2364","The left-hand side of an assignment expression must be a variable or a property access."),Operator_0_cannot_be_applied_to_types_1_and_2:t(2365,e.DiagnosticCategory.Error,"Operator_0_cannot_be_applied_to_types_1_and_2_2365","Operator '{0}' cannot be applied to types '{1}' and '{2}'."),Function_lacks_ending_return_statement_and_return_type_does_not_include_undefined:t(2366,e.DiagnosticCategory.Error,"Function_lacks_ending_return_statement_and_return_type_does_not_include_undefined_2366","Function lacks ending return statement and return type does not include 'undefined'."),Type_parameter_name_cannot_be_0:t(2368,e.DiagnosticCategory.Error,"Type_parameter_name_cannot_be_0_2368","Type parameter name cannot be '{0}'."),A_parameter_property_is_only_allowed_in_a_constructor_implementation:t(2369,e.DiagnosticCategory.Error,"A_parameter_property_is_only_allowed_in_a_constructor_implementation_2369","A parameter property is only allowed in a constructor implementation."),A_rest_parameter_must_be_of_an_array_type:t(2370,e.DiagnosticCategory.Error,"A_rest_parameter_must_be_of_an_array_type_2370","A rest parameter must be of an array type."),A_parameter_initializer_is_only_allowed_in_a_function_or_constructor_implementation:t(2371,e.DiagnosticCategory.Error,"A_parameter_initializer_is_only_allowed_in_a_function_or_constructor_implementation_2371","A parameter initializer is only allowed in a function or constructor implementation."),Parameter_0_cannot_be_referenced_in_its_initializer:t(2372,e.DiagnosticCategory.Error,"Parameter_0_cannot_be_referenced_in_its_initializer_2372","Parameter '{0}' cannot be referenced in its initializer."),Initializer_of_parameter_0_cannot_reference_identifier_1_declared_after_it:t(2373,e.DiagnosticCategory.Error,"Initializer_of_parameter_0_cannot_reference_identifier_1_declared_after_it_2373","Initializer of parameter '{0}' cannot reference identifier '{1}' declared after it."),Duplicate_string_index_signature:t(2374,e.DiagnosticCategory.Error,"Duplicate_string_index_signature_2374","Duplicate string index signature."),Duplicate_number_index_signature:t(2375,e.DiagnosticCategory.Error,"Duplicate_number_index_signature_2375","Duplicate number index signature."),A_super_call_must_be_the_first_statement_in_the_constructor_when_a_class_contains_initialized_properties_or_has_parameter_properties:t(2376,e.DiagnosticCategory.Error,"A_super_call_must_be_the_first_statement_in_the_constructor_when_a_class_contains_initialized_proper_2376","A 'super' call must be the first statement in the constructor when a class contains initialized properties or has parameter properties."),Constructors_for_derived_classes_must_contain_a_super_call:t(2377,e.DiagnosticCategory.Error,"Constructors_for_derived_classes_must_contain_a_super_call_2377","Constructors for derived classes must contain a 'super' call."),A_get_accessor_must_return_a_value:t(2378,e.DiagnosticCategory.Error,"A_get_accessor_must_return_a_value_2378","A 'get' accessor must return a value."),Getter_and_setter_accessors_do_not_agree_in_visibility:t(2379,e.DiagnosticCategory.Error,"Getter_and_setter_accessors_do_not_agree_in_visibility_2379","Getter and setter accessors do not agree in visibility."),get_and_set_accessor_must_have_the_same_type:t(2380,e.DiagnosticCategory.Error,"get_and_set_accessor_must_have_the_same_type_2380","'get' and 'set' accessor must have the same type."),A_signature_with_an_implementation_cannot_use_a_string_literal_type:t(2381,e.DiagnosticCategory.Error,"A_signature_with_an_implementation_cannot_use_a_string_literal_type_2381","A signature with an implementation cannot use a string literal type."),Specialized_overload_signature_is_not_assignable_to_any_non_specialized_signature:t(2382,e.DiagnosticCategory.Error,"Specialized_overload_signature_is_not_assignable_to_any_non_specialized_signature_2382","Specialized overload signature is not assignable to any non-specialized signature."),Overload_signatures_must_all_be_exported_or_non_exported:t(2383,e.DiagnosticCategory.Error,"Overload_signatures_must_all_be_exported_or_non_exported_2383","Overload signatures must all be exported or non-exported."),Overload_signatures_must_all_be_ambient_or_non_ambient:t(2384,e.DiagnosticCategory.Error,"Overload_signatures_must_all_be_ambient_or_non_ambient_2384","Overload signatures must all be ambient or non-ambient."),Overload_signatures_must_all_be_public_private_or_protected:t(2385,e.DiagnosticCategory.Error,"Overload_signatures_must_all_be_public_private_or_protected_2385","Overload signatures must all be public, private or protected."),Overload_signatures_must_all_be_optional_or_required:t(2386,e.DiagnosticCategory.Error,"Overload_signatures_must_all_be_optional_or_required_2386","Overload signatures must all be optional or required."),Function_overload_must_be_static:t(2387,e.DiagnosticCategory.Error,"Function_overload_must_be_static_2387","Function overload must be static."),Function_overload_must_not_be_static:t(2388,e.DiagnosticCategory.Error,"Function_overload_must_not_be_static_2388","Function overload must not be static."),Function_implementation_name_must_be_0:t(2389,e.DiagnosticCategory.Error,"Function_implementation_name_must_be_0_2389","Function implementation name must be '{0}'."),Constructor_implementation_is_missing:t(2390,e.DiagnosticCategory.Error,"Constructor_implementation_is_missing_2390","Constructor implementation is missing."),Function_implementation_is_missing_or_not_immediately_following_the_declaration:t(2391,e.DiagnosticCategory.Error,"Function_implementation_is_missing_or_not_immediately_following_the_declaration_2391","Function implementation is missing or not immediately following the declaration."),Multiple_constructor_implementations_are_not_allowed:t(2392,e.DiagnosticCategory.Error,"Multiple_constructor_implementations_are_not_allowed_2392","Multiple constructor implementations are not allowed."),Duplicate_function_implementation:t(2393,e.DiagnosticCategory.Error,"Duplicate_function_implementation_2393","Duplicate function implementation."),Overload_signature_is_not_compatible_with_function_implementation:t(2394,e.DiagnosticCategory.Error,"Overload_signature_is_not_compatible_with_function_implementation_2394","Overload signature is not compatible with function implementation."),Individual_declarations_in_merged_declaration_0_must_be_all_exported_or_all_local:t(2395,e.DiagnosticCategory.Error,"Individual_declarations_in_merged_declaration_0_must_be_all_exported_or_all_local_2395","Individual declarations in merged declaration '{0}' must be all exported or all local."),Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters:t(2396,e.DiagnosticCategory.Error,"Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters_2396","Duplicate identifier 'arguments'. Compiler uses 'arguments' to initialize rest parameters."),Declaration_name_conflicts_with_built_in_global_identifier_0:t(2397,e.DiagnosticCategory.Error,"Declaration_name_conflicts_with_built_in_global_identifier_0_2397","Declaration name conflicts with built-in global identifier '{0}'."),Duplicate_identifier_this_Compiler_uses_variable_declaration_this_to_capture_this_reference:t(2399,e.DiagnosticCategory.Error,"Duplicate_identifier_this_Compiler_uses_variable_declaration_this_to_capture_this_reference_2399","Duplicate identifier '_this'. Compiler uses variable declaration '_this' to capture 'this' reference."),Expression_resolves_to_variable_declaration_this_that_compiler_uses_to_capture_this_reference:t(2400,e.DiagnosticCategory.Error,"Expression_resolves_to_variable_declaration_this_that_compiler_uses_to_capture_this_reference_2400","Expression resolves to variable declaration '_this' that compiler uses to capture 'this' reference."),Duplicate_identifier_super_Compiler_uses_super_to_capture_base_class_reference:t(2401,e.DiagnosticCategory.Error,"Duplicate_identifier_super_Compiler_uses_super_to_capture_base_class_reference_2401","Duplicate identifier '_super'. Compiler uses '_super' to capture base class reference."),Expression_resolves_to_super_that_compiler_uses_to_capture_base_class_reference:t(2402,e.DiagnosticCategory.Error,"Expression_resolves_to_super_that_compiler_uses_to_capture_base_class_reference_2402","Expression resolves to '_super' that compiler uses to capture base class reference."),Subsequent_variable_declarations_must_have_the_same_type_Variable_0_must_be_of_type_1_but_here_has_type_2:t(2403,e.DiagnosticCategory.Error,"Subsequent_variable_declarations_must_have_the_same_type_Variable_0_must_be_of_type_1_but_here_has_t_2403","Subsequent variable declarations must have the same type.  Variable '{0}' must be of type '{1}', but here has type '{2}'."),The_left_hand_side_of_a_for_in_statement_cannot_use_a_type_annotation:t(2404,e.DiagnosticCategory.Error,"The_left_hand_side_of_a_for_in_statement_cannot_use_a_type_annotation_2404","The left-hand side of a 'for...in' statement cannot use a type annotation."),The_left_hand_side_of_a_for_in_statement_must_be_of_type_string_or_any:t(2405,e.DiagnosticCategory.Error,"The_left_hand_side_of_a_for_in_statement_must_be_of_type_string_or_any_2405","The left-hand side of a 'for...in' statement must be of type 'string' or 'any'."),The_left_hand_side_of_a_for_in_statement_must_be_a_variable_or_a_property_access:t(2406,e.DiagnosticCategory.Error,"The_left_hand_side_of_a_for_in_statement_must_be_a_variable_or_a_property_access_2406","The left-hand side of a 'for...in' statement must be a variable or a property access."),The_right_hand_side_of_a_for_in_statement_must_be_of_type_any_an_object_type_or_a_type_parameter:t(2407,e.DiagnosticCategory.Error,"The_right_hand_side_of_a_for_in_statement_must_be_of_type_any_an_object_type_or_a_type_parameter_2407","The right-hand side of a 'for...in' statement must be of type 'any', an object type or a type parameter."),Setters_cannot_return_a_value:t(2408,e.DiagnosticCategory.Error,"Setters_cannot_return_a_value_2408","Setters cannot return a value."),Return_type_of_constructor_signature_must_be_assignable_to_the_instance_type_of_the_class:t(2409,e.DiagnosticCategory.Error,"Return_type_of_constructor_signature_must_be_assignable_to_the_instance_type_of_the_class_2409","Return type of constructor signature must be assignable to the instance type of the class."),The_with_statement_is_not_supported_All_symbols_in_a_with_block_will_have_type_any:t(2410,e.DiagnosticCategory.Error,"The_with_statement_is_not_supported_All_symbols_in_a_with_block_will_have_type_any_2410","The 'with' statement is not supported. All symbols in a 'with' block will have type 'any'."),Property_0_of_type_1_is_not_assignable_to_string_index_type_2:t(2411,e.DiagnosticCategory.Error,"Property_0_of_type_1_is_not_assignable_to_string_index_type_2_2411","Property '{0}' of type '{1}' is not assignable to string index type '{2}'."),Property_0_of_type_1_is_not_assignable_to_numeric_index_type_2:t(2412,e.DiagnosticCategory.Error,"Property_0_of_type_1_is_not_assignable_to_numeric_index_type_2_2412","Property '{0}' of type '{1}' is not assignable to numeric index type '{2}'."),Numeric_index_type_0_is_not_assignable_to_string_index_type_1:t(2413,e.DiagnosticCategory.Error,"Numeric_index_type_0_is_not_assignable_to_string_index_type_1_2413","Numeric index type '{0}' is not assignable to string index type '{1}'."),Class_name_cannot_be_0:t(2414,e.DiagnosticCategory.Error,"Class_name_cannot_be_0_2414","Class name cannot be '{0}'."),Class_0_incorrectly_extends_base_class_1:t(2415,e.DiagnosticCategory.Error,"Class_0_incorrectly_extends_base_class_1_2415","Class '{0}' incorrectly extends base class '{1}'."),Class_static_side_0_incorrectly_extends_base_class_static_side_1:t(2417,e.DiagnosticCategory.Error,"Class_static_side_0_incorrectly_extends_base_class_static_side_1_2417","Class static side '{0}' incorrectly extends base class static side '{1}'."),Class_0_incorrectly_implements_interface_1:t(2420,e.DiagnosticCategory.Error,"Class_0_incorrectly_implements_interface_1_2420","Class '{0}' incorrectly implements interface '{1}'."),A_class_may_only_implement_another_class_or_interface:t(2422,e.DiagnosticCategory.Error,"A_class_may_only_implement_another_class_or_interface_2422","A class may only implement another class or interface."),Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_accessor:t(2423,e.DiagnosticCategory.Error,"Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_access_2423","Class '{0}' defines instance member function '{1}', but extended class '{2}' defines it as instance member accessor."),Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_property:t(2424,e.DiagnosticCategory.Error,"Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_proper_2424","Class '{0}' defines instance member function '{1}', but extended class '{2}' defines it as instance member property."),Class_0_defines_instance_member_property_1_but_extended_class_2_defines_it_as_instance_member_function:t(2425,e.DiagnosticCategory.Error,"Class_0_defines_instance_member_property_1_but_extended_class_2_defines_it_as_instance_member_functi_2425","Class '{0}' defines instance member property '{1}', but extended class '{2}' defines it as instance member function."),Class_0_defines_instance_member_accessor_1_but_extended_class_2_defines_it_as_instance_member_function:t(2426,e.DiagnosticCategory.Error,"Class_0_defines_instance_member_accessor_1_but_extended_class_2_defines_it_as_instance_member_functi_2426","Class '{0}' defines instance member accessor '{1}', but extended class '{2}' defines it as instance member function."),Interface_name_cannot_be_0:t(2427,e.DiagnosticCategory.Error,"Interface_name_cannot_be_0_2427","Interface name cannot be '{0}'."),All_declarations_of_0_must_have_identical_type_parameters:t(2428,e.DiagnosticCategory.Error,"All_declarations_of_0_must_have_identical_type_parameters_2428","All declarations of '{0}' must have identical type parameters."),Interface_0_incorrectly_extends_interface_1:t(2430,e.DiagnosticCategory.Error,"Interface_0_incorrectly_extends_interface_1_2430","Interface '{0}' incorrectly extends interface '{1}'."),Enum_name_cannot_be_0:t(2431,e.DiagnosticCategory.Error,"Enum_name_cannot_be_0_2431","Enum name cannot be '{0}'."),In_an_enum_with_multiple_declarations_only_one_declaration_can_omit_an_initializer_for_its_first_enum_element:t(2432,e.DiagnosticCategory.Error,"In_an_enum_with_multiple_declarations_only_one_declaration_can_omit_an_initializer_for_its_first_enu_2432","In an enum with multiple declarations, only one declaration can omit an initializer for its first enum element."),A_namespace_declaration_cannot_be_in_a_different_file_from_a_class_or_function_with_which_it_is_merged:t(2433,e.DiagnosticCategory.Error,"A_namespace_declaration_cannot_be_in_a_different_file_from_a_class_or_function_with_which_it_is_merg_2433","A namespace declaration cannot be in a different file from a class or function with which it is merged."),A_namespace_declaration_cannot_be_located_prior_to_a_class_or_function_with_which_it_is_merged:t(2434,e.DiagnosticCategory.Error,"A_namespace_declaration_cannot_be_located_prior_to_a_class_or_function_with_which_it_is_merged_2434","A namespace declaration cannot be located prior to a class or function with which it is merged."),Ambient_modules_cannot_be_nested_in_other_modules_or_namespaces:t(2435,e.DiagnosticCategory.Error,"Ambient_modules_cannot_be_nested_in_other_modules_or_namespaces_2435","Ambient modules cannot be nested in other modules or namespaces."),Ambient_module_declaration_cannot_specify_relative_module_name:t(2436,e.DiagnosticCategory.Error,"Ambient_module_declaration_cannot_specify_relative_module_name_2436","Ambient module declaration cannot specify relative module name."),Module_0_is_hidden_by_a_local_declaration_with_the_same_name:t(2437,e.DiagnosticCategory.Error,"Module_0_is_hidden_by_a_local_declaration_with_the_same_name_2437","Module '{0}' is hidden by a local declaration with the same name."),Import_name_cannot_be_0:t(2438,e.DiagnosticCategory.Error,"Import_name_cannot_be_0_2438","Import name cannot be '{0}'."),Import_or_export_declaration_in_an_ambient_module_declaration_cannot_reference_module_through_relative_module_name:t(2439,e.DiagnosticCategory.Error,"Import_or_export_declaration_in_an_ambient_module_declaration_cannot_reference_module_through_relati_2439","Import or export declaration in an ambient module declaration cannot reference module through relative module name."),Import_declaration_conflicts_with_local_declaration_of_0:t(2440,e.DiagnosticCategory.Error,"Import_declaration_conflicts_with_local_declaration_of_0_2440","Import declaration conflicts with local declaration of '{0}'."),Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module:t(2441,e.DiagnosticCategory.Error,"Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_2441","Duplicate identifier '{0}'. Compiler reserves name '{1}' in top level scope of a module."),Types_have_separate_declarations_of_a_private_property_0:t(2442,e.DiagnosticCategory.Error,"Types_have_separate_declarations_of_a_private_property_0_2442","Types have separate declarations of a private property '{0}'."),Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2:t(2443,e.DiagnosticCategory.Error,"Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2_2443","Property '{0}' is protected but type '{1}' is not a class derived from '{2}'."),Property_0_is_protected_in_type_1_but_public_in_type_2:t(2444,e.DiagnosticCategory.Error,"Property_0_is_protected_in_type_1_but_public_in_type_2_2444","Property '{0}' is protected in type '{1}' but public in type '{2}'."),Property_0_is_protected_and_only_accessible_within_class_1_and_its_subclasses:t(2445,e.DiagnosticCategory.Error,"Property_0_is_protected_and_only_accessible_within_class_1_and_its_subclasses_2445","Property '{0}' is protected and only accessible within class '{1}' and its subclasses."),Property_0_is_protected_and_only_accessible_through_an_instance_of_class_1:t(2446,e.DiagnosticCategory.Error,"Property_0_is_protected_and_only_accessible_through_an_instance_of_class_1_2446","Property '{0}' is protected and only accessible through an instance of class '{1}'."),The_0_operator_is_not_allowed_for_boolean_types_Consider_using_1_instead:t(2447,e.DiagnosticCategory.Error,"The_0_operator_is_not_allowed_for_boolean_types_Consider_using_1_instead_2447","The '{0}' operator is not allowed for boolean types. Consider using '{1}' instead."),Block_scoped_variable_0_used_before_its_declaration:t(2448,e.DiagnosticCategory.Error,"Block_scoped_variable_0_used_before_its_declaration_2448","Block-scoped variable '{0}' used before its declaration."),Class_0_used_before_its_declaration:t(2449,e.DiagnosticCategory.Error,"Class_0_used_before_its_declaration_2449","Class '{0}' used before its declaration."),Enum_0_used_before_its_declaration:t(2450,e.DiagnosticCategory.Error,"Enum_0_used_before_its_declaration_2450","Enum '{0}' used before its declaration."),Cannot_redeclare_block_scoped_variable_0:t(2451,e.DiagnosticCategory.Error,"Cannot_redeclare_block_scoped_variable_0_2451","Cannot redeclare block-scoped variable '{0}'."),An_enum_member_cannot_have_a_numeric_name:t(2452,e.DiagnosticCategory.Error,"An_enum_member_cannot_have_a_numeric_name_2452","An enum member cannot have a numeric name."),The_type_argument_for_type_parameter_0_cannot_be_inferred_from_the_usage_Consider_specifying_the_type_arguments_explicitly:t(2453,e.DiagnosticCategory.Error,"The_type_argument_for_type_parameter_0_cannot_be_inferred_from_the_usage_Consider_specifying_the_typ_2453","The type argument for type parameter '{0}' cannot be inferred from the usage. Consider specifying the type arguments explicitly."),Variable_0_is_used_before_being_assigned:t(2454,e.DiagnosticCategory.Error,"Variable_0_is_used_before_being_assigned_2454","Variable '{0}' is used before being assigned."),Type_argument_candidate_1_is_not_a_valid_type_argument_because_it_is_not_a_supertype_of_candidate_0:t(2455,e.DiagnosticCategory.Error,"Type_argument_candidate_1_is_not_a_valid_type_argument_because_it_is_not_a_supertype_of_candidate_0_2455","Type argument candidate '{1}' is not a valid type argument because it is not a supertype of candidate '{0}'."),Type_alias_0_circularly_references_itself:t(2456,e.DiagnosticCategory.Error,"Type_alias_0_circularly_references_itself_2456","Type alias '{0}' circularly references itself."),Type_alias_name_cannot_be_0:t(2457,e.DiagnosticCategory.Error,"Type_alias_name_cannot_be_0_2457","Type alias name cannot be '{0}'."),An_AMD_module_cannot_have_multiple_name_assignments:t(2458,e.DiagnosticCategory.Error,"An_AMD_module_cannot_have_multiple_name_assignments_2458","An AMD module cannot have multiple name assignments."),Type_0_has_no_property_1_and_no_string_index_signature:t(2459,e.DiagnosticCategory.Error,"Type_0_has_no_property_1_and_no_string_index_signature_2459","Type '{0}' has no property '{1}' and no string index signature."),Type_0_has_no_property_1:t(2460,e.DiagnosticCategory.Error,"Type_0_has_no_property_1_2460","Type '{0}' has no property '{1}'."),Type_0_is_not_an_array_type:t(2461,e.DiagnosticCategory.Error,"Type_0_is_not_an_array_type_2461","Type '{0}' is not an array type."),A_rest_element_must_be_last_in_a_destructuring_pattern:t(2462,e.DiagnosticCategory.Error,"A_rest_element_must_be_last_in_a_destructuring_pattern_2462","A rest element must be last in a destructuring pattern."),A_binding_pattern_parameter_cannot_be_optional_in_an_implementation_signature:t(2463,e.DiagnosticCategory.Error,"A_binding_pattern_parameter_cannot_be_optional_in_an_implementation_signature_2463","A binding pattern parameter cannot be optional in an implementation signature."),A_computed_property_name_must_be_of_type_string_number_symbol_or_any:t(2464,e.DiagnosticCategory.Error,"A_computed_property_name_must_be_of_type_string_number_symbol_or_any_2464","A computed property name must be of type 'string', 'number', 'symbol', or 'any'."),this_cannot_be_referenced_in_a_computed_property_name:t(2465,e.DiagnosticCategory.Error,"this_cannot_be_referenced_in_a_computed_property_name_2465","'this' cannot be referenced in a computed property name."),super_cannot_be_referenced_in_a_computed_property_name:t(2466,e.DiagnosticCategory.Error,"super_cannot_be_referenced_in_a_computed_property_name_2466","'super' cannot be referenced in a computed property name."),A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type:t(2467,e.DiagnosticCategory.Error,"A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type_2467","A computed property name cannot reference a type parameter from its containing type."),Cannot_find_global_value_0:t(2468,e.DiagnosticCategory.Error,"Cannot_find_global_value_0_2468","Cannot find global value '{0}'."),The_0_operator_cannot_be_applied_to_type_symbol:t(2469,e.DiagnosticCategory.Error,"The_0_operator_cannot_be_applied_to_type_symbol_2469","The '{0}' operator cannot be applied to type 'symbol'."),Symbol_reference_does_not_refer_to_the_global_Symbol_constructor_object:t(2470,e.DiagnosticCategory.Error,"Symbol_reference_does_not_refer_to_the_global_Symbol_constructor_object_2470","'Symbol' reference does not refer to the global Symbol constructor object."),A_computed_property_name_of_the_form_0_must_be_of_type_symbol:t(2471,e.DiagnosticCategory.Error,"A_computed_property_name_of_the_form_0_must_be_of_type_symbol_2471","A computed property name of the form '{0}' must be of type 'symbol'."),Spread_operator_in_new_expressions_is_only_available_when_targeting_ECMAScript_5_and_higher:t(2472,e.DiagnosticCategory.Error,"Spread_operator_in_new_expressions_is_only_available_when_targeting_ECMAScript_5_and_higher_2472","Spread operator in 'new' expressions is only available when targeting ECMAScript 5 and higher."),Enum_declarations_must_all_be_const_or_non_const:t(2473,e.DiagnosticCategory.Error,"Enum_declarations_must_all_be_const_or_non_const_2473","Enum declarations must all be const or non-const."),In_const_enum_declarations_member_initializer_must_be_constant_expression:t(2474,e.DiagnosticCategory.Error,"In_const_enum_declarations_member_initializer_must_be_constant_expression_2474","In 'const' enum declarations member initializer must be constant expression."),const_enums_can_only_be_used_in_property_or_index_access_expressions_or_the_right_hand_side_of_an_import_declaration_or_export_assignment:t(2475,e.DiagnosticCategory.Error,"const_enums_can_only_be_used_in_property_or_index_access_expressions_or_the_right_hand_side_of_an_im_2475","'const' enums can only be used in property or index access expressions or the right hand side of an import declaration or export assignment."),A_const_enum_member_can_only_be_accessed_using_a_string_literal:t(2476,e.DiagnosticCategory.Error,"A_const_enum_member_can_only_be_accessed_using_a_string_literal_2476","A const enum member can only be accessed using a string literal."),const_enum_member_initializer_was_evaluated_to_a_non_finite_value:t(2477,e.DiagnosticCategory.Error,"const_enum_member_initializer_was_evaluated_to_a_non_finite_value_2477","'const' enum member initializer was evaluated to a non-finite value."),const_enum_member_initializer_was_evaluated_to_disallowed_value_NaN:t(2478,e.DiagnosticCategory.Error,"const_enum_member_initializer_was_evaluated_to_disallowed_value_NaN_2478","'const' enum member initializer was evaluated to disallowed value 'NaN'."),Property_0_does_not_exist_on_const_enum_1:t(2479,e.DiagnosticCategory.Error,"Property_0_does_not_exist_on_const_enum_1_2479","Property '{0}' does not exist on 'const' enum '{1}'."),let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations:t(2480,e.DiagnosticCategory.Error,"let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations_2480","'let' is not allowed to be used as a name in 'let' or 'const' declarations."),Cannot_initialize_outer_scoped_variable_0_in_the_same_scope_as_block_scoped_declaration_1:t(2481,e.DiagnosticCategory.Error,"Cannot_initialize_outer_scoped_variable_0_in_the_same_scope_as_block_scoped_declaration_1_2481","Cannot initialize outer scoped variable '{0}' in the same scope as block scoped declaration '{1}'."),The_left_hand_side_of_a_for_of_statement_cannot_use_a_type_annotation:t(2483,e.DiagnosticCategory.Error,"The_left_hand_side_of_a_for_of_statement_cannot_use_a_type_annotation_2483","The left-hand side of a 'for...of' statement cannot use a type annotation."),Export_declaration_conflicts_with_exported_declaration_of_0:t(2484,e.DiagnosticCategory.Error,"Export_declaration_conflicts_with_exported_declaration_of_0_2484","Export declaration conflicts with exported declaration of '{0}'."),The_left_hand_side_of_a_for_of_statement_must_be_a_variable_or_a_property_access:t(2487,e.DiagnosticCategory.Error,"The_left_hand_side_of_a_for_of_statement_must_be_a_variable_or_a_property_access_2487","The left-hand side of a 'for...of' statement must be a variable or a property access."),Type_must_have_a_Symbol_iterator_method_that_returns_an_iterator:t(2488,e.DiagnosticCategory.Error,"Type_must_have_a_Symbol_iterator_method_that_returns_an_iterator_2488","Type must have a '[Symbol.iterator]()' method that returns an iterator."),An_iterator_must_have_a_next_method:t(2489,e.DiagnosticCategory.Error,"An_iterator_must_have_a_next_method_2489","An iterator must have a 'next()' method."),The_type_returned_by_the_next_method_of_an_iterator_must_have_a_value_property:t(2490,e.DiagnosticCategory.Error,"The_type_returned_by_the_next_method_of_an_iterator_must_have_a_value_property_2490","The type returned by the 'next()' method of an iterator must have a 'value' property."),The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern:t(2491,e.DiagnosticCategory.Error,"The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern_2491","The left-hand side of a 'for...in' statement cannot be a destructuring pattern."),Cannot_redeclare_identifier_0_in_catch_clause:t(2492,e.DiagnosticCategory.Error,"Cannot_redeclare_identifier_0_in_catch_clause_2492","Cannot redeclare identifier '{0}' in catch clause."),Tuple_type_0_with_length_1_cannot_be_assigned_to_tuple_with_length_2:t(2493,e.DiagnosticCategory.Error,"Tuple_type_0_with_length_1_cannot_be_assigned_to_tuple_with_length_2_2493","Tuple type '{0}' with length '{1}' cannot be assigned to tuple with length '{2}'."),Using_a_string_in_a_for_of_statement_is_only_supported_in_ECMAScript_5_and_higher:t(2494,e.DiagnosticCategory.Error,"Using_a_string_in_a_for_of_statement_is_only_supported_in_ECMAScript_5_and_higher_2494","Using a string in a 'for...of' statement is only supported in ECMAScript 5 and higher."),Type_0_is_not_an_array_type_or_a_string_type:t(2495,e.DiagnosticCategory.Error,"Type_0_is_not_an_array_type_or_a_string_type_2495","Type '{0}' is not an array type or a string type."),The_arguments_object_cannot_be_referenced_in_an_arrow_function_in_ES3_and_ES5_Consider_using_a_standard_function_expression:t(2496,e.DiagnosticCategory.Error,"The_arguments_object_cannot_be_referenced_in_an_arrow_function_in_ES3_and_ES5_Consider_using_a_stand_2496","The 'arguments' object cannot be referenced in an arrow function in ES3 and ES5. Consider using a standard function expression."),Module_0_resolves_to_a_non_module_entity_and_cannot_be_imported_using_this_construct:t(2497,e.DiagnosticCategory.Error,"Module_0_resolves_to_a_non_module_entity_and_cannot_be_imported_using_this_construct_2497","Module '{0}' resolves to a non-module entity and cannot be imported using this construct."),Module_0_uses_export_and_cannot_be_used_with_export_Asterisk:t(2498,e.DiagnosticCategory.Error,"Module_0_uses_export_and_cannot_be_used_with_export_Asterisk_2498","Module '{0}' uses 'export =' and cannot be used with 'export *'."),An_interface_can_only_extend_an_identifier_Slashqualified_name_with_optional_type_arguments:t(2499,e.DiagnosticCategory.Error,"An_interface_can_only_extend_an_identifier_Slashqualified_name_with_optional_type_arguments_2499","An interface can only extend an identifier/qualified-name with optional type arguments."),A_class_can_only_implement_an_identifier_Slashqualified_name_with_optional_type_arguments:t(2500,e.DiagnosticCategory.Error,"A_class_can_only_implement_an_identifier_Slashqualified_name_with_optional_type_arguments_2500","A class can only implement an identifier/qualified-name with optional type arguments."),A_rest_element_cannot_contain_a_binding_pattern:t(2501,e.DiagnosticCategory.Error,"A_rest_element_cannot_contain_a_binding_pattern_2501","A rest element cannot contain a binding pattern."),_0_is_referenced_directly_or_indirectly_in_its_own_type_annotation:t(2502,e.DiagnosticCategory.Error,"_0_is_referenced_directly_or_indirectly_in_its_own_type_annotation_2502","'{0}' is referenced directly or indirectly in its own type annotation."),Cannot_find_namespace_0:t(2503,e.DiagnosticCategory.Error,"Cannot_find_namespace_0_2503","Cannot find namespace '{0}'."),Type_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator:t(2504,e.DiagnosticCategory.Error,"Type_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator_2504","Type must have a '[Symbol.asyncIterator]()' method that returns an async iterator."),A_generator_cannot_have_a_void_type_annotation:t(2505,e.DiagnosticCategory.Error,"A_generator_cannot_have_a_void_type_annotation_2505","A generator cannot have a 'void' type annotation."),_0_is_referenced_directly_or_indirectly_in_its_own_base_expression:t(2506,e.DiagnosticCategory.Error,"_0_is_referenced_directly_or_indirectly_in_its_own_base_expression_2506","'{0}' is referenced directly or indirectly in its own base expression."),Type_0_is_not_a_constructor_function_type:t(2507,e.DiagnosticCategory.Error,"Type_0_is_not_a_constructor_function_type_2507","Type '{0}' is not a constructor function type."),No_base_constructor_has_the_specified_number_of_type_arguments:t(2508,e.DiagnosticCategory.Error,"No_base_constructor_has_the_specified_number_of_type_arguments_2508","No base constructor has the specified number of type arguments."),Base_constructor_return_type_0_is_not_a_class_or_interface_type:t(2509,e.DiagnosticCategory.Error,"Base_constructor_return_type_0_is_not_a_class_or_interface_type_2509","Base constructor return type '{0}' is not a class or interface type."),Base_constructors_must_all_have_the_same_return_type:t(2510,e.DiagnosticCategory.Error,"Base_constructors_must_all_have_the_same_return_type_2510","Base constructors must all have the same return type."),Cannot_create_an_instance_of_the_abstract_class_0:t(2511,e.DiagnosticCategory.Error,"Cannot_create_an_instance_of_the_abstract_class_0_2511","Cannot create an instance of the abstract class '{0}'."),Overload_signatures_must_all_be_abstract_or_non_abstract:t(2512,e.DiagnosticCategory.Error,"Overload_signatures_must_all_be_abstract_or_non_abstract_2512","Overload signatures must all be abstract or non-abstract."),Abstract_method_0_in_class_1_cannot_be_accessed_via_super_expression:t(2513,e.DiagnosticCategory.Error,"Abstract_method_0_in_class_1_cannot_be_accessed_via_super_expression_2513","Abstract method '{0}' in class '{1}' cannot be accessed via super expression."),Classes_containing_abstract_methods_must_be_marked_abstract:t(2514,e.DiagnosticCategory.Error,"Classes_containing_abstract_methods_must_be_marked_abstract_2514","Classes containing abstract methods must be marked abstract."),Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2:t(2515,e.DiagnosticCategory.Error,"Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2_2515","Non-abstract class '{0}' does not implement inherited abstract member '{1}' from class '{2}'."),All_declarations_of_an_abstract_method_must_be_consecutive:t(2516,e.DiagnosticCategory.Error,"All_declarations_of_an_abstract_method_must_be_consecutive_2516","All declarations of an abstract method must be consecutive."),Cannot_assign_an_abstract_constructor_type_to_a_non_abstract_constructor_type:t(2517,e.DiagnosticCategory.Error,"Cannot_assign_an_abstract_constructor_type_to_a_non_abstract_constructor_type_2517","Cannot assign an abstract constructor type to a non-abstract constructor type."),A_this_based_type_guard_is_not_compatible_with_a_parameter_based_type_guard:t(2518,e.DiagnosticCategory.Error,"A_this_based_type_guard_is_not_compatible_with_a_parameter_based_type_guard_2518","A 'this'-based type guard is not compatible with a parameter-based type guard."),An_async_iterator_must_have_a_next_method:t(2519,e.DiagnosticCategory.Error,"An_async_iterator_must_have_a_next_method_2519","An async iterator must have a 'next()' method."),Duplicate_identifier_0_Compiler_uses_declaration_1_to_support_async_functions:t(2520,e.DiagnosticCategory.Error,"Duplicate_identifier_0_Compiler_uses_declaration_1_to_support_async_functions_2520","Duplicate identifier '{0}'. Compiler uses declaration '{1}' to support async functions."),Expression_resolves_to_variable_declaration_0_that_compiler_uses_to_support_async_functions:t(2521,e.DiagnosticCategory.Error,"Expression_resolves_to_variable_declaration_0_that_compiler_uses_to_support_async_functions_2521","Expression resolves to variable declaration '{0}' that compiler uses to support async functions."),The_arguments_object_cannot_be_referenced_in_an_async_function_or_method_in_ES3_and_ES5_Consider_using_a_standard_function_or_method:t(2522,e.DiagnosticCategory.Error,"The_arguments_object_cannot_be_referenced_in_an_async_function_or_method_in_ES3_and_ES5_Consider_usi_2522","The 'arguments' object cannot be referenced in an async function or method in ES3 and ES5. Consider using a standard function or method."),yield_expressions_cannot_be_used_in_a_parameter_initializer:t(2523,e.DiagnosticCategory.Error,"yield_expressions_cannot_be_used_in_a_parameter_initializer_2523","'yield' expressions cannot be used in a parameter initializer."),await_expressions_cannot_be_used_in_a_parameter_initializer:t(2524,e.DiagnosticCategory.Error,"await_expressions_cannot_be_used_in_a_parameter_initializer_2524","'await' expressions cannot be used in a parameter initializer."),Initializer_provides_no_value_for_this_binding_element_and_the_binding_element_has_no_default_value:t(2525,e.DiagnosticCategory.Error,"Initializer_provides_no_value_for_this_binding_element_and_the_binding_element_has_no_default_value_2525","Initializer provides no value for this binding element and the binding element has no default value."),A_this_type_is_available_only_in_a_non_static_member_of_a_class_or_interface:t(2526,e.DiagnosticCategory.Error,"A_this_type_is_available_only_in_a_non_static_member_of_a_class_or_interface_2526","A 'this' type is available only in a non-static member of a class or interface."),The_inferred_type_of_0_references_an_inaccessible_this_type_A_type_annotation_is_necessary:t(2527,e.DiagnosticCategory.Error,"The_inferred_type_of_0_references_an_inaccessible_this_type_A_type_annotation_is_necessary_2527","The inferred type of '{0}' references an inaccessible 'this' type. A type annotation is necessary."),A_module_cannot_have_multiple_default_exports:t(2528,e.DiagnosticCategory.Error,"A_module_cannot_have_multiple_default_exports_2528","A module cannot have multiple default exports."),Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_containing_async_functions:t(2529,e.DiagnosticCategory.Error,"Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_containing_async_func_2529","Duplicate identifier '{0}'. Compiler reserves name '{1}' in top level scope of a module containing async functions."),Property_0_is_incompatible_with_index_signature:t(2530,e.DiagnosticCategory.Error,"Property_0_is_incompatible_with_index_signature_2530","Property '{0}' is incompatible with index signature."),Object_is_possibly_null:t(2531,e.DiagnosticCategory.Error,"Object_is_possibly_null_2531","Object is possibly 'null'."),Object_is_possibly_undefined:t(2532,e.DiagnosticCategory.Error,"Object_is_possibly_undefined_2532","Object is possibly 'undefined'."),Object_is_possibly_null_or_undefined:t(2533,e.DiagnosticCategory.Error,"Object_is_possibly_null_or_undefined_2533","Object is possibly 'null' or 'undefined'."),A_function_returning_never_cannot_have_a_reachable_end_point:t(2534,e.DiagnosticCategory.Error,"A_function_returning_never_cannot_have_a_reachable_end_point_2534","A function returning 'never' cannot have a reachable end point."),Enum_type_0_has_members_with_initializers_that_are_not_literals:t(2535,e.DiagnosticCategory.Error,"Enum_type_0_has_members_with_initializers_that_are_not_literals_2535","Enum type '{0}' has members with initializers that are not literals."),Type_0_cannot_be_used_to_index_type_1:t(2536,e.DiagnosticCategory.Error,"Type_0_cannot_be_used_to_index_type_1_2536","Type '{0}' cannot be used to index type '{1}'."),Type_0_has_no_matching_index_signature_for_type_1:t(2537,e.DiagnosticCategory.Error,"Type_0_has_no_matching_index_signature_for_type_1_2537","Type '{0}' has no matching index signature for type '{1}'."),Type_0_cannot_be_used_as_an_index_type:t(2538,e.DiagnosticCategory.Error,"Type_0_cannot_be_used_as_an_index_type_2538","Type '{0}' cannot be used as an index type."),Cannot_assign_to_0_because_it_is_not_a_variable:t(2539,e.DiagnosticCategory.Error,"Cannot_assign_to_0_because_it_is_not_a_variable_2539","Cannot assign to '{0}' because it is not a variable."),Cannot_assign_to_0_because_it_is_a_constant_or_a_read_only_property:t(2540,e.DiagnosticCategory.Error,"Cannot_assign_to_0_because_it_is_a_constant_or_a_read_only_property_2540","Cannot assign to '{0}' because it is a constant or a read-only property."),The_target_of_an_assignment_must_be_a_variable_or_a_property_access:t(2541,e.DiagnosticCategory.Error,"The_target_of_an_assignment_must_be_a_variable_or_a_property_access_2541","The target of an assignment must be a variable or a property access."),Index_signature_in_type_0_only_permits_reading:t(2542,e.DiagnosticCategory.Error,"Index_signature_in_type_0_only_permits_reading_2542","Index signature in type '{0}' only permits reading."),Duplicate_identifier_newTarget_Compiler_uses_variable_declaration_newTarget_to_capture_new_target_meta_property_reference:t(2543,e.DiagnosticCategory.Error,"Duplicate_identifier_newTarget_Compiler_uses_variable_declaration_newTarget_to_capture_new_target_me_2543","Duplicate identifier '_newTarget'. Compiler uses variable declaration '_newTarget' to capture 'new.target' meta-property reference."),Expression_resolves_to_variable_declaration_newTarget_that_compiler_uses_to_capture_new_target_meta_property_reference:t(2544,e.DiagnosticCategory.Error,"Expression_resolves_to_variable_declaration_newTarget_that_compiler_uses_to_capture_new_target_meta__2544","Expression resolves to variable declaration '_newTarget' that compiler uses to capture 'new.target' meta-property reference."),A_mixin_class_must_have_a_constructor_with_a_single_rest_parameter_of_type_any:t(2545,e.DiagnosticCategory.Error,"A_mixin_class_must_have_a_constructor_with_a_single_rest_parameter_of_type_any_2545","A mixin class must have a constructor with a single rest parameter of type 'any[]'."),Property_0_has_conflicting_declarations_and_is_inaccessible_in_type_1:t(2546,e.DiagnosticCategory.Error,"Property_0_has_conflicting_declarations_and_is_inaccessible_in_type_1_2546","Property '{0}' has conflicting declarations and is inaccessible in type '{1}'."),The_type_returned_by_the_next_method_of_an_async_iterator_must_be_a_promise_for_a_type_with_a_value_property:t(2547,e.DiagnosticCategory.Error,"The_type_returned_by_the_next_method_of_an_async_iterator_must_be_a_promise_for_a_type_with_a_value__2547","The type returned by the 'next()' method of an async iterator must be a promise for a type with a 'value' property."),Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator:t(2548,e.DiagnosticCategory.Error,"Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator_2548","Type '{0}' is not an array type or does not have a '[Symbol.iterator]()' method that returns an iterator."),Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator:t(2549,e.DiagnosticCategory.Error,"Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns__2549","Type '{0}' is not an array type or a string type or does not have a '[Symbol.iterator]()' method that returns an iterator."),Generic_type_instantiation_is_excessively_deep_and_possibly_infinite:t(2550,e.DiagnosticCategory.Error,"Generic_type_instantiation_is_excessively_deep_and_possibly_infinite_2550","Generic type instantiation is excessively deep and possibly infinite."),Property_0_does_not_exist_on_type_1_Did_you_mean_2:t(2551,e.DiagnosticCategory.Error,"Property_0_does_not_exist_on_type_1_Did_you_mean_2_2551","Property '{0}' does not exist on type '{1}'. Did you mean '{2}'?"),Cannot_find_name_0_Did_you_mean_1:t(2552,e.DiagnosticCategory.Error,"Cannot_find_name_0_Did_you_mean_1_2552","Cannot find name '{0}'. Did you mean '{1}'?"),Computed_values_are_not_permitted_in_an_enum_with_string_valued_members:t(2553,e.DiagnosticCategory.Error,"Computed_values_are_not_permitted_in_an_enum_with_string_valued_members_2553","Computed values are not permitted in an enum with string valued members."),Expected_0_arguments_but_got_1:t(2554,e.DiagnosticCategory.Error,"Expected_0_arguments_but_got_1_2554","Expected {0} arguments, but got {1}."),Expected_at_least_0_arguments_but_got_1:t(2555,e.DiagnosticCategory.Error,"Expected_at_least_0_arguments_but_got_1_2555","Expected at least {0} arguments, but got {1}."),Expected_0_arguments_but_got_a_minimum_of_1:t(2556,e.DiagnosticCategory.Error,"Expected_0_arguments_but_got_a_minimum_of_1_2556","Expected {0} arguments, but got a minimum of {1}."),Expected_at_least_0_arguments_but_got_a_minimum_of_1:t(2557,e.DiagnosticCategory.Error,"Expected_at_least_0_arguments_but_got_a_minimum_of_1_2557","Expected at least {0} arguments, but got a minimum of {1}."),Expected_0_type_arguments_but_got_1:t(2558,e.DiagnosticCategory.Error,"Expected_0_type_arguments_but_got_1_2558","Expected {0} type arguments, but got {1}."),Type_0_has_no_properties_in_common_with_type_1:t(2559,e.DiagnosticCategory.Error,"Type_0_has_no_properties_in_common_with_type_1_2559","Type '{0}' has no properties in common with type '{1}'."),Value_of_type_0_has_no_properties_in_common_with_type_1_Did_you_mean_to_call_it:t(2560,e.DiagnosticCategory.Error,"Value_of_type_0_has_no_properties_in_common_with_type_1_Did_you_mean_to_call_it_2560","Value of type '{0}' has no properties in common with type '{1}'. Did you mean to call it?"),Object_literal_may_only_specify_known_properties_but_0_does_not_exist_in_type_1_Did_you_mean_to_write_2:t(2561,e.DiagnosticCategory.Error,"Object_literal_may_only_specify_known_properties_but_0_does_not_exist_in_type_1_Did_you_mean_to_writ_2561","Object literal may only specify known properties, but '{0}' does not exist in type '{1}'. Did you mean to write '{2}'?"),Base_class_expressions_cannot_reference_class_type_parameters:t(2562,e.DiagnosticCategory.Error,"Base_class_expressions_cannot_reference_class_type_parameters_2562","Base class expressions cannot reference class type parameters."),The_containing_function_or_module_body_is_too_large_for_control_flow_analysis:t(2563,e.DiagnosticCategory.Error,"The_containing_function_or_module_body_is_too_large_for_control_flow_analysis_2563","The containing function or module body is too large for control flow analysis."),JSX_element_attributes_type_0_may_not_be_a_union_type:t(2600,e.DiagnosticCategory.Error,"JSX_element_attributes_type_0_may_not_be_a_union_type_2600","JSX element attributes type '{0}' may not be a union type."),The_return_type_of_a_JSX_element_constructor_must_return_an_object_type:t(2601,e.DiagnosticCategory.Error,"The_return_type_of_a_JSX_element_constructor_must_return_an_object_type_2601","The return type of a JSX element constructor must return an object type."),JSX_element_implicitly_has_type_any_because_the_global_type_JSX_Element_does_not_exist:t(2602,e.DiagnosticCategory.Error,"JSX_element_implicitly_has_type_any_because_the_global_type_JSX_Element_does_not_exist_2602","JSX element implicitly has type 'any' because the global type 'JSX.Element' does not exist."),Property_0_in_type_1_is_not_assignable_to_type_2:t(2603,e.DiagnosticCategory.Error,"Property_0_in_type_1_is_not_assignable_to_type_2_2603","Property '{0}' in type '{1}' is not assignable to type '{2}'."),JSX_element_type_0_does_not_have_any_construct_or_call_signatures:t(2604,e.DiagnosticCategory.Error,"JSX_element_type_0_does_not_have_any_construct_or_call_signatures_2604","JSX element type '{0}' does not have any construct or call signatures."),JSX_element_type_0_is_not_a_constructor_function_for_JSX_elements:t(2605,e.DiagnosticCategory.Error,"JSX_element_type_0_is_not_a_constructor_function_for_JSX_elements_2605","JSX element type '{0}' is not a constructor function for JSX elements."),Property_0_of_JSX_spread_attribute_is_not_assignable_to_target_property:t(2606,e.DiagnosticCategory.Error,"Property_0_of_JSX_spread_attribute_is_not_assignable_to_target_property_2606","Property '{0}' of JSX spread attribute is not assignable to target property."),JSX_element_class_does_not_support_attributes_because_it_does_not_have_a_0_property:t(2607,e.DiagnosticCategory.Error,"JSX_element_class_does_not_support_attributes_because_it_does_not_have_a_0_property_2607","JSX element class does not support attributes because it does not have a '{0}' property."),The_global_type_JSX_0_may_not_have_more_than_one_property:t(2608,e.DiagnosticCategory.Error,"The_global_type_JSX_0_may_not_have_more_than_one_property_2608","The global type 'JSX.{0}' may not have more than one property."),JSX_spread_child_must_be_an_array_type:t(2609,e.DiagnosticCategory.Error,"JSX_spread_child_must_be_an_array_type_2609","JSX spread child must be an array type."),Cannot_augment_module_0_with_value_exports_because_it_resolves_to_a_non_module_entity:t(2649,e.DiagnosticCategory.Error,"Cannot_augment_module_0_with_value_exports_because_it_resolves_to_a_non_module_entity_2649","Cannot augment module '{0}' with value exports because it resolves to a non-module entity."),A_member_initializer_in_a_enum_declaration_cannot_reference_members_declared_after_it_including_members_defined_in_other_enums:t(2651,e.DiagnosticCategory.Error,"A_member_initializer_in_a_enum_declaration_cannot_reference_members_declared_after_it_including_memb_2651","A member initializer in a enum declaration cannot reference members declared after it, including members defined in other enums."),Merged_declaration_0_cannot_include_a_default_export_declaration_Consider_adding_a_separate_export_default_0_declaration_instead:t(2652,e.DiagnosticCategory.Error,"Merged_declaration_0_cannot_include_a_default_export_declaration_Consider_adding_a_separate_export_d_2652","Merged declaration '{0}' cannot include a default export declaration. Consider adding a separate 'export default {0}' declaration instead."),Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1:t(2653,e.DiagnosticCategory.Error,"Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1_2653","Non-abstract class expression does not implement inherited abstract member '{0}' from class '{1}'."),Exported_external_package_typings_file_cannot_contain_tripleslash_references_Please_contact_the_package_author_to_update_the_package_definition:t(2654,e.DiagnosticCategory.Error,"Exported_external_package_typings_file_cannot_contain_tripleslash_references_Please_contact_the_pack_2654","Exported external package typings file cannot contain tripleslash references. Please contact the package author to update the package definition."),Exported_external_package_typings_file_0_is_not_a_module_Please_contact_the_package_author_to_update_the_package_definition:t(2656,e.DiagnosticCategory.Error,"Exported_external_package_typings_file_0_is_not_a_module_Please_contact_the_package_author_to_update_2656","Exported external package typings file '{0}' is not a module. Please contact the package author to update the package definition."),JSX_expressions_must_have_one_parent_element:t(2657,e.DiagnosticCategory.Error,"JSX_expressions_must_have_one_parent_element_2657","JSX expressions must have one parent element."),Type_0_provides_no_match_for_the_signature_1:t(2658,e.DiagnosticCategory.Error,"Type_0_provides_no_match_for_the_signature_1_2658","Type '{0}' provides no match for the signature '{1}'."),super_is_only_allowed_in_members_of_object_literal_expressions_when_option_target_is_ES2015_or_higher:t(2659,e.DiagnosticCategory.Error,"super_is_only_allowed_in_members_of_object_literal_expressions_when_option_target_is_ES2015_or_highe_2659","'super' is only allowed in members of object literal expressions when option 'target' is 'ES2015' or higher."),super_can_only_be_referenced_in_members_of_derived_classes_or_object_literal_expressions:t(2660,e.DiagnosticCategory.Error,"super_can_only_be_referenced_in_members_of_derived_classes_or_object_literal_expressions_2660","'super' can only be referenced in members of derived classes or object literal expressions."),Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module:t(2661,e.DiagnosticCategory.Error,"Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module_2661","Cannot export '{0}'. Only local declarations can be exported from a module."),Cannot_find_name_0_Did_you_mean_the_static_member_1_0:t(2662,e.DiagnosticCategory.Error,"Cannot_find_name_0_Did_you_mean_the_static_member_1_0_2662","Cannot find name '{0}'. Did you mean the static member '{1}.{0}'?"),Cannot_find_name_0_Did_you_mean_the_instance_member_this_0:t(2663,e.DiagnosticCategory.Error,"Cannot_find_name_0_Did_you_mean_the_instance_member_this_0_2663","Cannot find name '{0}'. Did you mean the instance member 'this.{0}'?"),Invalid_module_name_in_augmentation_module_0_cannot_be_found:t(2664,e.DiagnosticCategory.Error,"Invalid_module_name_in_augmentation_module_0_cannot_be_found_2664","Invalid module name in augmentation, module '{0}' cannot be found."),Invalid_module_name_in_augmentation_Module_0_resolves_to_an_untyped_module_at_1_which_cannot_be_augmented:t(2665,e.DiagnosticCategory.Error,"Invalid_module_name_in_augmentation_Module_0_resolves_to_an_untyped_module_at_1_which_cannot_be_augm_2665","Invalid module name in augmentation. Module '{0}' resolves to an untyped module at '{1}', which cannot be augmented."),Exports_and_export_assignments_are_not_permitted_in_module_augmentations:t(2666,e.DiagnosticCategory.Error,"Exports_and_export_assignments_are_not_permitted_in_module_augmentations_2666","Exports and export assignments are not permitted in module augmentations."),Imports_are_not_permitted_in_module_augmentations_Consider_moving_them_to_the_enclosing_external_module:t(2667,e.DiagnosticCategory.Error,"Imports_are_not_permitted_in_module_augmentations_Consider_moving_them_to_the_enclosing_external_mod_2667","Imports are not permitted in module augmentations. Consider moving them to the enclosing external module."),export_modifier_cannot_be_applied_to_ambient_modules_and_module_augmentations_since_they_are_always_visible:t(2668,e.DiagnosticCategory.Error,"export_modifier_cannot_be_applied_to_ambient_modules_and_module_augmentations_since_they_are_always__2668","'export' modifier cannot be applied to ambient modules and module augmentations since they are always visible."),Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_declarations:t(2669,e.DiagnosticCategory.Error,"Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_2669","Augmentations for the global scope can only be directly nested in external modules or ambient module declarations."),Augmentations_for_the_global_scope_should_have_declare_modifier_unless_they_appear_in_already_ambient_context:t(2670,e.DiagnosticCategory.Error,"Augmentations_for_the_global_scope_should_have_declare_modifier_unless_they_appear_in_already_ambien_2670","Augmentations for the global scope should have 'declare' modifier unless they appear in already ambient context."),Cannot_augment_module_0_because_it_resolves_to_a_non_module_entity:t(2671,e.DiagnosticCategory.Error,"Cannot_augment_module_0_because_it_resolves_to_a_non_module_entity_2671","Cannot augment module '{0}' because it resolves to a non-module entity."),Cannot_assign_a_0_constructor_type_to_a_1_constructor_type:t(2672,e.DiagnosticCategory.Error,"Cannot_assign_a_0_constructor_type_to_a_1_constructor_type_2672","Cannot assign a '{0}' constructor type to a '{1}' constructor type."),Constructor_of_class_0_is_private_and_only_accessible_within_the_class_declaration:t(2673,e.DiagnosticCategory.Error,"Constructor_of_class_0_is_private_and_only_accessible_within_the_class_declaration_2673","Constructor of class '{0}' is private and only accessible within the class declaration."),Constructor_of_class_0_is_protected_and_only_accessible_within_the_class_declaration:t(2674,e.DiagnosticCategory.Error,"Constructor_of_class_0_is_protected_and_only_accessible_within_the_class_declaration_2674","Constructor of class '{0}' is protected and only accessible within the class declaration."),Cannot_extend_a_class_0_Class_constructor_is_marked_as_private:t(2675,e.DiagnosticCategory.Error,"Cannot_extend_a_class_0_Class_constructor_is_marked_as_private_2675","Cannot extend a class '{0}'. Class constructor is marked as private."),Accessors_must_both_be_abstract_or_non_abstract:t(2676,e.DiagnosticCategory.Error,"Accessors_must_both_be_abstract_or_non_abstract_2676","Accessors must both be abstract or non-abstract."),A_type_predicate_s_type_must_be_assignable_to_its_parameter_s_type:t(2677,e.DiagnosticCategory.Error,"A_type_predicate_s_type_must_be_assignable_to_its_parameter_s_type_2677","A type predicate's type must be assignable to its parameter's type."),Type_0_is_not_comparable_to_type_1:t(2678,e.DiagnosticCategory.Error,"Type_0_is_not_comparable_to_type_1_2678","Type '{0}' is not comparable to type '{1}'."),A_function_that_is_called_with_the_new_keyword_cannot_have_a_this_type_that_is_void:t(2679,e.DiagnosticCategory.Error,"A_function_that_is_called_with_the_new_keyword_cannot_have_a_this_type_that_is_void_2679","A function that is called with the 'new' keyword cannot have a 'this' type that is 'void'."),A_0_parameter_must_be_the_first_parameter:t(2680,e.DiagnosticCategory.Error,"A_0_parameter_must_be_the_first_parameter_2680","A '{0}' parameter must be the first parameter."),A_constructor_cannot_have_a_this_parameter:t(2681,e.DiagnosticCategory.Error,"A_constructor_cannot_have_a_this_parameter_2681","A constructor cannot have a 'this' parameter."),get_and_set_accessor_must_have_the_same_this_type:t(2682,e.DiagnosticCategory.Error,"get_and_set_accessor_must_have_the_same_this_type_2682","'get' and 'set' accessor must have the same 'this' type."),this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation:t(2683,e.DiagnosticCategory.Error,"this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_2683","'this' implicitly has type 'any' because it does not have a type annotation."),The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1:t(2684,e.DiagnosticCategory.Error,"The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1_2684","The 'this' context of type '{0}' is not assignable to method's 'this' of type '{1}'."),The_this_types_of_each_signature_are_incompatible:t(2685,e.DiagnosticCategory.Error,"The_this_types_of_each_signature_are_incompatible_2685","The 'this' types of each signature are incompatible."),_0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead:t(2686,e.DiagnosticCategory.Error,"_0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead_2686","'{0}' refers to a UMD global, but the current file is a module. Consider adding an import instead."),All_declarations_of_0_must_have_identical_modifiers:t(2687,e.DiagnosticCategory.Error,"All_declarations_of_0_must_have_identical_modifiers_2687","All declarations of '{0}' must have identical modifiers."),Cannot_find_type_definition_file_for_0:t(2688,e.DiagnosticCategory.Error,"Cannot_find_type_definition_file_for_0_2688","Cannot find type definition file for '{0}'."),Cannot_extend_an_interface_0_Did_you_mean_implements:t(2689,e.DiagnosticCategory.Error,"Cannot_extend_an_interface_0_Did_you_mean_implements_2689","Cannot extend an interface '{0}'. Did you mean 'implements'?"),An_import_path_cannot_end_with_a_0_extension_Consider_importing_1_instead:t(2691,e.DiagnosticCategory.Error,"An_import_path_cannot_end_with_a_0_extension_Consider_importing_1_instead_2691","An import path cannot end with a '{0}' extension. Consider importing '{1}' instead."),_0_is_a_primitive_but_1_is_a_wrapper_object_Prefer_using_0_when_possible:t(2692,e.DiagnosticCategory.Error,"_0_is_a_primitive_but_1_is_a_wrapper_object_Prefer_using_0_when_possible_2692","'{0}' is a primitive, but '{1}' is a wrapper object. Prefer using '{0}' when possible."),_0_only_refers_to_a_type_but_is_being_used_as_a_value_here:t(2693,e.DiagnosticCategory.Error,"_0_only_refers_to_a_type_but_is_being_used_as_a_value_here_2693","'{0}' only refers to a type, but is being used as a value here."),Namespace_0_has_no_exported_member_1:t(2694,e.DiagnosticCategory.Error,"Namespace_0_has_no_exported_member_1_2694","Namespace '{0}' has no exported member '{1}'."),Left_side_of_comma_operator_is_unused_and_has_no_side_effects:t(2695,e.DiagnosticCategory.Error,"Left_side_of_comma_operator_is_unused_and_has_no_side_effects_2695","Left side of comma operator is unused and has no side effects."),The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead:t(2696,e.DiagnosticCategory.Error,"The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead_2696","The 'Object' type is assignable to very few other types. Did you mean to use the 'any' type instead?"),An_async_function_or_method_must_return_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option:t(2697,e.DiagnosticCategory.Error,"An_async_function_or_method_must_return_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_in_2697","An async function or method must return a 'Promise'. Make sure you have a declaration for 'Promise' or include 'ES2015' in your `--lib` option."),Spread_types_may_only_be_created_from_object_types:t(2698,e.DiagnosticCategory.Error,"Spread_types_may_only_be_created_from_object_types_2698","Spread types may only be created from object types."),Static_property_0_conflicts_with_built_in_property_Function_0_of_constructor_function_1:t(2699,e.DiagnosticCategory.Error,"Static_property_0_conflicts_with_built_in_property_Function_0_of_constructor_function_1_2699","Static property '{0}' conflicts with built-in property 'Function.{0}' of constructor function '{1}'."),Rest_types_may_only_be_created_from_object_types:t(2700,e.DiagnosticCategory.Error,"Rest_types_may_only_be_created_from_object_types_2700","Rest types may only be created from object types."),The_target_of_an_object_rest_assignment_must_be_a_variable_or_a_property_access:t(2701,e.DiagnosticCategory.Error,"The_target_of_an_object_rest_assignment_must_be_a_variable_or_a_property_access_2701","The target of an object rest assignment must be a variable or a property access."),_0_only_refers_to_a_type_but_is_being_used_as_a_namespace_here:t(2702,e.DiagnosticCategory.Error,"_0_only_refers_to_a_type_but_is_being_used_as_a_namespace_here_2702","'{0}' only refers to a type, but is being used as a namespace here."),The_operand_of_a_delete_operator_must_be_a_property_reference:t(2703,e.DiagnosticCategory.Error,"The_operand_of_a_delete_operator_must_be_a_property_reference_2703","The operand of a delete operator must be a property reference."),The_operand_of_a_delete_operator_cannot_be_a_read_only_property:t(2704,e.DiagnosticCategory.Error,"The_operand_of_a_delete_operator_cannot_be_a_read_only_property_2704","The operand of a delete operator cannot be a read-only property."),An_async_function_or_method_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option:t(2705,e.DiagnosticCategory.Error,"An_async_function_or_method_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_de_2705","An async function or method in ES5/ES3 requires the 'Promise' constructor.  Make sure you have a declaration for the 'Promise' constructor or include 'ES2015' in your `--lib` option."),Required_type_parameters_may_not_follow_optional_type_parameters:t(2706,e.DiagnosticCategory.Error,"Required_type_parameters_may_not_follow_optional_type_parameters_2706","Required type parameters may not follow optional type parameters."),Generic_type_0_requires_between_1_and_2_type_arguments:t(2707,e.DiagnosticCategory.Error,"Generic_type_0_requires_between_1_and_2_type_arguments_2707","Generic type '{0}' requires between {1} and {2} type arguments."),Cannot_use_namespace_0_as_a_value:t(2708,e.DiagnosticCategory.Error,"Cannot_use_namespace_0_as_a_value_2708","Cannot use namespace '{0}' as a value."),Cannot_use_namespace_0_as_a_type:t(2709,e.DiagnosticCategory.Error,"Cannot_use_namespace_0_as_a_type_2709","Cannot use namespace '{0}' as a type."),_0_are_specified_twice_The_attribute_named_0_will_be_overwritten:t(2710,e.DiagnosticCategory.Error,"_0_are_specified_twice_The_attribute_named_0_will_be_overwritten_2710","'{0}' are specified twice. The attribute named '{0}' will be overwritten."),A_dynamic_import_call_returns_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option:t(2711,e.DiagnosticCategory.Error,"A_dynamic_import_call_returns_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES20_2711","A dynamic import call returns a 'Promise'. Make sure you have a declaration for 'Promise' or include 'ES2015' in your `--lib` option."),A_dynamic_import_call_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option:t(2712,e.DiagnosticCategory.Error,"A_dynamic_import_call_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declarat_2712","A dynamic import call in ES5/ES3 requires the 'Promise' constructor.  Make sure you have a declaration for the 'Promise' constructor or include 'ES2015' in your `--lib` option."),Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_property_1_in_0_with_0_1:t(2713,e.DiagnosticCategory.Error,"Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_p_2713","Cannot access '{0}.{1}' because '{0}' is a type, but not a namespace. Did you mean to retrieve the type of the property '{1}' in '{0}' with '{0}[\"{1}\"]'?"),The_expression_of_an_export_assignment_must_be_an_identifier_or_qualified_name_in_an_ambient_context:t(2714,e.DiagnosticCategory.Error,"The_expression_of_an_export_assignment_must_be_an_identifier_or_qualified_name_in_an_ambient_context_2714","The expression of an export assignment must be an identifier or qualified name in an ambient context."),Type_parameter_0_has_a_circular_default:t(2716,e.DiagnosticCategory.Error,"Type_parameter_0_has_a_circular_default_2716","Type parameter '{0}' has a circular default."),Import_declaration_0_is_using_private_name_1:t(4e3,e.DiagnosticCategory.Error,"Import_declaration_0_is_using_private_name_1_4000","Import declaration '{0}' is using private name '{1}'."),Type_parameter_0_of_exported_class_has_or_is_using_private_name_1:t(4002,e.DiagnosticCategory.Error,"Type_parameter_0_of_exported_class_has_or_is_using_private_name_1_4002","Type parameter '{0}' of exported class has or is using private name '{1}'."),Type_parameter_0_of_exported_interface_has_or_is_using_private_name_1:t(4004,e.DiagnosticCategory.Error,"Type_parameter_0_of_exported_interface_has_or_is_using_private_name_1_4004","Type parameter '{0}' of exported interface has or is using private name '{1}'."),Type_parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1:t(4006,e.DiagnosticCategory.Error,"Type_parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1_4006","Type parameter '{0}' of constructor signature from exported interface has or is using private name '{1}'."),Type_parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1:t(4008,e.DiagnosticCategory.Error,"Type_parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1_4008","Type parameter '{0}' of call signature from exported interface has or is using private name '{1}'."),Type_parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1:t(4010,e.DiagnosticCategory.Error,"Type_parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1_4010","Type parameter '{0}' of public static method from exported class has or is using private name '{1}'."),Type_parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1:t(4012,e.DiagnosticCategory.Error,"Type_parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1_4012","Type parameter '{0}' of public method from exported class has or is using private name '{1}'."),Type_parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1:t(4014,e.DiagnosticCategory.Error,"Type_parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1_4014","Type parameter '{0}' of method from exported interface has or is using private name '{1}'."),Type_parameter_0_of_exported_function_has_or_is_using_private_name_1:t(4016,e.DiagnosticCategory.Error,"Type_parameter_0_of_exported_function_has_or_is_using_private_name_1_4016","Type parameter '{0}' of exported function has or is using private name '{1}'."),Implements_clause_of_exported_class_0_has_or_is_using_private_name_1:t(4019,e.DiagnosticCategory.Error,"Implements_clause_of_exported_class_0_has_or_is_using_private_name_1_4019","Implements clause of exported class '{0}' has or is using private name '{1}'."),extends_clause_of_exported_class_0_has_or_is_using_private_name_1:t(4020,e.DiagnosticCategory.Error,"extends_clause_of_exported_class_0_has_or_is_using_private_name_1_4020","'extends' clause of exported class '{0}' has or is using private name '{1}'."),extends_clause_of_exported_interface_0_has_or_is_using_private_name_1:t(4022,e.DiagnosticCategory.Error,"extends_clause_of_exported_interface_0_has_or_is_using_private_name_1_4022","'extends' clause of exported interface '{0}' has or is using private name '{1}'."),Exported_variable_0_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:t(4023,e.DiagnosticCategory.Error,"Exported_variable_0_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4023","Exported variable '{0}' has or is using name '{1}' from external module {2} but cannot be named."),Exported_variable_0_has_or_is_using_name_1_from_private_module_2:t(4024,e.DiagnosticCategory.Error,"Exported_variable_0_has_or_is_using_name_1_from_private_module_2_4024","Exported variable '{0}' has or is using name '{1}' from private module '{2}'."),Exported_variable_0_has_or_is_using_private_name_1:t(4025,e.DiagnosticCategory.Error,"Exported_variable_0_has_or_is_using_private_name_1_4025","Exported variable '{0}' has or is using private name '{1}'."),Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:t(4026,e.DiagnosticCategory.Error,"Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot__4026","Public static property '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."),Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:t(4027,e.DiagnosticCategory.Error,"Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4027","Public static property '{0}' of exported class has or is using name '{1}' from private module '{2}'."),Public_static_property_0_of_exported_class_has_or_is_using_private_name_1:t(4028,e.DiagnosticCategory.Error,"Public_static_property_0_of_exported_class_has_or_is_using_private_name_1_4028","Public static property '{0}' of exported class has or is using private name '{1}'."),Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:t(4029,e.DiagnosticCategory.Error,"Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_name_4029","Public property '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."),Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:t(4030,e.DiagnosticCategory.Error,"Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4030","Public property '{0}' of exported class has or is using name '{1}' from private module '{2}'."),Public_property_0_of_exported_class_has_or_is_using_private_name_1:t(4031,e.DiagnosticCategory.Error,"Public_property_0_of_exported_class_has_or_is_using_private_name_1_4031","Public property '{0}' of exported class has or is using private name '{1}'."),Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2:t(4032,e.DiagnosticCategory.Error,"Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2_4032","Property '{0}' of exported interface has or is using name '{1}' from private module '{2}'."),Property_0_of_exported_interface_has_or_is_using_private_name_1:t(4033,e.DiagnosticCategory.Error,"Property_0_of_exported_interface_has_or_is_using_private_name_1_4033","Property '{0}' of exported interface has or is using private name '{1}'."),Parameter_0_of_public_static_property_setter_from_exported_class_has_or_is_using_name_1_from_private_module_2:t(4034,e.DiagnosticCategory.Error,"Parameter_0_of_public_static_property_setter_from_exported_class_has_or_is_using_name_1_from_private_4034","Parameter '{0}' of public static property setter from exported class has or is using name '{1}' from private module '{2}'."),Parameter_0_of_public_static_property_setter_from_exported_class_has_or_is_using_private_name_1:t(4035,e.DiagnosticCategory.Error,"Parameter_0_of_public_static_property_setter_from_exported_class_has_or_is_using_private_name_1_4035","Parameter '{0}' of public static property setter from exported class has or is using private name '{1}'."),Parameter_0_of_public_property_setter_from_exported_class_has_or_is_using_name_1_from_private_module_2:t(4036,e.DiagnosticCategory.Error,"Parameter_0_of_public_property_setter_from_exported_class_has_or_is_using_name_1_from_private_module_4036","Parameter '{0}' of public property setter from exported class has or is using name '{1}' from private module '{2}'."),Parameter_0_of_public_property_setter_from_exported_class_has_or_is_using_private_name_1:t(4037,e.DiagnosticCategory.Error,"Parameter_0_of_public_property_setter_from_exported_class_has_or_is_using_private_name_1_4037","Parameter '{0}' of public property setter from exported class has or is using private name '{1}'."),Return_type_of_public_static_property_getter_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:t(4038,e.DiagnosticCategory.Error,"Return_type_of_public_static_property_getter_from_exported_class_has_or_is_using_name_0_from_externa_4038","Return type of public static property getter from exported class has or is using name '{0}' from external module {1} but cannot be named."),Return_type_of_public_static_property_getter_from_exported_class_has_or_is_using_name_0_from_private_module_1:t(4039,e.DiagnosticCategory.Error,"Return_type_of_public_static_property_getter_from_exported_class_has_or_is_using_name_0_from_private_4039","Return type of public static property getter from exported class has or is using name '{0}' from private module '{1}'."),Return_type_of_public_static_property_getter_from_exported_class_has_or_is_using_private_name_0:t(4040,e.DiagnosticCategory.Error,"Return_type_of_public_static_property_getter_from_exported_class_has_or_is_using_private_name_0_4040","Return type of public static property getter from exported class has or is using private name '{0}'."),Return_type_of_public_property_getter_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:t(4041,e.DiagnosticCategory.Error,"Return_type_of_public_property_getter_from_exported_class_has_or_is_using_name_0_from_external_modul_4041","Return type of public property getter from exported class has or is using name '{0}' from external module {1} but cannot be named."),Return_type_of_public_property_getter_from_exported_class_has_or_is_using_name_0_from_private_module_1:t(4042,e.DiagnosticCategory.Error,"Return_type_of_public_property_getter_from_exported_class_has_or_is_using_name_0_from_private_module_4042","Return type of public property getter from exported class has or is using name '{0}' from private module '{1}'."),Return_type_of_public_property_getter_from_exported_class_has_or_is_using_private_name_0:t(4043,e.DiagnosticCategory.Error,"Return_type_of_public_property_getter_from_exported_class_has_or_is_using_private_name_0_4043","Return type of public property getter from exported class has or is using private name '{0}'."),Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1:t(4044,e.DiagnosticCategory.Error,"Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_name_0_from_private_mod_4044","Return type of constructor signature from exported interface has or is using name '{0}' from private module '{1}'."),Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_0:t(4045,e.DiagnosticCategory.Error,"Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_0_4045","Return type of constructor signature from exported interface has or is using private name '{0}'."),Return_type_of_call_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1:t(4046,e.DiagnosticCategory.Error,"Return_type_of_call_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1_4046","Return type of call signature from exported interface has or is using name '{0}' from private module '{1}'."),Return_type_of_call_signature_from_exported_interface_has_or_is_using_private_name_0:t(4047,e.DiagnosticCategory.Error,"Return_type_of_call_signature_from_exported_interface_has_or_is_using_private_name_0_4047","Return type of call signature from exported interface has or is using private name '{0}'."),Return_type_of_index_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1:t(4048,e.DiagnosticCategory.Error,"Return_type_of_index_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1_4048","Return type of index signature from exported interface has or is using name '{0}' from private module '{1}'."),Return_type_of_index_signature_from_exported_interface_has_or_is_using_private_name_0:t(4049,e.DiagnosticCategory.Error,"Return_type_of_index_signature_from_exported_interface_has_or_is_using_private_name_0_4049","Return type of index signature from exported interface has or is using private name '{0}'."),Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:t(4050,e.DiagnosticCategory.Error,"Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_external_module__4050","Return type of public static method from exported class has or is using name '{0}' from external module {1} but cannot be named."),Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_private_module_1:t(4051,e.DiagnosticCategory.Error,"Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_private_module_1_4051","Return type of public static method from exported class has or is using name '{0}' from private module '{1}'."),Return_type_of_public_static_method_from_exported_class_has_or_is_using_private_name_0:t(4052,e.DiagnosticCategory.Error,"Return_type_of_public_static_method_from_exported_class_has_or_is_using_private_name_0_4052","Return type of public static method from exported class has or is using private name '{0}'."),Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:t(4053,e.DiagnosticCategory.Error,"Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_c_4053","Return type of public method from exported class has or is using name '{0}' from external module {1} but cannot be named."),Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_private_module_1:t(4054,e.DiagnosticCategory.Error,"Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_private_module_1_4054","Return type of public method from exported class has or is using name '{0}' from private module '{1}'."),Return_type_of_public_method_from_exported_class_has_or_is_using_private_name_0:t(4055,e.DiagnosticCategory.Error,"Return_type_of_public_method_from_exported_class_has_or_is_using_private_name_0_4055","Return type of public method from exported class has or is using private name '{0}'."),Return_type_of_method_from_exported_interface_has_or_is_using_name_0_from_private_module_1:t(4056,e.DiagnosticCategory.Error,"Return_type_of_method_from_exported_interface_has_or_is_using_name_0_from_private_module_1_4056","Return type of method from exported interface has or is using name '{0}' from private module '{1}'."),Return_type_of_method_from_exported_interface_has_or_is_using_private_name_0:t(4057,e.DiagnosticCategory.Error,"Return_type_of_method_from_exported_interface_has_or_is_using_private_name_0_4057","Return type of method from exported interface has or is using private name '{0}'."),Return_type_of_exported_function_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:t(4058,e.DiagnosticCategory.Error,"Return_type_of_exported_function_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named_4058","Return type of exported function has or is using name '{0}' from external module {1} but cannot be named."),Return_type_of_exported_function_has_or_is_using_name_0_from_private_module_1:t(4059,e.DiagnosticCategory.Error,"Return_type_of_exported_function_has_or_is_using_name_0_from_private_module_1_4059","Return type of exported function has or is using name '{0}' from private module '{1}'."),Return_type_of_exported_function_has_or_is_using_private_name_0:t(4060,e.DiagnosticCategory.Error,"Return_type_of_exported_function_has_or_is_using_private_name_0_4060","Return type of exported function has or is using private name '{0}'."),Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:t(4061,e.DiagnosticCategory.Error,"Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_can_4061","Parameter '{0}' of constructor from exported class has or is using name '{1}' from external module {2} but cannot be named."),Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_private_module_2:t(4062,e.DiagnosticCategory.Error,"Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_private_module_2_4062","Parameter '{0}' of constructor from exported class has or is using name '{1}' from private module '{2}'."),Parameter_0_of_constructor_from_exported_class_has_or_is_using_private_name_1:t(4063,e.DiagnosticCategory.Error,"Parameter_0_of_constructor_from_exported_class_has_or_is_using_private_name_1_4063","Parameter '{0}' of constructor from exported class has or is using private name '{1}'."),Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2:t(4064,e.DiagnosticCategory.Error,"Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_name_1_from_private_mod_4064","Parameter '{0}' of constructor signature from exported interface has or is using name '{1}' from private module '{2}'."),Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1:t(4065,e.DiagnosticCategory.Error,"Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1_4065","Parameter '{0}' of constructor signature from exported interface has or is using private name '{1}'."),Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2:t(4066,e.DiagnosticCategory.Error,"Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2_4066","Parameter '{0}' of call signature from exported interface has or is using name '{1}' from private module '{2}'."),Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1:t(4067,e.DiagnosticCategory.Error,"Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1_4067","Parameter '{0}' of call signature from exported interface has or is using private name '{1}'."),Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:t(4068,e.DiagnosticCategory.Error,"Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_external_module__4068","Parameter '{0}' of public static method from exported class has or is using name '{1}' from external module {2} but cannot be named."),Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_private_module_2:t(4069,e.DiagnosticCategory.Error,"Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_private_module_2_4069","Parameter '{0}' of public static method from exported class has or is using name '{1}' from private module '{2}'."),Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1:t(4070,e.DiagnosticCategory.Error,"Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1_4070","Parameter '{0}' of public static method from exported class has or is using private name '{1}'."),Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:t(4071,e.DiagnosticCategory.Error,"Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_c_4071","Parameter '{0}' of public method from exported class has or is using name '{1}' from external module {2} but cannot be named."),Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_private_module_2:t(4072,e.DiagnosticCategory.Error,"Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_private_module_2_4072","Parameter '{0}' of public method from exported class has or is using name '{1}' from private module '{2}'."),Parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1:t(4073,e.DiagnosticCategory.Error,"Parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1_4073","Parameter '{0}' of public method from exported class has or is using private name '{1}'."),Parameter_0_of_method_from_exported_interface_has_or_is_using_name_1_from_private_module_2:t(4074,e.DiagnosticCategory.Error,"Parameter_0_of_method_from_exported_interface_has_or_is_using_name_1_from_private_module_2_4074","Parameter '{0}' of method from exported interface has or is using name '{1}' from private module '{2}'."),Parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1:t(4075,e.DiagnosticCategory.Error,"Parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1_4075","Parameter '{0}' of method from exported interface has or is using private name '{1}'."),Parameter_0_of_exported_function_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:t(4076,e.DiagnosticCategory.Error,"Parameter_0_of_exported_function_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4076","Parameter '{0}' of exported function has or is using name '{1}' from external module {2} but cannot be named."),Parameter_0_of_exported_function_has_or_is_using_name_1_from_private_module_2:t(4077,e.DiagnosticCategory.Error,"Parameter_0_of_exported_function_has_or_is_using_name_1_from_private_module_2_4077","Parameter '{0}' of exported function has or is using name '{1}' from private module '{2}'."),Parameter_0_of_exported_function_has_or_is_using_private_name_1:t(4078,e.DiagnosticCategory.Error,"Parameter_0_of_exported_function_has_or_is_using_private_name_1_4078","Parameter '{0}' of exported function has or is using private name '{1}'."),Exported_type_alias_0_has_or_is_using_private_name_1:t(4081,e.DiagnosticCategory.Error,"Exported_type_alias_0_has_or_is_using_private_name_1_4081","Exported type alias '{0}' has or is using private name '{1}'."),Default_export_of_the_module_has_or_is_using_private_name_0:t(4082,e.DiagnosticCategory.Error,"Default_export_of_the_module_has_or_is_using_private_name_0_4082","Default export of the module has or is using private name '{0}'."),Type_parameter_0_of_exported_type_alias_has_or_is_using_private_name_1:t(4083,e.DiagnosticCategory.Error,"Type_parameter_0_of_exported_type_alias_has_or_is_using_private_name_1_4083","Type parameter '{0}' of exported type alias has or is using private name '{1}'."),Conflicting_definitions_for_0_found_at_1_and_2_Consider_installing_a_specific_version_of_this_library_to_resolve_the_conflict:t(4090,e.DiagnosticCategory.Message,"Conflicting_definitions_for_0_found_at_1_and_2_Consider_installing_a_specific_version_of_this_librar_4090","Conflicting definitions for '{0}' found at '{1}' and '{2}'. Consider installing a specific version of this library to resolve the conflict."),Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2:t(4091,e.DiagnosticCategory.Error,"Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2_4091","Parameter '{0}' of index signature from exported interface has or is using name '{1}' from private module '{2}'."),Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_private_name_1:t(4092,e.DiagnosticCategory.Error,"Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_private_name_1_4092","Parameter '{0}' of index signature from exported interface has or is using private name '{1}'."),Property_0_of_exported_class_expression_may_not_be_private_or_protected:t(4094,e.DiagnosticCategory.Error,"Property_0_of_exported_class_expression_may_not_be_private_or_protected_4094","Property '{0}' of exported class expression may not be private or protected."),The_current_host_does_not_support_the_0_option:t(5001,e.DiagnosticCategory.Error,"The_current_host_does_not_support_the_0_option_5001","The current host does not support the '{0}' option."),Cannot_find_the_common_subdirectory_path_for_the_input_files:t(5009,e.DiagnosticCategory.Error,"Cannot_find_the_common_subdirectory_path_for_the_input_files_5009","Cannot find the common subdirectory path for the input files."),File_specification_cannot_end_in_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0:t(5010,e.DiagnosticCategory.Error,"File_specification_cannot_end_in_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0_5010","File specification cannot end in a recursive directory wildcard ('**'): '{0}'."),File_specification_cannot_contain_multiple_recursive_directory_wildcards_Asterisk_Asterisk_Colon_0:t(5011,e.DiagnosticCategory.Error,"File_specification_cannot_contain_multiple_recursive_directory_wildcards_Asterisk_Asterisk_Colon_0_5011","File specification cannot contain multiple recursive directory wildcards ('**'): '{0}'."),Cannot_read_file_0_Colon_1:t(5012,e.DiagnosticCategory.Error,"Cannot_read_file_0_Colon_1_5012","Cannot read file '{0}': {1}."),Failed_to_parse_file_0_Colon_1:t(5014,e.DiagnosticCategory.Error,"Failed_to_parse_file_0_Colon_1_5014","Failed to parse file '{0}': {1}."),Unknown_compiler_option_0:t(5023,e.DiagnosticCategory.Error,"Unknown_compiler_option_0_5023","Unknown compiler option '{0}'."),Compiler_option_0_requires_a_value_of_type_1:t(5024,e.DiagnosticCategory.Error,"Compiler_option_0_requires_a_value_of_type_1_5024","Compiler option '{0}' requires a value of type {1}."),Could_not_write_file_0_Colon_1:t(5033,e.DiagnosticCategory.Error,"Could_not_write_file_0_Colon_1_5033","Could not write file '{0}': {1}."),Option_project_cannot_be_mixed_with_source_files_on_a_command_line:t(5042,e.DiagnosticCategory.Error,"Option_project_cannot_be_mixed_with_source_files_on_a_command_line_5042","Option 'project' cannot be mixed with source files on a command line."),Option_isolatedModules_can_only_be_used_when_either_option_module_is_provided_or_option_target_is_ES2015_or_higher:t(5047,e.DiagnosticCategory.Error,"Option_isolatedModules_can_only_be_used_when_either_option_module_is_provided_or_option_target_is_ES_5047","Option 'isolatedModules' can only be used when either option '--module' is provided or option 'target' is 'ES2015' or higher."),Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided:t(5051,e.DiagnosticCategory.Error,"Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided_5051","Option '{0} can only be used when either option '--inlineSourceMap' or option '--sourceMap' is provided."),Option_0_cannot_be_specified_without_specifying_option_1:t(5052,e.DiagnosticCategory.Error,"Option_0_cannot_be_specified_without_specifying_option_1_5052","Option '{0}' cannot be specified without specifying option '{1}'."),Option_0_cannot_be_specified_with_option_1:t(5053,e.DiagnosticCategory.Error,"Option_0_cannot_be_specified_with_option_1_5053","Option '{0}' cannot be specified with option '{1}'."),A_tsconfig_json_file_is_already_defined_at_Colon_0:t(5054,e.DiagnosticCategory.Error,"A_tsconfig_json_file_is_already_defined_at_Colon_0_5054","A 'tsconfig.json' file is already defined at: '{0}'."),Cannot_write_file_0_because_it_would_overwrite_input_file:t(5055,e.DiagnosticCategory.Error,"Cannot_write_file_0_because_it_would_overwrite_input_file_5055","Cannot write file '{0}' because it would overwrite input file."),Cannot_write_file_0_because_it_would_be_overwritten_by_multiple_input_files:t(5056,e.DiagnosticCategory.Error,"Cannot_write_file_0_because_it_would_be_overwritten_by_multiple_input_files_5056","Cannot write file '{0}' because it would be overwritten by multiple input files."),Cannot_find_a_tsconfig_json_file_at_the_specified_directory_Colon_0:t(5057,e.DiagnosticCategory.Error,"Cannot_find_a_tsconfig_json_file_at_the_specified_directory_Colon_0_5057","Cannot find a tsconfig.json file at the specified directory: '{0}'."),The_specified_path_does_not_exist_Colon_0:t(5058,e.DiagnosticCategory.Error,"The_specified_path_does_not_exist_Colon_0_5058","The specified path does not exist: '{0}'."),Invalid_value_for_reactNamespace_0_is_not_a_valid_identifier:t(5059,e.DiagnosticCategory.Error,"Invalid_value_for_reactNamespace_0_is_not_a_valid_identifier_5059","Invalid value for '--reactNamespace'. '{0}' is not a valid identifier."),Option_paths_cannot_be_used_without_specifying_baseUrl_option:t(5060,e.DiagnosticCategory.Error,"Option_paths_cannot_be_used_without_specifying_baseUrl_option_5060","Option 'paths' cannot be used without specifying '--baseUrl' option."),Pattern_0_can_have_at_most_one_Asterisk_character:t(5061,e.DiagnosticCategory.Error,"Pattern_0_can_have_at_most_one_Asterisk_character_5061","Pattern '{0}' can have at most one '*' character."),Substitution_0_in_pattern_1_in_can_have_at_most_one_Asterisk_character:t(5062,e.DiagnosticCategory.Error,"Substitution_0_in_pattern_1_in_can_have_at_most_one_Asterisk_character_5062","Substitution '{0}' in pattern '{1}' in can have at most one '*' character."),Substitutions_for_pattern_0_should_be_an_array:t(5063,e.DiagnosticCategory.Error,"Substitutions_for_pattern_0_should_be_an_array_5063","Substitutions for pattern '{0}' should be an array."),Substitution_0_for_pattern_1_has_incorrect_type_expected_string_got_2:t(5064,e.DiagnosticCategory.Error,"Substitution_0_for_pattern_1_has_incorrect_type_expected_string_got_2_5064","Substitution '{0}' for pattern '{1}' has incorrect type, expected 'string', got '{2}'."),File_specification_cannot_contain_a_parent_directory_that_appears_after_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0:t(5065,e.DiagnosticCategory.Error,"File_specification_cannot_contain_a_parent_directory_that_appears_after_a_recursive_directory_wildca_5065","File specification cannot contain a parent directory ('..') that appears after a recursive directory wildcard ('**'): '{0}'."),Substitutions_for_pattern_0_shouldn_t_be_an_empty_array:t(5066,e.DiagnosticCategory.Error,"Substitutions_for_pattern_0_shouldn_t_be_an_empty_array_5066","Substitutions for pattern '{0}' shouldn't be an empty array."),Invalid_value_for_jsxFactory_0_is_not_a_valid_identifier_or_qualified_name:t(5067,e.DiagnosticCategory.Error,"Invalid_value_for_jsxFactory_0_is_not_a_valid_identifier_or_qualified_name_5067","Invalid value for 'jsxFactory'. '{0}' is not a valid identifier or qualified-name."),Concatenate_and_emit_output_to_single_file:t(6001,e.DiagnosticCategory.Message,"Concatenate_and_emit_output_to_single_file_6001","Concatenate and emit output to single file."),Generates_corresponding_d_ts_file:t(6002,e.DiagnosticCategory.Message,"Generates_corresponding_d_ts_file_6002","Generates corresponding '.d.ts' file."),Specify_the_location_where_debugger_should_locate_map_files_instead_of_generated_locations:t(6003,e.DiagnosticCategory.Message,"Specify_the_location_where_debugger_should_locate_map_files_instead_of_generated_locations_6003","Specify the location where debugger should locate map files instead of generated locations."),Specify_the_location_where_debugger_should_locate_TypeScript_files_instead_of_source_locations:t(6004,e.DiagnosticCategory.Message,"Specify_the_location_where_debugger_should_locate_TypeScript_files_instead_of_source_locations_6004","Specify the location where debugger should locate TypeScript files instead of source locations."),Watch_input_files:t(6005,e.DiagnosticCategory.Message,"Watch_input_files_6005","Watch input files."),Redirect_output_structure_to_the_directory:t(6006,e.DiagnosticCategory.Message,"Redirect_output_structure_to_the_directory_6006","Redirect output structure to the directory."),Do_not_erase_const_enum_declarations_in_generated_code:t(6007,e.DiagnosticCategory.Message,"Do_not_erase_const_enum_declarations_in_generated_code_6007","Do not erase const enum declarations in generated code."),Do_not_emit_outputs_if_any_errors_were_reported:t(6008,e.DiagnosticCategory.Message,"Do_not_emit_outputs_if_any_errors_were_reported_6008","Do not emit outputs if any errors were reported."),Do_not_emit_comments_to_output:t(6009,e.DiagnosticCategory.Message,"Do_not_emit_comments_to_output_6009","Do not emit comments to output."),Do_not_emit_outputs:t(6010,e.DiagnosticCategory.Message,"Do_not_emit_outputs_6010","Do not emit outputs."),Allow_default_imports_from_modules_with_no_default_export_This_does_not_affect_code_emit_just_typechecking:t(6011,e.DiagnosticCategory.Message,"Allow_default_imports_from_modules_with_no_default_export_This_does_not_affect_code_emit_just_typech_6011","Allow default imports from modules with no default export. This does not affect code emit, just typechecking."),Skip_type_checking_of_declaration_files:t(6012,e.DiagnosticCategory.Message,"Skip_type_checking_of_declaration_files_6012","Skip type checking of declaration files."),Do_not_resolve_the_real_path_of_symlinks:t(6013,e.DiagnosticCategory.Message,"Do_not_resolve_the_real_path_of_symlinks_6013","Do not resolve the real path of symlinks."),Specify_ECMAScript_target_version_Colon_ES3_default_ES5_ES2015_ES2016_ES2017_or_ESNEXT:t(6015,e.DiagnosticCategory.Message,"Specify_ECMAScript_target_version_Colon_ES3_default_ES5_ES2015_ES2016_ES2017_or_ESNEXT_6015","Specify ECMAScript target version: 'ES3' (default), 'ES5', 'ES2015', 'ES2016', 'ES2017', or 'ESNEXT'."),Specify_module_code_generation_Colon_none_commonjs_amd_system_umd_es2015_or_ESNext:t(6016,e.DiagnosticCategory.Message,"Specify_module_code_generation_Colon_none_commonjs_amd_system_umd_es2015_or_ESNext_6016","Specify module code generation: 'none', 'commonjs', 'amd', 'system', 'umd', 'es2015', or 'ESNext'."),Print_this_message:t(6017,e.DiagnosticCategory.Message,"Print_this_message_6017","Print this message."),Print_the_compiler_s_version:t(6019,e.DiagnosticCategory.Message,"Print_the_compiler_s_version_6019","Print the compiler's version."),Compile_the_project_given_the_path_to_its_configuration_file_or_to_a_folder_with_a_tsconfig_json:t(6020,e.DiagnosticCategory.Message,"Compile_the_project_given_the_path_to_its_configuration_file_or_to_a_folder_with_a_tsconfig_json_6020","Compile the project given the path to its configuration file, or to a folder with a 'tsconfig.json'."),Syntax_Colon_0:t(6023,e.DiagnosticCategory.Message,"Syntax_Colon_0_6023","Syntax: {0}"),options:t(6024,e.DiagnosticCategory.Message,"options_6024","options"),file:t(6025,e.DiagnosticCategory.Message,"file_6025","file"),Examples_Colon_0:t(6026,e.DiagnosticCategory.Message,"Examples_Colon_0_6026","Examples: {0}"),Options_Colon:t(6027,e.DiagnosticCategory.Message,"Options_Colon_6027","Options:"),Version_0:t(6029,e.DiagnosticCategory.Message,"Version_0_6029","Version {0}"),Insert_command_line_options_and_files_from_a_file:t(6030,e.DiagnosticCategory.Message,"Insert_command_line_options_and_files_from_a_file_6030","Insert command line options and files from a file."),File_change_detected_Starting_incremental_compilation:t(6032,e.DiagnosticCategory.Message,"File_change_detected_Starting_incremental_compilation_6032","File change detected. Starting incremental compilation..."),KIND:t(6034,e.DiagnosticCategory.Message,"KIND_6034","KIND"),FILE:t(6035,e.DiagnosticCategory.Message,"FILE_6035","FILE"),VERSION:t(6036,e.DiagnosticCategory.Message,"VERSION_6036","VERSION"),LOCATION:t(6037,e.DiagnosticCategory.Message,"LOCATION_6037","LOCATION"),DIRECTORY:t(6038,e.DiagnosticCategory.Message,"DIRECTORY_6038","DIRECTORY"),STRATEGY:t(6039,e.DiagnosticCategory.Message,"STRATEGY_6039","STRATEGY"),FILE_OR_DIRECTORY:t(6040,e.DiagnosticCategory.Message,"FILE_OR_DIRECTORY_6040","FILE OR DIRECTORY"),Compilation_complete_Watching_for_file_changes:t(6042,e.DiagnosticCategory.Message,"Compilation_complete_Watching_for_file_changes_6042","Compilation complete. Watching for file changes."),Generates_corresponding_map_file:t(6043,e.DiagnosticCategory.Message,"Generates_corresponding_map_file_6043","Generates corresponding '.map' file."),Compiler_option_0_expects_an_argument:t(6044,e.DiagnosticCategory.Error,"Compiler_option_0_expects_an_argument_6044","Compiler option '{0}' expects an argument."),Unterminated_quoted_string_in_response_file_0:t(6045,e.DiagnosticCategory.Error,"Unterminated_quoted_string_in_response_file_0_6045","Unterminated quoted string in response file '{0}'."),Argument_for_0_option_must_be_Colon_1:t(6046,e.DiagnosticCategory.Error,"Argument_for_0_option_must_be_Colon_1_6046","Argument for '{0}' option must be: {1}."),Locale_must_be_of_the_form_language_or_language_territory_For_example_0_or_1:t(6048,e.DiagnosticCategory.Error,"Locale_must_be_of_the_form_language_or_language_territory_For_example_0_or_1_6048","Locale must be of the form <language> or <language>-<territory>. For example '{0}' or '{1}'."),Unsupported_locale_0:t(6049,e.DiagnosticCategory.Error,"Unsupported_locale_0_6049","Unsupported locale '{0}'."),Unable_to_open_file_0:t(6050,e.DiagnosticCategory.Error,"Unable_to_open_file_0_6050","Unable to open file '{0}'."),Corrupted_locale_file_0:t(6051,e.DiagnosticCategory.Error,"Corrupted_locale_file_0_6051","Corrupted locale file {0}."),Raise_error_on_expressions_and_declarations_with_an_implied_any_type:t(6052,e.DiagnosticCategory.Message,"Raise_error_on_expressions_and_declarations_with_an_implied_any_type_6052","Raise error on expressions and declarations with an implied 'any' type."),File_0_not_found:t(6053,e.DiagnosticCategory.Error,"File_0_not_found_6053","File '{0}' not found."),File_0_has_unsupported_extension_The_only_supported_extensions_are_1:t(6054,e.DiagnosticCategory.Error,"File_0_has_unsupported_extension_The_only_supported_extensions_are_1_6054","File '{0}' has unsupported extension. The only supported extensions are {1}."),Suppress_noImplicitAny_errors_for_indexing_objects_lacking_index_signatures:t(6055,e.DiagnosticCategory.Message,"Suppress_noImplicitAny_errors_for_indexing_objects_lacking_index_signatures_6055","Suppress noImplicitAny errors for indexing objects lacking index signatures."),Do_not_emit_declarations_for_code_that_has_an_internal_annotation:t(6056,e.DiagnosticCategory.Message,"Do_not_emit_declarations_for_code_that_has_an_internal_annotation_6056","Do not emit declarations for code that has an '@internal' annotation."),Specify_the_root_directory_of_input_files_Use_to_control_the_output_directory_structure_with_outDir:t(6058,e.DiagnosticCategory.Message,"Specify_the_root_directory_of_input_files_Use_to_control_the_output_directory_structure_with_outDir_6058","Specify the root directory of input files. Use to control the output directory structure with --outDir."),File_0_is_not_under_rootDir_1_rootDir_is_expected_to_contain_all_source_files:t(6059,e.DiagnosticCategory.Error,"File_0_is_not_under_rootDir_1_rootDir_is_expected_to_contain_all_source_files_6059","File '{0}' is not under 'rootDir' '{1}'. 'rootDir' is expected to contain all source files."),Specify_the_end_of_line_sequence_to_be_used_when_emitting_files_Colon_CRLF_dos_or_LF_unix:t(6060,e.DiagnosticCategory.Message,"Specify_the_end_of_line_sequence_to_be_used_when_emitting_files_Colon_CRLF_dos_or_LF_unix_6060","Specify the end of line sequence to be used when emitting files: 'CRLF' (dos) or 'LF' (unix)."),NEWLINE:t(6061,e.DiagnosticCategory.Message,"NEWLINE_6061","NEWLINE"),Option_0_can_only_be_specified_in_tsconfig_json_file:t(6064,e.DiagnosticCategory.Error,"Option_0_can_only_be_specified_in_tsconfig_json_file_6064","Option '{0}' can only be specified in 'tsconfig.json' file."),Enables_experimental_support_for_ES7_decorators:t(6065,e.DiagnosticCategory.Message,"Enables_experimental_support_for_ES7_decorators_6065","Enables experimental support for ES7 decorators."),Enables_experimental_support_for_emitting_type_metadata_for_decorators:t(6066,e.DiagnosticCategory.Message,"Enables_experimental_support_for_emitting_type_metadata_for_decorators_6066","Enables experimental support for emitting type metadata for decorators."),Enables_experimental_support_for_ES7_async_functions:t(6068,e.DiagnosticCategory.Message,"Enables_experimental_support_for_ES7_async_functions_6068","Enables experimental support for ES7 async functions."),Specify_module_resolution_strategy_Colon_node_Node_js_or_classic_TypeScript_pre_1_6:t(6069,e.DiagnosticCategory.Message,"Specify_module_resolution_strategy_Colon_node_Node_js_or_classic_TypeScript_pre_1_6_6069","Specify module resolution strategy: 'node' (Node.js) or 'classic' (TypeScript pre-1.6)."),Initializes_a_TypeScript_project_and_creates_a_tsconfig_json_file:t(6070,e.DiagnosticCategory.Message,"Initializes_a_TypeScript_project_and_creates_a_tsconfig_json_file_6070","Initializes a TypeScript project and creates a tsconfig.json file."),Successfully_created_a_tsconfig_json_file:t(6071,e.DiagnosticCategory.Message,"Successfully_created_a_tsconfig_json_file_6071","Successfully created a tsconfig.json file."),Suppress_excess_property_checks_for_object_literals:t(6072,e.DiagnosticCategory.Message,"Suppress_excess_property_checks_for_object_literals_6072","Suppress excess property checks for object literals."),Stylize_errors_and_messages_using_color_and_context_experimental:t(6073,e.DiagnosticCategory.Message,"Stylize_errors_and_messages_using_color_and_context_experimental_6073","Stylize errors and messages using color and context (experimental)."),Do_not_report_errors_on_unused_labels:t(6074,e.DiagnosticCategory.Message,"Do_not_report_errors_on_unused_labels_6074","Do not report errors on unused labels."),Report_error_when_not_all_code_paths_in_function_return_a_value:t(6075,e.DiagnosticCategory.Message,"Report_error_when_not_all_code_paths_in_function_return_a_value_6075","Report error when not all code paths in function return a value."),Report_errors_for_fallthrough_cases_in_switch_statement:t(6076,e.DiagnosticCategory.Message,"Report_errors_for_fallthrough_cases_in_switch_statement_6076","Report errors for fallthrough cases in switch statement."),Do_not_report_errors_on_unreachable_code:t(6077,e.DiagnosticCategory.Message,"Do_not_report_errors_on_unreachable_code_6077","Do not report errors on unreachable code."),Disallow_inconsistently_cased_references_to_the_same_file:t(6078,e.DiagnosticCategory.Message,"Disallow_inconsistently_cased_references_to_the_same_file_6078","Disallow inconsistently-cased references to the same file."),Specify_library_files_to_be_included_in_the_compilation_Colon:t(6079,e.DiagnosticCategory.Message,"Specify_library_files_to_be_included_in_the_compilation_Colon_6079","Specify library files to be included in the compilation: "),Specify_JSX_code_generation_Colon_preserve_react_native_or_react:t(6080,e.DiagnosticCategory.Message,"Specify_JSX_code_generation_Colon_preserve_react_native_or_react_6080","Specify JSX code generation: 'preserve', 'react-native', or 'react'."),File_0_has_an_unsupported_extension_so_skipping_it:t(6081,e.DiagnosticCategory.Message,"File_0_has_an_unsupported_extension_so_skipping_it_6081","File '{0}' has an unsupported extension, so skipping it."),Only_amd_and_system_modules_are_supported_alongside_0:t(6082,e.DiagnosticCategory.Error,"Only_amd_and_system_modules_are_supported_alongside_0_6082","Only 'amd' and 'system' modules are supported alongside --{0}."),Base_directory_to_resolve_non_absolute_module_names:t(6083,e.DiagnosticCategory.Message,"Base_directory_to_resolve_non_absolute_module_names_6083","Base directory to resolve non-absolute module names."),Deprecated_Use_jsxFactory_instead_Specify_the_object_invoked_for_createElement_when_targeting_react_JSX_emit:t(6084,e.DiagnosticCategory.Message,"Deprecated_Use_jsxFactory_instead_Specify_the_object_invoked_for_createElement_when_targeting_react__6084","[Deprecated] Use '--jsxFactory' instead. Specify the object invoked for createElement when targeting 'react' JSX emit"),Enable_tracing_of_the_name_resolution_process:t(6085,e.DiagnosticCategory.Message,"Enable_tracing_of_the_name_resolution_process_6085","Enable tracing of the name resolution process."),Resolving_module_0_from_1:t(6086,e.DiagnosticCategory.Message,"Resolving_module_0_from_1_6086","======== Resolving module '{0}' from '{1}'. ========"),Explicitly_specified_module_resolution_kind_Colon_0:t(6087,e.DiagnosticCategory.Message,"Explicitly_specified_module_resolution_kind_Colon_0_6087","Explicitly specified module resolution kind: '{0}'."),Module_resolution_kind_is_not_specified_using_0:t(6088,e.DiagnosticCategory.Message,"Module_resolution_kind_is_not_specified_using_0_6088","Module resolution kind is not specified, using '{0}'."),Module_name_0_was_successfully_resolved_to_1:t(6089,e.DiagnosticCategory.Message,"Module_name_0_was_successfully_resolved_to_1_6089","======== Module name '{0}' was successfully resolved to '{1}'. ========"),Module_name_0_was_not_resolved:t(6090,e.DiagnosticCategory.Message,"Module_name_0_was_not_resolved_6090","======== Module name '{0}' was not resolved. ========"),paths_option_is_specified_looking_for_a_pattern_to_match_module_name_0:t(6091,e.DiagnosticCategory.Message,"paths_option_is_specified_looking_for_a_pattern_to_match_module_name_0_6091","'paths' option is specified, looking for a pattern to match module name '{0}'."),Module_name_0_matched_pattern_1:t(6092,e.DiagnosticCategory.Message,"Module_name_0_matched_pattern_1_6092","Module name '{0}', matched pattern '{1}'."),Trying_substitution_0_candidate_module_location_Colon_1:t(6093,e.DiagnosticCategory.Message,"Trying_substitution_0_candidate_module_location_Colon_1_6093","Trying substitution '{0}', candidate module location: '{1}'."),Resolving_module_name_0_relative_to_base_url_1_2:t(6094,e.DiagnosticCategory.Message,"Resolving_module_name_0_relative_to_base_url_1_2_6094","Resolving module name '{0}' relative to base url '{1}' - '{2}'."),Loading_module_as_file_Slash_folder_candidate_module_location_0_target_file_type_1:t(6095,e.DiagnosticCategory.Message,"Loading_module_as_file_Slash_folder_candidate_module_location_0_target_file_type_1_6095","Loading module as file / folder, candidate module location '{0}', target file type '{1}'."),File_0_does_not_exist:t(6096,e.DiagnosticCategory.Message,"File_0_does_not_exist_6096","File '{0}' does not exist."),File_0_exist_use_it_as_a_name_resolution_result:t(6097,e.DiagnosticCategory.Message,"File_0_exist_use_it_as_a_name_resolution_result_6097","File '{0}' exist - use it as a name resolution result."),Loading_module_0_from_node_modules_folder_target_file_type_1:t(6098,e.DiagnosticCategory.Message,"Loading_module_0_from_node_modules_folder_target_file_type_1_6098","Loading module '{0}' from 'node_modules' folder, target file type '{1}'."),Found_package_json_at_0:t(6099,e.DiagnosticCategory.Message,"Found_package_json_at_0_6099","Found 'package.json' at '{0}'."),package_json_does_not_have_a_0_field:t(6100,e.DiagnosticCategory.Message,"package_json_does_not_have_a_0_field_6100","'package.json' does not have a '{0}' field."),package_json_has_0_field_1_that_references_2:t(6101,e.DiagnosticCategory.Message,"package_json_has_0_field_1_that_references_2_6101","'package.json' has '{0}' field '{1}' that references '{2}'."),Allow_javascript_files_to_be_compiled:t(6102,e.DiagnosticCategory.Message,"Allow_javascript_files_to_be_compiled_6102","Allow javascript files to be compiled."),Option_0_should_have_array_of_strings_as_a_value:t(6103,e.DiagnosticCategory.Error,"Option_0_should_have_array_of_strings_as_a_value_6103","Option '{0}' should have array of strings as a value."),Checking_if_0_is_the_longest_matching_prefix_for_1_2:t(6104,e.DiagnosticCategory.Message,"Checking_if_0_is_the_longest_matching_prefix_for_1_2_6104","Checking if '{0}' is the longest matching prefix for '{1}' - '{2}'."),Expected_type_of_0_field_in_package_json_to_be_string_got_1:t(6105,e.DiagnosticCategory.Message,"Expected_type_of_0_field_in_package_json_to_be_string_got_1_6105","Expected type of '{0}' field in 'package.json' to be 'string', got '{1}'."),baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1:t(6106,e.DiagnosticCategory.Message,"baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1_6106","'baseUrl' option is set to '{0}', using this value to resolve non-relative module name '{1}'."),rootDirs_option_is_set_using_it_to_resolve_relative_module_name_0:t(6107,e.DiagnosticCategory.Message,"rootDirs_option_is_set_using_it_to_resolve_relative_module_name_0_6107","'rootDirs' option is set, using it to resolve relative module name '{0}'."),Longest_matching_prefix_for_0_is_1:t(6108,e.DiagnosticCategory.Message,"Longest_matching_prefix_for_0_is_1_6108","Longest matching prefix for '{0}' is '{1}'."),Loading_0_from_the_root_dir_1_candidate_location_2:t(6109,e.DiagnosticCategory.Message,"Loading_0_from_the_root_dir_1_candidate_location_2_6109","Loading '{0}' from the root dir '{1}', candidate location '{2}'."),Trying_other_entries_in_rootDirs:t(6110,e.DiagnosticCategory.Message,"Trying_other_entries_in_rootDirs_6110","Trying other entries in 'rootDirs'."),Module_resolution_using_rootDirs_has_failed:t(6111,e.DiagnosticCategory.Message,"Module_resolution_using_rootDirs_has_failed_6111","Module resolution using 'rootDirs' has failed."),Do_not_emit_use_strict_directives_in_module_output:t(6112,e.DiagnosticCategory.Message,"Do_not_emit_use_strict_directives_in_module_output_6112","Do not emit 'use strict' directives in module output."),Enable_strict_null_checks:t(6113,e.DiagnosticCategory.Message,"Enable_strict_null_checks_6113","Enable strict null checks."),Unknown_option_excludes_Did_you_mean_exclude:t(6114,e.DiagnosticCategory.Error,"Unknown_option_excludes_Did_you_mean_exclude_6114","Unknown option 'excludes'. Did you mean 'exclude'?"),Raise_error_on_this_expressions_with_an_implied_any_type:t(6115,e.DiagnosticCategory.Message,"Raise_error_on_this_expressions_with_an_implied_any_type_6115","Raise error on 'this' expressions with an implied 'any' type."),Resolving_type_reference_directive_0_containing_file_1_root_directory_2:t(6116,e.DiagnosticCategory.Message,"Resolving_type_reference_directive_0_containing_file_1_root_directory_2_6116","======== Resolving type reference directive '{0}', containing file '{1}', root directory '{2}'. ========"),Resolving_using_primary_search_paths:t(6117,e.DiagnosticCategory.Message,"Resolving_using_primary_search_paths_6117","Resolving using primary search paths..."),Resolving_from_node_modules_folder:t(6118,e.DiagnosticCategory.Message,"Resolving_from_node_modules_folder_6118","Resolving from node_modules folder..."),Type_reference_directive_0_was_successfully_resolved_to_1_primary_Colon_2:t(6119,e.DiagnosticCategory.Message,"Type_reference_directive_0_was_successfully_resolved_to_1_primary_Colon_2_6119","======== Type reference directive '{0}' was successfully resolved to '{1}', primary: {2}. ========"),Type_reference_directive_0_was_not_resolved:t(6120,e.DiagnosticCategory.Message,"Type_reference_directive_0_was_not_resolved_6120","======== Type reference directive '{0}' was not resolved. ========"),Resolving_with_primary_search_path_0:t(6121,e.DiagnosticCategory.Message,"Resolving_with_primary_search_path_0_6121","Resolving with primary search path '{0}'."),Root_directory_cannot_be_determined_skipping_primary_search_paths:t(6122,e.DiagnosticCategory.Message,"Root_directory_cannot_be_determined_skipping_primary_search_paths_6122","Root directory cannot be determined, skipping primary search paths."),Resolving_type_reference_directive_0_containing_file_1_root_directory_not_set:t(6123,e.DiagnosticCategory.Message,"Resolving_type_reference_directive_0_containing_file_1_root_directory_not_set_6123","======== Resolving type reference directive '{0}', containing file '{1}', root directory not set. ========"),Type_declaration_files_to_be_included_in_compilation:t(6124,e.DiagnosticCategory.Message,"Type_declaration_files_to_be_included_in_compilation_6124","Type declaration files to be included in compilation."),Looking_up_in_node_modules_folder_initial_location_0:t(6125,e.DiagnosticCategory.Message,"Looking_up_in_node_modules_folder_initial_location_0_6125","Looking up in 'node_modules' folder, initial location '{0}'."),Containing_file_is_not_specified_and_root_directory_cannot_be_determined_skipping_lookup_in_node_modules_folder:t(6126,e.DiagnosticCategory.Message,"Containing_file_is_not_specified_and_root_directory_cannot_be_determined_skipping_lookup_in_node_mod_6126","Containing file is not specified and root directory cannot be determined, skipping lookup in 'node_modules' folder."),Resolving_type_reference_directive_0_containing_file_not_set_root_directory_1:t(6127,e.DiagnosticCategory.Message,"Resolving_type_reference_directive_0_containing_file_not_set_root_directory_1_6127","======== Resolving type reference directive '{0}', containing file not set, root directory '{1}'. ========"),Resolving_type_reference_directive_0_containing_file_not_set_root_directory_not_set:t(6128,e.DiagnosticCategory.Message,"Resolving_type_reference_directive_0_containing_file_not_set_root_directory_not_set_6128","======== Resolving type reference directive '{0}', containing file not set, root directory not set. ========"),Resolving_real_path_for_0_result_1:t(6130,e.DiagnosticCategory.Message,"Resolving_real_path_for_0_result_1_6130","Resolving real path for '{0}', result '{1}'."),Cannot_compile_modules_using_option_0_unless_the_module_flag_is_amd_or_system:t(6131,e.DiagnosticCategory.Error,"Cannot_compile_modules_using_option_0_unless_the_module_flag_is_amd_or_system_6131","Cannot compile modules using option '{0}' unless the '--module' flag is 'amd' or 'system'."),File_name_0_has_a_1_extension_stripping_it:t(6132,e.DiagnosticCategory.Message,"File_name_0_has_a_1_extension_stripping_it_6132","File name '{0}' has a '{1}' extension - stripping it."),_0_is_declared_but_its_value_is_never_read:t(6133,e.DiagnosticCategory.Error,"_0_is_declared_but_its_value_is_never_read_6133","'{0}' is declared but its value is never read."),Report_errors_on_unused_locals:t(6134,e.DiagnosticCategory.Message,"Report_errors_on_unused_locals_6134","Report errors on unused locals."),Report_errors_on_unused_parameters:t(6135,e.DiagnosticCategory.Message,"Report_errors_on_unused_parameters_6135","Report errors on unused parameters."),The_maximum_dependency_depth_to_search_under_node_modules_and_load_JavaScript_files:t(6136,e.DiagnosticCategory.Message,"The_maximum_dependency_depth_to_search_under_node_modules_and_load_JavaScript_files_6136","The maximum dependency depth to search under node_modules and load JavaScript files."),Cannot_import_type_declaration_files_Consider_importing_0_instead_of_1:t(6137,e.DiagnosticCategory.Error,"Cannot_import_type_declaration_files_Consider_importing_0_instead_of_1_6137","Cannot import type declaration files. Consider importing '{0}' instead of '{1}'."),Property_0_is_declared_but_its_value_is_never_read:t(6138,e.DiagnosticCategory.Error,"Property_0_is_declared_but_its_value_is_never_read_6138","Property '{0}' is declared but its value is never read."),Import_emit_helpers_from_tslib:t(6139,e.DiagnosticCategory.Message,"Import_emit_helpers_from_tslib_6139","Import emit helpers from 'tslib'."),Auto_discovery_for_typings_is_enabled_in_project_0_Running_extra_resolution_pass_for_module_1_using_cache_location_2:t(6140,e.DiagnosticCategory.Error,"Auto_discovery_for_typings_is_enabled_in_project_0_Running_extra_resolution_pass_for_module_1_using__6140","Auto discovery for typings is enabled in project '{0}'. Running extra resolution pass for module '{1}' using cache location '{2}'."),Parse_in_strict_mode_and_emit_use_strict_for_each_source_file:t(6141,e.DiagnosticCategory.Message,"Parse_in_strict_mode_and_emit_use_strict_for_each_source_file_6141",'Parse in strict mode and emit "use strict" for each source file.'),Module_0_was_resolved_to_1_but_jsx_is_not_set:t(6142,e.DiagnosticCategory.Error,"Module_0_was_resolved_to_1_but_jsx_is_not_set_6142","Module '{0}' was resolved to '{1}', but '--jsx' is not set."),Module_0_was_resolved_as_locally_declared_ambient_module_in_file_1:t(6144,e.DiagnosticCategory.Message,"Module_0_was_resolved_as_locally_declared_ambient_module_in_file_1_6144","Module '{0}' was resolved as locally declared ambient module in file '{1}'."),Module_0_was_resolved_as_ambient_module_declared_in_1_since_this_file_was_not_modified:t(6145,e.DiagnosticCategory.Message,"Module_0_was_resolved_as_ambient_module_declared_in_1_since_this_file_was_not_modified_6145","Module '{0}' was resolved as ambient module declared in '{1}' since this file was not modified."),Specify_the_JSX_factory_function_to_use_when_targeting_react_JSX_emit_e_g_React_createElement_or_h:t(6146,e.DiagnosticCategory.Message,"Specify_the_JSX_factory_function_to_use_when_targeting_react_JSX_emit_e_g_React_createElement_or_h_6146","Specify the JSX factory function to use when targeting 'react' JSX emit, e.g. 'React.createElement' or 'h'."),Resolution_for_module_0_was_found_in_cache:t(6147,e.DiagnosticCategory.Message,"Resolution_for_module_0_was_found_in_cache_6147","Resolution for module '{0}' was found in cache."),Directory_0_does_not_exist_skipping_all_lookups_in_it:t(6148,e.DiagnosticCategory.Message,"Directory_0_does_not_exist_skipping_all_lookups_in_it_6148","Directory '{0}' does not exist, skipping all lookups in it."),Show_diagnostic_information:t(6149,e.DiagnosticCategory.Message,"Show_diagnostic_information_6149","Show diagnostic information."),Show_verbose_diagnostic_information:t(6150,e.DiagnosticCategory.Message,"Show_verbose_diagnostic_information_6150","Show verbose diagnostic information."),Emit_a_single_file_with_source_maps_instead_of_having_a_separate_file:t(6151,e.DiagnosticCategory.Message,"Emit_a_single_file_with_source_maps_instead_of_having_a_separate_file_6151","Emit a single file with source maps instead of having a separate file."),Emit_the_source_alongside_the_sourcemaps_within_a_single_file_requires_inlineSourceMap_or_sourceMap_to_be_set:t(6152,e.DiagnosticCategory.Message,"Emit_the_source_alongside_the_sourcemaps_within_a_single_file_requires_inlineSourceMap_or_sourceMap__6152","Emit the source alongside the sourcemaps within a single file; requires '--inlineSourceMap' or '--sourceMap' to be set."),Transpile_each_file_as_a_separate_module_similar_to_ts_transpileModule:t(6153,e.DiagnosticCategory.Message,"Transpile_each_file_as_a_separate_module_similar_to_ts_transpileModule_6153","Transpile each file as a separate module (similar to 'ts.transpileModule')."),Print_names_of_generated_files_part_of_the_compilation:t(6154,e.DiagnosticCategory.Message,"Print_names_of_generated_files_part_of_the_compilation_6154","Print names of generated files part of the compilation."),Print_names_of_files_part_of_the_compilation:t(6155,e.DiagnosticCategory.Message,"Print_names_of_files_part_of_the_compilation_6155","Print names of files part of the compilation."),The_locale_used_when_displaying_messages_to_the_user_e_g_en_us:t(6156,e.DiagnosticCategory.Message,"The_locale_used_when_displaying_messages_to_the_user_e_g_en_us_6156","The locale used when displaying messages to the user (e.g. 'en-us')"),Do_not_generate_custom_helper_functions_like_extends_in_compiled_output:t(6157,e.DiagnosticCategory.Message,"Do_not_generate_custom_helper_functions_like_extends_in_compiled_output_6157","Do not generate custom helper functions like '__extends' in compiled output."),Do_not_include_the_default_library_file_lib_d_ts:t(6158,e.DiagnosticCategory.Message,"Do_not_include_the_default_library_file_lib_d_ts_6158","Do not include the default library file (lib.d.ts)."),Do_not_add_triple_slash_references_or_imported_modules_to_the_list_of_compiled_files:t(6159,e.DiagnosticCategory.Message,"Do_not_add_triple_slash_references_or_imported_modules_to_the_list_of_compiled_files_6159","Do not add triple-slash references or imported modules to the list of compiled files."),Deprecated_Use_skipLibCheck_instead_Skip_type_checking_of_default_library_declaration_files:t(6160,e.DiagnosticCategory.Message,"Deprecated_Use_skipLibCheck_instead_Skip_type_checking_of_default_library_declaration_files_6160","[Deprecated] Use '--skipLibCheck' instead. Skip type checking of default library declaration files."),List_of_folders_to_include_type_definitions_from:t(6161,e.DiagnosticCategory.Message,"List_of_folders_to_include_type_definitions_from_6161","List of folders to include type definitions from."),Disable_size_limitations_on_JavaScript_projects:t(6162,e.DiagnosticCategory.Message,"Disable_size_limitations_on_JavaScript_projects_6162","Disable size limitations on JavaScript projects."),The_character_set_of_the_input_files:t(6163,e.DiagnosticCategory.Message,"The_character_set_of_the_input_files_6163","The character set of the input files."),Emit_a_UTF_8_Byte_Order_Mark_BOM_in_the_beginning_of_output_files:t(6164,e.DiagnosticCategory.Message,"Emit_a_UTF_8_Byte_Order_Mark_BOM_in_the_beginning_of_output_files_6164","Emit a UTF-8 Byte Order Mark (BOM) in the beginning of output files."),Do_not_truncate_error_messages:t(6165,e.DiagnosticCategory.Message,"Do_not_truncate_error_messages_6165","Do not truncate error messages."),Output_directory_for_generated_declaration_files:t(6166,e.DiagnosticCategory.Message,"Output_directory_for_generated_declaration_files_6166","Output directory for generated declaration files."),A_series_of_entries_which_re_map_imports_to_lookup_locations_relative_to_the_baseUrl:t(6167,e.DiagnosticCategory.Message,"A_series_of_entries_which_re_map_imports_to_lookup_locations_relative_to_the_baseUrl_6167","A series of entries which re-map imports to lookup locations relative to the 'baseUrl'."),List_of_root_folders_whose_combined_content_represents_the_structure_of_the_project_at_runtime:t(6168,e.DiagnosticCategory.Message,"List_of_root_folders_whose_combined_content_represents_the_structure_of_the_project_at_runtime_6168","List of root folders whose combined content represents the structure of the project at runtime."),Show_all_compiler_options:t(6169,e.DiagnosticCategory.Message,"Show_all_compiler_options_6169","Show all compiler options."),Deprecated_Use_outFile_instead_Concatenate_and_emit_output_to_single_file:t(6170,e.DiagnosticCategory.Message,"Deprecated_Use_outFile_instead_Concatenate_and_emit_output_to_single_file_6170","[Deprecated] Use '--outFile' instead. Concatenate and emit output to single file"),Command_line_Options:t(6171,e.DiagnosticCategory.Message,"Command_line_Options_6171","Command-line Options"),Basic_Options:t(6172,e.DiagnosticCategory.Message,"Basic_Options_6172","Basic Options"),Strict_Type_Checking_Options:t(6173,e.DiagnosticCategory.Message,"Strict_Type_Checking_Options_6173","Strict Type-Checking Options"),Module_Resolution_Options:t(6174,e.DiagnosticCategory.Message,"Module_Resolution_Options_6174","Module Resolution Options"),Source_Map_Options:t(6175,e.DiagnosticCategory.Message,"Source_Map_Options_6175","Source Map Options"),Additional_Checks:t(6176,e.DiagnosticCategory.Message,"Additional_Checks_6176","Additional Checks"),Experimental_Options:t(6177,e.DiagnosticCategory.Message,"Experimental_Options_6177","Experimental Options"),Advanced_Options:t(6178,e.DiagnosticCategory.Message,"Advanced_Options_6178","Advanced Options"),Provide_full_support_for_iterables_in_for_of_spread_and_destructuring_when_targeting_ES5_or_ES3:t(6179,e.DiagnosticCategory.Message,"Provide_full_support_for_iterables_in_for_of_spread_and_destructuring_when_targeting_ES5_or_ES3_6179","Provide full support for iterables in 'for-of', spread, and destructuring when targeting 'ES5' or 'ES3'."),Enable_all_strict_type_checking_options:t(6180,e.DiagnosticCategory.Message,"Enable_all_strict_type_checking_options_6180","Enable all strict type-checking options."),List_of_language_service_plugins:t(6181,e.DiagnosticCategory.Message,"List_of_language_service_plugins_6181","List of language service plugins."),Scoped_package_detected_looking_in_0:t(6182,e.DiagnosticCategory.Message,"Scoped_package_detected_looking_in_0_6182","Scoped package detected, looking in '{0}'"),Reusing_resolution_of_module_0_to_file_1_from_old_program:t(6183,e.DiagnosticCategory.Message,"Reusing_resolution_of_module_0_to_file_1_from_old_program_6183","Reusing resolution of module '{0}' to file '{1}' from old program."),Reusing_module_resolutions_originating_in_0_since_resolutions_are_unchanged_from_old_program:t(6184,e.DiagnosticCategory.Message,"Reusing_module_resolutions_originating_in_0_since_resolutions_are_unchanged_from_old_program_6184","Reusing module resolutions originating in '{0}' since resolutions are unchanged from old program."),Disable_strict_checking_of_generic_signatures_in_function_types:t(6185,e.DiagnosticCategory.Message,"Disable_strict_checking_of_generic_signatures_in_function_types_6185","Disable strict checking of generic signatures in function types."),Enable_strict_checking_of_function_types:t(6186,e.DiagnosticCategory.Message,"Enable_strict_checking_of_function_types_6186","Enable strict checking of function types."),Variable_0_implicitly_has_an_1_type:t(7005,e.DiagnosticCategory.Error,"Variable_0_implicitly_has_an_1_type_7005","Variable '{0}' implicitly has an '{1}' type."),Parameter_0_implicitly_has_an_1_type:t(7006,e.DiagnosticCategory.Error,"Parameter_0_implicitly_has_an_1_type_7006","Parameter '{0}' implicitly has an '{1}' type."),Member_0_implicitly_has_an_1_type:t(7008,e.DiagnosticCategory.Error,"Member_0_implicitly_has_an_1_type_7008","Member '{0}' implicitly has an '{1}' type."),new_expression_whose_target_lacks_a_construct_signature_implicitly_has_an_any_type:t(7009,e.DiagnosticCategory.Error,"new_expression_whose_target_lacks_a_construct_signature_implicitly_has_an_any_type_7009","'new' expression, whose target lacks a construct signature, implicitly has an 'any' type."),_0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type:t(7010,e.DiagnosticCategory.Error,"_0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type_7010","'{0}', which lacks return-type annotation, implicitly has an '{1}' return type."),Function_expression_which_lacks_return_type_annotation_implicitly_has_an_0_return_type:t(7011,e.DiagnosticCategory.Error,"Function_expression_which_lacks_return_type_annotation_implicitly_has_an_0_return_type_7011","Function expression, which lacks return-type annotation, implicitly has an '{0}' return type."),Construct_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type:t(7013,e.DiagnosticCategory.Error,"Construct_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type_7013","Construct signature, which lacks return-type annotation, implicitly has an 'any' return type."),Element_implicitly_has_an_any_type_because_index_expression_is_not_of_type_number:t(7015,e.DiagnosticCategory.Error,"Element_implicitly_has_an_any_type_because_index_expression_is_not_of_type_number_7015","Element implicitly has an 'any' type because index expression is not of type 'number'."),Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type:t(7016,e.DiagnosticCategory.Error,"Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type_7016","Could not find a declaration file for module '{0}'. '{1}' implicitly has an 'any' type."),Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature:t(7017,e.DiagnosticCategory.Error,"Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature_7017","Element implicitly has an 'any' type because type '{0}' has no index signature."),Object_literal_s_property_0_implicitly_has_an_1_type:t(7018,e.DiagnosticCategory.Error,"Object_literal_s_property_0_implicitly_has_an_1_type_7018","Object literal's property '{0}' implicitly has an '{1}' type."),Rest_parameter_0_implicitly_has_an_any_type:t(7019,e.DiagnosticCategory.Error,"Rest_parameter_0_implicitly_has_an_any_type_7019","Rest parameter '{0}' implicitly has an 'any[]' type."),Call_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type:t(7020,e.DiagnosticCategory.Error,"Call_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type_7020","Call signature, which lacks return-type annotation, implicitly has an 'any' return type."),_0_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_and_is_referenced_directly_or_indirectly_in_its_own_initializer:t(7022,e.DiagnosticCategory.Error,"_0_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_and_is_referenced_directly_or__7022","'{0}' implicitly has type 'any' because it does not have a type annotation and is referenced directly or indirectly in its own initializer."),_0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions:t(7023,e.DiagnosticCategory.Error,"_0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_reference_7023","'{0}' implicitly has return type 'any' because it does not have a return type annotation and is referenced directly or indirectly in one of its return expressions."),Function_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions:t(7024,e.DiagnosticCategory.Error,"Function_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_ref_7024","Function implicitly has return type 'any' because it does not have a return type annotation and is referenced directly or indirectly in one of its return expressions."),Generator_implicitly_has_type_0_because_it_does_not_yield_any_values_Consider_supplying_a_return_type:t(7025,e.DiagnosticCategory.Error,"Generator_implicitly_has_type_0_because_it_does_not_yield_any_values_Consider_supplying_a_return_typ_7025","Generator implicitly has type '{0}' because it does not yield any values. Consider supplying a return type."),JSX_element_implicitly_has_type_any_because_no_interface_JSX_0_exists:t(7026,e.DiagnosticCategory.Error,"JSX_element_implicitly_has_type_any_because_no_interface_JSX_0_exists_7026","JSX element implicitly has type 'any' because no interface 'JSX.{0}' exists."),Unreachable_code_detected:t(7027,e.DiagnosticCategory.Error,"Unreachable_code_detected_7027","Unreachable code detected."),Unused_label:t(7028,e.DiagnosticCategory.Error,"Unused_label_7028","Unused label."),Fallthrough_case_in_switch:t(7029,e.DiagnosticCategory.Error,"Fallthrough_case_in_switch_7029","Fallthrough case in switch."),Not_all_code_paths_return_a_value:t(7030,e.DiagnosticCategory.Error,"Not_all_code_paths_return_a_value_7030","Not all code paths return a value."),Binding_element_0_implicitly_has_an_1_type:t(7031,e.DiagnosticCategory.Error,"Binding_element_0_implicitly_has_an_1_type_7031","Binding element '{0}' implicitly has an '{1}' type."),Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation:t(7032,e.DiagnosticCategory.Error,"Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation_7032","Property '{0}' implicitly has type 'any', because its set accessor lacks a parameter type annotation."),Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation:t(7033,e.DiagnosticCategory.Error,"Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation_7033","Property '{0}' implicitly has type 'any', because its get accessor lacks a return type annotation."),Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined:t(7034,e.DiagnosticCategory.Error,"Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined_7034","Variable '{0}' implicitly has type '{1}' in some locations where its type cannot be determined."),Try_npm_install_types_Slash_0_if_it_exists_or_add_a_new_declaration_d_ts_file_containing_declare_module_0:t(7035,e.DiagnosticCategory.Error,"Try_npm_install_types_Slash_0_if_it_exists_or_add_a_new_declaration_d_ts_file_containing_declare_mod_7035","Try `npm install @types/{0}` if it exists or add a new declaration (.d.ts) file containing `declare module '{0}';`"),Dynamic_import_s_specifier_must_be_of_type_string_but_here_has_type_0:t(7036,e.DiagnosticCategory.Error,"Dynamic_import_s_specifier_must_be_of_type_string_but_here_has_type_0_7036","Dynamic import's specifier must be of type 'string', but here has type '{0}'."),You_cannot_rename_this_element:t(8e3,e.DiagnosticCategory.Error,"You_cannot_rename_this_element_8000","You cannot rename this element."),You_cannot_rename_elements_that_are_defined_in_the_standard_TypeScript_library:t(8001,e.DiagnosticCategory.Error,"You_cannot_rename_elements_that_are_defined_in_the_standard_TypeScript_library_8001","You cannot rename elements that are defined in the standard TypeScript library."),import_can_only_be_used_in_a_ts_file:t(8002,e.DiagnosticCategory.Error,"import_can_only_be_used_in_a_ts_file_8002","'import ... =' can only be used in a .ts file."),export_can_only_be_used_in_a_ts_file:t(8003,e.DiagnosticCategory.Error,"export_can_only_be_used_in_a_ts_file_8003","'export=' can only be used in a .ts file."),type_parameter_declarations_can_only_be_used_in_a_ts_file:t(8004,e.DiagnosticCategory.Error,"type_parameter_declarations_can_only_be_used_in_a_ts_file_8004","'type parameter declarations' can only be used in a .ts file."),implements_clauses_can_only_be_used_in_a_ts_file:t(8005,e.DiagnosticCategory.Error,"implements_clauses_can_only_be_used_in_a_ts_file_8005","'implements clauses' can only be used in a .ts file."),interface_declarations_can_only_be_used_in_a_ts_file:t(8006,e.DiagnosticCategory.Error,"interface_declarations_can_only_be_used_in_a_ts_file_8006","'interface declarations' can only be used in a .ts file."),module_declarations_can_only_be_used_in_a_ts_file:t(8007,e.DiagnosticCategory.Error,"module_declarations_can_only_be_used_in_a_ts_file_8007","'module declarations' can only be used in a .ts file."),type_aliases_can_only_be_used_in_a_ts_file:t(8008,e.DiagnosticCategory.Error,"type_aliases_can_only_be_used_in_a_ts_file_8008","'type aliases' can only be used in a .ts file."),_0_can_only_be_used_in_a_ts_file:t(8009,e.DiagnosticCategory.Error,"_0_can_only_be_used_in_a_ts_file_8009","'{0}' can only be used in a .ts file."),types_can_only_be_used_in_a_ts_file:t(8010,e.DiagnosticCategory.Error,"types_can_only_be_used_in_a_ts_file_8010","'types' can only be used in a .ts file."),type_arguments_can_only_be_used_in_a_ts_file:t(8011,e.DiagnosticCategory.Error,"type_arguments_can_only_be_used_in_a_ts_file_8011","'type arguments' can only be used in a .ts file."),parameter_modifiers_can_only_be_used_in_a_ts_file:t(8012,e.DiagnosticCategory.Error,"parameter_modifiers_can_only_be_used_in_a_ts_file_8012","'parameter modifiers' can only be used in a .ts file."),non_null_assertions_can_only_be_used_in_a_ts_file:t(8013,e.DiagnosticCategory.Error,"non_null_assertions_can_only_be_used_in_a_ts_file_8013","'non-null assertions' can only be used in a .ts file."),enum_declarations_can_only_be_used_in_a_ts_file:t(8015,e.DiagnosticCategory.Error,"enum_declarations_can_only_be_used_in_a_ts_file_8015","'enum declarations' can only be used in a .ts file."),type_assertion_expressions_can_only_be_used_in_a_ts_file:t(8016,e.DiagnosticCategory.Error,"type_assertion_expressions_can_only_be_used_in_a_ts_file_8016","'type assertion expressions' can only be used in a .ts file."),Octal_literal_types_must_use_ES2015_syntax_Use_the_syntax_0:t(8017,e.DiagnosticCategory.Error,"Octal_literal_types_must_use_ES2015_syntax_Use_the_syntax_0_8017","Octal literal types must use ES2015 syntax. Use the syntax '{0}'."),Octal_literals_are_not_allowed_in_enums_members_initializer_Use_the_syntax_0:t(8018,e.DiagnosticCategory.Error,"Octal_literals_are_not_allowed_in_enums_members_initializer_Use_the_syntax_0_8018","Octal literals are not allowed in enums members initializer. Use the syntax '{0}'."),Report_errors_in_js_files:t(8019,e.DiagnosticCategory.Message,"Report_errors_in_js_files_8019","Report errors in .js files."),JSDoc_types_can_only_be_used_inside_documentation_comments:t(8020,e.DiagnosticCategory.Error,"JSDoc_types_can_only_be_used_inside_documentation_comments_8020","JSDoc types can only be used inside documentation comments."),JSDoc_typedef_tag_should_either_have_a_type_annotation_or_be_followed_by_property_or_member_tags:t(8021,e.DiagnosticCategory.Error,"JSDoc_typedef_tag_should_either_have_a_type_annotation_or_be_followed_by_property_or_member_tags_8021","JSDoc '@typedef' tag should either have a type annotation or be followed by '@property' or '@member' tags."),JSDoc_0_is_not_attached_to_a_class:t(8022,e.DiagnosticCategory.Error,"JSDoc_0_is_not_attached_to_a_class_8022","JSDoc '@{0}' is not attached to a class."),JSDoc_0_1_does_not_match_the_extends_2_clause:t(8023,e.DiagnosticCategory.Error,"JSDoc_0_1_does_not_match_the_extends_2_clause_8023","JSDoc '@{0} {1}' does not match the 'extends {2}' clause."),JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name:t(8024,e.DiagnosticCategory.Error,"JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name_8024","JSDoc '@param' tag has name '{0}', but there is no parameter with that name."),Class_declarations_cannot_have_more_than_one_augments_or_extends_tag:t(8025,e.DiagnosticCategory.Error,"Class_declarations_cannot_have_more_than_one_augments_or_extends_tag_8025","Class declarations cannot have more than one `@augments` or `@extends` tag."),Only_identifiers_Slashqualified_names_with_optional_type_arguments_are_currently_supported_in_a_class_extends_clause:t(9002,e.DiagnosticCategory.Error,"Only_identifiers_Slashqualified_names_with_optional_type_arguments_are_currently_supported_in_a_clas_9002","Only identifiers/qualified-names with optional type arguments are currently supported in a class 'extends' clause."),class_expressions_are_not_currently_supported:t(9003,e.DiagnosticCategory.Error,"class_expressions_are_not_currently_supported_9003","'class' expressions are not currently supported."),Language_service_is_disabled:t(9004,e.DiagnosticCategory.Error,"Language_service_is_disabled_9004","Language service is disabled."),JSX_attributes_must_only_be_assigned_a_non_empty_expression:t(17e3,e.DiagnosticCategory.Error,"JSX_attributes_must_only_be_assigned_a_non_empty_expression_17000","JSX attributes must only be assigned a non-empty 'expression'."),JSX_elements_cannot_have_multiple_attributes_with_the_same_name:t(17001,e.DiagnosticCategory.Error,"JSX_elements_cannot_have_multiple_attributes_with_the_same_name_17001","JSX elements cannot have multiple attributes with the same name."),Expected_corresponding_JSX_closing_tag_for_0:t(17002,e.DiagnosticCategory.Error,"Expected_corresponding_JSX_closing_tag_for_0_17002","Expected corresponding JSX closing tag for '{0}'."),JSX_attribute_expected:t(17003,e.DiagnosticCategory.Error,"JSX_attribute_expected_17003","JSX attribute expected."),Cannot_use_JSX_unless_the_jsx_flag_is_provided:t(17004,e.DiagnosticCategory.Error,"Cannot_use_JSX_unless_the_jsx_flag_is_provided_17004","Cannot use JSX unless the '--jsx' flag is provided."),A_constructor_cannot_contain_a_super_call_when_its_class_extends_null:t(17005,e.DiagnosticCategory.Error,"A_constructor_cannot_contain_a_super_call_when_its_class_extends_null_17005","A constructor cannot contain a 'super' call when its class extends 'null'."),An_unary_expression_with_the_0_operator_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses:t(17006,e.DiagnosticCategory.Error,"An_unary_expression_with_the_0_operator_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_ex_17006","An unary expression with the '{0}' operator is not allowed in the left-hand side of an exponentiation expression. Consider enclosing the expression in parentheses."),A_type_assertion_expression_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses:t(17007,e.DiagnosticCategory.Error,"A_type_assertion_expression_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Con_17007","A type assertion expression is not allowed in the left-hand side of an exponentiation expression. Consider enclosing the expression in parentheses."),JSX_element_0_has_no_corresponding_closing_tag:t(17008,e.DiagnosticCategory.Error,"JSX_element_0_has_no_corresponding_closing_tag_17008","JSX element '{0}' has no corresponding closing tag."),super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class:t(17009,e.DiagnosticCategory.Error,"super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class_17009","'super' must be called before accessing 'this' in the constructor of a derived class."),Unknown_type_acquisition_option_0:t(17010,e.DiagnosticCategory.Error,"Unknown_type_acquisition_option_0_17010","Unknown type acquisition option '{0}'."),super_must_be_called_before_accessing_a_property_of_super_in_the_constructor_of_a_derived_class:t(17011,e.DiagnosticCategory.Error,"super_must_be_called_before_accessing_a_property_of_super_in_the_constructor_of_a_derived_class_17011","'super' must be called before accessing a property of 'super' in the constructor of a derived class."),_0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2:t(17012,e.DiagnosticCategory.Error,"_0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2_17012","'{0}' is not a valid meta-property for keyword '{1}'. Did you mean '{2}'?"),Meta_property_0_is_only_allowed_in_the_body_of_a_function_declaration_function_expression_or_constructor:t(17013,e.DiagnosticCategory.Error,"Meta_property_0_is_only_allowed_in_the_body_of_a_function_declaration_function_expression_or_constru_17013","Meta-property '{0}' is only allowed in the body of a function declaration, function expression, or constructor."),Circularity_detected_while_resolving_configuration_Colon_0:t(18e3,e.DiagnosticCategory.Error,"Circularity_detected_while_resolving_configuration_Colon_0_18000","Circularity detected while resolving configuration: {0}"),A_path_in_an_extends_option_must_be_relative_or_rooted_but_0_is_not:t(18001,e.DiagnosticCategory.Error,"A_path_in_an_extends_option_must_be_relative_or_rooted_but_0_is_not_18001","A path in an 'extends' option must be relative or rooted, but '{0}' is not."),The_files_list_in_config_file_0_is_empty:t(18002,e.DiagnosticCategory.Error,"The_files_list_in_config_file_0_is_empty_18002","The 'files' list in config file '{0}' is empty."),No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2:t(18003,e.DiagnosticCategory.Error,"No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2_18003","No inputs were found in config file '{0}'. Specified 'include' paths were '{1}' and 'exclude' paths were '{2}'."),Add_missing_super_call:t(90001,e.DiagnosticCategory.Message,"Add_missing_super_call_90001","Add missing 'super()' call."),Make_super_call_the_first_statement_in_the_constructor:t(90002,e.DiagnosticCategory.Message,"Make_super_call_the_first_statement_in_the_constructor_90002","Make 'super()' call the first statement in the constructor."),Change_extends_to_implements:t(90003,e.DiagnosticCategory.Message,"Change_extends_to_implements_90003","Change 'extends' to 'implements'."),Remove_declaration_for_Colon_0:t(90004,e.DiagnosticCategory.Message,"Remove_declaration_for_Colon_0_90004","Remove declaration for: '{0}'."),Implement_interface_0:t(90006,e.DiagnosticCategory.Message,"Implement_interface_0_90006","Implement interface '{0}'."),Implement_inherited_abstract_class:t(90007,e.DiagnosticCategory.Message,"Implement_inherited_abstract_class_90007","Implement inherited abstract class."),Add_this_to_unresolved_variable:t(90008,e.DiagnosticCategory.Message,"Add_this_to_unresolved_variable_90008","Add 'this.' to unresolved variable."),Adding_a_tsconfig_json_file_will_help_organize_projects_that_contain_both_TypeScript_and_JavaScript_files_Learn_more_at_https_Colon_Slash_Slashaka_ms_Slashtsconfig:t(90009,e.DiagnosticCategory.Error,"Adding_a_tsconfig_json_file_will_help_organize_projects_that_contain_both_TypeScript_and_JavaScript__90009","Adding a tsconfig.json file will help organize projects that contain both TypeScript and JavaScript files. Learn more at https://aka.ms/tsconfig."),Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated:t(90010,e.DiagnosticCategory.Error,"Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated_90010","Type '{0}' is not assignable to type '{1}'. Two different types with this name exist, but they are unrelated."),Import_0_from_1:t(90013,e.DiagnosticCategory.Message,"Import_0_from_1_90013","Import '{0}' from \"{1}\"."),Change_0_to_1:t(90014,e.DiagnosticCategory.Message,"Change_0_to_1_90014","Change '{0}' to '{1}'."),Add_0_to_existing_import_declaration_from_1:t(90015,e.DiagnosticCategory.Message,"Add_0_to_existing_import_declaration_from_1_90015","Add '{0}' to existing import declaration from \"{1}\"."),Declare_property_0:t(90016,e.DiagnosticCategory.Message,"Declare_property_0_90016","Declare property '{0}'."),Add_index_signature_for_property_0:t(90017,e.DiagnosticCategory.Message,"Add_index_signature_for_property_0_90017","Add index signature for property '{0}'."),Disable_checking_for_this_file:t(90018,e.DiagnosticCategory.Message,"Disable_checking_for_this_file_90018","Disable checking for this file."),Ignore_this_error_message:t(90019,e.DiagnosticCategory.Message,"Ignore_this_error_message_90019","Ignore this error message."),Initialize_property_0_in_the_constructor:t(90020,e.DiagnosticCategory.Message,"Initialize_property_0_in_the_constructor_90020","Initialize property '{0}' in the constructor."),Initialize_static_property_0:t(90021,e.DiagnosticCategory.Message,"Initialize_static_property_0_90021","Initialize static property '{0}'."),Change_spelling_to_0:t(90022,e.DiagnosticCategory.Message,"Change_spelling_to_0_90022","Change spelling to '{0}'."),Declare_method_0:t(90023,e.DiagnosticCategory.Message,"Declare_method_0_90023","Declare method '{0}'."),Declare_static_method_0:t(90024,e.DiagnosticCategory.Message,"Declare_static_method_0_90024","Declare static method '{0}'."),Prefix_0_with_an_underscore:t(90025,e.DiagnosticCategory.Message,"Prefix_0_with_an_underscore_90025","Prefix '{0}' with an underscore."),Rewrite_as_the_indexed_access_type_0:t(90026,e.DiagnosticCategory.Message,"Rewrite_as_the_indexed_access_type_0_90026","Rewrite as the indexed access type '{0}'."),Declare_static_property_0:t(90027,e.DiagnosticCategory.Message,"Declare_static_property_0_90027","Declare static property '{0}'."),Call_decorator_expression:t(90028,e.DiagnosticCategory.Message,"Call_decorator_expression_90028","Call decorator expression."),Convert_function_to_an_ES2015_class:t(95001,e.DiagnosticCategory.Message,"Convert_function_to_an_ES2015_class_95001","Convert function to an ES2015 class"),Convert_function_0_to_class:t(95002,e.DiagnosticCategory.Message,"Convert_function_0_to_class_95002","Convert function '{0}' to class"),Extract_symbol:t(95003,e.DiagnosticCategory.Message,"Extract_symbol_95003","Extract symbol"),Extract_to_0_in_1:t(95004,e.DiagnosticCategory.Message,"Extract_to_0_in_1_95004","Extract to {0} in {1}"),Extract_function:t(95005,e.DiagnosticCategory.Message,"Extract_function_95005","Extract function"),Extract_constant:t(95006,e.DiagnosticCategory.Message,"Extract_constant_95006","Extract constant"),Extract_to_0_in_enclosing_scope:t(95007,e.DiagnosticCategory.Message,"Extract_to_0_in_enclosing_scope_95007","Extract to {0} in enclosing scope"),Extract_to_0_in_1_scope:t(95008,e.DiagnosticCategory.Message,"Extract_to_0_in_1_scope_95008","Extract to {0} in {1} scope"),Annotate_with_type_from_JSDoc:t(95009,e.DiagnosticCategory.Message,"Annotate_with_type_from_JSDoc_95009","Annotate with type from JSDoc"),Annotate_with_types_from_JSDoc:t(95010,e.DiagnosticCategory.Message,"Annotate_with_types_from_JSDoc_95010","Annotate with types from JSDoc"),Infer_type_of_0_from_usage:t(95011,e.DiagnosticCategory.Message,"Infer_type_of_0_from_usage_95011","Infer type of '{0}' from usage."),Infer_parameter_types_from_usage:t(95012,e.DiagnosticCategory.Message,"Infer_parameter_types_from_usage_95012","Infer parameter types from usage.")}}(ts||(ts={})),function(e){function t(e){return e>=71}e.tokenIsIdentifierOrKeyword=t;var n=e.createMapFromTemplate({abstract:117,any:119,as:118,boolean:122,break:72,case:73,catch:74,class:75,continue:77,const:76,constructor:123,debugger:78,declare:124,default:79,delete:80,do:81,else:82,enum:83,export:84,extends:85,false:86,finally:87,for:88,from:140,function:89,get:125,if:90,implements:108,import:91,in:92,instanceof:93,interface:109,is:126,keyof:127,let:110,module:128,namespace:129,never:130,new:94,null:95,number:133,object:134,package:111,private:112,protected:113,public:114,readonly:131,require:132,global:141,return:96,set:135,static:115,string:136,super:97,switch:98,symbol:137,this:99,throw:100,true:101,try:102,type:138,typeof:103,undefined:139,var:104,void:105,while:106,with:107,yield:116,async:120,await:121,of:142,"{":17,"}":18,"(":19,")":20,"[":21,"]":22,".":23,"...":24,";":25,",":26,"<":27,">":29,"<=":30,">=":31,"==":32,"!=":33,"===":34,"!==":35,"=>":36,"+":37,"-":38,"**":40,"*":39,"/":41,"%":42,"++":43,"--":44,"<<":45,"</":28,">>":46,">>>":47,"&":48,"|":49,"^":50,"!":51,"~":52,"&&":53,"||":54,"?":55,":":56,"=":58,"+=":59,"-=":60,"*=":61,"**=":62,"/=":63,"%=":64,"<<=":65,">>=":66,">>>=":67,"&=":68,"|=":69,"^=":70,"@":57}),r=[170,170,181,181,186,186,192,214,216,246,248,543,546,563,592,685,688,696,699,705,720,721,736,740,750,750,890,890,902,902,904,906,908,908,910,929,931,974,976,983,986,1011,1024,1153,1164,1220,1223,1224,1227,1228,1232,1269,1272,1273,1329,1366,1369,1369,1377,1415,1488,1514,1520,1522,1569,1594,1600,1610,1649,1747,1749,1749,1765,1766,1786,1788,1808,1808,1810,1836,1920,1957,2309,2361,2365,2365,2384,2384,2392,2401,2437,2444,2447,2448,2451,2472,2474,2480,2482,2482,2486,2489,2524,2525,2527,2529,2544,2545,2565,2570,2575,2576,2579,2600,2602,2608,2610,2611,2613,2614,2616,2617,2649,2652,2654,2654,2674,2676,2693,2699,2701,2701,2703,2705,2707,2728,2730,2736,2738,2739,2741,2745,2749,2749,2768,2768,2784,2784,2821,2828,2831,2832,2835,2856,2858,2864,2866,2867,2870,2873,2877,2877,2908,2909,2911,2913,2949,2954,2958,2960,2962,2965,2969,2970,2972,2972,2974,2975,2979,2980,2984,2986,2990,2997,2999,3001,3077,3084,3086,3088,3090,3112,3114,3123,3125,3129,3168,3169,3205,3212,3214,3216,3218,3240,3242,3251,3253,3257,3294,3294,3296,3297,3333,3340,3342,3344,3346,3368,3370,3385,3424,3425,3461,3478,3482,3505,3507,3515,3517,3517,3520,3526,3585,3632,3634,3635,3648,3654,3713,3714,3716,3716,3719,3720,3722,3722,3725,3725,3732,3735,3737,3743,3745,3747,3749,3749,3751,3751,3754,3755,3757,3760,3762,3763,3773,3773,3776,3780,3782,3782,3804,3805,3840,3840,3904,3911,3913,3946,3976,3979,4096,4129,4131,4135,4137,4138,4176,4181,4256,4293,4304,4342,4352,4441,4447,4514,4520,4601,4608,4614,4616,4678,4680,4680,4682,4685,4688,4694,4696,4696,4698,4701,4704,4742,4744,4744,4746,4749,4752,4782,4784,4784,4786,4789,4792,4798,4800,4800,4802,4805,4808,4814,4816,4822,4824,4846,4848,4878,4880,4880,4882,4885,4888,4894,4896,4934,4936,4954,5024,5108,5121,5740,5743,5750,5761,5786,5792,5866,6016,6067,6176,6263,6272,6312,7680,7835,7840,7929,7936,7957,7960,7965,7968,8005,8008,8013,8016,8023,8025,8025,8027,8027,8029,8029,8031,8061,8064,8116,8118,8124,8126,8126,8130,8132,8134,8140,8144,8147,8150,8155,8160,8172,8178,8180,8182,8188,8319,8319,8450,8450,8455,8455,8458,8467,8469,8469,8473,8477,8484,8484,8486,8486,8488,8488,8490,8493,8495,8497,8499,8505,8544,8579,12293,12295,12321,12329,12337,12341,12344,12346,12353,12436,12445,12446,12449,12538,12540,12542,12549,12588,12593,12686,12704,12727,13312,19893,19968,40869,40960,42124,44032,55203,63744,64045,64256,64262,64275,64279,64285,64285,64287,64296,64298,64310,64312,64316,64318,64318,64320,64321,64323,64324,64326,64433,64467,64829,64848,64911,64914,64967,65008,65019,65136,65138,65140,65140,65142,65276,65313,65338,65345,65370,65382,65470,65474,65479,65482,65487,65490,65495,65498,65500],i=[170,170,181,181,186,186,192,214,216,246,248,543,546,563,592,685,688,696,699,705,720,721,736,740,750,750,768,846,864,866,890,890,902,902,904,906,908,908,910,929,931,974,976,983,986,1011,1024,1153,1155,1158,1164,1220,1223,1224,1227,1228,1232,1269,1272,1273,1329,1366,1369,1369,1377,1415,1425,1441,1443,1465,1467,1469,1471,1471,1473,1474,1476,1476,1488,1514,1520,1522,1569,1594,1600,1621,1632,1641,1648,1747,1749,1756,1759,1768,1770,1773,1776,1788,1808,1836,1840,1866,1920,1968,2305,2307,2309,2361,2364,2381,2384,2388,2392,2403,2406,2415,2433,2435,2437,2444,2447,2448,2451,2472,2474,2480,2482,2482,2486,2489,2492,2492,2494,2500,2503,2504,2507,2509,2519,2519,2524,2525,2527,2531,2534,2545,2562,2562,2565,2570,2575,2576,2579,2600,2602,2608,2610,2611,2613,2614,2616,2617,2620,2620,2622,2626,2631,2632,2635,2637,2649,2652,2654,2654,2662,2676,2689,2691,2693,2699,2701,2701,2703,2705,2707,2728,2730,2736,2738,2739,2741,2745,2748,2757,2759,2761,2763,2765,2768,2768,2784,2784,2790,2799,2817,2819,2821,2828,2831,2832,2835,2856,2858,2864,2866,2867,2870,2873,2876,2883,2887,2888,2891,2893,2902,2903,2908,2909,2911,2913,2918,2927,2946,2947,2949,2954,2958,2960,2962,2965,2969,2970,2972,2972,2974,2975,2979,2980,2984,2986,2990,2997,2999,3001,3006,3010,3014,3016,3018,3021,3031,3031,3047,3055,3073,3075,3077,3084,3086,3088,3090,3112,3114,3123,3125,3129,3134,3140,3142,3144,3146,3149,3157,3158,3168,3169,3174,3183,3202,3203,3205,3212,3214,3216,3218,3240,3242,3251,3253,3257,3262,3268,3270,3272,3274,3277,3285,3286,3294,3294,3296,3297,3302,3311,3330,3331,3333,3340,3342,3344,3346,3368,3370,3385,3390,3395,3398,3400,3402,3405,3415,3415,3424,3425,3430,3439,3458,3459,3461,3478,3482,3505,3507,3515,3517,3517,3520,3526,3530,3530,3535,3540,3542,3542,3544,3551,3570,3571,3585,3642,3648,3662,3664,3673,3713,3714,3716,3716,3719,3720,3722,3722,3725,3725,3732,3735,3737,3743,3745,3747,3749,3749,3751,3751,3754,3755,3757,3769,3771,3773,3776,3780,3782,3782,3784,3789,3792,3801,3804,3805,3840,3840,3864,3865,3872,3881,3893,3893,3895,3895,3897,3897,3902,3911,3913,3946,3953,3972,3974,3979,3984,3991,3993,4028,4038,4038,4096,4129,4131,4135,4137,4138,4140,4146,4150,4153,4160,4169,4176,4185,4256,4293,4304,4342,4352,4441,4447,4514,4520,4601,4608,4614,4616,4678,4680,4680,4682,4685,4688,4694,4696,4696,4698,4701,4704,4742,4744,4744,4746,4749,4752,4782,4784,4784,4786,4789,4792,4798,4800,4800,4802,4805,4808,4814,4816,4822,4824,4846,4848,4878,4880,4880,4882,4885,4888,4894,4896,4934,4936,4954,4969,4977,5024,5108,5121,5740,5743,5750,5761,5786,5792,5866,6016,6099,6112,6121,6160,6169,6176,6263,6272,6313,7680,7835,7840,7929,7936,7957,7960,7965,7968,8005,8008,8013,8016,8023,8025,8025,8027,8027,8029,8029,8031,8061,8064,8116,8118,8124,8126,8126,8130,8132,8134,8140,8144,8147,8150,8155,8160,8172,8178,8180,8182,8188,8255,8256,8319,8319,8400,8412,8417,8417,8450,8450,8455,8455,8458,8467,8469,8469,8473,8477,8484,8484,8486,8486,8488,8488,8490,8493,8495,8497,8499,8505,8544,8579,12293,12295,12321,12335,12337,12341,12344,12346,12353,12436,12441,12442,12445,12446,12449,12542,12549,12588,12593,12686,12704,12727,13312,19893,19968,40869,40960,42124,44032,55203,63744,64045,64256,64262,64275,64279,64285,64296,64298,64310,64312,64316,64318,64318,64320,64321,64323,64324,64326,64433,64467,64829,64848,64911,64914,64967,65008,65019,65056,65059,65075,65076,65101,65103,65136,65138,65140,65140,65142,65276,65296,65305,65313,65338,65343,65343,65345,65370,65381,65470,65474,65479,65482,65487,65490,65495,65498,65500],a=[170,170,181,181,186,186,192,214,216,246,248,705,710,721,736,740,748,748,750,750,880,884,886,887,890,893,902,902,904,906,908,908,910,929,931,1013,1015,1153,1162,1319,1329,1366,1369,1369,1377,1415,1488,1514,1520,1522,1568,1610,1646,1647,1649,1747,1749,1749,1765,1766,1774,1775,1786,1788,1791,1791,1808,1808,1810,1839,1869,1957,1969,1969,1994,2026,2036,2037,2042,2042,2048,2069,2074,2074,2084,2084,2088,2088,2112,2136,2208,2208,2210,2220,2308,2361,2365,2365,2384,2384,2392,2401,2417,2423,2425,2431,2437,2444,2447,2448,2451,2472,2474,2480,2482,2482,2486,2489,2493,2493,2510,2510,2524,2525,2527,2529,2544,2545,2565,2570,2575,2576,2579,2600,2602,2608,2610,2611,2613,2614,2616,2617,2649,2652,2654,2654,2674,2676,2693,2701,2703,2705,2707,2728,2730,2736,2738,2739,2741,2745,2749,2749,2768,2768,2784,2785,2821,2828,2831,2832,2835,2856,2858,2864,2866,2867,2869,2873,2877,2877,2908,2909,2911,2913,2929,2929,2947,2947,2949,2954,2958,2960,2962,2965,2969,2970,2972,2972,2974,2975,2979,2980,2984,2986,2990,3001,3024,3024,3077,3084,3086,3088,3090,3112,3114,3123,3125,3129,3133,3133,3160,3161,3168,3169,3205,3212,3214,3216,3218,3240,3242,3251,3253,3257,3261,3261,3294,3294,3296,3297,3313,3314,3333,3340,3342,3344,3346,3386,3389,3389,3406,3406,3424,3425,3450,3455,3461,3478,3482,3505,3507,3515,3517,3517,3520,3526,3585,3632,3634,3635,3648,3654,3713,3714,3716,3716,3719,3720,3722,3722,3725,3725,3732,3735,3737,3743,3745,3747,3749,3749,3751,3751,3754,3755,3757,3760,3762,3763,3773,3773,3776,3780,3782,3782,3804,3807,3840,3840,3904,3911,3913,3948,3976,3980,4096,4138,4159,4159,4176,4181,4186,4189,4193,4193,4197,4198,4206,4208,4213,4225,4238,4238,4256,4293,4295,4295,4301,4301,4304,4346,4348,4680,4682,4685,4688,4694,4696,4696,4698,4701,4704,4744,4746,4749,4752,4784,4786,4789,4792,4798,4800,4800,4802,4805,4808,4822,4824,4880,4882,4885,4888,4954,4992,5007,5024,5108,5121,5740,5743,5759,5761,5786,5792,5866,5870,5872,5888,5900,5902,5905,5920,5937,5952,5969,5984,5996,5998,6e3,6016,6067,6103,6103,6108,6108,6176,6263,6272,6312,6314,6314,6320,6389,6400,6428,6480,6509,6512,6516,6528,6571,6593,6599,6656,6678,6688,6740,6823,6823,6917,6963,6981,6987,7043,7072,7086,7087,7098,7141,7168,7203,7245,7247,7258,7293,7401,7404,7406,7409,7413,7414,7424,7615,7680,7957,7960,7965,7968,8005,8008,8013,8016,8023,8025,8025,8027,8027,8029,8029,8031,8061,8064,8116,8118,8124,8126,8126,8130,8132,8134,8140,8144,8147,8150,8155,8160,8172,8178,8180,8182,8188,8305,8305,8319,8319,8336,8348,8450,8450,8455,8455,8458,8467,8469,8469,8473,8477,8484,8484,8486,8486,8488,8488,8490,8493,8495,8505,8508,8511,8517,8521,8526,8526,8544,8584,11264,11310,11312,11358,11360,11492,11499,11502,11506,11507,11520,11557,11559,11559,11565,11565,11568,11623,11631,11631,11648,11670,11680,11686,11688,11694,11696,11702,11704,11710,11712,11718,11720,11726,11728,11734,11736,11742,11823,11823,12293,12295,12321,12329,12337,12341,12344,12348,12353,12438,12445,12447,12449,12538,12540,12543,12549,12589,12593,12686,12704,12730,12784,12799,13312,19893,19968,40908,40960,42124,42192,42237,42240,42508,42512,42527,42538,42539,42560,42606,42623,42647,42656,42735,42775,42783,42786,42888,42891,42894,42896,42899,42912,42922,43e3,43009,43011,43013,43015,43018,43020,43042,43072,43123,43138,43187,43250,43255,43259,43259,43274,43301,43312,43334,43360,43388,43396,43442,43471,43471,43520,43560,43584,43586,43588,43595,43616,43638,43642,43642,43648,43695,43697,43697,43701,43702,43705,43709,43712,43712,43714,43714,43739,43741,43744,43754,43762,43764,43777,43782,43785,43790,43793,43798,43808,43814,43816,43822,43968,44002,44032,55203,55216,55238,55243,55291,63744,64109,64112,64217,64256,64262,64275,64279,64285,64285,64287,64296,64298,64310,64312,64316,64318,64318,64320,64321,64323,64324,64326,64433,64467,64829,64848,64911,64914,64967,65008,65019,65136,65140,65142,65276,65313,65338,65345,65370,65382,65470,65474,65479,65482,65487,65490,65495,65498,65500],o=[170,170,181,181,186,186,192,214,216,246,248,705,710,721,736,740,748,748,750,750,768,884,886,887,890,893,902,902,904,906,908,908,910,929,931,1013,1015,1153,1155,1159,1162,1319,1329,1366,1369,1369,1377,1415,1425,1469,1471,1471,1473,1474,1476,1477,1479,1479,1488,1514,1520,1522,1552,1562,1568,1641,1646,1747,1749,1756,1759,1768,1770,1788,1791,1791,1808,1866,1869,1969,1984,2037,2042,2042,2048,2093,2112,2139,2208,2208,2210,2220,2276,2302,2304,2403,2406,2415,2417,2423,2425,2431,2433,2435,2437,2444,2447,2448,2451,2472,2474,2480,2482,2482,2486,2489,2492,2500,2503,2504,2507,2510,2519,2519,2524,2525,2527,2531,2534,2545,2561,2563,2565,2570,2575,2576,2579,2600,2602,2608,2610,2611,2613,2614,2616,2617,2620,2620,2622,2626,2631,2632,2635,2637,2641,2641,2649,2652,2654,2654,2662,2677,2689,2691,2693,2701,2703,2705,2707,2728,2730,2736,2738,2739,2741,2745,2748,2757,2759,2761,2763,2765,2768,2768,2784,2787,2790,2799,2817,2819,2821,2828,2831,2832,2835,2856,2858,2864,2866,2867,2869,2873,2876,2884,2887,2888,2891,2893,2902,2903,2908,2909,2911,2915,2918,2927,2929,2929,2946,2947,2949,2954,2958,2960,2962,2965,2969,2970,2972,2972,2974,2975,2979,2980,2984,2986,2990,3001,3006,3010,3014,3016,3018,3021,3024,3024,3031,3031,3046,3055,3073,3075,3077,3084,3086,3088,3090,3112,3114,3123,3125,3129,3133,3140,3142,3144,3146,3149,3157,3158,3160,3161,3168,3171,3174,3183,3202,3203,3205,3212,3214,3216,3218,3240,3242,3251,3253,3257,3260,3268,3270,3272,3274,3277,3285,3286,3294,3294,3296,3299,3302,3311,3313,3314,3330,3331,3333,3340,3342,3344,3346,3386,3389,3396,3398,3400,3402,3406,3415,3415,3424,3427,3430,3439,3450,3455,3458,3459,3461,3478,3482,3505,3507,3515,3517,3517,3520,3526,3530,3530,3535,3540,3542,3542,3544,3551,3570,3571,3585,3642,3648,3662,3664,3673,3713,3714,3716,3716,3719,3720,3722,3722,3725,3725,3732,3735,3737,3743,3745,3747,3749,3749,3751,3751,3754,3755,3757,3769,3771,3773,3776,3780,3782,3782,3784,3789,3792,3801,3804,3807,3840,3840,3864,3865,3872,3881,3893,3893,3895,3895,3897,3897,3902,3911,3913,3948,3953,3972,3974,3991,3993,4028,4038,4038,4096,4169,4176,4253,4256,4293,4295,4295,4301,4301,4304,4346,4348,4680,4682,4685,4688,4694,4696,4696,4698,4701,4704,4744,4746,4749,4752,4784,4786,4789,4792,4798,4800,4800,4802,4805,4808,4822,4824,4880,4882,4885,4888,4954,4957,4959,4992,5007,5024,5108,5121,5740,5743,5759,5761,5786,5792,5866,5870,5872,5888,5900,5902,5908,5920,5940,5952,5971,5984,5996,5998,6e3,6002,6003,6016,6099,6103,6103,6108,6109,6112,6121,6155,6157,6160,6169,6176,6263,6272,6314,6320,6389,6400,6428,6432,6443,6448,6459,6470,6509,6512,6516,6528,6571,6576,6601,6608,6617,6656,6683,6688,6750,6752,6780,6783,6793,6800,6809,6823,6823,6912,6987,6992,7001,7019,7027,7040,7155,7168,7223,7232,7241,7245,7293,7376,7378,7380,7414,7424,7654,7676,7957,7960,7965,7968,8005,8008,8013,8016,8023,8025,8025,8027,8027,8029,8029,8031,8061,8064,8116,8118,8124,8126,8126,8130,8132,8134,8140,8144,8147,8150,8155,8160,8172,8178,8180,8182,8188,8204,8205,8255,8256,8276,8276,8305,8305,8319,8319,8336,8348,8400,8412,8417,8417,8421,8432,8450,8450,8455,8455,8458,8467,8469,8469,8473,8477,8484,8484,8486,8486,8488,8488,8490,8493,8495,8505,8508,8511,8517,8521,8526,8526,8544,8584,11264,11310,11312,11358,11360,11492,11499,11507,11520,11557,11559,11559,11565,11565,11568,11623,11631,11631,11647,11670,11680,11686,11688,11694,11696,11702,11704,11710,11712,11718,11720,11726,11728,11734,11736,11742,11744,11775,11823,11823,12293,12295,12321,12335,12337,12341,12344,12348,12353,12438,12441,12442,12445,12447,12449,12538,12540,12543,12549,12589,12593,12686,12704,12730,12784,12799,13312,19893,19968,40908,40960,42124,42192,42237,42240,42508,42512,42539,42560,42607,42612,42621,42623,42647,42655,42737,42775,42783,42786,42888,42891,42894,42896,42899,42912,42922,43e3,43047,43072,43123,43136,43204,43216,43225,43232,43255,43259,43259,43264,43309,43312,43347,43360,43388,43392,43456,43471,43481,43520,43574,43584,43597,43600,43609,43616,43638,43642,43643,43648,43714,43739,43741,43744,43759,43762,43766,43777,43782,43785,43790,43793,43798,43808,43814,43816,43822,43968,44010,44012,44013,44016,44025,44032,55203,55216,55238,55243,55291,63744,64109,64112,64217,64256,64262,64275,64279,64285,64296,64298,64310,64312,64316,64318,64318,64320,64321,64323,64324,64326,64433,64467,64829,64848,64911,64914,64967,65008,65019,65024,65039,65056,65062,65075,65076,65101,65103,65136,65140,65142,65276,65296,65305,65313,65338,65343,65343,65345,65370,65382,65470,65474,65479,65482,65487,65490,65495,65498,65500];function s(e,t){if(e<t[0])return!1;for(var n,r=0,i=t.length;r+1<i;){if(n=r+(i-r)/2,t[n-=n%2]<=e&&e<=t[n+1])return!0;e<t[n]?i=n:r=n+2}return!1}function c(e,t){return s(e,t>=1?a:r)}e.isUnicodeIdentifierStart=c;var u,_=(u=[],n.forEach((function(e,t){u[e]=t})),u);function l(e){for(var t=new Array,n=0,r=0;n<e.length;){var i=e.charCodeAt(n);switch(n++,i){case 13:10===e.charCodeAt(n)&&n++;case 10:t.push(r),r=n;break;default:i>127&&y(i)&&(t.push(r),r=n)}}return t.push(r),t}function d(t,n,r,i){e.Debug.assert(n>=0&&n<t.length);var a=t[n]+r;return n<t.length-1?e.Debug.assert(a<t[n+1]):void 0!==i&&e.Debug.assert(a<=i.length),a}function p(e){return e.lineMap||(e.lineMap=l(e.text))}function f(t,n){var r=e.binarySearch(t,n);return r<0&&(r=~r-1,e.Debug.assert(-1!==r,"position cannot precede the beginning of the file")),{line:r,character:n-t[r]}}function m(e){return g(e)||y(e)}function g(e){return 32===e||9===e||11===e||12===e||160===e||133===e||5760===e||e>=8192&&e<=8203||8239===e||8287===e||12288===e||65279===e}function y(e){return 10===e||13===e||8232===e||8233===e}function h(e){return e>=48&&e<=57}function v(e){return e>=48&&e<=55}e.tokenToString=function(e){return _[e]},e.stringToToken=function(e){return n.get(e)},e.computeLineStarts=l,e.getPositionOfLineAndCharacter=function(e,t,n){return d(p(e),t,n,e.text)},e.computePositionOfLineAndCharacter=d,e.getLineStarts=p,e.computeLineAndCharacterOfPosition=f,e.getLineAndCharacterOfPosition=function(e,t){return f(p(e),t)},e.isWhiteSpaceLike=m,e.isWhiteSpaceSingleLine=g,e.isLineBreak=y,e.isOctalDigit=v,e.couldStartTrivia=function(e,t){var n=e.charCodeAt(t);switch(n){case 13:case 10:case 9:case 11:case 12:case 32:case 47:case 60:case 124:case 61:case 62:return!0;case 35:return 0===t;default:return n>127}},e.skipTrivia=function(t,n,r,i){if(void 0===i&&(i=!1),e.positionIsSynthesized(n))return n;for(;;){var a=t.charCodeAt(n);switch(a){case 13:10===t.charCodeAt(n+1)&&n++;case 10:if(n++,r)return n;continue;case 9:case 11:case 12:case 32:n++;continue;case 47:if(i)break;if(47===t.charCodeAt(n+1)){for(n+=2;n<t.length&&!y(t.charCodeAt(n));)n++;continue}if(42===t.charCodeAt(n+1)){for(n+=2;n<t.length;){if(42===t.charCodeAt(n)&&47===t.charCodeAt(n+1)){n+=2;break}n++}continue}break;case 60:case 124:case 61:case 62:if(x(t,n)){n=k(t,n);continue}break;case 35:if(0===n&&D(t,n)){n=C(t,n);continue}break;default:if(a>127&&m(a)){n++;continue}}return n}};var b="<<<<<<<".length;function x(t,n){if(e.Debug.assert(n>=0),0===n||y(t.charCodeAt(n-1))){var r=t.charCodeAt(n);if(n+b<t.length){for(var i=0;i<b;i++)if(t.charCodeAt(n+i)!==r)return!1;return 61===r||32===t.charCodeAt(n+b)}}return!1}function k(t,n,r){r&&r(e.Diagnostics.Merge_conflict_marker_encountered,b);var i=t.charCodeAt(n),a=t.length;if(60===i||62===i)for(;n<a&&!y(t.charCodeAt(n));)n++;else for(e.Debug.assert(124===i||61===i);n<a;){var o=t.charCodeAt(n);if((61===o||62===o)&&o!==i&&x(t,n))break;n++}return n}var S=/^#!.*/;function D(t,n){return e.Debug.assert(0===n),S.test(t)}function C(e,t){return t+=S.exec(e)[0].length}function T(e,t,n,r,i,a,o){var s,c,u,_,l=!1,d=r||0===n,p=o;e:for(;n>=0&&n<t.length;){var f=t.charCodeAt(n);switch(f){case 13:10===t.charCodeAt(n+1)&&n++;case 10:if(n++,r)break e;d=!0,l&&(_=!0);continue;case 9:case 11:case 12:case 32:n++;continue;case 47:var g=t.charCodeAt(n+1),h=!1;if(47===g||42===g){var v=47===g?2:3,b=n;if(n+=2,47===g)for(;n<t.length;){if(y(t.charCodeAt(n))){h=!0;break}n++}else for(;n<t.length;){if(42===t.charCodeAt(n)&&47===t.charCodeAt(n+1)){n+=2;break}n++}if(d){if(l){if(p=i(s,c,u,_,a,p),!e&&p)return p;l=!1}s=b,c=n,u=v,_=h,l=!0}continue}break e;default:if(f>127&&m(f)){l&&y(f)&&(_=!0),n++;continue}break e}}return l&&(p=i(s,c,u,_,a,p)),p}function E(e,t,n,r,i){return T(!0,e,t,!1,n,r,i)}function N(e,t,n,r,i){return T(!0,e,t,!0,n,r,i)}function A(e,t,n,r,i,a){return a||(a=[]),a.push({kind:n,pos:e,end:t,hasTrailingNewLine:r}),a}function w(e,t){return e>=65&&e<=90||e>=97&&e<=122||36===e||95===e||e>127&&c(e,t)}function P(e,t){return e>=65&&e<=90||e>=97&&e<=122||e>=48&&e<=57||36===e||95===e||e>127&&function(e,t){return s(e,t>=1?o:i)}(e,t)}e.forEachLeadingCommentRange=function(e,t,n,r){return T(!1,e,t,!1,n,r)},e.forEachTrailingCommentRange=function(e,t,n,r){return T(!1,e,t,!0,n,r)},e.reduceEachLeadingCommentRange=E,e.reduceEachTrailingCommentRange=N,e.getLeadingCommentRanges=function(e,t){return E(e,t,A,void 0,void 0)},e.getTrailingCommentRanges=function(e,t){return N(e,t,A,void 0,void 0)},e.getShebang=function(e){var t=S.exec(e);if(t)return t[0]},e.isIdentifierStart=w,e.isIdentifierPart=P,e.isIdentifierText=function(e,t){if(!w(e.charCodeAt(0),t))return!1;for(var n=1;n<e.length;n++)if(!P(e.charCodeAt(n),t))return!1;return!0},e.createScanner=function(r,i,a,o,s,c,u){var _,l,d,p,f,b,S,T,E,N;return void 0===a&&(a=0),G(o,c,u),{getStartPos:function(){return d},getTextPos:function(){return _},getToken:function(){return f},getTokenPos:function(){return p},getTokenText:function(){return o.substring(p,_)},getTokenValue:function(){return b},hasExtendedUnicodeEscape:function(){return T},hasPrecedingLineBreak:function(){return S},isIdentifier:function(){return 71===f||f>107},isReservedWord:function(){return f>=72&&f<=107},isUnterminated:function(){return E},getNumericLiteralFlags:function(){return N},reScanGreaterToken:function(){if(29===f){if(62===o.charCodeAt(_))return 62===o.charCodeAt(_+1)?61===o.charCodeAt(_+2)?(_+=3,f=67):(_+=2,f=47):61===o.charCodeAt(_+1)?(_+=2,f=66):(_++,f=46);if(61===o.charCodeAt(_))return _++,f=31}return f},reScanSlashToken:function(){if(41===f||63===f){for(var t=p+1,n=!1,i=!1;;){if(t>=l){E=!0,A(e.Diagnostics.Unterminated_regular_expression_literal);break}var a=o.charCodeAt(t);if(y(a)){E=!0,A(e.Diagnostics.Unterminated_regular_expression_literal);break}if(n)n=!1;else{if(47===a&&!i){t++;break}91===a?i=!0:92===a?n=!0:93===a&&(i=!1)}t++}for(;t<l&&P(o.charCodeAt(t),r);)t++;_=t,b=o.substring(p,_),f=12}return f},reScanTemplateToken:function(){return e.Debug.assert(18===f,"'reScanTemplateToken' should only be called on a '}'"),_=p,f=B()},scanJsxIdentifier:function(){if(t(f)){for(var e=_;_<l;){var n=o.charCodeAt(_);if(45!==n&&!(e===_?w(n,r):P(n,r)))break;_++}b+=o.substr(e,_-e)}return f},scanJsxAttributeValue:function(){switch(d=_,o.charCodeAt(_)){case 34:case 39:return b=M(!1),f=9;default:return q()}},reScanJsxToken:function(){return _=p=d,f=W()},scanJsxToken:W,scanJSDocToken:function(){if(_>=l)return f=1;d=_,p=_;var e=o.charCodeAt(_);switch(e){case 9:case 11:case 12:case 32:for(;_<l&&g(o.charCodeAt(_));)_++;return f=5;case 64:return _++,f=57;case 10:case 13:return _++,f=4;case 42:return _++,f=39;case 123:return _++,f=17;case 125:return _++,f=18;case 91:return _++,f=21;case 93:return _++,f=22;case 60:return _++,f=27;case 62:return _++,f=29;case 61:return _++,f=58;case 44:return _++,f=26;case 46:return _++,f=23}if(w(e,5)){for(_++;P(o.charCodeAt(_),5)&&_<l;)_++;return f=71}return _+=1,f=0},scan:q,getText:function(){return o},setText:G,setScriptTarget:function(e){r=e},setLanguageVariant:function(e){a=e},setOnError:function(e){s=e},setTextPos:Q,tryScan:function(e){return H(e,!1)},lookAhead:function(e){return H(e,!0)},scanRange:function(e,t,n){var r=l,i=_,a=d,s=p,c=f,u=S,m=b,g=T,y=E;G(o,e,t);var h=n();return l=r,_=i,d=a,p=s,f=c,S=u,b=m,T=g,E=y,h}};function A(e,t){s&&s(e,t||0)}function F(){for(var t=_;h(o.charCodeAt(_));)_++;if(46===o.charCodeAt(_))for(_++;h(o.charCodeAt(_));)_++;var n=_;if(69===o.charCodeAt(_)||101===o.charCodeAt(_))if(_++,N=2,43!==o.charCodeAt(_)&&45!==o.charCodeAt(_)||_++,h(o.charCodeAt(_))){for(_++;h(o.charCodeAt(_));)_++;n=_}else A(e.Diagnostics.Digit_expected);return""+ +o.substring(t,n)}function O(){for(var e=_;v(o.charCodeAt(_));)_++;return+o.substring(e,_)}function I(e){return L(e,!1)}function R(e){return L(e,!0)}function L(e,t){for(var n=0,r=0;n<e||t;){var i=o.charCodeAt(_);if(i>=48&&i<=57)r=16*r+i-48;else if(i>=65&&i<=70)r=16*r+i-65+10;else{if(!(i>=97&&i<=102))break;r=16*r+i-97+10}_++,n++}return n<e&&(r=-1),r}function M(t){void 0===t&&(t=!0);for(var n=o.charCodeAt(_),r="",i=++_;;){if(_>=l){r+=o.substring(i,_),E=!0,A(e.Diagnostics.Unterminated_string_literal);break}var a=o.charCodeAt(_);if(a===n){r+=o.substring(i,_),_++;break}if(92===a&&t)r+=o.substring(i,_),r+=J(),i=_;else{if(y(a)){r+=o.substring(i,_),E=!0,A(e.Diagnostics.Unterminated_string_literal);break}_++}}return r}function B(){for(var t,n=96===o.charCodeAt(_),r=++_,i="";;){if(_>=l){i+=o.substring(r,_),E=!0,A(e.Diagnostics.Unterminated_template_literal),t=n?13:16;break}var a=o.charCodeAt(_);if(96===a){i+=o.substring(r,_),_++,t=n?13:16;break}if(36===a&&_+1<l&&123===o.charCodeAt(_+1)){i+=o.substring(r,_),_+=2,t=n?14:15;break}92!==a?13!==a?_++:(i+=o.substring(r,_),++_<l&&10===o.charCodeAt(_)&&_++,i+="\n",r=_):(i+=o.substring(r,_),i+=J(),r=_)}return e.Debug.assert(void 0!==t),b=i,t}function J(){if(++_>=l)return A(e.Diagnostics.Unexpected_end_of_text),"";var t=o.charCodeAt(_);switch(_++,t){case 48:return"\0";case 98:return"\b";case 116:return"\t";case 110:return"\n";case 118:return"\v";case 102:return"\f";case 114:return"\r";case 39:return"'";case 34:return'"';case 117:return _<l&&123===o.charCodeAt(_)?(T=!0,_++,function(){var t=R(1),n=!1;t<0?(A(e.Diagnostics.Hexadecimal_digit_expected),n=!0):t>1114111&&(A(e.Diagnostics.An_extended_Unicode_escape_value_must_be_between_0x0_and_0x10FFFF_inclusive),n=!0);_>=l?(A(e.Diagnostics.Unexpected_end_of_text),n=!0):125===o.charCodeAt(_)?_++:(A(e.Diagnostics.Unterminated_Unicode_escape_sequence),n=!0);if(n)return"";return function(t){if(e.Debug.assert(0<=t&&t<=1114111),t<=65535)return String.fromCharCode(t);var n=Math.floor((t-65536)/1024)+55296,r=(t-65536)%1024+56320;return String.fromCharCode(n,r)}(t)}()):z(4);case 120:return z(2);case 13:_<l&&10===o.charCodeAt(_)&&_++;case 10:case 8232:case 8233:return"";default:return String.fromCharCode(t)}}function z(t){var n=I(t);return n>=0?String.fromCharCode(n):(A(e.Diagnostics.Hexadecimal_digit_expected),"")}function j(){if(_+5<l&&117===o.charCodeAt(_+1)){var e=_;_+=2;var t=I(4);return _=e,t}return-1}function K(){for(var e="",t=_;_<l;){var n=o.charCodeAt(_);if(P(n,r))_++;else{if(92!==n)break;if(!((n=j())>=0&&P(n,r)))break;e+=o.substring(t,_),e+=String.fromCharCode(n),t=_+=6}}return e+=o.substring(t,_)}function U(){var e=b.length;if(e>=2&&e<=11){var t=b.charCodeAt(0);if(t>=97&&t<=122&&void 0!==(f=n.get(b)))return f}return f=71}function V(t){e.Debug.assert(2===t||8===t,"Expected either base 2 or base 8");for(var n=0,r=0;;){var i=o.charCodeAt(_),a=i-48;if(!h(i)||a>=t)break;n=n*t+a,_++,r++}return 0===r?-1:n}function q(){for(d=_,T=!1,S=!1,E=!1,N=0;;){if(p=_,_>=l)return f=1;var t=o.charCodeAt(_);if(35===t&&0===_&&D(o,_)){if(_=C(o,_),i)continue;return f=6}switch(t){case 10:case 13:if(S=!0,i){_++;continue}return 13===t&&_+1<l&&10===o.charCodeAt(_+1)?_+=2:_++,f=4;case 9:case 11:case 12:case 32:if(i){_++;continue}for(;_<l&&g(o.charCodeAt(_));)_++;return f=5;case 33:return 61===o.charCodeAt(_+1)?61===o.charCodeAt(_+2)?(_+=3,f=35):(_+=2,f=33):(_++,f=51);case 34:case 39:return b=M(),f=9;case 96:return f=B();case 37:return 61===o.charCodeAt(_+1)?(_+=2,f=64):(_++,f=42);case 38:return 38===o.charCodeAt(_+1)?(_+=2,f=53):61===o.charCodeAt(_+1)?(_+=2,f=68):(_++,f=48);case 40:return _++,f=19;case 41:return _++,f=20;case 42:return 61===o.charCodeAt(_+1)?(_+=2,f=61):42===o.charCodeAt(_+1)?61===o.charCodeAt(_+2)?(_+=3,f=62):(_+=2,f=40):(_++,f=39);case 43:return 43===o.charCodeAt(_+1)?(_+=2,f=43):61===o.charCodeAt(_+1)?(_+=2,f=59):(_++,f=37);case 44:return _++,f=26;case 45:return 45===o.charCodeAt(_+1)?(_+=2,f=44):61===o.charCodeAt(_+1)?(_+=2,f=60):(_++,f=38);case 46:return h(o.charCodeAt(_+1))?(b=F(),f=8):46===o.charCodeAt(_+1)&&46===o.charCodeAt(_+2)?(_+=3,f=24):(_++,f=23);case 47:if(47===o.charCodeAt(_+1)){for(_+=2;_<l&&!y(o.charCodeAt(_));)_++;if(i)continue;return f=2}if(42===o.charCodeAt(_+1)){_+=2;for(var n=!1;_<l;){var s=o.charCodeAt(_);if(42===s&&47===o.charCodeAt(_+1)){_+=2,n=!0;break}y(s)&&(S=!0),_++}if(n||A(e.Diagnostics.Asterisk_Slash_expected),i)continue;return E=!n,f=3}return 61===o.charCodeAt(_+1)?(_+=2,f=63):(_++,f=41);case 48:var c;if(_+2<l&&(88===o.charCodeAt(_+1)||120===o.charCodeAt(_+1)))return _+=2,(c=R(1))<0&&(A(e.Diagnostics.Hexadecimal_digit_expected),c=0),b=""+c,N=8,f=8;if(_+2<l&&(66===o.charCodeAt(_+1)||98===o.charCodeAt(_+1)))return _+=2,(c=V(2))<0&&(A(e.Diagnostics.Binary_digit_expected),c=0),b=""+c,N=16,f=8;if(_+2<l&&(79===o.charCodeAt(_+1)||111===o.charCodeAt(_+1)))return _+=2,(c=V(8))<0&&(A(e.Diagnostics.Octal_digit_expected),c=0),b=""+c,N=32,f=8;if(_+1<l&&v(o.charCodeAt(_+1)))return b=""+O(),N=4,f=8;case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return b=F(),f=8;case 58:return _++,f=56;case 59:return _++,f=25;case 60:if(x(o,_)){if(_=k(o,_,A),i)continue;return f=7}return 60===o.charCodeAt(_+1)?61===o.charCodeAt(_+2)?(_+=3,f=65):(_+=2,f=45):61===o.charCodeAt(_+1)?(_+=2,f=30):1===a&&47===o.charCodeAt(_+1)&&42!==o.charCodeAt(_+2)?(_+=2,f=28):(_++,f=27);case 61:if(x(o,_)){if(_=k(o,_,A),i)continue;return f=7}return 61===o.charCodeAt(_+1)?61===o.charCodeAt(_+2)?(_+=3,f=34):(_+=2,f=32):62===o.charCodeAt(_+1)?(_+=2,f=36):(_++,f=58);case 62:if(x(o,_)){if(_=k(o,_,A),i)continue;return f=7}return _++,f=29;case 63:return _++,f=55;case 91:return _++,f=21;case 93:return _++,f=22;case 94:return 61===o.charCodeAt(_+1)?(_+=2,f=70):(_++,f=50);case 123:return _++,f=17;case 124:if(x(o,_)){if(_=k(o,_,A),i)continue;return f=7}return 124===o.charCodeAt(_+1)?(_+=2,f=54):61===o.charCodeAt(_+1)?(_+=2,f=69):(_++,f=49);case 125:return _++,f=18;case 126:return _++,f=52;case 64:return _++,f=57;case 92:var u=j();return u>=0&&w(u,r)?(_+=6,b=String.fromCharCode(u)+K(),f=U()):(A(e.Diagnostics.Invalid_character),_++,f=0);default:if(w(t,r)){for(_++;_<l&&P(t=o.charCodeAt(_),r);)_++;return b=o.substring(p,_),92===t&&(b+=K()),f=U()}if(g(t)){_++;continue}if(y(t)){S=!0,_++;continue}return A(e.Diagnostics.Invalid_character),_++,f=0}}}function W(){if(d=p=_,_>=l)return f=1;var e=o.charCodeAt(_);if(60===e)return 47===o.charCodeAt(_+1)?(_+=2,f=28):(_++,f=27);if(123===e)return _++,f=17;for(var t=0;_<l&&123!==(e=o.charCodeAt(_));){if(60===e){if(x(o,_))return _=k(o,_,A),f=7;break}y(e)&&0===t?t=-1:m(e)||(t=_),_++}return-1===t?11:10}function H(e,t){var n=_,r=d,i=p,a=f,o=b,s=S,c=e();return c&&!t||(_=n,d=r,p=i,f=a,b=o,S=s),c}function G(e,t,n){o=e||"",l=void 0===n?o.length:t+n,Q(t||0)}function Q(t){e.Debug.assert(t>=0),_=t,d=t,p=t,f=0,S=!1,b=void 0,T=!1,E=!1}}}(ts||(ts={})),function(e){e.emptyArray=[],e.emptyMap=e.createMap(),e.externalHelpersModuleNameText="tslib",e.getDeclarationOfKind=function(e,t){var n=e.declarations;if(n)for(var r=0,i=n;r<i.length;r++){var a=i[r];if(a.kind===t)return a}};var t,n,r=(t="",{string:function(){return t},writeKeyword:n=function(e){return t+=e},writeOperator:n,writePunctuation:n,writeSpace:n,writeStringLiteral:n,writeParameter:n,writeProperty:n,writeSymbol:n,writeLine:function(){return t+=" "},increaseIndent:e.noop,decreaseIndent:e.noop,clear:function(){return t=""},trackSymbol:e.noop,reportInaccessibleThisError:e.noop,reportPrivateInBaseOfClassExpression:e.noop});function i(e){return e.end-e.pos}function a(t){return function(t){if(!(262144&t.flags)){(0!=(32768&t.flags)||e.forEachChild(t,a))&&(t.flags|=131072),t.flags|=262144}}(t),0!=(131072&t.flags)}function o(e){for(;e&&265!==e.kind;)e=e.parent;return e}function s(t,n){e.Debug.assert(t>=0);var r=e.getLineStarts(n),i=t,a=n.text;if(i+1===r.length)return a.length-1;var o=r[i],s=r[i+1]-1;for(e.Debug.assert(e.isLineBreak(a.charCodeAt(s)));o<=s&&e.isLineBreak(a.charCodeAt(s));)s--;return s}function c(e){return void 0===e||e.pos===e.end&&e.pos>=0&&1!==e.kind}function u(e){return!c(e)}function _(e,t){return 42===e.charCodeAt(t.pos+1)&&33===e.charCodeAt(t.pos+2)}function l(t,n,r){return c(t)?t.pos:e.isJSDocNode(t)?e.skipTrivia((n||o(t)).text,t.pos,!1,!0):r&&e.hasJSDocNodes(t)?l(t.jsDoc[0]):286===t.kind&&t._children.length>0?l(t._children[0],n,r):e.skipTrivia((n||o(t)).text,t.pos)}function d(t,n,r){if(void 0===r&&(r=!1),c(n))return"";var i=t.text;return i.substring(r?n.pos:e.skipTrivia(i,n.pos),n.end)}function p(t,n){return c(n)?"":t.substring(e.skipTrivia(t,n.pos),n.end)}function f(e,t){return void 0===t&&(t=!1),d(o(e),e,t)}function m(e,t){var n=e.pos,r=t.pos;return n<r?-1:r<n?1:0}function g(e){var t=e.emitNode;return t&&t.flags}function y(e){return e.length>=2&&95===e.charCodeAt(0)&&95===e.charCodeAt(1)?"_"+e:e}function h(e){var t=ce(e);return 226===t.kind&&260===t.parent.kind}function v(e){return e&&233===e.kind&&(9===e.name.kind||x(e))}function b(t){return e.isModuleDeclaration(t)&&9===t.name.kind}function x(e){return!!(512&e.flags)}function k(t,n){switch(t.kind){case 265:case 235:case 260:case 233:case 214:case 215:case 216:case 152:case 151:case 153:case 154:case 228:case 186:case 187:return!0;case 207:return n&&!e.isFunctionLike(n)}return!1}function S(e){return 0===i(e)?"(Missing)":f(e)}function D(e){switch(e.kind){case 71:return e.escapedText;case 9:case 8:return y(e.text);case 144:if(te(e.expression))return y(e.expression.text)}}function C(t,n,r,i,a,o){var s=E(t,n);return e.createFileDiagnostic(t,s.start,s.length,r,i,a,o)}function T(t,n){var r=e.createScanner(t.languageVersion,!0,t.languageVariant,t.text,void 0,n);r.scan();var i=r.getTokenPos();return e.createTextSpanFromBounds(i,r.getTextPos())}function E(t,n){var r=n;switch(n.kind){case 265:var i=e.skipTrivia(t.text,0,!1);return i===t.text.length?e.createTextSpan(0,0):T(t,i);case 226:case 176:case 229:case 199:case 230:case 233:case 232:case 264:case 228:case 186:case 151:case 153:case 154:case 231:r=n.name;break;case 187:return function(t,n){var r=e.skipTrivia(t.text,n.pos);if(n.body&&207===n.body.kind){var i=e.getLineAndCharacterOfPosition(t,n.body.pos).line;if(i<e.getLineAndCharacterOfPosition(t,n.body.end).line)return e.createTextSpan(r,s(i,t)-r+1)}return e.createTextSpanFromBounds(r,n.end)}(t,n)}if(void 0===r)return T(t,n.pos);var a=c(r)?r.pos:e.skipTrivia(t.text,r.pos);return e.createTextSpanFromBounds(a,r.end)}function N(t){return!!(2&e.getCombinedNodeFlags(t))||!!(2048&e.getCombinedModifierFlags(t))}e.usingSingleLineStringWriter=function(e){var t=r.string();try{return e(r),r.string()}finally{r.clear(),r.writeKeyword(t)}},e.getFullWidth=i,e.getResolvedModule=function(e,t){return e&&e.resolvedModules&&e.resolvedModules.get(t)},e.setResolvedModule=function(t,n,r){t.resolvedModules||(t.resolvedModules=e.createMap()),t.resolvedModules.set(n,r)},e.setResolvedTypeReferenceDirective=function(t,n,r){t.resolvedTypeReferenceDirectiveNames||(t.resolvedTypeReferenceDirectiveNames=e.createMap()),t.resolvedTypeReferenceDirectiveNames.set(n,r)},e.moduleResolutionIsEqualTo=function(e,t){return e.isExternalLibraryImport===t.isExternalLibraryImport&&e.extension===t.extension&&e.resolvedFileName===t.resolvedFileName&&(n=e.packageId,r=t.packageId,n===r||n&&r&&n.name===r.name&&n.subModuleName===r.subModuleName&&n.version===r.version);var n,r},e.typeDirectiveIsEqualTo=function(e,t){return e.resolvedFileName===t.resolvedFileName&&e.primary===t.primary},e.hasChangesInResolutions=function(t,n,r,i){e.Debug.assert(t.length===n.length);for(var a=0;a<t.length;a++){var o=n[a],s=r&&r.get(t[a]);if(s?!o||!i(s,o):o)return!0}return!1},e.containsParseError=a,e.getSourceFileOfNode=o,e.isStatementWithLocals=function(e){switch(e.kind){case 207:case 235:case 214:case 215:case 216:return!0}return!1},e.getStartPositionOfLine=function(t,n){return e.Debug.assert(t>=0),e.getLineStarts(n)[t]},e.nodePosToString=function(t){var n=o(t),r=e.getLineAndCharacterOfPosition(n,t.pos);return n.fileName+"("+(r.line+1)+","+(r.character+1)+")"},e.getEndLinePosition=s,e.nodeIsMissing=c,e.nodeIsPresent=u,e.isRecognizedTripleSlashComment=function(t,n,r){if(47===t.charCodeAt(n+1)&&n+2<r&&47===t.charCodeAt(n+2)){var i=t.substring(n,r);return!!(i.match(e.fullTripleSlashReferencePathRegEx)||i.match(e.fullTripleSlashAMDReferencePathRegEx)||i.match(A)||i.match(w))}return!1},e.isPinnedComment=_,e.getTokenPosOfNode=l,e.getNonDecoratorTokenPosOfNode=function(t,n){return c(t)||!t.decorators?l(t,n):e.skipTrivia((n||o(t)).text,t.decorators.end)},e.getSourceTextOfNodeFromSourceFile=d,e.getTextOfNodeFromSourceText=p,e.getTextOfNode=f,e.indexOfNode=function(t,n){return e.binarySearch(t,n,m)},e.getEmitFlags=g,e.getLiteralText=function(t,n){if(!ue(t)&&t.parent)return d(n,t);var r=16777216&g(t)?he:Se;switch(t.kind){case 9:return t.singleQuote?"'"+r(t.text,39)+"'":'"'+r(t.text,34)+'"';case 13:return"`"+r(t.text,96)+"`";case 14:return"`"+r(t.text,96)+"${";case 15:return"}"+r(t.text,96)+"${";case 16:return"}"+r(t.text,96)+"`";case 8:case 12:return t.text}e.Debug.fail("Literal kind '"+t.kind+"' not accounted for.")},e.getTextOfConstantValue=function(t){return e.isString(t)?'"'+Se(t)+'"':""+t},e.escapeLeadingUnderscores=y,e.escapeIdentifier=function(e){return e},e.makeIdentifierFromModuleName=function(t){return e.getBaseFileName(t).replace(/^(\d)/,"_$1").replace(/\W/g,"_")},e.isBlockOrCatchScoped=function(t){return 0!=(3&e.getCombinedNodeFlags(t))||h(t)},e.isCatchClauseVariableDeclarationOrBindingElement=h,e.isAmbientModule=v,e.isModuleWithStringLiteralName=b,e.isNonGlobalAmbientModule=function(t){return e.isModuleDeclaration(t)&&e.isStringLiteral(t.name)},e.isShorthandAmbientModuleSymbol=function(e){return(t=e.valueDeclaration)&&233===t.kind&&!t.body;var t},e.isBlockScopedContainerTopLevel=function(t){return 265===t.kind||233===t.kind||e.isFunctionLike(t)},e.isGlobalScopeAugmentation=x,e.isExternalModuleAugmentation=function(t){if(!t||!v(t))return!1;switch(t.parent.kind){case 265:return e.isExternalModule(t.parent);case 234:return v(t.parent.parent)&&!e.isExternalModule(t.parent.parent.parent)}return!1},e.isEffectiveExternalModule=function(t,n){return e.isExternalModule(t)||n.isolatedModules},e.isBlockScope=k,e.isDeclarationWithTypeParameters=function(t){switch(t.kind){case 155:case 156:case 150:case 157:case 160:case 161:case 273:case 229:case 199:case 230:case 231:case 282:case 228:case 151:case 152:case 153:case 154:case 186:case 187:return!0;default:return e.assertTypeIsNever(t),!1}},e.isAnyImportSyntax=function(e){switch(e.kind){case 238:case 237:return!0;default:return!1}},e.getEnclosingBlockScopeContainer=function(e){for(var t=e.parent;t;){if(k(t,t.parent))return t;t=t.parent}},e.declarationNameToString=S,e.getNameFromIndexInfo=function(e){return e.declaration?S(e.declaration.parameters[0].name):void 0},e.getTextOfPropertyName=D,e.entityNameToString=function t(n){switch(n.kind){case 71:return 0===i(n)?e.idText(n):f(n);case 143:return t(n.left)+"."+t(n.right);case 179:return t(n.expression)+"."+t(n.name)}},e.createDiagnosticForNode=function(e,t,n,r,i){return C(o(e),e,t,n,r,i)},e.createDiagnosticForNodeInSourceFile=C,e.createDiagnosticForNodeFromMessageChain=function(e,t){var n=o(e),r=E(n,e);return{file:n,start:r.start,length:r.length,code:t.code,category:t.category,messageText:t.next?t:t.messageText}},e.getSpanOfTokenAtPosition=T,e.getErrorSpanForNode=E,e.isExternalOrCommonJsModule=function(e){return void 0!==(e.externalModuleIndicator||e.commonJsModuleIndicator)},e.isConstEnumDeclaration=function(e){return 232===e.kind&&N(e)},e.isConst=N,e.isLet=function(t){return!!(1&e.getCombinedNodeFlags(t))},e.isSuperCall=function(e){return 181===e.kind&&97===e.expression.kind},e.isImportCall=function(e){return 181===e.kind&&91===e.expression.kind},e.isPrologueDirective=function(e){return 210===e.kind&&9===e.expression.kind},e.getLeadingCommentRangesOfNode=function(t,n){return 10!==t.kind?e.getLeadingCommentRanges(n.text,t.pos):void 0},e.getJSDocCommentRanges=function(t,n){var r=146===t.kind||145===t.kind||186===t.kind||187===t.kind||185===t.kind?e.concatenate(e.getTrailingCommentRanges(n,t.pos),e.getLeadingCommentRanges(n,t.pos)):e.getLeadingCommentRanges(n,t.pos);return e.filter(r,(function(e){return 42===n.charCodeAt(e.pos+1)&&42===n.charCodeAt(e.pos+2)&&47!==n.charCodeAt(e.pos+3)}))},e.fullTripleSlashReferencePathRegEx=/^(\/\/\/\s*<reference\s+path\s*=\s*)('|")(.+?)\2.*?\/>/;var A=/^(\/\/\/\s*<reference\s+types\s*=\s*)('|")(.+?)\2.*?\/>/;e.fullTripleSlashAMDReferencePathRegEx=/^(\/\/\/\s*<amd-dependency\s+path\s*=\s*)('|")(.+?)\2.*?\/>/;var w=/^(\/\/\/\s*<reference\s+no-default-lib\s*=\s*)('|")(.+?)\2\s*\/>/;function P(t){if(158<=t.kind&&t.kind<=173)return!0;switch(t.kind){case 119:case 133:case 136:case 122:case 137:case 139:case 130:return!0;case 105:return 190!==t.parent.kind;case 201:return!Ye(t);case 71:(143===t.parent.kind&&t.parent.right===t||179===t.parent.kind&&t.parent.name===t)&&(t=t.parent),e.Debug.assert(71===t.kind||143===t.kind||179===t.kind,"'node' was expected to be a qualified name, identifier or property access in 'isPartOfTypeNode'.");case 143:case 179:case 99:var n=t.parent;if(162===n.kind)return!1;if(158<=n.kind&&n.kind<=173)return!0;switch(n.kind){case 201:return!Ye(n);case 145:return t===n.constraint;case 149:case 148:case 146:case 226:return t===n.type;case 228:case 186:case 187:case 152:case 151:case 150:case 153:case 154:return t===n.type;case 155:case 156:case 157:case 184:return t===n.type;case 181:case 182:return n.typeArguments&&e.indexOf(n.typeArguments,t)>=0;case 183:return!1}}return!1}function F(e){if(e)switch(e.kind){case 176:case 264:case 146:case 261:case 149:case 148:case 262:case 226:return!0}return!1}function O(t,n){for(;;){if(!(t=t.parent))return;switch(t.kind){case 144:if(e.isClassLike(t.parent.parent))return t;t=t.parent;break;case 147:146===t.parent.kind&&e.isClassElement(t.parent.parent)?t=t.parent.parent:e.isClassElement(t.parent)&&(t=t.parent);break;case 187:if(!n)continue;case 228:case 186:case 233:case 149:case 148:case 151:case 150:case 152:case 153:case 154:case 155:case 156:case 157:case 232:case 265:return t}}}function I(e){switch(e.kind){case 229:return!0;case 149:return 229===e.parent.kind;case 153:case 154:case 151:return void 0!==e.body&&229===e.parent.kind;case 146:return void 0!==e.parent.body&&(152===e.parent.kind||151===e.parent.kind||154===e.parent.kind)&&229===e.parent.parent.kind}return!1}function R(e){return void 0!==e.decorators&&I(e)}function L(e){return R(e)||M(e)}function M(t){switch(t.kind){case 229:return e.forEach(t.members,L);case 151:case 154:return e.forEach(t.parameters,R)}}function B(e){var t=e.parent;return(251===t.kind||250===t.kind||252===t.kind)&&t.tagName===e}function J(e){switch(e.kind){case 97:case 95:case 101:case 86:case 12:case 177:case 178:case 179:case 180:case 181:case 182:case 183:case 202:case 184:case 203:case 185:case 186:case 199:case 187:case 190:case 188:case 189:case 192:case 193:case 194:case 195:case 198:case 196:case 13:case 200:case 249:case 250:case 197:case 191:case 204:return!0;case 143:for(;143===e.parent.kind;)e=e.parent;return 162===e.parent.kind||B(e);case 71:if(162===e.parent.kind||B(e))return!0;case 8:case 9:case 99:return z(e);default:return!1}}function z(e){var t=e.parent;switch(t.kind){case 226:case 146:case 149:case 148:case 264:case 261:case 176:return t.initializer===e;case 210:case 211:case 212:case 213:case 219:case 220:case 221:case 257:case 223:return t.expression===e;case 214:var n=t;return n.initializer===e&&227!==n.initializer.kind||n.condition===e||n.incrementor===e;case 215:case 216:var r=t;return r.initializer===e&&227!==r.initializer.kind||r.expression===e;case 184:case 202:case 205:case 144:return e===t.expression;case 147:case 256:case 255:case 263:return!0;case 201:return t.expression===e&&Ye(t);default:return J(t)}}function j(e){return 237===e.kind&&248===e.moduleReference.kind}function K(e){return U(e)}function U(e){return e&&!!(65536&e.flags)}function V(e){if(!U(e))return 0;if(58!==e.operatorToken.kind||179!==e.left.kind)return 0;var t=e.left;if(71===t.expression.kind){var n=t.expression;return"exports"===n.escapedText?1:"module"===n.escapedText&&"exports"===t.name.escapedText?2:5}if(99===t.expression.kind)return 4;if(179===t.expression.kind){var r=t.expression;if(71===r.expression.kind){if("module"===r.expression.escapedText&&"exports"===r.name.escapedText)return 1;if("prototype"===r.name.escapedText)return 3}}return 0}function q(t){return e.isExpressionStatement(t)&&t.expression&&e.isBinaryExpression(t.expression)&&58===t.expression.operatorToken.kind&&t.expression.right}function W(t,n){return e.isVariableStatement(t)&&t.declarationList.declarations.length>0&&(!n||t.declarationList.declarations[0].initializer===n)&&t.declarationList.declarations[0].initializer}function H(t,n){return e.isVariableStatement(t)&&t.declarationList.declarations.length>0&&(!n||t.declarationList.declarations[0]===n)&&t.declarationList.declarations[0]}function G(e){return 233===e.kind&&e.body&&233===e.body.kind&&e.body}function Q(t){var n;return function t(r){var i=r.parent;i&&(261===i.kind||G(i))&&t(i);i&&i.parent&&(H(i.parent,r)||q(i.parent))&&t(i.parent);i&&i.parent&&i.parent.parent&&W(i.parent.parent,r)&&t(i.parent.parent);146===r.kind&&(n=e.addRange(n,e.getJSDocParameterTags(r)));F(r)&&r.initializer&&e.hasJSDocNodes(r.initializer)&&(n=e.addRange(n,r.initializer.jsDoc));e.hasJSDocNodes(r)&&(n=e.addRange(n,r.jsDoc))}(t),n||e.emptyArray}function X(t){return e.Debug.assert(275===t.parent.kind),t.parent.parent}function Y(e){return void 0!==e.dotDotDotToken}function Z(e){for(var t=e.parent;;){switch(t.kind){case 194:var n=t.operatorToken.kind;return Ge(n)&&t.left===e?58===n?1:2:0;case 192:case 193:var r=t.operator;return 43===r||44===r?2:0;case 215:case 216:return t.initializer===e?1:0;case 185:case 177:case 198:e=t;break;case 262:if(t.name!==e)return 0;e=t.parent;break;case 261:if(t.name===e)return 0;e=t.parent;break;default:return 0}t=e.parent}}function $(e){return Ze(e.expression)}function ee(e,t){if(e)for(var n=0,r=e;n<r.length;n++){var i=r[n];if(i.token===t)return i}}function te(e){var t=e.kind;return 9===t||8===t}function ne(t){var n=e.getNameOfDeclaration(t);return n&&re(n)}function re(e){return 144===e.kind&&!te(e.expression)&&!ie(e.expression)}function ie(t){return e.isPropertyAccessExpression(t)&&se(t.expression)}function ae(t){if(71===t.kind)return t.escapedText;if(9===t.kind||8===t.kind)return y(t.text);if(144===t.kind){var n=t.expression;if(ie(n))return oe(e.idText(n.name));if(9===n.kind||8===n.kind)return y(n.text)}}function oe(e){return"__@"+e}function se(e){return 71===e.kind&&"Symbol"===e.escapedText}function ce(e){for(;176===e.kind;)e=e.parent.parent;return e}function ue(t){return e.positionIsSynthesized(t.pos)||e.positionIsSynthesized(t.end)}function _e(e,t,n){switch(e){case 182:return n?0:1;case 192:case 189:case 190:case 188:case 191:case 195:case 197:return 1;case 194:switch(t){case 40:case 58:case 59:case 60:case 62:case 61:case 63:case 64:case 65:case 66:case 67:case 68:case 70:case 69:return 1}}return 0}function le(e){return 194===e.kind?e.operatorToken.kind:192===e.kind||193===e.kind?e.operator:e.kind}function de(e,t,n){switch(e){case 99:case 97:case 71:case 95:case 101:case 86:case 8:case 9:case 177:case 178:case 186:case 187:case 199:case 249:case 250:case 12:case 13:case 196:case 185:case 200:return 19;case 183:case 179:case 180:return 18;case 182:return n?18:17;case 181:return 17;case 193:return 16;case 192:case 189:case 190:case 188:case 191:return 15;case 194:switch(t){case 51:case 52:return 15;case 40:case 39:case 41:case 42:return 14;case 37:case 38:return 13;case 45:case 46:case 47:return 12;case 27:case 30:case 29:case 31:case 92:case 93:return 11;case 32:case 34:case 33:case 35:return 10;case 48:return 9;case 50:return 8;case 49:return 7;case 53:return 6;case 54:return 5;case 58:case 59:case 60:case 62:case 61:case 63:case 64:case 65:case 66:case 67:case 68:case 70:case 69:return 3;case 26:return 0;default:return-1}case 195:return 4;case 197:return 2;case 198:return 1;case 289:return 0;default:return-1}}e.isPartOfTypeNode=P,e.isChildOfNodeWithKind=function(e,t){for(;e;){if(e.kind===t)return!0;e=e.parent}return!1},e.forEachReturnStatement=function(t,n){return function t(r){switch(r.kind){case 219:return n(r);case 235:case 207:case 211:case 212:case 213:case 214:case 215:case 216:case 220:case 221:case 257:case 258:case 222:case 224:case 260:return e.forEachChild(r,t)}}(t)},e.forEachYieldExpression=function(t,n){return function t(r){switch(r.kind){case 197:n(r);var i=r.expression;return void(i&&t(i));case 232:case 230:case 233:case 231:case 229:case 199:return;default:if(e.isFunctionLike(r)){var a=r.name;if(a&&144===a.kind)return void t(a.expression)}else P(r)||e.forEachChild(r,t)}}(t)},e.getRestParameterElementType=function(t){return t&&164===t.kind?t.elementType:t&&159===t.kind?e.singleOrUndefined(t.typeArguments):void 0},e.isVariableLike=F,e.introducesArgumentsExoticObject=function(e){switch(e.kind){case 151:case 150:case 152:case 153:case 154:case 228:case 186:return!0}return!1},e.unwrapInnermostStatementOfLabel=function(e,t){for(;;){if(t&&t(e),222!==e.statement.kind)return e.statement;e=e.statement}},e.isFunctionBlock=function(t){return t&&207===t.kind&&e.isFunctionLike(t.parent)},e.isObjectLiteralMethod=function(e){return e&&151===e.kind&&178===e.parent.kind},e.isObjectLiteralOrClassExpressionMethod=function(e){return 151===e.kind&&(178===e.parent.kind||199===e.parent.kind)},e.isIdentifierTypePredicate=function(e){return e&&1===e.kind},e.isThisTypePredicate=function(e){return e&&0===e.kind},e.getPropertyAssignment=function(t,n,r){return e.filter(t.properties,(function(e){if(261===e.kind){var t=D(e.name);return n===t||r&&r===t}}))},e.getContainingFunction=function(t){return e.findAncestor(t.parent,e.isFunctionLike)},e.getContainingClass=function(t){return e.findAncestor(t.parent,e.isClassLike)},e.getThisContainer=O,e.getNewTargetContainer=function(e){var t=O(e,!1);if(t)switch(t.kind){case 152:case 228:case 186:return t}},e.getSuperContainer=function(t,n){for(;;){if(!(t=t.parent))return t;switch(t.kind){case 144:t=t.parent;break;case 228:case 186:case 187:if(!n)continue;case 149:case 148:case 151:case 150:case 152:case 153:case 154:return t;case 147:146===t.parent.kind&&e.isClassElement(t.parent.parent)?t=t.parent.parent:e.isClassElement(t.parent)&&(t=t.parent)}}},e.getImmediatelyInvokedFunctionExpression=function(e){if(186===e.kind||187===e.kind){for(var t=e,n=e.parent;185===n.kind;)t=n,n=n.parent;if(181===n.kind&&n.expression===t)return n}},e.isSuperProperty=function(e){var t=e.kind;return(179===t||180===t)&&97===e.expression.kind},e.getEntityNameFromTypeNode=function(e){switch(e.kind){case 159:return e.typeName;case 201:return Ze(e.expression)?e.expression:void 0;case 71:case 143:return e}},e.getInvokedExpression=function(t){return 183===t.kind?t.tag:e.isJsxOpeningLikeElement(t)?t.tagName:t.expression},e.nodeCanBeDecorated=I,e.nodeIsDecorated=R,e.nodeOrChildIsDecorated=L,e.childIsDecorated=M,e.isJSXTagName=B,e.isPartOfExpression=J,e.isInExpressionContext=z,e.isExternalModuleImportEqualsDeclaration=j,e.getExternalModuleImportEqualsDeclarationExpression=function(t){return e.Debug.assert(j(t)),t.moduleReference.expression},e.isInternalModuleImportEqualsDeclaration=function(e){return 237===e.kind&&248!==e.moduleReference.kind},e.isSourceFileJavaScript=K,e.isInJavaScriptFile=U,e.isInJSDoc=function(e){return e&&!!(1048576&e.flags)},e.isJSDocIndexSignature=function(t){return e.isTypeReferenceNode(t)&&e.isIdentifier(t.typeName)&&"Object"===t.typeName.escapedText&&t.typeArguments&&2===t.typeArguments.length&&(136===t.typeArguments[0].kind||133===t.typeArguments[0].kind)},e.isRequireCall=function(e,t){if(181!==e.kind)return!1;var n=e,r=n.expression,i=n.arguments;if(71!==r.kind||"require"!==r.escapedText)return!1;if(1!==i.length)return!1;var a=i[0];return!t||9===a.kind||13===a.kind},e.isSingleOrDoubleQuote=function(e){return 39===e||34===e},e.isStringDoubleQuoted=function(e,t){return 34===d(t,e).charCodeAt(0)},e.isDeclarationOfFunctionOrClassExpression=function(e){if(e.valueDeclaration&&226===e.valueDeclaration.kind){var t=e.valueDeclaration;return t.initializer&&(186===t.initializer.kind||199===t.initializer.kind)}return!1},e.getRightMostAssignedExpression=function(e){for(;Xe(e,!0);)e=e.right;return e},e.isExportsIdentifier=function(t){return e.isIdentifier(t)&&"exports"===t.escapedText},e.isModuleExportsPropertyAccessExpression=function(t){return e.isPropertyAccessExpression(t)&&e.isIdentifier(t.expression)&&"module"===t.expression.escapedText&&"exports"===t.name.escapedText},e.getSpecialPropertyAssignmentKind=V,e.getExternalModuleName=function(e){if(238===e.kind)return e.moduleSpecifier;if(237===e.kind){var t=e.moduleReference;if(248===t.kind)return t.expression}return 244===e.kind?e.moduleSpecifier:b(e)?e.name:void 0},e.getNamespaceDeclarationNode=function(e){if(237===e.kind)return e;var t=e.importClause;return t&&t.namedBindings&&240===t.namedBindings.kind?t.namedBindings:void 0},e.isDefaultImport=function(e){return 238===e.kind&&e.importClause&&!!e.importClause.name},e.hasQuestionToken=function(e){if(e)switch(e.kind){case 146:case 151:case 150:case 262:case 261:case 149:case 148:return void 0!==e.questionToken}return!1},e.isJSDocConstructSignature=function(e){return 273===e.kind&&e.parameters.length>0&&e.parameters[0].name&&"new"===e.parameters[0].name.escapedText},e.getAllJSDocs=function(t){return e.isJSDocTypedefTag(t)?[t.parent]:Q(t)},e.getSourceOfAssignment=q,e.getSingleInitializerOfVariableStatement=W,e.getSingleVariableOfVariableStatement=H,e.getNestedModuleDeclaration=G,e.getJSDocCommentsAndTags=Q,e.getParameterSymbolFromJSDoc=function(t){if(t.symbol)return t.symbol;if(e.isIdentifier(t.name)){var n=t.name.escapedText,r=X(t),i=q(r)||W(r)||H(r)||G(r)||r;if(i&&e.isFunctionLike(i)){var a=e.find(i.parameters,(function(e){return 71===e.name.kind&&e.name.escapedText===n}));return a&&a.symbol}}},e.getJSDocHost=X,e.getTypeParameterFromJsDoc=function(t){var n=t.name.escapedText,r=t.parent.parent.parent.typeParameters;return e.find(r,(function(e){return e.name.escapedText===n}))},e.hasRestParameter=function(t){var n=e.lastOrUndefined(t.parameters);return n&&Y(n)},e.isRestParameter=Y,function(e){e[e.None=0]="None",e[e.Definite=1]="Definite",e[e.Compound=2]="Compound"}(e.AssignmentKind||(e.AssignmentKind={})),e.getAssignmentTargetKind=Z,e.isAssignmentTarget=function(e){return 0!==Z(e)},e.isDeleteTarget=function(e){if(179!==e.kind&&180!==e.kind)return!1;for(e=e.parent;e&&185===e.kind;)e=e.parent;return e&&188===e.kind},e.isNodeDescendantOf=function(e,t){for(;e;){if(e===t)return!0;e=e.parent}return!1},e.isInAmbientContext=function(e){for(;e;){if(Ue(e,2)||265===e.kind&&e.isDeclarationFile)return!0;e=e.parent}return!1},e.isDeclarationName=function(t){switch(t.kind){case 71:case 9:case 8:return e.isDeclaration(t.parent)&&t.parent.name===t;default:return!1}},e.isAnyDeclarationName=function(t){switch(t.kind){case 71:case 9:case 8:if(e.isDeclaration(t.parent))return t.parent.name===t;var n=t.parent.parent;return e.isBinaryExpression(n)&&0!==V(n)&&e.getNameOfDeclaration(n)===t;default:return!1}},e.isLiteralComputedPropertyDeclarationName=function(t){return(9===t.kind||8===t.kind)&&144===t.parent.kind&&e.isDeclaration(t.parent.parent)},e.isIdentifierName=function(e){var t=e.parent;switch(t.kind){case 149:case 148:case 151:case 150:case 153:case 154:case 264:case 261:case 179:return t.name===e;case 143:if(t.right===e){for(;143===t.kind;)t=t.parent;return 162===t.kind}return!1;case 176:case 242:return t.propertyName===e;case 246:case 253:return!0}return!1},e.isAliasSymbolDeclaration=function(e){return 237===e.kind||236===e.kind||239===e.kind&&!!e.name||240===e.kind||242===e.kind||246===e.kind||243===e.kind&&$(e)},e.exportAssignmentIsAlias=$,e.getClassExtendsHeritageClauseElement=function(e){var t=ee(e.heritageClauses,85);return t&&t.types.length>0?t.types[0]:void 0},e.getClassImplementsHeritageClauseElements=function(e){var t=ee(e.heritageClauses,108);return t?t.types:void 0},e.getInterfaceBaseTypeNodes=function(e){var t=ee(e.heritageClauses,85);return t?t.types:void 0},e.getHeritageClause=ee,e.tryResolveScriptReference=function(t,n,r){if(!t.getCompilerOptions().noResolve){var i=e.isRootedDiskPath(r.fileName)?r.fileName:e.combinePaths(e.getDirectoryPath(n.fileName),r.fileName);return t.getSourceFile(i)}},e.getAncestor=function(e,t){for(;e;){if(e.kind===t)return e;e=e.parent}},e.getFileReferenceFromReferencePath=function(t,n){var r=new RegExp(w.source,"gim");if(/^\/\/\/\s*<reference\s+/gim.test(t)){if(r.test(t))return{isNoDefaultLib:!0};var i=e.fullTripleSlashReferencePathRegEx.exec(t),a=!i&&A.exec(t),o=i||a;if(o){var s=n.pos+o[1].length+o[2].length;return{fileReference:{pos:s,end:s+o[3].length,fileName:o[3]},isNoDefaultLib:!1,isTypeReferenceDirective:!!a}}return{diagnosticMessage:e.Diagnostics.Invalid_reference_directive_syntax,isNoDefaultLib:!1}}},e.isKeyword=function(e){return 72<=e&&e<=142},e.isTrivia=function(e){return 2<=e&&e<=7},function(e){e[e.Normal=0]="Normal",e[e.Generator=1]="Generator",e[e.Async=2]="Async",e[e.Invalid=4]="Invalid",e[e.AsyncGenerator=3]="AsyncGenerator"}(e.FunctionFlags||(e.FunctionFlags={})),e.getFunctionFlags=function(e){if(!e)return 4;var t=0;switch(e.kind){case 228:case 186:case 151:e.asteriskToken&&(t|=1);case 187:Ue(e,256)&&(t|=2)}return e.body||(t|=4),t},e.isAsyncFunction=function(e){switch(e.kind){case 228:case 186:case 187:case 151:return void 0!==e.body&&void 0===e.asteriskToken&&Ue(e,256)}return!1},e.isStringOrNumericLiteral=te,e.hasDynamicName=ne,e.isDynamicName=re,e.isWellKnownSymbolSyntactically=ie,e.getPropertyNameForPropertyNameNode=ae,e.getTextOfIdentifierOrLiteral=function(t){if(t){if(71===t.kind)return e.idText(t);if(9===t.kind||8===t.kind)return t.text}},e.getEscapedTextOfIdentifierOrLiteral=function(e){if(e){if(71===e.kind)return e.escapedText;if(9===e.kind||8===e.kind)return y(e.text)}},e.getPropertyNameForKnownSymbolName=oe,e.isESSymbolIdentifier=se,e.isPushOrUnshiftIdentifier=function(e){return"push"===e.escapedText||"unshift"===e.escapedText},e.isParameterDeclaration=function(e){return 146===ce(e).kind},e.getRootDeclaration=ce,e.nodeStartsNewLexicalEnvironment=function(e){var t=e.kind;return 152===t||186===t||228===t||187===t||151===t||153===t||154===t||233===t||265===t},e.nodeIsSynthesized=ue,e.getOriginalSourceFile=function(t){return e.getParseTreeNode(t,e.isSourceFile)||t},function(e){e[e.Left=0]="Left",e[e.Right=1]="Right"}(e.Associativity||(e.Associativity={})),e.getExpressionAssociativity=function(e){var t=le(e),n=182===e.kind&&void 0!==e.arguments;return _e(e.kind,t,n)},e.getOperatorAssociativity=_e,e.getExpressionPrecedence=function(e){var t=le(e),n=182===e.kind&&void 0!==e.arguments;return de(e.kind,t,n)},e.getOperator=le,e.getOperatorPrecedence=de,e.createDiagnosticCollection=function(){var t=[],n=e.createMap(),r=!1,i=0;return{add:function(e){var a;e.file?(a=n.get(e.file.fileName))||(a=[],n.set(e.file.fileName,a)):a=t;a.push(e),r=!0,i++},getGlobalDiagnostics:function(){return a(),t},getDiagnostics:function(r){if(a(),r)return n.get(r)||[];var i=[];function o(e){i.push(e)}return e.forEach(t,o),n.forEach((function(t){e.forEach(t,o)})),e.sortAndDeduplicateDiagnostics(i)},getModificationCount:function(){return i},reattachFileDiagnostics:function(t){e.forEach(n.get(t.fileName),(function(e){return e.file=t}))}};function a(){r&&(r=!1,t=e.sortAndDeduplicateDiagnostics(t),n.forEach((function(t,r){n.set(r,e.sortAndDeduplicateDiagnostics(t))})))}};var pe=/[\\\"\u0000-\u001f\t\v\f\b\r\n\u2028\u2029\u0085]/g,fe=/[\\\'\u0000-\u001f\t\v\f\b\r\n\u2028\u2029\u0085]/g,me=/[\\\`\u0000-\u001f\t\v\f\b\r\n\u2028\u2029\u0085]/g,ge=e.createMapFromTemplate({"\0":"\\0","\t":"\\t","\v":"\\v","\f":"\\f","\b":"\\b","\r":"\\r","\n":"\\n","\\":"\\\\",'"':'\\"',"'":"\\'","`":"\\`","\u2028":"\\u2028","\u2029":"\\u2029","":"\\u0085"}),ye=/\\0[0-9]/g;function he(e,t){var n=96===t?me:39===t?fe:pe;return e.replace(n,be).replace(ye,ve)}function ve(e){return"\\x00"+e.charAt(e.length-1)}function be(e){return ge.get(e)||xe(e.charCodeAt(0))}function xe(e){return"\\u"+("0000"+e.toString(16).toUpperCase()).slice(-4)}e.escapeString=he,e.isIntrinsicJsxName=function(e){var t=e.substr(0,1);return t.toLowerCase()===t};var ke=/[^\u0000-\u007F]/g;function Se(e,t){return e=he(e,t),ke.test(e)?e.replace(ke,(function(e){return xe(e.charCodeAt(0))})):e}e.escapeNonAsciiString=Se;var De=["","    "];function Ce(e){return void 0===De[e]&&(De[e]=Ce(e-1)+De[1]),De[e]}function Te(){return De[1].length}function Ee(e,t){return t.moduleName||Ne(e,t.fileName)}function Ne(t,n){var r=function(e){return t.getCanonicalFileName(e)},i=e.toPath(t.getCommonSourceDirectory(),t.getCurrentDirectory(),r),a=e.getNormalizedAbsolutePath(n,t.getCurrentDirectory()),o=e.getRelativePathToDirectoryOrUrl(i,a,i,r,!1);return e.removeFileExtension(o)}function Ae(e,t,n){return!(t.noEmitForJsFiles&&K(e)||e.isDeclarationFile||n(e))}function we(t,n,r){var i=e.getNormalizedAbsolutePath(t.fileName,n.getCurrentDirectory()),a=n.getCommonSourceDirectory();return i=0===n.getCanonicalFileName(i).indexOf(n.getCanonicalFileName(a))?i.substring(a.length):i,e.combinePaths(r,i)}function Pe(t,n){return e.getLineAndCharacterOfPosition(t,n).line}function Fe(t,n){return e.computeLineAndCharacterOfPosition(t,n).line}function Oe(e){if(e&&e.parameters.length>0){var t=2===e.parameters.length&&Ie(e.parameters[0]);return e.parameters[t?1:0]}}function Ie(e){return Re(e.name)}function Re(e){return e&&71===e.kind&&Le(e)}function Le(e){return 99===e.originalKeywordKind}function Me(t,n){return t.type?t.type:n||U(t)?e.getJSDocType(t):void 0}function Be(e,t,n,r){Je(e,t,n.pos,r)}function Je(e,t,n,r){r&&r.length&&n!==r[0].pos&&Fe(e,n)!==Fe(e,r[0].pos)&&t.writeLine()}function ze(e,t,n,r,i,a,o,s){if(r&&r.length>0){i&&n.write(" ");for(var c=!1,u=0,_=r;u<_.length;u++){var l=_[u];c&&(n.write(" "),c=!1),s(e,t,n,l.pos,l.end,o),l.hasTrailingNewLine?n.writeLine():c=!0}c&&a&&n.write(" ")}}function je(e,t,n,r,i,a){var o=Math.min(t,a-1),s=e.substring(i,o).replace(/^\s+|\s+$/g,"");s?(n.write(s),o!==t&&n.writeLine()):n.writeLiteral(r)}function Ke(t,n,r){for(var i=0;n<r&&e.isWhiteSpaceSingleLine(t.charCodeAt(n));n++)9===t.charCodeAt(n)?i+=Te()-i%Te():i++;return i}function Ue(e,t){return!!Ve(e,t)}function Ve(e,t){return qe(e)&t}function qe(e){if(536870912&e.modifierFlagsCache)return-536870913&e.modifierFlagsCache;var t=We(e);return e.modifierFlagsCache=536870912|t,t}function We(e){var t=0;if(e.modifiers)for(var n=0,r=e.modifiers;n<r.length;n++){t|=He(r[n].kind)}return(4&e.flags||71===e.kind&&e.isInJSDocNamespace)&&(t|=1),t}function He(e){switch(e){case 115:return 32;case 114:return 4;case 113:return 16;case 112:return 8;case 117:return 128;case 84:return 1;case 124:return 2;case 76:return 2048;case 79:return 512;case 120:return 256;case 131:return 64}return 0}function Ge(e){return e>=58&&e<=70}function Qe(t){if(201===t.kind&&85===t.parent.token&&e.isClassLike(t.parent.parent))return t.parent.parent}function Xe(t,n){return e.isBinaryExpression(t)&&(n?58===t.operatorToken.kind:Ge(t.operatorToken.kind))&&e.isLeftHandSideExpression(t.left)}function Ye(e){return void 0!==Qe(e)}function Ze(e){return 71===e.kind||179===e.kind&&Ze(e.expression)}e.getIndentString=Ce,e.getIndentSize=Te,e.createTextWriter=function(t){var n,r,i,a,o;function s(e){e&&e.length&&(i&&(n+=Ce(r),i=!1),n+=e)}function c(){n="",r=0,i=!0,a=0,o=0}return c(),{write:s,rawWrite:function(e){void 0!==e&&(i&&(i=!1),n+=e)},writeTextOfNode:function(e,t){s(p(e,t))},writeLiteral:function(t){if(t&&t.length){s(t);var r=e.computeLineStarts(t);r.length>1&&(a=a+r.length-1,o=n.length-t.length+e.lastOrUndefined(r))}},writeLine:function(){i||(a++,o=(n+=t).length,i=!0)},increaseIndent:function(){r++},decreaseIndent:function(){r--},getIndent:function(){return r},getTextPos:function(){return n.length},getLine:function(){return a+1},getColumn:function(){return i?r*Te()+1:n.length-o+1},getText:function(){return n},isAtStartOfLine:function(){return i},reset:c}},e.getResolvedExternalModuleName=Ee,e.getExternalModuleNameFromDeclaration=function(e,t,n){var r=t.getExternalModuleFileFromDeclaration(n);if(r&&!r.isDeclarationFile)return Ee(e,r)},e.getExternalModuleNameFromPath=Ne,e.getOwnEmitOutputFilePath=function(t,n,r){var i=n.getCompilerOptions();return(i.outDir?e.removeFileExtension(we(t,n,i.outDir)):e.removeFileExtension(t.fileName))+r},e.getDeclarationEmitOutputFilePath=function(t,n){var r=n.getCompilerOptions(),i=r.declarationDir||r.outDir,a=i?we(t,n,i):t.fileName;return e.removeFileExtension(a)+".d.ts"},e.getSourceFilesToEmit=function(t,n){var r=t.getCompilerOptions(),i=function(e){return t.isSourceFileFromExternalLibrary(e)};if(r.outFile||r.out){var a=e.getEmitModuleKind(r),o=a===e.ModuleKind.AMD||a===e.ModuleKind.System;return e.filter(t.getSourceFiles(),(function(t){return(o||!e.isExternalModule(t))&&Ae(t,r,i)}))}var s=void 0===n?t.getSourceFiles():[n];return e.filter(s,(function(e){return Ae(e,r,i)}))},e.sourceFileMayBeEmitted=Ae,e.getSourceFilePathInNewDir=we,e.writeFile=function(t,n,r,i,a,o){t.writeFile(r,i,a,(function(t){n.add(e.createCompilerDiagnostic(e.Diagnostics.Could_not_write_file_0_Colon_1,r,t))}),o)},e.getLineOfLocalPosition=Pe,e.getLineOfLocalPositionFromLineMap=Fe,e.getFirstConstructorWithBody=function(t){return e.forEach(t.members,(function(e){if(152===e.kind&&u(e.body))return e}))},e.getSetAccessorTypeAnnotationNode=function(e){var t=Oe(e);return t&&t.type},e.getThisParameter=function(e){if(e.parameters.length){var t=e.parameters[0];if(Ie(t))return t}},e.parameterIsThisKeyword=Ie,e.isThisIdentifier=Re,e.identifierIsThisKeyword=Le,e.getAllAccessorDeclarations=function(t,n){var r,i,a,o;return ne(n)?(r=n,153===n.kind?a=n:154===n.kind?o=n:e.Debug.fail("Accessor has wrong kind")):e.forEach(t,(function(e){153!==e.kind&&154!==e.kind||Ue(e,32)!==Ue(n,32)||ae(e.name)===ae(n.name)&&(r?i||(i=e):r=e,153!==e.kind||a||(a=e),154!==e.kind||o||(o=e))})),{firstAccessor:r,secondAccessor:i,getAccessor:a,setAccessor:o}},e.getEffectiveTypeAnnotationNode=Me,e.getEffectiveReturnTypeNode=function(t,n){return t.type?t.type:n||U(t)?e.getJSDocReturnType(t):void 0},e.getEffectiveTypeParameterDeclarations=function(t,n){if(t.typeParameters)return t.typeParameters;if(n||U(t)){var r=e.getJSDocTemplateTag(t);return r&&r.typeParameters}},e.getEffectiveSetAccessorTypeAnnotationNode=function(e,t){var n=Oe(e);return n&&Me(n,t)},e.emitNewLineBeforeLeadingComments=Be,e.emitNewLineBeforeLeadingCommentsOfPosition=Je,e.emitNewLineBeforeLeadingCommentOfPosition=function(e,t,n,r){n!==r&&Fe(e,n)!==Fe(e,r)&&t.writeLine()},e.emitComments=ze,e.emitDetachedComments=function(t,n,r,i,a,o,s){var c,u;if(s?0===a.pos&&(c=e.filter(e.getLeadingCommentRanges(t,a.pos),(function(e){return _(t,e)}))):c=e.getLeadingCommentRanges(t,a.pos),c){for(var l=[],d=void 0,p=0,f=c;p<f.length;p++){var m=f[p];if(d){var g=Fe(n,d.end);if(Fe(n,m.pos)>=g+2)break}l.push(m),d=m}if(l.length){g=Fe(n,e.lastOrUndefined(l).end);Fe(n,e.skipTrivia(t,a.pos))>=g+2&&(Be(n,r,a,c),ze(t,n,r,l,!1,!0,o,i),u={nodePos:a.pos,detachedCommentEndPos:e.lastOrUndefined(l).end})}}return u},e.writeCommentRange=function(t,n,r,i,a,o){if(42===t.charCodeAt(i+1))for(var s=e.computeLineAndCharacterOfPosition(n,i),c=n.length,u=void 0,_=i,l=s.line;_<a;l++){var d=l+1===c?t.length+1:n[l+1];if(_!==i){void 0===u&&(u=Ke(t,n[s.line],i));var p=r.getIndent()*Te()-u+Ke(t,_,d);if(p>0){var f=p%Te(),m=Ce((p-f)/Te());for(r.rawWrite(m);f;)r.rawWrite(" "),f--}else r.rawWrite("")}je(t,a,r,o,_,d),_=d}else r.write(t.substring(i,a))},e.hasModifiers=function(e){return 0!==qe(e)},e.hasModifier=Ue,e.getSelectedModifierFlags=Ve,e.getModifierFlags=qe,e.getModifierFlagsNoCache=We,e.modifierToFlag=He,e.isLogicalOperator=function(e){return 54===e||53===e||51===e},e.isAssignmentOperator=Ge,e.tryGetClassExtendingExpressionWithTypeArguments=Qe,e.isAssignmentExpression=Xe,e.isDestructuringAssignment=function(e){if(Xe(e,!0)){var t=e.left.kind;return 178===t||177===t}return!1},e.isExpressionWithTypeArgumentsInClassExtendsClause=Ye,e.isExpressionWithTypeArgumentsInClassImplementsClause=function(t){return 201===t.kind&&Ze(t.expression)&&t.parent&&108===t.parent.token&&t.parent.parent&&e.isClassLike(t.parent.parent)},e.isEntityNameExpression=Ze,e.isRightSideOfQualifiedNameOrPropertyAccess=function(e){return 143===e.parent.kind&&e.parent.right===e||179===e.parent.kind&&e.parent.name===e},e.isEmptyObjectLiteral=function(e){return 178===e.kind&&0===e.properties.length},e.isEmptyArrayLiteral=function(e){return 177===e.kind&&0===e.elements.length},e.getLocalSymbolForExportDefault=function(t){return function(t){return t&&e.length(t.declarations)>0&&Ue(t.declarations[0],512)}(t)?t.declarations[0].localSymbol:void 0},e.tryExtractTypeScriptExtension=function(t){return e.find(e.supportedTypescriptExtensionsForExtractExtension,(function(n){return e.fileExtensionIs(t,n)}))};var $e="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";e.convertToBase64=function(t){for(var n,r,i,a,o="",s=function(t){for(var n=[],r=t.length,i=0;i<r;i++){var a=t.charCodeAt(i);a<128?n.push(a):a<2048?(n.push(a>>6|192),n.push(63&a|128)):a<65536?(n.push(a>>12|224),n.push(a>>6&63|128),n.push(63&a|128)):a<131072?(n.push(a>>18|240),n.push(a>>12&63|128),n.push(a>>6&63|128),n.push(63&a|128)):e.Debug.assert(!1,"Unexpected code point")}return n}(t),c=0,u=s.length;c<u;)n=s[c]>>2,r=(3&s[c])<<4|s[c+1]>>4,i=(15&s[c+1])<<2|s[c+2]>>6,a=63&s[c+2],c+1>=u?i=a=64:c+2>=u&&(a=64),o+=$e.charAt(n)+$e.charAt(r)+$e.charAt(i)+$e.charAt(a),c+=3;return o};var et;function tt(t,n,r){void 0===t&&(t=0);var i=function(t){var n=[];for(var r in t){var i=t[r];"number"==typeof i&&n.push([i,r])}return e.stableSort(n,(function(t,n){return e.compareValues(t[0],n[0])}))}(n);if(0===t)return i.length>0&&0===i[0][0]?i[0][1]:"0";if(r){for(var a="",o=t,s=i.length-1;s>=0&&0!==o;s--){var c=i[s],u=c[0],_=c[1];0!==u&&(o&u)===u&&(o&=~u,a=_+(a?", ":"")+a)}if(0===o)return a}else for(var l=0,d=i;l<d.length;l++){var p=d[l];u=p[0],_=p[1];if(u===t)return _}return t.toString()}function nt(e,t){return{pos:e,end:t}}function rt(e,t){return nt(t,e.end)}function it(e){return e.decorators&&e.decorators.length>0?rt(e,e.decorators.end):e}function at(e,t,n){return ot(st(e,n),t.end,n)}function ot(e,t,n){return e===t||Pe(n,e)===Pe(n,t)}function st(t,n){return e.positionIsSynthesized(t.pos)?-1:e.skipTrivia(n.text,t.pos)}function ct(e){return void 0!==e.initializer}function ut(e){return 33554432&e.flags?e.checkFlags:0}function _t(e){var t=e.parent;if(!t)return 0;switch(t.kind){case 193:case 192:var n=t.operator;return 43===n||44===n?o():0;case 194:var r=t,i=r.left,a=r.operatorToken;return i===e&&Ge(a.kind)?o():0;case 179:return t.name!==e?0:_t(t);default:return 0}function o(){return t.parent&&210===t.parent.kind?1:2}}e.getNewLineCharacter=function(t,n){switch(t.newLine){case 0:return"\r\n";case 1:return"\n"}return n?n.newLine:e.sys?e.sys.newLine:"\r\n"},e.formatSyntaxKind=function(t){return tt(t,e.SyntaxKind,!1)},e.formatModifierFlags=function(t){return tt(t,e.ModifierFlags,!0)},e.formatTransformFlags=function(t){return tt(t,e.TransformFlags,!0)},e.formatEmitFlags=function(t){return tt(t,e.EmitFlags,!0)},e.formatSymbolFlags=function(t){return tt(t,e.SymbolFlags,!0)},e.formatTypeFlags=function(t){return tt(t,e.TypeFlags,!0)},e.formatObjectFlags=function(t){return tt(t,e.ObjectFlags,!0)},e.createRange=nt,e.moveRangeEnd=function(e,t){return nt(e.pos,t)},e.moveRangePos=rt,e.moveRangePastDecorators=it,e.moveRangePastModifiers=function(e){return e.modifiers&&e.modifiers.length>0?rt(e,e.modifiers.end):it(e)},e.isCollapsedRange=function(e){return e.pos===e.end},e.createTokenRange=function(t,n){return nt(t,t+e.tokenToString(n).length)},e.rangeIsOnSingleLine=function(e,t){return at(e,e,t)},e.rangeStartPositionsAreOnSameLine=function(e,t,n){return ot(st(e,n),st(t,n),n)},e.rangeEndPositionsAreOnSameLine=function(e,t,n){return ot(e.end,t.end,n)},e.rangeStartIsOnSameLineAsRangeEnd=at,e.rangeEndIsOnSameLineAsRangeStart=function(e,t,n){return ot(e.end,st(t,n),n)},e.positionsAreOnSameLine=ot,e.getStartPositionOfRange=st,e.isDeclarationNameOfEnumOrNamespace=function(t){var n=e.getParseTreeNode(t);if(n)switch(n.parent.kind){case 232:case 233:return n===n.parent.name}return!1},e.getInitializedVariables=function(t){return e.filter(t.declarations,ct)},e.isWatchSet=function(e){return e.watch&&e.hasOwnProperty("watch")},e.getCheckFlags=ut,e.getDeclarationModifierFlagsFromSymbol=function(t){if(t.valueDeclaration){var n=e.getCombinedModifierFlags(t.valueDeclaration);return t.parent&&32&t.parent.flags?n:-29&n}if(6&ut(t)){var r=t.checkFlags;return(256&r?8:64&r?4:16)|(512&r?32:0)}return 4194304&t.flags?36:0},e.levenshtein=function(e,t){for(var n=new Array(t.length+1),r=new Array(t.length+1),i=0;i<t.length+1;i++)n[i]=i,r[i]=-1;for(i=1;i<e.length+1;i++){r[0]=i;for(var a=1;a<t.length+1;a++)r[a]=Math.min(n[a]+1,r[a-1]+1,n[a-1]+(e[i-1]===t[a-1]?0:2));var o=n;n=r,r=o}return n[n.length-1]},e.skipAlias=function(e,t){return 2097152&e.flags?t.getAliasedSymbol(e):e},e.getCombinedLocalAndExportSymbolFlags=function(e){return e.exportSymbol?e.exportSymbol.flags|e.flags:e.flags},e.isWriteOnlyAccess=function(e){return 1===_t(e)},e.isWriteAccess=function(e){return 0!==_t(e)},function(e){e[e.Read=0]="Read",e[e.Write=1]="Write",e[e.ReadWrite=2]="ReadWrite"}(et||(et={})),e.compareDataObjects=function e(t,n){if(!t||!n||Object.keys(t).length!==Object.keys(n).length)return!1;for(var r in t)if("object"==typeof t[r]){if(!e(t[r],n[r]))return!1}else if("function"!=typeof t[r]&&t[r]!==n[r])return!1;return!0},e.clearMap=function(e,t){e.forEach(t),e.clear()},e.mutateMap=function(e,t,n){var r=n.createNewValue,i=n.onDeleteValue,a=n.onExistingValue;e.forEach((function(n,r){var o=t.get(r);void 0===o?(e.delete(r),i(n,r)):a&&a(n,o,r)})),t.forEach((function(t,n){e.has(n)||e.set(n,r(n,t))}))},e.forEachAncestorDirectory=function(t,n){for(;;){var r=n(t);if(void 0!==r)return r;var i=e.getDirectoryPath(t);if(i===t)return;t=i}}}(ts||(ts={})),function(e){function t(e){return e.start+e.length}function n(e){return 0===e.length}function r(e,t){if(e<0)throw new Error("start < 0");if(t<0)throw new Error("length < 0");return{start:e,length:t}}function i(e,t){return r(e,t-e)}function a(e,t){if(t<0)throw new Error("newLength < 0");return{span:e,newLength:t}}function o(t){return!!e.isBindingPattern(t)&&e.every(t.elements,s)}function s(t){return!!e.isOmittedExpression(t)||o(t.name)}function c(t){for(;t&&(176===t.kind||e.isBindingPattern(t));)t=t.parent;return t}function u(e,t){if(e)for(;void 0!==e.original;)e=e.original;return!t||t(e)?e:void 0}function _(e){return 0==(8&e.flags)}function l(e){var t=e;return t.length>=3&&95===t.charCodeAt(0)&&95===t.charCodeAt(1)&&95===t.charCodeAt(2)?t.substr(1):t}function d(t){var n=f(t);return e.isIdentifier(n)?n:void 0}function p(t){return t.name||function(t){var n=t.parent.parent;if(n){if(e.isDeclaration(n))return d(n);switch(n.kind){case 208:return n.declarationList&&n.declarationList.declarations[0]?d(n.declarationList.declarations[0]):void 0;case 210:var r=n.expression;switch(r.kind){case 179:return r.name;case 180:var i=r.argumentExpression;if(e.isIdentifier(i))return i}return;case 1:return;case 185:return d(n.expression);case 222:return e.isDeclaration(n.statement)||e.isExpression(n.statement)?d(n.statement):void 0;default:e.Debug.assertNever(n,"Found typedef tag attached to node which it should not be!")}}}(t)}function f(t){if(t){switch(t.kind){case 284:case 279:var n=t.name;if(143===n.kind)return n.right;break;case 194:var r=t;switch(e.getSpecialPropertyAssignmentKind(r)){case 1:case 4:case 5:case 3:return r.left.name;default:return}case 283:return p(t);case 243:var i=t.expression;return e.isIdentifier(i)?i:void 0}return t.name}}function m(t){if(t.name&&e.isIdentifier(t.name)){var n=t.name.escapedText;return y(t.parent).filter((function(t){return e.isJSDocParameterTag(t)&&e.isIdentifier(t.name)&&t.name.escapedText===n}))}}function g(e){return h(e,280)}function y(t){var n=t.jsDocCache;return void 0===n&&(t.jsDocCache=n=e.flatMap(e.getJSDocCommentsAndTags(t),(function(t){return e.isJSDoc(t)?t.tags:t}))),n}function h(t,n){var r=y(t);return e.find(r,(function(e){return e.kind===n}))}e.getDefaultLibFileName=function(e){switch(e.target){case 5:return"lib.esnext.full.d.ts";case 4:return"lib.es2017.full.d.ts";case 3:return"lib.es2016.full.d.ts";case 2:return"lib.es6.d.ts";default:return"lib.d.ts"}},e.textSpanEnd=t,e.textSpanIsEmpty=n,e.textSpanContainsPosition=function(e,n){return n>=e.start&&n<t(e)},e.textSpanContainsTextSpan=function(e,n){return n.start>=e.start&&t(n)<=t(e)},e.textSpanOverlapsWith=function(e,n){return Math.max(e.start,n.start)<Math.min(t(e),t(n))},e.textSpanOverlap=function(e,n){var r=Math.max(e.start,n.start),a=Math.min(t(e),t(n));if(r<a)return i(r,a)},e.textSpanIntersectsWithTextSpan=function(e,n){return n.start<=t(e)&&t(n)>=e.start},e.textSpanIntersectsWith=function(e,n,r){var i=n+r;return n<=t(e)&&i>=e.start},e.decodedTextSpanIntersectsWith=function(e,t,n,r){return n<=e+t&&n+r>=e},e.textSpanIntersectsWithPosition=function(e,n){return n<=t(e)&&n>=e.start},e.textSpanIntersection=function(e,n){var r=Math.max(e.start,n.start),a=Math.min(t(e),t(n));if(r<=a)return i(r,a)},e.createTextSpan=r,e.createTextSpanFromBounds=i,e.textChangeRangeNewSpan=function(e){return r(e.span.start,e.newLength)},e.textChangeRangeIsUnchanged=function(e){return n(e.span)&&0===e.newLength},e.createTextChangeRange=a,e.unchangedTextChangeRange=a(r(0,0),0),e.collapseTextChangeRangesAcrossMultipleVersions=function(n){if(0===n.length)return e.unchangedTextChangeRange;if(1===n.length)return n[0];for(var r=n[0],o=r.span.start,s=t(r.span),c=o+r.newLength,u=1;u<n.length;u++){var _=n[u],l=o,d=s,p=c,f=_.span.start,m=t(_.span),g=f+_.newLength;o=Math.min(l,f),s=Math.max(d,d+(m-p)),c=Math.max(g,g+(p-m))}return a(i(o,s),c-o)},e.getTypeParameterOwner=function(t){if(t&&145===t.kind)for(var n=t;n;n=n.parent)if(e.isFunctionLike(n)||e.isClassLike(n)||230===n.kind)return n},e.isParameterPropertyDeclaration=function(t){return e.hasModifier(t,92)&&152===t.parent.kind&&e.isClassLike(t.parent.parent)},e.isEmptyBindingPattern=o,e.isEmptyBindingElement=s,e.getCombinedModifierFlags=function(t){t=c(t);var n=e.getModifierFlags(t);return 226===t.kind&&(t=t.parent),t&&227===t.kind&&(n|=e.getModifierFlags(t),t=t.parent),t&&208===t.kind&&(n|=e.getModifierFlags(t)),n},e.getCombinedNodeFlags=function(e){var t=(e=c(e)).flags;return 226===e.kind&&(e=e.parent),e&&227===e.kind&&(t|=e.flags,e=e.parent),e&&208===e.kind&&(t|=e.flags),t},e.validateLocaleAndSetLanguage=function(t,n,r){var i=/^([a-z]+)([_\-]([a-z]+))?$/.exec(t.toLowerCase());if(i){var a=i[1];o(a,i[3],r)||o(a,void 0,r)}else r&&r.push(e.createCompilerDiagnostic(e.Diagnostics.Locale_must_be_of_the_form_language_or_language_territory_For_example_0_or_1,"en","ja-jp"));function o(t,r,i){var a=e.normalizePath(n.getExecutingFilePath()),o=e.getDirectoryPath(a),s=e.combinePaths(o,t);if(r&&(s=s+"-"+r),s=n.resolvePath(e.combinePaths(s,"diagnosticMessages.generated.json")),!n.fileExists(s))return!1;var c="";try{c=n.readFile(s)}catch(t){return i&&i.push(e.createCompilerDiagnostic(e.Diagnostics.Unable_to_open_file_0,s)),!1}try{e.localizedDiagnosticMessages=JSON.parse(c)}catch(t){return i&&i.push(e.createCompilerDiagnostic(e.Diagnostics.Corrupted_locale_file_0,s)),!1}return!0}},e.getOriginalNode=u,e.isParseTreeNode=_,e.getParseTreeNode=function(e,t){return void 0===e||_(e)?e:!_(e=u(e))||t&&!t(e)?void 0:e},e.unescapeLeadingUnderscores=l,e.idText=function(e){return l(e.escapedText)},e.symbolName=function(e){return l(e.escapedName)},e.unescapeIdentifier=function(e){return e},e.getNameOfJSDocTypedef=p,e.getNameOfDeclaration=f,e.getJSDocParameterTags=m,e.hasJSDocParameterTags=function(e){return!!h(e,279)},e.getJSDocAugmentsTag=function(e){return h(e,277)},e.getJSDocClassTag=function(e){return h(e,278)},e.getJSDocReturnTag=g,e.getJSDocTemplateTag=function(e){return h(e,282)},e.getJSDocTypeTag=function(e){var t=h(e,281);if(t&&t.typeExpression&&t.typeExpression.type)return t},e.getJSDocType=function(t){var n=h(t,281);if(!n&&146===t.kind){var r=m(t);r&&(n=e.find(r,(function(e){return!!e.typeExpression})))}return n&&n.typeExpression&&n.typeExpression.type},e.getJSDocReturnType=function(e){var t=g(e);return t&&t.typeExpression&&t.typeExpression.type},e.getJSDocTags=y,e.getAllJSDocTagsOfKind=function(t,n){var r=y(t);return e.filter(r,(function(e){return e.kind===n}))}}(ts||(ts={})),function(e){e.isNumericLiteral=function(e){return 8===e.kind},e.isStringLiteral=function(e){return 9===e.kind},e.isJsxText=function(e){return 10===e.kind},e.isRegularExpressionLiteral=function(e){return 12===e.kind},e.isNoSubstitutionTemplateLiteral=function(e){return 13===e.kind},e.isTemplateHead=function(e){return 14===e.kind},e.isTemplateMiddle=function(e){return 15===e.kind},e.isTemplateTail=function(e){return 16===e.kind},e.isIdentifier=function(e){return 71===e.kind},e.isQualifiedName=function(e){return 143===e.kind},e.isComputedPropertyName=function(e){return 144===e.kind},e.isTypeParameterDeclaration=function(e){return 145===e.kind},e.isParameter=function(e){return 146===e.kind},e.isDecorator=function(e){return 147===e.kind},e.isPropertySignature=function(e){return 148===e.kind},e.isPropertyDeclaration=function(e){return 149===e.kind},e.isMethodSignature=function(e){return 150===e.kind},e.isMethodDeclaration=function(e){return 151===e.kind},e.isConstructorDeclaration=function(e){return 152===e.kind},e.isGetAccessorDeclaration=function(e){return 153===e.kind},e.isSetAccessorDeclaration=function(e){return 154===e.kind},e.isCallSignatureDeclaration=function(e){return 155===e.kind},e.isConstructSignatureDeclaration=function(e){return 156===e.kind},e.isIndexSignatureDeclaration=function(e){return 157===e.kind},e.isTypePredicateNode=function(e){return 158===e.kind},e.isTypeReferenceNode=function(e){return 159===e.kind},e.isFunctionTypeNode=function(e){return 160===e.kind},e.isConstructorTypeNode=function(e){return 161===e.kind},e.isTypeQueryNode=function(e){return 162===e.kind},e.isTypeLiteralNode=function(e){return 163===e.kind},e.isArrayTypeNode=function(e){return 164===e.kind},e.isTupleTypeNode=function(e){return 165===e.kind},e.isUnionTypeNode=function(e){return 166===e.kind},e.isIntersectionTypeNode=function(e){return 167===e.kind},e.isParenthesizedTypeNode=function(e){return 168===e.kind},e.isThisTypeNode=function(e){return 169===e.kind},e.isTypeOperatorNode=function(e){return 170===e.kind},e.isIndexedAccessTypeNode=function(e){return 171===e.kind},e.isMappedTypeNode=function(e){return 172===e.kind},e.isLiteralTypeNode=function(e){return 173===e.kind},e.isObjectBindingPattern=function(e){return 174===e.kind},e.isArrayBindingPattern=function(e){return 175===e.kind},e.isBindingElement=function(e){return 176===e.kind},e.isArrayLiteralExpression=function(e){return 177===e.kind},e.isObjectLiteralExpression=function(e){return 178===e.kind},e.isPropertyAccessExpression=function(e){return 179===e.kind},e.isElementAccessExpression=function(e){return 180===e.kind},e.isCallExpression=function(e){return 181===e.kind},e.isNewExpression=function(e){return 182===e.kind},e.isTaggedTemplateExpression=function(e){return 183===e.kind},e.isTypeAssertion=function(e){return 184===e.kind},e.isParenthesizedExpression=function(e){return 185===e.kind},e.skipPartiallyEmittedExpressions=function(e){for(;288===e.kind;)e=e.expression;return e},e.isFunctionExpression=function(e){return 186===e.kind},e.isArrowFunction=function(e){return 187===e.kind},e.isDeleteExpression=function(e){return 188===e.kind},e.isTypeOfExpression=function(e){return 191===e.kind},e.isVoidExpression=function(e){return 190===e.kind},e.isAwaitExpression=function(e){return 191===e.kind},e.isPrefixUnaryExpression=function(e){return 192===e.kind},e.isPostfixUnaryExpression=function(e){return 193===e.kind},e.isBinaryExpression=function(e){return 194===e.kind},e.isConditionalExpression=function(e){return 195===e.kind},e.isTemplateExpression=function(e){return 196===e.kind},e.isYieldExpression=function(e){return 197===e.kind},e.isSpreadElement=function(e){return 198===e.kind},e.isClassExpression=function(e){return 199===e.kind},e.isOmittedExpression=function(e){return 200===e.kind},e.isExpressionWithTypeArguments=function(e){return 201===e.kind},e.isAsExpression=function(e){return 202===e.kind},e.isNonNullExpression=function(e){return 203===e.kind},e.isMetaProperty=function(e){return 204===e.kind},e.isTemplateSpan=function(e){return 205===e.kind},e.isSemicolonClassElement=function(e){return 206===e.kind},e.isBlock=function(e){return 207===e.kind},e.isVariableStatement=function(e){return 208===e.kind},e.isEmptyStatement=function(e){return 209===e.kind},e.isExpressionStatement=function(e){return 210===e.kind},e.isIfStatement=function(e){return 211===e.kind},e.isDoStatement=function(e){return 212===e.kind},e.isWhileStatement=function(e){return 213===e.kind},e.isForStatement=function(e){return 214===e.kind},e.isForInStatement=function(e){return 215===e.kind},e.isForOfStatement=function(e){return 216===e.kind},e.isContinueStatement=function(e){return 217===e.kind},e.isBreakStatement=function(e){return 218===e.kind},e.isReturnStatement=function(e){return 219===e.kind},e.isWithStatement=function(e){return 220===e.kind},e.isSwitchStatement=function(e){return 221===e.kind},e.isLabeledStatement=function(e){return 222===e.kind},e.isThrowStatement=function(e){return 223===e.kind},e.isTryStatement=function(e){return 224===e.kind},e.isDebuggerStatement=function(e){return 225===e.kind},e.isVariableDeclaration=function(e){return 226===e.kind},e.isVariableDeclarationList=function(e){return 227===e.kind},e.isFunctionDeclaration=function(e){return 228===e.kind},e.isClassDeclaration=function(e){return 229===e.kind},e.isInterfaceDeclaration=function(e){return 230===e.kind},e.isTypeAliasDeclaration=function(e){return 231===e.kind},e.isEnumDeclaration=function(e){return 232===e.kind},e.isModuleDeclaration=function(e){return 233===e.kind},e.isModuleBlock=function(e){return 234===e.kind},e.isCaseBlock=function(e){return 235===e.kind},e.isNamespaceExportDeclaration=function(e){return 236===e.kind},e.isImportEqualsDeclaration=function(e){return 237===e.kind},e.isImportDeclaration=function(e){return 238===e.kind},e.isImportClause=function(e){return 239===e.kind},e.isNamespaceImport=function(e){return 240===e.kind},e.isNamedImports=function(e){return 241===e.kind},e.isImportSpecifier=function(e){return 242===e.kind},e.isExportAssignment=function(e){return 243===e.kind},e.isExportDeclaration=function(e){return 244===e.kind},e.isNamedExports=function(e){return 245===e.kind},e.isExportSpecifier=function(e){return 246===e.kind},e.isMissingDeclaration=function(e){return 247===e.kind},e.isExternalModuleReference=function(e){return 248===e.kind},e.isJsxElement=function(e){return 249===e.kind},e.isJsxSelfClosingElement=function(e){return 250===e.kind},e.isJsxOpeningElement=function(e){return 251===e.kind},e.isJsxClosingElement=function(e){return 252===e.kind},e.isJsxAttribute=function(e){return 253===e.kind},e.isJsxAttributes=function(e){return 254===e.kind},e.isJsxSpreadAttribute=function(e){return 255===e.kind},e.isJsxExpression=function(e){return 256===e.kind},e.isCaseClause=function(e){return 257===e.kind},e.isDefaultClause=function(e){return 258===e.kind},e.isHeritageClause=function(e){return 259===e.kind},e.isCatchClause=function(e){return 260===e.kind},e.isPropertyAssignment=function(e){return 261===e.kind},e.isShorthandPropertyAssignment=function(e){return 262===e.kind},e.isSpreadAssignment=function(e){return 263===e.kind},e.isEnumMember=function(e){return 264===e.kind},e.isSourceFile=function(e){return 265===e.kind},e.isBundle=function(e){return 266===e.kind},e.isJSDocTypeExpression=function(e){return 267===e.kind},e.isJSDocAllType=function(e){return 268===e.kind},e.isJSDocUnknownType=function(e){return 269===e.kind},e.isJSDocNullableType=function(e){return 270===e.kind},e.isJSDocNonNullableType=function(e){return 271===e.kind},e.isJSDocOptionalType=function(e){return 272===e.kind},e.isJSDocFunctionType=function(e){return 273===e.kind},e.isJSDocVariadicType=function(e){return 274===e.kind},e.isJSDoc=function(e){return 275===e.kind},e.isJSDocAugmentsTag=function(e){return 277===e.kind},e.isJSDocParameterTag=function(e){return 279===e.kind},e.isJSDocReturnTag=function(e){return 280===e.kind},e.isJSDocTypeTag=function(e){return 281===e.kind},e.isJSDocTemplateTag=function(e){return 282===e.kind},e.isJSDocTypedefTag=function(e){return 283===e.kind},e.isJSDocPropertyTag=function(e){return 284===e.kind},e.isJSDocPropertyLikeTag=function(e){return 284===e.kind||279===e.kind},e.isJSDocTypeLiteral=function(e){return 285===e.kind}}(ts||(ts={})),function(e){function t(e){return e>=143}function n(e){return 8<=e&&e<=13}function r(e){switch(e){case 117:case 120:case 76:case 124:case 79:case 84:case 114:case 112:case 113:case 131:case 115:return!0}return!1}function i(e){return e&&o(e.kind)}function a(e){switch(e){case 228:case 151:case 152:case 153:case 154:case 186:case 187:return!0;default:return!1}}function o(e){switch(e){case 150:case 155:case 156:case 157:case 160:case 273:case 161:return!0;default:return a(e)}}function s(e){switch(e.kind){case 174:case 178:return!0}return!1}function c(e){switch(e.kind){case 175:case 177:return!0}return!1}function u(e){switch(e){case 179:case 180:case 182:case 181:case 249:case 250:case 183:case 177:case 185:case 178:case 199:case 186:case 71:case 12:case 8:case 9:case 13:case 196:case 86:case 95:case 99:case 101:case 97:case 203:case 204:case 91:return!0;default:return!1}}function _(e){switch(e){case 192:case 193:case 188:case 189:case 190:case 191:case 184:return!0;default:return u(e)}}function l(t){return function(e){switch(e){case 195:case 197:case 187:case 194:case 198:case 202:case 200:case 289:case 288:return!0;default:return _(e)}}(e.skipPartiallyEmittedExpressions(t).kind)}function d(e){return 288===e.kind}function p(e){return 287===e.kind}function f(e){return 228===e||247===e||229===e||230===e||231===e||232===e||233===e||238===e||237===e||244===e||243===e||236===e}function m(e){return 218===e||217===e||225===e||212===e||210===e||209===e||215===e||216===e||214===e||211===e||222===e||219===e||221===e||223===e||224===e||208===e||213===e||220===e||287===e||291===e||290===e}function g(e){return e.kind>=276&&e.kind<=285}e.isSyntaxList=function(e){return 286===e.kind},e.isNode=function(e){return t(e.kind)},e.isNodeKind=t,e.isToken=function(e){return e.kind>=0&&e.kind<=142},e.isNodeArray=function(e){return e.hasOwnProperty("pos")&&e.hasOwnProperty("end")},e.isLiteralKind=n,e.isLiteralExpression=function(e){return n(e.kind)},e.isTemplateLiteralKind=function(e){return 13<=e&&e<=16},e.isTemplateMiddleOrTemplateTail=function(e){var t=e.kind;return 15===t||16===t},e.isStringTextContainingNode=function(e){switch(e.kind){case 9:case 14:case 15:case 16:case 13:return!0;default:return!1}},e.isGeneratedIdentifier=function(t){return e.isIdentifier(t)&&t.autoGenerateKind>0},e.isModifierKind=r,e.isModifier=function(e){return r(e.kind)},e.isEntityName=function(e){var t=e.kind;return 143===t||71===t},e.isPropertyName=function(e){var t=e.kind;return 71===t||9===t||8===t||144===t},e.isBindingName=function(e){var t=e.kind;return 71===t||174===t||175===t},e.isFunctionLike=i,e.isFunctionLikeDeclaration=function(e){return e&&a(e.kind)},e.isFunctionLikeKind=o,e.isFunctionOrModuleBlock=function(t){return e.isSourceFile(t)||e.isModuleBlock(t)||e.isBlock(t)&&i(t.parent)},e.isClassElement=function(e){var t=e.kind;return 152===t||149===t||151===t||153===t||154===t||157===t||206===t||247===t},e.isClassLike=function(e){return e&&(229===e.kind||199===e.kind)},e.isAccessor=function(e){return e&&(153===e.kind||154===e.kind)},e.isTypeElement=function(e){var t=e.kind;return 156===t||155===t||148===t||150===t||157===t||247===t},e.isObjectLiteralElementLike=function(e){var t=e.kind;return 261===t||262===t||263===t||151===t||153===t||154===t||247===t},e.isTypeNode=function(e){return(t=e.kind)>=158&&t<=173||119===t||133===t||134===t||122===t||136===t||137===t||99===t||105===t||139===t||95===t||130===t||201===t||268===t||269===t||270===t||271===t||272===t||273===t||274===t;var t},e.isFunctionOrConstructorTypeNode=function(e){switch(e.kind){case 160:case 161:return!0}return!1},e.isBindingPattern=function(e){if(e){var t=e.kind;return 175===t||174===t}return!1},e.isAssignmentPattern=function(e){var t=e.kind;return 177===t||178===t},e.isArrayBindingElement=function(e){var t=e.kind;return 176===t||200===t},e.isDeclarationBindingElement=function(e){switch(e.kind){case 226:case 146:case 176:return!0}return!1},e.isBindingOrAssignmentPattern=function(e){return s(e)||c(e)},e.isObjectBindingOrAssignmentPattern=s,e.isArrayBindingOrAssignmentPattern=c,e.isPropertyAccessOrQualifiedName=function(e){var t=e.kind;return 179===t||143===t},e.isCallLikeExpression=function(e){switch(e.kind){case 251:case 250:case 181:case 182:case 183:case 147:return!0;default:return!1}},e.isCallOrNewExpression=function(e){return 181===e.kind||182===e.kind},e.isTemplateLiteral=function(e){var t=e.kind;return 196===t||13===t},e.isLeftHandSideExpression=function(t){return u(e.skipPartiallyEmittedExpressions(t).kind)},e.isUnaryExpression=function(t){return _(e.skipPartiallyEmittedExpressions(t).kind)},e.isUnaryExpressionWithWrite=function(e){switch(e.kind){case 193:return!0;case 192:return 43===e.operator||44===e.operator;default:return!1}},e.isExpression=l,e.isAssertionExpression=function(e){var t=e.kind;return 184===t||202===t},e.isPartiallyEmittedExpression=d,e.isNotEmittedStatement=p,e.isNotEmittedOrPartiallyEmittedNode=function(e){return p(e)||d(e)},e.isIterationStatement=function e(t,n){switch(t.kind){case 214:case 215:case 216:case 212:case 213:return!0;case 222:return n&&e(t.statement,n)}return!1},e.isForInOrOfStatement=function(e){return 215===e.kind||216===e.kind},e.isConciseBody=function(t){return e.isBlock(t)||l(t)},e.isFunctionBody=function(t){return e.isBlock(t)},e.isForInitializer=function(t){return e.isVariableDeclarationList(t)||l(t)},e.isModuleBody=function(e){var t=e.kind;return 234===t||233===t||71===t},e.isNamespaceBody=function(e){var t=e.kind;return 234===t||233===t},e.isJSDocNamespaceBody=function(e){var t=e.kind;return 71===t||233===t},e.isNamedImportBindings=function(e){var t=e.kind;return 241===t||240===t},e.isModuleOrEnumDeclaration=function(e){return 233===e.kind||232===e.kind},e.isDeclaration=function(t){return 145===t.kind?282!==t.parent.kind||e.isInJavaScriptFile(t):187===(n=t.kind)||176===n||229===n||199===n||152===n||232===n||264===n||246===n||228===n||186===n||153===n||239===n||237===n||242===n||230===n||253===n||151===n||150===n||233===n||236===n||240===n||146===n||261===n||149===n||148===n||154===n||262===n||231===n||145===n||226===n||283===n;var n},e.isDeclarationStatement=function(e){return f(e.kind)},e.isStatementButNotDeclaration=function(e){return m(e.kind)},e.isStatement=function(t){var n=t.kind;return m(n)||f(n)||function(t){if(207!==t.kind)return!1;if(void 0!==t.parent&&(224===t.parent.kind||260===t.parent.kind))return!1;return!e.isFunctionBlock(t)}(t)},e.isModuleReference=function(e){var t=e.kind;return 248===t||143===t||71===t},e.isJsxTagNameExpression=function(e){var t=e.kind;return 99===t||71===t||179===t},e.isJsxChild=function(e){var t=e.kind;return 249===t||256===t||250===t||10===t},e.isJsxAttributeLike=function(e){var t=e.kind;return 253===t||255===t},e.isStringLiteralOrJsxExpression=function(e){var t=e.kind;return 9===t||256===t},e.isJsxOpeningLikeElement=function(e){var t=e.kind;return 251===t||250===t},e.isCaseOrDefaultClause=function(e){var t=e.kind;return 257===t||258===t},e.isJSDocNode=function(e){return e.kind>=267&&e.kind<=285},e.isJSDocCommentContainingNode=function(e){return 275===e.kind||g(e)},e.isJSDocTag=g,e.isSetAccessor=function(e){return 154===e.kind},e.isGetAccessor=function(e){return 153===e.kind},e.hasJSDocNodes=function(e){return!!e.jsDoc&&e.jsDoc.length>0}}(ts||(ts={})),function(e){var t,n,r,i,a,o,s;function c(e,t){return t&&e(t)}function u(e,t,n){if(n){if(t)return t(n);for(var r=0,i=n;r<i.length;r++){var a=e(i[r]);if(a)return a}}}function _(e,t,n){if(e&&!(e.kind<=142))switch(e.kind){case 143:return c(t,e.left)||c(t,e.right);case 145:return c(t,e.name)||c(t,e.constraint)||c(t,e.default)||c(t,e.expression);case 262:return u(t,n,e.decorators)||u(t,n,e.modifiers)||c(t,e.name)||c(t,e.questionToken)||c(t,e.equalsToken)||c(t,e.objectAssignmentInitializer);case 263:return c(t,e.expression);case 146:case 149:case 148:case 261:case 226:case 176:return u(t,n,e.decorators)||u(t,n,e.modifiers)||c(t,e.propertyName)||c(t,e.dotDotDotToken)||c(t,e.name)||c(t,e.questionToken)||c(t,e.type)||c(t,e.initializer);case 160:case 161:case 155:case 156:case 157:return u(t,n,e.decorators)||u(t,n,e.modifiers)||u(t,n,e.typeParameters)||u(t,n,e.parameters)||c(t,e.type);case 151:case 150:case 152:case 153:case 154:case 186:case 228:case 187:return u(t,n,e.decorators)||u(t,n,e.modifiers)||c(t,e.asteriskToken)||c(t,e.name)||c(t,e.questionToken)||u(t,n,e.typeParameters)||u(t,n,e.parameters)||c(t,e.type)||c(t,e.equalsGreaterThanToken)||c(t,e.body);case 159:return c(t,e.typeName)||u(t,n,e.typeArguments);case 158:return c(t,e.parameterName)||c(t,e.type);case 162:return c(t,e.exprName);case 163:return u(t,n,e.members);case 164:return c(t,e.elementType);case 165:return u(t,n,e.elementTypes);case 166:case 167:return u(t,n,e.types);case 168:case 170:return c(t,e.type);case 171:return c(t,e.objectType)||c(t,e.indexType);case 172:return c(t,e.readonlyToken)||c(t,e.typeParameter)||c(t,e.questionToken)||c(t,e.type);case 173:return c(t,e.literal);case 174:case 175:case 177:return u(t,n,e.elements);case 178:return u(t,n,e.properties);case 179:return c(t,e.expression)||c(t,e.name);case 180:return c(t,e.expression)||c(t,e.argumentExpression);case 181:case 182:return c(t,e.expression)||u(t,n,e.typeArguments)||u(t,n,e.arguments);case 183:return c(t,e.tag)||c(t,e.template);case 184:return c(t,e.type)||c(t,e.expression);case 185:case 188:case 189:case 190:return c(t,e.expression);case 192:return c(t,e.operand);case 197:return c(t,e.asteriskToken)||c(t,e.expression);case 191:return c(t,e.expression);case 193:return c(t,e.operand);case 194:return c(t,e.left)||c(t,e.operatorToken)||c(t,e.right);case 202:return c(t,e.expression)||c(t,e.type);case 203:return c(t,e.expression);case 204:return c(t,e.name);case 195:return c(t,e.condition)||c(t,e.questionToken)||c(t,e.whenTrue)||c(t,e.colonToken)||c(t,e.whenFalse);case 198:return c(t,e.expression);case 207:case 234:return u(t,n,e.statements);case 265:return u(t,n,e.statements)||c(t,e.endOfFileToken);case 208:return u(t,n,e.decorators)||u(t,n,e.modifiers)||c(t,e.declarationList);case 227:return u(t,n,e.declarations);case 210:return c(t,e.expression);case 211:return c(t,e.expression)||c(t,e.thenStatement)||c(t,e.elseStatement);case 212:return c(t,e.statement)||c(t,e.expression);case 213:return c(t,e.expression)||c(t,e.statement);case 214:return c(t,e.initializer)||c(t,e.condition)||c(t,e.incrementor)||c(t,e.statement);case 215:return c(t,e.initializer)||c(t,e.expression)||c(t,e.statement);case 216:return c(t,e.awaitModifier)||c(t,e.initializer)||c(t,e.expression)||c(t,e.statement);case 217:case 218:return c(t,e.label);case 219:return c(t,e.expression);case 220:return c(t,e.expression)||c(t,e.statement);case 221:return c(t,e.expression)||c(t,e.caseBlock);case 235:return u(t,n,e.clauses);case 257:return c(t,e.expression)||u(t,n,e.statements);case 258:return u(t,n,e.statements);case 222:return c(t,e.label)||c(t,e.statement);case 223:return c(t,e.expression);case 224:return c(t,e.tryBlock)||c(t,e.catchClause)||c(t,e.finallyBlock);case 260:return c(t,e.variableDeclaration)||c(t,e.block);case 147:return c(t,e.expression);case 229:case 199:case 230:return u(t,n,e.decorators)||u(t,n,e.modifiers)||c(t,e.name)||u(t,n,e.typeParameters)||u(t,n,e.heritageClauses)||u(t,n,e.members);case 231:return u(t,n,e.decorators)||u(t,n,e.modifiers)||c(t,e.name)||u(t,n,e.typeParameters)||c(t,e.type);case 232:return u(t,n,e.decorators)||u(t,n,e.modifiers)||c(t,e.name)||u(t,n,e.members);case 264:return c(t,e.name)||c(t,e.initializer);case 233:return u(t,n,e.decorators)||u(t,n,e.modifiers)||c(t,e.name)||c(t,e.body);case 237:return u(t,n,e.decorators)||u(t,n,e.modifiers)||c(t,e.name)||c(t,e.moduleReference);case 238:return u(t,n,e.decorators)||u(t,n,e.modifiers)||c(t,e.importClause)||c(t,e.moduleSpecifier);case 239:return c(t,e.name)||c(t,e.namedBindings);case 236:case 240:return c(t,e.name);case 241:case 245:return u(t,n,e.elements);case 244:return u(t,n,e.decorators)||u(t,n,e.modifiers)||c(t,e.exportClause)||c(t,e.moduleSpecifier);case 242:case 246:return c(t,e.propertyName)||c(t,e.name);case 243:return u(t,n,e.decorators)||u(t,n,e.modifiers)||c(t,e.expression);case 196:return c(t,e.head)||u(t,n,e.templateSpans);case 205:return c(t,e.expression)||c(t,e.literal);case 144:return c(t,e.expression);case 259:return u(t,n,e.types);case 201:return c(t,e.expression)||u(t,n,e.typeArguments);case 248:return c(t,e.expression);case 247:return u(t,n,e.decorators);case 289:return u(t,n,e.elements);case 249:return c(t,e.openingElement)||u(t,n,e.children)||c(t,e.closingElement);case 250:case 251:return c(t,e.tagName)||c(t,e.attributes);case 254:return u(t,n,e.properties);case 253:return c(t,e.name)||c(t,e.initializer);case 255:return c(t,e.expression);case 256:return c(t,e.dotDotDotToken)||c(t,e.expression);case 252:return c(t,e.tagName);case 267:case 271:case 270:case 272:return c(t,e.type);case 273:return u(t,n,e.parameters)||c(t,e.type);case 274:return c(t,e.type);case 275:return u(t,n,e.tags);case 279:case 284:return e.isNameFirst?c(t,e.name)||c(t,e.typeExpression):c(t,e.typeExpression)||c(t,e.name);case 280:case 281:return c(t,e.typeExpression);case 277:return c(t,e.class);case 282:return u(t,n,e.typeParameters);case 283:return e.typeExpression&&267===e.typeExpression.kind?c(t,e.typeExpression)||c(t,e.fullName):c(t,e.fullName)||c(t,e.typeExpression);case 285:if(e.jsDocPropertyTags)for(var r=0,i=e.jsDocPropertyTags;r<i.length;r++){c(t,i[r])}return;case 288:return c(t,e.expression)}}!function(e){e[e.None=0]="None",e[e.Yield=1]="Yield",e[e.Await=2]="Await",e[e.Type=4]="Type",e[e.RequireCompleteParameterList=8]="RequireCompleteParameterList",e[e.IgnoreMissingOpenBrace=16]="IgnoreMissingOpenBrace",e[e.JSDoc=32]="JSDoc"}(t||(t={})),e.createNode=function(t,o,s){return 265===t?new(a||(a=e.objectAllocator.getSourceFileConstructor()))(t,o,s):71===t?new(i||(i=e.objectAllocator.getIdentifierConstructor()))(t,o,s):e.isNodeKind(t)?new(n||(n=e.objectAllocator.getNodeConstructor()))(t,o,s):new(r||(r=e.objectAllocator.getTokenConstructor()))(t,o,s)},e.forEachChild=_,e.createSourceFile=function(t,n,r,i,a){void 0===i&&(i=!1),e.performance.mark("beforeParse");var s=o.parseSourceFile(t,n,r,void 0,i,a);return e.performance.mark("afterParse"),e.performance.measure("Parse","beforeParse","afterParse"),s},e.parseIsolatedEntityName=function(e,t){return o.parseIsolatedEntityName(e,t)},e.parseJsonText=function(e,t){return o.parseJsonText(e,t)},e.isExternalModule=function(e){return void 0!==e.externalModuleIndicator},e.updateSourceFile=function(e,t,n,r){var i=s.updateSourceFile(e,t,n,r);return i.flags|=524288&e.flags,i},e.parseIsolatedJSDocComment=function(e,t,n){var r=o.JSDocParser.parseIsolatedJSDocComment(e,t,n);return r&&r.jsDoc&&o.fixupParentReferences(r.jsDoc),r},e.parseJSDocTypeExpressionForTests=function(e,t,n){return o.JSDocParser.parseJSDocTypeExpressionForTests(e,t,n)},function(t){var n,r,i,a,o,s,c,u,l,d,p,f,m,g,y,h,v,b=e.createScanner(5,!0),x=10240,k=!1;function S(e){return 4===e||2===e||1===e||6===e?1:0}function D(t,o,u,_){n=e.objectAllocator.getNodeConstructor(),r=e.objectAllocator.getTokenConstructor(),i=e.objectAllocator.getIdentifierConstructor(),a=e.objectAllocator.getSourceFileConstructor(),l=t,c=u,s=[],m=0,p=e.createMap(),f=0,d=0,g=1===_||2===_||6===_?65536:0,k=!1,b.setText(l),b.setOnError(q),b.setScriptTarget(o),b.setLanguageVariant(S(_))}function C(){b.setText(""),b.setOnError(void 0),s=void 0,o=void 0,p=void 0,c=void 0,l=void 0}function T(t){var n=e.getJSDocCommentRanges(t,o.text);if(n)for(var r=0,i=n;r<i.length;r++){var a=i[r],s=v.parseJSDocComment(t,a.pos,a.end-a.pos);s&&(t.jsDoc||(t.jsDoc=[]),t.jsDoc.push(s))}return t}function E(t){var n=t;return void _(t,(function t(r){if(r.parent!==n){r.parent=n;var i=n;if(n=r,_(r,t),e.hasJSDocNodes(r))for(var a=0,o=r.jsDoc;a<o.length;a++){var s=o[a];s.parent=r,n=s,_(s,t)}n=i}}))}function N(t,n,r){var i=new a(265,0,l.length);return d++,i.text=l,i.bindDiagnostics=[],i.languageVersion=n,i.fileName=e.normalizePath(t),i.languageVariant=S(r),i.isDeclarationFile=e.fileExtensionIs(i.fileName,".d.ts"),i.scriptKind=r,i}function A(e,t){e?g|=t:g&=~t}function w(e){A(e,2048)}function P(e){A(e,4096)}function F(e){A(e,8192)}function O(e){A(e,16384)}function I(e,t){var n=e&g;if(n){A(!1,n);var r=t();return A(!0,n),r}return t()}function R(e,t){var n=e&~g;if(n){A(!0,n);var r=t();return A(!1,n),r}return t()}function L(e){return I(2048,e)}function M(e){return R(16384,e)}function B(e){return 0!=(g&e)}function J(){return B(4096)}function z(){return B(2048)}function j(){return B(8192)}function K(){return B(16384)}function U(e,t){var n=b.getTokenPos();V(n,b.getTextPos()-n,e,t)}function V(t,n,r,i){var a=e.lastOrUndefined(s);a&&t===a.start||s.push(e.createFileDiagnostic(o,t,n,r,i)),k=!0}function q(e,t){V(b.getTextPos(),t||0,e)}function W(){return b.getStartPos()}function H(){return u}function G(){return u=b.scan()}function Q(){return u=b.reScanGreaterToken()}function X(){return u=b.scanJsxIdentifier()}function Y(){return u=b.scanJsxToken()}function Z(t,n){var r=u,i=s.length,a=k,o=g,c=n?b.lookAhead(t):b.tryScan(t);return e.Debug.assert(o===g),c&&!n||(u=r,s.length=i,k=a),c}function $(e){return Z(e,!0)}function ee(e){return Z(e,!1)}function te(){return 71===H()||(116!==H()||!J())&&((121!==H()||!K())&&H()>107)}function ne(t,n,r){return void 0===r&&(r=!0),H()===t?(r&&G(),!0):(n?U(n):U(e.Diagnostics._0_expected,e.tokenToString(t)),!1)}function re(e){return H()===e&&(G(),!0)}function ie(e){if(H()===e)return oe()}function ae(e,t,n,r){return ie(e)||de(e,t,n,r)}function oe(){var e=ue(H());return G(),le(e)}function se(){return 25===H()||(18===H()||1===H()||b.hasPrecedingLineBreak())}function ce(){return se()?(25===H()&&G(),!0):ne(25)}function ue(t,a){return d++,a>=0||(a=b.getStartPos()),e.isNodeKind(t)?new n(t,a,a):71===t?new i(t,a,a):new r(t,a,a)}function _e(e,t,n){var r=e.length,i=r>=1&&r<=4?e.slice():e;return i.pos=t,i.end=void 0===n?b.getStartPos():n,i}function le(e,t){return e.end=void 0===t?b.getStartPos():t,g&&(e.flags|=g),k&&(k=!1,e.flags|=32768),e}function de(t,n,r,i){n?V(b.getStartPos(),0,r,i):U(r,i);var a=ue(t,b.getStartPos());return 71===t?a.escapedText="":(e.isLiteralKind(t)||e.isTemplateLiteralKind(t))&&(a.text=""),le(a)}function pe(e){var t=p.get(e);return void 0===t&&p.set(e,t=e),t}function fe(t,n){if(f++,t){var r=ue(71);return 71!==H()&&(r.originalKeywordKind=H()),r.escapedText=e.escapeLeadingUnderscores(pe(b.getTokenValue())),G(),le(r)}return de(71,1===H(),n||e.Diagnostics.Identifier_expected)}function me(e){return fe(te(),e)}function ge(t){return fe(e.tokenIsIdentifierOrKeyword(H()),t)}function ye(){return e.tokenIsIdentifierOrKeyword(H())||9===H()||8===H()}function he(e){if(9===H()||8===H()){var t=Ve();return t.text=pe(t.text),t}return e&&21===H()?function(){var e=ue(144);return ne(21),e.expression=L(wt),ne(22),le(e)}():ge()}function ve(){return he(!0)}function be(e){return H()===e&&ee(ke)}function xe(){return G(),!b.hasPrecedingLineBreak()&&Se()}function ke(){return 76===H()?83===G():84===H()?(G(),79===H()?$(De):39!==H()&&118!==H()&&17!==H()&&Se()):79===H()?De():115===H()?(G(),Se()):xe()}function Se(){return 21===H()||17===H()||39===H()||24===H()||ye()}function De(){return G(),75===H()||89===H()||109===H()||117===H()&&$(bn)||120===H()&&$(xn)}function Ce(t,n){if(Ie(t))return!0;switch(t){case 0:case 1:case 3:return!(25===H()&&n)&&Cn();case 2:return 73===H()||79===H();case 4:return $(ot);case 5:return $(qn)||25===H()&&!n;case 6:return 21===H()||ye();case 12:return 21===H()||39===H()||24===H()||ye();case 17:return ye();case 9:return 21===H()||24===H()||ye();case 7:return 17===H()?$(Te):n?te()&&!Ae():Nt()&&!Ae();case 8:return On();case 10:return 26===H()||24===H()||On();case 18:return te();case 11:case 15:return 26===H()||24===H()||At();case 16:return Ze();case 19:case 20:return 26===H()||yt();case 21:return nr();case 22:return e.tokenIsIdentifierOrKeyword(H());case 13:return e.tokenIsIdentifierOrKeyword(H())||17===H();case 14:return!0}e.Debug.fail("Non-exhaustive case in 'isListElement'.")}function Te(){if(e.Debug.assert(17===H()),18===G()){var t=G();return 26===t||17===t||85===t||108===t}return!0}function Ee(){return G(),te()}function Ne(){return G(),e.tokenIsIdentifierOrKeyword(H())}function Ae(){return(108===H()||85===H())&&$(we)}function we(){return G(),At()}function Pe(e){if(1===H())return!0;switch(e){case 1:case 2:case 4:case 5:case 6:case 12:case 9:case 22:return 18===H();case 3:return 18===H()||73===H()||79===H();case 7:return 17===H()||85===H()||108===H();case 8:return function(){if(se())return!0;if(zt(H()))return!0;if(36===H())return!0;return!1}();case 18:return 29===H()||19===H()||17===H()||85===H()||108===H();case 11:return 20===H()||25===H();case 15:case 20:case 10:return 22===H();case 16:case 17:return 20===H()||22===H();case 19:return 26!==H();case 21:return 17===H()||18===H();case 13:return 29===H()||41===H();case 14:return 27===H()&&$(cr)}}function Fe(e,t){var n=m;m|=1<<e;for(var r=[],i=W();!Pe(e);)if(Ce(e,!1)){var a=Oe(e,t);r.push(a)}else if(Re(e))break;return m=n,_e(r,i)}function Oe(e,t){var n=Ie(e);return n?function(e){return b.setTextPos(e.end),G(),e}(n):t()}function Ie(t){if(!k&&c){var n=c.currentNode(b.getStartPos());if(!e.nodeIsMissing(n))if(!n.intersectsChange)if(!e.containsParseError(n))if((96256&n.flags)===g&&function(e,t){switch(t){case 5:return function(e){if(e)switch(e.kind){case 152:case 157:case 153:case 154:case 149:case 206:return!0;case 151:var t=e;return!(71===t.name.kind&&123===t.name.originalKeywordKind)}return!1}(e);case 2:return function(e){if(e)switch(e.kind){case 257:case 258:return!0}return!1}(e);case 0:case 1:case 3:return function(e){if(e)switch(e.kind){case 228:case 208:case 207:case 211:case 210:case 223:case 219:case 221:case 218:case 217:case 215:case 216:case 214:case 213:case 220:case 209:case 224:case 222:case 212:case 225:case 238:case 237:case 244:case 243:case 233:case 229:case 230:case 232:case 231:return!0}return!1}(e);case 6:return function(e){return 264===e.kind}(e);case 4:return function(e){if(e)switch(e.kind){case 156:case 150:case 157:case 148:case 155:return!0}return!1}(e);case 8:return function(e){if(226!==e.kind)return!1;return void 0===e.initializer}(e);case 16:return function(e){if(146!==e.kind)return!1;return void 0===e.initializer}(e);case 17:return!1}return!1}(n,t))return n}}function Re(t){return U(function(t){switch(t){case 0:case 1:return e.Diagnostics.Declaration_or_statement_expected;case 2:return e.Diagnostics.case_or_default_expected;case 3:return e.Diagnostics.Statement_expected;case 17:case 4:return e.Diagnostics.Property_or_signature_expected;case 5:return e.Diagnostics.Unexpected_token_A_constructor_method_accessor_or_property_was_expected;case 6:return e.Diagnostics.Enum_member_expected;case 7:return e.Diagnostics.Expression_expected;case 8:return e.Diagnostics.Variable_declaration_expected;case 9:return e.Diagnostics.Property_destructuring_pattern_expected;case 10:return e.Diagnostics.Array_element_destructuring_pattern_expected;case 11:return e.Diagnostics.Argument_expression_expected;case 12:return e.Diagnostics.Property_assignment_expected;case 15:return e.Diagnostics.Expression_or_comma_expected;case 16:return e.Diagnostics.Parameter_declaration_expected;case 18:return e.Diagnostics.Type_parameter_declaration_expected;case 19:return e.Diagnostics.Type_argument_expected;case 20:return e.Diagnostics.Type_expected;case 21:return e.Diagnostics.Unexpected_token_expected;case 22:case 13:case 14:return e.Diagnostics.Identifier_expected}}(t)),!!function(){for(var e=0;e<23;e++)if(m&1<<e&&(Ce(e,!0)||Pe(e)))return!0;return!1}()||(G(),!1)}function Le(e,t,n){var r=m;m|=1<<e;for(var i=[],a=W(),o=-1;;)if(Ce(e,!1)){var s=b.getStartPos();if(i.push(Oe(e,t)),o=b.getTokenPos(),re(26))continue;if(o=-1,Pe(e))break;ne(26),n&&25===H()&&!b.hasPrecedingLineBreak()&&G(),s===b.getStartPos()&&G()}else{if(Pe(e))break;if(Re(e))break}m=r;var c=_e(i,a);return o>=0&&(c.hasTrailingComma=!0),c}function Me(){return _e([],W())}function Be(e,t,n,r){if(ne(n)){var i=Le(e,t);return ne(r),i}return Me()}function Je(e,t){for(var n=e?ge(t):me(t),r=b.getStartPos();re(23);){if(27===H()){n.jsdocDotPos=r;break}r=b.getStartPos(),n=ze(n,je(e))}return n}function ze(e,t){var n=ue(143,e.pos);return n.left=e,n.right=t,le(n)}function je(t){if(b.hasPrecedingLineBreak()&&e.tokenIsIdentifierOrKeyword(H())&&$(vn))return de(71,!0,e.Diagnostics.Identifier_expected);return t?ge():me()}function Ke(){var t,n=ue(196);n.head=(t=qe(H()),e.Debug.assert(14===t.kind,"Template head has wrong token kind"),t),e.Debug.assert(14===n.head.kind,"Template head has wrong token kind");var r=[],i=W();do{r.push(Ue())}while(15===e.lastOrUndefined(r).literal.kind);return n.templateSpans=_e(r,i),le(n)}function Ue(){var t,n,r=ue(205);return r.expression=L(wt),18===H()?(u=b.reScanTemplateToken(),n=qe(H()),e.Debug.assert(15===n.kind||16===n.kind,"Template fragment has wrong token kind"),t=n):t=ae(16,!1,e.Diagnostics._0_expected,e.tokenToString(18)),r.literal=t,le(r)}function Ve(){return qe(H())}function qe(e){var t=ue(e),n=b.getTokenValue();return t.text=n,b.hasExtendedUnicodeEscape()&&(t.hasExtendedUnicodeEscape=!0),b.isUnterminated()&&(t.isUnterminated=!0),8===t.kind&&(t.numericLiteralFlags=b.getNumericLiteralFlags()),G(),le(t),t}function We(){var t=ue(159);return t.typeName=Je(!0,e.Diagnostics.Type_expected),b.hasPrecedingLineBreak()||27!==H()||(t.typeArguments=Be(19,Ct,27,29)),le(t)}function He(){var e=ue(146);return 99!==H()&&94!==H()||(e.name=ge(),ne(56)),e.type=Ct(),le(e)}function Ge(e){var t=ue(e);return G(),t.type=gt(),le(t)}function Qe(){var e=ue(145);return e.name=me(),re(85)&&(yt()||!At()?e.constraint=Ct():e.expression=qt()),re(58)&&(e.default=Ct()),le(e)}function Xe(){if(27===H())return Be(18,Qe,27,29)}function Ye(){if(re(56))return Ct()}function Ze(){return 24===H()||On()||e.isModifierKind(H())||57===H()||yt(!0)}function $e(t){var n=ue(146);return 99===H()?(n.name=fe(!0),n.type=Ye(),le(n)):(n.decorators=Wn(),n.modifiers=Hn(),n.dotDotDotToken=ie(24),n.name=In(),0===e.getFullWidth(n.name)&&!e.hasModifiers(n)&&e.isModifierKind(H())&&G(),n.questionToken=ie(55),n.type=Ye(),n.initializer=Pt(!0,t),T(le(n)))}function et(t,n,r){32&n||(r.typeParameters=Xe()),r.parameters=function(e){if(ne(19)){var t=J(),n=K();P(!!(1&e)),O(!!(2&e));var r=Le(16,32&e?He:function(){return $e(!!(8&e))});if(P(t),O(n),!ne(20)&&8&e)return;return r}return 8&e?void 0:Me()}(n),r.type=function(t,n){return function(t,n){if(36===t)return ne(t),!0;if(re(56))return!0;if(n&&36===H())return U(e.Diagnostics._0_expected,e.tokenToString(56)),G(),!0;return!1}(t,n)?function(){var e=te()&&ee(Dt),t=Ct();if(e){var n=ue(158,e.pos);return n.parameterName=e,n.type=t,le(n)}return t}():void 0}(t,!!(4&n))}function tt(){re(26)||ce()}function nt(e){var t=ue(e);return 156===e&&ne(94),et(56,4,t),tt(),T(le(t))}function rt(){return 21===H()&&$(it)}function it(){if(G(),24===H()||22===H())return!0;if(e.isModifierKind(H())){if(G(),te())return!0}else{if(!te())return!1;G()}return 56===H()||26===H()||55===H()&&(G(),56===H()||26===H()||22===H())}function at(e,t,n){var r=ue(157,e);return r.decorators=t,r.modifiers=n,r.parameters=Be(16,$e,21,22),r.type=Et(),tt(),T(le(r))}function ot(){if(19===H()||27===H())return!0;for(var t;e.isModifierKind(H());)t=!0,G();return 21===H()||(ye()&&(t=!0,G()),!!t&&(19===H()||27===H()||55===H()||56===H()||26===H()||se()))}function st(){if(19===H()||27===H())return nt(155);if(94===H()&&$(ct))return nt(156);var e=W(),t=Hn();return rt()?at(e,void 0,t):function(e,t){var n=ve(),r=ie(55);if(19===H()||27===H()){var i=ue(150,e);return i.modifiers=t,i.name=n,i.questionToken=r,et(56,4,i),tt(),T(le(i))}var a=ue(148,e);return a.modifiers=t,a.name=n,a.questionToken=r,a.type=Et(),58===H()&&(a.initializer=Kn()),tt(),T(le(a))}(e,t)}function ct(){return G(),19===H()||27===H()}function ut(){var e;return ne(17)?(e=Fe(4,st),ne(18)):e=Me(),e}function _t(){return G(),131===H()&&G(),21===H()&&Ee()&&92===G()}function lt(){var e=ue(172);return ne(17),e.readonlyToken=ie(131),ne(21),e.typeParameter=function(){var e=ue(145);return e.name=me(),ne(92),e.constraint=Ct(),le(e)}(),ne(22),e.questionToken=ie(55),e.type=Et(),ce(),ne(18),le(e)}function dt(e){var t=ue(e);return 161===e&&ne(94),et(36,4,t),T(le(t))}function pt(){var e=oe();return 23===H()?void 0:e}function ft(e){var t,n=ue(173);e&&((t=ue(192)).operator=38,G());var r=101===H()||86===H()?oe():qe(H());return e&&(t.operand=r,le(t),r=t),n.literal=r,le(n)}function mt(){return 8===G()}function gt(){switch(H()){case 119:case 136:case 133:case 122:case 137:case 139:case 130:case 134:return ee(pt)||We();case 39:return n=ue(268),G(),le(n);case 55:return function(){var e,t=b.getStartPos();return G(),26===H()||18===H()||20===H()||29===H()||58===H()||49===H()?le(e=ue(269,t)):((e=ue(270,t)).type=Ct(),le(e))}();case 89:return function(){if($(sr)){var e=ue(273);return G(),et(56,36,e),T(le(e))}var t=ue(159);return t.typeName=ge(),le(t)}();case 24:return Ge(274);case 51:return Ge(271);case 13:case 9:case 8:case 101:case 86:return ft();case 38:return $(mt)?ft(!0):We();case 105:case 95:return oe();case 99:var e=(t=ue(169),G(),le(t));return 126!==H()||b.hasPrecedingLineBreak()?e:function(e){G();var t=ue(158,e.pos);return t.parameterName=e,t.type=Ct(),le(t)}(e);case 103:return function(){var e=ue(162);return ne(103),e.exprName=Je(!0),le(e)}();case 17:return $(_t)?lt():function(){var e=ue(163);return e.members=ut(),le(e)}();case 21:return function(){var e=ue(165);return e.elementTypes=Be(20,Ct,21,22),le(e)}();case 19:return function(){var e=ue(168);return ne(19),e.type=Ct(),ne(20),le(e)}();default:return We()}var t,n}function yt(e){switch(H()){case 119:case 136:case 133:case 122:case 137:case 105:case 139:case 95:case 99:case 103:case 130:case 17:case 21:case 27:case 49:case 48:case 94:case 9:case 8:case 101:case 86:case 134:case 39:case 55:case 51:case 24:return!0;case 38:return!e&&$(mt);case 19:return!e&&$(ht);default:return te()}}function ht(){return G(),20===H()||Ze()||yt()}function vt(e,t){G();var n=ue(e,t.pos);return n.type=t,le(n)}function bt(){switch(H()){case 127:return e=127,t=ue(170),ne(e),t.operator=e,t.type=bt(),le(t)}var e,t;return function(){for(var e=gt();!b.hasPrecedingLineBreak();)switch(H()){case 58:if(!(1048576&g))return e;e=vt(272,e);break;case 51:e=vt(271,e);break;case 55:e=vt(270,e);break;case 21:var t;ne(21),yt()?((t=ue(171,e.pos)).objectType=e,t.indexType=Ct(),ne(22),e=le(t)):((t=ue(164,e.pos)).elementType=e,ne(22),e=le(t));break;default:return e}return e}()}function xt(e,t,n){re(n);var r=t();if(H()===n){for(var i=[r];re(n);)i.push(t());var a=ue(e,r.pos);a.types=_e(i,r.pos),r=le(a)}return r}function kt(){return xt(167,bt,48)}function St(){if(G(),20===H()||24===H())return!0;if(function(){if(e.isModifierKind(H())&&Hn(),te()||99===H())return G(),!0;if(21===H()||17===H()){var t=s.length;return In(),t===s.length}return!1}()){if(56===H()||26===H()||55===H()||58===H())return!0;if(20===H()&&(G(),36===H()))return!0}return!1}function Dt(){var e=me();if(126===H()&&!b.hasPrecedingLineBreak())return G(),e}function Ct(){return I(20480,Tt)}function Tt(){return 27===H()||19===H()&&$(St)?dt(160):94===H()?dt(161):xt(166,kt,49)}function Et(){return re(56)?Ct():void 0}function Nt(){switch(H()){case 99:case 97:case 95:case 101:case 86:case 8:case 9:case 13:case 14:case 19:case 21:case 17:case 89:case 75:case 94:case 41:case 63:case 71:return!0;case 91:return $(ct);default:return te()}}function At(){if(Nt())return!0;switch(H()){case 37:case 38:case 52:case 51:case 80:case 103:case 105:case 43:case 44:case 27:case 121:case 116:return!0;default:return!!function(){if(z()&&92===H())return!1;return Kt()>0}()||te()}}function wt(){var e=j();e&&F(!1);for(var t,n=Ft();t=ie(26);)n=Ut(n,t,Ft());return e&&F(!0),n}function Pt(t,n){if(58!==H()){if(b.hasPrecedingLineBreak()||t&&17===H()||!At())return;if(t&&n){var r=de(71,!0,e.Diagnostics._0_expected,"=");return r.escapedText="= not found",r}}return ne(58),Ft()}function Ft(){if(function(){if(116===H())return!!J()||$(kn);return!1}())return t=ue(197),G(),b.hasPrecedingLineBreak()||39!==H()&&!At()||(t.asteriskToken=ie(39),t.expression=Ft()),le(t);var t,n=function(){var t=function(){if(19===H()||27===H()||120===H())return $(It);if(36===H())return 1;return 0}();if(0===t)return;var n=1===t?Mt(!0):ee(Rt);if(!n)return;var r=e.hasModifier(n,256),i=H();return n.equalsGreaterThanToken=ae(36,!1,e.Diagnostics._0_expected,"=>"),n.body=36===i||17===i?Bt(r):me(),T(le(n))}()||function(){if(120===H()&&1===$(Lt)){var e=Gn();return Ot(Jt(0),e)}return}();if(n)return n;var r=Jt(0);return 71===r.kind&&36===H()?Ot(r):e.isLeftHandSideExpression(r)&&e.isAssignmentOperator(Q())?Ut(r,oe(),Ft()):function(t){var n=ie(55);if(!n)return t;var r=ue(195,t.pos);return r.condition=t,r.questionToken=n,r.whenTrue=I(x,Ft),r.colonToken=ae(56,!1,e.Diagnostics._0_expected,e.tokenToString(56)),r.whenFalse=Ft(),le(r)}(r)}function Ot(t,n){var r;e.Debug.assert(36===H(),"parseSimpleArrowFunctionExpression should only have been called if we had a =>"),n?(r=ue(187,n.pos)).modifiers=n:r=ue(187,t.pos);var i=ue(146,t.pos);return i.name=t,le(i),r.parameters=_e([i],i.pos,i.end),r.equalsGreaterThanToken=ae(36,!1,e.Diagnostics._0_expected,"=>"),r.body=Bt(!!n),T(le(r))}function It(){if(120===H()){if(G(),b.hasPrecedingLineBreak())return 0;if(19!==H()&&27!==H())return 0}var t=H(),n=G();if(19===t){if(20===n)switch(G()){case 36:case 56:case 17:return 1;default:return 0}return 21===n||17===n?2:24===n?1:te()?56===G()?1:2:0}return e.Debug.assert(27===t),te()?1===o.languageVariant?$((function(){var e=G();if(85===e)switch(G()){case 58:case 29:return!1;default:return!0}else if(26===e)return!0;return!1}))?1:0:2:0}function Rt(){return Mt(!1)}function Lt(){if(120===H()){if(G(),b.hasPrecedingLineBreak()||36===H())return 0;var e=Jt(0);if(!b.hasPrecedingLineBreak()&&71===e.kind&&36===H())return 1}return 0}function Mt(t){var n=ue(187);if(n.modifiers=Gn(),et(56,(e.hasModifier(n,256)?2:0)|(t?0:8),n),n.parameters&&(t||!(36!==H()&&17!==H()||e.find(n.parameters,(function(t){return t.initializer&&e.isIdentifier(t.initializer)&&"= not found"===t.initializer.escapedText})))))return n}function Bt(e){return 17===H()?fn(e?2:0):25===H()||89===H()||75===H()||!Cn()||17!==H()&&89!==H()&&75!==H()&&57!==H()&&At()?e?M(Ft):I(16384,Ft):fn(16|(e?2:0))}function Jt(e){return jt(e,qt())}function zt(e){return 92===e||142===e}function jt(e,t){for(;;){Q();var n=Kt();if(!(40===H()?n>=e:n>e))break;if(92===H()&&z())break;if(118===H()){if(b.hasPrecedingLineBreak())break;G(),t=Vt(t,Ct())}else t=Ut(t,oe(),Jt(n))}return t}function Kt(){switch(H()){case 54:return 1;case 53:return 2;case 49:return 3;case 50:return 4;case 48:return 5;case 32:case 33:case 34:case 35:return 6;case 27:case 29:case 30:case 31:case 93:case 92:case 118:return 7;case 45:case 46:case 47:return 8;case 37:case 38:return 9;case 39:case 41:case 42:return 10;case 40:return 11}return-1}function Ut(e,t,n){var r=ue(194,e.pos);return r.left=e,r.operatorToken=t,r.right=n,le(r)}function Vt(e,t){var n=ue(202,e.pos);return n.expression=e,n.type=t,le(n)}function qt(){if(function(){switch(H()){case 37:case 38:case 52:case 51:case 80:case 103:case 105:case 121:return!1;case 27:if(1!==o.languageVariant)return!1;default:return!0}}()){var t=Ht();return 40===H()?jt(Kt(),t):t}var n=H(),r=Wt();if(40===H()){var i=e.skipTrivia(l,r.pos);184===r.kind?V(i,r.end-i,e.Diagnostics.A_type_assertion_expression_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses):V(i,r.end-i,e.Diagnostics.An_unary_expression_with_the_0_operator_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses,e.tokenToString(n))}return r}function Wt(){switch(H()){case 37:case 38:case 52:case 51:return(e=ue(192)).operator=H(),G(),e.operand=Wt(),le(e);case 80:return function(){var e=ue(188);return G(),e.expression=Wt(),le(e)}();case 103:return function(){var e=ue(189);return G(),e.expression=Wt(),le(e)}();case 105:return function(){var e=ue(190);return G(),e.expression=Wt(),le(e)}();case 27:return function(){var e=ue(184);return ne(27),e.type=Ct(),ne(29),e.expression=Wt(),le(e)}();case 121:if(121===H()&&(K()||$(kn)))return function(){var e=ue(191);return G(),e.expression=Wt(),le(e)}();default:return Ht()}var e}function Ht(){if(43===H()||44===H())return(t=ue(192)).operator=H(),G(),t.operand=Gt(),le(t);if(1===o.languageVariant&&27===H()&&$(Ne))return Yt(!0);var t,n=Gt();return e.Debug.assert(e.isLeftHandSideExpression(n)),43!==H()&&44!==H()||b.hasPrecedingLineBreak()?n:((t=ue(193,n.pos)).operand=n,t.operator=H(),G(),le(t))}function Gt(){var t;return 91===H()&&$(ct)?(o.flags|=524288,t=oe()):t=97===H()?function(){var t=oe();if(19===H()||23===H()||21===H())return t;var n=ue(179,t.pos);return n.expression=t,ae(23,!1,e.Diagnostics.super_must_be_followed_by_an_argument_list_or_member_access),n.name=je(!0),le(n)}():Qt(),function(e){for(;;)if(e=nn(e),27!==H()){if(19!==H())return e;(t=ue(181,e.pos)).expression=e,t.arguments=rn(),e=le(t)}else{var t,n=ee(an);if(!n)return e;(t=ue(181,e.pos)).expression=e,t.typeArguments=n,t.arguments=rn(),e=le(t)}}(t)}function Qt(){return nn(function(){switch(H()){case 8:case 9:case 13:return Ve();case 99:case 97:case 95:case 101:case 86:return oe();case 19:return t=ue(185),ne(19),t.expression=L(wt),ne(20),T(le(t));case 21:return function(){var e=ue(177);ne(21),b.hasPrecedingLineBreak()&&(e.multiLine=!0);return e.elements=Le(15,on),ne(22),le(e)}();case 17:return _n();case 120:if(!$(xn))break;return ln();case 75:return Yn(b.getStartPos(),void 0,void 0,199);case 89:return ln();case 94:return function(){var e=b.getStartPos();if(ne(94),re(23)){var t=ue(204,e);return t.keywordToken=94,t.name=ge(),le(t)}var n=ue(182,e);n.expression=Qt(),n.typeArguments=ee(an),(n.typeArguments||19===H())&&(n.arguments=rn());return le(n)}();case 41:case 63:if(12===(u=b.reScanSlashToken()))return Ve();break;case 14:return Ke()}var t;return me(e.Diagnostics.Expression_expected)}())}function Xt(e,t){return e.kind===t.kind&&(71===e.kind?e.escapedText===t.escapedText:99===e.kind||e.name.escapedText===t.name.escapedText&&Xt(e.expression,t.expression))}function Yt(t){var n,r=function(e){var t=b.getStartPos();ne(27);var n,r=$t(),i=(a=ue(254),a.properties=Fe(13,tn),le(a));var a;29===H()?(n=ue(251,t),Y()):(ne(41),e?ne(29):(ne(29,void 0,!1),Y()),n=ue(250,t));return n.tagName=r,n.attributes=i,le(n)}(t);if(251===r.kind){var i=ue(249,r.pos);i.openingElement=r,i.children=function(t){var n=[],r=W(),i=m;m|=16384;for(;u=b.reScanJsxToken(),28!==H();){if(1===H()){V(t.pos,t.end-t.pos,e.Diagnostics.JSX_element_0_has_no_corresponding_closing_tag,e.getTextOfNodeFromSourceText(l,t));break}if(7===H())break;var a=Zt();a&&n.push(a)}return m=i,_e(n,r)}(i.openingElement.tagName),i.closingElement=function(e){var t=ue(252);ne(28),t.tagName=$t(),e?ne(29):(ne(29,void 0,!1),Y());return le(t)}(t),Xt(i.openingElement.tagName,i.closingElement.tagName)||V(i.closingElement.pos,i.closingElement.end-i.closingElement.pos,e.Diagnostics.Expected_corresponding_JSX_closing_tag_for_0,e.getTextOfNodeFromSourceText(l,i.openingElement.tagName)),n=le(i)}else e.Debug.assert(250===r.kind),n=r;if(t&&27===H()){var a=ee((function(){return Yt(!0)}));if(a){U(e.Diagnostics.JSX_expressions_must_have_one_parent_element);var o=ue(194,n.pos);return o.end=a.end,o.left=n,o.right=a,o.operatorToken=de(26,!1,void 0),o.operatorToken.pos=o.operatorToken.end=o.right.pos,o}}return n}function Zt(){switch(H()){case 10:case 11:return(t=ue(10,b.getStartPos())).containsOnlyWhiteSpaces=11===u,u=b.scanJsxToken(),le(t);case 17:return en(!1);case 27:return Yt(!1)}var t;e.Debug.fail("Unknown JSX child kind "+H())}function $t(){X();for(var e=99===H()?oe():ge();re(23);){var t=ue(179,e.pos);t.expression=e,t.name=je(!0),e=le(t)}return e}function en(e){var t=ue(256);return ne(17),18!==H()&&(t.dotDotDotToken=ie(24),t.expression=Ft()),e?ne(18):(ne(18,void 0,!1),Y()),le(t)}function tn(){if(17===H())return function(){var e=ue(255);return ne(17),ne(24),e.expression=wt(),ne(18),le(e)}();X();var e=ue(253);if(e.name=ge(),58===H())switch(u=b.scanJsxAttributeValue()){case 9:e.initializer=Ve();break;default:e.initializer=en(!0)}return le(e)}function nn(e){for(;;){if(ie(23)){var t=ue(179,e.pos);t.expression=e,t.name=je(!0),e=le(t)}else if(51!==H()||b.hasPrecedingLineBreak())if(j()||!re(21)){if(13!==H()&&14!==H())return e;var n=ue(183,e.pos);n.tag=e,n.template=13===H()?Ve():Ke(),e=le(n)}else{var r=ue(180,e.pos);if(r.expression=e,22!==H()&&(r.argumentExpression=L(wt),9===r.argumentExpression.kind||8===r.argumentExpression.kind)){var i=r.argumentExpression;i.text=pe(i.text)}ne(22),e=le(r)}else{G();var a=ue(203,e.pos);a.expression=e,e=le(a)}}}function rn(){ne(19);var e=Le(11,sn);return ne(20),e}function an(){if(re(27)){var e=Le(19,Ct);if(ne(29))return e&&function(){switch(H()){case 19:case 23:case 20:case 22:case 56:case 25:case 55:case 32:case 34:case 33:case 35:case 53:case 54:case 50:case 48:case 49:case 18:case 1:return!0;case 26:case 17:default:return!1}}()?e:void 0}}function on(){return 24===H()?(e=ue(198),ne(24),e.expression=Ft(),le(e)):26===H()?ue(200):Ft();var e}function sn(){return I(x,on)}function cn(e,t,n){return be(125)?Un(153,e,t,n):be(135)?Un(154,e,t,n):void 0}function un(){var e=b.getStartPos();if(ie(24)){var t=ue(263,e);return t.expression=Ft(),T(le(t))}var n=Wn(),r=Hn(),i=cn(e,n,r);if(i)return i;var a=ie(39),o=te(),s=ve(),c=ie(55);if(a||19===H()||27===H())return zn(e,n,r,a,s,c);if(o&&(26===H()||18===H()||58===H())){var u=ue(262,e);u.name=s,u.questionToken=c;var _=ie(58);return _&&(u.equalsToken=_,u.objectAssignmentInitializer=L(Ft)),T(le(u))}var l=ue(261,e);return l.modifiers=r,l.name=s,l.questionToken=c,ne(56),l.initializer=L(Ft),T(le(l))}function _n(){var e=ue(178);return ne(17),b.hasPrecedingLineBreak()&&(e.multiLine=!0),e.properties=Le(12,un,!0),ne(18),le(e)}function ln(){var t=j();t&&F(!1);var n=ue(186);n.modifiers=Hn(),ne(89),n.asteriskToken=ie(39);var r=n.asteriskToken?1:0,i=e.hasModifier(n,256)?2:0;return n.name=r&&i?R(20480,dn):r?function(e){return R(4096,e)}(dn):i?M(dn):dn(),et(56,r|i,n),n.body=fn(r|i),t&&F(!0),T(le(n))}function dn(){return te()?me():void 0}function pn(e,t){var n=ue(207);return ne(17,t)||e?(b.hasPrecedingLineBreak()&&(n.multiLine=!0),n.statements=Fe(1,En),ne(18)):n.statements=Me(),le(n)}function fn(e,t){var n=J();P(!!(1&e));var r=K();O(!!(2&e));var i=j();i&&F(!1);var a=pn(!!(16&e),t);return i&&F(!0),P(n),O(r),a}function mn(){var e=W();ne(88);var t=ie(121);ne(19);var n,r=void 0;if(25!==H()&&(r=104===H()||110===H()||76===H()?Ln(!0):R(2048,wt)),t?ne(142):re(142)){var i=ue(216,e);i.awaitModifier=t,i.initializer=r,i.expression=L(Ft),ne(20),n=i}else if(re(92)){var a=ue(215,e);a.initializer=r,a.expression=L(wt),ne(20),n=a}else{var o=ue(214,e);o.initializer=r,ne(25),25!==H()&&20!==H()&&(o.condition=L(wt)),ne(25),20!==H()&&(o.incrementor=L(wt)),ne(20),n=o}return n.statement=En(),le(n)}function gn(e){var t=ue(e);return ne(218===e?72:77),se()||(t.label=me()),ce(),le(t)}function yn(){return 73===H()?(e=ue(257),ne(73),e.expression=L(wt),ne(56),e.statements=Fe(3,En),le(e)):function(){var e=ue(258);return ne(79),ne(56),e.statements=Fe(3,En),le(e)}();var e}function hn(){var e=ue(224);return ne(102),e.tryBlock=pn(!1),e.catchClause=74===H()?function(){var e=ue(260);ne(74),re(19)?(e.variableDeclaration=Rn(),ne(20)):e.variableDeclaration=void 0;return e.block=pn(!1),le(e)}():void 0,e.catchClause&&87!==H()||(ne(87),e.finallyBlock=pn(!1)),le(e)}function vn(){return G(),e.tokenIsIdentifierOrKeyword(H())&&!b.hasPrecedingLineBreak()}function bn(){return G(),75===H()&&!b.hasPrecedingLineBreak()}function xn(){return G(),89===H()&&!b.hasPrecedingLineBreak()}function kn(){return G(),(e.tokenIsIdentifierOrKeyword(H())||8===H()||9===H())&&!b.hasPrecedingLineBreak()}function Sn(){for(;;)switch(H()){case 104:case 110:case 76:case 89:case 75:case 83:return!0;case 109:case 138:return G(),!b.hasPrecedingLineBreak()&&te();case 128:case 129:return An();case 117:case 120:case 124:case 112:case 113:case 114:case 131:if(G(),b.hasPrecedingLineBreak())return!1;continue;case 141:return G(),17===H()||71===H()||84===H();case 91:return G(),9===H()||39===H()||17===H()||e.tokenIsIdentifierOrKeyword(H());case 84:if(G(),58===H()||39===H()||17===H()||79===H()||118===H())return!0;continue;case 115:G();continue;default:return!1}}function Dn(){return $(Sn)}function Cn(){switch(H()){case 57:case 25:case 17:case 104:case 110:case 89:case 75:case 83:case 90:case 81:case 106:case 88:case 77:case 72:case 96:case 107:case 98:case 100:case 102:case 78:case 74:case 87:return!0;case 91:return Dn()||$(ct);case 76:case 84:return Dn();case 120:case 124:case 109:case 128:case 129:case 138:case 141:return!0;case 114:case 112:case 113:case 115:case 131:return Dn()||!$(vn);default:return At()}}function Tn(){return G(),te()||17===H()||21===H()}function En(){switch(H()){case 25:return e=ue(209),ne(25),le(e);case 17:return pn(!1);case 104:return Bn(b.getStartPos(),void 0,void 0);case 110:if($(Tn))return Bn(b.getStartPos(),void 0,void 0);break;case 89:return Jn(b.getStartPos(),void 0,void 0);case 75:return Xn(b.getStartPos(),void 0,void 0);case 90:return function(){var e=ue(211);return ne(90),ne(19),e.expression=L(wt),ne(20),e.thenStatement=En(),e.elseStatement=re(82)?En():void 0,le(e)}();case 81:return function(){var e=ue(212);return ne(81),e.statement=En(),ne(106),ne(19),e.expression=L(wt),ne(20),re(25),le(e)}();case 106:return function(){var e=ue(213);return ne(106),ne(19),e.expression=L(wt),ne(20),e.statement=En(),le(e)}();case 88:return mn();case 77:return gn(217);case 72:return gn(218);case 96:return function(){var e=ue(219);return ne(96),se()||(e.expression=L(wt)),ce(),le(e)}();case 107:return function(){var e=ue(220);return ne(107),ne(19),e.expression=L(wt),ne(20),e.statement=En(),le(e)}();case 98:return function(){var e=ue(221);ne(98),ne(19),e.expression=L(wt),ne(20);var t=ue(235,b.getStartPos());return ne(17),t.clauses=Fe(2,yn),ne(18),e.caseBlock=le(t),le(e)}();case 100:return function(){var e=ue(223);return ne(100),e.expression=b.hasPrecedingLineBreak()?void 0:L(wt),ce(),le(e)}();case 102:case 74:case 87:return hn();case 78:return function(){var e=ue(225);return ne(78),ce(),le(e)}();case 57:return Nn();case 120:case 109:case 138:case 128:case 129:case 124:case 76:case 83:case 84:case 91:case 112:case 113:case 114:case 117:case 115:case 131:case 141:if(Dn())return Nn()}var e;return function(){var e=b.getStartPos(),t=L(wt);if(71===t.kind&&re(56)){var n=ue(222,e);return n.label=t,n.statement=En(),T(le(n))}var r=ue(210,e);return r.expression=t,ce(),T(le(r))}()}function Nn(){var t=W(),n=Wn(),r=Hn();switch(H()){case 104:case 110:case 76:return Bn(t,n,r);case 89:return Jn(t,n,r);case 75:return Xn(t,n,r);case 109:return function(e,t,n){var r=ue(230,e);return r.decorators=t,r.modifiers=n,ne(109),r.name=me(),r.typeParameters=Xe(),r.heritageClauses=Zn(),r.members=ut(),T(le(r))}(t,n,r);case 138:return function(e,t,n){var r=ue(231,e);return r.decorators=t,r.modifiers=n,ne(138),r.name=me(),r.typeParameters=Xe(),ne(58),r.type=Ct(),ce(),T(le(r))}(t,n,r);case 83:return function(e,t,n){var r=ue(232,e);r.decorators=t,r.modifiers=n,ne(83),r.name=me(),ne(17)?(r.members=Le(6,rr),ne(18)):r.members=Me();return T(le(r))}(t,n,r);case 141:case 128:case 129:return function(e,t,n){var r=0;if(141===H())return or(e,t,n);if(re(129))r|=16;else if(ne(128),9===H())return or(e,t,n);return ar(e,t,n,r)}(t,n,r);case 91:return function(e,t,n){ne(91);var r,i=b.getStartPos();if(te()&&(r=me(),26!==H()&&140!==H()))return function(e,t,n,r){var i=ue(237,e);return i.decorators=t,i.modifiers=n,i.name=r,ne(58),i.moduleReference=function(){return 132===H()&&$(sr)?function(){var e=ue(248);return ne(132),ne(19),e.expression=ur(),ne(20),le(e)}():Je(!1)}(),ce(),T(le(i))}(e,t,n,r);var a=ue(238,e);a.decorators=t,a.modifiers=n,(r||39===H()||17===H())&&(a.importClause=function(e,t){var n=ue(239,t);e&&(n.name=e);n.name&&!re(26)||(n.namedBindings=39===H()?(r=ue(240),ne(39),ne(118),r.name=me(),le(r)):_r(241));var r;return le(n)}(r,i),ne(140));return a.moduleSpecifier=ur(),ce(),le(a)}(t,n,r);case 84:switch(G(),H()){case 79:case 58:return function(e,t,n){var r=ue(243,e);r.decorators=t,r.modifiers=n,re(58)?r.isExportEquals=!0:ne(79);return r.expression=Ft(),ce(),le(r)}(t,n,r);case 118:return function(e,t,n){var r=ue(236,e);return r.decorators=t,r.modifiers=n,ne(118),ne(129),r.name=me(),ce(),le(r)}(t,n,r);default:return function(e,t,n){var r=ue(244,e);r.decorators=t,r.modifiers=n,re(39)?(ne(140),r.moduleSpecifier=ur()):(r.exportClause=_r(245),(140===H()||9===H()&&!b.hasPrecedingLineBreak())&&(ne(140),r.moduleSpecifier=ur()));return ce(),le(r)}(t,n,r)}default:if(n||r){var i=de(247,!0,e.Diagnostics.Declaration_expected);return i.pos=t,i.decorators=n,i.modifiers=r,le(i)}}}function An(){return G(),!b.hasPrecedingLineBreak()&&(te()||9===H())}function wn(e,t){if(17===H()||!se())return fn(e,t);ce()}function Pn(){if(26===H())return ue(200);var e=ue(176);return e.dotDotDotToken=ie(24),e.name=In(),e.initializer=Pt(!1),le(e)}function Fn(){var e=ue(176);e.dotDotDotToken=ie(24);var t=te(),n=ve();return t&&56!==H()?e.name=n:(ne(56),e.propertyName=n,e.name=In()),e.initializer=Pt(!1),le(e)}function On(){return 17===H()||21===H()||te()}function In(){return 21===H()?(e=ue(175),ne(21),e.elements=Le(10,Pn),ne(22),le(e)):17===H()?function(){var e=ue(174);return ne(17),e.elements=Le(9,Fn),ne(18),le(e)}():me();var e}function Rn(){var e=ue(226);return e.name=In(),e.type=Et(),zt(H())||(e.initializer=Kn()),le(e)}function Ln(t){var n=ue(227);switch(H()){case 104:break;case 110:n.flags|=1;break;case 76:n.flags|=2;break;default:e.Debug.fail()}if(G(),142===H()&&$(Mn))n.declarations=Me();else{var r=z();w(t),n.declarations=Le(8,Rn),w(r)}return le(n)}function Mn(){return Ee()&&20===G()}function Bn(e,t,n){var r=ue(208,e);return r.decorators=t,r.modifiers=n,r.declarationList=Ln(!1),ce(),T(le(r))}function Jn(t,n,r){var i=ue(228,t);i.decorators=n,i.modifiers=r,ne(89),i.asteriskToken=ie(39),i.name=e.hasModifier(i,512)?dn():me();var a=i.asteriskToken?1:0,o=e.hasModifier(i,256)?2:0;return et(56,a|o,i),i.body=wn(a|o,e.Diagnostics.or_expected),T(le(i))}function zn(t,n,r,i,a,o,s){var c=ue(151,t);c.decorators=n,c.modifiers=r,c.asteriskToken=i,c.name=a,c.questionToken=o;var u=i?1:0,_=e.hasModifier(c,256)?2:0;return et(56,u|_,c),c.body=wn(u|_,s),T(le(c))}function jn(t,n,r,i,a){var o=ue(149,t);return o.decorators=n,o.modifiers=r,o.name=i,o.questionToken=a,o.type=Et(),o.initializer=e.hasModifier(o,32)?L(Kn):I(6144,Kn),ce(),T(le(o))}function Kn(){return Pt(!1)}function Un(e,t,n,r){var i=ue(e,t);return i.decorators=n,i.modifiers=r,i.name=ve(),et(56,0,i),i.body=wn(0),T(le(i))}function Vn(e){switch(e){case 114:case 112:case 113:case 115:case 131:return!0;default:return!1}}function qn(){var t;if(57===H())return!0;for(;e.isModifierKind(H());){if(Vn(t=H()))return!0;G()}if(39===H())return!0;if(ye()&&(t=H(),G()),21===H())return!0;if(void 0!==t){if(!e.isKeyword(t)||135===t||125===t)return!0;switch(H()){case 19:case 27:case 56:case 58:case 55:return!0;default:return se()}}return!1}function Wn(){for(var e,t=W();;){var n=W();if(!re(57))break;var r=ue(147,n);r.expression=R(8192,Gt),le(r),(e||(e=[])).push(r)}return e&&_e(e,t)}function Hn(t){for(var n,r=W();;){var i=b.getStartPos(),a=H();if(76===H()&&t){if(!ee(xe))break}else if(!e.isModifierKind(H())||!ee(ke))break;var o=le(ue(a,i));(n||(n=[])).push(o)}return n&&_e(n,r)}function Gn(){var e;if(120===H()){var t=b.getStartPos(),n=H();G(),e=_e([le(ue(n,t))],t)}return e}function Qn(){if(25===H()){var t=ue(206);return G(),le(t)}var n=W(),r=Wn(),i=Hn(!0),a=cn(n,r,i);return a||(123===H()?function(t,n,r){var i=ue(152,t);return i.decorators=n,i.modifiers=r,ne(123),et(56,0,i),i.body=wn(0,e.Diagnostics.or_expected),T(le(i))}(n,r,i):rt()?at(n,r,i):e.tokenIsIdentifierOrKeyword(H())||9===H()||8===H()||39===H()||21===H()?function(t,n,r){var i=ie(39),a=ve(),o=ie(55);return i||19===H()||27===H()?zn(t,n,r,i,a,o,e.Diagnostics.or_expected):jn(t,n,r,a,o)}(n,r,i):r||i?jn(n,r,i,de(71,!0,e.Diagnostics.Declaration_expected),void 0):void e.Debug.fail("Should not have attempted to parse class member declaration."))}function Xn(e,t,n){return Yn(e,t,n,229)}function Yn(e,t,n,r){var i=ue(r,e);return i.decorators=t,i.modifiers=n,ne(75),i.name=!te()||108===H()&&$(Ne)?void 0:me(),i.typeParameters=Xe(),i.heritageClauses=Zn(),ne(17)?(i.members=Fe(5,Qn),ne(18)):i.members=Me(),T(le(i))}function Zn(){if(nr())return Fe(21,$n)}function $n(){var e=H();if(85===e||108===e){var t=ue(259);return t.token=e,G(),t.types=Le(7,er),le(t)}}function er(){var e=ue(201);return e.expression=Gt(),e.typeArguments=tr(),le(e)}function tr(){return 27===H()?Be(19,Ct,27,29):void 0}function nr(){return 85===H()||108===H()}function rr(){var e=ue(264,b.getStartPos());return e.name=ve(),e.initializer=L(Kn),T(le(e))}function ir(){var e=ue(234,b.getStartPos());return ne(17)?(e.statements=Fe(1,En),ne(18)):e.statements=Me(),le(e)}function ar(e,t,n,r){var i=ue(233,e),a=16&r;return i.decorators=t,i.modifiers=n,i.flags|=r,i.name=me(),i.body=re(23)?ar(W(),void 0,void 0,4|a):ir(),T(le(i))}function or(e,t,n){var r=ue(233,e);return r.decorators=t,r.modifiers=n,141===H()?(r.name=me(),r.flags|=512):(r.name=Ve(),r.name.text=pe(r.name.text)),17===H()?r.body=ir():ce(),le(r)}function sr(){return 19===G()}function cr(){return 41===G()}function ur(){if(9===H()){var e=Ve();return e.text=pe(e.text),e}return wt()}function _r(e){var t=ue(e);return t.elements=Be(22,241===e?dr:lr,17,18),le(t)}function lr(){return pr(246)}function dr(){return pr(242)}function pr(t){var n=ue(t),r=e.isKeyword(H())&&!te(),i=b.getTokenPos(),a=b.getTextPos(),o=ge();return 118===H()?(n.propertyName=o,ne(118),r=e.isKeyword(H())&&!te(),i=b.getTokenPos(),a=b.getTextPos(),n.name=ge()):n.name=o,242===t&&r&&V(i,a-i,e.Diagnostics.Identifier_expected),le(n)}function fr(t){for(var n,r=e.createScanner(t.languageVersion,!1,0,l),i=[],a=[],o=[],c=void 0;;){var u=r.scan();if(2!==u){if(e.isTrivia(u))continue;break}var _={kind:r.getToken(),pos:r.getTokenPos(),end:r.getTextPos()},d=l.substring(_.pos,_.end),p=e.getFileReferenceFromReferencePath(d,_);if(p){var f=p.fileReference;t.hasNoDefaultLib=p.isNoDefaultLib;var m=p.diagnosticMessage;f&&(p.isTypeReferenceDirective?a.push(f):i.push(f)),m&&s.push(e.createFileDiagnostic(t,_.pos,_.end-_.pos,m))}else{var g=/^\/\/\/\s*<amd-module\s+name\s*=\s*('|")(.+?)\1/gim.exec(d);g&&(n&&s.push(e.createFileDiagnostic(t,_.pos,_.end-_.pos,e.Diagnostics.An_AMD_module_cannot_have_multiple_name_assignments)),n=g[2]);if(/^\/\/\/\s*<amd-dependency\s/gim.exec(d)){var y=/\spath\s*=\s*('|")(.+?)\1/gim.exec(d),h=/\sname\s*=\s*('|")(.+?)\1/gim.exec(d);if(y){var v={path:y[2],name:h?h[2]:void 0};o.push(v)}}var b=/^\/\/\/?\s*(@ts-check|@ts-nocheck)\s*$/gim.exec(d);b&&(c={enabled:0===e.compareStrings(b[1],"@ts-check",!0),end:_.end,pos:_.pos})}}t.referencedFiles=i,t.typeReferenceDirectives=a,t.amdDependencies=o,t.moduleName=n,t.checkJsDirective=c}t.parseSourceFile=function(t,n,r,i,a,c){D(n,r,i,c=e.ensureScriptKind(t,c));var u=function(t,n,r,i){(o=N(t,n,i)).flags=g,G(),fr(o),o.statements=Fe(0,En),e.Debug.assert(1===H()),o.endOfFileToken=T(oe()),function(t){t.externalModuleIndicator=e.forEach(t.statements,(function(t){return e.hasModifier(t,1)||237===t.kind&&248===t.moduleReference.kind||238===t.kind||243===t.kind||244===t.kind?t:void 0}))}(o),o.nodeCount=d,o.identifierCount=f,o.identifiers=p,o.parseDiagnostics=s,r&&E(o);return o}(t,r,a,c);return C(),u},t.parseIsolatedEntityName=function(e,t){D(e,t,void 0,1),G();var n=Je(!0),r=1===H()&&!s.length;return C(),r?n:void 0},t.parseJsonText=function(t,n){D(n,2,void 0,6);var r=o=N(t,2,6);return G(),1===H()?o.endOfFileToken=oe():17===H()||$((function(){return 9===H()}))?(r.jsonObject=_n(),o.endOfFileToken=ae(1,!1,e.Diagnostics.Unexpected_token)):ne(17),o.parseDiagnostics=s,C(),r},t.fixupParentReferences=E,function(e){e[e.SourceElements=0]="SourceElements",e[e.BlockStatements=1]="BlockStatements",e[e.SwitchClauses=2]="SwitchClauses",e[e.SwitchClauseStatements=3]="SwitchClauseStatements",e[e.TypeMembers=4]="TypeMembers",e[e.ClassMembers=5]="ClassMembers",e[e.EnumMembers=6]="EnumMembers",e[e.HeritageClauseElement=7]="HeritageClauseElement",e[e.VariableDeclarations=8]="VariableDeclarations",e[e.ObjectBindingElements=9]="ObjectBindingElements",e[e.ArrayBindingElements=10]="ArrayBindingElements",e[e.ArgumentExpressions=11]="ArgumentExpressions",e[e.ObjectLiteralMembers=12]="ObjectLiteralMembers",e[e.JsxAttributes=13]="JsxAttributes",e[e.JsxChildren=14]="JsxChildren",e[e.ArrayLiteralMembers=15]="ArrayLiteralMembers",e[e.Parameters=16]="Parameters",e[e.RestProperties=17]="RestProperties",e[e.TypeParameters=18]="TypeParameters",e[e.TypeArguments=19]="TypeArguments",e[e.TupleElementTypes=20]="TupleElementTypes",e[e.HeritageClauses=21]="HeritageClauses",e[e.ImportOrExportSpecifiers=22]="ImportOrExportSpecifiers",e[e.Count=23]="Count"}(y||(y={})),function(e){e[e.False=0]="False",e[e.True=1]="True",e[e.Unknown=2]="Unknown"}(h||(h={})),function(t){function n(e){var t=ue(267,b.getTokenPos());if(ne(17)||!e)return t.type=R(1048576,Ct),ne(18),E(t),le(t)}var r,i;function a(t,r){var i=l;t=t||0;var a,o,s,c=void 0===r?i.length:t+r;r=c-t,e.Debug.assert(t>=0),e.Debug.assert(t<=c),e.Debug.assert(c<=i.length);var _,d=[];return function(e,t){return 47===e.charCodeAt(t)&&42===e.charCodeAt(t+1)&&42===e.charCodeAt(t+2)&&42!==e.charCodeAt(t+3)}(i,t)?(b.scanRange(t+3,r-5,(function(){var e=!0,n=1,r=void 0,u=t-Math.max(i.lastIndexOf("\n",t),0)+4;function l(e){r||(r=u),d.push(e),u+=e.length}for(E();5===H();)E();for(4===H()&&(n=0,u=0,E());1!==H();){switch(H()){case 57:0===n||1===n?(f(d),g(u),n=0,e=!1,r=void 0,u++):l(b.getTokenText());break;case 4:d.push(b.getTokenText()),n=0,u=0;break;case 39:var m=b.getTokenText();1===n||2===n?(n=2,l(m)):(n=1,u+=m.length);break;case 71:l(b.getTokenText()),n=2;break;case 5:var y=b.getTokenText();2===n?d.push(y):void 0!==r&&u+y.length>r&&d.push(y.slice(r-u-1)),u+=y.length;break;case 1:break;default:n=2,l(b.getTokenText())}e?E():e=!0}p(d),f(d),_=function(){var e=ue(275,t);return e.tags=a&&_e(a,o,s),e.comment=d.length?d.join(""):void 0,le(e,c)}()})),_):_;function p(e){for(;e.length&&("\n"===e[0]||"\r"===e[0]);)e.shift()}function f(e){for(;e.length&&("\n"===e[e.length-1]||"\r"===e[e.length-1]);)e.pop()}function m(){for(;5===H()||4===H();)E()}function g(t){e.Debug.assert(57===H());var n=ue(57,b.getTokenPos());n.end=b.getTextPos(),E();var r=N();if(m(),r){var i;if(r)switch(r.escapedText){case"augments":case"extends":i=function(e,t){var n=ue(277,e.pos);return n.atToken=e,n.tagName=t,n.class=function(){var e=re(17),t=ue(201);t.expression=function(){var e=N(!0);for(;re(23);){var t=ue(179,e.pos);t.expression=e,t.name=N(),e=le(t)}return e}(),t.typeArguments=tr();var n=le(t);e&&ne(18);return n}(),le(n)}(n,r);break;case"class":case"constructor":i=function(e,t){var n=ue(278,e.pos);return n.atToken=e,n.tagName=t,le(n)}(n,r);break;case"arg":case"argument":case"param":i=k(n,r,1);break;case"return":case"returns":i=function(t,n){e.forEach(a,(function(e){return 280===e.kind}))&&V(n.pos,b.getTokenPos()-n.pos,e.Diagnostics._0_tag_already_specified,n.escapedText);var r=ue(280,t.pos);return r.atToken=t,r.tagName=n,r.typeExpression=h(),le(r)}(n,r);break;case"template":i=function(t,n){e.forEach(a,(function(e){return 282===e.kind}))&&V(n.pos,b.getTokenPos()-n.pos,e.Diagnostics._0_tag_already_specified,n.escapedText);var r=[],i=W();for(;;){var o=N();if(m(),!o)return void V(b.getStartPos(),0,e.Diagnostics.Identifier_expected);var s=ue(145,o.pos);if(s.name=o,le(s),r.push(s),26!==H())break;E(),m()}var c=ue(282,t.pos);return c.atToken=t,c.tagName=n,c.typeParameters=_e(r,i),le(c),c}(n,r);break;case"type":i=S(n,r);break;case"typedef":i=function(e,t){var n=h();m();var r=ue(283,e.pos);if(r.atToken=e,r.tagName=t,r.fullName=u(0),r.fullName)for(var i=r.fullName;;){if(71===i.kind||!i.body){r.name=71===i.kind?i:i.name;break}i=i.body}if(m(),r.typeExpression=n,!n||x(n.type)){for(var a=void 0,o=void 0,s=void 0,c=b.getStartPos();a=ee((function(){return C(0)}));)if(o||(o=ue(285,c)),281===a.kind){if(s)break;s=a}else o.jsDocPropertyTags||(o.jsDocPropertyTags=[]),o.jsDocPropertyTags.push(a);o&&(n&&164===n.type.kind&&(o.isArrayType=!0),r.typeExpression=s&&s.typeExpression&&!x(s.typeExpression.type)?s.typeExpression:le(o))}return le(r);function u(e){var t=b.getTokenPos(),n=N();if(n&&re(23)){var r=ue(233,t);return r.flags|=e,r.name=n,r.body=u(4),le(r)}return n&&4&e&&(n.isInJSDocNamespace=!0),n}}(n,r);break;default:i=y(n,r)}else i=y(n,r);i&&function(e,t){e.comment=t.join(""),a?a.push(e):(a=[e],o=e.pos);s=e.end}(i,function(e){var t,n=[],r=0;function i(r){t||(t=e),n.push(r),e+=r.length}for(;57!==H()&&1!==H();){switch(H()){case 4:r>=1&&(r=0,n.push(b.getTokenText())),e=0;break;case 57:break;case 5:if(2===r)i(b.getTokenText());else{var a=b.getTokenText();void 0!==t&&e+a.length>t&&n.push(a.slice(t-e-1)),e+=a.length}break;case 39:if(0===r){r=1,e+=b.getTokenText().length;break}default:r=2,i(b.getTokenText())}if(57===H())break;E()}return p(n),f(n),n}(t+i.end-i.pos))}}function y(e,t){var n=ue(276,e.pos);return n.atToken=e,n.tagName=t,le(n)}function h(){return m(),17===H()?n():void 0}function v(){var e=re(21),t=function(){var e=N(!0);re(21)&&ne(22);for(;re(23);){var t=N(!0);re(21)&&ne(22),e=ze(e,t)}return e}();return e&&(m(),ie(58)&&wt(),ne(22)),{name:t,isBracketed:e}}function x(t){switch(t.kind){case 134:return!0;case 164:return x(t.elementType);default:return e.isTypeReferenceNode(t)&&e.isIdentifier(t.typeName)&&"Object"===t.typeName.escapedText}}function k(e,t,n){var r=h(),i=!r;m();var a=v(),o=a.name,s=a.isBracketed;m(),i&&(r=h());var c=ue(1===n?279:284,e.pos),u=function(e,t){if(e&&x(e.type)){for(var n=ue(267,b.getTokenPos()),r=void 0,i=void 0,a=b.getStartPos(),o=void 0;r=ee((function(){return C(1,t)}));)o||(o=[]),o.push(r);if(o)return(i=ue(285,a)).jsDocPropertyTags=o,164===e.type.kind&&(i.isArrayType=!0),n.type=le(i),le(n)}}(r,o);return u&&(r=u,i=!0),c.atToken=e,c.tagName=t,c.typeExpression=r,c.name=o,c.isNameFirst=i,c.isBracketed=s,le(c)}function S(t,r){e.forEach(a,(function(e){return 281===e.kind}))&&V(r.pos,b.getTokenPos()-r.pos,e.Diagnostics._0_tag_already_specified,r.escapedText);var i=ue(281,t.pos);return i.atToken=t,i.tagName=r,i.typeExpression=n(!0),le(i)}function D(t,n){for(;!e.isIdentifier(t)||!e.isIdentifier(n);){if(e.isIdentifier(t)||e.isIdentifier(n)||t.right.escapedText!==n.right.escapedText)return!1;t=t.left,n=n.left}return t.escapedText===n.escapedText}function C(t,n){for(var r=!0,i=!1;;)switch(E(),H()){case 57:if(r){var a=T(t);return!(a&&279===a.kind&&(e.isIdentifier(a.name)||!D(n,a.name.left)))&&a}i=!1;break;case 4:r=!0,i=!1;break;case 39:i&&(r=!1),i=!0;break;case 71:r=!1;break;case 1:return!1}}function T(t){e.Debug.assert(57===H());var n=ue(57,b.getStartPos());n.end=b.getTextPos(),E();var r=N();if(m(),!r)return!1;switch(r.escapedText){case"type":return 0===t&&S(n,r);case"prop":case"property":return 0===t&&k(n,r,t);case"arg":case"argument":case"param":return 1===t&&k(n,r,t)}return!1}function E(){return u=b.scanJSDocToken()}function N(t){if(void 0===t&&(t=!1),!e.tokenIsIdentifierOrKeyword(H()))return t?de(71,!0,e.Diagnostics.Identifier_expected):void U(e.Diagnostics.Identifier_expected);var n=b.getTokenPos(),r=b.getTextPos(),a=ue(71,n);return a.escapedText=e.escapeLeadingUnderscores(i.substring(n,r)),le(a,r),E(),a}}t.parseJSDocTypeExpressionForTests=function(e,t,r){D(e,5,void 0,1),o=N("file.js",5,1),b.setText(e,t,r),u=b.scan();var i=n(),a=s;return C(),i?{jsDocTypeExpression:i,diagnostics:a}:void 0},t.parseJSDocTypeExpression=n,t.parseIsolatedJSDocComment=function(e,t,n){D(e,5,void 0,1),o={languageVariant:0,text:e};var r=a(t,n),i=s;return C(),r?{jsDoc:r,diagnostics:i}:void 0},t.parseJSDocComment=function(t,n,r){var i,c=u,_=s.length,l=k,d=a(n,r);return d&&(d.parent=t),e.isInJavaScriptFile(t)&&(o.jsDocDiagnostics||(o.jsDocDiagnostics=[]),(i=o.jsDocDiagnostics).push.apply(i,s)),u=c,s.length=_,k=l,d},function(e){e[e.BeginningOfLine=0]="BeginningOfLine",e[e.SawAsterisk=1]="SawAsterisk",e[e.SavingComments=2]="SavingComments"}(r||(r={})),function(e){e[e.Property=0]="Property",e[e.Parameter=1]="Parameter"}(i||(i={})),t.parseJSDocCommentWorker=a}(v=t.JSDocParser||(t.JSDocParser={}))}(o||(o={})),function(t){function n(t,n,i,o,s,c){return void(n?l(t):u(t));function u(t){var n="";if(c&&r(t)&&(n=o.substring(t.pos,t.end)),t._children&&(t._children=void 0),t.pos+=i,t.end+=i,c&&r(t)&&e.Debug.assert(n===s.substring(t.pos,t.end)),_(t,u,l),e.hasJSDocNodes(t))for(var d=0,p=t.jsDoc;d<p.length;d++){_(p[d],u,l)}a(t,c)}function l(e){e._children=void 0,e.pos+=i,e.end+=i;for(var t=0,n=e;t<n.length;t++){u(n[t])}}}function r(e){switch(e.kind){case 9:case 8:case 71:return!0}return!1}function i(t,n,r,i,a){e.Debug.assert(t.end>=n,"Adjusting an element that was entirely before the change range"),e.Debug.assert(t.pos<=r,"Adjusting an element that was entirely after the change range"),e.Debug.assert(t.pos<=t.end),t.pos=Math.min(t.pos,i),t.end>=r?t.end+=a:t.end=Math.min(t.end,i),e.Debug.assert(t.pos<=t.end),t.parent&&(e.Debug.assert(t.pos>=t.parent.pos),e.Debug.assert(t.end<=t.parent.end))}function a(t,n){if(n){var r=t.pos;_(t,(function(t){e.Debug.assert(t.pos>=r),r=t.end})),e.Debug.assert(r<=t.end)}}function s(t,n){var r,i=t;if(_(t,(function t(a){if(e.nodeIsMissing(a))return;if(!(a.pos<=n))return e.Debug.assert(a.pos>n),!0;if(a.pos>=i.pos&&(i=a),n<a.end)return _(a,t),!0;e.Debug.assert(a.end<=n),r=a})),r){var a=function(e){for(;;){var t=o(e);if(!t)return e;e=t}}(r);a.pos>i.pos&&(i=a)}return i;function o(t){var n=void 0;return _(t,(function(t){e.nodeIsPresent(t)&&(n=t)})),n}}function c(t,n,r,i){var a=t.text;if(r&&(e.Debug.assert(a.length-r.span.length+r.newLength===n.length),i||e.Debug.shouldAssert(3))){var o=a.substr(0,r.span.start),s=n.substr(0,r.span.start);e.Debug.assert(o===s);var c=a.substring(e.textSpanEnd(r.span),a.length),u=n.substring(e.textSpanEnd(e.textChangeRangeNewSpan(r)),n.length);e.Debug.assert(c===u)}}var u;t.updateSourceFile=function(t,r,u,l){if(c(t,r,u,l=l||e.Debug.shouldAssert(2)),e.textChangeRangeIsUnchanged(u))return t;if(0===t.statements.length)return o.parseSourceFile(t.fileName,r,t.languageVersion,void 0,!0,t.scriptKind);var d=t;e.Debug.assert(!d.hasBeenIncrementallyParsed),d.hasBeenIncrementallyParsed=!0;var p=t.text,f=function(t){var n=t.statements,r=0;e.Debug.assert(r<n.length);var i=n[r],a=-1;return{currentNode:function(t){return t!==a&&(i&&i.end===t&&r<n.length-1&&(r++,i=n[r]),i&&i.pos===t||o(t)),a=t,e.Debug.assert(!i||i.pos===t),i}};function o(e){return n=void 0,r=-1,i=void 0,void _(t,a,o);function a(t){return e>=t.pos&&e<t.end&&(_(t,a,o),!0)}function o(t){if(e>=t.pos&&e<t.end)for(var s=0;s<t.length;s++){var c=t[s];if(c){if(c.pos===e)return n=t,r=s,i=c,!0;if(c.pos<e&&e<c.end)return _(c,a,o),!0}}return!1}}}(t),m=function(t,n){for(var r=1,i=n.span.start,a=0;i>0&&a<=r;a++){var o=s(t,i);e.Debug.assert(o.pos<=i);var c=o.pos;i=Math.max(0,c-1)}var u=e.createTextSpanFromBounds(i,e.textSpanEnd(n.span)),_=n.newLength+(n.span.start-i);return e.createTextChangeRange(u,_)}(t,u);c(t,r,m,l),e.Debug.assert(m.span.start<=u.span.start),e.Debug.assert(e.textSpanEnd(m.span)===e.textSpanEnd(u.span)),e.Debug.assert(e.textSpanEnd(e.textChangeRangeNewSpan(m))===e.textSpanEnd(e.textChangeRangeNewSpan(u)));var g=e.textChangeRangeNewSpan(m).length-m.span.length;return function(t,r,o,s,c,u,l,d){return void p(t);function p(t){if(e.Debug.assert(t.pos<=t.end),t.pos>o)n(t,!1,c,u,l,d);else{var m=t.end;if(m>=r)return t.intersectsChange=!0,t._children=void 0,i(t,r,o,s,c),_(t,p,f),void a(t,d);e.Debug.assert(m<r)}}function f(t){if(e.Debug.assert(t.pos<=t.end),t.pos>o)n(t,!0,c,u,l,d);else{var a=t.end;if(a>=r){t.intersectsChange=!0,t._children=void 0,i(t,r,o,s,c);for(var _=0,f=t;_<f.length;_++){p(f[_])}}else e.Debug.assert(a<r)}}}(d,m.span.start,e.textSpanEnd(m.span),e.textSpanEnd(e.textChangeRangeNewSpan(m)),g,p,r,l),o.parseSourceFile(t.fileName,r,t.languageVersion,f,!0,t.scriptKind)},function(e){e[e.Value=-1]="Value"}(u||(u={}))}(s||(s={}))}(ts||(ts={})),function(e){var t;function n(t){if(230===t.kind||231===t.kind)return 0;if(e.isConstEnumDeclaration(t))return 2;if(238!==t.kind&&237!==t.kind||e.hasModifier(t,1)){if(234===t.kind){var r=0;return e.forEachChild(t,(function(e){switch(n(e)){case 0:return!1;case 2:return r=2,!1;case 1:return r=1,!0}})),r}if(233===t.kind){var i=t.body;return i?n(i):1}return 71===t.kind&&t.isInJSDocNamespace?0:1}return 0}!function(e){e[e.NonInstantiated=0]="NonInstantiated",e[e.Instantiated=1]="Instantiated",e[e.ConstEnumOnly=2]="ConstEnumOnly"}(e.ModuleInstanceState||(e.ModuleInstanceState={})),e.getModuleInstanceState=n,function(e){e[e.None=0]="None",e[e.IsContainer=1]="IsContainer",e[e.IsBlockScopedContainer=2]="IsBlockScopedContainer",e[e.IsControlFlowContainer=4]="IsControlFlowContainer",e[e.IsFunctionLike=8]="IsFunctionLike",e[e.IsFunctionExpression=16]="IsFunctionExpression",e[e.HasLocals=32]="HasLocals",e[e.IsInterface=64]="IsInterface",e[e.IsObjectLiteralOrClassExpressionMethod=128]="IsObjectLiteralOrClassExpressionMethod"}(t||(t={}));var r=function(){var t,r,s,c,u,_,l,d,p,f,m,g,y,h,v,b,x,k,S,D,C,T,E=0,N={flags:1},A={flags:1},w=0;function P(n,r,i,a,o){return e.createDiagnosticForNodeInSourceFile(e.getSourceFileOfNode(n)||t,n,r,i,a,o)}return function(n,i){t=n,r=i,s=e.getEmitScriptTarget(r),S=function(e,t){return!(!(void 0===t.alwaysStrict?t.strict:t.alwaysStrict)||e.isDeclarationFile)||!!e.externalModuleIndicator}(t,i),C=e.createUnderscoreEscapedMap(),E=0,T=t.isDeclarationFile,D=e.objectAllocator.getSymbolConstructor(),t.locals||(be(t),t.symbolCount=E,t.classifiableNames=C),t=void 0,r=void 0,s=void 0,c=void 0,u=void 0,_=void 0,l=void 0,d=!1,p=void 0,f=void 0,m=void 0,g=void 0,y=void 0,h=void 0,b=void 0,x=!1,k=0,w=0};function F(e,t){return E++,new D(e,t)}function O(t,n,r){if(t.flags|=r,n.symbol=t,t.declarations?t.declarations.push(n):t.declarations=[n],1952&r&&!t.exports&&(t.exports=e.createSymbolTable()),6240&r&&!t.members&&(t.members=e.createSymbolTable()),107455&r){var i=t.valueDeclaration;(!i||i.kind!==n.kind&&233===i.kind)&&(t.valueDeclaration=n)}}function I(t){if(243===t.kind)return t.isExportEquals?"export=":"default";var n=e.getNameOfDeclaration(t);if(n){if(e.isAmbientModule(t)){var r=e.getTextOfIdentifierOrLiteral(n);return e.isGlobalScopeAugmentation(t)?"__global":'"'+r+'"'}if(144===n.kind){var i=n.expression;return e.isStringOrNumericLiteral(i)?e.escapeLeadingUnderscores(i.text):(e.Debug.assert(e.isWellKnownSymbolSyntactically(i)),e.getPropertyNameForKnownSymbolName(e.idText(i.name)))}return e.getEscapedTextOfIdentifierOrLiteral(n)}switch(t.kind){case 152:return"__constructor";case 160:case 155:return"__call";case 161:case 156:return"__new";case 157:return"__index";case 244:return"__export";case 194:if(2===e.getSpecialPropertyAssignmentKind(t))return"export=";e.Debug.fail("Unknown binary declaration kind");break;case 228:case 229:return e.hasModifier(t,512)?"default":void 0;case 273:return e.isJSDocConstructSignature(t)?"__new":"__call";case 146:e.Debug.assert(273===t.parent.kind);var a=t.parent;return"arg"+e.indexOf(a.parameters,t);case 283:var o=e.getNameOfJSDocTypedef(t);return void 0!==o?o.escapedText:void 0}}function R(t){return t.name?e.declarationNameToString(t.name):e.unescapeLeadingUnderscores(I(t))}function L(n,r,i,a,o,s){e.Debug.assert(!e.hasDynamicName(i));var c,u=e.hasModifier(i,512),_=u&&r?"default":I(i);if(void 0===_)c=F(0,"__missing");else if(c=n.get(_),788448&a&&C.set(_,!0),c){if(s&&!c.isReplaceableByMethod)return c;if(c.flags&o)if(c.isReplaceableByMethod)n.set(_,c=F(0,_));else{i.name&&(i.name.parent=i);var l=2&c.flags?e.Diagnostics.Cannot_redeclare_block_scoped_variable_0:e.Diagnostics.Duplicate_identifier_0;c.declarations&&c.declarations.length&&(u||c.declarations&&c.declarations.length&&(u||243===i.kind&&!i.isExportEquals))&&(l=e.Diagnostics.A_module_cannot_have_multiple_default_exports),e.forEach(c.declarations,(function(n){t.bindDiagnostics.push(P(e.getNameOfDeclaration(n)||n,l,R(n)))})),t.bindDiagnostics.push(P(e.getNameOfDeclaration(i)||i,l,R(i))),c=F(0,_)}}else n.set(_,c=F(0,_)),s&&(c.isReplaceableByMethod=!0);return O(c,i,a),c.parent=r,c}function M(t,n,r){var i=1&e.getCombinedModifierFlags(t);if(2097152&n)return 246===t.kind||237===t.kind&&i?L(u.symbol.exports,u.symbol,t,n,r):L(u.locals,void 0,t,n,r);283===t.kind&&e.Debug.assert(e.isInJavaScriptFile(t));var a=283===t.kind&&t.name&&71===t.name.kind&&t.name.isInJSDocNamespace;if(!e.isAmbientModule(t)&&(i||32&u.flags)||a){var o=107455&n?1048576:0,s=L(u.locals,void 0,t,o,r);return s.exportSymbol=L(u.symbol.exports,u.symbol,t,n,r),t.localSymbol=s,s}return L(u.locals,void 0,t,n,r)}function B(e){if(T)j(e);else if(536870912&e.transformFlags)T=!0,j(e),T=!1,w|=e.transformFlags&~a(e.kind);else{var t=w;w=0,j(e),w=t|i(e,w)}}function J(t){if(void 0!==t)if(T)e.forEach(t,be);else{var n=w;w=0;for(var r=0,i=0,a=t;i<a.length;i++){var o=a[i];be(o),r|=-536870913&o.transformFlags}t.transformFlags=536870912|r,w|=n}}function z(t){e.forEachChild(t,be,J)}function j(i){if(e.hasJSDocNodes(i))if(e.isInJavaScriptFile(i))for(var a=0,s=i.jsDoc;a<s.length;a++){be(s[a])}else for(var c=0,u=i.jsDoc;c<u.length;c++){o(i,u[c])}if(function(t){if(!(1&p.flags))return!1;if(p===N){if(e.isStatementButNotDeclaration(t)&&209!==t.kind||229===t.kind||233===t.kind&&function(e){var t=n(e);return 1===t||2===t&&r.preserveConstEnums}(t)||232===t.kind&&(!e.isConstEnumDeclaration(t)||r.preserveConstEnums))p=A,!r.allowUnreachableCode&&!e.isInAmbientContext(t)&&(208!==t.kind||3&e.getCombinedNodeFlags(t.declarationList)||e.forEach(t.declarationList.declarations,(function(e){return e.initializer})))&&ve(t,e.Diagnostics.Unreachable_code_detected)}return!0}(i))z(i);else switch(i.kind){case 213:!function(e){var t=H(),n=W(),r=W();Q(t,p),p=t,ne(e.expression,n,r),p=ee(n),re(e.statement,r,t),Q(t,p),p=ee(r)}(i);break;case 212:!function(t){var n=H(),r=222===t.parent.kind?e.lastOrUndefined(b):void 0,i=r?r.continueTarget:W(),a=r?r.breakTarget:W();Q(n,p),p=n,re(t.statement,a,i),Q(i,p),p=ee(i),ne(t.expression,n,a),p=ee(a)}(i);break;case 214:!function(e){var t=H(),n=W(),r=W();be(e.initializer),Q(t,p),p=t,ne(e.condition,n,r),p=ee(n),re(e.statement,r,t),be(e.incrementor),Q(t,p),p=ee(r)}(i);break;case 215:case 216:!function(e){var t=H(),n=W();Q(t,p),p=t,216===e.kind&&be(e.awaitModifier);be(e.expression),Q(n,p),be(e.initializer),227!==e.initializer.kind&&oe(e.initializer);re(e.statement,n,t),Q(t,p),p=ee(n)}(i);break;case 211:!function(e){var t=W(),n=W(),r=W();ne(e.expression,t,n),p=ee(t),be(e.thenStatement),Q(r,p),p=ee(n),be(e.elseStatement),Q(r,p),p=ee(r)}(i);break;case 219:case 223:!function(e){be(e.expression),219===e.kind&&(x=!0,g&&Q(g,p));p=N}(i);break;case 218:case 217:!function(e){if(be(e.label),e.label){var t=function(e){if(b)for(var t=0,n=b;t<n.length;t++){var r=n[t];if(r.name===e)return r}return}(e.label.escapedText);t&&(t.referenced=!0,ie(e,t.breakTarget,t.continueTarget))}else ie(e,f,m)}(i);break;case 224:!function(e){var t=W(),n=p;be(e.tryBlock),Q(t,p);var r=p,i=N;e.catchClause&&(p=n,be(e.catchClause),Q(t,p),i=p);if(e.finallyBlock){var a={flags:2048,antecedent:n,lock:{}};if(Q(t,a),p=ee(t),be(e.finallyBlock),1&p.flags||1&r.flags&&1&i.flags&&(p=r===A||i===A?A:N),!(1&p.flags)){var o={flags:4096,antecedent:p};a.lock=o,p=o}}else p=ee(t)}(i);break;case 221:!function(t){var n=W();be(t.expression);var r=f,i=v;f=n,v=p,be(t.caseBlock),Q(n,p);var a=e.forEach(t.caseBlock.clauses,(function(e){return 258===e.kind}));t.possiblyExhaustive=!a&&!n.antecedents,a||Q(n,Y(v,t,0,0));f=r,v=i,p=ee(n)}(i);break;case 235:!function(t){var n=w;w=0;for(var i=t.clauses,a=N,o=0;o<i.length;o++){for(var s=o;!i[o].statements.length&&o+1<i.length;)be(i[o]),o++;var c=W();Q(c,Y(v,t.parent,s,o+1)),Q(c,a),p=ee(c);var u=i[o];be(u),a=p,1&p.flags||o===i.length-1||!r.noFallthroughCasesInSwitch||ve(u,e.Diagnostics.Fallthrough_case_in_switch)}i.transformFlags=536870912|w,w|=n}(i);break;case 257:!function(e){var t=p;p=v,be(e.expression),p=t,J(e.statements)}(i);break;case 222:!function(n){var i=H(),a=W();be(n.label),Q(i,p);var o=function(e,t,n){var r={name:e,breakTarget:t,continueTarget:n,referenced:!1};return(b||(b=[])).push(r),r}(n.label.escapedText,a,i);be(n.statement),b.pop(),o.referenced||r.allowUnusedLabels||t.bindDiagnostics.push(P(n.label,e.Diagnostics.Unused_label));n.statement&&212===n.statement.kind||(Q(a,p),p=ee(a))}(i);break;case 192:!function(e){if(51===e.operator){var t=y;y=h,h=t,z(e),h=y,y=t}else z(e),43!==e.operator&&44!==e.operator||oe(e.operand)}(i);break;case 193:!function(e){z(e),(43===e.operator||44===e.operator)&&oe(e.operand)}(i);break;case 194:!function(t){var n=t.operatorToken.kind;if(53===n||54===n)if(function(e){for(;185===e.parent.kind||192===e.parent.kind&&51===e.parent.operator;)e=e.parent;return!function(e){var t=e.parent;switch(t.kind){case 211:case 213:case 212:return t.expression===e;case 214:case 195:return t.condition===e}return!1}(e)&&!te(e.parent)}(t)){var r=W();se(t,r,r),p=ee(r)}else se(t,y,h);else{if(z(t),e.isAssignmentOperator(n)&&!e.isAssignmentTarget(t))if(oe(t.left),58===n&&180===t.left.kind)q(t.left.expression)&&(p=$(p,t))}}(i);break;case 188:!function(e){z(e),179===e.expression.kind&&oe(e.expression)}(i);break;case 195:!function(e){var t=W(),n=W(),r=W();ne(e.condition,t,n),p=ee(t),be(e.questionToken),be(e.whenTrue),Q(r,p),p=ee(n),be(e.colonToken),be(e.whenFalse),Q(r,p),p=ee(r)}(i);break;case 226:!function(t){z(t),(t.initializer||e.isForInOrOfStatement(t.parent.parent))&&ce(t)}(i);break;case 181:!function(t){var n=t.expression;for(;185===n.kind;)n=n.expression;186===n.kind||187===n.kind?(J(t.typeArguments),J(t.arguments),be(t.expression)):z(t);if(179===t.expression.kind){var r=t.expression;q(r.expression)&&e.isPushOrUnshiftIdentifier(r.name)&&(p=$(p,t))}}(i);break;case 275:!function(t){e.forEachChild(t,(function(e){283!==e.kind&&be(e)}))}(i);break;case 283:!function(t){e.forEachChild(t,(function(e){t.fullName&&e===t.name&&71!==t.fullName.kind||be(e)}))}(i);break;default:z(i)}}function K(e){switch(e.kind){case 71:case 99:case 179:return U(e);case 181:return function(e){if(e.arguments)for(var t=0,n=e.arguments;t<n.length;t++){if(U(n[t]))return!0}if(179===e.expression.kind&&U(e.expression.expression))return!0;return!1}(e);case 185:return K(e.expression);case 194:return function(e){switch(e.operatorToken.kind){case 58:return U(e.left);case 32:case 33:case 34:case 35:return q(e.left)||q(e.right)||V(e.right,e.left)||V(e.left,e.right);case 93:return q(e.left);case 26:return K(e.right)}return!1}(e);case 192:return 51===e.operator&&K(e.operand)}return!1}function U(e){return 71===e.kind||99===e.kind||97===e.kind||179===e.kind&&U(e.expression)}function V(e,t){return 189===e.kind&&q(e.expression)&&9===t.kind}function q(e){switch(e.kind){case 185:return q(e.expression);case 194:switch(e.operatorToken.kind){case 58:return q(e.left);case 26:return q(e.right)}}return U(e)}function W(){return{flags:4,antecedents:void 0}}function H(){return{flags:8,antecedents:void 0}}function G(e){e.flags|=512&e.flags?1024:512}function Q(t,n){1&n.flags||e.contains(t.antecedents,n)||((t.antecedents||(t.antecedents=[])).push(n),G(n))}function X(e,t,n){return 1&t.flags?t:n?101===n.kind&&64&e||86===n.kind&&32&e?N:K(n)?(G(t),{flags:e,expression:n,antecedent:t}):t:32&e?t:N}function Y(e,t,n,r){return K(t.expression)?(G(e),{flags:128,switchStatement:t,clauseStart:n,clauseEnd:r,antecedent:e}):e}function Z(e,t){return G(e),{flags:16,antecedent:e,node:t}}function $(e,t){return G(e),{flags:256,antecedent:e,node:t}}function ee(e){var t=e.antecedents;return t?1===t.length?t[0]:e:N}function te(e){for(;;)if(185===e.kind)e=e.expression;else{if(192!==e.kind||51!==e.operator)return 194===e.kind&&(53===e.operatorToken.kind||54===e.operatorToken.kind);e=e.operand}}function ne(e,t,n){var r=y,i=h;y=t,h=n,be(e),y=r,h=i,e&&te(e)||(Q(t,X(32,p,e)),Q(n,X(64,p,e)))}function re(e,t,n){var r=f,i=m;f=t,m=n,be(e),f=r,m=i}function ie(e,t,n){var r=218===e.kind?t:n;r&&(Q(r,p),p=N)}function ae(e){194===e.kind&&58===e.operatorToken.kind?oe(e.left):oe(e)}function oe(e){if(U(e))p=Z(p,e);else if(177===e.kind)for(var t=0,n=e.elements;t<n.length;t++){var r=n[t];198===r.kind?oe(r.expression):ae(r)}else if(178===e.kind)for(var i=0,a=e.properties;i<a.length;i++){var o=a[i];261===o.kind?ae(o.initializer):262===o.kind?oe(o.name):263===o.kind&&oe(o.expression)}}function se(e,t,n){var r={flags:4,antecedents:void 0};53===e.operatorToken.kind?ne(e.left,r,n):ne(e.left,t,r),p=ee(r),be(e.operatorToken),ne(e.right,t,n)}function ce(t){var n=e.isOmittedExpression(t)?void 0:t.name;if(e.isBindingPattern(n))for(var r=0,i=n.elements;r<i.length;r++){ce(i[r])}else p=Z(p,t)}function ue(e){l&&(l.nextContainer=e),l=e}function _e(n,r,i){switch(u.kind){case 233:return M(n,r,i);case 265:return function(n,r,i){return e.isExternalModule(t)?M(n,r,i):L(t.locals,void 0,n,r,i)}(n,r,i);case 199:case 229:return function(t,n,r){return e.hasModifier(t,32)?L(u.symbol.exports,u.symbol,t,n,r):L(u.symbol.members,u.symbol,t,n,r)}(n,r,i);case 232:return L(u.symbol.exports,u.symbol,n,r,i);case 163:case 285:case 178:case 230:case 254:return L(u.symbol.members,u.symbol,n,r,i);case 160:case 161:case 155:case 156:case 157:case 151:case 150:case 152:case 153:case 154:case 228:case 186:case 187:case 273:case 231:case 172:return L(u.locals,void 0,n,r,i)}}function le(t){e.isInAmbientContext(t)&&!function(e){var t=265===e.kind?e:e.body;if(t&&(265===t.kind||234===t.kind))for(var n=0,r=t.statements;n<r.length;n++){var i=r[n];if(244===i.kind||243===i.kind)return!0}return!1}(t)?t.flags|=32:t.flags&=-33}function de(e){var t=n(e),r=0!==t;return _e(e,r?512:1024,r?106639:0),t}function pe(e,t,n){var r=F(t,n);8&t&&(r.parent=u.symbol),O(r,e,t)}function fe(t,n,r){switch(_.kind){case 233:M(t,n,r);break;case 265:if(e.isExternalModule(u)){M(t,n,r);break}default:_.locals||(_.locals=e.createSymbolTable(),ue(_)),L(_.locals,void 0,t,n,r)}}function me(n){S&&n.originalKeywordKind>=108&&n.originalKeywordKind<=116&&!e.isIdentifierName(n)&&!e.isInAmbientContext(n)&&(t.parseDiagnostics.length||t.bindDiagnostics.push(P(n,function(n){if(e.getContainingClass(n))return e.Diagnostics.Identifier_expected_0_is_a_reserved_word_in_strict_mode_Class_definitions_are_automatically_in_strict_mode;if(t.externalModuleIndicator)return e.Diagnostics.Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode;return e.Diagnostics.Identifier_expected_0_is_a_reserved_word_in_strict_mode}(n),e.declarationNameToString(n))))}function ge(n,r){if(r&&71===r.kind){var i=r;if(o=i,e.isIdentifier(o)&&("eval"===o.escapedText||"arguments"===o.escapedText)){var a=e.getErrorSpanForNode(t,r);t.bindDiagnostics.push(e.createFileDiagnostic(t,a.start,a.length,function(n){if(e.getContainingClass(n))return e.Diagnostics.Invalid_use_of_0_Class_definitions_are_automatically_in_strict_mode;if(t.externalModuleIndicator)return e.Diagnostics.Invalid_use_of_0_Modules_are_automatically_in_strict_mode;return e.Diagnostics.Invalid_use_of_0_in_strict_mode}(n),e.idText(i)))}}var o}function ye(e){S&&ge(e,e.name)}function he(n){if(s<2&&265!==_.kind&&233!==_.kind&&!e.isFunctionLike(_)){var r=e.getErrorSpanForNode(t,n);t.bindDiagnostics.push(e.createFileDiagnostic(t,r.start,r.length,function(n){return e.getContainingClass(n)?e.Diagnostics.Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Class_definitions_are_automatically_in_strict_mode:t.externalModuleIndicator?e.Diagnostics.Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Modules_are_automatically_in_strict_mode:e.Diagnostics.Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5}(n)))}}function ve(n,r,i,a,o){var s=e.getSpanOfTokenAtPosition(t,n.pos);t.bindDiagnostics.push(e.createFileDiagnostic(t,s.start,s.length,r,i,a,o))}function be(n){if(n){n.parent=c;var r=S;if(e.isInJavaScriptFile(n)&&function(t){if(!e.hasJSDocNodes(t))return;for(var n=0,r=t.jsDoc;n<r.length;n++){var i=r[n];if(i.tags)for(var a=0,o=i.tags;a<o.length;a++){var s=o[a];if(283===s.kind){var u=c;c=i,be(s),c=u}}}}(n),function(n){switch(n.kind){case 71:if(n.isInJSDocNamespace){for(var r=n.parent;r&&283!==r.kind;)r=r.parent;fe(r,524288,793064);break}case 99:return p&&(e.isExpression(n)||262===c.kind)&&(n.flowNode=p),me(n);case 179:p&&U(n)&&(n.flowNode=p);break;case 194:switch(e.getSpecialPropertyAssignmentKind(n)){case 1:De(n);break;case 2:!function(n){var r=e.getRightMostAssignedExpression(n.right);if(e.isEmptyObjectLiteral(r)||Ce(r))return void Se(n);Se(n),L(t.symbol.exports,t.symbol,n,1049092,0)}(n);break;case 3:!function(e){var t=e.left,n=t.expression,r=n.expression;t.parent=e,r.parent=n,n.parent=t,Ae(r.escapedText,t,!0)}(n);break;case 4:!function(t){e.Debug.assert(e.isInJavaScriptFile(t));var n=e.getThisContainer(t,!1);switch(n.kind){case 228:case 186:n.symbol.members=n.symbol.members||e.createSymbolTable(),L(n.symbol.members,n.symbol,t,4,0);break;case 152:case 149:case 151:case 153:case 154:var r=n.parent;L(e.hasModifier(n,32)?r.symbol.exports:r.symbol.members,r.symbol,t,4,0,!0)}}(n);break;case 5:!function(t){var n=t.left,r=n.expression;e.isIdentifier(r)&&(n.parent=t,r.parent=n,Te(r)?De(t):Ae(r.escapedText,n,!1))}(n);break;case 0:break;default:e.Debug.fail("Unknown special property assignment kind")}return function(t){S&&e.isLeftHandSideExpression(t.left)&&e.isAssignmentOperator(t.operatorToken.kind)&&ge(t,t.left)}(n);case 260:return function(e){S&&e.variableDeclaration&&ge(e,e.variableDeclaration.name)}(n);case 188:return function(n){if(S&&71===n.expression.kind){var r=e.getErrorSpanForNode(t,n.expression);t.bindDiagnostics.push(e.createFileDiagnostic(t,r.start,r.length,e.Diagnostics.delete_cannot_be_called_on_an_identifier_in_strict_mode))}}(n);case 8:return function(n){S&&4&n.numericLiteralFlags&&t.bindDiagnostics.push(P(n,e.Diagnostics.Octal_literals_are_not_allowed_in_strict_mode))}(n);case 193:return function(e){S&&ge(e,e.operand)}(n);case 192:return function(e){S&&(43!==e.operator&&44!==e.operator||ge(e,e.operand))}(n);case 220:return function(t){S&&ve(t,e.Diagnostics.with_statements_are_not_allowed_in_strict_mode)}(n);case 169:return void(d=!0);case 158:return function(e){var t=e.parameterName,n=e.type;t&&71===t.kind&&me(t);t&&169===t.kind&&(d=!0);be(n)}(n);case 145:return _e(n,262144,530920);case 146:return function(t){S&&!e.isInAmbientContext(t)&&ge(t,t.name);e.isBindingPattern(t.name)?pe(t,1,"__"+e.indexOf(t.parent.parameters,t)):_e(t,1,107455);if(e.isParameterPropertyDeclaration(t)){var n=t.parent.parent;L(n.symbol.members,n.symbol,t,4|(t.questionToken?16777216:0),0)}}(n);case 226:return we(n);case 176:return n.flowNode=p,we(n);case 149:case 148:return function(e){return Pe(e,4|(e.questionToken?16777216:0),0)}(n);case 261:case 262:return Pe(n,4,0);case 264:return Pe(n,8,900095);case 155:case 156:case 157:return _e(n,131072,0);case 151:case 150:return Pe(n,8192|(n.questionToken?16777216:0),e.isObjectLiteralMethod(n)?0:99263);case 228:return function(n){t.isDeclarationFile||e.isInAmbientContext(n)||e.isAsyncFunction(n)&&(k|=1024);ye(n),S?(he(n),fe(n,16,106927)):_e(n,16,106927)}(n);case 152:return _e(n,16384,0);case 153:return Pe(n,32768,41919);case 154:return Pe(n,65536,74687);case 160:case 273:case 161:return function(t){var n=F(131072,I(t));O(n,t,131072);var r=F(2048,"__type");O(r,t,2048),r.members=e.createSymbolTable(),r.members.set(n.escapedName,n)}(n);case 163:case 285:case 172:return function(e){return pe(e,2048,"__type")}(n);case 178:return function(n){var r;if(function(e){e[e.Property=1]="Property",e[e.Accessor=2]="Accessor"}(r||(r={})),S)for(var i=e.createUnderscoreEscapedMap(),a=0,o=n.properties;a<o.length;a++){var s=o[a];if(263!==s.kind&&71===s.name.kind){var c=s.name,u=261===s.kind||262===s.kind||151===s.kind?1:2,_=i.get(c.escapedText);if(_){if(1===u&&1===_){var l=e.getErrorSpanForNode(t,c);t.bindDiagnostics.push(e.createFileDiagnostic(t,l.start,l.length,e.Diagnostics.An_object_literal_cannot_have_multiple_properties_with_the_same_name_in_strict_mode))}}else i.set(c.escapedText,u)}}return pe(n,4096,"__object")}(n);case 186:case 187:return function(n){t.isDeclarationFile||e.isInAmbientContext(n)||e.isAsyncFunction(n)&&(k|=1024);p&&(n.flowNode=p);ye(n);var r=n.name?n.name.escapedText:"__function";return pe(n,16,r)}(n);case 181:e.isInJavaScriptFile(n)&&function(n){!t.commonJsModuleIndicator&&e.isRequireCall(n,!1)&&Se(n)}(n);break;case 199:case 229:return S=!0,function(n){if(229===n.kind)fe(n,32,899519);else{pe(n,32,n.name?n.name.escapedText:"__class"),n.name&&C.set(n.name.escapedText,!0)}var r=n.symbol,i=F(4194308,"prototype"),a=r.exports.get(i.escapedName);a&&(n.name&&(n.name.parent=n),t.bindDiagnostics.push(P(a.declarations[0],e.Diagnostics.Duplicate_identifier_0,e.symbolName(i))));r.exports.set(i.escapedName,i),i.parent=r}(n);case 230:return fe(n,64,792968);case 231:return fe(n,524288,793064);case 232:return function(t){return e.isConst(t)?fe(t,128,899967):fe(t,256,899327)}(n);case 233:return function(n){if(le(n),e.isAmbientModule(n))if(e.hasModifier(n,1)&&ve(n,e.Diagnostics.export_modifier_cannot_be_applied_to_ambient_modules_and_module_augmentations_since_they_are_always_visible),e.isExternalModuleAugmentation(n))de(n);else{var r=void 0;if(9===n.name.kind){var i=n.name.text;e.hasZeroOrOneAsteriskCharacter(i)?r=e.tryParsePattern(i):ve(n.name,e.Diagnostics.Pattern_0_can_have_at_most_one_Asterisk_character,i)}var a=_e(n,512,106639);r&&(t.patternAmbientModules||(t.patternAmbientModules=[])).push({pattern:r,symbol:a})}else{var o=de(n);if(0!==o)if(304&n.symbol.flags)n.symbol.constEnumOnlyModule=!1;else{var s=2===o;void 0===n.symbol.constEnumOnlyModule?n.symbol.constEnumOnlyModule=s:n.symbol.constEnumOnlyModule=n.symbol.constEnumOnlyModule&&s}}}(n);case 254:return function(e){return pe(e,4096,"__jsxAttributes")}(n);case 253:return function(e,t,n){return _e(e,t,n)}(n,4,0);case 237:case 240:case 242:case 246:return _e(n,2097152,2097152);case 236:return function(n){n.modifiers&&n.modifiers.length&&t.bindDiagnostics.push(P(n,e.Diagnostics.Modifiers_cannot_appear_here));if(265!==n.parent.kind)return void t.bindDiagnostics.push(P(n,e.Diagnostics.Global_module_exports_may_only_appear_at_top_level));var r=n.parent;if(!e.isExternalModule(r))return void t.bindDiagnostics.push(P(n,e.Diagnostics.Global_module_exports_may_only_appear_in_module_files));if(!r.isDeclarationFile)return void t.bindDiagnostics.push(P(n,e.Diagnostics.Global_module_exports_may_only_appear_in_declaration_files));t.symbol.globalExports=t.symbol.globalExports||e.createSymbolTable(),L(t.symbol.globalExports,t.symbol,n,2097152,2097152)}(n);case 239:return function(e){e.name&&_e(e,2097152,2097152)}(n);case 244:return function(e){u.symbol&&u.symbol.exports?e.exportClause||L(u.symbol.exports,u.symbol,e,8388608,0):pe(e,8388608,I(e))}(n);case 243:return function(t){if(u.symbol&&u.symbol.exports){var n=243===t.kind&&e.exportAssignmentIsAlias(t)?2097152:4;L(u.symbol.exports,u.symbol,t,n,2097204)}else pe(t,2097152,I(t))}(n);case 265:return xe(n.statements),le(t),void(e.isExternalModule(t)&&ke());case 207:if(!e.isFunctionLike(n.parent))return;case 234:return xe(n.statements);case 279:if(285!==n.parent.kind)break;case 284:var i=n;return _e(i,i.isBracketed||i.typeExpression&&272===i.typeExpression.type.kind?16777220:4,0);case 283:var a=n.fullName;if(!a||71===a.kind)fe(n,524288,793064)}}(n),n.kind>142){var a=c;c=n;var o=function(t){switch(t.kind){case 199:case 229:case 232:case 178:case 163:case 285:case 254:return 1;case 230:return 65;case 233:case 231:case 172:return 33;case 265:return 37;case 151:if(e.isObjectLiteralOrClassExpressionMethod(t))return 173;case 152:case 228:case 150:case 153:case 154:case 155:case 273:case 160:case 156:case 157:case 161:return 45;case 186:case 187:return 61;case 234:return 4;case 149:return t.initializer?4:0;case 260:case 214:case 215:case 216:case 235:return 2;case 207:return e.isFunctionLike(t.parent)?0:2}return 0}(n);0===o?B(n):function(t,n){var r=u,i=_;if(1&n?(u=_=t,32&n&&(u.locals=e.createSymbolTable()),ue(u)):2&n&&((_=t).locals=void 0),4&n){var a=p,o=f,s=m,c=g,l=b,y=x,h=16&n&&!e.hasModifier(t,256)&&!!e.getImmediatelyInvokedFunctionExpression(t);h?g={flags:4,antecedents:void 0}:(p={flags:2},144&n&&(p.container=t),g=void 0),f=void 0,m=void 0,b=void 0,x=!1,B(t),t.flags&=-1409,!(1&p.flags)&&8&n&&e.nodeIsPresent(t.body)&&(t.flags|=128,x&&(t.flags|=256)),265===t.kind&&(t.flags|=k),h?(Q(g,p),p=ee(g)):p=a,f=o,m=s,g=c,b=l,x=y}else 64&n?(d=!1,B(t),t.flags=d?64|t.flags:-65&t.flags):B(t);u=r,_=i}(n,o),c=a}else T||0!=(536870912&n.transformFlags)||(w|=i(n,0));S=r}}function xe(n){if(!S)for(var r=0,i=n;r<i.length;r++){var a=i[r];if(!e.isPrologueDirective(a))return;if(o=a,s=void 0,'"use strict"'===(s=e.getTextOfNodeFromSourceText(t.text,o.expression))||"'use strict'"===s)return void(S=!0)}var o,s}function ke(){pe(t,512,'"'+e.removeFileExtension(t.fileName)+'"')}function Se(e){t.commonJsModuleIndicator||(t.commonJsModuleIndicator=e,t.externalModuleIndicator||ke())}function De(e){Se(e),L(t.symbol.exports,t.symbol,e.left,1048580,0)}function Ce(t){return e.isExportsIdentifier(t)||e.isModuleExportsPropertyAccessExpression(t)||e.isIdentifier(t)&&Te(t)}function Te(t){var n=Ne(t.escapedText);return n&&n.valueDeclaration&&e.isVariableDeclaration(n.valueDeclaration)&&n.valueDeclaration.initializer&&Ee(n.valueDeclaration.initializer)}function Ee(t){return Ce(t)||e.isAssignmentExpression(t,!0)&&(Ee(t.left)||Ee(t.right))}function Ne(e){return u.symbol&&u.symbol.exports&&u.symbol.exports.get(e)||u.locals&&u.locals.get(e)}function Ae(t,n,r){var i=Ne(t);(i&&e.isDeclarationOfFunctionOrClassExpression(i)&&(i=i.valueDeclaration.initializer.symbol),i&&48&i.flags)&&L(r?i.members||(i.members=e.createSymbolTable()):i.exports||(i.exports=e.createSymbolTable()),i,n,4,0)}function we(t){S&&ge(t,t.name),e.isBindingPattern(t.name)||(e.isBlockOrCatchScoped(t)?function(e){fe(e,2,107455)}(t):e.isParameterDeclaration(t)?_e(t,1,107455):_e(t,1,107454))}function Pe(n,r,i){return t.isDeclarationFile||e.isInAmbientContext(n)||!e.isAsyncFunction(n)||(k|=1024),p&&e.isObjectLiteralOrClassExpressionMethod(n)&&(n.flowNode=p),e.hasDynamicName(n)?pe(n,r,"__computed"):_e(n,r,i)}}();function i(t,n){var r=t.kind;switch(r){case 181:return function(e,t){var n=t,r=e.expression,i=r.kind;e.typeArguments&&(n|=3);(524288&t||function(e,t){switch(t){case 97:return!0;case 179:case 180:return 97===e.expression.kind}return!1}(r,i))&&(n|=192);91===r.kind&&(n|=67108864,16384&t&&(n|=32768));return e.transformFlags=536870912|n,-537396546&n}(t,n);case 182:return function(e,t){var n=t;e.typeArguments&&(n|=3);524288&t&&(n|=192);return e.transformFlags=536870912|n,-537396546&n}(t,n);case 233:return function(t,n){var r=3;0==(2&e.getModifierFlags(t))&&(r|=n);return t.transformFlags=536870912|r,-574674242&r}(t,n);case 185:return function(e,t){var n=t,r=e.expression,i=r.kind,a=r.transformFlags;202!==i&&184!==i||(n|=3);1024&a&&(n|=1024);return e.transformFlags=536870912|n,-536872258&n}(t,n);case 194:return function(e,t){var n=t,r=e.operatorToken.kind,i=e.left.kind;58===r&&178===i?n|=3272:58===r&&177===i?n|=3264:40!==r&&62!==r||(n|=32);return e.transformFlags=536870912|n,-536872258&n}(t,n);case 210:return function(e,t){var n=t;1024&e.expression.transformFlags&&(n|=192);return e.transformFlags=536870912|n,-536872258&n}(t,n);case 146:return function(t,n){var r=n,i=t.name,a=t.initializer,o=t.dotDotDotToken;(t.questionToken||t.type||4096&n||e.isThisIdentifier(i))&&(r|=3);e.hasModifier(t,92)&&(r|=262147);1048576&n&&(r|=8);(8388608&n||a||o)&&(r|=131264);return t.transformFlags=536870912|r,-536872258&r}(t,n);case 187:return function(t,n){var r=192|n;(e.hasModifier(t,2270)||t.typeParameters||t.type)&&(r|=3);e.hasModifier(t,256)&&(r|=16);1048576&n&&(r|=8);16384&n&&(r|=32768);return t.transformFlags=536870912|r,-601249090&r}(t,n);case 186:return function(t,n){var r=n;(e.hasModifier(t,2270)||t.typeParameters||t.type)&&(r|=3);e.hasModifier(t,256)&&(r|=t.asteriskToken?8:16);1048576&n&&(r|=8);163840&n&&(r|=192);t.asteriskToken&&(r|=768);return t.transformFlags=536870912|r,-601281858&r}(t,n);case 228:return function(t,n){var r,i=e.getModifierFlags(t);!t.body||2&i?r=3:(r=33554432|n,(2270&i||t.typeParameters||t.type)&&(r|=3),256&i&&(r|=t.asteriskToken?8:16),1048576&n&&(r|=8),163840&n&&(r|=192),t.asteriskToken&&(r|=768));return t.transformFlags=536870912|r,-601281858&r}(t,n);case 226:return function(e,t){var n=t;n|=8388800,1048576&t&&(n|=8);e.type&&(n|=3);return e.transformFlags=536870912|n,-536872258&n}(t,n);case 227:return function(e,t){var n=33554432|t;8388608&t&&(n|=192);3&e.flags&&(n|=4194496);return e.transformFlags=536870912|n,-546309442&n}(t,n);case 208:return function(t,n){var r,i=t.declarationList.transformFlags;e.hasModifier(t,2)?r=3:(r=n,8388608&i&&(r|=192));return t.transformFlags=536870912|r,-536872258&r}(t,n);case 222:return function(t,n){var r=n;4194304&n&&e.isIterationStatement(t,!0)&&(r|=192);return t.transformFlags=536870912|r,-536872258&r}(t,n);case 229:return function(t,n){var r;e.hasModifier(t,2)?r=3:(r=192|n,(274432&n||t.typeParameters)&&(r|=3),65536&n&&(r|=16384));return t.transformFlags=536870912|r,-539358530&r}(t,n);case 199:return function(e,t){var n=192|t;(274432&t||e.typeParameters)&&(n|=3);65536&t&&(n|=16384);return e.transformFlags=536870912|n,-539358530&n}(t,n);case 259:return function(t,n){var r=n;switch(t.token){case 85:r|=192;break;case 108:r|=3;break;default:e.Debug.fail("Unexpected token for heritage clause")}return t.transformFlags=536870912|r,-536872258&r}(t,n);case 260:return function(t,n){var r=n;t.variableDeclaration?e.isBindingPattern(t.variableDeclaration.name)&&(r|=192):r|=8;return t.transformFlags=536870912|r,-537920834&r}(t,n);case 201:return function(e,t){var n=192|t;e.typeArguments&&(n|=3);return e.transformFlags=536870912|n,-536872258&n}(t,n);case 152:return function(t,n){var r=n;!e.hasModifier(t,2270)&&t.body||(r|=3);1048576&n&&(r|=8);return t.transformFlags=536870912|r,-601015618&r}(t,n);case 149:return function(e,t){var n=3|t;e.initializer&&(n|=8192);return e.transformFlags=536870912|n,-536872258&n}(t,n);case 151:return function(t,n){var r=192|n;(t.decorators||e.hasModifier(t,2270)||t.typeParameters||t.type||!t.body)&&(r|=3);1048576&n&&(r|=8);e.hasModifier(t,256)&&(r|=t.asteriskToken?8:16);t.asteriskToken&&(r|=768);return t.transformFlags=536870912|r,-601015618&r}(t,n);case 153:case 154:return function(t,n){var r=n;(t.decorators||e.hasModifier(t,2270)||t.type||!t.body)&&(r|=3);1048576&n&&(r|=8);return t.transformFlags=536870912|r,-601015618&r}(t,n);case 237:return function(t,n){var r=n;e.isExternalModuleImportEqualsDeclaration(t)||(r|=3);return t.transformFlags=536870912|r,-536872258&r}(t,n);case 179:return function(e,t){var n=t;97===e.expression.kind&&(n|=16384);return e.transformFlags=536870912|n,-536872258&n}(t,n);default:return function(e,t,n){var r=n,i=536872257;switch(t){case 120:case 191:r|=24;break;case 114:case 112:case 113:case 117:case 124:case 76:case 232:case 264:case 184:case 202:case 203:case 131:r|=3;break;case 249:case 250:case 251:case 10:case 252:case 253:case 254:case 255:case 256:r|=4;break;case 13:case 14:case 15:case 16:case 196:case 183:case 262:case 115:case 204:r|=192;break;case 9:e.hasExtendedUnicodeEscape&&(r|=192);break;case 8:48&e.numericLiteralFlags&&(r|=192);break;case 216:e.awaitModifier&&(r|=8),r|=192;break;case 197:r|=16777416;break;case 119:case 133:case 130:case 134:case 136:case 122:case 137:case 105:case 145:case 148:case 150:case 155:case 156:case 157:case 158:case 159:case 160:case 161:case 162:case 163:case 164:case 165:case 166:case 167:case 168:case 230:case 231:case 169:case 170:case 171:case 172:case 173:case 236:r=3,i=-3;break;case 144:r|=2097152,16384&n&&(r|=65536);break;case 198:r|=524480;break;case 263:r|=1048584;break;case 97:r|=192;break;case 99:r|=16384;break;case 174:r|=8388800,524288&n&&(r|=1048584),i=537396545;break;case 175:r|=8388800,i=537396545;break;case 176:r|=192,e.dotDotDotToken&&(r|=524288);break;case 147:r|=4099;break;case 178:i=540087617,2097152&n&&(r|=192),65536&n&&(r|=16384),1048576&n&&(r|=8);break;case 177:case 182:i=537396545,524288&n&&(r|=192);break;case 212:case 213:case 214:case 215:4194304&n&&(r|=192);break;case 265:32768&n&&(r|=192);break;case 219:case 217:case 218:r|=33554432}return e.transformFlags=536870912|r,r&~i}(t,r,n)}}function a(e){if(e>=158&&e<=173)return-3;switch(e){case 181:case 182:case 177:return 537396545;case 233:return 574674241;case 146:return 536872257;case 187:return 601249089;case 186:case 228:return 601281857;case 227:return 546309441;case 229:case 199:return 539358529;case 152:return 601015617;case 151:case 153:case 154:return 601015617;case 119:case 133:case 130:case 136:case 134:case 122:case 137:case 105:case 145:case 148:case 150:case 155:case 156:case 157:case 230:case 231:return-3;case 178:return 540087617;case 260:return 537920833;case 174:case 175:return 537396545;default:return 536872257}}function o(t,n){n.parent=t,e.forEachChild(n,(function(e){return o(n,e)}))}e.bindSourceFile=function(t,n){e.performance.mark("beforeBind"),r(t,n),e.performance.mark("afterBind"),e.performance.measure("Bind","beforeBind","afterBind")},e.computeTransformFlagsForNode=i,e.getTransformFlagsSubtreeExclusions=a}(ts||(ts={})),function(e){e.createGetSymbolWalker=function(t,n,r,i,a,o,s,c,u){return function(_){void 0===_&&(_=function(){return!0});var l=[],d=[];return{walkType:function(t){try{return p(t),{visitedTypes:e.getOwnValues(l),visitedSymbols:e.getOwnValues(d)}}finally{e.clear(l),e.clear(d)}},walkSymbol:function(t){try{return g(t),{visitedTypes:e.getOwnValues(l),visitedSymbols:e.getOwnValues(d)}}finally{e.clear(l),e.clear(d)}}};function p(t){if(t&&(!l[t.id]&&(l[t.id]=t,!g(t.symbol)))){if(32768&t.flags){var n=t,i=n.objectFlags;4&i&&function(t){p(t.target),e.forEach(t.typeArguments,p)}(t),32&i&&function(e){p(e.typeParameter),p(e.constraintType),p(e.templateType),p(e.modifiersType)}(t),3&i&&(m(a=t),e.forEach(a.typeParameters,p),e.forEach(r(a),p),p(a.thisType)),24&i&&m(n)}var a;16384&t.flags&&function(e){p(c(e))}(t),196608&t.flags&&function(t){e.forEach(t.types,p)}(t),262144&t.flags&&function(e){p(e.type)}(t),524288&t.flags&&function(e){p(e.objectType),p(e.indexType),p(e.constraint)}(t)}}function f(r){r.typePredicate&&p(r.typePredicate.type),e.forEach(r.typeParameters,p);for(var i=0,a=r.parameters;i<a.length;i++){g(a[i])}p(t(r)),p(n(r))}function m(e){p(s(e,0)),p(s(e,1));for(var t=i(e),n=0,r=t.callSignatures;n<r.length;n++){f(r[n])}for(var a=0,o=t.constructSignatures;a<o.length;a++){f(o[a])}for(var c=0,u=t.properties;c<u.length;c++){g(u[c])}}function g(t){if(t){var n=e.getSymbolId(t);if(!d[n]){if(d[n]=t,!_(t))return!0;p(a(t)),1952&t.flags&&t.exports.forEach(g),e.forEach(t.declarations,(function(e){if(e.type&&162===e.type.kind){var t=e.type;g(o(u(t.exprName)))}}))}}}}}}(ts||(ts={})),function(e){function t(t){t.trace(e.formatMessage.apply(void 0,arguments))}function n(e,t){return e.traceResolution&&void 0!==t.trace}function r(e,t){return t&&{path:t.path,extension:t.ext,packageId:e}}function i(e){return r(void 0,e)}var a;function o(t){if(t)return e.Debug.assert(e.extensionIsTypeScript(t.extension)),{fileName:t.path,packageId:t.packageId}}function s(e,t,n){return{resolvedModule:e&&{resolvedFileName:e.path,extension:e.extension,isExternalLibraryImport:t,packageId:e.packageId},failedLookupLocations:n}}function c(e,t){try{var n=t.readFile(e);return n?JSON.parse(n):{}}catch(e){return{}}}function u(t,n){return t.typeRoots?t.typeRoots:(t.configFilePath?r=e.getDirectoryPath(t.configFilePath):n.getCurrentDirectory&&(r=n.getCurrentDirectory()),void 0!==r?function(t,n){if(!n.directoryExists)return[e.combinePaths(t,_)];var r;return e.forEachAncestorDirectory(e.normalizePath(t),(function(t){var i=e.combinePaths(t,_);n.directoryExists(i)&&(r||(r=[])).push(i)})),r}(r,n):void 0);var r}e.trace=t,e.isTraceEnabled=n,function(e){e[e.TypeScript=0]="TypeScript",e[e.JavaScript=1]="JavaScript",e[e.DtsOnly=2]="DtsOnly"}(a||(a={})),e.getEffectiveTypeRoots=u;var _=e.combinePaths("node_modules","@types");function l(n,r,a,o,s,c){return e.isExternalModuleNameRelative(r)?function(n,r,i,a,o,s){if(!s.compilerOptions.rootDirs)return;s.traceEnabled&&t(s.host,e.Diagnostics.rootDirs_option_is_set_using_it_to_resolve_relative_module_name_0,r);for(var c,u,_=e.normalizePath(e.combinePaths(i,r)),l=0,d=s.compilerOptions.rootDirs;l<d.length;l++){var p=d[l],f=e.normalizePath(p);e.endsWith(f,e.directorySeparator)||(f+=e.directorySeparator);var m=e.startsWith(_,f)&&(void 0===u||u.length<f.length);s.traceEnabled&&t(s.host,e.Diagnostics.Checking_if_0_is_the_longest_matching_prefix_for_1_2,f,_,m),m&&(u=f,c=p)}if(u){s.traceEnabled&&t(s.host,e.Diagnostics.Longest_matching_prefix_for_0_is_1,_,u);var y=_.substr(u.length);s.traceEnabled&&t(s.host,e.Diagnostics.Loading_0_from_the_root_dir_1_candidate_location_2,y,u,_);var h=a(n,_,o,!g(i,s.host),s);if(h)return h;s.traceEnabled&&t(s.host,e.Diagnostics.Trying_other_entries_in_rootDirs);for(var v=0,b=s.compilerOptions.rootDirs;v<b.length;v++){if((p=b[v])!==c){var x=e.combinePaths(e.normalizePath(p),y);s.traceEnabled&&t(s.host,e.Diagnostics.Loading_0_from_the_root_dir_1_candidate_location_2,y,p,x);var k=a(n,x,o,!g(e.getDirectoryPath(x),s.host),s);if(k)return k}}s.traceEnabled&&t(s.host,e.Diagnostics.Module_resolution_using_rootDirs_has_failed)}return}(n,r,a,o,s,c):function(n,r,a,o,s){if(!s.compilerOptions.baseUrl)return;s.traceEnabled&&t(s.host,e.Diagnostics.baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1,s.compilerOptions.baseUrl,r);var c=void 0;s.compilerOptions.paths&&(s.traceEnabled&&t(s.host,e.Diagnostics.paths_option_is_specified_looking_for_a_pattern_to_match_module_name_0,r),c=e.matchPatternOrExact(e.getOwnKeys(s.compilerOptions.paths),r));if(c){var u=e.isString(c)?void 0:e.matchedText(c,r),_=e.isString(c)?c:e.patternText(c);return s.traceEnabled&&t(s.host,e.Diagnostics.Module_name_0_matched_pattern_1,r,_),e.forEach(s.compilerOptions.paths[_],(function(r){var c=u?r.replace("*",u):r,_=e.normalizePath(e.combinePaths(s.compilerOptions.baseUrl,c));s.traceEnabled&&t(s.host,e.Diagnostics.Trying_substitution_0_candidate_module_location_Colon_1,r,c);var l=e.tryGetExtensionFromPath(_);if(void 0!==l){var d=b(_,o,!1,s);if(void 0!==d)return i({path:d,ext:l})}return a(n,_,o,!g(e.getDirectoryPath(_),s.host),s)}))}var l=e.normalizePath(e.combinePaths(s.compilerOptions.baseUrl,r));return s.traceEnabled&&t(s.host,e.Diagnostics.Resolving_module_name_0_relative_to_base_url_1_2,r,s.compilerOptions.baseUrl,l),a(n,l,o,!g(e.getDirectoryPath(l),s.host),s)}(n,r,o,s,c)}function d(t,n,r,i,a){return p(t,e.getDirectoryPath(n),r,i,a,!1)}function p(r,i,o,c,u,_){var d=n(o,c),p=[],g={compilerOptions:o,host:c,traceEnabled:d},y=_?v(a.JavaScript):v(a.TypeScript)||v(a.JavaScript);if(y&&y.value){var h=y.value;return s(h.resolved,h.isExternalLibraryImport,p)}return{resolvedModule:void 0,failedLookupLocations:p};function v(n){var s=l(n,r,i,(function(e,t,n,r,i){return m(e,t,n,r,i,!0)}),p,g);if(s)return I({resolved:s,isExternalLibraryImport:!1});if(e.isExternalModuleNameRelative(r)){var _=e.normalizePathAndParts(e.combinePaths(i,r)),y=_.path,h=_.parts,v=m(n,y,p,!1,g,!0);return v&&I({resolved:v,isExternalLibraryImport:e.contains(h,"node_modules")})}d&&t(c,e.Diagnostics.Loading_module_0_from_node_modules_folder_target_file_type_1,r,a[n]);var b=E(n,r,i,p,g,u);if(b){var x=b.value;return o.preserveSymlinks||(x=x&&__assign({},b.value,{path:f(b.value.path,c,d),extension:b.value.extension})),{value:x&&{resolved:x,isExternalLibraryImport:!0}}}}}function f(n,r,i){if(!r.realpath)return n;var a=e.normalizePath(r.realpath(n));return i&&t(r,e.Diagnostics.Resolving_real_path_for_0_result_1,n,a),a}function m(n,r,o,s,c,u){if(c.traceEnabled&&t(c.host,e.Diagnostics.Loading_module_as_file_Slash_folder_candidate_module_location_0_target_file_type_1,r,a[n]),!e.pathEndsWithDirectorySeparator(r)){if(!s){var _=e.getDirectoryPath(r);g(_,c.host)||(c.traceEnabled&&t(c.host,e.Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it,_),s=!0)}var l=h(n,r,o,s,c);if(l)return i(l)}s||(g(r,c.host)||(c.traceEnabled&&t(c.host,e.Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it,r),s=!0));return x(n,r,o,s,c,u)}function g(e,t){return!t.directoryExists||t.directoryExists(e)}function y(e,t,n,r,a){return i(h(e,t,n,r,a))}function h(n,r,i,a,o){var s=v(r,n,i,a,o);if(s)return s;if(e.hasJavaScriptFileExtension(r)){var c=e.removeFileExtension(r);if(o.traceEnabled){var u=r.substring(c.length);t(o.host,e.Diagnostics.File_name_0_has_a_1_extension_stripping_it,r,u)}return v(c,n,i,a,o)}}function v(t,n,r,i,o){if(!i){var s=e.getDirectoryPath(t);s&&(i=!g(s,o.host))}switch(n){case a.DtsOnly:return c(".d.ts");case a.TypeScript:return c(".ts")||c(".tsx")||c(".d.ts");case a.JavaScript:return c(".js")||c(".jsx")}function c(e){var n=b(t+e,r,i,o);return n&&{path:n,ext:e}}}function b(n,r,i,a){if(!i){if(a.host.fileExists(n))return a.traceEnabled&&t(a.host,e.Diagnostics.File_0_exist_use_it_as_a_name_resolution_result,n),n;a.traceEnabled&&t(a.host,e.Diagnostics.File_0_does_not_exist,n)}r.push(n)}function x(e,t,n,i,a,o){void 0===o&&(o=!0);var s=o?S(t,"",n,i,a):{packageJsonContent:void 0,packageId:void 0},c=s.packageJsonContent;return r(s.packageId,k(e,t,n,i,a,c))}function k(n,r,i,o,s,c){var u=c&&function(n,r,i,o,s){var c=function(n,r,i,a){return n?o("typings")||o("types"):o("main");function o(n){if(e.hasProperty(r,n)){var o=r[n];if(e.isString(o)){var s=e.normalizePath(e.combinePaths(i,o));return a.traceEnabled&&t(a.host,e.Diagnostics.package_json_has_0_field_1_that_references_2,n,o,s),s}a.traceEnabled&&t(a.host,e.Diagnostics.Expected_type_of_0_field_in_package_json_to_be_string_got_1,n,typeof o)}else a.traceEnabled&&t(a.host,e.Diagnostics.package_json_does_not_have_a_0_field,n)}}(r!==a.JavaScript,n,i,s);if(!c)return;var u=!g(e.getDirectoryPath(c),s.host),_=b(c,o,u,s);if(_){var l=_&&function(t,n){var r=e.tryGetExtensionFromPath(n);return void 0!==r&&function(e,t){switch(e){case a.JavaScript:return".js"===t||".jsx"===t;case a.TypeScript:return".ts"===t||".tsx"===t||".d.ts"===t;case a.DtsOnly:return".d.ts"===t}}(t,r)?{path:n,ext:r}:void 0}(r,_);if(l)return l;s.traceEnabled&&t(s.host,e.Diagnostics.File_0_has_an_unsupported_extension_so_skipping_it,_)}var d=m(r===a.DtsOnly?a.TypeScript:r,c,o,u,s,!1);if(d)return e.Debug.assert(void 0===d.packageId),{path:d.path,ext:d.extension}}(c,n,r,i,s);if(u)return u;var _=!o&&g(r,s.host);return h(n,e.combinePaths(r,"index"),i,!_,s)}function S(n,r,i,a,o){var s=o.host,u=o.traceEnabled,_=!a&&g(n,s),l=D(n);if(_&&s.fileExists(l)){u&&t(s,e.Diagnostics.Found_package_json_at_0,l);var d=c(l,s);return{found:!0,packageJsonContent:d,packageId:"string"==typeof d.name&&"string"==typeof d.version?{name:d.name,subModuleName:r,version:d.version}:void 0}}return _&&u&&t(s,e.Diagnostics.File_0_does_not_exist,l),i.push(l),{found:!1,packageJsonContent:void 0,packageId:void 0}}function D(t){return e.combinePaths(t,"package.json")}function C(t,n,i,a,o,s){var c,u,_=e.normalizePath(e.combinePaths(i,n)),l=S(_,"",o,!a,s);if(l.found)c=l.packageJsonContent,u=l.packageId;else{var d=T(n),p=d.packageName,f=d.rest;if(""!==f)u=S(e.combinePaths(i,p),f,o,!a,s).packageId}return r(u,h(t,_,o,!a,s)||k(t,_,o,!a,s,c))}function T(t){var n=t.indexOf(e.directorySeparator);return"@"===t[0]&&(n=t.indexOf(e.directorySeparator,n+1)),-1===n?{packageName:t,rest:""}:{packageName:t.slice(0,n),rest:t.slice(n+1)}}function E(e,t,n,r,i,a){return N(e,t,n,r,i,!1,a)}function N(t,n,r,i,a,o,s){var c=s&&s.getOrCreateCacheForModuleName(n);return e.forEachAncestorDirectory(e.normalizeSlashes(r),(function(r){if("node_modules"!==e.getBaseFileName(r)){var s=F(c,n,r,a.traceEnabled,a.host);return s||I(A(t,n,r,i,a,o))}}))}function A(n,r,i,o,s,c){void 0===c&&(c=!1);var u=e.combinePaths(i,"node_modules"),_=g(u,s.host);!_&&s.traceEnabled&&t(s.host,e.Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it,u);var l=c?void 0:C(n,r,u,_,o,s);if(l)return l;if(n!==a.JavaScript){var d=e.combinePaths(u,"@types"),p=_;return _&&!g(d,s.host)&&(s.traceEnabled&&t(s.host,e.Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it,d),p=!1),C(a.DtsOnly,function(n,r){var i=P(n);r.traceEnabled&&i!==n&&t(r.host,e.Diagnostics.Scoped_package_detected_looking_in_0,i);return i}(r,s),d,p,o,s)}}e.resolveTypeReferenceDirective=function(r,i,s,c){var _=n(s,c),l={compilerOptions:s,host:c,traceEnabled:_},d=u(s,c);_&&(void 0===i?void 0===d?t(c,e.Diagnostics.Resolving_type_reference_directive_0_containing_file_not_set_root_directory_not_set,r):t(c,e.Diagnostics.Resolving_type_reference_directive_0_containing_file_not_set_root_directory_1,r,d):void 0===d?t(c,e.Diagnostics.Resolving_type_reference_directive_0_containing_file_1_root_directory_not_set,r,i):t(c,e.Diagnostics.Resolving_type_reference_directive_0_containing_file_1_root_directory_2,r,i,d));var p,m=[],y=function(){if(d&&d.length)return _&&t(c,e.Diagnostics.Resolving_with_primary_search_path_0,d.join(", ")),e.forEach(d,(function(n){var i=e.combinePaths(n,r),s=e.getDirectoryPath(i),u=g(s,c);return!u&&_&&t(c,e.Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it,s),o(x(a.DtsOnly,i,m,!u,l))}));_&&t(c,e.Diagnostics.Root_directory_cannot_be_determined_skipping_primary_search_paths)}(),h=!0;return y||(y=function(){var n,s=i&&e.getDirectoryPath(i);if(void 0!==s){_&&t(c,e.Diagnostics.Looking_up_in_node_modules_folder_initial_location_0,s);var u=E(a.DtsOnly,r,s,m,l,void 0);return!(n=o(u&&u.value))&&_&&t(c,e.Diagnostics.Type_reference_directive_0_was_not_resolved,r),n}_&&t(c,e.Diagnostics.Containing_file_is_not_specified_and_root_directory_cannot_be_determined_skipping_lookup_in_node_modules_folder)}(),h=!1),y&&(s.preserveSymlinks||(y=__assign({},y,{fileName:f(y.fileName,c,_)})),_&&t(c,e.Diagnostics.Type_reference_directive_0_was_successfully_resolved_to_1_primary_Colon_2,r,y.fileName,h),p={primary:h,resolvedFileName:y.fileName,packageId:y.packageId}),{resolvedTypeReferenceDirective:p,failedLookupLocations:m}},e.getAutomaticTypeDirectiveNames=function(t,n){if(t.types)return t.types;var r=[];if(n.directoryExists&&n.getDirectories){var i=u(t,n);if(i)for(var a=0,o=i;a<o.length;a++){var s=o[a];if(n.directoryExists(s))for(var _=0,l=n.getDirectories(s);_<l.length;_++){var d=l[_],p=e.normalizePath(d),f=D(e.combinePaths(s,p));n.fileExists(f)&&null===c(f,n).typings||r.push(e.getBaseFileName(p))}}}return r},e.createModuleResolutionCache=function(t,n){var r=e.createMap(),i=e.createMap();return{getOrCreateCacheForDirectory:function(i){var a=e.toPath(i,t,n),o=r.get(a);o||(o=e.createMap(),r.set(a,o));return o},getOrCreateCacheForModuleName:function(r){if(e.isExternalModuleNameRelative(r))return;var a=i.get(r);a||(a=function(){var r=e.createMap();return{get:i,set:a};function i(i){return r.get(e.toPath(i,t,n))}function a(i,a){var s=e.toPath(i,t,n);if(!r.has(s)){r.set(s,a);for(var c=o(s,a.resolvedModule&&a.resolvedModule.resolvedFileName),u=s;;){var _=e.getDirectoryPath(u);if(_===u||r.has(_))break;if(r.set(_,a),(u=_)===c)break}}}function o(r,i){if(void 0!==i){for(var a=e.toPath(e.getDirectoryPath(i),t,n),o=0;o<Math.min(r.length,a.length)&&r.charCodeAt(o)===a.charCodeAt(o);)o++;var s=r.lastIndexOf(e.directorySeparator,o);if(!(s<0))return r.substr(0,s)}}}(),i.set(r,a));return a}}},e.resolveModuleName=function(r,i,a,o,s){var c=n(a,o);c&&t(o,e.Diagnostics.Resolving_module_0_from_1,r,i);var u=e.getDirectoryPath(i),_=s&&s.getOrCreateCacheForDirectory(u),l=_&&_.get(r);if(l)c&&t(o,e.Diagnostics.Resolution_for_module_0_was_found_in_cache,r);else{var p=a.moduleResolution;switch(void 0===p?(p=e.getEmitModuleKind(a)===e.ModuleKind.CommonJS?e.ModuleResolutionKind.NodeJs:e.ModuleResolutionKind.Classic,c&&t(o,e.Diagnostics.Module_resolution_kind_is_not_specified_using_0,e.ModuleResolutionKind[p])):c&&t(o,e.Diagnostics.Explicitly_specified_module_resolution_kind_Colon_0,e.ModuleResolutionKind[p]),p){case e.ModuleResolutionKind.NodeJs:l=d(r,i,a,o,s);break;case e.ModuleResolutionKind.Classic:l=O(r,i,a,o,s);break;default:e.Debug.fail("Unexpected moduleResolution: "+p)}if(_){_.set(r,l);var f=s.getOrCreateCacheForModuleName(r);f&&f.set(u,l)}}return c&&(l.resolvedModule?t(o,e.Diagnostics.Module_name_0_was_successfully_resolved_to_1,r,l.resolvedModule.resolvedFileName):t(o,e.Diagnostics.Module_name_0_was_not_resolved,r)),l},e.nodeModuleNameResolver=d,e.resolveJavaScriptModule=function(t,n,r){var i=p(t,n,{moduleResolution:e.ModuleResolutionKind.NodeJs,allowJs:!0},r,void 0,!0),a=i.resolvedModule,o=i.failedLookupLocations;if(!a)throw new Error("Could not resolve JS module '"+t+"' starting at '"+n+"'. Looked in: "+o.join(", "));return a.resolvedFileName},e.directoryProbablyExists=g,e.getPackageName=T;var w="__";function P(t){if(e.startsWith(t,"@")){var n=t.replace(e.directorySeparator,w);if(n!==t)return n.slice(1)}return t}function F(n,r,i,a,o){var s=n&&n.get(i);if(s)return a&&t(o,e.Diagnostics.Resolution_for_module_0_was_found_in_cache,r),{value:s.resolvedModule&&{path:s.resolvedModule.resolvedFileName,extension:s.resolvedModule.extension,packageId:s.resolvedModule.packageId}}}function O(t,r,i,o,c){var u=n(i,o),_={compilerOptions:i,host:o,traceEnabled:u},d=[],p=e.getDirectoryPath(r),f=m(a.TypeScript)||m(a.JavaScript);return s(f&&f.value,!1,d);function m(n){var r=l(n,t,p,y,d,_);if(r)return{value:r};var i=c&&c.getOrCreateCacheForModuleName(t);if(e.isExternalModuleNameRelative(t)){var s=e.normalizePath(e.combinePaths(p,t));return I(y(n,s,d,!1,_))}var f=e.forEachAncestorDirectory(p,(function(r){var a=F(i,t,r,u,o);if(a)return a;var s=e.normalizePath(e.combinePaths(r,t));return I(y(n,s,d,!1,_))}));return f||(n===a.TypeScript?function(e,t,n,r){return N(a.DtsOnly,e,t,n,r,!0,void 0)}(t,p,d,_):void 0)}}function I(e){return void 0!==e?{value:e}:void 0}e.getTypesPackageName=function(e){return"@types/"+P(e)},e.getPackageNameFromAtTypesDirectory=function(t){var n=e.removePrefix(t,"@types/");return n!==t?e.stringContains(n,w)?"@"+n.replace(w,e.directorySeparator):n:t},e.classicNameResolver=O,e.loadModuleFromGlobalCache=function(r,i,o,c,u){var _=n(o,c);_&&t(c,e.Diagnostics.Auto_discovery_for_typings_is_enabled_in_project_0_Running_extra_resolution_pass_for_module_1_using_cache_location_2,i,r,u);var l={compilerOptions:o,host:c,traceEnabled:_},d=[];return s(A(a.DtsOnly,r,u,d,l),!0,d)}}(ts||(ts={})),function(e){var t=/^".+"$/,n=1,r=1,i=1,a=1;function o(e){return e.id||(e.id=r,r++),e.id}function s(e){return e.id||(e.id=n,n++),e.id}function c(t,n){var r=e.getModuleInstanceState(t);return 1===r||n&&2===r}function u(t){switch(t.parent.kind){case 242:case 246:return!0;default:return e.isDeclarationName(t)}}function _(e){switch(e.kind){case 239:case 237:case 240:case 242:return!0;case 71:return 242===e.parent.kind;default:return!1}}e.getNodeId=o,e.getSymbolId=s,e.isInstantiatedModule=c,e.createTypeChecker=function(n,r){var l,d,p,f=e.objectAllocator.getSymbolConstructor(),m=e.objectAllocator.getTypeConstructor(),g=e.objectAllocator.getSignatureConstructor(),y=0,h=0,v=0,b=0,x=e.createSymbolTable(),k=e.identity,S=n.getCompilerOptions(),D=e.getEmitScriptTarget(S),C=e.getEmitModuleKind(S),T=!!S.noUnusedLocals||!!S.noUnusedParameters,E=void 0!==S.allowSyntheticDefaultImports?S.allowSyntheticDefaultImports:C===e.ModuleKind.System,N=void 0===S.strictNullChecks?S.strict:S.strictNullChecks,A=void 0===S.strictFunctionTypes?S.strict:S.strictFunctionTypes,w=void 0===S.noImplicitAny?S.strict:S.noImplicitAny,P=void 0===S.noImplicitThis?S.strict:S.noImplicitThis,F=function(){var t,r=n.getResolvedTypeReferenceDirectives();r&&(t=e.createMap(),r.forEach((function(e,r){if(e){var i=n.getSourceFile(e.resolvedFileName);t.set(i.path,r)}})));return{getReferencedExportContainer:Tf,getReferencedImportDeclaration:Ef,getReferencedDeclarationWithCollidingName:Af,isDeclarationWithCollidingName:wf,isValueAliasDeclaration:function(t){return!(t=e.getParseTreeNode(t))||Pf(t)},hasGlobalName:Hf,isReferencedAliasDeclaration:function(t,n){return!(t=e.getParseTreeNode(t))||Rf(t,n)},getNodeCheckFlags:function(t){return(t=e.getParseTreeNode(t))?Jf(t):void 0},isTopLevelValueImportEqualsWithEntityName:Ff,isDeclarationVisible:Rr,isImplementationOfOverload:Lf,isRequiredInitializedParameter:Mf,isOptionalUninitializedParameterProperty:Bf,writeTypeOfDeclaration:Vf,writeReturnTypeOfSignatureDeclaration:qf,writeTypeOfExpression:Wf,isSymbolAccessible:yr,isEntityNameVisible:br,getConstantValue:function(t){return(t=e.getParseTreeNode(t,jf))?Kf(t):void 0},collectLinkedAliases:Lr,getReferencedValueDeclaration:Qf,getTypeReferenceSerializationKind:Uf,isOptionalParameter:wa,moduleExportsSomeValue:Cf,isArgumentsLocalBinding:Df,getExternalModuleFileFromDeclaration:Zf,getTypeReferenceDirectivesForEntityName:function(e){if(!t)return;var n=179===e.kind||71===e.kind&&qc(e)?1156031:794600,r=jn(e,n,!0);return r&&r!==q?i(r,n):void 0},getTypeReferenceDirectivesForSymbol:i,isLiteralConstDeclaration:Xf,writeLiteralConstValue:Yf,getJsxFactoryEntity:function(){return Pt}};function i(n,r){if(t&&function(n){if(!n.declarations)return!1;var r=n;for(;;){var i=tr(r);if(!i)break;r=i}if(r.valueDeclaration&&265===r.valueDeclaration.kind&&512&r.flags)return!1;for(var a=0,o=n.declarations;a<o.length;a++){var s=o[a],c=e.getSourceFileOfNode(s);if(t.has(c.path))return!0}return!1}(n)){for(var i,a=0,o=n.declarations;a<o.length;a++){var s=o[a];if(s.symbol&&s.symbol.flags&r){var c=e.getSourceFileOfNode(s),u=t.get(c.path);if(!u)return;(i||(i=[])).push(u)}}return i}}}(),O=function(){return{typeToTypeNode:function(e,r,i){var a=t(r,i),o=n(e,a);return a.encounteredError?void 0:o},indexInfoToIndexSignatureDeclaration:function(e,n,r,a){var o=t(r,a),s=i(e,n,o);return o.encounteredError?void 0:s},signatureToSignatureDeclaration:function(e,n,r,i){var o=t(r,i),s=a(e,n,o);return o.encounteredError?void 0:s}};function t(e,t){return{enclosingDeclaration:e,flags:t,encounteredError:!1,symbolStack:void 0}}function n(t,s){var u=s.flags&e.NodeBuilderFlags.InTypeAlias;if(s.flags&=~e.NodeBuilderFlags.InTypeAlias,t){if(1&t.flags)return e.createKeywordTypeNode(119);if(2&t.flags)return e.createKeywordTypeNode(136);if(4&t.flags)return e.createKeywordTypeNode(133);if(8&t.flags)return e.createKeywordTypeNode(122);if(256&t.flags&&!(65536&t.flags)){var _=tr(t.symbol),l=c(_,s,793064,!1),d=Fi(_)===t?l:e.createQualifiedName(l,Or(t.symbol,s));return e.createTypeReferenceNode(d,void 0)}if(272&t.flags){var p=c(t.symbol,s,793064,!1);return e.createTypeReferenceNode(p,void 0)}if(32&t.flags)return e.createLiteralTypeNode(e.setEmitFlags(e.createLiteral(t.value),16777216));if(64&t.flags)return e.createLiteralTypeNode(e.createLiteral(t.value));if(128&t.flags)return"true"===t.intrinsicName?e.createTrue():e.createFalse();if(1024&t.flags)return e.createKeywordTypeNode(105);if(2048&t.flags)return e.createKeywordTypeNode(139);if(4096&t.flags)return e.createKeywordTypeNode(95);if(8192&t.flags)return e.createKeywordTypeNode(130);if(512&t.flags)return e.createKeywordTypeNode(137);if(16777216&t.flags)return e.createKeywordTypeNode(134);if(16384&t.flags&&t.isThisType)return s.flags&e.NodeBuilderFlags.InObjectTypeLiteral&&(s.encounteredError||s.flags&e.NodeBuilderFlags.AllowThisInObjectLiteral||(s.encounteredError=!0)),e.createThis();var f=hn(t);if(4&f)return e.Debug.assert(!!(32768&t.flags)),function(t){var i=t.typeArguments||e.emptyArray;if(t.target===De){if(s.flags&e.NodeBuilderFlags.WriteArrayAsGenericType){var a=n(i[0],s);return e.createTypeReferenceNode("Array",[a])}var o=n(i[0],s);return e.createArrayTypeNode(o)}if(8&t.target.objectFlags){if(i.length>0){var c=r(i.slice(0,$a(t)),s);if(c&&c.length>0)return e.createTupleTypeNode(c)}return s.encounteredError||s.flags&e.NodeBuilderFlags.AllowEmptyTuple?e.createTupleTypeNode([]):void(s.encounteredError=!0)}var u=t.target.outerTypeParameters,_=0,l=void 0;if(u)for(var d=u.length;_<d;){var p=_,f=Ga(u[_]);do{_++}while(_<d&&Ga(u[_])===f);if(!e.rangeEquals(u,i,p,_)){var m=r(i.slice(p,_),s),g=m&&e.createNodeArray(m),y=b(f);(71===y.kind?y:y.right).typeArguments=g,l?(e.Debug.assert(!l.right),l=x(l,y),l=e.createQualifiedName(l,void 0)):l=e.createQualifiedName(y,void 0)}}var h=void 0,v=b(t.symbol);l?(e.Debug.assert(!l.right),h=l=x(l,v)):h=v;var k=void 0;if(i.length>0){var S=(t.target.typeParameters||e.emptyArray).length;k=r(i.slice(_,S),s)}return k&&((71===h.kind?h:h.right).typeArguments=void 0),e.createTypeReferenceNode(h,k)}(t);if(16384&t.flags||3&f){p=t.symbol?c(t.symbol,s,793064,!1):e.createIdentifier("?");return e.createTypeReferenceNode(p,void 0)}if(!u&&t.aliasSymbol&&gr(t.aliasSymbol,s.enclosingDeclaration)){p=b(t.aliasSymbol);var m=r(t.aliasTypeArguments,s);return e.createTypeReferenceNode(p,m)}if(196608&t.flags){var g=r(65536&t.flags?Nr(t.types):t.types,s);return g&&g.length>0?e.createUnionOrIntersectionTypeNode(65536&t.flags?166:167,g):void(s.encounteredError||s.flags&e.NodeBuilderFlags.AllowEmptyUnionOrIntersection||(s.encounteredError=!0))}if(48&f)return e.Debug.assert(!!(32768&t.flags)),function(t){var n=t.symbol;if(n){if(32&n.flags&&!oi(n)||896&n.flags||o())return function(t,n){var r=c(t,s,n,!1);return e.createTypeQueryNode(r)}(n,107455);if(e.contains(s.symbolStack,n)){var r=wr(t);if(r){var i=c(r,s,793064,!1);return e.createTypeReferenceNode(i,void 0)}return e.createKeywordTypeNode(119)}s.symbolStack||(s.symbolStack=[]),s.symbolStack.push(n);var a=v(t);return s.symbolStack.pop(),a}return v(t);function o(){var t=!!(8192&n.flags)&&e.some(n.declarations,(function(t){return e.hasModifier(t,32)})),r=!!(16&n.flags)&&(n.parent||e.forEach(n.declarations,(function(e){return 265===e.parent.kind||234===e.parent.kind})));if(t||r)return e.contains(s.symbolStack,n)}}(t);if(262144&t.flags){var y=n(t.type,s);return e.createTypeOperatorNode(y)}if(524288&t.flags){var h=n(t.objectType,s);y=n(t.indexType,s);return e.createIndexedAccessTypeNode(h,y)}e.Debug.fail("Should be unreachable.")}else s.encounteredError=!0;function v(t){if(ra(t))return function(t){e.Debug.assert(!!(32768&t.flags));var r=t.declaration&&t.declaration.readonlyToken?e.createToken(131):void 0,i=t.declaration&&t.declaration.questionToken?e.createToken(55):void 0,a=o(ea(t),s),c=n(na(t),s),u=e.createMappedTypeNode(r,a,i,c);return e.setEmitFlags(u,1)}(t);var r=ia(t);if(!r.properties.length&&!r.stringIndexInfo&&!r.numberIndexInfo){if(!r.callSignatures.length&&!r.constructSignatures.length)return e.setEmitFlags(e.createTypeLiteralNode(void 0),1);if(1===r.callSignatures.length&&!r.constructSignatures.length)return a(r.callSignatures[0],160,s);if(1===r.constructSignatures.length&&!r.callSignatures.length)return a(r.constructSignatures[0],161,s)}var u=s.flags;s.flags|=e.NodeBuilderFlags.InObjectTypeLiteral;var _=function(t){for(var r=[],o=0,u=t.callSignatures;o<u.length;o++){var _=u[o];r.push(a(_,155,s))}for(var l=0,d=t.constructSignatures;l<d.length;l++){_=d[l];r.push(a(_,156,s))}t.stringIndexInfo&&r.push(i(t.stringIndexInfo,0,s));t.numberIndexInfo&&r.push(i(t.numberIndexInfo,1,s));var p=t.properties;if(!p)return r;for(var f=0,m=p;f<m.length;f++){var g=m[f],y=ci(g),h=s.enclosingDeclaration;s.enclosingDeclaration=void 0;var v=c(g,s,107455,!0);s.enclosingDeclaration=h;var b=16777216&g.flags?e.createToken(55):void 0;if(8208&g.flags&&!aa(y).length)for(var x=0,k=xa(y,0);x<k.length;x++){var S=a(_=k[x],150,s);S.name=v,S.questionToken=b,r.push(S)}else{var D=y?n(y,s):e.createKeywordTypeNode(119),C=ed(g)?[e.createToken(131)]:void 0,T=e.createPropertySignature(C,v,b,D,void 0);r.push(T)}}return r.length?r:void 0}(r);s.flags=u;var l=e.createTypeLiteralNode(_);return e.setEmitFlags(l,1)}function b(t){return 32&t.flags||!cr(t.escapedName)?c(t,s,793064,!1):e.createIdentifier("")}function x(t,n){if(e.Debug.assert(void 0===t.right),71===n.kind)return t.right=n,t;for(var r=n;71!==r.left.kind;)r=r.left;return t.right=r.left,r.left=t,n}}function r(t,r){if(e.some(t)){for(var i=[],a=0;a<t.length;++a){var o=n(t[a],r);o&&i.push(o)}return i}}function i(t,r,i){var a=e.getNameFromIndexInfo(t)||"x",o=e.createKeywordTypeNode(0===r?136:133),s=e.createParameter(void 0,void 0,void 0,a,void 0,o,void 0),c=n(t.type,i);return e.createIndexSignature(void 0,t.isReadonly?[e.createToken(131)]:void 0,[s],c)}function a(t,r,i){var a,c=t.typeParameters&&t.typeParameters.map((function(e){return o(e,i)})),u=t.parameters.map((function(e){return s(e,i)}));if(t.thisParameter){var _=s(t.thisParameter,i);u.unshift(_)}if(t.typePredicate){var l=t.typePredicate,d=1===l.kind?e.setEmitFlags(e.createIdentifier(l.parameterName),16777216):e.createThisTypeNode(),p=n(l.type,i);a=e.createTypePredicateNode(d,p)}else{var f=La(t);a=f&&n(f,i)}return i.flags&e.NodeBuilderFlags.SuppressAnyReturnType?a&&119===a.kind&&(a=void 0):a||(a=e.createKeywordTypeNode(119)),e.createSignatureDeclaration(r,c,u,a)}function o(t,r){var i=c(t.symbol,r,793064,!0),a=Ha(t),o=a&&n(a,r),s=fa(t),u=s&&n(s,r);return e.createTypeParameterDeclaration(i,o,u)}function s(t,r){var i=e.getDeclarationOfKind(t,146);if(_n(t)&&t.isRestParameter)return e.createParameter(void 0,void 0,t.isRestParameter?e.createToken(24):void 0,"args",void 0,n(Pe,r),void 0);var a=i.modifiers&&i.modifiers.map(e.getSynthesizedClone),o=e.isRestParameter(i)?e.createToken(24):void 0,s=i.name?71===i.name.kind?e.setEmitFlags(e.getSynthesizedClone(i.name),16777216):function t(n){var r=e.visitEachChild(n,t,e.nullTransformationContext,void 0,t),i=e.nodeIsSynthesized(r)?r:e.getSynthesizedClone(r);return 176===i.kind&&(i.initializer=void 0),e.setEmitFlags(i,16777217)}(i.name):e.symbolName(t),c=wa(i)?e.createToken(55):void 0,u=ci(t);Mf(i)&&(u=bc(u,2048));var _=n(u,r);return e.createParameter(void 0,a,o,s,c,_,void 0)}function c(t,n,i,a){var o;return!(262144&t.flags)&&(n.enclosingDeclaration||n.flags&e.NodeBuilderFlags.UseFullyQualifiedType)?(o=function t(r,i,a){var o,s=fr(r,n.enclosingDeclaration,i,!1);if(!s||mr(s[0],n.enclosingDeclaration,1===s.length?i:pr(i))){var c=tr(s?s[0]:r);if(c){var u=t(c,pr(i),!1);u&&(o=c,s=u.concat(s||[r]))}}if(s)return s;if(a||(o||!e.forEach(r.declarations,hr))&&!(6144&r.flags))return[r]}(t,i,!0),e.Debug.assert(o&&o.length>0)):o=[t],!a||1===o.length||n.encounteredError||n.flags&e.NodeBuilderFlags.AllowQualifedNameInPlaceOfIdentifier||(n.encounteredError=!0),function t(i,a){e.Debug.assert(i&&0<=a&&a<i.length);var o,s=i[a];if(n.flags&e.NodeBuilderFlags.WriteTypeParametersInQualifiedName&&a>0){var c=i[a-1],u=void 0;if(1&e.getCheckFlags(s))u=gi(c);else 524384&qp(c).flags&&(u=mi(s));o=r(u,n)}var _=Or(s,n),l=e.setEmitFlags(e.createIdentifier(_,o),16777216);return a>0?e.createQualifiedName(t(i,a-1),l):l}(o,o.length-1)}}(),I=un(4,"undefined");I.declarations=[];var R,L,M=un(4,"arguments"),B={getNodeCount:function(){return e.sum(n.getSourceFiles(),"nodeCount")},getIdentifierCount:function(){return e.sum(n.getSourceFiles(),"identifierCount")},getSymbolCount:function(){return e.sum(n.getSourceFiles(),"symbolCount")+h},getTypeCount:function(){return y},isUndefinedSymbol:function(e){return e===I},isArgumentsSymbol:function(e){return e===M},isUnknownSymbol:function(e){return e===q},getMergedSymbol:$n,getDiagnostics:lf,getGlobalDiagnostics:function(){return df(),At.getGlobalDiagnostics()},getTypeOfSymbolAtLocation:function(t,n){return(n=e.getParseTreeNode(n))?function(t,n){if(t=t.exportSymbol||t,71===n.kind&&(e.isRightSideOfQualifiedNameOrPropertyAccess(n)&&(n=n.parent),e.isPartOfExpression(n)&&!e.isAssignmentTarget(n))){var r=Td(n);if(nr(yn(n).resolvedSymbol)===t)return r}return ci(t)}(t,n):Q},getSymbolsOfParameterPropertyDeclaration:function(t,n){return t=e.getParseTreeNode(t,e.isParameter),e.Debug.assert(void 0!==t,"Cannot get symbols of a synthetic parameter that cannot be resolved to a parse-tree node."),function(t,n){var r=t.parent,i=t.parent.parent,a=bn(r.locals,n,107455),o=bn(i.symbol.members,n,107455);if(a&&o)return[a,o];e.Debug.fail("There should exist two symbols, one as property declaration and one as parameter declaration")}(t,e.escapeLeadingUnderscores(n))},getDeclaredTypeOfSymbol:Fi,getPropertiesOfType:sa,getPropertyOfType:function(t,n){return va(t,e.escapeLeadingUnderscores(n))},getIndexInfoOfType:Da,getSignaturesOfType:xa,getIndexTypeOfType:Ca,getBaseTypes:Si,getBaseTypeOfLiteralType:dc,getWidenedType:Ec,getTypeFromTypeNode:function(t){return(t=e.getParseTreeNode(t,e.isTypeNode))?ds(t):Q},getParameterType:zl,getReturnTypeOfSignature:La,getNullableType:bc,getNonNullableType:xc,typeToTypeNode:O.typeToTypeNode,indexInfoToIndexSignatureDeclaration:O.indexInfoToIndexSignatureDeclaration,signatureToSignatureDeclaration:O.signatureToSignatureDeclaration,getSymbolsInScope:function(t,n){return(t=e.getParseTreeNode(t))?function(t,n){if(pf(t))return[];var r=e.createSymbolTable(),i=!1;return a(),Ea(r);function a(){for(;t;){switch(t.locals&&!vn(t)&&s(t.locals,n),t.kind){case 233:s(er(t).exports,2623475&n);break;case 232:s(er(t).exports,8&n);break;case 199:t.name&&o(t.symbol,n);case 229:case 230:i||s(er(t).members,793064&n);break;case 186:t.name&&o(t.symbol,n)}e.introducesArgumentsExoticObject(t)&&o(M,n),i=e.hasModifier(t,32),t=t.parent}s(ot,n)}function o(t,n){if(e.getCombinedLocalAndExportSymbolFlags(t)&n){var i=t.escapedName;r.has(i)||r.set(i,t)}}function s(e,t){t&&e.forEach((function(e){o(e,t)}))}}(t,n):[]},getSymbolAtLocation:function(t){return(t=e.getParseTreeNode(t))?bf(t):void 0},getShorthandAssignmentValueSymbol:function(t){return(t=e.getParseTreeNode(t))?function(e){if(e&&262===e.kind)return jn(e.name,2204607);return}(t):void 0},getExportSpecifierLocalTargetSymbol:function(t){return(t=e.getParseTreeNode(t,e.isExportSpecifier))?function(e){return e.parent.parent.moduleSpecifier?Pn(e.parent.parent,e):jn(e.propertyName||e.name,2998271)}(t):void 0},getExportSymbolOfSymbol:function(e){return $n(e.exportSymbol||e)},getTypeAtLocation:function(t){return(t=e.getParseTreeNode(t))?xf(t):Q},getPropertySymbolOfDestructuringAssignment:function(t){return(t=e.getParseTreeNode(t,e.isIdentifier))?function(e){var t=kf(e.parent.parent);return t&&va(t,e.escapedText)}(t):void 0},signatureToString:function(t,n,r,i){return Cr(t,e.getParseTreeNode(n),r,i)},typeToString:function(t,n,r){return Tr(t,e.getParseTreeNode(n),r)},getSymbolDisplayBuilder:Ir,symbolToString:function(t,n,r){return Dr(t,e.getParseTreeNode(n),r)},getAugmentedPropertiesOfType:function(t){t=ma(t);var n=e.createSymbolTable(sa(t));(xa(t,0).length||xa(t,1).length)&&e.forEach(sa(Se),(function(e){n.has(e.escapedName)||n.set(e.escapedName,e)}));return ur(n)},getRootSymbols:function t(n){if(6&e.getCheckFlags(n)){var r=[],i=n.escapedName;return e.forEach(gn(n).containingType.types,(function(e){var t=va(e,i);t&&r.push(t)})),r}if(33554432&n.flags){var a=n;if(a.leftSpread)return t(a.leftSpread).concat(t(a.rightSpread));if(a.syntheticOrigin)return t(a.syntheticOrigin);for(var o=void 0,s=n;s=gn(s).target;)o=s;if(o)return[o]}return[n]},getContextualType:function(t){return(t=e.getParseTreeNode(t,e.isExpression))?u_(t):void 0},getFullyQualifiedName:zn,getResolvedSignature:function(t,n,r){t=e.getParseTreeNode(t,e.isCallLikeExpression),R=r;var i=t?Pl(t,n):void 0;return R=void 0,i},getConstantValue:function(t){return(t=e.getParseTreeNode(t,jf))?Kf(t):void 0},isValidPropertyAccess:function(t,n){return!!(t=e.getParseTreeNode(t,e.isPropertyAccessOrQualifiedName))&&function(e,t){var n=179===e.kind?e.expression:e.left;return el(e,n,t,Ec(Ed(n)))}(t,e.escapeLeadingUnderscores(n))},getSignatureFromDeclaration:function(t){return(t=e.getParseTreeNode(t,e.isFunctionLike))?Oa(t):void 0},isImplementationOfOverload:function(t){var n=e.getParseTreeNode(t,e.isFunctionLike);return n?Lf(n):void 0},getImmediateAliasedSymbol:function(t){e.Debug.assert(0!=(2097152&t.flags),"Should only get Alias here.");var n=gn(t);if(!n.immediateTarget){var r=wn(t);e.Debug.assert(!!r),n.immediateTarget=On(r,!0)}return n.immediateTarget},getAliasedSymbol:Ln,getEmitResolver:function(e,t){return lf(e,t),F},getExportsOfModule:Gn,getExportsAndPropertiesOfModule:function(t){var n=Gn(t),r=qn(t);r!==t&&e.addRange(n,sa(ci(r)));return n},getSymbolWalker:e.createGetSymbolWalker(Ma,La,Si,ia,ci,Vc,Sa,Ha,$p),getAmbientModules:function(){be||(be=[],ot.forEach((function(e,n){t.test(n)&&be.push(e)})));return be},getAllAttributesTypeFromJsxOpeningLikeElement:function(t){return(t=e.getParseTreeNode(t,e.isJsxOpeningLikeElement))?function(e){return C_(e.tagName)?I_(e):R_(e,!0)}(t):void 0},getJsxIntrinsicTagNames:function(){var t=E_(Wt);return t?sa(t):e.emptyArray},isOptionalParameter:function(t){return!!(t=e.getParseTreeNode(t,e.isParameter))&&wa(t)},tryGetMemberInModuleExports:function(t,n){return Qn(e.escapeLeadingUnderscores(t),n)},tryGetMemberInModuleExportsAndProperties:function(t,n){return function(e,t){var n=Qn(e,t);if(!n){var r=qn(t);if(r!==t)return va(ci(r),e)}return n}(e.escapeLeadingUnderscores(t),n)},tryFindAmbientModuleWithoutAugmentations:function(e){return Aa(e,!1)},getApparentType:ma,getUnionType:zo,createAnonymousType:lr,createSignature:Ki,createSymbol:un,createIndexInfo:qa,getAnyType:function(){return H},getStringType:function(){return ee},getNumberType:function(){return te},createPromiseType:Vl,createArrayType:wo,getBooleanType:function(){return ie},getVoidType:function(){return oe},getUndefinedType:function(){return X},getNullType:function(){return Z},getESSymbolType:function(){return ae},getNeverType:function(){return se},isSymbolAccessible:yr,isArrayLikeType:cc,getAllPossiblePropertiesOfTypes:function(t){var n=zo(t);if(!(65536&n.flags))return sa(n);for(var r=e.createSymbolTable(),i=0,a=t;i<a.length;i++)for(var o=a[i],s=0,c=sa(o);s<c.length;s++){var u=c[s].escapedName;r.has(u)||r.set(u,ga(n,u))}return e.arrayFrom(r.values())},getSuggestionForNonexistentProperty:function(e,t){return X_(e,t)},getSuggestionForNonexistentSymbol:function(t,n,r){return Y_(t,e.escapeLeadingUnderscores(n),r)},getBaseConstraintOfType:_a,resolveName:function(t,n,r){return kn(n,e.escapeLeadingUnderscores(t),r,void 0,void 0,!1)},getJsxNamespace:function(){return e.unescapeLeadingUnderscores(sn())}},J=[],z=e.createMap(),j=e.createMap(),K=e.createMap(),U=e.createMap(),V=[],q=un(4,"unknown"),W=un(0,"__resolving__"),H=or(1,"any"),G=or(1,"any"),Q=or(1,"unknown"),X=or(2048,"undefined"),Y=N?X:or(2099200,"undefined"),Z=or(4096,"null"),$=N?Z:or(2101248,"null"),ee=or(2,"string"),te=or(4,"number"),ne=or(128,"true"),re=or(128,"false"),ie=((L=zo([ne,re])).flags|=8,L.intrinsicName="boolean",L),ae=or(512,"symbol"),oe=or(1024,"void"),se=or(8192,"never"),ce=or(8192,"never"),ue=or(16777216,"object"),_e=lr(void 0,x,e.emptyArray,e.emptyArray,void 0,void 0),le=un(2048,"__type");le.members=e.createSymbolTable();var de=lr(le,x,e.emptyArray,e.emptyArray,void 0,void 0),pe=lr(void 0,x,e.emptyArray,e.emptyArray,void 0,void 0);pe.instantiations=e.createMap();var fe=lr(void 0,x,e.emptyArray,e.emptyArray,void 0,void 0);fe.flags|=8388608;var me=lr(void 0,x,e.emptyArray,e.emptyArray,void 0,void 0),ge=lr(void 0,x,e.emptyArray,e.emptyArray,void 0,void 0),ye=lr(void 0,x,e.emptyArray,e.emptyArray,void 0,void 0),he=ar(16384),ve=ar(16384);ve.constraint=he;var be,xe,ke,Se,De,Ce,Te,Ee,Ne,Ae,we,Pe,Fe,Oe,Ie,Re,Le,Me,Be,Je,ze,je,Ke,Ue,Ve,qe,We,He,Ge,Qe,Xe,Ye,Ze,$e=ar(16384),et=Ki(void 0,void 0,void 0,e.emptyArray,H,void 0,0,!1,!1),tt=Ki(void 0,void 0,void 0,e.emptyArray,Q,void 0,0,!1,!1),nt=Ki(void 0,void 0,void 0,e.emptyArray,H,void 0,0,!1,!1),rt=Ki(void 0,void 0,void 0,e.emptyArray,ce,void 0,0,!1,!1),it=qa(ee,!0),at=qa(H,!1),ot=e.createSymbolTable(),st=0,ct=0,ut=0,_t=!1,lt=_s(""),dt=_s(0),pt=[],ft=[],mt=[],gt=0,yt=[],ht=[],vt=[],bt=[],xt=[],kt=[],St=[],Dt=[],Ct=[],Tt=[],Et=[],Nt=[],At=e.createDiagnosticCollection();!function(e){e[e.None=0]="None",e[e.TypeofEQString=1]="TypeofEQString",e[e.TypeofEQNumber=2]="TypeofEQNumber",e[e.TypeofEQBoolean=4]="TypeofEQBoolean",e[e.TypeofEQSymbol=8]="TypeofEQSymbol",e[e.TypeofEQObject=16]="TypeofEQObject",e[e.TypeofEQFunction=32]="TypeofEQFunction",e[e.TypeofEQHostObject=64]="TypeofEQHostObject",e[e.TypeofNEString=128]="TypeofNEString",e[e.TypeofNENumber=256]="TypeofNENumber",e[e.TypeofNEBoolean=512]="TypeofNEBoolean",e[e.TypeofNESymbol=1024]="TypeofNESymbol",e[e.TypeofNEObject=2048]="TypeofNEObject",e[e.TypeofNEFunction=4096]="TypeofNEFunction",e[e.TypeofNEHostObject=8192]="TypeofNEHostObject",e[e.EQUndefined=16384]="EQUndefined",e[e.EQNull=32768]="EQNull",e[e.EQUndefinedOrNull=65536]="EQUndefinedOrNull",e[e.NEUndefined=131072]="NEUndefined",e[e.NENull=262144]="NENull",e[e.NEUndefinedOrNull=524288]="NEUndefinedOrNull",e[e.Truthy=1048576]="Truthy",e[e.Falsy=2097152]="Falsy",e[e.Discriminatable=4194304]="Discriminatable",e[e.All=8388607]="All",e[e.BaseStringStrictFacts=933633]="BaseStringStrictFacts",e[e.BaseStringFacts=3145473]="BaseStringFacts",e[e.StringStrictFacts=4079361]="StringStrictFacts",e[e.StringFacts=4194049]="StringFacts",e[e.EmptyStringStrictFacts=3030785]="EmptyStringStrictFacts",e[e.EmptyStringFacts=3145473]="EmptyStringFacts",e[e.NonEmptyStringStrictFacts=1982209]="NonEmptyStringStrictFacts",e[e.NonEmptyStringFacts=4194049]="NonEmptyStringFacts",e[e.BaseNumberStrictFacts=933506]="BaseNumberStrictFacts",e[e.BaseNumberFacts=3145346]="BaseNumberFacts",e[e.NumberStrictFacts=4079234]="NumberStrictFacts",e[e.NumberFacts=4193922]="NumberFacts",e[e.ZeroStrictFacts=3030658]="ZeroStrictFacts",e[e.ZeroFacts=3145346]="ZeroFacts",e[e.NonZeroStrictFacts=1982082]="NonZeroStrictFacts",e[e.NonZeroFacts=4193922]="NonZeroFacts",e[e.BaseBooleanStrictFacts=933252]="BaseBooleanStrictFacts",e[e.BaseBooleanFacts=3145092]="BaseBooleanFacts",e[e.BooleanStrictFacts=4078980]="BooleanStrictFacts",e[e.BooleanFacts=4193668]="BooleanFacts",e[e.FalseStrictFacts=3030404]="FalseStrictFacts",e[e.FalseFacts=3145092]="FalseFacts",e[e.TrueStrictFacts=1981828]="TrueStrictFacts",e[e.TrueFacts=4193668]="TrueFacts",e[e.SymbolStrictFacts=1981320]="SymbolStrictFacts",e[e.SymbolFacts=4193160]="SymbolFacts",e[e.ObjectStrictFacts=6166480]="ObjectStrictFacts",e[e.ObjectFacts=8378320]="ObjectFacts",e[e.FunctionStrictFacts=6164448]="FunctionStrictFacts",e[e.FunctionFacts=8376288]="FunctionFacts",e[e.UndefinedFacts=2457472]="UndefinedFacts",e[e.NullFacts=2340752]="NullFacts"}(Ze||(Ze={}));var wt,Pt,Ft,Ot,It,Rt,Lt,Mt,Bt=e.createMapFromTemplate({string:1,number:2,boolean:4,symbol:8,undefined:16384,object:16,function:32}),Jt=e.createMapFromTemplate({string:128,number:256,boolean:512,symbol:1024,undefined:131072,object:2048,function:4096}),zt=e.createMapFromTemplate({string:ee,number:te,boolean:ie,symbol:ae,undefined:X}),jt=zo(e.arrayFrom(Bt.keys(),_s)),Kt=!1,Ut=!1,Vt=e.createUnderscoreEscapedMap(),qt="JSX",Wt="IntrinsicElements",Ht="ElementClass",Gt="ElementAttributesProperty",Qt="ElementChildrenAttribute",Xt="Element",Yt="IntrinsicAttributes",Zt="IntrinsicClassAttributes",$t=e.createMap(),en=e.createMap(),tn=e.createMap(),nn=e.createMap(),rn=e.createMap();!function(e){e[e.Type=0]="Type",e[e.ResolvedBaseConstructorType=1]="ResolvedBaseConstructorType",e[e.DeclaredType=2]="DeclaredType",e[e.ResolvedReturnType=3]="ResolvedReturnType"}(Rt||(Rt={})),function(e){e[e.Normal=0]="Normal",e[e.SkipContextSensitive=1]="SkipContextSensitive",e[e.Inferential=2]="Inferential"}(Lt||(Lt={})),function(e){e[e.None=0]="None",e[e.Bivariant=1]="Bivariant",e[e.Strict=2]="Strict"}(Mt||(Mt={}));var an=e.createSymbolTable();an.set(I.escapedName,I);var on=e.and(sf,(function(t){return!e.isAccessor(t)}));return function(){for(var t=0,r=n.getSourceFiles();t<r.length;t++){var i=r[t];e.bindSourceFile(i,S)}for(var a,o=0,s=n.getSourceFiles();o<s.length;o++){i=s[o];if(e.isExternalOrCommonJsModule(i)||fn(ot,i.locals),i.patternAmbientModules&&i.patternAmbientModules.length&&(xe=e.concatenate(xe,i.patternAmbientModules)),i.moduleAugmentations.length&&(a||(a=[])).push(i.moduleAugmentations),i.symbol&&i.symbol.globalExports)i.symbol.globalExports.forEach((function(e,t){ot.has(t)||ot.set(t,e)}))}if(a)for(var c=0,u=a;c<u.length;c++)for(var _=u[c],l=0,d=_;l<d.length;l++){mn(d[l])}(function(t,n,r){function i(t,n){return function(r){return At.add(e.createDiagnosticForNode(r,n,t))}}n.forEach((function(n,a){var o=t.get(a);o?e.forEach(o.declarations,i(e.unescapeLeadingUnderscores(a),r)):t.set(a,n)}))})(ot,an,e.Diagnostics.Declaration_name_conflicts_with_built_in_global_identifier_0),gn(I).type=Y,gn(M).type=po("IArguments",0,!0),gn(q).type=Q,De=po("Array",1,!0),ke=po("Object",0,!0),Se=po("Function",0,!0),Te=po("String",0,!0),Ee=po("Number",0,!0),Ne=po("Boolean",0,!0),Ae=po("RegExp",0,!0),Pe=wo(H),Fe=wo(G),Ce=So("ReadonlyArray",1),Oe=Ce?Co(Ce,[H]):Pe,we=So("ThisType",1)}(),B;function sn(){return wt||(wt="React",S.jsxFactory?(Pt=e.parseIsolatedEntityName(S.jsxFactory,D))&&(wt=$p(Pt).escapedText):S.reactNamespace&&(wt=e.escapeLeadingUnderscores(S.reactNamespace))),wt}function cn(t,n,r,i,a){var o=t?e.createDiagnosticForNode(t,n,r,i,a):e.createCompilerDiagnostic(n,r,i,a);At.add(o)}function un(e,t){h++;var n=new f(33554432|e,t);return n.checkFlags=0,n}function _n(e){return 0!=(33554432&e.flags)}function ln(e,t){t.mergeId||(t.mergeId=i,i++),yt[t.mergeId]=e}function dn(t){var n=un(t.flags,t.escapedName);return n.declarations=t.declarations?t.declarations.slice():[],n.parent=t.parent,t.valueDeclaration&&(n.valueDeclaration=t.valueDeclaration),t.constEnumOnlyModule&&(n.constEnumOnlyModule=!0),t.members&&(n.members=e.cloneMap(t.members)),t.exports&&(n.exports=e.cloneMap(t.exports)),ln(n,t),n}function pn(t,n){if(t.flags&(i=n.flags,a=0,2&i&&(a|=107455),1&i&&(a|=107454),4&i&&(a|=0),8&i&&(a|=900095),16&i&&(a|=106927),32&i&&(a|=899519),64&i&&(a|=792968),256&i&&(a|=899327),128&i&&(a|=899967),512&i&&(a|=106639),8192&i&&(a|=99263),32768&i&&(a|=41919),65536&i&&(a|=74687),262144&i&&(a|=530920),524288&i&&(a|=793064),2097152&i&&(a|=2097152),a))if(1024&t.flags)cn(e.getNameOfDeclaration(n.declarations[0]),e.Diagnostics.Cannot_augment_module_0_with_value_exports_because_it_resolves_to_a_non_module_entity,Dr(t));else{var r=2&t.flags||2&n.flags?e.Diagnostics.Cannot_redeclare_block_scoped_variable_0:e.Diagnostics.Duplicate_identifier_0;e.forEach(n.declarations,(function(t){cn(e.getNameOfDeclaration(t)||t,r,Dr(n))})),e.forEach(t.declarations,(function(t){cn(e.getNameOfDeclaration(t)||t,r,Dr(n))}))}else 512&n.flags&&512&t.flags&&t.constEnumOnlyModule&&!n.constEnumOnlyModule&&(t.constEnumOnlyModule=!1),t.flags|=n.flags,n.valueDeclaration&&(!t.valueDeclaration||233===t.valueDeclaration.kind&&233!==n.valueDeclaration.kind)&&(t.valueDeclaration=n.valueDeclaration),e.addRange(t.declarations,n.declarations),n.members&&(t.members||(t.members=e.createSymbolTable()),fn(t.members,n.members)),n.exports&&(t.exports||(t.exports=e.createSymbolTable()),fn(t.exports,n.exports)),ln(t,n);var i,a}function fn(e,t){t.forEach((function(t,n){var r=e.get(n);r?(33554432&r.flags||(r=dn(r),e.set(n,r)),pn(r,t)):e.set(n,t)}))}function mn(t){var n=t.parent;if(n.symbol.declarations[0]===n)if(e.isGlobalScopeAugmentation(n))fn(ot,n.symbol.exports);else{var r=Un(t,t,e.isInAmbientContext(t.parent.parent)?void 0:e.Diagnostics.Invalid_module_name_in_augmentation_module_0_cannot_be_found,!0);if(!r)return;1920&(r=qn(r)).flags?pn(r=33554432&r.flags?r:dn(r),n.symbol):cn(t,e.Diagnostics.Cannot_augment_module_0_because_it_resolves_to_a_non_module_entity,t.text)}else e.Debug.assert(n.symbol.declarations.length>1)}function gn(e){if(33554432&e.flags)return e;var t=s(e);return ht[t]||(ht[t]={})}function yn(e){var t=o(e);return vt[t]||(vt[t]={flags:0})}function hn(e){return 32768&e.flags?e.objectFlags:0}function vn(t){return 265===t.kind&&!e.isExternalOrCommonJsModule(t)}function bn(t,n,r){if(r){var i=t.get(n);if(i){if(e.Debug.assert(0==(1&e.getCheckFlags(i)),"Should never get an instantiated symbol here."),i.flags&r)return i;if(2097152&i.flags){var a=Ln(i);if(a===q||a.flags&r)return i}}}}function xn(t,r){var i=e.getSourceFileOfNode(t),a=e.getSourceFileOfNode(r);if(i!==a){if(C&&(i.externalModuleIndicator||a.externalModuleIndicator)||!S.outFile&&!S.out||qc(r)||e.isInAmbientContext(t))return!0;if(u(r,t))return!0;var o=n.getSourceFiles();return e.indexOf(o,i)<=e.indexOf(o,a)}if(t.pos<=r.pos){if(176===t.kind){var s=e.getAncestor(r,176);return s?e.findAncestor(s,e.isBindingElement)!==e.findAncestor(t,e.isBindingElement)||t.pos<s.pos:xn(e.getAncestor(t,226),r)}return 226!==t.kind||!function(t,n){var r=e.getEnclosingBlockScopeContainer(t);switch(t.parent.parent.kind){case 208:case 214:case 216:if(Nn(n,t,r))return!0}return e.isForInOrOfStatement(t.parent.parent)&&Nn(n,t.parent.parent.expression,r)}(t,r)}if(246===r.parent.kind||243===r.parent.kind&&r.parent.isExportEquals)return!0;if(243===r.kind&&r.isExportEquals)return!0;var c=e.getEnclosingBlockScopeContainer(t);return qc(r)||u(r,t,c);function u(t,n,r){return!!e.findAncestor(t,(function(i){if(i===r)return"quit";if(e.isFunctionLike(i))return!0;if(i.parent&&149===i.parent.kind&&i.parent.initializer===i)if(e.hasModifier(i.parent,32)){if(151===n.kind)return!0}else if(!(149===n.kind&&!e.hasModifier(n,32))||e.getContainingClass(t)!==e.getContainingClass(n))return!0}))}}function kn(e,t,n,r,i,a,o){return Sn(e,t,n,r,i,a,bn,o)}function Sn(t,n,r,i,a,o,s,c){var u,_,l,d,p,f=t,m=t,g=!1;e:for(;t;){if(t.locals&&!vn(t)&&(u=s(t.locals,n,r))){var y=!0;if(e.isFunctionLike(t)&&_&&_!==t.body&&(r&u.flags&793064&&275!==_.kind&&(y=!!(262144&u.flags)&&(_===t.type||146===_.kind||145===_.kind)),107455&r&&1&u.flags&&(y=146===_.kind||_===t.type&&146===u.valueDeclaration.kind)),y)break e;u=void 0}switch(t.kind){case 265:if(!e.isExternalOrCommonJsModule(t))break;g=!0;case 233:var h=er(t).exports;if(265===t.kind||e.isAmbientModule(t)){if(u=h.get("default")){var v=e.getLocalSymbolForExportDefault(u);if(v&&u.flags&r&&v.escapedName===n)break e;u=void 0}var b=h.get(n);if(b&&2097152===b.flags&&e.getDeclarationOfKind(b,246))break}if(u=s(h,n,2623475&r))break e;break;case 232:if(u=s(er(t).exports,n,8&r))break e;break;case 149:case 148:if(e.isClassLike(t.parent)&&!e.hasModifier(t,32)){var x=ir(t.parent);x&&x.locals&&s(x.locals,n,107455&r)&&(d=t)}break;case 229:case 199:case 230:if(u=s(er(t).members,n,793064&r)){if(!Cn(u,t)){u=void 0;break}if(_&&e.hasModifier(_,32))return void cn(m,e.Diagnostics.Static_members_cannot_reference_class_type_parameters);break e}if(199===t.kind&&32&r){var k=t.name;if(k&&n===k.escapedText){u=t.symbol;break e}}break;case 201:if(_===t.expression&&85===t.parent.token){var S=t.parent.parent;if(e.isClassLike(S)&&(u=s(er(S).members,n,793064&r)))return void(i&&cn(m,e.Diagnostics.Base_class_expressions_cannot_reference_class_type_parameters))}break;case 144:if(p=t.parent.parent,(e.isClassLike(p)||230===p.kind)&&(u=s(er(p).members,n,793064&r)))return void cn(m,e.Diagnostics.A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type);break;case 151:case 150:case 152:case 153:case 154:case 228:case 187:if(3&r&&"arguments"===n){u=M;break e}break;case 186:if(3&r&&"arguments"===n){u=M;break e}if(16&r){var D=t.name;if(D&&n===D.escapedText){u=t.symbol;break e}}break;case 147:t.parent&&146===t.parent.kind&&(t=t.parent),t.parent&&e.isClassElement(t.parent)&&(t=t.parent)}207!==t.kind&&(l=t),_=t,t=t.parent}if(o&&u&&i&&T&&u!==l.symbol&&(u.isReferenced=!0),!u){if(_&&(e.Debug.assert(265===_.kind),_.commonJsModuleIndicator&&"exports"===n))return _.symbol;u=s(ot,n,r)}if(u){if(i){if(d){var C=d.name;return void cn(m,e.Diagnostics.Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor,e.declarationNameToString(C),Dn(a))}if(m&&(2&r||(32&r||384&r)&&107455==(107455&r))){var E=nr(u);(2&E.flags||32&E.flags||384&E.flags)&&function(t,n){e.Debug.assert(!!(2&t.flags||32&t.flags||384&t.flags));var r=e.forEach(t.declarations,(function(t){return e.isBlockOrCatchScoped(t)||e.isClassLike(t)||232===t.kind?t:void 0}));e.Debug.assert(void 0!==r,"Declaration to checkResolvedBlockScopedVariable is undefined"),e.isInAmbientContext(r)||xn(r,n)||(2&t.flags?cn(n,e.Diagnostics.Block_scoped_variable_0_used_before_its_declaration,e.declarationNameToString(e.getNameOfDeclaration(r))):32&t.flags?cn(n,e.Diagnostics.Class_0_used_before_its_declaration,e.declarationNameToString(e.getNameOfDeclaration(r))):256&t.flags&&cn(n,e.Diagnostics.Enum_0_used_before_its_declaration,e.declarationNameToString(e.getNameOfDeclaration(r))))}(E,m)}if(u&&g&&107455==(107455&r)){var N=u.declarations;N&&1===N.length&&236===N[0].kind&&cn(m,e.Diagnostics._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead,e.unescapeLeadingUnderscores(n))}}return u}if(i&&!(m&&(function(t,n,r){if(71===t.kind&&mf(t)||qc(t))return!1;var i=e.getThisContainer(t,!0),a=i;for(;a;){if(e.isClassLike(a.parent)){var o=er(a.parent);if(!o)break;if(va(ci(o),n))return cn(t,e.Diagnostics.Cannot_find_name_0_Did_you_mean_the_static_member_1_0,Dn(r),Dr(o)),!0;if(a===i&&!e.hasModifier(a,32))if(va(Fi(o).thisType,n))return cn(t,e.Diagnostics.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0,Dn(r)),!0}a=a.parent}return!1}(m,n,a)||Tn(m)||function(t,n,r){if(1920===r){var i=Rn(kn(t,n,792640,void 0,void 0,!1)),a=t.parent;if(i){if(e.isQualifiedName(a)){e.Debug.assert(a.left===t,"Should only be resolving left side of qualified name as a namespace");var o=a.right.escapedText;if(va(Fi(i),o))return cn(a,e.Diagnostics.Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_property_1_in_0_with_0_1,e.unescapeLeadingUnderscores(n),e.unescapeLeadingUnderscores(o)),!0}return cn(t,e.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_namespace_here,e.unescapeLeadingUnderscores(n)),!0}}return!1}(m,n,r)||function(t,n,r){if(107455&r){if("any"===n||"string"===n||"number"===n||"boolean"===n||"never"===n)return cn(t,e.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here,e.unescapeLeadingUnderscores(n)),!0;var i=Rn(kn(t,n,792640,void 0,void 0,!1));if(i&&!(1024&i.flags))return cn(t,e.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here,e.unescapeLeadingUnderscores(n)),!0}return!1}(m,n,r)||function(t,n,r){if(107031&r){if(Rn(kn(t,n,1024,void 0,void 0,!1)))return cn(t,e.Diagnostics.Cannot_use_namespace_0_as_a_value,e.unescapeLeadingUnderscores(n)),!0}else if(792640&r){if(Rn(kn(t,n,1024,void 0,void 0,!1)))return cn(t,e.Diagnostics.Cannot_use_namespace_0_as_a_type,e.unescapeLeadingUnderscores(n)),!0}return!1}(m,n,r)))){var A=void 0;c&&gt<10&&(A=Y_(f,n,r))&&cn(m,c,Dn(a),A),A||cn(m,i,Dn(a)),gt++}}function Dn(t){return e.isString(t)?e.unescapeLeadingUnderscores(t):e.declarationNameToString(t)}function Cn(e,t){for(var n=0,r=e.declarations;n<r.length;n++){var i=r[n];if(145===i.kind&&i.parent===t)return!0}return!1}function Tn(t){var n=En(t),r=!(!n||!jn(n,64,!0));return r&&cn(t,e.Diagnostics.Cannot_extend_an_interface_0_Did_you_mean_implements,e.getTextOfNode(n)),r}function En(t){switch(t.kind){case 71:case 179:return t.parent?En(t.parent):void 0;case 201:if(e.isEntityNameExpression(t.expression))return t.expression;default:return}}function Nn(t,n,r){return n&&!!e.findAncestor(t,(function(t){return t===r||e.isFunctionLike(t)?"quit":t===n}))}function An(e){switch(e.kind){case 237:return e;case 239:return e.parent;case 240:return e.parent.parent;case 242:return e.parent.parent.parent;default:return}}function wn(t){return e.find(t.declarations,e.isAliasSymbolDeclaration)}function Pn(t,n,r){var i=Kn(t,t.moduleSpecifier),a=Wn(i,t.moduleSpecifier,r);if(a){var o=n.propertyName||n.name;if(o.escapedText){if(e.isShorthandAmbientModuleSymbol(i))return i;var s=void 0;s=i&&i.exports&&i.exports.get("export=")?va(ci(a),o.escapedText):function(e,t){if(3&e.flags){var n=e.valueDeclaration.type;if(n)return Rn(va(ds(n),t))}}(a,o.escapedText),s=Rn(s,r);var c=function(e,t,n){if(1536&e.flags)return Rn(Xn(e).get(t),n)}(a,o.escapedText,r);!c&&E&&"default"===o.escapedText&&(c=qn(i,r)||Rn(i,r));var u=c&&s?function(t,n){if(t===q&&n===q)return q;if(794600&t.flags)return t;var r=un(t.flags|n.flags,t.escapedName);return r.declarations=e.concatenate(t.declarations,n.declarations),r.parent=t.parent||n.parent,t.valueDeclaration&&(r.valueDeclaration=t.valueDeclaration),n.members&&(r.members=n.members),t.exports&&(r.exports=t.exports),r}(s,c):c||s;return u||cn(o,e.Diagnostics.Module_0_has_no_exported_member_1,zn(i),e.declarationNameToString(o)),u}}}function Fn(e,t,n){return e.parent.parent.moduleSpecifier?Pn(e.parent.parent,e,n):jn(e.propertyName||e.name,t,!1,n)}function On(t,n){switch(t.kind){case 237:return function(t,n){return 248===t.moduleReference.kind?qn(Kn(t,e.getExternalModuleImportEqualsDeclarationExpression(t))):Jn(t.moduleReference,n)}(t,n);case 239:return function(t,n){var r=Kn(t,t.parent.moduleSpecifier);if(r){var i=void 0;if(e.isShorthandAmbientModuleSymbol(r))i=r;else{var a=r.exports.get("export=");i=a?va(ci(a),"default"):Rn(r.exports.get("default"),n)}if(i||E){if(!i&&E)return qn(r,n)||Rn(r,n)}else cn(t.name,e.Diagnostics.Module_0_has_no_default_export,Dr(r));return i}}(t,n);case 240:return function(e,t){var n=e.parent.parent.moduleSpecifier;return Wn(Kn(e,n),n,t)}(t,n);case 242:return function(e,t){return Pn(e.parent.parent.parent,e,t)}(t,n);case 246:return Fn(t,901119,n);case 243:return function(e,t){return jn(e.expression,901119,!1,t)}(t,n);case 236:return function(e,t){return qn(e.parent.symbol,t)}(t,n)}}function In(e,t){return void 0===t&&(t=901119),e&&2097152==(e.flags&(2097152|t))}function Rn(e,t){return!t&&In(e)?Ln(e):e}function Ln(t){e.Debug.assert(0!=(2097152&t.flags),"Should only get Alias here.");var n=gn(t);if(n.target)n.target===W&&(n.target=q);else{n.target=W;var r=wn(t);e.Debug.assert(!!r);var i=On(r);n.target===W?n.target=i||q:cn(r,e.Diagnostics.Circular_definition_of_import_alias_0,Dr(t))}return n.target}function Mn(e){var t=er(e),n=Ln(t);n&&((n===q||107455&n.flags&&!If(n))&&Bn(t))}function Bn(t){var n=gn(t);if(!n.referenced){n.referenced=!0;var r=wn(t);e.Debug.assert(!!r),243===r.kind?hd(r.expression):246===r.kind?hd(r.propertyName||r.name):e.isInternalModuleImportEqualsDeclaration(r)&&hd(r.moduleReference)}}function Jn(t,n){return 71===t.kind&&e.isRightSideOfQualifiedNameOrPropertyAccess(t)&&(t=t.parent),71===t.kind||143===t.parent.kind?jn(t,1920,!1,n):(e.Debug.assert(237===t.parent.kind),jn(t,901119,!1,n))}function zn(e){return e.parent?zn(e.parent)+"."+Dr(e):Dr(e)}function jn(t,n,r,i,a){if(!e.nodeIsMissing(t)){var o;if(71===t.kind){var s=1920===n?e.Diagnostics.Cannot_find_namespace_0:e.Diagnostics.Cannot_find_name_0;if(!(o=kn(a||t,t.escapedText,n,r?void 0:s,t,!0)))return}else if(143===t.kind||179===t.kind){var c=void 0;if(143===t.kind)c=t.left;else{if(179!==t.kind||185!==t.expression.kind&&!e.isEntityNameExpression(t.expression))return;c=t.expression}var u=143===t.kind?t.right:t.name,_=jn(c,1920,r,!1,a);if(!_||e.nodeIsMissing(u))return;if(_===q)return _;if(!(o=bn(Xn(_),u.escapedText,n)))return void(r||cn(u,e.Diagnostics.Namespace_0_has_no_exported_member_1,zn(_),e.declarationNameToString(u)))}else{if(185===t.kind)return e.isEntityNameExpression(t.expression)?jn(t.expression,n,r,i,a):void 0;e.Debug.assertNever(t,"Unknown entity name kind.")}return e.Debug.assert(0==(1&e.getCheckFlags(o)),"Should never get an instantiated symbol here."),o.flags&n||i?o:Ln(o)}}function Kn(t,n){return Un(t,n,e.Diagnostics.Cannot_find_module_0)}function Un(e,t,n,r){if(void 0===r&&(r=!1),9===t.kind||13===t.kind){var i=t;return Vn(e,i.text,n,i,r)}}function Vn(t,r,i,a,o){if(void 0===o&&(o=!1),void 0!==r){if(e.startsWith(r,"@types/"))cn(a,e.Diagnostics.Cannot_import_type_declaration_files_Consider_importing_0_instead_of_1,e.removePrefix(r,"@types/"),r);var s=Aa(r,!0);if(s)return s;var c=e.getResolvedModule(e.getSourceFileOfNode(t),r),u=c&&e.getResolutionDiagnostic(S,c),_=c&&!u&&n.getSourceFile(c.resolvedFileName);if(_)return _.symbol?$n(_.symbol):void(i&&cn(a,e.Diagnostics.File_0_is_not_a_module,_.fileName));if(xe){var l=e.findBestPatternMatch(xe,(function(e){return e.pattern}),r);if(l)return $n(l.symbol)}if(c&&!e.extensionIsTypeScript(c.extension)&&void 0===u||u===e.Diagnostics.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type){if(o)cn(a,e.Diagnostics.Invalid_module_name_in_augmentation_Module_0_resolves_to_an_untyped_module_at_1_which_cannot_be_augmented,r,c.resolvedFileName);else if(w&&i){var d=c.isExternalLibraryImport?e.chainDiagnosticMessages(void 0,e.Diagnostics.Try_npm_install_types_Slash_0_if_it_exists_or_add_a_new_declaration_d_ts_file_containing_declare_module_0,r):void 0;d=e.chainDiagnosticMessages(d,e.Diagnostics.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type,r,c.resolvedFileName),At.add(e.createDiagnosticForNodeFromMessageChain(a,d))}}else if(i)if(u)cn(a,u,r,c.resolvedFileName);else{var p=e.tryExtractTypeScriptExtension(r);if(p)cn(a,e.Diagnostics.An_import_path_cannot_end_with_a_0_extension_Consider_importing_1_instead,p,e.removeExtension(r,p));else cn(a,i,r)}}}function qn(e,t){return e&&$n(Rn(e.exports.get("export="),t))||e}function Wn(t,n,r){var i=qn(t,r);return r||!i||1539&i.flags||cn(n,e.Diagnostics.Module_0_resolves_to_a_non_module_entity_and_cannot_be_imported_using_this_construct,Dr(t)),i}function Hn(e){return void 0!==e.exports.get("export=")}function Gn(e){return Ea(Yn(e))}function Qn(e,t){var n=Yn(t);if(n)return n.get(e)}function Xn(e){return 1536&e.flags?Yn(e):e.exports||x}function Yn(t){var n=gn(t);return n.resolvedExports||(n.resolvedExports=function(t){var n=[];return r(t=qn(t))||x;function r(t){if(t&&1952&t.flags&&e.pushIfUnique(n,t)){var i=e.cloneMap(t.exports),a=t.exports.get("__export");if(a){for(var o=e.createSymbolTable(),s=e.createMap(),c=0,u=a.declarations;c<u.length;c++){var _=u[c];Zn(o,r(Kn(_,_.moduleSpecifier)),s,_)}s.forEach((function(t,n){var r=t.exportsWithDuplicate;if("export="!==n&&r&&r.length&&!i.has(n))for(var a=0,o=r;a<o.length;a++){var c=o[a];At.add(e.createDiagnosticForNode(c,e.Diagnostics.Module_0_has_already_exported_a_member_named_1_Consider_explicitly_re_exporting_to_resolve_the_ambiguity,s.get(n).specifierText,e.unescapeLeadingUnderscores(n)))}})),Zn(i,o)}return i}}}(t))}function Zn(t,n,r,i){n&&n.forEach((function(n,a){if("default"!==a){var o=t.get(a);if(o){if(r&&i&&o&&Rn(o)!==Rn(n)){var s=r.get(a);s.exportsWithDuplicate?s.exportsWithDuplicate.push(i):s.exportsWithDuplicate=[i]}}else t.set(a,n),r&&i&&r.set(a,{specifierText:e.getTextOfNode(i.moduleSpecifier)})}}))}function $n(e){var t;return e&&e.mergeId&&(t=yt[e.mergeId])?t:e}function er(e){return $n(e.symbol)}function tr(e){return $n(e.parent)}function nr(e){return e&&0!=(1048576&e.flags)?$n(e.exportSymbol):e}function rr(e){return!!(107455&e.flags||2097152&e.flags&&107455&Ln(e).flags)}function ir(t){for(var n=0,r=t.members;n<r.length;n++){var i=r[n];if(152===i.kind&&e.nodeIsPresent(i.body))return i}}function ar(e){var t=new m(B,e);return y++,t.id=y,t}function or(e,t){var n=ar(e);return n.intrinsicName=t,n}function sr(e,t){var n=ar(32768);return n.objectFlags=e,n.symbol=t,n}function cr(e){return 95===e.charCodeAt(0)&&95===e.charCodeAt(1)&&95!==e.charCodeAt(2)&&64!==e.charCodeAt(2)}function ur(t){var n;return t.forEach((function(e,t){cr(t)||(n||(n=[]),rr(e)&&n.push(e))})),n||e.emptyArray}function _r(e,t,n,r,i,a){return e.members=t,e.properties=ur(t),e.callSignatures=n,e.constructSignatures=r,i&&(e.stringIndexInfo=i),a&&(e.numberIndexInfo=a),e}function lr(e,t,n,r,i,a){return _r(sr(16,e),t,n,r,i,a)}function dr(t,n){for(var r,i=t;i;i=i.parent){if(i.locals&&!vn(i)&&(r=n(i.locals)))return r;switch(i.kind){case 265:if(!e.isExternalOrCommonJsModule(i))break;case 233:if(r=n(er(i).exports))return r}}return n(ot)}function pr(e){return 107455===e?107455:1920}function fr(t,n,r,i){if(t&&!function(e){if(e.declarations&&e.declarations.length){for(var t=0,n=e.declarations;t<n.length;t++){switch(n[t].kind){case 149:case 151:case 153:case 154:continue;default:return!1}}return!0}return!1}(t)){var a=[];return dr(n,o)}function o(u){if(e.pushIfUnique(a,u)){var _=function(a){if(c(a.get(t.escapedName)))return[t];return e.forEachEntry(a,(function(t){if(2097152&t.flags&&"export="!==t.escapedName&&!e.getDeclarationOfKind(t,246)&&!(function(t){return t&&t.declarations&&t.declarations[0]&&e.isNamespaceExportDeclaration(t.declarations[0])}(t)&&n&&e.isExternalModule(e.getSourceFileOfNode(n)))&&(!i||e.some(t.declarations,e.isExternalModuleImportEqualsDeclaration))){var a=Ln(t);if(c(t,a))return[t];var u=a.exports?o(a.exports):void 0;if(u&&s(t,pr(r)))return[t].concat(u)}}))}(u);return a.pop(),_}}function s(e,t){return!mr(e,n,t)||!!fr(e.parent,n,pr(t),i)}function c(n,i){return t===(i||n)&&!e.some(n.declarations,hr)&&s(n,r)}}function mr(t,n,r){var i=!1;return dr(n,(function(n){var a=n.get(t.escapedName);return!!a&&(a===t||!!((a=2097152&a.flags&&!e.getDeclarationOfKind(a,246)?Ln(a):a).flags&r)&&(i=!0,!0))})),i}function gr(e,t){return 0===yr(e,t,793064,!1).accessibility}function yr(t,n,r,i){if(t&&n&&!(262144&t.flags)){for(var a=t,o=r;t;){var s=fr(t,n,o,!1);if(s){var c=vr(s[0],i);return c||{accessibility:1,errorSymbolName:Dr(a,n,r),errorModuleName:t!==a?Dr(t,n,1920):void 0}}o=pr(r),t=tr(t)}var u=e.forEach(a.declarations,_);if(u)if(u!==_(n))return{accessibility:2,errorSymbolName:Dr(a,n,r),errorModuleName:Dr(u)};return{accessibility:1,errorSymbolName:Dr(a,n,r)}}return{accessibility:0};function _(t){var n=e.findAncestor(t,hr);return n&&er(n)}}function hr(t){return e.isAmbientModule(t)||265===t.kind&&e.isExternalOrCommonJsModule(t)}function vr(t,n){var r;if(!e.forEach(t.declarations,(function(t){return!function(t){if(!Rr(t)){var i=An(t);return!(!i||e.hasModifier(i,1)||!Rr(i.parent))&&(n&&(yn(t).isVisible=!0,r=e.appendIfUnique(r,i)),!0)}return!0}(t)})))return{accessibility:0,aliasesToMakeVisible:r}}function br(t,n){var r;r=162===t.parent.kind||e.isExpressionWithTypeArgumentsInClassExtendsClause(t.parent)?1156031:143===t.kind||179===t.kind||237===t.parent.kind?1920:793064;var i=$p(t),a=kn(n,i.escapedText,r,void 0,void 0,!1);return a&&vr(a,!0)||{accessibility:1,errorSymbolName:e.getTextOfNode(i),errorNode:i}}function xr(t,n){t.writeKeyword(e.tokenToString(n))}function kr(t,n){t.writePunctuation(e.tokenToString(n))}function Sr(e){e.writeSpace(" ")}function Dr(t,n,r){return e.usingSingleLineStringWriter((function(e){Ir().buildSymbolDisplay(t,e,n,r)}))}function Cr(t,n,r,i){return e.usingSingleLineStringWriter((function(e){Ir().buildSignatureDisplay(t,e,n,r,i)}))}function Tr(t,n,r){var i=O.typeToTypeNode(t,n,function(t){var n=e.NodeBuilderFlags.None;if(!t)return n;8&t&&(n|=e.NodeBuilderFlags.NoTruncation);256&t&&(n|=e.NodeBuilderFlags.UseFullyQualifiedType);4096&t&&(n|=e.NodeBuilderFlags.SuppressAnyReturnType);1&t&&(n|=e.NodeBuilderFlags.WriteArrayAsGenericType);64&t&&(n|=e.NodeBuilderFlags.WriteTypeArgumentsOfSignature);return n}(r)|e.NodeBuilderFlags.IgnoreErrors|e.NodeBuilderFlags.WriteTypeParametersInQualifiedName);e.Debug.assert(void 0!==i,"should always get typenode");var a=e.createTextWriter(""),o=e.createPrinter({removeComments:!0}),s=n&&e.getSourceFileOfNode(n);o.writeNode(4,i,s,a);var c=a.getText(),u=S.noErrorTruncation||8&r?void 0:100;return u&&c.length>=u?c.substr(0,u-"...".length)+"...":c}function Er(t,n,r){return e.usingSingleLineStringWriter((function(e){Ir().buildTypePredicateDisplay(t,e,n,r)}))}function Nr(e){for(var t=[],n=0,r=0;r<e.length;r++){var i=e[r];if(n|=i.flags,!(6144&i.flags)){if(384&i.flags){var a=128&i.flags?ie:Ni(i);if(65536&a.flags){var o=a.types.length;if(r+o<=e.length&&e[r+o-1]===a.types[o-1]){t.push(a),r+=o-1;continue}}}t.push(i)}}return 4096&n&&t.push(Z),2048&n&&t.push(X),t||e}function Ar(e){return 8===e?"private":16===e?"protected":"public"}function wr(t){if(t.symbol&&2048&t.symbol.flags){var n=e.findAncestor(t.symbol.declarations[0].parent,(function(e){return 168!==e.kind}));if(231===n.kind)return er(n)}}function Pr(t){return t&&t.parent&&234===t.parent.kind&&e.isExternalModuleAugmentation(t.parent.parent)}function Fr(t){return 32&t.flags?'"'+e.escapeString(t.value)+'"':""+t.value}function Or(t,n){if(t.declarations&&t.declarations.length){var r=t.declarations[0],i=e.getNameOfDeclaration(r);if(i)return e.declarationNameToString(i);if(r.parent&&226===r.parent.kind)return e.declarationNameToString(r.parent.name);switch(!n||n.encounteredError||n.flags&e.NodeBuilderFlags.AllowAnonymousIdentifier||(n.encounteredError=!0),r.kind){case 199:return"(Anonymous class)";case 186:case 187:return"(Anonymous function)"}}if(t.syntheticLiteralTypeOrigin){var a=t.syntheticLiteralTypeOrigin.value;if(!e.isIdentifierText(a,S.target))return'"'+e.escapeString(a,34)+'"'}return e.symbolName(t)}function Ir(){function t(e,t){t.writeSymbol(Or(e),e)}function n(n,r,a,o,s,c){var u;function _(n){if(u){if(1&s)if(1&e.getCheckFlags(n))l(gi(2097152&u.flags?Ln(u):u),n.mapper,r,a);else i(u,r,a);!function(t,n){var r=Or(t),i=r.charCodeAt(0);e.isIdentifierStart(i,D)?(kr(n,23),n.writeSymbol(r,t)):(kr(n,21),e.isSingleOrDoubleQuote(i)?n.writeStringLiteral(r):n.writeSymbol(r,t),kr(n,22))}(n,r)}else t(n,r);u=n}r.trackSymbol(n,a,o),262144&n.flags||!a&&!(256&c)?_(n):function t(n,r,i){var o=fr(n,a,r,!!(2&s));if(!o||mr(o[0],a,1===o.length?r:pr(r))){var c=tr(o?o[0]:n);c&&t(c,pr(r),!1)}if(o)for(var l=0,d=o;l<d.length;l++)_(d[l]);else!i&&(!u&&e.forEach(n.declarations,hr)||6144&n.flags)||_(n)}(n,o,!0)}function r(r,i,a,o,s){var c=16416&o,u=!1;return _(r,o);function _(r,s){var c=-1025&s;if(16793231&r.flags)i.writeKeyword(32&o||!Ur(r)?r.intrinsicName:"any");else if(16384&r.flags&&r.isThisType)u&&i.reportInaccessibleThisError(),i.writeKeyword("this");else if(4&hn(r))!function(t,n){var r=t.typeArguments||e.emptyArray;if(t.target!==De||1&n)if(8&t.target.objectFlags)kr(i,21),l(t.typeArguments.slice(0,$a(t)),26),kr(i,22);else if(16384&n&&t.symbol.valueDeclaration&&199===t.symbol.valueDeclaration.kind)p(t,n);else{var a=t.target.outerTypeParameters,o=0;if(a)for(var s=a.length;o<s;){var c=o,u=Ga(a[o]);do{o++}while(o<s&&Ga(a[o])===u);e.rangeEquals(a,r,c,o)||(d(u,r,c,o,n),kr(i,23))}var f=(t.target.typeParameters||e.emptyArray).length;d(t.symbol,r,o,f,n)}else _(r[0],32896),kr(i,21),kr(i,22)}(r,c);else if(256&r.flags&&!(65536&r.flags)){var f=tr(r.symbol);n(f,i,a,793064,0,c),Fi(f)!==r&&(kr(i,23),t(r.symbol,i))}else if(3&hn(r)||16656&r.flags)n(r.symbol,i,a,793064,0,c);else if(1024&s||!r.aliasSymbol||!(65536&s||gr(r.aliasSymbol,a)))196608&r.flags?function(e,t){128&t&&kr(i,19);65536&e.flags?l(Nr(e.types),49):l(e.types,48);128&t&&kr(i,20)}(r,c):48&hn(r)?p(r,c):96&r.flags?i.writeStringLiteral(Fr(r)):262144&r.flags?(128&s&&kr(i,19),i.writeKeyword("keyof"),Sr(i),_(r.type,128),128&s&&kr(i,20)):524288&r.flags?(_(r.objectType,128),kr(i,21),_(r.indexType,0),kr(i,22)):(kr(i,17),Sr(i),kr(i,24),Sr(i),kr(i,18));else{var m=r.aliasTypeArguments;d(r.aliasSymbol,m,0,e.length(m),c)}}function l(e,t){for(var n=0;n<e.length;n++)n>0&&(26!==t&&Sr(i),kr(i,t),Sr(i)),_(e[n],26===t?0:128)}function d(e,t,r,o,s){if((32&e.flags||!cr(e.escapedName))&&n(e,i,a,793064,0,s),r<o){for(kr(i,27),_(t[r],512),r++;r<o;)kr(i,26),Sr(i),_(t[r],0),r++;kr(i,29)}}function p(t,r){var o=t.symbol;if(o)if(32&o.flags&&!oi(o)&&!(199===o.valueDeclaration.kind&&16384&r)||896&o.flags)f(t,r);else if(function(){var t=!!(8192&o.flags)&&e.some(o.declarations,(function(t){return e.hasModifier(t,32)})),n=!!(16&o.flags)&&(o.parent||e.some(o.declarations,(function(e){return 265===e.parent.kind||234===e.parent.kind})));if(t||n)return!!(4&r)||e.contains(s,o)}())f(t,r);else if(e.contains(s,o)){var c=wr(t);c?n(c,i,a,793064,0,r):xr(i,119)}else{s||(s=[]),16&t.objectFlags&&t.symbol&&32&t.symbol.flags?h(t,r):(s.push(o),h(t,r),s.pop())}else h(t,r)}function f(e,t){32768&t&&kr(i,19),xr(i,103),Sr(i),n(e.symbol,i,a,107455,0,t),32768&t&&kr(i,20)}function y(e){ed(e)&&(xr(i,131),Sr(i)),n(e,i),16777216&e.flags&&kr(i,55)}function h(n,r){if(ra(n))!function(e){kr(i,17),i.writeLine(),i.increaseIndent(),e.declaration.readonlyToken&&(xr(i,131),Sr(i));kr(i,21),t(ea(e).symbol,i),Sr(i),xr(i,92),Sr(i),_(ta(e),0),kr(i,22),e.declaration.questionToken&&kr(i,55);kr(i,56),Sr(i),_(na(e),0),kr(i,25),i.writeLine(),i.decreaseIndent(),kr(i,18)}(n);else{var l=ia(n);if(!l.properties.length&&!l.stringIndexInfo&&!l.numberIndexInfo){if(!l.callSignatures.length&&!l.constructSignatures.length)return kr(i,17),void kr(i,18);if(1===l.callSignatures.length&&!l.constructSignatures.length){var d=function(e,t){if(128&t)return!0;if(512&t){var n=e.target&&64&t?e.target.typeParameters:e.typeParameters;return n&&0!==n.length}return!1}(l.callSignatures[0],r);return d&&kr(i,19),m(l.callSignatures[0],i,a,16|c,void 0,s),void(d&&kr(i,20))}if(1===l.constructSignatures.length&&!l.callSignatures.length)return 128&r&&kr(i,19),xr(i,94),Sr(i),m(l.constructSignatures[0],i,a,16|c,void 0,s),void(128&r&&kr(i,20))}var p=u;u=!0,kr(i,17),i.writeLine(),i.increaseIndent(),function(t){for(var n=0,r=t.callSignatures;n<r.length;n++){m(x=r[n],i,a,c,void 0,s),kr(i,25),i.writeLine()}for(var u=0,l=t.constructSignatures;u<l.length;u++){m(x=l[u],i,a,c,1,s),kr(i,25),i.writeLine()}g(t.stringIndexInfo,i,0,a,o,s),g(t.numberIndexInfo,i,1,a,o,s);for(var d=0,p=t.properties;d<p.length;d++){var f=p[d];if(16384&o){if(4194304&f.flags)continue;24&e.getDeclarationModifierFlagsFromSymbol(f)&&i.reportPrivateInBaseOfClassExpression(e.symbolName(f))}var h=ci(f);if(8208&f.flags&&!aa(h).length)for(var v=0,b=xa(h,0);v<b.length;v++){var x=b[v];y(f),m(x,i,a,c,void 0,s),kr(i,25),i.writeLine()}else y(f),kr(i,56),Sr(i),_(h,16384&o),kr(i,25),i.writeLine()}}(l),i.decreaseIndent(),kr(i,18),u=p}}}function i(e,t,n,r){var i=qp(e);(32&i.flags||64&i.flags||524288&i.flags)&&u(mi(e),t,n,r)}function a(e,n,i,a,o){t(e.symbol,n);var s=ca(e);s&&(Sr(n),xr(n,85),Sr(n),r(s,n,i,a,o));var c=fa(e);c&&(Sr(n),kr(n,58),Sr(n),r(c,n,i,a,o))}function o(n,i,a,o,c){var u=n.valueDeclaration;(u?e.isRestParameter(u):_n(n)&&n.isRestParameter)&&kr(i,24),u&&e.isBindingPattern(u.name)?s(u.name,i,a,o,c):t(n,i),u&&wa(u)&&kr(i,55),kr(i,56),Sr(i);var _=ci(n);u&&Mf(u)&&(_=bc(_,2048)),r(_,i,a,o,c)}function s(e,t,n,r,i){if(174===e.kind)kr(t,17),_(e.elements,t,(function(e){return c(e,t,n,r,i)})),kr(t,18);else if(175===e.kind){kr(t,21);var a=e.elements;_(a,t,(function(e){return c(e,t,n,r,i)})),a&&a.hasTrailingComma&&kr(t,26),kr(t,22)}}function c(n,r,i,a,o){e.isOmittedExpression(n)||(e.Debug.assert(176===n.kind),n.propertyName&&(r.writeProperty(e.getTextOfNode(n.propertyName)),kr(r,56),Sr(r)),e.isBindingPattern(n.name)?s(n.name,r,i,a,o):(n.dotDotDotToken&&kr(r,24),t(n.symbol,r)))}function u(e,t,n,r,i){e&&e.length&&(kr(t,27),_(e,t,(function(e){return a(e,t,n,r,i)})),kr(t,29))}function _(e,t,n){for(var r=0;r<e.length;r++)r>0&&(kr(t,26),Sr(t)),n(e[r])}function l(e,t,n,i){if(e&&e.length){kr(n,27);for(var a=512,o=0;o<e.length;o++)o>0&&(kr(n,26),Sr(n),a=0),r(t(e[o]),n,i,a);kr(n,29)}}function d(e,t,n,r,i,a){kr(n,19),e&&o(e,n,r,i,a);for(var s=0;s<t.length;s++)(s>0||e)&&(kr(n,26),Sr(n)),o(t[s],n,r,i,a);kr(n,20)}function p(t,n,i,a,o){e.isIdentifierTypePredicate(t)?n.writeParameter(t.parameterName):xr(n,99),Sr(n),xr(n,126),Sr(n),r(t.type,n,i,a,o)}function f(e,t,n,i,a){var o=La(e);4096&i&&Ur(o)||(16&i?(Sr(t),kr(t,36)):kr(t,56),Sr(t),e.typePredicate?p(e.typePredicate,t,n,i,a):r(o,t,n,i,a))}function m(e,t,n,r,i,a){1===i&&(xr(t,94),Sr(t)),e.target&&64&r?l(e.target.typeParameters,e.mapper,t,n):u(e.typeParameters,t,n,r,a),d(e.thisParameter,e.parameters,t,n,r,a),f(e,t,n,r,a)}function g(t,n,i,a,o,s){if(t){switch(t.isReadonly&&(xr(n,131),Sr(n)),kr(n,21),n.writeParameter(t.declaration?e.declarationNameToString(t.declaration.parameters[0].name):"x"),kr(n,56),Sr(n),i){case 1:xr(n,133);break;case 0:xr(n,136)}kr(n,22),kr(n,56),Sr(n),r(t.type,n,a,o,s),kr(n,25),n.writeLine()}}return It||(It={buildSymbolDisplay:n,buildTypeDisplay:r,buildTypeParameterDisplay:a,buildTypePredicateDisplay:p,buildParameterDisplay:o,buildDisplayForParametersAndDelimiters:d,buildDisplayForTypeParametersAndDelimiters:u,buildTypeParameterDisplayFromSymbol:i,buildSignatureDisplay:m,buildIndexSignatureDisplay:g,buildReturnTypeDisplay:f})}function Rr(t){if(t){var n=yn(t);return void 0===n.isVisible&&(n.isVisible=!!function(){switch(t.kind){case 176:return Rr(t.parent.parent);case 226:if(e.isBindingPattern(t.name)&&!t.name.elements.length)return!1;case 233:case 229:case 230:case 231:case 228:case 232:case 237:if(e.isExternalModuleAugmentation(t))return!0;var n=jr(t);return 1&e.getCombinedModifierFlags(t)||237!==t.kind&&265!==n.kind&&e.isInAmbientContext(n)?Rr(n):vn(n);case 149:case 148:case 153:case 154:case 151:case 150:if(e.hasModifier(t,24))return!1;case 152:case 156:case 155:case 157:case 146:case 234:case 160:case 161:case 163:case 159:case 164:case 165:case 166:case 167:case 168:return Rr(t.parent);case 239:case 240:case 242:return!1;case 145:case 265:case 236:return!0;case 243:default:return!1}}()),n.isVisible}return!1}function Lr(t){var n;t.parent&&243===t.parent.kind?n=kn(t.parent,t.escapedText,2998271,e.Diagnostics.Cannot_find_name_0,t,!1):246===t.parent.kind&&(n=Fn(t.parent,2998271));var r=[];return n&&function t(n){e.forEach(n,(function(n){yn(n).isVisible=!0;var i=An(n)||n;if(e.pushIfUnique(r,i),e.isInternalModuleImportEqualsDeclaration(n)){var a=kn(n,$p(n.moduleReference).escapedText,901119,void 0,void 0,!1);a&&t(a.declarations)}}))}(n.declarations),r}function Mr(e,t){var n=Br(e,t);if(n>=0){for(var r=pt.length,i=n;i<r;i++)ft[i]=!1;return!1}return pt.push(e),ft.push(!0),mt.push(t),!0}function Br(e,t){for(var n=pt.length-1;n>=0;n--){if(Jr(pt[n],mt[n]))return-1;if(pt[n]===e&&mt[n]===t)return n}return-1}function Jr(t,n){return 0===n?gn(t).type:2===n?gn(t).declaredType:1===n?t.resolvedBaseConstructorType:3===n?t.resolvedReturnType:void e.Debug.fail("Unhandled TypeSystemPropertyName "+n)}function zr(){return pt.pop(),mt.pop(),ft.pop()}function jr(t){return(t=e.findAncestor(e.getRootDeclaration(t),(function(e){switch(e.kind){case 226:case 227:case 242:case 241:case 240:case 239:return!1;default:return!0}})))&&t.parent}function Kr(e,t){var n=va(e,t);return n?ci(n):void 0}function Ur(e){return e&&0!=(1&e.flags)}function Vr(e){var t=er(e);return t&&gn(t).type||Yr(e,!1)}function qr(t){return 144===t.kind&&!e.isStringOrNumericLiteral(t.expression)}function Wr(t,n,r){if(8192&(t=vu(t,(function(e){return!(6144&e.flags)}))).flags)return _e;if(65536&t.flags)return bu(t,(function(e){return Wr(e,n,r)}));for(var i=e.createSymbolTable(),a=e.createUnderscoreEscapedMap(),o=0,s=n;o<s.length;o++){var c=s[o];a.set(e.getTextOfPropertyName(c),!0)}for(var u=0,_=sa(t);u<_.length;u++){var l=_[u],d=a.has(l.escapedName),p=24&e.getDeclarationModifierFlagsFromSymbol(l),f=65536&l.flags&&!(32768&l.flags);d||p||os(l)||f||i.set(l.escapedName,l)}var m=Da(t,0),g=Da(t,1);return lr(r,i,e.emptyArray,e.emptyArray,m,g)}function Hr(t){var n,r=t.parent,i=Vr(r.parent);if(i===Q)return Q;if(!i)return t.initializer?bd(t):i;if(Ur(i))return i;if(174===r.kind)if(t.dotDotDotToken){if(!S_(i))return cn(t,e.Diagnostics.Rest_types_may_only_be_created_from_object_types),Q;for(var a=[],o=0,s=r.elements;o<s.length;o++){var c=s[o];c.dotDotDotToken||a.push(c.propertyName||c.name)}n=Wr(i,a,t.symbol)}else{var u=t.propertyName||t.name;if(qr(u))return H;var _=e.getTextOfPropertyName(u),l=Kr(i,_);if(!(n=l&&Iu(t,l)||v_(_)&&Ca(i,1)||Ca(i,0)))return cn(u,e.Diagnostics.Type_0_has_no_property_1_and_no_string_index_signature,Tr(i),e.declarationNameToString(u)),Q}else{var d=wp(i,r,!1,!1);if(t.dotDotDotToken)n=wo(d);else{var p=""+e.indexOf(r.elements,t);if(!(n=uc(i)?Kr(i,p):d))return fc(i)?cn(t,e.Diagnostics.Tuple_type_0_with_length_1_cannot_be_assigned_to_tuple_with_length_2,Tr(i),$a(i),r.elements.length):cn(t,e.Diagnostics.Type_0_has_no_property_1,Tr(i),p),Q}}return!N||!t.initializer||2048&gc(hd(t.initializer))||(n=nu(n,131072)),t.initializer?zo([n,hd(t.initializer)],!0):n}function Gr(t){var n=e.getJSDocType(t);if(n)return ds(n)}function Qr(t){var n=e.skipParentheses(t);return 177===n.kind&&0===n.elements.length}function Xr(e,t){return N&&t?bc(e,2048):e}function Yr(t,n){if(215===t.parent.parent.kind){var r=Wo(V_(t.parent.parent.expression));return 278528&r.flags?r:ee}if(216===t.parent.parent.kind){var i=t.parent.parent;return Ap(i.expression,i.awaitModifier)||H}if(e.isBindingPattern(t.parent))return Hr(t);var a,o,s=e.getEffectiveTypeAnnotationNode(t);if(s)return Xr(ds(s),t.questionToken&&n);if((w||e.isInJavaScriptFile(t))&&226===t.kind&&!e.isBindingPattern(t.name)&&!(1&e.getCombinedModifierFlags(t))&&!e.isInAmbientContext(t)){if(!(2&e.getCombinedNodeFlags(t)||t.initializer&&(a=t.initializer,o=e.skipParentheses(a),95!==o.kind&&(71!==o.kind||Vc(o)!==I))))return G;if(t.initializer&&Qr(t.initializer))return Fe}if(146===t.kind){var c=t.parent;if(154===c.kind&&!e.hasDynamicName(c)){var u=e.getDeclarationOfKind(t.parent.symbol,153);if(u){var _=Oa(u),l=mm(c);return l&&t===l?(e.Debug.assert(!l.type),ci(_.thisParameter)):La(_)}}var d=void 0;if(d="this"===t.symbol.escapedName?$u(c):e_(t))return Xr(d,t.questionToken&&n)}return t.initializer?Xr(d=bd(t),t.questionToken&&n):e.isJsxAttribute(t)?ne:262===t.kind?Ku(t.name):e.isBindingPattern(t.name)?$r(t.name,!1,!0):void 0}function Zr(t,n,r){return t.initializer?bd(t):e.isBindingPattern(t.name)?$r(t.name,n,r):(r&&w&&!ti(t)&&Ac(t,H),H)}function $r(t,n,r){return 174===t.kind?function(t,n,r){var i,a=e.createSymbolTable(),o=!1;e.forEach(t.elements,(function(t){var s=t.propertyName||t.name;if(qr(s))o=!0;else if(t.dotDotDotToken)i=qa(H,!1);else{var c=e.getTextOfPropertyName(s),u=un(4|(t.initializer?16777216:0),c);u.type=Zr(t,n,r),u.bindingElement=t,a.set(u.escapedName,u)}}));var s=lr(void 0,a,e.emptyArray,e.emptyArray,i,void 0);return n&&(s.pattern=t),o&&(s.objectFlags|=512),s}(t,n,r):function(t,n,r){var i=t.elements,a=e.lastOrUndefined(i);if(0===i.length||!e.isOmittedExpression(a)&&a.dotDotDotToken)return D>=2?No(H):Pe;var o=Fo(e.map(i,(function(t){return e.isOmittedExpression(t)?H:Zr(t,n,r)})));return n&&((o=Za(o)).pattern=t),o}(t,n,r)}function ei(e,t){var n=Yr(e,!0);return n?(t&&wc(e,n),261===e.kind?n:Ec(n)):(n=e.dotDotDotToken?Pe:H,t&&w&&(ti(e)||Ac(e,n)),n)}function ti(t){var n=e.getRootDeclaration(t);return Kd(146===n.kind?n.parent:n)}function ni(t){var n,r=gn(t);if(!r.type){if(4194304&t.flags)return r.type=(n=Fi(tr(t))).typeParameters?Ya(n,e.map(n.typeParameters,(function(e){return H}))):n;var i=t.valueDeclaration;if(e.isCatchClauseVariableDeclarationOrBindingElement(i))return r.type=H;if(243===i.kind)return r.type=Ed(i.expression);if(e.isInJavaScriptFile(i)&&e.isJSDocPropertyLikeTag(i)&&i.typeExpression)return r.type=ds(i.typeExpression.type);if(!Mr(t,0))return Q;var a=void 0;a=194===i.kind||179===i.kind&&194===i.parent.kind?function(t){for(var n,r=[],i=!1,a=!1,o=0,s=t.declarations;o<s.length;o++){var c=s[o],u=194===c.kind?c:179===c.kind?e.getAncestor(c,194):void 0;if(!u)return Q;e.isPropertyAccessExpression(u.left)&&99===u.left.expression.kind&&(152===e.getThisContainer(u,!1).kind?i=!0:a=!0);var _=Gr(u.parent);if(_){var l=Ec(_);if(n){if(n!==Q&&l!==Q&&!As(n,l)){var d=e.getNameOfDeclaration(c);cn(d,e.Diagnostics.Subsequent_variable_declarations_must_have_the_same_type_Variable_0_must_be_of_type_1_but_here_has_type_2,e.declarationNameToString(d),Tr(n),Tr(l))}}else n=l}else n||r.push(pc(hd(u.right)))}return Ec(Xr(n||zo(r,!0),a&&!i))}(t):ei(i,!0),zr()||(a=si(t)),r.type=a}return r.type}function ri(t){if(t){if(153===t.kind){var n=e.getEffectiveReturnTypeNode(t);return n&&ds(n)}var r=e.getEffectiveSetAccessorTypeAnnotationNode(t);return r&&ds(r)}}function ii(e){return Ra(Oa(e))}function ai(t){var n=gn(t);if(!n.type){var r=e.getDeclarationOfKind(t,153),i=e.getDeclarationOfKind(t,154);if(r&&e.isInJavaScriptFile(r)){var a=Gr(r);if(a)return n.type=a}if(!Mr(t,0))return Q;var o=void 0,s=ri(r);if(s)o=s;else{var c=ri(i);c?o=c:r&&r.body?o=Wl(r):(w&&(i?cn(i,e.Diagnostics.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation,Dr(t)):(e.Debug.assert(!!r,"there must existed getter as we are current checking either setter or getter in this function"),cn(r,e.Diagnostics.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation,Dr(t)))),o=H)}if(!zr())if(o=H,w)cn(e.getDeclarationOfKind(t,153),e.Diagnostics._0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions,Dr(t));n.type=o}return n.type}function oi(e){var t=ki(Ci(e));return 540672&t.flags?t:void 0}function si(t){return e.getEffectiveTypeAnnotationNode(t.valueDeclaration)?(cn(t.valueDeclaration,e.Diagnostics._0_is_referenced_directly_or_indirectly_in_its_own_type_annotation,Dr(t)),Q):(w&&cn(t.valueDeclaration,e.Diagnostics._0_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_and_is_referenced_directly_or_indirectly_in_its_own_initializer,Dr(t)),H)}function ci(t){return 1&e.getCheckFlags(t)?function(t){var n=gn(t);if(!n.type)if(100===b)cn(t.valueDeclaration,e.Diagnostics.Generic_type_instantiation_is_excessively_deep_and_possibly_infinite),n.type=Q;else{if(!Mr(t,0))return Q;b++;var r=Ss(ci(n.target),n.mapper);b--,zr()||(r=si(t)),n.type=r}return n.type}(t):7&t.flags?ni(t):9136&t.flags?function(t){var n=gn(t);if(!n.type)if(1536&t.flags&&e.isShorthandAmbientModuleSymbol(t))n.type=H;else{var r=sr(16,t);if(32&t.flags){var i=oi(t);n.type=i?Vo([r,i]):r}else n.type=N&&16777216&t.flags?bc(r,2048):r}return n.type}(t):8&t.flags?function(e){var t=gn(e);return t.type||(t.type=wi(e)),t.type}(t):98304&t.flags?ai(t):2097152&t.flags?function(e){var t=gn(e);if(!t.type){var n=Ln(e);t.type=107455&n.flags?ci(n):Q}return t.type}(t):Q}function ui(e,t){return void 0!==e&&void 0!==t&&0!=(4&hn(e))&&e.target===t}function _i(e){return 4&hn(e)?e.target:e}function li(t,n){return function t(r){if(7&hn(r)){var i=_i(r);return i===n||e.forEach(Si(i),t)}if(131072&r.flags)return e.forEach(r.types,t)}(t)}function di(t,n){for(var r=0,i=n;r<i.length;r++){var a=Pi(er(i[r]));t=e.appendIfUnique(t,a)}return t}function pi(t,n){for(;;){if(!(t=t.parent))return;switch(t.kind){case 229:case 199:case 230:case 155:case 156:case 150:case 160:case 161:case 273:case 228:case 151:case 186:case 187:case 231:case 282:case 172:var r=pi(t,n);if(172===t.kind)return e.append(r,Pi(er(t.typeParameter)));var i=di(r,e.getEffectiveTypeParameterDeclarations(t)||e.emptyArray),a=n&&(229===t.kind||199===t.kind||230===t.kind)&&Ci(er(t)).thisType;return a?e.append(i,a):i}}}function fi(t){return pi(32&t.flags?t.valueDeclaration:e.getDeclarationOfKind(t,230))}function mi(e){for(var t,n=0,r=e.declarations;n<r.length;n++){var i=r[n];if(230===i.kind||229===i.kind||199===i.kind||231===i.kind){var a=i;a.typeParameters&&(t=di(t,a.typeParameters))}}return t}function gi(t){return e.concatenate(fi(t),mi(t))}function yi(e){var t=xa(e,1);if(1===t.length){var n=t[0];return!n.typeParameters&&1===n.parameters.length&&n.hasRestParameter&&Jl(n.parameters[0])===Pe}return!1}function hi(e){if(Di(e)&&xa(e,1).length>0)return!0;if(540672&e.flags){var t=_a(e);return t&&Di(t)&&yi(t)}return!1}function vi(t){var n=t.symbol.valueDeclaration;if(e.isInJavaScriptFile(n)){var r=e.getJSDocAugmentsTag(n);if(r)return r.class}return e.getClassExtendsHeritageClauseElement(n)}function bi(t,n,r){var i=e.length(n),a=e.isInJavaScriptFile(r);return e.filter(xa(t,1),(function(t){return(a||i>=Pa(t.typeParameters))&&i<=e.length(t.typeParameters)}))}function xi(t,n,r){var i=bi(t,n,r),a=e.map(n,ds);return e.sameMap(i,(function(t){return e.some(t.typeParameters)?Ba(t,a,e.isInJavaScriptFile(r)):t}))}function ki(t){if(!t.resolvedBaseConstructorType){var n=t.symbol.valueDeclaration,r=e.getClassExtendsHeritageClauseElement(n),i=vi(t);if(!i)return t.resolvedBaseConstructorType=X;if(!Mr(t,1))return Q;var a=Ed(i.expression);if(r&&i!==r&&(e.Debug.assert(!r.typeArguments),Ed(r.expression)),163840&a.flags&&ia(a),!zr())return cn(t.symbol.valueDeclaration,e.Diagnostics._0_is_referenced_directly_or_indirectly_in_its_own_base_expression,Dr(t.symbol)),t.resolvedBaseConstructorType=Q;if(!(1&a.flags||a===$||hi(a)))return cn(i.expression,e.Diagnostics.Type_0_is_not_a_constructor_function_type,Tr(a)),t.resolvedBaseConstructorType=Q;t.resolvedBaseConstructorType=a}return t.resolvedBaseConstructorType}function Si(t){return t.resolvedBaseTypes||(8&t.objectFlags?t.resolvedBaseTypes=[wo(zo(t.typeParameters))]:96&t.symbol.flags?(32&t.symbol.flags&&function(t){t.resolvedBaseTypes=e.emptyArray;var n=ma(ki(t));if(!(163841&n.flags))return;var r,i=vi(t),a=so(i),o=n&&n.symbol?Fi(n.symbol):void 0;if(n.symbol&&32&n.symbol.flags&&function(e){var t=e.outerTypeParameters;if(t){var n=t.length-1,r=e.typeArguments;return t[n].symbol!==r[n].symbol}return!0}(o))r=eo(i,n.symbol,a);else if(1&n.flags)r=n;else{var s=xi(n,i.typeArguments,i);if(!s.length)return void cn(i.expression,e.Diagnostics.No_base_constructor_has_the_specified_number_of_type_arguments);r=La(s[0])}if(r===Q)return;if(!Di(r))return void cn(i.expression,e.Diagnostics.Base_constructor_return_type_0_is_not_a_class_or_interface_type,Tr(r));if(t===r||li(r,t))return void cn(t.symbol.valueDeclaration,e.Diagnostics.Type_0_recursively_references_itself_as_a_base_type,Tr(t,void 0,1));t.resolvedBaseTypes=[r]}(t),64&t.symbol.flags&&function(t){t.resolvedBaseTypes=t.resolvedBaseTypes||e.emptyArray;for(var n=0,r=t.symbol.declarations;n<r.length;n++){var i=r[n];if(230===i.kind&&e.getInterfaceBaseTypeNodes(i))for(var a=0,o=e.getInterfaceBaseTypeNodes(i);a<o.length;a++){var s=o[a],c=ds(s);c!==Q&&(Di(c)?t===c||li(c,t)?cn(i,e.Diagnostics.Type_0_recursively_references_itself_as_a_base_type,Tr(t,void 0,1)):t.resolvedBaseTypes===e.emptyArray?t.resolvedBaseTypes=[c]:t.resolvedBaseTypes.push(c):cn(s,e.Diagnostics.An_interface_may_only_extend_a_class_or_another_interface))}}}(t)):e.Debug.fail("type must be class or interface")),t.resolvedBaseTypes}function Di(t){return 16809985&t.flags&&!ra(t)||131072&t.flags&&!e.forEach(t.types,(function(e){return!Di(e)}))}function Ci(t){var n=gn(t);if(!n.declaredType){var r=32&t.flags?1:2,i=n.declaredType=sr(r,t),a=fi(t),o=mi(t);(a||o||1===r||!function(t){for(var n=0,r=t.declarations;n<r.length;n++){var i=r[n];if(230===i.kind){if(64&i.flags)return!1;var a=e.getInterfaceBaseTypeNodes(i);if(a)for(var o=0,s=a;o<s.length;o++){var c=s[o];if(e.isEntityNameExpression(c.expression)){var u=jn(c.expression,793064,!0);if(!u||!(64&u.flags)||Ci(u).thisType)return!1}}}}return!0}(t))&&(i.objectFlags|=4,i.typeParameters=e.concatenate(a,o),i.outerTypeParameters=a,i.localTypeParameters=o,i.instantiations=e.createMap(),i.instantiations.set(Qa(i.typeParameters),i),i.target=i,i.typeArguments=i.typeParameters,i.thisType=ar(16384),i.thisType.isThisType=!0,i.thisType.symbol=t,i.thisType.constraint=i)}return n.declaredType}function Ti(t){var n=t.initializer;if(!n)return!e.isInAmbientContext(t);switch(n.kind){case 9:case 8:return!0;case 192:return 38===n.operator&&8===n.operand.kind;case 71:return e.nodeIsMissing(n)||!!er(t.parent).exports.get(n.escapedText);default:return!1}}function Ei(e){var t=gn(e);if(void 0!==t.enumKind)return t.enumKind;for(var n=!1,r=0,i=e.declarations;r<i.length;r++){var a=i[r];if(232===a.kind)for(var o=0,s=a.members;o<s.length;o++){var c=s[o];if(c.initializer&&9===c.initializer.kind)return t.enumKind=1;Ti(c)||(n=!0)}}return t.enumKind=n?0:1}function Ni(e){return 256&e.flags&&!(65536&e.flags)?Fi(tr(e.symbol)):e}function Ai(e){var t=gn(e);if(t.declaredType)return t.declaredType;if(1===Ei(e)){v++;for(var n=[],r=0,i=e.declarations;r<i.length;r++){var a=i[r];if(232===a.kind)for(var o=0,s=a.members;o<s.length;o++){var c=s[o],u=_s(zf(c),v,er(c));gn(er(c)).declaredType=u,n.push(u)}}if(n.length){var _=zo(n,!1,e,void 0);return 65536&_.flags&&(_.flags|=256,_.symbol=e),t.declaredType=_}}var l=ar(16);return l.symbol=e,t.declaredType=l}function wi(e){var t=gn(e);if(!t.declaredType){var n=Ai(tr(e));t.declaredType||(t.declaredType=n)}return t.declaredType}function Pi(e){var t=gn(e);if(!t.declaredType){var n=ar(16384);n.symbol=e,t.declaredType=n}return t.declaredType}function Fi(e){return Oi(e)||Q}function Oi(t){return 96&t.flags?Ci(t):524288&t.flags?function(t){var n=gn(t);if(!n.declaredType){if(!Mr(t,2))return Q;var r=e.find(t.declarations,(function(e){return 283===e.kind||231===e.kind})),i=283===r.kind?r.typeExpression:r.type,a=i?ds(i):Q;if(zr()){var o=mi(t);o&&(n.typeParameters=o,n.instantiations=e.createMap(),n.instantiations.set(Qa(o),a))}else a=Q,cn(r.name,e.Diagnostics.Type_alias_0_circularly_references_itself,Dr(t));n.declaredType=a}return n.declaredType}(t):262144&t.flags?Pi(t):384&t.flags?Ai(t):8&t.flags?wi(t):2097152&t.flags?function(e){var t=gn(e);return t.declaredType||(t.declaredType=Fi(Ln(e))),t.declaredType}(t):void 0}function Ii(e){switch(e.kind){case 119:case 136:case 133:case 122:case 137:case 134:case 105:case 139:case 95:case 130:case 173:return!0;case 164:return Ii(e.elementType);case 159:return function(e){if(e.typeArguments)for(var t=0,n=e.typeArguments;t<n.length;t++)if(!Ii(n[t]))return!1;return!0}(e)}return!1}function Ri(t){var n=e.getEffectiveTypeAnnotationNode(t);return n?Ii(n):!t.initializer}function Li(t){if(t.declarations&&1===t.declarations.length){var n=t.declarations[0];if(n)switch(n.kind){case 149:case 148:return Ri(n);case 151:case 150:case 152:return function(t){if(152!==t.kind){var n=e.getEffectiveReturnTypeNode(t);if(!n||!Ii(n))return!1}for(var r=0,i=t.parameters;r<i.length;r++)if(!Ri(i[r]))return!1;return!0}(n)}}return!1}function Mi(t,n,r){for(var i=e.createSymbolTable(),a=0,o=t;a<o.length;a++){var s=o[a];i.set(s.escapedName,r&&Li(s)?s:bs(s,n))}return i}function Bi(e,t){for(var n=0,r=t;n<r.length;n++){var i=r[n];e.has(i.escapedName)||e.set(i.escapedName,i)}}function Ji(e){if(!e.declaredProperties){var t=e.symbol;e.declaredProperties=ur(t.members),e.declaredCallSignatures=Ia(t.members.get("__call")),e.declaredConstructSignatures=Ia(t.members.get("__new")),e.declaredStringIndexInfo=Wa(t,0),e.declaredNumberIndexInfo=Wa(t,1)}return e}function zi(t,n){if(4&hn(t)){var r=t.target,i=t.typeArguments;if(e.length(r.typeParameters)===e.length(i))return Ya(r,e.concatenate(i,[n||r.thisType]))}else if(131072&t.flags)return Vo(e.map(t.types,(function(e){return zi(e,n)})));return t}function ji(t,n,r,i){var a,o,s,c,u,_;e.rangeEquals(r,i,0,r.length)?(a=k,o=n.symbol?n.symbol.members:e.createSymbolTable(n.declaredProperties),s=n.declaredCallSignatures,c=n.declaredConstructSignatures,u=n.declaredStringIndexInfo,_=n.declaredNumberIndexInfo):(a=gs(r,i),o=Mi(n.declaredProperties,a,1===r.length),s=ms(n.declaredCallSignatures,a),c=ms(n.declaredConstructSignatures,a),u=Ds(n.declaredStringIndexInfo,a),_=Ds(n.declaredNumberIndexInfo,a));var l=Si(n);if(l.length){n.symbol&&o===n.symbol.members&&(o=e.createSymbolTable(n.declaredProperties));for(var d=e.lastOrUndefined(i),p=0,f=l;p<f.length;p++){var m=f[p],g=d?zi(Ss(m,a),d):m;Bi(o,sa(g)),s=e.concatenate(s,xa(g,0)),c=e.concatenate(c,xa(g,1)),u||(u=g===H?qa(H,!1):Da(g,0)),_=_||Da(g,1)}}_r(t,o,s,c,u,_)}function Ki(e,t,n,r,i,a,o,s,c){var u=new g(B);return u.declaration=e,u.typeParameters=t,u.parameters=r,u.thisParameter=n,u.resolvedReturnType=i,u.typePredicate=a,u.minArgumentCount=o,u.hasRestParameter=s,u.hasLiteralTypes=c,u}function Ui(e){return Ki(e.declaration,e.typeParameters,e.thisParameter,e.parameters,e.resolvedReturnType,e.typePredicate,e.minArgumentCount,e.hasRestParameter,e.hasLiteralTypes)}function Vi(e,t,n,r,i){for(var a=0,o=e;a<o.length;a++){var s=o[a];if(ic(s,t,n,r,i,ws))return s}}function qi(t,n,r){if(n.typeParameters){if(r>0)return;for(var i=1;i<t.length;i++)if(!Vi(t[i],n,!1,!1,!1))return;return[n]}var a=void 0;for(i=0;i<t.length;i++){var o=i===r?n:Vi(t[i],n,!0,!0,!0);if(!o)return;a=e.appendIfUnique(a,o)}return a}function Wi(t,n){for(var r=e.map(t,(function(e){return xa(e,n)})),i=void 0,a=0;a<r.length;a++)for(var o=0,s=r[a];o<s.length;o++){var c=s[o];if(!i||!Vi(i,c,!1,!0,!0)){var u=qi(r,c,a);if(u){var _=c;if(u.length>1){if(_=Ui(c),e.forEach(u,(function(e){return e.thisParameter}))){var l=zo(e.map(u,(function(e){return ci(e.thisParameter)||H})),!0);_.thisParameter=Sc(c.thisParameter,l)}_.resolvedReturnType=void 0,_.unionSignatures=u}(i||(i=[])).push(_)}}}return i||e.emptyArray}function Hi(e,t){for(var n=[],r=!1,i=0,a=e;i<a.length;i++){var o=Da(a[i],t);if(!o)return;n.push(o.type),r=r||o.isReadonly}return qa(zo(n,!0),r)}function Gi(e,t){return e?t?Vo([e,t]):e:t}function Qi(e,t){return e?t?qa(Vo([e.type,t.type]),e.isReadonly&&t.isReadonly):e:t}function Xi(e,t){return e&&t&&qa(zo([e.type,t.type]),e.isReadonly||t.isReadonly)}function Yi(t){for(var n,r,i=e.emptyArray,a=e.emptyArray,o=t.types,s=e.countWhere(o,yi),c=function(c){var u=t.types[c];if(0===s||s===o.length&&0===c||!yi(u)){var _=xa(u,1);_.length&&s>0&&(_=e.map(_,(function(e){var t=Ui(e);return t.resolvedReturnType=function(e,t,n){for(var r=[],i=0;i<t.length;i++)i===n?r.push(e):yi(t[i])&&r.push(La(xa(t[i],1)[0]));return Vo(r)}(La(e),o,c),t}))),a=e.concatenate(a,_)}i=e.concatenate(i,xa(u,0)),n=Qi(n,Da(u,0)),r=Qi(r,Da(u,1))},u=0;u<o.length;u++)c(u);_r(t,x,i,a,n,r)}function Zi(t){var n=t.symbol;if(t.target)_r(t,a=Mi(aa(t.target),t.mapper,!1),r=ms(xa(t.target,0),t.mapper),i=ms(xa(t.target,1),t.mapper),o=Ds(Da(t.target,0),t.mapper),c=Ds(Da(t.target,1),t.mapper));else if(2048&n.flags){var r=Ia((a=n.members).get("__call")),i=Ia(a.get("__new"));_r(t,a,r,i,o=Wa(n,0),c=Wa(n,1))}else{var a=x,o=void 0;if(n.exports&&(a=Xn(n)),32&n.flags){var s=ki(u=Ci(n));704512&s.flags?Bi(a=e.createSymbolTable(ur(a)),sa(s)):s===H&&(o=qa(H,!1))}var c=384&n.flags?it:void 0;if(_r(t,a,e.emptyArray,e.emptyArray,o,c),8208&n.flags&&(t.callSignatures=Ia(n)),32&n.flags){var u=Ci(n);(i=Ia(n.members.get("__constructor"))).length||(i=function(t){var n=xa(ki(t),1);if(0===n.length)return[Ki(void 0,t.localTypeParameters,void 0,e.emptyArray,t,void 0,0,!1,!1)];for(var r=vi(t),i=e.isInJavaScriptFile(r),a=so(r),o=e.length(a),s=[],c=0,u=n;c<u.length;c++){var _=u[c],l=Pa(_.typeParameters),d=e.length(_.typeParameters);if((i||o>=l)&&o<=d){var p=d?Ja(_,Fa(a,_.typeParameters,l,i)):Ui(_);p.typeParameters=t.localTypeParameters,p.resolvedReturnType=t,s.push(p)}}return s}(u)),t.constructSignatures=i}}}function $i(t){var n,r=e.createSymbolTable();_r(t,x,e.emptyArray,e.emptyArray,void 0,void 0);var i=ea(t),a=ta(t),o=na(t),s=ma(function(e){if(!e.modifiersType){var t=e.declaration.typeParameter.constraint;if(170===t.kind)e.modifiersType=Ss(ds(t.type),e.mapper||k);else{var n=ta(es(e.declaration)),r=n&&16384&n.flags?ca(n):n;e.modifiersType=r&&262144&r.flags?Ss(r.type,e.mapper||k):_e}}return e.modifiersType}(t)),c=!!t.declaration.readonlyToken,u=!!t.declaration.questionToken;if(170===t.declaration.typeParameter.constraint.kind){for(var _=0,l=sa(s);_<l.length;_++){var d=l[_];f(qo(d),d)}(1&s.flags||Da(s,0))&&f(ee)}else{var p=540672&a.flags?ma(a):a;hu(262144&p.flags?Wo(ma(p.type)):p,f)}function f(a,_){var l;"object"==typeof _&&(l=_);var d=gs([i],[a]),p=t.mapper?ys(t.mapper,d):d,f=Ss(o,p);if(32&a.flags){var m=e.escapeLeadingUnderscores(a.value),g=va(s,m),y=un(4|(u||!!(g&&16777216&g.flags)?16777216:0),m);y.checkFlags=c||g&&ed(g)?8:0,y.type=f,l&&(y.syntheticOrigin=l,y.declarations=l.declarations),y.syntheticLiteralTypeOrigin=a,r.set(m,y)}else 3&a.flags&&(n=qa(f,c))}_r(t,r,e.emptyArray,e.emptyArray,n,void 0)}function ea(e){return e.typeParameter||(e.typeParameter=Pi(er(e.declaration.typeParameter)))}function ta(e){return e.constraintType||(e.constraintType=Ss(ca(ea(e)),e.mapper||k)||Q)}function na(e){return e.templateType||(e.templateType=e.declaration.type?Ss(Xr(ds(e.declaration.type),!!e.declaration.questionToken),e.mapper||k):Q)}function ra(e){return 32&hn(e)&&Qo(ta(e))}function ia(t){return t.members||(32768&t.flags?4&t.objectFlags?function(t){var n=Ji(t.target),r=e.concatenate(n.typeParameters,[n.thisType]);ji(t,n,r,t.typeArguments&&t.typeArguments.length===r.length?t.typeArguments:e.concatenate(t.typeArguments,[t]))}(t):3&t.objectFlags?function(t){ji(t,Ji(t),e.emptyArray,e.emptyArray)}(t):16&t.objectFlags?Zi(t):32&t.objectFlags&&$i(t):65536&t.flags?function(e){var t=Wi(e.types,0),n=Wi(e.types,1),r=Hi(e.types,0),i=Hi(e.types,1);_r(e,x,t,n,r,i)}(t):131072&t.flags&&Yi(t)),t}function aa(t){return 32768&t.flags?ia(t).properties:e.emptyArray}function oa(e,t){if(32768&e.flags){var n=ia(e).members.get(t);if(n&&rr(n))return n}}function sa(t){return 196608&(t=ma(t)).flags?function(t){if(!t.resolvedProperties){for(var n=e.createSymbolTable(),r=0,i=t.types;r<i.length;r++){for(var a=0,o=sa(i[r]);a<o.length;a++){var s=o[a];if(!n.has(s.escapedName)){var c=ha(t,s.escapedName);c&&n.set(s.escapedName,c)}}if(65536&t.flags)break}t.resolvedProperties=ur(n)}return t.resolvedProperties}(t):aa(t)}function ca(e){return la(e)?Ha(e):void 0}function ua(e){var t=Yo(e);if(t)return t;var n=_a(e.objectType),r=_a(e.indexType);return n||r?Zo(n||e.objectType,r||e.indexType):void 0}function _a(e){if(737280&e.flags){var t=da(e);if(t!==me&&t!==ge)return t}else if(262144&e.flags)return ee}function la(e){return da(e)!==ge}function da(t){var n,r;if(!t.resolvedBaseConstraint){n=[];var i=a(t);t.resolvedBaseConstraint=r?ge:zi(i||me,t)}return t.resolvedBaseConstraint;function a(t){if(!e.contains(n,t)){n.push(t);var i=function(e){if(16384&e.flags){var t=Ha(e);return e.isThisType?t:t?a(t):void 0}if(196608&e.flags){for(var n=e.types,r=[],i=0,o=n;i<o.length;i++){var s=a(o[i]);s&&r.push(s)}return 65536&e.flags&&r.length===n.length?zo(r):131072&e.flags&&r.length?Vo(r):void 0}if(262144&e.flags)return ee;if(524288&e.flags){var c=Yo(e);if(c)return a(c);var u=a(e.objectType),_=a(e.indexType),l=u&&_?Zo(u,_):void 0;return l&&l!==Q?a(l):void 0}if(ra(e))return _e;return e}(t);return n.pop(),i}r=!0}}function pa(t){if(t.default)t.default===ye&&(t.default=ge);else if(t.target){var n=pa(t.target);t.default=n?Ss(n,t.mapper):me}else{t.default=ye;var r=t.symbol&&e.forEach(t.symbol.declarations,(function(t){return e.isTypeParameterDeclaration(t)&&t.default})),i=r?ds(r):me;t.default===ye&&(t.default=i)}return t.default}function fa(e){var t=pa(e);return t!==me&&t!==ge?t:void 0}function ma(e){var t=540672&e.flags?_a(e)||_e:e;return 131072&t.flags?function(e){return e.resolvedApparentType||(e.resolvedApparentType=zi(e,e))}(t):262178&t.flags?Te:84&t.flags?Ee:136&t.flags?Ne:512&t.flags?fo(D>=2):16777216&t.flags?_e:t}function ga(t,n){for(var r,i=t.types,a=65536&t.flags,o=a?24:0,s=a?0:16777216,c=4,u=0,_=0,l=i;_<l.length;_++){if((v=ma(l[_]))!==Q){var d=(h=va(v,n))?e.getDeclarationModifierFlagsFromSymbol(h):0;!h||d&o?a&&(u|=16):(s&=h.flags,r=e.appendIfUnique(r,h),u|=(ed(h)?8:0)|(24&d?0:64)|(16&d?128:0)|(8&d?256:0)|(32&d?512:0),K_(h)||(c=2))}}if(r){if(1===r.length&&!(16&u))return r[0];for(var p=[],f=[],m=void 0,g=0,y=r;g<y.length;g++){var h;(h=y[g]).declarations&&e.addRange(f,h.declarations);var v=ci(h);m?v!==m&&(u|=32):m=v,p.push(v)}var b=un(4|s,n);return b.checkFlags=c|u,b.containingType=t,b.declarations=f,b.type=a?zo(p):Vo(p),b}}function ya(t,n){var r=t.propertyCache||(t.propertyCache=e.createSymbolTable()),i=r.get(n);return i||(i=ga(t,n))&&r.set(n,i),i}function ha(t,n){var r=ya(t,n);return!r||16&e.getCheckFlags(r)?void 0:r}function va(e,t){if(32768&(e=ma(e)).flags){var n=ia(e),r=n.members.get(t);if(r&&rr(r))return r;if(n===fe||n.callSignatures.length||n.constructSignatures.length){var i=oa(Se,t);if(i)return i}return oa(ke,t)}if(196608&e.flags)return ha(e,t)}function ba(t,n){if(229376&t.flags){var r=ia(t);return 0===n?r.callSignatures:r.constructSignatures}return e.emptyArray}function xa(e,t){return ba(ma(e),t)}function ka(e,t){if(229376&e.flags){var n=ia(e);return 0===t?n.stringIndexInfo:n.numberIndexInfo}}function Sa(e,t){var n=ka(e,t);return n&&n.type}function Da(e,t){return ka(ma(e),t)}function Ca(e,t){return Sa(ma(e),t)}function Ta(e,t){if(kc(e)){for(var n=[],r=0,i=sa(e);r<i.length;r++){var a=i[r];(0===t||v_(a.escapedName))&&n.push(ci(a))}if(n.length)return zo(n,!0)}}function Ea(e){var t=[];return e.forEach((function(e,n){cr(n)||t.push(e)})),t}function Na(t){if(e.isInJavaScriptFile(t)){if(t.type&&272===t.type.kind)return!0;var n=e.getJSDocParameterTags(t);if(n)for(var r=0,i=n;r<i.length;r++){var a=i[r];if(a.isBracketed)return!0;if(a.typeExpression)return 272===a.typeExpression.type.kind}}}function Aa(t,n){if(!e.isExternalModuleNameRelative(t)){var r=bn(ot,'"'+t+'"',512);return r&&n?$n(r):r}}function wa(t){if(e.hasQuestionToken(t)||Na(t))return!0;if(t.initializer){var n=t.parent,r=Oa(n),i=e.indexOf(n.parameters,t);return e.Debug.assert(i>=0),i>=r.minArgumentCount}var a=e.getImmediatelyInvokedFunctionExpression(t.parent);return!!a&&(!t.type&&!t.dotDotDotToken&&e.indexOf(t.parent.parameters,t)>=a.arguments.length)}function Pa(t){var n,r=0;if(t)for(var i=0;i<t.length;i++)(n=t[i]).symbol&&e.forEach(n.symbol.declarations,(function(t){return e.isTypeParameterDeclaration(t)&&t.default}))||(r=i+1);return r}function Fa(t,n,r,i){var a=e.length(n);if(a){var o=e.length(t);if((i||o>=r)&&o<=a){t||(t=[]);for(var s=o;s<a;s++)t[s]=Kc(i);for(s=o;s<a;s++){var c=gs(n,t),u=fa(n[s]);t[s]=u?Ss(u,c):Kc(i)}}}return t}function Oa(t){var n,r,i,a=yn(t);if(!a.resolvedSignature){for(var o=[],s=!1,c=0,u=void 0,_=void 0,l=e.getImmediatelyInvokedFunctionExpression(t),d=e.isJSDocConstructSignature(t),p=!l&&!d&&e.isInJavaScriptFile(t)&&!e.hasJSDocParameterTags(t),f=d?1:0;f<t.parameters.length;f++){var m=t.parameters[f],g=m.symbol;if(g&&4&g.flags&&!e.isBindingPattern(m.name))g=kn(m,g.escapedName,107455,void 0,void 0,!1);0===f&&"this"===g.escapedName?(_=!0,u=m.symbol):o.push(g),m.type&&173===m.type.kind&&(s=!0),m.initializer||m.questionToken||m.dotDotDotToken||l&&o.length>l.arguments.length&&!m.type||Na(m)||p||(c=o.length)}if(!(153!==t.kind&&154!==t.kind||e.hasDynamicName(t)||_&&u)){var y=153===t.kind?154:153,h=e.getDeclarationOfKind(t.symbol,y);h&&(u=(i=mm(h))&&i.symbol)}var v=152===t.kind?Ci($n(t.parent.symbol)):void 0,b=v?v.localTypeParameters:function(t){var n;return e.forEach(e.getEffectiveTypeParameterDeclarations(t),(function(t){var r=Pi(t.symbol);n=e.appendIfUnique(n,r)})),n}(t),x=function(t,n,r){if(n)return ds(t.parameters[0].type);if(r)return r;var i=e.getEffectiveReturnTypeNode(t);if(i)return ds(i);if(153===t.kind&&!e.hasDynamicName(t)){return ri(e.getDeclarationOfKind(t.symbol,154))}if(e.nodeIsMissing(t.body))return H}(t,d,v),k=t.type&&158===t.type.kind?(n=t.type,71===(r=n.parameterName).kind?{kind:1,parameterName:r?r.escapedText:void 0,parameterIndex:r?wd(n.parent.parameters,r):void 0,type:ds(n.type)}:{kind:0,type:ds(n.type)}):void 0,S=e.hasRestParameter(t);if(!S&&e.isInJavaScriptFile(t)&&function(t){var n=yn(t);void 0===n.containsArgumentsReference&&(8192&n.flags?n.containsArgumentsReference=!0:n.containsArgumentsReference=r(t.body));return n.containsArgumentsReference;function r(t){if(!t)return!1;switch(t.kind){case 71:return"arguments"===t.escapedText&&e.isPartOfExpression(t);case 149:case 151:case 153:case 154:return 144===t.name.kind&&r(t.name);default:return!e.nodeStartsNewLexicalEnvironment(t)&&!e.isPartOfTypeNode(t)&&e.forEachChild(t,r)}}}(t)){S=!0;var D=un(3,"args");D.type=Pe,D.isRestParameter=!0,o.push(D)}a.resolvedSignature=Ki(t,b,u,o,x,k,c,S,s)}return a.resolvedSignature}function Ia(t){if(!t)return e.emptyArray;for(var n=[],r=0;r<t.declarations.length;r++){var i=t.declarations[r];switch(i.kind){case 160:case 161:case 228:case 151:case 150:case 152:case 155:case 156:case 157:case 153:case 154:case 186:case 187:case 273:if(r>0&&i.body){var a=t.declarations[r-1];if(i.parent===a.parent&&i.kind===a.kind&&i.pos===a.end)break}n.push(Oa(i))}}return n}function Ra(e){if(e.thisParameter)return ci(e.thisParameter)}function La(t){if(!t.resolvedReturnType){if(!Mr(t,3))return Q;var n=void 0;if(n=t.target?Ss(La(t.target),t.mapper):t.unionSignatures?zo(e.map(t.unionSignatures,La),!0):Wl(t.declaration),!zr()&&(n=H,w)){var r=t.declaration,i=e.getNameOfDeclaration(r);i?cn(i,e.Diagnostics._0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions,e.declarationNameToString(i)):cn(r,e.Diagnostics.Function_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions)}t.resolvedReturnType=n}return t.resolvedReturnType}function Ma(t){if(t.hasRestParameter){var n=ci(e.lastOrUndefined(t.parameters));if(4&hn(n)&&n.target===De)return n.typeArguments[0]}return H}function Ba(t,n,r){n=Fa(n,t.typeParameters,Pa(t.typeParameters),r);var i=t.instantiations||(t.instantiations=e.createMap()),a=Qa(n),o=i.get(a);return o||i.set(a,o=Ja(t,n)),o}function Ja(e,t){return vs(e,gs(e.typeParameters,t),!0)}function za(e){return e.typeParameters?e.erasedSignatureCache||(e.erasedSignatureCache=function(e){return vs(e,(t=e.typeParameters,gs(t,void 0)),!0);var t}(e)):e}function ja(t){return t.typeParameters?t.canonicalSignatureCache||(t.canonicalSignatureCache=function(t){return Ba(t,e.map(t.typeParameters,(function(e){return e.target&&!ca(e.target)?e.target:e})),e.isInJavaScriptFile(t.declaration))}(t)):t}function Ka(t){if(!t.isolatedSignatureType){var n=152===t.declaration.kind||156===t.declaration.kind,r=sr(16);r.members=x,r.properties=e.emptyArray,r.callSignatures=n?e.emptyArray:[t],r.constructSignatures=n?[t]:e.emptyArray,t.isolatedSignatureType=r}return t.isolatedSignatureType}function Ua(e){return e.members.get("__index")}function Va(e,t){var n=1===t?133:136,r=Ua(e);if(r)for(var i=0,a=r.declarations;i<a.length;i++){var o=a[i];if(1===o.parameters.length){var s=o.parameters[0];if(s&&s.type&&s.type.kind===n)return o}}}function qa(e,t,n){return{type:e,isReadonly:t,declaration:n}}function Wa(t,n){var r=Va(t,n);if(r)return qa(r.type?ds(r.type):H,e.hasModifier(r,64),r)}function Ha(t){if(!t.constraint)if(t.target){var n=ca(t.target);t.constraint=n?Ss(n,t.mapper):me}else{var r=function(t){return t.symbol&&e.getDeclarationOfKind(t.symbol,145).constraint}(t);t.constraint=r?ds(r):me}return t.constraint===me?void 0:t.constraint}function Ga(t){return er(e.getDeclarationOfKind(t.symbol,145).parent)}function Qa(e){var t="";if(e)for(var n=e.length,r=0;r<n;){for(var i=e[r].id,a=1;r+a<n&&e[r+a].id===i+a;)a++;t.length&&(t+=","),t+=i,a>1&&(t+=":"+a),r+=a}return t}function Xa(e,t){for(var n=0,r=0,i=e;r<i.length;r++){var a=i[r];a.flags&t||(n|=a.flags)}return 14680064&n}function Ya(e,t){var n=Qa(t),r=e.instantiations.get(n);return r||(r=sr(4,e.symbol),e.instantiations.set(n,r),r.flags|=t?Xa(t,0):0,r.target=e,r.typeArguments=t),r}function Za(e){var t=ar(e.flags);return t.symbol=e.symbol,t.objectFlags=e.objectFlags,t.target=e.target,t.typeArguments=e.typeArguments,t}function $a(t){return e.length(t.target.typeParameters)}function eo(t,n,r){var i=Fi($n(n)),a=i.localTypeParameters;if(a){var o=e.length(t.typeArguments),s=Pa(a),c=e.isInJavaScriptFile(t);return!c&&(o<s||o>a.length)?(cn(t,s===a.length?e.Diagnostics.Generic_type_0_requires_1_type_argument_s:e.Diagnostics.Generic_type_0_requires_between_1_and_2_type_arguments,Tr(i,void 0,1),s,a.length),Q):Ya(i,e.concatenate(i.outerTypeParameters,Fa(r,a,s,c)))}return t.typeArguments?(cn(t,e.Diagnostics.Type_0_is_not_generic,Tr(i)),Q):i}function to(t,n,r){var i=Fi(n),a=gn(n).typeParameters;if(a){var o=e.length(t.typeArguments),s=Pa(a);return o<s||o>a.length?(cn(t,s===a.length?e.Diagnostics.Generic_type_0_requires_1_type_argument_s:e.Diagnostics.Generic_type_0_requires_between_1_and_2_type_arguments,Dr(n),s,a.length),Q):function(t,n){var r=Fi(t),i=gn(t),a=i.typeParameters,o=Qa(n),s=i.instantiations.get(o);return s||i.instantiations.set(o,s=Ss(r,gs(a,Fa(n,a,Pa(a),e.isInJavaScriptFile(t.valueDeclaration))))),s}(n,r)}return t.typeArguments?(cn(t,e.Diagnostics.Type_0_is_not_generic,Dr(n)),Q):i}function no(t){switch(t.kind){case 159:return t.typeName;case 201:var n=t.expression;if(e.isEntityNameExpression(n))return n}}function ro(e,t){return e&&jn(e,t)||q}function io(t,n,r){return 96&n.flags?eo(t,n,r):524288&n.flags?to(t,n,r):16&n.flags&&ao(t)&&(n.members||e.getJSDocClassTag(n.valueDeclaration))?Ol(n):void 0}function ao(e){return 1048576&e.flags&&159===e.kind}function oo(t){var n=yn(t);if(!n.resolvedType){var r=void 0,i=void 0,a=793064;ao(t)&&(i=function(t){if(e.isIdentifier(t.typeName)){if("Object"===t.typeName.escapedText){if(e.isJSDocIndexSignature(t)){var n=ds(t.typeArguments[0]),r=qa(ds(t.typeArguments[1]),!1);return lr(void 0,x,e.emptyArray,e.emptyArray,n===ee&&r,n===te&&r)}return H}switch(t.typeName.escapedText){case"String":return ee;case"Number":return te;case"Boolean":return ie;case"Void":return oe;case"Undefined":return X;case"Null":return Z;case"Function":case"function":return Se;case"Array":case"array":return t.typeArguments&&t.typeArguments.length?void 0:Pe;case"Promise":case"promise":return t.typeArguments&&t.typeArguments.length?void 0:Vl(H)}}}(t),a|=107455),i||(i=function(t,n){var r=so(t);if(n===q)return Q;var i=io(t,n,r);if(i)return i;var a=Oi(n);if(void 0!==a)return r?(cn(t,e.Diagnostics.Type_0_is_not_generic,Dr(n)),Q):a;if(!(107455&n.flags&&ao(t)))return Q;var o=ci(n);if(o.symbol&&!Il(o)){var s=io(t,o.symbol,r);if(s)return s}return ro(no(t),793064),o}(t,r=ro(no(t),a))),n.resolvedSymbol=r,n.resolvedType=i}return n.resolvedType}function so(t){return e.map(t.typeArguments,ds)}function co(e){var t=yn(e);return t.resolvedType||(t.resolvedType=Ec(Ed(e.exprName))),t.resolvedType}function uo(t,n){function r(e){for(var t=0,n=e.declarations;t<n.length;t++){var r=n[t];switch(r.kind){case 229:case 230:case 232:return r}}}if(!t)return n?pe:_e;var i=Fi(t);return 32768&i.flags?e.length(i.typeParameters)!==n?(cn(r(t),e.Diagnostics.Global_type_0_must_have_1_type_parameter_s,e.symbolName(t),n),n?pe:_e):i:(cn(r(t),e.Diagnostics.Global_type_0_must_be_a_class_or_interface_type,e.symbolName(t)),n?pe:_e)}function _o(t,n){return lo(t,107455,n?e.Diagnostics.Cannot_find_global_value_0:void 0)}function lo(e,t,n){return kn(void 0,e,t,n,e,!1)}function po(t,n,r){var i=function(t,n){return lo(t,793064,n?e.Diagnostics.Cannot_find_global_type_0:void 0)}(t,r);return i||r?uo(i,n):void 0}function fo(e){return Re||(Re=po("Symbol",0,e))||_e}function mo(e){return Me||(Me=po("Promise",1,e))||pe}function go(e){return Be||(Be=_o("Promise",e))}function yo(e){return Ue||(Ue=po("AsyncIterable",1,e))||pe}function ho(e){return Ve||(Ve=po("AsyncIterator",1,e))||pe}function vo(e){return qe||(qe=po("AsyncIterableIterator",1,e))||pe}function bo(e){return ze||(ze=po("Iterable",1,e))||pe}function xo(e){return je||(je=po("Iterator",1,e))||pe}function ko(e){return Ke||(Ke=po("IterableIterator",1,e))||pe}function So(e,t){void 0===t&&(t=0);var n=lo(e,793064,void 0);return n&&uo(n,t)}function Do(e,t){var n=lo(e,1920,void 0),r=n&&bn(n.exports,t,793064);return r&&Fi(r)}function Co(e,t){return e!==pe?Ya(e,t):_e}function To(e){return Co(Le||(Le=po("TypedPropertyDescriptor",1,!0))||pe,[e])}function Eo(e){return Co(vo(!0),[e])}function No(e){return Co(bo(!0),[e])}function Ao(e){return Co(ko(!0),[e])}function wo(e){return Co(De,[e])}function Po(t){return J[t]||(J[t]=function(t){for(var n=[],r=[],i=0;i<t;i++){var a=ar(16384);n.push(a);var o=un(4,""+i);o.type=a,r.push(o)}var s=sr(12);return s.typeParameters=n,s.outerTypeParameters=void 0,s.localTypeParameters=n,s.instantiations=e.createMap(),s.instantiations.set(Qa(s.typeParameters),s),s.target=s,s.typeArguments=s.typeParameters,s.thisType=ar(16384),s.thisType.isThisType=!0,s.thisType.constraint=s,s.declaredProperties=r,s.declaredCallSignatures=e.emptyArray,s.declaredConstructSignatures=e.emptyArray,s.declaredStringIndexInfo=void 0,s.declaredNumberIndexInfo=void 0,s}(t))}function Fo(e){return Ya(Po(e.length),e)}function Oo(e,t){for(var n=0,r=e.length-1,i=t.id;n<=r;){var a=n+(r-n>>1),o=e[a].id;if(o===i)return a;o>i?r=a-1:n=a+1}return~n}function Io(e,t){return Oo(e,t)>=0}function Ro(e,t){var n=t.flags;if(65536&n)Lo(e,t.types);else if(1&n)e.containsAny=!0;else if(!N&&6144&n)2048&n&&(e.containsUndefined=!0),4096&n&&(e.containsNull=!0),2097152&n||(e.containsNonWideningType=!0);else if(!(8192&n||131072&n&&function(e){for(var t=0,n=0,r=e.types;n<r.length;n++){var i=r[n];if(6368&i.flags&&6368&t)return!0;if(6144&(t|=i.flags)&&16809984&t)return!0}return!1}(t))){2&n&&(e.containsString=!0),4&n&&(e.containsNumber=!0),96&n&&(e.containsStringOrNumberLiteral=!0);var r=e.length,i=r&&t.id>e[r-1].id?~r:Oo(e,t);i<0&&(32768&n&&16&t.objectFlags&&t.symbol&&8208&t.symbol.flags&&Mo(e,t)||e.splice(~i,0,t))}}function Lo(e,t){for(var n=0,r=t;n<r.length;n++){Ro(e,r[n])}}function Mo(e,t){for(var n=0,r=e;n<r.length;n++){if(As(r[n],t))return!0}return!1}function Bo(e,t){for(var n=0,r=t;n<r.length;n++){var i=r[n];if(e!==i&&Fs(e,i))return!0}return!1}function Jo(t){if(0!==t.length&&!function(e){var t=e[0];if(256&t.flags){for(var n=tr(t.symbol),r=1;r<e.length;r++){var i=e[r];if(!(256&i.flags)||n!==tr(i.symbol))return!1}return!0}return!1}(t))for(var n=t.length;n>0;)Bo(t[--n],t)&&e.orderedRemoveItemAt(t,n)}function zo(t,n,r,i){if(0===t.length)return se;if(1===t.length)return t[0];var a=[];return Lo(a,t),a.containsAny?H:(n?Jo(a):a.containsStringOrNumberLiteral&&function(t){for(var n=t.length;n>0;){var r=t[--n];(32&r.flags&&t.containsString||64&r.flags&&t.containsNumber||96&r.flags&&1048576&r.flags&&Io(t,r.regularType))&&e.orderedRemoveItemAt(t,n)}}(a),0===a.length?a.containsNull?a.containsNonWideningType?Z:$:a.containsUndefined?a.containsNonWideningType?X:Y:se:jo(a,r,i))}function jo(e,t,n){if(0===e.length)return se;if(1===e.length)return e[0];var r=Qa(e),i=z.get(r);i||(i=ar(65536|Xa(e,6144)),z.set(r,i),i.types=e,i.aliasSymbol=t,i.aliasTypeArguments=n);return i}function Ko(t,n){131072&n.flags?Uo(t,n.types):1&n.flags?t.containsAny=!0:8192&n.flags?t.containsNever=!0:16&hn(n)&&js(n)?t.containsEmptyObject=!0:!N&&6144&n.flags||e.contains(t,n)||(32768&n.flags&&(t.containsObjectType=!0),65536&n.flags&&void 0===t.unionIndex&&(t.unionIndex=t.length),32768&n.flags&&16&n.objectFlags&&n.symbol&&8208&n.symbol.flags&&Mo(t,n)||t.push(n))}function Uo(e,t){for(var n=0,r=t;n<r.length;n++){Ko(e,r[n])}}function Vo(t,n,r){if(0===t.length)return _e;var i=[];if(Uo(i,t),i.containsNever)return se;if(i.containsAny)return H;if(i.containsEmptyObject&&!i.containsObjectType&&i.push(_e),1===i.length)return i[0];var a=i.unionIndex;if(void 0!==a){var o=i[a];return zo(e.map(o.types,(function(t){return Vo(e.replaceElement(i,a,t))})),!1,n,r)}var s=Qa(i),c=j.get(s);c||(c=ar(131072|Xa(i,6144)),j.set(s,c),c.types=i,c.aliasSymbol=n,c.aliasTypeArguments=r);return c}function qo(t){return 24&e.getDeclarationModifierFlagsFromSymbol(t)||e.startsWith(t.escapedName,"__@")?se:_s(e.symbolName(t))}function Wo(t){return id(t,540672)?function(e){return e.resolvedIndexType||(e.resolvedIndexType=ar(262144),e.resolvedIndexType.type=e),e.resolvedIndexType}(t):32&hn(t)?ta(t):1&t.flags||Da(t,0)?ee:function(t){return zo(e.map(sa(t),qo))}(t)}function Ho(t,n,r,i){var a=r&&180===r.kind?r:void 0,o=96&n.flags?e.escapeLeadingUnderscores(""+n.value):a&&il(a.argumentExpression,n,!1)?e.getPropertyNameForKnownSymbolName(e.idText(a.argumentExpression.name)):void 0;if(void 0!==o){var s=va(t,o);if(s){if(a){if(e.isAssignmentTarget(a)&&(td(a,s)||nd(a)))return cn(a.argumentExpression,e.Diagnostics.Cannot_assign_to_0_because_it_is_a_constant_or_a_read_only_property,Dr(s)),Q;i&&(yn(r).resolvedSymbol=s)}return ci(s)}}if(!(6144&n.flags)&&ad(n,262774)){if(Ur(t))return H;var c=ad(n,84)&&Da(t,1)||Da(t,0)||void 0;if(c)return a&&c.isReadonly&&(e.isAssignmentTarget(a)||e.isDeleteTarget(a))&&cn(a,e.Diagnostics.Index_signature_in_type_0_only_permits_reading,Tr(t)),c.type;if(a&&!od(t))return w&&!S.suppressImplicitAnyIndexErrors&&(Ca(t,1)?cn(a.argumentExpression,e.Diagnostics.Element_implicitly_has_an_any_type_because_index_expression_is_not_of_type_number):cn(a,e.Diagnostics.Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature,Tr(t))),H}if(r){var u=180===r.kind?r.argumentExpression:r.indexType;return 96&n.flags?cn(u,e.Diagnostics.Property_0_does_not_exist_on_type_1,""+n.value,Tr(t)):6&n.flags?cn(u,e.Diagnostics.Type_0_has_no_matching_index_signature_for_type_1,Tr(t),Tr(n)):cn(u,e.Diagnostics.Type_0_cannot_be_used_as_an_index_type,Tr(n)),Q}return H}function Go(t){return!!(540672&t.flags)||(32&hn(t)?Qo(ta(t)):!!(196608&t.flags)&&e.forEach(t.types,Go))}function Qo(t){return!!(802816&t.flags)||!!(196608&t.flags)&&e.forEach(t.types,Qo)}function Xo(e){if(32768&e.flags&&!ra(e)){var t=ia(e);return 0===t.properties.length&&0===t.callSignatures.length&&0===t.constructSignatures.length&&t.stringIndexInfo&&!t.numberIndexInfo}return!1}function Yo(t){var n=t.objectType;if(131072&n.flags&&Go(n)&&e.some(n.types,Xo)){for(var r=[],i=[],a=0,o=n.types;a<o.length;a++){var s=o[a];Xo(s)?i.push(Ca(s,0)):r.push(s)}return zo([Zo(Vo(r),t.indexType),Vo(i)])}if(ra(n)){var c=gs([ea(n)],[t.indexType]),u=n.mapper,_=u?ys(u,c):c;return Ss(na(n),_)}}function Zo(e,t,n){if(Qo(t)||(!n||180!==n.kind)&&Go(e)){if(1&e.flags)return e;var r=e.id+","+t.id,i=U.get(r);return i||U.set(r,i=function(e,t){var n=ar(524288);return n.objectType=e,n.indexType=t,n}(e,t)),i}var a=ma(e);if(65536&t.flags&&!(8&t.flags)){for(var o=[],s=0,c=t.types;s<c.length;s++){var u=Ho(a,c[s],n,!1);if(u===Q)return Q;o.push(u)}return zo(o)}return Ho(a,t,n,!0)}function $o(e){var t=yn(e);return t.resolvedType||(t.resolvedType=Zo(ds(e.objectType),ds(e.indexType),e)),t.resolvedType}function es(e){var t=yn(e);if(!t.resolvedType){var n=sr(32,e.symbol);n.declaration=e,n.aliasSymbol=ns(e),n.aliasTypeArguments=rs(e),t.resolvedType=n,ta(n)}return t.resolvedType}function ts(t){var n=yn(t);if(!n.resolvedType){var r=ns(t);if(0!==t.symbol.members.size||r){var i=sr(16,t.symbol);i.aliasSymbol=r,i.aliasTypeArguments=rs(t),e.isJSDocTypeLiteral(t)&&t.isArrayType&&(i=wo(i)),n.resolvedType=i}else n.resolvedType=de}return n.resolvedType}function ns(e){return 231===e.parent.kind?er(e.parent):void 0}function rs(e){var t=ns(e);return t?mi(t):void 0}function is(t,n,r,i){if(1&t.flags||1&n.flags)return H;if(8192&t.flags)return n;if(8192&n.flags)return t;if(65536&t.flags)return bu(t,(function(e){return is(e,n,r,i)}));if(65536&n.flags)return bu(n,(function(e){return is(t,e,r,i)}));if(16777216&n.flags)return ue;if(262654&n.flags)return t;var a,o,s=e.createSymbolTable(),c=e.createUnderscoreEscapedMap();t===_e?(a=Da(n,0),o=Da(n,1)):(a=Xi(Da(t,0),Da(n,0)),o=Xi(Da(t,1),Da(n,1)));for(var u=0,_=sa(n);u<_.length;u++){var l=65536&(m=_[u]).flags&&!(32768&m.flags);24&e.getDeclarationModifierFlagsFromSymbol(m)?c.set(m.escapedName,!0):os(m)||l||s.set(m.escapedName,as(m))}for(var d=0,p=sa(t);d<p.length;d++){var f=p[d];if(!(65536&f.flags&&!(32768&f.flags)||c.has(f.escapedName)||os(f)))if(s.has(f.escapedName)){var m,g=ci(m=s.get(f.escapedName));if(16777216&m.flags){var y=e.concatenate(f.declarations,m.declarations),h=un(4|16777216&f.flags,f.escapedName);h.type=zo([ci(f),nu(g,131072)]),h.leftSpread=f,h.rightSpread=m,h.declarations=y,s.set(f.escapedName,h)}}else s.set(f.escapedName,as(f))}var v=lr(void 0,s,e.emptyArray,e.emptyArray,a,o);return v.flags|=i,v.flags|=5242880,v.objectFlags|=128,v.symbol=r,v}function as(e){if(!ed(e))return e;var t=un(4|16777216&e.flags,e.escapedName);return t.type=ci(e),t.declarations=e.declarations,t.syntheticOrigin=e,t}function os(t){return 8192&t.flags&&e.find(t.declarations,(function(t){return e.isClassLike(t.parent)}))}function ss(e,t,n){var r=ar(e);return r.symbol=n,r.value=t,r}function cs(e){if(96&e.flags&&!(1048576&e.flags)){if(!e.freshType){var t=ss(1048576|e.flags,e.value,e.symbol);t.regularType=e,e.freshType=t}return e.freshType}return e}function us(e){return 96&e.flags&&1048576&e.flags?e.regularType:e}function _s(e,t,n){var r="number"==typeof e?"#":"@",i=t?t+r+e:r+e,a=K.get(i);if(!a){var o=("number"==typeof e?64:32)|(t?256:0);K.set(i,a=ss(o,e,n))}return a}function ls(t){var n=yn(t);return n.resolvedType||(n.resolvedType=function(t){var n=e.getThisContainer(t,!1),r=n&&n.parent;return!r||!e.isClassLike(r)&&230!==r.kind||e.hasModifier(n,32)||152===n.kind&&!e.isNodeDescendantOf(t,n.body)?(cn(t,e.Diagnostics.A_this_type_is_available_only_in_a_non_static_member_of_a_class_or_interface),Q):Ci(er(r)).thisType}(t)),n.resolvedType}function ds(t){switch(t.kind){case 119:case 268:case 269:return H;case 136:return ee;case 133:return te;case 122:return ie;case 137:return ae;case 105:return oe;case 139:return X;case 95:return Z;case 130:return se;case 134:return 65536&t.flags?H:ue;case 169:case 99:return ls(t);case 173:return function(e){var t=yn(e);return t.resolvedType||(t.resolvedType=us(Ed(e.literal))),t.resolvedType}(t);case 159:return oo(t);case 158:return ie;case 201:return oo(t);case 162:return co(t);case 164:return function(e){var t=yn(e);return t.resolvedType||(t.resolvedType=wo(ds(e.elementType))),t.resolvedType}(t);case 165:return function(t){var n=yn(t);return n.resolvedType||(n.resolvedType=Fo(e.map(t.elementTypes,ds))),n.resolvedType}(t);case 166:return function(t){var n=yn(t);return n.resolvedType||(n.resolvedType=zo(e.map(t.types,ds),!1,ns(t),rs(t))),n.resolvedType}(t);case 167:return function(t){var n=yn(t);return n.resolvedType||(n.resolvedType=Vo(e.map(t.types,ds),ns(t),rs(t))),n.resolvedType}(t);case 270:return function(e){var t=ds(e.type);return N?zo([t,Z]):t}(t);case 168:case 271:case 272:case 267:return ds(t.type);case 160:case 161:case 163:case 285:case 273:return ts(t);case 170:return function(e){var t=yn(e);return t.resolvedType||(t.resolvedType=Wo(ds(e.type))),t.resolvedType}(t);case 171:return $o(t);case 172:return es(t);case 71:case 143:var n=bf(t);return n&&Fi(n);case 274:return function(e){var t=yn(e);if(!t.resolvedType){var n=ds(e.type);t.resolvedType=n?wo(n):Q}return t.resolvedType}(t);default:return Q}}function ps(e,t,n){if(e&&e.length){for(var r=[],i=0,a=e;i<a.length;i++){var o=a[i];r.push(n(o,t))}return r}return e}function fs(e,t){return ps(e,t,Ss)}function ms(e,t){return ps(e,t,vs)}function gs(t,n){return e.Debug.assert(void 0===n||t.length===n.length),1===t.length?(s=t[0],c=n?n[0]:H,function(e){return e===s?c:e}):2===t.length?(r=t[0],i=n?n[0]:H,a=t[1],o=n?n[1]:H,function(e){return e===r?i:e===a?o:e}):function(e,t){return function(n){for(var r=0;r<e.length;r++)if(n===e[r])return t?t[r]:H;return n}}(t,n);var r,i,a,o,s,c}function ys(e,t){return function(n){return Ss(e(n),t)}}function hs(e){var t=ar(16384);return t.symbol=e.symbol,t.target=e,t}function vs(t,n,r){var i,a;if(t.typeParameters&&!r){i=e.map(t.typeParameters,hs),n=ys(gs(t.typeParameters,i),n);for(var o=0,s=i;o<s.length;o++){s[o].mapper=n}}t.typePredicate&&(a=function(t,n){return e.isIdentifierTypePredicate(t)?{kind:1,parameterName:t.parameterName,parameterIndex:t.parameterIndex,type:Ss(t.type,n)}:{kind:0,type:Ss(t.type,n)}}(t.typePredicate,n));var c=Ki(t.declaration,i,t.thisParameter&&bs(t.thisParameter,n),ps(t.parameters,n,bs),void 0,a,t.minArgumentCount,t.hasRestParameter,t.hasLiteralTypes);return c.target=t,c.mapper=n,c}function bs(t,n){if(1&e.getCheckFlags(t)){var r=gn(t);t=r.target,n=ys(r.mapper,n)}var i=un(t.flags,t.escapedName);return i.checkFlags=1,i.declarations=t.declarations,i.parent=t.parent,i.target=t,i.mapper=n,t.valueDeclaration&&(i.valueDeclaration=t.valueDeclaration),t.isRestParameter&&(i.isRestParameter=t.isRestParameter),i}function xs(t,n){var r=64&t.objectFlags?t.target:t,i=r.symbol,a=gn(i),o=a.typeParameters;if(!o){var s=i.declarations[0],c=pi(s,!0)||e.emptyArray;o=2048&i.flags&&!r.aliasTypeArguments?e.filter(c,(function(t){return function(t,n){if(t.symbol&&t.symbol.declarations&&1===t.symbol.declarations.length){var r=t.symbol.declarations[0].parent;if(e.findAncestor(n,(function(e){return 207===e.kind?"quit":e===r})))return e.forEachChild(n,i)}return!0;function i(n){switch(n.kind){case 169:return t.isThisType;case 71:return!t.isThisType&&e.isPartOfTypeNode(n)&&ds(n)===t;case 162:return!0}return e.forEachChild(n,i)}}(t,s)})):c,a.typeParameters=o,o.length&&(a.instantiations=e.createMap(),a.instantiations.set(Qa(o),r))}if(o.length){var u=64&t.objectFlags?ys(t.mapper,n):n,_=e.map(o,u),l=Qa(_),d=a.instantiations.get(l);if(!d){var p=gs(o,_);d=32&r.objectFlags?function(e,t){var n=ta(e);if(262144&n.flags){var r=n.type;if(16384&r.flags){var i=Ss(r,t);if(r!==i)return bu(i,(function(n){return function(e){return 704513&e.flags}(n)?ks(e,function(e,t,n){return function(r){return r===e?t:n(r)}}(r,n,t)):n}))}}return ks(e,t)}(r,p):ks(r,p),a.instantiations.set(l,d)}return d}return t}function ks(e,t){var n=sr(64|e.objectFlags,e.symbol);return 32&e.objectFlags&&(n.declaration=e.declaration),n.target=e,n.mapper=t,n.aliasSymbol=e.aliasSymbol,n.aliasTypeArguments=fs(e.aliasTypeArguments,t),n}function Ss(e,t){if(e&&t!==k){if(16384&e.flags)return t(e);if(32768&e.flags){if(16&e.objectFlags)return e.symbol&&14384&e.symbol.flags&&e.symbol.declarations?xs(e,t):e;if(32&e.objectFlags)return xs(e,t);if(4&e.objectFlags)return Ya(e.target,fs(e.typeArguments,t))}if(65536&e.flags&&!(8190&e.flags))return zo(fs(e.types,t),!1,e.aliasSymbol,fs(e.aliasTypeArguments,t));if(131072&e.flags)return Vo(fs(e.types,t),e.aliasSymbol,fs(e.aliasTypeArguments,t));if(262144&e.flags)return Wo(Ss(e.type,t));if(524288&e.flags)return Zo(Ss(e.objectType,t),Ss(e.indexType,t))}return e}function Ds(e,t){return e&&qa(Ss(e.type,t),e.isReadonly,e.declaration)}function Cs(t){switch(e.Debug.assert(151!==t.kind||e.isObjectLiteralMethod(t)),t.kind){case 186:case 187:case 151:return Ts(t);case 178:return e.forEach(t.properties,Cs);case 177:return e.forEach(t.elements,Cs);case 195:return Cs(t.whenTrue)||Cs(t.whenFalse);case 194:return 54===t.operatorToken.kind&&(Cs(t.left)||Cs(t.right));case 261:return Cs(t.initializer);case 185:return Cs(t.expression);case 254:return e.forEach(t.properties,Cs);case 253:return t.initializer&&Cs(t.initializer);case 256:return t.expression&&Cs(t.expression)}return!1}function Ts(t){if(t.typeParameters)return!1;if(e.forEach(t.parameters,(function(t){return!e.getEffectiveTypeAnnotationNode(t)})))return!0;if(187!==t.kind){var n=e.firstOrUndefined(t.parameters);if(!n||!e.parameterIsThisKeyword(n))return!0}return 207!==t.body.kind&&Cs(t.body)}function Es(t){return(d_(t)||e.isObjectLiteralMethod(t))&&Ts(t)}function Ns(t){if(32768&t.flags){var n=ia(t);if(n.constructSignatures.length){var r=sr(16,t.symbol);return r.members=n.members,r.properties=n.properties,r.callSignatures=e.emptyArray,r.constructSignatures=e.emptyArray,r}}else if(131072&t.flags)return Vo(e.map(t.types,Ns));return t}function As(e,t){return Vs(e,t,nn)}function ws(e,t){return Vs(e,t,nn)?-1:0}function Ps(e,t){return Vs(e,t,en)?-1:0}function Fs(e,t){return Vs(e,t,$t)}function Os(e,t){return Vs(e,t,en)}function Is(e,t){return _i(e)===_i(t)||Fs(e,t)&&!As(e,t)}function Rs(e,t){return Vs(e,t,tn)}function Ls(e,t,n,r,i){return qs(e,t,en,n,r,i)}function Ms(e,t,n,r,i){return qs(e,t,tn,n,r,i)}function Bs(t,n,r,i,a,o,s){if(t===n)return-1;if(!n.hasRestParameter&&t.minArgumentCount>n.parameters.length)return 0;t.typeParameters&&t.typeParameters!==n.typeParameters&&(t=ll(t,n=ja(n),void 0,s));var c=n.declaration?n.declaration.kind:0,u=!r&&A&&151!==c&&150!==c&&152!==c,_=-1,l=Ra(t);if(l&&l!==oe){var d=Ra(n);if(d){if(!(v=!u&&s(l,d,!1)||s(d,l,a)))return a&&o(e.Diagnostics.The_this_types_of_each_signature_are_incompatible),0;_&=v}}for(var p=zs(t),f=zs(n),m=function(e,t,n,r){return e.hasRestParameter===n.hasRestParameter?e.hasRestParameter?Math.max(t,r)+1:Math.min(t,r):e.hasRestParameter?r:t}(t,p,n,f),g=t.parameters,y=n.parameters,h=0;h<m;h++){var v,b=h<p?Jl(g[h]):Ma(t),x=h<f?Jl(y[h]):Ma(n),k=r?void 0:_l(xc(b)),S=r?void 0:_l(xc(x));if(!(v=k&&S&&!k.typePredicate&&!S.typePredicate&&(6144&gc(b))==(6144&gc(x))?Bs(S,k,u?2:1,!1,a,o,s):!r&&!u&&s(b,x,!1)||s(x,b,a)))return a&&o(e.Diagnostics.Types_of_parameters_0_and_1_are_incompatible,e.symbolName(g[h<p?h:p]),e.symbolName(y[h<f?h:f])),0;_&=v}if(!i){var D=La(n);if(D===oe)return _;var C=La(t);if(n.typePredicate){if(t.typePredicate)_&=function(t,n,r,i,a,o,s){if(t.kind!==n.kind)return a&&(o(e.Diagnostics.A_this_based_type_guard_is_not_compatible_with_a_parameter_based_type_guard),o(e.Diagnostics.Type_predicate_0_is_not_assignable_to_1,Er(t),Er(n))),0;if(1===t.kind){var c=t,u=n;if(c.parameterIndex-(e.getThisParameter(r)?1:0)!==u.parameterIndex-(e.getThisParameter(i)?1:0))return a&&(o(e.Diagnostics.Parameter_0_is_not_in_the_same_position_as_parameter_1,c.parameterName,u.parameterName),o(e.Diagnostics.Type_predicate_0_is_not_assignable_to_1,Er(t),Er(n))),0}var _=s(t.type,n.type,a);0===_&&a&&o(e.Diagnostics.Type_predicate_0_is_not_assignable_to_1,Er(t),Er(n));return _}(t.typePredicate,n.typePredicate,t.declaration,n.declaration,a,o,s);else if(e.isIdentifierTypePredicate(n.typePredicate))return a&&o(e.Diagnostics.Signature_0_must_be_a_type_predicate,Cr(t)),0}else _&=1===r&&s(D,C,!1)||s(C,D,a)}return _}function Js(e,t){var n=za(e),r=za(t),i=La(n),a=La(r);return!(a!==oe&&!Vs(a,i,en)&&!Vs(i,a,en))&&0!==Bs(n,r,0,!0,!1,void 0,Ps)}function zs(e){var t=e.parameters.length;return e.hasRestParameter?t-1:t}function js(t){return 32768&t.flags?0===(n=ia(t)).properties.length&&0===n.callSignatures.length&&0===n.constructSignatures.length&&!n.stringIndexInfo&&!n.numberIndexInfo:!!(16777216&t.flags)||(65536&t.flags?e.forEach(t.types,js):!!(131072&t.flags)&&!e.forEach(t.types,(function(e){return!js(e)})));var n}function Ks(t,n,r){if(t===n)return!0;var i=s(t)+","+s(n),a=rn.get(i);if(void 0!==a)return a;if(!(t.escapedName===n.escapedName&&256&t.flags&&256&n.flags))return rn.set(i,!1),!1;for(var o=ci(n),c=0,u=sa(ci(t));c<u.length;c++){var _=u[c];if(8&_.flags){var l=va(o,_.escapedName);if(!(l&&8&l.flags))return r&&r(e.Diagnostics.Property_0_is_missing_in_type_1,e.symbolName(_),Tr(Fi(n),void 0,256)),rn.set(i,!1),!1}}return rn.set(i,!0),!0}function Us(e,t,n,r){var i=e.flags,a=t.flags;if(8192&a)return!1;if(1&a||8192&i)return!0;if(262178&i&&2&a)return!0;if(32&i&&256&i&&32&a&&!(256&a)&&e.value===t.value)return!0;if(84&i&&4&a)return!0;if(64&i&&256&i&&64&a&&!(256&a)&&e.value===t.value)return!0;if(136&i&&8&a)return!0;if(16&i&&16&a&&Ks(e.symbol,t.symbol,r))return!0;if(256&i&&256&a){if(65536&i&&65536&a&&Ks(e.symbol,t.symbol,r))return!0;if(224&i&&224&a&&e.value===t.value&&Ks(tr(e.symbol),tr(t.symbol),r))return!0}if(2048&i&&(!N||3072&a))return!0;if(4096&i&&(!N||4096&a))return!0;if(32768&i&&16777216&a)return!0;if(n===en||n===tn){if(1&i)return!0;if(68&i&&!(256&i)&&(16&a||64&a&&256&a))return!0}return!1}function Vs(e,t,n){if(96&e.flags&&1048576&e.flags&&(e=e.regularType),96&t.flags&&1048576&t.flags&&(t=t.regularType),e===t||n!==nn&&Us(e,t,n))return!0;if(32768&e.flags&&32768&t.flags){var r=n.get(Ys(e,t,n));if(void 0!==r)return 1===r}return!!(1032192&e.flags||1032192&t.flags)&&qs(e,t,n,void 0)}function qs(t,n,r,i,a,o){var s,c,u,_,l,d=0,p=0;!function(e){e[e.None=0]="None",e[e.Source=1]="Source",e[e.Target=2]="Target",e[e.Both=3]="Both"}(l||(l={}));var f=0,m=!1,g=!1;e.Debug.assert(r!==nn||!i,"no error reporting in identity checking");var y=b(t,n,!!i,a);return m?cn(i,e.Diagnostics.Excessive_stack_depth_comparing_types_0_and_1,Tr(t),Tr(n)):s&&(o&&(s=e.concatenateDiagnosticMessageChains(o,s)),At.add(e.createDiagnosticForNodeFromMessageChain(i,s))),0!==y;function h(t,n,r,a){e.Debug.assert(!!i),s=e.chainDiagnosticMessages(s,t,n,r,a)}function v(t,n,i){var a=Tr(n),o=Tr(i);a===o&&(a=Tr(n,void 0,256),o=Tr(i,void 0,256)),t||(t=r===tn?e.Diagnostics.Type_0_is_not_comparable_to_type_1:a===o?e.Diagnostics.Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated:e.Diagnostics.Type_0_is_not_assignable_to_type_1),h(t,a,o)}function b(t,n,i,a){if(96&t.flags&&1048576&t.flags&&(t=t.regularType),96&n.flags&&1048576&n.flags&&(n=n.regularType),t===n)return-1;if(r===nn)return function(e,t){var n;if(32768&e.flags&&32768&t.flags)return E(e,t,!1);if((65536&e.flags&&65536&t.flags||131072&e.flags&&131072&t.flags)&&(n=k(e,t))&&(n&=k(t,e)))return n;return 0}(t,n);if(Us(t,n,r,i?h:void 0))return-1;if(128&hn(t)&&1048576&t.flags){if(x(t,n,i))return i&&v(a,t,n),0;(function(e){if(!(196608&e.flags))return!1;for(var t=!1,n=0,r=e.types;n<r.length;n++)if(!(6144&r[n].flags)){if(t)return!0;t=!0}return!1})(n)&&(t=Dc(t))}if(r!==tn&&!(196608&t.flags)&&!(65536&n.flags)&&!g&&t!==ke&&(sa(t).length>0||xa(t,0).length>0||xa(t,1).length>0)&&N(n)&&!function(e,t){for(var n=!!(33554432&e.flags),r=0,i=sa(e);r<i.length;r++){if(z_(t,i[r].escapedName,n))return!0}return!1}(t,n)){if(i){var o=xa(t,0),c=xa(t,1);o.length>0&&b(La(o[0]),n,!1)||c.length>0&&b(La(c[0]),n,!1)?h(e.Diagnostics.Value_of_type_0_has_no_properties_in_common_with_type_1_Did_you_mean_to_call_it,Tr(t),Tr(n)):h(e.Diagnostics.Type_0_has_no_properties_in_common_with_type_1,Tr(t),Tr(n))}return 0}var u=0,_=s,l=g;return g=!1,65536&t.flags?u=r===tn?T(t,n,i&&!(8190&t.flags)):function(e,t,n){for(var r=-1,i=e.types,a=0,o=i;a<o.length;a++){var s=b(o[a],t,n);if(!s)return 0;r&=s}return r}(t,n,i&&!(8190&t.flags)):(65536&n.flags?u=D(t,n,i&&!(8190&t.flags)&&!(8190&n.flags)):131072&n.flags?(g=!0,u=function(e,t,n){for(var r=-1,i=t.types,a=0,o=i;a<o.length;a++){var s=b(e,o[a],n);if(!s)return 0;r&=s}return r}(t,n,i)):131072&t.flags&&(u=T(t,n,!1)),!u&&(1032192&t.flags||1032192&n.flags)&&(u=E(t,n,i))&&(s=_)),g=l,!u&&i&&(32768&t.flags&&8190&n.flags?function(t,n){var r=Tr(t),i=Tr(n);(Te===t&&ee===n||Ee===t&&te===n||Ne===t&&ie===n||fo(!1)===t&&ae===n)&&h(e.Diagnostics._0_is_a_primitive_but_1_is_a_wrapper_object_Prefer_using_0_when_possible,i,r)}(t,n):t.symbol&&32768&t.flags&&ke===t&&h(e.Diagnostics.The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead),v(a,t,n)),u}function x(t,n,a){if(id(n,32768)&&!(512&hn(n))){var o=!!(33554432&t.flags);if((r===en||r===tn)&&(yu(ke,n)||!o&&js(n)))return!1;if(65536&n.flags){var s=C(t,n);if(s)return x(t,s,a)}for(var c=function(r){if(!z_(n,r.escapedName,o)){if(a)if(e.Debug.assert(!!i),e.isJsxAttributes(i)||e.isJsxOpeningLikeElement(i))h(e.Diagnostics.Property_0_does_not_exist_on_type_1,Dr(r),Tr(n));else{var s=t.symbol&&e.firstOrUndefined(t.symbol.declarations),c=void 0;if(r.valueDeclaration&&e.findAncestor(r.valueDeclaration,(function(e){return e===s}))){var u=r.valueDeclaration;e.Debug.assertNode(u,e.isObjectLiteralElementLike),i=u,e.isIdentifier(u.name)&&(c=X_(u.name,n))}void 0!==c?h(e.Diagnostics.Object_literal_may_only_specify_known_properties_but_0_does_not_exist_in_type_1_Did_you_mean_to_write_2,Dr(r),Tr(n),c):h(e.Diagnostics.Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1,Dr(r),Tr(n))}return{value:!0}}},u=0,_=aa(t);u<_.length;u++){var l=c(_[u]);if("object"==typeof l)return l.value}}return!1}function k(e,t){for(var n=-1,r=0,i=e.types;r<i.length;r++){var a=D(i[r],t,!1);if(!a)return 0;n&=a}return n}function D(e,t,n){var r=t.types;if(65536&t.flags&&Io(r,e))return-1;for(var i=0,a=r;i<a.length;i++){var o=b(e,a[i],!1);if(o)return o}n&&b(e,C(e,t)||r[r.length-1],!0);return 0}function C(e,t){var n,r=aa(e);if(r){var i=function(e,t){for(var n,r=0,i=e;r<i.length;r++){var a=i[r];if(Zc(t,a.escapedName)){if(n)return;n=a}}return n}(r,t);if(i)for(var a=ci(i),o=0,s=t.types;o<s.length;o++){var c=s[o],u=Kr(c,i.escapedName);if(u&&b(a,u)){if(n)return;n=c}}}return n}function T(e,t,n){var r=e.types;if(65536&e.flags&&Io(r,t))return-1;for(var i=r.length,a=0;a<i;a++){var o=b(r[a],t,n&&a===i-1);if(o)return o}return 0}function E(t,n,i){if(m)return 0;var a=Ys(t,n,r),o=r.get(a);if(void 0!==o){if(!i||2!==o)return 1===o?-1:0;r.set(a,3)}if(c){for(var l=0;l<d;l++)if(a===c[l])return 1;if(100===p)return m=!0,0}else c=[],u=[],_=[];var g=d;c[d]=a,d++,u[p]=t,_[p]=n,p++;var y=f;1&f||!nc(t,u,p)||(f|=1),2&f||!nc(n,_,p)||(f|=2);var v=3!==f?function(t,n,i){var a,o=s;if(16384&n.flags){if(32&hn(t)&&ta(t)===Wo(n))if(!t.declaration.questionToken)if(a=b(na(t),Zo(n,ea(t)),i))return a}else if(262144&n.flags){if(262144&t.flags&&(a=b(n.type,t.type,!1)))return a;if((c=function(e){return 16384&e.flags?ca(e):524288&e.flags?ua(e):_a(e)}(n.type))&&(a=b(t,Wo(c),i)))return a}else if(524288&n.flags){if((c=ua(n))&&(a=b(t,c,i)))return s=o,a}if(16384&t.flags){if(32&hn(n)&&ta(n)===Wo(t)){if(a=b(Zo(t,ea(n)),na(n),i))return s=o,a}else if((c=ca(t))||!(16777216&n.flags))if((!c||1&c.flags)&&(c=_e),a=b(c,n,i&&c!==_e))return s=o,a}else if(524288&t.flags){var c;if(c=ua(t)){if(a=b(c,n,i))return s=o,a}else if(524288&n.flags&&t.indexType===n.indexType&&(a=b(t.objectType,n.objectType,i)))return a}else{if(4&hn(t)&&4&hn(n)&&t.target===n.target&&!(67108864&t.flags||67108864&n.flags)){var u=Hs(t.target);if(a=function(t,n,i,a){var o=t.typeArguments||e.emptyArray,s=n.typeArguments||e.emptyArray;if(o.length!==s.length&&r===nn)return 0;for(var c=o.length<=s.length?o.length:s.length,u=-1,_=0;_<c;_++){var l=_<i.length?i[_]:1;if(4!==l){var d=o[_],p=s[_],f=-1;if(1===l?f=b(d,p,a):2===l?f=b(p,d,a):3===l?(f=b(p,d,!1))||(f=b(d,p,a)):(f=b(d,p,a))&&(f&=b(p,d,a)),!f)return 0;u&=f}}return u}(t,n,u,i))return a;if(u!==e.emptyArray&&!function(e,t){for(var n=0;n<t.length;n++)if(1===t[n]&&1024&e.typeArguments[n].flags)return!0;return!1}(n,u)){if(!i||!e.some(u,(function(e){return 0===e})))return 0;s=o}}var _=!!(8190&t.flags);if(r!==nn&&(t=ma(t)),163840&t.flags&&32768&n.flags){var l=i&&s===o&&!_;if(!function(e){return 32&hn(e)&&!!e.declaration.questionToken}(n)||ra(t)||!js(t)?ra(n)?a=ra(t)?function(e,t,n){var i,a=!!e.declaration.readonlyToken,o=!!e.declaration.questionToken,s=!!t.declaration.readonlyToken,c=!!t.declaration.questionToken;if((r===nn?a===s&&o===c:r===tn||!o||c)&&(i=b(ta(t),ta(e),n))){var u=gs([ea(e)],[ea(t)]);return i&b(Ss(na(e),u),na(t),n)}return 0}(t,n,l):0:(a=function(t,n,i){if(r===nn)return function(e,t){if(!(32768&e.flags&&32768&t.flags))return 0;var n=aa(e),r=aa(t);if(n.length!==r.length)return 0;for(var i=-1,a=0,o=n;a<o.length;a++){var s=o[a],c=oa(t,s.escapedName);if(!c)return 0;var u=rc(s,c,b);if(!u)return 0;i&=u}return i}(t,n);var a=r===$t&&!(128&hn(t)),o=Mc(t,n,a);if(o)return i&&h(e.Diagnostics.Property_0_is_missing_in_type_1,Dr(o),Tr(t)),0;for(var s=-1,c=aa(n),u=0,_=c;u<_.length;u++){var l=_[u];if(!(4194304&l.flags)){var d=va(t,l.escapedName);if(d&&d!==l){var p=e.getDeclarationModifierFlagsFromSymbol(d),f=e.getDeclarationModifierFlagsFromSymbol(l);if(8&p||8&f){if(256&e.getCheckFlags(d))return i&&h(e.Diagnostics.Property_0_has_conflicting_declarations_and_is_inaccessible_in_type_1,Dr(d),Tr(t)),0;if(d.valueDeclaration!==l.valueDeclaration)return i&&(8&p&&8&f?h(e.Diagnostics.Types_have_separate_declarations_of_a_private_property_0,Dr(l)):h(e.Diagnostics.Property_0_is_private_in_type_1_but_not_in_type_2,Dr(l),Tr(8&p?t:n),Tr(8&p?n:t))),0}else if(16&f){if(!ec(d,l))return i&&h(e.Diagnostics.Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2,Dr(l),Tr($s(d)||t),Tr($s(l)||n)),0}else if(16&p)return i&&h(e.Diagnostics.Property_0_is_protected_in_type_1_but_public_in_type_2,Dr(l),Tr(t),Tr(n)),0;var m=b(ci(d),ci(l),i);if(!m)return i&&h(e.Diagnostics.Types_of_property_0_are_incompatible,Dr(l)),0;if(s&=m,r!==tn&&16777216&d.flags&&!(16777216&l.flags))return i&&h(e.Diagnostics.Property_0_is_optional_in_type_1_but_required_in_type_2,Dr(l),Tr(t),Tr(n)),0}}}return s}(t,n,l))&&(a&=A(t,n,0,l))&&(a&=A(t,n,1,l))&&(a&=F(t,n,0,_,l))&&(a&=F(t,n,1,_,l)):a=-1,a)return s=o,a}}return 0}(t,n,i):1;if(f=y,p--,v){if(-1===v||0===p){for(l=g;l<d;l++)r.set(c[l],1);d=g}}else r.set(a,i?3:2),d=g;return v}function N(t){if(32768&t.flags){var n=ia(t);return 0===n.callSignatures.length&&0===n.constructSignatures.length&&!n.stringIndexInfo&&!n.numberIndexInfo&&n.properties.length>0&&e.every(n.properties,(function(e){return!!(16777216&e.flags)}))}return!!(131072&t.flags)&&e.every(t.types,N)}function A(t,n,i,a){if(r===nn)return function(e,t,n){var r=xa(e,n),i=xa(t,n);if(r.length!==i.length)return 0;for(var a=-1,o=0;o<r.length;o++){var s=ic(r[o],i[o],!1,!1,!1,b);if(!s)return 0;a&=s}return a}(t,n,i);if(n===fe||t===fe)return-1;var o=xa(t,i),c=xa(n,i);if(1===i&&o.length&&c.length){if(tc(t)&&!tc(n))return a&&h(e.Diagnostics.Cannot_assign_an_abstract_constructor_type_to_a_non_abstract_constructor_type),0;if(!function(t,n,r){if(!t.declaration||!n.declaration)return!0;var i=e.getSelectedModifierFlags(t.declaration,24),a=e.getSelectedModifierFlags(n.declaration,24);if(8===a)return!0;if(16===a&&8!==i)return!0;if(16!==a&&!i)return!0;r&&h(e.Diagnostics.Cannot_assign_a_0_constructor_type_to_a_1_constructor_type,Ar(i),Ar(a));return!1}(o[0],c[0],a))return 0}var u=-1,_=s;if(64&hn(t)&&64&hn(n)&&t.symbol===n.symbol)for(var l=0;l<c.length;l++){if(!(x=w(o[l],c[l],!0,a)))return 0;u&=x}else if(1===o.length&&1===c.length){var d=r===tn||S.noStrictGenericChecks;u=w(o[0],c[0],d,a)}else e:for(var p=0,f=c;p<f.length;p++){for(var m=f[p],g=a,y=0,v=o;y<v.length;y++){var x;if(x=w(v[y],m,!0,g)){u&=x,s=_;continue e}g=!1}return g&&h(e.Diagnostics.Type_0_provides_no_match_for_the_signature_1,Tr(t),Cr(m,void 0,void 0,i)),0}return u}function w(e,t,n,r){return Bs(n?za(e):e,n?za(t):t,0,!1,r,h,b)}function P(t,n,r){var i=b(t.type,n.type,r);return!i&&r&&h(e.Diagnostics.Index_signatures_are_incompatible),i}function F(t,n,i,a,o){if(r===nn)return function(e,t,n){var r=Da(t,n),i=Da(e,n);if(!i&&!r)return-1;if(i&&r&&i.isReadonly===r.isReadonly)return b(i.type,r.type);return 0}(t,n,i);var s=Da(n,i);if(!s||1&s.type.flags&&!a)return-1;var c=Da(t,i)||1===i&&Da(t,0);if(c)return P(c,s,o);if(ra(t))return 0===i&&b(na(t),s.type,o);if(kc(t)){var u=-1;if(0===i){var _=Da(t,1);_&&(u=P(_,s,o))}return u&&(u&=function(t,n,r,i){for(var a=-1,o=0,s=aa(t);o<s.length;o++){var c=s[o];if(0===r||v_(c.escapedName)){var u=b(ci(c),n,i);if(!u)return i&&h(e.Diagnostics.Property_0_is_incompatible_with_index_signature,Dr(c)),0;a&=u}}return a}(t,s.type,i,o)),u}return o&&h(e.Diagnostics.Index_signature_is_missing_in_type_0,Tr(t)),0}}function Ws(t,n,r){var i=Ya(t,e.map(t.typeParameters,(function(e){return e===n?r:e})));return i.flags|=67108864,i}function Hs(t){if(!A)return e.emptyArray;var n=t.typeParameters||e.emptyArray,r=t.variances;if(!r){if(t===De||t===Ce)r=[1];else{t.variances=e.emptyArray,r=[];for(var i=0,a=n;i<a.length;i++){var o=a[i],s=Ws(t,o,he),c=Ws(t,o,ve),u=(Os(c,s)?1:0)|(Os(s,c)?2:0);3===u&&Os(Ws(t,o,$e),s)&&(u=4),r.push(u)}}t.variances=r}return r}function Gs(e){return 16384&e.flags&&!Ha(e)}function Qs(t){return 4&hn(t)&&e.some(t.typeArguments,(function(e){return Gs(e)||Qs(e)}))}function Xs(t,n,r){void 0===r&&(r=0);for(var i=""+t.target.id,a=0,o=t.typeArguments;a<o.length;a++){var s=o[a];if(Gs(s)){var c=e.indexOf(n,s);c<0&&(c=n.length,n.push(s)),i+="="+c}else r<4&&Qs(s)?i+="<"+Xs(s,n,r+1)+">":i+="-"+s.id}return i}function Ys(e,t,n){if(n===nn&&e.id>t.id){var r=e;e=t,t=r}if(Qs(e)&&Qs(t)){var i=[];return Xs(e,i)+","+Xs(t,i)}return e.id+","+t.id}function Zs(t,n){if(!(6&e.getCheckFlags(t)))return n(t);for(var r=0,i=t.containingType.types;r<i.length;r++){var a=va(i[r],t.escapedName),o=a&&Zs(a,n);if(o)return o}}function $s(e){return e.parent&&32&e.parent.flags?Fi(tr(e)):void 0}function ec(t,n){return!Zs(n,(function(n){return!!(16&e.getDeclarationModifierFlagsFromSymbol(n))&&(r=t,i=$s(n),!Zs(r,(function(e){var t=$s(e);return!!t&&li(t,i)})));var r,i}))}function tc(t){if(16&hn(t)){var n=t.symbol;if(n&&32&n.flags){var r=Wp(n);if(r&&e.hasModifier(r,128))return!0}}return!1}function nc(e,t,n){if(n>=5&&32768&e.flags){var r=e.symbol;if(r)for(var i=0,a=0;a<n;a++){var o=t[a];if(32768&o.flags&&o.symbol===r&&++i>=5)return!0}}return!1}function rc(t,n,r){if(t===n)return-1;var i=24&e.getDeclarationModifierFlagsFromSymbol(t);if(i!==(24&e.getDeclarationModifierFlagsFromSymbol(n)))return 0;if(i){if(qp(t)!==qp(n))return 0}else if((16777216&t.flags)!=(16777216&n.flags))return 0;return ed(t)!==ed(n)?0:r(ci(t),ci(n))}function ic(t,n,r,i,a,o){if(t===n)return-1;if(!function(e,t,n){if(e.parameters.length===t.parameters.length&&e.minArgumentCount===t.minArgumentCount&&e.hasRestParameter===t.hasRestParameter)return!0;var r=e.hasRestParameter?1:0,i=t.hasRestParameter?1:0;return!!(n&&e.minArgumentCount<=t.minArgumentCount&&(r>i||r===i&&e.parameters.length>=t.parameters.length))}(t,n,r))return 0;if(e.length(t.typeParameters)!==e.length(n.typeParameters))return 0;t=za(t),n=za(n);var s=-1;if(!i){var c=Ra(t);if(c){var u=Ra(n);if(u){if(!(d=o(c,u)))return 0;s&=d}}}for(var _=n.parameters.length,l=0;l<_;l++){var d;if(!(d=o(ac(t,l)?Ma(t):Jl(t.parameters[l]),ac(n,l)?Ma(n):Jl(n.parameters[l]))))return 0;s&=d}return a||(s&=o(La(t),La(n))),s}function ac(e,t){return e.hasRestParameter&&t>=e.parameters.length-1}function oc(t){return function(e){for(var t,n=0,r=e;n<r.length;n++){var i=r[n],a=dc(i);if(t||(t=a),a===i||a!==t)return!1}return!0}(t)?zo(t):e.reduceLeft(t,(function(e,t){return Fs(e,t)?t:e}))}function sc(e){return 4&hn(e)&&e.target===De}function cc(e){return 4&hn(e)&&(e.target===De||e.target===Ce)||!(6144&e.flags)&&Os(e,Oe)}function uc(e){return!!va(e,"0")}function _c(e){return!!(6368&e.flags)}function lc(t){return!!(8&t.flags)||(65536&t.flags?!!(256&t.flags)||!e.forEach(t.types,(function(e){return!_c(e)})):_c(t))}function dc(t){return 256&t.flags?Ni(t):32&t.flags?ee:64&t.flags?te:128&t.flags?ie:65536&t.flags?zo(e.sameMap(t.types,dc)):t}function pc(t){return 256&t.flags?Ni(t):32&t.flags&&1048576&t.flags?ee:64&t.flags&&1048576&t.flags?te:128&t.flags?ie:65536&t.flags?zo(e.sameMap(t.types,pc)):t}function fc(e){return!!(4&hn(e)&&8&e.target.objectFlags)}function mc(e){for(var t=0,n=0,r=e;n<r.length;n++){t|=gc(r[n])}return t}function gc(e){return 65536&e.flags?mc(e.types):32&e.flags?""===e.value?32:0:64&e.flags?0===e.value?64:0:128&e.flags?e===re?128:0:7406&e.flags}function yc(e){return 7392&gc(e)?vu(e,(function(e){return!(7392&gc(e))})):e}function hc(e){return bu(e,vc)}function vc(e){return 2&e.flags?lt:4&e.flags?dt:8&e.flags||e===re?re:7168&e.flags||32&e.flags&&""===e.value||64&e.flags&&0===e.value?e:se}function bc(e,t){var n=t&~e.flags&6144;return 0===n?e:zo(2048===n?[e,X]:4096===n?[e,Z]:[e,X,Z])}function xc(e){return N?nu(e,524288):e}function kc(e){return e.symbol&&0!=(6656&e.symbol.flags)&&0===xa(e,0).length&&0===xa(e,1).length}function Sc(e,t){var n=un(e.flags,e.escapedName);return n.declarations=e.declarations,n.parent=e.parent,n.type=t,n.target=e,e.valueDeclaration&&(n.valueDeclaration=e.valueDeclaration),n}function Dc(t){if(!(128&hn(t)&&1048576&t.flags))return t;var n=t.regularType;if(n)return n;var r=t,i=function(t,n){for(var r=e.createSymbolTable(),i=0,a=aa(t);i<a.length;i++){var o=a[i],s=ci(o),c=n(s);r.set(o.escapedName,c===s?o:Sc(o,c))}return r}(t,Dc),a=lr(r.symbol,i,r.callSignatures,r.constructSignatures,r.stringIndexInfo,r.numberIndexInfo);return a.flags=-1048577&r.flags,a.objectFlags|=128,t.regularType=a,a}function Cc(e){var t=ci(e),n=Ec(t);return n===t?e:Sc(e,n)}function Tc(e){return 6144&e.flags?e:Ec(e)}function Ec(t){if(6291456&t.flags){if(6144&t.flags)return H;if(128&hn(t))return function(t){for(var n=e.createSymbolTable(),r=0,i=aa(t);r<i.length;r++){var a=i[r];n.set(a.escapedName,4&a.flags?Cc(a):a)}var o=Da(t,0),s=Da(t,1);return lr(t.symbol,n,e.emptyArray,e.emptyArray,o&&qa(Ec(o.type),o.isReadonly),s&&qa(Ec(s.type),s.isReadonly))}(t);if(65536&t.flags)return zo(e.sameMap(t.types,Tc));if(sc(t)||fc(t))return Ya(t.target,e.sameMap(t.typeArguments,Ec))}return t}function Nc(t){var n=!1;if(65536&t.flags)for(var r=0,i=t.types;r<i.length;r++){Nc(u=i[r])&&(n=!0)}if(sc(t)||fc(t))for(var a=0,o=t.typeArguments;a<o.length;a++){Nc(u=o[a])&&(n=!0)}if(128&hn(t))for(var s=0,c=aa(t);s<c.length;s++){var u,_=c[s];2097152&(u=ci(_)).flags&&(Nc(u)||cn(_.valueDeclaration,e.Diagnostics.Object_literal_s_property_0_implicitly_has_an_1_type,e.symbolName(_),Tr(Ec(u))),n=!0)}return n}function Ac(t,n){var r,i=Tr(Ec(n));switch(t.kind){case 149:case 148:r=e.Diagnostics.Member_0_implicitly_has_an_1_type;break;case 146:r=t.dotDotDotToken?e.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type:e.Diagnostics.Parameter_0_implicitly_has_an_1_type;break;case 176:r=e.Diagnostics.Binding_element_0_implicitly_has_an_1_type;break;case 228:case 151:case 150:case 153:case 154:case 186:case 187:if(!t.name)return void cn(t,e.Diagnostics.Function_expression_which_lacks_return_type_annotation_implicitly_has_an_0_return_type,i);r=e.Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type;break;default:r=e.Diagnostics.Variable_0_implicitly_has_an_1_type}cn(t,r,e.declarationNameToString(e.getNameOfDeclaration(t)),i)}function wc(e,t){r&&w&&2097152&t.flags&&(Nc(t)||Ac(e,t))}function Pc(e,t,n){var r,i=e.parameters.length,a=t.parameters.length;r=e.hasRestParameter&&t.hasRestParameter?Math.max(i,a):e.hasRestParameter?a:t.hasRestParameter?i:Math.min(i,a);for(var o=0;o<r;o++)n(zl(e,o),zl(t,o))}function Fc(t,n,r,i){var a=i?e.map(i,Ic):e.map(t.typeParameters,Oc),o=function(e){for(var t=0;t<a.length;t++)if(e===a[t].typeParameter)return a[t].isFixed=!0,jc(o,t);return e};return o.signature=t,o.inferences=a,o.flags=n,o.compareTypes=r||Ps,o}function Oc(e){return{typeParameter:e,candidates:void 0,inferredType:void 0,priority:void 0,topLevel:!0,isFixed:!1}}function Ic(e){return{typeParameter:e.typeParameter,candidates:e.candidates&&e.candidates.slice(),inferredType:e.inferredType,priority:e.priority,topLevel:e.topLevel,isFixed:e.isFixed}}function Rc(t){var n=hn(t);return!!(802816&t.flags||4&n&&e.forEach(t.typeArguments,Rc)||16&n&&t.symbol&&10288&t.symbol.flags||32&n||196608&t.flags&&function(t){void 0===t.couldContainTypeVariables&&(t.couldContainTypeVariables=e.forEach(t.types,Rc));return t.couldContainTypeVariables}(t))}function Lc(t,n){return t===n||196608&t.flags&&e.forEach(t.types,(function(e){return Lc(e,n)}))}function Mc(e,t,n){for(var r=0,i=aa(t);r<i.length;r++){var a=i[r];if(n||!(16777216&a.flags))if(!va(e,a.escapedName))return a}}function Bc(t,n,r,i){var a,o;function s(t,n){if(Rc(n))if(t.aliasSymbol&&t.aliasTypeArguments&&t.aliasSymbol===n.aliasSymbol)for(var l=t.aliasTypeArguments,d=n.aliasTypeArguments,p=0;p<l.length;p++)s(l[p],d[p]);else{if(65536&t.flags&&65536&n.flags&&!(256&t.flags&&256&n.flags)||131072&t.flags&&131072&n.flags){if(t===n){for(var f=0,m=t.types;f<m.length;f++){s(E=m[f],E)}return}for(var g=void 0,y=0,h=t.types;y<h.length;y++){if(Jc(E=h[y],n.types))(g||(g=[])).push(E),s(E,E);else if(96&E.flags){var v=dc(E);Jc(v,n.types)&&(g||(g=[])).push(E,v)}}g&&(t=zc(t,g),n=zc(n,g))}if(540672&n.flags){if(8388608&t.flags||t===ce)return;var b=u(n);if(b)return void(b.isFixed||(!b.candidates||i<b.priority?(b.candidates=[t],b.priority=i):i===b.priority&&b.candidates.push(t),8&i||!(16384&n.flags)||Lc(r,n)||(b.topLevel=!1)))}else if(4&hn(t)&&4&hn(n)&&t.target===n.target){l=t.typeArguments||e.emptyArray,d=n.typeArguments||e.emptyArray;var x=l.length<d.length?l.length:d.length,k=Hs(t.target);for(p=0;p<x;p++)p<k.length&&2===k[p]?c(l[p],d[p]):s(l[p],d[p])}else if(262144&t.flags&&262144&n.flags)s(t.type,n.type);else if(524288&t.flags&&524288&n.flags)s(t.objectType,n.objectType),s(t.indexType,n.indexType);else if(196608&n.flags){for(var S=0,D=void 0,C=0,T=d=n.types;C<T.length;C++){var E;u(E=T[C])?(D=E,S++):s(t,E)}if(1===S){var N=i;i|=2,s(t,D),i=N}}else if(65536&t.flags)for(var A=0,w=l=t.types;A<w.length;A++){s(w[A],n)}else if(163840&(t=ma(t)).flags){var P=t.id+","+n.id;if(o&&o.get(P))return;(o||(o=e.createMap())).set(P,!0);var F=32768&n.flags&&!(16&hn(n)&&n.symbol&&32&n.symbol.flags)?n.symbol:void 0;if(F){if(e.contains(a,F))return;(a||(a=[])).push(F),_(t,n),a.pop()}else _(t,n)}}}function c(e,t){A?(i^=1,s(e,t),i^=1):s(e,t)}function u(e){if(540672&e.flags)for(var n=0,r=t;n<r.length;n++){var i=r[n];if(e===i.typeParameter)return i}}function _(t,n){if(ra(t)&&ra(n)&&(s(ta(t),ta(n)),s(na(t),na(n))),32&hn(n)){var r=ta(n);if(262144&r.flags){var a=u(r.type);if(a&&!a.isFixed){var o=function(t,n){var r=sa(t),i=Da(t,0);if(0!==r.length||i){for(var a=Oc(Zo(ta(n).type,ea(n))),o=[a],s=na(n),c=!n.declaration.readonlyToken,u=n.declaration.questionToken?0:16777216,_=e.createSymbolTable(),l=0,d=r;l<d.length;l++){var p=d[l],f=y(ci(p));if(!f)return;var m=un(4|p.flags&u,p.escapedName);m.checkFlags=c&&ed(p)?8:0,m.declarations=p.declarations,m.type=f,_.set(p.escapedName,m)}if(i){var g=y(i.type);if(!g)return;i=qa(g,c&&i.isReadonly)}return lr(void 0,_,e.emptyArray,e.emptyArray,i,void 0)}function y(e){return a.candidates=void 0,Bc(o,e,s),a.candidates&&zo(a.candidates,!0)}}(t,n);if(o){var c=i;i|=4,s(o,a.typeParameter),i=c}}return}if(16384&r.flags)return s(Wo(t),r),void s(zo(e.map(sa(t),ci)),na(n))}Mc(t,n,!1)&&Mc(n,t,!1)||(function(e,t){for(var n=aa(t),r=0,i=n;r<i.length;r++){var a=i[r],o=va(e,a.escapedName);o&&s(ci(o),ci(a))}}(t,n),l(t,n,0),l(t,n,1),function(e,t){var n=Ca(t,0);if(n){(i=Ca(e,0)||Ta(e,0))&&s(i,n)}var r=Ca(t,1);if(r){var i;(i=Ca(e,1)||Ca(e,0)||Ta(e,1))&&s(i,r)}}(t,n))}function l(e,t,n){for(var r=xa(e,n),i=xa(t,n),a=r.length,o=i.length,s=a<o?a:o,c=0;c<s;c++)d(za(r[a-s+c]),za(i[o-s+c]))}function d(e,t){Pc(e,t,c),e.typePredicate&&t.typePredicate&&e.typePredicate.kind===t.typePredicate.kind?s(e.typePredicate.type,t.typePredicate.type):s(La(e),La(t))}void 0===i&&(i=0),s(n,r)}function Jc(e,t){for(var n=0,r=t;n<r.length;n++){if(As(r[n],e))return!0}return!1}function zc(e,t){for(var n=[],r=0,i=e.types;r<i.length;r++){var a=i[r];Jc(a,t)||n.push(a)}return 65536&e.flags?zo(n):Vo(n)}function jc(t,n){var r,i=t.inferences[n],a=i.inferredType;if(!a){if(i.candidates){var o=t.signature,s=i.topLevel&&!function(e){var t=ca(e);return t&&id(t,270334)}(i.typeParameter)&&(i.isFixed||!Lc(La(o),i.typeParameter))?e.sameMap(i.candidates,pc):i.candidates;a=Ec(1&i.priority?(r=s,e.reduceLeft(r,(function(e,t){return Fs(t,e)?t:e}))):1&t.flags||8&i.priority?zo(s,!0):function(t){if(!N)return oc(t);var n=e.filter(t,(function(e){return!(6144&e.flags)}));return n.length?bc(oc(n),6144&mc(t)):zo(t,!0)}(s))}else if(2&t.flags)a=ce;else{var c=fa(i.typeParameter);a=c?Ss(c,ys(function(t,n){return function(r){return e.indexOf(t,r)>=n?_e:r}}(t.signature.typeParameters,n),t)):Kc(!!(4&t.flags))}i.inferredType=a;var u=ca(t.signature.typeParameters[n]);if(u){var _=Ss(u,t);t.compareTypes(a,zi(_,a))||(i.inferredType=a=_)}}return a}function Kc(e){return e?H:_e}function Uc(e){for(var t=[],n=0;n<e.inferences.length;n++)t.push(jc(e,n));return t}function Vc(t){var n=yn(t);return n.resolvedSymbol||(n.resolvedSymbol=!e.nodeIsMissing(t)&&kn(t,t.escapedText,1156031,e.Diagnostics.Cannot_find_name_0,t,!e.isWriteOnlyAccess(t),e.Diagnostics.Cannot_find_name_0_Did_you_mean_1)||q),n.resolvedSymbol}function qc(t){return!!e.findAncestor(t,(function(e){return 162===e.kind||71!==e.kind&&143!==e.kind&&"quit"}))}function Wc(t){if(71===t.kind){var n=Vc(t);return n!==q?(Ju(t)?"@":"")+s(n):void 0}if(99===t.kind)return"0";if(179===t.kind)return(i=Wc(t.expression))&&i+"."+e.idText(t.name);if(176===t.kind){var r=t.parent.parent,i=176===r.kind?Wc(r):r.initializer&&Wc(r.initializer),a=Hc(t);return i&&a&&i+"."+a}}function Hc(t){if(174!==t.parent.kind)return""+t.parent.elements.indexOf(t);var n=t.propertyName||t.name;switch(n.kind){case 71:return e.idText(n);case 144:return e.isStringOrNumericLiteral(n.expression)?n.expression.text:void 0;case 9:case 8:return n.text;default:e.Debug.fail("Unexpected name kind for binding element name")}}function Gc(e,t){switch(e.kind){case 71:return 71===t.kind&&Vc(e)===Vc(t)||(226===t.kind||176===t.kind)&&nr(Vc(e))===er(t);case 99:return 99===t.kind;case 97:return 97===t.kind;case 179:return 179===t.kind&&e.name.escapedText===t.name.escapedText&&Gc(e.expression,t.expression);case 176:if(179!==t.kind)return!1;var n=t;if(n.name.escapedText!==Hc(e))return!1;if(176===e.parent.parent.kind&&Gc(e.parent.parent,n.expression))return!0;if(226===e.parent.parent.kind){var r=e.parent.parent.initializer;return r&&Gc(r,n.expression)}}return!1}function Qc(e,t){for(;179===e.kind;)if(Gc(e=e.expression,t))return!0;return!1}function Xc(e,t){return 179===t.kind&&Qc(e,t.expression)&&Zc(Yc(t.expression),t.name.escapedText)}function Yc(e){if(71===e.kind)return ci(Vc(e));if(179===e.kind){var t=Yc(e.expression);return t&&Kr(t,e.name.escapedText)}}function Zc(t,n){if(t&&65536&t.flags){var r=ya(t,n);if(r&&2&e.getCheckFlags(r))return void 0===r.isDiscriminantProperty&&(r.isDiscriminantProperty=32&r.checkFlags&&lc(ci(r))),r.isDiscriminantProperty}return!1}function $c(e,t){return Gc(e,t)||Qc(e,t)}function eu(e,t){if(e!==t){if(8192&t.flags)return t;var n=vu(e,(function(e){return function(e,t){if(!(65536&e.flags))return Os(e,t);for(var n=0,r=e.types;n<r.length;n++)if(Os(r[n],t))return!0;return!1}(t,e)}));if(!(8192&n.flags))return n}return e}function tu(e){var t=e.flags;if(2&t)return N?4079361:4194049;if(32&t){var n=""===e.value;return N?n?3030785:1982209:n?3145473:4194049}if(20&t)return N?4079234:4193922;if(64&t){var r=0===e.value;return N?r?3030658:1982082:r?3145346:4193922}return 8&t?N?4078980:4193668:136&t?N?e===re?3030404:1981828:e===re?3145092:4193668:32768&t?function(e){var t=ia(e);return!!(t.callSignatures.length||t.constructSignatures.length||t.members.get("bind")&&Fs(e,Se))}(e)?N?6164448:8376288:N?6166480:8378320:3072&t?2457472:4096&t?2340752:512&t?N?1981320:4193160:16777216&t?N?6166480:8378320:540672&t?tu(_a(e)||_e):196608&t?function(e){for(var t=0,n=0,r=e;n<r.length;n++)t|=tu(r[n]);return t}(e.types):8388607}function nu(e,t){if(524288&e.flags){var n=_a(e)||_e,r=vu(n,(function(e){return 0!=(tu(e)&t)}));return r!==n?r:e}return vu(e,(function(e){return 0!=(tu(e)&t)}))}function ru(e,t){if(t){var n=Td(t);return zo([nu(e,131072),n])}return e}function iu(t,n){var r=e.getTextOfPropertyName(n);return Kr(t,r)||v_(r)&&Ca(t,1)||Ca(t,0)||Q}function au(e,t){return uc(e)&&Kr(e,""+t)||wp(e,void 0,!1,!1)||Q}function ou(e){return wo(wp(e,void 0,!1,!1)||Q)}function su(e){return 194===e.parent.kind&&e.parent.left===e||216===e.parent.kind&&e.parent.initializer===e}function cu(e){return iu(uu(e.parent),e.name)}function uu(t){var n=t.parent;switch(n.kind){case 215:return ee;case 216:return Ap(n.expression,n.awaitModifier)||Q;case 194:return function(e){return 177===e.parent.kind&&su(e.parent)||261===e.parent.kind&&su(e.parent.parent)?ru(uu(e),e.right):Td(e.right)}(n);case 188:return X;case 177:return function(t,n){return au(uu(t),e.indexOf(t.elements,n))}(n,t);case 198:return function(e){return ou(uu(e.parent))}(n);case 261:return cu(n);case 262:return function(e){return ru(cu(e),e.objectAssignmentInitializer)}(n)}return Q}function _u(e){return e.initializer?function(e){return yn(e).resolvedType||Td(e)}(e.initializer):215===e.parent.parent.kind?ee:216===e.parent.parent.kind&&Ap(e.parent.parent.expression,e.parent.parent.awaitModifier)||Q}function lu(t){return 226===t.kind?_u(t):function(t){var n=t.parent,r=lu(n.parent);return ru(174===n.kind?iu(r,t.propertyName||t.name):t.dotDotDotToken?ou(r):au(r,e.indexOf(n.elements,t)),t.initializer)}(t)}function du(e){return 226===e.kind||176===e.kind?lu(e):uu(e)}function pu(e){switch(e.kind){case 185:return pu(e.expression);case 194:switch(e.operatorToken.kind){case 58:return pu(e.left);case 26:return pu(e.right)}}return e}function fu(e){var t=e.parent;return 185===t.kind||194===t.kind&&58===t.operatorToken.kind&&t.left===e||194===t.kind&&26===t.operatorToken.kind&&t.right===e?fu(t):e}function mu(e){if(257===e.kind){var t=us(Td(e.expression));return _c(t)?t:void 0}return se}function gu(t){var n=yn(t);if(!n.switchTypes){n.switchTypes=[];for(var r=0,i=t.caseBlock.clauses;r<i.length;r++){var a=mu(i[r]);if(void 0===a)return n.switchTypes=e.emptyArray;n.switchTypes.push(a)}}return n.switchTypes}function yu(e,t){return e===t||65536&t.flags&&function(e,t){if(65536&e.flags){for(var n=0,r=e.types;n<r.length;n++){var i=r[n];if(!Io(t.types,i))return!1}return!0}if(256&e.flags&&Ni(e)===t)return!0;return Io(t.types,e)}(e,t)}function hu(t,n){return 65536&t.flags?e.forEach(t.types,n):n(t)}function vu(t,n){if(65536&t.flags){var r=t.types,i=e.filter(r,n);return i===r?t:jo(i)}return n(t)?t:se}function bu(e,t){if(!(65536&e.flags))return t(e);for(var n,r,i=0,a=e.types;i<a.length;i++){var o=t(a[i]);o&&(n?r?r.push(o):r=[n,o]:n=o)}return r?zo(r):n}function xu(e,t){return vu(e,(function(e){return 0!=(e.flags&t)}))}function ku(e,t){return yu(ee,e)&&id(t,32)||yu(te,e)&&id(t,64)?bu(e,(function(e){return 2&e.flags?xu(t,34):4&e.flags?xu(t,68):e})):e}function Su(e){return 0===e.flags}function Du(e){return 0===e.flags?e.type:e}function Cu(e,t){return t?{flags:0,type:e}:e}function Tu(e){return V[e.id]||(V[e.id]=function(e){var t=sr(256);return t.elementType=e,t}(e))}function Eu(e,t){var n=dc(function(e){var t=e.contextualType;e.contextualType=H;var n=Td(e);return e.contextualType=t,n}(t));return yu(n,e.elementType)?e:Tu(zo([e.elementType,n]))}function Nu(e){return e.finalArrayType||(e.finalArrayType=8192&(t=e.elementType).flags?Fe:wo(65536&t.flags?zo(t.types,!0):t));var t}function Au(e){return 256&hn(e)?Nu(e):e}function wu(e){return 256&hn(e)?e.elementType:se}function Pu(t,n){return function(e){for(var t=!1,n=0,r=e;n<r.length;n++){var i=r[n];if(!(8192&i.flags)){if(!(256&hn(i)))return!1;t=!0}}return t}(t)?Tu(zo(e.map(t,wu))):zo(e.sameMap(t,Au),n)}function Fu(t){var n=fu(t),r=n.parent,i=179===r.kind&&("length"===r.name.escapedText||181===r.parent.kind&&e.isPushOrUnshiftIdentifier(r.name)),a=180===r.kind&&r.expression===n&&194===r.parent.kind&&58===r.parent.operatorToken.kind&&r.parent.left===r&&!e.isAssignmentTarget(r.parent)&&ad(Td(r.argumentExpression),84);return i||a}function Ou(t){var n=yn(t);return void 0===n.maybeTypePredicate&&(n.maybeTypePredicate=function(t){if(97!==t.expression.kind){var n=V_(t.expression);if(n!==ce){var r=ma(n);if(r!==Q){var i=xa(r,0);return!!e.forEach(i,(function(e){return e.typePredicate}))}}}return!1}(t)),n.maybeTypePredicate}function Iu(t,n,r,i,o){var s;void 0===r&&(r=n);var c=0;if(_t)return Q;if(!t.flowNode||!o&&!(17810175&n.flags))return n;var u=ut,_=Du(d(t.flowNode));ut=u;var l=256&hn(_)&&Fu(t)?Pe:Au(_);return 203===t.parent.kind&&8192&nu(l,524288).flags?n:l;function d(a){if(2500===c)return _t=!0,o=t,s=e.findAncestor(o,e.isFunctionOrModuleBlock),_=e.getSourceFileOfNode(o),l=e.getSpanOfTokenAtPosition(_,s.statements.pos),At.add(e.createFileDiagnostic(_,l.start,l.length,e.Diagnostics.The_containing_function_or_module_body_is_too_large_for_control_flow_analysis)),Q;var o,s,_,l;for(c++;;){var v=a.flags;if(1024&v)for(var b=u;b<ut;b++)if(Dt[b]===a)return c--,Ct[b];var x=void 0;if(4096&v)a.locked=!0,x=d(a.antecedent),a.locked=!1;else{if(2048&v){a=a.antecedent;continue}if(16&v){if(!(x=p(a))){a=a.antecedent;continue}}else if(96&v)x=m(a);else if(128&v)x=g(a);else if(12&v){if(1===a.antecedents.length){a=a.antecedents[0];continue}x=4&v?y(a):h(a)}else if(256&v){if(!(x=f(a))){a=a.antecedent;continue}}else if(2&v){var k=a.container;if(k&&k!==i&&179!==t.kind&&99!==t.kind){a=k.flowNode;continue}x=r}else x=kp(n)}return 1024&v&&(Dt[ut]=a,Ct[ut]=x,ut++),c--,x}}function p(r){var i=r.node;if(Gc(t,i)){if(2===e.getAssignmentTargetKind(i)){var a=d(r.antecedent);return Cu(dc(Du(a)),Su(a))}if(n===G||n===Fe){if(function(e){return 226===e.kind&&e.initializer&&Qr(e.initializer)||176!==e.kind&&194===e.parent.kind&&Qr(e.parent.right)}(i))return Tu(se);var o=dc(du(i));return Os(o,n)?o:Pe}return 65536&n.flags?eu(n,du(i)):n}if(Qc(t,i))return n}function f(e){if(n===G||n===Fe){var r=e.node,i=181===r.kind?r.expression.expression:r.left.expression;if(Gc(t,pu(i))){var a=d(e.antecedent),o=Du(a);if(256&hn(o)){var s=o;if(181===r.kind)for(var c=0,u=r.arguments;c<u.length;c++){s=Eu(s,u[c])}else ad(Td(r.left.argumentExpression),84)&&(s=Eu(s,r.right));return s===o?a:Cu(s,Su(a))}return a}}}function m(e){var t=d(e.antecedent),n=Du(t);if(8192&n.flags)return t;var r=0!=(32&e.flags),i=Au(n),a=A(i,e.expression,r);if(a===i)return t;var o=Su(t);return Cu(o&&8192&a.flags?ce:a,o)}function g(e){var n=d(e.antecedent),r=Du(n),i=e.switchStatement.expression;return Gc(t,i)?r=C(r,e.switchStatement,e.clauseStart,e.clauseEnd):v(i,r)&&(r=b(r,i,(function(t){return C(t,e.switchStatement,e.clauseStart,e.clauseEnd)}))),Cu(r,Su(n))}function y(t){for(var i=[],a=!1,o=!1,s=0,c=t.antecedents;s<c.length;s++){var u=c[s];if(!(2048&u.flags&&u.lock.locked)){var _=d(u),l=Du(_);if(l===n&&n===r)return l;e.pushIfUnique(i,l),yu(l,n)||(a=!0),Su(_)&&(o=!0)}}return Cu(Pu(i,a),o)}function h(r){var i=function(e){return e.id||(e.id=a,a++),e.id}(r),o=bt[i]||(bt[i]=e.createMap());if(!s&&!(s=Wc(t)))return n;var c=o.get(s);if(c)return c;for(var u=st;u<ct;u++)if(xt[u]===r&&kt[u]===s&&St[u].length)return Cu(Pu(St[u],!1),!0);var _,l=[],p=!1;xt[ct]=r,kt[ct]=s,St[ct]=l;for(var f=0,m=r.antecedents;f<m.length;f++){var g=m[f];ct++;var y=d(g);ct--,_||(_=y);var h=Du(y),v=o.get(s);if(v)return v;if(e.pushIfUnique(l,h),yu(h,n)||(p=!0),h===n)break}var b=Pu(l,p);return Su(_)?Cu(b,!0):(o.set(s,b),b)}function v(e,n){return 179===e.kind&&65536&n.flags&&Gc(t,e.expression)&&Zc(n,e.name.escapedText)}function b(e,t,n){var r=t.name.escapedText,i=Kr(e,r),a=i&&n(i);return i===a?e:vu(e,(function(e){return Rs(Kr(e,r),a)}))}function x(e,r,i){return Gc(t,r)?nu(e,i?1048576:2097152):v(r,n)?b(e,r,(function(e){return nu(e,i?1048576:2097152)})):Xc(t,r)?n:e}function k(r,i,a){switch(i.operatorToken.kind){case 58:return x(r,i.left,a);case 32:case 33:case 34:case 35:var o=i.operatorToken.kind,s=pu(i.left),c=pu(i.right);if(189===s.kind&&9===c.kind)return D(r,s,o,c,a);if(189===c.kind&&9===s.kind)return D(r,c,o,s,a);if(Gc(t,s))return S(r,o,c,a);if(Gc(t,c))return S(r,o,s,a);if(v(s,n))return b(r,s,(function(e){return S(e,o,c,a)}));if(v(c,n))return b(r,c,(function(e){return S(e,o,s,a)}));if(Xc(t,s)||Xc(t,c))return n;break;case 93:return function(r,i,a){var o=pu(i.left);if(!Gc(t,o))return Qc(t,o)?n:r;var s,c=Td(i.right);if(!Fs(c,Se))return r;var u=va(c,"prototype");if(u){var _=ci(u);Ur(_)||(s=_)}if(Ur(r)&&(s===ke||s===Se))return r;if(!s){var l=void 0;2&hn(c)?l=Ji(c).declaredConstructSignatures:16&hn(c)&&(l=xa(c,1)),l&&l.length&&(s=zo(e.map(l,(function(e){return La(za(e))}))))}if(s)return T(r,s,a,Is);return r}(r,i,a);case 26:return A(r,i.right,a)}return r}function S(e,t,n,r){if(1&e.flags)return e;33!==t&&35!==t||(r=!r);var i=Td(n);if(6144&i.flags)return N?nu(e,32===t||33===t?r?65536:524288:95===n.kind?r?32768:262144:r?16384:131072):e;if(16810497&e.flags)return e;if(r){var a=vu(e,(function(e){return Rs(t=e,n=i)||Rs(n,t);var t,n}));return 8192&a.flags?e:ku(a,i)}if(_c(i)){var o=us(i);return vu(e,(function(e){return us(e)!==o}))}return e}function D(e,r,i,a,o){var s=pu(r.expression);if(!Gc(t,s))return Qc(t,s)?n:e;if(33!==i&&35!==i||(o=!o),o&&!(65536&e.flags)){var c=zt.get(a.text);if(c){if(Fs(c,e))return c;if(540672&e.flags)if(Fs(c,_a(e)||H))return Vo([e,c])}}return nu(e,o?Bt.get(a.text)||64:Jt.get(a.text)||8192)}function C(t,n,r,i){var a=gu(n);if(!a.length)return t;var o=a.slice(r,i),s=r===i||e.contains(o,se),c=zo(o),u=8192&c.flags?se:ku(vu(t,(function(e){return Rs(c,e)})),c);if(!s)return u;var _=vu(t,(function(t){return!(_c(t)&&e.contains(a,us(t)))}));return 8192&u.flags?_:zo([u,_])}function T(e,t,n,r){if(!n)return vu(e,(function(e){return!r(e,t)}));if(65536&e.flags){var i=vu(e,(function(e){return r(e,t)}));if(!(8192&i.flags))return i}return Fs(t,e)?t:Os(e,t)?e:Os(t,e)?t:Vo([e,t])}function E(r,i,a){if(!function(e,t){if(e.arguments)for(var n=0,r=e.arguments;n<r.length;n++)if($c(t,r[n]))return!0;return!(179!==e.expression.kind||!$c(t,e.expression.expression))}(i,t)||!Ou(i))return r;var o=Pl(i),s=o.typePredicate;if(!s)return r;if(Ur(r)&&(s.type===ke||s.type===Se))return r;if(e.isIdentifierTypePredicate(s)){var c=i.arguments[s.parameterIndex-(o.thisParameter?1:0)];if(c){if(Gc(t,c))return T(r,s.type,a,Fs);if(Qc(t,c))return n}}else{var u=e.skipParentheses(i.expression);if(180===u.kind||179===u.kind){var _=u,l=e.skipParentheses(_.expression);if(Gc(t,l))return T(r,s.type,a,Fs);if(Qc(t,l))return n}}return r}function A(e,t,n){switch(t.kind){case 71:case 99:case 97:case 179:return x(e,t,n);case 181:return E(e,t,n);case 185:return A(e,t.expression,n);case 194:return k(e,t,n);case 192:if(51===t.operator)return A(e,t.operand,!n)}return e}}function Ru(t){return e.findAncestor(t.parent,(function(t){return e.isFunctionLike(t)&&!e.getImmediatelyInvokedFunctionExpression(t)||234===t.kind||265===t.kind||149===t.kind}))}function Lu(t){var n,r=e.getRootDeclaration(t.valueDeclaration).parent,i=yn(r);return 4194304&i.flags||(i.flags|=4194304,n=r,e.findAncestor(n.parent,(function(t){return e.isFunctionLike(t)&&!!(4194304&yn(t).flags)}))||Mu(r)),t.isAssigned||!1}function Mu(t){if(71===t.kind){if(e.isAssignmentTarget(t)){var n=Vc(t);n.valueDeclaration&&146===e.getRootDeclaration(n.valueDeclaration).kind&&(n.isAssigned=!0)}}else e.forEachChild(t,Mu)}function Bu(e){return 3&e.flags&&0!=(2&j_(e))&&ci(e)!==Fe}function Ju(e){var t=e.parent;return 179===t.kind||181===t.kind&&t.expression===e||180===t.kind&&t.expression===e}function zu(e){return 540672&e.flags&&id(_a(e)||_e,6144)}function ju(e,t){var n=ci(e);return Ju(t)&&hu(n,zu)?bu(Ec(n),ma):n}function Ku(t){var n=Vc(t);if(n===q)return Q;if(n===M){var r=e.getContainingFunction(t);return D<2&&(187===r.kind?cn(t,e.Diagnostics.The_arguments_object_cannot_be_referenced_in_an_arrow_function_in_ES3_and_ES5_Consider_using_a_standard_function_expression):e.hasModifier(r,256)&&cn(t,e.Diagnostics.The_arguments_object_cannot_be_referenced_in_an_async_function_or_method_in_ES3_and_ES5_Consider_using_a_standard_function_or_method)),yn(r).flags|=8192,ci(n)}!In(n,107455)||qc(t)||If(Ln(n))||Bn(n);var i=nr(n),a=i.valueDeclaration;if(32&i.flags)if(229===a.kind&&e.nodeIsDecorated(a))for(r=e.getContainingClass(t);void 0!==r;){if(r===a&&r.name!==t){yn(a).flags|=8388608,yn(t).flags|=16777216;break}r=e.getContainingClass(r)}else if(199===a.kind)for(r=e.getThisContainer(t,!1);void 0!==r;){if(r.parent===a){149===r.kind&&e.hasModifier(r,32)&&(yn(a).flags|=8388608,yn(t).flags|=16777216);break}r=e.getThisContainer(r,!1)}hp(t,t),fp(t,t),mp(t,t),function(t,n){if(D>=2||0==(34&n.flags)||260===n.valueDeclaration.parent.kind)return;var r=e.getEnclosingBlockScopeContainer(n.valueDeclaration),i=function(t,n){return!!e.findAncestor(t,(function(t){return t===n?"quit":e.isFunctionLike(t)}))}(t.parent,r),a=r,o=!1;for(;a&&!e.nodeStartsNewLexicalEnvironment(a);){if(e.isIterationStatement(a,!1)){o=!0;break}a=a.parent}o&&(i&&(yn(a).flags|=65536),214===r.kind&&e.getAncestor(n.valueDeclaration,227).parent===r&&function(t,n){var r=t;for(;185===r.parent.kind;)r=r.parent;var i=!1;if(e.isAssignmentTarget(r))i=!0;else if(192===r.parent.kind||193===r.parent.kind){var a=r.parent;i=43===a.operator||44===a.operator}if(!i)return!1;return!!e.findAncestor(r,(function(e){return e===n?"quit":e===n.statement}))}(t,r)&&(yn(n.valueDeclaration).flags|=2097152),yn(n.valueDeclaration).flags|=262144);i&&(yn(n.valueDeclaration).flags|=131072)}(t,n);var o=ju(i,t),s=e.getAssignmentTargetKind(t);if(s){if(!(3&i.flags))return cn(t,e.Diagnostics.Cannot_assign_to_0_because_it_is_not_a_variable,Dr(n)),Q;if(ed(i))return cn(t,e.Diagnostics.Cannot_assign_to_0_because_it_is_a_constant_or_a_read_only_property,Dr(n)),Q}var c=2097152&i.flags;if(3&i.flags){if(1===s)return o}else{if(!c)return o;a=e.find(n.declarations,_)}if(!a)return o;for(var u=146===e.getRootDeclaration(a).kind,l=Ru(a),d=Ru(t),p=d!==l;d!==l&&(186===d.kind||187===d.kind||e.isObjectLiteralOrClassExpressionMethod(d))&&(Bu(i)||u&&!Lu(i));)d=Ru(d);var f=u||c||p||o!==G&&o!==Fe&&(!N||0!=(1&o.flags)||qc(t)||246===t.parent.kind)||203===t.parent.kind||e.isInAmbientContext(a),m=Iu(t,o,f?u?function(e,t){return N&&146===t.kind&&t.initializer&&2048&gc(e)&&!(2048&gc(Ed(t.initializer)))?nu(e,131072):e}(o,e.getRootDeclaration(a)):o:o===G||o===Fe?X:bc(o,2048),d,!f);if(o===G||o===Fe){if(m===G||m===Fe)return w&&(cn(e.getNameOfDeclaration(a),e.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined,Dr(n),Tr(m)),cn(t,e.Diagnostics.Variable_0_implicitly_has_an_1_type,Dr(n),Tr(m))),kp(m)}else if(!f&&!(2048&gc(o))&&2048&gc(m))return cn(t,e.Diagnostics.Variable_0_is_used_before_being_assigned,Dr(n)),o;return s?dc(m):m}function Uu(e,t){(yn(e).flags|=2,149===t.kind||152===t.kind)?yn(t.parent).flags|=4:yn(t).flags|=4}function Vu(t){return e.isSuperCall(t)?t:e.isFunctionLike(t)?void 0:e.forEachChild(t,Vu)}function qu(e){var t=yn(e);return void 0===t.hasSuperCall&&(t.superCall=Vu(e.body),t.hasSuperCall=!!t.superCall),t.superCall}function Wu(e){return ki(Fi(er(e)))===$}function Hu(t,n,r){var i=n.parent;if(e.getClassExtendsHeritageClauseElement(i)&&!Wu(i)){var a=qu(n);(!a||a.end>t.pos)&&cn(t,r)}}function Gu(t){var n=e.getThisContainer(t,!0),r=!1;switch(152===n.kind&&Hu(t,n,e.Diagnostics.super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class),187===n.kind&&(n=e.getThisContainer(n,!1),r=D<2),n.kind){case 233:cn(t,e.Diagnostics.this_cannot_be_referenced_in_a_module_or_namespace_body);break;case 232:cn(t,e.Diagnostics.this_cannot_be_referenced_in_current_location);break;case 152:Qu(t,n)&&cn(t,e.Diagnostics.this_cannot_be_referenced_in_constructor_arguments);break;case 149:case 148:e.hasModifier(n,32)&&cn(t,e.Diagnostics.this_cannot_be_referenced_in_a_static_property_initializer);break;case 144:cn(t,e.Diagnostics.this_cannot_be_referenced_in_a_computed_property_name)}if(r&&Uu(t,n),e.isFunctionLike(n)&&(!t_(t)||e.getThisParameter(n))){if(186===n.kind&&194===n.parent.kind&&3===e.getSpecialPropertyAssignmentKind(n.parent)){var i=Ed(n.parent.left.expression.expression).symbol;if(i&&i.members&&16&i.flags)return Ol(i)}var a=ii(n)||$u(n);if(a)return a}if(e.isClassLike(n.parent)){var o,s=er(n.parent);return Iu(t,o=e.hasModifier(n,32)?ci(s):Fi(s).thisType)}if(e.isInJavaScriptFile(t)&&((o=function(t){var n=e.getJSDocType(t);if(n&&273===n.kind){var r=n;if(r.parameters.length>0&&r.parameters[0].name&&"this"===r.parameters[0].name.escapedText)return ds(r.parameters[0].type)}}(n))&&o!==Q))return o;return P&&cn(t,e.Diagnostics.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation),H}function Qu(t,n){return!!e.findAncestor(t,(function(e){return e===n?"quit":146===e.kind}))}function Xu(t){var n=181===t.parent.kind&&t.parent.expression===t,r=e.getSuperContainer(t,!0),i=!1;if(!n)for(;r&&187===r.kind;)r=e.getSuperContainer(r,!0),i=D<2;var a=0;if(!function(t){if(!t)return!1;if(n)return 152===t.kind;if(e.isClassLike(t.parent)||178===t.parent.kind)return e.hasModifier(t,32)?151===t.kind||150===t.kind||153===t.kind||154===t.kind:151===t.kind||150===t.kind||153===t.kind||154===t.kind||149===t.kind||148===t.kind||152===t.kind;return!1}(r)){var o=e.findAncestor(t,(function(e){return e===r?"quit":144===e.kind}));return o&&144===o.kind?cn(t,e.Diagnostics.super_cannot_be_referenced_in_a_computed_property_name):n?cn(t,e.Diagnostics.Super_calls_are_not_permitted_outside_constructors_or_in_nested_functions_inside_constructors):r&&r.parent&&(e.isClassLike(r.parent)||178===r.parent.kind)?cn(t,e.Diagnostics.super_property_access_is_permitted_only_in_a_constructor_member_function_or_member_accessor_of_a_derived_class):cn(t,e.Diagnostics.super_can_only_be_referenced_in_members_of_derived_classes_or_object_literal_expressions),Q}if(n||152!==r.kind||Hu(t,r,e.Diagnostics.super_must_be_called_before_accessing_a_property_of_super_in_the_constructor_of_a_derived_class),a=e.hasModifier(r,32)||n?512:256,yn(t).flags|=a,151===r.kind&&e.hasModifier(r,256)&&(e.isSuperProperty(t.parent)&&e.isAssignmentTarget(t.parent)?yn(r).flags|=4096:yn(r).flags|=2048),i&&Uu(t.parent,r),178===r.parent.kind)return D<2?(cn(t,e.Diagnostics.super_is_only_allowed_in_members_of_object_literal_expressions_when_option_target_is_ES2015_or_higher),Q):H;var s=r.parent,c=Fi(er(s)),u=c&&Si(c)[0];return u?152===r.kind&&Qu(t,r)?(cn(t,e.Diagnostics.super_cannot_be_referenced_in_constructor_arguments),Q):512===a?ki(c):zi(u,c.thisType):(e.getClassExtendsHeritageClauseElement(s)||cn(t,e.Diagnostics.super_can_only_be_referenced_in_a_derived_class),Q)}function Yu(e){return 4&hn(e)&&e.target===we?e.typeArguments[0]:void 0}function Zu(t){return bu(t,(function(t){return 131072&t.flags?e.forEach(t.types,Yu):Yu(t)}))}function $u(t){if(187!==t.kind){if(Es(t)){var n=m_(t);if(n){var r=n.thisParameter;if(r)return ci(r)}}var i=e.isInJavaScriptFile(t);if(P||i){var a=function(e){return 151!==e.kind&&153!==e.kind&&154!==e.kind||178!==e.parent.kind?186===e.kind&&261===e.parent.kind?e.parent.parent:void 0:e.parent}(t);if(a){for(var o=c_(a),s=a,c=o;c;){var u=Zu(c);if(u)return Ss(u,__(a));if(261!==s.parent.kind)break;c=c_(s=s.parent.parent)}return o?xc(o):hd(a)}var _=t.parent;if(194===_.kind&&58===_.operatorToken.kind){var l=_.left;if(179===l.kind||180===l.kind){var d=l.expression;if(i&&e.isIdentifier(d)){var p=e.getSourceFileOfNode(_);if(p.commonJsModuleIndicator&&Vc(d)===p.symbol)return}return hd(d)}}}}}function e_(t){var n=t.parent;if(Es(n)){var r=e.getImmediatelyInvokedFunctionExpression(n);if(r&&r.arguments){var i=e.indexOf(n.parameters,t);if(t.dotDotDotToken){for(var a=[],o=i;o<r.arguments.length;o++)a.push(pc(Ed(r.arguments[o])));return a.length?wo(zo(a)):void 0}var s=yn(r),c=s.resolvedSignature;s.resolvedSignature=et;var u=i<r.arguments.length?pc(Ed(r.arguments[i])):t.initializer?void 0:Y;return s.resolvedSignature=c,u}var _=m_(n);if(_){var l=e.hasRestParameter(n),d=n.parameters.length-(l?1:0);i=e.indexOf(n.parameters,t);if(void 0===e.getThisParameter(n)||_.thisParameter||(e.Debug.assert(0!==i),i-=1),i<d)return zl(_,i);if(l&&i===n.parameters.length-1&&ac(_,n.parameters.length-1))return ci(e.lastOrUndefined(_.parameters))}}}function t_(t){for(;t.parent&&!e.isFunctionLike(t.parent);){if(146===t.parent.kind&&t.parent.initializer===t)return!0;t=t.parent}return!1}function n_(t){if(152===t.kind||e.getEffectiveReturnTypeNode(t)||Lp(t))return La(Oa(t));var n=p_(t);return n&&!function(e){return!e.resolvedReturnType&&Br(e,3)>=0}(n)?La(n):void 0}function r_(t,n){var r=gl(t),i=e.indexOf(r,n);if(i>=0)return zl(yn(t).resolvedSignature===nt?nt:Pl(t),i)}function i_(e,t){return bu(e,(function(e){var n=229376&e.flags?va(e,t):void 0;return n?ci(n):void 0}))}function a_(e,t){return bu(e,(function(e){return Sa(e,t)}))}function o_(t){var n=c_(t.parent);if(n){if(!e.hasDynamicName(t)){var r=i_(n,er(t).escapedName);if(r)return r}return h_(t.name)&&a_(n,1)||a_(n,0)}}function s_(e,t){return e&&(i_(e,""+t)||a_(e,1)||Pp(e,void 0,!1,!1,!1))}function c_(e){var t=u_(e);return t&&ma(t)}function u_(t){if(!pf(t)){if(t.contextualType)return t.contextualType;var n=t.parent;switch(n.kind){case 226:case 146:case 149:case 148:case 176:return function(t){var n=t.parent;if(t===n.initializer){var r=e.getEffectiveTypeAnnotationNode(n);if(r)return ds(r);if(146===n.kind){var i=e_(n);if(i)return i}if(e.isBindingPattern(n.name))return $r(n.name,!0,!1);if(e.isBindingPattern(n.parent)){var a=n.parent.parent,o=n.propertyName||n.name;if(176!==a.kind){var s=e.getEffectiveTypeAnnotationNode(a);if(s&&!e.isBindingPattern(o)){var c=e.getTextOfPropertyName(o);if(c)return Kr(ds(s),c)}}}}}(t);case 187:case 219:return function(t){var n=e.getContainingFunction(t);if(n){var r=e.getFunctionFlags(n);if(1&r)return;var i=n_(n);return 2&r?i&&Wd(i):i}}(t);case 197:return function(t){var n=e.getContainingFunction(t);if(n){var r=e.getFunctionFlags(n),i=n_(n);if(i)return t.asteriskToken?i:Ip(i,0!=(2&r))}}(n);case 181:case 182:return r_(n,t);case 184:case 202:return ds(n.type);case 194:return function(t){var n=t.parent,r=n.operatorToken.kind;if(e.isAssignmentOperator(r)){if(t===n.right){switch(e.getSpecialPropertyAssignmentKind(n)){case 0:break;case 5:if(!n.left.symbol)break;case 1:case 2:case 3:case 4:return}return Td(n.left)}}else{if(54===r){var i=u_(n);return i||t!==n.right||(i=Td(n.left,!0)),i}if((53===r||26===r)&&t===n.right)return u_(n)}}(t);case 261:case 262:return o_(n);case 263:return c_(n.parent);case 177:var r=n;return s_(c_(r),e.indexOfNode(r.elements,t));case 195:return function(e){var t=e.parent;return e===t.whenTrue||e===t.whenFalse?u_(t):void 0}(t);case 205:return e.Debug.assert(196===n.parent.kind),function(e,t){if(183===e.parent.kind)return r_(e.parent,t)}(n.parent,t);case 185:var i=e.isInJavaScriptFile(n)?e.getJSDocTypeTag(n):void 0;return i?ds(i.typeExpression.type):u_(n);case 256:return function(t){var n=u_(e.isJsxAttributeLike(t.parent)?t.parent.parent:t.parent.openingElement.attributes);if(n&&!Ur(n)){if(e.isJsxAttribute(t.parent))return i_(n,t.parent.name.escapedText);if(249===t.parent.kind){var r=P_();return r&&""!==r?i_(n,r):H}return n}}(n);case 253:case 255:return function(t){var n=u_(t.parent);if(e.isJsxAttribute(t)){if(!n||Ur(n))return;return i_(n,t.name.escapedText)}return n}(n);case 251:case 250:return L_(n)}}}function __(t){return(t=e.findAncestor(t,(function(e){return!!e.contextualMapper})))?t.contextualMapper:k}function l_(t,n){var r=ba(t,0);if(1===r.length){var i=r[0];if(!function(t,n){for(var r=0;r<n.parameters.length;r++){var i=n.parameters[r];if(i.initializer||i.questionToken||i.dotDotDotToken||Na(i))break}n.parameters.length&&e.parameterIsThisKeyword(n.parameters[0])&&r--;return(t.hasRestParameter?Number.MAX_VALUE:t.parameters.length)<r}(i,n))return i}}function d_(e){return 186===e.kind||187===e.kind}function p_(t){return d_(t)||e.isObjectLiteralMethod(t)?m_(t):void 0}function f_(t){return e.isObjectLiteralMethod(t)?function(t){if(e.Debug.assert(e.isObjectLiteralMethod(t)),!pf(t))return o_(t)}(t):c_(t)}function m_(t){e.Debug.assert(151!==t.kind||e.isObjectLiteralMethod(t));var n=f_(t);if(n){if(!(65536&n.flags))return l_(n,t);for(var r,i,a=0,o=n.types;a<o.length;a++){var s=l_(o[a],t);if(s)if(r){if(!ic(r[0],s,!1,!0,!0,ws))return;r.push(s)}else r=[s]}return r&&((i=Ui(r[0])).resolvedReturnType=void 0,i.unionSignatures=r),i}}function g_(e){return 176===e.kind&&!!e.initializer||194===e.kind&&58===e.operatorToken.kind}function y_(t,n){for(var r=t.elements,i=!1,a=[],o=e.isAssignmentTarget(t),s=c_(t),c=0;c<r.length;c++){var u=r[c];if(o&&198===u.kind){var _=Ed(u.expression,n),l=Ca(_,1)||Pp(_,void 0,!1,!1,!1);l&&a.push(l)}else{var d=kd(u,n,s_(s,c));a.push(d)}i=i||198===u.kind}if(!i){if(o&&a.length)return(d=Za(Fo(a))).pattern=t,d;var p=c_(t);if(p&&function(t){return!!(65536&t.flags?e.forEach(t.types,uc):uc(t))}(p)){var f=p.pattern;if(f&&(175===f.kind||177===f.kind))for(var m=f.elements,g=a.length;g<m.length;g++){var y=m[g];g_(y)?a.push(p.typeArguments[g]):(200!==y.kind&&cn(y,e.Diagnostics.Initializer_provides_no_value_for_this_binding_element_and_the_binding_element_has_no_default_value),a.push(Q))}if(a.length)return Fo(a)}}return wo(a.length?zo(a,!0):N?se:Y)}function h_(e){switch(e.kind){case 144:return function(e){return ad(b_(e),84)}(e);case 71:return v_(e.escapedText);case 8:case 9:return v_(e.text);default:return!1}}function v_(e){return(+e).toString()===e}function b_(t){var n=yn(t.expression);return n.resolvedType||(n.resolvedType=Ed(t.expression),6144&n.resolvedType.flags||!ad(n.resolvedType,262774)&&!Os(n.resolvedType,zo([ee,te,ae]))?cn(t,e.Diagnostics.A_computed_property_name_must_be_of_type_string_number_symbol_or_any):il(t.expression,n.resolvedType,!0)),n.resolvedType}function x_(e,t,n,r){for(var i=[],a=0;a<n.length;a++)(0===r||h_(e[a+t].name))&&i.push(ci(n[a]));return qa(i.length?zo(i,!0):X,!1)}function k_(t,n){var r=e.isAssignmentTarget(t);!function(t,n){for(var r=e.createUnderscoreEscapedMap(),i=1,a=2,o=4,s=a|o,c=0,u=t.properties;c<u.length;c++){var _=u[c];if(263!==_.kind){var l=_.name;if(144===l.kind&&lm(l),262===_.kind&&!n&&_.objectAssignmentInitializer)return Tm(_.equalsToken,e.Diagnostics.can_only_be_used_in_an_object_literal_property_inside_a_destructuring_assignment);if(_.modifiers)for(var d=0,p=_.modifiers;d<p.length;d++){var f=p[d];120===f.kind&&151===_.kind||Tm(f,e.Diagnostics._0_modifier_cannot_be_used_here,e.getTextOfNode(f))}var m=void 0;261===_.kind||262===_.kind?(pm(_.questionToken,e.Diagnostics.An_object_member_cannot_be_declared_optional),8===l.kind&&Am(l),m=i):151===_.kind?m=i:153===_.kind?m=a:154===_.kind?m=o:e.Debug.assertNever(_,"Unexpected syntax kind:"+_.kind);var g=e.getPropertyNameForPropertyNameNode(l);if(void 0!==g){var y=r.get(g);if(y)if(m===i&&y===i)Tm(l,e.Diagnostics.Duplicate_identifier_0,e.getTextOfNode(l));else{if(!(m&s&&y&s))return Tm(l,e.Diagnostics.An_object_literal_cannot_have_property_and_accessor_with_the_same_name);if(y===s||m===y)return Tm(l,e.Diagnostics.An_object_literal_cannot_have_multiple_get_Slashset_accessors_with_the_same_name);r.set(g,m|y)}else r.set(g,m)}}}}(t,r);for(var i=e.createSymbolTable(),a=[],o=_e,s=0,c=c_(t),u=c&&c.pattern&&(174===c.pattern.kind||178===c.pattern.kind),_=!c&&e.isInJavaScriptFile(t),l=0,d=!1,p=!1,f=!1,m=e.isInJavaScriptFile(t),g=0,y=0;y<t.properties.length;y++){var h=t.properties[y],v=h.symbol,b=void 0;if(261===h.kind||262===h.kind||e.isObjectLiteralMethod(h)){var x=void 0;m&&(x=Gr(h));var k=void 0;if(261===h.kind){if(144===h.name.kind){var C=b_(h.name);224&C.flags&&(b=e.escapeLeadingUnderscores(""+C.value))}k=Sd(h,n)}else 151===h.kind?k=Dd(h,n):(e.Debug.assert(262===h.kind),k=kd(h.name,n));x&&(Ls(k,x,h),k=x),l|=k.flags;var T=un(4|v.flags,b||v.escapedName);if(r)(261===h.kind&&g_(h.initializer)||262===h.kind&&h.objectAssignmentInitializer)&&(T.flags|=16777216),!b&&e.hasDynamicName(h)&&(d=!0);else if(u&&!(512&hn(c))){var E=va(c,v.escapedName);E?T.flags|=16777216&E.flags:S.suppressExcessPropertyErrors||Da(c,0)||cn(h.name,e.Diagnostics.Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1,Dr(v),Tr(c))}T.declarations=v.declarations,T.parent=v.parent,v.valueDeclaration&&(T.valueDeclaration=v.valueDeclaration),T.type=k,T.target=v,v=T}else{if(263===h.kind){if(D<2&&$f(h,2),a.length>0&&(o=is(o,w(),t.symbol,s),a=[],i=e.createSymbolTable(),p=!1,f=!1,l=0),!S_(k=Ed(h.expression)))return cn(h,e.Diagnostics.Spread_types_may_only_be_created_from_object_types),Q;o=is(o,k,t.symbol,s),g=y+1;continue}e.Debug.assert(153===h.kind||154===h.kind),uf(h)}!b&&e.hasDynamicName(h)?h_(h.name)?f=!0:p=!0:i.set(v.escapedName,v),a.push(v)}if(u)for(var N=0,A=sa(c);N<A.length;N++){T=A[N];i.get(T.escapedName)||(16777216&T.flags||cn(T.valueDeclaration||T.bindingElement,e.Diagnostics.Initializer_provides_no_value_for_this_binding_element_and_the_binding_element_has_no_default_value),i.set(T.escapedName,T),a.push(T))}return o!==_e?(a.length>0&&(o=is(o,w(),t.symbol,s)),o):w();function w(){var n=_?at:p?x_(t.properties,g,a,0):void 0,o=f&&!_?x_(t.properties,g,a,1):void 0,c=lr(t.symbol,i,e.emptyArray,e.emptyArray,n,o),u=S.suppressExcessPropertyErrors?0:1048576;return c.flags|=4194304|u|14680064&l,c.objectFlags|=128,d&&(c.objectFlags|=512),r&&(c.pattern=t),6144&c.flags||(s|=14680064&c.flags),c}}function S_(t){return!!(16777217&t.flags||7392&gc(t)&&S_(yc(t))||32768&t.flags&&!ra(t)||196608&t.flags&&!e.forEach(t.types,(function(e){return!S_(e)})))}function D_(t){return!e.stringContains(t,"-")}function C_(t){switch(t.kind){case 179:case 99:return!1;case 71:return e.isIntrinsicJsxName(t.escapedText);default:e.Debug.fail()}}function T_(t,n,r){for(var i,a=t.attributes,o=e.createSymbolTable(),s=_e,c=[],u=!1,_=!1,l=P_(),d=0,p=a.properties;d<p.length;d++){var f=p[d],m=f.symbol;if(e.isJsxAttribute(f)){var g=f.initializer?Ed(f.initializer,r):ne,y=un(33554436|m.flags,m.escapedName);y.declarations=m.declarations,y.parent=m.parent,m.valueDeclaration&&(y.valueDeclaration=m.valueDeclaration),y.type=g,y.target=m,o.set(y.escapedName,y),c.push(y),f.name.escapedText===l&&(_=!0)}else{e.Debug.assert(255===f.kind),c.length>0&&(s=is(s,N(a.symbol,o),t.symbol,0),c=[],o=e.createSymbolTable()),Ur(g=Ed(f.expression))&&(u=!0),S_(g)?s=is(s,g,t.symbol,0):i=i?Vo([i,g]):g}}if(!u){s!==_e&&(c.length>0&&(s=is(s,N(a.symbol,o),t.symbol,0)),c=sa(s)),o=e.createSymbolTable();for(var h=0,v=c;h<v.length;h++){var b=v[h];n&&!n(b)||o.set(b.escapedName,b)}}var x=249===t.parent.kind?t.parent:void 0;if(x&&x.openingElement===t&&x.children.length>0){for(var k=[],S=0,D=x.children;S<D.length;S++){var C=D[S];10===C.kind?C.containsOnlyWhiteSpaces||k.push(ee):k.push(Ed(C,r))}if(!u&&l&&""!==l){_&&cn(a,e.Diagnostics._0_are_specified_twice_The_attribute_named_0_will_be_overwritten,e.unescapeLeadingUnderscores(l));var T=un(33554436,l);T.type=1===k.length?k[0]:wo(zo(k,!1)),o.set(l,T)}}if(u)return H;var E=N(a.symbol,o);return i&&o.size?Vo([i,E]):i||E;function N(t,n){var r=lr(t,n,e.emptyArray,e.emptyArray,void 0,void 0);return r.flags|=37748736,r.objectFlags|=128,r}}function E_(e){var t=Vt.get(e);return void 0===t&&Vt.set(e,t=Do(qt,e)||Q),t}function N_(t){var n=yn(t);if(!n.resolvedSymbol){var r=E_(Wt);if(r!==Q){if(!e.isIdentifier(t.tagName))throw e.Debug.fail();var i=va(r,t.tagName.escapedText);return i?(n.jsxFlags|=1,n.resolvedSymbol=i):Ca(r,0)?(n.jsxFlags|=2,n.resolvedSymbol=r.symbol):(cn(t,e.Diagnostics.Property_0_does_not_exist_on_type_1,e.idText(t.tagName),"JSX."+Wt),n.resolvedSymbol=q)}return w&&cn(t,e.Diagnostics.JSX_element_implicitly_has_type_any_because_no_interface_JSX_0_exists,e.unescapeLeadingUnderscores(Wt)),n.resolvedSymbol=q}return n.resolvedSymbol}function A_(t){var n=lo(qt,1920,void 0),r=n&&bn(n.exports,t,793064),i=r&&Fi(r),a=i&&sa(i);if(a){if(0===a.length)return"";if(1===a.length)return a[0].escapedName;a.length>1&&cn(r.declarations[0],e.Diagnostics.The_global_type_JSX_0_may_not_have_more_than_one_property,e.unescapeLeadingUnderscores(t))}}function w_(){return Kt||(Kt=!0,Ft=A_(Gt)),Ft}function P_(){return Ut||(Ut=!0,Ot=A_(Qt)),Ot}function F_(e){if(e){if(131072&e.flags){for(var t=[],n=0,r=e.types;n<r.length;n++){var i=r[n];t.push(ma(i))}return Vo(t)}return ma(e)}}function O_(t,n,r,i){if(void 0===r&&(r=Ed(t.tagName)),65536&r.flags)return zo(r.types.map((function(e){return O_(t,n,e,i)})),!0);if(2&r.flags)return H;if(32&r.flags){var a=E_(Wt);if(a!==Q){var o=r.value,s=va(a,e.escapeLeadingUnderscores(o));if(s)return ci(s);var c=Ca(a,0);if(c)return c;cn(t,e.Diagnostics.Property_0_does_not_exist_on_type_1,o,"JSX."+Wt)}return H}var u=function(t,n){if(e.Debug.assert(!(65536&n.flags)),Ur(n))return H;var r=xa(n,1);if(0===r.length&&0===(r=xa(n,0)).length)return cn(t.tagName,e.Diagnostics.JSX_element_type_0_does_not_have_any_construct_or_call_signatures,e.getTextOfNode(t.tagName)),Q;for(var i=[],a=0,o=r;a<o.length;a++){var s=o[a];if(s.typeParameters){var c=e.isInJavaScriptFile(t),u=Fa(void 0,s.typeParameters,0,c);i.push(Ba(s,u,c))}else i.push(s)}return zo(e.map(i,La),!0)}(t,r),_=n?function(t,n,r,i){if(e.Debug.assert(!(65536&n.flags)),!i||!Os(r,i)){var a=B_();if(a){var o=[];Nl(t,n,o);for(var s=void 0,c=void 0,u=0,_=o;u<_.length;u++){var l=_[u],d=La(l),p=d&&(0===l.parameters.length?_e:ci(l.parameters[0]));if(p=F_(p),d&&Os(d,a)){for(var f=!0,m=0,g=t.attributes.properties;m<g.length;m++){var y=g[m];if(e.isJsxAttribute(y)&&D_(y.name.escapedText)&&!va(p,y.name.escapedText)){f=!1;break}}f&&(s=Gi(s,p)),c=Gi(c,p)}}s||(s=c);var h=E_(Yt);return h!==Q&&(s=Gi(h,s)),s}}}(t,r,u,i):function(t,n,r,i){if(e.Debug.assert(!(65536&n.flags)),!i||!Os(r,i)){var a=B_();if(a){var o=Nl(t,n,void 0);if(o!==tt){var s=o&&La(o),c=s&&(0===o.parameters.length?_e:ci(o.parameters[0]));if(c=F_(c),s&&Os(s,a)){var u=E_(Yt);return u!==Q&&(c=Gi(u,c)),c}}}}}(t,r,u,i);if(_)return _;if(i&&qs(u,i,en,t,e.Diagnostics.JSX_element_type_0_is_not_a_constructor_function_for_JSX_elements),Ur(u))return u;var l=w_();if(void 0===l)return H;if(""===l)return u;var d=Kr(u,l);if(d){if(Ur(d)||d===Q)return d;var p=d,f=E_(Zt);if(f!==Q){var m=mi(f.symbol);m?1===m.length&&(p=Gi(Ya(f,[u]),p)):p=Gi(d,f)}var g=E_(Yt);return g!==Q&&(p=Gi(g,p)),p}return _e}function I_(t){e.Debug.assert(C_(t.tagName));var n=yn(t);if(!n.resolvedJsxElementAttributesType){var r=N_(t);return 1&n.jsxFlags?n.resolvedJsxElementAttributesType=ci(r):2&n.jsxFlags?n.resolvedJsxElementAttributesType=Wa(r,0).type:n.resolvedJsxElementAttributesType=Q}return n.resolvedJsxElementAttributesType}function R_(e,t){var n=yn(e),r=t?"resolvedJsxElementAllAttributesType":"resolvedJsxElementAttributesType";if(!n[r]){var i=function(){He||(He=Do(qt,Ht));return He}();return n[r]=O_(e,t,void 0,i)}return n[r]}function L_(e){return C_(e.tagName)?I_(e):R_(e,!1)}function M_(){return Ge||(Ge=Do(qt,Xt)),Ge}function B_(){if(!Qe){var e=M_();e&&(Qe=zo([e,Z]))}return Qe}function J_(t){var n;!function(t){for(var n=e.createUnderscoreEscapedMap(),r=0,i=t.attributes.properties;r<i.length;r++){var a=i[r];if(255!==a.kind){var o=a,s=o.name;if(n.get(s.escapedText))return Tm(s,e.Diagnostics.JSX_elements_cannot_have_multiple_attributes_with_the_same_name);n.set(s.escapedText,!0);var c=o.initializer;if(c&&256===c.kind&&!c.expression)return Tm(o.initializer,e.Diagnostics.JSX_attributes_must_only_be_assigned_a_non_empty_expression)}}}(t),n=t,0===(S.jsx||0)&&cn(n,e.Diagnostics.Cannot_use_JSX_unless_the_jsx_flag_is_provided),void 0===M_()&&w&&cn(n,e.Diagnostics.JSX_element_implicitly_has_type_any_because_the_global_type_JSX_Element_does_not_exist);var r=At&&2===S.jsx?e.Diagnostics.Cannot_find_name_0:void 0,i=sn(),a=kn(t.tagName,i,107455,r,i,!0);a&&(a.isReferenced=!0,2097152&a.flags&&!If(Ln(a))&&Bn(a)),function(t){var n=C_(t.tagName)?I_(t):R_(t,!1),r=T_(t,(function(e){return D_(e.escapedName)||!!va(n,e.escapedName)}));if(n===_e&&(Ur(r)||r.properties.length>0))cn(t,e.Diagnostics.JSX_element_class_does_not_support_attributes_because_it_does_not_have_a_0_property,e.unescapeLeadingUnderscores(w_()));else{if(Ls(r,n,t.attributes.properties.length>0?t.attributes:t)&&!Ur(r)&&!Ur(n))for(var i=0,a=t.attributes.properties;i<a.length;i++){var o=a[i];if(e.isJsxAttribute(o)&&!z_(n,o.name.escapedText,!0)){cn(o,e.Diagnostics.Property_0_does_not_exist_on_type_1,e.idText(o.name),Tr(n));break}}}}(t)}function z_(e,t,n){if(32768&e.flags){var r=ia(e);if(r.stringIndexInfo||r.numberIndexInfo&&v_(t)||oa(e,t)||n&&!D_(t))return!0}else if(196608&e.flags)for(var i=0,a=e.types;i<a.length;i++){if(z_(a[i],t,n))return!0}return!1}function j_(t){return t.valueDeclaration?e.getCombinedNodeFlags(t.valueDeclaration):0}function K_(t){return!!(8192&t.flags||4&e.getCheckFlags(t))}function U_(t,n,r,i){var a=e.getDeclarationModifierFlagsFromSymbol(i),o=179===t.kind||226===t.kind?t.name:t.right;if(256&e.getCheckFlags(i))return cn(o,e.Diagnostics.Property_0_has_conflicting_declarations_and_is_inaccessible_in_type_1,Dr(i),Tr(r)),!1;if(97===n.kind){if(D<2)if(Zs(i,(function(e){var t,n=(t=e).valueDeclaration?t.valueDeclaration.kind:149;return 151!==n&&150!==n})))return cn(o,e.Diagnostics.Only_public_and_protected_methods_of_the_base_class_are_accessible_via_the_super_keyword),!1;if(128&a)return cn(o,e.Diagnostics.Abstract_method_0_in_class_1_cannot_be_accessed_via_super_expression,Dr(i),Tr($s(i))),!1}if(!(24&a))return!0;if(8&a)return!!yf(t,Wp(tr(i)))||(cn(o,e.Diagnostics.Property_0_is_private_and_only_accessible_within_class_1,Dr(i),Tr($s(i))),!1);if(97===n.kind)return!0;var s=gf(t,(function(t){var n=Fi(er(t));return function(t,n){return Zs(n,(function(n){return!!(16&e.getDeclarationModifierFlagsFromSymbol(n))&&!li(t,$s(n))}))?void 0:t}(n,i)?n:void 0}));return s?!!(32&a)||(16384&r.flags&&r.isThisType&&(r=ca(r)),!!(3&hn(_i(r))&&li(r,s))||(cn(o,e.Diagnostics.Property_0_is_protected_and_only_accessible_through_an_instance_of_class_1,Dr(i),Tr(s)),!1)):(cn(o,e.Diagnostics.Property_0_is_protected_and_only_accessible_within_class_1_and_its_subclasses,Dr(i),Tr($s(i)||r)),!1)}function V_(e){return q_(Ed(e),e)}function q_(t,n){var r=6144&(N?gc(t):t.flags);if(r){cn(n,2048&r?4096&r?e.Diagnostics.Object_is_possibly_null_or_undefined:e.Diagnostics.Object_is_possibly_undefined:e.Diagnostics.Object_is_possibly_null);var i=xc(t);return 14336&i.flags?Q:i}return t}function W_(e){return G_(e,e.expression,e.name)}function H_(e){return G_(e,e.left,e.right)}function G_(t,n,r){var i=V_(n);if(Ur(i)||i===ce)return i;var a=ma(Ec(i));if(a===Q||16384&i.flags&&Ur(a))return a;var o=va(a,r.escapedText);if(!o){var s=Da(a,0);return s&&s.type?(s.isReadonly&&(e.isAssignmentTarget(t)||e.isDeleteTarget(t))&&cn(t,e.Diagnostics.Index_signature_in_type_0_only_permits_reading,Tr(a)),s.type):(r.escapedText&&!Tn(t)&&function(t,n){var r;if(65536&n.flags&&!(8190&n.flags))for(var i=0,a=n.types;i<a.length;i++){var o=a[i];if(!va(o,t.escapedText)){r=e.chainDiagnosticMessages(r,e.Diagnostics.Property_0_does_not_exist_on_type_1,e.declarationNameToString(t),Tr(o));break}}var s=X_(t,n);r=void 0!==s?e.chainDiagnosticMessages(r,e.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_2,e.declarationNameToString(t),Tr(n),s):e.chainDiagnosticMessages(r,e.Diagnostics.Property_0_does_not_exist_on_type_1,e.declarationNameToString(t),Tr(n));At.add(e.createDiagnosticForNodeFromMessageChain(t,r))}(r,16384&i.flags&&i.isThisType?a:i),Q)}!function(t,n,r){var i=t.valueDeclaration;if(!i)return;!function(t){return!!e.findAncestor(t,(function(t){switch(t.kind){case 149:return!0;case 261:return!1;default:return!e.isPartOfExpression(t)&&"quit"}}))}(n)||xn(i,r)||function(e){var t=ci(e.parent);for(;;){if(!(t=Q_(t)))return!1;var n=oa(t,e.escapedName);if(n&&n.valueDeclaration)return!0}}(t)?229!==i.kind||159===n.parent.kind||e.isInAmbientContext(i)||xn(i,r)||cn(r,e.Diagnostics.Class_0_used_before_its_declaration,e.idText(r)):cn(r,e.Diagnostics.Block_scoped_variable_0_used_before_its_declaration,e.idText(r))}(o,t,r),$_(o,t,99===n.kind),yn(t).resolvedSymbol=o,U_(t,n,a,o);var c=ju(o,t),u=e.getAssignmentTargetKind(t);if(u&&(td(t,o)||nd(t)))return cn(r,e.Diagnostics.Cannot_assign_to_0_because_it_is_a_constant_or_a_read_only_property,e.idText(r)),Q;if(!(179===t.kind&&1!==u&&(98311&o.flags||8192&o.flags&&65536&c.flags)))return c;var _=Iu(t,c);return u?dc(_):_}function Q_(t){var n=Si(t);if(0!==n.length)return e.Debug.assert(1===n.length),n[0]}function X_(t,n){var r=Z_(e.idText(t),sa(n),107455);return r&&e.symbolName(r)}function Y_(t,n,r){var i=Sn(t,n,r,void 0,n,!1,(function(t,n,r){return bn(t,n,r)||Z_(e.unescapeLeadingUnderscores(n),e.arrayFrom(t.values()),r)}));return i&&e.symbolName(i)}function Z_(t,n,r){var i=.4*t.length,a=Math.min(3,.34*t.length),o=Number.MAX_VALUE,s=void 0,c=!1;if(!(t.length>30)){t=t.toLowerCase();for(var u=0,_=n;u<_.length;u++){var l=_[u],d=e.symbolName(l);if(l.flags&r&&d&&Math.abs(d.length-t.length)<a){if((d=d.toLowerCase())===t)return l;if(c)continue;if(d.length<3||t.length<3||"eval"===d||"intl"===d||"undefined"===d||"map"===d||"nan"===d||"set"===d)continue;var p=e.levenshtein(t,d);if(p>i)continue;p<3?(c=!0,s=l):p<o&&(o=p,s=l)}}return s}}function $_(t,n,r){if(t&&T&&106500&t.flags&&t.valueDeclaration&&e.hasModifier(t.valueDeclaration,8)&&(!n||!e.isWriteOnlyAccess(n))){if(r){var i=e.findAncestor(n,e.isFunctionLikeDeclaration);if(i&&i.symbol===t)return}1&e.getCheckFlags(t)?gn(t).target.isReferenced=!0:t.isReferenced=!0}}function el(t,n,r,i){if(i!==Q&&!Ur(i)){var a=va(i,r);if(a)return U_(t,n,i,a);if(e.isInJavaScriptFile(n)&&65536&i.flags)for(var o=0,s=i.types;o<s.length;o++){if(el(t,n,r,s[o]))return!0}return!1}return!0}function tl(t){var n=t.initializer;if(227===n.kind){var r=n.declarations[0];if(r&&!e.isBindingPattern(r.name))return er(r)}else if(71===n.kind)return Vc(n)}function nl(e){return Ca(e,1)&&!Ca(e,0)}function rl(t){var n=V_(t.expression),r=t.argumentExpression;if(!r){var i,a=e.getSourceFileOfNode(t);if(182===t.parent.kind&&t.parent.expression===t)Cm(a,i=e.skipTrivia(a.text,t.expression.end),t.end-i,e.Diagnostics.new_T_cannot_be_used_to_create_an_array_Use_new_Array_T_instead);else Cm(a,i=t.end-"]".length,t.end-i,e.Diagnostics.Expression_expected);return Q}var o=function(t){var n=e.skipParentheses(t);if(71===n.kind){var r=Vc(n);if(3&r.flags)for(var i=t,a=t.parent;a;){if(215===a.kind&&i===a.statement&&tl(a)===r&&nl(Td(a.expression)))return!0;i=a,a=a.parent}}return!1}(r)?te:Ed(r);return n===Q||n===ce?n:od(n)&&9!==r.kind?(cn(r,e.Diagnostics.A_const_enum_member_can_only_be_accessed_using_a_string_literal),Q):jd(Zo(n,o,t),t)}function il(t,n,r){if(n===Q)return!1;if(!e.isWellKnownSymbolSyntactically(t))return!1;if(0==(512&n.flags))return r&&cn(t,e.Diagnostics.A_computed_property_name_of_the_form_0_must_be_of_type_symbol,e.getTextOfNode(t)),!1;var i=t.expression,a=Vc(i);if(!a)return!1;var o,s=(o=!0,Ie||(Ie=_o("Symbol",o)));return!!s&&(a===s||(r&&cn(i,e.Diagnostics.Symbol_reference_does_not_refer_to_the_global_Symbol_constructor_object),!1))}function al(t){return e.isCallOrNewExpression(t)}function ol(t){return al(t)&&e.forEach(t.typeArguments,cf),183===t.kind?Ed(t.template):147!==t.kind&&e.forEach(t.arguments,(function(e){Ed(e)})),et}function sl(e){return ol(e),tt}function cl(e){for(var t=0;t<e.length;t++){var n=e[t];if(n&&198===n.kind)return t}return-1}function ul(t,n,r,i){var a,o,s;void 0===i&&(i=!1);var c=-1;if(e.isJsxOpeningLikeElement(t))return!0;if(183===t.kind){var u=t;if(a=n.length,o=void 0,196===u.template.kind){var _=u.template,l=e.lastOrUndefined(_.templateSpans);e.Debug.assert(void 0!==l),s=e.nodeIsMissing(l.literal)||!!l.literal.isUnterminated}else{var d=u.template;e.Debug.assert(13===d.kind),s=!!d.isUnterminated}}else if(147===t.kind)o=void 0,a=yl(t,void 0,r);else{var p=t;if(!p.arguments)return e.Debug.assert(182===p.kind),0===r.minArgumentCount;a=i?n.length+1:n.length,s=p.arguments.end===p.end,o=p.typeArguments,c=cl(n)}var f=e.length(r.typeParameters),m=Pa(r.typeParameters);if(!(!o||o.length>=m&&o.length<=f))return!1;if(c>=0)return ac(r,c)||c>=r.minArgumentCount;if(!r.hasRestParameter&&a>r.parameters.length)return!1;var g=a>=r.minArgumentCount;return s||g}function _l(e){if(32768&e.flags){var t=ia(e);if(1===t.callSignatures.length&&0===t.constructSignatures.length&&0===t.properties.length&&!t.stringIndexInfo&&!t.numberIndexInfo)return t.callSignatures[0]}}function ll(t,n,r,i){var a=Fc(t,1,i);return Pc(n,t,(function(e,t){Bc(a.inferences,Ss(e,r||k),t)})),r||Bc(a.inferences,La(n),La(t),8),Ba(t,Uc(a),e.isInJavaScriptFile(n.declaration))}function dl(t,n,r,i,a){for(var o=0,s=a.inferences;o<s.length;o++){var c=s[o];c.isFixed||(c.inferredType=void 0)}if(147!==t.kind){var u=u_(t);if(u){var _=Ss(u,function(e){return e&&function(e){return!!e.signature}(e)?Fc(e.signature,2|e.flags,e.compareTypes,e.inferences):e}(__(t))),l=_l(_),d=l&&l.typeParameters?Ka(Ba(l,l.typeParameters,e.isInJavaScriptFile(t))):_,p=La(n);Bc(a.inferences,d,p,8)}}var f=Ra(n);if(f){var m=ml(t),g=m?Ed(m):oe;Bc(a.inferences,g,f)}for(var y=yl(t,r,n),h=0;h<y;h++){if(void 0===(x=xl(t,r,h))||200!==x.kind){var v=zl(n,h),b=bl(t,h);if(void 0===b)b=yd(x,v,i&&void 0!==i[h]?k:a);Bc(a.inferences,b,v)}}if(i)for(h=0;h<y;h++)if(!1===i[h]){var x=r[h];v=zl(n,h);Bc(a.inferences,yd(x,v,a),v)}return Uc(a)}function pl(t,n,r,i){for(var a,o=e.isInJavaScriptFile(t.declaration),s=t.typeParameters,c=Fa(e.map(n,ds),s,Pa(s),o),u=0;u<n.length;u++){e.Debug.assert(void 0!==s[u],"Should not call checkTypeArguments with too many type arguments");var _=ca(s[u]);if(_){var l=r&&i&&e.chainDiagnosticMessages(void 0,e.Diagnostics.Type_0_does_not_satisfy_the_constraint_1),d=i||e.Diagnostics.Type_0_does_not_satisfy_the_constraint_1;a||(a=gs(s,c));var p=c[u];if(!Ls(p,zi(Ss(_,a),p),r?n[u]:void 0,d,l))return!1}}return c}function fl(t,n,r,i,a,o){if(e.isJsxOpeningLikeElement(t))return function(t,n,r){if(t.attributes.end===t.end)return!0;for(var i=e.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1,a=zl(n,0),o=yd(t.attributes,a,void 0),s=0,c=sa(o);s<c.length;s++){var u=c[s];if(!va(a,u.escapedName)&&D_(u.escapedName))return!1}return qs(o,a,r,void 0,i)}(t,r,i);var s=Ra(r);if(s&&s!==oe&&182!==t.kind){var c=ml(t),u=c?Ed(c):oe,_=o?c||t:void 0,l=e.Diagnostics.The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1;if(!qs(u,Ra(r),i,_,l))return!1}for(var d=e.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1,p=yl(t,n,r),f=0;f<p;f++){var m=xl(t,n,f);if(void 0===m||200!==m.kind){var g=zl(r,f),y=bl(t,f)||yd(m,g,a&&a[f]?k:void 0);if(!qs(a?Dc(y):y,g,i,_=o?kl(t,f,m):void 0,d))return!1}}return!0}function ml(e){if(181===e.kind){var t=e.expression;if(179===t.kind)return t.expression;if(180===t.kind)return t.expression}}function gl(t){if(183===t.kind){var n=t.template,r=[void 0];return 196===n.kind&&e.forEach(n.templateSpans,(function(e){r.push(e.expression)})),r}return 147===t.kind?void 0:e.isJsxOpeningLikeElement(t)?t.attributes.properties.length>0?[t.attributes]:e.emptyArray:t.arguments||e.emptyArray}function yl(e,t,n){if(147!==e.kind)return t.length;switch(e.parent.kind){case 229:case 199:return 1;case 149:return 2;case 151:case 153:case 154:return 0===D?2:n.parameters.length>=3?3:2;case 146:return 3}}function hl(t){if(229===t.kind)return ci(er(t));if(146===t.kind&&152===(t=t.parent).kind)return ci(er(t));return 149===t.kind||151===t.kind||153===t.kind||154===t.kind?function(t){var n=er(t.parent);return e.hasModifier(t,32)?ci(n):Fi(n)}(t):(e.Debug.fail("Unsupported decorator target."),Q)}function vl(t,n){return 0===n?hl(t.parent):1===n?function(t){if(229===t.kind)return e.Debug.fail("Class decorators should not have a second synthetic argument."),Q;if(146===t.kind&&152===(t=t.parent).kind)return H;if(149===t.kind||151===t.kind||153===t.kind||154===t.kind){var n=t;switch(n.name.kind){case 71:return _s(e.idText(n.name));case 8:case 9:return _s(n.name.text);case 144:var r=b_(n.name);return ad(r,512)?r:ee;default:return e.Debug.fail("Unsupported property name."),Q}}return e.Debug.fail("Unsupported decorator target."),Q}(t.parent):2===n?function(t){return 229===t.kind?(e.Debug.fail("Class decorators should not have a third synthetic argument."),Q):146===t.kind?te:149===t.kind?(e.Debug.fail("Property decorators should not have a third synthetic argument."),Q):151===t.kind||153===t.kind||154===t.kind?To(xf(t)):(e.Debug.fail("Unsupported decorator target."),Q)}(t.parent):(e.Debug.fail("Decorators should not have a fourth synthetic argument."),Q)}function bl(e,t){return 147===e.kind?vl(e,t):0===t&&183===e.kind?We||(We=po("TemplateStringsArray",0,!0))||_e:void 0}function xl(e,t,n){if(147!==e.kind&&(0!==n||183!==e.kind))return t[n]}function kl(e,t,n){return 147===e.kind?e.expression:0===t&&183===e.kind?e.template:n}function Sl(t,n,i,a){var o,s=183===t.kind,c=147===t.kind,u=e.isJsxOpeningLikeElement(t);s||c||u||(o=t.typeArguments,97!==t.expression.kind&&e.forEach(o,cf));var _=i||[];if(function(t,n){var r,i,a,o,s=0,c=-1;e.Debug.assert(!n.length);for(var u=0,_=t;u<_.length;u++){var l=_[u],d=l.declaration&&er(l.declaration),p=l.declaration&&l.declaration.parent;i&&d!==i?(a=s=n.length,r=p):r&&p===r?a++:(r=p,a=s),i=d,l.hasLiteralTypes?(o=++c,s++):o=a,n.splice(o,0,l)}}(n,_),!_.length)return At.add(e.createDiagnosticForNode(t,e.Diagnostics.Call_target_does_not_contain_any_signatures)),sl(t);var l,d,p,f,m=gl(t),g=1===_.length&&!_[0].typeParameters,y=0;if(!c&&!g)for(var h=s?1:0;h<m.length;h++)Cs(m[h])&&(l||(l=new Array(m.length)),l[h]=!0,y++);var v=i&&181===t.kind&&t.arguments.hasTrailingComma;if(_.length>1&&(f=B(_,$t,v)),f||(f=B(_,en,v)),f)return f;if(d){if(u)return d;fl(t,m,d,en,void 0,!0)}else if(p)pl(p,t.typeArguments,!0,a);else if(o&&e.every(n,(function(t){return e.length(t.typeParameters)!==o.length}))){for(var b=Number.POSITIVE_INFINITY,x=Number.NEGATIVE_INFINITY,k=0,S=n;k<S.length;k++){var D=S[k];b=Math.min(b,Pa(D.typeParameters)),x=Math.max(x,e.length(D.typeParameters))}var C=b<x?b+"-"+x:b;At.add(e.createDiagnosticForNode(t,e.Diagnostics.Expected_0_type_arguments_but_got_1,C,o.length))}else if(m){b=Number.POSITIVE_INFINITY,x=Number.NEGATIVE_INFINITY;for(var T=0,E=n;T<E.length;T++){D=E[T];b=Math.min(b,D.minArgumentCount),x=Math.max(x,D.parameters.length)}var N=e.some(n,(function(e){return e.hasRestParameter})),A=cl(m)>-1,w=(C=N?b:b<x?b+"-"+x:b,m.length-(A?1:0)),P=N&&A?e.Diagnostics.Expected_at_least_0_arguments_but_got_a_minimum_of_1:N?e.Diagnostics.Expected_at_least_0_arguments_but_got_1:A?e.Diagnostics.Expected_0_arguments_but_got_a_minimum_of_1:e.Diagnostics.Expected_0_arguments_but_got_1;At.add(e.createDiagnosticForNode(t,P,C,w))}else a&&At.add(e.createDiagnosticForNode(t,a));if(!r){e.Debug.assert(_.length>0);var F=function(e,t){for(var n=-1,r=-1,i=0;i<e.length;i++){var a=e[i];if(a.hasRestParameter||a.parameters.length>=t)return i;a.parameters.length>r&&(r=a.parameters.length,n=i)}return n}(_,void 0===R?m.length:R),O=_[F],I=O.typeParameters;if(I&&al(t)&&t.typeArguments){for(var L=t.typeArguments.map(xf);L.length>I.length;)L.pop();for(;L.length<I.length;)L.push(Kc(e.isInJavaScriptFile(t)));var M=Ja(O,L);return _[F]=M,M}return O}return sl(t);function B(n,r,i){if(void 0===i&&(i=!1),d=void 0,p=void 0,g){var a=n[0];if(!ul(t,m,a,i))return;return fl(t,m,a,r,l,!1)?a:void(d=a)}for(var s=0;s<n.length;s++){var c=n[s];if(ul(t,m,c,i)){a=void 0;for(var u=c.typeParameters?Fc(c,e.isInJavaScriptFile(t)?4:0):void 0;;){if((a=c).typeParameters){var _=void 0;if(o){var f=pl(a,o,!1);if(!f){p=c;break}_=f}else _=dl(t,a,m,l,u);a=Ba(a,_,e.isInJavaScriptFile(a.declaration))}if(!fl(t,m,a,r,l,!1)){d=a;break}if(0===y)return n[s]=a,a;--y>0?l[e.indexOf(l,!0)]=!1:l=void 0}}}}}function Dl(e,t,n,r){return!!Ur(e)||(!!(Ur(t)&&16384&e.flags)||!n&&!r&&(!(65536&e.flags)&&Os(e,Se)))}function Cl(t,n){if(t.arguments&&D<1){var r=cl(t.arguments);r>=0&&cn(t.arguments[r],e.Diagnostics.Spread_operator_in_new_expressions_is_only_available_when_targeting_ECMAScript_5_and_higher)}var i=V_(t.expression);if(i===ce)return rt;if((i=ma(i))===Q)return sl(t);if(Ur(i))return t.typeArguments&&cn(t,e.Diagnostics.Untyped_function_calls_may_not_accept_type_arguments),ol(t);var a=xa(i,1);if(a.length){if(!function(t,n){if(!n||!n.declaration)return!0;var r=n.declaration,i=e.getSelectedModifierFlags(r,24);if(!i)return!0;var a=Wp(r.parent.symbol),o=Fi(r.parent.symbol);if(!yf(t,a)){var s=e.getContainingClass(t);if(s)for(var c=Si(xf(s));c.length;){var u=c[0];if(16&i&&u.symbol===r.parent.symbol)return!0;c=Si(u)}return 8&i&&cn(t,e.Diagnostics.Constructor_of_class_0_is_private_and_only_accessible_within_the_class_declaration,Tr(o)),16&i&&cn(t,e.Diagnostics.Constructor_of_class_0_is_protected_and_only_accessible_within_the_class_declaration,Tr(o)),!1}return!0}(t,a[0]))return sl(t);var o=i.symbol&&Wp(i.symbol);return o&&e.hasModifier(o,128)?(cn(t,e.Diagnostics.Cannot_create_an_instance_of_the_abstract_class_0,e.declarationNameToString(e.getNameOfDeclaration(o))),sl(t)):Sl(t,a,n)}var s=xa(i,0);if(s.length){var c=Sl(t,s,n);return Fl(c.declaration)||La(c)===oe||cn(t,e.Diagnostics.Only_a_void_function_can_be_called_with_the_new_keyword),Ra(c)===oe&&cn(t,e.Diagnostics.A_function_that_is_called_with_the_new_keyword_cannot_have_a_this_type_that_is_void),c}return cn(t,e.Diagnostics.Cannot_use_new_with_an_expression_whose_type_lacks_a_call_or_construct_signature),sl(t)}function Tl(t){switch(t.parent.kind){case 229:case 199:return e.Diagnostics.Unable_to_resolve_signature_of_class_decorator_when_called_as_an_expression;case 146:return e.Diagnostics.Unable_to_resolve_signature_of_parameter_decorator_when_called_as_an_expression;case 149:return e.Diagnostics.Unable_to_resolve_signature_of_property_decorator_when_called_as_an_expression;case 151:case 153:case 154:return e.Diagnostics.Unable_to_resolve_signature_of_method_decorator_when_called_as_an_expression}}function El(t,n){var r=Ed(t.expression),i=ma(r);if(i===Q)return sl(t);var a,o,s=xa(i,0),c=xa(i,1);if(Dl(r,i,s.length,c.length))return ol(t);if(a=t,(o=s).length&&e.every(o,(function(e){return 0===e.minArgumentCount&&!e.hasRestParameter&&e.parameters.length<yl(a,void 0,e)}))){var u=e.getTextOfNode(t.expression,!1);return cn(t,e.Diagnostics._0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write_0,u),sl(t)}var _=Tl(t);if(!s.length){var l=void 0;return l=e.chainDiagnosticMessages(l,e.Diagnostics.Cannot_invoke_an_expression_whose_type_lacks_a_call_signature_Type_0_has_no_compatible_call_signatures,Tr(i)),l=e.chainDiagnosticMessages(l,_),At.add(e.createDiagnosticForNodeFromMessageChain(t,l)),sl(t)}return Sl(t,s,n,_)}function Nl(t,n,r){return e.Debug.assert(!(65536&n.flags)),Al(t,n,r)}function Al(e,t,n){if(65536&t.flags){for(var r=void 0,i=0,a=t.types;i<a.length;i++){var o=a[i];r=r||Al(e,o,n)}return r}var s=t&&xa(t,0);if(s&&s.length>0)return Sl(e,s,n)}function wl(t,n){switch(t.kind){case 181:return function(t,n){if(97===t.expression.kind){var r=Xu(t.expression);if(r!==Q){var i=e.getClassExtendsHeritageClauseElement(e.getContainingClass(t));if(i)return Sl(t,xi(r,i.typeArguments,i),n)}return ol(t)}var a=V_(t.expression);if(a===ce)return rt;var o=ma(a);if(o===Q)return sl(t);var s=xa(o,0),c=xa(o,1);return Dl(a,o,s.length,c.length)?(a!==Q&&t.typeArguments&&cn(t,e.Diagnostics.Untyped_function_calls_may_not_accept_type_arguments),ol(t)):s.length?Sl(t,s,n):(c.length?cn(t,e.Diagnostics.Value_of_type_0_is_not_callable_Did_you_mean_to_include_new,Tr(a)):cn(t,e.Diagnostics.Cannot_invoke_an_expression_whose_type_lacks_a_call_signature_Type_0_has_no_compatible_call_signatures,Tr(o)),sl(t))}(t,n);case 182:return Cl(t,n);case 183:return function(t,n){var r=Ed(t.tag),i=ma(r);if(i===Q)return sl(t);var a=xa(i,0),o=xa(i,1);return Dl(r,i,a.length,o.length)?ol(t):a.length?Sl(t,a,n):(cn(t,e.Diagnostics.Cannot_invoke_an_expression_whose_type_lacks_a_call_signature_Type_0_has_no_compatible_call_signatures,Tr(i)),sl(t))}(t,n);case 147:return El(t,n);case 251:case 250:return Al(t,Ed(t.tagName),n)||tt}e.Debug.assertNever(t,"Branch in 'resolveSignature' should be unreachable.")}function Pl(e,t){var n=yn(e),r=n.resolvedSignature;if(r&&r!==nt&&!t)return r;n.resolvedSignature=nt;var i=wl(e,t);return n.resolvedSignature=st===ct?i:r,i}function Fl(t){if(t&&e.isInJavaScriptFile(t)){if(e.getJSDocClassTag(t))return!0;var n=e.isFunctionDeclaration(t)||e.isFunctionExpression(t)?er(t):e.isVariableDeclaration(t)&&t.initializer&&e.isFunctionExpression(t.initializer)?er(t.initializer):void 0;return n&&void 0!==n.members}return!1}function Ol(t){var n=gn(t);return n.inferredClassType||(n.inferredClassType=lr(t,t.members||x,e.emptyArray,e.emptyArray,void 0,void 0)),n.inferredClassType}function Il(e){return e.symbol&&16&hn(e)&&gn(e.symbol).inferredClassType===e}function Rl(t){sm(t,t.typeArguments)||cm(t.arguments);var n=Pl(t);if(97===t.expression.kind)return oe;if(182===t.kind){var r=n.declaration;if(r&&152!==r.kind&&156!==r.kind&&161!==r.kind&&!e.isJSDocConstructSignature(r)){var i=Ed(t.expression).symbol;i||71!==t.expression.kind||(i=Vc(t.expression));var a=i&&function(t){if(e.isDeclarationOfFunctionOrClassExpression(t)&&(t=er(t.valueDeclaration.initializer)),Fl(t.valueDeclaration))return Ol(t);if(3&t.flags){var n=ci(t);if(n.symbol&&!Il(n)&&Fl(n.symbol.valueDeclaration))return Ol(n.symbol)}}(i);return a||(w&&cn(t,e.Diagnostics.new_expression_whose_target_lacks_a_construct_signature_implicitly_has_an_any_type),H)}}return e.isInJavaScriptFile(t)&&function(t){if(!e.isRequireCall(t,!0))return!1;if(!e.isIdentifier(t.expression))throw e.Debug.fail();var n=kn(t.expression,t.expression.escapedText,107455,void 0,void 0,!0);if(!n)return!0;if(2097152&n.flags)return!1;var r=16&n.flags?228:3&n.flags?226:0;if(0!==r){var i=e.getDeclarationOfKind(n,r);return e.isInAmbientContext(i)}return!1}(t)?function(e){var t=Kn(e,e);if(t){var n=qn(t);if(n)return ci(n)}return H}(t.arguments[0]):La(n)}function Ll(t){if(cm(t.arguments)||function(t){if(C===e.ModuleKind.ES2015)return Tm(t,e.Diagnostics.Dynamic_import_cannot_be_used_when_targeting_ECMAScript_2015_modules);if(t.typeArguments)return Tm(t,e.Diagnostics.Dynamic_import_cannot_have_type_arguments);var n=t.arguments;if(1!==n.length)return Tm(t,e.Diagnostics.Dynamic_import_must_have_one_specifier_as_an_argument);if(e.isSpreadElement(n[0]))Tm(n[0],e.Diagnostics.Specifier_of_dynamic_import_cannot_be_spread_element)}(t),0===t.arguments.length)return ql(t,H);for(var n=t.arguments[0],r=hd(n),i=1;i<t.arguments.length;++i)hd(t.arguments[i]);(2048&r.flags||4096&r.flags||!Os(r,ee))&&cn(n,e.Diagnostics.Dynamic_import_s_specifier_must_be_of_type_string_but_here_has_type_0,Tr(r));var a=Kn(t,n);if(a){var o=Wn(a,n,!0);if(o)return ql(t,function(t,n){if(E&&t&&t!==Q){var r=t;if(!r.syntheticType)if(va(t,"default"))r.syntheticType=t;else{var i=e.createSymbolTable(),a=un(2097152,"default");a.target=Rn(n),i.set("default",a);var o=un(2048,"__type"),s=lr(o,i,e.emptyArray,e.emptyArray,void 0,void 0);o.type=s,r.syntheticType=Vo([t,s])}return r.syntheticType}return t}(ci(o),o))}return ql(t,H)}function Ml(t,n,i,a){var o=Dc(dc(Ed(i,a)));cf(n);var s=ds(n);r&&s!==Q&&(Rs(s,Ec(o))||Ms(o,s,t,e.Diagnostics.Type_0_cannot_be_converted_to_type_1));return s}function Bl(t){!function(t){if(94===t.keywordToken&&"target"!==t.name.escapedText)Tm(t.name,e.Diagnostics._0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2,t.name.escapedText,e.tokenToString(t.keywordToken),"target")}(t);var n=e.getNewTargetContainer(t);return n?152===n.kind?ci(er(n.parent)):ci(er(n)):(cn(t,e.Diagnostics.Meta_property_0_is_only_allowed_in_the_body_of_a_function_declaration_function_expression_or_constructor,"new.target"),Q)}function Jl(e){var t=ci(e);if(N){var n=e.valueDeclaration;if(n&&n.initializer)return bc(t,2048)}return t}function zl(e,t){return e.hasRestParameter?t<e.parameters.length-1?Jl(e.parameters[t]):Ma(e):t<e.parameters.length?Jl(e.parameters[t]):H}function jl(e){return e.parameters.length>0?zl(e,0):se}function Kl(t){for(var n=0,r=t.elements;n<r.length;n++){var i=r[n];e.isOmittedExpression(i)||(71===i.name.kind?gn(er(i)).type=Hr(i):Kl(i.name))}}function Ul(e,t){var n=gn(e);if(!n.type){n.type=t;var r=e.valueDeclaration;71!==r.name.kind&&(n.type===_e&&(n.type=$r(r.name)),Kl(r.name))}}function Vl(e){var t=mo(!0);return t!==pe?Ya(t,[e=Qd(e)||_e]):_e}function ql(t,n){var r=Vl(n);return r===_e?(cn(t,e.isImportCall(t)?e.Diagnostics.A_dynamic_import_call_returns_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option:e.Diagnostics.An_async_function_or_method_must_return_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option),Q):(go(!0)||cn(t,e.isImportCall(t)?e.Diagnostics.A_dynamic_import_call_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option:e.Diagnostics.An_async_function_or_method_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option),r)}function Wl(t,n){var r=p_(t);if(!t.body)return Q;var i,a=e.getFunctionFlags(t);if(207!==t.body.kind)i=hd(t.body,n),2&a&&(i=Gd(i,t,e.Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member));else{var o=void 0;if(1&a){if(!(o=e.concatenate(function(t,n){var r=[],i=e.getFunctionFlags(t);return e.forEachYieldExpression(t.body,(function(t){var a=t.expression;if(a){var o=hd(a,n);t.asteriskToken&&(o=wp(o,t.expression,!1,0!=(2&i))),2&i&&(o=Gd(o,a,t.asteriskToken?e.Diagnostics.Type_of_iterated_elements_of_a_yield_Asterisk_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member:e.Diagnostics.Type_of_yield_operand_in_an_async_generator_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member)),e.pushIfUnique(r,o)}})),r}(t,n),Ql(t,n)))||0===o.length){var s=2&a?Eo(H):Ao(H);return w&&cn(t.asteriskToken,e.Diagnostics.Generator_implicitly_has_type_0_because_it_does_not_yield_any_values_Consider_supplying_a_return_type,Tr(s)),s}}else{if(!(o=Ql(t,n)))return 2&a?ql(t,se):se;if(0===o.length)return 2&a?ql(t,oe):oe}i=zo(o,!0),1&a&&(i=2&a?Eo(i):Ao(i))}r||wc(t,i),!_c(i)||r&&xd(r===Oa(t)?i:La(r))||(i=pc(i));var c=Ec(i);return 2==(3&a)?ql(t,c):c}function Hl(t){if(!t.possiblyExhaustive)return!1;var n=Td(t.expression);if(!lc(n))return!1;var r,i,a=gu(t);return!!a.length&&(r=bu(n,us),i=a,65536&r.flags?!e.forEach(r.types,(function(t){return!e.contains(i,t)})):e.contains(i,r))}function Gl(t){if(!(128&t.flags))return!1;var n=e.lastOrUndefined(t.body.statements);return!n||221!==n.kind||!Hl(n)}function Ql(t,n){var r=e.getFunctionFlags(t),i=[],a=Gl(t),o=!1;if(e.forEachReturnStatement(t.body,(function(s){var c=s.expression;if(c){var u=hd(c,n);2&r&&(u=Gd(u,t,e.Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member)),8192&u.flags&&(o=!0),e.pushIfUnique(i,u)}else a=!0})),0!==i.length||a||!o&&186!==t.kind&&187!==t.kind)return N&&i.length&&a&&e.pushIfUnique(i,X),i}function Xl(t,n){if(r&&(!n||!id(n,1025))&&!e.nodeIsMissing(t.body)&&207===t.body.kind&&Gl(t)){var i=256&t.flags;if(n&&8192&n.flags)cn(e.getEffectiveReturnTypeNode(t),e.Diagnostics.A_function_returning_never_cannot_have_a_reachable_end_point);else if(n&&!i)cn(e.getEffectiveReturnTypeNode(t),e.Diagnostics.A_function_whose_declared_type_is_neither_void_nor_any_must_return_a_value);else if(n&&N&&!Os(X,n))cn(e.getEffectiveReturnTypeNode(t),e.Diagnostics.Function_lacks_ending_return_statement_and_return_type_does_not_include_undefined);else if(S.noImplicitReturns){if(!n){if(!i)return;if(Mp(t,La(Oa(t))))return}cn(e.getEffectiveReturnTypeNode(t)||t,e.Diagnostics.Not_all_code_paths_return_a_value)}}}function Yl(t,n){if(e.Debug.assert(151!==t.kind||e.isObjectLiteralMethod(t)),1===n&&Cs(t))return uf(t),fe;om(t)||186!==t.kind||dm(t);var i=yn(t),a=ci(t.symbol);if(!(1024&i.flags)){var o=m_(t);if(!(1024&i.flags)){if(i.flags|=1024,o){var s=xa(a,0)[0];if(Cs(t)){var c=__(t);2===n&&function(t,n,r){for(var i=t.parameters.length-(t.hasRestParameter?1:0),a=0;a<i;a++){var o=t.parameters[a].valueDeclaration;if(o.type){var s=e.getEffectiveTypeAnnotationNode(o);s&&Bc(r.inferences,ds(s),zl(n,a))}}}(s,o,c),function(t,n){t.typeParameters=n.typeParameters,n.thisParameter&&(!(a=t.thisParameter)||a.valueDeclaration&&!a.valueDeclaration.type)&&(a||(t.thisParameter=Sc(n.thisParameter,void 0)),Ul(t.thisParameter,ci(n.thisParameter)));for(var r=t.parameters.length-(t.hasRestParameter?1:0),i=0;i<r;i++){var a=t.parameters[i];e.getEffectiveTypeAnnotationNode(a.valueDeclaration)||Ul(a,zl(n,i))}t.hasRestParameter&&ac(n,t.parameters.length-1)&&(!_n(a=e.lastOrUndefined(t.parameters))&&e.getEffectiveTypeAnnotationNode(a.valueDeclaration)||Ul(a,ci(e.lastOrUndefined(n.parameters))))}(s,c===k?o:vs(o,c))}if(!e.getEffectiveReturnTypeNode(t)&&!s.resolvedReturnType){var u=Wl(t,n);s.resolvedReturnType||(s.resolvedReturnType=u)}}Fd(t),uf(t)}}return r&&151!==t.kind&&(hp(t,t.name),fp(t,t.name),mp(t,t.name)),a}function Zl(t){e.Debug.assert(151!==t.kind||e.isObjectLiteralMethod(t));var n=e.getFunctionFlags(t),r=e.getEffectiveReturnTypeNode(t),i=r&&(2==(3&n)?Xd(t):ds(r));if(0==(1&n)&&Xl(t,i),t.body){if(r||La(Oa(t)),207===t.body.kind)cf(t.body);else{var a=Ed(t.body);if(i)if(2==(3&n))Ls(Gd(a,t.body,e.Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member),i,t.body);else Ls(a,i,t.body)}ap(t)}}function $l(e,t,n){return!!ad(t,84)||(cn(e,n),!1)}function ed(t){return!!(8&e.getCheckFlags(t)||4&t.flags&&64&e.getDeclarationModifierFlagsFromSymbol(t)||3&t.flags&&2&j_(t)||98304&t.flags&&!(65536&t.flags)||8&t.flags)}function td(t,n){if(ed(n)){if(4&n.flags&&(179===t.kind||180===t.kind)&&99===t.expression.kind){var r=e.getContainingFunction(t);return!r||152!==r.kind||!(r.parent===n.valueDeclaration.parent||r===n.valueDeclaration.parent)}return!0}return!1}function nd(t){if(179===t.kind||180===t.kind){var n=e.skipParentheses(t.expression);if(71===n.kind){var r=yn(n).resolvedSymbol;if(2097152&r.flags){var i=wn(r);return i&&240===i.kind}}}return!1}function rd(t,n){var r=e.skipOuterExpressions(t,3);return 71===r.kind||179===r.kind||180===r.kind||(cn(t,n),!1)}function id(e,t){if(e.flags&t)return!0;if(196608&e.flags)for(var n=0,r=e.types;n<r.length;n++){if(id(r[n],t))return!0}return!1}function ad(e,t,n){return!!(e.flags&t)||!(n&&7169&e.flags)&&(84&t&&Os(e,te)||262178&t&&Os(e,ee)||136&t&&Os(e,ie)||1024&t&&Os(e,oe)||8192&t&&Os(e,se)||4096&t&&Os(e,Z)||2048&t&&Os(e,X)||512&t&&Os(e,ae)||16777216&t&&Os(e,ue))}function od(e){return 16&hn(e)&&e.symbol&&sd(e.symbol)}function sd(e){return 0!=(128&e.flags)}function cd(t,n,r){if(261===n.kind||262===n.kind){var i=n.name;if(144===i.kind&&b_(i),qr(i))return;var a=e.getTextOfPropertyName(i);if(c=Ur(t)?t:Kr(t,a)||v_(a)&&Ca(t,1)||Ca(t,0))return 262===n.kind?_d(n,c):_d(n.initializer,c);cn(i,e.Diagnostics.Type_0_has_no_property_1_and_no_string_index_signature,Tr(t),e.declarationNameToString(i))}else{if(263===n.kind){D<5&&$f(n,4);var o=[];if(r)for(var s=0;s<r.length-1;s++)o.push(r[s].name);var c=Wr(t,o,t.symbol);return _d(n.expression,c)}cn(n,e.Diagnostics.Property_assignment_expected)}}function ud(t,n,r,i,a){var o=t.elements,s=o[r];if(200!==s.kind)if(198!==s.kind){var c=""+r,u=Ur(n)?n:uc(n)?Kr(n,c):i;if(u)return _d(s,u,a);Ed(s),fc(n)?cn(s,e.Diagnostics.Tuple_type_0_with_length_1_cannot_be_assigned_to_tuple_with_length_2,Tr(n),$a(n),o.length):cn(s,e.Diagnostics.Type_0_has_no_property_1,Tr(n),c)}else if(r<o.length-1)cn(s,e.Diagnostics.A_rest_element_must_be_last_in_a_destructuring_pattern);else{var _=s.expression;if(194!==_.kind||58!==_.operatorToken.kind)return _d(_,wo(i),a);cn(_.operatorToken,e.Diagnostics.A_rest_element_cannot_have_an_initializer)}}function _d(t,n,r){var i;if(262===t.kind){var a=t;a.objectAssignmentInitializer&&(!N||2048&gc(Ed(a.objectAssignmentInitializer))||(n=nu(n,131072)),md(a.name,a.equalsToken,a.objectAssignmentInitializer,r)),i=t.name}else i=t;return 194===i.kind&&58===i.operatorToken.kind&&(fd(i,r),i=i.left),178===i.kind?function(e,t){for(var n=e.properties,r=0,i=n;r<i.length;r++)cd(t,i[r],n);return t}(i,n):177===i.kind?function(e,t,n){D<2&&S.downlevelIteration&&$f(e,512);for(var r=wp(t,e,!1,!1)||Q,i=e.elements,a=0;a<i.length;a++)ud(e,t,a,r,n);return t}(i,n,r):function(t,n,r){var i=Ed(t,r),a=263===t.parent.kind?e.Diagnostics.The_target_of_an_object_rest_assignment_must_be_a_variable_or_a_property_access:e.Diagnostics.The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access;rd(t,a)&&Ls(n,i,t,void 0);return n}(i,n,r)}function ld(t){switch((t=e.skipParentheses(t)).kind){case 71:case 9:case 12:case 183:case 196:case 13:case 8:case 101:case 86:case 95:case 139:case 186:case 199:case 187:case 177:case 178:case 189:case 203:case 250:case 249:return!0;case 195:return ld(t.whenTrue)&&ld(t.whenFalse);case 194:return!e.isAssignmentOperator(t.operatorToken.kind)&&(ld(t.left)&&ld(t.right));case 192:case 193:switch(t.operator){case 51:case 37:case 38:case 52:return!0}return!1;case 190:case 184:case 202:default:return!1}}function dd(e,t){return 0!=(6144&t.flags)||Rs(e,t)}function pd(e,t){var n=Os(e,t),r=Os(t,e);return r&&!n?e:n&&!r?t:zo([e,t],!0)}function fd(e,t){return md(e.left,e.operatorToken,e.right,t,e)}function md(t,n,i,a,o){var s=n.kind;if(58===s&&(178===t.kind||177===t.kind))return _d(t,Ed(i,a),a);var c,u=Ed(t,a),_=Ed(i,a);switch(s){case 39:case 40:case 61:case 62:case 41:case 63:case 42:case 64:case 38:case 60:case 45:case 65:case 46:case 66:case 47:case 67:case 49:case 69:case 50:case 70:case 48:case 68:if(u===ce||_===ce)return ce;u=q_(u,t),_=q_(_,i);var l=void 0;if(136&u.flags&&136&_.flags&&void 0!==(l=function(e){switch(e){case 49:case 69:return 54;case 50:case 70:return 35;case 48:case 68:return 53;default:return}}(n.kind)))cn(o||n,e.Diagnostics.The_0_operator_is_not_allowed_for_boolean_types_Consider_using_1_instead,e.tokenToString(n.kind),e.tokenToString(l));else{var d=$l(t,u,e.Diagnostics.The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_or_an_enum_type),p=$l(i,_,e.Diagnostics.The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_or_an_enum_type);d&&p&&h(te)}return te;case 37:case 59:if(u===ce||_===ce)return ce;ad(u,262178)||ad(_,262178)||(u=q_(u,t),_=q_(_,i));var f=void 0;return ad(u,84,!0)&&ad(_,84,!0)?f=te:ad(u,262178,!0)||ad(_,262178,!0)?f=ee:(Ur(u)||Ur(_))&&(f=u===Q||_===Q?Q:H),f&&!y(s)?f:f?(59===s&&h(f),f):(v(),H);case 27:case 29:case 30:case 31:return y(s)&&(u=dc(q_(u,t)),_=dc(q_(_,i)),Rs(u,_)||Rs(_,u)||v()),ie;case 32:case 33:case 34:case 35:var m=lc(u),g=lc(_);return m&&g||(u=m?dc(u):u,_=g?dc(_):_),dd(u,_)||dd(_,u)||v(),ie;case 93:return function(t,n,r,i){return r===ce||i===ce?ce:(!Ur(r)&&ad(r,8190)&&cn(t,e.Diagnostics.The_left_hand_side_of_an_instanceof_expression_must_be_of_type_any_an_object_type_or_a_type_parameter),Ur(i)||xa(i,0).length||xa(i,1).length||Fs(i,Se)||cn(n,e.Diagnostics.The_right_hand_side_of_an_instanceof_expression_must_be_of_type_any_or_of_a_type_assignable_to_the_Function_interface_type),ie)}(t,i,u,_);case 92:return function(t,n,r,i){return r===ce||i===ce?ce:(r=q_(r,t),i=q_(i,n),Rs(r,ee)||ad(r,596)||cn(t,e.Diagnostics.The_left_hand_side_of_an_in_expression_must_be_of_type_any_string_number_or_symbol),ad(i,17317888)||cn(n,e.Diagnostics.The_right_hand_side_of_an_in_expression_must_be_of_type_any_an_object_type_or_a_type_parameter),ie)}(t,i,u,_);case 53:return 1048576&tu(u)?zo([hc(N?u:dc(_)),_]):u;case 54:return 2097152&tu(u)?pd(yc(u),_):u;case 58:return h(_),Dc(_);case 26:return!S.allowUnreachableCode&&ld(t)&&(71!==(c=i).kind||"eval"!==c.escapedText)&&cn(t,e.Diagnostics.Left_side_of_comma_operator_is_unused_and_has_no_side_effects),_}function y(n){var r=id(u,512)?t:id(_,512)?i:void 0;return!r||(cn(r,e.Diagnostics.The_0_operator_cannot_be_applied_to_type_symbol,e.tokenToString(n)),!1)}function h(n){r&&e.isAssignmentOperator(s)&&rd(t,e.Diagnostics.The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access)&&Ls(n,u,t,void 0)}function v(){cn(o||n,e.Diagnostics.Operator_0_cannot_be_applied_to_types_1_and_2,e.tokenToString(n.kind),Tr(u),Tr(_))}}function gd(t){if(r&&(4096&t.flags&&!function(t){for(var n=t,r=t.parent;r;){if(e.isFunctionLike(r)&&n===r.body)return!1;if(e.isClassLike(n))return!0;n=r,r=r.parent}return!1}(t)||Dm(t,e.Diagnostics.A_yield_expression_is_only_allowed_in_a_generator_body),t_(t)&&cn(t,e.Diagnostics.yield_expressions_cannot_be_used_in_a_parameter_initializer)),t.expression){var n=e.getContainingFunction(t),i=n&&e.getFunctionFlags(n);if(t.asteriskToken&&(3==(3&i)&&D<5&&$f(t,26624),1==(3&i)&&D<2&&S.downlevelIteration&&$f(t,256)),1&i){var a=hd(t.expression),o=void 0,s=!!t.asteriskToken;s&&(o=wp(a,t.expression,!1,0!=(2&i)));var c=e.getEffectiveReturnTypeNode(n);if(c){var u=Ip(ds(c),0!=(2&i))||H;Ls(s?2&i?Qd(o,t.expression,e.Diagnostics.Type_of_iterated_elements_of_a_yield_Asterisk_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member):o:2&i?Qd(a,t.expression,e.Diagnostics.Type_of_yield_operand_in_an_async_generator_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member):a,u,t.expression,void 0)}}}return H}function yd(e,t,n){var r=e.contextualType,i=e.contextualMapper;e.contextualType=t,e.contextualMapper=n;var a=Ed(e,n===k?1:n?2:0);return e.contextualType=r,e.contextualMapper=i,a}function hd(e,t){var n=yn(e);if(!n.resolvedType){var r=st;st=ct,n.resolvedType=Ed(e,t),st=r}return n.resolvedType}function vd(t){return 184===(t=e.skipParentheses(t)).kind||202===t.kind}function bd(t){var n=Td(t.initializer,!0);return 2&e.getCombinedNodeFlags(t)||64&e.getCombinedModifierFlags(t)&&!e.isParameterPropertyDeclaration(t)||vd(t.initializer)?n:pc(n)}function xd(e){if(e){if(540672&e.flags){var t=_a(e)||_e;if(30&t.flags)return!0;e=t}return id(e,262368)}return!1}function kd(e,t,n){2===arguments.length&&(n=u_(e));var r=Ed(e,t),i=vd(e)||xd(n);return i?r:pc(r)}function Sd(e,t){return 144===e.name.kind&&b_(e.name),kd(e.initializer,t)}function Dd(e,t){return ym(e),144===e.name.kind&&b_(e.name),Cd(e,Yl(e,t),t)}function Cd(e,t,n){if(2===n){var r=_l(t);if(r&&r.typeParameters){var i=c_(e);if(i){var a=_l(xc(i));if(a&&!a.typeParameters)return Ka(ll(r,a,__(e)))}}}return t}function Td(t,n){if(181===t.kind&&97!==t.expression.kind&&!e.isRequireCall(t,!0)){var r=_l(V_(t.expression));if(r&&!r.typeParameters)return La(r)}return n?hd(t):Ed(t)}function Ed(t,n){var i;143===t.kind?i=H_(t):i=Cd(t,function(t,n){switch(t.kind){case 71:return Ku(t);case 99:return Gu(t);case 97:return Xu(t);case 95:return $;case 13:case 9:return cs(_s(t.text));case 8:return Am(t),cs(_s(+t.text));case 101:return ne;case 86:return re;case 196:return function(t){return e.forEach(t.templateSpans,(function(e){Ed(e.expression)})),ee}(t);case 12:return Ae;case 177:return y_(t,n);case 178:return k_(t,n);case 179:return W_(t);case 180:return rl(t);case 181:if(91===t.expression.kind)return Ll(t);case 182:return Rl(t);case 183:return function(e){return D<2&&$f(e,65536),La(Pl(e))}(t);case 185:return function(t,n){var r=e.isInJavaScriptFile(t)?e.getJSDocTypeTag(t):void 0;if(r)return Ml(r,r.typeExpression.type,t.expression,n);return Ed(t.expression,n)}(t,n);case 199:return function(e){return Vp(e),uf(e),ci(er(e))}(t);case 186:case 187:return Yl(t,n);case 189:return function(e){return Ed(e.expression),jt}(t);case 184:case 202:return function(e){return Ml(e,e.type,e.expression)}(t);case 203:return function(e){return xc(Ed(e.expression))}(t);case 204:return Bl(t);case 188:return function(t){Ed(t.expression);var n=e.skipParentheses(t.expression);if(179!==n.kind&&180!==n.kind)return cn(n,e.Diagnostics.The_operand_of_a_delete_operator_must_be_a_property_reference),ie;var r=nr(yn(n).resolvedSymbol);return r&&ed(r)&&cn(n,e.Diagnostics.The_operand_of_a_delete_operator_cannot_be_a_read_only_property),ie}(t);case 190:return function(e){return Ed(e.expression),Y}(t);case 191:return function(t){return r&&(16384&t.flags||Dm(t,e.Diagnostics.await_expression_is_only_allowed_within_an_async_function),t_(t)&&cn(t,e.Diagnostics.await_expressions_cannot_be_used_in_a_parameter_initializer)),Gd(Ed(t.expression),t,e.Diagnostics.Type_of_await_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member)}(t);case 192:return function(t){var n=Ed(t.operand);if(n===ce)return ce;if(8===t.operand.kind){if(38===t.operator)return cs(_s(-t.operand.text));if(37===t.operator)return cs(_s(+t.operand.text))}switch(t.operator){case 37:case 38:case 52:return q_(n,t.operand),id(n,512)&&cn(t.operand,e.Diagnostics.The_0_operator_cannot_be_applied_to_type_symbol,e.tokenToString(t.operator)),te;case 51:var r=3145728&tu(n);return 1048576===r?re:2097152===r?ne:ie;case 43:case 44:return $l(t.operand,q_(n,t.operand),e.Diagnostics.An_arithmetic_operand_must_be_of_type_any_number_or_an_enum_type)&&rd(t.operand,e.Diagnostics.The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access),te}return Q}(t);case 193:return function(t){var n=Ed(t.operand);return n===ce?ce:($l(t.operand,q_(n,t.operand),e.Diagnostics.An_arithmetic_operand_must_be_of_type_any_number_or_an_enum_type)&&rd(t.operand,e.Diagnostics.The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access),te)}(t);case 194:return fd(t,n);case 195:return function(e,t){return Ed(e.condition),pd(Ed(e.whenTrue,t),Ed(e.whenFalse,t))}(t,n);case 198:return function(e,t){return D<2&&S.downlevelIteration&&$f(e,1536),wp(Ed(e.expression,t),e.expression,!1,!1)}(t,n);case 200:return Y;case 197:return gd(t);case 256:return function(t,n){if(t.expression){var r=Ed(t.expression,n);return t.dotDotDotToken&&r!==H&&!sc(r)&&cn(t,e.Diagnostics.JSX_spread_child_must_be_an_array_type),r}return Q}(t,n);case 249:return function(e){return J_(e.openingElement),C_(e.closingElement.tagName)?N_(e.closingElement):Ed(e.closingElement.tagName),M_()||H}(t);case 250:return function(e){return J_(e),M_()||H}(t);case 254:return function(e,t){return T_(e.parent,void 0,t)}(t,n);case 251:e.Debug.fail("Shouldn't ever directly check a JsxOpeningElement")}return Q}(t,n),n);od(i)&&(179===t.parent.kind&&t.parent.expression===t||180===t.parent.kind&&t.parent.expression===t||(71===t.kind||143===t.kind)&&hf(t)||cn(t,e.Diagnostics.const_enums_can_only_be_used_in_property_or_index_access_expressions_or_the_right_hand_side_of_an_import_declaration_or_export_assignment));return i}function Nd(t){t.expression&&Dm(t.expression,e.Diagnostics.Type_expected),cf(t.constraint),cf(t.default);var n=Pi(er(t));la(n)||cn(t.constraint,e.Diagnostics.Type_parameter_0_has_a_circular_constraint,Tr(n)),function(e){return pa(e)!==ge}(n)||cn(t.default,e.Diagnostics.Type_parameter_0_has_a_circular_default,Tr(n));var i=ca(n),a=fa(n);i&&a&&Ls(a,zi(i,a),t.default,e.Diagnostics.Type_0_does_not_satisfy_the_constraint_1),r&&zp(t.name,e.Diagnostics.Type_parameter_name_cannot_be_0)}function Ad(t){tm(t)||nm(t),Sp(t);var n=e.getContainingFunction(t);e.hasModifier(t,92)&&(152===n.kind&&e.nodeIsPresent(n.body)||cn(t,e.Diagnostics.A_parameter_property_is_only_allowed_in_a_constructor_implementation)),t.questionToken&&e.isBindingPattern(t.name)&&n.body&&cn(t,e.Diagnostics.A_binding_pattern_parameter_cannot_be_optional_in_an_implementation_signature),t.name&&e.isIdentifier(t.name)&&("this"===t.name.escapedText||"new"===t.name.escapedText)&&(0!==e.indexOf(n.parameters,t)&&cn(t,e.Diagnostics.A_0_parameter_must_be_the_first_parameter,t.name.escapedText),152!==n.kind&&156!==n.kind&&161!==n.kind||cn(t,e.Diagnostics.A_constructor_cannot_have_a_this_parameter)),!t.dotDotDotToken||e.isBindingPattern(t.name)||sc(ci(t.symbol))||cn(t,e.Diagnostics.A_rest_parameter_must_be_of_an_array_type)}function wd(e,t){if(e)for(var n=0;n<e.length;n++){var r=e[n];if(71===r.name.kind&&r.name.escapedText===t.escapedText)return n}return-1}function Pd(t,n,r){for(var i=0,a=t.elements;i<a.length;i++){var o=a[i];if(!e.isOmittedExpression(o)){var s=o.name;if(71===s.kind&&s.escapedText===r)return cn(n,e.Diagnostics.A_type_predicate_cannot_reference_element_0_in_a_binding_pattern,r),!0;if((175===s.kind||174===s.kind)&&Pd(s,n,r))return!0}}}function Fd(t){157===t.kind?function(t){tm(t)||nm(t)||function(t){var n=t.parameters[0];if(1!==t.parameters.length)return Tm(n?n.name:t,e.Diagnostics.An_index_signature_must_have_exactly_one_parameter);if(n.dotDotDotToken)return Tm(n.dotDotDotToken,e.Diagnostics.An_index_signature_cannot_have_a_rest_parameter);if(e.hasModifiers(n))return Tm(n.name,e.Diagnostics.An_index_signature_parameter_cannot_have_an_accessibility_modifier);if(n.questionToken)return Tm(n.questionToken,e.Diagnostics.An_index_signature_parameter_cannot_have_a_question_mark);if(n.initializer)return Tm(n.name,e.Diagnostics.An_index_signature_parameter_cannot_have_an_initializer);if(!n.type)return Tm(n.name,e.Diagnostics.An_index_signature_parameter_must_have_a_type_annotation);if(136!==n.type.kind&&133!==n.type.kind)return Tm(n.name,e.Diagnostics.An_index_signature_parameter_type_must_be_string_or_number);if(!t.type)Tm(t,e.Diagnostics.An_index_signature_must_have_a_type_annotation)}(t)}(t):160!==t.kind&&228!==t.kind&&161!==t.kind&&155!==t.kind&&152!==t.kind&&156!==t.kind||om(t);var n=e.getFunctionFlags(t);if(4&n||(3==(3&n)&&D<5&&$f(t,6144),2==(3&n)&&D<4&&$f(t,64),0!=(3&n)&&D<2&&$f(t,128)),jp(t.typeParameters),e.forEach(t.parameters,Ad),t.type&&cf(t.type),r){!function(t){if(!e.hasRestParameter(t)||e.isInAmbientContext(t)||e.nodeIsMissing(t.body))return;e.forEach(t.parameters,(function(t){t.name&&!e.isBindingPattern(t.name)&&t.name.escapedText===M.escapedName&&cn(t,e.Diagnostics.Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters)}))}(t);var i=e.getEffectiveReturnTypeNode(t);if(w&&!i)switch(t.kind){case 156:cn(t,e.Diagnostics.Construct_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type);break;case 155:cn(t,e.Diagnostics.Call_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type)}if(i){var a=e.getFunctionFlags(t);if(1==(5&a)){var o=ds(i);if(o===oe)cn(i,e.Diagnostics.A_generator_cannot_have_a_void_type_annotation);else{var s=Ip(o,0!=(2&a))||H;Ls(2&a?Eo(s):Ao(s),o,i)}}else 2==(3&a)&&Xd(t)}T&&!t.body&&_p(t)}}function Od(t){for(var n=e.createMap(),r=0,i=t.members;r<i.length;r++){var a=i[r];if(148===a.kind){var o=void 0;switch(a.name.kind){case 9:case 8:o=a.name.text;break;case 71:o=e.idText(a.name);break;default:continue}n.get(o)?(cn(e.getNameOfDeclaration(a.symbol.valueDeclaration),e.Diagnostics.Duplicate_identifier_0,o),cn(a.name,e.Diagnostics.Duplicate_identifier_0,o)):n.set(o,!0)}}}function Id(t){if(230===t.kind){var n=er(t);if(n.declarations.length>0&&n.declarations[0]!==t)return}var r=Ua(er(t));if(r)for(var i=!1,a=!1,o=0,s=r.declarations;o<s.length;o++){var c=s[o];if(1===c.parameters.length&&c.parameters[0].type)switch(c.parameters[0].type.kind){case 136:a?cn(c,e.Diagnostics.Duplicate_string_index_signature):a=!0;break;case 133:i?cn(c,e.Diagnostics.Duplicate_number_index_signature):i=!0}}}function Rd(t){tm(t)||nm(t)||function(t){if(e.isClassLike(t.parent)){if(gm(t.name,e.Diagnostics.A_computed_property_name_in_a_class_property_declaration_must_directly_refer_to_a_built_in_symbol))return!0}else if(230===t.parent.kind){if(gm(t.name,e.Diagnostics.A_computed_property_name_in_an_interface_must_directly_refer_to_a_built_in_symbol))return!0;if(t.initializer)return Tm(t.initializer,e.Diagnostics.An_interface_property_cannot_have_an_initializer)}else if(163===t.parent.kind){if(gm(t.name,e.Diagnostics.A_computed_property_name_in_a_type_literal_must_directly_refer_to_a_built_in_symbol))return!0;if(t.initializer)return Tm(t.initializer,e.Diagnostics.A_type_literal_property_cannot_have_an_initializer)}if(e.isInAmbientContext(t)&&t.initializer)return Dm(t.initializer,e.Diagnostics.Initializers_are_not_allowed_in_ambient_contexts)}(t)||lm(t.name),Sp(t)}function Ld(t){Fd(t),function(t){if(t.typeParameters)return Cm(t,t.typeParameters.pos,t.typeParameters.end-t.typeParameters.pos,e.Diagnostics.Type_parameters_cannot_appear_on_a_constructor_declaration)}(t)||function(t){if(t.type)Tm(t.type,e.Diagnostics.Type_annotation_cannot_appear_on_a_constructor_declaration)}(t),cf(t.body),ap(t);var n=er(t);if(t===e.getDeclarationOfKind(n,t.kind)&&Vd(n),!e.nodeIsMissing(t.body)&&r){var i=t.parent;if(e.getClassExtendsHeritageClauseElement(i)){Uu(t.parent,i);var a=Wu(i),o=qu(t);if(o){if(a&&cn(o,e.Diagnostics.A_constructor_cannot_contain_a_super_call_when_its_class_extends_null),e.some(t.parent.members,(function(t){return 149===t.kind&&!e.hasModifier(t,32)&&!!t.initializer}))||e.some(t.parameters,(function(t){return e.hasModifier(t,92)}))){for(var s=void 0,c=0,u=t.body.statements;c<u.length;c++){var _=u[c];if(210===_.kind&&e.isSuperCall(_.expression)){s=_;break}if(!e.isPrologueDirective(_))break}s||cn(t,e.Diagnostics.A_super_call_must_be_the_first_statement_in_the_constructor_when_a_class_contains_initialized_properties_or_has_parameter_properties)}}else a||cn(t,e.Diagnostics.Constructors_for_derived_classes_must_contain_a_super_call)}}}function Md(t){if(r){if(om(t)||function(t){var n=t.kind;if(D<1)return Tm(t.name,e.Diagnostics.Accessors_are_only_available_when_targeting_ECMAScript_5_and_higher);if(e.isInAmbientContext(t))return Tm(t.name,e.Diagnostics.An_accessor_cannot_be_declared_in_an_ambient_context);if(void 0===t.body&&!e.hasModifier(t,128))return Cm(t,t.end-1,";".length,e.Diagnostics._0_expected,"{");if(t.body&&e.hasModifier(t,128))return Tm(t,e.Diagnostics.An_abstract_accessor_cannot_have_an_implementation);if(t.typeParameters)return Tm(t.name,e.Diagnostics.An_accessor_cannot_have_type_parameters);if(!function(e){return mm(e)||e.parameters.length===(153===e.kind?0:1)}(t))return Tm(t.name,153===n?e.Diagnostics.A_get_accessor_cannot_have_parameters:e.Diagnostics.A_set_accessor_must_have_exactly_one_parameter);if(154===n){if(t.type)return Tm(t.name,e.Diagnostics.A_set_accessor_cannot_have_a_return_type_annotation);var r=t.parameters[0];if(r.dotDotDotToken)return Tm(r.dotDotDotToken,e.Diagnostics.A_set_accessor_cannot_have_rest_parameter);if(r.questionToken)return Tm(r.questionToken,e.Diagnostics.A_set_accessor_cannot_have_an_optional_parameter);if(r.initializer)return Tm(t.name,e.Diagnostics.A_set_accessor_parameter_cannot_have_an_initializer)}}(t)||lm(t.name),np(t),Fd(t),153===t.kind&&!e.isInAmbientContext(t)&&e.nodeIsPresent(t.body)&&128&t.flags&&(256&t.flags||cn(t.name,e.Diagnostics.A_get_accessor_must_return_a_value)),144===t.name.kind&&b_(t.name),!e.hasDynamicName(t)){var n=153===t.kind?154:153,i=e.getDeclarationOfKind(t.symbol,n);if(i){var a=e.getModifierFlags(t),o=e.getModifierFlags(i);(28&a)!=(28&o)&&cn(t.name,e.Diagnostics.Getter_and_setter_accessors_do_not_agree_in_visibility),(128&a)!=(128&o)&&cn(t.name,e.Diagnostics.Accessors_must_both_be_abstract_or_non_abstract),Bd(t,i,ri,e.Diagnostics.get_and_set_accessor_must_have_the_same_type),Bd(t,i,ii,e.Diagnostics.get_and_set_accessor_must_have_the_same_this_type)}}var s=ai(er(t));153===t.kind&&Xl(t,s)}cf(t.body),ap(t)}function Bd(e,t,n,r){var i=n(e),a=n(t);i&&a&&!As(i,a)&&cn(e,r)}function Jd(t,n){for(var r,i,a=Pa(t),o=!0,s=0;s<t.length;s++){var c=ca(t[s]);if(c){r||(i=gs(t,r=Fa(e.map(n,ds),t,a,e.isInJavaScriptFile(n[s]))));var u=r[s];o=o&&Ls(u,Ss(c,i),n[s],e.Diagnostics.Type_0_does_not_satisfy_the_constraint_1)}}return o}function zd(t){sm(t,t.typeArguments),159!==t.kind||void 0===t.typeName.jsdocDotPos||e.isInJavaScriptFile(t)||e.isInJSDoc(t)||Cm(t,t.typeName.jsdocDotPos,1,e.Diagnostics.JSDoc_types_can_only_be_used_inside_documentation_comments);var n=oo(t);if(n!==Q){if(t.typeArguments&&(e.forEach(t.typeArguments,cf),r)){var i=yn(t).resolvedSymbol;if(!i)return void(e.isJSDocIndexSignature(t)||cn(t,e.Diagnostics.Type_0_is_not_generic,Tr(n)));var a=524288&i.flags&&gn(i).typeParameters;!a&&4&hn(n)&&(a=n.target.localTypeParameters),Jd(a,t.typeArguments)}16&n.flags&&8&yn(t).resolvedSymbol.flags&&cn(t,e.Diagnostics.Enum_type_0_has_members_with_initializers_that_are_not_literals,Tr(n))}}function jd(t,n){if(!(524288&t.flags))return t;var r=t.objectType,i=t.indexType;return Os(i,Wo(r))?(180===n.kind&&e.isAssignmentTarget(n)&&32&hn(r)&&r.declaration.readonlyToken&&cn(n,e.Diagnostics.Index_signature_in_type_0_only_permits_reading,Tr(r)),t):(Da(ma(r),1)&&ad(i,84)||cn(n,e.Diagnostics.Type_0_cannot_be_used_to_index_type_1,Tr(i),Tr(r)),t)}function Kd(t){return e.hasModifier(t,8)&&e.isInAmbientContext(t)}function Ud(t,n){var r=e.getCombinedModifierFlags(t);return 230!==t.parent.kind&&229!==t.parent.kind&&199!==t.parent.kind&&e.isInAmbientContext(t)&&(2&r||(r|=1),r|=2),r&n}function Vd(t){if(r){for(var n,i,a,o=0,s=155,c=!1,u=!0,_=!1,l=t.declarations,d=0!=(16384&t.flags),p=!1,f=!1,m=0,g=l;m<g.length;m++){var y=g[m],h=e.isInAmbientContext(y),v=230===y.parent.kind||163===y.parent.kind||h;if(v&&(a=void 0),228===y.kind||151===y.kind||150===y.kind||152===y.kind){var b=Ud(y,155);o|=b,s&=b,c=c||e.hasQuestionToken(y),u=u&&e.hasQuestionToken(y),e.nodeIsPresent(y.body)&&n?d?f=!0:p=!0:a&&a.parent===y.parent&&a.end!==y.pos&&E(a),e.nodeIsPresent(y.body)?n||(n=y):_=!0,a=y,v||(i=y)}}if(f&&e.forEach(l,(function(t){cn(t,e.Diagnostics.Multiple_constructor_implementations_are_not_allowed)})),p&&e.forEach(l,(function(t){cn(e.getNameOfDeclaration(t),e.Diagnostics.Duplicate_function_implementation)})),!i||i.body||e.hasModifier(i,128)||i.questionToken||E(i),_&&(function(t,n,r,i,a){if(0!=(i^a)){var o=Ud(T(t,n),r);e.forEach(t,(function(t){var n=Ud(t,r)^o;1&n?cn(e.getNameOfDeclaration(t),e.Diagnostics.Overload_signatures_must_all_be_exported_or_non_exported):2&n?cn(e.getNameOfDeclaration(t),e.Diagnostics.Overload_signatures_must_all_be_ambient_or_non_ambient):24&n?cn(e.getNameOfDeclaration(t)||t,e.Diagnostics.Overload_signatures_must_all_be_public_private_or_protected):128&n&&cn(e.getNameOfDeclaration(t),e.Diagnostics.Overload_signatures_must_all_be_abstract_or_non_abstract)}))}}(l,n,155,o,s),function(t,n,r,i){if(r!==i){var a=e.hasQuestionToken(T(t,n));e.forEach(t,(function(t){e.hasQuestionToken(t)!==a&&cn(e.getNameOfDeclaration(t),e.Diagnostics.Overload_signatures_must_all_be_optional_or_required)}))}}(l,n,c,u),n))for(var x=Ia(t),k=Oa(n),S=0,D=x;S<D.length;S++){var C=D[S];if(!Js(k,C)){cn(C.declaration,e.Diagnostics.Overload_signature_is_not_compatible_with_function_implementation);break}}}function T(e,t){return void 0!==t&&t.parent===e[0].parent?t:e[0]}function E(t){if(!t.name||!e.nodeIsMissing(t.name)){var n=!1,r=e.forEachChild(t.parent,(function(e){if(n)return e;n=e===t}));if(r&&r.pos===t.end&&r.kind===t.kind){var i=r.name||r,a=r.name;if(t.name&&a&&(e.isComputedPropertyName(t.name)&&e.isComputedPropertyName(a)||!e.isComputedPropertyName(t.name)&&!e.isComputedPropertyName(a)&&e.getEscapedTextOfIdentifierOrLiteral(t.name)===e.getEscapedTextOfIdentifierOrLiteral(a))){if((151===t.kind||150===t.kind)&&e.hasModifier(t,32)!==e.hasModifier(r,32))cn(i,e.hasModifier(t,32)?e.Diagnostics.Function_overload_must_be_static:e.Diagnostics.Function_overload_must_not_be_static);return}if(e.nodeIsPresent(r.body))return void cn(i,e.Diagnostics.Function_implementation_name_must_be_0,e.declarationNameToString(t.name))}var o=t.name||t;d?cn(o,e.Diagnostics.Constructor_implementation_is_missing):e.hasModifier(t,128)?cn(o,e.Diagnostics.All_declarations_of_an_abstract_method_must_be_consecutive):cn(o,e.Diagnostics.Function_implementation_is_missing_or_not_immediately_following_the_declaration)}}}function qd(t){if(r){var n=t.localSymbol;if((n||(n=er(t)).exportSymbol)&&e.getDeclarationOfKind(n,t.kind)===t){for(var i=0,a=0,o=0,s=0,c=n.declarations;s<c.length;s++){var u=h(g=c[s]),_=Ud(g,513);1&_?512&_?o|=u:i|=u:a|=u}var l,d=i&a,p=o&(i|a);if(d||p)for(var f=0,m=n.declarations;f<m.length;f++){u=h(g=m[f]);var g,y=e.getNameOfDeclaration(g);u&p?cn(y,e.Diagnostics.Merged_declaration_0_cannot_include_a_default_export_declaration_Consider_adding_a_separate_export_default_0_declaration_instead,e.declarationNameToString(y)):u&d&&cn(y,e.Diagnostics.Individual_declarations_in_merged_declaration_0_must_be_all_exported_or_all_local,e.declarationNameToString(y))}!function(e){e[e.None=0]="None",e[e.ExportValue=1]="ExportValue",e[e.ExportType=2]="ExportType",e[e.ExportNamespace=4]="ExportNamespace"}(l||(l={}))}}function h(t){switch(t.kind){case 230:case 231:case 283:return 2;case 233:return e.isAmbientModule(t)||0!==e.getModuleInstanceState(t)?5:4;case 229:case 232:return 3;case 237:case 240:case 239:var n=0,r=Ln(er(t));return e.forEach(r.declarations,(function(e){n|=h(e)})),n;case 226:case 176:case 228:case 242:return 1;default:e.Debug.fail(e.SyntaxKind[t.kind])}}}function Wd(e,t,n){var r=Hd(e,t);return r&&Qd(r,t,n)}function Hd(t,n){if(!Ur(t)){var r=t;if(r.promisedTypeOfPromise)return r.promisedTypeOfPromise;if(ui(t,mo(!1)))return r.promisedTypeOfPromise=t.typeArguments[0];var i=Kr(t,"then");if(!Ur(i)){var a=i?xa(i,0):e.emptyArray;if(0!==a.length){var o=nu(zo(e.map(a,jl)),524288);if(!Ur(o)){var s=xa(o,0);if(0!==s.length)return r.promisedTypeOfPromise=zo(e.map(s,jl),!0);n&&cn(n,e.Diagnostics.The_first_parameter_of_the_then_method_of_a_promise_must_be_a_callback)}}else n&&cn(n,e.Diagnostics.A_promise_must_have_a_then_method)}}}function Gd(e,t,n){return Qd(e,t,n)||Q}function Qd(t,n,r){var i=t;if(i.awaitedTypeOfType)return i.awaitedTypeOfType;if(Ur(t))return i.awaitedTypeOfType=t;if(65536&t.flags){for(var a=void 0,o=0,s=t.types;o<s.length;o++){var c=s[o];a=e.append(a,Qd(c,n,r))}if(!a)return;return i.awaitedTypeOfType=zo(a)}var u=Hd(t);if(u){if(t.id===u.id||e.indexOf(Nt,u.id)>=0)return void(n&&cn(n,e.Diagnostics.Type_is_referenced_directly_or_indirectly_in_the_fulfillment_callback_of_its_own_then_method));Nt.push(t.id);var _=Qd(u,n,r);if(Nt.pop(),!_)return;return i.awaitedTypeOfType=_}var l=Kr(t,"then");if(!(l&&xa(l,0).length>0))return i.awaitedTypeOfType=t;n&&(e.Debug.assert(!!r),cn(n,r))}function Xd(t){var n,r=e.getEffectiveReturnTypeNode(t),i=ds(r);if(D>=2){if(i===Q)return Q;var a=mo(!0);if(a!==pe&&!ui(i,a))return cn(r,e.Diagnostics.The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type),Q}else{if(function(t){Zd(t&&e.getEntityNameFromTypeNode(t))}(r),i===Q)return Q;var o=e.getEntityNameFromTypeNode(r);if(void 0===o)return cn(r,e.Diagnostics.Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value,Tr(i)),Q;var s=jn(o,107455,!0),c=s?ci(s):Q;if(c===Q)return 71===o.kind&&"Promise"===o.escapedText&&_i(i)===mo(!1)?cn(r,e.Diagnostics.An_async_function_or_method_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option):cn(r,e.Diagnostics.Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value,e.entityNameToString(o)),Q;var u=(n=!0,Je||(Je=po("PromiseConstructorLike",0,n))||_e);if(u===_e)return cn(r,e.Diagnostics.Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value,e.entityNameToString(o)),Q;if(!Ls(c,u,r,e.Diagnostics.Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value))return Q;var _=o&&$p(o),l=bn(t.locals,_.escapedText,107455);if(l)return cn(l.valueDeclaration,e.Diagnostics.Duplicate_identifier_0_Compiler_uses_declaration_1_to_support_async_functions,e.idText(_),e.entityNameToString(o)),Q}return Gd(i,t,e.Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member)}function Yd(t){var n=La(Pl(t));if(!(1&n.flags)){var r,i,a=Tl(t);switch(t.parent.kind){case 229:r=zo([ci(er(t.parent)),oe]);break;case 146:r=oe,i=e.chainDiagnosticMessages(i,e.Diagnostics.The_return_type_of_a_parameter_decorator_function_must_be_either_void_or_any);break;case 149:r=oe,i=e.chainDiagnosticMessages(i,e.Diagnostics.The_return_type_of_a_property_decorator_function_must_be_either_void_or_any);break;case 151:case 153:case 154:r=zo([To(xf(t.parent)),oe])}Ls(n,r,t,a,i)}}function Zd(e){if(e){var t=$p(e),n=2097152|(71===e.kind?793064:1920),r=kn(t,t.escapedText,n,void 0,void 0,!0);r&&2097152&r.flags&&rr(r)&&!If(Ln(r))&&Bn(r)}}function $d(t){var n=ep(t);n&&e.isEntityName(n)&&Zd(n)}function ep(t){if(t)switch(t.kind){case 167:case 166:for(var n=void 0,r=0,i=t.types;r<i.length;r++){var a=ep(i[r]);if(!a)return;if(n){if(!e.isIdentifier(n)||!e.isIdentifier(a)||n.escapedText!==a.escapedText)return}else n=a}return n;case 168:return ep(t.type);case 159:return t.typeName}}function tp(t){var n=e.getEffectiveTypeAnnotationNode(t);return e.isRestParameter(t)?e.getRestParameterElementType(n):n}function np(t){if(t.decorators&&e.nodeCanBeDecorated(t)){S.experimentalDecorators||cn(t,e.Diagnostics.Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_the_experimentalDecorators_option_to_remove_this_warning);var n=t.decorators[0];if($f(n,8),146===t.kind&&$f(n,32),S.emitDecoratorMetadata)switch($f(n,16),t.kind){case 229:var r=e.getFirstConstructorWithBody(t);if(r)for(var i=0,a=r.parameters;i<a.length;i++){$d(tp(a[i]))}break;case 151:case 153:case 154:for(var o=0,s=t.parameters;o<s.length;o++){$d(tp(s[o]))}$d(e.getEffectiveReturnTypeNode(t));break;case 149:$d(e.getEffectiveTypeAnnotationNode(t));break;case 146:$d(tp(t))}e.forEach(t.decorators,Yd)}}function rp(e){switch(e.kind){case 71:return e;case 179:return e.name;default:return}}function ip(t){np(t),Fd(t);var n=e.getFunctionFlags(t);if(t.name&&144===t.name.kind&&b_(t.name),!e.hasDynamicName(t)){var i=er(t),a=t.localSymbol||i,o=e.find(a.declarations,(function(e){return e.kind===t.kind&&!(65536&e.flags)}));t===o&&Vd(a),i.parent&&e.getDeclarationOfKind(i,t.kind)===t&&Vd(i)}cf(t.body);var s=e.getEffectiveReturnTypeNode(t);if(0==(1&n)){var c=s&&(2&n?Xd(t):ds(s));Xl(t,c)}r&&!s&&(w&&e.nodeIsMissing(t.body)&&!Kd(t)&&Ac(t,H),1&n&&e.nodeIsPresent(t.body)&&La(Oa(t))),ap(t)}function ap(e){Ye&&Ye.push(e)}function op(t){230!==t.parent.kind&&T&&!e.isInAmbientContext(t)&&t.locals.forEach((function(t){if(!t.isReferenced)if(t.valueDeclaration&&146===e.getRootDeclaration(t.valueDeclaration).kind){var n=e.getRootDeclaration(t.valueDeclaration),r=e.getNameOfDeclaration(t.valueDeclaration);!S.noUnusedParameters||e.isParameterPropertyDeclaration(n)||e.parameterIsThisKeyword(n)||(i=r)&&cp(i)||cn(r,e.Diagnostics._0_is_declared_but_its_value_is_never_read,e.symbolName(t))}else S.noUnusedLocals&&e.forEach(t.declarations,(function(n){return sp(n,e.symbolName(t))}));var i}))}function sp(t,n){var r=e.getNameOfDeclaration(t)||t;if(cp(r)){var i=e.getRootDeclaration(r.parent);if(226===i.kind&&e.isForInOrOfStatement(i.parent.parent)||145===i.kind)return}(function(t){if(e.isBindingElement(t)&&e.isObjectBindingPattern(t.parent)){var n=e.lastOrUndefined(t.parent.elements);return n!==t&&!!n.dotDotDotToken}return!1})(71===r.kind?r.parent:r)||cn(r,e.Diagnostics._0_is_declared_but_its_value_is_never_read,n)}function cp(t){return 71===t.kind&&95===e.idText(t).charCodeAt(0)}function up(t){if(S.noUnusedLocals&&!e.isInAmbientContext(t)&&t.members)for(var n=0,r=t.members;n<r.length;n++){var i=r[n];if(151===i.kind||149===i.kind)!i.symbol.isReferenced&&e.hasModifier(i,8)&&cn(i.name,e.Diagnostics._0_is_declared_but_its_value_is_never_read,e.symbolName(i.symbol));else if(152===i.kind)for(var a=0,o=i.parameters;a<o.length;a++){var s=o[a];!s.symbol.isReferenced&&e.hasModifier(s,8)&&cn(s.name,e.Diagnostics.Property_0_is_declared_but_its_value_is_never_read,e.symbolName(s.symbol))}}}function _p(t){if(S.noUnusedLocals&&!e.isInAmbientContext(t)&&t.typeParameters){var n=er(t);if((n&&n.declarations&&e.lastOrUndefined(n.declarations))!==t)return;for(var r=0,i=t.typeParameters;r<i.length;r++){var a=i[r];$n(a.symbol).isReferenced||cp(a.name)||cn(a.name,e.Diagnostics._0_is_declared_but_its_value_is_never_read,e.symbolName(a.symbol))}}}function lp(t){S.noUnusedLocals&&!e.isInAmbientContext(t)&&t.locals.forEach((function(t){if(!t.isReferenced&&!t.exportSymbol)for(var n=0,r=t.declarations;n<r.length;n++){var i=r[n];e.isAmbientModule(i)||sp(i,e.symbolName(t))}}))}function dp(t){if(207===t.kind&&Nm(t),e.isFunctionOrModuleBlock(t)){var n=_t;e.forEach(t.statements,cf),_t=n}else e.forEach(t.statements,cf);t.locals&&ap(t)}function pp(t,n,r){if(!n||n.escapedText!==r)return!1;if(149===t.kind||148===t.kind||151===t.kind||150===t.kind||153===t.kind||154===t.kind)return!1;if(e.isInAmbientContext(t))return!1;var i=e.getRootDeclaration(t);return 146!==i.kind||!e.nodeIsMissing(i.parent.body)}function fp(e,t){pp(e,t,"_this")&&Tt.push(e)}function mp(e,t){pp(e,t,"_newTarget")&&Et.push(e)}function gp(t){e.findAncestor(t,(function(n){if(4&Jf(n))return 71!==t.kind?cn(e.getNameOfDeclaration(t),e.Diagnostics.Duplicate_identifier_this_Compiler_uses_variable_declaration_this_to_capture_this_reference):cn(t,e.Diagnostics.Expression_resolves_to_variable_declaration_this_that_compiler_uses_to_capture_this_reference),!0}))}function yp(t){e.findAncestor(t,(function(n){if(8&Jf(n))return 71!==t.kind?cn(e.getNameOfDeclaration(t),e.Diagnostics.Duplicate_identifier_newTarget_Compiler_uses_variable_declaration_newTarget_to_capture_new_target_meta_property_reference):cn(t,e.Diagnostics.Expression_resolves_to_variable_declaration_newTarget_that_compiler_uses_to_capture_new_target_meta_property_reference),!0}))}function hp(t,n){if(pp(t,n,"_super")){var r=e.getContainingClass(t);if(r&&!e.isInAmbientContext(r))if(e.getClassExtendsHeritageClauseElement(r))cn(t,71!==t.kind?e.Diagnostics.Duplicate_identifier_super_Compiler_uses_super_to_capture_base_class_reference:e.Diagnostics.Expression_resolves_to_super_that_compiler_uses_to_capture_base_class_reference)}}function vp(t,n){if(!(C>=e.ModuleKind.ES2015)&&(pp(t,n,"require")||pp(t,n,"exports"))&&(233!==t.kind||1===e.getModuleInstanceState(t))){var r=jr(t);265===r.kind&&e.isExternalOrCommonJsModule(r)&&cn(n,e.Diagnostics.Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module,e.declarationNameToString(n),e.declarationNameToString(n))}}function bp(t,n){if(!(D>=4)&&pp(t,n,"Promise")&&(233!==t.kind||1===e.getModuleInstanceState(t))){var r=jr(t);265===r.kind&&e.isExternalOrCommonJsModule(r)&&1024&r.flags&&cn(n,e.Diagnostics.Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_containing_async_functions,e.declarationNameToString(n),e.declarationNameToString(n))}}function xp(t){if(146===e.getRootDeclaration(t).kind){var n=e.getContainingFunction(t);!function r(i){if(e.isTypeNode(i)||e.isDeclarationName(i))return;if(179===i.kind)return r(i.expression);if(71!==i.kind)return e.forEachChild(i,r);var a=kn(i,i.escapedText,2204607,void 0,void 0,!1);if(!a||a===q||!a.valueDeclaration)return;if(a.valueDeclaration===t)return void cn(i,e.Diagnostics.Parameter_0_cannot_be_referenced_in_its_initializer,e.declarationNameToString(t.name));if(e.getEnclosingBlockScopeContainer(a.valueDeclaration)===n){if(146===a.valueDeclaration.kind||176===a.valueDeclaration.kind){if(a.valueDeclaration.pos<t.pos)return;if(e.findAncestor(i,(function(n){return n===t.initializer?"quit":e.isFunctionLike(n.parent)||149===n.parent.kind&&!e.hasModifier(n.parent,32)&&e.isClassLike(n.parent.parent)})))return}cn(i,e.Diagnostics.Initializer_of_parameter_0_cannot_reference_identifier_1_declared_after_it,e.declarationNameToString(t.name),e.declarationNameToString(i))}}(t.initializer)}}function kp(e){return e===G?H:e===Fe?Pe:e}function Sp(t){if(np(t),cf(t.type),t.name){if(144===t.name.kind&&(b_(t.name),t.initializer&&hd(t.initializer)),176===t.kind){174===t.parent.kind&&D<5&&$f(t,4),t.propertyName&&144===t.propertyName.kind&&b_(t.propertyName);var n=t.parent.parent,r=Vr(n),i=t.propertyName||t.name,a=va(r,e.getTextOfPropertyName(i));$_(a,void 0,!1),n.initializer&&a&&U_(n,n.initializer,r,a)}if(e.isBindingPattern(t.name)&&(175===t.name.kind&&D<2&&S.downlevelIteration&&$f(t,512),e.forEach(t.name.elements,cf)),t.initializer&&146===e.getRootDeclaration(t).kind&&e.nodeIsMissing(e.getContainingFunction(t).body))cn(t,e.Diagnostics.A_parameter_initializer_is_only_allowed_in_a_function_or_constructor_implementation);else if(e.isBindingPattern(t.name))t.initializer&&215!==t.parent.parent.kind&&(Ls(hd(t.initializer),ei(t),t,void 0),xp(t));else{var o=er(t),s=kp(ni(o));if(t===o.valueDeclaration)t.initializer&&215!==t.parent.parent.kind&&(Ls(hd(t.initializer),s,t,void 0),xp(t));else{var c=kp(ei(t));s===Q||c===Q||As(s,c)||cn(t.name,e.Diagnostics.Subsequent_variable_declarations_must_have_the_same_type_Variable_0_must_be_of_type_1_but_here_has_type_2,e.declarationNameToString(t.name),Tr(s),Tr(c)),t.initializer&&Ls(hd(t.initializer),c,t,void 0),function(t,n){if(146===t.kind&&226===n.kind||226===t.kind&&146===n.kind)return!0;if(e.hasQuestionToken(t)!==e.hasQuestionToken(n))return!1;var r=504;return e.getSelectedModifierFlags(t,r)===e.getSelectedModifierFlags(n,r)}(t,o.valueDeclaration)||(cn(e.getNameOfDeclaration(o.valueDeclaration),e.Diagnostics.All_declarations_of_0_must_have_identical_modifiers,e.declarationNameToString(t.name)),cn(t.name,e.Diagnostics.All_declarations_of_0_must_have_identical_modifiers,e.declarationNameToString(t.name)))}149!==t.kind&&148!==t.kind&&(qd(t),226!==t.kind&&176!==t.kind||function(t){if(0==(3&e.getCombinedNodeFlags(t))&&!e.isParameterDeclaration(t)&&(226!==t.kind||t.initializer)){var n=er(t);if(1&n.flags){if(!e.isIdentifier(t.name))throw e.Debug.fail();var r=kn(t,t.name.escapedText,3,void 0,void 0,!1);if(r&&r!==n&&2&r.flags&&3&j_(r)){var i=e.getAncestor(r.valueDeclaration,227),a=208===i.parent.kind&&i.parent.parent?i.parent.parent:void 0;if(!a||!(207===a.kind&&e.isFunctionLike(a.parent)||234===a.kind||233===a.kind||265===a.kind)){var o=Dr(r);cn(t,e.Diagnostics.Cannot_initialize_outer_scoped_variable_0_in_the_same_scope_as_block_scoped_declaration_1,o,o)}}}}}(t),hp(t,t.name),fp(t,t.name),mp(t,t.name),vp(t,t.name),bp(t,t.name))}}}function Dp(t){return function(t){if(215!==t.parent.parent.kind&&216!==t.parent.parent.kind)if(e.isInAmbientContext(t)){if(t.initializer){if(!e.isConst(t)||t.type){var n="=".length;return Cm(t,t.initializer.pos-n,n,e.Diagnostics.Initializers_are_not_allowed_in_ambient_contexts)}if(!hm(t.initializer))return Tm(t.initializer,e.Diagnostics.A_const_initializer_in_an_ambient_context_must_be_a_string_or_numeric_literal)}if(t.initializer&&(!e.isConst(t)||!hm(t.initializer))){n="=".length;return Cm(t,t.initializer.pos-n,n,e.Diagnostics.Initializers_are_not_allowed_in_ambient_contexts)}}else if(!t.initializer){if(e.isBindingPattern(t.name)&&!e.isBindingPattern(t.parent))return Tm(t,e.Diagnostics.A_destructuring_declaration_must_have_an_initializer);if(e.isConst(t))return Tm(t,e.Diagnostics.const_declarations_must_be_initialized)}S.module===e.ModuleKind.ES2015||S.module===e.ModuleKind.ESNext||S.module===e.ModuleKind.System||S.noEmit||e.isInAmbientContext(t.parent.parent)||!e.hasModifier(t.parent.parent,1)||vm(t.name);(e.isLet(t)||e.isConst(t))&&bm(t.name)}(t),Sp(t)}function Cp(t){return function(t){if(t.dotDotDotToken){var n=t.parent.elements;if(t!==e.lastOrUndefined(n))return Tm(t,e.Diagnostics.A_rest_element_must_be_last_in_a_destructuring_pattern);if(175===t.name.kind||174===t.name.kind)return Tm(t.name,e.Diagnostics.A_rest_element_cannot_contain_a_binding_pattern);if(t.initializer)Cm(t,t.initializer.pos-1,1,e.Diagnostics.A_rest_element_cannot_have_an_initializer)}}(t),Sp(t)}function Tp(t){tm(t)||nm(t)||xm(t.declarationList)||function(t){if(!km(t.parent)){if(e.isLet(t.declarationList))return Tm(t,e.Diagnostics.let_declarations_can_only_be_declared_inside_a_block);if(e.isConst(t.declarationList))Tm(t,e.Diagnostics.const_declarations_can_only_be_declared_inside_a_block)}}(t),e.forEach(t.declarationList.declarations,cf)}function Ep(t){fm(t);var n=V_(t.expression);if(227===t.initializer.kind){var r=t.initializer.declarations[0];r&&e.isBindingPattern(r.name)&&cn(r.name,e.Diagnostics.The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern),Np(t)}else{var i=t.initializer,a=Ed(i);177===i.kind||178===i.kind?cn(i,e.Diagnostics.The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern):Os(function(e){var t=Wo(e);return t!==se?t:ee}(n),a)?rd(i,e.Diagnostics.The_left_hand_side_of_a_for_in_statement_must_be_a_variable_or_a_property_access):cn(i,e.Diagnostics.The_left_hand_side_of_a_for_in_statement_must_be_of_type_string_or_any)}ad(n,17317888)||cn(t.expression,e.Diagnostics.The_right_hand_side_of_a_for_in_statement_must_be_of_type_any_an_object_type_or_a_type_parameter),cf(t.statement),t.locals&&ap(t)}function Np(e){var t=e.initializer;t.declarations.length>=1&&Dp(t.declarations[0])}function Ap(e,t){return wp(V_(e),e,!0,void 0!==t)}function wp(e,t,n,r){return Ur(e)?e:Pp(e,t,n,r,!0)||H}function Pp(t,n,r,i,a){var o=D>=2,s=!o&&S.downlevelIteration;if(o||s||i){var c=Fp(t,o?n:void 0,i,!0,a);if(c||o)return c}var u=t,_=!1,l=!1;if(r){if(65536&u.flags){var d=t.types,p=e.filter(d,(function(e){return!(262178&e.flags)}));p!==d&&(u=zo(p,!0))}else 262178&u.flags&&(u=se);if((l=u!==t)&&(D<1&&n&&(cn(n,e.Diagnostics.Using_a_string_in_a_for_of_statement_is_only_supported_in_ECMAScript_5_and_higher),_=!0),8192&u.flags))return ee}if(!cc(u)){if(n&&!_)cn(n,!r||l?s?e.Diagnostics.Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator:e.Diagnostics.Type_0_is_not_an_array_type:s?e.Diagnostics.Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator:e.Diagnostics.Type_0_is_not_an_array_type_or_a_string_type,Tr(u));return l?ee:void 0}var f=Ca(u,1);return l&&f?262178&f.flags?ee:zo([f,ee],!0):f}function Fp(t,n,r,i,a){if(!Ur(t))return bu(t,(function(t){var o=t;if(r){if(o.iteratedTypeOfAsyncIterable)return o.iteratedTypeOfAsyncIterable;if(ui(t,yo(!1))||ui(t,vo(!1)))return o.iteratedTypeOfAsyncIterable=t.typeArguments[0]}if(i){if(o.iteratedTypeOfIterable)return o.iteratedTypeOfIterable;if(ui(t,bo(!1))||ui(t,ko(!1)))return o.iteratedTypeOfIterable=t.typeArguments[0]}var s=r&&Kr(t,e.getPropertyNameForKnownSymbolName("asyncIterator")),c=s||i&&Kr(t,e.getPropertyNameForKnownSymbolName("iterator"));if(Ur(c))return;var u=c&&xa(c,0);if(!e.some(u))return void(n&&(cn(n,r?e.Diagnostics.Type_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator:e.Diagnostics.Type_must_have_a_Symbol_iterator_method_that_returns_an_iterator),n=void 0));var _=Op(zo(e.map(u,La),!0),n,!!s);a&&n&&_&&Ls(t,s?function(e){return Co(yo(!0),[e])}(_):No(_),n);return s?o.iteratedTypeOfAsyncIterable=_:o.iteratedTypeOfIterable=_}))}function Op(t,n,r){if(!Ur(t)){var i=t;if(r?i.iteratedTypeOfAsyncIterator:i.iteratedTypeOfIterator)return r?i.iteratedTypeOfAsyncIterator:i.iteratedTypeOfIterator;if(ui(t,(r?ho:xo)(!1)))return r?i.iteratedTypeOfAsyncIterator=t.typeArguments[0]:i.iteratedTypeOfIterator=t.typeArguments[0];var a=Kr(t,"next");if(!Ur(a)){var o=a?xa(a,0):e.emptyArray;if(0!==o.length){var s=zo(e.map(o,La),!0);if(!(Ur(s)||r&&Ur(s=Wd(s,n,e.Diagnostics.The_type_returned_by_the_next_method_of_an_async_iterator_must_be_a_promise_for_a_type_with_a_value_property)))){var c=s&&Kr(s,"value");if(c)return r?i.iteratedTypeOfAsyncIterator=c:i.iteratedTypeOfIterator=c;n&&cn(n,r?e.Diagnostics.The_type_returned_by_the_next_method_of_an_async_iterator_must_be_a_promise_for_a_type_with_a_value_property:e.Diagnostics.The_type_returned_by_the_next_method_of_an_iterator_must_have_a_value_property)}}else n&&cn(n,r?e.Diagnostics.An_async_iterator_must_have_a_next_method:e.Diagnostics.An_iterator_must_have_a_next_method)}}}function Ip(e,t){if(!Ur(e))return Fp(e,void 0,t,!t,!1)||Op(e,void 0,t)}function Rp(t){Nm(t)||function(t){var n=t;for(;n;){if(e.isFunctionLike(n))return Tm(t,e.Diagnostics.Jump_target_cannot_cross_function_boundary);switch(n.kind){case 222:if(t.label&&n.label.escapedText===t.label.escapedText)return!!(217===t.kind&&!e.isIterationStatement(n.statement,!0))&&Tm(t,e.Diagnostics.A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement);break;case 221:if(218===t.kind&&!t.label)return!1;break;default:if(e.isIterationStatement(n,!1)&&!t.label)return!1}n=n.parent}t.label?Tm(t,218===t.kind?e.Diagnostics.A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement:e.Diagnostics.A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement):Tm(t,218===t.kind?e.Diagnostics.A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement:e.Diagnostics.A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement)}(t)}function Lp(t){return 153===t.kind&&void 0!==e.getEffectiveSetAccessorTypeAnnotationNode(e.getDeclarationOfKind(t.symbol,154))}function Mp(t,n){var r=2==(3&e.getFunctionFlags(t))?Hd(n):n;return r&&id(r,1025)}function Bp(t){Nm(t)||void 0===t.expression&&function(t,n,r,i,a){var o=e.getSourceFileOfNode(t);if(!Sm(o)){var s=e.getSpanOfTokenAtPosition(o,t.pos);At.add(e.createFileDiagnostic(o,e.textSpanEnd(s),0,n,r,i,a))}}(t,e.Diagnostics.Line_break_not_permitted_here),t.expression&&Ed(t.expression)}function Jp(t){var n,r=Va(t.symbol,1),i=Va(t.symbol,0),a=Ca(t,0),o=Ca(t,1);if((a||o)&&(e.forEach(aa(t),(function(e){var n=ci(e);l(e,n,t,i,a,0),l(e,n,t,r,o,1)})),1&hn(t)&&e.isClassLike(t.symbol.valueDeclaration)))for(var s=0,c=t.symbol.valueDeclaration.members;s<c.length;s++){var u=c[s];if(!e.hasModifier(u,32)&&e.hasDynamicName(u)){var _=ci(u.symbol);l(u.symbol,_,t,i,a,0),l(u.symbol,_,t,r,o,1)}}a&&o&&(!(n=r||i)&&2&hn(t)&&(n=e.forEach(Si(t),(function(e){return Ca(e,0)&&Ca(e,1)}))?void 0:t.symbol.declarations[0]));function l(t,n,r,i,a,o){if(a){var s=t.valueDeclaration;if(1!==o||(s?h_(e.getNameOfDeclaration(s)):v_(t.escapedName))){var c;if(!s||194!==s.kind&&144!==e.getNameOfDeclaration(s).kind&&t.parent!==r.symbol){if(i)c=i;else if(2&hn(r)){c=e.forEach(Si(r),(function(e){return oa(e,t.escapedName)&&Ca(e,o)}))?void 0:r.symbol.declarations[0]}}else c=s;if(c&&!Os(n,a))cn(c,0===o?e.Diagnostics.Property_0_of_type_1_is_not_assignable_to_string_index_type_2:e.Diagnostics.Property_0_of_type_1_is_not_assignable_to_numeric_index_type_2,Dr(t),Tr(n),Tr(a))}}}n&&!Os(o,a)&&cn(n,e.Diagnostics.Numeric_index_type_0_is_not_assignable_to_string_index_type_1,Tr(o),Tr(a))}function zp(e,t){switch(e.escapedText){case"any":case"number":case"boolean":case"string":case"symbol":case"void":case"object":cn(e,t,e.escapedText)}}function jp(t){if(t)for(var n=!1,i=0;i<t.length;i++){var a=t[i];if(Nd(a),r){a.default?n=!0:n&&cn(a,e.Diagnostics.Required_type_parameters_may_not_follow_optional_type_parameters);for(var o=0;o<i;o++)t[o].symbol===a.symbol&&cn(a.name,e.Diagnostics.Duplicate_identifier_0,e.declarationNameToString(a.name))}}}function Kp(t){if(1!==t.declarations.length){var n=gn(t);if(!n.typeParametersChecked){n.typeParametersChecked=!0;var r=function(t){return e.filter(t.declarations,(function(e){return 229===e.kind||230===e.kind}))}(t);if(r.length<=1)return;if(!function(t,n){for(var r=e.length(n),i=Pa(n),a=0,o=t;a<o.length;a++){var s=o[a],c=e.length(s.typeParameters);if(c<i||c>r)return!1;for(var u=0;u<c;u++){var _=s.typeParameters[u],l=n[u];if(_.name.escapedText!==l.symbol.escapedName)return!1;var d=_.constraint&&ds(_.constraint),p=Ha(l);if((d||p)&&(!d||!p||!As(d,p)))return!1;var f=_.default&&ds(_.default),m=fa(l);if(f&&m&&!As(f,m))return!1}}return!0}(r,Fi(t).localTypeParameters))for(var i=Dr(t),a=0,o=r;a<o.length;a++){cn(o[a].name,e.Diagnostics.All_declarations_of_0_must_have_identical_type_parameters,i)}}}}function Up(t){e.forEach(t.members,cf),ap(t)}function Vp(t){!function(t){var n=e.getSourceFileOfNode(t);(function(t){var n=!1,r=!1;if(!tm(t)&&!nm(t)&&t.heritageClauses)for(var i=0,a=t.heritageClauses;i<a.length;i++){var o=a[i];if(85===o.token){if(n)return Dm(o,e.Diagnostics.extends_clause_already_seen);if(r)return Dm(o,e.Diagnostics.extends_clause_must_precede_implements_clause);if(o.types.length>1)return Dm(o.types[1],e.Diagnostics.Classes_can_only_extend_a_single_class);n=!0}else{if(e.Debug.assert(108===o.token),r)return Dm(o,e.Diagnostics.implements_clause_already_seen);r=!0}um(o)}})(t)||am(t.typeParameters,n)}(t),np(t),t.name&&(zp(t.name,e.Diagnostics.Class_name_cannot_be_0),fp(t,t.name),mp(t,t.name),vp(t,t.name),bp(t,t.name)),jp(t.typeParameters),qd(t);var n=er(t),i=Fi(n),a=zi(i),o=ci(n);Kp(n),function(t){var n;!function(e){e[e.Getter=1]="Getter",e[e.Setter=2]="Setter",e[e.Method=4]="Method",e[e.Property=3]="Property"}(n||(n={}));for(var r=e.createUnderscoreEscapedMap(),i=e.createUnderscoreEscapedMap(),a=0,o=t.members;a<o.length;a++){var s=o[a];if(152===s.kind)for(var c=0,u=s.parameters;c<u.length;c++){var _=u[c];e.isParameterPropertyDeclaration(_)&&!e.isBindingPattern(_.name)&&p(r,_.name,_.name.escapedText,3)}else{var l=e.hasModifier(s,32)?i:r,d=s.name&&e.getPropertyNameForPropertyNameNode(s.name);if(d)switch(s.kind){case 153:p(l,s.name,d,1);break;case 154:p(l,s.name,d,2);break;case 149:p(l,s.name,d,3);break;case 151:p(l,s.name,d,4)}}}function p(t,n,r,i){var a=t.get(r);a?4&a?4!==i&&cn(n,e.Diagnostics.Duplicate_identifier_0,e.getTextOfNode(n)):a&i?cn(n,e.Diagnostics.Duplicate_identifier_0,e.getTextOfNode(n)):t.set(r,a|i):t.set(r,i)}}(t),e.isInAmbientContext(t)||function(t){for(var n=0,r=t.members;n<r.length;n++){var i=r[n],a=i.name;if(e.hasModifier(i,32)&&a){var o=e.getPropertyNameForPropertyNameNode(a);switch(o){case"name":case"length":case"caller":case"arguments":case"prototype":cn(a,e.Diagnostics.Static_property_0_conflicts_with_built_in_property_Function_0_of_constructor_function_1,o,Or(er(t)))}}}}(t);var s=e.getClassExtendsHeritageClauseElement(t);if(s){D<2&&$f(s.parent,1);var c=Si(i);if(c.length&&r){var u=c[0],_=ki(i),l=ma(_);if(function(t,n){var r=xa(t,1);if(r.length){var i=r[0].declaration;if(i&&e.hasModifier(i,8))yf(n,Wp(t.symbol))||cn(n,e.Diagnostics.Cannot_extend_a_class_0_Class_constructor_is_marked_as_private,zn(t.symbol))}}(l,s),cf(s.expression),e.some(s.typeArguments)){e.forEach(s.typeArguments,cf);for(var d=0,p=bi(l,s.typeArguments,s);d<p.length;d++){if(!Jd(p[d].typeParameters,s.typeArguments))break}}if(Ls(a,zi(u,i.thisType),t.name||t,e.Diagnostics.Class_0_incorrectly_extends_base_class_1),Ls(o,Ns(l),t.name||t,e.Diagnostics.Class_static_side_0_incorrectly_extends_base_class_static_side_1),540672&_.flags&&!yi(o)&&cn(t.name||t,e.Diagnostics.A_mixin_class_must_have_a_constructor_with_a_single_rest_parameter_of_type_any),!(l.symbol&&32&l.symbol.flags||540672&_.flags)){var f=xi(l,s.typeArguments,s);e.forEach(f,(function(e){return La(e)!==u}))&&cn(s.expression,e.Diagnostics.Base_constructors_must_all_have_the_same_return_type)}!function(t,n){for(var r=sa(n),i=0,a=r;i<a.length;i++){var o=a[i],s=qp(o);if(!(4194304&s.flags)){var c=qp(oa(t,s.escapedName)),u=e.getDeclarationModifierFlagsFromSymbol(s);if(e.Debug.assert(!!c,"derived should point to something, even if it is the base class' declaration."),c)if(c===s){var _=Wp(t.symbol);!(128&u)||_&&e.hasModifier(_,128)||(199===_.kind?cn(_,e.Diagnostics.Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1,Dr(o),Tr(n)):cn(_,e.Diagnostics.Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2,Tr(t),Dr(o),Tr(n)))}else{var l=e.getDeclarationModifierFlagsFromSymbol(c);if(8&u||8&l)continue;if(K_(s)&&K_(c)||98308&s.flags&&98308&c.flags)continue;var d=void 0;d=K_(s)?98304&c.flags?e.Diagnostics.Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_accessor:e.Diagnostics.Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_property:4&s.flags?e.Diagnostics.Class_0_defines_instance_member_property_1_but_extended_class_2_defines_it_as_instance_member_function:e.Diagnostics.Class_0_defines_instance_member_accessor_1_but_extended_class_2_defines_it_as_instance_member_function,cn(e.getNameOfDeclaration(c.valueDeclaration)||c.valueDeclaration,d,Tr(n),Dr(s),Tr(t))}}}}(i,u)}}var m=e.getClassImplementsHeritageClauseElements(t);if(m)for(var g=0,y=m;g<y.length;g++){var h=y[g];if(e.isEntityNameExpression(h.expression)||cn(h.expression,e.Diagnostics.A_class_can_only_implement_an_identifier_Slashqualified_name_with_optional_type_arguments),zd(h),r){var v=ds(h);v!==Q&&(Di(v)?Ls(a,zi(v,i.thisType),t.name||t,e.Diagnostics.Class_0_incorrectly_implements_interface_1):cn(h,e.Diagnostics.A_class_may_only_implement_another_class_or_interface))}}r&&(Jp(i),Id(t))}function qp(t){return 1&e.getCheckFlags(t)?t.target:t}function Wp(t){return e.forEach(t.declarations,(function(t){return e.isClassLike(t)?t:void 0}))}function Hp(t){if(tm(t)||nm(t)||function(t){var n=!1;if(t.heritageClauses)for(var r=0,i=t.heritageClauses;r<i.length;r++){var a=i[r];if(85!==a.token)return e.Debug.assert(108===a.token),Dm(a,e.Diagnostics.Interface_declaration_cannot_have_implements_clause);if(n)return Dm(a,e.Diagnostics.extends_clause_already_seen);n=!0,um(a)}}(t),jp(t.typeParameters),r){zp(t.name,e.Diagnostics.Interface_name_cannot_be_0),qd(t);var n=er(t);if(Kp(n),t===e.getDeclarationOfKind(n,230)){var i=Fi(n),a=zi(i);if(function(t,n){var r=Si(t);if(r.length<2)return!0;var i=e.createUnderscoreEscapedMap();e.forEach(Ji(t).declaredProperties,(function(e){i.set(e.escapedName,{prop:e,containingType:t})}));for(var a=!0,o=0,s=r;o<s.length;o++)for(var c=s[o],u=0,_=sa(zi(c,t.thisType));u<_.length;u++){var l=_[u],d=i.get(l.escapedName);if(d){if(d.containingType!==t&&0===rc(d.prop,l,ws)){a=!1;var p=Tr(d.containingType),f=Tr(c),m=e.chainDiagnosticMessages(void 0,e.Diagnostics.Named_property_0_of_types_1_and_2_are_not_identical,Dr(l),p,f);m=e.chainDiagnosticMessages(m,e.Diagnostics.Interface_0_cannot_simultaneously_extend_types_1_and_2,Tr(t),p,f),At.add(e.createDiagnosticForNodeFromMessageChain(n,m))}}else i.set(l.escapedName,{prop:l,containingType:c})}return a}(i,t.name)){for(var o=0,s=Si(i);o<s.length;o++){Ls(a,zi(s[o],i.thisType),t.name,e.Diagnostics.Interface_0_incorrectly_extends_interface_1)}Jp(i)}}Od(t)}e.forEach(e.getInterfaceBaseTypeNodes(t),(function(t){e.isEntityNameExpression(t.expression)||cn(t.expression,e.Diagnostics.An_interface_can_only_extend_an_identifier_Slashqualified_name_with_optional_type_arguments),zd(t)})),e.forEach(t.members,cf),r&&(Id(t),ap(t))}function Gp(e){var t=yn(e);if(!(16384&t.flags)){t.flags|=16384;for(var n=0,r=0,i=e.members;r<i.length;r++){var a=i[r],o=Qp(a,n);yn(a).enumMemberValue=o,n="number"==typeof o?o+1:void 0}}}function Qp(t,n){if(qr(t.name))cn(t.name,e.Diagnostics.Computed_property_names_are_not_allowed_in_enums);else{var r=e.getTextOfPropertyName(t.name);v_(r)&&("Infinity"!==(i=r)&&"-Infinity"!==i&&"NaN"!==i)&&cn(t.name,e.Diagnostics.An_enum_member_cannot_have_a_numeric_name)}var i;return t.initializer?function(t){var n=Ei(er(t.parent)),r=e.isConst(t.parent),i=t.initializer,a=1!==n||Ti(t)?o(i):void 0;if(void 0!==a)r&&"number"==typeof a&&!isFinite(a)&&cn(i,isNaN(a)?e.Diagnostics.const_enum_member_initializer_was_evaluated_to_disallowed_value_NaN:e.Diagnostics.const_enum_member_initializer_was_evaluated_to_a_non_finite_value);else{if(1===n)return cn(i,e.Diagnostics.Computed_values_are_not_permitted_in_an_enum_with_string_valued_members),0;r?cn(i,e.Diagnostics.In_const_enum_declarations_member_initializer_must_be_constant_expression):e.isInAmbientContext(t.parent)?cn(i,e.Diagnostics.In_ambient_enum_declarations_member_initializer_must_be_constant_expression):Ls(Ed(i),Fi(er(t.parent)),i,void 0)}return a;function o(n){switch(n.kind){case 192:var r=o(n.operand);if("number"==typeof r)switch(n.operator){case 37:return r;case 38:return-r;case 52:return~r}break;case 194:var i=o(n.left),a=o(n.right);if("number"==typeof i&&"number"==typeof a)switch(n.operatorToken.kind){case 49:return i|a;case 48:return i&a;case 46:return i>>a;case 47:return i>>>a;case 45:return i<<a;case 50:return i^a;case 39:return i*a;case 41:return i/a;case 37:return i+a;case 38:return i-a;case 42:return i%a}break;case 9:return n.text;case 8:return Am(n),+n.text;case 185:return o(n.expression);case 71:return e.nodeIsMissing(n)?0:s(n,er(t.parent),n.escapedText);case 180:case 179:var c=n;if(Xp(c)){var u=Td(c.expression);if(u.symbol&&384&u.symbol.flags){var _=void 0;if(179===c.kind)_=c.name.escapedText;else{var l=c.argumentExpression;e.Debug.assert(e.isLiteralExpression(l)),_=e.escapeLeadingUnderscores(l.text)}return s(n,u.symbol,_)}}}}function s(n,r,i){var a=r.exports.get(i);if(a){var o=a.valueDeclaration;if(o!==t)return xn(o,t)?yn(o).enumMemberValue:(cn(n,e.Diagnostics.A_member_initializer_in_a_enum_declaration_cannot_reference_members_declared_after_it_including_members_defined_in_other_enums),0)}}}(t):!e.isInAmbientContext(t.parent)||e.isConst(t.parent)?void 0!==n?n:void cn(t.name,e.Diagnostics.Enum_member_must_have_initializer):void 0}function Xp(e){return 71===e.kind||179===e.kind&&Xp(e.expression)||180===e.kind&&Xp(e.expression)&&9===e.argumentExpression.kind}function Yp(t){if(r){var n=e.isGlobalScopeAugmentation(t),i=e.isInAmbientContext(t);n&&!i&&cn(t.name,e.Diagnostics.Augmentations_for_the_global_scope_should_have_declare_modifier_unless_they_appear_in_already_ambient_context);var a=e.isAmbientModule(t);if(rf(t,a?e.Diagnostics.An_ambient_module_declaration_is_only_allowed_at_the_top_level_in_a_file:e.Diagnostics.A_namespace_declaration_is_only_allowed_in_a_namespace_or_module))return;tm(t)||nm(t)||i||9!==t.name.kind||Tm(t.name,e.Diagnostics.Only_ambient_modules_can_use_quoted_names),e.isIdentifier(t.name)&&(fp(t,t.name),vp(t,t.name),bp(t,t.name)),qd(t);var o=er(t);if(512&o.flags&&o.declarations.length>1&&!i&&c(t,S.preserveConstEnums||S.isolatedModules)){var s=function(t){for(var n=0,r=t.declarations;n<r.length;n++){var i=r[n];if((229===i.kind||228===i.kind&&e.nodeIsPresent(i.body))&&!e.isInAmbientContext(i))return i}}(o);s&&(e.getSourceFileOfNode(t)!==e.getSourceFileOfNode(s)?cn(t.name,e.Diagnostics.A_namespace_declaration_cannot_be_in_a_different_file_from_a_class_or_function_with_which_it_is_merged):t.pos<s.pos&&cn(t.name,e.Diagnostics.A_namespace_declaration_cannot_be_located_prior_to_a_class_or_function_with_which_it_is_merged));var u=e.getDeclarationOfKind(o,229);u&&(d=t,p=u,f=e.getEnclosingBlockScopeContainer(d),m=e.getEnclosingBlockScopeContainer(p),vn(f)?vn(m):!vn(m)&&f===m)&&(yn(t).flags|=32768)}if(a)if(e.isExternalModuleAugmentation(t)){if((n||33554432&er(t).flags)&&t.body)for(var _=0,l=t.body.statements;_<l.length;_++){Zp(l[_],n)}}else vn(t.parent)?n?cn(t.name,e.Diagnostics.Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_declarations):e.isExternalModuleNameRelative(e.getTextOfIdentifierOrLiteral(t.name))&&cn(t.name,e.Diagnostics.Ambient_module_declaration_cannot_specify_relative_module_name):cn(t.name,n?e.Diagnostics.Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_declarations:e.Diagnostics.Ambient_modules_cannot_be_nested_in_other_modules_or_namespaces)}var d,p,f,m;t.body&&(cf(t.body),e.isGlobalScopeAugmentation(t)||ap(t))}function Zp(t,n){switch(t.kind){case 208:for(var r=0,i=t.declarationList.declarations;r<i.length;r++){Zp(i[r],n)}break;case 243:case 244:Dm(t,e.Diagnostics.Exports_and_export_assignments_are_not_permitted_in_module_augmentations);break;case 237:case 238:Dm(t,e.Diagnostics.Imports_are_not_permitted_in_module_augmentations_Consider_moving_them_to_the_enclosing_external_module);break;case 176:case 226:var a=t.name;if(e.isBindingPattern(a)){for(var o=0,s=a.elements;o<s.length;o++){Zp(s[o],n)}break}case 229:case 232:case 228:case 230:case 233:case 231:if(n)return;var c=er(t);if(c){var u=!(33554432&c.flags);u||(u=e.isExternalModuleAugmentation(c.parent.declarations[0]))}}}function $p(e){switch(e.kind){case 71:return e;case 143:do{e=e.left}while(71!==e.kind);return e;case 179:do{e=e.expression}while(71!==e.kind);return e}}function ef(t){var n=e.getExternalModuleName(t);if(!e.nodeIsMissing(n)&&9!==n.kind)return cn(n,e.Diagnostics.String_literal_expected),!1;var r=234===t.parent.kind&&e.isAmbientModule(t.parent.parent);return 265===t.parent.kind||r?!(r&&e.isExternalModuleNameRelative(e.getTextOfIdentifierOrLiteral(n))&&!Pr(t))||(cn(t,e.Diagnostics.Import_or_export_declaration_in_an_ambient_module_declaration_cannot_reference_module_through_relative_module_name),!1):(cn(n,244===t.kind?e.Diagnostics.Export_declarations_are_not_permitted_in_a_namespace:e.Diagnostics.Import_declarations_in_a_namespace_cannot_reference_a_module),!1)}function tf(t){var n=er(t),r=Ln(n);if(r!==q){var i=(1156031&n.flags?107455:0)|(793064&n.flags?793064:0)|(1920&n.flags?1920:0);if(r.flags&i)cn(t,246===t.kind?e.Diagnostics.Export_declaration_conflicts_with_exported_declaration_of_0:e.Diagnostics.Import_declaration_conflicts_with_local_declaration_of_0,Dr(n));!S.isolatedModules||246!==t.kind||107455&r.flags||e.isInAmbientContext(t)||cn(t,e.Diagnostics.Cannot_re_export_a_type_when_the_isolatedModules_flag_is_provided)}}function nf(e){fp(e,e.name),vp(e,e.name),bp(e,e.name),tf(e)}function rf(e,t){var n=265===e.parent.kind||234===e.parent.kind||233===e.parent.kind;return n||Dm(e,t),!n}function af(t){if(tf(t),!t.parent.parent.moduleSpecifier){var n=t.propertyName||t.name,r=kn(n,n.escapedText,2998271,void 0,void 0,!0);r&&(r===I||vn(jr(r.declarations[0])))?cn(n,e.Diagnostics.Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module,e.idText(n)):Mn(t)}}function of(t){var n=er(t),r=gn(n);if(!r.exportsChecked){var i=n.exports.get("export=");if(i&&function(t){return e.forEachEntry(t.exports,(function(e,t){return"export="!==t}))}(n)){var a=wn(i)||i.valueDeclaration;Pr(a)||cn(a,e.Diagnostics.An_export_assignment_cannot_be_used_in_a_module_with_other_exported_elements)}var o=Yn(n);o&&o.forEach((function(t,n){var r=t.declarations,i=t.flags;if("__export"!==n&&!(1984&i)){var a=e.countWhere(r,on);if(!(524288&i&&a<=2)&&a>1)for(var o=0,s=r;o<s.length;o++){var c=s[o];sf(c)&&At.add(e.createDiagnosticForNode(c,e.Diagnostics.Cannot_redeclare_exported_variable_0,e.unescapeLeadingUnderscores(n)))}}})),r.exportsChecked=!0}}function sf(e){return 228!==e.kind&&151!==e.kind||!!e.body}function cf(t){if(t){if(e.isInJavaScriptFile(t)&&t.jsDoc)for(var n=0,i=t.jsDoc;n<i.length;n++){var a=i[n].tags;e.forEach(a,cf)}var o=t.kind;if(l)switch(o){case 233:case 229:case 230:case 228:l.throwIfCancellationRequested()}switch(o){case 145:return Nd(t);case 146:return Ad(t);case 149:case 148:return Rd(t);case 160:case 161:case 155:case 156:case 157:return Fd(t);case 151:case 150:return function(t){ym(t)||lm(t.name),ip(t),e.hasModifier(t,128)&&t.body&&cn(t,e.Diagnostics.Method_0_cannot_have_an_implementation_because_it_is_marked_abstract,e.declarationNameToString(t.name))}(t);case 152:return Ld(t);case 153:case 154:return Md(t);case 159:return zd(t);case 158:return function(t){var n=function(e){switch(e.parent.kind){case 187:case 155:case 228:case 186:case 160:case 151:case 150:var t=e.parent;if(e===t.type)return t}}(t);if(n){var r=Oa(n).typePredicate;if(r){cf(t.type);var i=t.parameterName;if(e.isThisTypePredicate(r))ls(i);else if(r.parameterIndex>=0)if(n.parameters[r.parameterIndex].dotDotDotToken)cn(i,e.Diagnostics.A_type_predicate_cannot_reference_a_rest_parameter);else{var a=e.chainDiagnosticMessages(void 0,e.Diagnostics.A_type_predicate_s_type_must_be_assignable_to_its_parameter_s_type);Ls(r.type,xf(n.parameters[r.parameterIndex]),t.type,void 0,a)}else if(i){for(var o=!1,s=0,c=n.parameters;s<c.length;s++){var u=c[s].name;if(e.isBindingPattern(u)&&Pd(u,i,r.parameterName)){o=!0;break}}o||cn(t.parameterName,e.Diagnostics.Cannot_find_parameter_0,r.parameterName)}}}else cn(t,e.Diagnostics.A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods)}(t);case 162:return function(e){co(e)}(t);case 163:return function(t){e.forEach(t.members,cf),r&&(Jp(ts(t)),Id(t),Od(t))}(t);case 164:return function(e){cf(e.elementType)}(t);case 165:return function(t){im(t.elementTypes)||0!==t.elementTypes.length||Tm(t,e.Diagnostics.A_tuple_type_element_list_cannot_be_empty),e.forEach(t.elementTypes,cf)}(t);case 166:case 167:return function(t){e.forEach(t.types,cf)}(t);case 168:case 170:return cf(t.type);case 277:return function(t){var n=e.getJSDocHost(t);if(e.isClassDeclaration(n)||e.isClassExpression(n)){var r=e.getAllJSDocTagsOfKind(n,277);e.Debug.assert(r.length>0),r.length>1&&cn(r[1],e.Diagnostics.Class_declarations_cannot_have_more_than_one_augments_or_extends_tag);var i=rp(t.class.expression),a=e.getClassExtendsHeritageClauseElement(n);if(a){var o=rp(a.expression);o&&i.escapedText!==o.escapedText&&cn(i,e.Diagnostics.JSDoc_0_1_does_not_match_the_extends_2_clause,e.idText(t.tagName),e.idText(i),e.idText(o))}}else cn(n,e.Diagnostics.JSDoc_0_is_not_attached_to_a_class,e.idText(t.tagName))}(t);case 283:return function(t){t.typeExpression||cn(t.name,e.Diagnostics.JSDoc_typedef_tag_should_either_have_a_type_annotation_or_be_followed_by_property_or_member_tags)}(t);case 279:return function(t){cf(t.typeExpression),e.getParameterSymbolFromJSDoc(t)||cn(t.name,e.Diagnostics.JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name,e.idText(143===t.name.kind?t.name.right:t.name))}(t);case 273:Fd(t);case 274:case 271:case 270:case 268:case 269:return void(e.isInJavaScriptFile(t)||e.isInJSDoc(t)||Tm(t,e.Diagnostics.JSDoc_types_can_only_be_used_inside_documentation_comments));case 267:return cf(t.type);case 171:return function(e){cf(e.objectType),cf(e.indexType),jd($o(e),e)}(t);case 172:return function(e){cf(e.typeParameter),cf(e.type),Ls(ta(es(e)),ee,e.typeParameter.constraint)}(t);case 228:return function(e){r&&(ip(e),dm(e),hp(e,e.name),fp(e,e.name),mp(e,e.name),vp(e,e.name),bp(e,e.name))}(t);case 207:case 234:return dp(t);case 208:return Tp(t);case 210:return function(e){Nm(e),Ed(e.expression)}(t);case 211:return function(t){Nm(t),Ed(t.expression),cf(t.thenStatement),209===t.thenStatement.kind&&cn(t.thenStatement,e.Diagnostics.The_body_of_an_if_statement_cannot_be_the_empty_statement),cf(t.elseStatement)}(t);case 212:return function(e){Nm(e),cf(e.statement),Ed(e.expression)}(t);case 213:return function(e){Nm(e),Ed(e.expression),cf(e.statement)}(t);case 214:return function(t){Nm(t)||t.initializer&&227===t.initializer.kind&&xm(t.initializer),t.initializer&&(227===t.initializer.kind?e.forEach(t.initializer.declarations,Dp):Ed(t.initializer)),t.condition&&Ed(t.condition),t.incrementor&&Ed(t.incrementor),cf(t.statement),t.locals&&ap(t)}(t);case 215:return Ep(t);case 216:return function(t){if(fm(t),216===t.kind&&(t.awaitModifier?2==(6&e.getFunctionFlags(e.getContainingFunction(t)))&&D<5&&$f(t,16384):S.downlevelIteration&&D<2&&$f(t,256)),227===t.initializer.kind)Np(t);else{var n=t.initializer,r=Ap(t.expression,t.awaitModifier);if(177===n.kind||178===n.kind)_d(n,r||Q);else{var i=Ed(n);rd(n,e.Diagnostics.The_left_hand_side_of_a_for_of_statement_must_be_a_variable_or_a_property_access),r&&Ls(r,i,n,void 0)}}cf(t.statement),t.locals&&ap(t)}(t);case 217:case 218:return Rp(t);case 219:return function(t){Nm(t)||e.getContainingFunction(t)||Dm(t,e.Diagnostics.A_return_statement_can_only_be_used_within_a_function_body);var n=e.getContainingFunction(t);if(n){var r=La(Oa(n));if(N||t.expression||8192&r.flags){var i=t.expression?hd(t.expression):X,a=e.getFunctionFlags(n);if(1&a)return;if(154===n.kind)t.expression&&cn(t,e.Diagnostics.Setters_cannot_return_a_value);else if(152===n.kind)t.expression&&!Ls(i,r,t)&&cn(t,e.Diagnostics.Return_type_of_constructor_signature_must_be_assignable_to_the_instance_type_of_the_class);else if(e.getEffectiveReturnTypeNode(n)||Lp(n))if(2&a){var o=Hd(r),s=Gd(i,t,e.Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member);o&&Ls(s,o,t)}else Ls(i,r,t)}else 152!==n.kind&&S.noImplicitReturns&&!Mp(n,r)&&cn(t,e.Diagnostics.Not_all_code_paths_return_a_value)}}(t);case 220:return function(t){Nm(t)||16384&t.flags&&Dm(t,e.Diagnostics.with_statements_are_not_allowed_in_an_async_function_block),Ed(t.expression);var n=e.getSourceFileOfNode(t);if(!Sm(n)){var r=e.getSpanOfTokenAtPosition(n,t.pos).start;Cm(n,r,t.statement.pos-r,e.Diagnostics.The_with_statement_is_not_supported_All_symbols_in_a_with_block_will_have_type_any)}}(t);case 221:return function(t){var n;Nm(t);var i=!1,a=Ed(t.expression),o=lc(a);e.forEach(t.caseBlock.clauses,(function(s){if(258===s.kind&&!i)if(void 0===n)n=s;else{var c=e.getSourceFileOfNode(t),u=e.skipTrivia(c.text,s.pos);Cm(c,u,(s.statements.length>0?s.statements[0].pos:s.end)-u,e.Diagnostics.A_default_clause_cannot_appear_more_than_once_in_a_switch_statement),i=!0}if(r&&257===s.kind){var _=s,l=Ed(_.expression),d=lc(l),p=a;d&&o||(l=d?dc(l):l,p=dc(a)),dd(p,l)||Ms(l,p,_.expression,void 0)}e.forEach(s.statements,cf)})),t.caseBlock.locals&&ap(t.caseBlock)}(t);case 222:return function(t){Nm(t)||e.findAncestor(t.parent,(function(n){if(e.isFunctionLike(n))return"quit";if(222===n.kind&&n.label.escapedText===t.label.escapedText){var r=e.getSourceFileOfNode(t);return Tm(t.label,e.Diagnostics.Duplicate_label_0,e.getTextOfNodeFromSourceText(r.text,t.label)),!0}})),cf(t.statement)}(t);case 223:return Bp(t);case 224:return function(t){Nm(t),dp(t.tryBlock);var n=t.catchClause;if(n){if(n.variableDeclaration)if(n.variableDeclaration.type)Dm(n.variableDeclaration.type,e.Diagnostics.Catch_clause_variable_cannot_have_a_type_annotation);else if(n.variableDeclaration.initializer)Dm(n.variableDeclaration.initializer,e.Diagnostics.Catch_clause_variable_cannot_have_an_initializer);else{var r=n.block.locals;r&&e.forEachKey(n.locals,(function(t){var n=r.get(t);n&&0!=(2&n.flags)&&Tm(n.valueDeclaration,e.Diagnostics.Cannot_redeclare_identifier_0_in_catch_clause,t)}))}dp(n.block)}t.finallyBlock&&dp(t.finallyBlock)}(t);case 226:return Dp(t);case 176:return Cp(t);case 229:return function(t){t.name||e.hasModifier(t,512)||Dm(t,e.Diagnostics.A_class_declaration_without_the_default_modifier_must_have_a_name),Vp(t),e.forEach(t.members,cf),ap(t)}(t);case 230:return Hp(t);case 231:return function(t){tm(t)||nm(t),zp(t.name,e.Diagnostics.Type_alias_name_cannot_be_0),jp(t.typeParameters),cf(t.type),ap(t)}(t);case 232:return function(t){if(r){tm(t)||nm(t),zp(t.name,e.Diagnostics.Enum_name_cannot_be_0),fp(t,t.name),mp(t,t.name),vp(t,t.name),bp(t,t.name),qd(t),Gp(t);var n=e.isConst(t);S.isolatedModules&&n&&e.isInAmbientContext(t)&&cn(t.name,e.Diagnostics.Ambient_const_enums_are_not_allowed_when_the_isolatedModules_flag_is_provided);var i=er(t);if(t===e.getDeclarationOfKind(i,t.kind)){i.declarations.length>1&&e.forEach(i.declarations,(function(t){e.isConstEnumDeclaration(t)!==n&&cn(e.getNameOfDeclaration(t),e.Diagnostics.Enum_declarations_must_all_be_const_or_non_const)}));var a=!1;e.forEach(i.declarations,(function(t){if(232!==t.kind)return!1;var n=t;if(!n.members.length)return!1;var r=n.members[0];r.initializer||(a?cn(r.name,e.Diagnostics.In_an_enum_with_multiple_declarations_only_one_declaration_can_omit_an_initializer_for_its_first_enum_element):a=!0)}))}}}(t);case 233:return Yp(t);case 238:return function(t){if(!rf(t,e.Diagnostics.An_import_declaration_can_only_be_used_in_a_namespace_or_module)&&(tm(t)||nm(t)||!e.hasModifiers(t)||Dm(t,e.Diagnostics.An_import_declaration_cannot_have_modifiers),ef(t))){var n=t.importClause;n&&(n.name&&nf(n),n.namedBindings&&(240===n.namedBindings.kind?nf(n.namedBindings):e.forEach(n.namedBindings.elements,nf)))}}(t);case 237:return function(t){if(!rf(t,e.Diagnostics.An_import_declaration_can_only_be_used_in_a_namespace_or_module)&&(tm(t)||nm(t),e.isInternalModuleImportEqualsDeclaration(t)||ef(t)))if(nf(t),e.hasModifier(t,1)&&Mn(t),e.isInternalModuleImportEqualsDeclaration(t)){var n=Ln(er(t));if(n!==q){if(107455&n.flags){var r=$p(t.moduleReference);1920&jn(r,108479).flags||cn(r,e.Diagnostics.Module_0_is_hidden_by_a_local_declaration_with_the_same_name,e.declarationNameToString(r))}793064&n.flags&&zp(t.name,e.Diagnostics.Import_name_cannot_be_0)}}else C>=e.ModuleKind.ES2015&&!e.isInAmbientContext(t)&&Tm(t,e.Diagnostics.Import_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_import_Asterisk_as_ns_from_mod_import_a_from_mod_import_d_from_mod_or_another_module_format_instead)}(t);case 244:return function(t){if(!rf(t,e.Diagnostics.An_export_declaration_can_only_be_used_in_a_module)&&(tm(t)||nm(t)||!e.hasModifiers(t)||Dm(t,e.Diagnostics.An_export_declaration_cannot_have_modifiers),!t.moduleSpecifier||ef(t)))if(t.exportClause){e.forEach(t.exportClause.elements,af);var n=234===t.parent.kind&&e.isAmbientModule(t.parent.parent),r=!n&&234===t.parent.kind&&!t.moduleSpecifier&&e.isInAmbientContext(t);265===t.parent.kind||n||r||cn(t,e.Diagnostics.Export_declarations_are_not_permitted_in_a_namespace)}else{var i=Kn(t,t.moduleSpecifier);i&&Hn(i)&&cn(t.moduleSpecifier,e.Diagnostics.Module_0_uses_export_and_cannot_be_used_with_export_Asterisk,Dr(i)),C!==e.ModuleKind.System&&C!==e.ModuleKind.ES2015&&C!==e.ModuleKind.ESNext&&$f(t,32768)}}(t);case 243:return function(t){if(!rf(t,e.Diagnostics.An_export_assignment_can_only_be_used_in_a_module)){var n=265===t.parent.kind?t.parent:t.parent.parent;233!==n.kind||e.isAmbientModule(n)?(tm(t)||nm(t)||!e.hasModifiers(t)||Dm(t,e.Diagnostics.An_export_assignment_cannot_have_modifiers),71===t.expression.kind?Mn(t):hd(t.expression),of(n),e.isInAmbientContext(t)&&!e.isEntityNameExpression(t.expression)&&Tm(t.expression,e.Diagnostics.The_expression_of_an_export_assignment_must_be_an_identifier_or_qualified_name_in_an_ambient_context),t.isExportEquals&&!e.isInAmbientContext(t)&&(C>=e.ModuleKind.ES2015?Tm(t,e.Diagnostics.Export_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_export_default_or_another_module_format_instead):C===e.ModuleKind.System&&Tm(t,e.Diagnostics.Export_assignment_is_not_supported_when_module_flag_is_system))):t.isExportEquals?cn(t,e.Diagnostics.An_export_assignment_cannot_be_used_in_a_namespace):cn(t,e.Diagnostics.A_default_export_can_only_be_used_in_an_ECMAScript_style_module)}}(t);case 209:case 225:return void Nm(t);case 247:return function(e){np(e)}(t)}}}function uf(e){Xe&&Xe.push(e)}function _f(t){e.performance.mark("beforeCheck"),function(t){var n=yn(t);if(!(1&n.flags)){if(S.skipLibCheck&&t.isDeclarationFile||S.skipDefaultLibCheck&&t.hasNoDefaultLib)return;!function(t){e.isInAmbientContext(t)&&function(t){for(var n=0,r=t.statements;n<r.length;n++){var i=r[n];if((e.isDeclaration(i)||208===i.kind)&&Em(i))return!0}}(t)}(t),e.clear(Tt),e.clear(Et),Xe=[],Ye=r&&T?[]:void 0,_t=!1,e.forEach(t.statements,cf),function(){for(var e=0,t=Xe;e<t.length;e++){var n=t[e];switch(n.kind){case 186:case 187:case 151:case 150:Zl(n);break;case 153:case 154:Md(n);break;case 199:Up(n)}}}(),e.isExternalModule(t)&&ap(t),t.isDeclarationFile||function(){if(Ye)for(var e=0,t=Ye;e<t.length;e++){var n=t[e];switch(n.kind){case 265:case 233:lp(n);break;case 229:case 199:up(n),_p(n);break;case 230:_p(n);break;case 207:case 235:case 214:case 215:case 216:op(n);break;case 152:case 186:case 228:case 187:case 151:case 153:case 154:n.body&&op(n),_p(n);break;case 150:case 155:case 156:case 157:case 160:case 161:case 231:_p(n)}}}(),Xe=void 0,Ye=void 0,e.isExternalOrCommonJsModule(t)&&of(t),Tt.length&&(e.forEach(Tt,gp),e.clear(Tt)),Et.length&&(e.forEach(Et,yp),e.clear(Et)),n.flags|=1}}(t),e.performance.mark("afterCheck"),e.performance.measure("Check","beforeCheck","afterCheck")}function lf(t,r){try{return l=r,function(t){if(df(),t){var r=At.getGlobalDiagnostics(),i=r.length;_f(t);var a=At.getDiagnostics(t.fileName),o=At.getGlobalDiagnostics();if(o!==r){var s=e.relativeComplement(r,o,e.compareDiagnostics);return e.concatenate(s,a)}return 0===i&&o.length>0?e.concatenate(o,a):a}return e.forEach(n.getSourceFiles(),_f),At.getDiagnostics()}(t)}finally{l=void 0}}function df(){if(!r)throw new Error("Trying to get diagnostics from a type checker that does not produce them.")}function pf(e){if(e)for(;e.parent;){if(220===e.parent.kind&&e.parent.statement===e)return!0;e=e.parent}return!1}function ff(e){switch(e.kind){case 145:case 229:case 230:case 231:case 232:return!0}}function mf(e){for(var t=e;t.parent&&143===t.parent.kind;)t=t.parent;return t.parent&&159===t.parent.kind}function gf(t,n){for(var r;(t=e.getContainingClass(t))&&!(r=n(t)););return r}function yf(e,t){return!!gf(e,(function(e){return e===t}))}function hf(e){return void 0!==function(e){for(;143===e.parent.kind;)e=e.parent;return 237===e.parent.kind?e.parent.moduleReference===e&&e.parent:243===e.parent.kind?e.parent.expression===e&&e.parent:void 0}(e)}function vf(t){if(e.isDeclarationName(t))return er(t.parent);if(e.isInJavaScriptFile(t)&&179===t.parent.kind&&t.parent===t.parent.parent.left){var n=function(t){switch(e.getSpecialPropertyAssignmentKind(t.parent.parent)){case 1:case 3:return er(t.parent);case 4:case 2:case 5:return er(t.parent.parent)}}(t);if(n)return n}if(243===t.parent.kind&&e.isEntityNameExpression(t))return jn(t,2998271);if(179!==t.kind&&hf(t)){var r=e.getAncestor(t,237);return e.Debug.assert(void 0!==r),Jn(t,!0)}if(e.isRightSideOfQualifiedNameOrPropertyAccess(t)&&(t=t.parent),function(e){for(var t=e;t.parent&&179===t.parent.kind;)t=t.parent;return t.parent&&201===t.parent.kind}(t)){var i=0;201===t.parent.kind?(i=793064,e.isExpressionWithTypeArgumentsInClassExtendsClause(t.parent)&&(i|=107455)):i=1920;var a=jn(t,i|=2097152);if(a)return a}if(279===t.parent.kind)return e.getParameterSymbolFromJSDoc(t.parent);if(145===t.parent.kind&&282===t.parent.parent.kind){e.Debug.assert(!e.isInJavaScriptFile(t));var o=e.getTypeParameterFromJsDoc(t.parent);return o&&o.symbol}if(e.isPartOfExpression(t)){if(e.nodeIsMissing(t))return;if(71===t.kind)return e.isJSXTagName(t)&&C_(t)?N_(t.parent):jn(t,107455,!1,!0);if(179===t.kind||143===t.kind){var s=yn(t);return s.resolvedSymbol||(179===t.kind?W_(t):H_(t)),s.resolvedSymbol}}else{if(mf(t))return jn(t,i=159===t.parent.kind?793064:1920,!1,!0);if(253===t.parent.kind)return va(L_((c=t.parent).parent.parent),c.name.escapedText)||q}var c;return 158===t.parent.kind?jn(t,1):void 0}function bf(t){if(265===t.kind)return e.isExternalModule(t)?$n(t.symbol):void 0;if(!pf(t)){if(u(t))return er(t.parent);if(e.isLiteralComputedPropertyDeclarationName(t))return er(t.parent.parent);if(71===t.kind){if(hf(t))return vf(t);if(176===t.parent.kind&&174===t.parent.parent.kind&&t===t.parent.propertyName){var n=xf(t.parent.parent),r=n&&va(n,t.escapedText);if(r)return r}}switch(t.kind){case 71:case 179:case 143:return vf(t);case 99:var i=e.getThisContainer(t,!1);if(e.isFunctionLike(i)){var a=Oa(i);if(a.thisParameter)return a.thisParameter}if(e.isInExpressionContext(t))return Ed(t).symbol;case 169:return ls(t).symbol;case 97:return Ed(t).symbol;case 123:var o=t.parent;return o&&152===o.kind?o.parent.symbol:void 0;case 9:if(e.isExternalModuleImportEqualsDeclaration(t.parent.parent)&&e.getExternalModuleImportEqualsDeclarationExpression(t.parent.parent)===t||(238===t.parent.kind||244===t.parent.kind)&&t.parent.moduleSpecifier===t||e.isInJavaScriptFile(t)&&e.isRequireCall(t.parent,!1)||e.isImportCall(t.parent))return Kn(t,t);case 8:var s=e.isElementAccessExpression(t.parent)?t.parent.argumentExpression===t?Td(t.parent.expression):void 0:e.isLiteralTypeNode(t.parent)&&e.isIndexedAccessTypeNode(t.parent.parent)?ds(t.parent.parent.objectType):void 0;return s&&va(s,e.escapeLeadingUnderscores(t.text));case 79:return er(t.parent);default:return}}}function xf(t){if(pf(t))return Q;if(e.isPartOfTypeNode(t)){var n=ds(t);if(n&&e.isExpressionWithTypeArgumentsInClassImplementsClause(t))n=zi(n,(r=xf(e.getContainingClass(t))).thisType);return n}if(e.isPartOfExpression(t))return Sf(t);if(e.isExpressionWithTypeArgumentsInClassExtendsClause(t)){var r,i=Si(r=Fi(er(e.getContainingClass(t))))[0];return i&&zi(i,r.thisType)}var a;if(ff(t))return Fi(o=er(t));if(71===(a=t).kind&&ff(a.parent)&&a.parent.name===a)return(o=bf(t))&&Fi(o);if(e.isDeclaration(t))return ci(o=er(t));if(u(t))return(o=bf(t))&&ci(o);if(e.isBindingPattern(t))return Yr(t.parent,!0);if(hf(t)){var o,s=(o=bf(t))&&Fi(o);return s!==Q?s:ci(o)}return Q}function kf(t){if(e.Debug.assert(178===t.kind||177===t.kind),216===t.parent.kind)return _d(t,Ap(t.parent.expression,t.parent.awaitModifier)||Q);if(194===t.parent.kind)return _d(t,Td(t.parent.right)||Q);if(261===t.parent.kind)return cd(kf(t.parent.parent)||Q,t.parent);e.Debug.assert(177===t.parent.kind);var n=kf(t.parent),r=wp(n||Q,t.parent,!1,!1)||Q;return ud(t.parent,n,e.indexOf(t.parent.elements,t),r||Q)}function Sf(t){return e.isRightSideOfQualifiedNameOrPropertyAccess(t)&&(t=t.parent),us(Td(t))}function Df(t){if(!e.isGeneratedIdentifier(t)&&(t=e.getParseTreeNode(t,e.isIdentifier)))return!(179===t.parent.kind&&t.parent.name===t)&&Gf(t)===M;return!1}function Cf(t){var n=Kn(t.parent,t);if(!n||e.isShorthandAmbientModuleSymbol(n))return!0;var r=Hn(n),i=gn(n=qn(n));return void 0===i.exportsSomeValue&&(i.exportsSomeValue=r?!!(107455&n.flags):e.forEachEntry(Yn(n),(function(e){return(e=Rn(e))&&!!(107455&e.flags)}))),i.exportsSomeValue}function Tf(t,n){if(t=e.getParseTreeNode(t,e.isIdentifier)){var r=Gf(t,function(t){var n=t.parent;return n&&e.isModuleOrEnumDeclaration(n)&&t===n.name}(t));if(r){if(1048576&r.flags){var i=$n(r.exportSymbol);if(!n&&944&i.flags)return;r=i}var a=tr(r);if(a){if(512&a.flags&&265===a.valueDeclaration.kind){var o=a.valueDeclaration;return o!==e.getSourceFileOfNode(t)?void 0:o}return e.findAncestor(t.parent,(function(t){return e.isModuleOrEnumDeclaration(t)&&er(t)===a}))}}}}function Ef(t){if(t=e.getParseTreeNode(t,e.isIdentifier)){var n=Gf(t);if(In(n,107455))return wn(n)}}function Nf(t){if(418&t.flags){var n=gn(t);if(void 0===n.isDeclarationWithCollidingName){var r=e.getEnclosingBlockScopeContainer(t.valueDeclaration);if(e.isStatementWithLocals(r)){var i=yn(t.valueDeclaration);if(kn(r.parent,t.escapedName,107455,void 0,void 0,!1))n.isDeclarationWithCollidingName=!0;else if(131072&i.flags){var a=262144&i.flags,o=e.isIterationStatement(r,!1),s=207===r.kind&&e.isIterationStatement(r.parent,!1);n.isDeclarationWithCollidingName=!(e.isBlockScopedContainerTopLevel(r)||a&&(o||s))}else n.isDeclarationWithCollidingName=!1}}return n.isDeclarationWithCollidingName}return!1}function Af(t){if(!e.isGeneratedIdentifier(t)&&(t=e.getParseTreeNode(t,e.isIdentifier))){var n=Gf(t);if(n&&Nf(n))return n.valueDeclaration}}function wf(t){if(t=e.getParseTreeNode(t,e.isDeclaration)){var n=er(t);if(n)return Nf(n)}return!1}function Pf(t){switch(t.kind){case 237:case 239:case 240:case 242:case 246:return Of(er(t)||q);case 244:var n=t.exportClause;return n&&e.forEach(n.elements,Pf);case 243:return!t.expression||71!==t.expression.kind||Of(er(t)||q)}return!1}function Ff(t){return!(void 0===(t=e.getParseTreeNode(t,e.isImportEqualsDeclaration))||265!==t.parent.kind||!e.isInternalModuleImportEqualsDeclaration(t))&&(Of(er(t))&&t.moduleReference&&!e.nodeIsMissing(t.moduleReference))}function Of(e){var t=Ln(e);return t===q||107455&t.flags&&(S.preserveConstEnums||!If(t))}function If(e){return sd(e)||e.constEnumOnlyModule}function Rf(t,n){if(e.isAliasSymbolDeclaration(t)){var r=er(t);if(r&&gn(r).referenced)return!0}return!!n&&e.forEachChild(t,(function(e){return Rf(e,n)}))}function Lf(t){if(e.nodeIsPresent(t.body)){var n=Ia(er(t));return n.length>1||1===n.length&&n[0].declaration!==t}return!1}function Mf(t){return N&&!wa(t)&&t.initializer&&!e.hasModifier(t,92)}function Bf(t){return N&&wa(t)&&!t.initializer&&e.hasModifier(t,92)}function Jf(e){return yn(e).flags}function zf(e){return Gp(e.parent),yn(e).enumMemberValue}function jf(e){switch(e.kind){case 264:case 179:case 180:return!0}return!1}function Kf(t){if(264===t.kind)return zf(t);var n=yn(t).resolvedSymbol;return n&&8&n.flags&&e.isConstEnumDeclaration(n.valueDeclaration.parent)?zf(n.valueDeclaration):void 0}function Uf(t,n){if(!(t=e.getParseTreeNode(t,e.isEntityName)))return e.TypeReferenceSerializationKind.Unknown;if(n&&!(n=e.getParseTreeNode(n)))return e.TypeReferenceSerializationKind.Unknown;var r=jn(t,107455,!0,!1,n),i=jn(t,793064,!0,!1,n);if(r&&r===i){var a=go(!1);if(a&&r===a)return e.TypeReferenceSerializationKind.Promise;var o=ci(r);if(o&&hi(o))return e.TypeReferenceSerializationKind.TypeWithConstructSignatureAndValue}if(!i)return e.TypeReferenceSerializationKind.ObjectType;var s=Fi(i);return s===Q?e.TypeReferenceSerializationKind.Unknown:1&s.flags?e.TypeReferenceSerializationKind.ObjectType:ad(s,15360)?e.TypeReferenceSerializationKind.VoidNullableOrNeverType:ad(s,136)?e.TypeReferenceSerializationKind.BooleanType:ad(s,84)?e.TypeReferenceSerializationKind.NumberLikeType:ad(s,262178)?e.TypeReferenceSerializationKind.StringLikeType:fc(s)?e.TypeReferenceSerializationKind.ArrayLikeType:ad(s,512)?e.TypeReferenceSerializationKind.ESSymbolType:function(e){return 32768&e.flags&&xa(e,0).length>0}(s)?e.TypeReferenceSerializationKind.TypeWithCallSignature:sc(s)?e.TypeReferenceSerializationKind.ArrayLikeType:e.TypeReferenceSerializationKind.ObjectType}function Vf(e,t,n,r){var i=er(e),a=!i||133120&i.flags?Q:pc(ci(i));8192&n&&(a=bc(a,2048)),Ir().buildTypeDisplay(a,r,t,n)}function qf(e,t,n,r){var i=Oa(e);Ir().buildTypeDisplay(La(i),r,t,n)}function Wf(e,t,n,r){var i=Ec(Sf(e));Ir().buildTypeDisplay(i,r,t,n)}function Hf(t){return ot.has(e.escapeLeadingUnderscores(t))}function Gf(t,n){var r=yn(t).resolvedSymbol;if(r)return r;var i=t;if(n){var a=t.parent;e.isDeclaration(a)&&t===a.name&&(i=jr(a))}return kn(i,t.escapedText,3253183,void 0,void 0,!0)}function Qf(t){if(!e.isGeneratedIdentifier(t)&&(t=e.getParseTreeNode(t,e.isIdentifier))){var n=Gf(t);if(n)return nr(n).valueDeclaration}}function Xf(t){if(e.isConst(t)){var n=ci(er(t));return!!(96&n.flags&&1048576&n.flags)}return!1}function Yf(e,t){var n=ci(er(e));t.writeStringLiteral(Fr(n))}function Zf(t){var n=e.getExternalModuleName(t),r=Un(n,n,void 0);if(r)return e.getDeclarationOfKind(r,265)}function $f(t,n){if((d&n)!==n&&S.importHelpers){var r=e.getSourceFileOfNode(t);if(e.isEffectiveExternalModule(r,S)&&!e.isInAmbientContext(t)){var i=function(t,n){p||(p=Vn(t,e.externalHelpersModuleNameText,e.Diagnostics.This_syntax_requires_an_imported_helper_but_module_0_cannot_be_found,n)||q);return p}(r,t);if(i!==q)for(var a=n&~d,o=1;o<=65536;o<<=1)if(a&o){var s=em(o);bn(i.exports,e.escapeLeadingUnderscores(s),107455)||cn(t,e.Diagnostics.This_syntax_requires_an_imported_helper_named_1_but_module_0_has_no_exported_member_1,e.externalHelpersModuleNameText,s)}d|=n}}}function em(t){switch(t){case 1:return"__extends";case 2:return"__assign";case 4:return"__rest";case 8:return"__decorate";case 16:return"__metadata";case 32:return"__param";case 64:return"__awaiter";case 128:return"__generator";case 256:return"__values";case 512:return"__read";case 1024:return"__spread";case 2048:return"__await";case 4096:return"__asyncGenerator";case 8192:return"__asyncDelegator";case 16384:return"__asyncValues";case 32768:return"__exportStar";case 65536:return"__makeTemplateObject";default:e.Debug.fail("Unrecognized helper")}}function tm(t){if(!t.decorators)return!1;if(!e.nodeCanBeDecorated(t))return 151!==t.kind||e.nodeIsPresent(t.body)?Dm(t,e.Diagnostics.Decorators_are_not_valid_here):Dm(t,e.Diagnostics.A_decorator_can_only_decorate_a_method_implementation_not_an_overload);if(153===t.kind||154===t.kind){var n=e.getAllAccessorDeclarations(t.parent.members,t);if(n.firstAccessor.decorators&&t===n.secondAccessor)return Dm(t,e.Diagnostics.Decorators_cannot_be_applied_to_multiple_get_Slashset_accessors_of_the_same_name)}return!1}function nm(t){var n,r,i,a,o=function(t){return!!t.modifiers&&(function(t){switch(t.kind){case 153:case 154:case 152:case 149:case 148:case 151:case 150:case 157:case 233:case 238:case 237:case 244:case 243:case 186:case 187:case 146:return!1;default:if(234===t.parent.kind||265===t.parent.kind)return!1;switch(t.kind){case 228:return rm(t,120);case 229:return rm(t,117);case 230:case 208:case 231:return!0;case 232:return rm(t,76);default:return e.Debug.fail(),!1}}}(t)?Dm(t,e.Diagnostics.Modifiers_cannot_appear_here):void 0)}(t);if(void 0!==o)return o;for(var s=0,c=0,u=t.modifiers;c<u.length;c++){var _=u[c];if(131!==_.kind){if(148===t.kind||150===t.kind)return Tm(_,e.Diagnostics._0_modifier_cannot_appear_on_a_type_member,e.tokenToString(_.kind));if(157===t.kind)return Tm(_,e.Diagnostics._0_modifier_cannot_appear_on_an_index_signature,e.tokenToString(_.kind))}switch(_.kind){case 76:if(232!==t.kind&&229===t.parent.kind)return Tm(t,e.Diagnostics.A_class_member_cannot_have_the_0_keyword,e.tokenToString(76));break;case 114:case 113:case 112:var l=Ar(e.modifierToFlag(_.kind));if(28&s)return Tm(_,e.Diagnostics.Accessibility_modifier_already_seen);if(32&s)return Tm(_,e.Diagnostics._0_modifier_must_precede_1_modifier,l,"static");if(64&s)return Tm(_,e.Diagnostics._0_modifier_must_precede_1_modifier,l,"readonly");if(256&s)return Tm(_,e.Diagnostics._0_modifier_must_precede_1_modifier,l,"async");if(234===t.parent.kind||265===t.parent.kind)return Tm(_,e.Diagnostics._0_modifier_cannot_appear_on_a_module_or_namespace_element,l);if(128&s)return 112===_.kind?Tm(_,e.Diagnostics._0_modifier_cannot_be_used_with_1_modifier,l,"abstract"):Tm(_,e.Diagnostics._0_modifier_must_precede_1_modifier,l,"abstract");s|=e.modifierToFlag(_.kind);break;case 115:if(32&s)return Tm(_,e.Diagnostics._0_modifier_already_seen,"static");if(64&s)return Tm(_,e.Diagnostics._0_modifier_must_precede_1_modifier,"static","readonly");if(256&s)return Tm(_,e.Diagnostics._0_modifier_must_precede_1_modifier,"static","async");if(234===t.parent.kind||265===t.parent.kind)return Tm(_,e.Diagnostics._0_modifier_cannot_appear_on_a_module_or_namespace_element,"static");if(146===t.kind)return Tm(_,e.Diagnostics._0_modifier_cannot_appear_on_a_parameter,"static");if(128&s)return Tm(_,e.Diagnostics._0_modifier_cannot_be_used_with_1_modifier,"static","abstract");s|=32,n=_;break;case 131:if(64&s)return Tm(_,e.Diagnostics._0_modifier_already_seen,"readonly");if(149!==t.kind&&148!==t.kind&&157!==t.kind&&146!==t.kind)return Tm(_,e.Diagnostics.readonly_modifier_can_only_appear_on_a_property_declaration_or_index_signature);s|=64,a=_;break;case 84:if(1&s)return Tm(_,e.Diagnostics._0_modifier_already_seen,"export");if(2&s)return Tm(_,e.Diagnostics._0_modifier_must_precede_1_modifier,"export","declare");if(128&s)return Tm(_,e.Diagnostics._0_modifier_must_precede_1_modifier,"export","abstract");if(256&s)return Tm(_,e.Diagnostics._0_modifier_must_precede_1_modifier,"export","async");if(229===t.parent.kind)return Tm(_,e.Diagnostics._0_modifier_cannot_appear_on_a_class_element,"export");if(146===t.kind)return Tm(_,e.Diagnostics._0_modifier_cannot_appear_on_a_parameter,"export");s|=1;break;case 79:var d=265===t.parent.kind?t.parent:t.parent.parent;if(233===d.kind&&!e.isAmbientModule(d))return Tm(_,e.Diagnostics.A_default_export_can_only_be_used_in_an_ECMAScript_style_module);s|=512;break;case 124:if(2&s)return Tm(_,e.Diagnostics._0_modifier_already_seen,"declare");if(256&s)return Tm(_,e.Diagnostics._0_modifier_cannot_be_used_in_an_ambient_context,"async");if(229===t.parent.kind)return Tm(_,e.Diagnostics._0_modifier_cannot_appear_on_a_class_element,"declare");if(146===t.kind)return Tm(_,e.Diagnostics._0_modifier_cannot_appear_on_a_parameter,"declare");if(e.isInAmbientContext(t.parent)&&234===t.parent.kind)return Tm(_,e.Diagnostics.A_declare_modifier_cannot_be_used_in_an_already_ambient_context);s|=2,r=_;break;case 117:if(128&s)return Tm(_,e.Diagnostics._0_modifier_already_seen,"abstract");if(229!==t.kind){if(151!==t.kind&&149!==t.kind&&153!==t.kind&&154!==t.kind)return Tm(_,e.Diagnostics.abstract_modifier_can_only_appear_on_a_class_method_or_property_declaration);if(229!==t.parent.kind||!e.hasModifier(t.parent,128))return Tm(_,e.Diagnostics.Abstract_methods_can_only_appear_within_an_abstract_class);if(32&s)return Tm(_,e.Diagnostics._0_modifier_cannot_be_used_with_1_modifier,"static","abstract");if(8&s)return Tm(_,e.Diagnostics._0_modifier_cannot_be_used_with_1_modifier,"private","abstract")}s|=128;break;case 120:if(256&s)return Tm(_,e.Diagnostics._0_modifier_already_seen,"async");if(2&s||e.isInAmbientContext(t.parent))return Tm(_,e.Diagnostics._0_modifier_cannot_be_used_in_an_ambient_context,"async");if(146===t.kind)return Tm(_,e.Diagnostics._0_modifier_cannot_appear_on_a_parameter,"async");s|=256,i=_}}return 152===t.kind?32&s?Tm(n,e.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration,"static"):128&s?Tm(n,e.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration,"abstract"):256&s?Tm(i,e.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration,"async"):64&s?Tm(a,e.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration,"readonly"):void 0:(238===t.kind||237===t.kind)&&2&s?Tm(r,e.Diagnostics.A_0_modifier_cannot_be_used_with_an_import_declaration,"declare"):146===t.kind&&92&s&&e.isBindingPattern(t.name)?Tm(t,e.Diagnostics.A_parameter_property_may_not_be_declared_using_a_binding_pattern):146===t.kind&&92&s&&t.dotDotDotToken?Tm(t,e.Diagnostics.A_parameter_property_cannot_be_declared_using_a_rest_parameter):256&s?function(t,n){switch(t.kind){case 151:case 228:case 186:case 187:return!1}return Tm(n,e.Diagnostics._0_modifier_cannot_be_used_here,"async")}(t,i):void 0}function rm(e,t){return e.modifiers.length>1||e.modifiers[0].kind!==t}function im(t){if(t&&t.hasTrailingComma){var n=t.end-",".length,r=t.end;return Cm(t[0],n,r-n,e.Diagnostics.Trailing_comma_not_allowed)}}function am(t,n){if(im(t))return!0;if(t&&0===t.length){var r=t.pos-"<".length;return Cm(n,r,e.skipTrivia(n.text,t.end)+">".length-r,e.Diagnostics.Type_parameter_list_cannot_be_empty)}}function om(t){var n=e.getSourceFileOfNode(t);return tm(t)||nm(t)||am(t.typeParameters,n)||function(t){for(var n=!1,r=t.length,i=0;i<r;i++){var a=t[i];if(a.dotDotDotToken){if(i!==r-1)return Tm(a.dotDotDotToken,e.Diagnostics.A_rest_parameter_must_be_last_in_a_parameter_list);if(e.isBindingPattern(a.name))return Tm(a.name,e.Diagnostics.A_rest_element_cannot_contain_a_binding_pattern);if(a.questionToken)return Tm(a.questionToken,e.Diagnostics.A_rest_parameter_cannot_be_optional);if(a.initializer)return Tm(a.name,e.Diagnostics.A_rest_parameter_cannot_have_an_initializer)}else if(a.questionToken){if(n=!0,a.initializer)return Tm(a.name,e.Diagnostics.Parameter_cannot_have_question_mark_and_initializer)}else if(n&&!a.initializer)return Tm(a.name,e.Diagnostics.A_required_parameter_cannot_follow_an_optional_parameter)}}(t.parameters)||function(t,n){if(187===t.kind){var r=t;if(e.getLineAndCharacterOfPosition(n,r.equalsGreaterThanToken.pos).line!==e.getLineAndCharacterOfPosition(n,r.equalsGreaterThanToken.end).line)return Tm(r.equalsGreaterThanToken,e.Diagnostics.Line_terminator_not_permitted_before_arrow)}return!1}(t,n)}function sm(t,n){return im(n)||function(t,n){if(n&&0===n.length){var r=e.getSourceFileOfNode(t),i=n.pos-"<".length;return Cm(r,i,e.skipTrivia(r.text,n.end)+">".length-i,e.Diagnostics.Type_argument_list_cannot_be_empty)}}(t,n)}function cm(t){return function(t){if(t)for(var n=0,r=t;n<r.length;n++){var i=r[n];if(200===i.kind)return Cm(i,i.pos,0,e.Diagnostics.Argument_expression_expected)}}(t)}function um(t){var n=t.types;if(im(n))return!0;if(n&&0===n.length){var r=e.tokenToString(t.token);return Cm(t,n.pos,0,e.Diagnostics._0_list_cannot_be_empty,r)}return e.forEach(n,_m)}function _m(e){return sm(e,e.typeArguments)}function lm(t){if(144!==t.kind)return!1;var n=t;return 194===n.expression.kind&&26===n.expression.operatorToken.kind?Tm(n.expression,e.Diagnostics.A_comma_expression_is_not_allowed_in_a_computed_property_name):void 0}function dm(t){if(t.asteriskToken){if(e.Debug.assert(228===t.kind||186===t.kind||151===t.kind),e.isInAmbientContext(t))return Tm(t.asteriskToken,e.Diagnostics.Generators_are_not_allowed_in_an_ambient_context);if(!t.body)return Tm(t.asteriskToken,e.Diagnostics.An_overload_signature_cannot_be_declared_as_a_generator)}}function pm(e,t){if(e)return Tm(e,t)}function fm(t){if(Nm(t))return!0;if(216===t.kind&&t.awaitModifier&&0==(16384&t.flags))return Tm(t.awaitModifier,e.Diagnostics.A_for_await_of_statement_is_only_allowed_within_an_async_function_or_async_generator);if(227===t.initializer.kind){var n=t.initializer;if(!xm(n)){var r=n.declarations;if(!r.length)return!1;if(r.length>1){var i=215===t.kind?e.Diagnostics.Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement:e.Diagnostics.Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement;return Dm(n.declarations[1],i)}var a=r[0];if(a.initializer){var i=215===t.kind?e.Diagnostics.The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer:e.Diagnostics.The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer;return Tm(a.name,i)}if(a.type)return Tm(a,i=215===t.kind?e.Diagnostics.The_left_hand_side_of_a_for_in_statement_cannot_use_a_type_annotation:e.Diagnostics.The_left_hand_side_of_a_for_of_statement_cannot_use_a_type_annotation)}}return!1}function mm(t){if(t.parameters.length===(153===t.kind?1:2))return e.getThisParameter(t)}function gm(t,n){if(e.isDynamicName(t))return Tm(t,n)}function ym(t){if(function(t){if(t.modifiers&&178===t.parent.kind){if(!(2&e.getFunctionFlags(t)))return Dm(t,e.Diagnostics.Modifiers_cannot_appear_here);if(t.modifiers.length>1)return Dm(t,e.Diagnostics.Modifiers_cannot_appear_here)}}(t)||om(t)||dm(t))return!0;if(178===t.parent.kind){if(pm(t.questionToken,e.Diagnostics.An_object_member_cannot_be_declared_optional))return!0;if(void 0===t.body)return Cm(t,t.end-1,";".length,e.Diagnostics._0_expected,"{")}if(e.isClassLike(t.parent)){if(e.isInAmbientContext(t))return gm(t.name,e.Diagnostics.A_computed_property_name_in_an_ambient_context_must_directly_refer_to_a_built_in_symbol);if(!t.body)return gm(t.name,e.Diagnostics.A_computed_property_name_in_a_method_overload_must_directly_refer_to_a_built_in_symbol)}else{if(230===t.parent.kind)return gm(t.name,e.Diagnostics.A_computed_property_name_in_an_interface_must_directly_refer_to_a_built_in_symbol);if(163===t.parent.kind)return gm(t.name,e.Diagnostics.A_computed_property_name_in_a_type_literal_must_directly_refer_to_a_built_in_symbol)}}function hm(e){return 9===e.kind||8===e.kind||192===e.kind&&38===e.operator&&8===e.operand.kind}function vm(t){if(71===t.kind){if("__esModule"===e.idText(t))return Tm(t,e.Diagnostics.Identifier_expected_esModule_is_reserved_as_an_exported_marker_when_transforming_ECMAScript_modules)}else for(var n=0,r=t.elements;n<r.length;n++){var i=r[n];if(!e.isOmittedExpression(i))return vm(i.name)}}function bm(t){if(71===t.kind){if(110===t.originalKeywordKind)return Tm(t,e.Diagnostics.let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations)}else for(var n=0,r=t.elements;n<r.length;n++){var i=r[n];e.isOmittedExpression(i)||bm(i.name)}}function xm(t){var n=t.declarations;return!!im(t.declarations)||(t.declarations.length?void 0:Cm(t,n.pos,n.end-n.pos,e.Diagnostics.Variable_declaration_list_cannot_be_empty))}function km(e){switch(e.kind){case 211:case 212:case 213:case 220:case 214:case 215:case 216:return!1;case 222:return km(e.parent)}return!0}function Sm(e){return e.parseDiagnostics.length>0}function Dm(t,n,r,i,a){var o=e.getSourceFileOfNode(t);if(!Sm(o)){var s=e.getSpanOfTokenAtPosition(o,t.pos);return At.add(e.createFileDiagnostic(o,s.start,s.length,n,r,i,a)),!0}}function Cm(t,n,r,i,a,o,s){var c=e.getSourceFileOfNode(t);if(!Sm(c))return At.add(e.createFileDiagnostic(c,n,r,i,a,o,s)),!0}function Tm(t,n,r,i,a){if(!Sm(e.getSourceFileOfNode(t)))return At.add(e.createDiagnosticForNode(t,n,r,i,a)),!0}function Em(t){return 230!==t.kind&&231!==t.kind&&238!==t.kind&&237!==t.kind&&244!==t.kind&&243!==t.kind&&236!==t.kind&&!e.hasModifier(t,515)&&Dm(t,e.Diagnostics.A_declare_modifier_is_required_for_a_top_level_declaration_in_a_d_ts_file)}function Nm(t){if(e.isInAmbientContext(t)){if(e.isAccessor(t.parent))return yn(t).hasReportedStatementInAmbientContext=!0;if(!yn(t).hasReportedStatementInAmbientContext&&e.isFunctionLike(t.parent))return yn(t).hasReportedStatementInAmbientContext=Dm(t,e.Diagnostics.An_implementation_cannot_be_declared_in_ambient_contexts);if(207===t.parent.kind||234===t.parent.kind||265===t.parent.kind){var n=yn(t.parent);if(!n.hasReportedStatementInAmbientContext)return n.hasReportedStatementInAmbientContext=Dm(t,e.Diagnostics.Statements_are_not_allowed_in_ambient_contexts)}}}function Am(t){if(4&t.numericLiteralFlags){var n=void 0;if(D>=1?n=e.Diagnostics.Octal_literals_are_not_available_when_targeting_ECMAScript_5_and_higher_Use_the_syntax_0:e.isChildOfNodeWithKind(t,173)?n=e.Diagnostics.Octal_literal_types_must_use_ES2015_syntax_Use_the_syntax_0:e.isChildOfNodeWithKind(t,264)&&(n=e.Diagnostics.Octal_literals_are_not_allowed_in_enums_members_initializer_Use_the_syntax_0),n){var r=e.isPrefixUnaryExpression(t.parent)&&38===t.parent.operator,i=(r?"-":"")+"0o"+t.text;return Tm(r?t.parent:t,n,i)}}}}}(ts||(ts={})),function(e){function t(t){var n=e.createNode(t,-1,-1);return n.flags|=8,n}function n(t,n){return t!==n&&(Ot(t,n),Et(t,n),n.startsOnNewLine&&(t.startsOnNewLine=!0),e.aggregateTransformFlags(t)),t}function r(t,n){if(t){if(e.isNodeArray(t))return t}else t=[];var r=t;return r.pos=-1,r.end=-1,r.hasTrailingComma=n,r}function i(e){if(void 0!==e){var n=t(e.kind);for(var r in n.flags|=e.flags,Ot(n,e),e)!n.hasOwnProperty(r)&&e.hasOwnProperty(r)&&(n[r]=e[r]);return n}}function a(t){return"number"==typeof t?o(t+""):"boolean"==typeof t?t?d():p():e.isString(t)?s(t):(n=t,(r=s(e.getTextOfIdentifierOrLiteral(n))).textSourceNode=n,r);var n,r}function o(e){var n=t(8);return n.text=e,n.numericLiteralFlags=0,n}function s(e){var n=t(9);return n.text=e,n}function c(n,i){var a=t(71);return a.escapedText=e.escapeLeadingUnderscores(n),a.originalKeywordKind=n?e.stringToToken(n):0,a.autoGenerateKind=0,a.autoGenerateId=0,i&&(a.typeArguments=r(i)),a}e.updateNode=n,e.createNodeArray=r,e.getSynthesizedClone=i,e.createLiteral=a,e.createNumericLiteral=o,e.createIdentifier=c,e.updateIdentifier=function(t,r){return t.typeArguments!==r?n(c(e.idText(t),r),t):t};var u,_=0;function l(e){return t(e)}function d(){return t(101)}function p(){return t(86)}function f(e,n){var r=t(143);return r.left=e,r.right=Dt(n),r}function m(e){var n=t(144);return n.expression=e,n}function g(e,n,r){var i=t(145);return i.name=Dt(e),i.constraint=n,i.default=r,i}function y(n,r,i,a,o,s,c){var u=t(146);return u.decorators=Ct(n),u.modifiers=Ct(r),u.dotDotDotToken=i,u.name=Dt(a),u.questionToken=o,u.type=s,u.initializer=c?e.parenthesizeExpressionForList(c):void 0,u}function h(n){var r=t(147);return r.expression=e.parenthesizeForAccess(n),r}function v(e,n,r,i,a){var o=t(148);return o.modifiers=Ct(e),o.name=Dt(n),o.questionToken=r,o.type=i,o.initializer=a,o}function b(e,n,r,i,a,o){var s=t(149);return s.decorators=Ct(e),s.modifiers=Ct(n),s.name=Dt(r),s.questionToken=i,s.type=a,s.initializer=o,s}function x(e,t,n,r,i){var a=E(150,e,t,n);return a.name=Dt(r),a.questionToken=i,a}function k(e,n,i,a,o,s,c,u,_){var l=t(151);return l.decorators=Ct(e),l.modifiers=Ct(n),l.asteriskToken=i,l.name=Dt(a),l.questionToken=o,l.typeParameters=Ct(s),l.parameters=r(c),l.type=u,l.body=_,l}function S(e,n,i,a){var o=t(152);return o.decorators=Ct(e),o.modifiers=Ct(n),o.typeParameters=void 0,o.parameters=r(i),o.type=void 0,o.body=a,o}function D(e,n,i,a,o,s){var c=t(153);return c.decorators=Ct(e),c.modifiers=Ct(n),c.name=Dt(i),c.typeParameters=void 0,c.parameters=r(a),c.type=o,c.body=s,c}function C(e,n,i,a,o){var s=t(154);return s.decorators=Ct(e),s.modifiers=Ct(n),s.name=Dt(i),s.typeParameters=void 0,s.parameters=r(a),s.body=o,s}function T(e,n,i,a){var o=t(157);return o.decorators=Ct(e),o.modifiers=Ct(n),o.parameters=r(i),o.type=a,o}function E(e,n,r,i){var a=t(e);return a.typeParameters=Ct(n),a.parameters=Ct(r),a.type=i,a}function N(e,t,r,i){return e.typeParameters!==t||e.parameters!==r||e.type!==i?n(E(e.kind,t,r,i),e):e}function A(e,n){var r=t(158);return r.parameterName=Dt(e),r.type=n,r}function w(n,r){var i=t(159);return i.typeName=Dt(n),i.typeArguments=r&&e.parenthesizeTypeParameters(r),i}function P(e){var n=t(162);return n.exprName=e,n}function F(e){var n=t(163);return n.members=r(e),n}function O(n){var r=t(164);return r.elementType=e.parenthesizeArrayTypeMember(n),r}function I(e){var n=t(165);return n.elementTypes=r(e),n}function R(n,r){var i=t(n);return i.types=e.parenthesizeElementTypeMembers(r),i}function L(e,t){return e.types!==t?n(R(e.kind,t),e):e}function M(e){var n=t(168);return n.type=e,n}function B(n){var r=t(170);return r.operator=127,r.type=e.parenthesizeElementTypeMember(n),r}function J(n,r){var i=t(171);return i.objectType=e.parenthesizeElementTypeMember(n),i.indexType=r,i}function z(e,n,r,i){var a=t(172);return a.readonlyToken=e,a.typeParameter=n,a.questionToken=r,a.type=i,a}function j(e){var n=t(173);return n.literal=e,n}function K(e){var n=t(174);return n.elements=r(e),n}function U(e){var n=t(175);return n.elements=r(e),n}function V(e,n,r,i){var a=t(176);return a.dotDotDotToken=e,a.propertyName=Dt(n),a.name=Dt(r),a.initializer=i,a}function q(n,i){var a=t(177);return a.elements=e.parenthesizeListElements(r(n)),i&&(a.multiLine=!0),a}function W(e,n){var i=t(178);return i.properties=r(e),n&&(i.multiLine=!0),i}function H(n,r){var i=t(179);return i.expression=e.parenthesizeForAccess(n),i.name=Dt(r),Nt(i,131072),i}function G(n,r){var i,o=t(180);return o.expression=e.parenthesizeForAccess(n),o.argumentExpression=(i=r,e.isString(i)||"number"==typeof i?a(i):i),o}function Q(n,i,a){var o=t(181);return o.expression=e.parenthesizeForAccess(n),o.typeArguments=Ct(i),o.arguments=e.parenthesizeListElements(r(a)),o}function X(n,i,a){var o=t(182);return o.expression=e.parenthesizeForNew(n),o.typeArguments=Ct(i),o.arguments=a?e.parenthesizeListElements(r(a)):void 0,o}function Y(n,r){var i=t(183);return i.tag=e.parenthesizeForAccess(n),i.template=r,i}function Z(n,r){var i=t(184);return i.type=n,i.expression=e.parenthesizePrefixOperand(r),i}function $(e){var n=t(185);return n.expression=e,n}function ee(e,n,i,a,o,s,c){var u=t(186);return u.modifiers=Ct(e),u.asteriskToken=n,u.name=Dt(i),u.typeParameters=Ct(a),u.parameters=r(o),u.type=s,u.body=c,u}function te(n,i,a,o,s,c){var u=t(187);return u.modifiers=Ct(n),u.typeParameters=Ct(i),u.parameters=r(a),u.type=o,u.equalsGreaterThanToken=s||l(36),u.body=e.parenthesizeConciseBody(c),u}function ne(n){var r=t(188);return r.expression=e.parenthesizePrefixOperand(n),r}function re(n){var r=t(189);return r.expression=e.parenthesizePrefixOperand(n),r}function ie(n){var r=t(190);return r.expression=e.parenthesizePrefixOperand(n),r}function ae(n){var r=t(191);return r.expression=e.parenthesizePrefixOperand(n),r}function oe(n,r){var i=t(192);return i.operator=n,i.operand=e.parenthesizePrefixOperand(r),i}function se(n,r){var i=t(193);return i.operand=e.parenthesizePostfixOperand(n),i.operator=r,i}function ce(n,r,i){var a,o=t(194),s="number"==typeof(a=r)?l(a):a,c=s.kind;return o.left=e.parenthesizeBinaryOperand(c,n,!0,void 0),o.operatorToken=s,o.right=e.parenthesizeBinaryOperand(c,i,!1,o.left),o}function ue(n,r,i,a,o){var s=t(195);return s.condition=e.parenthesizeForConditionalHead(n),s.questionToken=o?r:l(55),s.whenTrue=e.parenthesizeSubexpressionOfConditionalExpression(o?i:r),s.colonToken=o?a:l(56),s.whenFalse=e.parenthesizeSubexpressionOfConditionalExpression(o||i),s}function _e(e,n){var i=t(196);return i.head=e,i.templateSpans=r(n),i}function le(e,n){var r=t(197);return r.asteriskToken=e&&39===e.kind?e:void 0,r.expression=e&&39!==e.kind?e:n,r}function de(n){var r=t(198);return r.expression=e.parenthesizeExpressionForList(n),r}function pe(e,n,i,a,o){var s=t(199);return s.decorators=void 0,s.modifiers=Ct(e),s.name=Dt(n),s.typeParameters=Ct(i),s.heritageClauses=Ct(a),s.members=r(o),s}function fe(n,r){var i=t(201);return i.expression=e.parenthesizeForAccess(r),i.typeArguments=Ct(n),i}function me(e,n){var r=t(202);return r.expression=e,r.type=n,r}function ge(n){var r=t(203);return r.expression=e.parenthesizeForAccess(n),r}function ye(e,n){var r=t(204);return r.keywordToken=e,r.name=n,r}function he(e,n){var r=t(205);return r.expression=e,r.literal=n,r}function ve(e,n){var i=t(207);return i.statements=r(e),n&&(i.multiLine=n),i}function be(n,r){var i=t(208);return i.decorators=void 0,i.modifiers=Ct(n),i.declarationList=e.isArray(r)?Me(r):r,i}function xe(n){var r=t(210);return r.expression=e.parenthesizeExpressionForExpressionStatement(n),r}function ke(e,n,r){var i=t(211);return i.expression=e,i.thenStatement=n,i.elseStatement=r,i}function Se(e,n){var r=t(212);return r.statement=e,r.expression=n,r}function De(e,n){var r=t(213);return r.expression=e,r.statement=n,r}function Ce(e,n,r,i){var a=t(214);return a.initializer=e,a.condition=n,a.incrementor=r,a.statement=i,a}function Te(e,n,r){var i=t(215);return i.initializer=e,i.expression=n,i.statement=r,i}function Ee(e,n,r,i){var a=t(216);return a.awaitModifier=e,a.initializer=n,a.expression=r,a.statement=i,a}function Ne(e){var n=t(217);return n.label=Dt(e),n}function Ae(e){var n=t(218);return n.label=Dt(e),n}function we(e){var n=t(219);return n.expression=e,n}function Pe(e,n){var r=t(220);return r.expression=e,r.statement=n,r}function Fe(n,r){var i=t(221);return i.expression=e.parenthesizeExpressionForList(n),i.caseBlock=r,i}function Oe(e,n){var r=t(222);return r.label=Dt(e),r.statement=n,r}function Ie(e){var n=t(223);return n.expression=e,n}function Re(e,n,r){var i=t(224);return i.tryBlock=e,i.catchClause=n,i.finallyBlock=r,i}function Le(n,r,i){var a=t(226);return a.name=Dt(n),a.type=r,a.initializer=void 0!==i?e.parenthesizeExpressionForList(i):void 0,a}function Me(e,n){var i=t(227);return i.flags|=3&n,i.declarations=r(e),i}function Be(e,n,i,a,o,s,c,u){var _=t(228);return _.decorators=Ct(e),_.modifiers=Ct(n),_.asteriskToken=i,_.name=Dt(a),_.typeParameters=Ct(o),_.parameters=r(s),_.type=c,_.body=u,_}function Je(e,n,i,a,o,s){var c=t(229);return c.decorators=Ct(e),c.modifiers=Ct(n),c.name=Dt(i),c.typeParameters=Ct(a),c.heritageClauses=Ct(o),c.members=r(s),c}function ze(e,n,i,a,o,s){var c=t(230);return c.decorators=Ct(e),c.modifiers=Ct(n),c.name=Dt(i),c.typeParameters=Ct(a),c.heritageClauses=Ct(o),c.members=r(s),c}function je(e,n,r,i,a){var o=t(231);return o.decorators=Ct(e),o.modifiers=Ct(n),o.name=Dt(r),o.typeParameters=Ct(i),o.type=a,o}function Ke(e,n,i,a){var o=t(232);return o.decorators=Ct(e),o.modifiers=Ct(n),o.name=Dt(i),o.members=r(a),o}function Ue(e,n,r,i,a){var o=t(233);return o.flags|=532&a,o.decorators=Ct(e),o.modifiers=Ct(n),o.name=r,o.body=i,o}function Ve(e){var n=t(234);return n.statements=r(e),n}function qe(e){var n=t(235);return n.clauses=r(e),n}function We(e){var n=t(236);return n.name=Dt(e),n}function He(e,n,r,i){var a=t(237);return a.decorators=Ct(e),a.modifiers=Ct(n),a.name=Dt(r),a.moduleReference=i,a}function Ge(e,n,r,i){var a=t(238);return a.decorators=Ct(e),a.modifiers=Ct(n),a.importClause=r,a.moduleSpecifier=i,a}function Qe(e,n){var r=t(239);return r.name=e,r.namedBindings=n,r}function Xe(e){var n=t(240);return n.name=e,n}function Ye(e){var n=t(241);return n.elements=r(e),n}function Ze(e,n){var r=t(242);return r.propertyName=e,r.name=n,r}function $e(e,n,r,i){var a=t(243);return a.decorators=Ct(e),a.modifiers=Ct(n),a.isExportEquals=r,a.expression=i,a}function et(e,n,r,i){var a=t(244);return a.decorators=Ct(e),a.modifiers=Ct(n),a.exportClause=r,a.moduleSpecifier=i,a}function tt(e){var n=t(245);return n.elements=r(e),n}function nt(e,n){var r=t(246);return r.propertyName=Dt(e),r.name=Dt(n),r}function rt(e){var n=t(248);return n.expression=e,n}function it(e,n,i){var a=t(249);return a.openingElement=e,a.children=r(n),a.closingElement=i,a}function at(e,n){var r=t(250);return r.tagName=e,r.attributes=n,r}function ot(e,n){var r=t(251);return r.tagName=e,r.attributes=n,r}function st(e){var n=t(252);return n.tagName=e,n}function ct(e,n){var r=t(253);return r.name=e,r.initializer=n,r}function ut(e){var n=t(254);return n.properties=r(e),n}function _t(e){var n=t(255);return n.expression=e,n}function lt(e,n){var r=t(256);return r.dotDotDotToken=e,r.expression=n,r}function dt(n,i){var a=t(257);return a.expression=e.parenthesizeExpressionForList(n),a.statements=r(i),a}function pt(e){var n=t(258);return n.statements=r(e),n}function ft(e,n){var i=t(259);return i.token=e,i.types=r(n),i}function mt(n,r){var i=t(260);return i.variableDeclaration=e.isString(n)?Le(n):n,i.block=r,i}function gt(n,r){var i=t(261);return i.name=Dt(n),i.questionToken=void 0,i.initializer=void 0!==r?e.parenthesizeExpressionForList(r):void 0,i}function yt(n,r){var i=t(262);return i.name=Dt(n),i.objectAssignmentInitializer=void 0!==r?e.parenthesizeExpressionForList(r):void 0,i}function ht(n){var r=t(263);return r.expression=void 0!==n?e.parenthesizeExpressionForList(n):void 0,r}function vt(n,r){var i=t(264);return i.name=Dt(n),i.initializer=r&&e.parenthesizeExpressionForList(r),i}function bt(e,n){var r=t(288);return r.expression=e,r.original=n,Et(r,n),r}function xt(t){if(e.nodeIsSynthesized(t)&&!e.isParseTreeNode(t)&&!t.original&&!t.emitNode&&!t.id){if(289===t.kind)return t.elements;if(e.isBinaryExpression(t)&&26===t.operatorToken.kind)return[t.left,t.right]}return t}function kt(n){var i=t(289);return i.elements=r(e.sameFlatMap(n,xt)),i}function St(t){var n=e.createNode(266);return n.sourceFiles=t,n}function Dt(t){return e.isString(t)?c(t):t}function Ct(e){return e?r(e):void 0}function Tt(t){if(!t.emitNode){if(e.isParseTreeNode(t)){if(265===t.kind)return t.emitNode={annotatedNodes:[t]};Tt(e.getSourceFileOfNode(t)).annotatedNodes.push(t)}t.emitNode={}}return t.emitNode}function Et(e,t){return t&&(e.pos=t.pos,e.end=t.end),e}function Nt(e,t){return Tt(e).flags=t,e}function At(e){var t=e.emitNode;return t&&t.leadingComments}function wt(e,t){return Tt(e).leadingComments=t,e}function Pt(e){var t=e.emitNode;return t&&t.trailingComments}function Ft(e,t){return Tt(e).trailingComments=t,e}function Ot(t,n){if(t.original=n,n){var r=n.emitNode;r&&(t.emitNode=function(t,n){var r=t.flags,i=t.leadingComments,a=t.trailingComments,o=t.commentRange,s=t.sourceMapRange,c=t.tokenSourceMapRanges,u=t.constantValue,_=t.helpers;n||(n={});i&&(n.leadingComments=e.addRange(i.slice(),n.leadingComments));a&&(n.trailingComments=e.addRange(a.slice(),n.trailingComments));r&&(n.flags=r);o&&(n.commentRange=o);s&&(n.sourceMapRange=s);c&&(n.tokenSourceMapRanges=function(e,t){t||(t=[]);for(var n in e)t[n]=e[n];return t}(c,n.tokenSourceMapRanges));void 0!==u&&(n.constantValue=u);_&&(n.helpers=e.addRange(n.helpers,_));return n}(r,t.emitNode))}return t}e.createTempVariable=function(e){var t=c("");return t.autoGenerateKind=1,t.autoGenerateId=_,_++,e&&e(t),t},e.createLoopVariable=function(){var e=c("");return e.autoGenerateKind=2,e.autoGenerateId=_,_++,e},e.createUniqueName=function(e){var t=c(e);return t.autoGenerateKind=3,t.autoGenerateId=_,_++,t},e.getGeneratedNameForNode=function(e){var t=c("");return t.autoGenerateKind=4,t.autoGenerateId=_,t.original=e,_++,t},e.createToken=l,e.createSuper=function(){return t(97)},e.createThis=function(){return t(99)},e.createNull=function(){return t(95)},e.createTrue=d,e.createFalse=p,e.createQualifiedName=f,e.updateQualifiedName=function(e,t,r){return e.left!==t||e.right!==r?n(f(t,r),e):e},e.createComputedPropertyName=m,e.updateComputedPropertyName=function(e,t){return e.expression!==t?n(m(t),e):e},e.createTypeParameterDeclaration=g,e.updateTypeParameterDeclaration=function(e,t,r,i){return e.name!==t||e.constraint!==r||e.default!==i?n(g(t,r,i),e):e},e.createParameter=y,e.updateParameter=function(e,t,r,i,a,o,s,c){return e.decorators!==t||e.modifiers!==r||e.dotDotDotToken!==i||e.name!==a||e.questionToken!==o||e.type!==s||e.initializer!==c?n(y(t,r,i,a,o,s,c),e):e},e.createDecorator=h,e.updateDecorator=function(e,t){return e.expression!==t?n(h(t),e):e},e.createPropertySignature=v,e.updatePropertySignature=function(e,t,r,i,a,o){return e.modifiers!==t||e.name!==r||e.questionToken!==i||e.type!==a||e.initializer!==o?n(v(t,r,i,a,o),e):e},e.createProperty=b,e.updateProperty=function(e,t,r,i,a,o,s){return e.decorators!==t||e.modifiers!==r||e.name!==i||e.questionToken!==a||e.type!==o||e.initializer!==s?n(b(t,r,i,a,o,s),e):e},e.createMethodSignature=x,e.updateMethodSignature=function(e,t,r,i,a,o){return e.typeParameters!==t||e.parameters!==r||e.type!==i||e.name!==a||e.questionToken!==o?n(x(t,r,i,a,o),e):e},e.createMethod=k,e.updateMethod=function(e,t,r,i,a,o,s,c,u,_){return e.decorators!==t||e.modifiers!==r||e.asteriskToken!==i||e.name!==a||e.questionToken!==o||e.typeParameters!==s||e.parameters!==c||e.type!==u||e.body!==_?n(k(t,r,i,a,o,s,c,u,_),e):e},e.createConstructor=S,e.updateConstructor=function(e,t,r,i,a){return e.decorators!==t||e.modifiers!==r||e.parameters!==i||e.body!==a?n(S(t,r,i,a),e):e},e.createGetAccessor=D,e.updateGetAccessor=function(e,t,r,i,a,o,s){return e.decorators!==t||e.modifiers!==r||e.name!==i||e.parameters!==a||e.type!==o||e.body!==s?n(D(t,r,i,a,o,s),e):e},e.createSetAccessor=C,e.updateSetAccessor=function(e,t,r,i,a,o){return e.decorators!==t||e.modifiers!==r||e.name!==i||e.parameters!==a||e.body!==o?n(C(t,r,i,a,o),e):e},e.createCallSignature=function(e,t,n){return E(155,e,t,n)},e.updateCallSignature=function(e,t,n,r){return N(e,t,n,r)},e.createConstructSignature=function(e,t,n){return E(156,e,t,n)},e.updateConstructSignature=function(e,t,n,r){return N(e,t,n,r)},e.createIndexSignature=T,e.updateIndexSignature=function(e,t,r,i,a){return e.parameters!==i||e.type!==a||e.decorators!==t||e.modifiers!==r?n(T(t,r,i,a),e):e},e.createSignatureDeclaration=E,e.createKeywordTypeNode=function(e){return t(e)},e.createTypePredicateNode=A,e.updateTypePredicateNode=function(e,t,r){return e.parameterName!==t||e.type!==r?n(A(t,r),e):e},e.createTypeReferenceNode=w,e.updateTypeReferenceNode=function(e,t,r){return e.typeName!==t||e.typeArguments!==r?n(w(t,r),e):e},e.createFunctionTypeNode=function(e,t,n){return E(160,e,t,n)},e.updateFunctionTypeNode=function(e,t,n,r){return N(e,t,n,r)},e.createConstructorTypeNode=function(e,t,n){return E(161,e,t,n)},e.updateConstructorTypeNode=function(e,t,n,r){return N(e,t,n,r)},e.createTypeQueryNode=P,e.updateTypeQueryNode=function(e,t){return e.exprName!==t?n(P(t),e):e},e.createTypeLiteralNode=F,e.updateTypeLiteralNode=function(e,t){return e.members!==t?n(F(t),e):e},e.createArrayTypeNode=O,e.updateArrayTypeNode=function(e,t){return e.elementType!==t?n(O(t),e):e},e.createTupleTypeNode=I,e.updateTypleTypeNode=function(e,t){return e.elementTypes!==t?n(I(t),e):e},e.createUnionTypeNode=function(e){return R(166,e)},e.updateUnionTypeNode=function(e,t){return L(e,t)},e.createIntersectionTypeNode=function(e){return R(167,e)},e.updateIntersectionTypeNode=function(e,t){return L(e,t)},e.createUnionOrIntersectionTypeNode=R,e.createParenthesizedType=M,e.updateParenthesizedType=function(e,t){return e.type!==t?n(M(t),e):e},e.createThisTypeNode=function(){return t(169)},e.createTypeOperatorNode=B,e.updateTypeOperatorNode=function(e,t){return e.type!==t?n(B(t),e):e},e.createIndexedAccessTypeNode=J,e.updateIndexedAccessTypeNode=function(e,t,r){return e.objectType!==t||e.indexType!==r?n(J(t,r),e):e},e.createMappedTypeNode=z,e.updateMappedTypeNode=function(e,t,r,i,a){return e.readonlyToken!==t||e.typeParameter!==r||e.questionToken!==i||e.type!==a?n(z(t,r,i,a),e):e},e.createLiteralTypeNode=j,e.updateLiteralTypeNode=function(e,t){return e.literal!==t?n(j(t),e):e},e.createObjectBindingPattern=K,e.updateObjectBindingPattern=function(e,t){return e.elements!==t?n(K(t),e):e},e.createArrayBindingPattern=U,e.updateArrayBindingPattern=function(e,t){return e.elements!==t?n(U(t),e):e},e.createBindingElement=V,e.updateBindingElement=function(e,t,r,i,a){return e.propertyName!==r||e.dotDotDotToken!==t||e.name!==i||e.initializer!==a?n(V(t,r,i,a),e):e},e.createArrayLiteral=q,e.updateArrayLiteral=function(e,t){return e.elements!==t?n(q(t,e.multiLine),e):e},e.createObjectLiteral=W,e.updateObjectLiteral=function(e,t){return e.properties!==t?n(W(t,e.multiLine),e):e},e.createPropertyAccess=H,e.updatePropertyAccess=function(t,r,i){return t.expression!==r||t.name!==i?n(Nt(H(r,i),e.getEmitFlags(t)),t):t},e.createElementAccess=G,e.updateElementAccess=function(e,t,r){return e.expression!==t||e.argumentExpression!==r?n(G(t,r),e):e},e.createCall=Q,e.updateCall=function(e,t,r,i){return e.expression!==t||e.typeArguments!==r||e.arguments!==i?n(Q(t,r,i),e):e},e.createNew=X,e.updateNew=function(e,t,r,i){return e.expression!==t||e.typeArguments!==r||e.arguments!==i?n(X(t,r,i),e):e},e.createTaggedTemplate=Y,e.updateTaggedTemplate=function(e,t,r){return e.tag!==t||e.template!==r?n(Y(t,r),e):e},e.createTypeAssertion=Z,e.updateTypeAssertion=function(e,t,r){return e.type!==t||e.expression!==r?n(Z(t,r),e):e},e.createParen=$,e.updateParen=function(e,t){return e.expression!==t?n($(t),e):e},e.createFunctionExpression=ee,e.updateFunctionExpression=function(e,t,r,i,a,o,s,c){return e.name!==i||e.modifiers!==t||e.asteriskToken!==r||e.typeParameters!==a||e.parameters!==o||e.type!==s||e.body!==c?n(ee(t,r,i,a,o,s,c),e):e},e.createArrowFunction=te,e.updateArrowFunction=function(t,r,i,a,o,s,c){var u,_;return void 0===c?(u=t.equalsGreaterThanToken,_=e.cast(s,e.isConciseBody)):(u=e.cast(s,(function(e){return 36===e.kind})),_=c),t.modifiers!==r||t.typeParameters!==i||t.parameters!==a||t.type!==o||t.equalsGreaterThanToken!==u||t.body!==_?n(te(r,i,a,o,u,_),t):t},e.createDelete=ne,e.updateDelete=function(e,t){return e.expression!==t?n(ne(t),e):e},e.createTypeOf=re,e.updateTypeOf=function(e,t){return e.expression!==t?n(re(t),e):e},e.createVoid=ie,e.updateVoid=function(e,t){return e.expression!==t?n(ie(t),e):e},e.createAwait=ae,e.updateAwait=function(e,t){return e.expression!==t?n(ae(t),e):e},e.createPrefix=oe,e.updatePrefix=function(e,t){return e.operand!==t?n(oe(e.operator,t),e):e},e.createPostfix=se,e.updatePostfix=function(e,t){return e.operand!==t?n(se(t,e.operator),e):e},e.createBinary=ce,e.updateBinary=function(e,t,r,i){return e.left!==t||e.right!==r?n(ce(t,i||e.operatorToken,r),e):e},e.createConditional=ue,e.updateConditional=function t(r,i){for(var a=[],o=2;o<arguments.length;o++)a[o-2]=arguments[o];if(2===a.length){var s=a[0],c=a[1];return t(r,i,r.questionToken,s,r.colonToken,c)}e.Debug.assert(4===a.length);var u=a[0],_=a[1],l=a[2],d=a[3];return r.condition!==i||r.questionToken!==u||r.whenTrue!==_||r.colonToken!==l||r.whenFalse!==d?n(ue(i,u,_,l,d),r):r},e.createTemplateExpression=_e,e.updateTemplateExpression=function(e,t,r){return e.head!==t||e.templateSpans!==r?n(_e(t,r),e):e},e.createTemplateHead=function(e){var n=t(14);return n.text=e,n},e.createTemplateMiddle=function(e){var n=t(15);return n.text=e,n},e.createTemplateTail=function(e){var n=t(16);return n.text=e,n},e.createNoSubstitutionTemplateLiteral=function(e){var n=t(13);return n.text=e,n},e.createYield=le,e.updateYield=function(e,t,r){return e.expression!==r||e.asteriskToken!==t?n(le(t,r),e):e},e.createSpread=de,e.updateSpread=function(e,t){return e.expression!==t?n(de(t),e):e},e.createClassExpression=pe,e.updateClassExpression=function(e,t,r,i,a,o){return e.modifiers!==t||e.name!==r||e.typeParameters!==i||e.heritageClauses!==a||e.members!==o?n(pe(t,r,i,a,o),e):e},e.createOmittedExpression=function(){return t(200)},e.createExpressionWithTypeArguments=fe,e.updateExpressionWithTypeArguments=function(e,t,r){return e.typeArguments!==t||e.expression!==r?n(fe(t,r),e):e},e.createAsExpression=me,e.updateAsExpression=function(e,t,r){return e.expression!==t||e.type!==r?n(me(t,r),e):e},e.createNonNullExpression=ge,e.updateNonNullExpression=function(e,t){return e.expression!==t?n(ge(t),e):e},e.createMetaProperty=ye,e.updateMetaProperty=function(e,t){return e.name!==t?n(ye(e.keywordToken,t),e):e},e.createTemplateSpan=he,e.updateTemplateSpan=function(e,t,r){return e.expression!==t||e.literal!==r?n(he(t,r),e):e},e.createSemicolonClassElement=function(){return t(206)},e.createBlock=ve,e.updateBlock=function(e,t){return e.statements!==t?n(ve(t,e.multiLine),e):e},e.createVariableStatement=be,e.updateVariableStatement=function(e,t,r){return e.modifiers!==t||e.declarationList!==r?n(be(t,r),e):e},e.createEmptyStatement=function(){return t(209)},e.createStatement=xe,e.updateStatement=function(e,t){return e.expression!==t?n(xe(t),e):e},e.createIf=ke,e.updateIf=function(e,t,r,i){return e.expression!==t||e.thenStatement!==r||e.elseStatement!==i?n(ke(t,r,i),e):e},e.createDo=Se,e.updateDo=function(e,t,r){return e.statement!==t||e.expression!==r?n(Se(t,r),e):e},e.createWhile=De,e.updateWhile=function(e,t,r){return e.expression!==t||e.statement!==r?n(De(t,r),e):e},e.createFor=Ce,e.updateFor=function(e,t,r,i,a){return e.initializer!==t||e.condition!==r||e.incrementor!==i||e.statement!==a?n(Ce(t,r,i,a),e):e},e.createForIn=Te,e.updateForIn=function(e,t,r,i){return e.initializer!==t||e.expression!==r||e.statement!==i?n(Te(t,r,i),e):e},e.createForOf=Ee,e.updateForOf=function(e,t,r,i,a){return e.awaitModifier!==t||e.initializer!==r||e.expression!==i||e.statement!==a?n(Ee(t,r,i,a),e):e},e.createContinue=Ne,e.updateContinue=function(e,t){return e.label!==t?n(Ne(t),e):e},e.createBreak=Ae,e.updateBreak=function(e,t){return e.label!==t?n(Ae(t),e):e},e.createReturn=we,e.updateReturn=function(e,t){return e.expression!==t?n(we(t),e):e},e.createWith=Pe,e.updateWith=function(e,t,r){return e.expression!==t||e.statement!==r?n(Pe(t,r),e):e},e.createSwitch=Fe,e.updateSwitch=function(e,t,r){return e.expression!==t||e.caseBlock!==r?n(Fe(t,r),e):e},e.createLabel=Oe,e.updateLabel=function(e,t,r){return e.label!==t||e.statement!==r?n(Oe(t,r),e):e},e.createThrow=Ie,e.updateThrow=function(e,t){return e.expression!==t?n(Ie(t),e):e},e.createTry=Re,e.updateTry=function(e,t,r,i){return e.tryBlock!==t||e.catchClause!==r||e.finallyBlock!==i?n(Re(t,r,i),e):e},e.createDebuggerStatement=function(){return t(225)},e.createVariableDeclaration=Le,e.updateVariableDeclaration=function(e,t,r,i){return e.name!==t||e.type!==r||e.initializer!==i?n(Le(t,r,i),e):e},e.createVariableDeclarationList=Me,e.updateVariableDeclarationList=function(e,t){return e.declarations!==t?n(Me(t,e.flags),e):e},e.createFunctionDeclaration=Be,e.updateFunctionDeclaration=function(e,t,r,i,a,o,s,c,u){return e.decorators!==t||e.modifiers!==r||e.asteriskToken!==i||e.name!==a||e.typeParameters!==o||e.parameters!==s||e.type!==c||e.body!==u?n(Be(t,r,i,a,o,s,c,u),e):e},e.createClassDeclaration=Je,e.updateClassDeclaration=function(e,t,r,i,a,o,s){return e.decorators!==t||e.modifiers!==r||e.name!==i||e.typeParameters!==a||e.heritageClauses!==o||e.members!==s?n(Je(t,r,i,a,o,s),e):e},e.createInterfaceDeclaration=ze,e.updateInterfaceDeclaration=function(e,t,r,i,a,o,s){return e.decorators!==t||e.modifiers!==r||e.name!==i||e.typeParameters!==a||e.heritageClauses!==o||e.members!==s?n(ze(t,r,i,a,o,s),e):e},e.createTypeAliasDeclaration=je,e.updateTypeAliasDeclaration=function(e,t,r,i,a,o){return e.decorators!==t||e.modifiers!==r||e.name!==i||e.typeParameters!==a||e.type!==o?n(je(t,r,i,a,o),e):e},e.createEnumDeclaration=Ke,e.updateEnumDeclaration=function(e,t,r,i,a){return e.decorators!==t||e.modifiers!==r||e.name!==i||e.members!==a?n(Ke(t,r,i,a),e):e},e.createModuleDeclaration=Ue,e.updateModuleDeclaration=function(e,t,r,i,a){return e.decorators!==t||e.modifiers!==r||e.name!==i||e.body!==a?n(Ue(t,r,i,a,e.flags),e):e},e.createModuleBlock=Ve,e.updateModuleBlock=function(e,t){return e.statements!==t?n(Ve(t),e):e},e.createCaseBlock=qe,e.updateCaseBlock=function(e,t){return e.clauses!==t?n(qe(t),e):e},e.createNamespaceExportDeclaration=We,e.updateNamespaceExportDeclaration=function(e,t){return e.name!==t?n(We(t),e):e},e.createImportEqualsDeclaration=He,e.updateImportEqualsDeclaration=function(e,t,r,i,a){return e.decorators!==t||e.modifiers!==r||e.name!==i||e.moduleReference!==a?n(He(t,r,i,a),e):e},e.createImportDeclaration=Ge,e.updateImportDeclaration=function(e,t,r,i,a){return e.decorators!==t||e.modifiers!==r||e.importClause!==i||e.moduleSpecifier!==a?n(Ge(t,r,i,a),e):e},e.createImportClause=Qe,e.updateImportClause=function(e,t,r){return e.name!==t||e.namedBindings!==r?n(Qe(t,r),e):e},e.createNamespaceImport=Xe,e.updateNamespaceImport=function(e,t){return e.name!==t?n(Xe(t),e):e},e.createNamedImports=Ye,e.updateNamedImports=function(e,t){return e.elements!==t?n(Ye(t),e):e},e.createImportSpecifier=Ze,e.updateImportSpecifier=function(e,t,r){return e.propertyName!==t||e.name!==r?n(Ze(t,r),e):e},e.createExportAssignment=$e,e.updateExportAssignment=function(e,t,r,i){return e.decorators!==t||e.modifiers!==r||e.expression!==i?n($e(t,r,e.isExportEquals,i),e):e},e.createExportDeclaration=et,e.updateExportDeclaration=function(e,t,r,i,a){return e.decorators!==t||e.modifiers!==r||e.exportClause!==i||e.moduleSpecifier!==a?n(et(t,r,i,a),e):e},e.createNamedExports=tt,e.updateNamedExports=function(e,t){return e.elements!==t?n(tt(t),e):e},e.createExportSpecifier=nt,e.updateExportSpecifier=function(e,t,r){return e.propertyName!==t||e.name!==r?n(nt(t,r),e):e},e.createExternalModuleReference=rt,e.updateExternalModuleReference=function(e,t){return e.expression!==t?n(rt(t),e):e},e.createJsxElement=it,e.updateJsxElement=function(e,t,r,i){return e.openingElement!==t||e.children!==r||e.closingElement!==i?n(it(t,r,i),e):e},e.createJsxSelfClosingElement=at,e.updateJsxSelfClosingElement=function(e,t,r){return e.tagName!==t||e.attributes!==r?n(at(t,r),e):e},e.createJsxOpeningElement=ot,e.updateJsxOpeningElement=function(e,t,r){return e.tagName!==t||e.attributes!==r?n(ot(t,r),e):e},e.createJsxClosingElement=st,e.updateJsxClosingElement=function(e,t){return e.tagName!==t?n(st(t),e):e},e.createJsxAttribute=ct,e.updateJsxAttribute=function(e,t,r){return e.name!==t||e.initializer!==r?n(ct(t,r),e):e},e.createJsxAttributes=ut,e.updateJsxAttributes=function(e,t){return e.properties!==t?n(ut(t),e):e},e.createJsxSpreadAttribute=_t,e.updateJsxSpreadAttribute=function(e,t){return e.expression!==t?n(_t(t),e):e},e.createJsxExpression=lt,e.updateJsxExpression=function(e,t){return e.expression!==t?n(lt(e.dotDotDotToken,t),e):e},e.createCaseClause=dt,e.updateCaseClause=function(e,t,r){return e.expression!==t||e.statements!==r?n(dt(t,r),e):e},e.createDefaultClause=pt,e.updateDefaultClause=function(e,t){return e.statements!==t?n(pt(t),e):e},e.createHeritageClause=ft,e.updateHeritageClause=function(e,t){return e.types!==t?n(ft(e.token,t),e):e},e.createCatchClause=mt,e.updateCatchClause=function(e,t,r){return e.variableDeclaration!==t||e.block!==r?n(mt(t,r),e):e},e.createPropertyAssignment=gt,e.updatePropertyAssignment=function(e,t,r){return e.name!==t||e.initializer!==r?n(gt(t,r),e):e},e.createShorthandPropertyAssignment=yt,e.updateShorthandPropertyAssignment=function(e,t,r){return e.name!==t||e.objectAssignmentInitializer!==r?n(yt(t,r),e):e},e.createSpreadAssignment=ht,e.updateSpreadAssignment=function(e,t){return e.expression!==t?n(ht(t),e):e},e.createEnumMember=vt,e.updateEnumMember=function(e,t,r){return e.name!==t||e.initializer!==r?n(vt(t,r),e):e},e.updateSourceFileNode=function(e,i){if(e.statements!==i){var a=t(265);return a.flags|=e.flags,a.statements=r(i),a.endOfFileToken=e.endOfFileToken,a.fileName=e.fileName,a.path=e.path,a.text=e.text,void 0!==e.amdDependencies&&(a.amdDependencies=e.amdDependencies),void 0!==e.moduleName&&(a.moduleName=e.moduleName),void 0!==e.referencedFiles&&(a.referencedFiles=e.referencedFiles),void 0!==e.typeReferenceDirectives&&(a.typeReferenceDirectives=e.typeReferenceDirectives),void 0!==e.languageVariant&&(a.languageVariant=e.languageVariant),void 0!==e.isDeclarationFile&&(a.isDeclarationFile=e.isDeclarationFile),void 0!==e.renamedDependencies&&(a.renamedDependencies=e.renamedDependencies),void 0!==e.hasNoDefaultLib&&(a.hasNoDefaultLib=e.hasNoDefaultLib),void 0!==e.languageVersion&&(a.languageVersion=e.languageVersion),void 0!==e.scriptKind&&(a.scriptKind=e.scriptKind),void 0!==e.externalModuleIndicator&&(a.externalModuleIndicator=e.externalModuleIndicator),void 0!==e.commonJsModuleIndicator&&(a.commonJsModuleIndicator=e.commonJsModuleIndicator),void 0!==e.identifiers&&(a.identifiers=e.identifiers),void 0!==e.nodeCount&&(a.nodeCount=e.nodeCount),void 0!==e.identifierCount&&(a.identifierCount=e.identifierCount),void 0!==e.symbolCount&&(a.symbolCount=e.symbolCount),void 0!==e.parseDiagnostics&&(a.parseDiagnostics=e.parseDiagnostics),void 0!==e.bindDiagnostics&&(a.bindDiagnostics=e.bindDiagnostics),void 0!==e.lineMap&&(a.lineMap=e.lineMap),void 0!==e.classifiableNames&&(a.classifiableNames=e.classifiableNames),void 0!==e.resolvedModules&&(a.resolvedModules=e.resolvedModules),void 0!==e.resolvedTypeReferenceDirectiveNames&&(a.resolvedTypeReferenceDirectiveNames=e.resolvedTypeReferenceDirectiveNames),void 0!==e.imports&&(a.imports=e.imports),void 0!==e.moduleAugmentations&&(a.moduleAugmentations=e.moduleAugmentations),n(a,e)}return e},e.getMutableClone=function(e){var t=i(e);return t.pos=e.pos,t.end=e.end,t.parent=e.parent,t},e.createNotEmittedStatement=function(e){var n=t(287);return n.original=e,Et(n,e),n},e.createEndOfDeclarationMarker=function(e){var n=t(291);return n.emitNode={},n.original=e,n},e.createMergeDeclarationMarker=function(e){var n=t(290);return n.emitNode={},n.original=e,n},e.createPartiallyEmittedExpression=bt,e.updatePartiallyEmittedExpression=function(e,t){return e.expression!==t?n(bt(t,e.original),e):e},e.createCommaList=kt,e.updateCommaList=function(e,t){return e.elements!==t?n(kt(t),e):e},e.createBundle=St,e.updateBundle=function(e,t){return e.sourceFiles!==t?St(t):e},e.createImmediatelyInvokedFunctionExpression=function(e,t,n){return Q(ee(void 0,void 0,void 0,void 0,t?[t]:[],void 0,ve(e,!0)),void 0,n?[n]:[])},e.createImmediatelyInvokedArrowFunction=function(e,t,n){return Q(te(void 0,void 0,t?[t]:[],void 0,void 0,ve(e,!0)),void 0,n?[n]:[])},e.createComma=function(e,t){return ce(e,26,t)},e.createLessThan=function(e,t){return ce(e,27,t)},e.createAssignment=function(e,t){return ce(e,58,t)},e.createStrictEquality=function(e,t){return ce(e,34,t)},e.createStrictInequality=function(e,t){return ce(e,35,t)},e.createAdd=function(e,t){return ce(e,37,t)},e.createSubtract=function(e,t){return ce(e,38,t)},e.createPostfixIncrement=function(e){return se(e,43)},e.createLogicalAnd=function(e,t){return ce(e,53,t)},e.createLogicalOr=function(e,t){return ce(e,54,t)},e.createLogicalNot=function(e){return oe(51,e)},e.createVoidZero=function(){return ie(a(0))},e.createExportDefault=function(e){return $e(void 0,void 0,!1,e)},e.createExternalModuleExport=function(e){return et(void 0,void 0,tt([nt(void 0,e)]))},e.disposeEmitNodes=function(t){var n=(t=e.getSourceFileOfNode(e.getParseTreeNode(t)))&&t.emitNode,r=n&&n.annotatedNodes;if(r)for(var i=0,a=r;i<a.length;i++){a[i].emitNode=void 0}},e.getOrCreateEmitNode=Tt,e.setTextRange=Et,e.setEmitFlags=Nt,e.addEmitFlags=function(e,t){var n=Tt(e);return n.flags=n.flags|t,e},e.getSourceMapRange=function(e){var t=e.emitNode;return t&&t.sourceMapRange||e},e.setSourceMapRange=function(e,t){return Tt(e).sourceMapRange=t,e},e.createSourceMapSource=function(t,n,r){return new(u||(u=e.objectAllocator.getSourceMapSourceConstructor()))(t,n,r)},e.getTokenSourceMapRange=function(e,t){var n=e.emitNode,r=n&&n.tokenSourceMapRanges;return r&&r[t]},e.setTokenSourceMapRange=function(e,t,n){var r=Tt(e);return(r.tokenSourceMapRanges||(r.tokenSourceMapRanges=[]))[t]=n,e},e.getCommentRange=function(e){var t=e.emitNode;return t&&t.commentRange||e},e.setCommentRange=function(e,t){return Tt(e).commentRange=t,e},e.getSyntheticLeadingComments=At,e.setSyntheticLeadingComments=wt,e.addSyntheticLeadingComment=function(t,n,r,i){return wt(t,e.append(At(t),{kind:n,pos:-1,end:-1,hasTrailingNewLine:i,text:r}))},e.getSyntheticTrailingComments=Pt,e.setSyntheticTrailingComments=Ft,e.addSyntheticTrailingComment=function(t,n,r,i){return Ft(t,e.append(Pt(t),{kind:n,pos:-1,end:-1,hasTrailingNewLine:i,text:r}))},e.getConstantValue=function(e){var t=e.emitNode;return t&&t.constantValue},e.setConstantValue=function(e,t){return Tt(e).constantValue=t,e},e.addEmitHelper=function(t,n){var r=Tt(t);return r.helpers=e.append(r.helpers,n),t},e.addEmitHelpers=function(t,n){if(e.some(n))for(var r=Tt(t),i=0,a=n;i<a.length;i++){var o=a[i];r.helpers=e.appendIfUnique(r.helpers,o)}return t},e.removeEmitHelper=function(t,n){var r=t.emitNode;if(r){var i=r.helpers;if(i)return e.orderedRemoveItem(i,n)}return!1},e.getEmitHelpers=function(e){var t=e.emitNode;return t&&t.helpers},e.moveEmitHelpers=function(t,n,r){var i=t.emitNode,a=i&&i.helpers;if(e.some(a)){for(var o=Tt(n),s=0,c=0;c<a.length;c++){var u=a[c];r(u)?(s++,o.helpers=e.appendIfUnique(o.helpers,u)):s>0&&(a[c-s]=u)}s>0&&(a.length-=s)}},e.compareEmitHelpers=function(t,n){return t===n||t.priority===n.priority?0:void 0===t.priority?1:void 0===n.priority?-1:e.compareValues(t.priority,n.priority)},e.setOriginalNode=Ot}(ts||(ts={})),function(e){function t(t,n,r){if(e.isComputedPropertyName(n))return e.setTextRange(e.createElementAccess(t,n.expression),r);var i=e.setTextRange(e.isIdentifier(n)?e.createPropertyAccess(t,n):e.createElementAccess(t,n),n);return e.getOrCreateEmitNode(i).flags|=64,i}function n(t,n){var r=e.createIdentifier(t||"React");return r.flags&=-9,r.parent=e.getParseTreeNode(n),r}function r(t,i){if(e.isQualifiedName(t)){var a=r(t.left,i),o=e.createIdentifier(e.idText(t.right));return o.escapedText=t.right.escapedText,e.createPropertyAccess(a,o)}return n(e.idText(t),i)}function i(t,i,a){return t?r(t,a):e.createPropertyAccess(n(i,a),"createElement")}function a(t){return e.setEmitFlags(e.createIdentifier(t),4098)}e.nullTransformationContext={enableEmitNotification:e.noop,enableSubstitution:e.noop,endLexicalEnvironment:function(){},getCompilerOptions:e.notImplemented,getEmitHost:e.notImplemented,getEmitResolver:e.notImplemented,hoistFunctionDeclaration:e.noop,hoistVariableDeclaration:e.noop,isEmitNotificationEnabled:e.notImplemented,isSubstitutionEnabled:e.notImplemented,onEmitNode:e.noop,onSubstituteNode:e.notImplemented,readEmitHelpers:e.notImplemented,requestEmitHelper:e.noop,resumeLexicalEnvironment:e.noop,startLexicalEnvironment:e.noop,suspendLexicalEnvironment:e.noop},e.createTypeCheck=function(t,n){return"undefined"===n?e.createStrictEquality(t,e.createVoidZero()):e.createStrictEquality(e.createTypeOf(t),e.createLiteral(n))},e.createMemberAccessForPropertyName=t,e.createFunctionCall=function(t,n,r,i){return e.setTextRange(e.createCall(e.createPropertyAccess(t,"call"),void 0,[n].concat(r)),i)},e.createFunctionApply=function(t,n,r,i){return e.setTextRange(e.createCall(e.createPropertyAccess(t,"apply"),void 0,[n,r]),i)},e.createArraySlice=function(t,n){var r=[];return void 0!==n&&r.push("number"==typeof n?e.createLiteral(n):n),e.createCall(e.createPropertyAccess(t,"slice"),void 0,r)},e.createArrayConcat=function(t,n){return e.createCall(e.createPropertyAccess(t,"concat"),void 0,n)},e.createMathPow=function(t,n,r){return e.setTextRange(e.createCall(e.createPropertyAccess(e.createIdentifier("Math"),"pow"),void 0,[t,n]),r)},e.createExpressionForJsxElement=function(t,n,r,a,o,s,c){var u=[r];if(a&&u.push(a),o&&o.length>0)if(a||u.push(e.createNull()),o.length>1)for(var _=0,l=o;_<l.length;_++){var d=l[_];d.startsOnNewLine=!0,u.push(d)}else u.push(o[0]);return e.setTextRange(e.createCall(i(t,n,s),void 0,u),c)},e.getHelperName=a;var o={name:"typescript:values",scoped:!1,text:'\n            var __values = (this && this.__values) || function (o) {\n                var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;\n                if (m) return m.call(o);\n                return {\n                    next: function () {\n                        if (o && i >= o.length) o = void 0;\n                        return { value: o && o[i++], done: !o };\n                    }\n                };\n            };\n        '};e.createValuesHelper=function(t,n,r){return t.requestEmitHelper(o),e.setTextRange(e.createCall(a("__values"),void 0,[n]),r)};var s={name:"typescript:read",scoped:!1,text:'\n            var __read = (this && this.__read) || function (o, n) {\n                var m = typeof Symbol === "function" && o[Symbol.iterator];\n                if (!m) return o;\n                var i = m.call(o), r, ar = [], e;\n                try {\n                    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);\n                }\n                catch (error) { e = { error: error }; }\n                finally {\n                    try {\n                        if (r && !r.done && (m = i["return"])) m.call(i);\n                    }\n                    finally { if (e) throw e.error; }\n                }\n                return ar;\n            };\n        '};e.createReadHelper=function(t,n,r,i){return t.requestEmitHelper(s),e.setTextRange(e.createCall(a("__read"),void 0,void 0!==r?[n,e.createLiteral(r)]:[n]),i)};var c={name:"typescript:spread",scoped:!1,text:"\n            var __spread = (this && this.__spread) || function () {\n                for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));\n                return ar;\n            };"};function u(e,t){var n=D(e);switch(n.kind){case 71:return t;case 99:case 8:case 9:return!1;case 177:return 0!==n.elements.length;case 178:return n.properties.length>0;default:return!0}}function _(t){return e.isIdentifier(t)?e.createLiteral(t):e.isComputedPropertyName(t)?e.getMutableClone(t.expression):e.getMutableClone(t)}function l(e,t,n){return d(e,t,n,8192)}function d(t,n,r,i){var a=e.getNameOfDeclaration(t);if(a&&e.isIdentifier(a)&&!e.isGeneratedIdentifier(a)){var o=e.getMutableClone(a);return i|=e.getEmitFlags(a),r||(i|=48),n||(i|=1536),i&&e.setEmitFlags(o,i),o}return e.getGeneratedNameForNode(t)}function p(t,n,r,i){var a,o=e.createPropertyAccess(t,e.nodeIsSynthesized(n)?n:e.getSynthesizedClone(n));return e.setTextRange(o,n),i||(a|=48),r||(a|=1536),a&&e.setEmitFlags(o,a),o}function f(t){return e.isStringLiteral(t.expression)&&"use strict"===t.expression.text}function m(t,n,r){e.Debug.assert(0===t.length,"Prologue directives should be at the first statement in the target statements array");for(var i=!1,a=0,o=n.length;a<o;){var s=n[a];if(!e.isPrologueDirective(s))break;f(s)&&(i=!0),t.push(s),a++}return r&&!i&&t.push(E(e.createStatement(e.createLiteral("use strict")))),a}function g(t,n,r,i){for(var a=n.length;r<a;){var o=n[r];if(!(1048576&e.getEmitFlags(o)))break;t.push(i?e.visitNode(o,i,e.isStatement):o),r++}return r}function y(t){if(t=e.skipPartiallyEmittedExpressions(t),e.isLiteralKind(t.kind))return t.kind;if(194===t.kind&&37===t.operatorToken.kind){if(void 0!==t.cachedLiteralKind)return t.cachedLiteralKind;var n=y(t.left),r=e.isLiteralKind(n)&&n===y(t.right)?n:0;return t.cachedLiteralKind=r,r}return 0}function h(t){var n=e.skipPartiallyEmittedExpressions(t);return e.isLeftHandSideExpression(n)&&(182!==n.kind||n.arguments)?t:e.setTextRange(e.createParen(t),t)}function v(t){var n=e.skipPartiallyEmittedExpressions(t);return e.getExpressionPrecedence(n)>e.getOperatorPrecedence(194,26)?t:e.setTextRange(e.createParen(t),t)}function b(t){switch(t.kind){case 166:case 167:case 160:case 161:return e.createParenthesizedType(t)}return t}function x(e,t){for(;;){switch(e.kind){case 193:e=e.operand;continue;case 194:e=e.left;continue;case 195:e=e.condition;continue;case 181:if(t)return e;case 180:case 179:case 288:e=e.expression;continue}return e}}function k(e,t){switch(void 0===t&&(t=7),e.kind){case 185:return 0!=(1&t);case 184:case 202:case 203:return 0!=(2&t);case 288:return 0!=(4&t)}return!1}function S(t,n){var r;void 0===n&&(n=7);do{r=t,1&n&&(t=D(t)),2&n&&(t=C(t)),4&n&&(t=e.skipPartiallyEmittedExpressions(t))}while(r!==t);return t}function D(e){for(;185===e.kind;)e=e.expression;return e}function C(t){for(;e.isAssertionExpression(t)||203===t.kind;)t=t.expression;return t}function T(t,n,r){return void 0===r&&(r=7),t&&k(t,r)&&(!(185===(i=t).kind&&e.nodeIsSynthesized(i)&&e.nodeIsSynthesized(e.getSourceMapRange(i))&&e.nodeIsSynthesized(e.getCommentRange(i)))||e.some(e.getSyntheticLeadingComments(i))||e.some(e.getSyntheticTrailingComments(i)))?function(t,n){switch(t.kind){case 185:return e.updateParen(t,n);case 184:return e.updateTypeAssertion(t,t.type,n);case 202:return e.updateAsExpression(t,n,t.type);case 203:return e.updateNonNullExpression(t,n);case 288:return e.updatePartiallyEmittedExpression(t,n)}}(t,T(t.expression,n)):n;var i}function E(e){return e.startsOnNewLine=!0,e}function N(t){var n=e.getOriginalNode(t,e.isSourceFile),r=n&&n.emitNode;return r&&r.externalHelpersModuleName}function A(t,n,r){if(t)return t.moduleName?e.createLiteral(t.moduleName):t.isDeclarationFile||!r.out&&!r.outFile?void 0:e.createLiteral(e.getExternalModuleNameFromPath(n,t.fileName))}function w(t){if(e.isDeclarationBindingElement(t))return t.name;if(!e.isObjectLiteralElementLike(t))return e.isAssignmentExpression(t,!0)?w(t.left):e.isSpreadElement(t)?w(t.expression):t;switch(t.kind){case 261:return w(t.initializer);case 262:return t.name;case 263:return w(t.expression)}}function P(t){if(e.isBindingElement(t)){if(t.dotDotDotToken)return e.Debug.assertNode(t.name,e.isIdentifier),e.setOriginalNode(e.setTextRange(e.createSpread(t.name),t),t);var n=L(t.name);return t.initializer?e.setOriginalNode(e.setTextRange(e.createAssignment(n,t.initializer),t),t):n}return e.Debug.assertNode(t,e.isExpression),t}function F(t){if(e.isBindingElement(t)){if(t.dotDotDotToken)return e.Debug.assertNode(t.name,e.isIdentifier),e.setOriginalNode(e.setTextRange(e.createSpreadAssignment(t.name),t),t);if(t.propertyName){var n=L(t.name);return e.setOriginalNode(e.setTextRange(e.createPropertyAssignment(t.propertyName,t.initializer?e.createAssignment(n,t.initializer):n),t),t)}return e.Debug.assertNode(t.name,e.isIdentifier),e.setOriginalNode(e.setTextRange(e.createShorthandPropertyAssignment(t.name,t.initializer),t),t)}return e.Debug.assertNode(t,e.isObjectLiteralElementLike),t}function O(e){switch(e.kind){case 175:case 177:return R(e);case 174:case 178:return I(e)}}function I(t){return e.isObjectBindingPattern(t)?e.setOriginalNode(e.setTextRange(e.createObjectLiteral(e.map(t.elements,F)),t),t):(e.Debug.assertNode(t,e.isObjectLiteralExpression),t)}function R(t){return e.isArrayBindingPattern(t)?e.setOriginalNode(e.setTextRange(e.createArrayLiteral(e.map(t.elements,P)),t),t):(e.Debug.assertNode(t,e.isArrayLiteralExpression),t)}function L(t){return e.isBindingPattern(t)?O(t):(e.Debug.assertNode(t,e.isExpression),t)}e.createSpreadHelper=function(t,n,r){return t.requestEmitHelper(s),t.requestEmitHelper(c),e.setTextRange(e.createCall(a("__spread"),void 0,n),r)},e.createForOfBindingStatement=function(t,n){if(e.isVariableDeclarationList(t)){var r=e.firstOrUndefined(t.declarations),i=e.updateVariableDeclaration(r,r.name,void 0,n);return e.setTextRange(e.createVariableStatement(void 0,e.updateVariableDeclarationList(t,[i])),t)}var a=e.setTextRange(e.createAssignment(t,n),t);return e.setTextRange(e.createStatement(a),t)},e.insertLeadingStatement=function(t,n){return e.isBlock(t)?e.updateBlock(t,e.setTextRange(e.createNodeArray([n].concat(t.statements)),t.statements)):e.createBlock(e.createNodeArray([t,n]),!0)},e.restoreEnclosingLabel=function t(n,r,i){if(!r)return n;var a=e.updateLabel(r,r.label,222===r.statement.kind?t(n,r.statement):n);return i&&i(r),a},e.createCallBinding=function(t,n,r,i){var a,o,s=S(t,7);if(e.isSuperProperty(s))a=e.createThis(),o=s;else if(97===s.kind)a=e.createThis(),o=r<2?e.setTextRange(e.createIdentifier("_super"),s):s;else if(4096&e.getEmitFlags(s))a=e.createVoidZero(),o=h(s);else switch(s.kind){case 179:u(s.expression,i)?(a=e.createTempVariable(n),o=e.createPropertyAccess(e.setTextRange(e.createAssignment(a,s.expression),s.expression),s.name),e.setTextRange(o,s)):(a=s.expression,o=s);break;case 180:u(s.expression,i)?(a=e.createTempVariable(n),o=e.createElementAccess(e.setTextRange(e.createAssignment(a,s.expression),s.expression),s.argumentExpression),e.setTextRange(o,s)):(a=s.expression,o=s);break;default:a=e.createVoidZero(),o=h(t)}return{target:o,thisArg:a}},e.inlineExpressions=function(t){return t.length>10?e.createCommaList(t):e.reduceLeft(t,e.createComma)},e.createExpressionFromEntityName=function t(n){if(e.isQualifiedName(n)){var r=t(n.left),i=e.getMutableClone(n.right);return e.setTextRange(e.createPropertyAccess(r,i),n)}return e.getMutableClone(n)},e.createExpressionForPropertyName=_,e.createExpressionForObjectLiteralElementLike=function(n,r,i){switch(r.kind){case 153:case 154:return function(t,n,r,i){var a=e.getAllAccessorDeclarations(t,n),o=a.firstAccessor,s=a.getAccessor,c=a.setAccessor;if(n===o){var u=[];if(s){var l=e.createFunctionExpression(s.modifiers,void 0,void 0,void 0,s.parameters,void 0,s.body);e.setTextRange(l,s),e.setOriginalNode(l,s);var d=e.createPropertyAssignment("get",l);u.push(d)}if(c){var p=e.createFunctionExpression(c.modifiers,void 0,void 0,void 0,c.parameters,void 0,c.body);e.setTextRange(p,c),e.setOriginalNode(p,c);var f=e.createPropertyAssignment("set",p);u.push(f)}u.push(e.createPropertyAssignment("enumerable",e.createTrue())),u.push(e.createPropertyAssignment("configurable",e.createTrue()));var m=e.setTextRange(e.createCall(e.createPropertyAccess(e.createIdentifier("Object"),"defineProperty"),void 0,[r,_(n.name),e.createObjectLiteral(u,i)]),o);return e.aggregateTransformFlags(m)}return}(n.properties,r,i,n.multiLine);case 261:return function(n,r){return e.aggregateTransformFlags(e.setOriginalNode(e.setTextRange(e.createAssignment(t(r,n.name,n.name),n.initializer),n),n))}(r,i);case 262:return function(n,r){return e.aggregateTransformFlags(e.setOriginalNode(e.setTextRange(e.createAssignment(t(r,n.name,n.name),e.getSynthesizedClone(n.name)),n),n))}(r,i);case 151:return function(n,r){return e.aggregateTransformFlags(e.setOriginalNode(e.setTextRange(e.createAssignment(t(r,n.name,n.name),e.setOriginalNode(e.setTextRange(e.createFunctionExpression(n.modifiers,n.asteriskToken,void 0,void 0,n.parameters,void 0,n.body),n),n)),n),n))}(r,i)}},e.getInternalName=function(e,t,n){return d(e,t,n,49152)},e.isInternalName=function(t){return 0!=(32768&e.getEmitFlags(t))},e.getLocalName=function(e,t,n){return d(e,t,n,16384)},e.isLocalName=function(t){return 0!=(16384&e.getEmitFlags(t))},e.getExportName=l,e.isExportName=function(t){return 0!=(8192&e.getEmitFlags(t))},e.getDeclarationName=function(e,t,n){return d(e,t,n)},e.getExternalModuleOrNamespaceExportName=function(t,n,r,i){return t&&e.hasModifier(n,1)?p(t,d(n),r,i):l(n,r,i)},e.getNamespaceMemberName=p,e.convertToFunctionBody=function(t,n){return e.isBlock(t)?t:e.setTextRange(e.createBlock([e.setTextRange(e.createReturn(t),t)],n),t)},e.convertFunctionDeclarationToExpression=function(t){e.Debug.assert(!!t.body);var n=e.createFunctionExpression(t.modifiers,t.asteriskToken,t.name,t.typeParameters,t.parameters,t.type,t.body);return e.setOriginalNode(n,t),e.setTextRange(n,t),t.startsOnNewLine&&(n.startsOnNewLine=!0),e.aggregateTransformFlags(n),n},e.addPrologue=function(e,t,n,r){return g(e,t,m(e,t,n),r)},e.addStandardPrologue=m,e.addCustomPrologue=g,e.startsWithUseStrict=function(t){var n=e.firstOrUndefined(t);return void 0!==n&&e.isPrologueDirective(n)&&f(n)},e.ensureUseStrict=function(t){for(var n=!1,r=0,i=t;r<i.length;r++){var a=i[r];if(!e.isPrologueDirective(a))break;if(f(a)){n=!0;break}}return n?t:e.setTextRange(e.createNodeArray([E(e.createStatement(e.createLiteral("use strict")))].concat(t)),t)},e.parenthesizeBinaryOperand=function(t,n,r,i){return 185===e.skipPartiallyEmittedExpressions(n).kind?n:function(t,n,r,i){var a=e.getOperatorPrecedence(194,t),o=e.getOperatorAssociativity(194,t),s=e.skipPartiallyEmittedExpressions(n),c=e.getExpressionPrecedence(s);switch(e.compareValues(c,a)){case-1:return!(!r&&1===o&&197===n.kind);case 1:return!1;case 0:if(r)return 1===o;if(e.isBinaryExpression(s)&&s.operatorToken.kind===t){if(function(e){return 39===e||49===e||48===e||50===e}(t))return!1;if(37===t){var u=i?y(i):0;if(e.isLiteralKind(u)&&u===y(s))return!1}}return 0===e.getExpressionAssociativity(s)}}(t,n,r,i)?e.createParen(n):n},e.parenthesizeForConditionalHead=function(t){var n=e.getOperatorPrecedence(195,55),r=e.skipPartiallyEmittedExpressions(t),i=e.getExpressionPrecedence(r);return-1===e.compareValues(i,n)?e.createParen(t):t},e.parenthesizeSubexpressionOfConditionalExpression=function(t){return 194===t.kind&&26===t.operatorToken.kind?e.createParen(t):t},e.parenthesizeForNew=function(t){var n=x(t,!0);switch(n.kind){case 181:return e.createParen(t);case 182:return n.arguments?t:e.createParen(t)}return h(t)},e.parenthesizeForAccess=h,e.parenthesizePostfixOperand=function(t){return e.isLeftHandSideExpression(t)?t:e.setTextRange(e.createParen(t),t)},e.parenthesizePrefixOperand=function(t){return e.isUnaryExpression(t)?t:e.setTextRange(e.createParen(t),t)},e.parenthesizeListElements=function(t){for(var n,r=0;r<t.length;r++){var i=v(t[r]);void 0===n&&i===t[r]||(void 0===n&&(n=t.slice(0,r)),n.push(i))}return void 0!==n?e.setTextRange(e.createNodeArray(n,t.hasTrailingComma),t):t},e.parenthesizeExpressionForList=v,e.parenthesizeExpressionForExpressionStatement=function(t){var n=e.skipPartiallyEmittedExpressions(t);if(e.isCallExpression(n)){var r=n.expression,i=e.skipPartiallyEmittedExpressions(r).kind;if(186===i||187===i){var a=e.getMutableClone(n);return a.expression=e.setTextRange(e.createParen(r),r),T(t,a,4)}}var o=x(n,!1).kind;return 178===o||186===o?e.setTextRange(e.createParen(t),t):t},e.parenthesizeElementTypeMember=b,e.parenthesizeArrayTypeMember=function(t){switch(t.kind){case 162:case 170:return e.createParenthesizedType(t)}return b(t)},e.parenthesizeElementTypeMembers=function(t){return e.createNodeArray(e.sameMap(t,b))},e.parenthesizeTypeParameters=function(t){if(e.some(t)){for(var n=[],r=0;r<t.length;++r){var i=t[r];n.push(0===r&&e.isFunctionOrConstructorTypeNode(i)&&i.typeParameters?e.createParenthesizedType(i):i)}return e.createNodeArray(n)}},e.parenthesizeConciseBody=function(t){return e.isBlock(t)||178!==x(t,!1).kind?t:e.setTextRange(e.createParen(t),t)},function(e){e[e.Parentheses=1]="Parentheses",e[e.Assertions=2]="Assertions",e[e.PartiallyEmittedExpressions=4]="PartiallyEmittedExpressions",e[e.All=7]="All"}(e.OuterExpressionKinds||(e.OuterExpressionKinds={})),e.isOuterExpression=k,e.skipOuterExpressions=S,e.skipParentheses=D,e.skipAssertions=C,e.recreateOuterExpressions=T,e.startOnNewLine=E,e.getExternalHelpersModuleName=N,e.getOrCreateExternalHelpersModuleNameIfNeeded=function(t,n,r){if(n.importHelpers&&e.isEffectiveExternalModule(t,n)){var i=N(t);if(i)return i;var a=e.getEmitModuleKind(n),o=r&&a!==e.ModuleKind.System&&a!==e.ModuleKind.ES2015&&a!==e.ModuleKind.ESNext;if(!o){var s=e.getEmitHelpers(t);if(s)for(var c=0,u=s;c<u.length;c++){if(!u[c].scoped){o=!0;break}}}if(o){var _=e.getOriginalNode(t,e.isSourceFile),l=e.getOrCreateEmitNode(_);return l.externalHelpersModuleName||(l.externalHelpersModuleName=e.createUniqueName(e.externalHelpersModuleNameText))}}},e.getLocalNameForExternalImport=function(t,n){var r=e.getNamespaceDeclarationNode(t);if(r&&!e.isDefaultImport(t)){var i=r.name;return e.isGeneratedIdentifier(i)?i:e.createIdentifier(e.getSourceTextOfNodeFromSourceFile(n,r.name))}return 238===t.kind&&t.importClause||244===t.kind&&t.moduleSpecifier?e.getGeneratedNameForNode(t):void 0},e.getExternalModuleNameLiteral=function(t,n,r,i,a){var o=e.getExternalModuleName(t);if(9===o.kind)return function(e,t,n,r){return A(n.getExternalModuleFileFromDeclaration(e),t,r)}(t,r,i,a)||function(t,n){var r=n.renamedDependencies&&n.renamedDependencies.get(t.text);return r&&e.createLiteral(r)}(o,n)||e.getSynthesizedClone(o)},e.tryGetModuleNameFromFile=A,e.getInitializerOfBindingOrAssignmentElement=function t(n){return e.isDeclarationBindingElement(n)?n.initializer:e.isPropertyAssignment(n)?e.isAssignmentExpression(n.initializer,!0)?n.initializer.right:void 0:e.isShorthandPropertyAssignment(n)?n.objectAssignmentInitializer:e.isAssignmentExpression(n,!0)?n.right:e.isSpreadElement(n)?t(n.expression):void 0},e.getTargetOfBindingOrAssignmentElement=w,e.getRestIndicatorOfBindingOrAssignmentElement=function(e){switch(e.kind){case 146:case 176:return e.dotDotDotToken;case 198:case 263:return e}},e.getPropertyNameOfBindingOrAssignmentElement=function(t){switch(t.kind){case 176:if(t.propertyName){var n=t.propertyName;return e.isComputedPropertyName(n)&&e.isStringOrNumericLiteral(n.expression)?n.expression:n}break;case 261:if(t.name){n=t.name;return e.isComputedPropertyName(n)&&e.isStringOrNumericLiteral(n.expression)?n.expression:n}break;case 263:return t.name}var r=w(t);if(r&&e.isPropertyName(r))return e.isComputedPropertyName(r)&&e.isStringOrNumericLiteral(r.expression)?r.expression:r;e.Debug.fail("Invalid property name for binding element.")},e.getElementsOfBindingOrAssignmentPattern=function(e){switch(e.kind){case 174:case 175:case 177:return e.elements;case 178:return e.properties}},e.convertToArrayAssignmentElement=P,e.convertToObjectAssignmentElement=F,e.convertToAssignmentPattern=O,e.convertToObjectAssignmentPattern=I,e.convertToArrayAssignmentPattern=R,e.convertToAssignmentElementTarget=L}(ts||(ts={})),function(e){function t(t,n,r,i){if(void 0===t||void 0===n)return t;e.aggregateTransformFlags(t);var a,s=n(t);return s===t?t:void 0!==s?(a=e.isArray(s)?(i||o)(s):s,e.Debug.assertNode(a,r),e.aggregateTransformFlags(a),a):void 0}function n(t,n,r,i,a){if(void 0===t||void 0===n)return t;var o,s=t.length;(void 0===i||i<0)&&(i=0),(void 0===a||a>s-i)&&(a=s-i),(i>0||a<s)&&(o=e.createNodeArray([],t.hasTrailingComma&&i+a===s));for(var c=0;c<a;c++){var u=t[c+i];e.aggregateTransformFlags(u);var _=void 0!==u?n(u):void 0;if((void 0!==o||void 0===_||_!==u)&&(void 0===o&&(o=e.createNodeArray(t.slice(0,c),t.hasTrailingComma),e.setTextRange(o,t)),_))if(e.isArray(_))for(var l=0,d=_;l<d.length;l++){var p=d[l];e.Debug.assertNode(p,r),e.aggregateTransformFlags(p),o.push(p)}else e.Debug.assertNode(_,r),e.aggregateTransformFlags(_),o.push(_)}return o||t}function r(t,r,i,a,o){i.startLexicalEnvironment(),t=n(t,r,e.isStatement,a),o&&!e.startsWithUseStrict(t)&&(t=e.setTextRange(e.createNodeArray([e.createStatement(e.createLiteral("use strict"))].concat(t)),t));var s=i.endLexicalEnvironment();return e.setTextRange(e.createNodeArray(e.concatenate(t,s)),t)}function i(t,r,i,a){void 0===a&&(a=n),i.startLexicalEnvironment();var o=a(t,r,e.isParameterDeclaration);return i.suspendLexicalEnvironment(),o}function a(n,r,i){i.resumeLexicalEnvironment();var a=t(n,r,e.isConciseBody),o=i.endLexicalEnvironment();if(e.some(o)){var s=e.convertToFunctionBody(a),c=e.mergeLexicalEnvironment(s.statements,o);return e.updateBlock(s,c)}return a}function o(t){return e.Debug.assert(t.length<=1,"Too many nodes written to output."),e.singleOrUndefined(t)}e.visitNode=t,e.visitNodes=n,e.visitLexicalEnvironment=r,e.visitParameterList=i,e.visitFunctionBody=a,e.visitEachChild=function(o,s,c,u,_){if(void 0===u&&(u=n),void 0!==o){var l=o.kind;if(l>0&&l<=142||169===l)return o;switch(l){case 71:return e.updateIdentifier(o,u(o.typeArguments,s,e.isTypeNode));case 143:return e.updateQualifiedName(o,t(o.left,s,e.isEntityName),t(o.right,s,e.isIdentifier));case 144:return e.updateComputedPropertyName(o,t(o.expression,s,e.isExpression));case 145:return e.updateTypeParameterDeclaration(o,t(o.name,s,e.isIdentifier),t(o.constraint,s,e.isTypeNode),t(o.default,s,e.isTypeNode));case 146:return e.updateParameter(o,u(o.decorators,s,e.isDecorator),u(o.modifiers,s,e.isModifier),t(o.dotDotDotToken,_,e.isToken),t(o.name,s,e.isBindingName),t(o.questionToken,_,e.isToken),t(o.type,s,e.isTypeNode),t(o.initializer,s,e.isExpression));case 147:return e.updateDecorator(o,t(o.expression,s,e.isExpression));case 148:return e.updatePropertySignature(o,u(o.modifiers,s,e.isToken),t(o.name,s,e.isPropertyName),t(o.questionToken,_,e.isToken),t(o.type,s,e.isTypeNode),t(o.initializer,s,e.isExpression));case 149:return e.updateProperty(o,u(o.decorators,s,e.isDecorator),u(o.modifiers,s,e.isModifier),t(o.name,s,e.isPropertyName),t(o.questionToken,_,e.isToken),t(o.type,s,e.isTypeNode),t(o.initializer,s,e.isExpression));case 150:return e.updateMethodSignature(o,u(o.typeParameters,s,e.isTypeParameterDeclaration),u(o.parameters,s,e.isParameterDeclaration),t(o.type,s,e.isTypeNode),t(o.name,s,e.isPropertyName),t(o.questionToken,_,e.isToken));case 151:return e.updateMethod(o,u(o.decorators,s,e.isDecorator),u(o.modifiers,s,e.isModifier),t(o.asteriskToken,_,e.isToken),t(o.name,s,e.isPropertyName),t(o.questionToken,_,e.isToken),u(o.typeParameters,s,e.isTypeParameterDeclaration),i(o.parameters,s,c,u),t(o.type,s,e.isTypeNode),a(o.body,s,c));case 152:return e.updateConstructor(o,u(o.decorators,s,e.isDecorator),u(o.modifiers,s,e.isModifier),i(o.parameters,s,c,u),a(o.body,s,c));case 153:return e.updateGetAccessor(o,u(o.decorators,s,e.isDecorator),u(o.modifiers,s,e.isModifier),t(o.name,s,e.isPropertyName),i(o.parameters,s,c,u),t(o.type,s,e.isTypeNode),a(o.body,s,c));case 154:return e.updateSetAccessor(o,u(o.decorators,s,e.isDecorator),u(o.modifiers,s,e.isModifier),t(o.name,s,e.isPropertyName),i(o.parameters,s,c,u),a(o.body,s,c));case 155:return e.updateCallSignature(o,u(o.typeParameters,s,e.isTypeParameterDeclaration),u(o.parameters,s,e.isParameterDeclaration),t(o.type,s,e.isTypeNode));case 156:return e.updateConstructSignature(o,u(o.typeParameters,s,e.isTypeParameterDeclaration),u(o.parameters,s,e.isParameterDeclaration),t(o.type,s,e.isTypeNode));case 157:return e.updateIndexSignature(o,u(o.decorators,s,e.isDecorator),u(o.modifiers,s,e.isModifier),u(o.parameters,s,e.isParameterDeclaration),t(o.type,s,e.isTypeNode));case 158:return e.updateTypePredicateNode(o,t(o.parameterName,s),t(o.type,s,e.isTypeNode));case 159:return e.updateTypeReferenceNode(o,t(o.typeName,s,e.isEntityName),u(o.typeArguments,s,e.isTypeNode));case 160:return e.updateFunctionTypeNode(o,u(o.typeParameters,s,e.isTypeParameterDeclaration),u(o.parameters,s,e.isParameterDeclaration),t(o.type,s,e.isTypeNode));case 161:return e.updateConstructorTypeNode(o,u(o.typeParameters,s,e.isTypeParameterDeclaration),u(o.parameters,s,e.isParameterDeclaration),t(o.type,s,e.isTypeNode));case 162:return e.updateTypeQueryNode(o,t(o.exprName,s,e.isEntityName));case 163:return e.updateTypeLiteralNode(o,u(o.members,s,e.isTypeElement));case 164:return e.updateArrayTypeNode(o,t(o.elementType,s,e.isTypeNode));case 165:return e.updateTypleTypeNode(o,u(o.elementTypes,s,e.isTypeNode));case 166:return e.updateUnionTypeNode(o,u(o.types,s,e.isTypeNode));case 167:return e.updateIntersectionTypeNode(o,u(o.types,s,e.isTypeNode));case 168:return e.updateParenthesizedType(o,t(o.type,s,e.isTypeNode));case 170:return e.updateTypeOperatorNode(o,t(o.type,s,e.isTypeNode));case 171:return e.updateIndexedAccessTypeNode(o,t(o.objectType,s,e.isTypeNode),t(o.indexType,s,e.isTypeNode));case 172:return e.updateMappedTypeNode(o,t(o.readonlyToken,_,e.isToken),t(o.typeParameter,s,e.isTypeParameterDeclaration),t(o.questionToken,_,e.isToken),t(o.type,s,e.isTypeNode));case 173:return e.updateLiteralTypeNode(o,t(o.literal,s,e.isExpression));case 174:return e.updateObjectBindingPattern(o,u(o.elements,s,e.isBindingElement));case 175:return e.updateArrayBindingPattern(o,u(o.elements,s,e.isArrayBindingElement));case 176:return e.updateBindingElement(o,t(o.dotDotDotToken,_,e.isToken),t(o.propertyName,s,e.isPropertyName),t(o.name,s,e.isBindingName),t(o.initializer,s,e.isExpression));case 177:return e.updateArrayLiteral(o,u(o.elements,s,e.isExpression));case 178:return e.updateObjectLiteral(o,u(o.properties,s,e.isObjectLiteralElementLike));case 179:return e.updatePropertyAccess(o,t(o.expression,s,e.isExpression),t(o.name,s,e.isIdentifier));case 180:return e.updateElementAccess(o,t(o.expression,s,e.isExpression),t(o.argumentExpression,s,e.isExpression));case 181:return e.updateCall(o,t(o.expression,s,e.isExpression),u(o.typeArguments,s,e.isTypeNode),u(o.arguments,s,e.isExpression));case 182:return e.updateNew(o,t(o.expression,s,e.isExpression),u(o.typeArguments,s,e.isTypeNode),u(o.arguments,s,e.isExpression));case 183:return e.updateTaggedTemplate(o,t(o.tag,s,e.isExpression),t(o.template,s,e.isTemplateLiteral));case 184:return e.updateTypeAssertion(o,t(o.type,s,e.isTypeNode),t(o.expression,s,e.isExpression));case 185:return e.updateParen(o,t(o.expression,s,e.isExpression));case 186:return e.updateFunctionExpression(o,u(o.modifiers,s,e.isModifier),t(o.asteriskToken,_,e.isToken),t(o.name,s,e.isIdentifier),u(o.typeParameters,s,e.isTypeParameterDeclaration),i(o.parameters,s,c,u),t(o.type,s,e.isTypeNode),a(o.body,s,c));case 187:return e.updateArrowFunction(o,u(o.modifiers,s,e.isModifier),u(o.typeParameters,s,e.isTypeParameterDeclaration),i(o.parameters,s,c,u),t(o.type,s,e.isTypeNode),t(o.equalsGreaterThanToken,s,e.isToken),a(o.body,s,c));case 188:return e.updateDelete(o,t(o.expression,s,e.isExpression));case 189:return e.updateTypeOf(o,t(o.expression,s,e.isExpression));case 190:return e.updateVoid(o,t(o.expression,s,e.isExpression));case 191:return e.updateAwait(o,t(o.expression,s,e.isExpression));case 192:return e.updatePrefix(o,t(o.operand,s,e.isExpression));case 193:return e.updatePostfix(o,t(o.operand,s,e.isExpression));case 194:return e.updateBinary(o,t(o.left,s,e.isExpression),t(o.right,s,e.isExpression),t(o.operatorToken,s,e.isToken));case 195:return e.updateConditional(o,t(o.condition,s,e.isExpression),t(o.questionToken,s,e.isToken),t(o.whenTrue,s,e.isExpression),t(o.colonToken,s,e.isToken),t(o.whenFalse,s,e.isExpression));case 196:return e.updateTemplateExpression(o,t(o.head,s,e.isTemplateHead),u(o.templateSpans,s,e.isTemplateSpan));case 197:return e.updateYield(o,t(o.asteriskToken,_,e.isToken),t(o.expression,s,e.isExpression));case 198:return e.updateSpread(o,t(o.expression,s,e.isExpression));case 199:return e.updateClassExpression(o,u(o.modifiers,s,e.isModifier),t(o.name,s,e.isIdentifier),u(o.typeParameters,s,e.isTypeParameterDeclaration),u(o.heritageClauses,s,e.isHeritageClause),u(o.members,s,e.isClassElement));case 201:return e.updateExpressionWithTypeArguments(o,u(o.typeArguments,s,e.isTypeNode),t(o.expression,s,e.isExpression));case 202:return e.updateAsExpression(o,t(o.expression,s,e.isExpression),t(o.type,s,e.isTypeNode));case 203:return e.updateNonNullExpression(o,t(o.expression,s,e.isExpression));case 204:return e.updateMetaProperty(o,t(o.name,s,e.isIdentifier));case 205:return e.updateTemplateSpan(o,t(o.expression,s,e.isExpression),t(o.literal,s,e.isTemplateMiddleOrTemplateTail));case 207:return e.updateBlock(o,u(o.statements,s,e.isStatement));case 208:return e.updateVariableStatement(o,u(o.modifiers,s,e.isModifier),t(o.declarationList,s,e.isVariableDeclarationList));case 210:return e.updateStatement(o,t(o.expression,s,e.isExpression));case 211:return e.updateIf(o,t(o.expression,s,e.isExpression),t(o.thenStatement,s,e.isStatement,e.liftToBlock),t(o.elseStatement,s,e.isStatement,e.liftToBlock));case 212:return e.updateDo(o,t(o.statement,s,e.isStatement,e.liftToBlock),t(o.expression,s,e.isExpression));case 213:return e.updateWhile(o,t(o.expression,s,e.isExpression),t(o.statement,s,e.isStatement,e.liftToBlock));case 214:return e.updateFor(o,t(o.initializer,s,e.isForInitializer),t(o.condition,s,e.isExpression),t(o.incrementor,s,e.isExpression),t(o.statement,s,e.isStatement,e.liftToBlock));case 215:return e.updateForIn(o,t(o.initializer,s,e.isForInitializer),t(o.expression,s,e.isExpression),t(o.statement,s,e.isStatement,e.liftToBlock));case 216:return e.updateForOf(o,o.awaitModifier,t(o.initializer,s,e.isForInitializer),t(o.expression,s,e.isExpression),t(o.statement,s,e.isStatement,e.liftToBlock));case 217:return e.updateContinue(o,t(o.label,s,e.isIdentifier));case 218:return e.updateBreak(o,t(o.label,s,e.isIdentifier));case 219:return e.updateReturn(o,t(o.expression,s,e.isExpression));case 220:return e.updateWith(o,t(o.expression,s,e.isExpression),t(o.statement,s,e.isStatement,e.liftToBlock));case 221:return e.updateSwitch(o,t(o.expression,s,e.isExpression),t(o.caseBlock,s,e.isCaseBlock));case 222:return e.updateLabel(o,t(o.label,s,e.isIdentifier),t(o.statement,s,e.isStatement,e.liftToBlock));case 223:return e.updateThrow(o,t(o.expression,s,e.isExpression));case 224:return e.updateTry(o,t(o.tryBlock,s,e.isBlock),t(o.catchClause,s,e.isCatchClause),t(o.finallyBlock,s,e.isBlock));case 226:return e.updateVariableDeclaration(o,t(o.name,s,e.isBindingName),t(o.type,s,e.isTypeNode),t(o.initializer,s,e.isExpression));case 227:return e.updateVariableDeclarationList(o,u(o.declarations,s,e.isVariableDeclaration));case 228:return e.updateFunctionDeclaration(o,u(o.decorators,s,e.isDecorator),u(o.modifiers,s,e.isModifier),t(o.asteriskToken,_,e.isToken),t(o.name,s,e.isIdentifier),u(o.typeParameters,s,e.isTypeParameterDeclaration),i(o.parameters,s,c,u),t(o.type,s,e.isTypeNode),a(o.body,s,c));case 229:return e.updateClassDeclaration(o,u(o.decorators,s,e.isDecorator),u(o.modifiers,s,e.isModifier),t(o.name,s,e.isIdentifier),u(o.typeParameters,s,e.isTypeParameterDeclaration),u(o.heritageClauses,s,e.isHeritageClause),u(o.members,s,e.isClassElement));case 230:return e.updateInterfaceDeclaration(o,u(o.decorators,s,e.isDecorator),u(o.modifiers,s,e.isModifier),t(o.name,s,e.isIdentifier),u(o.typeParameters,s,e.isTypeParameterDeclaration),u(o.heritageClauses,s,e.isHeritageClause),u(o.members,s,e.isTypeElement));case 231:return e.updateTypeAliasDeclaration(o,u(o.decorators,s,e.isDecorator),u(o.modifiers,s,e.isModifier),t(o.name,s,e.isIdentifier),u(o.typeParameters,s,e.isTypeParameterDeclaration),t(o.type,s,e.isTypeNode));case 232:return e.updateEnumDeclaration(o,u(o.decorators,s,e.isDecorator),u(o.modifiers,s,e.isModifier),t(o.name,s,e.isIdentifier),u(o.members,s,e.isEnumMember));case 233:return e.updateModuleDeclaration(o,u(o.decorators,s,e.isDecorator),u(o.modifiers,s,e.isModifier),t(o.name,s,e.isIdentifier),t(o.body,s,e.isModuleBody));case 234:return e.updateModuleBlock(o,u(o.statements,s,e.isStatement));case 235:return e.updateCaseBlock(o,u(o.clauses,s,e.isCaseOrDefaultClause));case 236:return e.updateNamespaceExportDeclaration(o,t(o.name,s,e.isIdentifier));case 237:return e.updateImportEqualsDeclaration(o,u(o.decorators,s,e.isDecorator),u(o.modifiers,s,e.isModifier),t(o.name,s,e.isIdentifier),t(o.moduleReference,s,e.isModuleReference));case 238:return e.updateImportDeclaration(o,u(o.decorators,s,e.isDecorator),u(o.modifiers,s,e.isModifier),t(o.importClause,s,e.isImportClause),t(o.moduleSpecifier,s,e.isExpression));case 239:return e.updateImportClause(o,t(o.name,s,e.isIdentifier),t(o.namedBindings,s,e.isNamedImportBindings));case 240:return e.updateNamespaceImport(o,t(o.name,s,e.isIdentifier));case 241:return e.updateNamedImports(o,u(o.elements,s,e.isImportSpecifier));case 242:return e.updateImportSpecifier(o,t(o.propertyName,s,e.isIdentifier),t(o.name,s,e.isIdentifier));case 243:return e.updateExportAssignment(o,u(o.decorators,s,e.isDecorator),u(o.modifiers,s,e.isModifier),t(o.expression,s,e.isExpression));case 244:return e.updateExportDeclaration(o,u(o.decorators,s,e.isDecorator),u(o.modifiers,s,e.isModifier),t(o.exportClause,s,e.isNamedExports),t(o.moduleSpecifier,s,e.isExpression));case 245:return e.updateNamedExports(o,u(o.elements,s,e.isExportSpecifier));case 246:return e.updateExportSpecifier(o,t(o.propertyName,s,e.isIdentifier),t(o.name,s,e.isIdentifier));case 248:return e.updateExternalModuleReference(o,t(o.expression,s,e.isExpression));case 249:return e.updateJsxElement(o,t(o.openingElement,s,e.isJsxOpeningElement),u(o.children,s,e.isJsxChild),t(o.closingElement,s,e.isJsxClosingElement));case 250:return e.updateJsxSelfClosingElement(o,t(o.tagName,s,e.isJsxTagNameExpression),t(o.attributes,s,e.isJsxAttributes));case 251:return e.updateJsxOpeningElement(o,t(o.tagName,s,e.isJsxTagNameExpression),t(o.attributes,s,e.isJsxAttributes));case 252:return e.updateJsxClosingElement(o,t(o.tagName,s,e.isJsxTagNameExpression));case 253:return e.updateJsxAttribute(o,t(o.name,s,e.isIdentifier),t(o.initializer,s,e.isStringLiteralOrJsxExpression));case 254:return e.updateJsxAttributes(o,u(o.properties,s,e.isJsxAttributeLike));case 255:return e.updateJsxSpreadAttribute(o,t(o.expression,s,e.isExpression));case 256:return e.updateJsxExpression(o,t(o.expression,s,e.isExpression));case 257:return e.updateCaseClause(o,t(o.expression,s,e.isExpression),u(o.statements,s,e.isStatement));case 258:return e.updateDefaultClause(o,u(o.statements,s,e.isStatement));case 259:return e.updateHeritageClause(o,u(o.types,s,e.isExpressionWithTypeArguments));case 260:return e.updateCatchClause(o,t(o.variableDeclaration,s,e.isVariableDeclaration),t(o.block,s,e.isBlock));case 261:return e.updatePropertyAssignment(o,t(o.name,s,e.isPropertyName),t(o.initializer,s,e.isExpression));case 262:return e.updateShorthandPropertyAssignment(o,t(o.name,s,e.isIdentifier),t(o.objectAssignmentInitializer,s,e.isExpression));case 263:return e.updateSpreadAssignment(o,t(o.expression,s,e.isExpression));case 264:return e.updateEnumMember(o,t(o.name,s,e.isPropertyName),t(o.initializer,s,e.isExpression));case 265:return e.updateSourceFileNode(o,r(o.statements,s,c));case 288:return e.updatePartiallyEmittedExpression(o,t(o.expression,s,e.isExpression));case 289:return e.updateCommaList(o,u(o.elements,s,e.isExpression));default:return o}}}}(ts||(ts={})),function(e){function t(e,t,n){return e?t(n,e):n}function n(e,t,n){return e?t(n,e):n}function r(r,i,a,o){if(void 0===r)return i;var s=o?n:e.reduceLeft,c=o||a,u=r.kind;if(u>0&&u<=142)return i;if(u>=158&&u<=173)return i;var _=i;switch(r.kind){case 206:case 209:case 200:case 225:case 287:break;case 143:_=t(r.left,a,_),_=t(r.right,a,_);break;case 144:_=t(r.expression,a,_);break;case 146:_=s(r.decorators,c,_),_=s(r.modifiers,c,_),_=t(r.name,a,_),_=t(r.type,a,_),_=t(r.initializer,a,_);break;case 147:_=t(r.expression,a,_);break;case 148:_=s(r.modifiers,c,_),_=t(r.name,a,_),_=t(r.questionToken,a,_),_=t(r.type,a,_),_=t(r.initializer,a,_);break;case 149:_=s(r.decorators,c,_),_=s(r.modifiers,c,_),_=t(r.name,a,_),_=t(r.type,a,_),_=t(r.initializer,a,_);break;case 151:_=s(r.decorators,c,_),_=s(r.modifiers,c,_),_=t(r.name,a,_),_=s(r.typeParameters,c,_),_=s(r.parameters,c,_),_=t(r.type,a,_),_=t(r.body,a,_);break;case 152:_=s(r.modifiers,c,_),_=s(r.parameters,c,_),_=t(r.body,a,_);break;case 153:_=s(r.decorators,c,_),_=s(r.modifiers,c,_),_=t(r.name,a,_),_=s(r.parameters,c,_),_=t(r.type,a,_),_=t(r.body,a,_);break;case 154:_=s(r.decorators,c,_),_=s(r.modifiers,c,_),_=t(r.name,a,_),_=s(r.parameters,c,_),_=t(r.body,a,_);break;case 174:case 175:_=s(r.elements,c,_);break;case 176:_=t(r.propertyName,a,_),_=t(r.name,a,_),_=t(r.initializer,a,_);break;case 177:_=s(r.elements,c,_);break;case 178:_=s(r.properties,c,_);break;case 179:_=t(r.expression,a,_),_=t(r.name,a,_);break;case 180:_=t(r.expression,a,_),_=t(r.argumentExpression,a,_);break;case 181:case 182:_=t(r.expression,a,_),_=s(r.typeArguments,c,_),_=s(r.arguments,c,_);break;case 183:_=t(r.tag,a,_),_=t(r.template,a,_);break;case 184:_=t(r.type,a,_),_=t(r.expression,a,_);break;case 186:_=s(r.modifiers,c,_),_=t(r.name,a,_),_=s(r.typeParameters,c,_),_=s(r.parameters,c,_),_=t(r.type,a,_),_=t(r.body,a,_);break;case 187:_=s(r.modifiers,c,_),_=s(r.typeParameters,c,_),_=s(r.parameters,c,_),_=t(r.type,a,_),_=t(r.body,a,_);break;case 185:case 188:case 189:case 190:case 191:case 197:case 198:case 203:_=t(r.expression,a,_);break;case 192:case 193:_=t(r.operand,a,_);break;case 194:_=t(r.left,a,_),_=t(r.right,a,_);break;case 195:_=t(r.condition,a,_),_=t(r.whenTrue,a,_),_=t(r.whenFalse,a,_);break;case 196:_=t(r.head,a,_),_=s(r.templateSpans,c,_);break;case 199:_=s(r.modifiers,c,_),_=t(r.name,a,_),_=s(r.typeParameters,c,_),_=s(r.heritageClauses,c,_),_=s(r.members,c,_);break;case 201:_=t(r.expression,a,_),_=s(r.typeArguments,c,_);break;case 202:_=t(r.expression,a,_),_=t(r.type,a,_);break;case 205:_=t(r.expression,a,_),_=t(r.literal,a,_);break;case 207:_=s(r.statements,c,_);break;case 208:_=s(r.modifiers,c,_),_=t(r.declarationList,a,_);break;case 210:_=t(r.expression,a,_);break;case 211:_=t(r.expression,a,_),_=t(r.thenStatement,a,_),_=t(r.elseStatement,a,_);break;case 212:_=t(r.statement,a,_),_=t(r.expression,a,_);break;case 213:case 220:_=t(r.expression,a,_),_=t(r.statement,a,_);break;case 214:_=t(r.initializer,a,_),_=t(r.condition,a,_),_=t(r.incrementor,a,_),_=t(r.statement,a,_);break;case 215:case 216:_=t(r.initializer,a,_),_=t(r.expression,a,_),_=t(r.statement,a,_);break;case 219:case 223:_=t(r.expression,a,_);break;case 221:_=t(r.expression,a,_),_=t(r.caseBlock,a,_);break;case 222:_=t(r.label,a,_),_=t(r.statement,a,_);break;case 224:_=t(r.tryBlock,a,_),_=t(r.catchClause,a,_),_=t(r.finallyBlock,a,_);break;case 226:_=t(r.name,a,_),_=t(r.type,a,_),_=t(r.initializer,a,_);break;case 227:_=s(r.declarations,c,_);break;case 228:_=s(r.decorators,c,_),_=s(r.modifiers,c,_),_=t(r.name,a,_),_=s(r.typeParameters,c,_),_=s(r.parameters,c,_),_=t(r.type,a,_),_=t(r.body,a,_);break;case 229:_=s(r.decorators,c,_),_=s(r.modifiers,c,_),_=t(r.name,a,_),_=s(r.typeParameters,c,_),_=s(r.heritageClauses,c,_),_=s(r.members,c,_);break;case 232:_=s(r.decorators,c,_),_=s(r.modifiers,c,_),_=t(r.name,a,_),_=s(r.members,c,_);break;case 233:_=s(r.decorators,c,_),_=s(r.modifiers,c,_),_=t(r.name,a,_),_=t(r.body,a,_);break;case 234:_=s(r.statements,c,_);break;case 235:_=s(r.clauses,c,_);break;case 237:_=s(r.decorators,c,_),_=s(r.modifiers,c,_),_=t(r.name,a,_),_=t(r.moduleReference,a,_);break;case 238:_=s(r.decorators,c,_),_=s(r.modifiers,c,_),_=t(r.importClause,a,_),_=t(r.moduleSpecifier,a,_);break;case 239:_=t(r.name,a,_),_=t(r.namedBindings,a,_);break;case 240:_=t(r.name,a,_);break;case 241:case 245:_=s(r.elements,c,_);break;case 242:case 246:_=t(r.propertyName,a,_),_=t(r.name,a,_);break;case 243:_=e.reduceLeft(r.decorators,a,_),_=e.reduceLeft(r.modifiers,a,_),_=t(r.expression,a,_);break;case 244:_=e.reduceLeft(r.decorators,a,_),_=e.reduceLeft(r.modifiers,a,_),_=t(r.exportClause,a,_),_=t(r.moduleSpecifier,a,_);break;case 248:_=t(r.expression,a,_);break;case 249:_=t(r.openingElement,a,_),_=e.reduceLeft(r.children,a,_),_=t(r.closingElement,a,_);break;case 250:case 251:_=t(r.tagName,a,_),_=t(r.attributes,a,_);break;case 254:_=s(r.properties,c,_);break;case 252:_=t(r.tagName,a,_);break;case 253:_=t(r.name,a,_),_=t(r.initializer,a,_);break;case 255:case 256:_=t(r.expression,a,_);break;case 257:_=t(r.expression,a,_);case 258:_=s(r.statements,c,_);break;case 259:_=s(r.types,c,_);break;case 260:_=t(r.variableDeclaration,a,_),_=t(r.block,a,_);break;case 261:_=t(r.name,a,_),_=t(r.initializer,a,_);break;case 262:_=t(r.name,a,_),_=t(r.objectAssignmentInitializer,a,_);break;case 263:_=t(r.expression,a,_);break;case 264:_=t(r.name,a,_),_=t(r.initializer,a,_);break;case 265:_=s(r.statements,c,_);break;case 288:_=t(r.expression,a,_);break;case 289:_=s(r.elements,c,_)}return _}function i(t){if(void 0===t)return 0;if(536870912&t.transformFlags)return t.transformFlags&~e.getTransformFlagsSubtreeExclusions(t.kind);var n=function(t){if(e.hasModifier(t,2)||e.isTypeNode(t)&&201!==t.kind)return 0;return r(t,0,a,o)}(t);return e.computeTransformFlagsForNode(t,n)}function a(e,t){return e|i(t)}function o(e,t){return e|function(e){if(void 0===e)return 0;for(var t=0,n=0,r=0,a=e;r<a.length;r++){var o=a[r];t|=i(o),n|=-536870913&o.transformFlags}return e.transformFlags=536870912|n,t}(t)}var s;e.reduceEachChild=r,e.mergeLexicalEnvironment=function(t,n){return e.some(n)?e.isNodeArray(t)?e.setTextRange(e.createNodeArray(e.concatenate(t,n)),t):e.addRange(t,n):t},e.liftToBlock=function(t){return s.assert(e.every(t,e.isStatement),"Cannot lift nodes to a Block."),e.singleOrUndefined(t)||e.createBlock(t)},e.aggregateTransformFlags=function(e){return i(e),e},function(t){var n=!1;t.failBadSyntaxKind=t.shouldAssert(1)?function(n,r){return t.fail((r||"Unexpected node.")+"\r\nNode "+e.formatSyntaxKind(n.kind)+" was unexpected.",t.failBadSyntaxKind)}:e.noop,t.assertEachNode=t.shouldAssert(1)?function(n,r,i){return t.assert(void 0===r||e.every(n,r),i||"Unexpected node.",(function(){return"Node array did not pass test '"+t.getFunctionName(r)+"'."}),t.assertEachNode)}:e.noop,t.assertNode=t.shouldAssert(1)?function(n,r,i){return t.assert(void 0===r||r(n),i||"Unexpected node.",(function(){return"Node "+e.formatSyntaxKind(n.kind)+" did not pass test '"+t.getFunctionName(r)+"'."}),t.assertNode)}:e.noop,t.assertOptionalNode=t.shouldAssert(1)?function(n,r,i){return t.assert(void 0===r||void 0===n||r(n),i||"Unexpected node.",(function(){return"Node "+e.formatSyntaxKind(n.kind)+" did not pass test '"+t.getFunctionName(r)+"'."}),t.assertOptionalNode)}:e.noop,t.assertOptionalToken=t.shouldAssert(1)?function(n,r,i){return t.assert(void 0===r||void 0===n||n.kind===r,i||"Unexpected node.",(function(){return"Node "+e.formatSyntaxKind(n.kind)+" was not a '"+e.formatSyntaxKind(r)+"' token."}),t.assertOptionalToken)}:e.noop,t.assertMissingNode=t.shouldAssert(1)?function(n,r){return t.assert(void 0===n,r||"Unexpected node.",(function(){return"Node "+e.formatSyntaxKind(n.kind)+" was unexpected'."}),t.assertMissingNode)}:e.noop,t.enableDebugInfo=function(){if(!n){Object.defineProperties(e.objectAllocator.getSymbolConstructor().prototype,{__debugFlags:{get:function(){return e.formatSymbolFlags(this.flags)}}}),Object.defineProperties(e.objectAllocator.getTypeConstructor().prototype,{__debugFlags:{get:function(){return e.formatTypeFlags(this.flags)}},__debugObjectFlags:{get:function(){return 32768&this.flags?e.formatObjectFlags(this.objectFlags):""}},__debugTypeToString:{value:function(){return this.checker.typeToString(this)}}});for(var t=0,r=[e.objectAllocator.getNodeConstructor(),e.objectAllocator.getIdentifierConstructor(),e.objectAllocator.getTokenConstructor(),e.objectAllocator.getSourceFileConstructor()];t<r.length;t++){var i=r[t];i.prototype.hasOwnProperty("__debugKind")||Object.defineProperties(i.prototype,{__debugKind:{get:function(){return e.formatSyntaxKind(this.kind)}},__debugModifierFlags:{get:function(){return e.formatModifierFlags(e.getModifierFlagsNoCache(this))}},__debugTransformFlags:{get:function(){return e.formatTransformFlags(this.transformFlags)}},__debugEmitFlags:{get:function(){return e.formatEmitFlags(e.getEmitFlags(this))}},__debugGetText:{value:function(t){if(e.nodeIsSynthesized(this))return"";var n=e.getParseTreeNode(this),r=n&&e.getSourceFileOfNode(n);return r?e.getSourceTextOfNodeFromSourceFile(r,n,t):""}}})}n=!0}}}(s=e.Debug||(e.Debug={}))}(ts||(ts={})),function(e){function t(t){return(t=e.getOriginalNode(t))?e.getNodeId(t):0}function n(t,r,i){if(e.isBindingPattern(t.name))for(var a=0,o=t.name.elements;a<o.length;a++){var s=o[a];e.isOmittedExpression(s)||(i=n(s,r,i))}else if(!e.isGeneratedIdentifier(t.name)){var c=e.idText(t.name);r.get(c)||(r.set(c,!0),i=e.append(i,t.name))}return i}function r(e,t,n){var r=e[t];return r?r.push(n):e[t]=r=[n],r}e.getOriginalNodeId=t,e.collectExternalModuleInfo=function(i,a,o){for(var s,c=[],u=e.createMultiMap(),_=[],l=e.createMap(),d=!1,p=void 0,f=!1,m=0,g=i.statements;m<g.length;m++){var y=g[m];switch(y.kind){case 238:c.push(y);break;case 237:248===y.moduleReference.kind&&c.push(y);break;case 244:if(y.moduleSpecifier)y.exportClause?c.push(y):(c.push(y),f=!0);else for(var h=0,v=y.exportClause.elements;h<v.length;h++){var b=v[h];if(!l.get(e.idText(b.name))){var x=b.propertyName||b.name;u.add(e.idText(x),b),(D=a.getReferencedImportDeclaration(x)||a.getReferencedValueDeclaration(x))&&r(_,t(D),b.name),l.set(e.idText(b.name),!0),s=e.append(s,b.name)}}break;case 243:y.isExportEquals&&!p&&(p=y);break;case 208:if(e.hasModifier(y,1))for(var k=0,S=y.declarationList.declarations;k<S.length;k++){var D;s=n(D=S[k],l,s)}break;case 228:if(e.hasModifier(y,1))if(e.hasModifier(y,512))d||(r(_,t(y),e.getDeclarationName(y)),d=!0);else{x=y.name;l.get(e.idText(x))||(r(_,t(y),x),l.set(e.idText(x),!0),s=e.append(s,x))}break;case 229:if(e.hasModifier(y,1))if(e.hasModifier(y,512))d||(r(_,t(y),e.getDeclarationName(y)),d=!0);else(x=y.name)&&!l.get(e.idText(x))&&(r(_,t(y),x),l.set(e.idText(x),!0),s=e.append(s,x))}}var C=e.getOrCreateExternalHelpersModuleNameIfNeeded(i,o,f),T=C&&e.createImportDeclaration(void 0,void 0,e.createImportClause(void 0,e.createNamespaceImport(C)),e.createLiteral(e.externalHelpersModuleNameText));return T&&c.unshift(T),{externalImports:c,exportSpecifiers:u,exportEquals:p,hasExportStarsToExportValues:f,exportedBindings:_,exportedNames:s,externalHelpersImportDeclaration:T}},e.isSimpleCopiableExpression=function(t){return 9===t.kind||8===t.kind||13===t.kind||e.isKeyword(t.kind)||e.isIdentifier(t)}}(ts||(ts={})),function(e){function t(i,a,o,s,c){if(!c){var u=e.visitNode(e.getInitializerOfBindingOrAssignmentElement(a),i.visitor,e.isExpression);u?o=o?function(t,n,i,a){return n=r(t,n,!0,a),e.createConditional(e.createTypeCheck(n,"undefined"),i,n)}(i,o,u,s):u:o||(o=e.createVoidZero())}var _=e.getTargetOfBindingOrAssignmentElement(a);e.isObjectBindingOrAssignmentPattern(_)?function(i,a,o,s,c){var u,_,d=e.getElementsOfBindingOrAssignmentPattern(o),p=d.length;if(1!==p){s=r(i,s,!e.isDeclarationBindingElement(a)||0!==p,c)}for(var f=0;f<p;f++){var m=d[f];if(e.getRestIndicatorOfBindingOrAssignmentElement(m)){if(f===p-1){u&&(i.emitBindingOrAssignment(i.createObjectBindingOrAssignmentPattern(u),s,c,o),u=void 0),t(i,m,y=l(i.context,s,d,_,o),m)}}else{var g=e.getPropertyNameOfBindingOrAssignmentElement(m);if(!(i.level>=1)||1572864&m.transformFlags||1572864&e.getTargetOfBindingOrAssignmentElement(m).transformFlags||e.isComputedPropertyName(g)){u&&(i.emitBindingOrAssignment(i.createObjectBindingOrAssignmentPattern(u),s,c,o),u=void 0);var y=n(i,s,g);e.isComputedPropertyName(g)&&(_=e.append(_,y.argumentExpression)),t(i,m,y,m)}else u=e.append(u,m)}}u&&i.emitBindingOrAssignment(i.createObjectBindingOrAssignmentPattern(u),s,c,o)}(i,a,_,o,s):e.isArrayBindingOrAssignmentPattern(_)?function(n,i,a,o,s){var c,u,_=e.getElementsOfBindingOrAssignmentPattern(a),l=_.length;if(n.level<1&&n.downlevelIteration)o=r(n,e.createReadHelper(n.context,o,l>0&&e.getRestIndicatorOfBindingOrAssignmentElement(_[l-1])?void 0:l,s),!1,s);else if(1!==l&&(n.level<1||0===l)||e.every(_,e.isOmittedExpression)){o=r(n,o,!e.isDeclarationBindingElement(i)||0!==l,s)}for(var d=0;d<l;d++){var p=_[d];if(n.level>=1)if(1048576&p.transformFlags){var f=e.createTempVariable(void 0);n.hoistTempVariables&&n.context.hoistVariableDeclaration(f),u=e.append(u,[f,p]),c=e.append(c,n.createArrayBindingOrAssignmentElement(f))}else c=e.append(c,p);else{if(e.isOmittedExpression(p))continue;if(e.getRestIndicatorOfBindingOrAssignmentElement(p)){if(d===l-1){t(n,p,e.createArraySlice(o,d),p)}}else t(n,p,e.createElementAccess(o,d),p)}}c&&n.emitBindingOrAssignment(n.createArrayBindingOrAssignmentPattern(c),o,s,a);if(u)for(var m=0,g=u;m<g.length;m++){var y=g[m],h=y[0];t(n,p=y[1],h,p)}}(i,a,_,o,s):i.emitBindingOrAssignment(_,o,s,a)}function n(t,n,i){if(e.isComputedPropertyName(i)){var a=r(t,e.visitNode(i.expression,t.visitor),!1,i);return e.createElementAccess(n,a)}if(e.isStringOrNumericLiteral(i))return(a=e.getSynthesizedClone(i)).text=a.text,e.createElementAccess(n,a);var o=e.createIdentifier(e.idText(i));return e.createPropertyAccess(n,o)}function r(t,n,r,i){if(e.isIdentifier(n)&&r)return n;var a=e.createTempVariable(void 0);return t.hoistTempVariables?(t.context.hoistVariableDeclaration(a),t.emitExpression(e.setTextRange(e.createAssignment(a,n),i))):t.emitBindingOrAssignment(a,n,i,void 0),a}function i(t){return e.Debug.assertEachNode(t,e.isArrayBindingElement),e.createArrayBindingPattern(t)}function a(t){return e.createArrayLiteral(e.map(t,e.convertToArrayAssignmentElement))}function o(t){return e.Debug.assertEachNode(t,e.isBindingElement),e.createObjectBindingPattern(t)}function s(t){return e.createObjectLiteral(e.map(t,e.convertToObjectAssignmentElement))}function c(t){return e.createBindingElement(void 0,void 0,t)}function u(e){return e}!function(e){e[e.All=0]="All",e[e.ObjectRest=1]="ObjectRest"}(e.FlattenLevel||(e.FlattenLevel={})),e.flattenDestructuringAssignment=function(n,i,o,c,_,l){var d,p,f=n;if(e.isDestructuringAssignment(n))for(d=n.right;e.isEmptyArrayLiteral(n.left)||e.isEmptyObjectLiteral(n.left);){if(!e.isDestructuringAssignment(d))return d;f=n=d,d=n.right}var m={context:o,level:c,downlevelIteration:o.getCompilerOptions().downlevelIteration,hoistTempVariables:!0,emitExpression:g,emitBindingOrAssignment:function(t,n,r,a){e.Debug.assertNode(t,l?e.isIdentifier:e.isExpression);var o=l?l(t,n,r):e.setTextRange(e.createAssignment(e.visitNode(t,i,e.isExpression),n),r);o.original=a,g(o)},createArrayBindingOrAssignmentPattern:a,createObjectBindingOrAssignmentPattern:s,createArrayBindingOrAssignmentElement:u,visitor:i};if(d&&(d=e.visitNode(d,i,e.isExpression),_?d=r(m,d,!0,f):e.nodeIsSynthesized(n)&&(f=d)),t(m,n,d,f,e.isDestructuringAssignment(n)),d&&_){if(!e.some(p))return d;p.push(d)}return e.aggregateTransformFlags(e.inlineExpressions(p))||e.createOmittedExpression();function g(t){e.setEmitFlags(t,64),e.aggregateTransformFlags(t),p=e.append(p,t)}},e.flattenDestructuringBinding=function(n,r,a,s,u,_,l){var d,p=[],f=[];if(t({context:a,level:s,downlevelIteration:a.getCompilerOptions().downlevelIteration,hoistTempVariables:_,emitExpression:function(t){d=e.append(d,t)},emitBindingOrAssignment:T,createArrayBindingOrAssignmentPattern:i,createObjectBindingOrAssignmentPattern:o,createArrayBindingOrAssignmentElement:c,visitor:r},n,u,n,l),d){var m=e.createTempVariable(void 0);if(_){var g=e.inlineExpressions(d);d=void 0,T(m,g,void 0,void 0)}else{a.hoistVariableDeclaration(m);var y=e.lastOrUndefined(p);y.pendingExpressions=e.append(y.pendingExpressions,e.createAssignment(m,y.value)),e.addRange(y.pendingExpressions,d),y.value=m}}for(var h=0,v=p;h<v.length;h++){var b=v[h],x=b.pendingExpressions,k=b.name,S=(g=b.value,b.location),D=b.original,C=e.createVariableDeclaration(k,void 0,x?e.inlineExpressions(e.append(x,g)):g);C.original=D,e.setTextRange(C,S),e.isIdentifier(k)&&e.setEmitFlags(C,64),e.aggregateTransformFlags(C),f.push(C)}return f;function T(t,n,r,i){e.Debug.assertNode(t,e.isBindingName),d&&(n=e.inlineExpressions(e.append(d,n)),d=void 0),p.push({pendingExpressions:d,name:t,value:n,location:r,original:i})}};var _={name:"typescript:rest",scoped:!1,text:'\n            var __rest = (this && this.__rest) || function (s, e) {\n                var t = {};\n                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)\n                    t[p] = s[p];\n                if (s != null && typeof Object.getOwnPropertySymbols === "function")\n                    for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)\n                        t[p[i]] = s[p[i]];\n                return t;\n            };'};function l(t,n,r,i,a){t.requestEmitHelper(_);for(var o=[],s=0,c=0;c<r.length-1;c++){var u=e.getPropertyNameOfBindingOrAssignmentElement(r[c]);if(u)if(e.isComputedPropertyName(u)){var l=i[s];s++,o.push(e.createConditional(e.createTypeCheck(l,"symbol"),l,e.createAdd(l,e.createLiteral(""))))}else o.push(e.createLiteral(u))}return e.createCall(e.getHelperName("__rest"),void 0,[n,e.setTextRange(e.createArrayLiteral(o),a)])}}(ts||(ts={})),function(e){var t,n;function r(t,n,r,a,o,s){var c=[];return c.push(e.createArrayLiteral(n,!0)),c.push(r),a&&(c.push(a),o&&c.push(o)),t.requestEmitHelper(i),e.setTextRange(e.createCall(e.getHelperName("__decorate"),void 0,c),s)}!function(e){e[e.ClassAliases=1]="ClassAliases",e[e.NamespaceExports=2]="NamespaceExports",e[e.NonQualifiedEnumMembers=8]="NonQualifiedEnumMembers"}(t||(t={})),function(e){e[e.None=0]="None",e[e.HasStaticInitializedProperties=1]="HasStaticInitializedProperties",e[e.HasConstructorDecorators=2]="HasConstructorDecorators",e[e.HasMemberDecorators=4]="HasMemberDecorators",e[e.IsExportOfNamespace=8]="IsExportOfNamespace",e[e.IsNamedExternalExport=16]="IsNamedExternalExport",e[e.IsDefaultExternalExport=32]="IsDefaultExternalExport",e[e.IsDerivedClass=64]="IsDerivedClass",e[e.UseImmediatelyInvokedFunctionExpression=128]="UseImmediatelyInvokedFunctionExpression",e[e.HasAnyDecorators=6]="HasAnyDecorators",e[e.NeedsName=5]="NeedsName",e[e.MayNeedImmediatelyInvokedFunctionExpression=7]="MayNeedImmediatelyInvokedFunctionExpression",e[e.IsExported=56]="IsExported"}(n||(n={})),e.transformTypeScript=function(t){var n,i,o,c,u,_,l,d,p=t.startLexicalEnvironment,f=t.resumeLexicalEnvironment,m=t.endLexicalEnvironment,g=t.hoistVariableDeclaration,y=t.getEmitResolver(),h=t.getCompilerOptions(),v=void 0===h.strictNullChecks?h.strict:h.strictNullChecks,b=e.getEmitScriptTarget(h),x=e.getEmitModuleKind(h),k=t.onEmitNode,S=t.onSubstituteNode;return t.onEmitNode=function(t,r,i){var a=d,o=n;e.isSourceFile(r)&&(n=r);2&_&&function(t){return 233===e.getOriginalNode(t).kind}(r)&&(d|=2);8&_&&function(t){return 232===e.getOriginalNode(t).kind}(r)&&(d|=8);k(t,r,i),d=a,n=o},t.onSubstituteNode=function(t,n){if(n=S(t,n),1===t)return function(t){switch(t.kind){case 71:return function(t){return function(t){if(1&_&&16777216&y.getNodeCheckFlags(t)){var n=y.getReferencedValueDeclaration(t);if(n){var r=l[n.id];if(r){var i=e.getSynthesizedClone(r);return e.setSourceMapRange(i,t),e.setCommentRange(i,t),i}}}return}(t)||Je(t)||t}(t);case 179:case 180:return function(e){return ze(e)}(t)}return t}(n);if(e.isShorthandPropertyAssignment(n))return function(t){if(2&_){var n=t.name,r=Je(n);if(r){if(t.objectAssignmentInitializer){var i=e.createAssignment(r,t.objectAssignmentInitializer);return e.setTextRange(e.createPropertyAssignment(n,i),t)}return e.setTextRange(e.createPropertyAssignment(n,r),t)}}return t}(n);return n},t.enableSubstitution(179),t.enableSubstitution(180),function(r){if(r.isDeclarationFile)return r;n=r;var i=D(r,R);return e.addEmitHelpers(i,t.readEmitHelpers()),n=void 0,i};function D(t,n){var r=c,i=u;!function(t){switch(t.kind){case 265:case 235:case 234:case 207:c=t,u=void 0;break;case 229:case 228:if(e.hasModifier(t,2))break;t.name?he(t):e.Debug.assert(229===t.kind||e.hasModifier(t,512))}}(t);var a=n(t);return c!==r&&(u=i),c=r,a}function C(e){return D(e,T)}function T(n){return 1&n.transformFlags?I(n):2&n.transformFlags?e.visitEachChild(n,C,t):n}function E(e){return D(e,N)}function N(n){switch(n.kind){case 238:case 237:case 243:case 244:return function(n){if(e.getParseTreeNode(n)!==n)return n;switch(n.kind){case 238:return function(t){if(!t.importClause)return t;var n=e.visitNode(t.importClause,Se,e.isImportClause);return n?e.updateImportDeclaration(t,void 0,void 0,n,t.moduleSpecifier):void 0}(n);case 237:return Ne(n);case 243:return function(n){return y.isValueAliasDeclaration(n)?e.visitEachChild(n,C,t):void 0}(n);case 244:return function(t){if(!t.exportClause)return h.isolatedModules||y.moduleExportsSomeValue(t.moduleSpecifier)?t:void 0;if(!y.isValueAliasDeclaration(t))return;var n=e.visitNode(t.exportClause,Te,e.isNamedExports);return n?e.updateExportDeclaration(t,void 0,void 0,n,t.moduleSpecifier):void 0}(n);default:e.Debug.fail("Unhandled ellided statement")}}(n);default:return T(n)}}function A(e){return D(e,w)}function w(n){if(244!==n.kind&&238!==n.kind&&239!==n.kind&&(237!==n.kind||248!==n.moduleReference.kind))return 1&n.transformFlags||e.hasModifier(n,1)?I(n):2&n.transformFlags?e.visitEachChild(n,C,t):n}function P(e){return D(e,F)}function F(t){switch(t.kind){case 152:return;case 149:case 157:case 153:case 154:case 151:return T(t);case 206:return t;default:return void e.Debug.failBadSyntaxKind(t)}}function O(t){if(!(2270&e.modifierToFlag(t.kind)||i&&84===t.kind))return t}function I(a){if(e.hasModifier(a,2)&&e.isStatement(a))return e.createNotEmittedStatement(a);switch(a.kind){case 84:case 79:return i?void 0:a;case 114:case 112:case 113:case 117:case 76:case 124:case 131:case 164:case 165:case 163:case 158:case 145:case 119:case 122:case 136:case 133:case 130:case 105:case 137:case 161:case 160:case 162:case 159:case 166:case 167:case 168:case 169:case 170:case 171:case 172:case 173:case 157:case 147:case 231:case 149:case 236:return;case 152:return function(n){if(!pe(n))return;return e.updateConstructor(n,e.visitNodes(n.decorators,C,e.isDecorator),e.visitNodes(n.modifiers,C,e.isModifier),e.visitParameterList(n.parameters,C,t),e.visitFunctionBody(n.body,C,t))}(a);case 230:return e.createNotEmittedStatement(a);case 229:return function(i){var a=z(i,!0),o=function(t,n){var r=0;e.some(n)&&(r|=1);var i=e.getClassExtendsHeritageClauseElement(t);i&&95!==e.skipOuterExpressions(i.expression).kind&&(r|=64);(function(t){if(t.decorators&&t.decorators.length>0)return!0;var n=e.getFirstConstructorWithBody(t);if(n)return e.forEach(n.parameters,L);return!1})(t)&&(r|=2);e.childIsDecorated(t)&&(r|=4);Ae(t)?r|=8:!function(t){return we(t)&&e.hasModifier(t,512)}(t)?Pe(t)&&(r|=16):r|=32;b<=1&&7&r&&(r|=128);return r}(i,a);128&o&&t.startLexicalEnvironment();var s=i.name||(5&o?e.getGeneratedNameForNode(i):void 0),c=2&o?function(t,n,r){var i=e.moveRangePastDecorators(t),a=function(t){if(8388608&y.getNodeCheckFlags(t)){Be();var n=e.createUniqueName(t.name&&!e.isGeneratedIdentifier(t.name)?e.idText(t.name):"default");return l[e.getOriginalNodeId(t)]=n,g(n),n}}(t),o=e.getLocalName(t,!1,!0),s=e.visitNodes(t.heritageClauses,C,e.isHeritageClause),c=M(t,0!=(64&r)),u=e.createClassExpression(void 0,n,void 0,s,c);e.setOriginalNode(u,t),e.setTextRange(u,i);var _=e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration(o,void 0,a?e.createAssignment(a,u):u)],1));return e.setOriginalNode(_,t),e.setTextRange(_,i),e.setCommentRange(_,t),_}(i,s,o):function(t,n,r){var i=128&r?void 0:e.visitNodes(t.modifiers,O,e.isModifier),a=e.createClassDeclaration(void 0,i,n,void 0,e.visitNodes(t.heritageClauses,C,e.isHeritageClause),M(t,0!=(64&r))),o=e.getEmitFlags(t);1&r&&(o|=32);return e.setTextRange(a,t),e.setOriginalNode(a,t),e.setEmitFlags(a,o),a}(i,s,o),u=[c];1&o&&V(u,a,128&o?e.getInternalName(i):e.getLocalName(i));if(Z(u,i,!1),Z(u,i,!0),function(n,i){var a=function(n){var i=function(t){var n=t.decorators,r=Q(e.getFirstConstructorWithBody(t));if(!n&&!r)return;return{decorators:n,parameters:r}}(n),a=Y(n,n,i);if(!a)return;var o=l&&l[e.getOriginalNodeId(n)],s=e.getLocalName(n,!1,!0),c=r(t,a,s),u=e.createAssignment(s,o?e.createAssignment(o,c):c);return e.setEmitFlags(u,1536),e.setSourceMapRange(u,e.moveRangePastDecorators(n)),u}(i);a&&n.push(e.setOriginalNode(e.createStatement(a),i))}(u,i),128&o){var _=e.createTokenRange(e.skipTrivia(n.text,i.members.end),18),d=e.getInternalName(i),p=e.createPartiallyEmittedExpression(d);p.end=_.end,e.setEmitFlags(p,1536);var f=e.createReturn(p);f.pos=_.pos,e.setEmitFlags(f,1920),u.push(f),e.addRange(u,t.endLexicalEnvironment());var m=e.createImmediatelyInvokedArrowFunction(u);e.setEmitFlags(m,33554432);var h=e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration(e.getLocalName(i,!1,!1),void 0,m)]));e.setOriginalNode(h,i),e.setCommentRange(h,i),e.setSourceMapRange(h,e.moveRangePastDecorators(i)),e.startOnNewLine(h),u=[h]}8&o?Oe(u,i):(128&o||2&o)&&(32&o?u.push(e.createExportDefault(e.getLocalName(i,!1,!0))):16&o&&u.push(e.createExternalModuleExport(e.getLocalName(i,!1,!0))));u.length>1&&(u.push(e.createEndOfDeclarationMarker(i)),e.setEmitFlags(c,4194304|e.getEmitFlags(c)));return e.singleOrMany(u)}(a);case 199:return function(t){var n=z(t,!0),r=e.visitNodes(t.heritageClauses,C,e.isHeritageClause),i=M(t,e.some(r,(function(e){return 85===e.token}))),a=e.createClassExpression(void 0,t.name,void 0,r,i);if(e.setOriginalNode(a,t),e.setTextRange(a,t),n.length>0){var o=[],s=e.createTempVariable(g);return 8388608&y.getNodeCheckFlags(t)&&(Be(),l[e.getOriginalNodeId(t)]=e.getSynthesizedClone(s)),e.setEmitFlags(a,65536|e.getEmitFlags(a)),o.push(e.startOnNewLine(e.createAssignment(s,a))),e.addRange(o,function(t,n){for(var r=[],i=0,a=t;i<a.length;i++){var o=a[i],s=q(o,n);s.startsOnNewLine=!0,e.setSourceMapRange(s,e.moveRangePastModifiers(o)),e.setCommentRange(s,o),r.push(s)}return r}(n,s)),o.push(e.startOnNewLine(s)),e.inlineExpressions(o)}return a}(a);case 259:return function(t){if(85===t.token){var n=e.visitNodes(t.types,C,e.isExpressionWithTypeArguments,0,1);return e.setTextRange(e.createHeritageClause(85,n),t)}return}(a);case 201:return function(t){return e.updateExpressionWithTypeArguments(t,void 0,e.visitNode(t.expression,C,e.isLeftHandSideExpression))}(a);case 151:return function(n){if(!pe(n))return;var r=e.updateMethod(n,void 0,e.visitNodes(n.modifiers,O,e.isModifier),n.asteriskToken,de(n),void 0,void 0,e.visitParameterList(n.parameters,C,t),void 0,e.visitFunctionBody(n.body,C,t));r!==n&&(e.setCommentRange(r,n),e.setSourceMapRange(r,e.moveRangePastDecorators(n)));return r}(a);case 153:return function(n){if(!fe(n))return;var r=e.updateGetAccessor(n,void 0,e.visitNodes(n.modifiers,O,e.isModifier),de(n),e.visitParameterList(n.parameters,C,t),void 0,e.visitFunctionBody(n.body,C,t)||e.createBlock([]));r!==n&&(e.setCommentRange(r,n),e.setSourceMapRange(r,e.moveRangePastDecorators(n)));return r}(a);case 154:return function(n){if(!fe(n))return;var r=e.updateSetAccessor(n,void 0,e.visitNodes(n.modifiers,O,e.isModifier),de(n),e.visitParameterList(n.parameters,C,t),e.visitFunctionBody(n.body,C,t)||e.createBlock([]));r!==n&&(e.setCommentRange(r,n),e.setSourceMapRange(r,e.moveRangePastDecorators(n)));return r}(a);case 228:return function(n){if(!pe(n))return e.createNotEmittedStatement(n);var r=e.updateFunctionDeclaration(n,void 0,e.visitNodes(n.modifiers,O,e.isModifier),n.asteriskToken,n.name,void 0,e.visitParameterList(n.parameters,C,t),void 0,e.visitFunctionBody(n.body,C,t)||e.createBlock([]));if(Ae(n)){var i=[r];return Oe(i,n),i}return r}(a);case 186:return function(n){if(!pe(n))return e.createOmittedExpression();return e.updateFunctionExpression(n,e.visitNodes(n.modifiers,O,e.isModifier),n.asteriskToken,n.name,void 0,e.visitParameterList(n.parameters,C,t),void 0,e.visitFunctionBody(n.body,C,t)||e.createBlock([]))}(a);case 187:return function(n){return e.updateArrowFunction(n,e.visitNodes(n.modifiers,O,e.isModifier),void 0,e.visitParameterList(n.parameters,C,t),void 0,n.equalsGreaterThanToken,e.visitFunctionBody(n.body,C,t))}(a);case 146:return function(t){if(e.parameterIsThisKeyword(t))return;var n=e.createParameter(void 0,void 0,t.dotDotDotToken,e.visitNode(t.name,C,e.isBindingName),void 0,void 0,e.visitNode(t.initializer,C,e.isExpression));return e.setOriginalNode(n,t),e.setTextRange(n,e.moveRangePastModifiers(t)),e.setCommentRange(n,t),e.setSourceMapRange(n,e.moveRangePastModifiers(t)),e.setEmitFlags(n.name,32),n}(a);case 185:return function(n){var r=e.skipOuterExpressions(n.expression,-3);if(e.isAssertionExpression(r)){var i=e.visitNode(n.expression,C,e.isExpression);return e.createPartiallyEmittedExpression(i,n)}return e.visitEachChild(n,C,t)}(a);case 184:case 202:return function(t){var n=e.visitNode(t.expression,C,e.isExpression);return e.createPartiallyEmittedExpression(n,t)}(a);case 181:return function(t){return e.updateCall(t,e.visitNode(t.expression,C,e.isExpression),void 0,e.visitNodes(t.arguments,C,e.isExpression))}(a);case 182:return function(t){return e.updateNew(t,e.visitNode(t.expression,C,e.isExpression),void 0,e.visitNodes(t.arguments,C,e.isExpression))}(a);case 203:return function(t){var n=e.visitNode(t.expression,C,e.isLeftHandSideExpression);return e.createPartiallyEmittedExpression(n,t)}(a);case 232:return function(t){if(!function(t){return!e.isConst(t)||h.preserveConstEnums||h.isolatedModules}(t))return;var r=[],i=2;be(r,t)&&(x===e.ModuleKind.System&&c===n||(i|=512));var a=Le(t),s=Me(t),u=e.hasModifier(t,1)?e.getExternalModuleOrNamespaceExportName(o,t,!1,!0):e.getLocalName(t,!1,!0),_=e.createLogicalOr(u,e.createAssignment(u,e.createObjectLiteral()));if(ye(t)){var l=e.getLocalName(t,!1,!0);_=e.createAssignment(l,_)}var d=e.createStatement(e.createCall(e.createFunctionExpression(void 0,void 0,void 0,void 0,[e.createParameter(void 0,void 0,void 0,a)],void 0,function(t,n){var r=o;o=n;var i=[];return p(),e.addRange(i,e.map(t.members,ge)),e.addRange(i,m()),o=r,e.createBlock(e.setTextRange(e.createNodeArray(i),t.members),!0)}(t,s)),void 0,[_]));return e.setOriginalNode(d,t),e.setTextRange(d,t),e.setEmitFlags(d,i),r.push(d),r.push(e.createEndOfDeclarationMarker(t)),r}(a);case 208:return function(n){if(Ae(n)){var r=e.getInitializedVariables(n.declarationList);if(0===r.length)return;return e.setTextRange(e.createStatement(e.inlineExpressions(e.map(r,me))),n)}return e.visitEachChild(n,C,t)}(a);case 226:return function(t){return e.updateVariableDeclaration(t,e.visitNode(t.name,C,e.isBindingName),void 0,e.visitNode(t.initializer,C,e.isExpression))}(a);case 233:return xe(a);case 237:return Ne(a);default:return e.Debug.failBadSyntaxKind(a),e.visitEachChild(a,C,t)}}function R(n){var r=(void 0===h.alwaysStrict?h.strict:h.alwaysStrict)&&!(e.isExternalModule(n)&&x>=e.ModuleKind.ES2015);return e.updateSourceFileNode(n,e.visitLexicalEnvironment(n.statements,E,t,0,r))}function L(e){return void 0!==e.decorators&&e.decorators.length>0}function M(n,r){var i=[],a=function(n,r){var i=e.forEach(n.members,K),a=262144&n.transformFlags,o=e.getFirstConstructorWithBody(n);if(!i&&!a)return e.visitEachChild(o,C,t);var s=function(n){return e.visitParameterList(n&&n.parameters,C,t)||[]}(o),c=function(t,n,r){var i=[],a=0;if(f(),n){a=function(t,n){if(t.body){var r=t.body.statements,i=e.addPrologue(n,r,!1,C);if(i===r.length)return i;var a=r[i];return 210===a.kind&&e.isSuperCall(a.expression)?(n.push(e.visitNode(a,C,e.isStatement)),i+1):i}return 0}(n,i);var o=function(t){return e.filter(t.parameters,B)}(n);e.addRange(i,e.map(o,J))}else r&&i.push(e.createStatement(e.createCall(e.createSuper(),void 0,[e.createSpread(e.createIdentifier("arguments"))])));var s=z(t,!1);V(i,s,e.createThis()),n&&e.addRange(i,e.visitNodes(n.body.statements,C,e.isStatement,a));return i=e.mergeLexicalEnvironment(i,m()),e.setTextRange(e.createBlock(e.setTextRange(e.createNodeArray(i),n?n.body.statements:t.members),!0),n?n.body:void 0)}(n,o,r);return e.startOnNewLine(e.setOriginalNode(e.setTextRange(e.createConstructor(void 0,void 0,s,c),o||n),o))}(n,r);return a&&i.push(a),e.addRange(i,e.visitNodes(n.members,P,e.isClassElement)),e.setTextRange(e.createNodeArray(i),n.members)}function B(t){return e.hasModifier(t,92)&&e.isIdentifier(t.name)}function J(t){e.Debug.assert(e.isIdentifier(t.name));var n=t.name,r=e.getMutableClone(n);e.setEmitFlags(r,1584);var i=e.getMutableClone(n);return e.setEmitFlags(i,1536),e.startOnNewLine(e.setTextRange(e.createStatement(e.createAssignment(e.setTextRange(e.createPropertyAccess(e.createThis(),r),t.name),i)),e.moveRangePos(t,-1)))}function z(t,n){return e.filter(t.members,n?j:K)}function j(e){return U(e,!0)}function K(e){return U(e,!1)}function U(t,n){return 149===t.kind&&n===e.hasModifier(t,32)&&void 0!==t.initializer}function V(t,n,r){for(var i=0,a=n;i<a.length;i++){var o=a[i],s=e.createStatement(q(o,r));e.setSourceMapRange(s,e.moveRangePastModifiers(o)),e.setCommentRange(s,o),t.push(s)}}function q(t,n){var r=de(t),i=e.visitNode(t.initializer,C,e.isExpression),a=e.createMemberAccessForPropertyName(n,r,r);return e.createAssignment(a,i)}function W(e){return G(e,!0)}function H(e){return G(e,!1)}function G(t,n){return e.nodeOrChildIsDecorated(t)&&n===e.hasModifier(t,32)}function Q(e){var t;if(e)for(var n=e.parameters,r=0;r<n.length;r++){var i=n[r];(t||i.decorators)&&(t||(t=new Array(n.length)),t[r]=i.decorators)}return t}function X(t,n){switch(n.kind){case 153:case 154:return function(t,n){if(!n.body)return;var r=e.getAllAccessorDeclarations(t.members,n),i=r.firstAccessor,a=r.secondAccessor,o=r.setAccessor,s=i.decorators?i:a&&a.decorators?a:void 0;if(!s||n!==s)return;var c=s.decorators,u=Q(o);if(!c&&!u)return;return{decorators:c,parameters:u}}(t,n);case 151:return function(e){if(!e.body)return;var t=e.decorators,n=Q(e);if(!t&&!n)return;return{decorators:t,parameters:n}}(n);case 149:return function(e){var t=e.decorators;if(!t)return;return{decorators:t}}(n);default:return}}function Y(n,r,i){if(i){var o=[];return e.addRange(o,e.map(i.decorators,ee)),e.addRange(o,e.flatMap(i.parameters,te)),function(e,n,r){(function(e,n,r){h.emitDecoratorMetadata&&(ne(e)&&r.push(a(t,"design:type",ae(e))),ie(e)&&r.push(a(t,"design:paramtypes",oe(e,n))),re(e)&&r.push(a(t,"design:returntype",se(e))))})(e,n,r)}(n,r,o),o}}function Z(t,n,r){e.addRange(t,e.map(function(t,n){for(var r,i=function(t,n){return e.filter(t.members,n?W:H)}(t,n),a=0,o=i;a<o.length;a++){var s=$(t,o[a]);s&&(r?r.push(s):r=[s])}return r}(n,r),Fe))}function $(n,i){var a=Y(i,n,X(n,i));if(a){var o=function(t,n){return e.hasModifier(n,32)?e.getDeclarationName(t):function(t){return e.createPropertyAccess(e.getDeclarationName(t),"prototype")}(t)}(n,i),s=le(i,!0),c=b>0?149===i.kind?e.createVoidZero():e.createNull():void 0,u=r(t,a,o,s,c,e.moveRangePastDecorators(i));return e.setEmitFlags(u,1536),u}}function ee(t){return e.visitNode(t.expression,C,e.isExpression)}function te(n,r){var i;if(n){i=[];for(var a=0,o=n;a<o.length;a++){var c=o[a],u=s(t,ee(c),r,c.expression);e.setEmitFlags(u,1536),i.push(u)}}return i}function ne(e){var t=e.kind;return 151===t||153===t||154===t||149===t}function re(e){return 151===e.kind}function ie(t){switch(t.kind){case 229:case 199:return void 0!==e.getFirstConstructorWithBody(t);case 151:case 153:case 154:return!0}return!1}function ae(t){switch(t.kind){case 149:case 146:case 153:return ce(t.type);case 154:return ce(e.getSetAccessorTypeAnnotationNode(t));case 229:case 199:case 151:return e.createIdentifier("Function");default:return e.createVoidZero()}}function oe(t,n){var r=e.isClassLike(t)?e.getFirstConstructorWithBody(t):e.isFunctionLike(t)&&e.nodeIsPresent(t.body)?t:void 0,i=[];if(r)for(var a=function(t,n){if(n&&153===t.kind){var r=e.getAllAccessorDeclarations(n.members,t).setAccessor;if(r)return r.parameters}return t.parameters}(r,n),o=a.length,s=0;s<o;s++){var c=a[s];0===s&&e.isIdentifier(c.name)&&"this"===c.name.escapedText||(c.dotDotDotToken?i.push(ce(e.getRestParameterElementType(c.type))):i.push(ae(c)))}return e.createArrayLiteral(i)}function se(t){return e.isFunctionLike(t)&&t.type?ce(t.type):e.isAsyncFunction(t)?e.createIdentifier("Promise"):e.createVoidZero()}function ce(t){if(void 0===t)return e.createIdentifier("Object");switch(t.kind){case 105:case 139:case 95:case 130:return e.createVoidZero();case 168:return ce(t.type);case 160:case 161:return e.createIdentifier("Function");case 164:case 165:return e.createIdentifier("Array");case 158:case 122:return e.createIdentifier("Boolean");case 136:return e.createIdentifier("String");case 134:return e.createIdentifier("Object");case 173:switch(t.literal.kind){case 9:return e.createIdentifier("String");case 8:return e.createIdentifier("Number");case 101:case 86:return e.createIdentifier("Boolean");default:e.Debug.failBadSyntaxKind(t.literal)}break;case 133:return e.createIdentifier("Number");case 137:return b<2?_e():e.createIdentifier("Symbol");case 159:return function(t){switch(y.getTypeReferenceSerializationKind(t.typeName,c)){case e.TypeReferenceSerializationKind.Unknown:var n=ue(t.typeName,!0),r=e.createTempVariable(g);return e.createLogicalOr(e.createLogicalAnd(e.createTypeCheck(e.createAssignment(r,n),"function"),r),e.createIdentifier("Object"));case e.TypeReferenceSerializationKind.TypeWithConstructSignatureAndValue:return ue(t.typeName,!1);case e.TypeReferenceSerializationKind.VoidNullableOrNeverType:return e.createVoidZero();case e.TypeReferenceSerializationKind.BooleanType:return e.createIdentifier("Boolean");case e.TypeReferenceSerializationKind.NumberLikeType:return e.createIdentifier("Number");case e.TypeReferenceSerializationKind.StringLikeType:return e.createIdentifier("String");case e.TypeReferenceSerializationKind.ArrayLikeType:return e.createIdentifier("Array");case e.TypeReferenceSerializationKind.ESSymbolType:return b<2?_e():e.createIdentifier("Symbol");case e.TypeReferenceSerializationKind.TypeWithCallSignature:return e.createIdentifier("Function");case e.TypeReferenceSerializationKind.Promise:return e.createIdentifier("Promise");case e.TypeReferenceSerializationKind.ObjectType:default:return e.createIdentifier("Object")}}(t);case 167:case 166:return function(t){for(var n,r=0,i=t.types;r<i.length;r++){for(var a=i[r];168===a.kind;)a=a.type;if(130!==a.kind&&(v||95!==a.kind&&139!==a.kind)){var o=ce(a);if(e.isIdentifier(o)&&"Object"===o.escapedText)return o;if(n){if(!e.isIdentifier(n)||!e.isIdentifier(o)||n.escapedText!==o.escapedText)return e.createIdentifier("Object")}else n=o}}return n||e.createVoidZero()}(t);case 162:case 170:case 171:case 172:case 163:case 119:case 169:break;default:e.Debug.failBadSyntaxKind(t)}return e.createIdentifier("Object")}function ue(t,n){switch(t.kind){case 71:var r=e.getMutableClone(t);return r.flags&=-9,r.original=void 0,r.parent=e.getParseTreeNode(c),n?e.createLogicalAnd(e.createStrictInequality(e.createTypeOf(r),e.createLiteral("undefined")),r):r;case 143:return function(t,n){var r;if(71===t.left.kind)r=ue(t.left,n);else if(n){var i=e.createTempVariable(g);r=e.createLogicalAnd(e.createAssignment(i,ue(t.left,!0)),i)}else r=ue(t.left,!1);return e.createPropertyAccess(r,t.right)}(t,n)}}function _e(){return e.createConditional(e.createTypeCheck(e.createIdentifier("Symbol"),"function"),e.createIdentifier("Symbol"),e.createIdentifier("Object"))}function le(t,n){var r=t.name;return e.isComputedPropertyName(r)?n?e.getGeneratedNameForNode(r):r.expression:e.isIdentifier(r)?e.createLiteral(e.idText(r)):e.getSynthesizedClone(r)}function de(t){var n=t.name;if(e.isComputedPropertyName(n)){var r=e.visitNode(n.expression,C,e.isExpression);if(t.decorators){var i=e.getGeneratedNameForNode(n);g(i),r=e.createAssignment(i,r)}return e.updateComputedPropertyName(n,r)}return n}function pe(t){return!e.nodeIsMissing(t.body)}function fe(t){return!(e.nodeIsMissing(t.body)&&e.hasModifier(t,128))}function me(n){var r=n.name;return e.isBindingPattern(r)?e.flattenDestructuringAssignment(n,C,t,0,!1,Ie):e.setTextRange(e.createAssignment(Re(r),e.visitNode(n.initializer,C,e.isExpression)),n)}function ge(n){var r=le(n,!1),i=function(n){var r=y.getConstantValue(n);return void 0!==r?e.createLiteral(r):(0==(8&_)&&(_|=8,t.enableSubstitution(71)),n.initializer?e.visitNode(n.initializer,C,e.isExpression):e.createVoidZero())}(n),a=e.createAssignment(e.createElementAccess(o,r),i),s=9===i.kind?a:e.createAssignment(e.createElementAccess(o,a),r);return e.setTextRange(e.createStatement(e.setTextRange(s,n)),n)}function ye(t){return Ae(t)||we(t)&&x!==e.ModuleKind.ES2015&&x!==e.ModuleKind.ESNext&&x!==e.ModuleKind.System}function he(t){u||(u=e.createUnderscoreEscapedMap());var n=ve(t);u.has(n)||u.set(n,t)}function ve(t){return e.Debug.assertNode(t.name,e.isIdentifier),t.name.escapedText}function be(t,n){var r=e.createVariableStatement(e.visitNodes(n.modifiers,O,e.isModifier),e.createVariableDeclarationList([e.createVariableDeclaration(e.getLocalName(n,!1,!0))],265===c.kind?0:1));if(e.setOriginalNode(r,n),he(n),function(e){if(u){var t=ve(e);return u.get(t)===e}return!0}(n))return 232===n.kind?e.setSourceMapRange(r.declarationList,n):e.setSourceMapRange(r,n),e.setCommentRange(r,n),e.setEmitFlags(r,4195328),t.push(r),!0;var i=e.createMergeDeclarationMarker(r);return e.setEmitFlags(i,4195840),t.push(i),!1}function xe(r){if(!function(t){return e.isInstantiatedModule(t,h.preserveConstEnums||h.isolatedModules)}(r))return e.createNotEmittedStatement(r);e.Debug.assertNode(r.name,e.isIdentifier,"A TypeScript namespace should have an Identifier name."),0==(2&_)&&(_|=2,t.enableSubstitution(71),t.enableSubstitution(262),t.enableEmitNotification(233));var a=[],s=2;be(a,r)&&(x===e.ModuleKind.System&&c===n||(s|=512));var l=Le(r),d=Me(r),f=e.hasModifier(r,1)?e.getExternalModuleOrNamespaceExportName(o,r,!1,!0):e.getLocalName(r,!1,!0),g=e.createLogicalOr(f,e.createAssignment(f,e.createObjectLiteral()));if(ye(r)){var y=e.getLocalName(r,!1,!0);g=e.createAssignment(y,g)}var v=e.createStatement(e.createCall(e.createFunctionExpression(void 0,void 0,void 0,void 0,[e.createParameter(void 0,void 0,void 0,l)],void 0,function(t,n){var r=o,a=i,s=u;o=n,i=t,u=void 0;var c,_,l=[];p();var d=t.body;if(234===d.kind)D(d,(function(t){return e.addRange(l,e.visitNodes(t.statements,A,e.isStatement))})),c=d.statements,_=d;else{var f=xe(d);f&&(e.isArray(f)?e.addRange(l,f):l.push(f));var g=ke(t).body;c=e.moveRangePos(g.statements,-1)}e.addRange(l,m()),o=r,i=a,u=s;var y=e.createBlock(e.setTextRange(e.createNodeArray(l),c),!0);e.setTextRange(y,_),234!==d.kind&&e.setEmitFlags(y,1536|e.getEmitFlags(y));return y}(r,d)),void 0,[g]));return e.setOriginalNode(v,r),e.setTextRange(v,r),e.setEmitFlags(v,s),a.push(v),a.push(e.createEndOfDeclarationMarker(r)),a}function ke(e){if(233===e.body.kind)return ke(e.body)||e.body}function Se(t){var n=y.isReferencedAliasDeclaration(t)?t.name:void 0,r=e.visitNode(t.namedBindings,De,e.isNamedImportBindings);return n||r?e.updateImportClause(t,n,r):void 0}function De(t){if(240===t.kind)return y.isReferencedAliasDeclaration(t)?t:void 0;var n=e.visitNodes(t.elements,Ce,e.isImportSpecifier);return e.some(n)?e.updateNamedImports(t,n):void 0}function Ce(e){return y.isReferencedAliasDeclaration(e)?e:void 0}function Te(t){var n=e.visitNodes(t.elements,Ee,e.isExportSpecifier);return e.some(n)?e.updateNamedExports(t,n):void 0}function Ee(e){return y.isValueAliasDeclaration(e)?e:void 0}function Ne(r){if(e.isExternalModuleImportEqualsDeclaration(r))return y.isReferencedAliasDeclaration(r)?e.visitEachChild(r,C,t):void 0;if(function(t){return y.isReferencedAliasDeclaration(t)||!e.isExternalModule(n)&&y.isTopLevelValueImportEqualsWithEntityName(t)}(r)){var i,a,s,c=e.createExpressionFromEntityName(r.moduleReference);return e.setEmitFlags(c,3584),Pe(r)||!Ae(r)?e.setOriginalNode(e.setTextRange(e.createVariableStatement(e.visitNodes(r.modifiers,O,e.isModifier),e.createVariableDeclarationList([e.setOriginalNode(e.createVariableDeclaration(r.name,void 0,c),r)])),r),r):e.setOriginalNode((i=r.name,a=c,s=r,e.setTextRange(e.createStatement(e.createAssignment(e.getNamespaceMemberName(o,i,!1,!0),a)),s)),r)}}function Ae(t){return void 0!==i&&e.hasModifier(t,1)}function we(t){return void 0===i&&e.hasModifier(t,1)}function Pe(t){return we(t)&&!e.hasModifier(t,512)}function Fe(t){return e.createStatement(t)}function Oe(t,n){var r=e.createAssignment(e.getExternalModuleOrNamespaceExportName(o,n,!1,!0),e.getLocalName(n));e.setSourceMapRange(r,e.createRange(n.name?n.name.pos:n.pos,n.end));var i=e.createStatement(r);e.setSourceMapRange(i,e.createRange(-1,n.end)),t.push(i)}function Ie(t,n,r){return e.setTextRange(e.createAssignment(Re(t),n),r)}function Re(t){return e.getNamespaceMemberName(o,t,!1,!0)}function Le(t){var n=e.getGeneratedNameForNode(t);return e.setSourceMapRange(n,t.name),n}function Me(t){return e.getGeneratedNameForNode(t)}function Be(){0==(1&_)&&(_|=1,t.enableSubstitution(71),l=[])}function Je(t){if(_&d&&!e.isGeneratedIdentifier(t)&&!e.isLocalName(t)){var n=y.getReferencedExportContainer(t,!1);if(n&&265!==n.kind)if(2&d&&233===n.kind||8&d&&232===n.kind)return e.setTextRange(e.createPropertyAccess(e.getGeneratedNameForNode(n),t),t)}}function ze(t){var n=function(t){if(h.isolatedModules)return;return e.isPropertyAccessExpression(t)||e.isElementAccessExpression(t)?y.getConstantValue(t):void 0}(t);if(void 0!==n){e.setConstantValue(t,n);var r=e.createLiteral(n);if(!h.removeComments){var i=e.isPropertyAccessExpression(t)?e.declarationNameToString(t.name):e.getTextOfNode(t.argumentExpression);e.addSyntheticTrailingComment(r,3," "+i+" ")}return r}return t}};var i={name:"typescript:decorate",scoped:!1,priority:2,text:'\n            var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {\n                var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;\n                if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);\n                else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;\n                return c > 3 && r && Object.defineProperty(target, key, r), r;\n            };'};function a(t,n,r){return t.requestEmitHelper(o),e.createCall(e.getHelperName("__metadata"),void 0,[e.createLiteral(n),r])}var o={name:"typescript:metadata",scoped:!1,priority:3,text:'\n            var __metadata = (this && this.__metadata) || function (k, v) {\n                if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);\n            };'};function s(t,n,r,i){return t.requestEmitHelper(c),e.setTextRange(e.createCall(e.getHelperName("__param"),void 0,[e.createLiteral(r),n]),i)}var c={name:"typescript:param",scoped:!1,priority:4,text:"\n            var __param = (this && this.__param) || function (paramIndex, decorator) {\n                return function (target, key) { decorator(target, key, paramIndex); }\n            };"}}(ts||(ts={})),function(e){var t;!function(e){e[e.AsyncMethodsWithSuper=1]="AsyncMethodsWithSuper"}(t||(t={})),e.transformES2017=function(t){var n,i=t.startLexicalEnvironment,a=t.resumeLexicalEnvironment,o=t.endLexicalEnvironment,s=t.getEmitResolver(),c=t.getCompilerOptions(),u=e.getEmitScriptTarget(c),_=0,l=t.onEmitNode,d=t.onSubstituteNode;return t.onEmitNode=function(e,t,r){if(1&n&&function(e){var t=e.kind;return 229===t||152===t||151===t||153===t||154===t}(t)){var i=6144&s.getNodeCheckFlags(t);if(i!==_){var a=_;return _=i,l(e,t,r),void(_=a)}}l(e,t,r)},t.onSubstituteNode=function(t,n){if(n=d(t,n),1===t&&_)return function(t){switch(t.kind){case 179:return y(t);case 180:return h(t);case 181:return function(t){var n=t.expression;if(e.isSuperProperty(n)){var r=e.isPropertyAccessExpression(n)?y(n):h(n);return e.createCall(e.createPropertyAccess(r,"call"),void 0,[e.createThis()].concat(t.arguments))}return t}(t)}return t}(n);return n},function(n){if(n.isDeclarationFile)return n;var r=e.visitEachChild(n,p,t);return e.addEmitHelpers(r,t.readEmitHelpers()),r};function p(n){if(0==(16&n.transformFlags))return n;switch(n.kind){case 120:return;case 191:return function(t){return e.setOriginalNode(e.setTextRange(e.createYield(void 0,e.visitNode(t.expression,p,e.isExpression)),t),t)}(n);case 151:return function(n){return e.updateMethod(n,void 0,e.visitNodes(n.modifiers,p,e.isModifier),n.asteriskToken,n.name,void 0,void 0,e.visitParameterList(n.parameters,p,t),void 0,2&e.getFunctionFlags(n)?f(n):e.visitFunctionBody(n.body,p,t))}(n);case 228:return function(n){return e.updateFunctionDeclaration(n,void 0,e.visitNodes(n.modifiers,p,e.isModifier),n.asteriskToken,n.name,void 0,e.visitParameterList(n.parameters,p,t),void 0,2&e.getFunctionFlags(n)?f(n):e.visitFunctionBody(n.body,p,t))}(n);case 186:return function(n){return e.updateFunctionExpression(n,e.visitNodes(n.modifiers,p,e.isModifier),n.asteriskToken,n.name,void 0,e.visitParameterList(n.parameters,p,t),void 0,2&e.getFunctionFlags(n)?f(n):e.visitFunctionBody(n.body,p,t))}(n);case 187:return function(n){return e.updateArrowFunction(n,e.visitNodes(n.modifiers,p,e.isModifier),void 0,e.visitParameterList(n.parameters,p,t),void 0,n.equalsGreaterThanToken,2&e.getFunctionFlags(n)?f(n):e.visitFunctionBody(n.body,p,t))}(n);default:return e.visitEachChild(n,p,t)}}function f(n){a();var i=e.getOriginalNode(n,e.isFunctionLike).type,c=u<2?function(t){var n=t&&e.getEntityNameFromTypeNode(t);if(n&&e.isEntityName(n)){var r=s.getTypeReferenceSerializationKind(n);if(r===e.TypeReferenceSerializationKind.TypeWithConstructSignatureAndValue||r===e.TypeReferenceSerializationKind.Unknown)return n}return}(i):void 0,_=187===n.kind,l=0!=(8192&s.getNodeCheckFlags(n));if(_){var d=r(t,l,c,m(n.body)),f=o();if(e.some(f)){v=e.convertToFunctionBody(d);return e.updateBlock(v,e.setTextRange(e.createNodeArray(e.concatenate(v.statements,f)),v.statements))}return d}var y=[],h=e.addPrologue(y,n.body.statements,!1,p);y.push(e.createReturn(r(t,l,c,m(n.body,h)))),e.addRange(y,o());var v=e.createBlock(y,!0);return e.setTextRange(v,n.body),u>=2&&(4096&s.getNodeCheckFlags(n)?(g(),e.addEmitHelper(v,e.advancedAsyncSuperHelper)):2048&s.getNodeCheckFlags(n)&&(g(),e.addEmitHelper(v,e.asyncSuperHelper))),v}function m(n,r){if(e.isBlock(n))return e.updateBlock(n,e.visitLexicalEnvironment(n.statements,p,t,r));i();var a=e.convertToFunctionBody(e.visitNode(n,p,e.isConciseBody)),s=o();return e.updateBlock(a,e.setTextRange(e.createNodeArray(e.concatenate(a.statements,s)),a.statements))}function g(){0==(1&n)&&(n|=1,t.enableSubstitution(181),t.enableSubstitution(179),t.enableSubstitution(180),t.enableEmitNotification(229),t.enableEmitNotification(151),t.enableEmitNotification(153),t.enableEmitNotification(154),t.enableEmitNotification(152))}function y(t){return 97===t.expression.kind?v(e.createLiteral(e.idText(t.name)),t):t}function h(e){return 97===e.expression.kind?v(e.argumentExpression,e):e}function v(t,n){return 4096&_?e.setTextRange(e.createPropertyAccess(e.createCall(e.createIdentifier("_super"),void 0,[t]),"value"),n):e.setTextRange(e.createCall(e.createIdentifier("_super"),void 0,[t]),n)}};var n={name:"typescript:awaiter",scoped:!1,priority:5,text:'\n            var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {\n                return new (P || (P = Promise))(function (resolve, reject) {\n                    function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }\n                    function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }\n                    function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }\n                    step((generator = generator.apply(thisArg, _arguments || [])).next());\n                });\n            };'};function r(t,r,i,a){t.requestEmitHelper(n);var o=e.createFunctionExpression(void 0,e.createToken(39),void 0,void 0,[],void 0,a);return(o.emitNode||(o.emitNode={})).flags|=786432,e.createCall(e.getHelperName("__awaiter"),void 0,[e.createThis(),r?e.createIdentifier("arguments"):e.createVoidZero(),i?e.createExpressionFromEntityName(i):e.createVoidZero(),o])}e.asyncSuperHelper={name:"typescript:async-super",scoped:!0,text:"\n            const _super = name => super[name];\n        "},e.advancedAsyncSuperHelper={name:"typescript:advanced-async-super",scoped:!0,text:"\n            const _super = (function (geti, seti) {\n                const cache = Object.create(null);\n                return name => cache[name] || (cache[name] = { get value() { return geti(name); }, set value(v) { seti(name, v); } });\n            })(name => super[name], (name, value) => super[name] = value);\n        "}}(ts||(ts={})),function(e){var t;!function(e){e[e.AsyncMethodsWithSuper=1]="AsyncMethodsWithSuper"}(t||(t={})),e.transformESNext=function(t){var n=t.resumeLexicalEnvironment,c=t.endLexicalEnvironment,_=t.hoistVariableDeclaration,l=t.getEmitResolver(),d=t.getCompilerOptions(),p=e.getEmitScriptTarget(d),f=t.onEmitNode;t.onEmitNode=function(e,t,n){if(1&m&&function(e){var t=e.kind;return 229===t||152===t||151===t||153===t||154===t}(t)){var r=6144&l.getNodeCheckFlags(t);if(r!==h){var i=h;return h=r,f(e,t,n),void(h=i)}}f(e,t,n)};var m,g,y=t.onSubstituteNode;t.onSubstituteNode=function(t,n){if(n=y(t,n),1===t&&h)return function(t){switch(t.kind){case 179:return A(t);case 180:return w(t);case 181:return function(t){var n=t.expression;if(e.isSuperProperty(n)){var r=e.isPropertyAccessExpression(n)?A(n):w(n);return e.createCall(e.createPropertyAccess(r,"call"),void 0,[e.createThis()].concat(t.arguments))}return t}(t)}return t}(n);return n};var h=0;return function(n){if(n.isDeclarationFile)return n;var r=e.visitEachChild(n,v,t);return e.addEmitHelpers(r,t.readEmitHelpers()),r};function v(e){return k(e,!1)}function b(e){return k(e,!0)}function x(e){if(120!==e.kind)return e}function k(n,o){if(0==(8&n.transformFlags))return n;switch(n.kind){case 191:return function(n){if(2&g&&1&g)return e.setOriginalNode(e.setTextRange(e.createYield(a(t,e.visitNode(n.expression,v,e.isExpression))),n),n);return e.visitEachChild(n,v,t)}(n);case 197:return function(n){if(2&g&&1&g&&n.asteriskToken){var r=e.visitNode(n.expression,v,e.isExpression);return e.setOriginalNode(e.setTextRange(e.createYield(a(t,e.updateYield(n,n.asteriskToken,function(t,n,r){return t.requestEmitHelper(i),t.requestEmitHelper(s),e.setTextRange(e.createCall(e.getHelperName("__asyncDelegator"),void 0,[n]),r)}(t,u(t,r,r),r)))),n),n)}return e.visitEachChild(n,v,t)}(n);case 222:return function(n){if(2&g&&1&g){var r=e.unwrapInnermostStatementOfLabel(n);return 216===r.kind&&r.awaitModifier?S(r,n):e.restoreEnclosingLabel(e.visitEachChild(n,v,t),n)}return e.visitEachChild(n,v,t)}(n);case 178:return function(n){if(1048576&n.transformFlags){var i=function(t){for(var n,r=[],i=0,a=t;i<a.length;i++){var o=a[i];if(263===o.kind){n&&(r.push(e.createObjectLiteral(n)),n=void 0);var s=o.expression;r.push(e.visitNode(s,v,e.isExpression))}else if(n||(n=[]),261===o.kind){var c=o;n.push(e.createPropertyAssignment(c.name,e.visitNode(c.initializer,v,e.isExpression)))}else n.push(e.visitNode(o,v,e.isObjectLiteralElementLike))}n&&r.push(e.createObjectLiteral(n));return r}(n.properties);return i.length&&178!==i[0].kind&&i.unshift(e.createObjectLiteral()),r(t,i)}return e.visitEachChild(n,v,t)}(n);case 194:return function(n,r){if(e.isDestructuringAssignment(n)&&1048576&n.left.transformFlags)return e.flattenDestructuringAssignment(n,v,t,1,!r);if(26===n.operatorToken.kind)return e.updateBinary(n,e.visitNode(n.left,b,e.isExpression),e.visitNode(n.right,r?b:v,e.isExpression));return e.visitEachChild(n,v,t)}(n,o);case 226:return function(n){if(e.isBindingPattern(n.name)&&1048576&n.name.transformFlags)return e.flattenDestructuringBinding(n,v,t,1);return e.visitEachChild(n,v,t)}(n);case 216:return S(n,void 0);case 214:return function(t){return e.updateFor(t,e.visitNode(t.initializer,b,e.isForInitializer),e.visitNode(t.condition,v,e.isExpression),e.visitNode(t.incrementor,v,e.isExpression),e.visitNode(t.statement,v,e.isStatement))}(n);case 190:return function(n){return e.visitEachChild(n,b,t)}(n);case 152:return function(n){var r=g;g=0;var i=e.updateConstructor(n,void 0,n.modifiers,e.visitParameterList(n.parameters,v,t),T(n));return g=r,i}(n);case 151:return function(n){var r=g;g=e.getFunctionFlags(n);var i=e.updateMethod(n,void 0,1&g?e.visitNodes(n.modifiers,x,e.isModifier):n.modifiers,2&g?void 0:n.asteriskToken,e.visitNode(n.name,v,e.isPropertyName),e.visitNode(void 0,v,e.isToken),void 0,e.visitParameterList(n.parameters,v,t),void 0,2&g&&1&g?C(n):T(n));return g=r,i}(n);case 153:return function(n){var r=g;g=0;var i=e.updateGetAccessor(n,void 0,n.modifiers,e.visitNode(n.name,v,e.isPropertyName),e.visitParameterList(n.parameters,v,t),void 0,T(n));return g=r,i}(n);case 154:return function(n){var r=g;g=0;var i=e.updateSetAccessor(n,void 0,n.modifiers,e.visitNode(n.name,v,e.isPropertyName),e.visitParameterList(n.parameters,v,t),T(n));return g=r,i}(n);case 228:return function(n){var r=g;g=e.getFunctionFlags(n);var i=e.updateFunctionDeclaration(n,void 0,1&g?e.visitNodes(n.modifiers,x,e.isModifier):n.modifiers,2&g?void 0:n.asteriskToken,n.name,void 0,e.visitParameterList(n.parameters,v,t),void 0,2&g&&1&g?C(n):T(n));return g=r,i}(n);case 186:return function(n){var r=g;g=e.getFunctionFlags(n);var i=e.updateFunctionExpression(n,1&g?e.visitNodes(n.modifiers,x,e.isModifier):n.modifiers,2&g?void 0:n.asteriskToken,n.name,void 0,e.visitParameterList(n.parameters,v,t),void 0,2&g&&1&g?C(n):T(n));return g=r,i}(n);case 187:return function(n){var r=g;g=e.getFunctionFlags(n);var i=e.updateArrowFunction(n,n.modifiers,void 0,e.visitParameterList(n.parameters,v,t),void 0,n.equalsGreaterThanToken,T(n));return g=r,i}(n);case 146:return function(n){if(1048576&n.transformFlags)return e.updateParameter(n,void 0,void 0,n.dotDotDotToken,e.getGeneratedNameForNode(n),void 0,void 0,e.visitNode(n.initializer,v,e.isExpression));return e.visitEachChild(n,v,t)}(n);case 210:return function(n){return e.visitEachChild(n,b,t)}(n);case 185:return function(n,r){return e.visitEachChild(n,r?b:v,t)}(n,o);case 260:return function(n){if(!n.variableDeclaration)return e.updateCatchClause(n,e.createVariableDeclaration(e.createTempVariable(void 0)),e.visitNode(n.block,v,e.isBlock));return e.visitEachChild(n,v,t)}(n);default:return e.visitEachChild(n,v,t)}}function S(n,r){return 1048576&n.initializer.transformFlags&&(n=function(t){var n=e.skipParentheses(t.initializer);if(e.isVariableDeclarationList(n)||e.isAssignmentPattern(n)){var r=void 0,i=void 0,a=e.createTempVariable(void 0),o=[e.createForOfBindingStatement(n,a)];return e.isBlock(t.statement)&&(e.addRange(o,t.statement.statements),r=t.statement,i=t.statement.statements),e.updateForOf(t,t.awaitModifier,e.setTextRange(e.createVariableDeclarationList([e.setTextRange(e.createVariableDeclaration(a),t.initializer)],1),t.initializer),t.expression,e.setTextRange(e.createBlock(e.setTextRange(e.createNodeArray(o),i),!0),r))}return t}(n)),n.awaitModifier?function(n,r){var i=e.visitNode(n.expression,v,e.isExpression),a=e.isIdentifier(i)?e.getGeneratedNameForNode(i):e.createTempVariable(void 0),o=e.isIdentifier(i)?e.getGeneratedNameForNode(a):e.createTempVariable(void 0),s=e.createUniqueName("e"),c=e.getGeneratedNameForNode(s),l=e.createTempVariable(void 0),d=u(t,i,n.expression),p=e.createCall(e.createPropertyAccess(a,"next"),void 0,[]),f=e.createPropertyAccess(o,"done"),m=e.createPropertyAccess(o,"value"),g=e.createFunctionCall(l,a,[]);_(s),_(l);var y=e.setEmitFlags(e.setTextRange(e.createFor(e.setEmitFlags(e.setTextRange(e.createVariableDeclarationList([e.setTextRange(e.createVariableDeclaration(a,void 0,d),n.expression),e.createVariableDeclaration(o)]),n.expression),2097152),e.createComma(e.createAssignment(o,D(p)),e.createLogicalNot(f)),void 0,function(t,n){var r,i,a=e.createForOfBindingStatement(t.initializer,n),o=[e.visitNode(a,v,e.isStatement)],s=e.visitNode(t.statement,v,e.isStatement);e.isBlock(s)?(e.addRange(o,s.statements),r=s,i=s.statements):o.push(s);return e.setEmitFlags(e.setTextRange(e.createBlock(e.setTextRange(e.createNodeArray(o),i),!0),r),432)}(n,D(m))),n),256);return e.createTry(e.createBlock([e.restoreEnclosingLabel(y,r)]),e.createCatchClause(e.createVariableDeclaration(c),e.setEmitFlags(e.createBlock([e.createStatement(e.createAssignment(s,e.createObjectLiteral([e.createPropertyAssignment("error",c)])))]),1)),e.createBlock([e.createTry(e.createBlock([e.setEmitFlags(e.createIf(e.createLogicalAnd(e.createLogicalAnd(o,e.createLogicalNot(f)),e.createAssignment(l,e.createPropertyAccess(a,"return"))),e.createStatement(D(g))),1)]),void 0,e.setEmitFlags(e.createBlock([e.setEmitFlags(e.createIf(s,e.createThrow(e.createPropertyAccess(s,"error"))),1)]),1))]))}(n,r):e.restoreEnclosingLabel(e.visitEachChild(n,v,t),r)}function D(n){return 1&g?e.createYield(void 0,a(t,n)):e.createAwait(n)}function C(r){n();var a=[],s=e.addPrologue(a,r.body.statements,!1,v);E(a,r),a.push(e.createReturn(function(t,n){return t.requestEmitHelper(i),t.requestEmitHelper(o),(n.emitNode||(n.emitNode={})).flags|=262144,e.createCall(e.getHelperName("__asyncGenerator"),void 0,[e.createThis(),e.createIdentifier("arguments"),n])}(t,e.createFunctionExpression(void 0,e.createToken(39),r.name&&e.getGeneratedNameForNode(r.name),void 0,[],void 0,e.updateBlock(r.body,e.visitLexicalEnvironment(r.body.statements,v,t,s)))))),e.addRange(a,c());var u=e.updateBlock(r.body,a);return p>=2&&(4096&l.getNodeCheckFlags(r)?(N(),e.addEmitHelper(u,e.advancedAsyncSuperHelper)):2048&l.getNodeCheckFlags(r)&&(N(),e.addEmitHelper(u,e.asyncSuperHelper))),u}function T(t){n();var r=0,i=[],a=e.visitNode(t.body,v,e.isConciseBody);e.isBlock(a)&&(r=e.addPrologue(i,a.statements,!1,v)),e.addRange(i,E(void 0,t));var o=c();if(r>0||e.some(i)||e.some(o)){var s=e.convertToFunctionBody(a,!0);return e.addRange(i,s.statements.slice(r)),e.addRange(i,o),e.updateBlock(s,e.setTextRange(e.createNodeArray(i),s.statements))}return a}function E(n,r){for(var i=0,a=r.parameters;i<a.length;i++){var o=a[i];if(1048576&o.transformFlags){var s=e.getGeneratedNameForNode(o),c=e.flattenDestructuringBinding(o,v,t,1,s,!1,!0);if(e.some(c)){var u=e.createVariableStatement(void 0,e.createVariableDeclarationList(c));e.setEmitFlags(u,1048576),n=e.append(n,u)}}}return n}function N(){0==(1&m)&&(m|=1,t.enableSubstitution(181),t.enableSubstitution(179),t.enableSubstitution(180),t.enableEmitNotification(229),t.enableEmitNotification(151),t.enableEmitNotification(153),t.enableEmitNotification(154),t.enableEmitNotification(152))}function A(t){return 97===t.expression.kind?P(e.createLiteral(e.idText(t.name)),t):t}function w(e){return 97===e.expression.kind?P(e.argumentExpression,e):e}function P(t,n){return 4096&h?e.setTextRange(e.createPropertyAccess(e.createCall(e.createIdentifier("_super"),void 0,[t]),"value"),n):e.setTextRange(e.createCall(e.createIdentifier("_super"),void 0,[t]),n)}};var n={name:"typescript:assign",scoped:!1,priority:1,text:"\n            var __assign = (this && this.__assign) || Object.assign || function(t) {\n                for (var s, i = 1, n = arguments.length; i < n; i++) {\n                    s = arguments[i];\n                    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))\n                        t[p] = s[p];\n                }\n                return t;\n            };"};function r(t,r){return t.getCompilerOptions().target>=2?e.createCall(e.createPropertyAccess(e.createIdentifier("Object"),"assign"),void 0,r):(t.requestEmitHelper(n),e.createCall(e.getHelperName("__assign"),void 0,r))}e.createAssignHelper=r;var i={name:"typescript:await",scoped:!1,text:"\n            var __await = (this && this.__await) || function (v) { return this instanceof __await ? (this.v = v, this) : new __await(v); }\n        "};function a(t,n){return t.requestEmitHelper(i),e.createCall(e.getHelperName("__await"),void 0,[n])}var o={name:"typescript:asyncGenerator",scoped:!1,text:'\n            var __asyncGenerator = (this && this.__asyncGenerator) || function (thisArg, _arguments, generator) {\n                if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");\n                var g = generator.apply(thisArg, _arguments || []), i, q = [];\n                return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;\n                function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }\n                function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }\n                function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r);  }\n                function fulfill(value) { resume("next", value); }\n                function reject(value) { resume("throw", value); }\n                function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }\n            };\n        '};var s={name:"typescript:asyncDelegator",scoped:!1,text:'\n            var __asyncDelegator = (this && this.__asyncDelegator) || function (o) {\n                var i, p;\n                return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;\n                function verb(n, f) { if (o[n]) i[n] = function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; }; }\n            };\n        '};var c={name:"typescript:asyncValues",scoped:!1,text:'\n            var __asyncValues = (this && this.__asyncIterator) || function (o) {\n                if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");\n                var m = o[Symbol.asyncIterator];\n                return m ? m.call(o) : typeof __values === "function" ? __values(o) : o[Symbol.iterator]();\n            };\n        '};function u(t,n,r){return t.requestEmitHelper(c),e.setTextRange(e.createCall(e.getHelperName("__asyncValues"),void 0,[n]),r)}}(ts||(ts={})),function(e){e.transformJsx=function(n){var r=n.getCompilerOptions();return function(t){if(t.isDeclarationFile)return t;var r=e.visitEachChild(t,i,n);return e.addEmitHelpers(r,n.readEmitHelpers()),r};function i(t){return 4&t.transformFlags?function(t){switch(t.kind){case 249:return o(t,!1);case 250:return s(t,!1);case 256:return f(t);default:return e.visitEachChild(t,i,n)}}(t):t}function a(t){switch(t.kind){case 10:return function(t){var n=function(t){for(var n,r=0,i=-1,a=0;a<t.length;a++){var o=t.charCodeAt(a);e.isLineBreak(o)?(-1!==r&&-1!==i&&(n=l(n,t.substr(r,i-r+1))),r=-1):e.isWhiteSpaceSingleLine(o)||(i=a,-1===r&&(r=a))}return-1!==r?l(n,t.substr(r)):n}(e.getTextOfNode(t,!0));return void 0===n?void 0:e.createLiteral(n)}(t);case 256:return f(t);case 249:return o(t,!0);case 250:return s(t,!0);default:return void e.Debug.failBadSyntaxKind(t)}}function o(e,t){return c(e.openingElement,e.children,t,e)}function s(e,t){return c(e,void 0,t,e)}function c(t,i,o,s){var c,l=p(t),d=t.attributes.properties;if(0===d.length)c=e.createNull();else{var f=e.flatten(e.spanMap(d,e.isJsxSpreadAttribute,(function(t,n){return n?e.map(t,u):e.createObjectLiteral(e.map(t,_))})));e.isJsxSpreadAttribute(d[0])&&f.unshift(e.createObjectLiteral()),(c=e.singleOrUndefined(f))||(c=e.createAssignHelper(n,f))}var m=e.createExpressionForJsxElement(n.getEmitResolver().getJsxFactoryEntity(),r.reactNamespace,l,c,e.mapDefined(i,a),t,s);return o&&e.startOnNewLine(m),m}function u(t){return e.visitNode(t.expression,i,e.isExpression)}function _(t){var n=function(t){var n=t.name,r=e.idText(n);return/^[A-Za-z_]\w*$/.test(r)?n:e.createLiteral(r)}(t),r=function(t){if(void 0===t)return e.createTrue();if(9===t.kind){var n=function(e){var t=d(e);return t===e?void 0:t}(t.text);return n?e.setTextRange(e.createLiteral(n),t):t}if(256===t.kind)return void 0===t.expression?e.createTrue():f(t);e.Debug.failBadSyntaxKind(t)}(t.initializer);return e.createPropertyAssignment(n,r)}function l(e,t){var n=d(t);return void 0===e?n:e+" "+n}function d(e){return e.replace(/&((#((\d+)|x([\da-fA-F]+)))|(\w+));/g,(function(e,n,r,i,a,o,s){if(a)return String.fromCharCode(parseInt(a,10));if(o)return String.fromCharCode(parseInt(o,16));var c=t.get(s);return c?String.fromCharCode(c):e}))}function p(t){if(249===t.kind)return p(t.openingElement);var n=t.tagName;return e.isIdentifier(n)&&e.isIntrinsicJsxName(n.escapedText)?e.createLiteral(e.idText(n)):e.createExpressionFromEntityName(n)}function f(t){return e.visitNode(t.expression,i,e.isExpression)}};var t=e.createMapFromTemplate({quot:34,amp:38,apos:39,lt:60,gt:62,nbsp:160,iexcl:161,cent:162,pound:163,curren:164,yen:165,brvbar:166,sect:167,uml:168,copy:169,ordf:170,laquo:171,not:172,shy:173,reg:174,macr:175,deg:176,plusmn:177,sup2:178,sup3:179,acute:180,micro:181,para:182,middot:183,cedil:184,sup1:185,ordm:186,raquo:187,frac14:188,frac12:189,frac34:190,iquest:191,Agrave:192,Aacute:193,Acirc:194,Atilde:195,Auml:196,Aring:197,AElig:198,Ccedil:199,Egrave:200,Eacute:201,Ecirc:202,Euml:203,Igrave:204,Iacute:205,Icirc:206,Iuml:207,ETH:208,Ntilde:209,Ograve:210,Oacute:211,Ocirc:212,Otilde:213,Ouml:214,times:215,Oslash:216,Ugrave:217,Uacute:218,Ucirc:219,Uuml:220,Yacute:221,THORN:222,szlig:223,agrave:224,aacute:225,acirc:226,atilde:227,auml:228,aring:229,aelig:230,ccedil:231,egrave:232,eacute:233,ecirc:234,euml:235,igrave:236,iacute:237,icirc:238,iuml:239,eth:240,ntilde:241,ograve:242,oacute:243,ocirc:244,otilde:245,ouml:246,divide:247,oslash:248,ugrave:249,uacute:250,ucirc:251,uuml:252,yacute:253,thorn:254,yuml:255,OElig:338,oelig:339,Scaron:352,scaron:353,Yuml:376,fnof:402,circ:710,tilde:732,Alpha:913,Beta:914,Gamma:915,Delta:916,Epsilon:917,Zeta:918,Eta:919,Theta:920,Iota:921,Kappa:922,Lambda:923,Mu:924,Nu:925,Xi:926,Omicron:927,Pi:928,Rho:929,Sigma:931,Tau:932,Upsilon:933,Phi:934,Chi:935,Psi:936,Omega:937,alpha:945,beta:946,gamma:947,delta:948,epsilon:949,zeta:950,eta:951,theta:952,iota:953,kappa:954,lambda:955,mu:956,nu:957,xi:958,omicron:959,pi:960,rho:961,sigmaf:962,sigma:963,tau:964,upsilon:965,phi:966,chi:967,psi:968,omega:969,thetasym:977,upsih:978,piv:982,ensp:8194,emsp:8195,thinsp:8201,zwnj:8204,zwj:8205,lrm:8206,rlm:8207,ndash:8211,mdash:8212,lsquo:8216,rsquo:8217,sbquo:8218,ldquo:8220,rdquo:8221,bdquo:8222,dagger:8224,Dagger:8225,bull:8226,hellip:8230,permil:8240,prime:8242,Prime:8243,lsaquo:8249,rsaquo:8250,oline:8254,frasl:8260,euro:8364,image:8465,weierp:8472,real:8476,trade:8482,alefsym:8501,larr:8592,uarr:8593,rarr:8594,darr:8595,harr:8596,crarr:8629,lArr:8656,uArr:8657,rArr:8658,dArr:8659,hArr:8660,forall:8704,part:8706,exist:8707,empty:8709,nabla:8711,isin:8712,notin:8713,ni:8715,prod:8719,sum:8721,minus:8722,lowast:8727,radic:8730,prop:8733,infin:8734,ang:8736,and:8743,or:8744,cap:8745,cup:8746,int:8747,there4:8756,sim:8764,cong:8773,asymp:8776,ne:8800,equiv:8801,le:8804,ge:8805,sub:8834,sup:8835,nsub:8836,sube:8838,supe:8839,oplus:8853,otimes:8855,perp:8869,sdot:8901,lceil:8968,rceil:8969,lfloor:8970,rfloor:8971,lang:9001,rang:9002,loz:9674,spades:9824,clubs:9827,hearts:9829,diams:9830})}(ts||(ts={})),function(e){e.transformES2016=function(t){var n=t.hoistVariableDeclaration;return function(n){if(n.isDeclarationFile)return n;return e.visitEachChild(n,r,t)};function r(i){if(0==(32&i.transformFlags))return i;switch(i.kind){case 194:return function(i){switch(i.operatorToken.kind){case 62:return function(t){var i,a,o=e.visitNode(t.left,r,e.isExpression),s=e.visitNode(t.right,r,e.isExpression);if(e.isElementAccessExpression(o)){var c=e.createTempVariable(n),u=e.createTempVariable(n);i=e.setTextRange(e.createElementAccess(e.setTextRange(e.createAssignment(c,o.expression),o.expression),e.setTextRange(e.createAssignment(u,o.argumentExpression),o.argumentExpression)),o),a=e.setTextRange(e.createElementAccess(c,u),o)}else if(e.isPropertyAccessExpression(o)){c=e.createTempVariable(n);i=e.setTextRange(e.createPropertyAccess(e.setTextRange(e.createAssignment(c,o.expression),o.expression),o.name),o),a=e.setTextRange(e.createPropertyAccess(c,o.name),o)}else i=o,a=o;return e.setTextRange(e.createAssignment(i,e.createMathPow(a,s,t)),t)}(i);case 40:return function(t){var n=e.visitNode(t.left,r,e.isExpression),i=e.visitNode(t.right,r,e.isExpression);return e.createMathPow(n,i,t)}(i);default:return e.visitEachChild(i,r,t)}}(i);default:return e.visitEachChild(i,r,t)}}}}(ts||(ts={})),function(e){var t,n,r,i,a;!function(e){e[e.CapturedThis=1]="CapturedThis",e[e.BlockScopedBindings=2]="BlockScopedBindings"}(t||(t={})),function(e){e[e.ToOriginal=0]="ToOriginal",e[e.ToOutParameter=1]="ToOutParameter"}(n||(n={})),function(e){e[e.Break=2]="Break",e[e.Continue=4]="Continue",e[e.Return=8]="Return"}(r||(r={})),function(e){e[e.NoReplacement=0]="NoReplacement",e[e.ReplaceSuperCapture=1]="ReplaceSuperCapture",e[e.ReplaceWithReturn=2]="ReplaceWithReturn"}(i||(i={})),function(e){e[e.None=0]="None",e[e.Function=1]="Function",e[e.ArrowFunction=2]="ArrowFunction",e[e.AsyncFunctionBody=4]="AsyncFunctionBody",e[e.NonStaticClassElement=8]="NonStaticClassElement",e[e.CapturesThis=16]="CapturesThis",e[e.ExportedVariableStatement=32]="ExportedVariableStatement",e[e.TopLevel=64]="TopLevel",e[e.Block=128]="Block",e[e.IterationStatement=256]="IterationStatement",e[e.IterationStatementBlock=512]="IterationStatementBlock",e[e.ForStatement=1024]="ForStatement",e[e.ForInOrForOfStatement=2048]="ForInOrForOfStatement",e[e.ConstructorWithCapturedSuper=4096]="ConstructorWithCapturedSuper",e[e.ComputedPropertyName=8192]="ComputedPropertyName",e[e.AncestorFactsMask=16383]="AncestorFactsMask",e[e.BlockScopeIncludes=0]="BlockScopeIncludes",e[e.BlockScopeExcludes=4032]="BlockScopeExcludes",e[e.SourceFileIncludes=64]="SourceFileIncludes",e[e.SourceFileExcludes=3968]="SourceFileExcludes",e[e.FunctionIncludes=65]="FunctionIncludes",e[e.FunctionExcludes=16286]="FunctionExcludes",e[e.AsyncFunctionBodyIncludes=69]="AsyncFunctionBodyIncludes",e[e.AsyncFunctionBodyExcludes=16278]="AsyncFunctionBodyExcludes",e[e.ArrowFunctionIncludes=66]="ArrowFunctionIncludes",e[e.ArrowFunctionExcludes=16256]="ArrowFunctionExcludes",e[e.ConstructorIncludes=73]="ConstructorIncludes",e[e.ConstructorExcludes=16278]="ConstructorExcludes",e[e.DoOrWhileStatementIncludes=256]="DoOrWhileStatementIncludes",e[e.DoOrWhileStatementExcludes=0]="DoOrWhileStatementExcludes",e[e.ForStatementIncludes=1280]="ForStatementIncludes",e[e.ForStatementExcludes=3008]="ForStatementExcludes",e[e.ForInOrForOfStatementIncludes=2304]="ForInOrForOfStatementIncludes",e[e.ForInOrForOfStatementExcludes=1984]="ForInOrForOfStatementExcludes",e[e.BlockIncludes=128]="BlockIncludes",e[e.BlockExcludes=3904]="BlockExcludes",e[e.IterationStatementBlockIncludes=512]="IterationStatementBlockIncludes",e[e.IterationStatementBlockExcludes=4032]="IterationStatementBlockExcludes",e[e.ComputedPropertyNameIncludes=8192]="ComputedPropertyNameIncludes",e[e.ComputedPropertyNameExcludes=0]="ComputedPropertyNameExcludes",e[e.NewTarget=16384]="NewTarget",e[e.NewTargetInComputedPropertyName=32768]="NewTargetInComputedPropertyName",e[e.SubtreeFactsMask=-16384]="SubtreeFactsMask",e[e.PropagateNewTargetMask=49152]="PropagateNewTargetMask"}(a||(a={})),e.transformES2015=function(t){var n,r,i,a,c,u,_=t.startLexicalEnvironment,l=t.resumeLexicalEnvironment,d=t.endLexicalEnvironment,p=t.hoistVariableDeclaration,f=t.getCompilerOptions(),m=t.getEmitResolver(),g=t.onSubstituteNode,y=t.onEmitNode;return t.onEmitNode=function(t,n,r){if(1&u&&e.isFunctionLike(n)){var i=h(16286,8&e.getEmitFlags(n)?81:65);return y(t,n,r),void v(i,0,0)}y(t,n,r)},t.onSubstituteNode=function(t,n){if(n=g(t,n),1===t)return function(t){switch(t.kind){case 71:return function(t){if(2&u&&!e.isInternalName(t)){var n=m.getReferencedDeclarationWithCollidingName(t);if(n&&(!e.isClassLike(n)||!function(t,n){var r=e.getParseTreeNode(n);if(!r||r===t||r.end<=t.pos||r.pos>=t.end)return!1;var i=e.getEnclosingBlockScopeContainer(t);for(;r;){if(r===i||r===t)return!1;if(e.isClassElement(r)&&r.parent===t)return!0;r=r.parent}return!1}(n,t)))return e.setTextRange(e.getGeneratedNameForNode(e.getNameOfDeclaration(n)),t)}return t}(t);case 99:return function(t){if(1&u&&16&i)return e.setTextRange(e.createIdentifier("_this"),t);return t}(t)}return t}(n);if(e.isIdentifier(n))return function(t){if(2&u&&!e.isInternalName(t)){var n=e.getParseTreeNode(t,e.isIdentifier);if(n&&function(e){var t=e.parent;switch(t.kind){case 176:case 229:case 232:case 226:return t.name===e&&m.isDeclarationWithCollidingName(t)}return!1}(n))return e.setTextRange(e.getGeneratedNameForNode(n),t)}return t}(n);return n},function(o){if(o.isDeclarationFile)return o;n=o,r=o.text;var s=function(t){var n=h(3968,64),r=[];_();var i=e.addStandardPrologue(r,t.statements,!1);I(r,t),i=e.addCustomPrologue(r,t.statements,i,k),e.addRange(r,e.visitNodes(t.statements,k,e.isStatement,i)),a&&r.push(e.createVariableStatement(void 0,e.createVariableDeclarationList(a)));return e.addRange(r,d()),v(n,0,0),e.updateSourceFileNode(t,e.setTextRange(e.createNodeArray(r),t.statements))}(o);return e.addEmitHelpers(s,t.readEmitHelpers()),n=void 0,r=void 0,a=void 0,i=0,s};function h(e,t){var n=i;return i=16383&(i&~e|t),n}function v(e,t,n){i=-16384&(i&~t|n)|e}function b(e){return 4096&i&&219===e.kind&&!e.expression}function x(t){return 0!=(128&t.transformFlags)||void 0!==c||4096&i&&(e.isStatement(t)||207===t.kind)||e.isIterationStatement(t,!1)&&ae(t)||0!=(33554432&e.getEmitFlags(t))}function k(r){return x(r)?function(r){switch(r.kind){case 115:return;case 229:return function(t){var n=e.createVariableDeclaration(e.getLocalName(t,!0),void 0,T(t));e.setOriginalNode(n,t);var r=[],i=e.createVariableStatement(void 0,e.createVariableDeclarationList([n]));if(e.setOriginalNode(i,t),e.setTextRange(i,t),e.startOnNewLine(i),r.push(i),e.hasModifier(t,1)){var a=e.hasModifier(t,512)?e.createExportDefault(e.getLocalName(t)):e.createExternalModuleExport(e.getLocalName(t));e.setOriginalNode(a,i),r.push(a)}var o=e.getEmitFlags(t);0==(4194304&o)&&(r.push(e.createEndOfDeclarationMarker(t)),e.setEmitFlags(i,4194304|o));return e.singleOrMany(r)}(r);case 199:return function(e){return T(e)}(r);case 146:return function(t){return t.dotDotDotToken?void 0:e.isBindingPattern(t.name)?e.setOriginalNode(e.setTextRange(e.createParameter(void 0,void 0,void 0,e.getGeneratedNameForNode(t),void 0,void 0,void 0),t),t):t.initializer?e.setOriginalNode(e.setTextRange(e.createParameter(void 0,void 0,void 0,t.name,void 0,void 0,void 0),t),t):t}(r);case 228:return function(n){var r=c;c=void 0;var a=h(16286,65),o=e.visitParameterList(n.parameters,k,t),s=64&n.transformFlags?K(n):U(n),u=16384&i?e.getLocalName(n):n.name;return v(a,49152,0),c=r,e.updateFunctionDeclaration(n,void 0,e.visitNodes(n.modifiers,k,e.isModifier),n.asteriskToken,u,void 0,o,void 0,s)}(r);case 187:return function(n){16384&n.transformFlags&&De();var r=c;c=void 0;var i=h(16256,66),a=e.createFunctionExpression(void 0,void 0,void 0,void 0,e.visitParameterList(n.parameters,k,t),void 0,K(n));return e.setTextRange(a,n),e.setOriginalNode(a,n),e.setEmitFlags(a,8),v(i,0,0),c=r,a}(r);case 186:return function(n){var r=262144&e.getEmitFlags(n)?h(16278,69):h(16286,65),a=c;c=void 0;var o=e.visitParameterList(n.parameters,k,t),s=64&n.transformFlags?K(n):U(n),u=16384&i?e.getLocalName(n):n.name;return v(r,49152,0),c=a,e.updateFunctionExpression(n,void 0,n.asteriskToken,u,void 0,o,void 0,s)}(r);case 226:return G(r);case 71:return function(t){if(!c)return t;if(e.isGeneratedIdentifier(t))return t;if("arguments"!==t.escapedText||!m.isArgumentsLocalBinding(t))return t;return c.argumentsName||(c.argumentsName=e.createUniqueName("arguments"))}(r);case 227:return function(n){if(64&n.transformFlags){3&n.flags&&Se();var r=e.flatMap(n.declarations,1&n.flags?H:G),i=e.createVariableDeclarationList(r);if(e.setOriginalNode(i,n),e.setTextRange(i,n),e.setCommentRange(i,n),8388608&n.transformFlags&&(e.isBindingPattern(n.declarations[0].name)||e.isBindingPattern(e.lastOrUndefined(n.declarations).name))){var a=e.firstOrUndefined(r);if(a){var o=e.lastOrUndefined(r);e.setSourceMapRange(i,e.createRange(a.pos,o.end))}}return i}return e.visitEachChild(n,k,t)}(r);case 221:return function(n){if(void 0!==c){var r=c.allowedNonLabeledJumps;c.allowedNonLabeledJumps|=2;var i=e.visitEachChild(n,k,t);return c.allowedNonLabeledJumps=r,i}return e.visitEachChild(n,k,t)}(r);case 235:return function(n){var r=h(4032,0),i=e.visitEachChild(n,k,t);return v(r,0,0),i}(r);case 207:return V(r,!1);case 218:case 217:return function(n){if(c){var r=218===n.kind?2:4;if(!(n.label&&c.labels&&c.labels.get(e.idText(n.label))||!n.label&&c.allowedNonLabeledJumps&r)){var i=void 0;n.label?218===n.kind?(i="break-"+n.label.escapedText,ue(c,!0,e.idText(n.label),i)):(i="continue-"+n.label.escapedText,ue(c,!1,e.idText(n.label),i)):218===n.kind?(c.nonLocalJumps|=2,i="break"):(c.nonLocalJumps|=4,i="continue");var a=e.createLiteral(i);if(c.loopOutParameters.length){for(var o=c.loopOutParameters,s=void 0,u=0;u<o.length;u++){var _=se(o[u],1);s=0===u?_:e.createBinary(s,26,_)}a=e.createBinary(s,26,a)}return e.createReturn(a)}}return e.visitEachChild(n,k,t)}(r);case 222:return function(t){c&&!c.labels&&(c.labels=e.createMap());var n=e.unwrapInnermostStatementOfLabel(t,c&&Q);return e.isIterationStatement(n,!1)?function(e,t){switch(e.kind){case 212:case 213:return Z(e,t);case 214:return $(e,t);case 215:return ee(e,t);case 216:return te(e,t)}}(n,t):e.restoreEnclosingLabel(e.visitNode(n,k,e.isStatement),t,c&&X)}(r);case 212:case 213:return Z(r,void 0);case 214:return $(r,void 0);case 215:return ee(r,void 0);case 216:return te(r,void 0);case 210:return function(n){switch(n.expression.kind){case 185:return e.updateStatement(n,q(n.expression,!1));case 194:return e.updateStatement(n,W(n.expression,!1))}return e.visitEachChild(n,k,t)}(r);case 178:return function(n){for(var r=n.properties,a=r.length,o=a,s=a,c=0;c<a;c++){var u=r[c];if(16777216&u.transformFlags&&4&i&&c<s&&(s=c),144===u.name.kind){o=c;break}}if(o!==a){s<o&&(o=s);var _=e.createTempVariable(p),l=[],d=e.createAssignment(_,e.setEmitFlags(e.createObjectLiteral(e.visitNodes(r,k,e.isObjectLiteralElementLike,0,o),n.multiLine),65536));return n.multiLine&&(d.startsOnNewLine=!0),l.push(d),function(t,n,r,i){for(var a=n.properties,o=a.length,s=i;s<o;s++){var c=a[s];switch(c.kind){case 153:case 154:var u=e.getAllAccessorDeclarations(n.properties,c);c===u.firstAccessor&&t.push(z(r,u,n,n.multiLine));break;case 151:t.push(fe(c,r,n,n.multiLine));break;case 261:t.push(de(c,r,n.multiLine));break;case 262:t.push(pe(c,r,n.multiLine));break;default:e.Debug.failBadSyntaxKind(n)}}}(l,n,_,o),l.push(n.multiLine?e.startOnNewLine(e.getMutableClone(_)):_),e.inlineExpressions(l)}return e.visitEachChild(n,k,t)}(r);case 260:return function(n){var r,i=h(4032,0);if(e.Debug.assert(!!n.variableDeclaration,"Catch clause variable should always be present when downleveling ES2015."),e.isBindingPattern(n.variableDeclaration.name)){var a=e.createTempVariable(void 0),o=e.createVariableDeclaration(a);e.setTextRange(o,n.variableDeclaration);var s=e.flattenDestructuringBinding(n.variableDeclaration,k,t,0,a),c=e.createVariableDeclarationList(s);e.setTextRange(c,n.variableDeclaration);var u=e.createVariableStatement(void 0,c);r=e.updateCatchClause(n,o,(_=n.block,l=u,d=e.visitNodes(_.statements,k,e.isStatement),e.updateBlock(_,[l].concat(d))))}else r=e.visitEachChild(n,k,t);var _,l,d;return v(i,0,0),r}(r);case 262:return function(t){return e.setTextRange(e.createPropertyAssignment(t.name,e.getSynthesizedClone(t.name)),t)}(r);case 144:return function(n){var r=h(0,8192),a=e.visitEachChild(n,k,t);return v(r,49152,49152&i?32768:0),a}(r);case 177:return function(n){if(64&n.transformFlags)return ge(n.elements,!0,n.multiLine,n.elements.hasTrailingComma);return e.visitEachChild(n,k,t)}(r);case 181:return function(t){if(33554432&e.getEmitFlags(t))return function(t){var n=e.cast(e.cast(e.skipOuterExpressions(t.expression),e.isArrowFunction).body,e.isBlock),r=e.visitNodes(n.statements,k,e.isStatement,0,1),i=e.visitNodes(n.statements,k,e.isStatement,1,n.statements.length-1),a=e.cast(e.firstOrUndefined(r),e.isVariableStatement).declarationList.declarations[0],o=e.skipOuterExpressions(a.initializer),s=e.tryCast(o,e.isAssignmentExpression),c=e.cast(s?e.skipOuterExpressions(s.right):o,e.isCallExpression),u=e.cast(e.skipOuterExpressions(c.expression),e.isFunctionExpression),_=u.body.statements,l=0,d=-1,p=[];if(s){var f=e.tryCast(_[l],e.isExpressionStatement);f&&(p.push(f),l++),p.push(_[l]),l++,p.push(e.createStatement(e.createAssignment(s.left,e.cast(a.name,e.isIdentifier))))}for(;!e.isReturnStatement(e.elementAt(_,d));)d--;e.addRange(p,_,l,d),d<-1&&e.addRange(p,_,d+1);return e.addRange(p,i),e.addRange(p,r,1),e.recreateOuterExpressions(t.expression,e.recreateOuterExpressions(a.initializer,e.recreateOuterExpressions(s&&s.right,e.updateCall(c,e.recreateOuterExpressions(c.expression,e.updateFunctionExpression(u,void 0,void 0,void 0,void 0,u.parameters,void 0,e.updateBlock(u.body,p))),void 0,c.arguments))))}(t);if(64&t.transformFlags)return me(t,!0);return e.updateCall(t,e.visitNode(t.expression,D,e.isExpression),void 0,e.visitNodes(t.arguments,k,e.isExpression))}(r);case 182:return function(n){if(524288&n.transformFlags){var r=e.createCallBinding(e.createPropertyAccess(n.expression,"bind"),p),i=r.target,a=r.thisArg;return e.createNew(e.createFunctionApply(e.visitNode(i,k,e.isExpression),a,ge(e.createNodeArray([e.createVoidZero()].concat(n.arguments)),!1,!1,!1)),void 0,[])}return e.visitEachChild(n,k,t)}(r);case 185:return q(r,!0);case 194:return W(r,!0);case 13:case 14:case 15:case 16:return function(t){return e.setTextRange(e.createLiteral(t.text),t)}(r);case 9:return function(t){if(t.hasExtendedUnicodeEscape)return e.setTextRange(e.createLiteral(t.text),t);return t}(r);case 8:return function(t){if(48&t.numericLiteralFlags)return e.setTextRange(e.createNumericLiteral(t.text),t);return t}(r);case 183:return function(r){var i=e.visitNode(r.tag,k,e.isExpression),o=[void 0],c=[],u=[],_=r.template;if(e.isNoSubstitutionTemplateLiteral(_))c.push(e.createLiteral(_.text)),u.push(xe(_));else{c.push(e.createLiteral(_.head.text)),u.push(xe(_.head));for(var l=0,d=_.templateSpans;l<d.length;l++){var p=d[l];c.push(e.createLiteral(p.literal.text)),u.push(xe(p.literal)),o.push(e.visitNode(p.expression,k,e.isExpression))}}var f=function(t,n,r){return t.requestEmitHelper(s),e.createCall(e.getHelperName("__makeTemplateObject"),void 0,[n,r])}(t,e.createArrayLiteral(c),e.createArrayLiteral(u));if(e.isExternalModule(n)){var m=e.createUniqueName("templateObject");g=m,a=e.append(a,e.createVariableDeclaration(g)),o[0]=e.createLogicalOr(m,e.createAssignment(m,f))}else o[0]=f;var g;return e.createCall(i,void 0,o)}(r);case 196:return function(t){var n=[];(function(t,n){if(!function(t){return e.Debug.assert(0!==t.templateSpans.length),0!==t.head.text.length||0===t.templateSpans[0].literal.text.length}(n))return;t.push(e.createLiteral(n.head.text))})(n,t),function(t,n){for(var r=0,i=n.templateSpans;r<i.length;r++){var a=i[r];t.push(e.visitNode(a.expression,k,e.isExpression)),0!==a.literal.text.length&&t.push(e.createLiteral(a.literal.text))}}(n,t);var r=e.reduceLeft(n,e.createAdd);e.nodeIsSynthesized(r)&&(r.pos=t.pos,r.end=t.end);return r}(r);case 197:return function(n){return e.visitEachChild(n,k,t)}(r);case 198:return function(t){return e.visitNode(t.expression,k,e.isExpression)}(r);case 97:return ke(!1);case 99:return function(t){if(c)return 2&i?(c.containsLexicalThis=!0,t):c.thisName||(c.thisName=e.createUniqueName("this"));return t}(r);case 204:return function(t){if(94===t.keywordToken&&"target"===t.name.escapedText)return i|=8192&i?32768:16384,e.createIdentifier("_newTarget");return t}(r);case 151:return function(t){e.Debug.assert(!e.isComputedPropertyName(t.name));var n=j(t,e.moveRangePos(t,-1),void 0,void 0);return e.setEmitFlags(n,512|e.getEmitFlags(n)),e.setTextRange(e.createPropertyAssignment(t.name,n),t)}(r);case 153:case 154:return function(n){e.Debug.assert(!e.isComputedPropertyName(n.name));var r=c;c=void 0;var i,a=h(16286,65);if(32768&n.transformFlags){var o=e.visitParameterList(n.parameters,k,t),s=K(n);i=153===n.kind?e.updateGetAccessor(n,n.decorators,n.modifiers,n.name,o,n.type,s):e.updateSetAccessor(n,n.decorators,n.modifiers,n.name,o,s)}else i=e.visitEachChild(n,k,t);return v(a,49152,0),c=r,i}(r);case 208:return function(n){var r,i=h(0,e.hasModifier(n,1)?32:0);if(c&&0==(3&n.declarationList.flags)){for(var a=void 0,o=0,s=n.declarationList.declarations;o<s.length;o++){var u=s[o];if(oe(c,u),u.initializer){var _=void 0;e.isBindingPattern(u.name)?_=e.flattenDestructuringAssignment(u,k,t,0):(_=e.createBinary(u.name,58,e.visitNode(u.initializer,k,e.isExpression)),e.setTextRange(_,u)),a=e.append(a,_)}}r=a?e.setTextRange(e.createStatement(e.inlineExpressions(a)),n):void 0}else r=e.visitEachChild(n,k,t);return v(i,0,0),r}(r);case 219:return function(n){if(c)return c.nonLocalJumps|=8,b(n)&&(n=C(n)),e.createReturn(e.createObjectLiteral([e.createPropertyAssignment(e.createIdentifier("value"),n.expression?e.visitNode(n.expression,k,e.isExpression):e.createVoidZero())]));if(b(n))return C(n);return e.visitEachChild(n,k,t)}(r);default:return e.visitEachChild(r,k,t)}}(r):r}function S(e){return x(e)?V(e,!0):e}function D(e){return 97===e.kind?ke(!0):k(e)}function C(t){return e.setOriginalNode(e.createReturn(e.createIdentifier("_this")),t)}function T(n){n.name&&Se();var a=e.getClassExtendsHeritageClauseElement(n),s=e.createFunctionExpression(void 0,void 0,void 0,void 0,a?[e.createParameter(void 0,void 0,void 0,"_super")]:[],void 0,function(n,a){var s=[];_(),function(n,r,i){i&&n.push(e.setTextRange(e.createStatement(function(t,n){return t.requestEmitHelper(o),e.createCall(e.getHelperName("__extends"),void 0,[n,e.createIdentifier("_super")])}(t,e.getLocalName(r))),i))}(s,n,a),function(n,r,a){var o=c;c=void 0;var s=h(16278,73),u=e.getFirstConstructorWithBody(r),_=function(t,n){if(!t||!n)return!1;if(e.some(t.parameters))return!1;var r=e.firstOrUndefined(t.body.statements);if(!r||!e.nodeIsSynthesized(r)||210!==r.kind)return!1;var i=r.expression;if(!e.nodeIsSynthesized(i)||181!==i.kind)return!1;var a=i.expression;if(!e.nodeIsSynthesized(a)||97!==a.kind)return!1;var o=e.singleOrUndefined(i.arguments);if(!o||!e.nodeIsSynthesized(o)||198!==o.kind)return!1;var s=o.expression;return e.isIdentifier(s)&&"arguments"===s.escapedText}(u,void 0!==a),p=e.createFunctionDeclaration(void 0,void 0,void 0,e.getInternalName(r),void 0,function(n,r){return e.visitParameterList(n&&!r&&n.parameters,k,t)||[]}(u,_),void 0,function(t,n,r,a){var o=[];l();var s=-1;a?s=0:t&&(s=e.addStandardPrologue(o,t.body.statements,!1));t&&(w(o,t),O(o,t,a),a||(s=e.addCustomPrologue(o,t.body.statements,s,k)),e.Debug.assert(s>=0,"statementOffset not initialized correctly!"));var c=r&&95!==e.skipOuterExpressions(r.expression).kind,u=function(t,n,r,i,a){if(!r)return n&&I(t,n),0;if(!n)return t.push(e.createReturn(A())),2;if(i)return R(t,n,A()),De(),1;var o,s,c=n.body.statements;a<c.length&&210===(o=c[a]).kind&&e.isSuperCall(o.expression)&&(s=function(e){return me(e,!1)}(o.expression));if(s&&a===c.length-1&&!(49152&n.transformFlags)){var u=e.createReturn(s);return 194===s.kind&&181===s.left.kind||e.Debug.fail("Assumed generated super call would have form 'super.call(...) || this'."),e.setCommentRange(u,e.getCommentRange(e.setEmitFlags(s.left,1536))),t.push(u),2}if(R(t,n,s||N(),o),s)return 1;return 0}(o,t,c,a,s);1!==u&&2!==u||s++;t&&(1===u&&(i|=4096),e.addRange(o,e.visitNodes(t.body.statements,k,e.isStatement,s)));!c||2===u||t&&E(t.body)||o.push(e.createReturn(e.createIdentifier("_this")));e.addRange(o,d()),t&&L(o,t,!1);var _=e.createBlock(e.setTextRange(e.createNodeArray(o),t?t.body.statements:n.members),!0);e.setTextRange(_,t?t.body:n),t||e.setEmitFlags(_,1536);return _}(u,r,a,_));e.setTextRange(p,u||r),a&&e.setEmitFlags(p,8);n.push(p),v(s,49152,0),c=o}(s,n,a),function(t,n){for(var r=0,i=n.members;r<i.length;r++){var a=i[r];switch(a.kind){case 206:t.push(M(a));break;case 151:t.push(B(Ce(n,a),a,n));break;case 153:case 154:var o=e.getAllAccessorDeclarations(n.members,a);a===o.firstAccessor&&t.push(J(Ce(n,a),o,n));break;case 152:break;default:e.Debug.failBadSyntaxKind(n)}}}(s,n);var u=e.createTokenRange(e.skipTrivia(r,n.members.end),18),p=e.getInternalName(n),f=e.createPartiallyEmittedExpression(p);f.end=u.end,e.setEmitFlags(f,1536);var m=e.createReturn(f);m.pos=u.pos,e.setEmitFlags(m,1920),s.push(m),e.addRange(s,d());var g=e.createBlock(e.setTextRange(e.createNodeArray(s),n.members),!0);return e.setEmitFlags(g,1536),g}(n,a));65536&e.getEmitFlags(n)&&e.setEmitFlags(s,65536);var u=e.createPartiallyEmittedExpression(s);u.end=n.end,e.setEmitFlags(u,1536);var p=e.createPartiallyEmittedExpression(u);p.end=e.skipTrivia(r,n.pos),e.setEmitFlags(p,1536);var f=e.createParen(e.createCall(p,void 0,a?[e.visitNode(a.expression,k,e.isExpression)]:[]));return e.addSyntheticLeadingComment(f,3,"* @class "),f}function E(t){if(219===t.kind)return!0;if(211===t.kind){var n=t;if(n.elseStatement)return E(n.thenStatement)&&E(n.elseStatement)}else if(207===t.kind){var r=e.lastOrUndefined(t.statements);if(r&&E(r))return!0}return!1}function N(){return e.setEmitFlags(e.createThis(),4)}function A(){return e.createLogicalOr(e.createLogicalAnd(e.createStrictInequality(e.createIdentifier("_super"),e.createNull()),e.createFunctionApply(e.createIdentifier("_super"),N(),e.createIdentifier("arguments"))),N())}function w(t,n){if(function(e){return 0!=(131072&e.transformFlags)}(n))for(var r=0,i=n.parameters;r<i.length;r++){var a=i[r],o=a.name,s=a.initializer;a.dotDotDotToken||(e.isBindingPattern(o)?P(t,a,o,s):s&&F(t,a,o,s))}}function P(n,r,i,a){var o=e.getGeneratedNameForNode(r);i.elements.length>0?n.push(e.setEmitFlags(e.createVariableStatement(void 0,e.createVariableDeclarationList(e.flattenDestructuringBinding(r,k,t,0,o))),1048576)):a&&n.push(e.setEmitFlags(e.createStatement(e.createAssignment(o,e.visitNode(a,k,e.isExpression))),1048576))}function F(t,n,r,i){i=e.visitNode(i,k,e.isExpression);var a=e.createIf(e.createTypeCheck(e.getSynthesizedClone(r),"undefined"),e.setEmitFlags(e.setTextRange(e.createBlock([e.createStatement(e.setTextRange(e.createAssignment(e.setEmitFlags(e.getMutableClone(r),48),e.setEmitFlags(i,48|e.getEmitFlags(i))),n))]),n),417));a.startsOnNewLine=!0,e.setTextRange(a,n),e.setEmitFlags(a,1048992),t.push(a)}function O(t,n,r){var i=e.lastOrUndefined(n.parameters);if(function(e,t){return e&&e.dotDotDotToken&&71===e.name.kind&&!t}(i,r)){var a=e.getMutableClone(i.name);e.setEmitFlags(a,48);var o=e.getSynthesizedClone(i.name),s=n.parameters.length-1,c=e.createLoopVariable();t.push(e.setEmitFlags(e.setTextRange(e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration(a,void 0,e.createArrayLiteral([]))])),i),1048576));var u=e.createFor(e.setTextRange(e.createVariableDeclarationList([e.createVariableDeclaration(c,void 0,e.createLiteral(s))]),i),e.setTextRange(e.createLessThan(c,e.createPropertyAccess(e.createIdentifier("arguments"),"length")),i),e.setTextRange(e.createPostfixIncrement(c),i),e.createBlock([e.startOnNewLine(e.setTextRange(e.createStatement(e.createAssignment(e.createElementAccess(o,0===s?c:e.createSubtract(c,e.createLiteral(s))),e.createElementAccess(e.createIdentifier("arguments"),c))),i))]));e.setEmitFlags(u,1048576),e.startOnNewLine(u),t.push(u)}}function I(t,n){32768&n.transformFlags&&187!==n.kind&&R(t,n,e.createThis())}function R(t,n,r,i){De();var a=e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration("_this",void 0,r)]));e.setEmitFlags(a,1050112),e.setTextRange(a,i),e.setSourceMapRange(a,n),t.push(a)}function L(t,n,r){if(16384&i){var a=void 0;switch(n.kind){case 187:return t;case 151:case 153:case 154:a=e.createVoidZero();break;case 152:a=e.createPropertyAccess(e.setEmitFlags(e.createThis(),4),"constructor");break;case 228:case 186:a=e.createConditional(e.createLogicalAnd(e.setEmitFlags(e.createThis(),4),e.createBinary(e.setEmitFlags(e.createThis(),4),93,e.getLocalName(n))),e.createPropertyAccess(e.setEmitFlags(e.createThis(),4),"constructor"),e.createVoidZero());break;default:e.Debug.failBadSyntaxKind(n)}var o=e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration("_newTarget",void 0,a)]));if(r)return[o].concat(t);t.unshift(o)}return t}function M(t){return e.setTextRange(e.createEmptyStatement(),t)}function B(t,n,r){var a=h(0,0),o=e.getCommentRange(n),s=e.getSourceMapRange(n),c=e.createMemberAccessForPropertyName(t,e.visitNode(n.name,k,e.isPropertyName),n.name),u=j(n,n,void 0,r);e.setEmitFlags(u,1536),e.setSourceMapRange(u,s);var _=e.setTextRange(e.createStatement(e.createAssignment(c,u)),n);return e.setOriginalNode(_,n),e.setCommentRange(_,o),e.setEmitFlags(_,48),v(a,49152,49152&i?16384:0),_}function J(t,n,r){var i=e.createStatement(z(t,n,r,!1));return e.setEmitFlags(i,1536),e.setSourceMapRange(i,e.getSourceMapRange(n.firstAccessor)),i}function z(t,n,r,a){var o=n.firstAccessor,s=n.getAccessor,c=n.setAccessor,u=h(0,0),_=e.getMutableClone(t);e.setEmitFlags(_,1568),e.setSourceMapRange(_,o.name);var l=e.createExpressionForPropertyName(e.visitNode(o.name,k,e.isPropertyName));e.setEmitFlags(l,1552),e.setSourceMapRange(l,o.name);var d=[];if(s){var p=j(s,void 0,void 0,r);e.setSourceMapRange(p,e.getSourceMapRange(s)),e.setEmitFlags(p,512);var f=e.createPropertyAssignment("get",p);e.setCommentRange(f,e.getCommentRange(s)),d.push(f)}if(c){var m=j(c,void 0,void 0,r);e.setSourceMapRange(m,e.getSourceMapRange(c)),e.setEmitFlags(m,512);var g=e.createPropertyAssignment("set",m);e.setCommentRange(g,e.getCommentRange(c)),d.push(g)}d.push(e.createPropertyAssignment("enumerable",e.createTrue()),e.createPropertyAssignment("configurable",e.createTrue()));var y=e.createCall(e.createPropertyAccess(e.createIdentifier("Object"),"defineProperty"),void 0,[_,l,e.createObjectLiteral(d,!0)]);return a&&(y.startsOnNewLine=!0),v(u,49152,49152&i?16384:0),y}function j(n,r,a,o){var s=c;c=void 0;var u=o&&e.isClassLike(o)&&!e.hasModifier(n,32)?h(16286,73):h(16286,65),_=e.visitParameterList(n.parameters,k,t),l=K(n);return 16384&i&&!a&&(228===n.kind||186===n.kind)&&(a=e.getGeneratedNameForNode(n)),v(u,49152,0),c=s,e.setOriginalNode(e.setTextRange(e.createFunctionExpression(void 0,n.asteriskToken,a,void 0,_,void 0,l),r),n)}function K(r){var i,a,o,s=!1,c=!1,u=[],_=r.body;if(l(),e.isBlock(_)&&(o=e.addStandardPrologue(u,_.statements,!1)),I(u,r),w(u,r),O(u,r,!1),!s&&u.length>0&&(s=!0),e.isBlock(_))o=e.addCustomPrologue(u,_.statements,o,k),i=_.statements,e.addRange(u,e.visitNodes(_.statements,k,e.isStatement,o)),!s&&_.multiLine&&(s=!0);else{e.Debug.assert(187===r.kind),i=e.moveRangeEnd(_,-1);var d=r.equalsGreaterThanToken;e.nodeIsSynthesized(d)||e.nodeIsSynthesized(_)||(e.rangeEndIsOnSameLineAsRangeStart(d,_,n)?c=!0:s=!0);var p=e.visitNode(_,k,e.isExpression),f=e.createReturn(p);e.setTextRange(f,_),e.setEmitFlags(f,1440),u.push(f),a=_}var m=t.endLexicalEnvironment();e.addRange(u,m),L(u,r,!1),!s&&m&&m.length&&(s=!0);var g=e.createBlock(e.setTextRange(e.createNodeArray(u),i),s);return e.setTextRange(g,r.body),!s&&c&&e.setEmitFlags(g,1),a&&e.setTokenSourceMapRange(g,18,a),e.setOriginalNode(g,r.body),g}function U(n){var r=e.visitFunctionBody(n.body,S,t);return e.updateBlock(r,e.setTextRange(e.createNodeArray(L(r.statements,n,!0)),r.statements))}function V(n,r){if(r)return e.visitEachChild(n,k,t);var a=256&i?h(4032,512):h(3904,128),o=e.visitEachChild(n,k,t);return v(a,0,0),o}function q(n,r){if(!r)switch(n.expression.kind){case 185:return e.updateParen(n,q(n.expression,!1));case 194:return e.updateParen(n,W(n.expression,!1))}return e.visitEachChild(n,k,t)}function W(n,r){return e.isDestructuringAssignment(n)?e.flattenDestructuringAssignment(n,k,t,0,r):e.visitEachChild(n,k,t)}function H(n){var r=n.name;if(e.isBindingPattern(r))return G(n);if(!n.initializer&&function(e){var t=m.getNodeCheckFlags(e),n=131072&t,r=262144&t;return!(0!=(64&i)||n&&r&&0!=(512&i))&&0==(2048&i)&&(!m.isDeclarationWithCollidingName(e)||r&&!n&&0==(3072&i))}(n)){var a=e.getMutableClone(n);return a.initializer=e.createVoidZero(),a}return e.visitEachChild(n,k,t)}function G(n){var r,i=h(32,0);return r=e.isBindingPattern(n.name)?e.flattenDestructuringBinding(n,k,t,0,void 0,0!=(32&i)):e.visitEachChild(n,k,t),v(i,0,0),r}function Q(t){c.labels.set(e.idText(t.label),!0)}function X(t){c.labels.set(e.idText(t.label),!1)}function Y(n,r,a,o,s){var u=h(n,r),l=function(n,r,a){if(!ae(n)){var o=void 0;c&&(o=c.allowedNonLabeledJumps,c.allowedNonLabeledJumps=6);var s=a?a(n,r,void 0):e.restoreEnclosingLabel(e.visitEachChild(n,k,t),r,c&&X);return c&&(c.allowedNonLabeledJumps=o),s}var u,l=e.createUniqueName("_loop");switch(n.kind){case 214:case 215:case 216:var p=n.initializer;p&&227===p.kind&&(u=p)}var f=[],m=[];if(u&&3&e.getCombinedNodeFlags(u))for(var g=0,y=u.declarations;g<y.length;g++){le(y[g],f,m)}var h=c;c={loopOutParameters:m},h&&(h.argumentsName&&(c.argumentsName=h.argumentsName),h.thisName&&(c.thisName=h.thisName),h.hoistedLocalVariables&&(c.hoistedLocalVariables=h.hoistedLocalVariables));_();var v=e.visitNode(n.statement,k,e.isStatement,e.liftToBlock),b=d(),x=c;if(c=h,m.length||b){var S=e.isBlock(v)?v.statements.slice():[v];m.length&&ce(m,1,S),e.addRange(S,b),v=e.createBlock(S,!0)}e.isBlock(v)?v.multiLine=!0:v=e.createBlock([v],!0);var D=0!=(16777216&n.statement.transformFlags),C=D&&0!=(4&i),T=0;x.containsLexicalThis&&(T|=8);C&&(T|=262144);var E,N=[e.createVariableStatement(void 0,e.setEmitFlags(e.createVariableDeclarationList([e.createVariableDeclaration(l,void 0,e.setEmitFlags(e.createFunctionExpression(void 0,D?e.createToken(39):void 0,void 0,void 0,f,void 0,v),T))]),2097152))];x.argumentsName&&(h?h.argumentsName=x.argumentsName:(E||(E=[])).push(e.createVariableDeclaration(x.argumentsName,void 0,e.createIdentifier("arguments"))));x.thisName&&(h?h.thisName=x.thisName:(E||(E=[])).push(e.createVariableDeclaration(x.thisName,void 0,e.createIdentifier("this"))));if(x.hoistedLocalVariables)if(h)h.hoistedLocalVariables=x.hoistedLocalVariables;else{E||(E=[]);for(var A=0,w=x.hoistedLocalVariables;A<w.length;A++){var P=w[A];E.push(e.createVariableDeclaration(P))}}if(m.length){E||(E=[]);for(var F=0,O=m;F<O.length;F++){var I=O[F];E.push(e.createVariableDeclaration(I.outParamName))}}E&&N.push(e.createVariableStatement(void 0,e.createVariableDeclarationList(E)));var R,L=function(t,n,r,i){var a=c,o=[],s=!(-5&r.nonLocalJumps||r.labeledNonLocalBreaks||r.labeledNonLocalContinues),u=e.createCall(t,void 0,e.map(n,(function(e){return e.name}))),_=i?e.createYield(e.createToken(39),e.setEmitFlags(u,8388608)):u;if(s)o.push(e.createStatement(_)),ce(r.loopOutParameters,0,o);else{var l=e.createUniqueName("state"),d=e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration(l,void 0,_)]));if(o.push(d),ce(r.loopOutParameters,0,o),8&r.nonLocalJumps){var p=void 0;a?(a.nonLocalJumps|=8,p=e.createReturn(l)):p=e.createReturn(e.createPropertyAccess(l,"value")),o.push(e.createIf(e.createBinary(e.createTypeOf(l),34,e.createLiteral("object")),p))}if(2&r.nonLocalJumps&&o.push(e.createIf(e.createBinary(l,34,e.createLiteral("break")),e.createBreak())),r.labeledNonLocalBreaks||r.labeledNonLocalContinues){var f=[];_e(r.labeledNonLocalBreaks,!0,l,a,f),_e(r.labeledNonLocalContinues,!1,l,a,f),o.push(e.createSwitch(l,e.createCaseBlock(f)))}}return o}(l,f,x,D);if(a)R=a(n,r,L);else{var M=e.getMutableClone(n);M.statement=void 0,(M=e.visitEachChild(M,k,t)).statement=e.createBlock(L,!0),M.transformFlags=0,e.aggregateTransformFlags(M),R=e.restoreEnclosingLabel(M,r,c&&X)}return N.push(R),N}(a,o,s);return v(u,0,0),l}function Z(e,t){return Y(0,256,e,t)}function $(e,t){return Y(3008,1280,e,t)}function ee(e,t){return Y(1984,2304,e,t)}function te(e,t){return Y(1984,2304,e,t,f.downlevelIteration?ie:re)}function ne(n,r,i){var a,o,s=[];if(e.isVariableDeclarationList(n.initializer)){3&n.initializer.flags&&Se();var c=e.firstOrUndefined(n.initializer.declarations);if(c&&e.isBindingPattern(c.name)){var u=e.flattenDestructuringBinding(c,k,t,0,r),_=e.setTextRange(e.createVariableDeclarationList(u),n.initializer);e.setOriginalNode(_,n.initializer);var l=u[0],d=e.lastOrUndefined(u);e.setSourceMapRange(_,e.createRange(l.pos,d.end)),s.push(e.createVariableStatement(void 0,_))}else s.push(e.setTextRange(e.createVariableStatement(void 0,e.setOriginalNode(e.setTextRange(e.createVariableDeclarationList([e.createVariableDeclaration(c?c.name:e.createTempVariable(void 0),void 0,r)]),e.moveRangePos(n.initializer,-1)),n.initializer)),e.moveRangeEnd(n.initializer,-1)))}else{var p=e.createAssignment(n.initializer,r);e.isDestructuringAssignment(p)?(e.aggregateTransformFlags(p),s.push(e.createStatement(W(p,!1)))):(p.end=n.initializer.end,s.push(e.setTextRange(e.createStatement(e.visitNode(p,k,e.isExpression)),e.moveRangeEnd(n.initializer,-1))))}if(i)e.addRange(s,i);else{var f=e.visitNode(n.statement,k,e.isStatement,e.liftToBlock);e.isBlock(f)?(e.addRange(s,f.statements),a=f,o=f.statements):s.push(f)}return e.setEmitFlags(e.setTextRange(e.createBlock(e.setTextRange(e.createNodeArray(s),o),!0),a),432)}function re(t,n,r){var i=e.visitNode(t.expression,k,e.isExpression),a=e.createLoopVariable(),o=e.isIdentifier(i)?e.getGeneratedNameForNode(i):e.createTempVariable(void 0);e.setEmitFlags(i,48|e.getEmitFlags(i));var s=e.setTextRange(e.createFor(e.setEmitFlags(e.setTextRange(e.createVariableDeclarationList([e.setTextRange(e.createVariableDeclaration(a,void 0,e.createLiteral(0)),e.moveRangePos(t.expression,-1)),e.setTextRange(e.createVariableDeclaration(o,void 0,i),t.expression)]),t.expression),2097152),e.setTextRange(e.createLessThan(a,e.createPropertyAccess(o,"length")),t.expression),e.setTextRange(e.createPostfixIncrement(a),t.expression),ne(t,e.createElementAccess(o,a),r)),t);return e.setEmitFlags(s,256),e.setTextRange(s,t),e.restoreEnclosingLabel(s,n,c&&X)}function ie(n,r,i){var a=e.visitNode(n.expression,k,e.isExpression),o=e.isIdentifier(a)?e.getGeneratedNameForNode(a):e.createTempVariable(void 0),s=e.isIdentifier(a)?e.getGeneratedNameForNode(o):e.createTempVariable(void 0),u=e.createUniqueName("e"),_=e.getGeneratedNameForNode(u),l=e.createTempVariable(void 0),d=e.createValuesHelper(t,a,n.expression),f=e.createCall(e.createPropertyAccess(o,"next"),void 0,[]);p(u),p(l);var m=e.setEmitFlags(e.setTextRange(e.createFor(e.setEmitFlags(e.setTextRange(e.createVariableDeclarationList([e.setTextRange(e.createVariableDeclaration(o,void 0,d),n.expression),e.createVariableDeclaration(s,void 0,f)]),n.expression),2097152),e.createLogicalNot(e.createPropertyAccess(s,"done")),e.createAssignment(s,f),ne(n,e.createPropertyAccess(s,"value"),i)),n),256);return e.createTry(e.createBlock([e.restoreEnclosingLabel(m,r,c&&X)]),e.createCatchClause(e.createVariableDeclaration(_),e.setEmitFlags(e.createBlock([e.createStatement(e.createAssignment(u,e.createObjectLiteral([e.createPropertyAssignment("error",_)])))]),1)),e.createBlock([e.createTry(e.createBlock([e.setEmitFlags(e.createIf(e.createLogicalAnd(e.createLogicalAnd(s,e.createLogicalNot(e.createPropertyAccess(s,"done"))),e.createAssignment(l,e.createPropertyAccess(o,"return"))),e.createStatement(e.createFunctionCall(l,o,[]))),1)]),void 0,e.setEmitFlags(e.createBlock([e.setEmitFlags(e.createIf(u,e.createThrow(e.createPropertyAccess(u,"error"))),1)]),1))]))}function ae(e){return 0!=(65536&m.getNodeCheckFlags(e))}function oe(t,n){t.hoistedLocalVariables||(t.hoistedLocalVariables=[]),function n(r){if(71===r.kind)t.hoistedLocalVariables.push(r);else for(var i=0,a=r.elements;i<a.length;i++){var o=a[i];e.isOmittedExpression(o)||n(o.name)}}(n.name)}function se(t,n){var r=0===n?t.outParamName:t.originalName,i=0===n?t.originalName:t.outParamName;return e.createBinary(i,58,r)}function ce(t,n,r){for(var i=0,a=t;i<a.length;i++){var o=a[i];r.push(e.createStatement(se(o,n)))}}function ue(t,n,r,i){n?(t.labeledNonLocalBreaks||(t.labeledNonLocalBreaks=e.createMap()),t.labeledNonLocalBreaks.set(r,i)):(t.labeledNonLocalContinues||(t.labeledNonLocalContinues=e.createMap()),t.labeledNonLocalContinues.set(r,i))}function _e(t,n,r,i,a){t&&t.forEach((function(t,o){var s=[];if(!i||i.labels&&i.labels.get(o)){var c=e.createIdentifier(o);s.push(n?e.createBreak(c):e.createContinue(c))}else ue(i,n,o,t),s.push(e.createReturn(r));a.push(e.createCaseClause(e.createLiteral(t),s))}))}function le(t,n,r){var i=t.name;if(e.isBindingPattern(i))for(var a=0,o=i.elements;a<o.length;a++){var s=o[a];e.isOmittedExpression(s)||le(s,n,r)}else if(n.push(e.createParameter(void 0,void 0,void 0,i)),2097152&m.getNodeCheckFlags(t)){var c=e.createUniqueName("out_"+e.idText(i));r.push({originalName:i,outParamName:c})}}function de(t,n,r){var i=e.createAssignment(e.createMemberAccessForPropertyName(n,e.visitNode(t.name,k,e.isPropertyName)),e.visitNode(t.initializer,k,e.isExpression));return e.setTextRange(i,t),r&&(i.startsOnNewLine=!0),i}function pe(t,n,r){var i=e.createAssignment(e.createMemberAccessForPropertyName(n,e.visitNode(t.name,k,e.isPropertyName)),e.getSynthesizedClone(t.name));return e.setTextRange(i,t),r&&(i.startsOnNewLine=!0),i}function fe(t,n,r,a){var o=h(0,0),s=e.createAssignment(e.createMemberAccessForPropertyName(n,e.visitNode(t.name,k,e.isPropertyName)),j(t,t,void 0,r));return e.setTextRange(s,t),a&&(s.startsOnNewLine=!0),v(o,49152,49152&i?16384:0),s}function me(t,n){var r,i=e.createCallBinding(t.expression,p),a=i.target,o=i.thisArg;if(97===t.expression.kind&&e.setEmitFlags(o,4),r=524288&t.transformFlags?e.createFunctionApply(e.visitNode(a,D,e.isExpression),e.visitNode(o,k,e.isExpression),ge(t.arguments,!1,!1,!1)):e.createFunctionCall(e.visitNode(a,D,e.isExpression),e.visitNode(o,k,e.isExpression),e.visitNodes(t.arguments,k,e.isExpression),t),97===t.expression.kind){var s=e.createThis();e.setEmitFlags(s,4);var c=e.createLogicalOr(r,s);r=n?e.createAssignment(e.createIdentifier("_this"),c):c}return e.setOriginalNode(r,t)}function ge(n,r,i,a){var o=n.length,s=e.flatten(e.spanMap(n,ye,(function(e,t,n,r){return t(e,i,a&&r===o)})));if(f.downlevelIteration){if(1===s.length){var c=s[0];if(e.isCallExpression(c)&&e.isIdentifier(c.expression)&&4096&e.getEmitFlags(c.expression)&&"___spread"===c.expression.escapedText)return s[0]}return e.createSpreadHelper(t,s)}if(1===s.length){var u=n[0];return r&&e.isSpreadElement(u)&&177!==u.expression.kind?e.createArraySlice(s[0]):s[0]}return e.createArrayConcat(s.shift(),s)}function ye(t){return e.isSpreadElement(t)?he:ve}function he(t){return e.map(t,be)}function ve(t,n,r){return e.createArrayLiteral(e.visitNodes(e.createNodeArray(t,r),k,e.isExpression),n)}function be(t){return e.visitNode(t.expression,k,e.isExpression)}function xe(t){var r=e.getSourceTextOfNodeFromSourceFile(n,t),i=13===t.kind||16===t.kind;return r=(r=r.substring(1,r.length-(i?1:2))).replace(/\r\n?/g,"\n"),e.setTextRange(e.createLiteral(r),t)}function ke(t){return 8&i&&!t?e.createPropertyAccess(e.createIdentifier("_super"),"prototype"):e.createIdentifier("_super")}function Se(){0==(2&u)&&(u|=2,t.enableSubstitution(71))}function De(){0==(1&u)&&(u|=1,t.enableSubstitution(99),t.enableEmitNotification(152),t.enableEmitNotification(151),t.enableEmitNotification(153),t.enableEmitNotification(154),t.enableEmitNotification(187),t.enableEmitNotification(186),t.enableEmitNotification(228))}function Ce(t,n){return e.hasModifier(n,32)?e.getInternalName(t):e.createPropertyAccess(e.getInternalName(t),"prototype")}};var o={name:"typescript:extends",scoped:!1,priority:0,text:"\n            var __extends = (this && this.__extends) || (function () {\n                var extendStatics = Object.setPrototypeOf ||\n                    ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||\n                    function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };\n                return function (d, b) {\n                    extendStatics(d, b);\n                    function __() { this.constructor = d; }\n                    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());\n                };\n            })();"},s={name:"typescript:makeTemplateObject",scoped:!1,priority:0,text:'\n            var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {\n                if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }\n                return cooked;\n            };'}}(ts||(ts={})),function(e){e.transformES5=function(t){var n,r,i=t.getCompilerOptions();1!==i.jsx&&3!==i.jsx||(n=t.onEmitNode,t.onEmitNode=function(t,i,a){switch(i.kind){case 251:case 252:case 250:var o=i.tagName;r[e.getOriginalNodeId(o)]=!0}n(t,i,a)},t.enableEmitNotification(251),t.enableEmitNotification(252),t.enableEmitNotification(250),r=[]);var a=t.onSubstituteNode;return t.onSubstituteNode=function(t,n){if(n.id&&r&&r[n.id])return a(t,n);if(n=a(t,n),e.isPropertyAccessExpression(n))return function(t){var n=o(t.name);if(n)return e.setTextRange(e.createElementAccess(t.expression,n),t);return t}(n);if(e.isPropertyAssignment(n))return function(t){var n=e.isIdentifier(t.name)&&o(t.name);if(n)return e.updatePropertyAssignment(t,n,t.initializer);return t}(n);return n},t.enableSubstitution(179),t.enableSubstitution(261),function(e){return e};function o(t){var n=t.originalKeywordKind||(e.nodeIsSynthesized(t)?e.stringToToken(e.idText(t)):void 0);if(n>=72&&n<=107)return e.setTextRange(e.createLiteral(t),t)}}}(ts||(ts={})),function(e){var t,n,r,i,a;!function(e){e[e.Nop=0]="Nop",e[e.Statement=1]="Statement",e[e.Assign=2]="Assign",e[e.Break=3]="Break",e[e.BreakWhenTrue=4]="BreakWhenTrue",e[e.BreakWhenFalse=5]="BreakWhenFalse",e[e.Yield=6]="Yield",e[e.YieldStar=7]="YieldStar",e[e.Return=8]="Return",e[e.Throw=9]="Throw",e[e.Endfinally=10]="Endfinally"}(t||(t={})),function(e){e[e.Open=0]="Open",e[e.Close=1]="Close"}(n||(n={})),function(e){e[e.Exception=0]="Exception",e[e.With=1]="With",e[e.Switch=2]="Switch",e[e.Loop=3]="Loop",e[e.Labeled=4]="Labeled"}(r||(r={})),function(e){e[e.Try=0]="Try",e[e.Catch=1]="Catch",e[e.Finally=2]="Finally",e[e.Done=3]="Done"}(i||(i={})),function(e){e[e.Next=0]="Next",e[e.Throw=1]="Throw",e[e.Return=2]="Return",e[e.Break=3]="Break",e[e.Yield=4]="Yield",e[e.YieldStar=5]="YieldStar",e[e.Catch=6]="Catch",e[e.Endfinally=7]="Endfinally"}(a||(a={})),e.transformGenerators=function(t){var n,r,i,a,s,c,u,_,l,d,p=t.resumeLexicalEnvironment,f=t.endLexicalEnvironment,m=t.hoistFunctionDeclaration,g=t.hoistVariableDeclaration,y=t.getCompilerOptions(),h=e.getEmitScriptTarget(y),v=t.getEmitResolver(),b=t.onSubstituteNode;t.onSubstituteNode=function(t,i){if(i=b(t,i),1===t)return function(t){if(e.isIdentifier(t))return function(t){if(!e.isGeneratedIdentifier(t)&&n&&n.has(e.idText(t))){var i=e.getOriginalNode(t);if(e.isIdentifier(i)&&i.parent){var a=v.getReferencedValueDeclaration(i);if(a){var o=r[e.getOriginalNodeId(a)];if(o){var s=e.getMutableClone(o);return e.setSourceMapRange(s,t),e.setCommentRange(s,t),s}}}}return t}(t);return t}(i);return i};var x,k,S,D,C,T,E,N,A,w,P,F,O=1,I=0,R=0;return function(n){if(n.isDeclarationFile||0==(512&n.transformFlags))return n;var r=e.visitEachChild(n,L,t);return e.addEmitHelpers(r,t.readEmitHelpers()),r};function L(n){var r=n.transformFlags;return a?function(n){switch(n.kind){case 212:case 213:return function(n){return a?(re(),n=e.visitEachChild(n,L,t),ae(),n):e.visitEachChild(n,L,t)}(n);case 221:return function(n){a&&$({kind:2,isScript:!0,breakLabel:-1});n=e.visitEachChild(n,L,t),a&&oe();return n}(n);case 222:return function(n){a&&$({kind:4,isScript:!0,labelText:e.idText(n.label),breakLabel:-1});n=e.visitEachChild(n,L,t),a&&se();return n}(n);default:return M(n)}}(n):i?M(n):256&r?function(n){switch(n.kind){case 228:return B(n);case 186:return J(n);default:return e.Debug.failBadSyntaxKind(n),e.visitEachChild(n,L,t)}}(n):512&r?e.visitEachChild(n,L,t):n}function M(n){switch(n.kind){case 228:return B(n);case 186:return J(n);case 153:case 154:return function(n){var r=i,o=a;return i=!1,a=!1,n=e.visitEachChild(n,L,t),i=r,a=o,n}(n);case 208:return function(t){if(16777216&t.transformFlags)return void q(t.declarationList);if(1048576&e.getEmitFlags(t))return t;for(var n=0,r=t.declarationList.declarations;n<r.length;n++){var i=r[n];g(i.name)}var a=e.getInitializedVariables(t.declarationList);if(0===a.length)return;return e.setSourceMapRange(e.createStatement(e.inlineExpressions(e.map(a,W))),t)}(n);case 214:return function(n){a&&re();var r=n.initializer;if(r&&e.isVariableDeclarationList(r)){for(var i=0,o=r.declarations;i<o.length;i++){var s=o[i];g(s.name)}var c=e.getInitializedVariables(r);n=e.updateFor(n,c.length>0?e.inlineExpressions(e.map(c,W)):void 0,e.visitNode(n.condition,L,e.isExpression),e.visitNode(n.incrementor,L,e.isExpression),e.visitNode(n.statement,L,e.isStatement,e.liftToBlock))}else n=e.visitEachChild(n,L,t);a&&ae();return n}(n);case 215:return function(n){a&&re();var r=n.initializer;if(e.isVariableDeclarationList(r)){for(var i=0,o=r.declarations;i<o.length;i++){var s=o[i];g(s.name)}n=e.updateForIn(n,r.declarations[0].name,e.visitNode(n.expression,L,e.isExpression),e.visitNode(n.statement,L,e.isStatement,e.liftToBlock))}else n=e.visitEachChild(n,L,t);a&&ae();return n}(n);case 218:return function(n){if(a){var r=de(n.label&&e.idText(n.label));if(r>0)return ge(r,n)}return e.visitEachChild(n,L,t)}(n);case 217:return function(n){if(a){var r=pe(n.label&&e.idText(n.label));if(r>0)return ge(r,n)}return e.visitEachChild(n,L,t)}(n);case 219:return function(t){return n=e.visitNode(t.expression,L,e.isExpression),r=t,e.setTextRange(e.createReturn(e.createArrayLiteral(n?[me(2),n]:[me(2)])),r);var n,r}(n);default:return 16777216&n.transformFlags?function(n){switch(n.kind){case 194:return function(n){switch(e.getExpressionAssociativity(n)){case 0:return function(n){if(H(n.right)){if(e.isLogicalOperator(n.operatorToken.kind))return function(t){var n=Y(),r=X();ve(r,e.visitNode(t.left,L,e.isExpression),t.left),53===t.operatorToken.kind?ke(n,r,t.left):xe(n,r,t.left);return ve(r,e.visitNode(t.right,L,e.isExpression),t.right),Z(n),r}(n);if(26===n.operatorToken.kind)return function(t){var n=[];return r(t.left),r(t.right),e.inlineExpressions(n);function r(t){e.isBinaryExpression(t)&&26===t.operatorToken.kind?(r(t.left),r(t.right)):(H(t)&&n.length>0&&(Se(1,[e.createStatement(e.inlineExpressions(n))]),n=[]),n.push(e.visitNode(t,L,e.isExpression)))}}(n);var r=e.getMutableClone(n);return r.left=Q(e.visitNode(n.left,L,e.isExpression)),r.right=e.visitNode(n.right,L,e.isExpression),r}return e.visitEachChild(n,L,t)}(n);case 1:return function(n){var r=n.left,i=n.right;if(H(i)){var a=void 0;switch(r.kind){case 179:a=e.updatePropertyAccess(r,Q(e.visitNode(r.expression,L,e.isLeftHandSideExpression)),r.name);break;case 180:a=e.updateElementAccess(r,Q(e.visitNode(r.expression,L,e.isLeftHandSideExpression)),Q(e.visitNode(r.argumentExpression,L,e.isExpression)));break;default:a=e.visitNode(r,L,e.isExpression)}var o=n.operatorToken.kind;return(s=o)>=59&&s<=70?e.setTextRange(e.createAssignment(a,e.setTextRange(e.createBinary(Q(a),function(e){switch(e){case 59:return 37;case 60:return 38;case 61:return 39;case 62:return 40;case 63:return 41;case 64:return 42;case 65:return 45;case 66:return 46;case 67:return 47;case 68:return 48;case 69:return 49;case 70:return 50}}(o),e.visitNode(i,L,e.isExpression)),n)),n):e.updateBinary(n,a,e.visitNode(i,L,e.isExpression))}var s;return e.visitEachChild(n,L,t)}(n);default:e.Debug.fail("Unknown associativity.")}}(n);case 195:return function(n){if(H(n.whenTrue)||H(n.whenFalse)){var r=Y(),i=Y(),a=X();return ke(r,e.visitNode(n.condition,L,e.isExpression),n.condition),ve(a,e.visitNode(n.whenTrue,L,e.isExpression),n.whenTrue),be(i),Z(r),ve(a,e.visitNode(n.whenFalse,L,e.isExpression),n.whenFalse),Z(i),a}return e.visitEachChild(n,L,t)}(n);case 197:return function(n){var r=Y(),i=e.visitNode(n.expression,L,e.isExpression);if(n.asteriskToken){!function(e,t){Se(7,[e],t)}(0==(8388608&e.getEmitFlags(n.expression))?e.createValuesHelper(t,i,n):i,n)}else!function(e,t){Se(6,[e],t)}(i,n);return Z(r),function(t){return e.setTextRange(e.createCall(e.createPropertyAccess(D,"sent"),void 0,[]),t)}(n)}(n);case 177:return function(e){return j(e.elements,void 0,void 0,e.multiLine)}(n);case 178:return function(t){var n=t.properties,r=t.multiLine,i=G(n),a=X();ve(a,e.createObjectLiteral(e.visitNodes(n,L,e.isObjectLiteralElementLike,0,i),r));var o=e.reduceLeft(n,s,[],i);return o.push(r?e.startOnNewLine(e.getMutableClone(a)):a),e.inlineExpressions(o);function s(n,i){H(i)&&n.length>0&&(he(e.createStatement(e.inlineExpressions(n))),n=[]);var o=e.createExpressionForObjectLiteralElementLike(t,i,a),s=e.visitNode(o,L,e.isExpression);return s&&(r&&(s.startsOnNewLine=!0),n.push(s)),n}}(n);case 180:return function(n){if(H(n.argumentExpression)){var r=e.getMutableClone(n);return r.expression=Q(e.visitNode(n.expression,L,e.isLeftHandSideExpression)),r.argumentExpression=e.visitNode(n.argumentExpression,L,e.isExpression),r}return e.visitEachChild(n,L,t)}(n);case 181:return function(n){if(!e.isImportCall(n)&&e.forEach(n.arguments,H)){var r=e.createCallBinding(n.expression,g,h,!0),i=r.target,a=r.thisArg;return e.setOriginalNode(e.createFunctionApply(Q(e.visitNode(i,L,e.isLeftHandSideExpression)),a,j(n.arguments),n),n)}return e.visitEachChild(n,L,t)}(n);case 182:return function(n){if(e.forEach(n.arguments,H)){var r=e.createCallBinding(e.createPropertyAccess(n.expression,"bind"),g),i=r.target,a=r.thisArg;return e.setOriginalNode(e.setTextRange(e.createNew(e.createFunctionApply(Q(e.visitNode(i,L,e.isExpression)),a,j(n.arguments,e.createVoidZero())),void 0,[]),n),n)}return e.visitEachChild(n,L,t)}(n);default:return e.visitEachChild(n,L,t)}}(n):33554944&n.transformFlags?e.visitEachChild(n,L,t):n}}function B(n){if(n.asteriskToken)n=e.setOriginalNode(e.setTextRange(e.createFunctionDeclaration(void 0,n.modifiers,void 0,n.name,void 0,e.visitParameterList(n.parameters,L,t),void 0,z(n.body)),n),n);else{var r=i,o=a;i=!1,a=!1,n=e.visitEachChild(n,L,t),i=r,a=o}return i?void m(n):n}function J(n){if(n.asteriskToken)n=e.setOriginalNode(e.setTextRange(e.createFunctionExpression(void 0,void 0,n.name,void 0,e.visitParameterList(n.parameters,L,t),void 0,z(n.body)),n),n);else{var r=i,o=a;i=!1,a=!1,n=e.visitEachChild(n,L,t),i=r,a=o}return n}function z(t){var n=[],r=i,o=a,m=s,g=c,y=u,h=_,v=l,b=d,C=O,T=x,E=k,N=S,A=D;i=!0,a=!1,s=void 0,c=void 0,u=void 0,_=void 0,l=void 0,d=void 0,O=1,x=void 0,k=void 0,S=void 0,D=e.createTempVariable(void 0),p();var w=e.addPrologue(n,t.statements,!1,L);K(t.statements,w);var P=De();return e.addRange(n,f()),n.push(e.createReturn(P)),i=r,a=o,s=m,c=g,u=y,_=h,l=v,d=b,O=C,x=T,k=E,S=N,D=A,e.setTextRange(e.createBlock(n,t.multiLine),t)}function j(t,n,r,i){var a,o=G(t);if(o>0){a=X();var s=e.visitNodes(t,L,e.isExpression,0,o);ve(a,e.createArrayLiteral(n?[n].concat(s):s)),n=void 0}var c=e.reduceLeft(t,(function(t,r){if(H(r)&&t.length>0){var o=void 0!==a;a||(a=X()),ve(a,o?e.createArrayConcat(a,[e.createArrayLiteral(t,i)]):e.createArrayLiteral(n?[n].concat(t):t,i)),n=void 0,t=[]}return t.push(e.visitNode(r,L,e.isExpression)),t}),[],o);return a?e.createArrayConcat(a,[e.createArrayLiteral(c,i)]):e.setTextRange(e.createArrayLiteral(n?[n].concat(c):c,i),r)}function K(e,t){void 0===t&&(t=0);for(var n=e.length,r=t;r<n;r++)V(e[r])}function U(t){e.isBlock(t)?K(t.statements):V(t)}function V(i){var o=a;a||(a=H(i)),function(i){switch(i.kind){case 207:return function(t){H(t)?K(t.statements):he(e.visitNode(t,L,e.isStatement))}(i);case 210:return function(t){he(e.visitNode(t,L,e.isStatement))}(i);case 211:return function(t){if(H(t))if(H(t.thenStatement)||H(t.elseStatement)){var n=Y(),r=t.elseStatement?Y():void 0;ke(t.elseStatement?r:n,e.visitNode(t.expression,L,e.isExpression),t.expression),U(t.thenStatement),t.elseStatement&&(be(n),Z(r),U(t.elseStatement)),Z(n)}else he(e.visitNode(t,L,e.isStatement));else he(e.visitNode(t,L,e.isStatement))}(i);case 212:return function(t){if(H(t)){var n=Y(),r=Y();ie(n),Z(r),U(t.statement),Z(n),xe(r,e.visitNode(t.expression,L,e.isExpression)),ae()}else he(e.visitNode(t,L,e.isStatement))}(i);case 213:return function(t){if(H(t)){var n=Y(),r=ie(n);Z(n),ke(r,e.visitNode(t.expression,L,e.isExpression)),U(t.statement),be(n),ae()}else he(e.visitNode(t,L,e.isStatement))}(i);case 214:return function(t){if(H(t)){var n=Y(),r=Y(),i=ie(r);if(t.initializer){var a=t.initializer;e.isVariableDeclarationList(a)?q(a):he(e.setTextRange(e.createStatement(e.visitNode(a,L,e.isExpression)),a))}Z(n),t.condition&&ke(i,e.visitNode(t.condition,L,e.isExpression)),U(t.statement),Z(r),t.incrementor&&he(e.setTextRange(e.createStatement(e.visitNode(t.incrementor,L,e.isExpression)),t.incrementor)),be(n),ae()}else he(e.visitNode(t,L,e.isStatement))}(i);case 215:return function(t){if(H(t)){var n=X(),r=X(),i=e.createLoopVariable(),a=t.initializer;g(i),ve(n,e.createArrayLiteral()),he(e.createForIn(r,e.visitNode(t.expression,L,e.isExpression),e.createStatement(e.createCall(e.createPropertyAccess(n,"push"),void 0,[r])))),ve(i,e.createLiteral(0));var o=Y(),s=Y(),c=ie(s);Z(o),ke(c,e.createLessThan(i,e.createPropertyAccess(n,"length")));var u=void 0;if(e.isVariableDeclarationList(a)){for(var _=0,l=a.declarations;_<l.length;_++){var d=l[_];g(d.name)}u=e.getSynthesizedClone(a.declarations[0].name)}else u=e.visitNode(a,L,e.isExpression),e.Debug.assert(e.isLeftHandSideExpression(u));ve(u,e.createElementAccess(n,i)),U(t.statement),Z(s),he(e.createStatement(e.createPostfixIncrement(i))),be(o),ae()}else he(e.visitNode(t,L,e.isStatement))}(i);case 217:return function(t){var n=pe(t.label?e.idText(t.label):void 0);n>0?be(n,t):he(t)}(i);case 218:return function(t){var n=de(t.label?e.idText(t.label):void 0);n>0?be(n,t):he(t)}(i);case 219:return function(t){n=e.visitNode(t.expression,L,e.isExpression),r=t,Se(8,[n],r);var n,r}(i);case 220:return function(t){H(t)?(n=Q(e.visitNode(t.expression,L,e.isExpression)),r=Y(),i=Y(),Z(r),$({kind:1,expression:n,startLabel:r,endLabel:i}),U(t.statement),e.Debug.assert(1===ne()),Z(ee().endLabel)):he(e.visitNode(t,L,e.isStatement));var n,r,i}(i);case 221:return function(t){if(H(t.caseBlock)){for(var n=t.caseBlock,r=n.clauses.length,i=($({kind:2,isScript:!1,breakLabel:f=Y()}),f),a=Q(e.visitNode(t.expression,L,e.isExpression)),o=[],s=-1,c=0;c<r;c++){var u=n.clauses[c];o.push(Y()),258===u.kind&&-1===s&&(s=c)}for(var _=0,l=[];_<r;){var d=0;for(c=_;c<r;c++){if(257===(u=n.clauses[c]).kind){var p=u;if(H(p.expression)&&l.length>0)break;l.push(e.createCaseClause(e.visitNode(p.expression,L,e.isExpression),[ge(o[c],p.expression)]))}else d++}l.length&&(he(e.createSwitch(a,e.createCaseBlock(l))),_+=l.length,l=[]),d>0&&(_+=d,d=0)}be(s>=0?o[s]:i);for(c=0;c<r;c++)Z(o[c]),K(n.clauses[c].statements);oe()}else he(e.visitNode(t,L,e.isStatement));var f}(i);case 222:return function(t){H(t)?(n=e.idText(t.label),r=Y(),$({kind:4,isScript:!1,labelText:n,breakLabel:r}),U(t.statement),se()):he(e.visitNode(t,L,e.isStatement));var n,r}(i);case 223:return function(t){n=e.visitNode(t.expression,L,e.isExpression),r=t,Se(9,[n],r);var n,r}(i);case 224:return function(i){H(i)?(a=Y(),o=Y(),Z(a),$({kind:0,state:0,startLabel:a,endLabel:o}),ye(),U(i.tryBlock),i.catchClause&&(!function(i){var a;if(e.Debug.assert(0===ne()),e.isGeneratedIdentifier(i.name))a=i.name,g(i.name);else{var o=e.idText(i.name);a=X(o),n||(n=e.createMap(),r=[],t.enableSubstitution(71)),n.set(o,!0),r[e.getOriginalNodeId(i)]=a}var s=te();e.Debug.assert(s.state<1),be(s.endLabel);var c=Y();Z(c),s.state=1,s.catchVariable=a,s.catchLabel=c,ve(a,e.createCall(e.createPropertyAccess(D,"sent"),void 0,[])),ye()}(i.catchClause.variableDeclaration),U(i.catchClause.block)),i.finallyBlock&&(!function(){e.Debug.assert(0===ne());var t=te();e.Debug.assert(t.state<2),be(t.endLabel);var n=Y();Z(n),t.state=2,t.finallyLabel=n}(),U(i.finallyBlock)),function(){e.Debug.assert(0===ne());var t=ee();t.state<2?be(t.endLabel):Se(10);Z(t.endLabel),ye(),t.state=3}()):he(e.visitEachChild(i,L,t));var a,o}(i);default:he(e.visitNode(i,L,e.isStatement))}}(i),a=o}function q(t){for(var n=0,r=t.declarations;n<r.length;n++){var i=r[n],a=e.getSynthesizedClone(i.name);e.setCommentRange(a,i.name),g(a)}for(var o=e.getInitializedVariables(t),s=o.length,c=0,u=[];c<s;){for(var _=c;_<s;_++){if(H((i=o[_]).initializer)&&u.length>0)break;u.push(W(i))}u.length&&(he(e.createStatement(e.inlineExpressions(u))),c+=u.length,u=[])}}function W(t){return e.setSourceMapRange(e.createAssignment(e.setSourceMapRange(e.getSynthesizedClone(t.name),t.name),e.visitNode(t.initializer,L,e.isExpression)),t)}function H(e){return e&&0!=(16777216&e.transformFlags)}function G(e){for(var t=e.length,n=0;n<t;n++)if(H(e[n]))return n;return-1}function Q(t){var n;return e.isGeneratedIdentifier(t)||4096&e.getEmitFlags(t)?t:(ve(n=e.createTempVariable(g),t,t),n)}function X(t){var n=t?e.createUniqueName(t):e.createTempVariable(void 0);return g(n),n}function Y(){l||(l=[]);var e=O;return O++,l[e]=-1,e}function Z(t){e.Debug.assert(void 0!==l,"No labels were defined."),l[t]=x?x.length:0}function $(e){s||(s=[],u=[],c=[],_=[]);var t=u.length;return u[t]=0,c[t]=x?x.length:0,s[t]=e,_.push(e),t}function ee(){var t=te();e.Debug.assert(void 0!==t,"beginBlock was never called.");var n=u.length;return u[n]=1,c[n]=x?x.length:0,s[n]=t,_.pop(),t}function te(){return e.lastOrUndefined(_)}function ne(){var e=te();return e&&e.kind}function re(){$({kind:3,isScript:!0,breakLabel:-1,continueLabel:-1})}function ie(e){var t=Y();return $({kind:3,isScript:!1,breakLabel:t,continueLabel:e}),t}function ae(){e.Debug.assert(3===ne());var t=ee(),n=t.breakLabel;t.isScript||Z(n)}function oe(){e.Debug.assert(2===ne());var t=ee(),n=t.breakLabel;t.isScript||Z(n)}function se(){e.Debug.assert(4===ne());var t=ee();t.isScript||Z(t.breakLabel)}function ce(e){return 2===e.kind||3===e.kind}function ue(e){return 4===e.kind}function _e(e){return 3===e.kind}function le(e,t){for(var n=t;n>=0;n--){var r=_[n];if(!ue(r))break;if(r.labelText===e)return!0}return!1}function de(e){if(_)if(e)for(var t=_.length-1;t>=0;t--){if(ue(n=_[t])&&n.labelText===e)return n.breakLabel;if(ce(n)&&le(e,t-1))return n.breakLabel}else for(t=_.length-1;t>=0;t--){var n;if(ce(n=_[t]))return n.breakLabel}return 0}function pe(e){if(_)if(e)for(var t=_.length-1;t>=0;t--){if(_e(n=_[t])&&le(e,t-1))return n.continueLabel}else for(t=_.length-1;t>=0;t--){var n;if(_e(n=_[t]))return n.continueLabel}return 0}function fe(t){if(t>0){void 0===d&&(d=[]);var n=e.createLiteral(-1);return void 0===d[t]?d[t]=[n]:d[t].push(n),n}return e.createOmittedExpression()}function me(t){var n=e.createLiteral(t);return e.addSyntheticTrailingComment(n,3,function(e){switch(e){case 2:return"return";case 3:return"break";case 4:return"yield";case 5:return"yield*";case 7:return"endfinally"}}(t)),n}function ge(t,n){return e.Debug.assertLessThan(0,t,"Invalid label"),e.setTextRange(e.createReturn(e.createArrayLiteral([me(3),fe(t)])),n)}function ye(){Se(0)}function he(e){e?Se(1,[e]):ye()}function ve(e,t,n){Se(2,[e,t],n)}function be(e,t){Se(3,[e],t)}function xe(e,t,n){Se(4,[e,t],n)}function ke(e,t,n){Se(5,[e,t],n)}function Se(e,t,n){void 0===x&&(x=[],k=[],S=[]),void 0===l&&Z(Y());var r=x.length;x[r]=e,k[r]=t,S[r]=n}function De(){I=0,R=0,C=void 0,T=!1,E=!1,N=void 0,A=void 0,w=void 0,P=void 0,F=void 0;var n=function(){if(x){for(var t=0;t<x.length;t++)Ne(t);Ce(x.length)}else Ce(0);if(N){var n=e.createPropertyAccess(D,"label"),r=e.createSwitch(n,e.createCaseBlock(N));return r.startsOnNewLine=!0,[r]}if(A)return A;return[]}();return function(t,n){return t.requestEmitHelper(o),e.createCall(e.getHelperName("__generator"),void 0,[e.createThis(),n])}(t,e.setEmitFlags(e.createFunctionExpression(void 0,void 0,void 0,void 0,[e.createParameter(void 0,void 0,void 0,D)],void 0,e.createBlock(n,n.length>0)),524288))}function Ce(e){(function(e){if(!E)return!0;if(!l||!d)return!1;for(var t=0;t<l.length;t++)if(l[t]===e&&d[t])return!0;return!1})(e)&&(Ee(e),F=void 0,we(void 0,void 0)),A&&N&&Te(!1),function(){if(void 0!==d&&void 0!==C)for(var e=0;e<C.length;e++){var t=C[e];if(void 0!==t)for(var n=0,r=t;n<r.length;n++){var i=r[n],a=d[i];if(void 0!==a)for(var o=0,s=a;o<s.length;o++){s[o].text=String(e)}}}}()}function Te(t){if(N||(N=[]),A){if(F)for(var n=F.length-1;n>=0;n--){var r=F[n];A=[e.createWith(r.expression,e.createBlock(A))]}if(P){var i=P.startLabel,a=P.catchLabel,o=P.finallyLabel,s=P.endLabel;A.unshift(e.createStatement(e.createCall(e.createPropertyAccess(e.createPropertyAccess(D,"trys"),"push"),void 0,[e.createArrayLiteral([fe(i),fe(a),fe(o),fe(s)])]))),P=void 0}t&&A.push(e.createStatement(e.createAssignment(e.createPropertyAccess(D,"label"),e.createLiteral(R+1))))}N.push(e.createCaseClause(e.createLiteral(R),A||[])),A=void 0}function Ee(e){if(l)for(var t=0;t<l.length;t++)l[t]===e&&(A&&(Te(!T),T=!1,E=!1,R++),void 0===C&&(C=[]),void 0===C[R]?C[R]=[t]:C[R].push(t))}function Ne(t){if(Ee(t),function(e){if(s)for(;I<u.length&&c[I]<=e;I++){var t=s[I],n=u[I];switch(t.kind){case 0:0===n?(w||(w=[]),A||(A=[]),w.push(P),P=t):1===n&&(P=w.pop());break;case 1:0===n?(F||(F=[]),F.push(t)):1===n&&F.pop()}}}(t),!T){T=!1,E=!1;var n=x[t];if(0!==n){if(10===n)return T=!0,void Ae(e.createReturn(e.createArrayLiteral([me(7)])));var r=k[t];if(1===n)return Ae(r[0]);var i,a,o,_=S[t];switch(n){case 2:return i=r[0],a=r[1],o=_,void Ae(e.setTextRange(e.createStatement(e.createAssignment(i,a)),o));case 3:return function(t,n){T=!0,Ae(e.setEmitFlags(e.setTextRange(e.createReturn(e.createArrayLiteral([me(3),fe(t)])),n),384))}(r[0],_);case 4:return function(t,n,r){Ae(e.setEmitFlags(e.createIf(n,e.setEmitFlags(e.setTextRange(e.createReturn(e.createArrayLiteral([me(3),fe(t)])),r),384)),1))}(r[0],r[1],_);case 5:return function(t,n,r){Ae(e.setEmitFlags(e.createIf(e.createLogicalNot(n),e.setEmitFlags(e.setTextRange(e.createReturn(e.createArrayLiteral([me(3),fe(t)])),r),384)),1))}(r[0],r[1],_);case 6:return function(t,n){T=!0,Ae(e.setEmitFlags(e.setTextRange(e.createReturn(e.createArrayLiteral(t?[me(4),t]:[me(4)])),n),384))}(r[0],_);case 7:return function(t,n){T=!0,Ae(e.setEmitFlags(e.setTextRange(e.createReturn(e.createArrayLiteral([me(5),t])),n),384))}(r[0],_);case 8:return we(r[0],_);case 9:return function(t,n){T=!0,E=!0,Ae(e.setTextRange(e.createThrow(t),n))}(r[0],_)}}}}function Ae(e){e&&(A?A.push(e):A=[e])}function we(t,n){T=!0,E=!0,Ae(e.setEmitFlags(e.setTextRange(e.createReturn(e.createArrayLiteral(t?[me(2),t]:[me(2)])),n),384))}};var o={name:"typescript:generator",scoped:!1,priority:6,text:'\n            var __generator = (this && this.__generator) || function (thisArg, body) {\n                var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;\n                return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;\n                function verb(n) { return function (v) { return step([n, v]); }; }\n                function step(op) {\n                    if (f) throw new TypeError("Generator is already executing.");\n                    while (_) try {\n                        if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;\n                        if (y = 0, t) op = [0, t.value];\n                        switch (op[0]) {\n                            case 0: case 1: t = op; break;\n                            case 4: _.label++; return { value: op[1], done: false };\n                            case 5: _.label++; y = op[1]; op = [0]; continue;\n                            case 7: op = _.ops.pop(); _.trys.pop(); continue;\n                            default:\n                                if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }\n                                if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }\n                                if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }\n                                if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }\n                                if (t[2]) _.ops.pop();\n                                _.trys.pop(); continue;\n                        }\n                        op = body.call(thisArg, _);\n                    } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }\n                    if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };\n                }\n            };'}}(ts||(ts={})),function(e){e.transformModule=function(r){var i=r.startLexicalEnvironment,a=r.endLexicalEnvironment,o=r.hoistVariableDeclaration,s=r.getCompilerOptions(),c=r.getEmitResolver(),u=r.getEmitHost(),_=e.getEmitScriptTarget(s),l=e.getEmitModuleKind(s),d=r.onSubstituteNode,p=r.onEmitNode;r.onSubstituteNode=function(t,n){if((n=d(t,n)).id&&g[n.id])return n;if(1===t)return function(t){switch(t.kind){case 71:return V(t);case 194:return function(t){if(e.isAssignmentOperator(t.operatorToken.kind)&&e.isIdentifier(t.left)&&!e.isGeneratedIdentifier(t.left)&&!e.isLocalName(t.left)&&!e.isDeclarationNameOfEnumOrNamespace(t.left)){var n=q(t.left);if(n){for(var r=t,i=0,a=n;i<a.length;i++){var o=a[i];g[e.getNodeId(r)]=!0,r=K(o,r,t)}return r}}return t}(t);case 193:case 192:return function(t){if((43===t.operator||44===t.operator)&&e.isIdentifier(t.operand)&&!e.isGeneratedIdentifier(t.operand)&&!e.isLocalName(t.operand)&&!e.isDeclarationNameOfEnumOrNamespace(t.operand)){var n=q(t.operand);if(n){for(var r=193===t.kind?e.setTextRange(e.createBinary(t.operand,e.createToken(43===t.operator?59:60),e.createLiteral(1)),t):t,i=0,a=n;i<a.length;i++){var o=a[i];g[e.getNodeId(r)]=!0,r=K(o,r)}return r}}return t}(t)}return t}(n);if(e.isShorthandPropertyAssignment(n))return function(t){var n=t.name,r=V(n);if(r!==n){if(t.objectAssignmentInitializer){var i=e.createAssignment(r,t.objectAssignmentInitializer);return e.setTextRange(e.createPropertyAssignment(n,i),t)}return e.setTextRange(e.createPropertyAssignment(n,r),t)}return t}(n);return n},r.onEmitNode=function(t,n,r){265===n.kind?(f=n,m=h[e.getOriginalNodeId(f)],g=[],p(t,n,r),f=void 0,m=void 0,g=void 0):p(t,n,r)},r.enableSubstitution(71),r.enableSubstitution(194),r.enableSubstitution(192),r.enableSubstitution(193),r.enableSubstitution(262),r.enableEmitNotification(265);var f,m,g,y,h=[],v=[];return function(t){if(t.isDeclarationFile||!(e.isExternalModule(t)||s.isolatedModules||67108864&t.transformFlags))return t;f=t,m=e.collectExternalModuleInfo(t,c,s),h[e.getOriginalNodeId(t)]=m;var n=function(t){switch(t){case e.ModuleKind.AMD:return k;case e.ModuleKind.UMD:return S;default:return x}}(l)(t);return f=void 0,m=void 0,y=!1,e.aggregateTransformFlags(n)};function b(){return!(m.exportEquals||!e.isExternalModule(f))}function x(n){i();var o=[],c=s.alwaysStrict||!s.noImplicitUseStrict&&e.isExternalModule(f),u=e.addPrologue(o,n.statements,c,E);b()&&e.append(o,j()),e.append(o,e.visitNode(m.externalHelpersImportDeclaration,E,e.isStatement)),e.addRange(o,e.visitNodes(n.statements,E,e.isStatement,u)),T(o,!1),e.addRange(o,a());var _=e.updateSourceFileNode(n,e.setTextRange(e.createNodeArray(o),n.statements));return m.hasExportStarsToExportValues&&!s.importHelpers&&e.addEmitHelper(_,t),e.addEmitHelpers(_,r.readEmitHelpers()),_}function k(t){var n=e.createIdentifier("define"),r=e.tryGetModuleNameFromFile(t,u,s),i=D(t,!0),a=i.aliasedModuleNames,o=i.unaliasedModuleNames,c=i.importAliasNames;return e.updateSourceFileNode(t,e.setTextRange(e.createNodeArray([e.createStatement(e.createCall(n,void 0,(r?[r]:[]).concat([e.createArrayLiteral([e.createLiteral("require"),e.createLiteral("exports")].concat(a,o)),e.createFunctionExpression(void 0,void 0,void 0,void 0,[e.createParameter(void 0,void 0,void 0,"require"),e.createParameter(void 0,void 0,void 0,"exports")].concat(c),void 0,C(t))])))]),t.statements))}function S(t){var n=D(t,!1),r=n.aliasedModuleNames,i=n.unaliasedModuleNames,a=n.importAliasNames,o=e.tryGetModuleNameFromFile(t,u,s),c=e.createFunctionExpression(void 0,void 0,void 0,void 0,[e.createParameter(void 0,void 0,void 0,"factory")],void 0,e.setTextRange(e.createBlock([e.createIf(e.createLogicalAnd(e.createTypeCheck(e.createIdentifier("module"),"object"),e.createTypeCheck(e.createPropertyAccess(e.createIdentifier("module"),"exports"),"object")),e.createBlock([e.createVariableStatement(void 0,[e.createVariableDeclaration("v",void 0,e.createCall(e.createIdentifier("factory"),void 0,[e.createIdentifier("require"),e.createIdentifier("exports")]))]),e.setEmitFlags(e.createIf(e.createStrictInequality(e.createIdentifier("v"),e.createIdentifier("undefined")),e.createStatement(e.createAssignment(e.createPropertyAccess(e.createIdentifier("module"),"exports"),e.createIdentifier("v")))),1)]),e.createIf(e.createLogicalAnd(e.createTypeCheck(e.createIdentifier("define"),"function"),e.createPropertyAccess(e.createIdentifier("define"),"amd")),e.createBlock([e.createStatement(e.createCall(e.createIdentifier("define"),void 0,(o?[o]:[]).concat([e.createArrayLiteral([e.createLiteral("require"),e.createLiteral("exports")].concat(r,i)),e.createIdentifier("factory")])))])))],!0),void 0));return e.updateSourceFileNode(t,e.setTextRange(e.createNodeArray([e.createStatement(e.createCall(c,void 0,[e.createFunctionExpression(void 0,void 0,void 0,void 0,[e.createParameter(void 0,void 0,void 0,"require"),e.createParameter(void 0,void 0,void 0,"exports")].concat(a),void 0,C(t))]))]),t.statements))}function D(t,n){for(var r=[],i=[],a=[],o=0,_=t.amdDependencies;o<_.length;o++){var l=_[o];l.name?(r.push(e.createLiteral(l.path)),a.push(e.createParameter(void 0,void 0,void 0,l.name))):i.push(e.createLiteral(l.path))}for(var d=0,p=m.externalImports;d<p.length;d++){var g=p[d],y=e.getExternalModuleNameLiteral(g,f,u,c,s),h=e.getLocalNameForExternalImport(g,f);y&&(n&&h?(e.setEmitFlags(h,4),r.push(y),a.push(e.createParameter(void 0,void 0,void 0,h))):i.push(y))}return{aliasedModuleNames:r,unaliasedModuleNames:i,importAliasNames:a}}function C(r){i();var o=[],c=e.addPrologue(o,r.statements,!s.noImplicitUseStrict,E);b()&&e.append(o,j()),e.append(o,e.visitNode(m.externalHelpersImportDeclaration,E,e.isStatement)),e.addRange(o,e.visitNodes(r.statements,E,e.isStatement,c)),T(o,!0),e.addRange(o,a());var u=e.createBlock(o,!0);return m.hasExportStarsToExportValues&&!s.importHelpers&&e.addEmitHelper(u,t),y&&e.addEmitHelper(u,n),u}function T(t,n){if(m.exportEquals){var r=e.visitNode(m.exportEquals.expression,N);if(r)if(n){var i=e.createReturn(r);e.setTextRange(i,m.exportEquals),e.setEmitFlags(i,1920),t.push(i)}else{i=e.createStatement(e.createAssignment(e.createPropertyAccess(e.createIdentifier("module"),"exports"),r));e.setTextRange(i,m.exportEquals),e.setEmitFlags(i,1536),t.push(i)}}}function E(t){switch(t.kind){case 238:return function(t){var n,r=e.getNamespaceDeclarationNode(t);if(l!==e.ModuleKind.AMD){if(!t.importClause)return e.setTextRange(e.createStatement(P(t)),t);var i=[];r&&!e.isDefaultImport(t)?i.push(e.createVariableDeclaration(e.getSynthesizedClone(r.name),void 0,P(t))):(i.push(e.createVariableDeclaration(e.getGeneratedNameForNode(t),void 0,P(t))),r&&e.isDefaultImport(t)&&i.push(e.createVariableDeclaration(e.getSynthesizedClone(r.name),void 0,e.getGeneratedNameForNode(t)))),n=e.append(n,e.setTextRange(e.createVariableStatement(void 0,e.createVariableDeclarationList(i,_>=2?2:0)),t))}else r&&e.isDefaultImport(t)&&(n=e.append(n,e.createVariableStatement(void 0,e.createVariableDeclarationList([e.setTextRange(e.createVariableDeclaration(e.getSynthesizedClone(r.name),void 0,e.getGeneratedNameForNode(t)),t)],_>=2?2:0))));if(O(t)){var a=e.getOriginalNodeId(t);v[a]=I(v[a],t)}else n=I(n,t);return e.singleOrMany(n)}(t);case 237:return function(t){var n;e.Debug.assert(e.isExternalModuleImportEqualsDeclaration(t),"import= for internal module references should be handled in an earlier transformer."),l!==e.ModuleKind.AMD?n=e.hasModifier(t,1)?e.append(n,e.setTextRange(e.createStatement(K(t.name,P(t))),t)):e.append(n,e.setTextRange(e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration(e.getSynthesizedClone(t.name),void 0,P(t))],_>=2?2:0)),t)):e.hasModifier(t,1)&&(n=e.append(n,e.setTextRange(e.createStatement(K(e.getExportName(t),e.getLocalName(t))),t)));if(O(t)){var r=e.getOriginalNodeId(t);v[r]=R(v[r],t)}else n=R(n,t);return e.singleOrMany(n)}(t);case 244:return function(t){if(!t.moduleSpecifier)return;var n=e.getGeneratedNameForNode(t);if(t.exportClause){var i=[];l!==e.ModuleKind.AMD&&i.push(e.setTextRange(e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration(n,void 0,P(t))])),t));for(var a=0,o=t.exportClause.elements;a<o.length;a++){var s=o[a],c=e.createPropertyAccess(n,s.propertyName||s.name);i.push(e.setTextRange(e.createStatement(K(e.getExportName(s),c)),s))}return e.singleOrMany(i)}return e.setTextRange(e.createStatement(function(t,n){return t.getCompilerOptions().importHelpers?e.createCall(e.getHelperName("__exportStar"),void 0,[n,e.createIdentifier("exports")]):e.createCall(e.createIdentifier("__export"),void 0,[n])}(r,l!==e.ModuleKind.AMD?P(t):n)),t)}(t);case 243:return function(t){if(t.isExportEquals)return;var n,r=t.original;if(r&&O(r)){var i=e.getOriginalNodeId(t);v[i]=z(v[i],e.createIdentifier("default"),e.visitNode(t.expression,N),t,!0)}else n=z(n,e.createIdentifier("default"),e.visitNode(t.expression,N),t,!0);return e.singleOrMany(n)}(t);case 208:return function(t){var n,i,a;if(e.hasModifier(t,1)){for(var o=void 0,s=0,c=t.declarationList.declarations;s<c.length;s++){var u=c[s];e.isIdentifier(u.name)&&e.isLocalName(u.name)?(o||(o=e.visitNodes(t.modifiers,U,e.isModifier)),i=e.append(i,u)):u.initializer&&(a=e.append(a,F(u)))}i&&(n=e.append(n,e.updateVariableStatement(t,o,e.updateVariableDeclarationList(t.declarationList,i)))),a&&(n=e.append(n,e.setTextRange(e.createStatement(e.inlineExpressions(a)),t)))}else n=e.append(n,e.visitEachChild(t,N,r));if(O(t)){var _=e.getOriginalNodeId(t);v[_]=L(v[_],t)}else n=L(n,t);return e.singleOrMany(n)}(t);case 228:return function(t){var n;n=e.hasModifier(t,1)?e.append(n,e.setOriginalNode(e.setTextRange(e.createFunctionDeclaration(void 0,e.visitNodes(t.modifiers,U,e.isModifier),t.asteriskToken,e.getDeclarationName(t,!0,!0),void 0,e.visitNodes(t.parameters,N),void 0,e.visitEachChild(t.body,N,r)),t),t)):e.append(n,e.visitEachChild(t,N,r));if(O(t)){var i=e.getOriginalNodeId(t);v[i]=B(v[i],t)}else n=B(n,t);return e.singleOrMany(n)}(t);case 229:return function(t){var n;n=e.hasModifier(t,1)?e.append(n,e.setOriginalNode(e.setTextRange(e.createClassDeclaration(void 0,e.visitNodes(t.modifiers,U,e.isModifier),e.getDeclarationName(t,!0,!0),void 0,e.visitNodes(t.heritageClauses,N),e.visitNodes(t.members,N)),t),t)):e.append(n,e.visitEachChild(t,N,r));if(O(t)){var i=e.getOriginalNodeId(t);v[i]=B(v[i],t)}else n=B(n,t);return e.singleOrMany(n)}(t);case 290:return function(t){if(O(t)&&208===t.original.kind){var n=e.getOriginalNodeId(t);v[n]=L(v[n],t.original)}return t}(t);case 291:return function(t){var n=e.getOriginalNodeId(t),r=v[n];if(r)return delete v[n],e.append(r,t);return t}(t);default:return e.visitEachChild(t,N,r)}}function N(t){return 67108864&t.transformFlags?e.isImportCall(t)?function(t){var n=e.visitNode(e.firstOrUndefined(t.arguments),N),r=!!(16384&t.transformFlags);switch(s.module){case e.ModuleKind.AMD:return A(n,r);case e.ModuleKind.UMD:return function(t,n){if(y=!0,e.isSimpleCopiableExpression(t)){var r=e.isGeneratedIdentifier(t)?t:e.isStringLiteral(t)?e.createLiteral(t):e.setEmitFlags(e.setTextRange(e.getSynthesizedClone(t),t),1536);return e.createConditional(e.createIdentifier("__syncRequire"),w(t,n),A(r,n))}var i=e.createTempVariable(o);return e.createComma(e.createAssignment(i,t),e.createConditional(e.createIdentifier("__syncRequire"),w(i,n),A(i,n)))}(n,r);case e.ModuleKind.CommonJS:default:return w(n,r)}}(t):e.visitEachChild(t,N,r):t}function A(t,n){var r,i=e.createUniqueName("resolve"),a=e.createUniqueName("reject"),o=[e.createParameter(void 0,void 0,void 0,i),e.createParameter(void 0,void 0,void 0,a)],s=e.createBlock([e.createStatement(e.createCall(e.createIdentifier("require"),void 0,[e.createArrayLiteral([t||e.createOmittedExpression()]),i,a]))]);return _>=2?r=e.createArrowFunction(void 0,void 0,o,void 0,void 0,s):(r=e.createFunctionExpression(void 0,void 0,void 0,void 0,o,void 0,s),n&&e.setEmitFlags(r,8)),e.createNew(e.createIdentifier("Promise"),void 0,[r])}function w(t,n){var r,i=e.createCall(e.createPropertyAccess(e.createIdentifier("Promise"),"resolve"),void 0,[]),a=e.createCall(e.createIdentifier("require"),void 0,t?[t]:[]);return _>=2?r=e.createArrowFunction(void 0,void 0,[],void 0,void 0,a):(r=e.createFunctionExpression(void 0,void 0,void 0,void 0,[],void 0,e.createBlock([e.createReturn(a)])),n&&e.setEmitFlags(r,8)),e.createCall(e.createPropertyAccess(i,"then"),void 0,[r])}function P(t){var n=e.getExternalModuleNameLiteral(t,f,u,c,s),r=[];return n&&r.push(n),e.createCall(e.createIdentifier("require"),void 0,r)}function F(t){return e.isBindingPattern(t.name)?e.flattenDestructuringAssignment(e.visitNode(t,N),void 0,r,0,!1,K):e.createAssignment(e.setTextRange(e.createPropertyAccess(e.createIdentifier("exports"),t.name),t.name),e.visitNode(t.initializer,N))}function O(t){return 0!=(4194304&e.getEmitFlags(t))}function I(e,t){if(m.exportEquals)return e;var n=t.importClause;if(!n)return e;n.name&&(e=J(e,n));var r=n.namedBindings;if(r)switch(r.kind){case 240:e=J(e,r);break;case 241:for(var i=0,a=r.elements;i<a.length;i++){e=J(e,a[i])}}return e}function R(e,t){return m.exportEquals?e:J(e,t)}function L(e,t){if(m.exportEquals)return e;for(var n=0,r=t.declarationList.declarations;n<r.length;n++){e=M(e,r[n])}return e}function M(t,n){if(m.exportEquals)return t;if(e.isBindingPattern(n.name))for(var r=0,i=n.name.elements;r<i.length;r++){var a=i[r];e.isOmittedExpression(a)||(t=M(t,a))}else e.isGeneratedIdentifier(n.name)||(t=J(t,n));return t}function B(t,n){if(m.exportEquals)return t;e.hasModifier(n,1)&&(t=z(t,e.hasModifier(n,512)?e.createIdentifier("default"):e.getDeclarationName(n),e.getLocalName(n),n));return n.name&&(t=J(t,n)),t}function J(t,n){var r=e.getDeclarationName(n),i=m.exportSpecifiers.get(e.idText(r));if(i)for(var a=0,o=i;a<o.length;a++){var s=o[a];t=z(t,s.name,r,s.name)}return t}function z(t,n,r,i,a){return t=e.append(t,function(t,n,r,i){var a=e.setTextRange(e.createStatement(K(t,n)),r);e.startOnNewLine(a),i||e.setEmitFlags(a,1536);return a}(n,r,i,a))}function j(){var t;return t=0===_?e.createStatement(K(e.createIdentifier("__esModule"),e.createLiteral(!0))):e.createStatement(e.createCall(e.createPropertyAccess(e.createIdentifier("Object"),"defineProperty"),void 0,[e.createIdentifier("exports"),e.createLiteral("__esModule"),e.createObjectLiteral([e.createPropertyAssignment("value",e.createLiteral(!0))])])),e.setEmitFlags(t,1048576),t}function K(t,n,r){return e.setTextRange(e.createAssignment(e.createPropertyAccess(e.createIdentifier("exports"),e.getSynthesizedClone(t)),n),r)}function U(e){switch(e.kind){case 84:case 79:return}return e}function V(t){if(4096&e.getEmitFlags(t)){var n=e.getExternalHelpersModuleName(f);return n?e.createPropertyAccess(n,t):t}if(!e.isGeneratedIdentifier(t)&&!e.isLocalName(t)){var r=c.getReferencedExportContainer(t,e.isExportName(t));if(r&&265===r.kind)return e.setTextRange(e.createPropertyAccess(e.createIdentifier("exports"),e.getSynthesizedClone(t)),t);var i=c.getReferencedImportDeclaration(t);if(i){if(e.isImportClause(i))return e.setTextRange(e.createPropertyAccess(e.getGeneratedNameForNode(i.parent),e.createIdentifier("default")),t);if(e.isImportSpecifier(i)){var a=i.propertyName||i.name;return e.setTextRange(e.createPropertyAccess(e.getGeneratedNameForNode(i.parent.parent.parent),e.getSynthesizedClone(a)),t)}}}return t}function q(t){if(!e.isGeneratedIdentifier(t)){var n=c.getReferencedImportDeclaration(t)||c.getReferencedValueDeclaration(t);if(n)return m&&m.exportedBindings[e.getOriginalNodeId(n)]}}};var t={name:"typescript:export-star",scoped:!0,text:"\n            function __export(m) {\n                for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];\n            }\n        "};var n={name:"typescript:dynamicimport-sync-require",scoped:!0,text:'\n            var __syncRequire = typeof module === "object" && typeof module.exports === "object";'}}(ts||(ts={})),function(e){e.transformSystemModule=function(t){var n=t.startLexicalEnvironment,r=t.endLexicalEnvironment,i=t.hoistVariableDeclaration,a=t.getCompilerOptions(),o=t.getEmitResolver(),s=t.getEmitHost(),c=t.onSubstituteNode,u=t.onEmitNode;t.onSubstituteNode=function(t,n){if(function(e){return g&&e.id&&g[e.id]}(n=c(t,n)))return n;if(1===t)return function(t){switch(t.kind){case 71:return function(t){if(4096&e.getEmitFlags(t)){var n=e.getExternalHelpersModuleName(_);return n?e.createPropertyAccess(n,t):t}if(!e.isGeneratedIdentifier(t)&&!e.isLocalName(t)){var r=o.getReferencedImportDeclaration(t);if(r){if(e.isImportClause(r))return e.setTextRange(e.createPropertyAccess(e.getGeneratedNameForNode(r.parent),e.createIdentifier("default")),t);if(e.isImportSpecifier(r))return e.setTextRange(e.createPropertyAccess(e.getGeneratedNameForNode(r.parent.parent.parent),e.getSynthesizedClone(r.propertyName||r.name)),t)}}return t}(t);case 194:return function(t){if(e.isAssignmentOperator(t.operatorToken.kind)&&e.isIdentifier(t.left)&&!e.isGeneratedIdentifier(t.left)&&!e.isLocalName(t.left)&&!e.isDeclarationNameOfEnumOrNamespace(t.left)){var n=q(t.left);if(n){for(var r=t,i=0,a=n;i<a.length;i++){r=J(a[i],W(r))}return r}}return t}(t);case 192:case 193:return function(t){if((43===t.operator||44===t.operator)&&e.isIdentifier(t.operand)&&!e.isGeneratedIdentifier(t.operand)&&!e.isLocalName(t.operand)&&!e.isDeclarationNameOfEnumOrNamespace(t.operand)){var n=q(t.operand);if(n){for(var r=193===t.kind?e.setTextRange(e.createPrefix(t.operator,t.operand),t):t,i=0,a=n;i<a.length;i++){r=J(a[i],W(r))}return 193===t.kind&&(r=43===t.operator?e.createSubtract(W(r),e.createLiteral(1)):e.createAdd(W(r),e.createLiteral(1))),r}}return t}(t)}return t}(n);return n},t.onEmitNode=function(t,n,r){if(265===n.kind){var i=e.getOriginalNodeId(n);_=n,l=y[i],d=v[i],(g=b[i])&&delete b[i],u(t,n,r),_=void 0,l=void 0,d=void 0,g=void 0}else u(t,n,r)},t.enableSubstitution(71),t.enableSubstitution(194),t.enableSubstitution(192),t.enableSubstitution(193),t.enableEmitNotification(265);var _,l,d,p,f,m,g,y=[],h=[],v=[],b=[];return function(t){if(t.isDeclarationFile||!(e.isEffectiveExternalModule(t,a)||67108864&t.transformFlags))return t;var i=e.getOriginalNodeId(t);_=t,m=t,l=y[i]=e.collectExternalModuleInfo(t,o,a),d=e.createUniqueName("exports"),v[i]=d,p=e.createUniqueName("context");var c=function(t){for(var n=e.createMap(),r=[],i=0;i<t.length;i++){var c=t[i],u=e.getExternalModuleNameLiteral(c,_,s,o,a);if(u){var l=u.text,d=n.get(l);void 0!==d?r[d].externalImports.push(c):(n.set(l,r.length),r.push({name:u,externalImports:[c]}))}}return r}(l.externalImports),u=function(t,i){var o=[];n();var s=a.alwaysStrict||!a.noImplicitUseStrict&&e.isExternalModule(_),c=e.addPrologue(o,t.statements,s,S);o.push(e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration("__moduleName",void 0,e.createLogicalAnd(p,e.createPropertyAccess(p,"id")))]))),e.visitNode(l.externalHelpersImportDeclaration,S,e.isStatement);var u=e.visitNodes(t.statements,S,e.isStatement,c);e.addRange(o,f),e.addRange(o,r());var d=function(t){if(!l.hasExportStarsToExportValues)return;if(!l.exportedNames&&0===l.exportSpecifiers.size){for(var n=!1,r=0,i=l.externalImports;r<i.length;r++){if(244===(p=i[r]).kind&&p.exportClause){n=!0;break}}if(!n){var a=x(void 0);return t.push(a),a.name}}var o=[];if(l.exportedNames)for(var s=0,c=l.exportedNames;s<c.length;s++){var u=c[s];"default"!==u.escapedText&&o.push(e.createPropertyAssignment(e.createLiteral(u),e.createTrue()))}for(var _=0,d=l.externalImports;_<d.length;_++){var p;if(244===(p=d[_]).kind){var f=p;if(f.exportClause)for(var m=0,g=f.exportClause.elements;m<g.length;m++){var y=g[m];o.push(e.createPropertyAssignment(e.createLiteral(e.idText(y.name||y.propertyName)),e.createTrue()))}}}var h=e.createUniqueName("exportedNames");t.push(e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration(h,void 0,e.createObjectLiteral(o,!0))])));var v=x(h);return t.push(v),v.name}(o),m=e.createObjectLiteral([e.createPropertyAssignment("setters",k(d,i)),e.createPropertyAssignment("execute",e.createFunctionExpression(void 0,void 0,void 0,void 0,[],void 0,e.createBlock(u,!0)))]);return m.multiLine=!0,o.push(e.createReturn(m)),e.createBlock(o,!0)}(t,c),h=e.createFunctionExpression(void 0,void 0,void 0,void 0,[e.createParameter(void 0,void 0,void 0,d),e.createParameter(void 0,void 0,void 0,p)],void 0,u),D=e.tryGetModuleNameFromFile(t,s,a),C=e.createArrayLiteral(e.map(c,(function(e){return e.name}))),T=e.setEmitFlags(e.updateSourceFileNode(t,e.setTextRange(e.createNodeArray([e.createStatement(e.createCall(e.createPropertyAccess(e.createIdentifier("System"),"register"),void 0,D?[D,C,h]:[C,h]))]),t.statements)),1024);a.outFile||a.out||e.moveEmitHelpers(T,u,(function(e){return!e.scoped}));g&&(b[i]=g,g=void 0);return _=void 0,l=void 0,d=void 0,p=void 0,f=void 0,m=void 0,e.aggregateTransformFlags(T)};function x(t){var n=e.createUniqueName("exportStar"),r=e.createIdentifier("m"),i=e.createIdentifier("n"),a=e.createIdentifier("exports"),o=e.createStrictInequality(i,e.createLiteral("default"));return t&&(o=e.createLogicalAnd(o,e.createLogicalNot(e.createCall(e.createPropertyAccess(t,"hasOwnProperty"),void 0,[i])))),e.createFunctionDeclaration(void 0,void 0,void 0,n,void 0,[e.createParameter(void 0,void 0,void 0,r)],void 0,e.createBlock([e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration(a,void 0,e.createObjectLiteral([]))])),e.createForIn(e.createVariableDeclarationList([e.createVariableDeclaration(i,void 0)]),r,e.createBlock([e.setEmitFlags(e.createIf(o,e.createStatement(e.createAssignment(e.createElementAccess(a,i),e.createElementAccess(r,i)))),1)])),e.createStatement(e.createCall(d,void 0,[a]))],!0))}function k(t,n){for(var r=[],i=0,a=n;i<a.length;i++){for(var o=a[i],s=e.forEach(o.externalImports,(function(t){return e.getLocalNameForExternalImport(t,_)})),c=s?e.getGeneratedNameForNode(s):e.createUniqueName(""),u=[],l=0,p=o.externalImports;l<p.length;l++){var f=p[l],m=e.getLocalNameForExternalImport(f,_);switch(f.kind){case 238:if(!f.importClause)break;case 237:e.Debug.assert(void 0!==m),u.push(e.createStatement(e.createAssignment(m,c)));break;case 244:if(e.Debug.assert(void 0!==m),f.exportClause){for(var g=[],y=0,h=f.exportClause.elements;y<h.length;y++){var v=h[y];g.push(e.createPropertyAssignment(e.createLiteral(e.idText(v.name)),e.createElementAccess(c,e.createLiteral(e.idText(v.propertyName||v.name)))))}u.push(e.createStatement(e.createCall(d,void 0,[e.createObjectLiteral(g,!0)])))}else u.push(e.createStatement(e.createCall(t,void 0,[c])))}}r.push(e.createFunctionExpression(void 0,void 0,void 0,void 0,[e.createParameter(void 0,void 0,void 0,c)],void 0,e.createBlock(u,!0)))}return e.createArrayLiteral(r,!0)}function S(t){switch(t.kind){case 238:return function(t){var n;t.importClause&&i(e.getLocalNameForExternalImport(t,_));if(w(t)){var r=e.getOriginalNodeId(t);h[r]=P(h[r],t)}else n=P(n,t);return e.singleOrMany(n)}(t);case 237:return function(t){var n;if(e.Debug.assert(e.isExternalModuleImportEqualsDeclaration(t),"import= for internal module references should be handled in an earlier transformer."),i(e.getLocalNameForExternalImport(t,_)),w(t)){var r=e.getOriginalNodeId(t);h[r]=F(h[r],t)}else n=F(n,t);return e.singleOrMany(n)}(t);case 244:return;case 243:return function(t){if(t.isExportEquals)return;var n=e.visitNode(t.expression,K,e.isExpression),r=t.original;if(!r||!w(r))return B(e.createIdentifier("default"),n,!0);var i=e.getOriginalNodeId(t);h[i]=M(h[i],e.createIdentifier("default"),n,!0)}(t);default:return z(t)}}function D(t){if(e.isBindingPattern(t.name))for(var n=0,r=t.name.elements;n<r.length;n++){var a=r[n];e.isOmittedExpression(a)||D(a)}else i(e.getSynthesizedClone(t.name))}function C(t){return 0==(2097152&e.getEmitFlags(t))&&(265===m.kind||0==(3&e.getOriginalNode(t).flags))}function T(n,r){var i=r?E:N;return e.isBindingPattern(n.name)?e.flattenDestructuringAssignment(n,K,t,0,!1,i):n.initializer?i(n.name,e.visitNode(n.initializer,K,e.isExpression)):n.name}function E(e,t,n){return A(e,t,n,!0)}function N(e,t,n){return A(e,t,n,!1)}function A(t,n,r,a){return i(e.getSynthesizedClone(t)),a?J(t,W(e.setTextRange(e.createAssignment(t,n),r))):W(e.setTextRange(e.createAssignment(t,n),r))}function w(t){return 0!=(4194304&e.getEmitFlags(t))}function P(e,t){if(l.exportEquals)return e;var n=t.importClause;if(!n)return e;n.name&&(e=L(e,n));var r=n.namedBindings;if(r)switch(r.kind){case 240:e=L(e,r);break;case 241:for(var i=0,a=r.elements;i<a.length;i++){e=L(e,a[i])}}return e}function F(e,t){return l.exportEquals?e:L(e,t)}function O(e,t,n){if(l.exportEquals)return e;for(var r=0,i=t.declarationList.declarations;r<i.length;r++){var a=i[r];(a.initializer||n)&&(e=I(e,a,n))}return e}function I(t,n,r){if(l.exportEquals)return t;if(e.isBindingPattern(n.name))for(var i=0,a=n.name.elements;i<a.length;i++){var o=a[i];e.isOmittedExpression(o)||(t=I(t,o,r))}else if(!e.isGeneratedIdentifier(n.name)){var s=void 0;r&&(t=M(t,n.name,e.getLocalName(n)),s=e.idText(n.name)),t=L(t,n,s)}return t}function R(t,n){if(l.exportEquals)return t;var r;if(e.hasModifier(n,1)){var i=e.hasModifier(n,512)?e.createLiteral("default"):n.name;t=M(t,i,e.getLocalName(n)),r=e.getTextOfIdentifierOrLiteral(i)}return n.name&&(t=L(t,n,r)),t}function L(t,n,r){if(l.exportEquals)return t;var i=e.getDeclarationName(n),a=l.exportSpecifiers.get(e.idText(i));if(a)for(var o=0,s=a;o<s.length;o++){var c=s[o];c.name.escapedText!==r&&(t=M(t,c.name,i))}return t}function M(t,n,r,i){return t=e.append(t,B(n,r,i))}function B(t,n,r){var i=e.createStatement(J(t,n));return e.startOnNewLine(i),r||e.setEmitFlags(i,1536),i}function J(t,n){var r=e.isIdentifier(t)?e.createLiteral(t):t;return e.setEmitFlags(n,1536|e.getEmitFlags(n)),e.setCommentRange(e.createCall(d,void 0,[r,n]),n)}function z(n){switch(n.kind){case 208:return function(t){if(!C(t.declarationList))return e.visitNode(t,K,e.isStatement);for(var n,r,i=e.hasModifier(t,1),a=w(t),o=0,s=t.declarationList.declarations;o<s.length;o++){var c=s[o];c.initializer?n=e.append(n,T(c,i&&!a)):D(c)}if(n&&(r=e.append(r,e.setTextRange(e.createStatement(e.inlineExpressions(n)),t))),a){var u=e.getOriginalNodeId(t);h[u]=O(h[u],t,i)}else r=O(r,t,!1);return e.singleOrMany(r)}(n);case 228:return function(n){if(f=e.hasModifier(n,1)?e.append(f,e.updateFunctionDeclaration(n,n.decorators,e.visitNodes(n.modifiers,V,e.isModifier),n.asteriskToken,e.getDeclarationName(n,!0,!0),void 0,e.visitNodes(n.parameters,K,e.isParameterDeclaration),void 0,e.visitNode(n.body,K,e.isBlock))):e.append(f,e.visitEachChild(n,K,t)),w(n)){var r=e.getOriginalNodeId(n);h[r]=R(h[r],n)}else f=R(f,n)}(n);case 229:return function(t){var n,r=e.getLocalName(t);if(i(r),n=e.append(n,e.setTextRange(e.createStatement(e.createAssignment(r,e.setTextRange(e.createClassExpression(void 0,t.name,void 0,e.visitNodes(t.heritageClauses,K,e.isHeritageClause),e.visitNodes(t.members,K,e.isClassElement)),t))),t)),w(t)){var a=e.getOriginalNodeId(t);h[a]=R(h[a],t)}else n=R(n,t);return e.singleOrMany(n)}(n);case 214:return function(t){var n=m;return m=t,t=e.updateFor(t,j(t.initializer),e.visitNode(t.condition,K,e.isExpression),e.visitNode(t.incrementor,K,e.isExpression),e.visitNode(t.statement,z,e.isStatement)),m=n,t}(n);case 215:return function(t){var n=m;return m=t,t=e.updateForIn(t,j(t.initializer),e.visitNode(t.expression,K,e.isExpression),e.visitNode(t.statement,z,e.isStatement,e.liftToBlock)),m=n,t}(n);case 216:return function(t){var n=m;return m=t,t=e.updateForOf(t,t.awaitModifier,j(t.initializer),e.visitNode(t.expression,K,e.isExpression),e.visitNode(t.statement,z,e.isStatement,e.liftToBlock)),m=n,t}(n);case 212:return function(t){return e.updateDo(t,e.visitNode(t.statement,z,e.isStatement,e.liftToBlock),e.visitNode(t.expression,K,e.isExpression))}(n);case 213:return function(t){return e.updateWhile(t,e.visitNode(t.expression,K,e.isExpression),e.visitNode(t.statement,z,e.isStatement,e.liftToBlock))}(n);case 222:return function(t){return e.updateLabel(t,t.label,e.visitNode(t.statement,z,e.isStatement,e.liftToBlock))}(n);case 220:return function(t){return e.updateWith(t,e.visitNode(t.expression,K,e.isExpression),e.visitNode(t.statement,z,e.isStatement,e.liftToBlock))}(n);case 221:return function(t){return e.updateSwitch(t,e.visitNode(t.expression,K,e.isExpression),e.visitNode(t.caseBlock,z,e.isCaseBlock))}(n);case 235:return function(t){var n=m;return m=t,t=e.updateCaseBlock(t,e.visitNodes(t.clauses,z,e.isCaseOrDefaultClause)),m=n,t}(n);case 257:return function(t){return e.updateCaseClause(t,e.visitNode(t.expression,K,e.isExpression),e.visitNodes(t.statements,z,e.isStatement))}(n);case 258:case 224:return function(n){return e.visitEachChild(n,z,t)}(n);case 260:return function(t){var n=m;return m=t,t=e.updateCatchClause(t,t.variableDeclaration,e.visitNode(t.block,z,e.isBlock)),m=n,t}(n);case 207:return function(n){var r=m;return m=n,n=e.visitEachChild(n,z,t),m=r,n}(n);case 290:return function(t){if(w(t)&&208===t.original.kind){var n=e.getOriginalNodeId(t),r=e.hasModifier(t.original,1);h[n]=O(h[n],t.original,r)}return t}(n);case 291:return function(t){var n=e.getOriginalNodeId(t),r=h[n];return r?(delete h[n],e.append(r,t)):t}(n);default:return K(n)}}function j(n){if(!n)return n;if(function(t){return e.isVariableDeclarationList(t)&&C(t)}(n)){for(var r=void 0,i=0,a=n.declarations;i<a.length;i++){var o=a[i];r=e.append(r,T(o,!1)),o.initializer||D(o)}return r?e.inlineExpressions(r):e.createOmittedExpression()}return e.visitEachChild(n,z,t)}function K(n){return 1024&n.transformFlags&&194===n.kind?function(n){if(U(n.left))return e.flattenDestructuringAssignment(n,K,t,0,!0);return e.visitEachChild(n,K,t)}(n):e.isImportCall(n)?function(t){return e.createCall(e.createPropertyAccess(p,e.createIdentifier("import")),void 0,e.some(t.arguments)?[e.visitNode(t.arguments[0],K)]:[])}(n):2048&n.transformFlags||67108864&n.transformFlags?e.visitEachChild(n,K,t):n}function U(t){if(e.isAssignmentExpression(t,!0))return U(t.left);if(e.isSpreadElement(t))return U(t.expression);if(e.isObjectLiteralExpression(t))return e.some(t.properties,U);if(e.isArrayLiteralExpression(t))return e.some(t.elements,U);if(e.isShorthandPropertyAssignment(t))return U(t.name);if(e.isPropertyAssignment(t))return U(t.initializer);if(e.isIdentifier(t)){var n=o.getReferencedExportContainer(t);return void 0!==n&&265===n.kind}return!1}function V(e){switch(e.kind){case 84:case 79:return}return e}function q(t){var n;if(!e.isGeneratedIdentifier(t)){var r=o.getReferencedImportDeclaration(t)||o.getReferencedValueDeclaration(t);if(r){var i=o.getReferencedExportContainer(t,!1);i&&265===i.kind&&(n=e.append(n,e.getDeclarationName(r))),n=e.addRange(n,l&&l.exportedBindings[e.getOriginalNodeId(r)])}}return n}function W(t){return void 0===g&&(g=[]),g[e.getNodeId(t)]=!0,t}}}(ts||(ts={})),function(e){e.transformES2015Module=function(t){var n,r=t.getCompilerOptions(),i=t.onEmitNode,a=t.onSubstituteNode;return t.onEmitNode=function(t,r,a){e.isSourceFile(r)?(n=r,i(t,r,a),n=void 0):i(t,r,a)},t.onSubstituteNode=function(t,r){if(r=a(t,r),e.isIdentifier(r)&&1===t)return function(t){if(4096&e.getEmitFlags(t)){var r=e.getExternalHelpersModuleName(n);if(r)return e.createPropertyAccess(r,t)}return t}(r);return r},t.enableEmitNotification(265),t.enableSubstitution(71),function(n){if(n.isDeclarationFile)return n;if(e.isExternalModule(n)||r.isolatedModules){var i=e.getOrCreateExternalHelpersModuleNameIfNeeded(n,r);if(i){var a=[],s=e.addPrologue(a,n.statements);return e.append(a,e.createImportDeclaration(void 0,void 0,e.createImportClause(void 0,e.createNamespaceImport(i)),e.createLiteral(e.externalHelpersModuleNameText))),e.addRange(a,e.visitNodes(n.statements,o,e.isStatement,s)),e.updateSourceFileNode(n,e.setTextRange(e.createNodeArray(a),n.statements))}return e.visitEachChild(n,o,t)}return n};function o(e){switch(e.kind){case 237:return;case 243:return function(e){return e.isExportEquals?void 0:e}(e)}return e}}}(ts||(ts={})),function(e){var t,n;!function(e){e[e.Uninitialized=0]="Uninitialized",e[e.Initialized=1]="Initialized",e[e.Completed=2]="Completed",e[e.Disposed=3]="Disposed"}(t||(t={})),function(e){e[e.Substitution=1]="Substitution",e[e.EmitNotifications=2]="EmitNotifications"}(n||(n={})),e.getTransformers=function(t,n){var r=t.jsx,i=e.getEmitScriptTarget(t),a=e.getEmitModuleKind(t),o=[];return e.addRange(o,n&&n.before),o.push(e.transformTypeScript),2===r&&o.push(e.transformJsx),i<5&&o.push(e.transformESNext),i<4&&o.push(e.transformES2017),i<3&&o.push(e.transformES2016),i<2&&(o.push(e.transformES2015),o.push(e.transformGenerators)),o.push(function(t){switch(t){case e.ModuleKind.ESNext:case e.ModuleKind.ES2015:return e.transformES2015Module;case e.ModuleKind.System:return e.transformSystemModule;default:return e.transformModule}}(a)),i<1&&o.push(e.transformES5),e.addRange(o,n&&n.after),o},e.transformNodes=function(t,n,r,i,a,o){for(var s,c,u,_=new Array(292),l=[],d=[],p=0,f=!1,m=function(e,t){return t},g=function(e,t,n){return n(e,t)},y=0,h={getCompilerOptions:function(){return r},getEmitResolver:function(){return t},getEmitHost:function(){return n},startLexicalEnvironment:function(){e.Debug.assert(y>0,"Cannot modify the lexical environment during initialization."),e.Debug.assert(y<2,"Cannot modify the lexical environment after transformation has completed."),e.Debug.assert(!f,"Lexical environment is suspended."),l[p]=s,d[p]=c,p++,s=void 0,c=void 0},suspendLexicalEnvironment:function(){e.Debug.assert(y>0,"Cannot modify the lexical environment during initialization."),e.Debug.assert(y<2,"Cannot modify the lexical environment after transformation has completed."),e.Debug.assert(!f,"Lexical environment is already suspended."),f=!0},resumeLexicalEnvironment:function(){e.Debug.assert(y>0,"Cannot modify the lexical environment during initialization."),e.Debug.assert(y<2,"Cannot modify the lexical environment after transformation has completed."),e.Debug.assert(f,"Lexical environment is not suspended."),f=!1},endLexicalEnvironment:function(){var t;if(e.Debug.assert(y>0,"Cannot modify the lexical environment during initialization."),e.Debug.assert(y<2,"Cannot modify the lexical environment after transformation has completed."),e.Debug.assert(!f,"Lexical environment is suspended."),(s||c)&&(c&&(t=c.slice()),s)){var n=e.createVariableStatement(void 0,e.createVariableDeclarationList(s));t?t.push(n):t=[n]}p--,s=l[p],c=d[p],0===p&&(l=[],d=[]);return t},hoistVariableDeclaration:function(t){e.Debug.assert(y>0,"Cannot modify the lexical environment during initialization."),e.Debug.assert(y<2,"Cannot modify the lexical environment after transformation has completed.");var n=e.setEmitFlags(e.createVariableDeclaration(t),64);s?s.push(n):s=[n]},hoistFunctionDeclaration:function(t){e.Debug.assert(y>0,"Cannot modify the lexical environment during initialization."),e.Debug.assert(y<2,"Cannot modify the lexical environment after transformation has completed."),c?c.push(t):c=[t]},requestEmitHelper:function(t){e.Debug.assert(y>0,"Cannot modify the transformation context during initialization."),e.Debug.assert(y<2,"Cannot modify the transformation context after transformation has completed."),e.Debug.assert(!t.scoped,"Cannot request a scoped emit helper."),u=e.append(u,t)},readEmitHelpers:function(){e.Debug.assert(y>0,"Cannot modify the transformation context during initialization."),e.Debug.assert(y<2,"Cannot modify the transformation context after transformation has completed.");var t=u;return u=void 0,t},enableSubstitution:function(t){e.Debug.assert(y<2,"Cannot modify the transformation context after transformation has completed."),_[t]|=1},enableEmitNotification:function(t){e.Debug.assert(y<2,"Cannot modify the transformation context after transformation has completed."),_[t]|=2},isSubstitutionEnabled:D,isEmitNotificationEnabled:C,get onSubstituteNode(){return m},set onSubstituteNode(t){e.Debug.assert(y<1,"Cannot modify transformation hooks after initialization has completed."),e.Debug.assert(void 0!==t,"Value must not be 'undefined'"),m=t},get onEmitNode(){return g},set onEmitNode(t){e.Debug.assert(y<1,"Cannot modify transformation hooks after initialization has completed."),e.Debug.assert(void 0!==t,"Value must not be 'undefined'"),g=t}},v=0,b=i;v<b.length;v++){var x=b[v];e.disposeEmitNodes(e.getSourceFileOfNode(e.getParseTreeNode(x)))}e.performance.mark("beforeTransform");var k=e.chain.apply(void 0,a)(h);y=1;var S=e.map(i,o?k:function(t){return!t||e.isSourceFile(t)&&t.isDeclarationFile?t:k(t)});return y=2,e.performance.mark("afterTransform"),e.performance.measure("transformTime","beforeTransform","afterTransform"),{transformed:S,substituteNode:function(t,n){return e.Debug.assert(y<3,"Cannot substitute a node after the result is disposed."),n&&D(n)&&m(t,n)||n},emitNodeWithNotification:function(t,n,r){e.Debug.assert(y<3,"Cannot invoke TransformationResult callbacks after the result is disposed."),n&&(C(n)?g(t,n,r):r(t,n))},dispose:function(){if(y<3){for(var t=0,n=i;t<n.length;t++){var r=n[t];e.disposeEmitNodes(e.getSourceFileOfNode(e.getParseTreeNode(r)))}s=void 0,l=void 0,c=void 0,d=void 0,m=void 0,g=void 0,u=void 0,y=3}}};function D(t){return 0!=(1&_[t.kind])&&0==(4&e.getEmitFlags(t))}function C(t){return 0!=(2&_[t.kind])||0!=(2&e.getEmitFlags(t))}}}(ts||(ts={})),function(e){var t={emittedLine:1,emittedColumn:1,sourceLine:1,sourceColumn:1,sourceIndex:0};e.createSourceMapWriter=function(n,i){var a,o,s,c,u,_,l,d,p=n.getCompilerOptions(),f=p.extendedDiagnostics,m=!(p.sourceMap||p.inlineSourceMap);return{initialize:function(r,i,f){if(m)return;d&&y();a=void 0,o=void 0,c=-1,u=void 0,_=t,l=0,(d={sourceMapFilePath:i,jsSourceMappingURL:p.inlineSourceMap?void 0:e.getBaseFileName(e.normalizeSlashes(i)),sourceMapFile:e.getBaseFileName(e.normalizeSlashes(r)),sourceMapSourceRoot:p.sourceRoot||"",sourceMapSources:[],inputSourceFileNames:[],sourceMapNames:[],sourceMapMappings:"",sourceMapSourcesContent:p.inlineSources?[]:void 0,sourceMapDecodedMappings:[]}).sourceMapSourceRoot=e.normalizeSlashes(d.sourceMapSourceRoot),d.sourceMapSourceRoot.length&&47!==d.sourceMapSourceRoot.charCodeAt(d.sourceMapSourceRoot.length-1)&&(d.sourceMapSourceRoot+=e.directorySeparator);p.mapRoot?(s=e.normalizeSlashes(p.mapRoot),265===f.kind&&(s=e.getDirectoryPath(e.getSourceFilePathInNewDir(f,n,s))),e.isRootedDiskPath(s)||e.isUrl(s)?d.jsSourceMappingURL=e.combinePaths(s,d.jsSourceMappingURL):(s=e.combinePaths(n.getCommonSourceDirectory(),s),d.jsSourceMappingURL=e.getRelativePathToDirectoryOrUrl(e.getDirectoryPath(e.normalizePath(r)),e.combinePaths(s,d.jsSourceMappingURL),n.getCurrentDirectory(),n.getCanonicalFileName,!0))):s=e.getDirectoryPath(e.normalizePath(r))},reset:y,getSourceMapData:function(){return d},setSourceFile:b,emitPos:v,emitNodeWithSourceMap:function(e,t,n){if(m)return n(e,t);if(t){var r=t.emitNode,i=r&&r.flags,o=r&&r.sourceMapRange,s=o||t,c=s.pos,u=s.end,_=o&&o.source,l=a;_===l&&(_=void 0),_&&b(_),287!==t.kind&&0==(16&i)&&c>=0&&v(g(c)),_&&b(l),64&i?(m=!0,n(e,t),m=!1):n(e,t),_&&b(_),287!==t.kind&&0==(32&i)&&u>=0&&v(u),_&&b(l)}},emitTokenWithSourceMap:function(e,t,n,r){if(m)return r(t,n);var i=e&&e.emitNode,a=i&&i.flags,o=i&&i.tokenSourceMapRanges&&i.tokenSourceMapRanges[t];n=g(o?o.pos:n),0==(128&a)&&n>=0&&v(n);n=r(t,n),o&&(n=o.end);0==(256&a)&&n>=0&&v(n);return n},getText:x,getSourceMappingURL:function(){if(m)return;if(p.inlineSourceMap){var t=e.convertToBase64(x());return d.jsSourceMappingURL="data:application/json;base64,"+t}return d.jsSourceMappingURL}};function g(t){return a.skipTrivia?a.skipTrivia(t):e.skipTrivia(o,t)}function y(){m||(a=void 0,s=void 0,c=void 0,u=void 0,_=void 0,l=void 0,d=void 0)}function h(){if(u&&u!==_){var t=_.emittedColumn;if(_.emittedLine===u.emittedLine)d.sourceMapMappings&&(d.sourceMapMappings+=",");else{for(var n=_.emittedLine;n<u.emittedLine;n++)d.sourceMapMappings+=";";t=1}d.sourceMapMappings+=r(u.emittedColumn-t),d.sourceMapMappings+=r(u.sourceIndex-_.sourceIndex),d.sourceMapMappings+=r(u.sourceLine-_.sourceLine),d.sourceMapMappings+=r(u.sourceColumn-_.sourceColumn),u.nameIndex>=0&&(e.Debug.assert(!1,"We do not support name index right now, Make sure to update updateLastEncodedAndRecordedSpans when we start using this"),d.sourceMapMappings+=r(u.nameIndex-l),l=u.nameIndex),_=u,d.sourceMapDecodedMappings.push(_)}}function v(t){if(!m&&!e.positionIsSynthesized(t)){f&&e.performance.mark("beforeSourcemap");var n=e.getLineAndCharacterOfPosition(a,t);n.line++,n.character++;var r=i.getLine(),o=i.getColumn();!u||u.emittedLine!==r||u.emittedColumn!==o||u.sourceIndex===c&&(u.sourceLine>n.line||u.sourceLine===n.line&&u.sourceColumn>n.character)?(h(),u={emittedLine:r,emittedColumn:o,sourceLine:n.line,sourceColumn:n.character,sourceIndex:c}):(u.sourceLine=n.line,u.sourceColumn=n.character,u.sourceIndex=c),f&&(e.performance.mark("afterSourcemap"),e.performance.measure("Source Map","beforeSourcemap","afterSourcemap"))}}function b(t){if(!m){o=(a=t).text;var r=p.sourceRoot?n.getCommonSourceDirectory():s,i=e.getRelativePathToDirectoryOrUrl(r,a.fileName,n.getCurrentDirectory(),n.getCanonicalFileName,!0);-1===(c=e.indexOf(d.sourceMapSources,i))&&(c=d.sourceMapSources.length,d.sourceMapSources.push(i),d.inputSourceFileNames.push(a.fileName),p.inlineSources&&d.sourceMapSourcesContent.push(a.text))}}function x(){if(!m)return h(),JSON.stringify({version:3,file:d.sourceMapFile,sourceRoot:d.sourceMapSourceRoot,sources:d.sourceMapSources,names:d.sourceMapNames,mappings:d.sourceMapMappings,sourcesContent:d.sourceMapSourcesContent})}};function n(e){if(e<64)return"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".charAt(e);throw TypeError(e+": not a 64 based value")}function r(e){e<0?e=1+(-e<<1):e<<=1;var t="";do{var r=31&e;(e>>=5)>0&&(r|=32),t+=n(r)}while(e>0);return t}}(ts||(ts={})),function(e){e.createCommentWriter=function(t,n){var r,i,a,o,s,c=t.extendedDiagnostics,u=e.getNewLineCharacter(t),_=-1,l=-1,d=-1,p=!1,f=t.removeComments;return{reset:function(){i=void 0,a=void 0,o=void 0,s=void 0},setWriter:function(e){r=e},setSourceFile:function(t){a=(i=t).text,o=e.getLineStarts(i),s=void 0},emitNodeWithComments:function(t,n,r){if(f)return void r(t,n);if(n){p=!1;var i=n.emitNode,a=i&&i.flags,o=i&&i.commentRange||n,s=o.pos,u=o.end;if(s<0&&u<0||s===u)m(t,n,i,a,r);else{c&&e.performance.mark("preEmitNodeWithComment");var g=287!==n.kind,y=s<0||0!=(512&a)||10===n.kind,h=u<0||0!=(1024&a)||10===n.kind;y||v(s,g);var b=_,x=l,S=d;y||(_=s),h||(l=u,227===n.kind&&(d=u)),c&&e.performance.measure("commentTime","preEmitNodeWithComment"),m(t,n,i,a,r),c&&e.performance.mark("postEmitNodeWithComment"),_=b,l=x,d=S,!h&&g&&function(e){C(e,k)}(u),c&&e.performance.measure("commentTime","postEmitNodeWithComment")}}},emitBodyWithDetachedComments:function(t,n,i){c&&e.performance.mark("preEmitBodyWithDetachedComments");var _=n.pos,l=n.end,d=e.getEmitFlags(t),m=f||l<0||0!=(1024&d);_<0||0!=(512&d)||(g=n,(y=e.emitDetachedComments(a,o,r,T,g,u,f))&&(s?s.push(y):s=[y]));var g,y;c&&e.performance.measure("commentTime","preEmitBodyWithDetachedComments");2048&d&&!f?(f=!0,i(t),f=!1):i(t);c&&e.performance.mark("beginEmitBodyWithDetachedCommetns");m||(v(n.end,!0),p&&!r.isAtStartOfLine()&&r.writeLine());c&&e.performance.measure("commentTime","beginEmitBodyWithDetachedCommetns")},emitTrailingCommentsOfPosition:function(t,n){if(f)return;c&&e.performance.mark("beforeEmitTrailingCommentsOfPosition");C(t,n?k:S),c&&e.performance.measure("commentTime","beforeEmitTrailingCommentsOfPosition")},emitLeadingCommentsOfPosition:function(e){if(f||-1===e)return;v(e,!0)}};function m(t,n,r,i,a){var o=r&&r.leadingComments;e.some(o)&&(c&&e.performance.mark("preEmitNodeWithSynthesizedComments"),e.forEach(o,g),c&&e.performance.measure("commentTime","preEmitNodeWithSynthesizedComments")),function(e,t,n,r){2048&n?(f=!0,r(e,t),f=!1):r(e,t)}(t,n,i,a);var s=r&&r.trailingComments;e.some(s)&&(c&&e.performance.mark("postEmitNodeWithSynthesizedComments"),e.forEach(s,y),c&&e.performance.measure("commentTime","postEmitNodeWithSynthesizedComments"))}function g(e){2===e.kind&&r.writeLine(),h(e),e.hasTrailingNewLine||2===e.kind?r.writeLine():r.write(" ")}function y(e){r.isAtStartOfLine()||r.write(" "),h(e),e.hasTrailingNewLine&&r.writeLine()}function h(t){var n=function(e){return 3===e.kind?"/*"+e.text+"*/":"//"+e.text}(t),i=3===t.kind?e.computeLineStarts(n):void 0;e.writeCommentRange(n,i,r,0,n.length,u)}function v(e,t){p=!1,t?D(e,x):0===e&&D(e,b)}function b(t,n,r,i,o){(function(t,n){return e.isRecognizedTripleSlashComment(a,t,n)})(t,n)&&x(t,n,r,i,o)}function x(t,i,s,c,_){p||(e.emitNewLineBeforeLeadingCommentOfPosition(o,r,_,t),p=!0),n&&n(t),e.writeCommentRange(a,o,r,t,i,u),n&&n(i),c?r.writeLine():r.write(" ")}function k(t,i,s,c){r.isAtStartOfLine()||r.write(" "),n&&n(t),e.writeCommentRange(a,o,r,t,i,u),n&&n(i),c&&r.writeLine()}function S(t,i,s,c){n&&n(t),e.writeCommentRange(a,o,r,t,i,u),n&&n(i),c?r.writeLine():r.write(" ")}function D(t,n){-1!==_&&t===_||(function(t){return void 0!==s&&e.lastOrUndefined(s).nodePos===t}(t)?function(t){var n=e.lastOrUndefined(s).detachedCommentEndPos;s.length-1?s.pop():s=void 0;e.forEachLeadingCommentRange(a,n,t,n)}(n):e.forEachLeadingCommentRange(a,t,n,t))}function C(t,n){(-1===l||t!==l&&t!==d)&&e.forEachTrailingCommentRange(a,t,n)}function T(t,r,i,a,o,s){n&&n(a),e.writeCommentRange(t,r,i,a,o,s),n&&n(o)}}}(ts||(ts={})),function(e){function t(t,n,r,i,a,o){var s,c,u,_,l,d,p,f,m,g,y,h,v=266===a.kind?a.sourceFiles:[a],b=266===a.kind,x=t.getNewLine(),k=t.getCompilerOptions();L();var S,D,C,T=!1,E=k.removeComments?e.noop:function(t){if(t){var n=e.getJSDocCommentRanges(t,m);e.emitNewLineBeforeLeadingComments(g,d,t,n),e.emitComments(m,g,d,n,!1,!0,x,e.writeCommentRange)}},N=k.stripInternal?function(t){if(t){var n=e.getLeadingCommentRanges(m,t.pos);if(e.forEach(n,R))return;ye(t)}}:ye,A=!0,w=[],P="",F=[],O=!1,I=[];return e.forEach(v,(function(n){if(!e.isSourceFileJavaScript(n)){if(k.noResolve||e.forEach(n.referencedFiles,(function(r){var a=e.tryResolveScriptReference(t,n,r);a&&!e.contains(F,a)&&(function(n,r,a){var o,s=!1;n.isDeclarationFile?o=n.fileName:e.forEachEmittedFile(t,c,n,a);o&&(o=e.getRelativePathToDirectoryOrUrl(e.getDirectoryPath(e.normalizeSlashes(i)),o,t.getCurrentDirectory(),t.getCanonicalFileName,!1),P+='/// <reference path="'+o+'" />'+x);return s;function c(t,i){var a=266===i.kind;a&&!r||(e.Debug.assert(!!t.declarationFilePath||e.isSourceFileJavaScript(n),"Declaration file is not present only for javascript files"),o=t.declarationFilePath||t.jsFilePath,s=a)}}(a,!b&&!O,o)&&(O=!0),F.push(a))})),f=!1,b&&e.isExternalModule(n)?e.isExternalModule(n)&&(A=!1,s('declare module "'+e.getResolvedExternalModuleName(t,n)+'" {'),c(),u(),X(n),_(),s("}"),c()):(A=!0,X(n)),w.length){var r=d;e.forEach(w,(function(t){if(t.isVisible&&!t.asynchronousOutput){e.Debug.assert(238===t.node.kind),L(),e.Debug.assert(0===t.indent||1===t.indent&&b);for(var n=0;n<t.indent;n++)u();re(t.node),t.asynchronousOutput=d.getText();for(n=0;n<t.indent;n++)_()}})),M(r),I=I.concat(w),w=[]}!b&&e.isExternalModule(n)&&n.moduleAugmentations.length&&!f&&(s("export {};"),c())}})),C&&e.forEachKey(C,(function(e){P+='/// <reference types="'+e+'" />'+x})),{reportedDeclarationError:T,moduleElementDeclarationEmitInfo:I,synchronousDeclarationOutput:d.getText(),referencesOutput:P};function R(t){var n=m.substring(t.pos,t.end);return e.stringContains(n,"@internal")}function L(){var t=e.createTextWriter(x);t.trackSymbol=j,t.reportInaccessibleThisError=U,t.reportPrivateInBaseOfClassExpression=K,t.writeKeyword=t.write,t.writeOperator=t.write,t.writePunctuation=t.write,t.writeSpace=t.write,t.writeStringLiteral=t.writeLiteral,t.writeParameter=t.write,t.writeProperty=t.write,t.writeSymbol=t.write,M(t)}function M(e){d=e,s=e.write,l=e.writeTextOfNode,c=e.writeLine,u=e.increaseIndent,_=e.decreaseIndent}function B(t){var n=d;e.forEach(t,(function(t){var n;226===t.kind?n=t.parent.parent:241===t.kind||242===t.kind||239===t.kind?e.Debug.fail("We should be getting ImportDeclaration instead to write"):n=t;var r=e.forEach(w,(function(e){return e.node===n?e:void 0}));if(!r&&D&&(r=e.forEach(D,(function(e){return e.node===n?e:void 0}))),r)if(238===r.node.kind)r.isVisible=!0;else{L();for(var i=r.indent;i;i--)u();233===n.kind&&(e.Debug.assert(void 0===D),D=[]),$(n),233===n.kind&&(r.subModuleElementDeclarationEmitInfo=D,D=void 0),r.asynchronousOutput=d.getText()}})),M(n)}function J(t){if(t){C||(C=e.createMap());for(var n=0,r=t;n<r.length;n++){var i=r[n];C.has(i)||C.set(i,i)}}}function z(t){if(0===t.accessibility)t&&t.aliasesToMakeVisible&&B(t.aliasesToMakeVisible);else{T=!0;var n=d.getSymbolAccessibilityDiagnostic(t);n&&(n.typeName?r.add(e.createDiagnosticForNode(t.errorNode||n.errorNode,n.diagnosticMessage,e.getTextOfNodeFromSourceText(m,n.typeName),t.errorSymbolName,t.errorModuleName)):r.add(e.createDiagnosticForNode(t.errorNode||n.errorNode,n.diagnosticMessage,t.errorSymbolName,t.errorModuleName)))}}function j(e,t,r){z(n.isSymbolAccessible(e,t,r,!0)),J(n.getTypeReferenceDirectivesForSymbol(e,r))}function K(t){S&&(T=!0,r.add(e.createDiagnosticForNode(S,e.Diagnostics.Property_0_of_exported_class_expression_may_not_be_private_or_protected,t)))}function U(){S&&(T=!0,r.add(e.createDiagnosticForNode(S,e.Diagnostics.The_inferred_type_of_0_references_an_inaccessible_this_type_A_type_annotation_is_necessary,e.declarationNameToString(S))))}function V(e,t,r){d.getSymbolAccessibilityDiagnostic=r,s(": ");var i=146===e.kind&&(n.isRequiredInitializedParameter(e)||n.isOptionalUninitializedParameterProperty(e));if(t&&!i)Q(t);else{S=e.name;var a=16388|(i?8192:0);n.writeTypeOfDeclaration(e,p,a,d),S=void 0}}function q(e){for(var t=0,n=e;t<n.length;t++){var r=n[t];N(r)}}function W(e,t,n,r){for(var i=d.getTextPos(),a=0,o=e;a<o.length;a++){var c=o[a];r&&!r(c)||(i!==d.getTextPos()&&s(t),i=d.getTextPos(),n(c))}}function H(e,t,n){W(e,", ",t,n)}function G(e,t){d.getSymbolAccessibilityDiagnostic=t,Q(e)}function Q(t){switch(t.kind){case 119:case 136:case 133:case 122:case 134:case 137:case 105:case 139:case 95:case 130:case 169:case 173:return l(m,t);case 201:return r=t,void(e.isEntityNameExpression(r.expression)&&(e.Debug.assert(71===r.expression.kind||179===r.expression.kind),a(r.expression),r.typeArguments&&(s("<"),H(r.typeArguments,Q),s(">"))));case 159:return function(e){a(e.typeName),e.typeArguments&&(s("<"),H(e.typeArguments,Q),s(">"))}(t);case 162:return function(e){s("typeof "),a(e.exprName)}(t);case 164:return function(e){Q(e.elementType),s("[]")}(t);case 165:return function(e){s("["),H(e.elementTypes,Q),s("]")}(t);case 166:return function(e){W(e.types," | ",Q)}(t);case 167:return function(e){W(e.types," & ",Q)}(t);case 168:return function(e){s("("),Q(e.type),s(")")}(t);case 170:return function(t){s(e.tokenToString(t.operator)),s(" "),Q(t.type)}(t);case 171:return function(e){Q(e.objectType),s("["),Q(e.indexType),s("]")}(t);case 172:return function(e){var t=p;p=e,s("{"),c(),u(),e.readonlyToken&&s("readonly ");s("["),i(e.typeParameter.name),s(" in "),Q(e.typeParameter.constraint),s("]"),e.questionToken&&s("?");s(": "),Q(e.type),s(";"),c(),_(),s("}"),p=t}(t);case 160:case 161:return fe(t);case 163:return function(e){s("{"),e.members.length&&(c(),u(),q(e.members),_());s("}")}(t);case 71:case 143:return a(t);case 158:return function(e){l(m,e.parameterName),s(" is "),Q(e.type)}(t)}var r;function i(e){if(71===e.kind)l(m,e);else{var t=143===e.kind?e.left:e.expression,n=143===e.kind?e.right:e.name;i(t),s("."),l(m,n)}}function a(e){z(n.isEntityNameVisible(e,237===e.parent.kind?e.parent:p)),J(n.getTypeReferenceDirectivesForEntityName(e)),i(e)}}function X(t){m=t.text,g=e.getLineStarts(t),y=t.identifiers,h=e.isExternalModule(t),p=t,e.emitDetachedComments(m,g,d,e.writeCommentRange,t,x,!0),q(t.statements)}function Y(e,t,r,i){var a=function(e){if(!y.has(e))return e;for(var t=0;;){var n=e+"_"+ ++t;if(!y.has(n))return n}}(t);return i&&s("declare "),s("const "),s(a),s(": "),d.getSymbolAccessibilityDiagnostic=function(){return r},n.writeTypeOfExpression(e,p,16388,d),s(";"),c(),a}function Z(e,t){if(t)$(e);else if(237===e.kind||265===e.parent.kind&&h){var r=void 0;if(D&&265!==e.parent.kind)D.push({node:e,outputPos:d.getTextPos(),indent:d.getIndent(),isVisible:r});else{if(238===e.kind){var i=e;i.importClause&&(r=i.importClause.name&&n.isDeclarationVisible(i.importClause)||ne(i.importClause.namedBindings))}w.push({node:e,outputPos:d.getTextPos(),indent:d.getIndent(),isVisible:r})}}}function $(t){switch(t.kind){case 228:return pe(t);case 208:return function(t){if(e.every(t.declarationList&&t.declarationList.declarations,(function(t){return t.name&&e.isEmptyBindingPattern(t.name)})))return;E(t),ee(t),e.isLet(t.declarationList)?s("let "):e.isConst(t.declarationList)?s("const "):s("var ");H(t.declarationList.declarations,le,n.isDeclarationVisible),s(";"),c()}(t);case 230:return function(t){E(t),ee(t),s("interface "),l(m,t.name);var n=p;p=t,ce(t.typeParameters);var r=e.filter(e.getInterfaceBaseTypeNodes(t),(function(t){return e.isEntityNameExpression(t.expression)}));r&&r.length&&ue(r,!1);s(" {"),c(),u(),q(t.members),_(),s("}"),c(),p=n}(t);case 229:return function(t){function n(t){t&&e.forEach(t.parameters,(function(t){e.hasModifier(t,92)&&_e(t)}))}var r=p;p=t;var i,a=e.getClassExtendsHeritageClauseElement(t);a&&!e.isEntityNameExpression(a.expression)&&(i=95===a.expression.kind?"null":Y(a.expression,t.name.escapedText+"_base",{diagnosticMessage:e.Diagnostics.extends_clause_of_exported_class_0_has_or_is_using_private_name_1,errorNode:a,typeName:t.name},!e.findAncestor(t,(function(e){return 233===e.kind}))));E(t),ee(t),e.hasModifier(t,128)&&s("abstract ");s("class "),l(m,t.name),ce(t.typeParameters),a&&(e.isEntityNameExpression(a.expression)?ue([a],!1):(s(" extends "),s(i),a.typeArguments&&(s("<"),H(a.typeArguments,Q),s(">"))));ue(e.getClassImplementsHeritageClauseElements(t),!0),s(" {"),c(),u(),n(e.getFirstConstructorWithBody(t)),q(t.members),_(),s("}"),c(),p=r}(t);case 231:return function(t){var n=p;function r(){return{diagnosticMessage:e.Diagnostics.Exported_type_alias_0_has_or_is_using_private_name_1,errorNode:t.type,typeName:t.name}}p=t,E(t),ee(t),s("type "),l(m,t.name),ce(t.typeParameters),s(" = "),G(t.type,r),s(";"),c(),p=n}(t);case 232:return function(t){E(t),ee(t),e.isConst(t)&&s("const ");s("enum "),l(m,t.name),s(" {"),c(),u(),q(t.members),_(),s("}"),c()}(t);case 233:return function(t){E(t),ee(t),e.isGlobalScopeAugmentation(t)?s("global "):(16&t.flags?s("namespace "):s("module "),e.isExternalModuleAugmentation(t)?ie(t):l(m,t.name));for(;t.body&&234!==t.body.kind;)t=t.body,s("."),l(m,t.name);var n=p;t.body?(p=t,s(" {"),c(),u(),q(t.body.statements),_(),s("}"),c(),p=n):s(";")}(t);case 237:return function(t){E(t),e.hasModifier(t,1)&&s("export ");s("import "),l(m,t.name),s(" = "),e.isInternalModuleImportEqualsDeclaration(t)?(G(t.moduleReference,n),s(";")):(s("require("),ie(t),s(");"));function n(){return{diagnosticMessage:e.Diagnostics.Import_declaration_0_is_using_private_name_1,errorNode:t,typeName:t.name}}d.writeLine()}(t);case 238:return re(t);default:e.Debug.fail("Unknown symbol kind")}}function ee(t){if(265===t.parent.kind){var n=e.getModifierFlags(t);1&n&&s("export "),512&n?s("default "):230!==t.kind&&A&&s("declare ")}}function te(e){8&e?s("private "):16&e&&s("protected "),32&e&&s("static "),64&e&&s("readonly "),128&e&&s("abstract ")}function ne(t){if(t)return 240===t.kind?n.isDeclarationVisible(t):e.forEach(t.elements,(function(e){return n.isDeclarationVisible(e)}))}function re(t){if(E(t),e.hasModifier(t,1)&&s("export "),s("import "),t.importClause){var r=d.getTextPos();t.importClause.name&&n.isDeclarationVisible(t.importClause)&&l(m,t.importClause.name),t.importClause.namedBindings&&ne(t.importClause.namedBindings)&&(r!==d.getTextPos()&&s(", "),240===t.importClause.namedBindings.kind?(s("* as "),l(m,t.importClause.namedBindings.name)):(s("{ "),H(t.importClause.namedBindings.elements,ae,n.isDeclarationVisible),s(" }"))),s(" from ")}ie(t),s(";"),d.writeLine()}function ie(r){var i;if(f=f||233!==r.kind,237===r.kind){var a=r;i=e.getExternalModuleImportEqualsDeclarationExpression(a)}else if(233===r.kind)i=r.name;else{i=(a=r).moduleSpecifier}if(9===i.kind&&b&&(k.out||k.outFile)){var o=e.getExternalModuleNameFromDeclaration(t,n,r);if(o)return s('"'),s(o),void s('"')}l(m,i)}function ae(e){e.propertyName&&(l(m,e.propertyName),s(" as ")),l(m,e.name)}function oe(e){ae(e),B(n.collectLinkedAliases(e.propertyName||e.name))}function se(t){return 151===t.parent.kind&&e.hasModifier(t.parent,8)}function ce(t){t&&(s("<"),H(t,(function(t){function n(){var n;switch(t.parent.kind){case 229:n=e.Diagnostics.Type_parameter_0_of_exported_class_has_or_is_using_private_name_1;break;case 230:n=e.Diagnostics.Type_parameter_0_of_exported_interface_has_or_is_using_private_name_1;break;case 156:n=e.Diagnostics.Type_parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1;break;case 155:n=e.Diagnostics.Type_parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1;break;case 151:case 150:n=e.hasModifier(t.parent,32)?e.Diagnostics.Type_parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1:229===t.parent.parent.kind?e.Diagnostics.Type_parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1:e.Diagnostics.Type_parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1;break;case 228:n=e.Diagnostics.Type_parameter_0_of_exported_function_has_or_is_using_private_name_1;break;case 231:n=e.Diagnostics.Type_parameter_0_of_exported_type_alias_has_or_is_using_private_name_1;break;default:e.Debug.fail("This is unknown parent for type parameter: "+t.parent.kind)}return{diagnosticMessage:n,errorNode:t,typeName:t.name}}u(),E(t),_(),l(m,t.name),t.constraint&&!se(t)&&(s(" extends "),160===t.parent.kind||161===t.parent.kind||t.parent.parent&&163===t.parent.parent.kind?(e.Debug.assert(151===t.parent.kind||150===t.parent.kind||160===t.parent.kind||161===t.parent.kind||155===t.parent.kind||156===t.parent.kind),Q(t.constraint)):G(t.constraint,n)),t.default&&!se(t)&&(s(" = "),160===t.parent.kind||161===t.parent.kind||t.parent.parent&&163===t.parent.parent.kind?(e.Debug.assert(151===t.parent.kind||150===t.parent.kind||160===t.parent.kind||161===t.parent.kind||155===t.parent.kind||156===t.parent.kind),Q(t.default)):G(t.default,n))})),s(">"))}function ue(t,n){t&&(s(n?" implements ":" extends "),H(t,(function(t){e.isEntityNameExpression(t.expression)?G(t,r):n||95!==t.expression.kind||s("null");function r(){return{diagnosticMessage:229===t.parent.parent.kind?n?e.Diagnostics.Implements_clause_of_exported_class_0_has_or_is_using_private_name_1:e.Diagnostics.extends_clause_of_exported_class_0_has_or_is_using_private_name_1:e.Diagnostics.extends_clause_of_exported_interface_0_has_or_is_using_private_name_1,errorNode:t,typeName:e.getNameOfDeclaration(t.parent.parent)}}})))}function _e(t){e.hasDynamicName(t)||(E(t),te(e.getModifierFlags(t)),le(t),s(";"),c())}function le(t){function r(n){return 226===t.kind?n.errorModuleName?2===n.accessibility?e.Diagnostics.Exported_variable_0_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:e.Diagnostics.Exported_variable_0_has_or_is_using_name_1_from_private_module_2:e.Diagnostics.Exported_variable_0_has_or_is_using_private_name_1:149===t.kind||148===t.kind||146===t.kind&&e.hasModifier(t.parent,8)?e.hasModifier(t,32)?n.errorModuleName?2===n.accessibility?e.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:e.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:e.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_private_name_1:229===t.parent.kind||146===t.kind?n.errorModuleName?2===n.accessibility?e.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:e.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:e.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_private_name_1:n.errorModuleName?e.Diagnostics.Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2:e.Diagnostics.Property_0_of_exported_interface_has_or_is_using_private_name_1:void 0}function i(e){for(var t=[],n=0,r=e.elements;n<r.length;n++){var i=r[n];200!==i.kind&&t.push(i)}H(t,a)}function a(t){t.name&&(e.isBindingPattern(t.name)?i(t.name):(l(m,t.name),V(t,void 0,(function(e){var n=r(e);return void 0!==n?{diagnosticMessage:n,errorNode:t,typeName:t.name}:void 0}))))}(226!==t.kind||n.isDeclarationVisible(t))&&(e.isBindingPattern(t.name)?i(t.name):(l(m,t.name),(149===t.kind||148===t.kind||146===t.kind&&!e.isParameterPropertyDeclaration(t))&&e.hasQuestionToken(t)&&s("?"),149!==t.kind&&148!==t.kind||163!==t.parent.kind?n.isLiteralConstDeclaration(t)?(s(" = "),n.writeLiteralConstValue(t,d)):e.hasModifier(t,8)||V(t,t.type,(function(e){var n=r(e);return void 0!==n?{diagnosticMessage:n,errorNode:t,typeName:t.name}:void 0})):de(t)))}function de(e){e.type&&(s(": "),Q(e.type))}function pe(t){e.hasDynamicName(t)||n.isImplementationOfOverload(t)||(E(t),228===t.kind?ee(t):151!==t.kind&&152!==t.kind||te(e.getModifierFlags(t)),228===t.kind?(s("function "),l(m,t.name)):152===t.kind?s("constructor"):(l(m,t.name),e.hasQuestionToken(t)&&s("?")),me(t))}function fe(e){E(e),me(e)}function me(t){var r=p;p=t;var i=!1;if(157===t.kind)te(e.getModifierFlags(t)),s("[");else{if(152===t.kind&&e.hasModifier(t,8))return s("();"),void c();if(156===t.kind||161===t.kind)s("new ");else if(160===t.kind){var a=d.getText();t.typeParameters&&"<"===a.charAt(a.length-1)&&(i=!0,s("("))}ce(t.typeParameters),s("(")}H(t.parameters,ge),157===t.kind?s("]"):s(")");var o,u,_=160===t.kind||161===t.kind;_||163===t.parent.kind?t.type&&(s(_?" => ":": "),Q(t.type)):152===t.kind||e.hasModifier(t,8)||(o=t,u=function(n){var r;switch(t.kind){case 156:r=n.errorModuleName?e.Diagnostics.Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1:e.Diagnostics.Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_0;break;case 155:r=n.errorModuleName?e.Diagnostics.Return_type_of_call_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1:e.Diagnostics.Return_type_of_call_signature_from_exported_interface_has_or_is_using_private_name_0;break;case 157:r=n.errorModuleName?e.Diagnostics.Return_type_of_index_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1:e.Diagnostics.Return_type_of_index_signature_from_exported_interface_has_or_is_using_private_name_0;break;case 151:case 150:r=e.hasModifier(t,32)?n.errorModuleName?2===n.accessibility?e.Diagnostics.Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:e.Diagnostics.Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_private_module_1:e.Diagnostics.Return_type_of_public_static_method_from_exported_class_has_or_is_using_private_name_0:229===t.parent.kind?n.errorModuleName?2===n.accessibility?e.Diagnostics.Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:e.Diagnostics.Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_private_module_1:e.Diagnostics.Return_type_of_public_method_from_exported_class_has_or_is_using_private_name_0:n.errorModuleName?e.Diagnostics.Return_type_of_method_from_exported_interface_has_or_is_using_name_0_from_private_module_1:e.Diagnostics.Return_type_of_method_from_exported_interface_has_or_is_using_private_name_0;break;case 228:r=n.errorModuleName?2===n.accessibility?e.Diagnostics.Return_type_of_exported_function_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:e.Diagnostics.Return_type_of_exported_function_has_or_is_using_name_0_from_private_module_1:e.Diagnostics.Return_type_of_exported_function_has_or_is_using_private_name_0;break;default:e.Debug.fail("This is unknown kind for signature: "+t.kind)}return{diagnosticMessage:r,errorNode:t.name||t}},d.getSymbolAccessibilityDiagnostic=u,s(": "),o.type?Q(o.type):(S=o.name,n.writeReturnTypeOfSignatureDeclaration(o,p,16388,d),S=void 0)),p=r,_?i&&s(")"):(s(";"),c())}function ge(t){function r(e){if(174===e.kind)s("{"),H(e.elements,i),s("}");else if(175===e.kind){s("[");var t=e.elements;H(t,i),t&&t.hasTrailingComma&&s(", "),s("]")}}function i(t){200===t.kind?s(" "):176===t.kind&&(t.propertyName&&(l(m,t.propertyName),s(": ")),t.name&&(e.isBindingPattern(t.name)?r(t.name):(e.Debug.assert(71===t.name.kind),t.dotDotDotToken&&s("..."),l(m,t.name))))}u(),E(t),t.dotDotDotToken&&s("..."),e.isBindingPattern(t.name)?r(t.name):l(m,t.name),n.isOptionalParameter(t)&&s("?"),_(),160===t.parent.kind||161===t.parent.kind||163===t.parent.parent.kind?de(t):e.hasModifier(t.parent,8)||V(t,t.type,(function(n){var r=function(n){switch(t.parent.kind){case 152:return n.errorModuleName?2===n.accessibility?e.Diagnostics.Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:e.Diagnostics.Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_private_module_2:e.Diagnostics.Parameter_0_of_constructor_from_exported_class_has_or_is_using_private_name_1;case 156:return n.errorModuleName?e.Diagnostics.Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2:e.Diagnostics.Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1;case 155:return n.errorModuleName?e.Diagnostics.Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2:e.Diagnostics.Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1;case 157:return n.errorModuleName?e.Diagnostics.Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2:e.Diagnostics.Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_private_name_1;case 151:case 150:return e.hasModifier(t.parent,32)?n.errorModuleName?2===n.accessibility?e.Diagnostics.Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:e.Diagnostics.Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_private_module_2:e.Diagnostics.Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1:229===t.parent.parent.kind?n.errorModuleName?2===n.accessibility?e.Diagnostics.Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:e.Diagnostics.Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_private_module_2:e.Diagnostics.Parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1:n.errorModuleName?e.Diagnostics.Parameter_0_of_method_from_exported_interface_has_or_is_using_name_1_from_private_module_2:e.Diagnostics.Parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1;case 228:return n.errorModuleName?2===n.accessibility?e.Diagnostics.Parameter_0_of_exported_function_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:e.Diagnostics.Parameter_0_of_exported_function_has_or_is_using_name_1_from_private_module_2:e.Diagnostics.Parameter_0_of_exported_function_has_or_is_using_private_name_1;default:e.Debug.fail("This is unknown parent for parameter: "+t.parent.kind)}}(n);return void 0!==r?{diagnosticMessage:r,errorNode:t,typeName:t.name}:void 0}))}function ye(t){switch(t.kind){case 228:case 233:case 237:case 230:case 229:case 231:case 232:return Z(t,function(e){return n.isDeclarationVisible(e)}(t));case 208:return Z(t,function(t){return e.forEach(t.declarationList.declarations,(function(e){return n.isDeclarationVisible(e)}))}(t));case 238:return Z(t,!t.importClause);case 244:return function(e){E(e),s("export "),e.exportClause?(s("{ "),H(e.exportClause.elements,oe),s(" }")):s("*"),e.moduleSpecifier&&(s(" from "),ie(e)),s(";"),d.writeLine()}(t);case 152:case 151:case 150:return pe(t);case 156:case 155:case 157:return fe(t);case 153:case 154:return function(t){if(!e.hasDynamicName(t)){var n,r=e.getAllAccessorDeclarations(t.parent.members,t);if(t===r.firstAccessor){if(E(r.getAccessor),E(r.setAccessor),te(e.getModifierFlags(t)|(r.setAccessor?0:64)),l(m,t.name),!e.hasModifier(t,8)){n=t;var i=o(t);if(!i){var a=153===t.kind?r.setAccessor:r.getAccessor;(i=o(a))&&(n=a)}V(t,i,(function(t){return 154===n.kind?{diagnosticMessage:e.hasModifier(n.parent,32)?t.errorModuleName?e.Diagnostics.Parameter_0_of_public_static_property_setter_from_exported_class_has_or_is_using_name_1_from_private_module_2:e.Diagnostics.Parameter_0_of_public_static_property_setter_from_exported_class_has_or_is_using_private_name_1:t.errorModuleName?e.Diagnostics.Parameter_0_of_public_property_setter_from_exported_class_has_or_is_using_name_1_from_private_module_2:e.Diagnostics.Parameter_0_of_public_property_setter_from_exported_class_has_or_is_using_private_name_1,errorNode:n.parameters[0],typeName:n.name}:{diagnosticMessage:e.hasModifier(n,32)?t.errorModuleName?2===t.accessibility?e.Diagnostics.Return_type_of_public_static_property_getter_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:e.Diagnostics.Return_type_of_public_static_property_getter_from_exported_class_has_or_is_using_name_0_from_private_module_1:e.Diagnostics.Return_type_of_public_static_property_getter_from_exported_class_has_or_is_using_private_name_0:t.errorModuleName?2===t.accessibility?e.Diagnostics.Return_type_of_public_property_getter_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:e.Diagnostics.Return_type_of_public_property_getter_from_exported_class_has_or_is_using_name_0_from_private_module_1:e.Diagnostics.Return_type_of_public_property_getter_from_exported_class_has_or_is_using_private_name_0,errorNode:n.name,typeName:void 0}}))}s(";"),c()}}function o(e){if(e)return 153===e.kind?e.type:e.parameters.length>0?e.parameters[0].type:void 0}}(t);case 149:case 148:return _e(t);case 264:return function(t){E(t),l(m,t.name);var r=n.getConstantValue(t);void 0!==r&&(s(" = "),s(e.getTextOfConstantValue(r))),s(","),c()}(t);case 243:return function(t){if(71===t.expression.kind)s(t.isExportEquals?"export = ":"export default "),l(m,t.expression);else{var r=Y(t.expression,"_default",{diagnosticMessage:e.Diagnostics.Default_export_of_the_module_has_or_is_using_private_name_0,errorNode:t},A);s(t.isExportEquals?"export = ":"export default "),s(r)}s(";"),c(),71===t.expression.kind&&B(n.collectLinkedAliases(t.expression))}(t);case 265:return X(t)}}}e.getDeclarationDiagnostics=function(n,r,i){var a=e.createDiagnosticCollection();return e.forEachEmittedFile(n,(function(e,i){var o=e.declarationFilePath;t(n,r,a,o,i,!1)}),i),a.getDiagnostics(i?i.fileName:void 0)},e.writeDeclarationFile=function(n,r,i,a,o,s){var c=t(i,a,o,n,r,s),u=c.reportedDeclarationError||i.isEmitBlocked(n)||i.getCompilerOptions().noEmit;if(!u){var _=266===r.kind?r.sourceFiles:[r],l=c.referencesOutput+function t(n,r){var i=0,a="";return e.forEach(r,(function(e){e.asynchronousOutput&&(a+=n.substring(i,e.outputPos),a+=t(e.asynchronousOutput,e.subModuleElementDeclarationEmitInfo),i=e.outputPos)})),a+=n.substring(i)}(c.synchronousDeclarationOutput,c.moduleElementDeclarationEmitInfo);e.writeFile(i,o,n,l,i.getCompilerOptions().emitBOM,_)}return u}}(ts||(ts={})),function(e){var t,n,r=function(){var e=[];return e[0]="",e[16]=",",e[4]=" |",e[8]=" &",e}(),i=function(){var e=[];return e[512]=["{","}"],e[1024]=["(",")"],e[2048]=["<",">"],e[4096]=["[","]"],e}();function a(t,n,r,i){var a=e.isArray(r)?r:e.getSourceFilesToEmit(t,r),c=t.getCompilerOptions();if(c.outFile||c.out)a.length&&n({jsFilePath:l=c.outFile||c.out,sourceMapFilePath:o(l,c),declarationFilePath:c.declaration?e.removeFileExtension(l)+".d.ts":""},e.createBundle(a),i);else for(var u=0,_=a;u<_.length;u++){var l,d=_[u];n({jsFilePath:l=e.getOwnEmitOutputFilePath(d,t,s(d,c)),sourceMapFilePath:o(l,c),declarationFilePath:e.isSourceFileJavaScript(d)||!i&&!c.declaration?void 0:e.getDeclarationEmitOutputFilePath(d,t)},d,i)}}function o(e,t){return t.sourceMap?e+".map":void 0}function s(t,n){if(1===n.jsx)if(e.isSourceFileJavaScript(t)){if(e.fileExtensionIs(t.fileName,".jsx"))return".jsx"}else if(1===t.languageVariant)return".jsx";return".js"}function c(t,n){void 0===t&&(t={}),void 0===n&&(n={});var a,o,s,c,u,_,l,d,p=n.hasGlobalName,f=n.onEmitSourceMapOfNode,m=n.onEmitSourceMapOfToken,g=n.onEmitSourceMapOfPosition,y=n.onEmitNode,h=n.onEmitHelpers,v=n.onSetSourceFile,b=n.substituteNode,x=n.onBeforeEmitNodeArray,k=n.onAfterEmitNodeArray,S=n.onBeforeEmitToken,D=n.onAfterEmitToken,C=e.getNewLineCharacter(t),T=e.createCommentWriter(t,g),E=T.emitNodeWithComments,N=T.emitBodyWithDetachedComments,A=T.emitTrailingCommentsOfPosition,w=T.emitLeadingCommentsOfPosition;return j(),{printNode:function(t,n,r){switch(t){case 0:e.Debug.assert(e.isSourceFile(n),"Expected a SourceFile node.");break;case 2:e.Debug.assert(e.isIdentifier(n),"Expected an Identifier node.");break;case 1:e.Debug.assert(e.isExpression(n),"Expected an Expression node.")}switch(n.kind){case 265:return F(n);case 266:return P(n)}return O(t,n,r,L()),M()},printFile:F,printBundle:P,writeNode:O,writeFile:R,writeBundle:I};function P(e){return I(e,L()),M()}function F(e){return R(e,L()),M()}function O(e,t,n,r){var i=l;z(r),B(e,t,n),j(),l=i}function I(e,t){var n=l;z(t),ve(e),he(e),Z(e);for(var r=0,i=e.sourceFiles;r<i.length;r++){var a=i[r];B(0,a,a)}j(),l=n}function R(e,t){var n=l;z(t),ve(e),he(e),B(0,e,e),j(),l=n}function L(){return d||(d=e.createTextWriter(C))}function M(){var e=d.getText();return d.reset(),e}function B(e,t,n){n&&J(n),W(e,t)}function J(e){a=e,T.setSourceFile(e),v&&v(e)}function z(e){l=e,T.setWriter(e)}function j(){o=[],s=[],c=e.createMap(),u=[],_=0,T.reset(),z(void 0)}function K(e){e&&U(e)}function U(e){W(4,e)}function V(e){W(2,e)}function q(e){W(1,e)}function W(e,t){y?y(e,t,H):H(e,t)}function H(e,t){t=Y(e,t),E&&0!==e?E(e,t,G):G(e,t)}function G(e,t){f&&0!==e&&2!==e?f(e,t,Q):Q(e,t)}function Q(t,n){switch(t){case 0:return function(t){e.Debug.assertNode(t,e.isSourceFile),function(t){Re();var n=t.statements;if(N){if(0===n.length||!e.isPrologueDirective(n[0])||e.nodeIsSynthesized(n[0]))return void N(t,n,ge)}ge(t)}(t)}(n);case 2:return function(t){e.Debug.assertNode(t,e.isIdentifier),ee(t)}(n);case 1:return X(n);case 3:return function(e){U(e.name),Ie(" in "),U(e.constraint)}(e.cast(n,e.isTypeParameterDeclaration));case 4:return function(t){var n=t.kind;if(e.isKeyword(n))return void Je(t);switch(n){case 14:case 15:case 16:return $(t);case 71:return ee(t);case 143:return function(e){(function(e){71===e.kind?q(e):U(e)})(e.left),Ie("."),U(e.right)}(t);case 144:return function(e){Ie("["),q(e.expression),Ie("]")}(t);case 145:return function(e){U(e.name),xe(" extends ",e.constraint),xe(" = ",e.default)}(t);case 146:return function(e){Te(e,e.decorators),be(e,e.modifiers),K(e.dotDotDotToken),e.name&&U(e.name);K(e.questionToken),e.parent&&273===e.parent.kind&&!e.name?U(e.type):xe(": ",e.type);ke(" = ",e.initializer)}(t);case 147:return r=t,Ie("@"),void q(r.expression);case 148:return function(e){Te(e,e.decorators),be(e,e.modifiers),U(e.name),K(e.questionToken),xe(": ",e.type),Ie(";")}(t);case 149:return function(e){Te(e,e.decorators),be(e,e.modifiers),U(e.name),K(e.questionToken),xe(": ",e.type),ke(" = ",e.initializer),Ie(";")}(t);case 150:return function(e){Te(e,e.decorators),be(e,e.modifiers),U(e.name),K(e.questionToken),Ne(e,e.typeParameters),Ae(e,e.parameters),xe(": ",e.type),Ie(";")}(t);case 151:return function(e){Te(e,e.decorators),be(e,e.modifiers),K(e.asteriskToken),U(e.name),K(e.questionToken),oe(e,se)}(t);case 152:return function(e){be(e,e.modifiers),Ie("constructor"),oe(e,se)}(t);case 153:case 154:return function(e){Te(e,e.decorators),be(e,e.modifiers),Ie(153===e.kind?"get ":"set "),U(e.name),oe(e,se)}(t);case 155:return function(e){Te(e,e.decorators),be(e,e.modifiers),Ne(e,e.typeParameters),Ae(e,e.parameters),xe(": ",e.type),Ie(";")}(t);case 156:return function(e){Te(e,e.decorators),be(e,e.modifiers),Ie("new "),Ne(e,e.typeParameters),Ae(e,e.parameters),xe(": ",e.type),Ie(";")}(t);case 157:return function(e){Te(e,e.decorators),be(e,e.modifiers),t=e,n=e.parameters,Pe(t,n,4432),xe(": ",e.type),Ie(";");var t,n}(t);case 158:return function(e){U(e.parameterName),Ie(" is "),U(e.type)}(t);case 159:return function(e){U(e.typeName),Ee(e,e.typeArguments)}(t);case 160:return function(e){Ne(e,e.typeParameters),we(e,e.parameters),Ie(" => "),U(e.type)}(t);case 273:return function(e){Ie("function"),Ae(e,e.parameters),Ie(":"),U(e.type)}(t);case 161:return function(e){Ie("new "),Ne(e,e.typeParameters),Ae(e,e.parameters),Ie(" => "),U(e.type)}(t);case 162:return function(e){Ie("typeof "),U(e.exprName)}(t);case 163:return function(t){Ie("{");var n=1&e.getEmitFlags(t)?448:65;Pe(t,t.members,262144|n),Ie("}")}(t);case 164:return function(e){U(e.elementType),Ie("[]")}(t);case 165:return function(e){Ie("["),Pe(e,e.elementTypes,336),Ie("]")}(t);case 166:return function(e){Pe(e,e.types,260)}(t);case 167:return function(e){Pe(e,e.types,264)}(t);case 168:return function(e){Ie("("),U(e.type),Ie(")")}(t);case 201:return function(e){q(e.expression),Ee(e,e.typeArguments)}(t);case 169:return void Ie("this");case 170:return function(e){ze(e.operator),Ie(" "),U(e.type)}(t);case 171:return function(e){U(e.objectType),Ie("["),U(e.indexType),Ie("]")}(t);case 172:return function(t){var n=e.getEmitFlags(t);Ie("{"),1&n?Ie(" "):(Re(),Le());t.readonlyToken&&(U(t.readonlyToken),Ie(" "));Ie("["),W(3,t.typeParameter),Ie("]"),K(t.questionToken),Ie(": "),U(t.type),Ie(";"),1&n?Ie(" "):(Re(),Me());Ie("}")}(t);case 173:return function(e){q(e.literal)}(t);case 268:return void Ie("*");case 269:return void Ie("?");case 270:return function(e){Ie("?"),U(e.type)}(t);case 271:return function(e){Ie("!"),U(e.type)}(t);case 272:return function(e){U(e.type),Ie("=")}(t);case 274:return function(e){Ie("..."),U(e.type)}(t);case 174:return function(e){var t=e.elements;0===t.length?Ie("{}"):(Ie("{"),Pe(e,t,432),Ie("}"))}(t);case 175:return function(e){0===e.elements.length?Ie("[]"):(Ie("["),Pe(e,e.elements,304),Ie("]"))}(t);case 176:return function(e){De(e.propertyName,": "),K(e.dotDotDotToken),U(e.name),ke(" = ",e.initializer)}(t);case 205:return function(e){q(e.expression),U(e.literal)}(t);case 206:return void Ie(";");case 207:return function(e){Be(17,e.pos,e),ne(e,!e.multiLine&&Xe(e)),Le(),w(e.statements.end),Me(),Be(18,e.statements.end,e)}(t);case 208:return function(e){be(e,e.modifiers),U(e.declarationList),Ie(";")}(t);case 209:return void Ie(";");case 210:return function(e){q(e.expression),Ie(";")}(t);case 211:return function(e){var t=Be(90,e.pos,e);Ie(" "),Be(19,t,e),q(e.expression),Be(20,e.expression.end,e),Ce(e,e.thenStatement),e.elseStatement&&(je(e),Be(82,e.thenStatement.end,e),211===e.elseStatement.kind?(Ie(" "),U(e.elseStatement)):Ce(e,e.elseStatement))}(t);case 212:return function(t){Ie("do"),Ce(t,t.statement),e.isBlock(t.statement)?Ie(" "):je(t);Ie("while ("),q(t.expression),Ie(");")}(t);case 213:return function(e){Ie("while ("),q(e.expression),Ie(")"),Ce(e,e.statement)}(t);case 214:return function(e){var t=Be(88,e.pos);Ie(" "),Be(19,t,e),re(e.initializer),Ie(";"),ke(" ",e.condition),Ie(";"),ke(" ",e.incrementor),Ie(")"),Ce(e,e.statement)}(t);case 215:return function(e){var t=Be(88,e.pos);Ie(" "),Be(19,t),re(e.initializer),Ie(" in "),q(e.expression),Be(20,e.expression.end),Ce(e,e.statement)}(t);case 216:return function(e){var t=Be(88,e.pos);Ie(" "),De(e.awaitModifier," "),Be(19,t),re(e.initializer),Ie(" of "),q(e.expression),Be(20,e.expression.end),Ce(e,e.statement)}(t);case 217:return function(e){Be(77,e.pos),xe(" ",e.label),Ie(";")}(t);case 218:return function(e){Be(72,e.pos),xe(" ",e.label),Ie(";")}(t);case 219:return function(t){(function(t,n,r){var i=r&&e.getParseTreeNode(r);i&&i.kind===r.kind&&(n=e.skipTrivia(a.text,n));n=Be(t,n,r),i&&i.kind===r.kind&&A(n,!0)})(96,t.pos,t),ke(" ",t.expression),Ie(";")}(t);case 220:return function(e){Ie("with ("),q(e.expression),Ie(")"),Ce(e,e.statement)}(t);case 221:return function(e){var t=Be(98,e.pos);Ie(" "),Be(19,t),q(e.expression),Be(20,e.expression.end),Ie(" "),U(e.caseBlock)}(t);case 222:return function(e){U(e.label),Ie(": "),U(e.statement)}(t);case 223:return function(e){Ie("throw"),ke(" ",e.expression),Ie(";")}(t);case 224:return function(e){Ie("try "),U(e.tryBlock),e.catchClause&&(je(e),U(e.catchClause));e.finallyBlock&&(je(e),Ie("finally "),U(e.finallyBlock))}(t);case 225:return function(e){Be(78,e.pos),Ie(";")}(t);case 226:return function(e){U(e.name),xe(": ",e.type),ke(" = ",e.initializer)}(t);case 227:return function(t){Ie(e.isLet(t)?"let ":e.isConst(t)?"const ":"var "),Pe(t,t.declarations,272)}(t);case 228:return function(e){ie(e)}(t);case 229:return function(e){le(e)}(t);case 230:return function(e){Te(e,e.decorators),be(e,e.modifiers),Ie("interface "),U(e.name),Ne(e,e.typeParameters),Pe(e,e.heritageClauses,256),Ie(" {"),Pe(e,e.members,65),Ie("}")}(t);case 231:return function(e){Te(e,e.decorators),be(e,e.modifiers),Ie("type "),U(e.name),Ne(e,e.typeParameters),Ie(" = "),U(e.type),Ie(";")}(t);case 232:return function(e){be(e,e.modifiers),Ie("enum "),U(e.name),et(),Ie(" {"),Pe(e,e.members,81),Ie("}"),tt()}(t);case 233:return function(e){be(e,e.modifiers),512&~e.flags&&Ie(16&e.flags?"namespace ":"module ");U(e.name);var t=e.body;for(;233===t.kind;)Ie("."),U(t.name),t=t.body;Ie(" "),U(t)}(t);case 234:return function(e){et(),Ie("{"),ne(e,Xe(e)),Ie("}"),tt()}(t);case 235:return function(e){Be(17,e.pos),Pe(e,e.clauses,65),Be(18,e.clauses.end)}(t);case 236:return function(e){Ie("export as namespace "),U(e.name),Ie(";")}(t);case 237:return function(e){be(e,e.modifiers),Ie("import "),U(e.name),Ie(" = "),function(e){71===e.kind?q(e):U(e)}(e.moduleReference),Ie(";")}(t);case 238:return function(e){be(e,e.modifiers),Ie("import "),e.importClause&&(U(e.importClause),Ie(" from "));q(e.moduleSpecifier),Ie(";")}(t);case 239:return function(e){U(e.name),e.name&&e.namedBindings&&Ie(", ");U(e.namedBindings)}(t);case 240:return function(e){Ie("* as "),U(e.name)}(t);case 241:return function(e){de(e)}(t);case 242:return function(e){pe(e)}(t);case 243:return function(e){Ie(e.isExportEquals?"export = ":"export default "),q(e.expression),Ie(";")}(t);case 244:return function(e){Ie("export "),e.exportClause?U(e.exportClause):Ie("*");e.moduleSpecifier&&(Ie(" from "),q(e.moduleSpecifier));Ie(";")}(t);case 245:return function(e){de(e)}(t);case 246:return function(e){pe(e)}(t);case 247:return;case 248:return function(e){Ie("require("),q(e.expression),Ie(")")}(t);case 10:return function(e){l.writeLiteral(Ze(e,!0))}(t);case 251:return function(t){Ie("<"),fe(t.tagName),n=t.attributes.properties,r=" ",void(e.some(n)&&Ie(r)),t.attributes.properties&&t.attributes.properties.length>0&&U(t.attributes);var n,r;Ie(">")}(t);case 252:return function(e){Ie("</"),fe(e.tagName),Ie(">")}(t);case 253:return function(e){U(e.name),xe("=",e.initializer)}(t);case 254:return function(e){Pe(e,e.properties,131328)}(t);case 255:return function(e){Ie("{..."),q(e.expression),Ie("}")}(t);case 256:return function(e){e.expression&&(Ie("{"),K(e.dotDotDotToken),q(e.expression),Ie("}"))}(t);case 257:return function(e){Ie("case "),q(e.expression),Ie(":"),me(e,e.statements)}(t);case 258:return function(e){Ie("default:"),me(e,e.statements)}(t);case 259:return function(e){Ie(" "),ze(e.token),Ie(" "),Pe(e,e.types,272)}(t);case 260:return function(e){var t=Be(74,e.pos);Ie(" "),e.variableDeclaration&&(Be(19,t),U(e.variableDeclaration),Be(20,e.variableDeclaration.end),Ie(" "));U(e.block)}(t);case 261:return function(t){U(t.name),Ie(": ");var n=t.initializer;if(A&&0==(512&e.getEmitFlags(n))){var r=e.getCommentRange(n);A(r.pos)}q(n)}(t);case 262:return function(e){U(e.name),e.objectAssignmentInitializer&&(Ie(" = "),q(e.objectAssignmentInitializer))}(t);case 263:return function(e){e.expression&&(Ie("..."),q(e.expression))}(t);case 264:return function(e){U(e.name),ke(" = ",e.initializer)}(t)}var r;if(e.isExpression(t))return X(Y(1,t));if(e.isToken(t))return void Je(t)}(n)}}function X(n){switch(n.kind){case 8:return function(e){$(e)}(n);case 9:case 12:case 13:return $(n);case 71:return ee(n);case 86:case 95:case 97:case 101:case 99:case 91:return void Je(n);case 177:return function(e){var t=e.elements,n=e.multiLine?32768:0;Fe(e,t,4466|n)}(n);case 178:return function(t){var n=65536&e.getEmitFlags(t);n&&Le();var r=t.multiLine?32768:0,i=a.languageVersion>=1?32:0;Pe(t,t.properties,263122|i|r),n&&Me()}(n);case 179:return function(n){var r=!1,i=!1;if(!(131072&e.getEmitFlags(n))){var o=n.expression.end,s=e.skipTrivia(a.text,n.expression.end)+1,c=e.createToken(23);c.pos=o,c.end=s,r=Qe(n,n.expression,c),i=Qe(n,c,n.name)}q(n.expression),Ue(r),Ie(!r&&function(n){if(n=e.skipPartiallyEmittedExpressions(n),e.isNumericLiteral(n)){var r=$e(n);return!n.numericLiteralFlags&&!e.stringContains(r,e.tokenToString(23))}if(e.isPropertyAccessExpression(n)||e.isElementAccessExpression(n)){var i=e.getConstantValue(n);return"number"==typeof i&&isFinite(i)&&Math.floor(i)===i&&t.removeComments}}(n.expression)?"..":"."),Ue(i),U(n.name),Ve(r,i)}(n);case 180:return function(e){q(e.expression),Ie("["),q(e.argumentExpression),Ie("]")}(n);case 181:return function(e){q(e.expression),Ee(e,e.typeArguments),Fe(e,e.arguments,1296)}(n);case 182:return function(e){Ie("new "),q(e.expression),Ee(e,e.typeArguments),Fe(e,e.arguments,9488)}(n);case 183:return function(e){q(e.tag),Ie(" "),q(e.template)}(n);case 184:return function(e){Ie("<"),U(e.type),Ie(">"),q(e.expression)}(n);case 185:return function(e){Ie("("),q(e.expression),Ie(")")}(n);case 186:return function(e){ie(e)}(n);case 187:return function(e){Te(e,e.decorators),be(e,e.modifiers),oe(e,te)}(n);case 188:return function(e){Ie("delete "),q(e.expression)}(n);case 189:return function(e){Ie("typeof "),q(e.expression)}(n);case 190:return function(e){Ie("void "),q(e.expression)}(n);case 191:return function(e){Ie("await "),q(e.expression)}(n);case 192:return function(e){ze(e.operator),function(e){var t=e.operand;return 192===t.kind&&(37===e.operator&&(37===t.operator||43===t.operator)||38===e.operator&&(38===t.operator||44===t.operator))}(e)&&Ie(" ");q(e.operand)}(n);case 193:return function(e){q(e.operand),ze(e.operator)}(n);case 194:return function(e){var t=26!==e.operatorToken.kind,n=Qe(e,e.left,e.operatorToken),r=Qe(e,e.operatorToken,e.right);q(e.left),Ue(n,t?" ":void 0),w(e.operatorToken.pos),Je(e.operatorToken),A(e.operatorToken.end,!0),Ue(r," "),q(e.right),Ve(n,r)}(n);case 195:return function(e){var t=Qe(e,e.condition,e.questionToken),n=Qe(e,e.questionToken,e.whenTrue),r=Qe(e,e.whenTrue,e.colonToken),i=Qe(e,e.colonToken,e.whenFalse);q(e.condition),Ue(t," "),U(e.questionToken),Ue(n," "),q(e.whenTrue),Ve(t,n),Ue(r," "),U(e.colonToken),Ue(i," "),q(e.whenFalse),Ve(r,i)}(n);case 196:return function(e){U(e.head),Pe(e,e.templateSpans,131072)}(n);case 197:return function(e){Ie("yield"),U(e.asteriskToken),ke(" ",e.expression)}(n);case 198:return function(e){Ie("..."),q(e.expression)}(n);case 199:return function(e){le(e)}(n);case 200:return;case 202:return function(e){q(e.expression),e.type&&(Ie(" as "),U(e.type))}(n);case 203:return function(e){q(e.expression),Ie("!")}(n);case 204:return function(e){Be(e.keywordToken,e.pos),Ie("."),U(e.name)}(n);case 249:return function(e){U(e.openingElement),Pe(e,e.children,131072),U(e.closingElement)}(n);case 250:return function(e){Ie("<"),fe(e.tagName),Ie(" "),e.attributes.properties&&e.attributes.properties.length>0&&U(e.attributes);Ie("/>")}(n);case 288:return function(e){q(e.expression)}(n);case 289:return function(e){Fe(e,e.elements,272)}(n)}}function Y(e,t){return t&&b&&b(e,t)||t}function Z(e){h&&h(e,Ke)}function $(n){var r=$e(n);!t.sourceMap&&!t.inlineSourceMap||9!==n.kind&&!e.isTemplateLiteralKind(n.kind)?Ie(r):l.writeLiteral(r)}function ee(e){Ie(Ze(e,!1)),Ee(e,e.typeArguments)}function te(e){Ne(e,e.typeParameters),we(e,e.parameters),xe(": ",e.type),Ie(" "),U(e.equalsGreaterThanToken)}function ne(t,n){var r=n||1&e.getEmitFlags(t)?384:65;Pe(t,t.statements,r)}function re(e){void 0!==e&&(227===e.kind?U(e):q(e))}function ie(e){Te(e,e.decorators),be(e,e.modifiers),Ie("function"),K(e.asteriskToken),Ie(" "),V(e.name),oe(e,se)}function ae(e,t){ce(t)}function oe(t,n){var r=t.body;if(r)if(e.isBlock(r)){var i=65536&e.getEmitFlags(t);i&&Le(),524288&e.getEmitFlags(t)?(n(t),y?y(4,r,ae):ce(r)):(et(),n(t),y?y(4,r,ae):ce(r),tt()),i&&Me()}else n(t),Ie(" "),q(r);else n(t),Ie(";")}function se(e){Ne(e,e.typeParameters),Ae(e,e.parameters),xe(": ",e.type)}function ce(t){Ie(" {"),Le();var n=function(t){if(1&e.getEmitFlags(t))return!0;if(t.multiLine)return!1;if(!e.nodeIsSynthesized(t)&&!e.rangeIsOnSingleLine(t,a))return!1;if(qe(t,t.statements,2)||He(t,t.statements,2))return!1;for(var n,r=0,i=t.statements;r<i.length;r++){var o=i[r];if(We(n,o,2))return!1;n=o}return!0}(t)?ue:_e;N?N(t,t.statements,n):n(t),Me(),Be(18,t.statements.end,t)}function ue(e){_e(e,!0)}function _e(e,t){var n=ye(e.statements,!0),r=l.getTextPos();Z(e),0===n&&r===l.getTextPos()&&t?(Me(),Pe(e,e.statements,384),Le()):Pe(e,e.statements,1,n)}function le(t){Te(t,t.decorators),be(t,t.modifiers),Ie("class"),Se(" ",t.name,V);var n=65536&e.getEmitFlags(t);n&&Le(),Ne(t,t.typeParameters),Pe(t,t.heritageClauses,256),et(),Ie(" {"),Pe(t,t.members,65),Ie("}"),tt(),n&&Me()}function de(e){Ie("{"),Pe(e,e.elements,432),Ie("}")}function pe(e){e.propertyName&&(U(e.propertyName),Ie(" as ")),U(e.name)}function fe(e){71===e.kind?q(e):U(e)}function me(t,n){var r=1===n.length&&(e.nodeIsSynthesized(t)||e.nodeIsSynthesized(n[0])||e.rangeStartPositionsAreOnSameLine(t,n[0],a));n.length>0&&A(n.pos);var i=81985;r&&(Ie(" "),i&=-66),Pe(t,n,i)}function ge(t){var n=t.statements;et(),Z(t);var r=e.findIndex(n,(function(t){return!e.isPrologueDirective(t)}));Pe(t,n,1,-1===r?n.length:r),tt()}function ye(t,n,r){for(var i=0;i<t.length;i++){var a=t[i];if(!e.isPrologueDirective(a))return i;(!r||!r.has(a.expression.text))&&((n||i>0)&&Re(),U(a),r&&r.set(a.expression.text,!0))}return t.length}function he(t){if(e.isSourceFile(t))J(t),ye(t.statements);else for(var n=e.createMap(),r=0,i=t.sourceFiles;r<i.length;r++){var a=i[r];J(a),ye(a.statements,!0,n)}}function ve(t){if(e.isSourceFile(t)){var n=e.getShebang(t.text);if(n)return Ie(n),Re(),!0}else for(var r=0,i=t.sourceFiles;r<i.length;r++){if(ve(i[r]))break}}function be(e,t){t&&t.length&&(Pe(e,t,131328),Ie(" "))}function xe(e,t){Se(e,t,U)}function ke(e,t){Se(e,t,q)}function Se(e,t,n){t&&(Ie(e),n(t))}function De(e,t){e&&(U(e),Ie(t))}function Ce(t,n){e.isBlock(n)||1&e.getEmitFlags(t)?(Ie(" "),U(n)):(Re(),Le(),U(n),Me())}function Te(e,t){Pe(e,t,24577)}function Ee(e,t){Pe(e,t,26960)}function Ne(e,t){Pe(e,t,26960)}function Ae(e,t){Pe(e,t,1360)}function we(t,n){!function(t,n){var r=e.singleOrUndefined(n);return r&&r.pos===t.pos&&!(e.isArrowFunction(t)&&t.type)&&!e.some(t.decorators)&&!e.some(t.modifiers)&&!e.some(t.typeParameters)&&!e.some(r.decorators)&&!e.some(r.modifiers)&&!r.dotDotDotToken&&!r.questionToken&&!r.type&&!r.initializer&&e.isIdentifier(r.name)}(t,n)?Ae(t,n):Pe(t,n,336)}function Pe(e,t,n,r,i){Oe(U,e,t,n,r,i)}function Fe(e,t,n,r,i){Oe(q,e,t,n,r,i)}function Oe(t,n,a,o,s,c){void 0===s&&(s=0),void 0===c&&(c=a?a.length-s:0);var u=void 0===a;if(!(u&&8192&o)){var _=u||s>=a.length||0===c;if(_&&16384&o)return x&&x(a),void(k&&k(a));if(7680&o&&Ie(function(e){return i[7680&e][0]}(o)),x&&x(a),_)1&o?Re():128&o&&!(262144&o)&&Ie(" ");else{var l=0==(131072&o),d=l;qe(n,a,o)?(Re(),d=!1):128&o&&Ie(" "),64&o&&Le();for(var p=void 0,f=void 0,m=function(e){return r[28&e]}(o),g=0;g<c;g++){var y=a[s+g];if(p&&(m&&p.end!==n.end&&w(p.end),Ie(m),We(p,y,o)?(0==(67&o)&&(Le(),f=!0),Re(),d=!1):p&&256&o&&Ie(" ")),d){if(A){var h=e.getCommentRange(y);A(h.pos)}}else d=l;t(y),f&&(Me(),f=!1),p=y}var v=32&o&&a.hasTrailingComma;16&o&&v&&Ie(","),!p||!m||p.end===n.end||1024&e.getEmitFlags(p)||w(p.end),64&o&&Me(),He(n,a,o)?Re():128&o&&Ie(" ")}k&&k(a),7680&o&&Ie(function(e){return i[7680&e][1]}(o))}}function Ie(e){l.write(e)}function Re(){l.writeLine()}function Le(){l.increaseIndent()}function Me(){l.decreaseIndent()}function Be(e,t,n){return m?m(n,e,t,ze):ze(e,t)}function Je(t){S&&S(t),Ie(e.tokenToString(t.kind)),D&&D(t)}function ze(t,n){var r=e.tokenToString(t);return Ie(r),n<0?n:n+r.length}function je(t){1&e.getEmitFlags(t)?Ie(" "):Re()}function Ke(t){for(var n=t.split(/\r\n?|\n/g),r=function(t){for(var n,r=0,i=t;r<i.length;r++)for(var a=i[r],o=0;o<a.length&&(void 0===n||o<n);o++)if(!e.isWhiteSpaceLike(a.charCodeAt(o))&&(void 0===n||o<n)){n=o;break}return n}(n),i=0;i<n.length;i++){var a=r?n[i].slice(r):n[i];a.length&&(Re(),Ie(a),Re())}}function Ue(e,t){e?(Le(),Re()):t&&Ie(t)}function Ve(e,t){e&&Me(),t&&Me()}function qe(t,n,r){if(1&r)return!0;if(2&r){if(32768&r)return!0;var i=n[0];return void 0===i?!e.rangeIsOnSingleLine(t,a):e.positionIsSynthesized(t.pos)||e.nodeIsSynthesized(i)?Ge(i,r):!e.rangeStartPositionsAreOnSameLine(t,i,a)}return!1}function We(t,n,r){return!!(1&r)||(2&r?void 0!==t&&void 0!==n&&(e.nodeIsSynthesized(t)||e.nodeIsSynthesized(n)?Ge(t,r)||Ge(n,r):!e.rangeEndIsOnSameLineAsRangeStart(t,n,a)):n.startsOnNewLine)}function He(t,n,r){if(1&r)return 0==(65536&r);if(2&r){if(32768&r)return!0;var i=e.lastOrUndefined(n);return void 0===i?!e.rangeIsOnSingleLine(t,a):e.positionIsSynthesized(t.pos)||e.nodeIsSynthesized(i)?Ge(i,r):!e.rangeEndPositionsAreOnSameLine(t,i,a)}return!1}function Ge(t,n){if(e.nodeIsSynthesized(t)){var r=t.startsOnNewLine;return void 0===r?0!=(32768&n):r}return 0!=(32768&n)}function Qe(t,n,r){return t=Ye(t),n=Ye(n),!!(r=Ye(r)).startsOnNewLine||!(e.nodeIsSynthesized(t)||e.nodeIsSynthesized(n)||e.nodeIsSynthesized(r)||e.rangeEndIsOnSameLineAsRangeStart(n,r,a))}function Xe(t){return 0===t.statements.length&&e.rangeEndIsOnSameLineAsRangeStart(t,t,a)}function Ye(t){for(;185===t.kind&&e.nodeIsSynthesized(t);)t=t.expression;return t}function Ze(t,n){return e.isGeneratedIdentifier(t)?function(t){if(4===t.autoGenerateKind)return nt(function(t){var n=t.autoGenerateId,r=t,i=r.original;for(;i&&(r=i,!e.isIdentifier(r)||4!==r.autoGenerateKind||r.autoGenerateId===n);)i=r.original;return r}(t));var n=t.autoGenerateId;return s[n]||(s[n]=function(t){switch(t.autoGenerateKind){case 1:return it(0);case 2:return it(268435456);case 3:return at(e.idText(t))}e.Debug.fail("Unsupported GeneratedIdentifierKind.")}(t))}(t):!e.isIdentifier(t)||!e.nodeIsSynthesized(t)&&t.parent?9===t.kind&&t.textSourceNode?Ze(t.textSourceNode,n):!e.isLiteralExpression(t)||!e.nodeIsSynthesized(t)&&t.parent?e.getSourceTextOfNodeFromSourceFile(a,t,n):t.text:e.idText(t)}function $e(t){if(9===t.kind&&t.textSourceNode){var n=t.textSourceNode;return e.isIdentifier(n)?16777216&e.getEmitFlags(t)?'"'+e.escapeString(Ze(n))+'"':'"'+e.escapeNonAsciiString(Ze(n))+'"':$e(n)}return e.getLiteralText(t,a)}function et(){u.push(_),_=0}function tt(){_=u.pop()}function nt(t){var n=e.getNodeId(t);return o[n]||(o[n]=function(t){switch(t.kind){case 71:return at(Ze(t));case 233:case 232:return function(t){var n=Ze(t.name);return function(t,n){for(var r=n;e.isNodeDescendantOf(r,n);r=r.nextContainer)if(r.locals){var i=r.locals.get(e.escapeLeadingUnderscores(t));if(i&&3253183&i.flags)return!1}return!0}(n,t)?n:at(n)}(t);case 238:case 244:return function(t){var n=e.getExternalModuleName(t);return at(e.isStringLiteral(n)?e.makeIdentifierFromModuleName(n.text):"module")}(t);case 228:case 229:case 243:return at("default");case 199:return at("class");case 151:case 153:case 154:return function(t){if(e.isIdentifier(t.name))return nt(t.name);return it(0)}(t);default:return it(0)}}(t))}function rt(e){return!(p&&p(e)||a.identifiers.has(e)||c.has(e))}function it(e){if(e&&!(_&e)&&rt(t=268435456===e?"_i":"_n"))return _|=e,t;for(;;){var t,n=268435455&_;if(_++,8!==n&&13!==n)if(rt(t=n<26?"_"+String.fromCharCode(97+n):"_"+(n-26)))return t}}function at(e){95!==e.charCodeAt(e.length-1)&&(e+="_");for(var t=1;;){var n=e+t;if(rt(n))return c.set(n,!0),n;t++}}}e.forEachEmittedFile=a,e.emitFiles=function(t,n,r,i,o){var s,u,_,l=n.getCompilerOptions(),d=e.getEmitModuleKind(l),p=l.sourceMap||l.inlineSourceMap?[]:void 0,f=l.listEmittedFiles?[]:void 0,m=e.createDiagnosticCollection(),g=n.getNewLine(),y=e.createTextWriter(g),h=e.createSourceMapWriter(n,y),v=!1,b=e.getSourceFilesToEmit(n,r),x=e.transformNodes(t,n,l,b,o,!1),k=c(l,{hasGlobalName:t.hasGlobalName,onEmitNode:x.emitNodeWithNotification,substituteNode:x.substituteNode,onEmitSourceMapOfNode:h.emitNodeWithSourceMap,onEmitSourceMapOfToken:h.emitTokenWithSourceMap,onEmitSourceMapOfPosition:h.emitPos,onEmitHelpers:function(t,n){var r=!1,i=266===t.kind?t:void 0;if(i&&d===e.ModuleKind.None)return;for(var a=i?i.sourceFiles.length:1,o=0;o<a;o++){var c=i?i.sourceFiles[o]:t,p=e.isSourceFile(c)?c:s,f=l.noEmitHelpers||void 0!==e.getExternalHelpersModuleName(p),m=e.isSourceFile(c)&&!_,g=e.getEmitHelpers(c);if(g)for(var y=0,h=e.stableSort(g,e.compareEmitHelpers);y<h.length;y++){var v=h[y];if(v.scoped){if(i)continue}else{if(f)continue;if(m){if(u.get(v.name))continue;u.set(v.name,!0)}}n(v.text),r=!0}}return r},onSetSourceFile:function(e){s=e,h.setSourceFile(e)}});return e.performance.mark("beforePrint"),a(n,(function(r,a){var o=r.jsFilePath,c=r.sourceMapFilePath,d=r.declarationFilePath;n.isEmitBlocked(o)||l.noEmit?v=!0:i||function(t,r,i){var a=266===i.kind?i:void 0,o=265===i.kind?i:void 0,c=a?a.sourceFiles:[o];h.initialize(t,r,i),a?(u=e.createMap(),_=!1,k.writeBundle(a,y)):(_=!0,k.writeFile(o,y));y.writeLine();var d=h.getSourceMappingURL();d&&y.write("//# sourceMappingURL="+d);l.sourceMap&&!l.inlineSourceMap&&e.writeFile(n,m,r,h.getText(),!1,c);p&&p.push(h.getSourceMapData());e.writeFile(n,m,t,y.getText(),l.emitBOM,c),h.reset(),y.reset(),s=void 0,u=void 0,_=!1}(o,c,a);d&&(v=e.writeDeclarationFile(d,function(t){return 266===t.kind?e.updateBundle(t,e.sameMap(t.sourceFiles,e.getOriginalSourceFile)):e.getOriginalSourceFile(t)}(a),n,t,m,i)||v);!v&&f&&(i||f.push(o),c&&f.push(c),d&&f.push(d))}),x.transformed,i),e.performance.measure("printTime","beforePrint"),x.dispose(),{emitSkipped:v,diagnostics:m.getDiagnostics(),emittedFiles:f,sourceMaps:p}},e.createPrinter=c,function(e){e[e.Auto=0]="Auto",e[e.CountMask=268435455]="CountMask",e[e._i=268435456]="_i"}(t||(t={})),function(e){e[e.None=0]="None",e[e.SingleLine=0]="SingleLine",e[e.MultiLine=1]="MultiLine",e[e.PreserveLines=2]="PreserveLines",e[e.LinesMask=3]="LinesMask",e[e.NotDelimited=0]="NotDelimited",e[e.BarDelimited=4]="BarDelimited",e[e.AmpersandDelimited=8]="AmpersandDelimited",e[e.CommaDelimited=16]="CommaDelimited",e[e.DelimitersMask=28]="DelimitersMask",e[e.AllowTrailingComma=32]="AllowTrailingComma",e[e.Indented=64]="Indented",e[e.SpaceBetweenBraces=128]="SpaceBetweenBraces",e[e.SpaceBetweenSiblings=256]="SpaceBetweenSiblings",e[e.Braces=512]="Braces",e[e.Parenthesis=1024]="Parenthesis",e[e.AngleBrackets=2048]="AngleBrackets",e[e.SquareBrackets=4096]="SquareBrackets",e[e.BracketsMask=7680]="BracketsMask",e[e.OptionalIfUndefined=8192]="OptionalIfUndefined",e[e.OptionalIfEmpty=16384]="OptionalIfEmpty",e[e.Optional=24576]="Optional",e[e.PreferNewLine=32768]="PreferNewLine",e[e.NoTrailingNewLine=65536]="NoTrailingNewLine",e[e.NoInterveningComments=131072]="NoInterveningComments",e[e.NoSpaceIfEmpty=262144]="NoSpaceIfEmpty",e[e.SingleElement=524288]="SingleElement",e[e.Modifiers=131328]="Modifiers",e[e.HeritageClauses=256]="HeritageClauses",e[e.SingleLineTypeLiteralMembers=448]="SingleLineTypeLiteralMembers",e[e.MultiLineTypeLiteralMembers=65]="MultiLineTypeLiteralMembers",e[e.TupleTypeElements=336]="TupleTypeElements",e[e.UnionTypeConstituents=260]="UnionTypeConstituents",e[e.IntersectionTypeConstituents=264]="IntersectionTypeConstituents",e[e.ObjectBindingPatternElements=432]="ObjectBindingPatternElements",e[e.ArrayBindingPatternElements=304]="ArrayBindingPatternElements",e[e.ObjectLiteralExpressionProperties=263122]="ObjectLiteralExpressionProperties",e[e.ArrayLiteralExpressionElements=4466]="ArrayLiteralExpressionElements",e[e.CommaListElements=272]="CommaListElements",e[e.CallExpressionArguments=1296]="CallExpressionArguments",e[e.NewExpressionArguments=9488]="NewExpressionArguments",e[e.TemplateExpressionSpans=131072]="TemplateExpressionSpans",e[e.SingleLineBlockStatements=384]="SingleLineBlockStatements",e[e.MultiLineBlockStatements=65]="MultiLineBlockStatements",e[e.VariableDeclarationList=272]="VariableDeclarationList",e[e.SingleLineFunctionBodyStatements=384]="SingleLineFunctionBodyStatements",e[e.MultiLineFunctionBodyStatements=1]="MultiLineFunctionBodyStatements",e[e.ClassHeritageClauses=256]="ClassHeritageClauses",e[e.ClassMembers=65]="ClassMembers",e[e.InterfaceMembers=65]="InterfaceMembers",e[e.EnumMembers=81]="EnumMembers",e[e.CaseBlockClauses=65]="CaseBlockClauses",e[e.NamedImportsOrExportsElements=432]="NamedImportsOrExportsElements",e[e.JsxElementChildren=131072]="JsxElementChildren",e[e.JsxElementAttributes=131328]="JsxElementAttributes",e[e.CaseOrDefaultClauseStatements=81985]="CaseOrDefaultClauseStatements",e[e.HeritageClauseTypes=272]="HeritageClauseTypes",e[e.SourceFileStatements=65537]="SourceFileStatements",e[e.Decorators=24577]="Decorators",e[e.TypeArguments=26960]="TypeArguments",e[e.TypeParameters=26960]="TypeParameters",e[e.Parameters=1360]="Parameters",e[e.IndexSignatureParameters=4432]="IndexSignatureParameters"}(n||(n={}))}(ts||(ts={})),function(e){function t(e,t,n,r,i){var a=[],o=e.emit(t,(function(e,t,n){a.push({name:e,writeByteOrderMark:n,text:t})}),r,n,i);return{outputFiles:a,emitSkipped:o.emitSkipped}}e.getFileEmitOutput=t,e.createBuilder=function(n){var r,i,a,o=e.createMap(),s=e.createMap(),c=e.createMap(),u=e.createMap();return{updateProgram:function(e){a&&_(e)},getFilesAffectedBy:f,emitChangedFiles:function(t,n){p(t);var r=t.getCompilerOptions();if(!c.size)return e.emptyArray;if(r.outFile||r.out)return e.Debug.assert(0===s.size),c.clear(),[t.emit(void 0,n)];var i,a=e.createMap();return c.forEach((function(e,r){f(t,r).forEach((function(e){s.delete(e.path),a.has(e.path)||(a.set(e.path,!0),(i||(i=[])).push(t.emit(e,n)))}))})),c.clear(),i||e.emptyArray},getSemanticDiagnostics:function(t,n){p(t),e.Debug.assert(0===c.size);var r,i=t.getCompilerOptions();if(i.outFile||i.out)return e.Debug.assert(0===s.size),t.getSemanticDiagnostics(void 0,n);for(var a=0,o=t.getSourceFiles();a<o.length;a++){var u=o[a];r=e.addRange(r,m(t,u,n))}return r||e.emptyArray},clear:function(){r=void 0,a=void 0,o.clear(),s.clear(),c.clear(),u.clear()}};function _(t){var n=t.getCompilerOptions().module!==e.ModuleKind.None;r!==n&&(a=(r=n)?function(){var t=e.createMap();return{onAddSourceFile:n,onRemoveSourceFile:a,onUpdateSourceFile:r,onUpdateSourceFileWithSameVersion:i,getFilesAffectedByUpdatedShape:c};function n(e,n){var r=y(e,n);r&&t.set(n.path,r)}function r(e,n){var r=y(e,n);r?t.set(n.path,r):t.delete(n.path)}function i(n,r){var i=y(n,r);if(!i)return t.delete(r.path);var a=t.get(r.path);return t.set(r.path,i),!a||a.size!==i.size||(e.forEachEntry(i,(function(e,t){return!a.delete(t)}))||!!a.size)}function a(e){t.forEach((function(t,n){t.has(e)&&(o.get(n)&&l(n))})),t.delete(e)}function s(n){return e.mapDefinedIter(t.entries(),(function(e){var t=e[0];return e[1].has(n)?t:void 0}))}function c(t,n){if(!e.isExternalModule(n)&&!function(t){for(var n=0,r=t.statements;n<r.length;n++){var i=r[n];if(!e.isModuleWithStringLiteralName(i))return!1}return!0}(n))return h(t,n);var r=t.getCompilerOptions();if(r&&(r.isolatedModules||r.out||r.outFile))return[n];var i=e.createMap(),a=n.path;i.set(a,n);for(var o=s(a);o.length>0;){var c=o.pop();if(!i.has(c)){var u=t.getSourceFileByPath(c);i.set(c,u),u&&g(t,u)&&o.push.apply(o,s(c))}}return e.flatMapIter(i.values(),(function(e){return e}))}}():function(){return{onAddSourceFile:e.noop,onRemoveSourceFile:e.noop,onUpdateSourceFile:e.noop,onUpdateSourceFileWithSameVersion:e.returnFalse,getFilesAffectedByUpdatedShape:t};function t(e,t){var n=e.getCompilerOptions();return n&&(n.out||n.outFile)?[t]:h(e,t)}}(),o.clear(),s.clear()),u.clear(),i=void 0,e.mutateMap(o,e.arrayToMap(t.getSourceFiles(),(function(e){return e.path})),{createNewValue:function(e,n){return function(e,t){return l(t.path),a.onAddSourceFile(e,t),{version:t.version,signature:void 0}}(t,n)},onDeleteValue:d,onExistingValue:function(e,n){return function(e,t,n){t.version!==n.version?(l(n.path),t.version=n.version,a.onUpdateSourceFile(e,n)):a.onUpdateSourceFileWithSameVersion(e,n)&&l(n.path)}(t,e,n)}})}function l(e){c.set(e,!0),s.delete(e)}function d(e,t){c.delete(t),s.delete(t),a.onRemoveSourceFile(t)}function p(e){a||_(e)}function f(t,n){p(t);var r=t.getSourceFileByPath(n);return r?g(t,r)?a.getFilesAffectedByUpdatedShape(t,r):[r]:e.emptyArray}function m(e,t,n){var r=t.path,i=s.get(r);if(i)return i;var a=e.getSemanticDiagnostics(t,n);return s.set(r,a),a}function g(r,i){if(e.Debug.assert(!!i),u.has(i.path))return!1;u.set(i.path,!0);var a=o.get(i.path);e.Debug.assert(!!a);var s,c=a.signature;if(i.isDeclarationFile)s=i.version,a.signature=s;else{var _=t(r,i,!0);_.outputFiles&&_.outputFiles.length>0?(s=n.computeHash(_.outputFiles[0].text),a.signature=s):s=c}return!c||s!==c}function y(t,r){var i;if(r.imports&&r.imports.length>0)for(var a=t.getTypeChecker(),o=0,s=r.imports;o<s.length;o++){var c=s[o],u=a.getSymbolAtLocation(c);if(u&&u.declarations&&u.declarations[0]){var _=e.getSourceFileOfNode(u.declarations[0]);_&&m(_.path)}}var l=e.getDirectoryPath(r.path);if(r.referencedFiles&&r.referencedFiles.length>0)for(var d=0,p=r.referencedFiles;d<p.length;d++){var f=p[d];m(e.toPath(f.fileName,l,n.getCanonicalFileName))}return r.resolvedTypeReferenceDirectiveNames&&r.resolvedTypeReferenceDirectiveNames.forEach((function(t){if(t){var r=t.resolvedFileName;m(e.toPath(r,l,n.getCanonicalFileName))}})),i;function m(t){i||(i=e.createMap()),i.set(t,!0)}}function h(t,n){if(i)return i;var r;c(n);for(var a=0,o=t.getSourceFiles();a<o.length;a++){var s=o[a];s!==n&&c(s)}return i=r||e.emptyArray;function c(e){t.isSourceFileDefaultLibrary(e)||(r||(r=[])).push(e)}}}}(ts||(ts={})),function(e){var t=/(^\s*$)|(^\s*\/\/\/?\s*(@ts-ignore)?)/;function n(t,n){var r=e.getDirectoryPath(n),i=e.isRootedDiskPath(t)?t:e.combinePaths(r,t);return e.normalizePath(i)}function r(t,n,r){var i;return e.forEach(t,(function(t){var a=e.getNormalizedPathComponents(t,n);if(a.pop(),i){for(var o=Math.min(i.length,a.length),s=0;s<o;s++)if(r(i[s])!==r(a[s])){if(0===s)return!0;i.length=s;break}a.length<i.length&&(i.length=a.length)}else i=a}))?"":i?e.getNormalizedPathFromPathComponents(i):n}function i(t,n){var r,i=e.createMap();function a(t){t.length>e.getRootLength(t)&&!function(t){return!!i.has(t)||!!e.sys.directoryExists(t)&&(i.set(t,!0),!0)}(t)&&(a(e.getDirectoryPath(t)),e.sys.createDirectory(t))}function o(){return e.getDirectoryPath(e.normalizePath(e.sys.getExecutingFilePath()))}var s=e.getNewLineCharacter(t),c=e.sys.realpath&&function(t){return e.sys.realpath(t)};return{getSourceFile:function(r,i,a){var o;try{e.performance.mark("beforeIORead"),o=e.sys.readFile(r,t.charset),e.performance.mark("afterIORead"),e.performance.measure("I/O Read","beforeIORead","afterIORead")}catch(e){a&&a(e.message),o=""}return void 0!==o?e.createSourceFile(r,o,i,n):void 0},getDefaultLibLocation:o,getDefaultLibFileName:function(t){return e.combinePaths(o(),e.getDefaultLibFileName(t))},writeFile:function(n,i,o,s){try{e.performance.mark("beforeIOWrite"),a(e.getDirectoryPath(e.normalizePath(n))),e.isWatchSet(t)&&e.sys.createHash&&e.sys.getModifiedTime?function(t,n,i){r||(r=e.createMap());var a=e.sys.createHash(n),o=e.sys.getModifiedTime(t);if(o){var s=r.get(t);if(s&&s.byteOrderMark===i&&s.hash===a&&s.mtime.getTime()===o.getTime())return}e.sys.writeFile(t,n,i);var c=e.sys.getModifiedTime(t);r.set(t,{hash:a,byteOrderMark:i,mtime:c})}(n,i,o):e.sys.writeFile(n,i,o),e.performance.mark("afterIOWrite"),e.performance.measure("I/O Write","beforeIOWrite","afterIOWrite")}catch(e){s&&s(e.message)}},getCurrentDirectory:e.memoize((function(){return e.sys.getCurrentDirectory()})),useCaseSensitiveFileNames:function(){return e.sys.useCaseSensitiveFileNames},getCanonicalFileName:function(t){return e.sys.useCaseSensitiveFileNames?t:t.toLowerCase()},getNewLine:function(){return s},fileExists:function(t){return e.sys.fileExists(t)},readFile:function(t){return e.sys.readFile(t)},trace:function(t){return e.sys.write(t+s)},directoryExists:function(t){return e.sys.directoryExists(t)},getEnvironmentVariable:function(t){return e.sys.getEnvironmentVariable?e.sys.getEnvironmentVariable(t):""},getDirectories:function(t){return e.sys.getDirectories(t)},realpath:c}}function a(t,n){var r=e.DiagnosticCategory[t.category].toLowerCase()+" TS"+t.code+": "+d(t.messageText,n.getNewLine())+n.getNewLine();if(t.file){var i=e.getLineAndCharacterOfPosition(t.file,t.start),a=i.line,o=i.character,s=t.file.fileName;return e.convertToRelativePath(s,n.getCurrentDirectory(),(function(e){return n.getCanonicalFileName(e)}))+"("+(a+1)+","+(o+1)+"): "+r}return r}e.findConfigFile=function(t,n,r){for(void 0===r&&(r="tsconfig.json");;){var i=e.combinePaths(t,r);if(n(i))return i;var a=e.getDirectoryPath(t);if(a===t)break;t=a}},e.resolveTripleslashReference=n,e.computeCommonSourceDirectoryOfFilenames=r,e.createCompilerHost=i,e.getPreEmitDiagnostics=function(t,n,r){var i=t.getOptionsDiagnostics(r).concat(t.getSyntacticDiagnostics(n,r),t.getGlobalDiagnostics(r),t.getSemanticDiagnostics(n,r));return t.getCompilerOptions().declaration&&e.addRange(i,t.getDeclarationDiagnostics(n,r)),e.sortAndDeduplicateDiagnostics(i)},e.formatDiagnostics=function(e,t){for(var n="",r=0,i=e;r<i.length;r++){n+=a(i[r],t)}return n},e.formatDiagnostic=a;var o="[91m",s="[30;47m",c="[0m";function u(t){switch(t){case e.DiagnosticCategory.Warning:return"[93m";case e.DiagnosticCategory.Error:return o;case e.DiagnosticCategory.Message:return"[93m"}}function _(e,t){return t+e+c}function l(e,t){for(;e.length<t;)e=" "+e;return e}function d(t,n){if(e.isString(t))return t;for(var r=t,i="",a=0;r;){if(a){i+=n;for(var o=0;o<a;o++)i+="  "}i+=r.messageText,a++,r=r.next}return i}function p(t,n,r){if(0===t.length)return[];for(var i=[],a=e.createMap(),o=0,s=t;o<s.length;o++){var c=s[o],u=void 0;a.has(c)?u=a.get(c):a.set(c,u=r(c,n)),i.push(u)}return i}function f(t,n){switch(n.extension){case".ts":case".d.ts":return;case".tsx":return r();case".jsx":return r()||i();case".js":return i()}function r(){return t.jsx?void 0:e.Diagnostics.Module_0_was_resolved_to_1_but_jsx_is_not_set}function i(){return t.allowJs||!t.noImplicitAny?void 0:e.Diagnostics.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type}}function m(t){return e.Debug.assert(t.every((function(e){return void 0!==e})),"A name is undefined.",(function(){return JSON.stringify(t)})),t}function g(e){for(var t=e.imports,n=e.moduleAugmentations,r=t.map((function(e){return e.text})),i=0,a=n;i<a.length;i++){var o=a[i];9===o.kind&&r.push(o.text)}return r}e.formatDiagnosticsWithColorAndContext=function(t,n){for(var r="",i=0,a=t;i<a.length;i++){var p=a[i],f="";if(p.file){var m=p.start,g=p.length,y=p.file,h=e.getLineAndCharacterOfPosition(y,m),v=h.line,b=h.character,x=e.getLineAndCharacterOfPosition(y,m+g),k=x.line,S=x.character,D=e.getLineAndCharacterOfPosition(y,y.text.length).line,C=n?e.convertToRelativePath(y.fileName,n.getCurrentDirectory(),(function(e){return n.getCanonicalFileName(e)})):y.fileName,T=k-v>=4,E=(k+1+"").length;T&&(E=Math.max("...".length,E)),f+=n.getNewLine();for(var N=v;N<=k;N++){T&&v+1<N&&N<k-1&&(f+=_(l("...",E),s)+" "+n.getNewLine(),N=k-1);var A=e.getPositionOfLineAndCharacter(y,N,0),w=N<D?e.getPositionOfLineAndCharacter(y,N+1,0):y.text.length,P=y.text.slice(A,w);if(P=(P=P.replace(/\s+$/g,"")).replace("\t"," "),f+=_(l(N+1+"",E),s)+" ",f+=P+n.getNewLine(),f+=_(l("",E),s)+" ",f+=o,N===v){var F=N===k?S:void 0;f+=P.slice(0,b).replace(/\S/g," "),f+=P.slice(b,F).replace(/./g,"~")}else f+=N===k?P.slice(0,S).replace(/./g,"~"):P.replace(/./g,"~");f+=c}r+=n.getNewLine(),r+=C+"("+(v+1)+","+(b+1)+"): "}var O=u(p.category);r+=_(e.DiagnosticCategory[p.category].toLowerCase(),O)+" TS"+p.code+": "+d(p.messageText,n.getNewLine()),p.file&&(r+=n.getNewLine(),r+=f),r+=n.getNewLine()}return r},e.flattenDiagnosticMessageText=d,e.isProgramUptoDate=function(t,n,r,i,a,o,s){if(!t||s)return!1;if(t.getRootFileNames().length!==n.length)return!1;if(t.getSourceFiles().some((function(e){return e.version!==i(e.path)||o(e.path)})))return!1;if(t.getMissingFilePaths().some(a))return!1;var c=t.getCompilerOptions();return!!e.compareDataObjects(c,r)&&(!c.configFile||!r.configFile||c.configFile.text===r.configFile.text)},e.createProgram=function(a,o,s,c){var u,_,l,d,y,h,v=[],b={},x={},k=e.createMap(),S=e.createDiagnosticCollection(),D="number"==typeof o.maxNodeModuleJsDepth?o.maxNodeModuleJsDepth:0,C=0,T=e.createMap(),E=e.createMap();e.performance.mark("beforeProgram"),s=s||i(o);var N,A,w,P,F=o.noLib,O=e.memoize((function(){return s.getDefaultLibFileName(o)})),I=s.getDefaultLibLocation?s.getDefaultLibLocation():e.getDirectoryPath(O()),R=e.createDiagnosticCollection(),L=s.getCurrentDirectory(),M=e.getSupportedExtensions(o),B=e.createMap(),J=s.hasInvalidatedResolution||e.returnFalse;if(s.resolveModuleNames)w=function(t,n,r){return s.resolveModuleNames(m(t),n,r).map((function(t){if(!t||void 0!==t.extension)return t;var n=e.clone(t);return n.extension=e.extensionFromPath(t.resolvedFileName),n}))};else{A=e.createModuleResolutionCache(L,(function(e){return s.getCanonicalFileName(e)}));var z=function(t,n){return e.resolveModuleName(t,n,o,s,A).resolvedModule};w=function(e,t){return p(m(e),t,z)}}if(s.resolveTypeReferenceDirectives)P=function(e,t){return s.resolveTypeReferenceDirectives(m(e),t)};else{var j=function(t,n){return e.resolveTypeReferenceDirective(t,n,o,s).resolvedTypeReferenceDirective};P=function(e,t){return p(m(e),t,j)}}var K,U=e.createMap(),V=e.createMap(),q=e.createMap(),W=e.createMap(),H=s.useCaseSensitiveFileNames()?e.createMap():void 0,G=function(t,n){var r=t&&t.getCompilerOptions();return r&&(r.target!==n.target||r.module!==n.module||r.moduleResolution!==n.moduleResolution||r.noResolve!==n.noResolve||r.jsx!==n.jsx||r.allowJs!==n.allowJs||r.disableSizeLimit!==n.disableSizeLimit||r.baseUrl!==n.baseUrl||!e.equalOwnProperties(r.paths,n.paths))}(c,o),Q=function(){if(!c)return 0;var t=c.getCompilerOptions();if(e.changesAffectModuleResolution(t,o))return c.structureIsReused=0;e.Debug.assert(!(3&c.structureIsReused));var n=c.getRootFileNames();if(!e.arrayIsEqualTo(n,a))return c.structureIsReused=0;if(!e.arrayIsEqualTo(o.types,t.types))return c.structureIsReused=0;var r=[],i=[],u=[];if(c.structureIsReused=2,c.getMissingFilePaths().some((function(e){return s.fileExists(e)})))return c.structureIsReused=0;var _,l=c.getSourceFiles();!function(e){e[e.Exists=0]="Exists",e[e.Modified=1]="Modified"}(_||(_={}));for(var d=e.createMap(),p=0,f=l;p<f.length;p++){var m=f[p];if(!(A=s.getSourceFileByPath?s.getSourceFileByPath(m.fileName,m.path,o.target,void 0,G):s.getSourceFile(m.fileName,o.target,void 0,G)))return c.structureIsReused=0;e.Debug.assert(!A.redirectInfo,"Host should not return a redirect source file from `getSourceFile`");var y=void 0;if(m.redirectInfo){if(A!==m.redirectInfo.unredirected)return c.structureIsReused=0;y=!1,A=m}else if(c.redirectTargetsSet.has(m.path)){if(A!==m)return c.structureIsReused=0;y=!1}else y=A!==m;A.path=m.path,i.push(A.path);var b=c.sourceFileToPackageName.get(m.path);if(void 0!==b){var x=d.get(b),D=y?1:0;if(void 0!==x&&1===D||1===x)return c.structureIsReused=0;d.set(b,D)}y?(m.hasNoDefaultLib!==A.hasNoDefaultLib&&(c.structureIsReused=1),e.arrayIsEqualTo(m.referencedFiles,A.referencedFiles,Ce)||(c.structureIsReused=1),Ee(A),e.arrayIsEqualTo(m.imports,A.imports,Te)||(c.structureIsReused=1),e.arrayIsEqualTo(m.moduleAugmentations,A.moduleAugmentations,Te)||(c.structureIsReused=1),(524288&m.flags)!=(524288&A.flags)&&(c.structureIsReused=1),e.arrayIsEqualTo(m.typeReferenceDirectives,A.typeReferenceDirectives,Ce)||(c.structureIsReused=1),u.push({oldFile:m,newFile:A})):J(m.path)&&(c.structureIsReused=1,u.push({oldFile:m,newFile:A})),r.push(A)}if(2!==c.structureIsReused)return c.structureIsReused;h=u.map((function(e){return e.newFile.path}));for(var C=0,T=u;C<T.length;C++){var N=T[C],A=(m=N.oldFile,N.newFile),F=e.getNormalizedAbsolutePath(A.fileName,L);if(w){var O=g(A),I=oe(O,F,A,{program:c,file:m,modifiedFilePaths:h});e.hasChangesInResolutions(O,I,m.resolvedModules,e.moduleResolutionIsEqualTo)?(c.structureIsReused=1,A.resolvedModules=e.zipToMap(O,I)):A.resolvedModules=m.resolvedModules}if(P){var R=e.map(A.typeReferenceDirectives,(function(e){return e.fileName}));I=P(R,F);e.hasChangesInResolutions(R,I,m.resolvedTypeReferenceDirectiveNames,e.typeDirectiveIsEqualTo)?(c.structureIsReused=1,A.resolvedTypeReferenceDirectiveNames=e.zipToMap(R,I)):A.resolvedTypeReferenceDirectiveNames=m.resolvedTypeReferenceDirectiveNames}}if(2!==c.structureIsReused)return c.structureIsReused;if(s.hasChangedAutomaticTypeDirectiveNames)return c.structureIsReused=1;K=c.getMissingFilePaths();for(var M=0;M<r.length;M++)W.set(i[M],r[M]),c.isSourceFileFromExternalLibrary(c.getSourceFileByPath(i[M]))&&E.set(i[M],!0);v=r,S=c.getFileProcessingDiagnostics();for(var B=0,z=u;B<z.length;B++){var j=z[B];S.reattachFileDiagnostics(j.newFile)}return k=c.getResolvedTypeReferenceDirectives(),V=c.sourceFileToPackageName,q=c.redirectTargetsSet,c.structureIsReused=2}();if(2!==Q){e.forEach(a,(function(e){return De(e,!1)}));var X=e.getAutomaticTypeDirectiveNames(o,s);if(X.length)for(var Y=o.configFilePath?e.getDirectoryPath(o.configFilePath):s.getCurrentDirectory(),Z=e.combinePaths(Y,"__inferred type names__.ts"),$=P(X,Z),ee=0;ee<X.length;ee++)Ie(X[ee],$[ee]);F||(o.lib?e.forEach(o.lib,(function(t){De(e.combinePaths(I,t),!0)})):De(O(),!0)),K=e.arrayFrom(W.keys(),(function(e){return e})).filter((function(e){return!W.get(e)}))}if(e.Debug.assert(!!K),A=void 0,c&&s.onReleaseOldSourceFile)for(var te=0,ne=c.getSourceFiles();te<ne.length;te++){var re=ne[te];de(re.path)&&!G||s.onReleaseOldSourceFile(re,c.getCompilerOptions())}return c=void 0,u={getRootFileNames:function(){return a},getSourceFile:de,getSourceFileByPath:pe,getSourceFiles:function(){return v},getMissingFilePaths:function(){return K},getCompilerOptions:function(){return o},getSyntacticDiagnostics:function(e,t){return fe(e,me,t)},getOptionsDiagnostics:function(){return e.sortAndDeduplicateDiagnostics(e.concatenate(S.getGlobalDiagnostics(),e.concatenate(R.getGlobalDiagnostics(),o.configFile?R.getDiagnostics(o.configFile.fileName):[])))},getGlobalDiagnostics:function(){return e.sortAndDeduplicateDiagnostics(ue().getGlobalDiagnostics().slice())},getSemanticDiagnostics:function(e,t){return fe(e,ye,t)},getDeclarationDiagnostics:function(e,t){var n=u.getCompilerOptions();return!e||n.out||n.outFile?be(e,t):fe(e,Se,t)},getTypeChecker:_e,getClassifiableNames:function(){if(!y){_e(),y=e.createUnderscoreEscapedMap();for(var t=0,n=v;t<n.length;t++){var r=n[t];e.copyEntries(r.classifiableNames,y)}}return y},getDiagnosticsProducingTypeChecker:ue,getCommonSourceDirectory:ae,emit:function(t,n,r,i,a){return ge((function(){return function(t,n,r,i,a,s){var c=[];if(o.noEmit)return{diagnostics:c,sourceMaps:void 0,emittedFiles:void 0,emitSkipped:!0};if(o.noEmitOnError){var u=t.getOptionsDiagnostics(i).concat(t.getSyntacticDiagnostics(n,i),t.getGlobalDiagnostics(i),t.getSemanticDiagnostics(n,i));if(0===u.length&&t.getCompilerOptions().declaration&&(c=t.getDeclarationDiagnostics(void 0,i)),u.length>0||c.length>0)return{diagnostics:e.concatenate(u,c),sourceMaps:void 0,emittedFiles:void 0,emitSkipped:!0}}var _=ue().getEmitResolver(o.outFile||o.out?void 0:n);e.performance.mark("beforeEmit");var l=a?[]:e.getTransformers(o,s),d=e.emitFiles(_,se(r),n,a,l);return e.performance.mark("afterEmit"),e.performance.measure("Emit","beforeEmit","afterEmit"),d}(u,t,n,r,i,a)}))},getCurrentDirectory:function(){return L},getNodeCount:function(){return ue().getNodeCount()},getIdentifierCount:function(){return ue().getIdentifierCount()},getSymbolCount:function(){return ue().getSymbolCount()},getTypeCount:function(){return ue().getTypeCount()},getFileProcessingDiagnostics:function(){return S},getResolvedTypeReferenceDirectives:function(){return k},isSourceFileFromExternalLibrary:ce,isSourceFileDefaultLibrary:function(t){if(t.hasNoDefaultLib)return!0;if(!o.noLib)return!1;return o.lib?e.forEach(o.lib,(function(n){return 0===e.compareStrings(t.fileName,e.combinePaths(I,n),!s.useCaseSensitiveFileNames())})):0===e.compareStrings(t.fileName,O(),!s.useCaseSensitiveFileNames())},dropDiagnosticsProducingTypeChecker:function(){l=void 0},getSourceFileFromReference:function(e,t){return Ne(n(t.fileName,e.fileName),(function(e){return W.get(ie(e))}))},sourceFileToPackageName:V,redirectTargetsSet:q},function(){o.isolatedModules&&(o.declaration&&je(e.Diagnostics.Option_0_cannot_be_specified_with_option_1,"declaration","isolatedModules"),o.noEmitOnError&&je(e.Diagnostics.Option_0_cannot_be_specified_with_option_1,"noEmitOnError","isolatedModules"),o.out&&je(e.Diagnostics.Option_0_cannot_be_specified_with_option_1,"out","isolatedModules"),o.outFile&&je(e.Diagnostics.Option_0_cannot_be_specified_with_option_1,"outFile","isolatedModules"));o.inlineSourceMap&&(o.sourceMap&&je(e.Diagnostics.Option_0_cannot_be_specified_with_option_1,"sourceMap","inlineSourceMap"),o.mapRoot&&je(e.Diagnostics.Option_0_cannot_be_specified_with_option_1,"mapRoot","inlineSourceMap"));o.paths&&void 0===o.baseUrl&&je(e.Diagnostics.Option_paths_cannot_be_used_without_specifying_baseUrl_option,"paths");if(o.paths)for(var t in o.paths)if(e.hasProperty(o.paths,t))if(e.hasZeroOrOneAsteriskCharacter(t)||Je(!0,t,e.Diagnostics.Pattern_0_can_have_at_most_one_Asterisk_character,t),e.isArray(o.paths[t])){var n=o.paths[t].length;0===n&&Je(!1,t,e.Diagnostics.Substitutions_for_pattern_0_shouldn_t_be_an_empty_array,t);for(var r=0;r<n;r++){var i=o.paths[t][r],a=typeof i;"string"===a?e.hasZeroOrOneAsteriskCharacter(i)||Be(t,r,e.Diagnostics.Substitution_0_in_pattern_1_in_can_have_at_most_one_Asterisk_character,i,t):Be(t,r,e.Diagnostics.Substitution_0_for_pattern_1_has_incorrect_type_expected_string_got_2,i,t,a)}}else Je(!1,t,e.Diagnostics.Substitutions_for_pattern_0_should_be_an_array,t);o.sourceMap||o.inlineSourceMap||(o.inlineSources&&je(e.Diagnostics.Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided,"inlineSources"),o.sourceRoot&&je(e.Diagnostics.Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided,"sourceRoot"));o.out&&o.outFile&&je(e.Diagnostics.Option_0_cannot_be_specified_with_option_1,"out","outFile");o.mapRoot&&!o.sourceMap&&je(e.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1,"mapRoot","sourceMap");o.declarationDir&&(o.declaration||je(e.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1,"declarationDir","declaration"),(o.out||o.outFile)&&je(e.Diagnostics.Option_0_cannot_be_specified_with_option_1,"declarationDir",o.out?"out":"outFile"));o.lib&&o.noLib&&je(e.Diagnostics.Option_0_cannot_be_specified_with_option_1,"lib","noLib");o.noImplicitUseStrict&&(void 0===o.alwaysStrict?o.strict:o.alwaysStrict)&&je(e.Diagnostics.Option_0_cannot_be_specified_with_option_1,"noImplicitUseStrict","alwaysStrict");var c=o.target||0,u=o.outFile||o.out,_=e.forEach(v,(function(t){return e.isExternalModule(t)&&!t.isDeclarationFile?t:void 0}));if(o.isolatedModules){o.module===e.ModuleKind.None&&c<2&&je(e.Diagnostics.Option_isolatedModules_can_only_be_used_when_either_option_module_is_provided_or_option_target_is_ES2015_or_higher,"isolatedModules","target");var l=e.forEach(v,(function(t){return e.isExternalModule(t)||t.isDeclarationFile?void 0:t}));if(l){var d=e.getErrorSpanForNode(l,l);R.add(e.createFileDiagnostic(l,d.start,d.length,e.Diagnostics.Cannot_compile_namespaces_when_the_isolatedModules_flag_is_provided))}}else if(_&&c<2&&o.module===e.ModuleKind.None){var p=e.getErrorSpanForNode(_,_.externalModuleIndicator);R.add(e.createFileDiagnostic(_,p.start,p.length,e.Diagnostics.Cannot_use_imports_exports_or_module_augmentations_when_module_is_none))}if(u)if(o.module&&o.module!==e.ModuleKind.AMD&&o.module!==e.ModuleKind.System)je(e.Diagnostics.Only_amd_and_system_modules_are_supported_alongside_0,o.out?"out":"outFile","module");else if(void 0===o.module&&_){var f=e.getErrorSpanForNode(_,_.externalModuleIndicator);R.add(e.createFileDiagnostic(_,f.start,f.length,e.Diagnostics.Cannot_compile_modules_using_option_0_unless_the_module_flag_is_amd_or_system,o.out?"out":"outFile"))}if(o.outDir||o.sourceRoot||o.mapRoot){var m=ae();o.outDir&&""===m&&e.forEach(v,(function(t){return e.getRootLength(t.fileName)>1}))&&je(e.Diagnostics.Cannot_find_the_common_subdirectory_path_for_the_input_files,"outDir")}!o.noEmit&&o.allowJs&&o.declaration&&je(e.Diagnostics.Option_0_cannot_be_specified_with_option_1,"allowJs","declaration");o.checkJs&&!o.allowJs&&R.add(e.createCompilerDiagnostic(e.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1,"checkJs","allowJs"));o.emitDecoratorMetadata&&!o.experimentalDecorators&&je(e.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1,"emitDecoratorMetadata","experimentalDecorators");o.jsxFactory?(o.reactNamespace&&je(e.Diagnostics.Option_0_cannot_be_specified_with_option_1,"reactNamespace","jsxFactory"),e.parseIsolatedEntityName(o.jsxFactory,c)||Ke("jsxFactory",e.Diagnostics.Invalid_value_for_jsxFactory_0_is_not_a_valid_identifier_or_qualified_name,o.jsxFactory)):o.reactNamespace&&!e.isIdentifierText(o.reactNamespace,c)&&Ke("reactNamespace",e.Diagnostics.Invalid_value_for_reactNamespace_0_is_not_a_valid_identifier,o.reactNamespace);if(!o.noEmit&&!o.suppressOutputPathCheck){var g=se(),y=e.createMap();e.forEachEmittedFile(g,(function(e){h(e.jsFilePath,y),h(e.declarationFilePath,y)}))}function h(t,n){if(t){var r,i=ie(t);if(W.has(i))o.configFilePath||(r=e.chainDiagnosticMessages(void 0,e.Diagnostics.Adding_a_tsconfig_json_file_will_help_organize_projects_that_contain_both_TypeScript_and_JavaScript_files_Learn_more_at_https_Colon_Slash_Slashaka_ms_Slashtsconfig)),r=e.chainDiagnosticMessages(r,e.Diagnostics.Cannot_write_file_0_because_it_would_overwrite_input_file,t),We(t,e.createCompilerDiagnosticFromMessageChain(r));var a=s.useCaseSensitiveFileNames()?i:i.toLocaleLowerCase();n.has(a)?We(t,e.createCompilerDiagnostic(e.Diagnostics.Cannot_write_file_0_because_it_would_be_overwritten_by_multiple_input_files,t)):n.set(a,!0)}}}(),e.performance.mark("afterProgram"),e.performance.measure("Program","beforeProgram","afterProgram"),u;function ie(t){return e.toPath(t,L,Le)}function ae(){if(void 0===_){var t=e.filter(v,(function(t){return e.sourceFileMayBeEmitted(t,o,ce)}));(_=o.rootDir&&function(t,n){var r=!0;if(t)for(var i=s.getCanonicalFileName(e.getNormalizedAbsolutePath(n,L)),a=0,c=t;a<c.length;a++){var u=c[a];if(!u.isDeclarationFile)0!==s.getCanonicalFileName(e.getNormalizedAbsolutePath(u.fileName,L)).indexOf(i)&&(R.add(e.createCompilerDiagnostic(e.Diagnostics.File_0_is_not_under_rootDir_1_rootDir_is_expected_to_contain_all_source_files,u.fileName,o.rootDir)),r=!1)}return r}(t,o.rootDir)?e.getNormalizedAbsolutePath(o.rootDir,L):function(e){for(var t=[],n=0,i=e;n<i.length;n++){var a=i[n];a.isDeclarationFile||t.push(a.fileName)}return r(t,L,Le)}(t))&&_[_.length-1]!==e.directorySeparator&&(_+=e.directorySeparator)}return _}function oe(t,n,r,i){if(0===Q&&!r.ambientModuleNames.length)return w(t,n);var a,c,u,_=i.program&&i.program.getSourceFile(n);if(_!==r&&r.resolvedModules){for(var l=[],d=0,p=t;d<p.length;d++){var f=p[d],m=r.resolvedModules.get(f);l.push(m)}return l}for(var g={},y=0;y<t.length;y++){f=t[y];if(r===_&&!J(_.path)){var h=_&&_.resolvedModules.get(f);if(h){e.isTraceEnabled(o,s)&&e.trace(s,e.Diagnostics.Reusing_resolution_of_module_0_to_file_1_from_old_program,f,n),(c||(c=new Array(t.length)))[y]=h,(u||(u=[])).push(f);continue}}var v=!1;e.contains(r.ambientModuleNames,f)?(v=!0,e.isTraceEnabled(o,s)&&e.trace(s,e.Diagnostics.Module_0_was_resolved_as_locally_declared_ambient_module_in_file_1,f,n)):v=k(f,i),v?(c||(c=new Array(t.length)))[y]=g:(a||(a=[])).push(f)}var b=a&&a.length?w(a,n,u):e.emptyArray;if(!c)return e.Debug.assert(b.length===t.length),b;var x=0;for(y=0;y<c.length;y++)c[y]?c[y]===g&&(c[y]=void 0):(c[y]=b[x],x++);return e.Debug.assert(x===b.length),c;function k(t,n){if(e.getResolvedModule(n.file,t))return!1;var r=n.program&&n.program.getTypeChecker().tryFindAmbientModuleWithoutAugmentations(t);if(!r||!r.declarations)return!1;var i=e.forEach(r.declarations,(function(t){var r=e.getSourceFileOfNode(t);return!e.contains(n.modifiedFilePaths,r.path)&&r}));return!!i&&(e.isTraceEnabled(o,s)&&e.trace(s,e.Diagnostics.Module_0_was_resolved_as_ambient_module_declared_in_1_since_this_file_was_not_modified,t,i.fileName),!0)}}function se(e){return{getCanonicalFileName:Le,getCommonSourceDirectory:u.getCommonSourceDirectory,getCompilerOptions:u.getCompilerOptions,getCurrentDirectory:function(){return L},getNewLine:function(){return s.getNewLine()},getSourceFile:u.getSourceFile,getSourceFileByPath:u.getSourceFileByPath,getSourceFiles:u.getSourceFiles,isSourceFileFromExternalLibrary:ce,writeFile:e||function(e,t,n,r,i){return s.writeFile(e,t,n,r,i)},isEmitBlocked:le}}function ce(e){return E.get(e.path)}function ue(){return l||(l=e.createTypeChecker(u,!0))}function _e(){return d||(d=e.createTypeChecker(u,!1))}function le(e){return B.has(ie(e))}function de(e){return pe(ie(e))}function pe(e){return W.get(e)}function fe(t,n,r){return t?n(t,r):e.sortAndDeduplicateDiagnostics(e.flatMap(u.getSourceFiles(),(function(e){return r&&r.throwIfCancellationRequested(),n(e,r)})))}function me(t){return e.isSourceFileJavaScript(t)?(t.additionalSyntacticDiagnostics||(t.additionalSyntacticDiagnostics=function(t){return ge((function(){var n=[],r=t;return i(t),n;function i(t){switch(r.kind){case 146:case 149:if(r.questionToken===t)return void n.push(u(t,e.Diagnostics._0_can_only_be_used_in_a_ts_file,"?"));case 151:case 150:case 152:case 153:case 154:case 186:case 228:case 187:case 226:if(r.type===t)return void n.push(u(t,e.Diagnostics.types_can_only_be_used_in_a_ts_file))}switch(t.kind){case 237:return void n.push(u(t,e.Diagnostics.import_can_only_be_used_in_a_ts_file));case 243:if(t.isExportEquals)return void n.push(u(t,e.Diagnostics.export_can_only_be_used_in_a_ts_file));break;case 259:if(108===t.token)return void n.push(u(t,e.Diagnostics.implements_clauses_can_only_be_used_in_a_ts_file));break;case 230:return void n.push(u(t,e.Diagnostics.interface_declarations_can_only_be_used_in_a_ts_file));case 233:return void n.push(u(t,e.Diagnostics.module_declarations_can_only_be_used_in_a_ts_file));case 231:return void n.push(u(t,e.Diagnostics.type_aliases_can_only_be_used_in_a_ts_file));case 232:return void n.push(u(t,e.Diagnostics.enum_declarations_can_only_be_used_in_a_ts_file));case 203:return void n.push(u(t,e.Diagnostics.non_null_assertions_can_only_be_used_in_a_ts_file));case 202:return void n.push(u(t.type,e.Diagnostics.type_assertion_expressions_can_only_be_used_in_a_ts_file));case 184:e.Debug.fail()}var o=r;r=t,e.forEachChild(t,i,a),r=o}function a(t){switch(r.decorators!==t||o.experimentalDecorators||n.push(u(r,e.Diagnostics.Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_the_experimentalDecorators_option_to_remove_this_warning)),r.kind){case 229:case 151:case 150:case 152:case 153:case 154:case 186:case 228:case 187:if(t===r.typeParameters)return void n.push(c(t,e.Diagnostics.type_parameter_declarations_can_only_be_used_in_a_ts_file));case 208:if(t===r.modifiers)return s(t,208===r.kind);break;case 149:if(t===r.modifiers){for(var a=0,_=t;a<_.length;a++){var l=_[a];115!==l.kind&&n.push(u(l,e.Diagnostics._0_can_only_be_used_in_a_ts_file,e.tokenToString(l.kind)))}return}break;case 146:if(t===r.modifiers)return void n.push(c(t,e.Diagnostics.parameter_modifiers_can_only_be_used_in_a_ts_file));break;case 181:case 182:case 201:if(t===r.typeArguments)return void n.push(c(t,e.Diagnostics.type_arguments_can_only_be_used_in_a_ts_file))}for(var d=0,p=t;d<p.length;d++){i(p[d])}}function s(t,r){for(var i=0,a=t;i<a.length;i++){var o=a[i];switch(o.kind){case 76:if(r)continue;case 114:case 112:case 113:case 131:case 124:case 117:n.push(u(o,e.Diagnostics._0_can_only_be_used_in_a_ts_file,e.tokenToString(o.kind)))}}}function c(n,r,i,a,o){var s=n.pos;return e.createFileDiagnostic(t,s,n.end-s,r,i,a,o)}function u(n,r,i,a,o){return e.createDiagnosticForNodeInSourceFile(t,n,r,i,a,o)}}))}(t),e.isCheckJsEnabledForFile(t,o)&&(t.additionalSyntacticDiagnostics=e.concatenate(t.additionalSyntacticDiagnostics,t.jsDocDiagnostics))),e.concatenate(t.additionalSyntacticDiagnostics,t.parseDiagnostics)):t.parseDiagnostics}function ge(t){try{return t()}catch(t){throw t instanceof e.OperationCanceledException&&(d=void 0,l=void 0),t}}function ye(e,t){return ke(e,t,b,he)}function he(t,n){return ge((function(){if(o.skipLibCheck&&t.isDeclarationFile||o.skipDefaultLibCheck&&t.hasNoDefaultLib)return e.emptyArray;var r=ue();e.Debug.assert(!!t.bindDiagnostics);var i=3===t.scriptKind||4===t.scriptKind||5===t.scriptKind||e.isCheckJsEnabledForFile(t,o),a=i?t.bindDiagnostics:e.emptyArray,s=i?r.getDiagnostics(t,n):e.emptyArray,c=S.getDiagnostics(t.fileName),u=R.getDiagnostics(t.fileName),_=a.concat(s,c,u);return e.filter(_,ve)}))}function ve(n){var r=n.file,i=n.start;if(r)for(var a=e.getLineStarts(r),o=e.computeLineAndCharacterOfPosition(a,i).line;o>0;){var s=r.text.slice(a[o-1],a[o]),c=t.exec(s);if(!c)return!0;if(c[3])return!1;o--}return!0}function be(e,t){return ke(e,t,x,xe)}function xe(t,n){return ge((function(){var r=ue().getEmitResolver(t,n);return e.getDeclarationDiagnostics(se(e.noop),r,t)}))}function ke(t,n,r,i){var a=t?r.perFile&&r.perFile.get(t.path):r.allDiagnostics;if(a)return a;var o=i(t,n)||e.emptyArray;return t?(r.perFile||(r.perFile=e.createMap()),r.perFile.set(t.path,o)):r.allDiagnostics=o,o}function Se(e,t){return e.isDeclarationFile?[]:be(e,t)}function De(t,n){Ae(e.normalizePath(t),n,void 0)}function Ce(e,t){return e.fileName===t.fileName}function Te(e,t){return 9===e.kind?9===t.kind&&e.text===t.text:71===t.kind&&e.escapedText===t.escapedText}function Ee(t){if(!t.imports){var n,r,i,a=e.isSourceFileJavaScript(t),s=e.isExternalModule(t);if(o.importHelpers&&(o.isolatedModules||s)&&!t.isDeclarationFile){var c=e.createLiteral(e.externalHelpersModuleNameText),u=e.createImportDeclaration(void 0,void 0,void 0);c.parent=u,u.parent=t,n=[c]}for(var _=0,l=t.statements;_<l.length;_++){var d=l[_];p(d,!1),(524288&t.flags||a)&&f(d)}return t.imports=n||e.emptyArray,t.moduleAugmentations=r||e.emptyArray,void(t.ambientModuleNames=i||e.emptyArray)}function p(a,o){switch(a.kind){case 238:case 237:case 244:var c=e.getExternalModuleName(a);if(!c||!e.isStringLiteral(c))break;if(!c.text)break;o&&e.isExternalModuleNameRelative(c.text)||(n||(n=[])).push(c);break;case 233:if(e.isAmbientModule(a)&&(o||e.hasModifier(a,2)||t.isDeclarationFile)){var u=a.name,_=e.getTextOfIdentifierOrLiteral(u);if(s||o&&!e.isExternalModuleNameRelative(_))(r||(r=[])).push(u);else if(!o){t.isDeclarationFile&&(i||(i=[])).push(_);var l=a.body;if(l)for(var d=0,f=l.statements;d<f.length;d++){p(f[d],!0)}}}}}function f(t){e.isRequireCall(t,!0)||e.isImportCall(t)&&1===t.arguments.length&&9===t.arguments[0].kind?(n||(n=[])).push(t.arguments[0]):e.forEachChild(t,f)}}function Ne(t,n,r,i){if(e.hasExtension(t)){if(!o.allowNonTsExtensions&&!e.forEach(M,(function(n){return e.fileExtensionIs(s.getCanonicalFileName(t),n)})))return void(r&&r(e.Diagnostics.File_0_has_unsupported_extension_The_only_supported_extensions_are_1,t,"'"+M.join("', '")+"'"));var a=n(t);return r&&(a?i&&s.getCanonicalFileName(t)===s.getCanonicalFileName(i.fileName)&&r(e.Diagnostics.A_file_cannot_have_a_reference_to_itself):r(e.Diagnostics.File_0_not_found,t)),a}var c=o.allowNonTsExtensions&&n(t);if(c)return c;if(!r||!o.allowNonTsExtensions){var u=e.forEach(M,(function(e){return n(t+e)}));return r&&!u&&r(e.Diagnostics.File_0_not_found,t+".ts"),u}r(e.Diagnostics.File_0_not_found,t)}function Ae(t,n,r,i,a,o){Ne(t,(function(e){return Pe(e,ie(e),n,i,a,o,r)}),(function(t){for(var n=[],r=1;r<arguments.length;r++)n[r-1]=arguments[r];S.add(void 0!==i&&void 0!==o&&void 0!==a?e.createFileDiagnostic.apply(void 0,[i,a,o-a,t].concat(n)):e.createCompilerDiagnostic.apply(void 0,[t].concat(n)))}),i)}function we(t,n,r,i,a){void 0!==r&&void 0!==i&&void 0!==a?S.add(e.createFileDiagnostic(r,i,a-i,e.Diagnostics.File_name_0_differs_from_already_included_file_name_1_only_in_casing,t,n)):S.add(e.createCompilerDiagnostic(e.Diagnostics.File_name_0_differs_from_already_included_file_name_1_only_in_casing,t,n))}function Pe(t,n,r,i,a,c,u){if(W.has(n)){var _=W.get(n);return _&&o.forceConsistentCasingInFileNames&&e.getNormalizedAbsolutePath(_.fileName,L)!==e.getNormalizedAbsolutePath(t,L)&&we(t,_.fileName,i,a,c),_&&E.get(_.path)&&0===C?(E.set(_.path,!1),o.noResolve||(Fe(_,r),Oe(_)),T.set(_.path,!1),Me(_)):_&&T.get(_.path)&&C<D&&(T.set(_.path,!1),Me(_)),_}var l=s.getSourceFile(t,o.target,(function(n){void 0!==i&&void 0!==a&&void 0!==c?S.add(e.createFileDiagnostic(i,a,c-a,e.Diagnostics.Cannot_read_file_0_Colon_1,t,n)):S.add(e.createCompilerDiagnostic(e.Diagnostics.Cannot_read_file_0_Colon_1,t,n))}),G);if(u){var d=u.name+"/"+u.subModuleName+"@"+u.version,p=U.get(d);if(p){var f=function(e,t,n,r){var i=Object.create(e);return i.fileName=n,i.path=r,i.redirectInfo={redirectTarget:e,unredirected:t},Object.defineProperties(i,{id:{get:function(){return this.redirectInfo.redirectTarget.id},set:function(e){this.redirectInfo.redirectTarget.id=e}},symbol:{get:function(){return this.redirectInfo.redirectTarget.symbol},set:function(e){this.redirectInfo.redirectTarget.symbol=e}}}),i}(p,l,t,n);return q.set(p.path,!0),W.set(n,f),V.set(n,u.name),v.push(f),f}l&&(U.set(d,l),V.set(n,u.name))}if(W.set(n,l),l){if(E.set(n,C>0),l.path=n,s.useCaseSensitiveFileNames()){var m=n.toLowerCase(),g=H.get(m);g?we(t,g.fileName,i,a,c):H.set(m,l)}F=F||l.hasNoDefaultLib,o.noResolve||(Fe(l,r),Oe(l)),Me(l),r?v.unshift(l):v.push(l)}return l}function Fe(t,r){e.forEach(t.referencedFiles,(function(e){Ae(n(e.fileName,t.fileName),r,void 0,t,e.pos,e.end)}))}function Oe(t){for(var n=e.map(t.typeReferenceDirectives,(function(e){return e.fileName.toLocaleLowerCase()})),r=P(n,t.fileName),i=0;i<n.length;i++){var a=t.typeReferenceDirectives[i],o=r[i],s=a.fileName.toLocaleLowerCase();e.setResolvedTypeReferenceDirective(t,s,o),Ie(s,o,t,a.pos,a.end)}}function Ie(t,n,r,i,a){var o=k.get(t);if(!o||!o.primary){var c=!0;if(n)if(n.primary)Ae(n.resolvedFileName,!1,n.packageId,r,i,a);else if(o){if(n.resolvedFileName!==o.resolvedFileName)s.readFile(n.resolvedFileName)!==de(o.resolvedFileName).text&&S.add(Re(r,i,a,e.Diagnostics.Conflicting_definitions_for_0_found_at_1_and_2_Consider_installing_a_specific_version_of_this_library_to_resolve_the_conflict,t,n.resolvedFileName,o.resolvedFileName));c=!1}else Ae(n.resolvedFileName,!1,n.packageId,r,i,a);else S.add(Re(r,i,a,e.Diagnostics.Cannot_find_type_definition_file_for_0,t));c&&k.set(t,n)}}function Re(t,n,r,i){for(var a=[],o=4;o<arguments.length;o++)a[o-4]=arguments[o];return void 0===t||void 0===n||void 0===r?e.createCompilerDiagnostic.apply(void 0,[i].concat(a)):e.createFileDiagnostic.apply(void 0,[t,n,r-n,i].concat(a))}function Le(e){return s.getCanonicalFileName(e)}function Me(t){if(Ee(t),t.imports.length||t.moduleAugmentations.length){var n=g(t),r={program:c,file:t,modifiedFilePaths:h},i=oe(n,e.getNormalizedAbsolutePath(t.fileName,L),t,r);e.Debug.assert(i.length===n.length);for(var a=0;a<n.length;a++){var s=i[a];if(e.setResolvedModule(t,n[a],s),s){var u=s.isExternalLibraryImport,_=!e.extensionIsTypeScript(s.extension),l=u&&_,d=s.resolvedFileName;u&&C++;var p=l&&C>D,m=d&&!f(o,s)&&!o.noResolve&&a<t.imports.length&&!p&&!(_&&!o.allowJs);if(p)T.set(t.path,!0);else if(m){Pe(d,ie(d),!1,t,e.skipTrivia(t.text,t.imports[a].pos),t.imports[a].end,s.packageId)}u&&C--}}}else t.resolvedModules=void 0}function Be(t,n,r,i,a,s){for(var c=!0,u=0,_=ze();u<_.length;u++){var l=_[u];if(e.isObjectLiteralExpression(l.initializer))for(var d=0,p=e.getPropertyAssignment(l.initializer,t);d<p.length;d++){var f=p[d];e.isArrayLiteralExpression(f.initializer)&&f.initializer.elements.length>n&&(R.add(e.createDiagnosticForNodeInSourceFile(o.configFile,f.initializer.elements[n],r,i,a,s)),c=!1)}}c&&R.add(e.createCompilerDiagnostic(r,i,a,s))}function Je(t,n,r,i){for(var a=!0,o=0,s=ze();o<s.length;o++){var c=s[o];e.isObjectLiteralExpression(c.initializer)&&qe(c.initializer,t,n,void 0,r,i)&&(a=!1)}a&&R.add(e.createCompilerDiagnostic(r,i))}function ze(){var t=Ve();return t?e.getPropertyAssignment(t,"paths"):e.emptyArray}function je(e,t,n){Ue(!0,t,n,e,t,n)}function Ke(e,t,n){Ue(!1,e,void 0,t,n)}function Ue(t,n,r,i,a,o){var s=Ve();(!s||!qe(s,t,n,r,i,a,o))&&R.add(e.createCompilerDiagnostic(i,a,o))}function Ve(){if(void 0===N&&(N=null,o.configFile&&o.configFile.jsonObject))for(var t=0,n=e.getPropertyAssignment(o.configFile.jsonObject,"compilerOptions");t<n.length;t++){var r=n[t];if(e.isObjectLiteralExpression(r.initializer)){N=r.initializer;break}}return N}function qe(t,n,r,i,a,s,c){for(var u=e.getPropertyAssignment(t,r,i),_=0,l=u;_<l.length;_++){var d=l[_];R.add(e.createDiagnosticForNodeInSourceFile(o.configFile,n?d.name:d.initializer,a,s,c))}return!!u.length}function We(e,t){B.set(ie(e),!0),R.add(t)}},e.getResolutionDiagnostic=f}(ts||(ts={})),function(e){var t,n;function r(e){return e&&void 0!==e.enableAutoDiscovery&&void 0===e.enable?{enable:e.enableAutoDiscovery,include:e.include||[],exclude:e.exclude||[]}:e}function i(){if(t)return t;var n=e.createMap(),r=e.createMap();return e.forEach(e.optionDeclarations,(function(e){n.set(e.name.toLowerCase(),e),e.shortName&&r.set(e.shortName,e.name)})),t={optionNameMap:n,shortOptionNames:r}}function a(t){return o(t,e.createCompilerDiagnostic)}function o(t,n){var r=e.arrayFrom(t.type.keys()).map((function(e){return"'"+e+"'"})).join(", ");return n(e.Diagnostics.Argument_for_0_option_must_be_Colon_1,"--"+t.name,r)}function s(e,t,n){return I(e,R(t||""),n)}function c(t,n,r){if(void 0===n&&(n=""),n=R(n),!e.startsWith(n,"-")){if(""===n)return[];var i=n.split(",");switch(t.element.type){case"number":return e.map(i,parseInt);case"string":return e.map(i,(function(e){return e||""}));default:return e.filter(e.map(i,(function(e){return s(t.element,e,r)})),(function(e){return!!e}))}}}function u(e,t){void 0===t&&(t=!1),e=e.toLowerCase();var n=i(),r=n.optionNameMap,a=n.shortOptionNames;if(t){var o=a.get(e);void 0!==o&&(e=o)}return r.get(e)}function _(t,n){var r=e.parseJsonText(t,n);return{config:f(r,r.parseDiagnostics),error:r.parseDiagnostics.length?r.parseDiagnostics[0]:void 0}}function l(t,n){var r=d(t,n);return e.isString(r)?e.parseJsonText(t,r):{parseDiagnostics:[r]}}function d(t,n){var r;try{r=n(t)}catch(n){return e.createCompilerDiagnostic(e.Diagnostics.Cannot_read_file_0_Colon_1,t,n.message)}return void 0===r?e.createCompilerDiagnostic(e.Diagnostics.The_specified_path_does_not_exist_Colon_0,t):r}function p(t){return e.arrayToMap(t,(function(e){return e.name}))}function f(e,t){return m(e,t,void 0,void 0)}function m(t,n,r,i){return t.jsonObject?a(t.jsonObject,r,void 0,void 0):{};function a(a,o,u,_){for(var l={},d=0,p=a.properties;d<p.length;d++){var f=p[d];if(261===f.kind){f.questionToken&&n.push(e.createDiagnosticForNodeInSourceFile(t,f.questionToken,e.Diagnostics._0_can_only_be_used_in_a_ts_file,"?")),c(f.name)||n.push(e.createDiagnosticForNodeInSourceFile(t,f.name,e.Diagnostics.String_literal_with_double_quotes_expected));var m=e.unescapeLeadingUnderscores(e.getTextOfPropertyName(f.name)),g=o?o.get(m):void 0;u&&!g&&n.push(e.createDiagnosticForNodeInSourceFile(t,f.name,u,m));var h=s(f.initializer,g);if(void 0!==m&&(l[m]=h,i&&(_||o===r))){var v=y(g,h);_?v&&i.onSetValidOptionKeyValueInParent(_,g,h):o===r&&(v?i.onSetValidOptionKeyValueInRoot(m,f.name,h,f.initializer):g||i.onSetUnknownOptionKeyValueInRoot(m,f.name,h,f.initializer))}}else n.push(e.createDiagnosticForNodeInSourceFile(t,f,e.Diagnostics.Property_assignment_expected))}return l}function s(r,i){switch(r.kind){case 101:return m(i&&"boolean"!==i.type),!0;case 86:return m(i&&"boolean"!==i.type),!1;case 95:return m(i&&"extends"===i.name),null;case 9:c(r)||n.push(e.createDiagnosticForNodeInSourceFile(t,r,e.Diagnostics.String_literal_with_double_quotes_expected)),m(i&&e.isString(i.type)&&"string"!==i.type);var u=r.text;if(i&&!e.isString(i.type)){var _=i;_.type.has(u.toLowerCase())||n.push(o(_,(function(n,i,a){return e.createDiagnosticForNodeInSourceFile(t,r,n,i,a)})))}return u;case 8:return m(i&&"number"!==i.type),Number(r.text);case 178:m(i&&"object"!==i.type);var l=r;if(i){var d=i;return a(l,d.elementOptions,d.extraKeyDiagnosticMessage,d.name)}return a(l,void 0,void 0,void 0);case 177:return m(i&&"list"!==i.type),p=r.elements,f=i&&i.element,p.map((function(e){return s(e,f)}))}var p,f;return void(i?m(!0):n.push(e.createDiagnosticForNodeInSourceFile(t,r,e.Diagnostics.Property_value_can_only_be_string_literal_numeric_literal_true_false_null_object_literal_or_array_literal)));function m(a){a&&n.push(e.createDiagnosticForNodeInSourceFile(t,r,e.Diagnostics.Compiler_option_0_requires_a_value_of_type_1,i.name,g(i)))}}function c(n){return e.isStringLiteral(n)&&e.isStringDoubleQuoted(n,t)}}function g(t){return"list"===t.type?"Array":e.isString(t.type)?t.type:"string"}function y(t,n){if(t)return!!v(n)||("list"===t.type?e.isArray(n):typeof n===(e.isString(t.type)?t.type:"string"))}function h(e,t){t&&Object.defineProperty(e,"configFile",{enumerable:!1,writable:!1,value:t})}function v(e){return null==e}function b(t,n){return e.getDirectoryPath(e.toPath(t,n,e.identity))}function x(t,n,r,i,a,o,s,c){void 0===a&&(a={}),void 0===s&&(s=[]),void 0===c&&(c=[]),e.Debug.assert(void 0===t&&void 0!==n||void 0!==t&&void 0===n);var u=[],_=e.createGetCanonicalFileName(r.useCaseSensitiveFileNames),l=D(t,n,r,i,o,_,s,u),d=l.raw,p=e.extend(a,l.options||{});p.configFilePath=o,h(p,n);var f=function(){var t,a,_;e.hasProperty(d,"files")&&!v(d.files)&&(e.isArray(d.files)?0===(t=d.files).length&&x(e.Diagnostics.The_files_list_in_config_file_0_is_empty,o||"tsconfig.json"):x(e.Diagnostics.Compiler_option_0_requires_a_value_of_type_1,"files","Array"));e.hasProperty(d,"include")&&!v(d.include)&&(e.isArray(d.include)?a=d.include:x(e.Diagnostics.Compiler_option_0_requires_a_value_of_type_1,"include","Array"));if(e.hasProperty(d,"exclude")&&!v(d.exclude))e.isArray(d.exclude)?_=d.exclude:x(e.Diagnostics.Compiler_option_0_requires_a_value_of_type_1,"exclude","Array");else{var l=d.compilerOptions&&d.compilerOptions.outDir;l&&(_=[l])}void 0===t&&void 0===a&&(a=["**/*"]);var f=function(t,n,r,i,a,o,s,c,u){var _,l;i=e.normalizePath(i),n&&(_=K(n,s,!1,u,"include"));r&&(l=K(r,s,!0,u,"exclude"));var d=function(t,n,r,i){var a=e.getRegularExpressionForWildcard(n,r,"exclude"),o=a&&new RegExp(a,i?"":"i"),s={};if(void 0!==t){for(var c=[],u=0,_=t;u<_.length;u++){var l=_[u],d=e.normalizePath(e.combinePaths(r,l));if(!o||!o.test(d)){var p=U(d,i);if(p){var f=p.key,m=p.flags,g=s[f];(void 0===g||g<m)&&(s[f]=m,1===m&&c.push(f))}}}for(var f in s)if(e.hasProperty(s,f))for(var y=0,h=c;y<h.length;y++){var v=h[y];f!==v&&e.containsPath(v,f,r,!i)&&delete s[f]}}return s}(_,l,i,o.useCaseSensitiveFileNames);return j({filesSpecs:t,includeSpecs:n,excludeSpecs:r,validatedIncludeSpecs:_,validatedExcludeSpecs:l,wildcardDirectories:d},i,a,o,c)}(t,a,_,o?b(o,i):i,p,r,u,c,n);0!==f.fileNames.length||e.hasProperty(d,"files")||0!==s.length||u.push(k(f.spec,o));return f}(),m=f.fileNames,g=f.wildcardDirectories,y=f.spec;return{options:p,fileNames:m,typeAcquisition:l.typeAcquisition||N(),raw:d,errors:u,wildcardDirectories:g,compileOnSave:!!d.compileOnSave,configFileSpecs:y};function x(t,r,i){n||u.push(e.createCompilerDiagnostic(t,r,i))}}function k(t,n){var r=t.includeSpecs,i=t.excludeSpecs;return e.createCompilerDiagnostic(e.Diagnostics.No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2,n||"tsconfig.json",JSON.stringify(r||[]),JSON.stringify(i||[]))}function S(e){return!!e.options}function D(t,r,i,a,o,s,c,u){a=e.normalizeSlashes(a);var _=e.toPath(o||"",a,s);if(c.indexOf(_)>=0)return u.push(e.createCompilerDiagnostic(e.Diagnostics.Circularity_detected_while_resolving_configuration_Colon_0,c.concat([_]).join(" -> "))),{raw:t||f(r,u)};var d=t?function(t,n,r,i,a,o){e.hasProperty(t,"excludes")&&o.push(e.createCompilerDiagnostic(e.Diagnostics.Unknown_option_excludes_Did_you_mean_exclude));var s,c=E(t.compilerOptions,r,o,a),u=A(t.typeAcquisition||t.typingOptions,r,o,a);if(t.compileOnSave=function(t,n,r){if(!e.hasProperty(t,e.compileOnSaveCommandLineOption.name))return;var i=P(e.compileOnSaveCommandLineOption,t.compileOnSave,n,r);if("boolean"==typeof i&&i)return i;return!1}(t,r,o),t.extends)if(e.isString(t.extends)){var _=a?b(a,r):r;s=C(t.extends,n,_,i,o,e.createCompilerDiagnostic)}else o.push(e.createCompilerDiagnostic(e.Diagnostics.Compiler_option_0_requires_a_value_of_type_1,"extends","string"));return{raw:t,options:c,typeAcquisition:u,extendedConfigPath:s}}(t,i,a,s,o,u):function(t,r,i,a,o,s){var c,u,_,l=T(o),d={onSetValidOptionKeyValueInParent:function(t,n,r){e.Debug.assert("compilerOptions"===t||"typeAcquisition"===t||"typingOptions"===t),("compilerOptions"===t?l:"typeAcquisition"===t?c||(c=N(o)):u||(u=N(o)))[n.name]=F(n,i,r)},onSetValidOptionKeyValueInRoot:function(n,c,u,l){switch(n){case"extends":var d=o?b(o,i):i;return void(_=C(u,r,d,a,s,(function(n,r){return e.createDiagnosticForNodeInSourceFile(t,l,n,r)})));case"files":return void(0===u.length&&s.push(e.createDiagnosticForNodeInSourceFile(t,l,e.Diagnostics.The_files_list_in_config_file_0_is_empty,o||"tsconfig.json")))}},onSetUnknownOptionKeyValueInRoot:function(n,r,i,a){"excludes"===n&&s.push(e.createDiagnosticForNodeInSourceFile(t,r,e.Diagnostics.Unknown_option_excludes_Did_you_mean_exclude))}},f=m(t,s,(void 0===n&&(n=p([{name:"compilerOptions",type:"object",elementOptions:p(e.optionDeclarations),extraKeyDiagnosticMessage:e.Diagnostics.Unknown_compiler_option_0},{name:"typingOptions",type:"object",elementOptions:p(e.typeAcquisitionDeclarations),extraKeyDiagnosticMessage:e.Diagnostics.Unknown_type_acquisition_option_0},{name:"typeAcquisition",type:"object",elementOptions:p(e.typeAcquisitionDeclarations),extraKeyDiagnosticMessage:e.Diagnostics.Unknown_type_acquisition_option_0},{name:"extends",type:"string"},{name:"files",type:"list",element:{name:"files",type:"string"}},{name:"include",type:"list",element:{name:"include",type:"string"}},{name:"exclude",type:"list",element:{name:"exclude",type:"string"}},e.compileOnSaveCommandLineOption])),n),d);c||(c=u?void 0!==u.enableAutoDiscovery?{enable:u.enableAutoDiscovery,include:u.include,exclude:u.exclude}:u:N(o));return{raw:f,options:l,typeAcquisition:c,extendedConfigPath:_}}(r,i,a,s,o,u);if(d.extendedConfigPath){c=c.concat([_]);var g=function(t,n,r,i,a,o,s){var c=l(n,(function(e){return r.readFile(e)}));t&&(t.extendedSourceFiles||(t.extendedSourceFiles=[])).push(c.fileName);if(c.parseDiagnostics.length)return void s.push.apply(s,c.parseDiagnostics);var u,_=e.getDirectoryPath(n),d=D(void 0,c,r,_,e.getBaseFileName(n),a,o,s);t&&(u=t.extendedSourceFiles).push.apply(u,c.extendedSourceFiles);if(S(d)){var p=e.convertToRelativePath(_,i,a),f=function(t){return e.isRootedDiskPath(t)?t:e.combinePaths(p,t)},m=function(t){g[t]&&(g[t]=e.map(g[t],f))},g=d.raw;m("include"),m("exclude"),m("files")}return d}(r,d.extendedConfigPath,i,a,s,c,u);if(g&&S(g)){var y=g.raw,h=d.raw,v=function(e){var t=h[e]||y[e];t&&(h[e]=t)};v("include"),v("exclude"),v("files"),void 0===h.compileOnSave&&(h.compileOnSave=y.compileOnSave),d.options=e.assign({},g.options,d.options)}}return d}function C(t,n,r,i,a,o){if(t=e.normalizeSlashes(t),e.isRootedDiskPath(t)||e.startsWith(t,"./")||e.startsWith(t,"../")){var s=e.toPath(t,r,i);if(n.fileExists(s)||e.endsWith(s,".json")||(s+=".json",n.fileExists(s)))return s;a.push(o(e.Diagnostics.File_0_does_not_exist,t))}else a.push(o(e.Diagnostics.A_path_in_an_extends_option_must_be_relative_or_rooted_but_0_is_not,t))}function T(t){return"jsconfig.json"===e.getBaseFileName(t)?{allowJs:!0,maxNodeModuleJsDepth:2,allowSyntheticDefaultImports:!0,skipLibCheck:!0}:{}}function E(t,n,r,i){var a=T(i);return w(e.optionDeclarations,t,n,a,e.Diagnostics.Unknown_compiler_option_0,r),a}function N(t){return{enable:"jsconfig.json"===e.getBaseFileName(t),include:[],exclude:[]}}function A(t,n,i,a){var o=N(a),s=r(t);return w(e.typeAcquisitionDeclarations,s,n,o,e.Diagnostics.Unknown_type_acquisition_option_0,i),o}function w(t,n,r,i,a,o){if(n){var s=p(t);for(var c in n){var u=s.get(c);u?i[u.name]=P(u,n[c],r,o):o.push(e.createCompilerDiagnostic(a,c))}}}function P(t,n,r,i){if(y(t,n)){var a=t.type;return"list"===a&&e.isArray(n)?function(t,n,r,i){return e.filter(e.map(n,(function(e){return P(t.element,e,r,i)})),(function(e){return!!e}))}(t,n,r,i):e.isString(a)?O(t,r,n):I(t,n,i)}i.push(e.createCompilerDiagnostic(e.Diagnostics.Compiler_option_0_requires_a_value_of_type_1,t.name,g(t)))}function F(t,n,r){if(!v(r)){if("list"===t.type){var i=t;return i.element.isFilePath||!e.isString(i.element.type)?e.filter(e.map(r,(function(e){return F(i.element,n,e)})),(function(e){return!!e})):r}return e.isString(t.type)?O(t,n,r):t.type.get(e.isString(r)?r.toLowerCase():r)}}function O(t,n,r){return t.isFilePath&&""===(r=e.normalizePath(e.combinePaths(n,r)))&&(r="."),r}function I(e,t,n){if(!v(t)){var r=t.toLowerCase(),i=e.type.get(r);if(void 0!==i)return i;n.push(a(e))}}function R(e){return"function"==typeof e.trim?e.trim():e.replace(/^[\s]+|[\s]+$/g,"")}e.compileOnSaveCommandLineOption={name:"compileOnSave",type:"boolean"},e.optionDeclarations=[{name:"help",shortName:"h",type:"boolean",showInSimplifiedHelpView:!0,category:e.Diagnostics.Command_line_Options,description:e.Diagnostics.Print_this_message},{name:"help",shortName:"?",type:"boolean"},{name:"all",type:"boolean",showInSimplifiedHelpView:!0,category:e.Diagnostics.Command_line_Options,description:e.Diagnostics.Show_all_compiler_options},{name:"version",shortName:"v",type:"boolean",showInSimplifiedHelpView:!0,category:e.Diagnostics.Command_line_Options,description:e.Diagnostics.Print_the_compiler_s_version},{name:"init",type:"boolean",showInSimplifiedHelpView:!0,category:e.Diagnostics.Command_line_Options,description:e.Diagnostics.Initializes_a_TypeScript_project_and_creates_a_tsconfig_json_file},{name:"project",shortName:"p",type:"string",isFilePath:!0,showInSimplifiedHelpView:!0,category:e.Diagnostics.Command_line_Options,paramType:e.Diagnostics.FILE_OR_DIRECTORY,description:e.Diagnostics.Compile_the_project_given_the_path_to_its_configuration_file_or_to_a_folder_with_a_tsconfig_json},{name:"pretty",type:"boolean",showInSimplifiedHelpView:!0,category:e.Diagnostics.Command_line_Options,description:e.Diagnostics.Stylize_errors_and_messages_using_color_and_context_experimental},{name:"watch",shortName:"w",type:"boolean",showInSimplifiedHelpView:!0,category:e.Diagnostics.Command_line_Options,description:e.Diagnostics.Watch_input_files},{name:"target",shortName:"t",type:e.createMapFromTemplate({es3:0,es5:1,es6:2,es2015:2,es2016:3,es2017:4,esnext:5}),paramType:e.Diagnostics.VERSION,showInSimplifiedHelpView:!0,category:e.Diagnostics.Basic_Options,description:e.Diagnostics.Specify_ECMAScript_target_version_Colon_ES3_default_ES5_ES2015_ES2016_ES2017_or_ESNEXT},{name:"module",shortName:"m",type:e.createMapFromTemplate({none:e.ModuleKind.None,commonjs:e.ModuleKind.CommonJS,amd:e.ModuleKind.AMD,system:e.ModuleKind.System,umd:e.ModuleKind.UMD,es6:e.ModuleKind.ES2015,es2015:e.ModuleKind.ES2015,esnext:e.ModuleKind.ESNext}),paramType:e.Diagnostics.KIND,showInSimplifiedHelpView:!0,category:e.Diagnostics.Basic_Options,description:e.Diagnostics.Specify_module_code_generation_Colon_none_commonjs_amd_system_umd_es2015_or_ESNext},{name:"lib",type:"list",element:{name:"lib",type:e.createMapFromTemplate({es5:"lib.es5.d.ts",es6:"lib.es2015.d.ts",es2015:"lib.es2015.d.ts",es7:"lib.es2016.d.ts",es2016:"lib.es2016.d.ts",es2017:"lib.es2017.d.ts",esnext:"lib.esnext.d.ts",dom:"lib.dom.d.ts","dom.iterable":"lib.dom.iterable.d.ts",webworker:"lib.webworker.d.ts",scripthost:"lib.scripthost.d.ts","es2015.core":"lib.es2015.core.d.ts","es2015.collection":"lib.es2015.collection.d.ts","es2015.generator":"lib.es2015.generator.d.ts","es2015.iterable":"lib.es2015.iterable.d.ts","es2015.promise":"lib.es2015.promise.d.ts","es2015.proxy":"lib.es2015.proxy.d.ts","es2015.reflect":"lib.es2015.reflect.d.ts","es2015.symbol":"lib.es2015.symbol.d.ts","es2015.symbol.wellknown":"lib.es2015.symbol.wellknown.d.ts","es2016.array.include":"lib.es2016.array.include.d.ts","es2017.object":"lib.es2017.object.d.ts","es2017.sharedmemory":"lib.es2017.sharedmemory.d.ts","es2017.string":"lib.es2017.string.d.ts","es2017.intl":"lib.es2017.intl.d.ts","esnext.asynciterable":"lib.esnext.asynciterable.d.ts"})},showInSimplifiedHelpView:!0,category:e.Diagnostics.Basic_Options,description:e.Diagnostics.Specify_library_files_to_be_included_in_the_compilation_Colon},{name:"allowJs",type:"boolean",showInSimplifiedHelpView:!0,category:e.Diagnostics.Basic_Options,description:e.Diagnostics.Allow_javascript_files_to_be_compiled},{name:"checkJs",type:"boolean",category:e.Diagnostics.Basic_Options,description:e.Diagnostics.Report_errors_in_js_files},{name:"jsx",type:e.createMapFromTemplate({preserve:1,"react-native":3,react:2}),paramType:e.Diagnostics.KIND,showInSimplifiedHelpView:!0,category:e.Diagnostics.Basic_Options,description:e.Diagnostics.Specify_JSX_code_generation_Colon_preserve_react_native_or_react},{name:"declaration",shortName:"d",type:"boolean",showInSimplifiedHelpView:!0,category:e.Diagnostics.Basic_Options,description:e.Diagnostics.Generates_corresponding_d_ts_file},{name:"sourceMap",type:"boolean",showInSimplifiedHelpView:!0,category:e.Diagnostics.Basic_Options,description:e.Diagnostics.Generates_corresponding_map_file},{name:"outFile",type:"string",isFilePath:!0,paramType:e.Diagnostics.FILE,showInSimplifiedHelpView:!0,category:e.Diagnostics.Basic_Options,description:e.Diagnostics.Concatenate_and_emit_output_to_single_file},{name:"outDir",type:"string",isFilePath:!0,paramType:e.Diagnostics.DIRECTORY,showInSimplifiedHelpView:!0,category:e.Diagnostics.Basic_Options,description:e.Diagnostics.Redirect_output_structure_to_the_directory},{name:"rootDir",type:"string",isFilePath:!0,paramType:e.Diagnostics.LOCATION,category:e.Diagnostics.Basic_Options,description:e.Diagnostics.Specify_the_root_directory_of_input_files_Use_to_control_the_output_directory_structure_with_outDir},{name:"removeComments",type:"boolean",showInSimplifiedHelpView:!0,category:e.Diagnostics.Basic_Options,description:e.Diagnostics.Do_not_emit_comments_to_output},{name:"noEmit",type:"boolean",showInSimplifiedHelpView:!0,category:e.Diagnostics.Basic_Options,description:e.Diagnostics.Do_not_emit_outputs},{name:"importHelpers",type:"boolean",category:e.Diagnostics.Basic_Options,description:e.Diagnostics.Import_emit_helpers_from_tslib},{name:"downlevelIteration",type:"boolean",category:e.Diagnostics.Basic_Options,description:e.Diagnostics.Provide_full_support_for_iterables_in_for_of_spread_and_destructuring_when_targeting_ES5_or_ES3},{name:"isolatedModules",type:"boolean",category:e.Diagnostics.Basic_Options,description:e.Diagnostics.Transpile_each_file_as_a_separate_module_similar_to_ts_transpileModule},{name:"strict",type:"boolean",showInSimplifiedHelpView:!0,category:e.Diagnostics.Strict_Type_Checking_Options,description:e.Diagnostics.Enable_all_strict_type_checking_options},{name:"noImplicitAny",type:"boolean",showInSimplifiedHelpView:!0,category:e.Diagnostics.Strict_Type_Checking_Options,description:e.Diagnostics.Raise_error_on_expressions_and_declarations_with_an_implied_any_type},{name:"strictNullChecks",type:"boolean",showInSimplifiedHelpView:!0,category:e.Diagnostics.Strict_Type_Checking_Options,description:e.Diagnostics.Enable_strict_null_checks},{name:"strictFunctionTypes",type:"boolean",showInSimplifiedHelpView:!0,category:e.Diagnostics.Strict_Type_Checking_Options,description:e.Diagnostics.Enable_strict_checking_of_function_types},{name:"noImplicitThis",type:"boolean",showInSimplifiedHelpView:!0,category:e.Diagnostics.Strict_Type_Checking_Options,description:e.Diagnostics.Raise_error_on_this_expressions_with_an_implied_any_type},{name:"alwaysStrict",type:"boolean",showInSimplifiedHelpView:!0,category:e.Diagnostics.Strict_Type_Checking_Options,description:e.Diagnostics.Parse_in_strict_mode_and_emit_use_strict_for_each_source_file},{name:"noUnusedLocals",type:"boolean",showInSimplifiedHelpView:!0,category:e.Diagnostics.Additional_Checks,description:e.Diagnostics.Report_errors_on_unused_locals},{name:"noUnusedParameters",type:"boolean",showInSimplifiedHelpView:!0,category:e.Diagnostics.Additional_Checks,description:e.Diagnostics.Report_errors_on_unused_parameters},{name:"noImplicitReturns",type:"boolean",showInSimplifiedHelpView:!0,category:e.Diagnostics.Additional_Checks,description:e.Diagnostics.Report_error_when_not_all_code_paths_in_function_return_a_value},{name:"noFallthroughCasesInSwitch",type:"boolean",showInSimplifiedHelpView:!0,category:e.Diagnostics.Additional_Checks,description:e.Diagnostics.Report_errors_for_fallthrough_cases_in_switch_statement},{name:"moduleResolution",type:e.createMapFromTemplate({node:e.ModuleResolutionKind.NodeJs,classic:e.ModuleResolutionKind.Classic}),paramType:e.Diagnostics.STRATEGY,category:e.Diagnostics.Module_Resolution_Options,description:e.Diagnostics.Specify_module_resolution_strategy_Colon_node_Node_js_or_classic_TypeScript_pre_1_6},{name:"baseUrl",type:"string",isFilePath:!0,category:e.Diagnostics.Module_Resolution_Options,description:e.Diagnostics.Base_directory_to_resolve_non_absolute_module_names},{name:"paths",type:"object",isTSConfigOnly:!0,category:e.Diagnostics.Module_Resolution_Options,description:e.Diagnostics.A_series_of_entries_which_re_map_imports_to_lookup_locations_relative_to_the_baseUrl},{name:"rootDirs",type:"list",isTSConfigOnly:!0,element:{name:"rootDirs",type:"string",isFilePath:!0},category:e.Diagnostics.Module_Resolution_Options,description:e.Diagnostics.List_of_root_folders_whose_combined_content_represents_the_structure_of_the_project_at_runtime},{name:"typeRoots",type:"list",element:{name:"typeRoots",type:"string",isFilePath:!0},category:e.Diagnostics.Module_Resolution_Options,description:e.Diagnostics.List_of_folders_to_include_type_definitions_from},{name:"types",type:"list",element:{name:"types",type:"string"},showInSimplifiedHelpView:!0,category:e.Diagnostics.Module_Resolution_Options,description:e.Diagnostics.Type_declaration_files_to_be_included_in_compilation},{name:"allowSyntheticDefaultImports",type:"boolean",category:e.Diagnostics.Module_Resolution_Options,description:e.Diagnostics.Allow_default_imports_from_modules_with_no_default_export_This_does_not_affect_code_emit_just_typechecking},{name:"preserveSymlinks",type:"boolean",category:e.Diagnostics.Module_Resolution_Options,description:e.Diagnostics.Do_not_resolve_the_real_path_of_symlinks},{name:"sourceRoot",type:"string",isFilePath:!0,paramType:e.Diagnostics.LOCATION,category:e.Diagnostics.Source_Map_Options,description:e.Diagnostics.Specify_the_location_where_debugger_should_locate_TypeScript_files_instead_of_source_locations},{name:"mapRoot",type:"string",isFilePath:!0,paramType:e.Diagnostics.LOCATION,category:e.Diagnostics.Source_Map_Options,description:e.Diagnostics.Specify_the_location_where_debugger_should_locate_map_files_instead_of_generated_locations},{name:"inlineSourceMap",type:"boolean",category:e.Diagnostics.Source_Map_Options,description:e.Diagnostics.Emit_a_single_file_with_source_maps_instead_of_having_a_separate_file},{name:"inlineSources",type:"boolean",category:e.Diagnostics.Source_Map_Options,description:e.Diagnostics.Emit_the_source_alongside_the_sourcemaps_within_a_single_file_requires_inlineSourceMap_or_sourceMap_to_be_set},{name:"experimentalDecorators",type:"boolean",category:e.Diagnostics.Experimental_Options,description:e.Diagnostics.Enables_experimental_support_for_ES7_decorators},{name:"emitDecoratorMetadata",type:"boolean",category:e.Diagnostics.Experimental_Options,description:e.Diagnostics.Enables_experimental_support_for_emitting_type_metadata_for_decorators},{name:"jsxFactory",type:"string",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Specify_the_JSX_factory_function_to_use_when_targeting_react_JSX_emit_e_g_React_createElement_or_h},{name:"diagnostics",type:"boolean",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Show_diagnostic_information},{name:"extendedDiagnostics",type:"boolean",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Show_verbose_diagnostic_information},{name:"traceResolution",type:"boolean",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Enable_tracing_of_the_name_resolution_process},{name:"listFiles",type:"boolean",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Print_names_of_files_part_of_the_compilation},{name:"listEmittedFiles",type:"boolean",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Print_names_of_generated_files_part_of_the_compilation},{name:"out",type:"string",isFilePath:!1,category:e.Diagnostics.Advanced_Options,paramType:e.Diagnostics.FILE,description:e.Diagnostics.Deprecated_Use_outFile_instead_Concatenate_and_emit_output_to_single_file},{name:"reactNamespace",type:"string",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Deprecated_Use_jsxFactory_instead_Specify_the_object_invoked_for_createElement_when_targeting_react_JSX_emit},{name:"skipDefaultLibCheck",type:"boolean",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Deprecated_Use_skipLibCheck_instead_Skip_type_checking_of_default_library_declaration_files},{name:"charset",type:"string",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.The_character_set_of_the_input_files},{name:"emitBOM",type:"boolean",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Emit_a_UTF_8_Byte_Order_Mark_BOM_in_the_beginning_of_output_files},{name:"locale",type:"string",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.The_locale_used_when_displaying_messages_to_the_user_e_g_en_us},{name:"newLine",type:e.createMapFromTemplate({crlf:0,lf:1}),paramType:e.Diagnostics.NEWLINE,category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Specify_the_end_of_line_sequence_to_be_used_when_emitting_files_Colon_CRLF_dos_or_LF_unix},{name:"noErrorTruncation",type:"boolean",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Do_not_truncate_error_messages},{name:"noLib",type:"boolean",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Do_not_include_the_default_library_file_lib_d_ts},{name:"noResolve",type:"boolean",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Do_not_add_triple_slash_references_or_imported_modules_to_the_list_of_compiled_files},{name:"stripInternal",type:"boolean",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Do_not_emit_declarations_for_code_that_has_an_internal_annotation},{name:"disableSizeLimit",type:"boolean",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Disable_size_limitations_on_JavaScript_projects},{name:"noImplicitUseStrict",type:"boolean",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Do_not_emit_use_strict_directives_in_module_output},{name:"noEmitHelpers",type:"boolean",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Do_not_generate_custom_helper_functions_like_extends_in_compiled_output},{name:"noEmitOnError",type:"boolean",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Do_not_emit_outputs_if_any_errors_were_reported},{name:"preserveConstEnums",type:"boolean",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Do_not_erase_const_enum_declarations_in_generated_code},{name:"declarationDir",type:"string",isFilePath:!0,paramType:e.Diagnostics.DIRECTORY,category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Output_directory_for_generated_declaration_files},{name:"skipLibCheck",type:"boolean",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Skip_type_checking_of_declaration_files},{name:"allowUnusedLabels",type:"boolean",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Do_not_report_errors_on_unused_labels},{name:"allowUnreachableCode",type:"boolean",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Do_not_report_errors_on_unreachable_code},{name:"suppressExcessPropertyErrors",type:"boolean",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Suppress_excess_property_checks_for_object_literals},{name:"suppressImplicitAnyIndexErrors",type:"boolean",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Suppress_noImplicitAny_errors_for_indexing_objects_lacking_index_signatures},{name:"forceConsistentCasingInFileNames",type:"boolean",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Disallow_inconsistently_cased_references_to_the_same_file},{name:"maxNodeModuleJsDepth",type:"number",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.The_maximum_dependency_depth_to_search_under_node_modules_and_load_JavaScript_files},{name:"noStrictGenericChecks",type:"boolean",category:e.Diagnostics.Advanced_Options,description:e.Diagnostics.Disable_strict_checking_of_generic_signatures_in_function_types},{name:"plugins",type:"list",isTSConfigOnly:!0,element:{name:"plugin",type:"object"},description:e.Diagnostics.List_of_language_service_plugins}],e.typeAcquisitionDeclarations=[{name:"enableAutoDiscovery",type:"boolean"},{name:"enable",type:"boolean"},{name:"include",type:"list",element:{name:"include",type:"string"}},{name:"exclude",type:"list",element:{name:"exclude",type:"string"}}],e.defaultInitCompilerOptions={module:e.ModuleKind.CommonJS,target:1,strict:!0},e.convertEnableAutoDiscoveryToEnable=r,e.createCompilerDiagnosticForInvalidCustomType=a,e.parseCustomTypeOption=s,e.parseListTypeOption=c,e.parseCommandLine=function(t,n){var r={},i=[],a=[];return o(t),{options:r,fileNames:i,errors:a};function o(t){for(var n=0;n<t.length;){var o=t[n];if(n++,64===o.charCodeAt(0))_(o.slice(1));else if(45===o.charCodeAt(0)){var l=u(o.slice(45===o.charCodeAt(1)?2:1),!0);if(l)if(l.isTSConfigOnly)a.push(e.createCompilerDiagnostic(e.Diagnostics.Option_0_can_only_be_specified_in_tsconfig_json_file,l.name));else switch(t[n]||"boolean"===l.type||a.push(e.createCompilerDiagnostic(e.Diagnostics.Compiler_option_0_expects_an_argument,l.name)),l.type){case"number":r[l.name]=parseInt(t[n]),n++;break;case"boolean":var d=t[n];r[l.name]="false"!==d,"false"!==d&&"true"!==d||n++;break;case"string":r[l.name]=t[n]||"",n++;break;case"list":var p=c(l,t[n],a);r[l.name]=p||[],p&&n++;break;default:r[l.name]=s(l,t[n],a),n++}else a.push(e.createCompilerDiagnostic(e.Diagnostics.Unknown_compiler_option_0,o))}else i.push(o)}}function _(t){var r=n?n(t):e.sys.readFile(t);if(r){for(var i=[],s=0;;){for(;s<r.length&&r.charCodeAt(s)<=32;)s++;if(s>=r.length)break;var c=s;if(34===r.charCodeAt(c)){for(s++;s<r.length&&34!==r.charCodeAt(s);)s++;s<r.length?(i.push(r.substring(c+1,s)),s++):a.push(e.createCompilerDiagnostic(e.Diagnostics.Unterminated_quoted_string_in_response_file_0,t))}else{for(;r.charCodeAt(s)>32;)s++;i.push(r.substring(c,s))}}o(i)}else a.push(e.createCompilerDiagnostic(e.Diagnostics.File_0_not_found,t))}},e.readConfigFile=function(t,n){var r=d(t,n);return e.isString(r)?_(t,r):{config:{},error:r}},e.parseConfigFileTextToJson=_,e.readJsonConfigFile=l,e.convertToObject=f,e.generateTSConfig=function(t,n,r){var a=function(t){var n=e.createMap(),r=i().optionNameMap,a=function(i){if(e.hasProperty(t,i)){if(r.has(i)&&r.get(i).category===e.Diagnostics.Command_line_Options)return"continue";var a=t[i],c=r.get(i.toLowerCase());if(c){var u=o(c);u?"list"===c.type?n.set(i,a.map((function(e){return s(e,u)}))):n.set(i,s(a,u)):n.set(i,a)}}};for(var c in t)a(c);return n}(e.extend(t,e.defaultInitCompilerOptions));return function(){for(var t=e.createMultiMap(),i=0,o=e.optionDeclarations;i<o.length;i++){var s=o[i],_=s.category;void 0!==_&&_!==e.Diagnostics.Command_line_Options&&_!==e.Diagnostics.Advanced_Options&&t.add(e.getLocaleSpecificMessage(_),s)}var l=0,d=0,p=[],f=[];t.forEach((function(t,n){0!==p.length&&(p.push(""),f.push("")),p.push("/* "+n+" */"),f.push("");for(var r=0,i=t;r<i.length;r++){var o=i[r],s=void 0;s=a.has(o.name)?'"'+o.name+'": '+JSON.stringify(a.get(o.name))+((d+=1)===a.size?"":","):'// "'+o.name+'": '+JSON.stringify(c(o))+",",p.push(s),f.push("/* "+(o.description&&e.getLocaleSpecificMessage(o.description)||o.name)+" */"),l=Math.max(s.length,l)}}));var m=u(2),g=[];g.push("{"),g.push(m+'"compilerOptions": {');for(var y=0;y<p.length;y++){var h=p[y],v=f[y];g.push(h&&""+m+m+h+(v&&u(l-h.length+2)+v))}if(n.length){g.push(m+"},"),g.push(m+'"files": [');for(y=0;y<n.length;y++)g.push(""+m+m+JSON.stringify(n[y])+(y===n.length-1?"":","));g.push(m+"]")}else g.push(m+"}");return g.push("}"),g.join(r)}();function o(e){return"string"===e.type||"number"===e.type||"boolean"===e.type?void 0:"list"===e.type?o(e.element):e.type}function s(t,n){return e.forEachEntry(n,(function(e,n){if(e===t)return n}))}function c(e){switch(e.type){case"number":return 1;case"boolean":return!0;case"string":return e.isFilePath?"./":"";case"list":return[];case"object":return{};default:return e.type.keys().next().value}}function u(e){return Array(e+1).join(" ")}},e.parseJsonConfigFileContent=function(e,t,n,r,i,a,o){return x(e,void 0,t,n,r,i,a,o)},e.parseJsonSourceFileConfigFileContent=function(e,t,n,r,i,a,o){return x(void 0,e,t,n,r,i,a,o)},e.setConfigFileInOptions=h,e.isErrorNoInputFiles=function(t){return t.code===e.Diagnostics.No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2.code},e.getErrorForNoInputFiles=k,e.convertCompilerOptionsFromJson=function(e,t,n){var r=[];return{options:E(e,t,r,n),errors:r}},e.convertTypeAcquisitionFromJson=function(e,t,n){var r=[];return{options:A(e,t,r,n),errors:r}};var L=/(^|\/)\*\*\/?$/,M=/(^|\/)\*\*\/(.*\/)?\*\*($|\/)/,B=/(^|\/)\*\*\/(.*\/)?\.\.($|\/)/,J=/\/[^/]*?[*?][^/]*\//,z=/^[^*?]*(?=\/[^/]*[*?])/;function j(t,n,r,i,a){void 0===a&&(a=[]),n=e.normalizePath(n);var o=i.useCaseSensitiveFileNames?W:H,s=e.createMap(),c=e.createMap(),u=t.filesSpecs,_=t.validatedIncludeSpecs,l=t.validatedExcludeSpecs,d=t.wildcardDirectories,p=e.getSupportedExtensions(r,a);if(u)for(var f=0,m=u;f<m.length;f++){var g=m[f],y=e.getNormalizedAbsolutePath(g,n);s.set(o(y),y)}if(_&&_.length>0)for(var h=0,v=i.readDirectory(n,p,l,_,void 0);h<v.length;h++){if(!V(y=v[h],s,c,p,o)){q(y,c,p,o);var b=o(y);s.has(b)||c.has(b)||c.set(b,y)}}var x=e.arrayFrom(s.values()),k=e.arrayFrom(c.values());return{fileNames:x.concat(k),wildcardDirectories:d,spec:t}}function K(t,n,r,i,a){return t.filter((function(t){var o=function(t,n){if(!n&&L.test(t))return e.Diagnostics.File_specification_cannot_end_in_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0;if(M.test(t))return e.Diagnostics.File_specification_cannot_contain_multiple_recursive_directory_wildcards_Asterisk_Asterisk_Colon_0;if(B.test(t))return e.Diagnostics.File_specification_cannot_contain_a_parent_directory_that_appears_after_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0}(t,r);return void 0!==o&&n.push(function(t,n){if(i&&i.jsonObject)for(var r=0,o=e.getPropertyAssignment(i.jsonObject,a);r<o.length;r++){var s=o[r];if(e.isArrayLiteralExpression(s.initializer))for(var c=0,u=s.initializer.elements;c<u.length;c++){var _=u[c];if(e.isStringLiteral(_)&&_.text===n)return e.createDiagnosticForNodeInSourceFile(i,_,t,n)}}return e.createCompilerDiagnostic(t,n)}(o,t)),void 0===o}))}function U(t,n){var r=z.exec(t);return r?{key:n?r[0]:r[0].toLowerCase(),flags:J.test(t)?1:0}:e.isImplicitGlob(t)?{key:t,flags:1}:void 0}function V(t,n,r,i,a){for(var o=e.getExtensionPriority(t,i),s=e.adjustExtensionPriority(o,i),c=0;c<s;c++){var u=i[c],_=a(e.changeExtension(t,u));if(n.has(_)||r.has(_))return!0}return!1}function q(t,n,r,i){for(var a=e.getExtensionPriority(t,r),o=e.getNextLowestExtensionPriority(a,r);o<r.length;o++){var s=r[o],c=i(e.changeExtension(t,s));n.delete(c)}}function W(e){return e}function H(e){return e.toLowerCase()}function G(t,n){switch(n.type){case"object":case"string":return"";case"number":return"number"==typeof t?t:"";case"boolean":return"boolean"==typeof t?t:"";case"list":var r=n.element;return e.isArray(t)?t.map((function(e){return G(e,r)})):"";default:return e.forEachEntry(n.type,(function(e,n){if(e===t)return n}))}}e.getFileNamesFromConfigSpecs=j,e.convertCompilerOptionsForTelemetry=function(e){var t={};for(var n in e)if(e.hasOwnProperty(n)){var r=u(n);void 0!==r&&(t[n]=G(e[n],r))}return t}}(ts||(ts={})),function(e){!function(e){var t=function(){function e(e){this.text=e}return e.prototype.getText=function(e,t){return 0===e&&t===this.text.length?this.text:this.text.substring(e,t)},e.prototype.getLength=function(){return this.text.length},e.prototype.getChangeRange=function(){},e}();e.fromString=function(e){return new t(e)}}(e.ScriptSnapshot||(e.ScriptSnapshot={}));var t=function(){};e.TextChange=t,function(e){e.none="none",e.definition="definition",e.reference="reference",e.writtenReference="writtenReference"}(e.HighlightSpanKind||(e.HighlightSpanKind={})),function(e){e[e.None=0]="None",e[e.Block=1]="Block",e[e.Smart=2]="Smart"}(e.IndentStyle||(e.IndentStyle={})),function(e){e[e.aliasName=0]="aliasName",e[e.className=1]="className",e[e.enumName=2]="enumName",e[e.fieldName=3]="fieldName",e[e.interfaceName=4]="interfaceName",e[e.keyword=5]="keyword",e[e.lineBreak=6]="lineBreak",e[e.numericLiteral=7]="numericLiteral",e[e.stringLiteral=8]="stringLiteral",e[e.localName=9]="localName",e[e.methodName=10]="methodName",e[e.moduleName=11]="moduleName",e[e.operator=12]="operator",e[e.parameterName=13]="parameterName",e[e.propertyName=14]="propertyName",e[e.punctuation=15]="punctuation",e[e.space=16]="space",e[e.text=17]="text",e[e.typeParameterName=18]="typeParameterName",e[e.enumMemberName=19]="enumMemberName",e[e.functionName=20]="functionName",e[e.regularExpressionLiteral=21]="regularExpressionLiteral"}(e.SymbolDisplayPartKind||(e.SymbolDisplayPartKind={})),function(e){e[e.JavaScript=0]="JavaScript",e[e.SourceMap=1]="SourceMap",e[e.Declaration=2]="Declaration"}(e.OutputFileType||(e.OutputFileType={})),function(e){e[e.None=0]="None",e[e.InMultiLineCommentTrivia=1]="InMultiLineCommentTrivia",e[e.InSingleQuoteStringLiteral=2]="InSingleQuoteStringLiteral",e[e.InDoubleQuoteStringLiteral=3]="InDoubleQuoteStringLiteral",e[e.InTemplateHeadOrNoSubstitutionTemplate=4]="InTemplateHeadOrNoSubstitutionTemplate",e[e.InTemplateMiddleOrTail=5]="InTemplateMiddleOrTail",e[e.InTemplateSubstitutionPosition=6]="InTemplateSubstitutionPosition"}(e.EndOfLineState||(e.EndOfLineState={})),function(e){e[e.Punctuation=0]="Punctuation",e[e.Keyword=1]="Keyword",e[e.Operator=2]="Operator",e[e.Comment=3]="Comment",e[e.Whitespace=4]="Whitespace",e[e.Identifier=5]="Identifier",e[e.NumberLiteral=6]="NumberLiteral",e[e.StringLiteral=7]="StringLiteral",e[e.RegExpLiteral=8]="RegExpLiteral"}(e.TokenClass||(e.TokenClass={})),function(e){e.unknown="",e.warning="warning",e.keyword="keyword",e.scriptElement="script",e.moduleElement="module",e.classElement="class",e.localClassElement="local class",e.interfaceElement="interface",e.typeElement="type",e.enumElement="enum",e.enumMemberElement="enum member",e.variableElement="var",e.localVariableElement="local var",e.functionElement="function",e.localFunctionElement="local function",e.memberFunctionElement="method",e.memberGetAccessorElement="getter",e.memberSetAccessorElement="setter",e.memberVariableElement="property",e.constructorImplementationElement="constructor",e.callSignatureElement="call",e.indexSignatureElement="index",e.constructSignatureElement="construct",e.parameterElement="parameter",e.typeParameterElement="type parameter",e.primitiveType="primitive type",e.label="label",e.alias="alias",e.constElement="const",e.letElement="let",e.directory="directory",e.externalModuleName="external module name",e.jsxAttribute="JSX attribute"}(e.ScriptElementKind||(e.ScriptElementKind={})),function(e){e.none="",e.publicMemberModifier="public",e.privateMemberModifier="private",e.protectedMemberModifier="protected",e.exportedModifier="export",e.ambientModifier="declare",e.staticModifier="static",e.abstractModifier="abstract"}(e.ScriptElementKindModifier||(e.ScriptElementKindModifier={})),function(e){e.comment="comment",e.identifier="identifier",e.keyword="keyword",e.numericLiteral="number",e.operator="operator",e.stringLiteral="string",e.whiteSpace="whitespace",e.text="text",e.punctuation="punctuation",e.className="class name",e.enumName="enum name",e.interfaceName="interface name",e.moduleName="module name",e.typeParameterName="type parameter name",e.typeAliasName="type alias name",e.parameterName="parameter name",e.docCommentTagName="doc comment tag name",e.jsxOpenTagName="jsx open tag name",e.jsxCloseTagName="jsx close tag name",e.jsxSelfClosingTagName="jsx self closing tag name",e.jsxAttribute="jsx attribute",e.jsxText="jsx text",e.jsxAttributeStringLiteralValue="jsx attribute string literal value"}(e.ClassificationTypeNames||(e.ClassificationTypeNames={})),function(e){e[e.comment=1]="comment",e[e.identifier=2]="identifier",e[e.keyword=3]="keyword",e[e.numericLiteral=4]="numericLiteral",e[e.operator=5]="operator",e[e.stringLiteral=6]="stringLiteral",e[e.regularExpressionLiteral=7]="regularExpressionLiteral",e[e.whiteSpace=8]="whiteSpace",e[e.text=9]="text",e[e.punctuation=10]="punctuation",e[e.className=11]="className",e[e.enumName=12]="enumName",e[e.interfaceName=13]="interfaceName",e[e.moduleName=14]="moduleName",e[e.typeParameterName=15]="typeParameterName",e[e.typeAliasName=16]="typeAliasName",e[e.parameterName=17]="parameterName",e[e.docCommentTagName=18]="docCommentTagName",e[e.jsxOpenTagName=19]="jsxOpenTagName",e[e.jsxCloseTagName=20]="jsxCloseTagName",e[e.jsxSelfClosingTagName=21]="jsxSelfClosingTagName",e[e.jsxAttribute=22]="jsxAttribute",e[e.jsxText=23]="jsxText",e[e.jsxAttributeStringLiteralValue=24]="jsxAttributeStringLiteralValue"}(e.ClassificationType||(e.ClassificationType={}))}(ts||(ts={})),function(e){function t(t){switch(t.kind){case 146:case 226:case 176:case 149:case 148:case 261:case 262:case 151:case 150:case 152:case 153:case 154:case 228:case 186:case 187:case 260:case 253:return 1;case 145:case 230:case 231:case 163:return 2;case 283:return void 0===t.name?3:2;case 264:case 229:return 3;case 233:return e.isAmbientModule(t)||1===e.getModuleInstanceState(t)?5:4;case 232:case 241:case 242:case 237:case 238:case 243:case 244:return 7;case 265:return 5}return 7}function n(t){for(;143===t.parent.kind;)t=t.parent;return e.isInternalModuleImportEqualsDeclaration(t.parent)&&t.parent.moduleReference===t}function r(e,t){var n=i(e);return n&&n.parent&&n.parent.kind===t&&n.parent.expression===n}function i(e){return o(e)?e.parent:e}function a(e){return 71===e.kind&&(218===e.parent.kind||217===e.parent.kind)&&e.parent.label===e}function o(e){return e&&e.parent&&179===e.parent.kind&&e.parent.name===e}e.scanner=e.createScanner(5,!0),function(e){e[e.None=0]="None",e[e.Value=1]="Value",e[e.Type=2]="Type",e[e.Namespace=4]="Namespace",e[e.All=7]="All"}(e.SemanticMeaning||(e.SemanticMeaning={})),e.getMeaningFromDeclaration=t,e.getMeaningFromLocation=function(r){return 265===r.kind?1:243===r.parent.kind?7:n(r)?function(t){if(e.Debug.assert(71===t.kind),143===t.parent.kind&&t.parent.right===t&&237===t.parent.parent.kind)return 7;return 4}(r):e.isDeclarationName(r)?t(r.parent):function(t){e.isRightSideOfQualifiedNameOrPropertyAccess(t)&&(t=t.parent);switch(t.kind){case 99:return!e.isPartOfExpression(t);case 169:return!0}switch(t.parent.kind){case 159:return!0;case 201:return!e.isExpressionWithTypeArgumentsInClassExtendsClause(t.parent)}return!1}(r)?2:function(e){return function(e){var t=e,n=!0;if(143===t.parent.kind){for(;t.parent&&143===t.parent.kind;)t=t.parent;n=t.right===e}return 159===t.parent.kind&&!n}(e)||function(e){var t=e,n=!0;if(179===t.parent.kind){for(;t.parent&&179===t.parent.kind;)t=t.parent;n=t.name===e}if(!n&&201===t.parent.kind&&259===t.parent.parent.kind){var r=t.parent.parent.parent;return 229===r.kind&&108===t.parent.parent.token||230===r.kind&&85===t.parent.parent.token}return!1}(e)}(r)?4:e.isTypeParameterDeclaration(r.parent)?(e.Debug.assert(e.isJSDocTemplateTag(r.parent.parent)),2):1},e.isInRightSideOfInternalImportEqualsDeclaration=n,e.isCallExpressionTarget=function(e){return r(e,181)},e.isNewExpressionTarget=function(e){return r(e,182)},e.climbPastPropertyAccess=i,e.getTargetLabel=function(e,t){for(;e;){if(222===e.kind&&e.label.escapedText===t)return e.label;e=e.parent}},e.isJumpStatementTarget=a,e.isLabelName=function(e){return function(e){return 71===e.kind&&222===e.parent.kind&&e.parent.label===e}(e)||a(e)},e.isRightSideOfQualifiedName=function(e){return 143===e.parent.kind&&e.parent.right===e},e.isRightSideOfPropertyAccess=o,e.isNameOfModuleDeclaration=function(e){return 233===e.parent.kind&&e.parent.name===e},e.isNameOfFunctionDeclaration=function(t){return 71===t.kind&&e.isFunctionLike(t.parent)&&t.parent.name===t},e.isLiteralNameOfPropertyDeclarationOrIndexAccess=function(t){switch(t.parent.kind){case 149:case 148:case 261:case 264:case 151:case 150:case 153:case 154:case 233:return e.getNameOfDeclaration(t.parent)===t;case 180:return t.parent.argumentExpression===t;case 144:return!0;case 173:return 171===t.parent.parent.kind}},e.isExpressionOfExternalModuleImportEqualsDeclaration=function(t){return e.isExternalModuleImportEqualsDeclaration(t.parent.parent)&&e.getExternalModuleImportEqualsDeclarationExpression(t.parent.parent)===t},e.getContainerNode=function(e){for(283===e.kind&&(e=e.parent.parent);;){if(!(e=e.parent))return;switch(e.kind){case 265:case 151:case 150:case 228:case 186:case 153:case 154:case 229:case 230:case 232:case 233:return e}}},e.getNodeKind=function t(n){switch(n.kind){case 265:return e.isExternalModule(n)?"module":"script";case 233:return"module";case 229:case 199:return"class";case 230:return"interface";case 231:return"type";case 232:return"enum";case 226:return o(n);case 176:return o(e.getRootDeclaration(n));case 187:case 228:case 186:return"function";case 153:return"getter";case 154:return"setter";case 151:case 150:return"method";case 149:case 148:return"property";case 157:return"index";case 156:return"construct";case 155:return"call";case 152:return"constructor";case 145:return"type parameter";case 264:return"enum member";case 146:return e.hasModifier(n,92)?"property":"parameter";case 237:case 242:case 239:case 246:case 240:return"alias";case 283:return"type";case 194:var r=e.getSpecialPropertyAssignmentKind(n),i=n.right;switch(r){case 0:return"";case 1:case 2:var a=t(i);return""===a?"const":a;case 3:return"method";case 4:return"property";case 5:return e.isFunctionExpression(i)?"method":"property";default:return e.assertTypeIsNever(r),""}default:return""}function o(t){return e.isConst(t)?"const":e.isLet(t)?"let":"var"}},e.isThis=function(t){switch(t.kind){case 99:return!0;case 71:return e.identifierIsThisKeyword(t)&&146===t.parent.kind;default:return!1}};var s=/^\/\/\/\s*</;function c(e,t,n){return e<=n.pos&&t>=n.end}function u(e,t,n,r){return Math.max(e,n)<Math.min(t,r)}function _(t,n){if(e.nodeIsMissing(t))return!1;switch(t.kind){case 229:case 230:case 232:case 178:case 174:case 163:case 207:case 234:case 235:case 241:case 245:return l(t,18,n);case 260:return _(t.block,n);case 182:if(!t.arguments)return!0;case 181:case 185:case 168:return l(t,20,n);case 160:case 161:return _(t.type,n);case 152:case 153:case 154:case 228:case 186:case 151:case 150:case 156:case 155:case 187:return t.body?_(t.body,n):t.type?_(t.type,n):d(t,20,n);case 233:return t.body&&_(t.body,n);case 211:return t.elseStatement?_(t.elseStatement,n):_(t.thenStatement,n);case 210:return _(t.expression,n)||d(t,25);case 177:case 175:case 180:case 144:case 165:return l(t,22,n);case 157:return t.type?_(t.type,n):d(t,22,n);case 257:case 258:return!1;case 214:case 215:case 216:case 213:return _(t.statement,n);case 212:return p(t,106,n)?l(t,20,n):_(t.statement,n);case 162:return _(t.exprName,n);case 189:case 188:case 190:case 197:case 198:return _(t.expression,n);case 183:return _(t.template,n);case 196:return _(e.lastOrUndefined(t.templateSpans),n);case 205:return e.nodeIsPresent(t.literal);case 244:case 238:return e.nodeIsPresent(t.moduleSpecifier);case 192:return _(t.operand,n);case 194:return _(t.right,n);case 195:return _(t.whenFalse,n);default:return!0}}function l(t,n,r){var i=t.getChildren(r);if(i.length){var a=e.lastOrUndefined(i);if(a.kind===n)return!0;if(25===a.kind&&1!==i.length)return i[i.length-2].kind===n}return!1}function d(e,t,n){return!!p(e,t,n)}function p(t,n,r){return e.forEach(t.getChildren(r),(function(e){return e.kind===n&&e}))}function f(t){var n=e.forEach(t.parent.getChildren(),(function(n){if(e.isSyntaxList(n)&&n.pos<=t.pos&&n.end>=t.end)return n}));return e.Debug.assert(!n||e.contains(n.getChildren(),t)),n}function m(e,t,n,r){return y(e,t,!1,r,!1,n)}function g(e,t,n,r){return y(e,t,!0,void 0,r,n)}function y(t,n,r,i,a,o){var s=t;e:for(;;){if(e.isToken(s))return s;for(var c=0,u=s.getChildren();c<u.length;c++){var _=u[c];if(o||!e.isJSDocNode(_)){if((r?_.getFullStart():_.getStart(t,o))>n)break;var l=_.getEnd();if(n<l||n===l&&(1===_.kind||a)){s=_;continue e}if(i&&l===n){var d=h(n,t,_);if(d&&i(d))return d}}}return s}}function h(t,n,r,i){var a=function a(c){if(e.isToken(c))return c;for(var u=c.getChildren(),_=0;_<u.length;_++){var l=u[_];if(t<l.end)return l.getStart(n,i)>=t||!x(l)||v(l)?(d=s(u,_))&&o(d):a(l)}if(e.Debug.assert(void 0!==r||265===c.kind||e.isJSDocCommentContainingNode(c)),u.length){var d;return(d=s(u,u.length))&&o(d)}}(r||n);return e.Debug.assert(!(a&&v(a))),a;function o(t){if(e.isToken(t))return t;var n=t.getChildren(),r=s(n,n.length);return r&&o(r)}function s(t,n){for(var r=n-1;r>=0;r--){if(v(t[r]))e.Debug.assert(r>0,"`JsxText` tokens should not be the first child of `JsxElement | JsxSelfClosingElement`");else if(x(t[r]))return t[r]}}}function v(t){return e.isJsxText(t)&&t.containsOnlyWhiteSpaces}function b(t,n,r,i){return!!e.formatting.getRangeOfEnclosingComment(t,n,!1,void 0,r,i)}function x(e){return 0!==e.getWidth()}function k(t){return 71===t||e.isKeyword(t)}e.getLineStartPositionForPosition=function(t,n){return e.getLineStarts(n)[n.getLineAndCharacterOfPosition(t).line]},e.rangeContainsRange=function(e,t){return c(e.pos,e.end,t)},e.startEndContainsRange=c,e.rangeContainsStartEnd=function(e,t,n){return e.pos<=t&&e.end>=n},e.rangeOverlapsWithStartEnd=function(e,t,n){return u(e.pos,e.end,t,n)},e.startEndOverlapsWithStartEnd=u,e.positionBelongsToNode=function(e,t,n){return t<e.end||!_(e,n)},e.isCompletedNode=_,e.findListItemInfo=function(t){var n=f(t);if(n){var r=n.getChildren();return{listItemIndex:e.indexOfNode(r,t),list:n}}},e.hasChildOfKind=d,e.findChildOfKind=p,e.findContainingList=f,e.getTouchingWord=function(e,t,n){return m(e,t,n,(function(e){return k(e.kind)}))},e.getTouchingPropertyName=function(e,t,n){return m(e,t,n,(function(e){return 9===(t=e.kind)||8===t||k(t);var t}))},e.getTouchingToken=m,e.getTokenAtPosition=g,e.findTokenOnLeftOfPosition=function(t,n){var r=g(t,n,!1);return e.isToken(r)&&n>r.getStart(t)&&n<r.getEnd()?r:h(n,t)},e.findNextToken=function(t,n){return function n(r){if(e.isToken(r)&&r.pos===t.end)return r;for(var i=r.getChildren(),a=0,o=i;a<o.length;a++){var s=o[a];if((s.pos<=t.pos&&s.end>t.end||s.pos===t.end)&&x(s))return n(s)}return}(n)},e.findPrecedingToken=h,e.isInString=function(t,n){var r=h(n,t);if(r&&e.isStringTextContainingNode(r)){var i=r.getStart(),a=r.getEnd();if(i<n&&n<a)return!0;if(n===a)return!!r.isUnterminated}return!1},e.isInsideJsxElementOrAttribute=function(e,t){var n=g(e,t,!1);return!!n&&(10===n.kind||(27===n.kind&&10===n.parent.kind||(27===n.kind&&256===n.parent.kind||(!(!n||18!==n.kind||256!==n.parent.kind)||27===n.kind&&252===n.parent.kind))))},e.isWhiteSpaceOnlyJsxText=v,e.isInTemplateString=function(t,n){var r=g(t,n,!1);return e.isTemplateLiteralKind(r.kind)&&n>r.getStart(t)},e.isInComment=b,e.hasDocComment=function(t,n){var r=g(t,n,!1),i=e.getLeadingCommentRanges(t.text,r.pos);return e.forEach(i,(function(e){var n=t.text;return n.length>=e.pos+3&&"/"===n[e.pos]&&"*"===n[e.pos+1]&&"*"===n[e.pos+2]}))},e.getNodeModifiers=function(t){var n=e.getCombinedModifierFlags(t),r=[];return 8&n&&r.push("private"),16&n&&r.push("protected"),4&n&&r.push("public"),32&n&&r.push("static"),128&n&&r.push("abstract"),1&n&&r.push("export"),e.isInAmbientContext(t)&&r.push("declare"),r.length>0?r.join(","):""},e.getTypeArgumentOrTypeParameterList=function(t){return 159===t.kind||181===t.kind?t.typeArguments:e.isFunctionLike(t)||229===t.kind||230===t.kind?t.typeParameters:void 0},e.isWord=k,e.isComment=function(e){return 2===e||3===e},e.isStringOrRegularExpressionOrTemplateLiteral=function(t){return!(9!==t&&12!==t&&!e.isTemplateLiteralKind(t))},e.isPunctuation=function(e){return 17<=e&&e<=70},e.isInsideTemplateLiteral=function(t,n){return e.isTemplateLiteralKind(t.kind)&&t.getStart()<n&&n<t.getEnd()||!!t.isUnterminated&&n===t.getEnd()},e.isAccessibilityModifier=function(e){switch(e){case 114:case 112:case 113:return!0}return!1},e.cloneCompilerOptions=function(t){var n=e.clone(t);return e.setConfigFileInOptions(n,t&&t.configFile),n},e.isArrayLiteralOrObjectLiteralDestructuringPattern=function e(t){if(177===t.kind||178===t.kind){if(194===t.parent.kind&&t.parent.left===t&&58===t.parent.operatorToken.kind)return!0;if(216===t.parent.kind&&t.parent.initializer===t)return!0;if(e(261===t.parent.kind?t.parent.parent:t.parent))return!0}return!1},e.hasTrailingDirectorySeparator=function(e){var t=e.charAt(e.length-1);return"/"===t||"\\"===t},e.isInReferenceComment=function(e,t){return b(e,t,void 0,(function(t){var n=e.text.substring(t.pos,t.end);return s.test(n)}))},e.isInNonReferenceComment=function(e,t){return b(e,t,void 0,(function(t){var n=e.text.substring(t.pos,t.end);return!s.test(n)}))},e.createTextSpanFromNode=function(t,n){return e.createTextSpanFromBounds(t.getStart(n),t.getEnd())},e.createTextSpanFromRange=function(t){return e.createTextSpanFromBounds(t.pos,t.end)},e.isTypeKeyword=function(e){switch(e){case 119:case 122:case 130:case 133:case 134:case 136:case 137:case 105:return!0;default:return!1}},e.isExternalModuleSymbol=function(t){return e.Debug.assert(!!(1536&t.flags)),34===t.name.charCodeAt(0)},e.nodeSeenTracker=function(){var t=[];return function(n){var r=e.getNodeId(n);return!t[r]&&(t[r]=!0)}}}(ts||(ts={})),function(e){function t(e){return e.declarations&&e.declarations.length>0&&146===e.declarations[0].kind}e.isFirstDeclarationOfSymbolParameter=t;var n=function(){var t,n,a;return u(),{displayParts:function(){return t},writeKeyword:function(t){return c(t,e.SymbolDisplayPartKind.keyword)},writeOperator:function(t){return c(t,e.SymbolDisplayPartKind.operator)},writePunctuation:function(t){return c(t,e.SymbolDisplayPartKind.punctuation)},writeSpace:function(t){return c(t,e.SymbolDisplayPartKind.space)},writeStringLiteral:function(t){return c(t,e.SymbolDisplayPartKind.stringLiteral)},writeParameter:function(t){return c(t,e.SymbolDisplayPartKind.parameterName)},writeProperty:function(t){return c(t,e.SymbolDisplayPartKind.propertyName)},writeSymbol:function(e,n){o(),t.push(r(e,n))},writeLine:function(){t.push(s()),n=!0},increaseIndent:function(){a++},decreaseIndent:function(){a--},clear:u,trackSymbol:e.noop,reportInaccessibleThisError:e.noop,reportPrivateInBaseOfClassExpression:e.noop};function o(){if(n){var r=e.getIndentString(a);r&&t.push(i(r,e.SymbolDisplayPartKind.space)),n=!1}}function c(e,n){o(),t.push(i(e,n))}function u(){t=[],n=!0,a=0}}();function r(n,r){return i(n,function(n){var r=n.flags;if(3&r)return t(n)?e.SymbolDisplayPartKind.parameterName:e.SymbolDisplayPartKind.localName;if(4&r)return e.SymbolDisplayPartKind.propertyName;if(32768&r)return e.SymbolDisplayPartKind.propertyName;if(65536&r)return e.SymbolDisplayPartKind.propertyName;if(8&r)return e.SymbolDisplayPartKind.enumMemberName;if(16&r)return e.SymbolDisplayPartKind.functionName;if(32&r)return e.SymbolDisplayPartKind.className;if(64&r)return e.SymbolDisplayPartKind.interfaceName;if(384&r)return e.SymbolDisplayPartKind.enumName;if(1536&r)return e.SymbolDisplayPartKind.moduleName;if(8192&r)return e.SymbolDisplayPartKind.methodName;if(262144&r)return e.SymbolDisplayPartKind.typeParameterName;if(524288&r)return e.SymbolDisplayPartKind.aliasName;if(2097152&r)return e.SymbolDisplayPartKind.aliasName;return e.SymbolDisplayPartKind.text}(r))}function i(t,n){return{text:t,kind:e.SymbolDisplayPartKind[n]}}function a(t){return i(e.tokenToString(t),e.SymbolDisplayPartKind.keyword)}function o(t){return i(t,e.SymbolDisplayPartKind.text)}e.symbolPart=r,e.displayPart=i,e.spacePart=function(){return i(" ",e.SymbolDisplayPartKind.space)},e.keywordPart=a,e.punctuationPart=function(t){return i(e.tokenToString(t),e.SymbolDisplayPartKind.punctuation)},e.operatorPart=function(t){return i(e.tokenToString(t),e.SymbolDisplayPartKind.operator)},e.textOrKeywordPart=function(t){var n=e.stringToToken(t);return void 0===n?o(t):a(n)},e.textPart=o;function s(){return i("\n",e.SymbolDisplayPartKind.lineBreak)}function c(e){try{return e(n),n.displayParts()}finally{n.clear()}}function u(e){return e.parent&&(242===e.parent.kind||246===e.parent.kind)&&e.parent.propertyName===e}function _(t,n){return e.ensureScriptKind(t,n&&n.getScriptKind&&n.getScriptKind(t))}e.getNewLineOrDefaultFromHost=function(e){return e.getNewLine?e.getNewLine():"\r\n"},e.lineBreakPart=s,e.mapToDisplayParts=c,e.typeToDisplayParts=function(e,t,n,r){return c((function(i){e.getSymbolDisplayBuilder().buildTypeDisplay(t,i,n,r)}))},e.symbolToDisplayParts=function(e,t,n,r,i){return c((function(a){e.getSymbolDisplayBuilder().buildSymbolDisplay(t,a,n,r,i)}))},e.signatureToDisplayParts=function(e,t,n,r){return r|=65536,c((function(i){e.getSymbolDisplayBuilder().buildSignatureDisplay(t,i,n,r)}))},e.getDeclaredName=function(t,n,r){if(u(r)||e.isStringOrNumericLiteral(r)&&144===r.parent.kind)return e.getTextOfIdentifierOrLiteral(r);var i=e.getLocalSymbolForExportDefault(n);return t.symbolToString(i||n)},e.isImportOrExportSpecifierName=u,e.stripQuotes=function(t){var n=t.length;return n>=2&&t.charCodeAt(0)===t.charCodeAt(n-1)&&e.isSingleOrDoubleQuote(t.charCodeAt(0))?t.substring(1,n-1):t},e.scriptKindIs=function(t,n){for(var r=[],i=2;i<arguments.length;i++)r[i-2]=arguments[i];var a=_(t,n);return e.forEach(r,(function(e){return e===a}))},e.getScriptKind=_,e.getUniqueSymbolId=function(t,n){return e.getSymbolId(e.skipAlias(t,n))},e.getFirstNonSpaceCharacterPosition=function(t,n){for(;e.isWhiteSpaceLike(t.charCodeAt(n));)n+=1;return n},e.getOpenBrace=function(e,t){return e.body.getFirstToken(t)},e.getOpenBraceOfClassLike=function(t,n){return e.getTokenAtPosition(n,t.members.pos-1,!1)},e.getSourceFileImportLocation=function(t){var n=t.text,r=e.getLeadingCommentRanges(n,0);if(!r)return 0;var i=0;r.length&&3===r[0].kind&&e.isPinnedComment(n,r[0])&&(i=r[0].end+1,r=r.slice(1));for(var a=0,o=r;a<o.length;a++){var s=o[a];if(2!==s.kind||!e.isRecognizedTripleSlashComment(t.text,s.pos,s.end))break;i=s.end+1}return i},e.getSynthesizedDeepClone=function t(n){if(void 0!==n){var r=e.visitEachChild(n,t,e.nullTransformationContext);if(r===n){var i=e.getSynthesizedClone(n);return e.isStringLiteral(i)?i.textSourceNode=n:e.isNumericLiteral(i)&&(i.numericLiteralFlags=n.numericLiteralFlags),i.pos=n.pos,i.end=n.end,i}return r.parent=void 0,r}},e.suppressLeadingAndTrailingTrivia=function(t){e.Debug.assert(void 0!==t),function t(n){e.addEmitFlags(n,512);var r=e.forEachChild(n,(function(e){return e}));r&&t(r)}(t),function t(n){e.addEmitFlags(n,1024);var r=void 0;e.forEachChild(n,(function(e){r=e}),(function(t){t.length&&(r=e.last(t))})),r&&t(r)}(t)}}(ts||(ts={})),function(e){function t(e,t){switch(t){case 233:case 229:case 230:case 228:e.throwIfCancellationRequested()}}function n(n,r,i,a,o){var s=[];return function i(c){if(c&&e.textSpanIntersectsWith(o,c.getFullStart(),c.getFullWidth())){var u=c.kind;if(t(r,u),71===u&&!e.nodeIsMissing(c)){var _=c;if(a.has(_.escapedText)){var l=n.getSymbolAtLocation(c);if(l){var d=function(t,n){var r=t.getFlags();if(0==(788448&r))return;if(32&r)return 11;if(384&r)return 12;if(524288&r)return 16;if(2&n){if(64&r)return 13;if(262144&r)return 15}else if(1536&r&&(4&n||1&n&&i(t)))return 14;return;function i(t){return e.forEach(t.declarations,(function(t){return 233===t.kind&&1===e.getModuleInstanceState(t)}))}}(l,e.getMeaningFromLocation(c));d&&function(e,t,n){s.push(e),s.push(t),s.push(n)}(c.getStart(),c.getWidth(),d)}}}e.forEachChild(c,i)}}(i),{spans:s,endOfLineState:0}}function r(e){switch(e){case 1:return"comment";case 2:return"identifier";case 3:return"keyword";case 4:return"number";case 5:return"operator";case 6:return"string";case 8:return"whitespace";case 9:return"text";case 10:return"punctuation";case 11:return"class name";case 12:return"enum name";case 13:return"interface name";case 14:return"module name";case 15:return"type parameter name";case 16:return"type alias name";case 17:return"parameter name";case 18:return"doc comment tag name";case 19:return"jsx open tag name";case 20:return"jsx close tag name";case 21:return"jsx self closing tag name";case 22:return"jsx attribute";case 23:return"jsx text";case 24:return"jsx attribute string literal value"}}function i(t){e.Debug.assert(t.spans.length%3==0);for(var n=t.spans,i=[],a=0;a<n.length;a+=3)i.push({textSpan:e.createTextSpan(n[a],n[a+1]),classificationType:r(n[a+2])});return i}function a(n,r,i){var a=i.start,o=i.length,s=e.createScanner(5,!1,r.languageVariant,r.text),c=e.createScanner(5,!1,r.languageVariant,r.text),u=[];return h(r),{spans:u,endOfLineState:0};function _(e,t,n){u.push(e),u.push(t),u.push(n)}function l(t,n,i,a){if(3===n){var o=e.parseIsolatedJSDocComment(r.text,i,a);if(o&&o.jsDoc)return o.jsDoc.parent=t,void function(e){var t=e.pos;if(e.tags)for(var n=0,r=e.tags;n<r.length;n++){var i=r[n];switch(i.pos!==t&&d(t,i.pos-t),_(i.atToken.pos,i.atToken.end-i.atToken.pos,10),_(i.tagName.pos,i.tagName.end-i.tagName.pos,18),t=i.tagName.end,i.kind){case 279:a(i);break;case 282:p(i);break;case 281:case 280:h(i.typeExpression)}t=i.end}t!==e.end&&d(t,e.end-t);return;function a(e){e.isNameFirst&&(d(t,e.name.pos-t),_(e.name.pos,e.name.end-e.name.pos,17),t=e.name.end),e.typeExpression&&(d(t,e.typeExpression.pos-t),h(e.typeExpression),t=e.typeExpression.end),e.isNameFirst||(d(t,e.name.pos-t),_(e.name.pos,e.name.end-e.name.pos,17),t=e.name.end)}}(o.jsDoc)}d(i,a)}function d(e,t){_(e,t,1)}function p(e){for(var t=0,n=e.getChildren();t<n.length;t++){h(n[t])}}function f(t,n,r){var i;for(i=n;i<r&&!e.isLineBreak(t.charCodeAt(i));i++);for(_(n,i-n,1),c.setTextPos(i);c.getTextPos()<r;)m()}function m(){var e=c.getTextPos(),t=c.scan(),n=c.getTextPos(),r=y(t);r&&_(e,n-e,r)}function g(t){if(e.isJSDoc(t))return!0;if(e.nodeIsMissing(t))return!0;var n=function(e){switch(e.parent&&e.parent.kind){case 251:if(e.parent.tagName===e)return 19;break;case 252:if(e.parent.tagName===e)return 20;break;case 250:if(e.parent.tagName===e)return 21;break;case 253:if(e.parent.name===e)return 22}return}(t);if(!e.isToken(t)&&10!==t.kind&&void 0===n)return!1;var i=10===t.kind?t.pos:function(t){for(s.setTextPos(t.pos);;){var n=s.getTextPos();if(!e.couldStartTrivia(r.text,n))return n;var i=s.scan(),a=s.getTextPos(),o=a-n;if(!e.isTrivia(i))return n;if(4!==i&&5!==i)if(e.isComment(i))l(t,i,n,o),s.setTextPos(a);else if(7===i){var c=r.text,u=c.charCodeAt(n);if(60===u||62===u){_(n,o,1);continue}e.Debug.assert(124===u||61===u),f(c,n,a)}}}(t),a=t.end-i;if(e.Debug.assert(a>=0),a>0){var o=n||y(t.kind,t);o&&_(i,a,o)}return!0}function y(t,n){if(e.isKeyword(t))return 3;if((27===t||29===t)&&n&&e.getTypeArgumentOrTypeParameterList(n.parent))return 10;if(e.isPunctuation(t)){if(n){if(58===t&&(226===n.parent.kind||149===n.parent.kind||146===n.parent.kind||253===n.parent.kind))return 5;if(194===n.parent.kind||192===n.parent.kind||193===n.parent.kind||195===n.parent.kind)return 5}return 10}if(8===t)return 4;if(9===t)return 253===n.parent.kind?24:6;if(12===t)return 6;if(e.isTemplateLiteralKind(t))return 6;if(10===t)return 23;if(71===t){if(n)switch(n.parent.kind){case 229:return n.parent.name===n?11:void 0;case 145:return n.parent.name===n?15:void 0;case 230:return n.parent.name===n?13:void 0;case 232:return n.parent.name===n?12:void 0;case 233:return n.parent.name===n?14:void 0;case 146:return n.parent.name===n?e.isThisIdentifier(n)?3:17:void 0}return 2}}function h(i){if(i&&e.decodedTextSpanIntersectsWith(a,o,i.pos,i.getFullWidth())){t(n,i.kind);for(var s=0,c=i.getChildren(r);s<c.length;s++){var u=c[s];g(u)||h(u)}}}}e.createClassifier=function(){var t=e.createScanner(5,!1),n=[];n[71]=!0,n[9]=!0,n[8]=!0,n[12]=!0,n[99]=!0,n[43]=!0,n[44]=!0,n[20]=!0,n[22]=!0,n[18]=!0,n[101]=!0,n[86]=!0;var r=[];function i(t){switch(t){case 1:return e.TokenClass.Comment;case 3:return e.TokenClass.Keyword;case 4:return e.TokenClass.NumberLiteral;case 5:return e.TokenClass.Operator;case 6:return e.TokenClass.StringLiteral;case 8:return e.TokenClass.Whitespace;case 10:return e.TokenClass.Punctuation;case 2:case 11:case 12:case 13:case 14:case 15:case 16:case 9:case 17:default:return e.TokenClass.Identifier}}function a(i,a,s){for(var c=0,u=0,_=0;r.length>0;)r.pop();switch(a){case 3:i='"\\\n'+i,c=3;break;case 2:i="'\\\n"+i,c=3;break;case 1:i="/*\n"+i,c=3;break;case 4:i="`\n"+i,c=2;break;case 5:i="}\n"+i,c=2;case 6:r.push(14)}t.setText(i);var l,d,p={endOfLineState:0,spans:[]},f=0;do{if(u=t.scan(),!e.isTrivia(u)){if(41!==u&&63!==u||n[_]){if(23===_&&o(u))u=71;else if(o(_)&&o(u)&&(l=_,d=u,e.isAccessibilityModifier(l)&&125!==d&&135!==d&&123!==d&&115!==d))u=71;else if(71===_&&27===u)f++;else if(29===u&&f>0)f--;else if(119===u||136===u||133===u||122===u||137===u)f>0&&!s&&(u=71);else if(14===u)r.push(u);else if(17===u)r.length>0&&r.push(u);else if(18===u&&r.length>0){var m=e.lastOrUndefined(r);14===m?16===(u=t.reScanTemplateToken())?r.pop():e.Debug.assertEqual(u,15,"Should have been a template middle."):(e.Debug.assertEqual(m,17,"Should have been an open brace"),r.pop())}}else 12===t.reScanSlashToken()&&(u=12);_=u}g()}while(1!==u);return p;function g(){var n=t.getTokenPos(),a=t.getTextPos();if(function(e,t,n){if(8===n)return;0===e&&c>0&&(e+=c);var r=(t-=c)-(e-=c);r>0&&(p.spans.push(e),p.spans.push(r),p.spans.push(n))}(n,a,function(t){if(o(t))return 3;if(function(e){switch(e){case 39:case 41:case 42:case 37:case 38:case 45:case 46:case 47:case 27:case 29:case 30:case 31:case 93:case 92:case 118:case 32:case 33:case 34:case 35:case 48:case 50:case 49:case 53:case 54:case 69:case 68:case 70:case 65:case 66:case 67:case 59:case 60:case 61:case 63:case 64:case 58:case 26:return!0;default:return!1}}(t)||function(e){switch(e){case 37:case 38:case 52:case 51:case 43:case 44:return!0;default:return!1}}(t))return 5;if(t>=17&&t<=70)return 10;switch(t){case 8:return 4;case 9:return 6;case 12:return 7;case 7:case 3:case 2:return 1;case 5:case 4:return 8;case 71:default:return e.isTemplateLiteralKind(t)?6:2}}(u)),a>=i.length)if(9===u){var s=t.getTokenText();if(t.isUnterminated()){for(var _=s.length-1,l=0;92===s.charCodeAt(_-l);)l++;if(1&l){var d=s.charCodeAt(0);p.endOfLineState=34===d?3:2}}}else 3===u?t.isUnterminated()&&(p.endOfLineState=1):e.isTemplateLiteralKind(u)?t.isUnterminated()&&(16===u?p.endOfLineState=5:13===u?p.endOfLineState=4:e.Debug.fail("Only 'NoSubstitutionTemplateLiteral's and 'TemplateTail's can be unterminated; got SyntaxKind #"+u)):r.length>0&&14===e.lastOrUndefined(r)&&(p.endOfLineState=6)}}function o(e){return e>=72&&e<=142}return{getClassificationsForLine:function(t,n,r){return function(t,n){for(var r=[],a=t.spans,o=0,s=0;s<a.length;s+=3){var c=a[s],u=a[s+1],_=a[s+2];if(o>=0){var l=c-o;l>0&&r.push({length:l,classification:e.TokenClass.Whitespace})}r.push({length:u,classification:i(_)}),o=c+u}var d=n.length-o;return d>0&&r.push({length:d,classification:e.TokenClass.Whitespace}),{entries:r,finalLexState:t.endOfLineState}}(a(t,n,r),t)},getEncodedLexicalClassifications:a}},e.getSemanticClassifications=function(e,t,r,a,o){return i(n(e,t,r,a,o))},e.getEncodedSemanticClassifications=n,e.getSyntacticClassifications=function(e,t,n){return i(a(e,t,n))},e.getEncodedSyntacticClassifications=a}(ts||(ts={})),function(e){!function(t){!function(t){function n(t,n,r,i,a,o,c,_){void 0===_&&(_=[]),void 0===t&&(t=""),t=e.normalizeSlashes(t),""===(t=e.getDirectoryPath(t))&&(t="."+e.directorySeparator),t=e.ensureTrailingDirectorySeparator(t);var l=u(e.isRootedDiskPath(t)?t:e.combinePaths(n,t)),f=e.getDirectoryPath(l),g=!(o.useCaseSensitiveFileNames&&o.useCaseSensitiveFileNames());if(m(o,f)){var y=p(o,f,r,void 0,["./*"]);if(y){for(var h=e.createMap(),v=0,b=y;v<b.length;v++){var x=b[v];if(x=e.normalizePath(x),!c||0!==e.comparePaths(x,c,n,g)){var k=i?e.getBaseFileName(x):e.removeFileExtension(e.getBaseFileName(x));h.get(k)||h.set(k,!0)}}e.forEachKey(h,(function(e){_.push(s(e,"script",a))}))}var S=d(o,f);if(S)for(var D=0,C=S;D<C.length;D++){var T=C[D],E=e.getBaseFileName(e.normalizePath(T));_.push(s(E,"directory",a))}}return _}function r(t,n,r,i,a){if(a.readDirectory){var o=e.hasZeroOrOneAsteriskCharacter(r)?e.tryParsePattern(r):void 0;if(o){var s=u(o.prefix),c=e.getDirectoryPath(s),_=e.getBaseFileName(s),l=e.stringContains(t,e.directorySeparator),d=l?e.combinePaths(c,_+e.getDirectoryPath(t)):c,f=e.normalizePath(o.suffix),m=e.combinePaths(n,d),g=l?m:e.ensureTrailingDirectorySeparator(m)+_,y=p(a,m,i,void 0,[f?"**/*":"./*"]);if(y){for(var h=[],v=0,b=y;v<b.length;v++){var x=b[v],k=e.normalizePath(x);if(e.endsWith(k,f)&&e.startsWith(k,g)){var S=g.length,D=k.length-S-f.length;h.push(e.removeFileExtension(k.substr(S,D)))}}return h}}}}function i(t,n,r,i,c){if(void 0===c&&(c=[]),n.types)for(var u=0,_=n.types;u<_.length;u++){var l=_[u];c.push(s(l,"external module name",i))}else if(t.getDirectories){var d=void 0;try{d=e.getEffectiveTypeRoots(n,t)}catch(e){}if(d)for(var p=0,f=d;p<f.length;p++){a(t,f[p],i,c)}}if(t.getDirectories)for(var m=0,g=o(r,t);m<g.length;m++){var y=g[m];a(t,e.combinePaths(e.getDirectoryPath(y),"node_modules/@types"),i,c)}return c}function a(t,n,r,i){if(t.getDirectories&&m(t,n)){var a=d(t,n);if(a)for(var o=0,c=a;o<c.length;o++){var u=c[o];u=e.normalizePath(u),i.push(s(e.getBaseFileName(u),"external module name",r))}}}function o(t,n){for(var r,i=[];r=e.findConfigFile(t,(function(e){return f(n,e)}),"package.json");){i.push(r),t=e.getDirectoryPath(r);var a=e.getDirectoryPath(t);if(t===a)break;t=a}return i}function s(e,t,n){return{name:e,kind:t,kindModifiers:"",sortText:e,replacementSpan:n}}function c(t,n){var r=t.lastIndexOf(e.directorySeparator),i=-1!==r?r+1:0;return{start:n+i,length:t.length-i}}function u(t){return e.hasTrailingDirectorySeparator(t)?e.ensureTrailingDirectorySeparator(e.normalizePath(t)):e.normalizePath(t)}t.getStringLiteralCompletionEntriesFromModuleNames=function(t,a,u,_){var d,f=e.normalizeSlashes(t.text),m=t.getSourceFile().path,y=e.getDirectoryPath(m),h=c(t.text,t.getStart()+1);if(function(e){if(e&&e.length>=2&&46===e.charCodeAt(0)){var t=e.length>=3&&46===e.charCodeAt(1)?2:1,n=e.charCodeAt(t);return 47===n||92===n}return!1}(f)||e.isRootedDiskPath(f)){var v=e.getSupportedExtensions(a);d=a.rootDirs?function(t,r,i,a,o,s,c,u,_){for(var l=c.project||u.getCurrentDirectory(),d=!(u.useCaseSensitiveFileNames&&u.useCaseSensitiveFileNames()),p=function(t,n,r,i){t=e.map(t,(function(t){return e.normalizePath(e.isRootedDiskPath(t)?t:e.combinePaths(n,t))}));var a=e.forEach(t,(function(t){return e.containsPath(t,r,n,i)?r.substr(t.length):void 0}));return e.deduplicate(e.map(t,(function(t){return e.combinePaths(t,a)})))}(t,l,i,d),f=[],m=0,g=p;m<g.length;m++){n(r,g[m],a,o,s,u,_,f)}return f}(a.rootDirs,f,y,v,!1,h,a,u,m):n(f,y,v,!1,h,u,m)}else d=function(t,a,c,u,_,d){var f,m=u.baseUrl,y=u.paths;if(m){var h=e.getSupportedExtensions(u),v=u.project||_.getCurrentDirectory(),b=e.isRootedDiskPath(m)?m:e.combinePaths(v,m);if(f=n(t,e.normalizePath(b),h,!1,c,_),y)for(var x in y)if(y.hasOwnProperty(x))if("*"===x){if(y[x])for(var k=0,S=y[x];k<S.length;k++)for(var D=0,C=r(t,m,S[k],h,_);D<C.length;D++){var T=C[D];f.push(s(T,"external module name",c))}}else if(e.startsWith(x,t)){y[x]&&1===y[x].length&&y[x][0]&&f.push(s(x,"external module name",c))}}else f=[];i(_,u,a,c,f);for(var E=0,N=function(t,n,r,i,a){var s=e.stringContains(t,e.directorySeparator),c=s?t.substr(0,t.lastIndexOf(e.directorySeparator)):void 0,u=e.map(i.getAmbientModules(),(function(t){return e.stripQuotes(t.name)})),_=e.filter(u,(function(n){return e.startsWith(n,t)}));if(s){var d=e.ensureTrailingDirectorySeparator(c);_=e.map(_,(function(t){return e.removePrefix(t,d)}))}if(!r.moduleResolution||r.moduleResolution===e.ModuleResolutionKind.NodeJs)for(var f=0,m=function(t,n){var r=[];if(t.readFile&&t.fileExists)for(var i=0,a=o(n,t);i<a.length;i++){var s=a[i],c=v(s);if(!c)return;for(var u=e.combinePaths(e.getDirectoryPath(s),"node_modules"),_=[],d=0,p=l;d<p.length;d++){b(c[p[d]],_)}for(var f=0,m=_;f<m.length;f++){var y=m[f],h=e.combinePaths(u,y);r.push({moduleName:y,moduleDir:h})}}return r;function v(e){try{var n=function(e,t){return g(e,e.readFile,t)}(t,e);return n?JSON.parse(n):void 0}catch(e){return}}function b(t,n){if(t)for(var r in t)t.hasOwnProperty(r)&&!e.startsWith(r,"@types/")&&n.push(r)}}(a,n);f<m.length;f++){var y=m[f];if(s){if(e.startsWith(y.moduleName,c)){var h=p(a,y.moduleDir,e.supportedTypeScriptExtensions,void 0,["./*"]);if(h)for(var v=0,b=h;v<b.length;v++){var x=b[v];x=e.normalizePath(x);var k=e.removeFileExtension(e.getBaseFileName(x));_.push(k)}}}else _.push(y.moduleName)}return e.deduplicate(_)}(t,a,u,d,_);E<N.length;E++){var A=N[E];f.push(s(A,"external module name",c))}return f}(f,y,h,a,u,_);return{isGlobalCompletion:!1,isMemberCompletion:!1,isNewIdentifierLocation:!0,entries:d}},t.getTripleSlashReferenceCompletion=function(t,r,a,o){var s=e.getTokenAtPosition(t,r,!1);if(s){var u=e.getLeadingCommentRanges(t.text,s.pos);if(u&&u.length){var l=e.forEach(u,(function(e){return r>=e.pos&&r<=e.end&&e}));if(l){var d={isGlobalCompletion:!1,isMemberCompletion:!1,isNewIdentifierLocation:!0,entries:[]},p=t.text.substr(l.pos,r-l.pos),f=_.exec(p);if(f){var m=f[1],g=f[2],y=f[3],h=e.getDirectoryPath(t.path);if("path"===g){var v=c(y,l.pos+m.length);d.entries=n(y,h,e.getSupportedExtensions(a),!0,v,o,t.path)}else{var b={start:l.pos+m.length,length:f[0].length-m.length};d.entries=i(o,a,h,b)}}return d}}}};var _=/^(\/\/\/\s*<reference\s+(path|types)\s*=\s*(?:'|"))([^\3"]*)$/,l=["dependencies","devDependencies","peerDependencies","optionalDependencies"];function d(e,t){return g(e,e.getDirectories,t)}function p(e,t,n,r,i){return g(e,e.readDirectory,t,n,r,i)}function f(e,t){return g(e,e.fileExists,t)}function m(t,n){try{return e.directoryProbablyExists(n,t)}catch(e){}}function g(e,t){for(var n=[],r=2;r<arguments.length;r++)n[r-2]=arguments[r];try{return t&&t.apply(e,n)}catch(e){}}}(t.PathCompletions||(t.PathCompletions={}))}(e.Completions||(e.Completions={}))}(ts||(ts={})),function(e){!function(t){var n;function r(t,n,r,a,o,s,c){var u=_(t,o,r,s);if(u)return{name:u,kind:e.SymbolDisplay.getSymbolKind(a,t,n),kindModifiers:e.SymbolDisplay.getSymbolModifiers(t),sortText:"0",source:i(c),hasAction:void 0!==c||void 0}}function i(t){return t&&e.stripQuotes(t.moduleSymbol.name)}function a(t,n,i,a,o,s,c,u,_){var l=e.timestamp(),d=e.createMap();if(t)for(var p=0,f=t;p<f.length;p++){var m=f[p],g=_?_[e.getSymbolId(m)]:void 0,y=r(m,i,a,o,s,u,g);if(y){var h=y.name;d.has(h)||(g||void 0===m.parent&&!e.some(m.declarations,(function(e){return e.getSourceFile()===i.getSourceFile()}))||d.set(h,!0),n.push(y))}}return c("getCompletionsAtPosition: getCompletionEntriesFromSymbols: "+(e.timestamp()-l)),d}function o(e,t){if(e){var n=[];if(s(e,n,t),n.length)return{isGlobalCompletion:!1,isMemberCompletion:!1,isNewIdentifierLocation:!1,entries:n}}}function s(t,n,r,i){if(void 0===i&&(i=e.createMap()),t&&16384&t.flags&&(t=r.getBaseConstraintOfType(t)),t)if(65536&t.flags)for(var a=0,o=t.types;a<o.length;a++){s(o[a],n,r,i)}else if(32&t.flags&&!(256&t.flags)){var c=t.value;i.has(c)||(i.set(c,!0),n.push({name:c,kindModifiers:"",kind:"var",sortText:"0"}))}}function c(t,n,r,a,o,s,c){var l=s.name,d=s.source,p=u(t,n,a,o,c);if(p){var f=p.symbols,m=p.location,g=p.allowStringLiteral,y=p.symbolToOriginInfoMap,h=e.find(f,(function(t){return _(t,r.target,!1,g)===l&&i(y[e.getSymbolId(t)])===d}));return h&&{symbol:h,location:m,symbolToOriginInfoMap:y}}}function u(t,n,r,i,a){var o,s=e.isSourceFileJavaScript(r),c=e.timestamp(),u=e.getTokenAtPosition(r,i,!1);n("getCompletionData: Get current token: "+(e.timestamp()-c)),c=e.timestamp();var _=e.isInComment(r,i,u);n("getCompletionData: Is inside comment: "+(e.timestamp()-c));var l=!1;if(_){if(e.hasDocComment(r,i))if(64===r.text.charCodeAt(i-1))o={kind:"JsDocTagName"};else{var d=e.getLineStartPositionForPosition(i,r);r.text.substring(d,i).match(/[^\*|\s|(/\*\*)]/)||(o={kind:"JsDocTag"})}var p=function(t,n){var r=function(t){if(!e.isToken(t))return t;switch(t.kind){case 104:case 110:case 76:return t.parent.parent;default:return t.parent}}(t).jsDoc;if(!r)return;for(var i=0,a=r;i<a.length;i++){var o=a[i],s=o.pos,c=o.end,u=o.tags;if(!(!u||n<s||n>c))for(var _=u.length-1;_>=0;_--){var l=u[_];if(n>=l.pos)return l}}}(u,i);if(p&&(p.tagName.pos<=i&&i<=p.tagName.end&&(o={kind:"JsDocTagName"}),function(e){switch(e.kind){case 279:case 284:case 280:case 281:case 283:return!0}}(p)&&p.typeExpression&&267===p.typeExpression.kind&&((u=e.getTokenAtPosition(r,i,!0))&&(e.isDeclarationName(u)||284===u.parent.kind&&u.parent.name===u)||(l=q(p.typeExpression))),e.isJSDocParameterTag(p)&&(e.nodeIsMissing(p.name)||p.name.pos<=i&&i<=p.name.end)&&(o={kind:"JsDocParameterName",tag:p})),o)return{symbols:void 0,isGlobalCompletion:!1,isMemberCompletion:!1,allowStringLiteral:!1,isNewIdentifierLocation:!1,location:void 0,isRightOfDot:!1,request:o,keywordFilters:0,symbolToOriginInfoMap:void 0};if(!l)return void n("Returning an empty list because completion was inside a regular comment or plain text part of a JsDoc comment.")}c=e.timestamp();var h=e.findPrecedingToken(i,r,void 0,l);n("getCompletionData: Get previous token 1: "+(e.timestamp()-c));var v=h;if(v&&i<=v.end&&e.isWord(v.kind)){var b=e.timestamp();v=e.findPrecedingToken(v.getFullStart(),r,void 0,l),n("getCompletionData: Get previous token 2: "+(e.timestamp()-b))}var x=u,k=!1,S=!1,D=!1,C=e.getTouchingPropertyName(r,i,l);if(v){if(function(t){var r=e.timestamp(),a=function(t){if(9===t.kind||12===t.kind||e.isTemplateLiteralKind(t.kind)){var n=t.getStart(),r=t.getEnd();if(n<i&&i<r)return!0;if(i===r)return!!t.isUnterminated||12===t.kind}return!1}(t)||function(t){var n=t.parent.kind;switch(t.kind){case 26:return 226===n||227===n||208===n||232===n||V(n)||230===n||175===n||231===n||e.isClassLike(t.parent)&&t.parent.typeParameters&&t.parent.typeParameters.end>=t.pos;case 23:return 175===n;case 56:return 176===n;case 21:return 175===n;case 19:return 260===n||V(n);case 17:return 232===n||230===n||163===n;case 25:return 148===n&&t.parent&&t.parent.parent&&(230===t.parent.parent.kind||163===t.parent.parent.kind);case 27:return 229===n||199===n||230===n||231===n||e.isFunctionLikeKind(n);case 115:return 149===n&&!e.isClassLike(t.parent.parent);case 24:return 146===n||t.parent&&t.parent.parent&&175===t.parent.parent.kind;case 114:case 112:case 113:return 146===n&&!e.isConstructorDeclaration(t.parent.parent);case 118:return 242===n||246===n||240===n;case 125:case 135:if(K(t))return!1;case 75:case 83:case 109:case 89:case 104:case 91:case 110:case 76:case 116:case 138:return!0}if(m(t.getText())&&K(t))return!1;if(U(t)&&(!e.isIdentifier(t)||y(t.getText())||q(t)))return!1;switch(t.getText()){case"abstract":case"async":case"class":case"const":case"declare":case"enum":case"function":case"interface":case"let":case"private":case"protected":case"public":case"static":case"var":case"yield":return!0}return e.isDeclarationName(t)&&!e.isJsxAttribute(t.parent)}(t)||function(e){if(8===e.kind){var t=e.getFullText();return"."===t.charAt(t.length-1)}return!1}(t)||function(e){if(10===e.kind)return!0;if(29===e.kind&&e.parent){if(251===e.parent.kind)return!0;if(252===e.parent.kind||250===e.parent.kind)return e.parent.parent&&249===e.parent.parent.kind}return!1}(t);return n("getCompletionsAtPosition: isCompletionListBlocker: "+(e.timestamp()-r)),a}(v))return void n("Returning an empty list because completion was requested in an invalid position.");var T=v.parent;if(23===v.kind)if(179===T.kind)x=v.parent.expression,k=!0;else{if(143!==T.kind)return;x=v.parent.left,k=!0}else if(1===r.languageVariant)switch(T&&179===T.kind&&(v=T,T=T.parent),T.kind){case 252:41===v.kind&&(D=!0,C=v);break;case 194:if(!(32768&T.left.flags))break;case 250:case 249:case 251:27===v.kind&&(S=!0,C=v)}}var E,N,A=e.timestamp(),w=!1,P=!1,F=0,O=[],I=[];if(k)!function(){w=!1,E=!0,N=!1;var n=l||e.isPartOfTypeNode(x.parent),r=e.isInRightSideOfInternalImportEqualsDeclaration(x);if(e.isEntityName(x)){var i=t.getSymbolAtLocation(x);if(i&&1920&(i=e.skipAlias(i,t)).flags){for(var a=t.getExportsOfModule(i),o=function(e){return t.isValidPropertyAccess(x.parent,e.name)},s=function(e){return z(e)},c=r?function(e){return s(e)||o(e)}:n?s:o,u=0,_=a;u<_.length;u++){var d=_[u];c(d)&&O.push(d)}return void(!n&&i.declarations.some((function(e){return 265!==e.kind&&233!==e.kind&&232!==e.kind}))&&B(t.getTypeOfSymbolAtLocation(i,x)))}}n||B(t.getTypeAtLocation(x))}();else if(S){var R=t.getJsxIntrinsicTagNames();O=J()?R.concat(O.filter((function(e){return!!(2204607&e.flags)}))):R,E=!0,N=!1}else if(D){var L=v.parent.parent.openingElement.tagName,M=t.getSymbolAtLocation(L);t.isUnknownSymbol(M)||(O=[M]),E=!0,N=!1}else if(!J())return;return n("getCompletionData: Semantic work: "+(e.timestamp()-A)),{symbols:O,isGlobalCompletion:w,isMemberCompletion:E,allowStringLiteral:P,isNewIdentifierLocation:N,location:C,isRightOfDot:k||S,request:o,keywordFilters:F,symbolToOriginInfoMap:I};function B(e){for(var n=0,r=e.getApparentProperties();n<r.length;n++){var i=r[n];t.isValidPropertyAccess(x.parent,i.name)&&O.push(i)}if(s&&65536&e.flags)for(var a=0,o=e.types;a<o.length;a++){B(o[a])}}function J(){var n,o,s,c;if(n=function(t){if(t)switch(t.kind){case 17:case 26:var n=t.parent;if(e.isObjectLiteralExpression(n)||e.isObjectBindingPattern(n))return n}return}(v))return function(n){var r,i;if(E=!0,P=!0,178===n.kind){if(N=!0,!(s=t.getContextualType(n)))return!1;r=function(e,t){if(!(65536&e.flags))return t.getPropertiesOfType(e);var n=e.types.filter((function(e){return!(8190&e.flags||t.isArrayLikeType(e))}));return t.getAllPossiblePropertiesOfTypes(n)}(s,t),i=n.properties}else{e.Debug.assert(174===n.kind),N=!1;var a=e.getRootDeclaration(n.parent);if(!e.isVariableLike(a))throw e.Debug.fail("Root declaration is not variable-like.");var o=a.initializer||a.type||216===a.parent.parent.kind;if(o||146!==a.kind||(e.isExpression(a.parent)?o=!!t.getContextualType(a.parent):151!==a.parent.kind&&154!==a.parent.kind||(o=e.isExpression(a.parent.parent)&&!!t.getContextualType(a.parent.parent))),o){var s;if(!(s=t.getTypeAtLocation(n)))return!1;r=t.getPropertiesOfType(s).filter((function(t){return!(24&e.getDeclarationModifierFlagsFromSymbol(t))})),i=n.elements}}r&&r.length>0&&(O=function(t,n){if(!n||0===n.length)return t;for(var r=e.createUnderscoreEscapedMap(),i=0,a=n;i<a.length;i++){var o=a[i];if((261===o.kind||262===o.kind||176===o.kind||151===o.kind||153===o.kind||154===o.kind)&&!q(o)){var s=void 0;if(176===o.kind&&o.propertyName)71===o.propertyName.kind&&(s=o.propertyName.escapedText);else{var c=e.getNameOfDeclaration(o);s=e.getEscapedTextOfIdentifierOrLiteral(c)}r.set(s,!0)}}return e.filter(t,(function(e){return!r.get(e.escapedName)}))}(r,i));return!0}(n);if(o=function(e){if(e)switch(e.kind){case 17:case 26:switch(e.parent.kind){case 241:case 245:return e.parent}}return}(v))return function(n){var r=241===n.kind?238:244,i=e.getAncestor(n,r).moduleSpecifier;if(!i)return!1;E=!0,N=!1;var a=t.getSymbolAtLocation(i);if(!a)return O=e.emptyArray,!0;var o=t.getExportsAndPropertiesOfModule(a);return O=function(t,n){for(var r=e.createUnderscoreEscapedMap(),i=0,a=n;i<a.length;i++){var o=a[i];if(!q(o)){var s=o.propertyName||o.name;r.set(s.escapedText,!0)}}if(0===r.size)return e.filter(t,(function(e){return"default"!==e.escapedName}));return e.filter(t,(function(e){return"default"!==e.escapedName&&!r.get(e.escapedName)}))}(o,n.elements),!0}(o);if(function(t){if(t)switch(t.kind){case 19:case 26:return e.isConstructorDeclaration(t.parent)&&t.parent;default:if(U(t))return t.parent.parent}return}(v))return E=!1,N=!0,F=2,!0;if(s=function(t){if(t)switch(t.kind){case 17:case 26:if(e.isClassLike(t.parent))return t.parent;break;case 25:case 18:if(e.isClassLike(C))return C;if(K(C)&&C.parent.name===C)return C.parent.parent;break;default:if(K(t)&&(f(t.kind)||m(t.getText())))return t.parent.parent}if(C&&286===C.kind&&e.isClassLike(C.parent))return C.parent;return}(v))return function(n){E=!0,N=!0,F=1;var r=e.getClassExtendsHeritageClauseElement(n),i=e.getClassImplementsHeritageClauseElements(n);if(r||i){var a=v.parent,o=e.isClassElement(a)&&e.getModifierFlags(a);if(71===v.kind&&!q(v))switch(v.getText()){case"private":o|=8;break;case"static":o|=32}if(!(8&o)){var s=void 0;r&&(s=t.getTypeAtLocation(r),32&o&&(s=t.getTypeOfSymbolAtLocation(s.symbol,n)));var c=32&o?e.emptyArray:e.flatMap(i||e.emptyArray,(function(e){return t.getPropertiesOfType(t.getTypeAtLocation(e))}));O=function(t,n,r,i){for(var a=e.createUnderscoreEscapedMap(),o=0,s=r;o<s.length;o++){var c=s[o];if((149===c.kind||151===c.kind||153===c.kind||154===c.kind)&&(!q(c)&&!e.hasModifier(c,8))){var u=e.hasModifier(c,32),_=!!(32&i);if(!(u&&!_||!u&&_)){var l=e.getPropertyNameForPropertyNameNode(c.name);l&&a.set(l,!0)}}}var d=[];return p(t,8),p(n,24),d;function p(e,t){for(var n=0,r=e;n<r.length;n++){var i=r[n];f(i,t)&&d.push(i)}}function f(t,n){return!a.get(t.escapedName)&&t.getDeclarations()&&!(e.getDeclarationModifierFlagsFromSymbol(t)&n)}}(s?t.getPropertiesOfType(s):e.emptyArray,c,n.members,o)}}}(s),!0;if(c=function(e){if(e){var t=e.parent;switch(e.kind){case 28:case 41:case 71:case 179:case 254:case 253:case 255:if(t&&(250===t.kind||251===t.kind))return t;if(253===t.kind)return t.parent.parent;break;case 9:if(t&&(253===t.kind||255===t.kind))return t.parent.parent;break;case 18:if(t&&256===t.kind&&t.parent&&253===t.parent.kind)return t.parent.parent.parent;if(t&&255===t.kind)return t.parent.parent}}return}(v)){var u=void 0;if((250===c.kind||251===c.kind)&&(u=t.getAllAttributesTypeFromJsxOpeningLikeElement(c)))return O=function(t,n){for(var r=e.createUnderscoreEscapedMap(),i=0,a=n;i<a.length;i++){var o=a[i];q(o)||253===o.kind&&r.set(o.name.escapedText,!0)}return e.filter(t,(function(e){return!r.get(e.escapedName)}))}(t.getPropertiesOfType(u),c.attributes.properties),E=!0,N=!1,!0}E=!1,N=function(e){if(e){var t=e.parent.kind;switch(e.kind){case 26:return 181===t||152===t||182===t||177===t||194===t||160===t;case 19:return 181===t||152===t||182===t||185===t||168===t;case 21:return 177===t||157===t||144===t;case 128:case 129:return!0;case 23:return 233===t;case 17:return 229===t;case 58:return 226===t||194===t;case 14:return 196===t;case 15:return 205===t;case 114:case 112:case 113:return 149===t}switch(e.getText()){case"public":case"protected":case"private":return!0}}return!1}(v),h!==v&&e.Debug.assert(!!h,"Expected 'contextToken' to be defined when different from 'previousToken'.");var _=h!==v?h.getStart():i,d=function(t,n,r){var i=t;for(;i&&!e.positionBelongsToNode(i,n,r);)i=i.parent;return i}(v,_,r)||r;d&&(w=265===d.kind||196===d.kind||256===d.kind||e.isStatement(d));return function(n,i){var o=i.toLowerCase();e.codefix.forEachExternalModule(t,a,(function(i){if(i!==r.symbol)for(var a=0,s=t.getExportsOfModule(i);a<s.length;a++){var c=s[a],u=c.name,_="default"===u;if(_){var l=e.getLocalSymbolForExportDefault(c);l&&(c=l,u=l.name)}c.declarations&&c.declarations.some((function(t){return e.isExportSpecifier(t)&&!!t.parent.parent.moduleSpecifier}))||j(u.toLowerCase(),o)&&(n.push(c),I[e.getSymbolId(c)]={moduleSymbol:i,isDefaultExport:_})}}))}(O=t.getSymbolsInScope(d,2998271),h&&e.isIdentifier(h)?h.text:""),function(n){e.filterMutate(n,(function(n){if(!e.isSourceFile(C)){if(e.isExportAssignment(C.parent))return!0;if(n&&2097152&n.flags&&(n=t.getAliasedSymbol(n)),e.isInRightSideOfInternalImportEqualsDeclaration(C))return!!(1920&n.flags);if(l||!function(e){return e&&103===e.kind&&162===e.parent.kind}(v)&&(e.isPartOfTypeNode(C)||function(t){if(t){var n=t.parent.kind;switch(t.kind){case 56:return 149===n||148===n||146===n||226===n||e.isFunctionLikeKind(n);case 58:return 231===n;case 118:return 202===n}}}(v)))return z(n)}return!!(107455&e.getCombinedLocalAndExportSymbolFlags(n))}))}(O),!0}function z(n){if(n=n.exportSymbol||n,793064&(n=e.skipAlias(n,t)).flags)return!0;if(1536&n.flags){var r=t.getExportsOfModule(n);return e.forEach(r,z)}}function j(e,t){if(0===t.length)return!0;for(var n=0,r=0;r<e.length;r++)if(e.charCodeAt(r)===t.charCodeAt(n)&&++n===t.length)return!0;return!1}function K(t){return e.isClassElement(t.parent)&&e.isClassLike(t.parent.parent)}function U(t){return t.parent&&function(t){return e.isParameter(t)&&e.isConstructorDeclaration(t.parent)}(t.parent)&&(g(t.kind)||e.isDeclarationName(t))}function V(t){return e.isFunctionLikeKind(t)&&152!==t}function q(e){return e.getStart()<=i&&i<=e.getEnd()}}function _(t,n,r,i){var a=t.name;if(a){if(1920&t.flags){var o=a.charCodeAt(0);if(e.isSingleOrDoubleQuote(o))return}return l(a,n,r,i)}}function l(t,n,r,i){return r&&!e.isIdentifierText(t,n)?i?JSON.stringify(t):void 0:t}!function(e){e[e.None=0]="None",e[e.ClassElementKeywords=1]="ClassElementKeywords",e[e.ConstructorParameterKeywords=2]="ConstructorParameterKeywords"}(n||(n={})),t.getCompletionsAtPosition=function(n,r,i,c,_,d,f){if(e.isInReferenceComment(_,d))return t.PathCompletions.getTripleSlashReferenceCompletion(_,d,c,n);if(e.isInString(_,d))return function(n,r,i,c,u,_){var l=e.findPrecedingToken(r,n);if(!l||9!==l.kind)return;if(261===l.parent.kind&&178===l.parent.parent.kind&&l.parent.name===l)return function(e,t,n,r){var i=t.getContextualType(e.parent),o=[];if(i&&(a(i.getApparentProperties(),o,e,!1,t,n,r,!0),o.length))return{isGlobalCompletion:!1,isMemberCompletion:!0,isNewIdentifierLocation:!0,entries:o}}(l.parent,i,c.target,_);if(e.isElementAccessExpression(l.parent)&&l.parent.argumentExpression===l)return function(e,t,n,r){var i=t.getTypeAtLocation(e.expression),o=[];if(i&&(a(i.getApparentProperties(),o,e,!1,t,n,r,!0),o.length))return{isGlobalCompletion:!1,isMemberCompletion:!0,isNewIdentifierLocation:!0,entries:o};return}(l.parent,i,c.target,_);if(238===l.parent.kind||e.isExpressionOfExternalModuleImportEqualsDeclaration(l)||e.isRequireCall(l.parent,!1))return t.PathCompletions.getStringLiteralCompletionEntriesFromModuleNames(l,c,u,i);if(function(t){return e.isBinaryExpression(t)&&(n=t.operatorToken.kind,32===n||33===n||34===n||35===n);var n}(l.parent))return o(i.getTypeAtLocation(l.parent.left===l?l.parent.right:l.parent.left),i);if(e.isCaseOrDefaultClause(l.parent))return o(i.getTypeAtLocation(l.parent.parent.parent.expression),i);var d=e.SignatureHelp.getImmediatelyContainingArgumentInfo(l,r,n);return d?function(t,n){var r=[],i=[],a=e.createMap();n.getResolvedSignature(t.invocation,r,t.argumentCount);for(var o=0,c=r;o<c.length;o++){var u=c[o];s(n.getParameterType(u,t.argumentIndex),i,n,a)}if(i.length)return{isGlobalCompletion:!1,isMemberCompletion:!1,isNewIdentifierLocation:!0,entries:i};return}(d,i):o(i.getContextualType(l),i)}(_,d,r,c,n,i);var m=u(r,i,_,d,f);if(m){var g=m.symbols,y=m.isGlobalCompletion,h=m.isMemberCompletion,v=m.allowStringLiteral,b=m.isNewIdentifierLocation,x=m.location,k=m.request,S=m.keywordFilters,D=m.symbolToOriginInfoMap;if(1===_.languageVariant&&x&&x.parent&&252===x.parent.kind)return{isGlobalCompletion:!1,isMemberCompletion:!0,isNewIdentifierLocation:!1,entries:[{name:x.parent.parent.openingElement.tagName.getFullText(),kind:"class",kindModifiers:void 0,sortText:"0"}]};if(k)return{isGlobalCompletion:!1,isMemberCompletion:!1,isNewIdentifierLocation:!1,entries:"JsDocTagName"===k.kind?e.JsDoc.getJSDocTagNameCompletions():"JsDocTag"===k.kind?e.JsDoc.getJSDocTagCompletions():e.JsDoc.getJSDocParameterNameCompletions(k.tag)};var C=[];if(e.isSourceFileJavaScript(_)){var T=a(g,C,x,!0,r,c.target,i,v,D);!function(t,n,r,i,a){e.getNameTable(t).forEach((function(t,o){if(t!==n){var s=e.unescapeLeadingUnderscores(o);if(!r.has(s)){r.set(s,!0);var c=l(s,i,!0,!1);c&&a.push({name:c,kind:"warning",kindModifiers:"",sortText:"1"})}}}))}(_,x.pos,T,c.target,C)}else{if((!g||0===g.length)&&0===S)return;a(g,C,x,!0,r,c.target,i,v,D)}return 0===S&&h||e.addRange(C,p(S)),{isGlobalCompletion:y,isMemberCompletion:h,isNewIdentifierLocation:b,entries:C}}},t.getCompletionEntryDetails=function(t,n,r,i,a,o,s,u,_){var l=o.name,d=o.source,f=c(t,n,r,i,a,o,s);if(f){var m=f.symbol,g=f.location,y=function(t,n,r,i,a,o,s){var c=t[e.getSymbolId(n)];if(!c)return;var u=c.moduleSymbol,_=c.isDefaultExport;return e.codefix.getCodeActionForImport(u,{host:i,checker:r,newLineCharacter:i.getNewLine(),compilerOptions:a,sourceFile:o,rulesProvider:s,symbolName:n.name,getCanonicalFileName:e.createGetCanonicalFileName(!!i.useCaseSensitiveFileNames&&i.useCaseSensitiveFileNames()),symbolToken:void 0,kind:_?1:0})}(f.symbolToOriginInfoMap,m,t,u,r,i,_),h=e.SymbolDisplay.getSymbolModifiers(m),v=e.SymbolDisplay.getSymbolDisplayPartsDocumentationAndSymbolKind(t,m,i,g,g,7),b=v.displayParts,x=v.documentation,k=v.symbolKind,S=v.tags;return{name:l,kindModifiers:h,kind:k,displayParts:b,documentation:x,tags:S,codeActions:y,source:void 0===d?void 0:[e.textPart(d)]}}if(void 0===d&&e.some(p(0),(function(e){return e.name===l})))return{name:l,kind:"keyword",kindModifiers:"",displayParts:[e.displayPart(l,e.SymbolDisplayPartKind.keyword)],documentation:void 0,tags:void 0,codeActions:void 0,source:void 0}},t.getCompletionEntrySymbol=function(e,t,n,r,i,a,o){var s=c(e,t,n,r,i,a,o);return s&&s.symbol};var d=[];function p(t){var n=d[t];return n||(d[t]=function(t){switch(t){case 0:return function(){for(var t=[],n=72;n<=142;n++)t.push({name:e.tokenToString(n),kind:"keyword",kindModifiers:"",sortText:"0"});return t}();case 1:return r(m);case 2:return r(y)}}(t));function r(t){return e.filter(p(0),(function(e){return t(e.name)}))}}function f(e){switch(e){case 114:case 113:case 112:case 117:case 115:case 123:case 131:case 125:case 135:case 120:return!0}}function m(t){return f(e.stringToToken(t))}function g(e){switch(e){case 114:case 112:case 113:case 131:return!0}}function y(t){return g(e.stringToToken(t))}}(e.Completions||(e.Completions={}))}(ts||(ts={})),function(e){!function(t){function n(t,n){return{fileName:n.fileName,textSpan:e.createTextSpanFromNode(t,n),kind:"none"}}function r(e,t){return void 0!==e&&e.kind===t}function i(e){return e&&e.parent}function a(t){var n=[];return function t(r){if(223===r.kind)n.push(r);else if(224===r.kind){var i=r;i.catchClause?t(i.catchClause):t(i.tryBlock),i.finallyBlock&&t(i.finallyBlock)}else e.isFunctionLike(r)||e.forEachChild(r,t)}(t),n}function o(t){var n=[];return function t(r){218===r.kind||217===r.kind?n.push(r):e.isFunctionLike(r)||e.forEachChild(r,t)}(t),n}function s(e,t){var n=c(t);return n&&n===e}function c(t){for(var n=t.parent;n;n=n.parent)switch(n.kind){case 221:if(217===t.kind)continue;case 214:case 215:case 216:case 213:case 212:if(!t.label||d(n,t.label.text))return n;break;default:if(e.isFunctionLike(n))return}}function u(t,n){for(var r=[],i=2;i<arguments.length;i++)r[i-2]=arguments[i];return!(!n||!e.contains(r,n.kind))&&(t.push(n),!0)}function _(t){var n=[];if(u(n,t.getFirstToken(),88,106,81)&&212===t.kind)for(var r=t.getChildren(),i=r.length-1;i>=0&&!u(n,r[i],106);i--);var a=o(t.statement);return e.forEach(a,(function(e){s(t,e)&&u(n,e.getFirstToken(),72,77)})),n}function l(t){var n=[];return u(n,t.getFirstToken(),98),e.forEach(t.caseBlock.clauses,(function(r){u(n,r.getFirstToken(),73,79);var i=o(r);e.forEach(i,(function(e){s(t,e)&&u(n,e.getFirstToken(),72)}))})),n}function d(e,t){for(var n=e.parent;222===n.kind;n=n.parent)if(n.label.escapedText===t)return!0;return!1}t.getDocumentHighlights=function(t,o,s,d,p){var f=e.getTouchingWord(s,d,!0);if(f!==s){if(e.Debug.assert(void 0!==f.parent),e.isJsxOpeningElement(f.parent)&&f.parent.tagName===f||e.isJsxClosingElement(f.parent)){var m=f.parent.parent,g=[m.openingElement,m.closingElement].map((function(e){return n(e.tagName,s)}));return[{fileName:s.fileName,highlightSpans:g}]}return function(t,n,r,i){var a=e.FindAllReferences.getReferenceEntriesForNode(t,n,i,r);return a&&function(t){for(var n=e.createMap(),r=0,i=t;r<i.length;r++){var a=i[r],o=e.FindAllReferences.toHighlightSpan(a),s=o.fileName,c=o.span,u=n.get(s);u||n.set(s,u=[]),u.push(c)}return e.arrayFrom(n.entries(),(function(e){return{fileName:e[0],highlightSpans:e[1]}}))}(a)}(f,t,o,p)||function(t,o){var s=function(t,o){if(!t)return;switch(t.kind){case 90:case 82:if(r(t.parent,211))return function(t,i){var a=[];for(;r(t.parent,211)&&t.parent.elseStatement===t;)t=t.parent;for(;t;){var o=t.getChildren();u(a,o[0],90);for(var s=o.length-1;s>=0&&!u(a,o[s],82);s--);if(!r(t.elseStatement,211))break;t=t.elseStatement}var c=[];for(s=0;s<a.length;s++){if(82===a[s].kind&&s<a.length-1){for(var _=a[s],l=a[s+1],d=!0,p=l.getStart()-1;p>=_.end;p--)if(!e.isWhiteSpaceSingleLine(i.text.charCodeAt(p))){d=!1;break}if(d){c.push({fileName:i.fileName,textSpan:e.createTextSpanFromBounds(_.getStart(),l.end),kind:"reference"}),s++;continue}}c.push(n(a[s],i))}return c}(t.parent,o);break;case 96:if(r(t.parent,219))return m(function(t){var n=e.getContainingFunction(t);if(!n||!r(n.body,207))return;var i=[];return e.forEachReturnStatement(n.body,(function(e){u(i,e.getFirstToken(),96)})),e.forEach(a(n.body),(function(e){u(i,e.getFirstToken(),100)})),i}(t.parent));break;case 100:if(r(t.parent,223))return m(function(t){var n=function(t){var n=t;for(;n.parent;){var r=n.parent;if(e.isFunctionBlock(r)||265===r.kind)return r;if(224===r.kind){var i=r;if(i.tryBlock===n&&i.catchClause)return n}n=r}return}(t);if(!n)return;var r=[];e.forEach(a(n),(function(e){u(r,e.getFirstToken(),100)})),e.isFunctionBlock(n)&&e.forEachReturnStatement(n,(function(e){u(r,e.getFirstToken(),96)}));return r}(t.parent));break;case 102:case 74:case 87:var s=74===t.kind?i(i(t)):i(t);if(r(s,224))return m(function(t,n){var r=[];u(r,t.getFirstToken(),102),t.catchClause&&u(r,t.catchClause.getFirstToken(),74);if(t.finallyBlock){u(r,e.findChildOfKind(t,87,n),87)}return r}(s,o));break;case 98:if(r(t.parent,221))return m(l(t.parent));break;case 73:case 79:if(r(i(i(i(t))),221))return m(l(t.parent.parent.parent));break;case 72:case 77:if(r(t.parent,218)||r(t.parent,217))return m(function(e){var t=c(e);if(t)switch(t.kind){case 214:case 215:case 216:case 212:case 213:return _(t);case 221:return l(t)}return}(t.parent));break;case 88:if(r(t.parent,214)||r(t.parent,215)||r(t.parent,216))return m(_(t.parent));break;case 106:case 81:if(r(t.parent,213)||r(t.parent,212))return m(_(t.parent));break;case 123:if(r(t.parent,152))return m((d=t.parent,p=d.symbol.getDeclarations(),f=[],e.forEach(p,(function(t){e.forEach(t.getChildren(),(function(e){return u(f,e,123)}))})),f));break;case 125:case 135:if(r(t.parent,153)||r(t.parent,154))return m(function(t){var n=[];return r(t.symbol,153),r(t.symbol,154),n;function r(t,r){var i=e.getDeclarationOfKind(t,r);i&&e.forEach(i.getChildren(),(function(e){return u(n,e,125,135)}))}}(t.parent));break;default:if(e.isModifierKind(t.kind)&&t.parent&&(e.isDeclaration(t.parent)||208===t.parent.kind))return m(function(t,n){if(!function(e,t){var n=t.parent;switch(e){case 112:case 113:case 114:switch(n.kind){case 229:case 199:return!0;case 152:return 146===t.kind;default:return!1}case 115:return 229===n.kind||199===n.kind;case 84:case 124:return 234===n.kind||265===n.kind;case 117:return 229===n.kind||229===t.kind;default:return!1}}(t,n))return;var r=e.modifierToFlag(t);return e.mapDefined(function(t,n){var r=t.parent;switch(r.kind){case 234:case 265:case 207:case 257:case 258:return 128&n?t.members.concat([t]):r.statements;case 152:return r.parameters.concat(r.parent.members);case 229:case 199:var i=r.members;if(28&n){var a=e.find(r.members,e.isConstructorDeclaration);if(a)return i.concat(a.parameters)}else if(128&n)return i.concat([r]);return i;default:e.Debug.fail("Invalid container kind.")}}(n,r),(function(n){if(e.getModifierFlags(n)&r){var i=e.find(n.modifiers,(function(e){return e.kind===t}));return e.Debug.assert(!!i),i}}))}(t.kind,t.parent))}var d,p,f;function m(e){return e&&e.map((function(e){return n(e,o)}))}}(t,o);if(!s||0===s.length)return;return[{fileName:o.fileName,highlightSpans:s}]}(f,s)}}}(e.DocumentHighlights||(e.DocumentHighlights={}))}(ts||(ts={})),function(e){e.createDocumentRegistry=function(t,n){void 0===n&&(n="");var r=e.createMap(),i=e.createGetCanonicalFileName(!!t);function a(e){return"_"+e.target+"|"+e.module+"|"+e.noResolve+"|"+e.jsx+"|"+e.allowJs+"|"+e.baseUrl+"|"+JSON.stringify(e.typeRoots)+"|"+JSON.stringify(e.rootDirs)+"|"+JSON.stringify(e.paths)}function o(t,n){var i=r.get(t);return!i&&n&&r.set(t,i=e.createMap()),i}function s(e,t,n,r,i,a,o){return u(e,t,n,r,i,a,!0,o)}function c(e,t,n,r,i,a,o){return u(e,t,n,r,i,a,!1,o)}function u(t,n,r,i,a,s,c,u){var _=o(i,!0),l=_.get(n);l?(l.sourceFile.version!==s&&(l.sourceFile=e.updateLanguageServiceSourceFile(l.sourceFile,a,s,a.getChangeRange(l.sourceFile.scriptSnapshot))),c&&l.languageServiceRefCount++):(l={sourceFile:e.createLanguageServiceSourceFile(t,a,r.target,s,!1,u),languageServiceRefCount:1,owners:[]},_.set(n,l));return l.sourceFile}function _(t,n){var r=o(n,!1);e.Debug.assert(void 0!==r);var i=r.get(t);i.languageServiceRefCount--,e.Debug.assert(i.languageServiceRefCount>=0),0===i.languageServiceRefCount&&r.delete(t)}return{acquireDocument:function(t,r,o,c,u){return s(t,e.toPath(t,n,i),r,a(r),o,c,u)},acquireDocumentWithKey:s,updateDocument:function(t,r,o,s,u){return c(t,e.toPath(t,n,i),r,a(r),o,s,u)},updateDocumentWithKey:c,releaseDocument:function(t,r){return _(e.toPath(t,n,i),a(r))},releaseDocumentWithKey:_,reportStats:function(){var t=e.arrayFrom(r.keys()).filter((function(e){return e&&"_"===e.charAt(0)})).map((function(e){var t=r.get(e),n=[];return t.forEach((function(e,t){n.push({name:t,refCount:e.languageServiceRefCount,references:e.owners.slice(0)})})),n.sort((function(e,t){return t.refCount-e.refCount})),{bucket:e,sourceFiles:n}}));return JSON.stringify(t,void 0,2)},getKeyForCompilationSettings:a}}}(ts||(ts={})),function(e){!function(t){function n(t,n){return e.forEach(265===t.kind?t.statements:t.body.statements,(function(t){return n(t)||u(t)&&e.forEach(t.body&&t.body.statements,n)}))}function r(e,t){if(e.externalModuleIndicator||void 0!==e.imports)for(var r=0,a=e.imports;r<a.length;r++){var o=a[r];t(i(o),o)}else n(e,(function(e){switch(e.kind){case 244:case 238:(n=e).moduleSpecifier&&9===n.moduleSpecifier.kind&&t(n,n.moduleSpecifier);break;case 237:var n,r=(n=e).moduleReference;248===r.kind&&9===r.expression.kind&&t(n,r.expression)}}))}function i(t){var n=t.parent;switch(n.kind){case 181:case 238:case 244:return n;case 248:return n.parent;default:e.Debug.fail("Unexpected module specifier parent: "+n.kind)}}function a(t,n,r){var i=r.getMergedSymbol(t.parent);return e.isExternalModuleSymbol(i)?{exportingModuleSymbol:i,exportKind:n}:void 0}function o(t){return"default"!==t.escapedName?t.escapedName:e.forEach(t.declarations,(function(t){var n=e.getNameOfDeclaration(t);return n&&71===n.kind&&n.escapedText}))}function s(e,t){return t.getMergedSymbol(c(e).symbol)}function c(t){if(181===t.kind)return t.getSourceFile();var n=t.parent;return 265===n.kind?n:(e.Debug.assert(234===n.kind&&u(n.parent)),n.parent)}function u(e){return 233===e.kind&&9===e.name.kind}function _(e){var t=e.moduleReference;return 248===t.kind&&9===t.expression.kind}t.createImportTracker=function(t,i,a){var u=function(t,n,i){for(var a=e.createMap(),o=0,s=t;o<s.length;o++){var c=s[o];i.throwIfCancellationRequested(),r(c,(function(t,r){var i=n.getSymbolAtLocation(r);if(i){var o=e.getSymbolId(i).toString(),s=a.get(o);s||a.set(o,s=[]),s.push(t)}}))}return a}(t,i,a);return function(r,l,d){var p=function(t,r,i,a,o){var u=i.exportingModuleSymbol,_=i.exportKind,l=e.nodeSeenTracker(),d=e.nodeSeenTracker(),p=[],f=!!u.globalExports,m=f?void 0:[];return y(u),{directImports:p,indirectUsers:g()};function g(){if(f)return t;for(var n=0,r=u.declarations;n<r.length;n++){var i=r[n];e.isExternalModuleAugmentation(i)&&v(i)}return m.map(e.getSourceFileOfNode)}function y(t){var n=x(t);if(n)for(var r=0,i=n;r<i.length;r++){var c=i[r];if(l(c))switch(o.throwIfCancellationRequested(),c.kind){case 181:if(!f){var u=c.parent;if(2===_&&226===u.kind){var d=u.name;if(71===d.kind){p.push(d);break}}v(c.getSourceFile())}break;case 237:h(c,c.name,e.hasModifier(c,1));break;case 238:var m=c.importClause&&c.importClause.namedBindings;m&&240===m.kind?h(c,m.name):p.push(c);break;case 244:c.exportClause?p.push(c):y(s(c,a))}}}function h(t,r,i){if(2===_)p.push(t);else if(!f){var o=c(t);e.Debug.assert(265===o.kind||233===o.kind),i||function(e,t,r){var i=r.getSymbolAtLocation(t);return n(e,(function(e){if(244===e.kind){var t=e,n=t.exportClause;if(!t.moduleSpecifier&&n)for(var a=0,o=n.elements;a<o.length;a++){var s=o[a];if(r.getExportSpecifierLocalTargetSymbol(s)===i)return!0}}}))}(o,r,a)?b(o):v(o)}}function v(t){e.Debug.assert(!f);var n=d(t);return n&&m.push(t),n}function b(t){if(v(t)){var n=a.getMergedSymbol(t.symbol);e.Debug.assert(!!(1536&n.flags));var r=x(n);if(r)for(var i=0,o=r;i<o.length;i++){b(c(o[i]))}}}function x(t){return r.get(e.getSymbolId(t).toString())}}(t,u,l,i,a),f=p.directImports,m=p.indirectUsers;return __assign({indirectUsers:m},function(e,t,n,r,i){var a=[],s=[];function c(e,t){a.push([e,t])}if(e)for(var u=0,l=e;u<l.length;u++){d(l[u])}return{importSearches:a,singleReferences:s};function d(e){if(237!==e.kind)if(71!==e.kind){if(9===e.moduleSpecifier.kind)if(244!==e.kind){var a=e.importClause;if(a){var s=a.namedBindings;if(s&&240===s.kind)p(s.name);else if(0===n)f(s);else{var u=a.name;if(u&&(!i||u.escapedText===o(t)))c(u,r.getSymbolAtLocation(u));i||1!==n||f(s)}}}else f(e.exportClause)}else p(e);else _(e)&&p(e.name)}function p(e){2!==n||i&&!m(e.escapedText)||c(e,r.getSymbolAtLocation(e))}function f(e){if(e)for(var t=0,n=e.elements;t<n.length;t++){var a=n[t],o=a.name,u=a.propertyName;if(m((u||o).escapedText))if(u)s.push(u),i||c(o,r.getSymbolAtLocation(o));else c(o,246===a.kind&&a.propertyName?r.getExportSpecifierLocalTargetSymbol(a):r.getSymbolAtLocation(o))}}function m(e){return e===t.escapedName||0!==n&&"default"===e}}(f,r,l.exportKind,i,d))}},function(e){e[e.Named=0]="Named",e[e.Default=1]="Default",e[e.ExportEquals=2]="ExportEquals"}(t.ExportKind||(t.ExportKind={})),function(e){e[e.Import=0]="Import",e[e.Export=1]="Export"}(t.ImportExport||(t.ImportExport={})),t.findModuleReferences=function(e,t,n){for(var i=[],a=e.getTypeChecker(),o=0,s=t;o<s.length;o++){var c=s[o],u=n.valueDeclaration;if(265===u.kind){for(var _=0,l=c.referencedFiles;_<l.length;_++){var d=l[_];e.getSourceFileFromReference(c,d)===u&&i.push({kind:"reference",referencingFile:c,ref:d})}for(var p=0,f=c.typeReferenceDirectives;p<f.length;p++){d=f[p];var m=e.getResolvedTypeReferenceDirectives().get(d.fileName);void 0!==m&&m.resolvedFileName===u.fileName&&i.push({kind:"reference",referencingFile:c,ref:d})}}r(c,(function(e,t){a.getSymbolAtLocation(t)===n&&i.push({kind:"import",literal:t})}))}return i},t.getImportOrExportSymbol=function(t,n,r,i){return i?s():s()||function(){var i=function(t){var n=t.parent;switch(n.kind){case 237:return n.name===t&&_(n)?{isNamedImport:!1}:void 0;case 242:return n.propertyName?void 0:{isNamedImport:!0};case 239:case 240:return e.Debug.assert(n.name===t),{isNamedImport:!1};default:return}}(t);if(!i)return;var a=r.getImmediateAliasedSymbol(n);if(!a)return;"export="===(a=function(t,n){if(t.declarations)for(var r=0,i=t.declarations;r<i.length;r++){var a=i[r];if(e.isExportSpecifier(a)&&!a.propertyName&&!a.parent.parent.moduleSpecifier)return n.getExportSpecifierLocalTargetSymbol(a)}return t}(a,r)).escapedName&&(a=function(t,n){if(2097152&t.flags)return n.getImmediateAliasedSymbol(t);var r=t.valueDeclaration;if(e.isExportAssignment(r))return r.expression.symbol;if(e.isBinaryExpression(r))return r.right.symbol;e.Debug.fail()}(a,r));var s=o(a);if(void 0===s||"default"===s||s===n.escapedName)return __assign({kind:0,symbol:a},i)}();function s(){var a=t.parent;if(n.exportSymbol)return 179===a.kind?n.declarations.some((function(e){return e===a}))&&e.isBinaryExpression(a.parent)?_(a.parent,!1):void 0:c(n.exportSymbol,u(a));var o=function(e,t){if(226===e.kind){var n=e;return n.name!==t||260===n.parent.kind?void 0:208===n.parent.parent.kind?n.parent.parent:void 0}return e}(a,t);if(o&&e.hasModifier(o,1)){if(e.isImportEqualsDeclaration(o)&&o.moduleReference===t){if(i)return;return{kind:0,symbol:r.getSymbolAtLocation(o.name),isNamedImport:!1}}return c(n,u(o))}if(e.isExportAssignment(a))return s(a);if(e.isExportAssignment(a.parent))return s(a.parent);if(e.isBinaryExpression(a))return _(a,!0);if(e.isBinaryExpression(a.parent))return _(a.parent,!0);function s(t){var r=t.symbol.parent;e.Debug.assert(!!r);var i=t.isExportEquals?2:1;return{kind:1,symbol:n,exportInfo:{exportingModuleSymbol:r,exportKind:i}}}function _(t,i){var a;switch(e.getSpecialPropertyAssignmentKind(t)){case 1:a=0;break;case 2:a=2;break;default:return}var o=i?r.getSymbolAtLocation(t.left.name):n;return o&&c(o,a)}}function c(e,t){var n=a(e,t,r);return n&&{kind:1,symbol:e,exportInfo:n}}function u(t){return e.hasModifier(t,512)?1:0}},t.getExportInfo=a}(e.FindAllReferences||(e.FindAllReferences={}))}(ts||(ts={})),function(e){!function(t){function n(e,t){return{type:"node",node:e,isInString:t}}function r(e,n,r,i,o){return void 0===o&&(o={}),a(t.Core.getReferencedSymbolsForNode(e,n,r,i,o))}function i(n,r,i,a,o,s){var c=e.getTouchingPropertyName(a,o,!0);return t.Core.getReferencedSymbolsForNode(c,n,i,r,s)}function a(t){return t&&e.flatMap(t,(function(e){return e.references}))}function o(t,n){var r=function(){switch(t.type){case"symbol":var r=t.symbol,i=t.node,a=s(r,i,n),o=a.displayParts,c=a.kind;return{node:i,name:o.map((function(e){return e.text})).join(""),kind:c,displayParts:o};case"label":var u=t.node;return{node:u,name:u.text,kind:"label",displayParts:[e.displayPart(u.text,e.SymbolDisplayPartKind.text)]};case"keyword":var _=t.node,l=e.tokenToString(_.kind);return{node:_,name:l,kind:"keyword",displayParts:[{text:l,kind:"keyword"}]};case"this":var d=t.node,p=(r=n.getSymbolAtLocation(d))&&e.SymbolDisplay.getSymbolDisplayPartsDocumentationAndSymbolKind(n,r,d.getSourceFile(),e.getContainerNode(d),d).displayParts;return{node:d,name:"this",kind:"var",displayParts:p};case"string":var f=t.node;return{node:f,name:f.text,kind:"var",displayParts:[e.displayPart(e.getTextOfNode(f),e.SymbolDisplayPartKind.stringLiteral)]}}}();if(r){var i=r.node,a=r.name,o=r.kind,c=r.displayParts,u=i.getSourceFile();return{containerKind:"",containerName:"",fileName:u.fileName,kind:o,name:a,textSpan:e.createTextSpanFromNode(i,u),displayParts:c}}}function s(t,n,r){var i=e.SymbolDisplay.getSymbolDisplayPartsDocumentationAndSymbolKind(r,t,n.getSourceFile(),e.getContainerNode(n),n);return{displayParts:i.displayParts,kind:i.symbolKind}}function c(t){if("span"===t.type)return{textSpan:t.textSpan,fileName:t.fileName,isWriteAccess:!1,isDefinition:!1};var n=t.node,r=t.isInString;return{fileName:n.getSourceFile().fileName,textSpan:u(n),isWriteAccess:_(n),isDefinition:79===n.kind||e.isAnyDeclarationName(n)||e.isLiteralComputedPropertyDeclarationName(n),isInString:r}}function u(t){var n=t.getStart(),r=t.getEnd();return 9===t.kind&&(n+=1,r-=1),e.createTextSpanFromBounds(n,r)}function _(t){return 79===t.kind||e.isAnyDeclarationName(t)||e.isWriteAccess(t)}t.nodeEntry=n,t.findReferencedSymbols=function(e,t,n,r,a){var s=i(e,t,n,r,a);if(s&&s.length){for(var u=[],_=e.getTypeChecker(),l=0,d=s;l<d.length;l++){var p=d[l],f=p.definition,m=p.references;f&&u.push({definition:o(f,_),references:m.map(c)})}return u}},t.getImplementationsAtPosition=function(i,a,o,c,_){var l=function(i,a,o,s){if(265===s.kind)return;var c=i.getTypeChecker();if(262===s.parent.kind){var u=[];return t.Core.getReferenceEntriesForShorthandPropertyAssignment(s,c,(function(e){return u.push(n(e))})),u}if(97===s.kind||e.isSuperProperty(s.parent)){var _=c.getSymbolAtLocation(s);return _.valueDeclaration&&[n(_.valueDeclaration)]}return r(s,i,o,a,{implementations:!0})}(i,a,o,e.getTouchingPropertyName(c,_,!1)),d=i.getTypeChecker();return e.map(l,(function(t){return function(t,n){if("node"===t.type){var r=t.node;return __assign({textSpan:u(r),fileName:r.getSourceFile().fileName},function(t,n){var r=n.getSymbolAtLocation(e.isDeclaration(t)&&t.name?t.name:t);return r?s(r,t,n):178===t.kind?{kind:"interface",displayParts:[e.punctuationPart(19),e.textPart("object literal"),e.punctuationPart(20)]}:199===t.kind?{kind:"local class",displayParts:[e.punctuationPart(19),e.textPart("anonymous local class"),e.punctuationPart(20)]}:{kind:e.getNodeKind(t),displayParts:[]}}(r,n))}return{textSpan:t.textSpan,fileName:t.fileName,kind:"",displayParts:[]}}(t,d)}))},t.findReferencedEntries=function(t,n,r,o,s,u){var _=a(i(t,n,r,o,s,u));return e.map(_,c)},t.getReferenceEntriesForNode=r,t.toHighlightSpan=function(e){if("span"===e.type)return{fileName:e.fileName,span:{textSpan:e.textSpan,kind:"reference"}};var t=e.node,n=e.isInString,r=e.node.getSourceFile().fileName,i=_(t);return{fileName:r,span:{textSpan:u(t),kind:i?"writtenReference":"reference",isInString:n}}}}(e.FindAllReferences||(e.FindAllReferences={}))}(ts||(ts={})),function(e){!function(t){!function(n){n.getReferencedSymbolsForNode=function(n,a,s,u,d){if(void 0===d&&(d={}),265!==n.kind){if(!d.implementations){var f=function(n,r,i){if(e.isTypeKeyword(n.kind))return function(t,n,r){for(var i=[],a=0,o=t;a<o.length;a++){var s=o[a];r.throwIfCancellationRequested(),p(s,n,e.tokenToString(n),i)}return i.length?[{definition:{type:"keyword",node:i[0].node},references:i}]:void 0}(r,n.kind,i);if(e.isLabelName(n)){if(e.isJumpStatementTarget(n)){var a=e.getTargetLabel(n.parent,n.text);return a&&l(a.parent,a)}return l(n.parent,n)}if(e.isThis(n))return function(n,r,i){var a=e.getThisContainer(n,!1),o=32;switch(a.kind){case 151:case 150:if(e.isObjectLiteralMethod(a))break;case 149:case 148:case 152:case 153:case 154:o&=e.getModifierFlags(a),a=a.parent;break;case 265:if(e.isExternalModule(a))return;case 228:case 186:break;default:return}var s=[];if(265===a.kind)e.forEach(r,(function(e){i.throwIfCancellationRequested(),u(e,e,_(e,"this"),s)}));else{var c=a.getSourceFile();u(c,a,_(c,"this",a),s)}return[{definition:{type:"this",node:n},references:s}];function u(n,r,i,a){e.forEach(i,(function(i){var s=e.getTouchingWord(n,i,!1);if(s&&e.isThis(s)){var c=e.getThisContainer(s,!1);switch(r.kind){case 186:case 228:r.symbol===c.symbol&&a.push(t.nodeEntry(s));break;case 151:case 150:e.isObjectLiteralMethod(r)&&r.symbol===c.symbol&&a.push(t.nodeEntry(s));break;case 199:case 229:c.parent&&r.symbol===c.parent.symbol&&(32&e.getModifierFlags(c))===o&&a.push(t.nodeEntry(s));break;case 265:265!==c.kind||e.isExternalModule(c)||a.push(t.nodeEntry(s))}}}))}}(n,r,i);if(97===n.kind)return function(n){var r=e.getSuperContainer(n,!1);if(!r)return;var i=32;switch(r.kind){case 149:case 148:case 151:case 150:case 152:case 153:case 154:i&=e.getModifierFlags(r),r=r.parent;break;default:return}for(var a=[],o=r.getSourceFile(),s=_(o,"super",r),c=0,u=s;c<u.length;c++){var l=u[c],d=e.getTouchingWord(o,l,!1);if(d&&97===d.kind){var p=e.getSuperContainer(d,!1);p&&(32&e.getModifierFlags(p))===i&&p.parent.symbol===r.symbol&&a.push(t.nodeEntry(d))}}return[{definition:{type:"symbol",symbol:r.symbol,node:n},references:a}]}(n);return}(n,s,u);if(f)return f}var g=a.getTypeChecker(),v=g.getSymbolAtLocation(n);return v?1536&v.flags&&function(t){if(9!==t.kind)return!1;switch(t.parent.kind){case 233:case 248:case 238:case 244:return!0;case 181:return e.isRequireCall(t.parent,!1)||e.isImportCall(t.parent);default:return!1}}(n)?function(n,r,i){e.Debug.assert(!!r.valueDeclaration);for(var a=t.findModuleReferences(n,i,r).map((function(t){return"import"===t.kind?{type:"node",node:t.literal}:{type:"span",fileName:t.referencingFile.fileName,textSpan:e.createTextSpanFromRange(t.ref)}})),o=0,s=r.declarations;o<s.length;o++){var c=s[o];switch(c.kind){case 265:break;case 233:a.push({type:"node",node:c.name});break;default:e.Debug.fail("Expected a module symbol to be declared by a SourceFile or ModuleDeclaration.")}}return[{definition:{type:"symbol",symbol:r,node:r.valueDeclaration},references:a}]}(a,v,s):function(t,n,a,s,u,_){t=function(t,n,r){var i=n.parent;if(e.isExportSpecifier(i))return y(n,t,i,r);if(e.isImportSpecifier(i)&&i.propertyName===n)return r.getImmediateAliasedSymbol(t);return t}(t,n,s);var l=function(t,n){if(n){var r=void 0;do{r=t;for(var i=0,a=n;i<a.length;i++){var o=a[i],s=e.getMeaningFromDeclaration(o);s&t&&(t|=s)}}while(t!==r)}return t}(e.getMeaningFromLocation(n),t.declarations),d=[],p=new r(a,123===n.kind,s,u,l,_,d);if(79===n.kind)h(n,t,n,p),i(n,t,{exportingModuleSymbol:t.parent,exportKind:1},p);else{var f=p.createSearch(n,t,void 0,{allSearchSymbols:k(t,n,s,_.implementations)}),g=function(t){var n=t.declarations,r=t.flags,i=t.parent,a=t.valueDeclaration;if(a&&(186===a.kind||199===a.kind))return a;if(!n)return;if(8196&r){var o=e.find(n,(function(t){return e.hasModifier(t,8)}));return o?e.getAncestor(o,229):void 0}if(c(t))return;var s,u=i&&!(262144&t.flags);if(u&&(!(1536&i.flags&&e.isExternalModuleSymbol(i))||i.globalExports))return;for(var _=0,l=n;_<l.length;_++){var d=l[_],p=e.getContainerNode(d);if(s&&s!==p)return;if(!p||265===p.kind&&!e.isExternalOrCommonJsModule(p))return;s=p}return u?s.getSourceFile():s}(t);if(g)m(g,g.getSourceFile(),f,p);else for(var v=0,b=p.sourceFiles;v<b.length;v++){var x=b[v];p.cancellationToken.throwIfCancellationRequested(),o(x,f,p)}}return d}(v,n,s,g,u,d):d.implementations||9!==n.kind?void 0:function(n,r,i){for(var a=[],o=0,s=r;o<s.length;o++){var c=s[o];i.throwIfCancellationRequested();var u=_(c,n.text);l(c,n.text,u,a)}return[{definition:{type:"string",node:n},references:a}];function l(n,r,i,a){for(var o=0,s=i;o<s.length;o++){var c=s[o],u=e.getTouchingWord(n,c,!1);u&&9===u.kind&&u.text===r&&a.push(t.nodeEntry(u,!0))}}}(n,s,u)}};var r=function(){function n(t,n,r,i,a,o,s){this.sourceFiles=t,this.isForConstructor=n,this.checker=r,this.cancellationToken=i,this.searchMeaning=a,this.options=o,this.result=s,this.inheritsFromCache=e.createMap(),this.markSeenContainingTypeReference=e.nodeSeenTracker(),this.markSeenReExportRHS=e.nodeSeenTracker(),this.symbolIdToReferences=[],this.sourceFileToSeenSymbols=[]}return n.prototype.getImportSearches=function(e,n){return this.importTracker||(this.importTracker=t.createImportTracker(this.sourceFiles,this.checker,this.cancellationToken)),this.importTracker(e,n,this.options.isForRename)},n.prototype.createSearch=function(t,n,r,i){void 0===i&&(i={});var a=i.text,o=void 0===a?e.stripQuotes(e.unescapeLeadingUnderscores((e.getLocalSymbolForExportDefault(n)||n).escapedName)):a,s=i.allSearchSymbols,c=void 0===s?void 0:s,u=e.escapeLeadingUnderscores(o),_=this.options.implementations&&function(t,n,r){var i=(a=t,e.isRightSideOfPropertyAccess(a)&&a.parent);var a;if(!i)return;var o=r.getTypeAtLocation(i.expression);if(!o)return;if(o.symbol&&96&o.symbol.flags&&o.symbol!==n.parent)return[o.symbol];if(196608&o.flags)return v(o)}(t,n,this.checker);return{location:t,symbol:n,comingFrom:r,text:o,escapedText:u,parents:_,includes:function(t){return c?e.contains(c,t):t===n}}},n.prototype.referenceAdder=function(n,r){var i=e.getSymbolId(n),a=this.symbolIdToReferences[i];return a||(a=this.symbolIdToReferences[i]=[],this.result.push({definition:{type:"symbol",symbol:n,node:r},references:a})),function(e){return a.push(t.nodeEntry(e))}},n.prototype.addStringOrCommentReference=function(e,t){this.result.push({definition:void 0,references:[{type:"span",fileName:e,textSpan:t}]})},n.prototype.markSearchedSymbol=function(t,n){var r=e.getNodeId(t),i=e.getSymbolId(n),a=this.sourceFileToSeenSymbols[r]||(this.sourceFileToSeenSymbols[r]=[]);return!a[i]&&(a[i]=!0)},n}();function i(e,t,n,r){var i=r.getImportSearches(t,n),a=i.importSearches,s=i.singleReferences,c=i.indirectUsers;if(s.length)for(var u=r.referenceAdder(t,e),_=0,l=s;_<l.length;_++){u(l[_])}for(var d=0,p=a;d<p.length;d++){var m=p[d],g=m[0],y=m[1];f(g.getSourceFile(),r.createSearch(g,y,1),r)}if(c.length){var h=void 0;switch(n.exportKind){case 0:h=r.createSearch(e,t,1);break;case 1:h=r.options.isForRename?void 0:r.createSearch(e,t,1,{text:"default"})}if(h)for(var v=0,b=c;v<b.length;v++){o(b[v],h,r)}}}function a(e,t){for(var n=0,r=e.declarations;n<r.length;n++){var i=r[n];f(i.getSourceFile(),t.createSearch(i,e,0),t)}}function o(t,n,r){void 0!==e.getNameTable(t).get(n.escapedText)&&f(t,n,r)}function s(t,n){return e.isArrayLiteralOrObjectLiteralDestructuringPattern(t.parent.parent)&&n.getPropertySymbolOfDestructuringAssignment(t)}function c(t){var n=e.getDeclarationOfKind(t,176);if(n&&174===n.parent.kind&&!n.propertyName)return n}function u(t,n){var r=c(t);if(r){var i=n.getTypeAtLocation(r.parent),a=i&&n.getPropertyOfType(i,r.name.text);return a&&98304&a.flags?(e.Debug.assert(!!(33554432&a.flags)),a.target):a}}function _(t,n,r){void 0===r&&(r=t);var i=[];if(!n||!n.length)return i;for(var a=t.text,o=a.length,s=n.length,c=a.indexOf(n,r.pos);c>=0&&!(c>r.end);){var u=c+s;0!==c&&e.isIdentifierPart(a.charCodeAt(c-1),5)||u!==o&&e.isIdentifierPart(a.charCodeAt(u),5)||i.push(c),c=a.indexOf(n,c+s+1)}return i}function l(n,r){for(var i=[],a=n.getSourceFile(),o=r.text,s=0,c=_(a,o,n);s<c.length;s++){var u=c[s],l=e.getTouchingWord(a,u,!1);l&&(l===r||e.isJumpStatementTarget(l)&&e.getTargetLabel(l,o)===r)&&i.push(t.nodeEntry(l))}return[{definition:{type:"label",node:r},references:i}]}function d(t,n){switch(t.kind){case 71:return t.text.length===n.length;case 9:return(e.isLiteralNameOfPropertyDeclarationOrIndexAccess(t)||function(t){if(9===t.kind)return e.isNameOfModuleDeclaration(t)||e.isExpressionOfExternalModuleImportEqualsDeclaration(t);return!1}(t))&&t.text.length===n.length;case 8:return e.isLiteralNameOfPropertyDeclarationOrIndexAccess(t)&&t.text.length===n.length;case 79:return"default".length===n.length;default:return!1}}function p(n,r,i,a){for(var o=0,s=_(n,i,n);o<s.length;o++){var c=s[o],u=e.getTouchingPropertyName(n,c,!0);u.kind===r&&a.push(t.nodeEntry(u))}}function f(e,t,n){return n.cancellationToken.throwIfCancellationRequested(),m(e,e,t,n)}function m(e,t,n,r){if(r.markSearchedSymbol(t,n.symbol))for(var i=0,a=_(t,n.text,e);i<a.length;i++){g(t,a[i],n,r)}}function g(n,r,o,c){var _=e.getTouchingPropertyName(n,r,!0);if(d(_,o.text)){if(e.getMeaningFromLocation(_)&c.searchMeaning){var l=c.checker.getSymbolAtLocation(_);if(l){var p=_.parent;if(!e.isImportSpecifier(p)||p.propertyName!==_){if(e.isExportSpecifier(p))return e.Debug.assert(71===_.kind),void function(n,r,o,s,c){var u=o.parent,_=o.propertyName,l=o.name,d=u.parent,p=y(n,r,o,c.checker);if(!s.includes(p))return;_?n===_?(d.moduleSpecifier||g(),!c.options.isForRename&&c.markSeenReExportRHS(l)&&h(l,r,l,c)):c.markSeenReExportRHS(n)&&g():g();if(n!==_||!c.options.isForRename){var f=79===n.originalKeywordKind?1:0,m=t.getExportInfo(r,f,c.checker);e.Debug.assert(!!m),i(n,r,m,c)}1!==s.comingFrom&&d.moduleSpecifier&&!_&&a(c.checker.getExportSpecifierLocalTargetSymbol(o),c);function g(){h(n,p,s.location,c)}}(_,l,p,o,c);var f=function(t,n,r,i){if(t.includes(n))return n;var a=e.getContainingObjectLiteralElement(r);if(a){var o=e.forEach(D(a,i.checker),(function(n){return e.find(i.checker.getRootSymbols(n),t.includes)}));if(o)return o;var c=s(r,i.checker);if(c&&t.includes(c))return c}var _=u(n,i.checker);if(_){var l=d(_);if(l)return l}return d(n);function d(n){return e.forEach(i.checker.getRootSymbols(n),(function(n){if(t.includes(n))return n;if(n.parent&&96&n.parent.flags){if(t.parents&&!e.some(t.parents,(function(t){return function(t,n,r,i){var a=64&n.getFlags();return o(t);function o(t){if(t===n)return!0;var i=e.getSymbolId(t)+","+e.getSymbolId(n),o=r.get(i);if(void 0!==o)return o;r.set(i,!1);var c=e.forEach(t.getDeclarations(),(function(t){if(e.isClassLike(t)){if(a){var n=e.getClassImplementsHeritageClauseElements(t);if(n)for(var r=0,i=n;r<i.length;r++){if(s(i[r]))return!0}}return s(e.getClassExtendsHeritageClauseElement(t))}return!(230!==t.kind||!a)&&e.forEach(e.getInterfaceBaseTypeNodes(t),s)}));return r.set(i,c),c}function s(e){if(e){var t=i.getTypeAtLocation(e);if(t&&t.symbol)return o(t.symbol)}return!1}}(n.parent,t,i.inheritsFromCache,i.checker)})))return;var r=[];return S(n.parent,n.name,r,e.createSymbolTable(),i.checker),e.find(r,t.includes)}}))}}(o,l,_,c);f?(c.isForConstructor?function(t,n,r,i){e.isNewExpressionTarget(t)&&h(t,r.symbol,r.location,i);var a=i.referenceAdder(r.symbol,r.location);if(e.isClassLike(t.parent))e.Debug.assert(t.parent.name===t),function(t,n,r){for(var i=0,a=t.members.get("__constructor").declarations;i<a.length;i++){var o=a[i],s=e.findChildOfKind(o,123,n);e.Debug.assert(152===o.kind&&!!s),r(s)}t.exports.forEach((function(t){var n=t.valueDeclaration;if(n&&151===n.kind){var i=n.body;i&&T(i,99,(function(t){e.isNewExpressionTarget(t)&&r(t)}))}}))}(r.symbol,n,a);else{var o=(s=t,e.tryGetClassExtendingExpressionWithTypeArguments(e.climbPastPropertyAccess(s).parent));o&&e.isClassLike(o)&&function(t,n){var r=t.symbol.members.get("__constructor");if(!r)return;for(var i=0,a=r.declarations;i<a.length;i++){var o=a[i];e.Debug.assert(152===o.kind);var s=o.body;s&&T(s,97,(function(t){e.isCallExpressionTarget(t)&&n(t)}))}}(o,a)}var s}(_,n,o,c):h(_,f,o.location,c),function(e,n,r,o){var s=t.getImportOrExportSymbol(e,n,o.checker,1===r.comingFrom);if(!s)return;var c=s.symbol;0===s.kind?o.options.isForRename&&!s.isNamedImport||a(c,o):i(e,c,s.exportInfo,o)}(_,l,o,c)):function(t,n,r){var i=t.flags,a=t.valueDeclaration,o=r.checker.getShorthandAssignmentValueSymbol(a);33554432&i||!n.includes(o)||h(e.getNameOfDeclaration(a),o,n.location,r)}(l,o,c)}}}}else!c.options.implementations&&(c.options.findInStrings&&e.isInString(n,r)||c.options.findInComments&&e.isInNonReferenceComment(n,r))&&c.addStringOrCommentReference(n.fileName,e.createTextSpan(r,o.text.length))}function y(t,n,r,i){return function(t,n){var r=n.parent,i=n.propertyName,a=n.name;return e.Debug.assert(i===t||a===t),i?i===t:!r.parent.moduleSpecifier}(t,r)?i.getExportSpecifierLocalTargetSymbol(r):n}function h(t,n,r,i){var a=i.referenceAdder(n,r);i.options.implementations?function(t,n,r){if(e.isDeclarationName(t)&&function(t){if(!t)return!1;if(e.isVariableLike(t)){if(t.initializer)return!0;if(226===t.kind){var n=function(t){if(t.parent&&t.parent.parent&&208===t.parent.parent.kind)return e.Debug.assert(227===t.parent.kind),t.parent.parent}(t);return n&&e.hasModifier(n,2)}}else{if(e.isFunctionLike(t))return!!t.body||e.hasModifier(t,2);switch(t.kind){case 229:case 199:case 232:case 233:return!0}}return!1}(t.parent))return void n(t.parent);if(71!==t.kind)return;262===t.parent.kind&&C(t,r.checker,n);var i=b(t);if(i)return void n(i);var a=function(t){var n=void 0;for(;t;)e.isTypeNode(t)&&(n=t),t=t.parent;return n}(t);if(a&&r.markSeenContainingTypeReference(a)){var o=a.parent;if(e.isVariableLike(o)&&o.type===a&&o.initializer&&x(o.initializer))n(o.initializer);else if(e.isFunctionLike(o)&&o.type===a&&o.body){var s=o.body;207===s.kind?e.forEachReturnStatement(s,(function(e){e.expression&&x(e.expression)&&n(e.expression)})):x(s)&&n(s)}else e.isAssertionExpression(o)&&x(o.expression)&&n(o.expression)}}(t,a,i):a(t)}function v(e,t){void 0===t&&(t=[]);for(var n=0,r=e.types;n<r.length;n++){var i=r[n];i.symbol&&96&i.symbol.getFlags()&&t.push(i.symbol),196608&i.getFlags()&&v(i,t)}return t}function b(t){if(t&&t.parent){if(201===t.kind&&259===t.parent.kind&&e.isClassLike(t.parent.parent))return t.parent.parent;if(71===t.kind||179===t.kind)return b(t.parent)}}function x(e){switch(e.kind){case 185:return x(e.expression);case 187:case 186:case 178:case 199:case 177:return!0;default:return!1}}function k(t,n,r,i){var a=[t],o=e.getContainingObjectLiteralElement(n);if(o){if(262!==o.kind){var c=s(n,r);c&&a.push(c)}e.forEach(D(o,r),(function(t){e.addRange(a,r.getRootSymbols(t))}));var _=r.getShorthandAssignmentValueSymbol(n.parent);_&&a.push(_)}t.valueDeclaration&&146===t.valueDeclaration.kind&&e.isParameterPropertyDeclaration(t.valueDeclaration)&&e.addRange(a,r.getSymbolsOfParameterPropertyDeclaration(t.valueDeclaration,t.name));var l=u(t,r);return l&&(a.push(l),d(l)),d(t),a;function d(t){for(var n=0,o=r.getRootSymbols(t);n<o.length;n++){var s=o[n];s!==t&&a.push(s),!i&&s.parent&&96&s.parent.flags&&S(s.parent,s.name,a,e.createSymbolTable(),r)}}}function S(t,n,r,i,a){function o(e){if(e){var o=a.getTypeAtLocation(e);if(o){var s=a.getPropertyOfType(o,n);s&&r.push.apply(r,a.getRootSymbols(s)),i.set(t.escapedName,t),S(o.symbol,n,r,i,a)}}}!t||i.has(t.escapedName)||96&t.flags&&e.forEach(t.getDeclarations(),(function(t){e.isClassLike(t)?(o(e.getClassExtendsHeritageClauseElement(t)),e.forEach(e.getClassImplementsHeritageClauseElements(t),o)):230===t.kind&&e.forEach(e.getInterfaceBaseTypeNodes(t),o)}))}function D(t,n){var r=t.parent,i=n.getContextualType(r),a=function(t){if(144===t.name.kind){var n=t.name.expression;return e.isStringOrNumericLiteral(n)?n.text:void 0}return e.getTextOfIdentifierOrLiteral(t.name)}(t);if(a&&i){var o=[],s=i.getProperty(a);return s&&o.push(s),65536&i.flags&&e.forEach(i.types,(function(e){var t=e.getProperty(a);t&&o.push(t)})),o}}function C(t,n,r){var i=n.getSymbolAtLocation(t),a=n.getShorthandAssignmentValueSymbol(i.valueDeclaration);if(a)for(var o=0,s=a.getDeclarations();o<s.length;o++){var c=s[o];1&e.getMeaningFromDeclaration(c)&&r(c)}}function T(t,n,r){e.forEachChild(t,(function(e){e.kind===n&&r(e),T(e,n,r)}))}n.getReferenceEntriesForShorthandPropertyAssignment=C}(t.Core||(t.Core={}))}(e.FindAllReferences||(e.FindAllReferences={}))}(ts||(ts={})),function(e){!function(t){function n(t,n,a){var s=[],c=n.getDeclarations(),u=o(t,n,a),_=u.symbolName,l=u.symbolKind,d=u.containerName;return function(t,n,r,i,a,o){if((e.isNewExpressionTarget(n)||123===n.kind)&&32&t.flags){for(var s=0,c=t.getDeclarations();s<c.length;s++){var u=c[s];if(e.isClassLike(u))return p(u.members,!0,r,i,a,o)}e.Debug.fail("Expected declaration to have at least one class-like declaration")}return!1}(n,a,l,_,d,s)||function(t,n,r,i,a,o){if(e.isCallExpressionTarget(n)||e.isNewExpressionTarget(n)||e.isNameOfFunctionDeclaration(n))return p(t.declarations,!1,r,i,a,o);return!1}(n,a,l,_,d,s)||e.forEach(c,(function(e){s.push(i(e,l,_,d))})),s;function p(t,n,a,o,s,c){if(!t)return!1;for(var u,_=[],l=0,d=t;l<d.length;l++){var p=d[l];(n?152===p.kind:r(p))&&(_.push(p),p.body&&(u=p))}return!!_.length&&(c.push(i(u||e.lastOrUndefined(_),a,o,s)),!0)}}function r(e){switch(e.kind){case 152:case 228:case 151:case 150:return!0;default:return!1}}function i(t,n,r,i){return a(e.getNameOfDeclaration(t)||t,n,r,i)}function a(t,n,r,i){var a=t.getSourceFile();return{fileName:a.fileName,textSpan:e.createTextSpanFromNode(t,a),kind:n,name:r,containerKind:void 0,containerName:i}}function o(t,n,r){return{symbolName:t.symbolToString(n),symbolKind:e.SymbolDisplay.getSymbolKind(t,n,r),containerName:n.parent?t.symbolToString(n.parent,r):""}}function s(e,t){var n=o(e,t.symbol,t),r=n.symbolName;return i(t,n.symbolKind,r,n.containerName)}function c(e,t){for(var n=0,r=e;n<r.length;n++){var i=r[n];if(i.pos<=t&&t<=i.end)return i}}function u(t,n){return{fileName:n,textSpan:e.createTextSpanFromBounds(0,0),kind:"script",name:t,containerName:void 0,containerKind:void 0}}function _(t){return e.isRightSideOfPropertyAccess(t)?_(t.parent):t}t.getDefinitionAtPosition=function(t,o,l){var d=c(o.referencedFiles,l);if(d&&(p=e.tryResolveScriptReference(t,o,d)))return[u(d.fileName,p.fileName)];var p,f=c(o.typeReferenceDirectives,l);if(f)return(p=t.getResolvedTypeReferenceDirectives().get(f.fileName))&&p.resolvedFileName&&[u(f.fileName,p.resolvedFileName)];var m=e.getTouchingPropertyName(o,l,!0);if(m!==o){if(e.isJumpStatementTarget(m)){var g=m.text,y=e.getTargetLabel(m.parent,g);return y?[a(y,"label",g,void 0)]:void 0}var h=t.getTypeChecker(),v=function(t,n){var i=function(t){var n=_(t),r=n.parent;return r&&e.isCallLikeExpression(r)&&e.getInvokedExpression(r)===n&&r}(n),a=i&&t.getResolvedSignature(i);if(a){var o=a.declaration;if(o&&r(o))return o}return}(h,m);if(v)return[s(h,v)];var b=h.getSymbolAtLocation(m);if(b){if(2097152&b.flags&&function(e,t){if(71!==e.kind)return!1;if(e.parent===t)return!0;switch(t.kind){case 239:case 237:return!0;case 242:return 241===t.parent.kind;default:return!1}}(m,b.declarations[0])){var x=h.getAliasedSymbol(b);x.declarations&&(b=x)}if(262===m.parent.kind){var k=h.getShorthandAssignmentValueSymbol(b.valueDeclaration);if(!k)return[];var S=k.getDeclarations(),D=e.SymbolDisplay.getSymbolKind(h,k,m),C=h.symbolToString(k),T=h.symbolToString(b.parent,m);return e.map(S,(function(e){return i(e,D,C,T)}))}if(e.isPropertyName(m)&&e.isBindingElement(m.parent)&&e.isObjectBindingPattern(m.parent.parent)&&m===(m.parent.propertyName||m.parent.name)){var E=h.getTypeAtLocation(m.parent.parent);if(E){var N=e.getPropertySymbolsFromType(E,m);if(N)return e.flatMap(N,(function(e){return n(h,e,m)}))}}var A=e.getContainingObjectLiteralElement(m);return A&&h.getContextualType(A.parent)?e.flatMap(e.getPropertySymbolsFromContextualType(h,A),(function(e){return n(h,e,m)})):n(h,b,m)}}},t.getTypeDefinitionAtPosition=function(t,r,i){var a=e.getTouchingPropertyName(r,i,!0);if(a!==r){var o=t.getSymbolAtLocation(a);if(o){var s=t.getTypeOfSymbolAtLocation(o,a);if(s){if(65536&s.flags&&!(16&s.flags)){var c=[];return e.forEach(s.types,(function(r){r.symbol&&e.addRange(c,n(t,r.symbol,a))})),c}if(s.symbol)return n(t,s.symbol,a)}}}}}(e.GoToDefinition||(e.GoToDefinition={}))}(ts||(ts={})),function(e){!function(t){var n,r,i=["augments","author","argument","borrows","class","constant","constructor","constructs","default","deprecated","description","event","example","extends","field","fileOverview","function","ignore","inner","lends","link","memberOf","method","name","namespace","param","private","prop","property","public","requires","returns","see","since","static","throws","type","typedef","version"];function a(t,n){if(t)for(var r=0;r<t.length;r++)if(e.indexOf(t,t[r])===r){var i=n(t[r],r);if(i)return i}}function o(t){for(;185===t.kind;)t=t.expression;switch(t.kind){case 186:case 187:return t.parameters;case 199:for(var n=0,r=t.members;n<r.length;n++){var i=r[n];if(152===i.kind)return i.parameters}}return e.emptyArray}t.getJsDocCommentsFromDeclarations=function(t){var n=[];return a(t,(function(t){e.forEach(e.getAllJSDocs(t),(function(t){t.comment&&(n.length&&n.push(e.lineBreakPart()),n.push(e.textPart(t.comment)))}))})),n},t.getJsDocTagsFromDeclarations=function(t){var n=[];return a(t,(function(t){for(var r=0,i=e.getJSDocTags(t);r<i.length;r++){var a=i[r];276===a.kind&&n.push({name:a.tagName.text,text:a.comment})}})),n},t.getJSDocTagNameCompletions=function(){return n||(n=e.map(i,(function(e){return{name:e,kind:"keyword",kindModifiers:"",sortText:"0"}})))},t.getJSDocTagCompletions=function(){return r||(r=e.map(i,(function(e){return{name:"@"+e,kind:"keyword",kindModifiers:"",sortText:"0"}})))},t.getJSDocParameterNameCompletions=function(t){if(!e.isIdentifier(t.name))return e.emptyArray;var n=t.name.text,r=t.parent,i=r.parent;return e.isFunctionLike(i)?e.mapDefined(i.parameters,(function(i){if(e.isIdentifier(i.name)){var a=i.name.text;if(!r.tags.some((function(n){return n!==t&&e.isJSDocParameterTag(n)&&e.isIdentifier(n.name)&&n.name.escapedText===a}))&&(void 0===n||e.startsWith(a,n)))return{name:a,kind:"parameter",kindModifiers:"",sortText:"0"}}})):[]},t.getDocCommentTemplateAtPosition=function(t,n,r){if(!(e.isInString(n,r)||e.isInComment(n,r)||e.hasDocComment(n,r))){var i=e.getTokenAtPosition(n,r,!1),a=i.getStart();if(i&&!(a<r)){var s=function(t){for(var n=t;n;n=n.parent)switch(n.kind){case 228:case 151:case 152:return{commentOwner:n,parameters:n.parameters};case 229:return{commentOwner:n};case 208:var r=n.declarationList.declarations;return{commentOwner:n,parameters:1===r.length&&r[0].initializer?o(r[0].initializer):void 0};case 265:return;case 233:return 233===n.parent.kind?void 0:{commentOwner:n};case 194:var i=n;if(0===e.getSpecialPropertyAssignmentKind(i))return;return{commentOwner:n,parameters:e.isFunctionLike(i.right)?i.right.parameters:e.emptyArray}}}(i);if(s){var c=s.commentOwner,u=s.parameters;if(!(c.getStart()<r)){var _=n.getLineAndCharacterOfPosition(r),l=n.getLineStarts()[_.line],d=n.text.substr(l,_.character).replace(/\S/i,(function(){return" "})),p=e.hasJavaScriptFileExtension(n.fileName),f="";if(u)for(var m=0;m<u.length;m++){var g=u[m].name,y=71===g.kind?g.escapedText:"param"+m;f+=p?d+" * @param {any} "+y+t:d+" * @param "+y+t}var h="/**"+t+d+" * ";return{newText:h+t+f+d+" */"+(a===r?t+d:""),caretOffset:h.length}}}}}}}(e.JsDoc||(e.JsDoc={}))}(ts||(ts={})),function(e){!function(t){t.nodeCoreModuleList=["buffer","querystring","events","http","cluster","zlib","os","https","punycode","repl","readline","vm","child_process","url","dns","net","dgram","fs","path","string_decoder","tls","crypto","stream","util","assert","tty","domain","constants","process","v8","timers","console"];var n=e.arrayToSet(t.nodeCoreModuleList);t.loadSafeList=function(t,n){var r=e.readConfigFile(n,(function(e){return t.readFile(e)}));return e.createMapFromTemplate(r.config)},t.loadTypesMap=function(t,n){var r=e.readConfigFile(n,(function(e){return t.readFile(e)}));if(r.config)return e.createMapFromTemplate(r.config.simpleMap)},t.discoverTypings=function(t,r,i,a,o,s,c,u){if(!c||!c.enable)return{cachedTypingPaths:[],newTypingNames:[],filesToWatch:[]};var _=e.createMap();i=e.mapDefined(i,(function(t){var n=e.normalizePath(t);if(e.hasJavaScriptFileExtension(n))return n}));var l=[];c.include&&x(c.include,"Explicitly included types");var d=c.exclude||[],p=e.arrayToSet(i,e.getDirectoryPath);p.set(a,!0),p.forEach((function(t,n){k(e.combinePaths(n,"package.json"),l),k(e.combinePaths(n,"bower.json"),l),S(e.combinePaths(n,"bower_components"),l),S(e.combinePaths(n,"node_modules"),l)})),function(t){var n=e.mapDefined(t,(function(t){if(e.hasJavaScriptFileExtension(t)){var n=e.removeFileExtension(e.getBaseFileName(t.toLowerCase())).replace(/((?:\.|-)min(?=\.|$))|((?:-|\.)\d+)/g,"");return o.get(n)}}));n.length&&x(n,"Inferred typings from file names");e.some(t,(function(t){return e.fileExtensionIs(t,".jsx")}))&&(r&&r("Inferred 'react' typings due to presence of '.jsx' extension"),b("react"))}(i),u&&x(e.deduplicate(u.map((function(e){return n.has(e)?"node":e}))),"Inferred typings from unresolved imports"),s.forEach((function(e,t){_.has(t)&&void 0===_.get(t)&&_.set(t,e)}));for(var f=0,m=d;f<m.length;f++){var g=m[f];_.delete(g)&&r&&r("Typing for "+g+" is in exclude list, will be ignored.")}var y=[],h=[];_.forEach((function(e,t){void 0!==e?h.push(e):y.push(t)}));var v={cachedTypingPaths:h,newTypingNames:y,filesToWatch:l};return r&&r("Result: "+JSON.stringify(v)),v;function b(e){_.has(e)||_.set(e,void 0)}function x(t,n){r&&r(n+": "+JSON.stringify(t)),e.forEach(t,b)}function k(n,r){if(t.fileExists(n)){r.push(n);var i=e.readConfigFile(n,(function(e){return t.readFile(e)})).config;x(e.flatMap([i.dependencies,i.devDependencies,i.optionalDependencies,i.peerDependencies],e.getOwnKeys),"Typing names in '"+n+"' dependencies")}}function S(n,i){if(i.push(n),t.directoryExists(n)){var a=t.readDirectory(n,[".json"],void 0,void 0,2);r&&r("Searching for typing names in "+n+"; all files: "+JSON.stringify(a));for(var o=[],s=0,c=a;s<c.length;s++){var u=c[s],l=e.normalizePath(u),d=e.getBaseFileName(l);if("package.json"===d||"bower.json"===d){var p=e.readConfigFile(l,(function(e){return t.readFile(e)})).config;if(("package.json"!==d||!p._requiredBy||0!==e.filter(p._requiredBy,(function(e){return"#"===e[0]||"/"===e})).length)&&p.name){var f=p.types||p.typings;if(f){var m=e.getNormalizedAbsolutePath(f,e.getDirectoryPath(l));r&&r("    Package '"+p.name+"' provides its own types."),_.set(p.name,m)}else o.push(p.name)}}}x(o,"    Found package names")}}},function(e){e[e.Ok=0]="Ok",e[e.ScopedPackagesNotSupported=1]="ScopedPackagesNotSupported",e[e.EmptyName=2]="EmptyName",e[e.NameTooLong=3]="NameTooLong",e[e.NameStartsWithDot=4]="NameStartsWithDot",e[e.NameStartsWithUnderscore=5]="NameStartsWithUnderscore",e[e.NameContainsNonURISafeCharacters=6]="NameContainsNonURISafeCharacters"}(t.PackageNameValidationResult||(t.PackageNameValidationResult={}));t.validatePackageName=function(e){return e?e.length>214?3:46===e.charCodeAt(0)?4:95===e.charCodeAt(0)?5:/^@[^/]+\/[^/]+$/.test(e)?1:encodeURIComponent(e)!==e?6:0:2},t.renderPackageNameValidationFailure=function(t,n){switch(t){case 2:return"Package name '"+n+"' cannot be empty";case 3:return"Package name '"+n+"' should be less than 214 characters";case 4:return"Package name '"+n+"' cannot start with '.'";case 5:return"Package name '"+n+"' cannot start with '_'";case 1:return"Package '"+n+"' is scoped and currently is not supported";case 6:return"Package name '"+n+"' contains non URI safe characters";case 0:throw e.Debug.fail();default:e.Debug.assertNever(t)}}}(e.JsTyping||(e.JsTyping={}))}(ts||(ts={})),function(e){!function(t){function n(e,t){switch(e.kind){case 239:case 242:case 237:var n=t.getSymbolAtLocation(e.name),r=t.getAliasedSymbol(n);return n.escapedName!==r.escapedName;default:return!0}}function r(t){e.Debug.assert(t.length>0);for(var n=0,r=t;n<r.length;n++){if(!r[n].isCaseSensitive)return!1}return!0}function i(t,n){if(t){var r=e.getNameOfDeclaration(t);if(r){var i=e.getTextOfIdentifierOrLiteral(r);if(void 0===i)return 144===r.kind&&a(r.expression,n,!0);n.unshift(i)}}return!0}function a(t,n,r){var i=e.getTextOfIdentifierOrLiteral(t);if(void 0!==i)return r&&n.unshift(i),!0;if(179===t.kind){var o=t;return r&&n.unshift(o.name.text),a(o.expression,n,!0)}return!1}function o(t){var n=[],r=e.getNameOfDeclaration(t);if(144!==r.kind||a(r.expression,n,!1)){for(t=e.getContainerNode(t);t;){if(!i(t,n))return;t=e.getContainerNode(t)}return n}}function s(t){e.Debug.assert(t.length>0);for(var n=e.PatternMatchKind.camelCase,r=0,i=t;r<i.length;r++){var a=i[r].kind;a<n&&(n=a)}return n}function c(t,n){return t.matchKind-n.matchKind||e.compareStringsCaseInsensitive(t.name,n.name)||e.compareStrings(t.name,n.name)}function u(t){var n=t.declaration,r=e.getContainerNode(n),i=r&&e.getNameOfDeclaration(r);return{name:t.name,kind:e.getNodeKind(n),kindModifiers:e.getNodeModifiers(n),matchKind:e.PatternMatchKind[t.matchKind],isCaseSensitive:t.isCaseSensitive,fileName:t.fileName,textSpan:e.createTextSpanFromNode(n),containerName:i?i.text:"",containerKind:i?e.getNodeKind(r):""}}t.getNavigateToItems=function(t,i,a,_,l,d){for(var p=e.createPatternMatcher(_),f=[],m=function(t){if(a.throwIfCancellationRequested(),d&&e.fileExtensionIs(t.fileName,".d.ts"))return"continue";e.forEachEntry(t.getNamedDeclarations(),(function(e,a){!function(e,t,i,a,c,u){var _=e.getMatchesForLastSegmentOfPattern(t);if(!_)return;for(var l=0,d=i;l<d.length;l++){var p=d[l];if(n(p,a)){var f=_;if(!e.patternContainsDots||(f=e.getMatches(o(p),t))){var m=s(f),g=r(f);u.push({name:t,fileName:c,matchKind:m,isCaseSensitive:g,declaration:p})}}}}(p,a,e,i,t.fileName,f)}))},g=0,y=t;g<y.length;g++){m(y[g])}return f.sort(c),void 0!==l&&(f=f.slice(0,l)),f.map(u)}}(e.NavigateTo||(e.NavigateTo={}))}(ts||(ts={})),function(e){!function(t){var n,r,i,a=/\s+/g,o=[],s=[];function c(){r=void 0,n=void 0,o=[],i=void 0,s=[]}function u(e){return e.getText(r)}function _(e){return e.node.kind}function l(e,t){e.children?e.children.push(t):e.children=[t]}function d(t){e.Debug.assert(!o.length);var n={node:t,additionalNodes:void 0,parent:void 0,children:void 0,indent:0};i=n;for(var r=0,a=t.statements;r<a.length;r++){h(a[r])}return g(),e.Debug.assert(!i&&!o.length),n}function p(e){l(i,f(e))}function f(e){return{node:e,additionalNodes:void 0,parent:i,children:void 0,indent:i.indent+1}}function m(e){var t=f(e);l(i,t),o.push(i),i=t}function g(){i.children&&(v(i.children),b(i.children)),i=o.pop()}function y(e,t){m(e),h(t),g()}function h(t){if(n.throwIfCancellationRequested(),t&&!e.isToken(t))switch(t.kind){case 152:var r=t;y(r,r.body);for(var i=0,a=r.parameters;i<a.length;i++){var o=a[i];e.isParameterPropertyDeclaration(o)&&p(o)}break;case 151:case 153:case 154:case 150:e.hasDynamicName(t)||y(t,t.body);break;case 149:case 148:e.hasDynamicName(t)||p(t);break;case 239:var s=t;s.name&&p(s);var c=s.namedBindings;if(c)if(240===c.kind)p(c);else for(var u=0,_=c.elements;u<_.length;u++){p(_[u])}break;case 176:case 226:var l=t,d=l.name,f=l.initializer;e.isBindingPattern(d)?h(d):f&&function(e){switch(e.kind){case 187:case 186:case 199:return!0;default:return!1}}(f)?f.name?h(f):(m(t),e.forEachChild(f,h),g()):y(t,f);break;case 187:case 228:case 186:y(t,t.body);break;case 232:m(t);for(var v=0,b=t.members;v<b.length;v++){w(S=b[v])||p(S)}g();break;case 229:case 199:case 230:m(t);for(var x=0,k=t.members;x<k.length;x++){var S;h(S=k[x])}g();break;case 233:y(t,A(t).body);break;case 246:case 237:case 157:case 155:case 156:case 231:p(t);break;default:e.hasJSDocNodes(t)&&e.forEach(t.jsDoc,(function(t){e.forEach(t.tags,(function(e){283===e.kind&&p(e)}))})),e.forEachChild(t,h)}}function v(t){var n=e.createMap();e.filterMutate(t,(function(t){var r=e.getNameOfDeclaration(t.node),i=r&&u(r);if(!i)return!0;var a=n.get(i);if(!a)return n.set(i,t),!0;if(a instanceof Array){for(var o=0,s=a;o<s.length;o++){var c;if(_(c=s[o],t))return!1}return a.push(t),!0}return!_(c=a,t)&&(n.set(i,[c,t]),!0);function _(t,n){return!!function(e,t){return e.kind===t.kind&&(233!==e.kind||n(e,t));function n(e,t){return e.body.kind===t.body.kind&&(233!==e.body.kind||n(e.body,t.body))}}(t.node,n.node)&&(function(t,n){t.additionalNodes=t.additionalNodes||[],t.additionalNodes.push(n.node),n.additionalNodes&&(r=t.additionalNodes).push.apply(r,n.additionalNodes);t.children=e.concatenate(t.children,n.children),t.children&&(v(t.children),b(t.children));var r}(t,n),!0)}}))}function b(e){e.sort(x)}function x(t,n){var r=k(t.node),i=k(n.node);if(r&&i){var a=e.compareStringsCaseInsensitive(r,i);return 0!==a?a:_(t)-_(n)}return r?1:i?-1:_(t)-_(n)}function k(t){if(233===t.kind)return N(t);var n=e.getNameOfDeclaration(t);if(n)return e.unescapeLeadingUnderscores(e.getPropertyNameForPropertyNameNode(n));switch(t.kind){case 186:case 187:case 199:return O(t);case 283:return D(t);default:return}}function S(t){if(233===t.kind)return N(t);var n=e.getNameOfDeclaration(t);if(n){var r=u(n);if(r.length>0)return r}switch(t.kind){case 265:var i=t;return e.isExternalModule(i)?'"'+e.escapeString(e.getBaseFileName(e.removeFileExtension(e.normalizePath(i.fileName))))+'"':"<global>";case 187:case 228:case 186:case 229:case 199:return 512&e.getModifierFlags(t)?"default":O(t);case 152:return"constructor";case 156:return"new()";case 155:return"()";case 157:return"[]";case 283:return D(t);default:return"<unknown>"}}function D(e){if(e.name)return e.name.text;var t=e.parent&&e.parent.parent;if(t&&208===t.kind&&t.declarationList.declarations.length>0){var n=t.declarationList.declarations[0].name;if(71===n.kind)return n.text}return"<typedef>"}function C(t){return{text:S(t.node),kind:e.getNodeKind(t.node),kindModifiers:F(t.node),spans:E(t),childItems:e.map(t.children,C)}}function T(t){return{text:S(t.node),kind:e.getNodeKind(t.node),kindModifiers:F(t.node),spans:E(t),childItems:e.map(t.children,(function(t){return{text:S(t.node),kind:e.getNodeKind(t.node),kindModifiers:e.getNodeModifiers(t.node),spans:E(t),childItems:s,indent:0,bolded:!1,grayed:!1}}))||s,indent:t.indent,bolded:!1,grayed:!1}}function E(e){var t=[P(e.node)];if(e.additionalNodes)for(var n=0,r=e.additionalNodes;n<r.length;n++){var i=r[n];t.push(P(i))}return t}function N(t){if(e.isAmbientModule(t))return e.getTextOfNode(t.name);var n=[];for(n.push(e.getTextOfIdentifierOrLiteral(t.name));t.body&&233===t.body.kind;)t=t.body,n.push(e.getTextOfIdentifierOrLiteral(t.name));return n.join(".")}function A(e){return 233===e.body.kind?A(e.body):e}function w(e){return!e.name||144===e.name.kind}function P(t){return 265===t.kind?e.createTextSpanFromBounds(t.getFullStart(),t.getEnd()):e.createTextSpanFromNode(t,r)}function F(t){return t.parent&&226===t.parent.kind&&(t=t.parent),e.getNodeModifiers(t)}function O(t){return t.name&&e.getFullWidth(t.name)>0?e.declarationNameToString(t.name):226===t.parent.kind?e.declarationNameToString(t.parent.name):194===t.parent.kind&&58===t.parent.operatorToken.kind?u(t.parent.left).replace(a,""):261===t.parent.kind&&t.parent.name?u(t.parent.name):512&e.getModifierFlags(t)?"default":e.isClassLike(t)?"<class>":"<function>"}t.getNavigationBarItems=function(t,i){n=i,r=t;try{return e.map(function(t){var n=[];function r(e){if(i(e)&&(n.push(e),e.children))for(var t=0,a=e.children;t<a.length;t++){r(a[t])}}return r(t),n;function i(t){switch(_(t)){case 229:case 199:case 232:case 230:case 233:case 265:case 231:case 283:return!0;case 152:case 151:case 153:case 154:case 226:return r(t);case 187:case 228:case 186:return n(t);default:return!1}function n(e){if(!e.node.body)return!1;switch(_(e.parent)){case 234:case 265:case 151:case 152:return!0;default:return r(e)}}function r(t){return e.forEach(t.children,(function(e){var t=_(e);return 226!==t&&176!==t}))}}}(d(t)),T)}finally{c()}},t.getNavigationTree=function(e,t){n=t,r=e;try{return C(d(e))}finally{c()}}}(e.NavigationBar||(e.NavigationBar={}))}(ts||(ts={})),function(e){!function(t){var n="...",r=new RegExp("^\\s*//\\s*#(end)?region(?:\\s+(.*))?$");t.collectElements=function(t,i){var a=[],o=0,s=[];return function r(s){if(i.throwIfCancellationRequested(),o>40)return;e.isDeclaration(s)&&function(n){var r=e.getLeadingCommentRangesOfNode(n,t);if(r){for(var a=-1,o=-1,s=!0,c=0,l=0,d=r;l<d.length;l++){var p=d[l];i.throwIfCancellationRequested(),2===p.kind?(s&&(a=p.pos),s=!1,o=p.end,c++):3===p.kind&&(_(c,a,o),u(p,!1),c=0,o=-1,s=!0)}_(c,a,o)}}(s);switch(s.kind){case 207:if(!e.isFunctionBlock(s)){var d=s.parent,p=e.findChildOfKind(s,17,t),f=e.findChildOfKind(s,18,t);if(212===d.kind||215===d.kind||216===d.kind||214===d.kind||211===d.kind||213===d.kind||220===d.kind||260===d.kind){c(d,p,f,l(s),!0);break}if(224===d.kind){var m=d;if(m.tryBlock===s){c(d,p,f,l(s),!0);break}if(m.finallyBlock===s){var g=e.findChildOfKind(m,87,t);if(g){c(g,p,f,l(s),!0);break}}}var y=e.createTextSpanFromNode(s);a.push({textSpan:y,hintSpan:y,bannerText:n,autoCollapse:l(s)});break}case 234:var h=e.findChildOfKind(s,17,t),v=e.findChildOfKind(s,18,t);c(s.parent,h,v,l(s),!0);break;case 229:case 230:case 232:case 235:var b=e.findChildOfKind(s,17,t),x=e.findChildOfKind(s,18,t);c(s,b,x,l(s),!0);break;case 178:var k=e.findChildOfKind(s,17,t),S=e.findChildOfKind(s,18,t);c(s,k,S,l(s),!e.isArrayLiteralExpression(s.parent));break;case 177:var D=e.findChildOfKind(s,21,t),C=e.findChildOfKind(s,22,t);c(s,D,C,l(s),!e.isArrayLiteralExpression(s.parent))}o++,e.forEachChild(s,r),o--}(t),function(){for(var n=t.getLineStarts(),i=0;i<n.length;i++){var o=n[i],c=n[i+1]-1||t.getEnd(),u=t.text.substring(o,c).match(r);if(u&&!e.isInComment(t,o))if(u[1]){(d=s.pop())&&(d.textSpan.length=c-d.textSpan.start,d.hintSpan.length=c-d.textSpan.start,a.push(d))}else{var _=t.getFullText().indexOf("//",o),l=e.createTextSpanFromBounds(_,c),d={textSpan:l,hintSpan:l,bannerText:u[2]||"#region",autoCollapse:!1};s.push(d)}}}(),a.sort((function(e,t){return e.textSpan.start-t.textSpan.start}));function c(r,i,o,s,c){if(r&&i&&o){var u={textSpan:e.createTextSpanFromBounds(c?i.getFullStart():i.getStart(),o.getEnd()),hintSpan:e.createTextSpanFromNode(r,t),bannerText:n,autoCollapse:s};a.push(u)}}function u(t,r){if(t){var i={textSpan:e.createTextSpanFromBounds(t.pos,t.end),hintSpan:e.createTextSpanFromBounds(t.pos,t.end),bannerText:n,autoCollapse:r};a.push(i)}}function _(e,t,n){e>1&&u({kind:2,pos:t,end:n},!1)}function l(t){return e.isFunctionBlock(t)&&187!==t.parent.kind}}}(e.OutliningElementsCollector||(e.OutliningElementsCollector={}))}(ts||(ts={})),function(e){var t;function n(e,t,n,r){return{kind:e,punctuationStripped:t,isCaseSensitive:n,camelCaseWeight:r}}function r(e){return 0===e.subWordTextChunks.length}function i(t){if(t>=65&&t<=90)return!0;if(t<127||!e.isUnicodeIdentifierStart(t,5))return!1;var n=String.fromCharCode(t);return n===n.toUpperCase()}function a(t){if(t>=97&&t<=122)return!0;if(t<127||!e.isUnicodeIdentifierStart(t,5))return!1;var n=String.fromCharCode(t);return n===n.toLowerCase()}function o(e,t,n){for(var r=0;r<t.length;r++){if(s(e.charCodeAt(r+n))!==t.charCodeAt(r))return!1}return!0}function s(e){return e>=65&&e<=90?e-65+97:e<127?e:String.fromCharCode(e).toLowerCase().charCodeAt(0)}function c(e){return e>=48&&e<=57}function u(e){return i(e)||a(e)||c(e)||95===e||36===e}function _(e){for(var t=[],n=0,r=0,i=0;i<e.length;i++){u(e.charCodeAt(i))?(0===r&&(n=i),r++):r>0&&(t.push(l(e.substr(n,r))),r=0)}return r>0&&t.push(l(e.substr(n,r))),t}function l(e){var t=e.toLowerCase();return{text:e,textLowerCase:t,isLowerCase:e===t,characterSpans:d(e)}}function d(e){return f(e,!1)}function p(e){return f(e,!0)}function f(t,n){for(var r=[],i=0,a=1;a<t.length;a++){var o=c(t.charCodeAt(a-1)),s=c(t.charCodeAt(a)),u=h(t,n,a),_=y(t,n,a,i);(m(t.charCodeAt(a-1))||m(t.charCodeAt(a))||o!==s||u||_)&&(g(t,i,a)||r.push(e.createTextSpan(i,a-i)),i=a)}return g(t,i,t.length)||r.push(e.createTextSpan(i,t.length-i)),r}function m(e){switch(e){case 33:case 34:case 35:case 37:case 38:case 39:case 40:case 41:case 42:case 44:case 45:case 46:case 47:case 58:case 59:case 63:case 64:case 91:case 92:case 93:case 95:case 123:case 125:return!0}return!1}function g(e,t,n){for(var r=t;r<n;r++){var i=e.charCodeAt(r);if(!m(i)||95===i||36===i)return!1}return!0}function y(e,t,n,r){if(t&&n!==r&&n+1<e.length){var o=i(e.charCodeAt(n)),s=a(e.charCodeAt(n+1));if(o&&s){for(var c=r;c<n;c++)if(!i(e.charCodeAt(c)))return!1;return!0}}return!1}function h(e,t,n){var r=i(e.charCodeAt(n-1)),a=i(e.charCodeAt(n));return t?a&&!r:a}!function(e){e[e.exact=0]="exact",e[e.prefix=1]="prefix",e[e.substring=2]="substring",e[e.camelCase=3]="camelCase"}(t=e.PatternMatchKind||(e.PatternMatchKind={})),e.createPatternMatcher=function(a){var c=e.createMap(),u=(a=a.trim()).split(".").map((function(e){return{totalTextChunk:l(t=e.trim()),subWordTextChunks:_(t)};var t})),d=0===u.length||e.forEach(u,r);return{getMatches:function(t,n){if(f(n))return;var r=y(n,e.lastOrUndefined(u));if(!r)return;if(t=t||[],u.length-1>t.length)return;for(var i=r,a=u.length-2,o=t.length-1;a>=0;a-=1,o-=1){var s=u[a],c=y(t[o],s);if(!c)return;e.addRange(i,c)}return i},getMatchesForLastSegmentOfPattern:function(t){if(f(t))return;return y(t,e.lastOrUndefined(u))},patternContainsDots:u.length>1};function f(e){return d||!e}function m(e){var t=c.get(e);return t||c.set(e,t=p(e)),t}function g(r,a,s){var c=function(e,t){for(var n=e.length-t.length,r=0;r<=n;r++)if(o(e,t,r))return r;return-1}(r,a.textLowerCase);if(0===c)return a.text.length===r.length?n(t.exact,s,r===a.text):n(t.prefix,s,e.startsWith(r,a.text));var u=a.isLowerCase;if(u){if(c>0)for(var _=0,l=m(r);_<l.length;_++){var d=l[_];if(h(r,d,a.text,!0))return n(t.substring,s,h(r,d,a.text,!1))}}else if(r.indexOf(a.text)>0)return n(t.substring,s,!0);if(!u&&a.characterSpans.length>0){var p=m(r),f=v(r,p,a,!1);if(void 0!==f)return n(t.camelCase,s,!0,f);if(void 0!==(f=v(r,p,a,!0)))return n(t.camelCase,s,!1,f)}return u&&a.text.length<r.length&&c>0&&i(r.charCodeAt(c))?n(t.substring,s,!1):void 0}function y(e,t){if(!function(e){for(var t=0;t<e.length;t++){var n=e.charCodeAt(t);if(32===n||42===n)return!0}return!1}(t.totalTextChunk.text)){var n=g(e,t.totalTextChunk,!1);if(n)return[n]}for(var r=void 0,i=0,a=t.subWordTextChunks;i<a.length;i++){var o=g(e,a[i],!0);if(!o)return;(r=r||[]).push(o)}return r}function h(e,t,n,r,i){var a=i?i.start:0,o=i?i.length:n.length;if(o>t.length)return!1;if(r)for(var c=0;c<o;c++){var u=n.charCodeAt(a+c),_=e.charCodeAt(t.start+c);if(s(u)!==s(_))return!1}else for(c=0;c<o;c++){if((u=n.charCodeAt(a+c))!==(_=e.charCodeAt(t.start+c)))return!1}return!0}function v(t,n,r,a){for(var o=r.characterSpans,s=0,c=0,u=void 0,_=void 0;;){if(c===o.length){var l=0;return _&&(l+=1),0===u&&(l+=2),l}if(s===n.length)return;for(var d=n[s],p=!1;c<o.length;c++){var f=o[c];if(p&&(!i(r.text.charCodeAt(o[c-1].start))||!i(r.text.charCodeAt(o[c].start))))break;if(!h(t,d,r.text,a,f))break;p=!0,u=void 0===u?s:u,_=void 0===_||_,d=e.createTextSpan(d.start+f.length,d.length-f.length)}p||void 0===_||(_=!1),s++}}},e.breakIntoCharacterSpans=d,e.breakIntoWordSpans=p}(ts||(ts={})),function(e){e.preProcessFile=function(t,n,r){void 0===n&&(n=!0),void 0===r&&(r=!1);var i,a,o=[],s=[],c=[],u=!1,_=0,l=!1;function d(){var t=e.scanner.scan();return 17===t?_++:18===t&&_--,t}function p(){var t=e.scanner.getTokenValue(),n=e.scanner.getTokenPos();return{fileName:t,pos:n,end:n+t.length}}function f(){c.push(p()),m()}function m(){0===_&&(l=!0)}function g(){var t=e.scanner.getToken();return 124===t&&(128===(t=d())&&9===(t=d())&&(i||(i=[]),i.push({ref:p(),depth:_})),!0)}function y(){var t=e.scanner.getToken();if(91===t){if(19===(t=d())){if(9===(t=d()))return f(),!0}else{if(9===t)return f(),!0;if(71===t||e.isKeyword(t))if(140===(t=d())){if(9===(t=d()))return f(),!0}else if(58===t){if(v(!0))return!0}else{if(26!==t)return!0;t=d()}if(17===t){for(t=d();18!==t&&1!==t;)t=d();18===t&&140===(t=d())&&9===(t=d())&&f()}else 39===t&&118===(t=d())&&(71===(t=d())||e.isKeyword(t))&&140===(t=d())&&9===(t=d())&&f()}return!0}return!1}function h(){var t=e.scanner.getToken();if(84===t){if(m(),17===(t=d())){for(t=d();18!==t&&1!==t;)t=d();18===t&&140===(t=d())&&9===(t=d())&&f()}else if(39===t)140===(t=d())&&9===(t=d())&&f();else if(91===t&&(71===(t=d())||e.isKeyword(t))&&58===(t=d())&&v(!0))return!0;return!0}return!1}function v(t){var n=t?d():e.scanner.getToken();return 132===n&&(19===(n=d())&&9===(n=d())&&f(),!0)}function b(){var t=e.scanner.getToken();if(71===t&&"define"===e.scanner.getTokenValue()){if(19!==(t=d()))return!0;if(9===(t=d())){if(26!==(t=d()))return!0;t=d()}if(21!==t)return!0;for(t=d();22!==t&&1!==t;)9===t&&f(),t=d();return!0}return!1}if(n&&function(){for(e.scanner.setText(t),d();1!==e.scanner.getToken();)g()||y()||h()||r&&(v(!1)||b())||d();e.scanner.setText(void 0)}(),a=e.getLeadingCommentRanges(t,0),e.forEach(a,(function(n){var r=t.substring(n.pos,n.end),i=e.getFileReferenceFromReferencePath(r,n);if(i){u=i.isNoDefaultLib;var a=i.fileReference;a&&(i.isTypeReferenceDirective?s:o).push(a)}})),l){if(i)for(var x=0,k=i;x<k.length;x++){var S=k[x];c.push(S.ref)}return{referencedFiles:o,typeReferenceDirectives:s,importedFiles:c,isLibFile:u,ambientExternalModules:void 0}}var D=void 0;if(i)for(var C=0,T=i;C<T.length;C++){0===(S=T[C]).depth?(D||(D=[]),D.push(S.ref.fileName)):c.push(S.ref)}return{referencedFiles:o,typeReferenceDirectives:s,importedFiles:c,isLibFile:u,ambientExternalModules:D}}}(ts||(ts={})),function(e){!function(t){function n(e,t,n,r,a,o){return{canRename:!0,kind:n,displayName:e,localizedErrorMessage:void 0,fullDisplayName:t,kindModifiers:r,triggerSpan:i(a,o)}}function r(t){return{canRename:!1,localizedErrorMessage:e.getLocaleSpecificMessage(t),displayName:void 0,fullDisplayName:void 0,kind:void 0,kindModifiers:void 0,triggerSpan:void 0}}function i(t,n){var r=t.getStart(n),i=t.getWidth(n);return 9===t.kind&&(r+=1,i-=2),e.createTextSpan(r,i)}t.getRenameInfo=function(t,i,a,o,s){var c=e.memoize((function(){return a(e.normalizePath(i))})),u=e.getTouchingWord(o,s,!0);return(u&&function(t){switch(t.kind){case 71:case 9:case 99:return!0;case 8:return e.isLiteralNameOfPropertyDeclarationOrIndexAccess(t);default:return!1}}(u)?function(t,i,a,o){var s=i.getSymbolAtLocation(t);if(s){var c=s.getDeclarations();if(c&&c.length>0){if(e.some(c,o))return r(e.Diagnostics.You_cannot_rename_elements_that_are_defined_in_the_standard_TypeScript_library);if(71===t.kind&&79===t.originalKeywordKind&&1536&s.parent.flags)return;var u=e.stripQuotes(e.getDeclaredName(i,s,t)),_=e.SymbolDisplay.getSymbolKind(i,s,t);return _?n(u,i.getFullyQualifiedName(s),_,e.SymbolDisplay.getSymbolModifiers(s),t,a):void 0}}else if(9===t.kind){return o(t)?r(e.Diagnostics.You_cannot_rename_elements_that_are_defined_in_the_standard_TypeScript_library):n(u=e.stripQuotes(t.text),u,"var","",t,a)}}(u,t,o,(function(t){if(!i)return!1;var n=t.getSourceFile();return a(e.normalizePath(n.fileName))===c()})):void 0)||r(e.Diagnostics.You_cannot_rename_this_element)}}(e.Rename||(e.Rename={}))}(ts||(ts={})),function(e){!function(t){function n(t,n,i){if(e.isCallOrNewExpression(t.parent)){var a=t.parent,o=void 0,s=void 0;if(27===t.kind||19===t.kind)o=function(t,n,r){var i=t.getChildren(r),a=i.indexOf(n);return e.Debug.assert(a>=0&&i.length>a+1),i[a+1]}(a,t,i),e.Debug.assert(void 0!==o),s=0;else{if(!(o=e.findContainingList(t)))return;s=function(e,t){for(var n=0,r=e.getChildren(),i=0,a=r;i<a.length;i++){var o=a[i];if(o===t)break;26!==o.kind&&n++}return n}(o,t)}var c=a.typeArguments&&a.typeArguments.pos===o.pos?0:1,u=function(t){var n=t.getChildren(),r=e.countWhere(n,(function(e){return 26!==e.kind}));n.length>0&&26===e.lastOrUndefined(n).kind&&r++;return r}(o);return 0!==s&&e.Debug.assertLessThan(s,u),{kind:c,invocation:a,argumentsSpan:function(t,n){var r=t.getFullStart(),i=e.skipTrivia(n.text,t.getEnd(),!1);return e.createTextSpan(r,i-r)}(o,i),argumentIndex:s,argumentCount:u}}if(13===t.kind&&183===t.parent.kind){if(e.isInsideTemplateLiteral(t,n))return r(t.parent,0,i)}else{if(14===t.kind&&183===t.parent.parent.kind){var _=(l=t.parent).parent;return e.Debug.assert(196===l.kind),r(_,s=e.isInsideTemplateLiteral(t,n)?0:1,i)}if(205===t.parent.kind&&183===t.parent.parent.parent.kind){var l,d=t.parent;_=(l=d.parent).parent;if(e.Debug.assert(196===l.kind),16===t.kind&&!e.isInsideTemplateLiteral(t,n))return;return r(_,s=function(t,n,r){if(e.Debug.assert(r>=n.getStart(),"Assumed 'position' could not occur before node."),e.isTemplateLiteralKind(n.kind))return e.isInsideTemplateLiteral(n,r)?0:t+2;return t+1}(l.templateSpans.indexOf(d),t,n),i)}if(t.parent&&e.isJsxOpeningLikeElement(t.parent)){var p=t.parent.attributes.getFullStart(),f=e.skipTrivia(i.text,t.parent.attributes.getEnd(),!1);return{kind:3,invocation:t.parent,argumentsSpan:e.createTextSpan(p,f-p),argumentIndex:0,argumentCount:1}}}}function r(t,n,r){var a=13===t.template.kind?1:t.template.templateSpans.length+1;return 0!==n&&e.Debug.assertLessThan(n,a),{kind:2,invocation:t,argumentsSpan:i(t,r),argumentIndex:n,argumentCount:a}}function i(t,n){var r=t.template,i=r.getStart(),a=r.getEnd();196===r.kind&&(0===e.lastOrUndefined(r.templateSpans).literal.getFullWidth()&&(a=e.skipTrivia(n.text,a,!1)));return e.createTextSpan(i,a-i)}function a(t,r,i){for(var a=t;265!==a.kind;a=a.parent){if(e.isFunctionBlock(a))return;(a.pos<a.parent.pos||a.end>a.parent.end)&&e.Debug.fail("Node of kind "+a.kind+" is not a subspan of its parent of kind "+a.parent.kind);var o=n(a,r,i);if(o)return o}}function o(t,n,r,i){var a=r.argumentCount,o=r.argumentsSpan,s=r.invocation,c=r.argumentIndex,u=0===r.kind,_=e.getInvokedExpression(s),l=i.getSymbolAtLocation(_),d=l&&e.symbolToDisplayParts(i,l,void 0,void 0),p=e.map(t,(function(t){var n,r,a=[],o=[];if(d&&e.addRange(a,d),u){r=!1,a.push(e.punctuationPart(27));var c=(t.target||t).typeParameters;n=c&&c.length>0?e.map(c,g):e.emptyArray,o.push(e.punctuationPart(29));var _=e.mapToDisplayParts((function(e){return i.getSymbolDisplayBuilder().buildDisplayForParametersAndDelimiters(t.thisParameter,t.parameters,e,s)}));e.addRange(o,_)}else{r=t.hasRestParameter;var l=e.mapToDisplayParts((function(e){return i.getSymbolDisplayBuilder().buildDisplayForTypeParametersAndDelimiters(t.typeParameters,e,s)}));e.addRange(a,l),a.push(e.punctuationPart(19)),n=e.map(t.parameters,m),o.push(e.punctuationPart(20))}var p=e.mapToDisplayParts((function(e){return i.getSymbolDisplayBuilder().buildReturnTypeDisplay(t,e,s)}));return e.addRange(o,p),{isVariadic:r,prefixDisplayParts:a,suffixDisplayParts:o,separatorDisplayParts:[e.punctuationPart(26),e.spacePart()],parameters:n,documentation:t.getDocumentationComment(),tags:t.getJsDocTags()}}));0!==c&&e.Debug.assertLessThan(c,a);var f=t.indexOf(n);return e.Debug.assert(-1!==f),{items:p,applicableSpan:o,selectedItemIndex:f,argumentIndex:c,argumentCount:a};function m(t){var n=e.mapToDisplayParts((function(e){return i.getSymbolDisplayBuilder().buildParameterDisplay(t,e,s)}));return{name:t.name,documentation:t.getDocumentationComment(),displayParts:n,isOptional:i.isOptionalParameter(t.valueDeclaration)}}function g(t){var n=e.mapToDisplayParts((function(e){return i.getSymbolDisplayBuilder().buildTypeParameterDisplay(t,e,s)}));return{name:t.symbol.name,documentation:e.emptyArray,displayParts:n,isOptional:!1}}}!function(e){e[e.TypeArguments=0]="TypeArguments",e[e.CallArguments=1]="CallArguments",e[e.TaggedTemplateArguments=2]="TaggedTemplateArguments",e[e.JSXAttributesArguments=3]="JSXAttributesArguments"}(t.ArgumentListKind||(t.ArgumentListKind={})),t.getSignatureHelpItems=function(t,n,r,i){var s=t.getTypeChecker(),c=e.findTokenOnLeftOfPosition(n,r);if(c){var u=a(c,r,n);if(u){i.throwIfCancellationRequested();var _=u.invocation,l=[],d=s.getResolvedSignature(_,l,u.argumentCount);return i.throwIfCancellationRequested(),l.length?o(l,d,u,s):e.isSourceFileJavaScript(n)?function(e,t){if(181!==e.invocation.kind)return;var n=e.invocation.expression,r=71===n.kind?n:179===n.kind?n.name:void 0;if(!r||!r.escapedText)return;for(var i=t.getTypeChecker(),a=0,s=t.getSourceFiles();a<s.length;a++){var c=s[a].getNamedDeclarations().get(r.text);if(c)for(var u=0,_=c;u<_.length;u++){var l=_[u],d=l.symbol;if(d){var p=i.getTypeOfSymbolAtLocation(d,l);if(p){var f=p.getCallSignatures();if(f&&f.length)return o(f,f[0],e,i)}}}}}(u,t):void 0}}},t.getImmediatelyContainingArgumentInfo=n,t.getContainingArgumentInfo=a}(e.SignatureHelp||(e.SignatureHelp={}))}(ts||(ts={})),function(e){!function(t){function n(t,n,i){var a=e.getCombinedLocalAndExportSymbolFlags(n);if(32&a)return e.getDeclarationOfKind(n,199)?"local class":"class";if(384&a)return"enum";if(524288&a)return"type";if(64&a)return"interface";if(262144&a)return"type parameter";var o=r(t,n,i);if(""===o){if(262144&a)return"type parameter";if(8&a)return"enum member";if(2097152&a)return"alias";if(1536&a)return"module"}return o}function r(t,n,r){if(t.isUndefinedSymbol(n))return"var";if(t.isArgumentsSymbol(n))return"local var";if(99===r.kind&&e.isExpression(r))return"parameter";var a=e.getCombinedLocalAndExportSymbolFlags(n);if(3&a)return e.isFirstDeclarationOfSymbolParameter(n)?"parameter":n.valueDeclaration&&e.isConst(n.valueDeclaration)?"const":e.forEach(n.declarations,e.isLet)?"let":i(n)?"local var":"var";if(16&a)return i(n)?"local function":"function";if(32768&a)return"getter";if(65536&a)return"setter";if(8192&a)return"method";if(16384&a)return"constructor";if(4&a){if(33554432&a&&6&n.checkFlags){var o=e.forEach(t.getRootSymbols(n),(function(t){var n=t.getFlags();if(98311&n)return"property";e.Debug.assert(!!(8208&n))}));return o||(t.getTypeOfSymbolAtLocation(n,r).getCallSignatures().length?"method":"property")}return r.parent&&e.isJsxAttribute(r.parent)?"JSX attribute":"property"}return""}function i(t){return!t.parent&&e.forEach(t.declarations,(function(t){if(186===t.kind)return!0;if(226!==t.kind&&228!==t.kind)return!1;for(var n=t.parent;!e.isFunctionBlock(n);n=n.parent)if(265===n.kind||234===n.kind)return!1;return!0}))}t.getSymbolKind=n,t.getSymbolModifiers=function(t){return t&&t.declarations&&t.declarations.length>0?e.getNodeModifiers(t.declarations[0]):""},t.getSymbolDisplayPartsDocumentationAndSymbolKind=function(t,i,a,o,s,c){void 0===c&&(c=e.getMeaningFromLocation(s));var u,_,l,d,p=[],f=e.getCombinedLocalAndExportSymbolFlags(i),m=r(t,i,s),g=99===s.kind&&e.isExpression(s);if(""!==m||32&f||2097152&f){"getter"!==m&&"setter"!==m||(m="property");var y=void 0;if(d=g?t.getTypeAtLocation(s):t.getTypeOfSymbolAtLocation(i.exportSymbol||i,s),s.parent&&179===s.parent.kind){var h=s.parent.name;(h===s||h&&0===h.getFullWidth())&&(s=s.parent)}var v=void 0;if(e.isCallOrNewExpression(s)?v=s:(e.isCallExpressionTarget(s)||e.isNewExpressionTarget(s)||s.parent&&e.isJsxOpeningLikeElement(s.parent)&&e.isFunctionLike(i.valueDeclaration))&&(v=s.parent),v){y=t.getResolvedSignature(v,[]);var b=182===v.kind||e.isCallExpression(v)&&97===v.expression.kind,x=b?d.getConstructSignatures():d.getCallSignatures();if(e.contains(x,y.target)||e.contains(x,y)||(y=x.length?x[0]:void 0),y){switch(b&&32&f?(m="constructor",I(d.symbol,m)):2097152&f?(R(m="alias"),p.push(e.spacePart()),b&&(p.push(e.keywordPart(94)),p.push(e.spacePart())),O(i)):I(i,m),m){case"JSX attribute":case"property":case"var":case"const":case"let":case"parameter":case"local var":p.push(e.punctuationPart(56)),p.push(e.spacePart()),b&&(p.push(e.keywordPart(94)),p.push(e.spacePart())),32768&d.flags&&16&d.objectFlags||!d.symbol||e.addRange(p,e.symbolToDisplayParts(t,d.symbol,o,void 0,1)),L(y,x,16);break;default:L(y,x)}l=!0}}else if(e.isNameOfFunctionDeclaration(s)&&!(98304&f)||123===s.kind&&152===s.parent.kind){var k=s.parent;if(e.find(i.declarations,(function(e){return e===(123===s.kind?k.parent:k)}))){x=152===k.kind?d.getNonNullableType().getConstructSignatures():d.getNonNullableType().getCallSignatures();y=t.isImplementationOfOverload(k)?x[0]:t.getSignatureFromDeclaration(k),152===k.kind?(m="constructor",I(d.symbol,m)):I(155!==k.kind||2048&d.symbol.flags||4096&d.symbol.flags?i:d.symbol,m),L(y,x),l=!0}}}if(32&f&&!l&&!g&&(e.getDeclarationOfKind(i,199)?R("local class"):p.push(e.keywordPart(75)),p.push(e.spacePart()),O(i),M(i,a)),64&f&&2&c&&(P(),p.push(e.keywordPart(109)),p.push(e.spacePart()),O(i),M(i,a)),524288&f&&(P(),p.push(e.keywordPart(138)),p.push(e.spacePart()),O(i),M(i,a),p.push(e.spacePart()),p.push(e.operatorPart(58)),p.push(e.spacePart()),e.addRange(p,e.typeToDisplayParts(t,t.getDeclaredTypeOfSymbol(i),o,1024))),384&f&&(P(),e.forEach(i.declarations,e.isConstEnumDeclaration)&&(p.push(e.keywordPart(76)),p.push(e.spacePart())),p.push(e.keywordPart(83)),p.push(e.spacePart()),O(i)),1536&f){P();var S=(A=e.getDeclarationOfKind(i,233))&&A.name&&71===A.name.kind;p.push(e.keywordPart(S?129:128)),p.push(e.spacePart()),O(i)}if(262144&f&&2&c)if(P(),p.push(e.punctuationPart(19)),p.push(e.textPart("type parameter")),p.push(e.punctuationPart(20)),p.push(e.spacePart()),O(i),i.parent)F(),O(i.parent,o),M(i.parent,o);else{var D=e.getDeclarationOfKind(i,145);if(e.Debug.assert(void 0!==D),A=D.parent)if(e.isFunctionLikeKind(A.kind)){F();y=t.getSignatureFromDeclaration(A);156===A.kind?(p.push(e.keywordPart(94)),p.push(e.spacePart())):155!==A.kind&&A.name&&O(A.symbol),e.addRange(p,e.signatureToDisplayParts(t,y,a,64))}else 231===A.kind&&(F(),p.push(e.keywordPart(138)),p.push(e.spacePart()),O(A.symbol),M(A.symbol,a))}if(8&f&&(m="enum member",I(i,"enum member"),264===(A=i.declarations[0]).kind)){var C=t.getConstantValue(A);void 0!==C&&(p.push(e.spacePart()),p.push(e.operatorPart(58)),p.push(e.spacePart()),p.push(e.displayPart(e.getTextOfConstantValue(C),"number"==typeof C?e.SymbolDisplayPartKind.numericLiteral:e.SymbolDisplayPartKind.stringLiteral)))}if(2097152&f){switch(P(),i.declarations[0].kind){case 236:p.push(e.keywordPart(84)),p.push(e.spacePart()),p.push(e.keywordPart(129));break;case 243:p.push(e.keywordPart(84)),p.push(e.spacePart()),p.push(e.keywordPart(i.declarations[0].isExportEquals?58:79));break;default:p.push(e.keywordPart(91))}p.push(e.spacePart()),O(i),e.forEach(i.declarations,(function(n){if(237===n.kind){var r=n;if(e.isExternalModuleImportEqualsDeclaration(r))p.push(e.spacePart()),p.push(e.operatorPart(58)),p.push(e.spacePart()),p.push(e.keywordPart(132)),p.push(e.punctuationPart(19)),p.push(e.displayPart(e.getTextOfNode(e.getExternalModuleImportEqualsDeclarationExpression(r)),e.SymbolDisplayPartKind.stringLiteral)),p.push(e.punctuationPart(20));else{var i=t.getSymbolAtLocation(r.moduleReference);i&&(p.push(e.spacePart()),p.push(e.operatorPart(58)),p.push(e.spacePart()),O(i,o))}return!0}}))}if(!l)if(""!==m){if(d)if(g?(P(),p.push(e.keywordPart(99))):I(i,m),"property"===m||"JSX attribute"===m||3&f||"local var"===m||g)if(p.push(e.punctuationPart(56)),p.push(e.spacePart()),d.symbol&&262144&d.symbol.flags){var T=e.mapToDisplayParts((function(e){t.getSymbolDisplayBuilder().buildTypeParameterDisplay(d,e,o)}));e.addRange(p,T)}else e.addRange(p,e.typeToDisplayParts(t,d,o));else if(16&f||8192&f||16384&f||131072&f||98304&f||"method"===m){(x=d.getNonNullableType().getCallSignatures()).length&&L(x[0],x)}}else m=n(t,i,s);if(!u&&(u=i.getDocumentationComment(),_=i.getJsDocTags(),0===u.length&&4&f&&i.parent&&e.forEach(i.parent.declarations,(function(e){return 265===e.kind}))))for(var E=0,N=i.declarations;E<N.length;E++){var A;if((A=N[E]).parent&&194===A.parent.kind){var w=t.getSymbolAtLocation(A.parent.right);if(w&&(u=w.getDocumentationComment(),_=w.getJsDocTags(),u.length>0))break}}return{displayParts:p,documentation:u,symbolKind:m,tags:_};function P(){p.length&&p.push(e.lineBreakPart())}function F(){p.push(e.spacePart()),p.push(e.keywordPart(92)),p.push(e.spacePart())}function O(n,r){var i=e.symbolToDisplayParts(t,n,r||a,void 0,3);e.addRange(p,i)}function I(t,n){P(),n&&(R(n),p.push(e.spacePart()),O(t))}function R(t){switch(t){case"var":case"function":case"let":case"const":case"constructor":return void p.push(e.textOrKeywordPart(t));default:return p.push(e.punctuationPart(19)),p.push(e.textOrKeywordPart(t)),void p.push(e.punctuationPart(20))}}function L(n,r,i){e.addRange(p,e.signatureToDisplayParts(t,n,o,64|i)),r.length>1&&(p.push(e.spacePart()),p.push(e.punctuationPart(19)),p.push(e.operatorPart(37)),p.push(e.displayPart((r.length-1).toString(),e.SymbolDisplayPartKind.numericLiteral)),p.push(e.spacePart()),p.push(e.textPart(2===r.length?"overload":"overloads")),p.push(e.punctuationPart(20))),u=n.getDocumentationComment(),_=n.getJsDocTags()}function M(n,r){var i=e.mapToDisplayParts((function(e){t.getSymbolDisplayBuilder().buildTypeParameterDisplayFromSymbol(n,e,r)}));e.addRange(p,i)}}}(e.SymbolDisplay||(e.SymbolDisplay={}))}(ts||(ts={})),function(e){function t(t,n){var i=[],a=n.compilerOptions?r(n.compilerOptions,i):e.getDefaultCompilerOptions();a.isolatedModules=!0,a.suppressOutputPathCheck=!0,a.allowNonTsExtensions=!0,a.noLib=!0,a.lib=void 0,a.types=void 0,a.noEmit=void 0,a.noEmitOnError=void 0,a.paths=void 0,a.rootDirs=void 0,a.declaration=void 0,a.declarationDir=void 0,a.out=void 0,a.outFile=void 0,a.noResolve=!0;var o=n.fileName||(a.jsx?"module.tsx":"module.ts"),s=e.createSourceFile(o,t,a.target);n.moduleName&&(s.moduleName=n.moduleName),n.renamedDependencies&&(s.renamedDependencies=e.createMapFromTemplate(n.renamedDependencies));var c,u,_=e.getNewLineCharacter(a),l={getSourceFile:function(t){return t===e.normalizePath(o)?s:void 0},writeFile:function(t,n){e.fileExtensionIs(t,".map")?(e.Debug.assertEqual(u,void 0,"Unexpected multiple source map outputs, file:",t),u=n):(e.Debug.assertEqual(c,void 0,"Unexpected multiple outputs, file:",t),c=n)},getDefaultLibFileName:function(){return"lib.d.ts"},useCaseSensitiveFileNames:function(){return!1},getCanonicalFileName:function(e){return e},getCurrentDirectory:function(){return""},getNewLine:function(){return _},fileExists:function(e){return e===o},readFile:function(){return""},directoryExists:function(){return!0},getDirectories:function(){return[]}},d=e.createProgram([o],a,l);return n.reportDiagnostics&&(e.addRange(i,d.getSyntacticDiagnostics(s)),e.addRange(i,d.getOptionsDiagnostics())),d.emit(void 0,void 0,void 0,void 0,n.transformers),e.Debug.assert(void 0!==c,"Output generation failed"),{outputText:c,diagnostics:i,sourceMapText:u}}var n;function r(t,r){n=n||e.filter(e.optionDeclarations,(function(t){return"object"==typeof t.type&&!e.forEachEntry(t.type,(function(e){return"number"!=typeof e}))})),t=e.cloneCompilerOptions(t);for(var i=function(n){if(!e.hasProperty(t,n.name))return"continue";var i=t[n.name];e.isString(i)?t[n.name]=e.parseCustomTypeOption(n,i,r):e.forEachEntry(n.type,(function(e){return e===i}))||r.push(e.createCompilerDiagnosticForInvalidCustomType(n))},a=0,o=n;a<o.length;a++){i(o[a])}return t}e.transpileModule=t,e.transpile=function(n,r,i,a,o){var s=t(n,{compilerOptions:r,fileName:i,reportDiagnostics:!!a,moduleName:o});return e.addRange(a,s.diagnostics),s.outputText},e.fixupCompilerOptions=r}(ts||(ts={})),function(e){!function(t){var n,r=e.createScanner(5,!1,0),i=e.createScanner(5,!1,1);!function(e){e[e.Scan=0]="Scan",e[e.RescanGreaterThanToken=1]="RescanGreaterThanToken",e[e.RescanSlashToken=2]="RescanSlashToken",e[e.RescanTemplateToken=3]="RescanTemplateToken",e[e.RescanJsxIdentifier=4]="RescanJsxIdentifier",e[e.RescanJsxText=5]="RescanJsxText"}(n||(n={})),t.getFormattingScanner=function(t,n,a,o,s){var c=1===n?i:r;c.setText(t),c.setTextPos(a);var u,_,l,d,p,f=!0,m=s({advance:function(){p=void 0,c.getStartPos()!==a?f=_&&4===e.lastOrUndefined(_).kind:c.scan();u=void 0,_=void 0;var t=c.getStartPos();for(;t<o;){var n=c.getToken();if(!e.isTrivia(n))break;c.scan();var r={pos:t,end:c.getStartPos(),kind:n};t=c.getStartPos(),u=e.append(u,r)}l=c.getStartPos()},readTokenInfo:function(t){e.Debug.assert(g());var n=function(e){switch(e.kind){case 31:case 66:case 67:case 47:case 46:return!0}return!1}(t)?1:(i=t,12===i.kind?2:function(e){return 15===e.kind||16===e.kind}(t)?3:function(t){if(t.parent)switch(t.parent.kind){case 253:case 251:case 252:case 250:return e.isKeyword(t.kind)||71===t.kind}return!1}(t)?4:(r=t,10===r.kind?5:0));var r;var i;if(p&&n===d)return y(p,t);c.getStartPos()!==l&&(e.Debug.assert(void 0!==p),c.setTextPos(l),c.scan());var a=function(t,n){var r=c.getToken();switch(d=0,n){case 1:if(29===r){d=1;var i=c.reScanGreaterToken();return e.Debug.assert(t.kind===i),i}break;case 2:if(41===(a=r)||63===a){d=2;i=c.reScanSlashToken();return e.Debug.assert(t.kind===i),i}break;case 3:if(18===r)return d=3,c.reScanTemplateToken();break;case 4:return d=4,c.scanJsxIdentifier();case 5:return d=5,c.reScanJsxToken();case 0:break;default:e.Debug.assertNever(n)}var a;return r}(t,n),s={pos:c.getStartPos(),end:c.getTextPos(),kind:a};_&&(_=void 0);for(;c.getStartPos()<o&&(a=c.scan(),e.isTrivia(a));){var f={pos:c.getStartPos(),end:c.getTextPos(),kind:a};if(_||(_=[]),_.push(f),4===a){c.scan();break}}return y(p={leadingTrivia:u,trailingTrivia:_,token:s},t)},isOnToken:g,getCurrentLeadingTrivia:function(){return u},lastTrailingTriviaWasNewLine:function(){return f},skipToEndOf:function(e){c.setTextPos(e.end),l=c.getStartPos(),d=void 0,p=void 0,f=!1,u=void 0,_=void 0}});return p=void 0,c.setText(void 0),m;function g(){var t=p?p.token.kind:c.getToken();return(p?p.token.pos:c.getStartPos())<o&&1!==t&&!e.isTrivia(t)}function y(t,n){return e.isToken(n)&&t.token.kind!==n.kind&&(t.token.kind=n.kind),t}}}(e.formatting||(e.formatting={}))}(ts||(ts={})),function(e){!function(t){var n=function(){function t(e,t,n){this.sourceFile=e,this.formattingRequestKind=t,this.options=n}return t.prototype.updateContext=function(t,n,r,i,a){e.Debug.assert(void 0!==t,"currentTokenSpan is null"),e.Debug.assert(void 0!==n,"currentTokenParent is null"),e.Debug.assert(void 0!==r,"nextTokenSpan is null"),e.Debug.assert(void 0!==i,"nextTokenParent is null"),e.Debug.assert(void 0!==a,"commonParent is null"),this.currentTokenSpan=t,this.currentTokenParent=n,this.nextTokenSpan=r,this.nextTokenParent=i,this.contextNode=a,this.contextNodeAllOnSameLine=void 0,this.nextNodeAllOnSameLine=void 0,this.tokensAreOnSameLine=void 0,this.contextNodeBlockIsOnOneLine=void 0,this.nextNodeBlockIsOnOneLine=void 0},t.prototype.ContextNodeAllOnSameLine=function(){return void 0===this.contextNodeAllOnSameLine&&(this.contextNodeAllOnSameLine=this.NodeIsOnOneLine(this.contextNode)),this.contextNodeAllOnSameLine},t.prototype.NextNodeAllOnSameLine=function(){return void 0===this.nextNodeAllOnSameLine&&(this.nextNodeAllOnSameLine=this.NodeIsOnOneLine(this.nextTokenParent)),this.nextNodeAllOnSameLine},t.prototype.TokensAreOnSameLine=function(){if(void 0===this.tokensAreOnSameLine){var e=this.sourceFile.getLineAndCharacterOfPosition(this.currentTokenSpan.pos).line,t=this.sourceFile.getLineAndCharacterOfPosition(this.nextTokenSpan.pos).line;this.tokensAreOnSameLine=e===t}return this.tokensAreOnSameLine},t.prototype.ContextNodeBlockIsOnOneLine=function(){return void 0===this.contextNodeBlockIsOnOneLine&&(this.contextNodeBlockIsOnOneLine=this.BlockIsOnOneLine(this.contextNode)),this.contextNodeBlockIsOnOneLine},t.prototype.NextNodeBlockIsOnOneLine=function(){return void 0===this.nextNodeBlockIsOnOneLine&&(this.nextNodeBlockIsOnOneLine=this.BlockIsOnOneLine(this.nextTokenParent)),this.nextNodeBlockIsOnOneLine},t.prototype.NodeIsOnOneLine=function(e){return this.sourceFile.getLineAndCharacterOfPosition(e.getStart(this.sourceFile)).line===this.sourceFile.getLineAndCharacterOfPosition(e.getEnd()).line},t.prototype.BlockIsOnOneLine=function(t){var n=e.findChildOfKind(t,17,this.sourceFile),r=e.findChildOfKind(t,18,this.sourceFile);return!(!n||!r)&&this.sourceFile.getLineAndCharacterOfPosition(n.getEnd()).line===this.sourceFile.getLineAndCharacterOfPosition(r.getStart(this.sourceFile)).line},t}();t.FormattingContext=n}(e.formatting||(e.formatting={}))}(ts||(ts={})),function(e){!function(e){!function(e){e[e.FormatDocument=0]="FormatDocument",e[e.FormatSelection=1]="FormatSelection",e[e.FormatOnEnter=2]="FormatOnEnter",e[e.FormatOnSemicolon=3]="FormatOnSemicolon",e[e.FormatOnOpeningCurlyBrace=4]="FormatOnOpeningCurlyBrace",e[e.FormatOnClosingCurlyBrace=5]="FormatOnClosingCurlyBrace"}(e.FormattingRequestKind||(e.FormattingRequestKind={}))}(e.formatting||(e.formatting={}))}(ts||(ts={})),function(e){!function(e){var t=function(e,t,n){void 0===n&&(n=0),this.Descriptor=e,this.Operation=t,this.Flag=n};e.Rule=t}(e.formatting||(e.formatting={}))}(ts||(ts={})),function(e){!function(e){!function(e){e[e.Ignore=1]="Ignore",e[e.Space=2]="Space",e[e.NewLine=4]="NewLine",e[e.Delete=8]="Delete"}(e.RuleAction||(e.RuleAction={}))}(e.formatting||(e.formatting={}))}(ts||(ts={})),function(e){!function(e){var t=function(){function t(e,t){this.LeftTokenRange=e,this.RightTokenRange=t}return t.prototype.toString=function(){return"[leftRange="+this.LeftTokenRange+",rightRange="+this.RightTokenRange+"]"},t.create1=function(n,r){return t.create4(e.Shared.TokenRange.FromToken(n),e.Shared.TokenRange.FromToken(r))},t.create2=function(n,r){return t.create4(n,e.Shared.TokenRange.FromToken(r))},t.create3=function(n,r){return t.create4(e.Shared.TokenRange.FromToken(n),r)},t.create4=function(e,n){return new t(e,n)},t}();e.RuleDescriptor=t}(e.formatting||(e.formatting={}))}(ts||(ts={})),function(e){!function(e){!function(e){e[e.None=0]="None",e[e.CanDeleteNewLines=1]="CanDeleteNewLines"}(e.RuleFlags||(e.RuleFlags={}))}(e.formatting||(e.formatting={}))}(ts||(ts={})),function(e){!function(e){var t=function(){function t(e,t){this.Context=e,this.Action=t}return t.prototype.toString=function(){return"[context="+this.Context+",action="+this.Action+"]"},t.create1=function(n){return t.create2(e.RuleOperationContext.Any,n)},t.create2=function(e,n){return new t(e,n)},t}();e.RuleOperation=t}(e.formatting||(e.formatting={}))}(ts||(ts={})),function(e){!function(e){var t=function(){function e(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];this.customContextChecks=e}return e.prototype.IsAny=function(){return this===e.Any},e.prototype.InContext=function(e){if(this.IsAny())return!0;for(var t=0,n=this.customContextChecks;t<n.length;t++){if(!(0,n[t])(e))return!1}return!0},e.Any=new e,e}();e.RuleOperationContext=t}(e.formatting||(e.formatting={}))}(ts||(ts={})),function(e){!function(t){var n=function(){function n(){if(this.IgnoreBeforeComment=new t.Rule(t.RuleDescriptor.create4(t.Shared.TokenRange.Any,t.Shared.TokenRange.Comments),t.RuleOperation.create1(1)),this.IgnoreAfterLineComment=new t.Rule(t.RuleDescriptor.create3(2,t.Shared.TokenRange.Any),t.RuleOperation.create1(1)),this.NoSpaceBeforeSemicolon=new t.Rule(t.RuleDescriptor.create2(t.Shared.TokenRange.Any,25),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext),8)),this.NoSpaceBeforeColon=new t.Rule(t.RuleDescriptor.create2(t.Shared.TokenRange.Any,56),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext,n.IsNotBinaryOpContext),8)),this.NoSpaceBeforeQuestionMark=new t.Rule(t.RuleDescriptor.create2(t.Shared.TokenRange.Any,55),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext,n.IsNotBinaryOpContext),8)),this.SpaceAfterColon=new t.Rule(t.RuleDescriptor.create3(56,t.Shared.TokenRange.Any),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext,n.IsNotBinaryOpContext),2)),this.SpaceAfterQuestionMarkInConditionalOperator=new t.Rule(t.RuleDescriptor.create3(55,t.Shared.TokenRange.Any),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext,n.IsConditionalOperatorContext),2)),this.NoSpaceAfterQuestionMark=new t.Rule(t.RuleDescriptor.create3(55,t.Shared.TokenRange.Any),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext),8)),this.SpaceAfterSemicolon=new t.Rule(t.RuleDescriptor.create3(25,t.Shared.TokenRange.Any),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext),2)),this.SpaceAfterCloseBrace=new t.Rule(t.RuleDescriptor.create3(18,t.Shared.TokenRange.FromRange(0,142,[20])),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext,n.IsAfterCodeBlockContext),2)),this.SpaceBetweenCloseBraceAndElse=new t.Rule(t.RuleDescriptor.create1(18,82),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext),2)),this.SpaceBetweenCloseBraceAndWhile=new t.Rule(t.RuleDescriptor.create1(18,106),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext),2)),this.NoSpaceAfterCloseBrace=new t.Rule(t.RuleDescriptor.create3(18,t.Shared.TokenRange.FromTokens([22,26,25])),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext),8)),this.NoSpaceBeforeDot=new t.Rule(t.RuleDescriptor.create2(t.Shared.TokenRange.Any,23),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext),8)),this.NoSpaceAfterDot=new t.Rule(t.RuleDescriptor.create3(23,t.Shared.TokenRange.Any),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext),8)),this.NoSpaceBeforeOpenBracket=new t.Rule(t.RuleDescriptor.create2(t.Shared.TokenRange.AnyExcept(120),21),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext),8)),this.NoSpaceAfterCloseBracket=new t.Rule(t.RuleDescriptor.create3(22,t.Shared.TokenRange.Any),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext,n.IsNotBeforeBlockInFunctionDeclarationContext),8)),this.FunctionOpenBraceLeftTokenRange=t.Shared.TokenRange.AnyIncludingMultilineComments,this.SpaceBeforeOpenBraceInFunction=new t.Rule(t.RuleDescriptor.create2(this.FunctionOpenBraceLeftTokenRange,17),t.RuleOperation.create2(new t.RuleOperationContext(n.isOptionDisabledOrUndefinedOrTokensOnSameLine("placeOpenBraceOnNewLineForFunctions"),n.IsFunctionDeclContext,n.IsBeforeBlockContext,n.IsNotFormatOnEnter,n.IsSameLineTokenOrBeforeBlockContext),2),1),this.TypeScriptOpenBraceLeftTokenRange=t.Shared.TokenRange.FromTokens([71,3,75,84,91]),this.SpaceBeforeOpenBraceInTypeScriptDeclWithBlock=new t.Rule(t.RuleDescriptor.create2(this.TypeScriptOpenBraceLeftTokenRange,17),t.RuleOperation.create2(new t.RuleOperationContext(n.isOptionDisabledOrUndefinedOrTokensOnSameLine("placeOpenBraceOnNewLineForFunctions"),n.IsTypeScriptDeclWithBlockContext,n.IsNotFormatOnEnter,n.IsSameLineTokenOrBeforeBlockContext),2),1),this.ControlOpenBraceLeftTokenRange=t.Shared.TokenRange.FromTokens([20,3,81,102,87,82]),this.SpaceBeforeOpenBraceInControl=new t.Rule(t.RuleDescriptor.create2(this.ControlOpenBraceLeftTokenRange,17),t.RuleOperation.create2(new t.RuleOperationContext(n.isOptionDisabledOrUndefinedOrTokensOnSameLine("placeOpenBraceOnNewLineForControlBlocks"),n.IsControlDeclContext,n.IsNotFormatOnEnter,n.IsSameLineTokenOrBeforeBlockContext),2),1),this.SpaceAfterOpenBrace=new t.Rule(t.RuleDescriptor.create3(17,t.Shared.TokenRange.Any),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionEnabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"),n.IsBraceWrappedContext),2)),this.SpaceBeforeCloseBrace=new t.Rule(t.RuleDescriptor.create2(t.Shared.TokenRange.Any,18),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionEnabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"),n.IsBraceWrappedContext),2)),this.NoSpaceAfterOpenBrace=new t.Rule(t.RuleDescriptor.create3(17,t.Shared.TokenRange.Any),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionDisabled("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"),n.IsNonJsxSameLineTokenContext),8)),this.NoSpaceBeforeCloseBrace=new t.Rule(t.RuleDescriptor.create2(t.Shared.TokenRange.Any,18),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionDisabled("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"),n.IsNonJsxSameLineTokenContext),8)),this.NoSpaceBetweenEmptyBraceBrackets=new t.Rule(t.RuleDescriptor.create1(17,18),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext,n.IsObjectContext),8)),this.NewLineAfterOpenBraceInBlockContext=new t.Rule(t.RuleDescriptor.create3(17,t.Shared.TokenRange.Any),t.RuleOperation.create2(new t.RuleOperationContext(n.IsMultilineBlockContext),4)),this.NewLineBeforeCloseBraceInBlockContext=new t.Rule(t.RuleDescriptor.create2(t.Shared.TokenRange.AnyIncludingMultilineComments,18),t.RuleOperation.create2(new t.RuleOperationContext(n.IsMultilineBlockContext),4)),this.NoSpaceAfterUnaryPrefixOperator=new t.Rule(t.RuleDescriptor.create4(t.Shared.TokenRange.UnaryPrefixOperators,t.Shared.TokenRange.UnaryPrefixExpressions),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext,n.IsNotBinaryOpContext),8)),this.NoSpaceAfterUnaryPreincrementOperator=new t.Rule(t.RuleDescriptor.create3(43,t.Shared.TokenRange.UnaryPreincrementExpressions),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext),8)),this.NoSpaceAfterUnaryPredecrementOperator=new t.Rule(t.RuleDescriptor.create3(44,t.Shared.TokenRange.UnaryPredecrementExpressions),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext),8)),this.NoSpaceBeforeUnaryPostincrementOperator=new t.Rule(t.RuleDescriptor.create2(t.Shared.TokenRange.UnaryPostincrementExpressions,43),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext),8)),this.NoSpaceBeforeUnaryPostdecrementOperator=new t.Rule(t.RuleDescriptor.create2(t.Shared.TokenRange.UnaryPostdecrementExpressions,44),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext),8)),this.SpaceAfterPostincrementWhenFollowedByAdd=new t.Rule(t.RuleDescriptor.create1(43,37),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext,n.IsBinaryOpContext),2)),this.SpaceAfterAddWhenFollowedByUnaryPlus=new t.Rule(t.RuleDescriptor.create1(37,37),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext,n.IsBinaryOpContext),2)),this.SpaceAfterAddWhenFollowedByPreincrement=new t.Rule(t.RuleDescriptor.create1(37,43),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext,n.IsBinaryOpContext),2)),this.SpaceAfterPostdecrementWhenFollowedBySubtract=new t.Rule(t.RuleDescriptor.create1(44,38),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext,n.IsBinaryOpContext),2)),this.SpaceAfterSubtractWhenFollowedByUnaryMinus=new t.Rule(t.RuleDescriptor.create1(38,38),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext,n.IsBinaryOpContext),2)),this.SpaceAfterSubtractWhenFollowedByPredecrement=new t.Rule(t.RuleDescriptor.create1(38,44),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext,n.IsBinaryOpContext),2)),this.NoSpaceBeforeComma=new t.Rule(t.RuleDescriptor.create2(t.Shared.TokenRange.Any,26),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext),8)),this.SpaceAfterCertainKeywords=new t.Rule(t.RuleDescriptor.create4(t.Shared.TokenRange.FromTokens([104,100,94,80,96,103,121]),t.Shared.TokenRange.Any),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext),2)),this.NoSpaceAfterNewKeywordOnConstructorSignature=new t.Rule(t.RuleDescriptor.create1(94,19),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext,n.IsConstructorSignatureContext),8)),this.SpaceAfterLetConstInVariableDeclaration=new t.Rule(t.RuleDescriptor.create4(t.Shared.TokenRange.FromTokens([110,76]),t.Shared.TokenRange.Any),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext,n.IsStartOfVariableDeclarationList),2)),this.NoSpaceBeforeOpenParenInFuncCall=new t.Rule(t.RuleDescriptor.create2(t.Shared.TokenRange.Any,19),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext,n.IsFunctionCallOrNewContext,n.IsPreviousTokenNotComma),8)),this.SpaceAfterFunctionInFuncDecl=new t.Rule(t.RuleDescriptor.create3(89,t.Shared.TokenRange.Any),t.RuleOperation.create2(new t.RuleOperationContext(n.IsFunctionDeclContext),2)),this.SpaceBeforeOpenParenInFuncDecl=new t.Rule(t.RuleDescriptor.create2(t.Shared.TokenRange.Any,19),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionEnabled("insertSpaceBeforeFunctionParenthesis"),n.IsNonJsxSameLineTokenContext,n.IsFunctionDeclContext),2)),this.NoSpaceBeforeOpenParenInFuncDecl=new t.Rule(t.RuleDescriptor.create2(t.Shared.TokenRange.Any,19),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionDisabledOrUndefined("insertSpaceBeforeFunctionParenthesis"),n.IsNonJsxSameLineTokenContext,n.IsFunctionDeclContext),8)),this.SpaceAfterVoidOperator=new t.Rule(t.RuleDescriptor.create3(105,t.Shared.TokenRange.Any),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext,n.IsVoidOpContext),2)),this.NoSpaceBetweenReturnAndSemicolon=new t.Rule(t.RuleDescriptor.create1(96,25),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext),8)),this.SpaceBetweenStatements=new t.Rule(t.RuleDescriptor.create4(t.Shared.TokenRange.FromTokens([20,81,82,73]),t.Shared.TokenRange.Any),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext,n.IsNonJsxElementContext,n.IsNotForContext),2)),this.SpaceAfterTryFinally=new t.Rule(t.RuleDescriptor.create2(t.Shared.TokenRange.FromTokens([102,87]),17),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext),2)),this.SpaceAfterGetSetInMember=new t.Rule(t.RuleDescriptor.create2(t.Shared.TokenRange.FromTokens([125,135]),71),t.RuleOperation.create2(new t.RuleOperationContext(n.IsFunctionDeclContext),2)),this.SpaceBeforeBinaryKeywordOperator=new t.Rule(t.RuleDescriptor.create4(t.Shared.TokenRange.Any,t.Shared.TokenRange.BinaryKeywordOperators),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext,n.IsBinaryOpContext),2)),this.SpaceAfterBinaryKeywordOperator=new t.Rule(t.RuleDescriptor.create4(t.Shared.TokenRange.BinaryKeywordOperators,t.Shared.TokenRange.Any),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext,n.IsBinaryOpContext),2)),this.SpaceAfterConstructor=new t.Rule(t.RuleDescriptor.create1(123,19),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionEnabled("insertSpaceAfterConstructor"),n.IsNonJsxSameLineTokenContext),2)),this.NoSpaceAfterConstructor=new t.Rule(t.RuleDescriptor.create1(123,19),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionDisabledOrUndefined("insertSpaceAfterConstructor"),n.IsNonJsxSameLineTokenContext),8)),this.NoSpaceAfterModuleImport=new t.Rule(t.RuleDescriptor.create2(t.Shared.TokenRange.FromTokens([128,132]),19),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext),8)),this.SpaceAfterCertainTypeScriptKeywords=new t.Rule(t.RuleDescriptor.create4(t.Shared.TokenRange.FromTokens([117,75,124,79,83,84,85,125,108,91,109,128,129,112,114,113,131,135,115,138,140,127]),t.Shared.TokenRange.Any),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext),2)),this.SpaceBeforeCertainTypeScriptKeywords=new t.Rule(t.RuleDescriptor.create4(t.Shared.TokenRange.Any,t.Shared.TokenRange.FromTokens([85,108,140])),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext),2)),this.SpaceAfterModuleName=new t.Rule(t.RuleDescriptor.create1(9,17),t.RuleOperation.create2(new t.RuleOperationContext(n.IsModuleDeclContext),2)),this.SpaceBeforeArrow=new t.Rule(t.RuleDescriptor.create2(t.Shared.TokenRange.Any,36),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext),2)),this.SpaceAfterArrow=new t.Rule(t.RuleDescriptor.create3(36,t.Shared.TokenRange.Any),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext),2)),this.NoSpaceAfterEllipsis=new t.Rule(t.RuleDescriptor.create1(24,71),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext),8)),this.NoSpaceAfterOptionalParameters=new t.Rule(t.RuleDescriptor.create3(55,t.Shared.TokenRange.FromTokens([20,26])),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext,n.IsNotBinaryOpContext),8)),this.NoSpaceBeforeOpenAngularBracket=new t.Rule(t.RuleDescriptor.create2(t.Shared.TokenRange.TypeNames,27),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext,n.IsTypeArgumentOrParameterOrAssertionContext),8)),this.NoSpaceBetweenCloseParenAndAngularBracket=new t.Rule(t.RuleDescriptor.create1(20,27),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext,n.IsTypeArgumentOrParameterOrAssertionContext),8)),this.NoSpaceAfterOpenAngularBracket=new t.Rule(t.RuleDescriptor.create3(27,t.Shared.TokenRange.Any),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext,n.IsTypeArgumentOrParameterOrAssertionContext),8)),this.NoSpaceBeforeCloseAngularBracket=new t.Rule(t.RuleDescriptor.create2(t.Shared.TokenRange.Any,29),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext,n.IsTypeArgumentOrParameterOrAssertionContext),8)),this.NoSpaceAfterCloseAngularBracket=new t.Rule(t.RuleDescriptor.create3(29,t.Shared.TokenRange.FromTokens([19,21,29,26])),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext,n.IsTypeArgumentOrParameterOrAssertionContext),8)),this.NoSpaceBetweenEmptyInterfaceBraceBrackets=new t.Rule(t.RuleDescriptor.create1(17,18),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext,n.IsObjectTypeContext),8)),this.SpaceBeforeAt=new t.Rule(t.RuleDescriptor.create2(t.Shared.TokenRange.Any,57),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext),2)),this.NoSpaceAfterAt=new t.Rule(t.RuleDescriptor.create3(57,t.Shared.TokenRange.Any),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext),8)),this.SpaceAfterDecorator=new t.Rule(t.RuleDescriptor.create4(t.Shared.TokenRange.Any,t.Shared.TokenRange.FromTokens([117,71,84,79,75,115,114,112,113,125,135,21,39])),t.RuleOperation.create2(new t.RuleOperationContext(n.IsEndOfDecoratorContextOnSameLine),2)),this.NoSpaceBetweenFunctionKeywordAndStar=new t.Rule(t.RuleDescriptor.create1(89,39),t.RuleOperation.create2(new t.RuleOperationContext(n.IsFunctionDeclarationOrFunctionExpressionContext),8)),this.SpaceAfterStarInGeneratorDeclaration=new t.Rule(t.RuleDescriptor.create3(39,t.Shared.TokenRange.FromTokens([71,19])),t.RuleOperation.create2(new t.RuleOperationContext(n.IsFunctionDeclarationOrFunctionExpressionContext),2)),this.NoSpaceBetweenYieldKeywordAndStar=new t.Rule(t.RuleDescriptor.create1(116,39),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext,n.IsYieldOrYieldStarWithOperand),8)),this.SpaceBetweenYieldOrYieldStarAndOperand=new t.Rule(t.RuleDescriptor.create4(t.Shared.TokenRange.FromTokens([116,39]),t.Shared.TokenRange.Any),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext,n.IsYieldOrYieldStarWithOperand),2)),this.SpaceBetweenAsyncAndOpenParen=new t.Rule(t.RuleDescriptor.create1(120,19),t.RuleOperation.create2(new t.RuleOperationContext(n.IsArrowFunctionContext,n.IsNonJsxSameLineTokenContext),2)),this.SpaceBetweenAsyncAndFunctionKeyword=new t.Rule(t.RuleDescriptor.create1(120,89),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext),2)),this.NoSpaceBetweenTagAndTemplateString=new t.Rule(t.RuleDescriptor.create3(71,t.Shared.TokenRange.FromTokens([13,14])),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext),8)),this.SpaceBeforeJsxAttribute=new t.Rule(t.RuleDescriptor.create2(t.Shared.TokenRange.Any,71),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNextTokenParentJsxAttribute,n.IsNonJsxSameLineTokenContext),2)),this.SpaceBeforeSlashInJsxOpeningElement=new t.Rule(t.RuleDescriptor.create2(t.Shared.TokenRange.Any,41),t.RuleOperation.create2(new t.RuleOperationContext(n.IsJsxSelfClosingElementContext,n.IsNonJsxSameLineTokenContext),2)),this.NoSpaceBeforeGreaterThanTokenInJsxOpeningElement=new t.Rule(t.RuleDescriptor.create1(41,29),t.RuleOperation.create2(new t.RuleOperationContext(n.IsJsxSelfClosingElementContext,n.IsNonJsxSameLineTokenContext),8)),this.NoSpaceBeforeEqualInJsxAttribute=new t.Rule(t.RuleDescriptor.create2(t.Shared.TokenRange.Any,58),t.RuleOperation.create2(new t.RuleOperationContext(n.IsJsxAttributeContext,n.IsNonJsxSameLineTokenContext),8)),this.NoSpaceAfterEqualInJsxAttribute=new t.Rule(t.RuleDescriptor.create3(58,t.Shared.TokenRange.Any),t.RuleOperation.create2(new t.RuleOperationContext(n.IsJsxAttributeContext,n.IsNonJsxSameLineTokenContext),8)),this.NoSpaceBeforeNonNullAssertionOperator=new t.Rule(t.RuleDescriptor.create2(t.Shared.TokenRange.Any,51),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext,n.IsNonNullAssertionContext),8)),this.SpaceAfterComma=new t.Rule(t.RuleDescriptor.create3(26,t.Shared.TokenRange.Any),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionEnabled("insertSpaceAfterCommaDelimiter"),n.IsNonJsxSameLineTokenContext,n.IsNonJsxElementContext,n.IsNextTokenNotCloseBracket),2)),this.NoSpaceAfterComma=new t.Rule(t.RuleDescriptor.create3(26,t.Shared.TokenRange.Any),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionDisabledOrUndefined("insertSpaceAfterCommaDelimiter"),n.IsNonJsxSameLineTokenContext,n.IsNonJsxElementContext),8)),this.SpaceBeforeBinaryOperator=new t.Rule(t.RuleDescriptor.create4(t.Shared.TokenRange.Any,t.Shared.TokenRange.BinaryOperators),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionEnabled("insertSpaceBeforeAndAfterBinaryOperators"),n.IsNonJsxSameLineTokenContext,n.IsBinaryOpContext),2)),this.SpaceAfterBinaryOperator=new t.Rule(t.RuleDescriptor.create4(t.Shared.TokenRange.BinaryOperators,t.Shared.TokenRange.Any),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionEnabled("insertSpaceBeforeAndAfterBinaryOperators"),n.IsNonJsxSameLineTokenContext,n.IsBinaryOpContext),2)),this.NoSpaceBeforeBinaryOperator=new t.Rule(t.RuleDescriptor.create4(t.Shared.TokenRange.Any,t.Shared.TokenRange.BinaryOperators),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionDisabledOrUndefined("insertSpaceBeforeAndAfterBinaryOperators"),n.IsNonJsxSameLineTokenContext,n.IsBinaryOpContext),8)),this.NoSpaceAfterBinaryOperator=new t.Rule(t.RuleDescriptor.create4(t.Shared.TokenRange.BinaryOperators,t.Shared.TokenRange.Any),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionDisabledOrUndefined("insertSpaceBeforeAndAfterBinaryOperators"),n.IsNonJsxSameLineTokenContext,n.IsBinaryOpContext),8)),this.SpaceAfterKeywordInControl=new t.Rule(t.RuleDescriptor.create2(t.Shared.TokenRange.Keywords,19),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionEnabled("insertSpaceAfterKeywordsInControlFlowStatements"),n.IsControlDeclContext),2)),this.NoSpaceAfterKeywordInControl=new t.Rule(t.RuleDescriptor.create2(t.Shared.TokenRange.Keywords,19),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionDisabledOrUndefined("insertSpaceAfterKeywordsInControlFlowStatements"),n.IsControlDeclContext),8)),this.NewLineBeforeOpenBraceInFunction=new t.Rule(t.RuleDescriptor.create2(this.FunctionOpenBraceLeftTokenRange,17),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionEnabled("placeOpenBraceOnNewLineForFunctions"),n.IsFunctionDeclContext,n.IsBeforeMultilineBlockContext),4),1),this.NewLineBeforeOpenBraceInTypeScriptDeclWithBlock=new t.Rule(t.RuleDescriptor.create2(this.TypeScriptOpenBraceLeftTokenRange,17),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionEnabled("placeOpenBraceOnNewLineForFunctions"),n.IsTypeScriptDeclWithBlockContext,n.IsBeforeMultilineBlockContext),4),1),this.NewLineBeforeOpenBraceInControl=new t.Rule(t.RuleDescriptor.create2(this.ControlOpenBraceLeftTokenRange,17),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionEnabled("placeOpenBraceOnNewLineForControlBlocks"),n.IsControlDeclContext,n.IsBeforeMultilineBlockContext),4),1),this.SpaceAfterSemicolonInFor=new t.Rule(t.RuleDescriptor.create3(25,t.Shared.TokenRange.Any),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionEnabled("insertSpaceAfterSemicolonInForStatements"),n.IsNonJsxSameLineTokenContext,n.IsForContext),2)),this.NoSpaceAfterSemicolonInFor=new t.Rule(t.RuleDescriptor.create3(25,t.Shared.TokenRange.Any),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionDisabledOrUndefined("insertSpaceAfterSemicolonInForStatements"),n.IsNonJsxSameLineTokenContext,n.IsForContext),8)),this.SpaceAfterOpenParen=new t.Rule(t.RuleDescriptor.create3(19,t.Shared.TokenRange.Any),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"),n.IsNonJsxSameLineTokenContext),2)),this.SpaceBeforeCloseParen=new t.Rule(t.RuleDescriptor.create2(t.Shared.TokenRange.Any,20),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"),n.IsNonJsxSameLineTokenContext),2)),this.SpaceBetweenOpenParens=new t.Rule(t.RuleDescriptor.create1(19,19),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"),n.IsNonJsxSameLineTokenContext),2)),this.NoSpaceBetweenParens=new t.Rule(t.RuleDescriptor.create1(19,20),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext),8)),this.NoSpaceAfterOpenParen=new t.Rule(t.RuleDescriptor.create3(19,t.Shared.TokenRange.Any),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"),n.IsNonJsxSameLineTokenContext),8)),this.NoSpaceBeforeCloseParen=new t.Rule(t.RuleDescriptor.create2(t.Shared.TokenRange.Any,20),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"),n.IsNonJsxSameLineTokenContext),8)),this.SpaceAfterOpenBracket=new t.Rule(t.RuleDescriptor.create3(21,t.Shared.TokenRange.Any),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"),n.IsNonJsxSameLineTokenContext),2)),this.SpaceBeforeCloseBracket=new t.Rule(t.RuleDescriptor.create2(t.Shared.TokenRange.Any,22),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"),n.IsNonJsxSameLineTokenContext),2)),this.NoSpaceBetweenBrackets=new t.Rule(t.RuleDescriptor.create1(21,22),t.RuleOperation.create2(new t.RuleOperationContext(n.IsNonJsxSameLineTokenContext),8)),this.NoSpaceAfterOpenBracket=new t.Rule(t.RuleDescriptor.create3(21,t.Shared.TokenRange.Any),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"),n.IsNonJsxSameLineTokenContext),8)),this.NoSpaceBeforeCloseBracket=new t.Rule(t.RuleDescriptor.create2(t.Shared.TokenRange.Any,22),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"),n.IsNonJsxSameLineTokenContext),8)),this.NoSpaceAfterTemplateHeadAndMiddle=new t.Rule(t.RuleDescriptor.create4(t.Shared.TokenRange.FromTokens([14,15]),t.Shared.TokenRange.Any),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"),n.IsNonJsxSameLineTokenContext),8)),this.SpaceAfterTemplateHeadAndMiddle=new t.Rule(t.RuleDescriptor.create4(t.Shared.TokenRange.FromTokens([14,15]),t.Shared.TokenRange.Any),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"),n.IsNonJsxSameLineTokenContext),2)),this.NoSpaceBeforeTemplateMiddleAndTail=new t.Rule(t.RuleDescriptor.create4(t.Shared.TokenRange.Any,t.Shared.TokenRange.FromTokens([15,16])),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"),n.IsNonJsxSameLineTokenContext),8)),this.SpaceBeforeTemplateMiddleAndTail=new t.Rule(t.RuleDescriptor.create4(t.Shared.TokenRange.Any,t.Shared.TokenRange.FromTokens([15,16])),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"),n.IsNonJsxSameLineTokenContext),2)),this.NoSpaceAfterOpenBraceInJsxExpression=new t.Rule(t.RuleDescriptor.create3(17,t.Shared.TokenRange.Any),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"),n.IsNonJsxSameLineTokenContext,n.IsJsxExpressionContext),8)),this.SpaceAfterOpenBraceInJsxExpression=new t.Rule(t.RuleDescriptor.create3(17,t.Shared.TokenRange.Any),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"),n.IsNonJsxSameLineTokenContext,n.IsJsxExpressionContext),2)),this.NoSpaceBeforeCloseBraceInJsxExpression=new t.Rule(t.RuleDescriptor.create2(t.Shared.TokenRange.Any,18),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"),n.IsNonJsxSameLineTokenContext,n.IsJsxExpressionContext),8)),this.SpaceBeforeCloseBraceInJsxExpression=new t.Rule(t.RuleDescriptor.create2(t.Shared.TokenRange.Any,18),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"),n.IsNonJsxSameLineTokenContext,n.IsJsxExpressionContext),2)),this.SpaceAfterAnonymousFunctionKeyword=new t.Rule(t.RuleDescriptor.create1(89,19),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionEnabled("insertSpaceAfterFunctionKeywordForAnonymousFunctions"),n.IsFunctionDeclContext),2)),this.NoSpaceAfterAnonymousFunctionKeyword=new t.Rule(t.RuleDescriptor.create1(89,19),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionDisabledOrUndefined("insertSpaceAfterFunctionKeywordForAnonymousFunctions"),n.IsFunctionDeclContext),8)),this.NoSpaceAfterTypeAssertion=new t.Rule(t.RuleDescriptor.create3(29,t.Shared.TokenRange.Any),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionDisabledOrUndefined("insertSpaceAfterTypeAssertion"),n.IsNonJsxSameLineTokenContext,n.IsTypeAssertionContext),8)),this.SpaceAfterTypeAssertion=new t.Rule(t.RuleDescriptor.create3(29,t.Shared.TokenRange.Any),t.RuleOperation.create2(new t.RuleOperationContext(n.IsOptionEnabled("insertSpaceAfterTypeAssertion"),n.IsNonJsxSameLineTokenContext,n.IsTypeAssertionContext),2)),this.HighPriorityCommonRules=[this.IgnoreBeforeComment,this.IgnoreAfterLineComment,this.NoSpaceBeforeColon,this.SpaceAfterColon,this.NoSpaceBeforeQuestionMark,this.SpaceAfterQuestionMarkInConditionalOperator,this.NoSpaceAfterQuestionMark,this.NoSpaceBeforeDot,this.NoSpaceAfterDot,this.NoSpaceAfterUnaryPrefixOperator,this.NoSpaceAfterUnaryPreincrementOperator,this.NoSpaceAfterUnaryPredecrementOperator,this.NoSpaceBeforeUnaryPostincrementOperator,this.NoSpaceBeforeUnaryPostdecrementOperator,this.SpaceAfterPostincrementWhenFollowedByAdd,this.SpaceAfterAddWhenFollowedByUnaryPlus,this.SpaceAfterAddWhenFollowedByPreincrement,this.SpaceAfterPostdecrementWhenFollowedBySubtract,this.SpaceAfterSubtractWhenFollowedByUnaryMinus,this.SpaceAfterSubtractWhenFollowedByPredecrement,this.NoSpaceAfterCloseBrace,this.NewLineBeforeCloseBraceInBlockContext,this.SpaceAfterCloseBrace,this.SpaceBetweenCloseBraceAndElse,this.SpaceBetweenCloseBraceAndWhile,this.NoSpaceBetweenEmptyBraceBrackets,this.NoSpaceBetweenFunctionKeywordAndStar,this.SpaceAfterStarInGeneratorDeclaration,this.SpaceAfterFunctionInFuncDecl,this.NewLineAfterOpenBraceInBlockContext,this.SpaceAfterGetSetInMember,this.NoSpaceBetweenYieldKeywordAndStar,this.SpaceBetweenYieldOrYieldStarAndOperand,this.NoSpaceBetweenReturnAndSemicolon,this.SpaceAfterCertainKeywords,this.SpaceAfterLetConstInVariableDeclaration,this.NoSpaceBeforeOpenParenInFuncCall,this.SpaceBeforeBinaryKeywordOperator,this.SpaceAfterBinaryKeywordOperator,this.SpaceAfterVoidOperator,this.SpaceBetweenAsyncAndOpenParen,this.SpaceBetweenAsyncAndFunctionKeyword,this.NoSpaceBetweenTagAndTemplateString,this.SpaceBeforeJsxAttribute,this.SpaceBeforeSlashInJsxOpeningElement,this.NoSpaceBeforeGreaterThanTokenInJsxOpeningElement,this.NoSpaceBeforeEqualInJsxAttribute,this.NoSpaceAfterEqualInJsxAttribute,this.NoSpaceAfterModuleImport,this.SpaceAfterCertainTypeScriptKeywords,this.SpaceBeforeCertainTypeScriptKeywords,this.SpaceAfterModuleName,this.SpaceBeforeArrow,this.SpaceAfterArrow,this.NoSpaceAfterEllipsis,this.NoSpaceAfterOptionalParameters,this.NoSpaceBetweenEmptyInterfaceBraceBrackets,this.NoSpaceBeforeOpenAngularBracket,this.NoSpaceBetweenCloseParenAndAngularBracket,this.NoSpaceAfterOpenAngularBracket,this.NoSpaceBeforeCloseAngularBracket,this.NoSpaceAfterCloseAngularBracket,this.SpaceBeforeAt,this.NoSpaceAfterAt,this.SpaceAfterDecorator,this.NoSpaceBeforeNonNullAssertionOperator,this.NoSpaceAfterNewKeywordOnConstructorSignature],this.UserConfigurableRules=[this.SpaceAfterConstructor,this.NoSpaceAfterConstructor,this.SpaceAfterComma,this.NoSpaceAfterComma,this.SpaceAfterAnonymousFunctionKeyword,this.NoSpaceAfterAnonymousFunctionKeyword,this.SpaceAfterKeywordInControl,this.NoSpaceAfterKeywordInControl,this.SpaceAfterOpenParen,this.SpaceBeforeCloseParen,this.SpaceBetweenOpenParens,this.NoSpaceBetweenParens,this.NoSpaceAfterOpenParen,this.NoSpaceBeforeCloseParen,this.SpaceAfterOpenBracket,this.SpaceBeforeCloseBracket,this.NoSpaceBetweenBrackets,this.NoSpaceAfterOpenBracket,this.NoSpaceBeforeCloseBracket,this.SpaceAfterOpenBrace,this.SpaceBeforeCloseBrace,this.NoSpaceBetweenEmptyBraceBrackets,this.NoSpaceAfterOpenBrace,this.NoSpaceBeforeCloseBrace,this.SpaceAfterTemplateHeadAndMiddle,this.SpaceBeforeTemplateMiddleAndTail,this.NoSpaceAfterTemplateHeadAndMiddle,this.NoSpaceBeforeTemplateMiddleAndTail,this.SpaceAfterOpenBraceInJsxExpression,this.SpaceBeforeCloseBraceInJsxExpression,this.NoSpaceAfterOpenBraceInJsxExpression,this.NoSpaceBeforeCloseBraceInJsxExpression,this.SpaceAfterSemicolonInFor,this.NoSpaceAfterSemicolonInFor,this.SpaceBeforeBinaryOperator,this.SpaceAfterBinaryOperator,this.NoSpaceBeforeBinaryOperator,this.NoSpaceAfterBinaryOperator,this.SpaceBeforeOpenParenInFuncDecl,this.NoSpaceBeforeOpenParenInFuncDecl,this.NewLineBeforeOpenBraceInControl,this.NewLineBeforeOpenBraceInFunction,this.NewLineBeforeOpenBraceInTypeScriptDeclWithBlock,this.SpaceAfterTypeAssertion,this.NoSpaceAfterTypeAssertion],this.LowPriorityCommonRules=[this.NoSpaceBeforeSemicolon,this.SpaceBeforeOpenBraceInControl,this.SpaceBeforeOpenBraceInFunction,this.SpaceBeforeOpenBraceInTypeScriptDeclWithBlock,this.NoSpaceBeforeComma,this.NoSpaceBeforeOpenBracket,this.NoSpaceAfterCloseBracket,this.SpaceAfterSemicolon,this.SpaceBetweenStatements,this.SpaceAfterTryFinally],e.Debug.isDebugging){for(var r in this){var i=this[r];i instanceof t.Rule&&(i.debugName=r)}}}return n.IsOptionEnabled=function(e){return function(t){return t.options&&t.options.hasOwnProperty(e)&&!!t.options[e]}},n.IsOptionDisabled=function(e){return function(t){return t.options&&t.options.hasOwnProperty(e)&&!t.options[e]}},n.IsOptionDisabledOrUndefined=function(e){return function(t){return!t.options||!t.options.hasOwnProperty(e)||!t.options[e]}},n.isOptionDisabledOrUndefinedOrTokensOnSameLine=function(e){return function(t){return!t.options||!t.options.hasOwnProperty(e)||!t.options[e]||t.TokensAreOnSameLine()}},n.IsOptionEnabledOrUndefined=function(e){return function(t){return!t.options||!t.options.hasOwnProperty(e)||!!t.options[e]}},n.IsForContext=function(e){return 214===e.contextNode.kind},n.IsNotForContext=function(e){return!n.IsForContext(e)},n.IsBinaryOpContext=function(e){switch(e.contextNode.kind){case 194:case 195:case 202:case 246:case 242:case 158:case 166:case 167:return!0;case 176:case 231:case 237:case 226:case 146:case 264:case 149:case 148:return 58===e.currentTokenSpan.kind||58===e.nextTokenSpan.kind;case 215:case 145:return 92===e.currentTokenSpan.kind||92===e.nextTokenSpan.kind;case 216:return 142===e.currentTokenSpan.kind||142===e.nextTokenSpan.kind}return!1},n.IsNotBinaryOpContext=function(e){return!n.IsBinaryOpContext(e)},n.IsConditionalOperatorContext=function(e){return 195===e.contextNode.kind},n.IsSameLineTokenOrBeforeBlockContext=function(e){return e.TokensAreOnSameLine()||n.IsBeforeBlockContext(e)},n.IsBraceWrappedContext=function(e){return 174===e.contextNode.kind||n.IsSingleLineBlockContext(e)},n.IsBeforeMultilineBlockContext=function(e){return n.IsBeforeBlockContext(e)&&!(e.NextNodeAllOnSameLine()||e.NextNodeBlockIsOnOneLine())},n.IsMultilineBlockContext=function(e){return n.IsBlockContext(e)&&!(e.ContextNodeAllOnSameLine()||e.ContextNodeBlockIsOnOneLine())},n.IsSingleLineBlockContext=function(e){return n.IsBlockContext(e)&&(e.ContextNodeAllOnSameLine()||e.ContextNodeBlockIsOnOneLine())},n.IsBlockContext=function(e){return n.NodeIsBlockContext(e.contextNode)},n.IsBeforeBlockContext=function(e){return n.NodeIsBlockContext(e.nextTokenParent)},n.NodeIsBlockContext=function(e){if(n.NodeIsTypeScriptDeclWithBlockContext(e))return!0;switch(e.kind){case 207:case 235:case 178:case 234:return!0}return!1},n.IsFunctionDeclContext=function(e){switch(e.contextNode.kind){case 228:case 151:case 150:case 153:case 154:case 155:case 186:case 152:case 187:case 230:return!0}return!1},n.IsFunctionDeclarationOrFunctionExpressionContext=function(e){return 228===e.contextNode.kind||186===e.contextNode.kind},n.IsTypeScriptDeclWithBlockContext=function(e){return n.NodeIsTypeScriptDeclWithBlockContext(e.contextNode)},n.NodeIsTypeScriptDeclWithBlockContext=function(e){switch(e.kind){case 229:case 199:case 230:case 232:case 163:case 233:case 244:case 245:case 238:case 241:return!0}return!1},n.IsAfterCodeBlockContext=function(e){switch(e.currentTokenParent.kind){case 229:case 233:case 232:case 260:case 234:case 221:return!0;case 207:var t=e.currentTokenParent.parent;if(!t||187!==t.kind&&186!==t.kind)return!0}return!1},n.IsControlDeclContext=function(e){switch(e.contextNode.kind){case 211:case 221:case 214:case 215:case 216:case 213:case 224:case 212:case 220:case 260:return!0;default:return!1}},n.IsObjectContext=function(e){return 178===e.contextNode.kind},n.IsFunctionCallContext=function(e){return 181===e.contextNode.kind},n.IsNewContext=function(e){return 182===e.contextNode.kind},n.IsFunctionCallOrNewContext=function(e){return n.IsFunctionCallContext(e)||n.IsNewContext(e)},n.IsPreviousTokenNotComma=function(e){return 26!==e.currentTokenSpan.kind},n.IsNextTokenNotCloseBracket=function(e){return 22!==e.nextTokenSpan.kind},n.IsArrowFunctionContext=function(e){return 187===e.contextNode.kind},n.IsNonJsxSameLineTokenContext=function(e){return e.TokensAreOnSameLine()&&10!==e.contextNode.kind},n.IsNonJsxElementContext=function(e){return 249!==e.contextNode.kind},n.IsJsxExpressionContext=function(e){return 256===e.contextNode.kind},n.IsNextTokenParentJsxAttribute=function(e){return 253===e.nextTokenParent.kind},n.IsJsxAttributeContext=function(e){return 253===e.contextNode.kind},n.IsJsxSelfClosingElementContext=function(e){return 250===e.contextNode.kind},n.IsNotBeforeBlockInFunctionDeclarationContext=function(e){return!n.IsFunctionDeclContext(e)&&!n.IsBeforeBlockContext(e)},n.IsEndOfDecoratorContextOnSameLine=function(e){return e.TokensAreOnSameLine()&&e.contextNode.decorators&&n.NodeIsInDecoratorContext(e.currentTokenParent)&&!n.NodeIsInDecoratorContext(e.nextTokenParent)},n.NodeIsInDecoratorContext=function(t){for(;e.isPartOfExpression(t);)t=t.parent;return 147===t.kind},n.IsStartOfVariableDeclarationList=function(e){return 227===e.currentTokenParent.kind&&e.currentTokenParent.getStart(e.sourceFile)===e.currentTokenSpan.pos},n.IsNotFormatOnEnter=function(e){return 2!==e.formattingRequestKind},n.IsModuleDeclContext=function(e){return 233===e.contextNode.kind},n.IsObjectTypeContext=function(e){return 163===e.contextNode.kind},n.IsConstructorSignatureContext=function(e){return 156===e.contextNode.kind},n.IsTypeArgumentOrParameterOrAssertion=function(e,t){if(27!==e.kind&&29!==e.kind)return!1;switch(t.kind){case 159:case 184:case 231:case 229:case 199:case 230:case 228:case 186:case 187:case 151:case 150:case 155:case 156:case 181:case 182:case 201:return!0;default:return!1}},n.IsTypeArgumentOrParameterOrAssertionContext=function(e){return n.IsTypeArgumentOrParameterOrAssertion(e.currentTokenSpan,e.currentTokenParent)||n.IsTypeArgumentOrParameterOrAssertion(e.nextTokenSpan,e.nextTokenParent)},n.IsTypeAssertionContext=function(e){return 184===e.contextNode.kind},n.IsVoidOpContext=function(e){return 105===e.currentTokenSpan.kind&&190===e.currentTokenParent.kind},n.IsYieldOrYieldStarWithOperand=function(e){return 197===e.contextNode.kind&&void 0!==e.contextNode.expression},n.IsNonNullAssertionContext=function(e){return 203===e.contextNode.kind},n}();t.Rules=n}(e.formatting||(e.formatting={}))}(ts||(ts={})),function(e){!function(t){var n=function(){function t(e){this.mapRowLength=143,this.map=new Array(this.mapRowLength*this.mapRowLength);for(var t=new Array(this.map.length),n=0,r=e;n<r.length;n++){var i=r[n];this.FillRule(i,t)}}return t.prototype.GetRuleBucketIndex=function(t,n){return e.Debug.assert(t<=142&&n<=142,"Must compute formatting context from tokens"),t*this.mapRowLength+n},t.prototype.FillRule=function(e,t){var n=this,r=e.Descriptor.LeftTokenRange.isSpecific()&&e.Descriptor.RightTokenRange.isSpecific();e.Descriptor.LeftTokenRange.GetTokens().forEach((function(i){e.Descriptor.RightTokenRange.GetTokens().forEach((function(o){var s=n.GetRuleBucketIndex(i,o),c=n.map[s];void 0===c&&(c=n.map[s]=new a),c.AddRule(e,r,t,s)}))}))},t.prototype.GetRule=function(e){var t=this.GetRuleBucketIndex(e.currentTokenSpan.kind,e.nextTokenSpan.kind),n=this.map[t];if(n)for(var r=0,i=n.Rules();r<i.length;r++){var a=i[r];if(a.Operation.Context.InContext(e))return a}},t}();t.RulesMap=n;var r;!function(e){e[e.IgnoreRulesSpecific=0]="IgnoreRulesSpecific",e[e.IgnoreRulesAny=5]="IgnoreRulesAny",e[e.ContextRulesSpecific=10]="ContextRulesSpecific",e[e.ContextRulesAny=15]="ContextRulesAny",e[e.NoContextRulesSpecific=20]="NoContextRulesSpecific",e[e.NoContextRulesAny=25]="NoContextRulesAny"}(r||(r={}));var i=function(){function t(){this.rulesInsertionIndexBitmap=0}return t.prototype.GetInsertionIndex=function(e){for(var t=0,n=0,r=this.rulesInsertionIndexBitmap;n<=e;)t+=31&r,r>>=5,n+=5;return t},t.prototype.IncreaseInsertionIndex=function(t){var n=this.rulesInsertionIndexBitmap>>t&31;n++,e.Debug.assert((31&n)===n,"Adding more rules into the sub-bucket than allowed. Maximum allowed is 32 rules.");var r=this.rulesInsertionIndexBitmap&~(31<<t);r|=n<<t,this.rulesInsertionIndexBitmap=r},t}();t.RulesBucketConstructionState=i;var a=function(){function e(){this.rules=[]}return e.prototype.Rules=function(){return this.rules},e.prototype.AddRule=function(e,t,n,a){var o;o=1===e.Operation.Action?t?r.IgnoreRulesSpecific:r.IgnoreRulesAny:e.Operation.Context.IsAny()?t?r.NoContextRulesSpecific:r.NoContextRulesAny:t?r.ContextRulesSpecific:r.ContextRulesAny;var s=n[a];void 0===s&&(s=n[a]=new i);var c=s.GetInsertionIndex(o);this.rules.splice(c,0,e),s.IncreaseInsertionIndex(o)},e}();t.RulesBucket=a}(e.formatting||(e.formatting={}))}(ts||(ts={})),function(e){!function(t){!function(t){for(var n=[],r=0;r<=142;r++)n.push(r);var i=function(){function e(e){void 0===e&&(e=[]),this.tokens=e}return e.prototype.GetTokens=function(){return this.tokens},e.prototype.Contains=function(e){return this.tokens.indexOf(e)>=0},e.prototype.isSpecific=function(){return!0},e}(),a=function(){function e(e){this.token=e}return e.prototype.GetTokens=function(){return[this.token]},e.prototype.Contains=function(e){return e===this.token},e.prototype.isSpecific=function(){return!0},e}(),o=function(){function e(){}return e.prototype.GetTokens=function(){return n},e.prototype.Contains=function(){return!0},e.prototype.toString=function(){return"[allTokens]"},e.prototype.isSpecific=function(){return!1},e}(),s=function(){function e(e){this.except=e}return e.prototype.GetTokens=function(){var e=this;return n.filter((function(t){return t!==e.except}))},e.prototype.Contains=function(e){return e!==this.except},e.prototype.isSpecific=function(){return!1},e}();!function(t){t.FromToken=function(e){return new a(e)},t.FromTokens=function(e){return new i(e)},t.FromRange=function(t,n,r){void 0===r&&(r=[]);for(var a=[],o=t;o<=n;o++)e.indexOf(r,o)<0&&a.push(o);return new i(a)},t.AnyExcept=function(e){return new s(e)},t.Any=new o,t.AnyIncludingMultilineComments=t.FromTokens(n.concat([3])),t.Keywords=t.FromRange(72,142),t.BinaryOperators=t.FromRange(27,70),t.BinaryKeywordOperators=t.FromTokens([92,93,142,118,126]),t.UnaryPrefixOperators=t.FromTokens([43,44,52,51]),t.UnaryPrefixExpressions=t.FromTokens([8,71,19,21,17,99,94]),t.UnaryPreincrementExpressions=t.FromTokens([71,19,99,94]),t.UnaryPostincrementExpressions=t.FromTokens([71,20,22,94]),t.UnaryPredecrementExpressions=t.FromTokens([71,19,99,94]),t.UnaryPostdecrementExpressions=t.FromTokens([71,20,22,94]),t.Comments=t.FromTokens([2,3]),t.TypeNames=t.FromTokens([71,133,136,122,137,105,119])}(t.TokenRange||(t.TokenRange={}))}(t.Shared||(t.Shared={}))}(e.formatting||(e.formatting={}))}(ts||(ts={})),function(e){!function(t){var n=function(){function n(){this.globalRules=new t.Rules;var e=this.globalRules.HighPriorityCommonRules.concat(this.globalRules.UserConfigurableRules).concat(this.globalRules.LowPriorityCommonRules);this.rulesMap=new t.RulesMap(e)}return n.prototype.getRulesMap=function(){return this.rulesMap},n.prototype.getFormatOptions=function(){return this.options},n.prototype.ensureUpToDate=function(t){this.options&&e.compareDataObjects(this.options,t)||(this.options=e.clone(t))},n}();t.RulesProvider=n}(e.formatting||(e.formatting={}))}(ts||(ts={})),function(e){!function(t){var n,r,i,a;function o(t,n,r){var i=e.findPrecedingToken(t,r);return i&&i.kind===n&&t===i.getEnd()?i:void 0}function s(e){for(var t=e;t&&t.parent&&t.parent.end===e.end&&!c(t.parent,t);)t=t.parent;return t}function c(t,n){switch(t.kind){case 229:case 230:return e.rangeContainsRange(t.members,n);case 233:var r=t.body;return r&&234===r.kind&&e.rangeContainsRange(r.statements,n);case 265:case 207:case 234:return e.rangeContainsRange(t.statements,n);case 260:return e.rangeContainsRange(t.block.statements,n)}return!1}function u(t,n,r,i,a){return t?_({pos:e.getLineStartPositionForPosition(t.getStart(n),n),end:t.end},n,r,i,a):[]}function _(n,r,i,a,o){var s=function(t,n){return function r(i){var a=e.forEachChild(i,(function(r){return e.startEndContainsRange(r.getStart(n),r.end,t)&&r}));if(a){var o=r(a);if(o)return o}return i}(n)}(n,r);return t.getFormattingScanner(r.text,r.languageVariant,function(t,n,r){var i=t.getStart(r);if(i===n.pos&&t.end===n.end)return i;var a=e.findPrecedingToken(n.pos,r);return a?a.end>=n.pos?t.pos:a.end:t.pos}(s,n,r),n.end,(function(c){return l(n,s,t.SmartIndenter.getIndentationForNode(s,n,r,i),function(e,n,r){for(var i,a=-1;e;){var o=r.getLineAndCharacterOfPosition(e.getStart(r)).line;if(-1!==a&&o!==a)break;if(t.SmartIndenter.shouldIndentChildNode(e,i))return n.indentSize;a=o,i=e,e=e.parent}return 0}(s,i,r),c,i,a,o,function(t,n){if(!t.length)return a;var r=t.filter((function(t){return e.rangeOverlapsWithStartEnd(n,t.start,t.start+t.length)})).sort((function(e,t){return e.start-t.start}));if(!r.length)return a;var i=0;return function(t){for(;;){if(i>=r.length)return!1;var n=r[i];if(t.end<=n.start)return!1;if(e.startEndOverlapsWithStartEnd(t.pos,t.end,n.start,n.start+n.length))return!0;i++}};function a(){return!1}}(r.parseDiagnostics,n),r)}))}function l(n,r,i,a,o,s,c,u,_,l){var p,f,m,g,y,h=new t.FormattingContext(l,u,s),v=[];if(o.advance(),o.isOnToken()){var b=l.getLineAndCharacterOfPosition(r.getStart(l)).line,x=b;r.decorators&&(x=l.getLineAndCharacterOfPosition(e.getNonDecoratorTokenPosOfNode(r,l)).line),function r(i,a,c,u,d,f){if(!e.rangeOverlapsWithStartEnd(n,i.getStart(l),i.getEnd()))return;var m=D(i,c,d,f),h=a;e.forEachChild(i,(function(e){b(e,-1,i,m,c,u,!1)}),(function(e){x(e,i,c,m)}));for(;o.isOnToken();){var v=o.readTokenInfo(i);if(v.token.end>i.end)break;k(v,i,m,i)}function b(a,c,u,_,d,p,f,m){var g=a.getStart(l),y=l.getLineAndCharacterOfPosition(g).line,v=y;a.decorators&&(v=l.getLineAndCharacterOfPosition(e.getNonDecoratorTokenPosOfNode(a,l)).line);var b=-1;if(f&&e.rangeContainsRange(n,u)&&-1!==(b=function(n,r,i,a,o){if(e.rangeOverlapsWithStartEnd(a,n,r)||e.rangeContainsStartEnd(a,n,r)){if(-1!==o)return o}else{var c=l.getLineAndCharacterOfPosition(n).line,u=e.getLineStartPositionForPosition(n,l),_=t.SmartIndenter.findFirstNonWhitespaceColumn(u,n,l,s);if(c!==i||n===_){var d=t.SmartIndenter.getBaseIndentation(s);return d>_?d:_}}return-1}(g,a.end,d,n,c))&&(c=b),!e.rangeOverlapsWithStartEnd(n,a.pos,a.end))return a.end<n.pos&&o.skipToEndOf(a),c;if(0===a.getFullWidth())return c;for(;o.isOnToken();){if((x=o.readTokenInfo(i)).token.end>g)break;k(x,i,_,i)}if(!o.isOnToken())return c;if(e.isToken(a)&&10!==a.kind){var x=o.readTokenInfo(a);return e.Debug.assert(x.token.end===a.end,"Token end is child end"),k(x,i,_,a),c}var D=147===a.kind?y:p,C=S(a,y,b,i,_,D);return r(a,h,y,v,C.indentation,C.delta),h=i,m&&177===u.kind&&-1===c&&(c=C.indentation),c}function x(t,n,r,a){e.Debug.assert(e.isNodeArray(t));var s=function(e,t){switch(e.kind){case 152:case 228:case 186:case 151:case 150:case 187:if(e.typeParameters===t)return 27;if(e.parameters===t)return 19;break;case 181:case 182:if(e.typeArguments===t)return 27;if(e.arguments===t)return 19;break;case 159:if(e.typeArguments===t)return 27}return 0}(n,t),c=function(e){switch(e){case 19:return 20;case 27:return 29}return 0}(s),u=a,_=r;if(0!==s)for(;o.isOnToken();){if((p=o.readTokenInfo(n)).token.end>t.pos)break;if(p.token.kind===s){_=l.getLineAndCharacterOfPosition(p.token.pos).line;var d=S(p.token,_,-1,n,a,r);k(p,n,u=D(n,r,d.indentation,d.delta),n)}else k(p,n,a,n)}for(var p,f=-1,m=0;m<t.length;m++){f=b(t[m],f,i,u,_,_,!0,0===m)}0!==c&&(o.isOnToken()&&(p=o.readTokenInfo(n)).token.kind===c&&e.rangeContainsRange(n,p.token)&&k(p,n,u,n))}function k(t,r,i,a){e.Debug.assert(e.rangeContainsRange(r,t.token));var s,c=o.lastTrailingTriviaWasNewLine(),u=!1;t.leadingTrivia&&C(t.leadingTrivia,r,h,i);var d=e.rangeContainsRange(n,t.token),f=l.getLineAndCharacterOfPosition(t.token.pos);if(d){var m=_(t.token),v=p;if(s=T(t.token,f,r,h,i),m)u=!1;else if(void 0!==s)u=s;else{var b=v&&l.getLineAndCharacterOfPosition(v.end).line;u=c&&f.line!==b}}if(t.trailingTrivia&&C(t.trailingTrivia,r,h,i),u){var x=d&&!_(t.token)?i.getIndentationForToken(f.line,t.token.kind,a):-1,k=!0;if(t.leadingTrivia)for(var S=i.getIndentationForComment(t.token.kind,x,a),D=0,A=t.leadingTrivia;D<A.length;D++){var w=A[D],P=e.rangeContainsRange(n,w);switch(w.kind){case 3:P&&N(w,S,!k),k=!1;break;case 2:k&&P&&E(w.pos,S,!1),k=!1;break;case 4:k=!0}}-1!==x&&k&&(E(t.token.pos,x,s),g=f.line,y=x)}o.advance(),h=r}}(r,r,b,x,i,a)}if(!o.isOnToken()){var k=o.getCurrentLeadingTrivia();k&&(C(k,r,r,void 0),function(){var e=p?p.end:n.pos,t=l.getLineAndCharacterOfPosition(e).line,r=l.getLineAndCharacterOfPosition(n.end).line;A(t,r+1,p)}())}return v;function S(e,n,r,i,a,o){var c=r,u=t.SmartIndenter.shouldIndentChildNode(e)?s.indentSize:0;return o===n?(c=n===g?y:a.getIndentation(),u=Math.min(s.indentSize,a.getDelta(e)+u)):-1===c&&(c=t.SmartIndenter.childStartsOnTheSameLineWithElseInIfStatement(i,e,n,l)?a.getIndentation():a.getIndentation()+a.getDelta(e)),{indentation:c,delta:u}}function D(n,r,i,a){return{getIndentationForComment:function(e,t,n){switch(e){case 18:case 22:case 20:return i+o(a,n)}return-1!==t?t:i},getIndentationForToken:function(t,s,c){if(r!==t&&n.decorators&&s===function(t){if(t.modifiers&&t.modifiers.length)return t.modifiers[0].kind;switch(t.kind){case 229:return 75;case 230:return 109;case 228:return 89;case 232:return 232;case 153:return 125;case 154:return 135;case 151:if(t.asteriskToken)return 39;case 149:case 146:return e.getNameOfDeclaration(t).kind}}(n))return i;switch(s){case 17:case 18:case 19:case 20:case 82:case 106:case 57:return i;case 41:case 29:if(251===c.kind||252===c.kind||250===c.kind)return i;break;case 21:case 22:if(172!==c.kind)return i}return r!==t?i+o(a,c):i},getIndentation:function(){return i},getDelta:function(e){return o(a,e)},recomputeIndentation:function(e){n.parent&&t.SmartIndenter.shouldIndentChildNode(n.parent,n)&&(e?i+=s.indentSize:i-=s.indentSize,a=t.SmartIndenter.shouldIndentChildNode(n)?s.indentSize:0)}};function o(e,r){return t.SmartIndenter.nodeWillIndentChild(n,r,!0)?e:0}}function C(t,r,i,a){for(var o=0,s=t;o<s.length;o++){var c=s[o];if(e.isComment(c.kind)&&e.rangeContainsRange(n,c))T(c,l.getLineAndCharacterOfPosition(c.pos),r,i,a)}}function T(e,t,r,i,a){var o;_(e)||(p?o=function(e,t,n,r,i,a,o,u){h.updateContext(r,a,e,n,o);var _,d,p=c.getRulesMap().GetRule(h);p?(!function(e,t,n,r,i){switch(e.Operation.Action){case 1:return;case 8:t.end!==r.pos&&F(t.end,r.pos-t.end);break;case 4:if(1!==e.Flag&&n!==i)return;1!==i-n&&O(t.end,r.pos-t.end,s.newLineCharacter);break;case 2:if(1!==e.Flag&&n!==i)return;1===r.pos-t.end&&32===l.text.charCodeAt(t.end)||O(t.end,r.pos-t.end," ")}}(p,r,i,e,t),10&p.Operation.Action&&t!==i?(d=!1,n.getStart(l)===e.pos&&u.recomputeIndentation(!1)):4&p.Operation.Action&&t===i&&(d=!0,n.getStart(l)===e.pos&&u.recomputeIndentation(!0)),_=!(8&p.Operation.Action)&&1!==p.Flag):_=!0;t!==i&&_&&A(i,t,r);return d}(e,t.line,r,p,m,f,i,a):A(l.getLineAndCharacterOfPosition(n.pos).line,t.line));return p=e,f=r,m=t.line,o}function E(t,n,r){var i=d(n,s);if(r)O(t,0,i);else{var a=l.getLineAndCharacterOfPosition(t),o=e.getStartPositionOfLine(a.line,l);(n!==function(e,t){for(var n=0,r=0;r<t;r++)9===l.text.charCodeAt(e+r)?n+=s.tabSize-n%s.tabSize:n++;return n}(o,a.character)||function(e,t){return e!==l.text.substr(t,e.length)}(i,o))&&O(o,a.character,i)}}function N(n,r,i){var a,o=l.getLineAndCharacterOfPosition(n.pos).line,c=l.getLineAndCharacterOfPosition(n.end).line;if(o!==c){a=[];for(var u=n.pos,_=o;_<c;_++){var p=e.getEndLinePosition(_,l);a.push({pos:u,end:p}),u=e.getStartPositionOfLine(_+1,l)}a.push({pos:u,end:n.end});var f=e.getStartPositionOfLine(o,l),m=t.SmartIndenter.findFirstNonWhitespaceCharacterAndColumn(f,a[0].pos,l,s);if(r!==m.column){var g=0;i&&(g=1,o++);for(var y=r-m.column,h=g;h<a.length;h++,o++){var v=e.getStartPositionOfLine(o,l),b=0===h?m:t.SmartIndenter.findFirstNonWhitespaceCharacterAndColumn(a[h].pos,a[h].end,l,s),x=b.column+y;if(x>0){var k=d(x,s);O(v,b.character,k)}else F(v,b.character)}}}else i||E(n.pos,r,!1)}function A(t,n,r){for(var i=t;i<n;i++){var a=e.getStartPositionOfLine(i,l),o=e.getEndLinePosition(i,l);if(!(r&&(e.isComment(r.kind)||e.isStringOrRegularExpressionOrTemplateLiteral(r.kind))&&r.pos<=o&&r.end>o)){var s=w(a,o);-1!==s&&(e.Debug.assert(s===a||!e.isWhiteSpaceSingleLine(l.text.charCodeAt(s-1))),F(s,o+1-s))}}}function w(t,n){for(var r=n;r>=t&&e.isWhiteSpaceSingleLine(l.text.charCodeAt(r));)r--;return r!==n?r+1:-1}function P(t,n,r){return{span:e.createTextSpan(t,n),newText:r}}function F(e,t){t&&v.push(P(e,t,""))}function O(e,t,n){(t||n)&&v.push(P(e,t,n))}}function d(e,t){if((!r||r.tabSize!==t.tabSize||r.indentSize!==t.indentSize)&&(r={tabSize:t.tabSize,indentSize:t.indentSize},i=a=void 0),t.convertTabsToSpaces){var n=void 0,o=Math.floor(e/t.indentSize),s=e%t.indentSize;return a||(a=[]),void 0===a[o]?(n=l(" ",t.indentSize*o),a[o]=n):n=a[o],s?n+l(" ",s):n}var c=Math.floor(e/t.tabSize),u=e-c*t.tabSize,_=void 0;return i||(i=[]),void 0===i[c]?i[c]=_=l("\t",c):_=i[c],u?_+l(" ",u):_;function l(e,t){for(var n="",r=0;r<t;r++)n+=e;return n}}!function(e){e[e.Unknown=-1]="Unknown"}(n||(n={})),t.formatOnEnter=function(t,n,r,i){var a=n.getLineAndCharacterOfPosition(t).line;if(0===a)return[];for(var o=e.getEndLinePosition(a,n);e.isWhiteSpaceSingleLine(n.text.charCodeAt(o));)o--;return e.isLineBreak(n.text.charCodeAt(o))&&o--,_({pos:e.getStartPositionOfLine(a-1,n),end:o+1},n,i,r,2)},t.formatOnSemicolon=function(e,t,n,r){return u(s(o(e,25,t)),t,r,n,3)},t.formatOnOpeningCurly=function(t,n,r,i){var a=o(t,17,n);if(!a)return[];var c=s(a.parent);return _({pos:e.getLineStartPositionForPosition(c.getStart(n),n),end:t},n,i,r,4)},t.formatOnClosingCurly=function(e,t,n,r){return u(s(o(e,18,t)),t,r,n,5)},t.formatDocument=function(e,t,n){return _({pos:0,end:e.text.length},e,n,t,0)},t.formatSelection=function(t,n,r,i,a){return _({pos:e.getLineStartPositionForPosition(t,r),end:n},r,a,i,1)},t.formatNodeGivenIndentation=function(e,n,r,i,a,o){var s={pos:0,end:n.text.length};return t.getFormattingScanner(n.text,r,s.pos,s.end,(function(t){return l(s,e,i,a,t,o.getFormatOptions(),o,1,(function(e){return!1}),n)}))},t.getRangeOfEnclosingComment=function(t,n,r,i,a,o){if(void 0===a&&(a=e.getTokenAtPosition(t,n,!1)),!(a.getStart(t)<=n&&n<a.getEnd())){void 0===i&&(i=e.findPrecedingToken(n,t));var s=i&&e.getTrailingCommentRanges(t.text,i.end),c=e.getLeadingCommentRangesOfNode(a,t),u=s&&c?s.concat(c):s||c;if(u)for(var _=0,l=u;_<l.length;_++){var d=l[_];if(d.pos<n&&n<d.end||n===d.end&&(2===d.kind||n===t.getFullWidth()))return 3!==d.kind&&r||o&&!o(d)?void 0:d}}},t.getIndentationString=d}(e.formatting||(e.formatting={}))}(ts||(ts={})),function(e){!function(t){!function(n){var r,i;function a(e){return e.baseIndentSize||0}function o(e,t,n,r,i,o){for(var u,_=e.parent;_;){var p=!0;if(n){var f=e.getStart(i);p=f<n.pos||f>n.end}if(p)if(-1!==(h=m(e,i,o)))return h+r;var y=(u=s(_,e,i)).line===t.line||d(_,e,t.line,i);if(p){var h;if(-1!==(h=c(e,_,t,y,i,o)))return h+r;if(-1!==(h=g(e,i,o)))return h+r}k(_,e)&&!y&&(r+=o.indentSize);var v=l(_,e,t.line,i);_=(e=_).parent,t=v?i.getLineAndCharacterOfPosition(e.getStart()):u}return r+a(o)}function s(e,t,n){var r=f(t,n),i=r?r.pos:e.getStart(n);return n.getLineAndCharacterOfPosition(i)}function c(t,n,r,i,a,o){return(e.isDeclaration(t)||e.isStatementButNotDeclaration(t))&&(265===n.kind||!i)?h(r,a,o):-1}function u(t,n,r,i){var a=e.findNextToken(t,n);return a?17===a.kind?1:18===a.kind&&r===_(a,i).line?2:0:0}function _(e,t){return t.getLineAndCharacterOfPosition(e.getStart(t))}function l(t,n,r,i){if(!e.isCallExpression(t)||!e.contains(t.arguments,n))return!1;var a=t.expression.getEnd();return e.getLineAndCharacterOfPosition(i,a).line===r}function d(t,n,r,i){if(211===t.kind&&t.elseStatement===n){var a=e.findChildOfKind(t,82,i);return e.Debug.assert(void 0!==a),_(a,i).line===r}return!1}function p(t,n,r){return t&&e.rangeContainsStartEnd(t,n,r)?t:void 0}function f(e,t){if(e.parent)switch(e.parent.kind){case 159:return p(e.parent.typeArguments,e.getStart(t),e.getEnd());case 178:return e.parent.properties;case 177:return e.parent.elements;case 228:case 186:case 187:case 151:case 150:case 155:case 152:case 161:case 156:var n=e.getStart(t);return p(e.parent.typeParameters,n,e.getEnd())||p(e.parent.parameters,n,e.getEnd());case 229:return p(e.parent.typeParameters,e.getStart(t),e.getEnd());case 182:case 181:n=e.getStart(t);return p(e.parent.typeArguments,n,e.getEnd())||p(e.parent.arguments,n,e.getEnd());case 227:return p(e.parent.declarations,e.getStart(t),e.getEnd());case 241:case 245:return p(e.parent.elements,e.getStart(t),e.getEnd())}}function m(t,n,r){var i,a,o=f(t,n);return o?(i=o,-1!==(a=e.indexOf(i,t))?y(i,a,n,r):-1):-1}function g(t,n,r){if(20===t.kind)return-1;if(t.parent&&e.isCallOrNewExpression(t.parent)&&t.parent.expression!==t){var i=t.parent.expression,a=function(e){for(;;)switch(e.kind){case 181:case 182:case 179:case 180:e=e.expression;break;default:return e}}(i);if(i===a)return-1;var o=n.getLineAndCharacterOfPosition(i.end),s=n.getLineAndCharacterOfPosition(a.end);return o.line===s.line?-1:h(o,n,r)}return-1}function y(t,n,r,i){e.Debug.assert(n>=0&&n<t.length);for(var a=_(t[n],r),o=n-1;o>=0;o--)if(26!==t[o].kind){if(r.getLineAndCharacterOfPosition(t[o].end).line!==a.line)return h(a,r,i);a=_(t[o],r)}return-1}function h(e,t,n){var r=t.getPositionOfLineAndCharacter(e.line,0);return b(r,r+e.character,t,n)}function v(t,n,r,i){for(var a=0,o=0,s=t;s<n;s++){var c=r.text.charCodeAt(s);if(!e.isWhiteSpaceSingleLine(c))break;9===c?o+=i.tabSize+o%i.tabSize:o++,a++}return{column:o,character:a}}function b(e,t,n,r){return v(e,t,n,r).column}function x(e,t,n){var r=t?t.kind:0;switch(e.kind){case 212:case 213:case 215:case 216:case 214:case 211:case 228:case 186:case 151:case 187:case 152:case 153:case 154:return 207!==r;case 244:return 245!==r;case 238:return 239!==r||t.namedBindings&&241!==t.namedBindings.kind;case 249:return 252!==r}return n}function k(e,t){return function(e){switch(e){case 210:case 229:case 199:case 230:case 232:case 231:case 177:case 207:case 234:case 178:case 163:case 172:case 165:case 235:case 258:case 257:case 185:case 179:case 181:case 182:case 208:case 226:case 243:case 219:case 195:case 175:case 174:case 251:case 250:case 256:case 150:case 155:case 156:case 146:case 160:case 161:case 168:case 183:case 191:case 245:case 241:case 246:case 242:case 261:case 149:return!0}return!1}(e.kind)||x(e,t,!1)}!function(e){e[e.Unknown=-1]="Unknown"}(r||(r={})),n.getIndentation=function(r,i,s,c){if(void 0===c&&(c=!1),r>i.text.length)return a(s);if(s.indentStyle===e.IndentStyle.None)return 0;var l=e.findPrecedingToken(r,i),d=t.getRangeOfEnclosingComment(i,r,!0,l||null);if(d){var p=e.getLineAndCharacterOfPosition(i,r).line-1,f=e.getLineAndCharacterOfPosition(i,d.pos).line;if(e.Debug.assert(f>=0),p<=f)return b(e.getStartPositionOfLine(f,i),r,i,s);var h=e.getStartPositionOfLine(p,i),x=v(h,r,i,s),S=x.column,D=x.character;return 0===S?S:42===i.text.charCodeAt(h+D)?S-1:S}if(!l)return a(s);if(e.isStringOrRegularExpressionOrTemplateLiteral(l.kind)&&l.getStart(i)<=r&&r<l.end)return 0;var C,T=i.getLineAndCharacterOfPosition(r).line;if(s.indentStyle===e.IndentStyle.Block){for(var E=r;E>0;){var N=i.text.charCodeAt(E);if(!e.isWhiteSpaceLike(N))break;E--}var A=e.getLineStartPositionForPosition(E,i);return n.findFirstNonWhitespaceColumn(A,E,i,s)}if(26===l.kind&&194!==l.parent.kind&&-1!==(I=function(t,n,r){var i=e.findListItemInfo(t);return i&&i.listItemIndex>0?y(i.list.getChildren(),i.listItemIndex-1,n,r):-1}(l,i,s)))return I;for(var w,P,F=l;F;){if(e.positionBelongsToNode(F,r,i)&&k(F,C)){w=_(F,i);var O=u(l,F,T,i);P=0!==O?c&&2===O?s.indentSize:0:T!==w.line?s.indentSize:0;break}var I;if(-1!==(I=m(F,i,s)))return I;if(-1!==(I=g(F,i,s)))return I+s.indentSize;C=F,F=F.parent}return F?o(F,w,void 0,P,i,s):a(s)},n.getIndentationForNode=function(e,t,n,r){var i=n.getLineAndCharacterOfPosition(e.getStart(n));return o(e,i,t,0,n,r)},n.getBaseIndentation=a,function(e){e[e.Unknown=0]="Unknown",e[e.OpenBrace=1]="OpenBrace",e[e.CloseBrace=2]="CloseBrace"}(i||(i={})),n.isArgumentAndStartLineOverlapsExpressionBeingCalled=l,n.childStartsOnTheSameLineWithElseInIfStatement=d,n.getContainingList=f,n.findFirstNonWhitespaceCharacterAndColumn=v,n.findFirstNonWhitespaceColumn=b,n.nodeWillIndentChild=x,n.shouldIndentChildNode=k}(t.SmartIndenter||(t.SmartIndenter={}))}(e.formatting||(e.formatting={}))}(ts||(ts={})),function(e){!function(t){function n(t){var n=t.__pos;return e.Debug.assert("number"==typeof n),n}function r(t,n){e.Debug.assert("number"==typeof n),t.__pos=n}function i(t){var n=t.__end;return e.Debug.assert("number"==typeof n),n}function a(t,n){e.Debug.assert("number"==typeof n),t.__end=n}var o,s;function c(t,n){return e.skipTrivia(t,n,!1,!0)}function u(t,n,r,i){if(r.useNonAdjustedStartPosition)return n.getFullStart();var a=n.getFullStart(),s=n.getStart(t);if(a===s)return s;var u=e.getLineStartPositionForPosition(a,t);if(e.getLineStartPositionForPosition(s,t)===u)return i===o.Start?s:a;var _=a>0?1:0,l=e.getStartPositionOfLine(e.getLineOfLocalPosition(t,u)+_,t);return l=c(t.text,l),e.getStartPositionOfLine(e.getLineOfLocalPosition(t,l),t)}function _(t,n,r){if(r.useNonAdjustedEndPosition||e.isExpression(n))return n.getEnd();var i=n.getEnd(),a=e.skipTrivia(t.text,i,!0);return a!==i&&e.isLineBreak(t.text.charCodeAt(a-1))?a:i}function l(e,t){return t&&e.parent&&(26===t.kind||25===t.kind&&178===e.parent.kind)}!function(e){e[e.FullStart=0]="FullStart",e[e.Start=1]="Start"}(o=t.Position||(t.Position={})),function(e){e[e.Remove=0]="Remove",e[e.ReplaceWithSingleNode=1]="ReplaceWithSingleNode",e[e.ReplaceWithMultipleNodes=2]="ReplaceWithMultipleNodes"}(s||(s={})),t.getSeparatorCharacter=function(t){return e.tokenToString(t.kind)},t.getAdjustedStartPosition=u,t.getAdjustedEndPosition=_;var d=function(){function t(t,n,r){this.newLine=t,this.rulesProvider=n,this.validator=r,this.changes=[],this.newLineCharacter=e.getNewLineCharacter({newLine:t})}return t.fromContext=function(e){return new t("\n"===e.newLineCharacter?1:0,e.rulesProvider)},t.with=function(e,n){var r=t.fromContext(e);return n(r),r.getChanges()},t.prototype.deleteRange=function(e,t){return this.changes.push({kind:s.Remove,sourceFile:e,range:t}),this},t.prototype.deleteNode=function(e,t,n){void 0===n&&(n={});var r=u(e,t,n,o.FullStart),i=_(e,t,n);return this.changes.push({kind:s.Remove,sourceFile:e,range:{pos:r,end:i}}),this},t.prototype.deleteNodeRange=function(e,t,n,r){void 0===r&&(r={});var i=u(e,t,r,o.FullStart),a=_(e,n,r);return this.changes.push({kind:s.Remove,sourceFile:e,range:{pos:i,end:a}}),this},t.prototype.deleteNodeInList=function(t,n){var r=e.formatting.SmartIndenter.getContainingList(n,t);if(!r)return e.Debug.fail("node is not a list element"),this;var i=e.indexOfNode(r,n);if(i<0)return this;if(1===r.length)return this.deleteNode(t,n),this;if(i!==r.length-1){var a=e.getTokenAtPosition(t,n.end,!1);if(a&&l(n,a)){var s=e.skipTrivia(t.text,u(t,n,{},o.FullStart),!1,!0),c=r[i+1],_=e.skipTrivia(t.text,u(t,c,{},o.FullStart),!1,!0);this.deleteRange(t,{pos:s,end:_})}}else{var d=e.getTokenAtPosition(t,r[i-1].end,!1);d&&l(n,d)&&this.deleteNodeRange(t,d,n)}return this},t.prototype.replaceRange=function(e,t,n,r){return void 0===r&&(r={}),this.changes.push({kind:s.ReplaceWithSingleNode,sourceFile:e,range:t,options:r,node:n}),this},t.prototype.replaceNode=function(e,t,n,r){void 0===r&&(r={});var i=u(e,t,r,o.Start),a=_(e,t,r);return this.replaceWithSingle(e,i,a,n,r)},t.prototype.replaceNodeRange=function(e,t,n,r,i){void 0===i&&(i={});var a=u(e,t,i,o.Start),s=_(e,n,i);return this.replaceWithSingle(e,a,s,r,i)},t.prototype.replaceWithSingle=function(e,t,n,r,i){return this.changes.push({kind:s.ReplaceWithSingleNode,sourceFile:e,options:i,node:r,range:{pos:t,end:n}}),this},t.prototype.replaceWithMultiple=function(e,t,n,r,i){return this.changes.push({kind:s.ReplaceWithMultipleNodes,sourceFile:e,options:i,nodes:r,range:{pos:t,end:n}}),this},t.prototype.replaceNodeWithNodes=function(e,t,n,r){var i=u(e,t,r,o.Start),a=_(e,t,r);return this.replaceWithMultiple(e,i,a,n,r)},t.prototype.replaceNodesWithNodes=function(t,n,r,i){var a=u(t,n[0],i,o.Start),s=_(t,e.lastOrUndefined(n),i);return this.replaceWithMultiple(t,a,s,r,i)},t.prototype.replaceRangeWithNodes=function(e,t,n,r){return this.replaceWithMultiple(e,t.pos,t.end,n,r)},t.prototype.replaceNodeRangeWithNodes=function(e,t,n,r,i){var a=u(e,t,i,o.Start),s=_(e,n,i);return this.replaceWithMultiple(e,a,s,r,i)},t.prototype.insertNodeAt=function(e,t,n,r){return void 0===r&&(r={}),this.changes.push({kind:s.ReplaceWithSingleNode,sourceFile:e,options:r,node:n,range:{pos:t,end:t}}),this},t.prototype.insertNodeBefore=function(e,t,n,r){void 0===r&&(r={});var i=u(e,t,r,o.Start);return this.replaceWithSingle(e,i,i,n,r)},t.prototype.insertNodeAfter=function(t,n,r,i){void 0===i&&(i={}),(e.isStatementButNotDeclaration(n)||149===n.kind||148===n.kind||150===n.kind)&&59!==t.text.charCodeAt(n.end-1)&&this.changes.push({kind:s.ReplaceWithSingleNode,sourceFile:t,options:{},range:{pos:n.end,end:n.end},node:e.createToken(25)});var a=_(t,n,i);return this.replaceWithSingle(t,a,a,r,i)},t.prototype.insertNodeInListAfter=function(t,n,r){var i=e.formatting.SmartIndenter.getContainingList(n,t);if(!i)return e.Debug.fail("node is not a list element"),this;var a=e.indexOfNode(i,n);if(a<0)return this;var o=n.getEnd();if(a!==i.length-1){var u=e.getTokenAtPosition(t,n.end,!1);if(u&&l(n,u)){var _=e.getLineAndCharacterOfPosition(t,c(t.text,i[a+1].getFullStart())),d=e.getLineAndCharacterOfPosition(t,u.end),p=void 0,f=void 0;d.line===_.line?(f=u.end,p=function(e){for(var t="",n=0;n<e;n++)t+=" ";return t}(_.character-d.character)):f=e.getStartPositionOfLine(_.line,t),this.changes.push({kind:s.ReplaceWithSingleNode,sourceFile:t,range:{pos:f,end:i[a+1].getStart(t)},node:r,options:{prefix:p,suffix:""+e.tokenToString(u.kind)+t.text.substring(u.end,i[a+1].getStart(t))}})}}else{var m=n.getStart(t),g=e.getLineStartPositionForPosition(m,t),y=void 0,h=!1;if(1===i.length)y=26;else{var v=e.findPrecedingToken(n.pos,t);y=l(n,v)?v.kind:26,h=e.getLineStartPositionForPosition(i[a-1].getStart(t),t)!==g}if(function(t,n){for(var r=n;r<t.length;){var i=t.charCodeAt(r);if(!e.isWhiteSpaceSingleLine(i))return 47===i;r++}return!1}(t.text,n.end)&&(h=!0),h){this.changes.push({kind:s.ReplaceWithSingleNode,sourceFile:t,range:{pos:o,end:o},node:e.createToken(y),options:{}});var b=e.formatting.SmartIndenter.findFirstNonWhitespaceColumn(g,m,t,this.rulesProvider.getFormatOptions()),x=e.skipTrivia(t.text,o,!0,!1);x!==o&&e.isLineBreak(t.text.charCodeAt(x-1))&&x--,this.changes.push({kind:s.ReplaceWithSingleNode,sourceFile:t,range:{pos:x,end:x},node:r,options:{indentation:b,prefix:this.newLineCharacter}})}else this.changes.push({kind:s.ReplaceWithSingleNode,sourceFile:t,range:{pos:o,end:o},node:r,options:{prefix:e.tokenToString(y)+" "}})}return this},t.prototype.getChanges=function(){for(var n=this,r=e.createMap(),i=0,a=this.changes;i<a.length;i++){var o=a[i],s=r.get(o.sourceFile.path);s||r.set(o.sourceFile.path,s=[]),s.push(o)}var c=[];return r.forEach((function(e){for(var r=e[0].sourceFile,i={fileName:r.fileName,textChanges:[]},a=0,o=t.normalize(e);a<o.length;a++){var s=o[a];i.textChanges.push({span:n.computeSpan(s,r),newText:n.computeNewText(s,r)})}c.push(i)})),c},t.prototype.computeSpan=function(t,n){return e.createTextSpanFromBounds(t.range.pos,t.range.end)},t.prototype.computeNewText=function(t,n){var r=this;if(t.kind===s.Remove)return"";var i,a=t.options||{},o=t.range.pos,c=e.getLineStartPositionForPosition(o,n)===o;t.kind===s.ReplaceWithMultipleNodes?i=t.nodes.map((function(e){return r.getFormattedTextOfNode(e,n,o,a)})).join(t.options.nodeSeparator):(e.Debug.assert(t.kind===s.ReplaceWithSingleNode,"change.kind === ReplaceWithSingleNode"),i=this.getFormattedTextOfNode(t.node,n,o,a));return i=c||void 0!==a.indentation?i:i.replace(/^\s+/,""),(a.prefix||"")+i+(a.suffix||"")},t.prototype.getFormattedTextOfNode=function(t,n,r,i){var a=function(t,n,r){var i={newLine:r,target:n&&n.languageVersion},a=new g(e.getNewLineCharacter(i));return e.createPrinter(i,a).writeNode(4,t,n,a),{text:a.getText(),node:f(t)}}(t,n,this.newLine);this.validator&&this.validator(a);var o=this.rulesProvider.getFormatOptions(),s=e.getLineStartPositionForPosition(r,n)===r;return function(t,n,r,i,a){var o=e.computeLineStarts(t.text),s={text:t.text,lineMap:o,getLineAndCharacterOfPosition:function(t){return e.computeLineAndCharacterOfPosition(o,t)}},c=e.formatting.formatNodeGivenIndentation(t.node,s,n.languageVariant,r,i,a);return p(t.text,c)}(a,n,void 0!==i.indentation?i.indentation:!1!==i.useIndentationFromFile?e.formatting.SmartIndenter.getIndentation(r,n,o,s||i.prefix===this.newLineCharacter):0,void 0!==i.delta?i.delta:e.formatting.SmartIndenter.shouldIndentChildNode(t)&&o.indentSize||0,this.rulesProvider)},t.normalize=function(t){for(var n=e.stableSort(t,(function(e,t){return e.range.pos-t.range.pos})),r=0;r<n.length-2;r++)e.Debug.assert(n[r].range.end<=n[r+1].range.pos);return n},t}();function p(t,n){for(var r=n.length-1;r>=0;r--){var i=n[r];t=""+t.substring(0,i.span.start)+i.newText+t.substring(e.textSpanEnd(i.span))}return t}function f(t){var r=e.visitEachChild(t,f,e.nullTransformationContext,m,f),a=e.nodeIsSynthesized(r)?r:Object.create(r);return a.pos=n(t),a.end=i(t),a}function m(t,r,a,o,s){var c=e.visitNodes(t,r,a,o,s);if(!c)return c;var u=c===t?e.createNodeArray(c.slice(0)):c;return u.pos=n(t),u.end=i(t),u}t.ChangeTracker=d,t.applyChanges=p;var g=function(){function t(t){var n=this;this.lastNonTriviaPosition=0,this.writer=e.createTextWriter(t),this.onEmitNode=function(e,t,i){t&&r(t,n.lastNonTriviaPosition),i(e,t),t&&a(t,n.lastNonTriviaPosition)},this.onBeforeEmitNodeArray=function(e){e&&r(e,n.lastNonTriviaPosition)},this.onAfterEmitNodeArray=function(e){e&&a(e,n.lastNonTriviaPosition)},this.onBeforeEmitToken=function(e){e&&r(e,n.lastNonTriviaPosition)},this.onAfterEmitToken=function(e){e&&a(e,n.lastNonTriviaPosition)}}return t.prototype.setLastNonTriviaPosition=function(t,n){if(n||!function(t){return e.skipTrivia(t,0)===t.length}(t)){this.lastNonTriviaPosition=this.writer.getTextPos();for(var r=0;e.isWhiteSpaceLike(t.charCodeAt(t.length-r-1));)r++;this.lastNonTriviaPosition-=r}},t.prototype.write=function(e){this.writer.write(e),this.setLastNonTriviaPosition(e,!1)},t.prototype.writeTextOfNode=function(e,t){this.writer.writeTextOfNode(e,t)},t.prototype.writeLine=function(){this.writer.writeLine()},t.prototype.increaseIndent=function(){this.writer.increaseIndent()},t.prototype.decreaseIndent=function(){this.writer.decreaseIndent()},t.prototype.getText=function(){return this.writer.getText()},t.prototype.rawWrite=function(e){this.writer.rawWrite(e),this.setLastNonTriviaPosition(e,!1)},t.prototype.writeLiteral=function(e){this.writer.writeLiteral(e),this.setLastNonTriviaPosition(e,!0)},t.prototype.getTextPos=function(){return this.writer.getTextPos()},t.prototype.getLine=function(){return this.writer.getLine()},t.prototype.getColumn=function(){return this.writer.getColumn()},t.prototype.getIndent=function(){return this.writer.getIndent()},t.prototype.isAtStartOfLine=function(){return this.writer.isAtStartOfLine()},t.prototype.reset=function(){this.writer.reset(),this.lastNonTriviaPosition=0},t}()}(e.textChanges||(e.textChanges={}))}(ts||(ts={})),function(e){!function(t){var n=[];t.registerCodeFix=function(t){e.forEach(t.errorCodes,(function(e){var r=n[e];r||(r=[],n[e]=r),r.push(t)}))},t.getSupportedErrorCodes=function(){return Object.keys(n)},t.getFixes=function(t){var r=n[t.errorCode],i=[];return e.forEach(r,(function(e){var n=e.getCodeActions(t);if(n&&n.length>0)for(var r=0,a=n;r<a.length;r++){var o=a[r];void 0===o?t.host.log("Action for error code "+t.errorCode+" added an invalid action entry; please log a bug"):i.push(o)}})),i}}(e.codefix||(e.codefix={}))}(ts||(ts={})),function(e){var t,n;t=e.refactor||(e.refactor={}),n=e.createMap(),t.registerRefactor=function(e){n.set(e.name,e)},t.getApplicableRefactors=function(t){return e.flatMapIter(n.values(),(function(e){return t.cancellationToken&&t.cancellationToken.isCancellationRequested()?void 0:e.getAvailableActions(t)}))},t.getEditsForRefactor=function(e,t,r){var i=n.get(t);return i&&i.getEditsForAction(e,r)},e.getRefactorContextLength=function(e){return void 0===e.endPosition?0:e.endPosition-e.startPosition}}(ts||(ts={})),function(e){!function(t){t.registerCodeFix({errorCodes:[e.Diagnostics._0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write_0.code],getCodeActions:function(t){var n=t.sourceFile,r=e.getTokenAtPosition(n,t.span.start,!1),i=e.getAncestor(r,147);e.Debug.assert(!!i,"Expected position to be owned by a decorator.");var a=e.createCall(i.expression,void 0,void 0),o=e.textChanges.ChangeTracker.fromContext(t);return o.replaceNode(n,i.expression,a),[{description:e.getLocaleSpecificMessage(e.Diagnostics.Call_decorator_expression),changes:o.getChanges()}]}})}(e.codefix||(e.codefix={}))}(ts||(ts={})),function(e){!function(t){t.registerCodeFix({errorCodes:[e.Diagnostics.Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_property_1_in_0_with_0_1.code],getCodeActions:function(t){var n=t.sourceFile,r=e.getTokenAtPosition(n,t.span.start,!1),i=e.getAncestor(r,143);if(e.Debug.assert(!!i,"Expected position to be owned by a qualified name."),e.isIdentifier(i.left)){var a=i.left.getText(n),o=i.right.getText(n),s=e.createIndexedAccessTypeNode(e.createTypeReferenceNode(i.left,void 0),e.createLiteralTypeNode(e.createLiteral(o))),c=e.textChanges.ChangeTracker.fromContext(t);return c.replaceNode(n,i,s),[{description:e.formatStringFromArgs(e.getLocaleSpecificMessage(e.Diagnostics.Rewrite_as_the_indexed_access_type_0),[a+'["'+o+'"]']),changes:c.getChanges()}]}}})}(e.codefix||(e.codefix={}))}(ts||(ts={})),function(e){!function(t){t.registerCodeFix({errorCodes:[e.Diagnostics.Class_0_incorrectly_implements_interface_1.code],getCodeActions:function(n){var r=n.sourceFile,i=n.span.start,a=e.getTokenAtPosition(r,i,!1),o=n.program.getTypeChecker(),s=e.getContainingClass(a);if(!s)return;for(var c=e.getOpenBraceOfClassLike(s,r),u=o.getTypeAtLocation(s),_=e.getClassImplementsHeritageClauseElements(s),l=!!o.getIndexTypeOfType(u,1),d=!!o.getIndexTypeOfType(u,0),p=[],f=0,m=_;f<m.length;f++){var g=m[f],y=o.getTypeAtLocation(g),h=o.getPropertiesOfType(y).filter((function(t){return!(8&e.getModifierFlags(t.valueDeclaration))})),v=[];x(y,1,l,v),x(y,0,d,v),v=v.concat(t.createMissingMemberNodes(s,h,o));var b=e.formatStringFromArgs(e.getLocaleSpecificMessage(e.Diagnostics.Implement_interface_0),[g.getText()]);v.length>0&&k(p,v,b)}return p;function x(e,t,n,r){if(!n){var i=o.getIndexInfoOfType(e,t);if(i){var a=o.indexInfoToIndexSignatureDeclaration(i,t,s);r.push(a)}}}function k(e,r,i){e.push({description:i,changes:t.newNodesToChanges(r,c,n)})}}})}(e.codefix||(e.codefix={}))}(ts||(ts={})),function(e){!function(t){t.registerCodeFix({errorCodes:[e.Diagnostics.Property_0_does_not_exist_on_type_1.code,e.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_2.code],getCodeActions:function(n){var r=n.sourceFile,i=n.span.start,a=e.getTokenAtPosition(r,i,!1);if(71!==a.kind)return;if(!e.isPropertyAccessExpression(a.parent))return;var o,s=a.getText(r),c=!1;if(99===a.parent.expression.kind){var u=e.getThisContainer(a,!1);if(!e.isClassElement(u))return;o=u.parent,c=o&&e.hasModifier(u,32)}else{var _=n.program.getTypeChecker(),l=a.parent.expression,d=_.getTypeAtLocation(l);if(32768&d.flags){var p=d.symbol;32&p.flags&&(o=p.declarations&&p.declarations[0],d!==_.getDeclaredTypeOfSymbol(p)&&(c=!0))}}if(!o||!e.isClassLike(o))return;var f=e.getSourceFileOfNode(o),m=e.getOpenBraceOfClassLike(o,f);return e.isInJavaScriptFile(f)?function(t,r){var i,a=g(!1);a&&(i=[a]);if(r){if(199===t.kind)return i;var o=t.name.getText(),c=e.createStatement(e.createAssignment(e.createPropertyAccess(e.createIdentifier(o),s),e.createIdentifier("undefined"))),u=e.textChanges.ChangeTracker.fromContext(n);u.insertNodeAfter(f,t,c,{prefix:n.newLineCharacter,suffix:n.newLineCharacter});var _={description:e.formatStringFromArgs(e.getLocaleSpecificMessage(e.Diagnostics.Initialize_static_property_0),[s]),changes:u.getChanges()};return(i||(i=[])).push(_),i}var l=e.getFirstConstructorWithBody(t);if(!l)return i;var d=e.createStatement(e.createAssignment(e.createPropertyAccess(e.createThis(),s),e.createIdentifier("undefined"))),p=e.textChanges.ChangeTracker.fromContext(n);p.insertNodeBefore(f,l.body.getLastToken(),d,{suffix:n.newLineCharacter});var m={description:e.formatStringFromArgs(e.getLocaleSpecificMessage(e.Diagnostics.Initialize_property_0_in_the_constructor),[s]),changes:p.getChanges()};return(i||(i=[])).push(m),i}(o,c):function(t,r){var i,o,c=g(!0);c&&(i=[c]);if(194===a.parent.parent.kind){var u=a.parent.parent,_=a.parent===u.left?u.right:u.left,l=n.program.getTypeChecker(),d=l.getWidenedType(l.getBaseTypeOfLiteralType(l.getTypeAtLocation(_)));o=l.typeToTypeNode(d,t)}o=o||e.createKeywordTypeNode(119);var p=e.createProperty(void 0,r?[e.createToken(115)]:void 0,s,void 0,o,void 0),y=e.textChanges.ChangeTracker.fromContext(n);y.insertNodeAfter(f,m,p,{suffix:n.newLineCharacter});var h=r?e.Diagnostics.Declare_static_property_0:e.Diagnostics.Declare_property_0;if(i=e.append(i,{description:e.formatStringFromArgs(e.getLocaleSpecificMessage(h),[s]),changes:y.getChanges()}),!r){var v=e.createKeywordTypeNode(136),b=e.createParameter(void 0,void 0,void 0,"x",void 0,v,void 0),x=e.createIndexSignature(void 0,void 0,[b],o),k=e.textChanges.ChangeTracker.fromContext(n);k.insertNodeAfter(f,m,x,{suffix:n.newLineCharacter}),i.push({description:e.formatStringFromArgs(e.getLocaleSpecificMessage(e.Diagnostics.Add_index_signature_for_property_0),[s]),changes:k.getChanges()})}return i}(o,c);function g(r){if(181===a.parent.parent.kind){var i=a.parent.parent,o=t.createMethodFromCallExpression(i,s,r,c),u=e.textChanges.ChangeTracker.fromContext(n);u.insertNodeAfter(f,m,o,{suffix:n.newLineCharacter});var _=c?e.Diagnostics.Declare_static_method_0:e.Diagnostics.Declare_method_0;return{description:e.formatStringFromArgs(e.getLocaleSpecificMessage(_),[s]),changes:u.getChanges()}}}}})}(e.codefix||(e.codefix={}))}(ts||(ts={})),function(e){!function(t){t.registerCodeFix({errorCodes:[e.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_2.code,e.Diagnostics.Cannot_find_name_0_Did_you_mean_1.code],getCodeActions:function(t){var n,r=t.sourceFile,i=e.getTokenAtPosition(r,t.span.start,!1),a=t.program.getTypeChecker();if(e.isPropertyAccessExpression(i.parent)&&i.parent.name===i){e.Debug.assert(71===i.kind);var o=a.getTypeAtLocation(i.parent.expression);n=a.getSuggestionForNonexistentProperty(i,o)}else{var s=e.getMeaningFromLocation(i);n=a.getSuggestionForNonexistentSymbol(i,e.getTextOfNode(i),function(e){var t=0;4&e&&(t|=1920);2&e&&(t|=793064);1&e&&(t|=107455);return t}(s))}if(n)return[{description:e.formatStringFromArgs(e.getLocaleSpecificMessage(e.Diagnostics.Change_spelling_to_0),[n]),changes:[{fileName:r.fileName,textChanges:[{span:{start:i.getStart(),length:i.getWidth()},newText:n}]}]}]}})}(e.codefix||(e.codefix={}))}(ts||(ts={})),function(e){!function(t){function n(t,n){var r=e.getPackageName(n).packageName;if(t.isKnownTypesPackageName(r)){var i=e.getTypesPackageName(r);return{description:"Install '"+i+"'",changes:[],commands:[{type:"install package",packageName:i}]}}}t.registerCodeFix({errorCodes:[e.Diagnostics.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type.code],getCodeActions:function(t){var r=t.sourceFile,i=t.span.start,a=e.getTokenAtPosition(r,i,!1);if(!e.isStringLiteral(a))throw e.Debug.fail();var o=n(t.host,a.text);return o&&[o]}}),t.tryGetCodeActionForInstallPackageTypes=n}(e.codefix||(e.codefix={}))}(ts||(ts={})),function(e){!function(t){function n(n){var i=n.sourceFile,a=n.span.start,o=e.getTokenAtPosition(i,a,!1),s=n.program.getTypeChecker();if(e.isClassLike(o.parent)){var c=o.parent,u=e.getClassExtendsHeritageClauseElement(c),_=s.getTypeAtLocation(u),l=s.getPropertiesOfType(_).filter(r),d=t.createMissingMemberNodes(c,l,s),p=t.newNodesToChanges(d,e.getOpenBraceOfClassLike(c,i),n);if(p&&p.length>0)return[{description:e.getLocaleSpecificMessage(e.Diagnostics.Implement_inherited_abstract_class),changes:p}]}}function r(t){var n=t.getDeclarations();e.Debug.assert(!!(n&&n.length>0));var r=e.getModifierFlags(n[0]);return!(8&r||!(128&r))}t.registerCodeFix({errorCodes:[e.Diagnostics.Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2.code],getCodeActions:n}),t.registerCodeFix({errorCodes:[e.Diagnostics.Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1.code],getCodeActions:n})}(e.codefix||(e.codefix={}))}(ts||(ts={})),function(e){!function(t){t.registerCodeFix({errorCodes:[e.Diagnostics.super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class.code],getCodeActions:function(t){var n=t.sourceFile,r=e.getTokenAtPosition(n,t.span.start,!1);if(99===r.kind){var i=e.getContainingFunction(r),a=function t(n){if(210===n.kind&&e.isSuperCall(n.expression))return n;if(e.isFunctionLike(n))return;return e.forEachChild(n,t)}(i.body);if(a){if(a.expression&&181===a.expression.kind)for(var o=a.expression.arguments,s=0;s<o.length;s++)if(o[s].expression===r)return;var c=e.textChanges.ChangeTracker.fromContext(t);return c.insertNodeAfter(n,e.getOpenBrace(i,n),a,{suffix:t.newLineCharacter}),c.deleteNode(n,a),[{description:e.getLocaleSpecificMessage(e.Diagnostics.Make_super_call_the_first_statement_in_the_constructor),changes:c.getChanges()}]}}}})}(e.codefix||(e.codefix={}))}(ts||(ts={})),function(e){!function(t){t.registerCodeFix({errorCodes:[e.Diagnostics.Constructors_for_derived_classes_must_contain_a_super_call.code],getCodeActions:function(t){var n=t.sourceFile,r=e.getTokenAtPosition(n,t.span.start,!1);if(123===r.kind){var i=e.textChanges.ChangeTracker.fromContext(t),a=e.createStatement(e.createCall(e.createSuper(),void 0,e.emptyArray));return i.insertNodeAfter(n,e.getOpenBrace(r.parent,n),a,{suffix:t.newLineCharacter}),[{description:e.getLocaleSpecificMessage(e.Diagnostics.Add_missing_super_call),changes:i.getChanges()}]}}})}(e.codefix||(e.codefix={}))}(ts||(ts={})),function(e){!function(t){t.registerCodeFix({errorCodes:[e.Diagnostics.Cannot_extend_an_interface_0_Did_you_mean_implements.code],getCodeActions:function(t){var n=t.sourceFile,r=t.span.start,i=e.getTokenAtPosition(n,r,!1),a=e.getContainingClass(i);if(71===i.kind&&e.isClassLike(a)){var o=a.heritageClauses;if(o&&o.length>0){var s=o[0].getFirstToken();if(s&&85===s.kind){var c=e.textChanges.ChangeTracker.fromContext(t);c.replaceNode(n,s,e.createToken(108));for(var u=1;u<o.length;u++){var _=o[u].getFirstToken();_&&c.replaceNode(n,_,e.createToken(26))}return[{description:e.getLocaleSpecificMessage(e.Diagnostics.Change_extends_to_implements),changes:c.getChanges()}]}}}}})}(e.codefix||(e.codefix={}))}(ts||(ts={})),function(e){!function(t){t.registerCodeFix({errorCodes:[e.Diagnostics.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0.code],getCodeActions:function(t){var n=t.sourceFile,r=e.getTokenAtPosition(n,t.span.start,!1);if(71===r.kind){var i=e.textChanges.ChangeTracker.fromContext(t);return i.replaceNode(n,r,e.createPropertyAccess(e.createThis(),r)),[{description:e.getLocaleSpecificMessage(e.Diagnostics.Add_this_to_unresolved_variable),changes:i.getChanges()}]}}})}(e.codefix||(e.codefix={}))}(ts||(ts={})),function(e){!function(t){t.registerCodeFix({errorCodes:[e.Diagnostics._0_is_declared_but_its_value_is_never_read.code,e.Diagnostics.Property_0_is_declared_but_its_value_is_never_read.code],getCodeActions:function(t){var n=t.sourceFile,r=t.span.start,i=e.getTokenAtPosition(n,r,!1);switch(21===i.kind&&(i=e.getTokenAtPosition(n,r+1,!1)),i.kind){case 71:return function(t){var r=t.parent;switch(r.kind){case 226:return function(t,n){switch(n.parent.parent.kind){case 214:var r=n.parent.parent.initializer;return[1===r.declarations.length?c(r):_(n)];case 216:var i=n.parent.parent;return e.Debug.assert(227===i.initializer.kind),[d(i.initializer.declarations[0],e.createObjectLiteral()),o(t)];case 215:return[o(t)];default:var a=n.parent.parent;return 1===a.declarationList.declarations.length?[c(a)]:[_(n)]}}(t,r);case 145:var i=r.parent.typeParameters;if(1===i.length){var p=e.getTokenAtPosition(n,i.pos-1,!1),f=e.getTokenAtPosition(n,i.end,!1);return e.Debug.assert(27===p.kind),e.Debug.assert(29===f.kind),[l(p,f)]}return[_(r)];case 146:return[1===r.parent.parameters.length?c(r):_(r),o(t)];case 237:return[c(e.getAncestor(t,237))];case 242:var m=r.parent;return 1===m.elements.length?s(m):[_(r)];case 239:var g=r;if(g.namedBindings){var y=g.name.getStart(n);return(f=e.getTokenAtPosition(n,g.name.end,!1))&&26===f.kind?[u({pos:y,end:e.skipTrivia(n.text,f.end,!1,!0)})]:[c(g.name)]}return[c(e.getAncestor(g,238))];case 240:return s(r);default:return a()}}(i);case 149:case 240:return[c(i.parent)];default:return a()}function a(){return e.isDeclarationName(i)?[c(i.parent)]:e.isLiteralComputedPropertyDeclarationName(i)?[c(i.parent.parent)]:void 0}function o(t){var r=t.getStart(n,!1);return{description:e.formatStringFromArgs(e.getLocaleSpecificMessage(e.Diagnostics.Prefix_0_with_an_underscore),{0:i.getText()}),changes:[{fileName:n.path,textChanges:[{span:{start:r,length:0},newText:"_"}]}]}}function s(t){if(t.parent.name){var r=e.getTokenAtPosition(n,t.pos-1,!1);return r&&26===r.kind?[u({pos:r.getStart(),end:t.end})]:void 0}return[c(e.getAncestor(t,238))]}function c(r){return p(e.textChanges.ChangeTracker.fromContext(t).deleteNode(n,r))}function u(r){return p(e.textChanges.ChangeTracker.fromContext(t).deleteRange(n,r))}function _(r){return p(e.textChanges.ChangeTracker.fromContext(t).deleteNodeInList(n,r))}function l(r,i){return p(e.textChanges.ChangeTracker.fromContext(t).deleteNodeRange(n,r,i))}function d(r,i){return p(e.textChanges.ChangeTracker.fromContext(t).replaceNode(n,r,i))}function p(t){return{description:e.formatStringFromArgs(e.getLocaleSpecificMessage(e.Diagnostics.Remove_declaration_for_Colon_0),{0:i.getText()}),changes:t.getChanges()}}}})}(e.codefix||(e.codefix={}))}(ts||(ts={})),function(e){!function(t){function n(t,n,r,i){return{description:e.formatStringFromArgs(e.getLocaleSpecificMessage(e.Diagnostics.Change_0_to_1),[r,i]),changes:[{fileName:n,textChanges:[{span:{start:t.getStart(),length:t.getWidth()},newText:i}]}]}}t.registerCodeFix({errorCodes:[e.Diagnostics.JSDoc_types_can_only_be_used_inside_documentation_comments.code],getCodeActions:function(t){var r=t.sourceFile,i=e.getTokenAtPosition(r,t.span.start,!1),a=e.findAncestor(i,(function(e){return 202===e.kind||155===e.kind||156===e.kind||228===e.kind||153===e.kind||157===e.kind||172===e.kind||151===e.kind||150===e.kind||146===e.kind||149===e.kind||148===e.kind||154===e.kind||231===e.kind||184===e.kind||226===e.kind}));if(!a)return;var o=t.program.getTypeChecker(),s=a.type;if(!s)return;var c=e.getTextOfNode(s),u=o.getTypeFromTypeNode(s),_=[n(s,r.fileName,c,o.typeToString(u,void 0,8))];if(270===s.kind){var l=o.typeToString(o.getNullableType(u,2048),void 0,8);_.push(n(s,r.fileName,c,l))}return _}})}(e.codefix||(e.codefix={}))}(ts||(ts={})),function(e){!function(t){var n,r=e.textChanges.ChangeTracker;t.registerCodeFix({errorCodes:[e.Diagnostics.Cannot_find_name_0.code,e.Diagnostics.Cannot_find_name_0_Did_you_mean_1.code,e.Diagnostics.Cannot_find_namespace_0.code,e.Diagnostics._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead.code],getCodeActions:function(t){var n=function(t){var n=!!t.host.useCaseSensitiveFileNames&&t.host.useCaseSensitiveFileNames(),r=t.program.getTypeChecker(),i=e.getTokenAtPosition(t.sourceFile,t.span.start,!1);return{host:t.host,newLineCharacter:t.newLineCharacter,rulesProvider:t.rulesProvider,sourceFile:t.sourceFile,checker:r,compilerOptions:t.program.getCompilerOptions(),cachedImportDeclarations:[],getCanonicalFileName:e.createGetCanonicalFileName(n),symbolName:i.getText(),symbolToken:i}}(t);return t.errorCode===e.Diagnostics._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead.code?function(t){var n,r,i=t.checker,a=t.symbolToken,s=i.getSymbolAtLocation(a);2097152&s.flags?(n=i.getAliasedSymbol(s),r=t.symbolName):e.isJsxOpeningLikeElement(a.parent)&&a.parent.tagName===a?r=(n=i.getAliasedSymbol(i.resolveName(i.getJsxNamespace(),a.parent.tagName,107455))).name:e.Debug.fail("Either the symbol or the JSX namespace should be a UMD global if we got here");return o(n,__assign({},t,{symbolName:r,kind:2}))}(n):function(t,n,r){var a=t.sourceFile,s=t.checker,c=t.symbolName,u=t.symbolToken;e.Debug.assert("default"!==c);var _=new i,l=e.getMeaningFromLocation(u);return m(s,n,(function(n){if(n!==a.symbol){r.throwIfCancellationRequested();var i=s.tryGetMemberInModuleExports("default",n);if(i){var u=e.getLocalSymbolForExportDefault(i);if(u&&u.escapedName===c&&f(u,l)){var d=e.getUniqueSymbolId(u,s);_.addActions(d,o(n,__assign({},t,{kind:1})))}}var p=s.tryGetMemberInModuleExportsAndProperties(c,n);if(p&&f(p,l)){d=e.getUniqueSymbolId(p,s);_.addActions(d,o(n,__assign({},t,{kind:0})))}}})),_.getAllActions()}(n,t.program.getSourceFiles(),t.cancellationToken)}}),function(e){e[e.Better=0]="Better",e[e.Equal=1]="Equal",e[e.Worse=2]="Worse"}(n||(n={}));var i=function(){function t(){this.symbolIdToActionMap=[]}return t.prototype.addAction=function(e,t){var n=this.symbolIdToActionMap[e];if(n)if("CodeChange"!==t.kind){for(var r=[],i=0,a=this.symbolIdToActionMap[e];i<a.length;i++){var o=a[i];if("CodeChange"!==o.kind)switch(this.compareModuleSpecifiers(o.moduleSpecifier,t.moduleSpecifier)){case 0:if("NewImport"===t.kind)return;case 1:r.push(o);break;case 2:continue}else r.push(o)}r.push(t),this.symbolIdToActionMap[e]=r}else n.push(t);else this.symbolIdToActionMap[e]=[t]},t.prototype.addActions=function(e,t){for(var n=0,r=t;n<r.length;n++){var i=r[n];this.addAction(e,i)}},t.prototype.getAllActions=function(){var t=[];for(var n in this.symbolIdToActionMap)t=e.concatenate(t,this.symbolIdToActionMap[n]);return t},t.prototype.compareModuleSpecifiers=function(t,n){if(t===n)return 1;if(0===n.indexOf(t))return 0;if(0===t.indexOf(n))return 2;if(e.isExternalModuleNameRelative(t)&&e.isExternalModuleNameRelative(n)){var r=new RegExp(e.directorySeparator,"g"),i=(t.match(r)||[]).length,a=(n.match(r)||[]).length;return i<a?0:i===a?1:2}return 1},t}();function a(t,n,r,i,a){return{description:e.formatMessage.apply(void 0,[void 0,t].concat(n)),changes:r,kind:i,moduleSpecifier:a}}function o(t,n){var i=function(t,n,r,i){var a=r.imports;void 0===i&&(i=[]);var o=e.getUniqueSymbolId(t,n),s=i[o];s||(s=i[o]=e.mapDefined(a,(function(r){return n.getSymbolAtLocation(r)===t?function(t){var n=t.parent;switch(n.kind){case 238:return n;case 248:return n.parent;default:return void e.Debug.assert(244===n.kind)}}(r):void 0})));return s}(t,n.checker,n.sourceFile,n.cachedImportDeclarations),o=[];if(n.symbolToken)for(var f=0,m=i;f<m.length;f++){var g=s(m[f]);g&&o.push(p(g.text,n,n.symbolToken))}return o.push(function(t,n,i){var o=e.firstDefined(i,(function(t){if(238===t.kind&&t.importClause){var i=function(t,n){var i=t.symbolName,a=t.sourceFile,o=t.kind,s=n.name,c=n.namedBindings;switch(o){case 1:return s?void 0:r.with(t,(function(t){return t.replaceNode(a,n,e.createImportClause(e.createIdentifier(i),c))}));case 0:var u=e.createImportSpecifier(void 0,e.createIdentifier(i));return c&&241===c.kind&&0!==c.elements.length?r.with(t,(function(e){return e.insertNodeInListAfter(a,c.elements[c.elements.length-1],u)})):!c||241===c.kind&&0===c.elements.length?r.with(t,(function(t){return t.replaceNode(a,n,e.createImportClause(s,e.createNamedImports([u])))})):void 0;case 2:return c?void 0:r.with(t,(function(t){return t.replaceNode(a,n,e.createImportClause(s,e.createNamespaceImport(e.createIdentifier(i))))}));default:e.Debug.assertNever(o)}}(n,t.importClause);if(i){var o=e.stripQuotes(t.moduleSpecifier.getText());return a(e.Diagnostics.Add_0_to_existing_import_declaration_from_1,[n.symbolName,o],i,"InsertingIntoExistingImport",o)}}}));if(o)return o;var s=e.firstDefined(i,d)||function(t,n,r,i,a){var o=n.valueDeclaration.getSourceFile().fileName,s=e.getDirectoryPath(t.fileName);return function(t){var n=t.valueDeclaration;if(e.isModuleDeclaration(n)&&e.isStringLiteral(n.name))return n.name.text}(n)||function(t,n,r,i){var a=e.getEffectiveTypeRoots(t,n);return a&&e.firstDefined(a,(function(t){var n=e.toPath(t,void 0,r);if(e.startsWith(i,n))return u(i.substring(n.length+1))}))}(r,a,i,o)||function(t,n,r,i,a){if(e.getEmitModuleResolutionKind(t)!==e.ModuleResolutionKind.NodeJs)return;var o=function(e){var t,n=0,r=0,i=0,a=0;!function(e){e[e.BeforeNodeModules=0]="BeforeNodeModules",e[e.NodeModules=1]="NodeModules",e[e.Scope=2]="Scope",e[e.PackageContent=3]="PackageContent"}(t||(t={}));var o=0,s=0,c=0;for(;s>=0;)switch(o=s,s=e.indexOf("/",o+1),c){case 0:e.indexOf("/node_modules/",o)===o&&(n=o,r=s,c=1);break;case 1:case 2:1===c&&"@"===e.charAt(o+1)?c=2:(i=s,c=3);break;case 3:c=e.indexOf("/node_modules/",o)===o?1:3}return a=o,c>1?{topLevelNodeModulesIndex:n,topLevelPackageNameIndex:r,packageRootIndex:i,fileNameIndex:a}:void 0}(n);if(!o)return;var s=c(n);return s=u(s),e.getPackageNameFromAtTypesDirectory(s);function c(t){var n=t.substring(0,o.packageRootIndex),a=e.combinePaths(n,"package.json");if(r.fileExists(a)){var s=JSON.parse(r.readFile(a));if(s){var c=s.typings||s.types||s.main;if(c)if(e.toPath(c,n,i)===i(t))return n}}var u=e.removeFileExtension(t);return"/index"===i(u.substring(o.fileNameIndex))?u.substring(0,o.fileNameIndex):u}function u(e){var t=e.substring(0,o.topLevelNodeModulesIndex);return 0===a.indexOf(t)?e.substring(o.topLevelPackageNameIndex+1):l(e,a,i)}}(r,o,a,i,s)||function(t,n,r){if(!t.baseUrl)return;var i=_(n,t.baseUrl,r);if(!i)return;var a=e.removeFileExtension(i);if(i=u(i),t.paths)for(var o in t.paths)for(var s=0,c=t.paths[o];s<c.length;s++){var l=c[s],d=l.indexOf("*");if(0!==d||1!==l.length)if(-1!==d){var p=l.substr(0,d),f=l.substr(d+1);if(i.length>=p.length+f.length&&e.startsWith(i,p)&&e.endsWith(i,f)){var m=i.substr(p.length,i.length-f.length);return o.replace("*",m)}}else if(l===i||l===a)return o}return i}(r,o,i)||r.rootDirs&&function(t,n,r,i){var a=c(n,t,i);if(void 0===a)return;var o=c(r,t,i),s=void 0!==o?l(a,o,i):a;return e.removeFileExtension(s)}(r.rootDirs,o,s,i)||e.removeFileExtension(l(o,s,i))}(n.sourceFile,t,n.compilerOptions,n.getCanonicalFileName,n.host);return function(t,n){var i=t.kind,o=t.sourceFile,s=t.newLineCharacter,c=t.symbolName,u=e.findLast(o.statements,e.isAnyImportSyntax),_=e.stripQuotes(n),l=e.createImportDeclaration(void 0,void 0,function(t,n){var r=e.createIdentifier(n);switch(t){case 1:return e.createImportClause(r,void 0);case 2:return e.createImportClause(void 0,e.createNamespaceImport(r));case 0:return e.createImportClause(void 0,e.createNamedImports([e.createImportSpecifier(void 0,r)]));default:e.Debug.assertNever(t)}}(i,c),function(t,n){var r=e.createLiteral(n),i=e.firstOrUndefined(t.imports);return r.singleQuote=!!i&&!e.isStringDoubleQuoted(i,t),r}(o,_)),d=r.with(t,(function(t){u?t.insertNodeAfter(o,u,l,{suffix:s}):t.insertNodeAt(o,e.getSourceFileImportLocation(o),l,{suffix:""+s+s})}));return a(e.Diagnostics.Import_0_from_1,[c,_],d,"NewImport",_)}(n,s)}(t,n,i)),o}function s(e){if(238===e.kind){var t=e.importClause&&e.importClause.namedBindings;return t&&240===t.kind?t.name:void 0}return e.name}function c(t,n,r){return e.firstDefined(n,(function(e){return _(t,e,r)}))}function u(t){return t=e.removeFileExtension(t),e.endsWith(t,"/index")&&(t=t.substr(0,t.length-6)),t}function _(t,n,r){var i=e.getRelativePathToDirectoryOrUrl(n,t,n,r,!1);return e.isRootedDiskPath(i)||e.startsWith(i,"..")?void 0:i}function l(t,n,r){var i=e.getRelativePathToDirectoryOrUrl(n,t,n,r,!1);return e.pathIsRelative(i)?i:"./"+i}function d(t){var n=238===t.kind?t.moduleSpecifier:248===t.moduleReference.kind?t.moduleReference.expression:void 0;return n&&e.isStringLiteral(n)?n.text:void 0}function p(t,n,i){var o=n.symbolName,s=n.sourceFile;return a(e.Diagnostics.Change_0_to_1,[o,t+"."+o],r.with(n,(function(n){return n.replaceNode(s,i,e.createPropertyAccess(e.createIdentifier(t),o))})),"CodeChange",void 0)}function f(t,n){var r=t.declarations;return e.some(r,(function(t){return!!(e.getMeaningFromDeclaration(t)&n)}))}function m(t,n,r){for(var i=0,a=t.getAmbientModules();i<a.length;i++){r(a[i])}for(var o=0,s=n;o<s.length;o++){var c=s[o];e.isExternalOrCommonJsModule(c)&&r(c.symbol)}}!function(e){e[e.Named=0]="Named",e[e.Default=1]="Default",e[e.Namespace=2]="Namespace"}(t.ImportKind||(t.ImportKind={})),t.getCodeActionForImport=o,t.forEachExternalModule=m}(e.codefix||(e.codefix={}))}(ts||(ts={})),function(e){!function(t){var n;function r(t,n,r){var i=e.getLineAndCharacterOfPosition(t,n).line,a=e.getStartPositionOfLine(i,t),o=e.getFirstNonSpaceCharacterPosition(t.text,a);if(!e.isInComment(t,o)&&!e.isInString(t,o)&&!e.isInTemplateString(t,o)){var s=e.getTouchingToken(t,o,!1),c=e.getLeadingCommentRangesOfNode(s,t);if(!c||!c.length||c[0].pos>=o)return{span:{start:o,length:0},newText:"// @ts-ignore"+r}}return{span:{start:n,length:0},newText:(n===o?"":r)+"// @ts-ignore"+r}}t.registerCodeFix({errorCodes:(n=e.Diagnostics,Object.keys(n).filter((function(t){return n[t]&&n[t].category===e.DiagnosticCategory.Error})).map((function(e){return n[e].code}))),getCodeActions:function(t){var n=t.sourceFile,i=t.program,a=t.newLineCharacter,o=t.span;if(!e.isInJavaScriptFile(n)||!e.isCheckJsEnabledForFile(n,i.getCompilerOptions()))return;return[{description:e.getLocaleSpecificMessage(e.Diagnostics.Ignore_this_error_message),changes:[{fileName:n.fileName,textChanges:[r(n,o.start,a)]}]},{description:e.getLocaleSpecificMessage(e.Diagnostics.Disable_checking_for_this_file),changes:[{fileName:n.fileName,textChanges:[{span:{start:n.checkJsDirective?n.checkJsDirective.pos:0,length:n.checkJsDirective?n.checkJsDirective.end-n.checkJsDirective.pos:0},newText:"// @ts-nocheck"+a}]}]}]}})}(e.codefix||(e.codefix={}))}(ts||(ts={})),function(e){!function(t){function n(t,n,o){var s=t.getDeclarations();if(s&&s.length){var c=s[0],u=e.getSynthesizedClone(e.getNameOfDeclaration(c)),_=function(t){if(4&t)return e.createToken(114);if(16&t)return e.createToken(113);return}(e.getModifierFlags(c)),l=_?e.createNodeArray([_]):void 0,d=o.getWidenedType(o.getTypeOfSymbolAtLocation(t,n)),p=!!(16777216&t.flags);switch(c.kind){case 153:case 154:case 148:case 149:var f=o.typeToTypeNode(d,n);return e.createProperty(void 0,l,u,p?e.createToken(55):void 0,f,void 0);case 150:case 151:var m=o.getSignaturesOfType(d,0);if(!e.some(m))return;if(1===s.length)return e.Debug.assert(1===m.length),b(m[0],n,a());for(var g=[],y=0;y<m.length;y++){(h=b(m[y],n))&&g.push(h)}if(s.length>m.length){var h;(h=b(o.getSignatureFromDeclaration(s[s.length-1]),n,a()))&&g.push(h)}else{e.Debug.assert(s.length===m.length);var v=function(t,n,a,o){for(var s=t[0],c=t[0].minArgumentCount,u=!1,_=0;_<t.length;_++){var l=t[_];c=Math.min(l.minArgumentCount,c),l.hasRestParameter&&(u=!0),l.parameters.length>=s.parameters.length&&(!l.hasRestParameter||s.hasRestParameter)&&(s=l)}var d=s.parameters.length-(s.hasRestParameter?1:0),p=s.parameters.map((function(e){return e.name})),f=r(d,p,c,!0);if(u){var m=e.createArrayTypeNode(e.createKeywordTypeNode(119)),g=e.createParameter(void 0,void 0,e.createToken(24),p[d]||"rest",d>=c?e.createToken(55):void 0,m,void 0);f.push(g)}return i(o,n,a,void 0,f,void 0)}(m,u,p,l);g.push(v)}return g;default:return}}function b(t,n,r){var i=o.signatureToSignatureDeclaration(t,151,n,e.NodeBuilderFlags.SuppressAnyReturnType);return i&&(i.decorators=void 0,i.modifiers=l,i.name=u,i.questionToken=p?e.createToken(55):void 0,i.body=r),i}}function r(t,n,r,i){for(var a=[],o=0;o<t;o++){var s=e.createParameter(void 0,void 0,void 0,n&&n[o]||"arg"+o,void 0!==r&&o>=r?e.createToken(55):void 0,i?e.createKeywordTypeNode(119):void 0,void 0);a.push(s)}return a}function i(t,n,r,i,o,s){return e.createMethod(void 0,t,void 0,n,r?e.createToken(55):void 0,i,o,s,a())}function a(){return e.createBlock([e.createThrow(e.createNew(e.createIdentifier("Error"),void 0,[e.createLiteral("Method not implemented.")]))],!0)}t.newNodesToChanges=function(t,n,r){for(var i=r.sourceFile,a=e.textChanges.ChangeTracker.fromContext(r),o=0,s=t;o<s.length;o++){var c=s[o];a.insertNodeAfter(i,n,c,{suffix:r.newLineCharacter})}var u=a.getChanges();return e.some(u)?(e.Debug.assert(1===u.length),[{fileName:u[0].fileName,textChanges:[{span:u[0].textChanges[0].span,newText:u[0].textChanges.reduce((function(e,t){return e+t.newText}),"")}]}]):u},t.createMissingMemberNodes=function(e,t,r){for(var i=e.symbol.members,a=[],o=0,s=t.filter((function(e){return!i.has(e.escapedName)}));o<s.length;o++){var c=n(s[o],e,r);c&&(Array.isArray(c)?a=a.concat(c):a.push(c))}return a},t.createMethodFromCallExpression=function(t,n,i,o){var s,c=r(t.arguments.length,void 0,void 0,i);if(i)for(var u=e.length(t.typeArguments),_=0;_<u;_++){var l=u<8?String.fromCharCode(84+_):"T"+_,d=e.createTypeParameterDeclaration(l,void 0,void 0);(s||(s=[])).push(d)}return e.createMethod(void 0,o?[e.createToken(115)]:void 0,void 0,n,void 0,s,c,i?e.createKeywordTypeNode(119):void 0,a())},t.createStubbedMethod=i}(e.codefix||(e.codefix={}))}(ts||(ts={})),function(e){!function(t){var n;t.registerCodeFix({errorCodes:[e.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined.code,e.Diagnostics.Variable_0_implicitly_has_an_1_type.code,e.Diagnostics.Parameter_0_implicitly_has_an_1_type.code,e.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type.code,e.Diagnostics.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation.code,e.Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type.code,e.Diagnostics.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation.code,e.Diagnostics.Member_0_implicitly_has_an_1_type.code],getCodeActions:function(t){var r,i=t.sourceFile,a=t.program,o=t.span.start,s=t.errorCode,c=t.cancellationToken,u=e.getTokenAtPosition(i,o,!1);if(e.isInJavaScriptFile(u))return;switch(u.kind){case 71:case 24:case 114:case 112:case 113:case 131:break;default:return}var _=e.getContainingFunction(u),l=a.getTypeChecker();switch(s){case e.Diagnostics.Member_0_implicitly_has_an_1_type.code:case e.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined.code:return d(u.parent);case e.Diagnostics.Variable_0_implicitly_has_an_1_type.code:return function(e){var t=l.getSymbolAtLocation(e);return t&&t.valueDeclaration&&d(t.valueDeclaration)}(u);case e.Diagnostics.Parameter_0_implicitly_has_an_1_type.code:if(e.isSetAccessor(_))return p(_);case e.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type.code:return function(t){if(!e.isIdentifier(t.name)||!function(e){switch(e.kind){case 228:case 151:case 152:return!0;case 186:return!!e.name}return!1}(_))return;var r=function(e){switch(e.kind){case 152:case 186:case 228:case 151:var t=152===e.kind?v(e,i,123):e.name;if(t)return n.inferTypeForParametersFromReferences(m(t),e,l,c)}}(_)||e.map(_.parameters,(function(t){return e.isIdentifier(t.name)&&g(t.name)}));if(!r)return;var a=e.zipWith(_.parameters,r,(function(e,t){if(t&&!e.type&&!e.initializer){var n=h(t,_);return n?{span:{start:e.end,length:0},newText:": "+n}:void 0}})).filter((function(e){return!!e}));return a.length?[{description:e.formatStringFromArgs(e.getLocaleSpecificMessage(e.Diagnostics.Infer_parameter_types_from_usage),[t.name.getText()]),changes:[{fileName:i.fileName,textChanges:a}]}]:void 0}(u.parent);case e.Diagnostics.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation.code:case e.Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type.code:return e.isGetAccessor(_)?function(t){if(!e.isIdentifier(t.name))return;var n=g(t.name),r=n&&h(n,_);if(!r)return;var a=v(t,i,20);return f(t.name.getText(),a.getEnd(),": "+r)}(_):void 0;case e.Diagnostics.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation.code:return e.isSetAccessor(_)?p(_):void 0}return;function d(t){if(e.isIdentifier(t.name)){var n=g(t.name),r=n&&h(n,t);if(r)return f(t.name.getText(),t.name.getEnd(),": "+r)}}function p(t){var n=t.parameters[0];if(n&&e.isIdentifier(t.name)&&e.isIdentifier(n.name)){var r=g(t.name)||g(n.name),i=r&&h(r,_);if(i)return f(t.name.getText(),n.name.getEnd(),": "+i)}}function f(t,n,r){return[{description:e.formatStringFromArgs(e.getLocaleSpecificMessage(e.Diagnostics.Infer_type_of_0_from_usage),[t]),changes:[{fileName:i.fileName,textChanges:[{span:{start:n,length:0},newText:r}]}]}]}function m(t){var n=e.FindAllReferences.findReferencedSymbols(a,c,a.getSourceFiles(),t.getSourceFile(),t.getStart());return e.Debug.assert(!!n,"Found no references!"),e.Debug.assert(1===n.length,"Found more references than expected"),e.map(n[0].references,(function(t){return e.getTokenAtPosition(a.getSourceFile(t.fileName),t.textSpan.start,!1)}))}function g(e){return n.inferTypeFromReferences(m(e),l,c)}function y(){if(!r){var t="",n=!0,i=function(e){return t+=e};r={string:function(){return n?t:void 0},writeKeyword:i,writeOperator:i,writePunctuation:i,writeSpace:i,writeStringLiteral:i,writeParameter:i,writeProperty:i,writeSymbol:i,writeLine:function(){return t+=" "},increaseIndent:e.noop,decreaseIndent:e.noop,clear:function(){t="",n=!0},trackSymbol:function(e,t,r){0!==l.isSymbolAccessible(e,t,r,!1).accessibility&&(n=!1)},reportInaccessibleThisError:function(){n=!1},reportPrivateInBaseOfClassExpression:function(){n=!1}}}return r.clear(),r}function h(e,t){var n=y();return l.getSymbolDisplayBuilder().buildTypeDisplay(e,n,t),n.string()}function v(e,t,n){for(var r=0,i=e.getChildren(t);r<i.length;r++){var a=i[r];if(a.kind===n)return a}}}}),function(t){function n(t,i,a){for(;e.isRightSideOfQualifiedNameOrPropertyAccess(t);)t=t.parent;switch(t.parent.kind){case 193:a.isNumber=!0;break;case 192:!function(e,t){switch(e.operator){case 43:case 44:case 38:case 52:t.isNumber=!0;break;case 37:t.isNumberOrString=!0}}(t.parent,a);break;case 194:!function(t,n,r,i){switch(n.operatorToken.kind){case 40:case 39:case 41:case 42:case 45:case 46:case 47:case 48:case 49:case 50:case 60:case 62:case 61:case 63:case 64:case 68:case 69:case 70:case 65:case 67:case 66:case 38:case 27:case 30:case 29:case 31:var a=r.getTypeAtLocation(n.left===t?n.right:n.left);272&a.flags?s(i,a):i.isNumber=!0;break;case 59:case 37:var o=r.getTypeAtLocation(n.left===t?n.right:n.left);272&o.flags?s(i,o):84&o.flags?i.isNumber=!0:262178&o.flags?i.isString=!0:i.isNumberOrString=!0;break;case 58:case 32:case 34:case 35:case 33:s(i,r.getTypeAtLocation(n.left===t?n.right:n.left));break;case 92:t===n.left&&(i.isString=!0);break;case 54:t!==n.left||226!==t.parent.parent.kind&&!e.isAssignmentExpression(t.parent.parent,!0)||s(i,r.getTypeAtLocation(n.right))}}(t,t.parent,i,a);break;case 257:case 258:!function(e,t,n){s(n,t.getTypeAtLocation(e.parent.parent.expression))}(t.parent,i,a);break;case 181:case 182:t.parent.expression===t?function(e,t,r){var i={argumentTypes:[],returnType:{}};if(e.arguments)for(var a=0,o=e.arguments;a<o.length;a++){var s=o[a];i.argumentTypes.push(t.getTypeAtLocation(s))}n(e,t,i.returnType),181===e.kind?(r.callContexts||(r.callContexts=[])).push(i):(r.constructContexts||(r.constructContexts=[])).push(i)}(t.parent,i,a):r(t,i,a);break;case 179:!function(t,r,i){var a=e.escapeLeadingUnderscores(t.name.text);i.properties||(i.properties=e.createUnderscoreEscapedMap());var o=i.properties.get(a)||{};n(t,r,o),i.properties.set(a,o)}(t.parent,i,a);break;case 180:!function(e,t,r,i){if(t===e.argumentExpression)return void(i.isNumberOrString=!0);var a=r.getTypeAtLocation(e),o={};n(e,r,o),84&a.flags?i.numberIndexContext=o:i.stringIndexContext=o}(t.parent,t,i,a);break;default:return r(t,i,a)}}function r(t,n,r){e.isPartOfExpression(t)&&s(r,n.getContextualType(t))}function i(t,n){if(t.isNumberOrString&&!t.isNumber&&!t.isString)return n.getUnionType([n.getNumberType(),n.getStringType()]);if(t.isNumber)return n.getNumberType();if(t.isString)return n.getStringType();if(t.candidateTypes)return n.getWidenedType(n.getUnionType(e.map(t.candidateTypes,(function(e){return n.getBaseTypeOfLiteralType(e)})),!0));if(t.properties&&c(t.properties.get("then"))){var r=a(0,t.properties.get("then").callContexts,!1,n).getCallSignatures().map((function(e){return e.getReturnType()}));return n.createPromiseType(r.length?n.getUnionType(r,!0):n.getAnyType())}if(t.properties&&c(t.properties.get("push")))return n.createArrayType(a(0,t.properties.get("push").callContexts,!1,n));if(t.properties||t.callContexts||t.constructContexts||t.numberIndexContext||t.stringIndexContext){var s=e.createUnderscoreEscapedMap(),u=[],_=[],l=void 0,d=void 0;if(t.properties&&t.properties.forEach((function(e,t){var r=n.createSymbol(4,t);r.type=i(e,n)||n.getAnyType(),s.set(t,r)})),t.callContexts)for(var p=0,f=t.callContexts;p<f.length;p++){var m=f[p];u.push(o(m,n))}if(t.constructContexts)for(var g=0,y=t.constructContexts;g<y.length;g++){var h=y[g];_.push(o(h,n))}return t.numberIndexContext&&(d=n.createIndexInfo(i(t.numberIndexContext,n),!1)),t.stringIndexContext&&(l=n.createIndexInfo(i(t.stringIndexContext,n),!1)),n.createAnonymousType(void 0,s,u,_,l,d)}}function a(t,n,r,i){var a=[];if(n)for(var o=0,s=n;o<s.length;o++){var c=s[o];c.argumentTypes.length>t&&(r?a=e.concatenate(a,e.map(c.argumentTypes.slice(t),(function(e){return i.getBaseTypeOfLiteralType(e)}))):a.push(i.getBaseTypeOfLiteralType(c.argumentTypes[t])))}if(a.length){var u=i.getWidenedType(i.getUnionType(a,!0));return r?i.createArrayType(u):u}}function o(t,n){for(var r=[],a=0;a<t.argumentTypes.length;a++){var o=n.createSymbol(1,e.escapeLeadingUnderscores("arg"+a));o.type=n.getWidenedType(n.getBaseTypeOfLiteralType(t.argumentTypes[a])),r.push(o)}var s=i(t.returnType,n)||n.getVoidType();return n.createSignature(void 0,void 0,void 0,r,s,void 0,t.argumentTypes.length,!1,!1)}function s(e,t){!t||1&t.flags||8192&t.flags||(e.candidateTypes||(e.candidateTypes=[])).push(t)}function c(e){return e&&e.callContexts}t.inferTypeFromReferences=function(e,t,r){for(var a={},o=0,s=e;o<s.length;o++){var c=s[o];r.throwIfCancellationRequested(),n(c,t,a)}return i(a,t)},t.inferTypeForParametersFromReferences=function(t,r,i,a){if(r.parameters){for(var o={},s=0,c=t;s<c.length;s++){var u=c[s];a.throwIfCancellationRequested(),n(u,i,o)}var _=152===r.kind?o.constructContexts:o.callContexts;if(_){for(var l=[],d=0;d<r.parameters.length;d++){for(var p=[],f=e.isRestParameter(r.parameters[d]),m=0,g=_;m<g.length;m++){var y=g[m];y.argumentTypes.length>d&&(f?p=e.concatenate(p,e.map(y.argumentTypes.slice(d),(function(e){return i.getBaseTypeOfLiteralType(e)}))):p.push(i.getBaseTypeOfLiteralType(y.argumentTypes[d])))}if(p.length){var h=i.getWidenedType(i.getUnionType(p,!0));l[d]=f?i.createArrayType(h):h}}return l}}}}(n||(n={}))}(e.codefix||(e.codefix={}))}(ts||(ts={})),function(e){!function(t){!function(n){var r="annotate",i={name:"Annotate with type from JSDoc",description:e.Diagnostics.Annotate_with_type_from_JSDoc.message,getEditsForAction:function(n,i){if(r!==i)return e.Debug.fail("actionName !== action: annotate !== "+i);var a=e.getTokenAtPosition(n.file,n.startPosition,!1),c=e.findAncestor(a,o);if(!c||c.type)return;var u=e.getJSDocType(c);if(e.isFunctionLikeDeclaration(c)&&(e.getJSDocReturnType(c)||c.parameters.some((function(t){return!!e.getJSDocType(t)})))||u&&146===c.kind)return function(t){var n=t.file,r=e.getTokenAtPosition(n,t.startPosition,!1),i=e.findAncestor(r,e.isFunctionLikeDeclaration),a=e.textChanges.ChangeTracker.fromContext(t),o=function(t){var n=e.getEffectiveTypeParameterDeclarations(t,!0),r=t.parameters.map((function(t){return e.createParameter(t.decorators,t.modifiers,t.dotDotDotToken,t.name,t.questionToken,s(e.getEffectiveTypeAnnotationNode(t,!0)),t.initializer)})),i=s(e.getEffectiveReturnTypeNode(t,!0));switch(t.kind){case 228:return e.createFunctionDeclaration(t.decorators,t.modifiers,t.asteriskToken,t.name,n,r,i,t.body);case 152:return e.createConstructor(t.decorators,t.modifiers,r,t.body);case 186:return e.createFunctionExpression(t.modifiers,t.asteriskToken,t.name,n,r,i,t.body);case 187:return e.createArrowFunction(t.modifiers,n,r,i,t.equalsGreaterThanToken,t.body);case 151:return e.createMethod(t.decorators,t.modifiers,t.asteriskToken,t.name,t.questionToken,n,r,i,t.body);case 153:return e.createGetAccessor(t.decorators,t.modifiers,t.name,t.parameters,i,t.body);case 154:return e.createSetAccessor(t.decorators,t.modifiers,t.name,r,t.body);default:return e.Debug.assertNever(t,"Unexpected SyntaxKind: "+t.kind)}}(i);return e.suppressLeadingAndTrailingTrivia(o),a.replaceRange(n,{pos:i.getStart(),end:i.end},o),{edits:a.getChanges(),renameFilename:void 0,renameLocation:void 0}}(n);if(u)return function(t){var n=t.file,r=e.getTokenAtPosition(n,t.startPosition,!1),i=e.findAncestor(r,o),a=e.getJSDocType(i);if(!i||!a||i.type)return e.Debug.fail("!decl || !jsdocType || decl.type: !"+i+" || !"+a+" || "+i.type);var c=e.textChanges.ChangeTracker.fromContext(t),u=function(t,n){switch(t.kind){case 226:return e.createVariableDeclaration(t.name,n,t.initializer);case 148:return e.createPropertySignature(t.modifiers,t.name,t.questionToken,n,t.initializer);case 149:return e.createProperty(t.decorators,t.modifiers,t.name,t.questionToken,n,t.initializer);default:return e.Debug.fail("Unexpected SyntaxKind: "+t.kind)}}(i,s(a));return e.suppressLeadingAndTrailingTrivia(u),c.replaceRange(n,{pos:i.getStart(),end:i.end},u),{edits:c.getChanges(),renameFilename:void 0,renameLocation:void 0}}(n);e.Debug.assert(!!t,"No applicable refactor found.")},getAvailableActions:function(t){if(e.isInJavaScriptFile(t.file))return;var n=e.getTokenAtPosition(t.file,t.startPosition,!1);if(a(e.findAncestor(n,o)))return[{name:i.name,description:i.description,actions:[{description:i.description,name:r}]}]}};function a(t){return!!t&&(e.isFunctionLikeDeclaration(t)?t.parameters.some(a)||!t.type&&!!e.getJSDocReturnType(t):!t.type&&!!e.getJSDocType(t))}function o(t){return e.isFunctionLikeDeclaration(t)||226===t.kind||146===t.kind||148===t.kind||149===t.kind}function s(t){if(void 0!==t)switch(t.kind){case 268:case 269:return e.createTypeReferenceNode("any",e.emptyArray);case 272:return function(t){return e.createUnionTypeNode([e.visitNode(t.type,s),e.createTypeReferenceNode("undefined",e.emptyArray)])}(t);case 271:return s(t.type);case 270:return function(t){return e.createUnionTypeNode([e.visitNode(t.type,s),e.createTypeReferenceNode("null",e.emptyArray)])}(t);case 274:return function(t){return e.createArrayTypeNode(e.visitNode(t.type,s))}(t);case 273:return function(t){var n=t.parameters&&t.parameters.map(s);return e.createFunctionTypeNode(e.emptyArray,n,t.type)}(t);case 146:return function(t){var n=t.parent.parameters.indexOf(t),r=274===t.type.kind&&n===t.parent.parameters.length-1,i=t.name||(r?"rest":"arg"+n),a=r?e.createToken(24):t.dotDotDotToken;return e.createParameter(t.decorators,t.modifiers,a,i,t.questionToken,e.visitNode(t.type,s),t.initializer)}(t);case 159:return function(t){var n=t.typeName,r=t.typeArguments;if(e.isIdentifier(t.typeName)){if(e.isJSDocIndexSignature(t))return function(t){var n=e.createParameter(void 0,void 0,void 0,133===t.typeArguments[0].kind?"n":"s",void 0,e.createTypeReferenceNode(133===t.typeArguments[0].kind?"number":"string",[]),void 0),r=e.createTypeLiteralNode([e.createIndexSignature(void 0,void 0,[n],t.typeArguments[1])]);return e.setEmitFlags(r,1),r}(t);var i=t.typeName.text;switch(t.typeName.text){case"String":case"Boolean":case"Object":case"Number":i=i.toLowerCase();break;case"array":case"date":case"promise":i=i[0].toUpperCase()+i.slice(1)}n=e.createIdentifier(i),r="Array"!==i&&"Promise"!==i||t.typeArguments?e.visitNodes(t.typeArguments,s):e.createNodeArray([e.createTypeReferenceNode("any",e.emptyArray)])}return e.createTypeReferenceNode(n,r)}(t);default:var n=e.visitEachChild(t,s,void 0);return e.setEmitFlags(n,1),n}}t.registerRefactor(i)}(t.annotateWithTypeFromJSDoc||(t.annotateWithTypeFromJSDoc={}))}(e.refactor||(e.refactor={}))}(ts||(ts={})),function(e){!function(t){!function(n){var r="convert",i={name:"Convert to ES2015 class",description:e.Diagnostics.Convert_function_to_an_ES2015_class.message,getEditsForAction:function(t,n){if(r!==n)return;var i=t.file,o=a(t),s=t.rulesProvider.getFormatOptions().newLineCharacter,c=[],u=[];if(!(19&o.flags))return;var _,l,d=o.valueDeclaration,p=e.textChanges.ChangeTracker.fromContext(t);switch(d.kind){case 228:_=d,g(d),l=function(t){var n=y(o);t.body&&n.unshift(e.createConstructor(void 0,void 0,t.parameters,t.body));var r=v(t,84);return e.createClassDeclaration(void 0,r,t.name,void 0,void 0,n)}(d);break;case 226:_=d.parent.parent,1===d.parent.declarations.length?g(_):g(d,!0),l=function(t){var n=t.initializer;if(!n||186!==n.kind)return;if(71!==t.name.kind)return;var r=y(n.symbol);n.body&&r.unshift(e.createConstructor(void 0,void 0,n.parameters,n.body));var i=v(_,84);return e.createClassDeclaration(void 0,i,t.name,void 0,void 0,r)}(d)}if(!l)return;p.insertNodeAfter(i,_,l,{suffix:s});for(var f=0,m=u;f<m.length;f++){(0,m[f])()}return{edits:p.getChanges(),renameFilename:void 0,renameLocation:void 0};function g(t,n){void 0===n&&(n=!1),c.some((function(n){return e.isNodeDescendantOf(t,n)}))||(c.push(t),n?u.push((function(){return p.deleteNodeInList(i,t)})):u.push((function(){return p.deleteNode(i,t)})))}function y(t){var n=[];return t.members&&t.members.forEach((function(e){var t=r(e,void 0);t&&n.push(t)})),t.exports&&t.exports.forEach((function(t){var i=r(t,[e.createToken(115)]);i&&n.push(i)})),n;function r(t,n){if(4&t.flags){var r=t.valueDeclaration,a=r.parent;if(o=a.right,e.isFunctionLike(o)){var o;if(g(a.parent&&210===a.parent.kind?a.parent:a),!a.right)return e.createProperty([],n,t.name,void 0,void 0,void 0);switch(a.right.kind){case 186:var s=a.right,c=e.concatenate(n,v(s,120));return h(a,p=e.createMethod(void 0,c,void 0,r.name,void 0,void 0,s.parameters,void 0,s.body)),p;case 187:var u=a.right,_=u.body,l=void 0;if(207===_.kind)l=_;else{var d=_;l=e.createBlock([e.createReturn(d)])}var p;c=e.concatenate(n,v(u,120));return h(a,p=e.createMethod(void 0,c,void 0,r.name,void 0,void 0,u.parameters,void 0,l)),p;default:if(e.isSourceFileJavaScript(i))return;var f=e.createProperty(void 0,n,r.name,void 0,void 0,a.right);return h(a.parent,f),f}}}}}function h(t,n){e.forEachLeadingCommentRange(i.text,t.pos,(function(t,r,a,o){3===a?(t+=2,r-=2):t+=2,e.addSyntheticLeadingComment(n,a,i.text.slice(t,r),o)}))}function v(t,n){return e.filter(t.modifiers,(function(e){return e.kind===n}))}},getAvailableActions:function(t){if(!e.isInJavaScriptFile(t.file))return;var n=a(t);if(!n)return;e.isDeclarationOfFunctionOrClassExpression(n)&&(n=n.valueDeclaration.initializer.symbol);if(16&n.flags&&n.members&&n.members.size>0)return[{name:i.name,description:i.description,actions:[{description:i.description,name:r}]}]}};function a(t){var n=t.startPosition,r=t.file,i=t.program.getTypeChecker(),a=e.getTokenAtPosition(r,n,!1);return i.getSymbolAtLocation(a)}t.registerRefactor(i)}(t.convertFunctionToES6Class||(t.convertFunctionToES6Class={}))}(e.refactor||(e.refactor={}))}(ts||(ts={})),function(e){!function(t){!function(n){var r,i,a,o,s={name:"Extract Symbol",description:e.getLocaleSpecificMessage(e.Diagnostics.Extract_symbol),getAvailableActions:c,getEditsForAction:u};function c(t){var n=_(t.file,{start:t.startPosition,length:e.getRefactorContextLength(t)}).targetRange;if(void 0!==n){var r=function(t,n){var r=p(t,n),i=r.scopes,a=r.readsAndWrites,o=a.functionErrorsPerScope,s=a.constantErrorsPerScope;return i.map((function(t,n){var r,i,a=function(t){return e.isFunctionLikeDeclaration(t)?"inner function":e.isClassLike(t)?"method":"function"}(t),c=function(t){return e.isClassLike(t)?"readonly field":"constant"}(t),u=e.isFunctionLikeDeclaration(t)?function(t){switch(t.kind){case 152:return"constructor";case 186:return t.name?"function expression '"+t.name.text+"'":"anonymous function expression";case 228:return"function '"+t.name.text+"'";case 187:return"arrow function";case 151:return"method '"+t.name.getText();case 153:return"'get "+t.name.getText()+"'";case 154:return"'set "+t.name.getText()+"'";default:e.Debug.assertNever(t)}}(t):e.isClassLike(t)?function(e){return 229===e.kind?"class '"+e.name.text+"'":e.name?"class expression '"+e.name.text+"'":"anonymous class expression"}(t):function(e){return 234===e.kind?"namespace '"+e.parent.name.getText()+"'":e.externalModuleIndicator?0:1}(t);return 1===u?(r=e.formatStringFromArgs(e.getLocaleSpecificMessage(e.Diagnostics.Extract_to_0_in_1_scope),[a,"global"]),i=e.formatStringFromArgs(e.getLocaleSpecificMessage(e.Diagnostics.Extract_to_0_in_1_scope),[c,"global"])):0===u?(r=e.formatStringFromArgs(e.getLocaleSpecificMessage(e.Diagnostics.Extract_to_0_in_1_scope),[a,"module"]),i=e.formatStringFromArgs(e.getLocaleSpecificMessage(e.Diagnostics.Extract_to_0_in_1_scope),[c,"module"])):(r=e.formatStringFromArgs(e.getLocaleSpecificMessage(e.Diagnostics.Extract_to_0_in_1),[a,u]),i=e.formatStringFromArgs(e.getLocaleSpecificMessage(e.Diagnostics.Extract_to_0_in_1),[c,u])),0!==n||e.isClassLike(t)||(i=e.formatStringFromArgs(e.getLocaleSpecificMessage(e.Diagnostics.Extract_to_0_in_enclosing_scope),[c])),{functionExtraction:{description:r,errors:o[n]},constantExtraction:{description:i,errors:s[n]}}}))}(n,t);if(void 0!==r){for(var i=[],a=e.createMap(),o=[],c=e.createMap(),u=0,l=0,d=r;l<d.length;l++){var f=d[l],m=f.functionExtraction,g=f.constantExtraction;if(0===m.errors.length){var y=m.description;a.has(y)||(a.set(y,!0),i.push({description:y,name:"function_scope_"+u}))}if(0===g.errors.length){y=g.description;c.has(y)||(c.set(y,!0),o.push({description:y,name:"constant_scope_"+u}))}u++}var h=[];return i.length&&h.push({name:s.name,description:e.getLocaleSpecificMessage(e.Diagnostics.Extract_function),actions:i}),o.length&&h.push({name:s.name,description:e.getLocaleSpecificMessage(e.Diagnostics.Extract_constant),actions:o}),h.length?h:void 0}}}function u(t,n){var r=_(t.file,{start:t.startPosition,length:e.getRefactorContextLength(t)}).targetRange,a=/^function_scope_(\d+)$/.exec(n);if(a){var o=+a[1];return e.Debug.assert(isFinite(o),"Expected to parse a finite number from the function scope index"),function(t,n,r){var a=p(t,n),o=a.scopes,s=a.readsAndWrites,c=s.target,u=s.usagesPerScope,_=s.functionErrorsPerScope,l=s.exposedVariableDeclarations;return e.Debug.assert(!_[r].length,"The extraction went missing? How?"),n.cancellationToken.throwIfCancellationRequested(),function(t,n,r,a,o,s){var c,u=r.usages,_=r.typeParameterUsages,l=r.substitutions,d=s.program.getTypeChecker(),p=n.getSourceFile(),b=f(e.isClassLike(n)?"newMethod":"newFunction",p.text),x=e.isInJavaScriptFile(n),k=e.createIdentifier(b),S=void 0,D=[],C=[];u.forEach((function(n,r){var i=void 0;if(!x){var a=d.getTypeOfSymbolAtLocation(n.symbol,n.node);a=d.getBaseTypeOfLiteralType(a),i=d.typeToTypeNode(a,t,e.NodeBuilderFlags.NoTruncation)}var o=e.createParameter(void 0,void 0,void 0,r,void 0,i);D.push(o),2===n.usage&&(c||(c=[])).push(n),C.push(e.createIdentifier(r))}));var T=e.arrayFrom(_.values()).map((function(e){return{type:e,declaration:g(e)}})).sort(y),E=0===T.length?void 0:T.map((function(e){return e.declaration})),N=void 0!==E?E.map((function(t){return e.createTypeReferenceNode(t.name,void 0)})):void 0;if(e.isExpression(t)&&!x){var A=d.getContextualType(t);S=d.typeToTypeNode(A,n,e.NodeBuilderFlags.NoTruncation)}var w,P=function(t,n,r,i,a){var o,s=void 0!==r||n.length>0;if(e.isBlock(t)&&!s&&0===i.size)return{body:e.createBlock(t.statements,!0),returnValueProperty:void 0};var c=!1,u=e.createNodeArray(e.isBlock(t)?t.statements.slice(0):[e.isStatement(t)?t:e.createReturn(t)]);if(s||i.size){var _=e.visitNodes(u,d).slice();if(s&&!a&&e.isStatement(t)){var l=h(n,r);1===l.length?_.push(e.createReturn(l[0].name)):_.push(e.createReturn(e.createObjectLiteral(l)))}return{body:e.createBlock(_,!0),returnValueProperty:o}}return{body:e.createBlock(u,!0),returnValueProperty:void 0};function d(t){if(!c&&219===t.kind&&s){var a=h(n,r);return t.expression&&(o||(o="__return"),a.unshift(e.createPropertyAssignment(o,e.visitNode(t.expression,d)))),1===a.length?e.createReturn(a[0].name):e.createReturn(e.createObjectLiteral(a))}var u=c;c=c||e.isFunctionLikeDeclaration(t)||e.isClassLike(t);var _=i.get(e.getNodeId(t).toString()),l=_?e.getSynthesizedDeepClone(_):e.visitEachChild(t,d,e.nullTransformationContext);return c=u,l}}(t,a,c,l,!!(o.facts&i.HasReturn)),F=P.body,O=P.returnValueProperty;if(e.suppressLeadingAndTrailingTrivia(F),e.isClassLike(n)){var I=x?[]:[e.createToken(112)];o.facts&i.InStaticRegion&&I.push(e.createToken(115)),o.facts&i.IsAsyncFunction&&I.push(e.createToken(120)),w=e.createMethod(void 0,I.length?I:void 0,o.facts&i.IsGenerator?e.createToken(39):void 0,k,void 0,E,D,S,F)}else w=e.createFunctionDeclaration(void 0,o.facts&i.IsAsyncFunction?[e.createToken(120)]:void 0,o.facts&i.IsGenerator?e.createToken(39):void 0,k,E,D,S,F);var R=e.textChanges.ChangeTracker.fromContext(s),L=function(t,n){return e.find(function(t){if(e.isFunctionLikeDeclaration(t)){var n=t.body;if(e.isBlock(n))return n.statements}else{if(e.isModuleBlock(t)||e.isSourceFile(t))return t.statements;if(e.isClassLike(t))return t.members;e.assertTypeIsNever(t)}return e.emptyArray}(n),(function(n){return n.pos>=t&&e.isFunctionLikeDeclaration(n)&&!e.isConstructorDeclaration(n)}))}((v(o.range)?e.last(o.range):o.range).end,n);L?R.insertNodeBefore(s.file,L,w,{suffix:s.newLineCharacter+s.newLineCharacter}):R.insertNodeBefore(s.file,n.getLastToken(),w,{prefix:e.isLineBreak(p.text.charCodeAt(n.getLastToken().pos))?s.newLineCharacter:s.newLineCharacter+s.newLineCharacter,suffix:s.newLineCharacter});var M=[],B=function(t,n,r){var a=e.createIdentifier(r);if(e.isClassLike(t)){var o=n.facts&i.InStaticRegion?e.createIdentifier(t.name.text):e.createThis();return e.createPropertyAccess(o,a)}return a}(n,o,b),J=e.createCall(B,N,C);o.facts&i.IsGenerator&&(J=e.createYield(e.createToken(39),J));o.facts&i.IsAsyncFunction&&(J=e.createAwait(J));if(a.length&&!c)if(e.Debug.assert(!O),e.Debug.assert(!(o.facts&i.HasReturn)),1===a.length){var z=a[0];M.push(e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration(e.getSynthesizedDeepClone(z.name),e.getSynthesizedDeepClone(z.type),J)],z.parent.flags)))}else{for(var j=[],K=[],U=a[0].parent.flags,V=!1,q=0,W=a;q<W.length;q++){z=W[q];j.push(e.createBindingElement(void 0,void 0,e.getSynthesizedDeepClone(z.name)));var H=d.typeToTypeNode(d.getBaseTypeOfLiteralType(d.getTypeAtLocation(z)),n,e.NodeBuilderFlags.NoTruncation);K.push(e.createPropertySignature(void 0,z.symbol.name,void 0,H,void 0)),V=V||void 0!==z.type,U&=z.parent.flags}var G=V?e.createTypeLiteralNode(K):void 0;G&&e.setEmitFlags(G,1),M.push(e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration(e.createObjectBindingPattern(j),G,J)],U)))}else if(a.length||c){if(a.length)for(var Q=0,X=a;Q<X.length;Q++){var Y=(z=X[Q]).parent.flags;2&Y&&(Y=-3&Y|1),M.push(e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration(z.symbol.name,re(z.type))],Y)))}O&&M.push(e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration(O,re(S))],1)));var Z=h(a,c);O&&Z.unshift(e.createShorthandPropertyAssignment(O)),1===Z.length?(e.Debug.assert(!O),M.push(e.createStatement(e.createAssignment(Z[0].name,J))),o.facts&i.HasReturn&&M.push(e.createReturn())):(M.push(e.createStatement(e.createAssignment(e.createObjectLiteral(Z),J))),O&&M.push(e.createReturn(e.createIdentifier(O))))}else o.facts&i.HasReturn?M.push(e.createReturn(J)):v(o.range)?M.push(e.createStatement(J)):M.push(J);var $=v(o.range)?{pos:e.first(o.range).getStart(),end:e.last(o.range).end}:{pos:o.range.getStart(),end:o.range.end};R.replaceRangeWithNodes(s.file,$,M,{nodeSeparator:s.newLineCharacter});var ee=R.getChanges(),te=(v(o.range)?e.first(o.range):o.range).getSourceFile().fileName,ne=m(ee,te,b,!1);return{renameFilename:te,renameLocation:ne,edits:ee};function re(t){if(void 0!==t){for(var n=e.getSynthesizedDeepClone(t),r=n;e.isParenthesizedTypeNode(r);)r=r.type;return e.isUnionTypeNode(r)&&e.find(r.types,(function(e){return 139===e.kind}))?n:e.createUnionTypeNode([n,e.createKeywordTypeNode(139)])}}}(c,o[r],u[r],l,t,n)}(r,t,o)}var s=/^constant_scope_(\d+)$/.exec(n);if(s){o=+s[1];return e.Debug.assert(isFinite(o),"Expected to parse a finite number from the constant scope index"),function(t,n,r){var a=p(t,n),o=a.scopes,s=a.readsAndWrites,c=s.target,u=s.usagesPerScope,_=s.constantErrorsPerScope,l=s.exposedVariableDeclarations;return e.Debug.assert(!_[r].length,"The extraction went missing? How?"),e.Debug.assert(0===l.length,"Extract constant accepted a range containing a variable declaration?"),n.cancellationToken.throwIfCancellationRequested(),function(t,n,r,a,o){var s=r.substitutions,c=o.program.getTypeChecker(),u=n.getSourceFile(),_=f(e.isClassLike(n)?"newProperty":"newLocal",u.text),l=e.isInJavaScriptFile(n),p=l?void 0:c.typeToTypeNode(c.getContextualType(t),n,e.NodeBuilderFlags.NoTruncation),g=function(t,n){return n.size?r(t):t;function r(t){var i=n.get(e.getNodeId(t).toString());return i?e.getSynthesizedDeepClone(i):e.visitEachChild(t,r,e.nullTransformationContext)}}(t,s);e.suppressLeadingAndTrailingTrivia(g);var y=e.textChanges.ChangeTracker.fromContext(o);if(e.isClassLike(n)){e.Debug.assert(!l);var h=[];h.push(e.createToken(112)),a&i.InStaticRegion&&h.push(e.createToken(115)),h.push(e.createToken(131));var v=e.createProperty(void 0,h,_,void 0,p,g),b=e.createPropertyAccess(a&i.InStaticRegion?e.createIdentifier(n.name.getText()):e.createThis(),e.createIdentifier(_)),x=function(t,n){var r=n.members;e.Debug.assert(r.length>0);for(var i=void 0,a=!0,o=0,s=r;o<s.length;o++){var c=s[o];if(c.pos>t)return i||r[0];if(a&&!e.isPropertyDeclaration(c)){if(void 0!==i)return c;a=!1}i=c}return e.Debug.assert(void 0!==i),i}(t.pos,n);y.insertNodeBefore(o.file,x,v,{suffix:o.newLineCharacter+o.newLineCharacter}),y.replaceRange(o.file,{pos:t.getStart(),end:t.end},b)}else{var S=e.createVariableDeclaration(_,p,g),D=function(t,n){var r=void 0;for(;void 0!==t&&t!==n;){if(e.isVariableDeclaration(t)&&t.initializer===r&&e.isVariableDeclarationList(t.parent)&&t.parent.declarations.length>1)return t;r=t,t=t.parent}}(t,n);if(D){y.insertNodeAt(o.file,D.getStart(),S,{suffix:", "});b=e.createIdentifier(_);y.replaceRange(o.file,{pos:t.getStart(),end:t.end},b)}else if(210===t.parent.kind&&n===e.findAncestor(t,d)){var C=e.createVariableStatement(void 0,e.createVariableDeclarationList([S],2));y.replaceRange(o.file,{pos:t.parent.getStart(),end:t.parent.end},C)}else{C=e.createVariableStatement(void 0,e.createVariableDeclarationList([S],2));if(0===(x=function(t,n){e.Debug.assert(!e.isClassLike(n));for(var r=void 0,i=t;i!==n;i=i.parent)d(i)&&(r=i);for(i=(r||t).parent;;i=i.parent){if(k(i)){for(var a=void 0,o=0,s=i.statements;o<s.length;o++){var c=s[o];if(c.pos>t.pos)break;a=c}return e.Debug.assert(void 0!==a),a}if(i===n){e.Debug.fail("Didn't encounter a block-like before encountering scope");break}}}(t,n)).pos){var T=e.getSourceFileImportLocation(u);y.insertNodeAt(o.file,T,C,{prefix:0===T?void 0:o.newLineCharacter,suffix:e.isLineBreak(u.text.charCodeAt(T))?o.newLineCharacter:o.newLineCharacter+o.newLineCharacter})}else y.insertNodeBefore(o.file,x,C,{suffix:o.newLineCharacter+o.newLineCharacter});if(210===t.parent.kind)y.deleteRange(o.file,{pos:t.parent.getStart(),end:t.parent.end});else{b=e.createIdentifier(_);y.replaceRange(o.file,{pos:t.getStart(),end:t.end},b)}}}var E=y.getChanges(),N=t.getSourceFile().fileName,A=m(E,N,_,!0);return{renameFilename:N,renameLocation:A,edits:E}}(e.isExpression(c)?c:c.statements[0].expression,o[r],u[r],t.facts,n)}(r,t,o)}e.Debug.fail("Unrecognized action name")}function _(t,n){var a=n.length;if(0===a)return{errors:[e.createFileDiagnostic(t,n.start,a,r.CannotExtractEmpty)]};var o=b(e.getTokenAtPosition(t,n.start,!1),t,n),s=b(e.findTokenOnLeftOfPosition(t,e.textSpanEnd(n)),t,n),c=[],u=i.None;if(!o||!s)return{errors:[e.createFileDiagnostic(t,n.start,a,r.CannotExtractRange)]};if(o.parent!==s.parent)return{errors:[e.createFileDiagnostic(t,n.start,a,r.CannotExtractRange)]};if(o!==s){if(!k(o.parent))return{errors:[e.createFileDiagnostic(t,n.start,a,r.CannotExtractRange)]};for(var _=[],d=0,p=o.parent.statements;d<p.length;d++){var f=p[d];if(f===o||_.length){var m=y(f);if(m)return{errors:m};_.push(f)}if(f===s)break}return{targetRange:{range:_,facts:u,declarations:c}}}var g=function(t){if(e.isIdentifier(e.isExpressionStatement(t)?t.expression:t))return[e.createDiagnosticForNode(t,r.CannotExtractIdentifier)];return}(o)||y(o);return g?{errors:g}:{targetRange:{range:l(o),facts:u,declarations:c}};function y(t){var a;if(function(e){e[e.None=0]="None",e[e.Break=1]="Break",e[e.Continue=2]="Continue",e[e.Return=4]="Return"}(a||(a={})),!(e.isStatement(t)||e.isPartOfExpression(t)&&function(e){switch(e.parent.kind){case 264:return!1}switch(e.kind){case 9:return 238!==e.parent.kind&&242!==e.parent.kind;case 198:case 174:case 176:return!1;case 71:return 176!==e.parent.kind&&242!==e.parent.kind&&246!==e.parent.kind}return!0}(t)))return[e.createDiagnosticForNode(t,r.StatementOrExpressionExpected)];if(e.isInAmbientContext(t))return[e.createDiagnosticForNode(t,r.CannotExtractAmbientBlock)];var o,s=e.getContainingClass(t);s&&function(t,n){for(var r=t;r!==n;){if(149===r.kind){e.hasModifier(r,32)&&(u|=i.InStaticRegion);break}if(146===r.kind){152===e.getContainingFunction(r).kind&&(u|=i.InStaticRegion);break}151===r.kind&&e.hasModifier(r,32)&&(u|=i.InStaticRegion),r=r.parent}}(t,s);var _,l=4;return function t(a){if(o)return!0;if(e.isDeclaration(a)){var s=226===a.kind?a.parent.parent:a;if(e.hasModifier(s,1))return(o||(o=[])).push(e.createDiagnosticForNode(a,r.CannotExtractExportedEntity)),!0;c.push(a.symbol)}switch(a.kind){case 238:return(o||(o=[])).push(e.createDiagnosticForNode(a,r.CannotExtractImport)),!0;case 97:if(181===a.parent.kind){var d=e.getContainingClass(a);if(d.pos<n.start||d.end>=n.start+n.length)return(o||(o=[])).push(e.createDiagnosticForNode(a,r.CannotExtractSuper)),!0}else u|=i.UsesThis}if(!a||e.isFunctionLikeDeclaration(a)||e.isClassLike(a)){switch(a.kind){case 228:case 229:265===a.parent.kind&&void 0===a.parent.externalModuleIndicator&&(o||(o=[])).push(e.createDiagnosticForNode(a,r.FunctionWillNotBeVisibleInTheNewScope))}return!1}var p=l;switch(a.kind){case 211:case 224:l=0;break;case 207:a.parent&&224===a.parent.kind&&a.parent.finallyBlock===a&&(l=4);break;case 257:l|=1;break;default:e.isIterationStatement(a,!1)&&(l|=3)}switch(a.kind){case 169:case 99:u|=i.UsesThis;break;case 222:var f=a.label;(_||(_=[])).push(f.escapedText),e.forEachChild(a,t),_.pop();break;case 218:case 217:(f=a.label)?e.contains(_,f.escapedText)||(o||(o=[])).push(e.createDiagnosticForNode(a,r.CannotExtractRangeContainingLabeledBreakOrContinueStatementWithTargetOutsideOfTheRange)):l&(218===a.kind?1:2)||(o||(o=[])).push(e.createDiagnosticForNode(a,r.CannotExtractRangeContainingConditionalBreakOrContinueStatements));break;case 191:u|=i.IsAsyncFunction;break;case 197:u|=i.IsGenerator;break;case 219:4&l?u|=i.HasReturn:(o||(o=[])).push(e.createDiagnosticForNode(a,r.CannotExtractRangeContainingConditionalReturnStatement));break;default:e.forEachChild(a,t)}l=p}(t),o}}function l(t){return e.isStatement(t)?[t]:e.isPartOfExpression(t)?e.isExpressionStatement(t.parent)?[t.parent]:t:void 0}function d(t){return e.isFunctionLikeDeclaration(t)||e.isSourceFile(t)||e.isModuleBlock(t)||e.isClassLike(t)}function p(t,n){var a=n.file,o=function(t){var n=v(t.range)?e.first(t.range):t.range;if(t.facts&i.UsesThis){var r=e.getContainingClass(n);if(r){var a=e.findAncestor(n,e.isFunctionLikeDeclaration);return a?[a,r]:[r]}}for(var o=[];;)if(146===(n=n.parent).kind&&(n=e.findAncestor(n,(function(t){return e.isFunctionLikeDeclaration(t)})).parent),d(n)&&(o.push(n),265===n.kind))return o}(t);return{scopes:o,readsAndWrites:function(t,n,a,o,s,c){var u=e.createMap(),_=[],l=[],d=[],p=[],f=[],m=e.createMap(),g=[],y=void 0,h=v(t.range)?1===t.range.length&&e.isExpressionStatement(t.range[0])?t.range[0].expression:void 0:t.range,b=void 0;if(void 0===h){var x=t.range,k=e.first(x).getStart(),S=e.last(x).end;b=e.createFileDiagnostic(o,k,S-k,r.ExpressionExpected)}else 9216&s.getTypeAtLocation(h).flags&&(b=e.createDiagnosticForNode(h,r.UselessConstantType));for(var D=0,C=n;D<C.length;D++){var T=C[D];_.push({usages:e.createMap(),typeParameterUsages:e.createMap(),substitutions:e.createMap()}),l.push(e.createMap()),d.push(e.isFunctionLikeDeclaration(T)&&228!==T.kind?[e.createDiagnosticForNode(T,r.CannotExtractToOtherFunctionLike)]:[]);var E=[];b&&E.push(b),e.isClassLike(T)&&e.isInJavaScriptFile(T)&&E.push(e.createDiagnosticForNode(T,r.CannotExtractToJSClass)),e.isArrowFunction(T)&&!e.isBlock(T.body)&&E.push(e.createDiagnosticForNode(T,r.CannotExtractToExpressionArrowFunction)),p.push(E)}var N=e.createMap(),A=v(t.range)?e.createBlock(t.range):t.range,w=v(t.range)?e.first(t.range):t.range,P=U(w);if(q(A),P&&!v(t.range)){V(s.getContextualType(t.range))}if(u.size>0){for(var F=e.createMap(),O=0,I=w;void 0!==I&&O<n.length;I=I.parent)if(I===n[O]&&(F.forEach((function(e,t){_[O].typeParameterUsages.set(t,e)})),O++),e.isDeclarationWithTypeParameters(I)&&I.typeParameters)for(var R=0,L=I.typeParameters;R<L.length;R++){var M=L[R],B=s.getTypeAtLocation(M);u.has(B.id.toString())&&F.set(B.id.toString(),B)}e.Debug.assert(O===n.length)}if(f.length){var J=e.isBlockScope(n[0],n[0].parent)?n[0]:e.getEnclosingBlockScopeContainer(n[0]);e.forEachChild(J,G)}for(var z=function(n){var i=_[n];if(n>0&&(i.usages.size>0||i.typeParameterUsages.size>0)){var a=v(t.range)?t.range[0]:t.range;p[n].push(e.createDiagnosticForNode(a,r.CannotAccessVariablesFromNestedScopes))}var o=!1,s=void 0;if(_[n].usages.forEach((function(t){2===t.usage&&(o=!0,106500&t.symbol.flags&&t.symbol.valueDeclaration&&e.hasModifier(t.symbol.valueDeclaration,64)&&(s=t.symbol.valueDeclaration))})),e.Debug.assert(v(t.range)||0===g.length),o&&!v(t.range)){var c=e.createDiagnosticForNode(t.range,r.CannotWriteInExpression);d[n].push(c),p[n].push(c)}else if(s&&n>0){c=e.createDiagnosticForNode(s,r.CannotExtractReadonlyPropertyInitializerOutsideConstructor);d[n].push(c),p[n].push(c)}else if(y){c=e.createDiagnosticForNode(y,r.CannotExtractExportedEntity);d[n].push(c),p[n].push(c)}},j=0;j<n.length;j++)z(j);return{target:A,usagesPerScope:_,functionErrorsPerScope:d,constantErrorsPerScope:p,exposedVariableDeclarations:g};function K(t){return e.isDeclarationWithTypeParameters(t)&&void 0!==t.typeParameters&&t.typeParameters.length>0}function U(e){for(;e;e=e.parent)if(K(e))return!0;return!1}function V(e){for(var t=0,n=s.getSymbolWalker((function(){return c.throwIfCancellationRequested(),!0})).walkType(e).visitedTypes;t<n.length;t++){var r=n[t];16384&r.flags&&u.set(r.id.toString(),r)}}function q(t,n){(void 0===n&&(n=1),P)&&V(s.getTypeAtLocation(t));if(e.isDeclaration(t)&&t.symbol&&f.push(t),e.isAssignmentExpression(t))q(t.left,2),q(t.right);else if(e.isUnaryExpressionWithWrite(t))q(t.operand,2);else if(e.isPropertyAccessExpression(t)||e.isElementAccessExpression(t))e.forEachChild(t,q);else if(e.isIdentifier(t)){if(!t.parent)return;if(e.isQualifiedName(t.parent)&&t!==t.parent.left)return;if(e.isPropertyAccessExpression(t.parent)&&t!==t.parent.expression)return;W(t,n,e.isPartOfTypeNode(t))}else e.forEachChild(t,q)}function W(t,r,i){var a=H(t,r,i);if(a)for(var o=0;o<n.length;o++){var s=l[o].get(a);s&&_[o].substitutions.set(e.getNodeId(t).toString(),s)}}function H(c,u,f){var m=Q(c);if(m){var g=e.getSymbolId(m).toString(),y=N.get(g);if(y&&y>=u)return g;if(N.set(g,u),y){for(var h=0,v=_;h<v.length;h++){var b=v[h];b.usages.get(c.text)&&b.usages.set(c.text,{usage:u,symbol:m,node:c})}return g}var x=e.find(m.getDeclarations(),(function(e){return e.getSourceFile()===o}));if(x&&!e.rangeContainsStartEnd(a,x.getStart(),x.end)){if(t.facts&i.IsGenerator&&2===u){for(var k=e.createDiagnosticForNode(c,r.CannotExtractRangeThatContainsWritesToReferencesLocatedOutsideOfTheTargetRangeInGenerators),S=0,D=d;S<D.length;S++){D[S].push(k)}for(var C=0,T=p;C<T.length;C++){T[C].push(k)}}for(var E=0;E<n.length;E++){var A=n[E];if(s.resolveName(m.name,A,m.flags)!==m&&!l[E].has(g)){var w=X(m.exportSymbol||m,A,f);if(w)l[E].set(g,w);else if(f){if(!(262144&m.flags)){k=e.createDiagnosticForNode(c,r.TypeWillNotBeVisibleInTheNewScope);d[E].push(k),p[E].push(k)}}else _[E].usages.set(c.text,{usage:u,symbol:m,node:c})}}return g}}}function G(n){if(!(n===t.range||v(t.range)&&t.range.indexOf(n)>=0)){var r=e.isIdentifier(n)?Q(n):s.getSymbolAtLocation(n);if(r){var i=e.find(f,(function(e){return e.symbol===r}));if(i)if(e.isVariableDeclaration(i)){var a=i.symbol.id.toString();m.has(a)||(g.push(i),m.set(a,!0))}else y=y||i}e.forEachChild(n,G)}}function Q(t){return t.parent&&e.isShorthandPropertyAssignment(t.parent)&&t.parent.name===t?s.getShorthandAssignmentValueSymbol(t.parent):s.getSymbolAtLocation(t)}function X(t,n,r){if(t){if(t.getDeclarations().some((function(e){return e.parent===n})))return e.createIdentifier(t.name);var i=X(t.parent,n,r);if(void 0!==i)return r?e.createQualifiedName(i,e.createIdentifier(t.name)):e.createPropertyAccess(i,t.name)}}}(t,o,function(t,n){return v(t.range)?{pos:e.first(t.range).getStart(n),end:e.last(t.range).getEnd()}:t.range}(t,a),a,n.program.getTypeChecker(),n.cancellationToken)}}function f(t,n){for(var r=t,i=1;e.stringContains(n,r);i++)r=t+"_"+i;return r}function m(t,n,r,i){for(var a=0,o=-1,s=0,c=t;s<c.length;s++){var u=c[s],_=u.fileName,l=u.textChanges;e.Debug.assert(_===n);for(var d=0,p=l;d<p.length;d++){var f=p[d],m=f.span,g=f.newText,y=g.indexOf(r);if(-1!==y&&(o=m.start+a+y,!i))return o;a+=g.length-m.length}}return e.Debug.assert(i),e.Debug.assert(o>=0),o}function g(e){var t=void 0,n=e.symbol;if(n&&n.declarations)for(var r=0,i=n.declarations;r<i.length;r++){var a=i[r];(void 0===t||a.pos<t.pos)&&(t=a)}return t}function y(t,n){var r=t.type,i=t.declaration,a=n.type,o=n.declaration;if(i){if(!o)return 1;var s=i.pos-o.pos;if(0!==s)return s}else if(o)return-1;var c=r.symbol?r.symbol.getName():"",u=a.symbol?a.symbol.getName():"",_=e.compareStrings(c,u);return 0!==_?_:r.id-a.id}function h(t,n){var r=e.map(t,(function(t){return e.createShorthandPropertyAssignment(t.symbol.name)})),i=e.map(n,(function(t){return e.createShorthandPropertyAssignment(t.symbol.name)}));return void 0===r?i:void 0===i?r:r.concat(i)}function v(t){return e.isArray(t)}function b(t,n,r){if(t)for(;t.parent;){if(e.isSourceFile(t.parent)||!x(r,t.parent,n))return t;t=t.parent}}function x(t,n,r){return e.textSpanContainsPosition(t,n.getStart(r))&&n.getEnd()<=e.textSpanEnd(t)}function k(e){switch(e.kind){case 207:case 265:case 234:case 257:return!0;default:return!1}}t.registerRefactor(s),n.getAvailableActions=c,n.getEditsForAction=u,function(t){function n(t){return{message:t,code:0,category:e.DiagnosticCategory.Message,key:t}}t.CannotExtractRange=n("Cannot extract range."),t.CannotExtractImport=n("Cannot extract import statement."),t.CannotExtractSuper=n("Cannot extract super call."),t.CannotExtractEmpty=n("Cannot extract empty range."),t.ExpressionExpected=n("expression expected."),t.UselessConstantType=n("No reason to extract constant of type."),t.StatementOrExpressionExpected=n("Statement or expression expected."),t.CannotExtractRangeContainingConditionalBreakOrContinueStatements=n("Cannot extract range containing conditional break or continue statements."),t.CannotExtractRangeContainingConditionalReturnStatement=n("Cannot extract range containing conditional return statement."),t.CannotExtractRangeContainingLabeledBreakOrContinueStatementWithTargetOutsideOfTheRange=n("Cannot extract range containing labeled break or continue with target outside of the range."),t.CannotExtractRangeThatContainsWritesToReferencesLocatedOutsideOfTheTargetRangeInGenerators=n("Cannot extract range containing writes to references located outside of the target range in generators."),t.TypeWillNotBeVisibleInTheNewScope=n("Type will not visible in the new scope."),t.FunctionWillNotBeVisibleInTheNewScope=n("Function will not visible in the new scope."),t.CannotExtractIdentifier=n("Select more than a single identifier."),t.CannotExtractExportedEntity=n("Cannot extract exported declaration"),t.CannotWriteInExpression=n("Cannot write back side-effects when extracting an expression"),t.CannotExtractReadonlyPropertyInitializerOutsideConstructor=n("Cannot move initialization of read-only class property outside of the constructor"),t.CannotExtractAmbientBlock=n("Cannot extract code from ambient contexts"),t.CannotAccessVariablesFromNestedScopes=n("Cannot access variables from nested scopes"),t.CannotExtractToOtherFunctionLike=n("Cannot extract method to a function-like scope that is not a function"),t.CannotExtractToJSClass=n("Cannot extract constant to a class scope in JS"),t.CannotExtractToExpressionArrowFunction=n("Cannot extract constant to an arrow function without a block")}(r=n.Messages||(n.Messages={})),function(e){e[e.None=0]="None",e[e.HasReturn=1]="HasReturn",e[e.IsGenerator=2]="IsGenerator",e[e.IsAsyncFunction=4]="IsAsyncFunction",e[e.UsesThis=8]="UsesThis",e[e.InStaticRegion=16]="InStaticRegion"}(i||(i={})),n.getRangeToExtract=_,function(e){e[e.Module=0]="Module",e[e.Global=1]="Global"}(a||(a={})),function(e){e[e.Read=1]="Read",e[e.Write=2]="Write"}(o||(o={}))}(t.extractSymbol||(t.extractSymbol={}))}(e.refactor||(e.refactor={}))}(ts||(ts={})),function(e){!function(t){!function(n){var r="install",i={name:"Install missing types package",description:"Install missing types package",getEditsForAction:function(t,n){e.Debug.assertEqual(r,n);var i=a(t);return{edits:[],renameFilename:void 0,renameLocation:void 0,commands:i.commands}},getAvailableActions:function(e){var t=e.program.getCompilerOptions();if(void 0===t.noImplicitAny?t.strict:t.noImplicitAny)return;var n=a(e);return n&&[{name:i.name,description:i.description,actions:[{description:n.description,name:r}]}]}};function a(t){var n=t.file,r=t.startPosition,i=e.getTokenAtPosition(n,r,!1);if(e.isStringLiteral(i)&&function(e){switch(e.parent.kind){case 238:case 248:return!0;default:return!1}}(i)&&void 0===e.getResolvedModule(n,i.text))return e.codefix.tryGetCodeActionForInstallPackageTypes(t.host,i.text)}t.registerRefactor(i)}(t.installTypesForPackage||(t.installTypesForPackage={}))}(e.refactor||(e.refactor={}))}(ts||(ts={})),function(e){var t;function n(t,n,i,a){var c=e.isNodeKind(t)?new r(t,n,i):71===t?new s(71,n,i):new o(t,n,i);return c.parent=a,c}e.servicesVersion="0.6";var r=function(){function t(e,t,n){this.pos=t,this.end=n,this.flags=0,this.transformFlags=void 0,this.parent=void 0,this.kind=e}return t.prototype.getSourceFile=function(){return e.getSourceFileOfNode(this)},t.prototype.getStart=function(t,n){return e.getTokenPosOfNode(this,t,n)},t.prototype.getFullStart=function(){return this.pos},t.prototype.getEnd=function(){return this.end},t.prototype.getWidth=function(e){return this.getEnd()-this.getStart(e)},t.prototype.getFullWidth=function(){return this.end-this.pos},t.prototype.getLeadingTriviaWidth=function(e){return this.getStart(e)-this.pos},t.prototype.getFullText=function(e){return(e||this.getSourceFile()).text.substring(this.pos,this.end)},t.prototype.getText=function(e){return e||(e=this.getSourceFile()),e.text.substring(this.getStart(e),this.getEnd())},t.prototype.addSyntheticNodes=function(t,r,i){for(e.scanner.setTextPos(r);r<i;){var a=e.scanner.scan(),o=e.scanner.getTextPos();if(o<=i&&t.push(n(a,r,o,this)),r=o,1===a)break}return r},t.prototype.createSyntaxList=function(e){var t=n(286,e.pos,e.end,this);t._children=[];for(var r=e.pos,i=0,a=e;i<a.length;i++){var o=a[i];r<o.pos&&(r=this.addSyntheticNodes(t._children,r,o.pos)),t._children.push(o),r=o.end}return r<e.end&&this.addSyntheticNodes(t._children,r,e.end),t},t.prototype.createChildren=function(t){var n=this;if(e.isNodeKind(this.kind)){if(e.isJSDocCommentContainingNode(this)){var r=[];return this.forEachChild((function(e){r.push(e)})),void(this._children=r)}var i=[];e.scanner.setText((t||this.getSourceFile()).text);var a=this.pos,o=function(e){a=n.addSyntheticNodes(i,a,e.pos),i.push(e),a=e.end};if(this.jsDoc)for(var s=0,c=this.jsDoc;s<c.length;s++){o(c[s])}a=this.pos,e.forEachChild(this,o,(function(e){a<e.pos&&(a=n.addSyntheticNodes(i,a,e.pos)),i.push(n.createSyntaxList(e)),a=e.end})),a<this.end&&this.addSyntheticNodes(i,a,this.end),e.scanner.setText(void 0),this._children=i}else this._children=e.emptyArray},t.prototype.getChildCount=function(e){return this._children||this.createChildren(e),this._children.length},t.prototype.getChildAt=function(e,t){return this._children||this.createChildren(t),this._children[e]},t.prototype.getChildren=function(e){return this._children||this.createChildren(e),this._children},t.prototype.getFirstToken=function(t){var n=this.getChildren(t);if(n.length){var r=e.find(n,(function(e){return e.kind<267||e.kind>285}));return r.kind<143?r:r.getFirstToken(t)}},t.prototype.getLastToken=function(t){var n=this.getChildren(t),r=e.lastOrUndefined(n);if(r)return r.kind<143?r:r.getLastToken(t)},t.prototype.forEachChild=function(t,n){return e.forEachChild(this,t,n)},t}(),i=function(){function t(e,t){this.pos=e,this.end=t,this.flags=0,this.parent=void 0}return t.prototype.getSourceFile=function(){return e.getSourceFileOfNode(this)},t.prototype.getStart=function(t,n){return e.getTokenPosOfNode(this,t,n)},t.prototype.getFullStart=function(){return this.pos},t.prototype.getEnd=function(){return this.end},t.prototype.getWidth=function(e){return this.getEnd()-this.getStart(e)},t.prototype.getFullWidth=function(){return this.end-this.pos},t.prototype.getLeadingTriviaWidth=function(e){return this.getStart(e)-this.pos},t.prototype.getFullText=function(e){return(e||this.getSourceFile()).text.substring(this.pos,this.end)},t.prototype.getText=function(e){return(e||this.getSourceFile()).text.substring(this.getStart(),this.getEnd())},t.prototype.getChildCount=function(){return 0},t.prototype.getChildAt=function(){},t.prototype.getChildren=function(){return e.emptyArray},t.prototype.getFirstToken=function(){},t.prototype.getLastToken=function(){},t.prototype.forEachChild=function(){},t}(),a=function(){function t(e,t){this.flags=e,this.escapedName=t}return t.prototype.getFlags=function(){return this.flags},Object.defineProperty(t.prototype,"name",{get:function(){return e.symbolName(this)},enumerable:!0,configurable:!0}),t.prototype.getEscapedName=function(){return this.escapedName},t.prototype.getName=function(){return this.name},t.prototype.getDeclarations=function(){return this.declarations},t.prototype.getDocumentationComment=function(){return void 0===this.documentationComment&&(this.documentationComment=e.JsDoc.getJsDocCommentsFromDeclarations(this.declarations)),this.documentationComment},t.prototype.getJsDocTags=function(){return void 0===this.tags&&(this.tags=e.JsDoc.getJsDocTagsFromDeclarations(this.declarations)),this.tags},t}(),o=function(e){function t(t,n,r){var i=e.call(this,n,r)||this;return i.kind=t,i}return __extends(t,e),t}(i),s=function(t){function n(e,n,r){return t.call(this,n,r)||this}return __extends(n,t),Object.defineProperty(n.prototype,"text",{get:function(){return e.idText(this)},enumerable:!0,configurable:!0}),n}(i);s.prototype.kind=71;var c=function(){function e(e,t){this.checker=e,this.flags=t}return e.prototype.getFlags=function(){return this.flags},e.prototype.getSymbol=function(){return this.symbol},e.prototype.getProperties=function(){return this.checker.getPropertiesOfType(this)},e.prototype.getProperty=function(e){return this.checker.getPropertyOfType(this,e)},e.prototype.getApparentProperties=function(){return this.checker.getAugmentedPropertiesOfType(this)},e.prototype.getCallSignatures=function(){return this.checker.getSignaturesOfType(this,0)},e.prototype.getConstructSignatures=function(){return this.checker.getSignaturesOfType(this,1)},e.prototype.getStringIndexType=function(){return this.checker.getIndexTypeOfType(this,0)},e.prototype.getNumberIndexType=function(){return this.checker.getIndexTypeOfType(this,1)},e.prototype.getBaseTypes=function(){return 32768&this.flags&&3&this.objectFlags?this.checker.getBaseTypes(this):void 0},e.prototype.getNonNullableType=function(){return this.checker.getNonNullableType(this)},e}(),u=function(){function t(e){this.checker=e}return t.prototype.getDeclaration=function(){return this.declaration},t.prototype.getTypeParameters=function(){return this.typeParameters},t.prototype.getParameters=function(){return this.parameters},t.prototype.getReturnType=function(){return this.checker.getReturnTypeOfSignature(this)},t.prototype.getDocumentationComment=function(){return void 0===this.documentationComment&&(this.documentationComment=this.declaration?e.JsDoc.getJsDocCommentsFromDeclarations([this.declaration]):[]),this.documentationComment},t.prototype.getJsDocTags=function(){return void 0===this.jsDocTags&&(this.jsDocTags=this.declaration?e.JsDoc.getJsDocTagsFromDeclarations([this.declaration]):[]),this.jsDocTags},t}(),_=function(t){function n(e,n,r){return t.call(this,e,n,r)||this}return __extends(n,t),n.prototype.update=function(t,n){return e.updateSourceFile(this,t,n)},n.prototype.getLineAndCharacterOfPosition=function(t){return e.getLineAndCharacterOfPosition(this,t)},n.prototype.getLineStarts=function(){return e.getLineStarts(this)},n.prototype.getPositionOfLineAndCharacter=function(t,n){return e.getPositionOfLineAndCharacter(this,t,n)},n.prototype.getLineEndOfPosition=function(e){var t,n=this.getLineAndCharacterOfPosition(e).line,r=this.getLineStarts();n+1>=r.length&&(t=this.getEnd()),t||(t=r[n+1]-1);var i=this.getFullText();return"\n"===i[t]&&"\r"===i[t-1]?t-1:t},n.prototype.getNamedDeclarations=function(){return this.namedDeclarations||(this.namedDeclarations=this.computeNamedDeclarations()),this.namedDeclarations},n.prototype.computeNamedDeclarations=function(){var t=e.createMultiMap();return e.forEachChild(this,(function i(a){switch(a.kind){case 228:case 186:case 151:case 150:var o=a,s=r(o);if(s){var c=function(e){var n=t.get(e);n||t.set(e,n=[]);return n}(s),u=e.lastOrUndefined(c);u&&o.parent===u.parent&&o.symbol===u.symbol?o.body&&!u.body&&(c[c.length-1]=o):c.push(o)}e.forEachChild(a,i);break;case 229:case 199:case 230:case 231:case 232:case 233:case 237:case 246:case 242:case 239:case 240:case 153:case 154:case 163:n(a),e.forEachChild(a,i);break;case 146:if(!e.hasModifier(a,92))break;case 226:case 176:var _=a;if(e.isBindingPattern(_.name)){e.forEachChild(_.name,i);break}_.initializer&&i(_.initializer);case 264:case 149:case 148:n(a);break;case 244:a.exportClause&&e.forEach(a.exportClause.elements,i);break;case 238:var l=a.importClause;l&&(l.name&&n(l),l.namedBindings&&(240===l.namedBindings.kind?n(l.namedBindings):e.forEach(l.namedBindings.elements,i)));break;case 194:0!==e.getSpecialPropertyAssignmentKind(a)&&n(a);default:e.forEachChild(a,i)}})),t;function n(e){var n=r(e);n&&t.add(n,e)}function r(t){var n=e.getNameOfDeclaration(t);if(n){var r=e.getTextOfIdentifierOrLiteral(n);if(void 0!==r)return r;if(144===n.kind){var i=n.expression;return 179===i.kind?i.name.text:e.getTextOfIdentifierOrLiteral(i)}}}},n}(r),l=function(){function t(e,t,n){this.fileName=e,this.text=t,this.skipTrivia=n}return t.prototype.getLineAndCharacterOfPosition=function(t){return e.getLineAndCharacterOfPosition(this,t)},t}();function d(t){var n=!0;for(var r in t)if(e.hasProperty(t,r)&&!p(r)){n=!1;break}if(n)return t;var i={};for(var r in t){if(e.hasProperty(t,r))i[p(r)?r:r.charAt(0).toLowerCase()+r.substr(1)]=t[r]}return i}function p(e){return!e.length||e.charAt(0)===e.charAt(0).toLowerCase()}function f(){return{target:1,jsx:1}}e.toEditorSettings=d,e.displayPartsToString=function(t){return t?e.map(t,(function(e){return e.text})).join(""):""},e.getDefaultCompilerOptions=f,e.getSupportedCodeFixes=function(){return e.codefix.getSupportedErrorCodes()};var m=function(){function t(t,n){this.host=t,this.currentDirectory=t.getCurrentDirectory(),this.fileNameToEntry=e.createMap();for(var r=0,i=t.getScriptFileNames();r<i.length;r++){var a=i[r];this.createEntry(a,e.toPath(a,this.currentDirectory,n))}this._compilationSettings=t.getCompilationSettings()||{target:1,jsx:1}}return t.prototype.compilationSettings=function(){return this._compilationSettings},t.prototype.createEntry=function(t,n){var r,i=this.host.getScriptSnapshot(t);return r=i?{hostFileName:t,version:this.host.getScriptVersion(t),scriptSnapshot:i,scriptKind:e.getScriptKind(t,this.host)}:t,this.fileNameToEntry.set(n,r),r},t.prototype.getEntryByPath=function(e){return this.fileNameToEntry.get(e)},t.prototype.getHostFileInformation=function(t){var n=this.fileNameToEntry.get(t);return e.isString(n)?void 0:n},t.prototype.getOrCreateEntryByPath=function(t,n){var r=this.getEntryByPath(n)||this.createEntry(t,n);return e.isString(r)?void 0:r},t.prototype.getRootFileNames=function(){return e.arrayFrom(this.fileNameToEntry.values(),(function(t){return e.isString(t)?t:t.hostFileName}))},t.prototype.getVersion=function(e){var t=this.getHostFileInformation(e);return t&&t.version},t.prototype.getScriptSnapshot=function(e){var t=this.getHostFileInformation(e);return t&&t.scriptSnapshot},t}(),g=function(){function t(e){this.host=e}return t.prototype.getCurrentSourceFile=function(t){var n=this.host.getScriptSnapshot(t);if(!n)throw new Error("Could not find file: '"+t+"'.");var r,i=e.getScriptKind(t,this.host),a=this.host.getScriptVersion(t);if(this.currentFileName!==t)r=h(t,n,5,a,!0,i);else if(this.currentFileVersion!==a){var o=n.getChangeRange(this.currentFileScriptSnapshot);r=v(this.currentSourceFile,n,a,o)}return r&&(this.currentFileVersion=a,this.currentFileName=t,this.currentFileScriptSnapshot=n,this.currentSourceFile=r),this.currentSourceFile},t}();function y(e,t,n){e.version=n,e.scriptSnapshot=t}function h(t,n,r,i,a,o){var s=n.getText(0,n.getLength()),c=e.createSourceFile(t,s,r,a,o);return y(c,n,i),c}function v(t,n,r,i,a){if(i&&r!==t.version&&!e.disableIncrementalParsing){var o=void 0,s=0!==i.span.start?t.text.substr(0,i.span.start):"",c=e.textSpanEnd(i.span)!==t.text.length?t.text.substr(e.textSpanEnd(i.span)):"";if(0===i.newLength)o=s&&c?s+c:s||c;else{var u=n.getText(i.span.start,i.span.start+i.newLength);o=s&&c?s+u+c:s?s+u:u+c}var _=e.updateSourceFile(t,o,i,a);return y(_,n,r),_.nameTable=void 0,t!==_&&t.scriptSnapshot&&(t.scriptSnapshot.dispose&&t.scriptSnapshot.dispose(),t.scriptSnapshot=void 0),_}return h(t.fileName,n,t.languageVersion,r,!0,t.scriptKind)}e.createLanguageServiceSourceFile=h,e.disableIncrementalParsing=!1,e.updateLanguageServiceSourceFile=v;var b=function(){function t(e){this.cancellationToken=e}return t.prototype.isCancellationRequested=function(){return this.cancellationToken&&this.cancellationToken.isCancellationRequested()},t.prototype.throwIfCancellationRequested=function(){if(this.isCancellationRequested())throw new e.OperationCanceledException},t}(),x=function(){function t(e,t){void 0===t&&(t=20),this.hostCancellationToken=e,this.throttleWaitMilliseconds=t,this.lastCancellationCheckTime=0}return t.prototype.isCancellationRequested=function(){var t=e.timestamp();return Math.abs(t-this.lastCancellationCheckTime)>=this.throttleWaitMilliseconds&&(this.lastCancellationCheckTime=t,this.hostCancellationToken.isCancellationRequested())},t.prototype.throwIfCancellationRequested=function(){if(this.isCancellationRequested())throw new e.OperationCanceledException},t}();function k(e){switch(e.kind){case 253:case 255:case 261:case 262:case 151:case 153:case 154:return!0}return!1}function S(t,n){var r=e.unescapeLeadingUnderscores(e.getTextOfPropertyName(n));if(r&&t){var i=[],a=t.getProperty(r);if(65536&t.flags)return e.forEach(t.types,(function(e){var t=e.getProperty(r);t&&i.push(t)})),i;if(a)return i.push(a),i}}e.ThrottledCancellationToken=x,e.createLanguageService=function(n,r){void 0===r&&(r=e.createDocumentRegistry(n.useCaseSensitiveFileNames&&n.useCaseSensitiveFileNames(),n.getCurrentDirectory()));var i,a,o=new g(n);t=t||new e.formatting.RulesProvider;var s=0,c=n.useCaseSensitiveFileNames&&n.useCaseSensitiveFileNames(),u=new b(n.getCancellationToken&&n.getCancellationToken()),_=n.getCurrentDirectory();function l(e){n.log&&n.log(e)}!e.localizedDiagnosticMessages&&n.getLocalizedDiagnosticMessages&&(e.localizedDiagnosticMessages=n.getLocalizedDiagnosticMessages());var p=e.createGetCanonicalFileName(c);function f(e){var t=i.getSourceFile(e);if(!t)throw new Error("Could not find file: '"+e+"'.");return t}function y(e){return t.ensureUpToDate(e),t}function h(){if(n.getProjectVersion){var t=n.getProjectVersion();if(t){if(a===t&&!n.hasChangedAutomaticTypeDirectiveNames)return;a=t}}var o=n.getTypeRootsVersion?n.getTypeRootsVersion():0;s!==o&&(l("TypeRoots version has changed; provide new program"),i=void 0,s=o);var d=new m(n,p),f=d.getRootFileNames(),g=n.hasInvalidatedResolution||e.returnFalse;if(!e.isProgramUptoDate(i,f,d.compilationSettings(),(function(e){return d.getVersion(e)}),b,g,n.hasChangedAutomaticTypeDirectiveNames)){var y=d.compilationSettings(),h={getSourceFile:function(t,n,r,i){return x(t,e.toPath(t,_,p),n,r,i)},getSourceFileByPath:x,getCancellationToken:function(){return u},getCanonicalFileName:p,useCaseSensitiveFileNames:function(){return c},getNewLine:function(){return e.getNewLineCharacter(y,{newLine:e.getNewLineOrDefaultFromHost(n)})},getDefaultLibFileName:function(e){return n.getDefaultLibFileName(e)},writeFile:e.noop,getCurrentDirectory:function(){return _},fileExists:b,readFile:function(t){var r=e.toPath(t,_,p),i=d.getEntryByPath(r);return i?e.isString(i)?void 0:i.scriptSnapshot.getText(0,i.scriptSnapshot.getLength()):n.readFile&&n.readFile(t)},directoryExists:function(t){return e.directoryProbablyExists(t,n)},getDirectories:function(e){return n.getDirectories?n.getDirectories(e):[]},onReleaseOldSourceFile:function(e,t){var n=r.getKeyForCompilationSettings(t);r.releaseDocumentWithKey(e.path,n)},hasInvalidatedResolution:g,hasChangedAutomaticTypeDirectiveNames:n.hasChangedAutomaticTypeDirectiveNames};n.trace&&(h.trace=function(e){return n.trace(e)}),n.resolveModuleNames&&(h.resolveModuleNames=function(e,t,r){return n.resolveModuleNames(e,t,r)}),n.resolveTypeReferenceDirectives&&(h.resolveTypeReferenceDirectives=function(e,t){return n.resolveTypeReferenceDirectives(e,t)});var v=r.getKeyForCompilationSettings(y);return i=e.createProgram(f,y,h,i),d=void 0,void i.getTypeChecker()}function b(t){var r=e.toPath(t,_,p),i=d.getEntryByPath(r);return i?!e.isString(i):n.fileExists&&n.fileExists(t)}function x(t,n,a,o,s){e.Debug.assert(void 0!==d);var c=d.getOrCreateEntryByPath(t,n);if(c){if(!s){var u=i&&i.getSourceFileByPath(n);if(u)return e.Debug.assertEqual(c.scriptKind,u.scriptKind,"Registered script kind should match new script kind.",n),r.updateDocumentWithKey(t,n,y,v,c.scriptSnapshot,c.version,c.scriptKind)}return r.acquireDocumentWithKey(t,n,y,v,c.scriptSnapshot,c.version,c.scriptKind)}}}function v(){return h(),i}function x(t,n,r){h();var a=e.map(r,(function(e){return i.getSourceFile(e)})),o=f(t);return e.DocumentHighlights.getDocumentHighlights(i,u,o,n,a)}function k(t,n,r){h();var a=[];if(r&&r.isForRename)for(var o=0,s=i.getSourceFiles();o<s.length;o++){var c=s[o];i.isSourceFileDefaultLibrary(c)||a.push(c)}else a=i.getSourceFiles().slice();return e.FindAllReferences.findReferencedEntries(i,u,a,f(t),n,r)}function S(e){return o.getCurrentSourceFile(e)}function D(t){var r=e.getScriptKind(t,n);return 3===r||4===r}function C(e,t,r){var i="number"==typeof t?[t,void 0]:[t.pos,t.end];return{file:e,startPosition:i[0],endPosition:i[1],program:v(),newLineCharacter:r?r.newLineCharacter:n.getNewLine(),host:n,rulesProvider:y(r),cancellationToken:u}}return{dispose:function(){i&&(e.forEach(i.getSourceFiles(),(function(e){return r.releaseDocument(e.fileName,i.getCompilerOptions())})),i=void 0),n=void 0},cleanupSemanticCache:function(){i=void 0},getSyntacticDiagnostics:function(e){return h(),i.getSyntacticDiagnostics(f(e),u).slice()},getSemanticDiagnostics:function(e){h();var t=f(e),n=i.getSemanticDiagnostics(t,u);if(!i.getCompilerOptions().declaration)return n.slice();var r=i.getDeclarationDiagnostics(t,u);return n.concat(r)},getCompilerOptionsDiagnostics:function(){return h(),i.getOptionsDiagnostics(u).concat(i.getGlobalDiagnostics(u))},getSyntacticClassifications:function(t,n){return e.getSyntacticClassifications(u,o.getCurrentSourceFile(t),n)},getSemanticClassifications:function(t,n){return D(t)?(h(),e.getSemanticClassifications(i.getTypeChecker(),u,f(t),i.getClassifiableNames(),n)):[]},getEncodedSyntacticClassifications:function(t,n){return e.getEncodedSyntacticClassifications(u,o.getCurrentSourceFile(t),n)},getEncodedSemanticClassifications:function(t,n){return D(t)?(h(),e.getEncodedSemanticClassifications(i.getTypeChecker(),u,f(t),i.getClassifiableNames(),n)):{spans:[],endOfLineState:0}},getCompletionsAtPosition:function(t,r){return h(),e.Completions.getCompletionsAtPosition(n,i.getTypeChecker(),l,i.getCompilerOptions(),f(t),r,i.getSourceFiles())},getCompletionEntryDetails:function(t,r,a,o,s){h();var c=o?y(o):void 0;return e.Completions.getCompletionEntryDetails(i.getTypeChecker(),l,i.getCompilerOptions(),f(t),r,{name:a,source:s},i.getSourceFiles(),n,c)},getCompletionEntrySymbol:function(t,n,r,a){return h(),e.Completions.getCompletionEntrySymbol(i.getTypeChecker(),l,i.getCompilerOptions(),f(t),n,{name:r,source:a},i.getSourceFiles())},getSignatureHelpItems:function(t,n){h();var r=f(t);return e.SignatureHelp.getSignatureHelpItems(i,r,n,u)},getQuickInfoAtPosition:function(t,n){h();var r=f(t),a=e.getTouchingPropertyName(r,n,!0);if(a!==r&&!e.isLabelName(a)){var o=i.getTypeChecker(),s=function(t,n){if((e.isIdentifier(t)||e.isStringLiteral(t))&&e.isPropertyAssignment(t.parent)&&t.parent.name===t){var r=n.getContextualType(t.parent.parent);if(r){var i=n.getPropertyOfType(r,e.getTextOfIdentifierOrLiteral(t));if(i)return i}}return n.getSymbolAtLocation(t)}(a,o);if(s&&!o.isUnknownSymbol(s)){var c=e.SymbolDisplay.getSymbolDisplayPartsDocumentationAndSymbolKind(o,s,r,e.getContainerNode(a),a);return{kind:c.symbolKind,kindModifiers:e.SymbolDisplay.getSymbolModifiers(s),textSpan:e.createTextSpan(a.getStart(),a.getWidth()),displayParts:c.displayParts,documentation:c.documentation,tags:c.tags}}switch(a.kind){case 71:case 179:case 143:case 99:case 169:case 97:var u=o.getTypeAtLocation(a);if(u)return{kind:"",kindModifiers:"",textSpan:e.createTextSpan(a.getStart(),a.getWidth()),displayParts:e.typeToDisplayParts(o,u,e.getContainerNode(a)),documentation:u.symbol?u.symbol.getDocumentationComment():void 0,tags:u.symbol?u.symbol.getJsDocTags():void 0}}}},getDefinitionAtPosition:function(t,n){return h(),e.GoToDefinition.getDefinitionAtPosition(i,f(t),n)},getImplementationAtPosition:function(t,n){return h(),e.FindAllReferences.getImplementationsAtPosition(i,u,i.getSourceFiles(),f(t),n)},getTypeDefinitionAtPosition:function(t,n){return h(),e.GoToDefinition.getTypeDefinitionAtPosition(i.getTypeChecker(),f(t),n)},getReferencesAtPosition:function(e,t){return k(e,t)},findReferences:function(t,n){return h(),e.FindAllReferences.findReferencedSymbols(i,u,i.getSourceFiles(),f(t),n)},getOccurrencesAtPosition:function(t,n){var r=function(e,t){return n(x(e,t,[e]));function n(e){if(e){for(var t=[],n=0,r=e;n<r.length;n++)for(var i=r[n],a=0,o=i.highlightSpans;a<o.length;a++){var s=o[a];t.push({fileName:i.fileName,textSpan:s.textSpan,isWriteAccess:"writtenReference"===s.kind,isDefinition:!1,isInString:s.isInString})}return t}}}(t,n);if(r){var i=p(e.normalizeSlashes(t));r=e.filter(r,(function(t){return p(e.normalizeSlashes(t.fileName))===i}))}return r},getDocumentHighlights:x,getNameOrDottedNameSpan:function(t,n,r){var i=o.getCurrentSourceFile(t),a=e.getTouchingPropertyName(i,n,!1);if(a!==i){switch(a.kind){case 179:case 143:case 9:case 86:case 101:case 95:case 97:case 99:case 169:case 71:break;default:return}for(var s=a;;)if(e.isRightSideOfPropertyAccess(s)||e.isRightSideOfQualifiedName(s))s=s.parent;else{if(!e.isNameOfModuleDeclaration(s))break;if(233!==s.parent.parent.kind||s.parent.parent.body!==s.parent)break;s=s.parent.parent.name}return e.createTextSpanFromBounds(s.getStart(),a.getEnd())}},getBreakpointStatementAtPosition:function(t,n){var r=o.getCurrentSourceFile(t);return e.BreakpointResolver.spanInSourceFileAtLocation(r,n)},getNavigateToItems:function(t,n,r,a){h();var o=r?[f(r)]:i.getSourceFiles();return e.NavigateTo.getNavigateToItems(o,i.getTypeChecker(),u,t,n,a)},getRenameInfo:function(t,r){h();var a=n.getDefaultLibFileName(n.getCompilationSettings());return e.Rename.getRenameInfo(i.getTypeChecker(),a,p,f(t),r)},findRenameLocations:function(e,t,n,r){return k(e,t,{findInStrings:n,findInComments:r,isForRename:!0})},getNavigationBarItems:function(t){return e.NavigationBar.getNavigationBarItems(o.getCurrentSourceFile(t),u)},getNavigationTree:function(t){return e.NavigationBar.getNavigationTree(o.getCurrentSourceFile(t),u)},getOutliningSpans:function(t){var n=o.getCurrentSourceFile(t);return e.OutliningElementsCollector.collectElements(n,u)},getTodoComments:function(t,n){h();var r=f(t);u.throwIfCancellationRequested();var i,a,o=r.text,s=[];if(n.length>0&&(a=r.fileName,!e.stringContains(a,"/node_modules/")))for(var c=function(){var t="("+/(?:^(?:\s|\*)*)/.source+"|"+/(?:\/\/+\s*)/.source+"|"+/(?:\/\*+\s*)/.source+")",r="(?:"+e.map(n,(function(e){return"("+(e.text.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g,"\\$&")+")")})).join("|")+")";return new RegExp(t+"("+r+/(?:.*?)/.source+")"+/(?:$|\*\/)/.source,"gim")}(),_=void 0;_=c.exec(o);){u.throwIfCancellationRequested();e.Debug.assert(_.length===n.length+3);var l=_[1],d=_.index+l.length;if(e.isInComment(r,d)){for(var p=void 0,m=0;m<n.length;m++)_[m+3]&&(p=n[m]);if(e.Debug.assert(void 0!==p),!((i=o.charCodeAt(d+p.text.length))>=97&&i<=122||i>=65&&i<=90||i>=48&&i<=57)){var g=_[2];s.push({descriptor:p,message:g,position:d})}}}return s},getBraceMatchingAtPosition:function(t,n){var r=o.getCurrentSourceFile(t),i=[],a=e.getTouchingToken(r,n,!1);if(a.getStart(r)===n){var s=function(e){switch(e.kind){case 17:return 18;case 19:return 20;case 21:return 22;case 27:return 29;case 18:return 17;case 20:return 19;case 22:return 21;case 29:return 27}return}(a);if(s)for(var c=0,u=a.parent.getChildren(r);c<u.length;c++){var _=u[c];if(_.kind===s){var l=e.createTextSpan(a.getStart(r),a.getWidth(r)),d=e.createTextSpan(_.getStart(r),_.getWidth(r));l.start<d.start?i.push(l,d):i.push(d,l);break}}}return i},getIndentationAtPosition:function(t,n,r){var i=e.timestamp(),a=d(r),s=o.getCurrentSourceFile(t);l("getIndentationAtPosition: getCurrentSourceFile: "+(e.timestamp()-i)),i=e.timestamp();var c=e.formatting.SmartIndenter.getIndentation(n,s,a);return l("getIndentationAtPosition: computeIndentation  : "+(e.timestamp()-i)),c},getFormattingEditsForRange:function(t,n,r,i){var a=o.getCurrentSourceFile(t),s=d(i);return e.formatting.formatSelection(n,r,a,y(s),s)},getFormattingEditsForDocument:function(t,n){var r=o.getCurrentSourceFile(t),i=d(n);return e.formatting.formatDocument(r,y(i),i)},getFormattingEditsAfterKeystroke:function(t,n,r,i){var a=o.getCurrentSourceFile(t),s=d(i);if(!e.isInComment(a,n)){if("{"===r)return e.formatting.formatOnOpeningCurly(n,a,y(s),s);if("}"===r)return e.formatting.formatOnClosingCurly(n,a,y(s),s);if(";"===r)return e.formatting.formatOnSemicolon(n,a,y(s),s);if("\n"===r)return e.formatting.formatOnEnter(n,a,y(s),s)}return[]},getDocCommentTemplateAtPosition:function(t,r){return e.JsDoc.getDocCommentTemplateAtPosition(e.getNewLineOrDefaultFromHost(n),o.getCurrentSourceFile(t),r)},isValidBraceCompletionAtPosition:function(t,n,r){if(60===r)return!1;var i=o.getCurrentSourceFile(t);if(e.isInString(i,n))return!1;if(e.isInsideJsxElementOrAttribute(i,n))return 123===r;if(e.isInTemplateString(i,n))return!1;switch(r){case 39:case 34:case 96:return!e.isInComment(i,n)}return!0},getSpanOfEnclosingComment:function(t,n,r){var i=o.getCurrentSourceFile(t),a=e.formatting.getRangeOfEnclosingComment(i,n,r);return a&&e.createTextSpanFromRange(a)},getCodeFixesAtPosition:function(t,r,a,o,s){h();var c=f(t),_=e.createTextSpanFromBounds(r,a),l=e.getNewLineOrDefaultFromHost(n),d=y(s);return e.flatMap(e.deduplicate(o),(function(t){return u.throwIfCancellationRequested(),e.codefix.getFixes({errorCode:t,sourceFile:c,span:_,program:i,newLineCharacter:l,host:n,cancellationToken:u,rulesProvider:d})}))},applyCodeActionCommand:function(t,r){switch(t=e.toPath(t,_,p),r.type){case"install package":return n.installPackage?n.installPackage({fileName:t,packageName:r.packageName}):Promise.reject("Host does not implement `installPackage`");default:e.Debug.fail()}},getEmitOutput:function(t,r){h();var a=f(t),o=n.getCustomTransformers&&n.getCustomTransformers();return e.getFileEmitOutput(i,a,r,u,o)},getNonBoundSourceFile:S,getSourceFile:function(e){return S(e)},getProgram:v,getApplicableRefactors:function(t,n){h();var r=f(t);return e.refactor.getApplicableRefactors(C(r,n))},getEditsForRefactor:function(t,n,r,i,a){h();var o=f(t);return e.refactor.getEditsForRefactor(C(o,r,n),i,a)}}},e.getNameTable=function(t){return t.nameTable||function(t){var n=t.nameTable=e.createUnderscoreEscapedMap();t.forEachChild((function t(r){if(e.isIdentifier(r)&&r.escapedText||e.isStringOrNumericLiteral(r)&&function(t){return e.isDeclarationName(t)||248===t.parent.kind||function(e){return e&&e.parent&&180===e.parent.kind&&e.parent.argumentExpression===e}(t)||e.isLiteralComputedPropertyDeclarationName(t)}(r)){var i=e.getEscapedTextOfIdentifierOrLiteral(r);n.set(i,void 0===n.get(i)?r.pos:-1)}if(e.forEachChild(r,t),e.hasJSDocNodes(r))for(var a=0,o=r.jsDoc;a<o.length;a++){var s=o[a];e.forEachChild(s,t)}}))}(t),t.nameTable},e.getContainingObjectLiteralElement=function(e){switch(e.kind){case 9:case 8:if(144===e.parent.kind)return k(e.parent.parent)?e.parent.parent:void 0;case 71:return!k(e.parent)||178!==e.parent.parent.kind&&254!==e.parent.parent.kind||e.parent.name!==e?void 0:e.parent}},e.getPropertySymbolsFromContextualType=function(e,t){var n=t.parent;return S(e.getContextualType(n),t.name)},e.getPropertySymbolsFromType=S,e.getDefaultLibFilePath=function(t){if("undefined"!=typeof __dirname)return __dirname+e.directorySeparator+e.getDefaultLibFileName(t);throw new Error("getDefaultLibFilePath is only supported when consumed as a node module. ")},e.objectAllocator={getNodeConstructor:function(){return r},getTokenConstructor:function(){return o},getIdentifierConstructor:function(){return s},getSourceFileConstructor:function(){return _},getSymbolConstructor:function(){return a},getTypeConstructor:function(){return c},getSignatureConstructor:function(){return u},getSourceMapSourceConstructor:function(){return l}}}(ts||(ts={})),function(e){!function(t){t.spanInSourceFileAtLocation=function(t,n){if(!t.isDeclarationFile){var r=e.getTokenAtPosition(t,n,!1),i=t.getLineAndCharacterOfPosition(n).line;if((!(t.getLineAndCharacterOfPosition(r.getStart(t)).line>i)||(r=e.findPrecedingToken(r.pos,t))&&t.getLineAndCharacterOfPosition(r.getEnd()).line===i)&&!e.isInAmbientContext(r))return _(r)}function a(n,r){var i=n.decorators?e.skipTrivia(t.text,n.decorators.end):n.getStart(t);return e.createTextSpanFromBounds(i,(r||n).getEnd())}function o(t,n){return a(t,e.findNextToken(n,n.parent))}function s(e,n){return e&&i===t.getLineAndCharacterOfPosition(e.getStart(t)).line?_(e):_(n)}function c(n){return _(e.findPrecedingToken(n.pos,t))}function u(t){return _(e.findNextToken(t,t.parent))}function _(n){if(n)switch(n.kind){case 208:return p(n.declarationList.declarations[0]);case 226:case 149:case 148:return p(n);case 146:return function t(n){if(e.isBindingPattern(n.name))return y(n.name);if(function(t){return!!t.initializer||void 0!==t.dotDotDotToken||e.hasModifier(t,12)}(n))return a(n);var r=n.parent,i=e.indexOf(r.parameters,n);return i?t(r.parameters[i-1]):_(r.body)}(n);case 228:case 151:case 150:case 153:case 154:case 152:case 186:case 187:return function(e){if(!e.body)return;if(f(e))return a(e);return _(e.body)}(n);case 207:if(e.isFunctionBlock(n))return function(e){var t=e.statements.length?e.statements[0]:e.getLastToken();if(f(e.parent))return s(e.parent,t);return _(t)}(n);case 234:return m(n);case 260:return m(n.block);case 210:return a(n.expression);case 219:return a(n.getChildAt(0),n.expression);case 213:return o(n,n.expression);case 212:return _(n.statement);case 225:return a(n.getChildAt(0));case 211:return o(n,n.expression);case 222:return _(n.statement);case 218:case 217:return a(n.getChildAt(0),n.label);case 214:return function(e){if(e.initializer)return g(e);if(e.condition)return a(e.condition);if(e.incrementor)return a(e.incrementor)}(n);case 215:return o(n,n.expression);case 216:return g(n);case 221:return o(n,n.expression);case 257:case 258:return _(n.statements[0]);case 224:return m(n.tryBlock);case 223:case 243:return a(n,n.expression);case 237:return a(n,n.moduleReference);case 238:case 244:return a(n,n.moduleSpecifier);case 233:if(1!==e.getModuleInstanceState(n))return;case 229:case 232:case 264:case 176:return a(n);case 220:return _(n.statement);case 147:return l=n.parent.decorators,e.createTextSpanFromBounds(e.skipTrivia(t.text,l.pos),l.end);case 174:case 175:return y(n);case 230:case 231:return;case 25:case 1:return s(e.findPrecedingToken(n.pos,t));case 26:return c(n);case 17:return function(n){switch(n.parent.kind){case 232:var r=n.parent;return s(e.findPrecedingToken(n.pos,t,n.parent),r.members.length?r.members[0]:r.getLastToken(t));case 229:var i=n.parent;return s(e.findPrecedingToken(n.pos,t,n.parent),i.members.length?i.members[0]:i.getLastToken(t));case 235:return s(n.parent.parent,n.parent.clauses[0])}return _(n.parent)}(n);case 18:return function(t){switch(t.parent.kind){case 234:if(1!==e.getModuleInstanceState(t.parent.parent))return;case 232:case 229:return a(t);case 207:if(e.isFunctionBlock(t.parent))return a(t);case 260:return _(e.lastOrUndefined(t.parent.statements));case 235:var n=t.parent,r=e.lastOrUndefined(n.clauses);return r?_(e.lastOrUndefined(r.statements)):void 0;case 174:var i=t.parent;return _(e.lastOrUndefined(i.elements)||i);default:if(e.isArrayLiteralOrObjectLiteralDestructuringPattern(t.parent)){var o=t.parent;return a(e.lastOrUndefined(o.properties)||o)}return _(t.parent)}}(n);case 22:return function(t){switch(t.parent.kind){case 175:var n=t.parent;return a(e.lastOrUndefined(n.elements)||n);default:if(e.isArrayLiteralOrObjectLiteralDestructuringPattern(t.parent)){var r=t.parent;return a(e.lastOrUndefined(r.elements)||r)}return _(t.parent)}}(n);case 19:return function(e){if(212===e.parent.kind||181===e.parent.kind||182===e.parent.kind)return c(e);if(185===e.parent.kind)return u(e);return _(e.parent)}(n);case 20:return function(e){switch(e.parent.kind){case 186:case 228:case 187:case 151:case 150:case 153:case 154:case 152:case 213:case 212:case 214:case 216:case 181:case 182:case 185:return c(e);default:return _(e.parent)}}(n);case 56:return function(t){if(e.isFunctionLike(t.parent)||261===t.parent.kind||146===t.parent.kind)return c(t);return _(t.parent)}(n);case 29:case 27:return function(e){if(184===e.parent.kind)return u(e);return _(e.parent)}(n);case 106:return function(e){if(212===e.parent.kind)return o(e,e.parent.expression);return _(e.parent)}(n);case 82:case 74:case 87:return u(n);case 142:return function(e){if(216===e.parent.kind)return u(e);return _(e.parent)}(n);default:if(e.isArrayLiteralOrObjectLiteralDestructuringPattern(n))return h(n);if((71===n.kind||198===n.kind||261===n.kind||262===n.kind)&&e.isArrayLiteralOrObjectLiteralDestructuringPattern(n.parent))return a(n);if(194===n.kind){var r=n;if(e.isArrayLiteralOrObjectLiteralDestructuringPattern(r.left))return h(r.left);if(58===r.operatorToken.kind&&e.isArrayLiteralOrObjectLiteralDestructuringPattern(r.parent))return a(n);if(26===r.operatorToken.kind)return _(r.left)}if(e.isPartOfExpression(n))switch(n.parent.kind){case 212:return c(n);case 147:return _(n.parent);case 214:case 216:return a(n);case 194:if(26===n.parent.operatorToken.kind)return a(n);break;case 187:if(n.parent.body===n)return a(n)}if(261===n.parent.kind&&n.parent.name===n&&!e.isArrayLiteralOrObjectLiteralDestructuringPattern(n.parent.parent))return _(n.parent.initializer);if(184===n.parent.kind&&n.parent.type===n)return u(n.parent.type);if(e.isFunctionLike(n.parent)&&n.parent.type===n)return c(n);if(226===n.parent.kind||146===n.parent.kind){var i=n.parent;if(i.initializer===n||i.type===n||e.isAssignmentOperator(n.kind))return c(n)}if(194===n.parent.kind){r=n.parent;if(e.isArrayLiteralOrObjectLiteralDestructuringPattern(r.left)&&(r.right===n||r.operatorToken===n))return c(n)}return _(n.parent)}var l;function d(n){return 227===n.parent.kind&&n.parent.declarations[0]===n?a(e.findPrecedingToken(n.pos,t,n.parent),n):a(n)}function p(n){return 215===n.parent.parent.kind?_(n.parent.parent):e.isBindingPattern(n.name)?y(n.name):n.initializer||e.hasModifier(n,1)||216===n.parent.parent.kind?d(n):227===n.parent.kind&&n.parent.declarations[0]!==n?_(e.findPrecedingToken(n.pos,t,n.parent)):void 0}function f(t){return e.hasModifier(t,1)||229===t.parent.kind&&152!==t.kind}function m(n){switch(n.parent.kind){case 233:if(1!==e.getModuleInstanceState(n.parent))return;case 213:case 211:case 215:return s(n.parent,n.statements[0]);case 214:case 216:return s(e.findPrecedingToken(n.pos,t,n.parent),n.statements[0])}return _(n.statements[0])}function g(e){if(227!==e.initializer.kind)return _(e.initializer);var t=e.initializer;return t.declarations.length>0?_(t.declarations[0]):void 0}function y(t){var n=e.forEach(t.elements,(function(e){return 200!==e.kind?e:void 0}));return n?_(n):176===t.parent.kind?a(t.parent):d(t.parent)}function h(t){e.Debug.assert(175!==t.kind&&174!==t.kind);var n=177===t.kind?t.elements:t.properties,r=e.forEach(n,(function(e){return 200!==e.kind?e:void 0}));return r?_(r):a(194===t.parent.kind?t.parent:t)}}}}(e.BreakpointResolver||(e.BreakpointResolver={}))}(ts||(ts={})),function(e){e.transform=function(t,n,r){var i=[];r=e.fixupCompilerOptions(r,i);var a=e.isArray(t)?t:[t],o=e.transformNodes(void 0,void 0,r,a,n,!0);return o.diagnostics=e.concatenate(o.diagnostics,i),o}}(ts||(ts={}));var ts,TypeScript,debugObjectHost=function(){return this}();!function(e){function t(e,t){e&&e.log("*INTERNAL ERROR* - Exception in typescript services: "+t.message)}var n=function(){function t(e){this.scriptSnapshotShim=e}return t.prototype.getText=function(e,t){return this.scriptSnapshotShim.getText(e,t)},t.prototype.getLength=function(){return this.scriptSnapshotShim.getLength()},t.prototype.getChangeRange=function(t){var n=t,r=this.scriptSnapshotShim.getChangeRange(n.scriptSnapshotShim);if(null===r)return null;var i=JSON.parse(r);return e.createTextChangeRange(e.createTextSpan(i.span.start,i.span.length),i.newLength)},t.prototype.dispose=function(){"dispose"in this.scriptSnapshotShim&&this.scriptSnapshotShim.dispose()},t}(),r=function(){function t(t){var n=this;this.shimHost=t,this.loggingEnabled=!1,this.tracingEnabled=!1,"getModuleResolutionsForFile"in this.shimHost&&(this.resolveModuleNames=function(t,r){var i=JSON.parse(n.shimHost.getModuleResolutionsForFile(r));return e.map(t,(function(t){var n=e.getProperty(i,t);return n?{resolvedFileName:n,extension:e.extensionFromPath(n),isExternalLibraryImport:!1}:void 0}))}),"directoryExists"in this.shimHost&&(this.directoryExists=function(e){return n.shimHost.directoryExists(e)}),"getTypeReferenceDirectiveResolutionsForFile"in this.shimHost&&(this.resolveTypeReferenceDirectives=function(t,r){var i=JSON.parse(n.shimHost.getTypeReferenceDirectiveResolutionsForFile(r));return e.map(t,(function(t){return e.getProperty(i,t)}))})}return t.prototype.log=function(e){this.loggingEnabled&&this.shimHost.log(e)},t.prototype.trace=function(e){this.tracingEnabled&&this.shimHost.trace(e)},t.prototype.error=function(e){this.shimHost.error(e)},t.prototype.getProjectVersion=function(){if(this.shimHost.getProjectVersion)return this.shimHost.getProjectVersion()},t.prototype.getTypeRootsVersion=function(){return this.shimHost.getTypeRootsVersion?this.shimHost.getTypeRootsVersion():0},t.prototype.useCaseSensitiveFileNames=function(){return!!this.shimHost.useCaseSensitiveFileNames&&this.shimHost.useCaseSensitiveFileNames()},t.prototype.getCompilationSettings=function(){var e=this.shimHost.getCompilationSettings();if(null===e||""===e)throw Error("LanguageServiceShimHostAdapter.getCompilationSettings: empty compilationSettings");var t=JSON.parse(e);return t.allowNonTsExtensions=!0,t},t.prototype.getScriptFileNames=function(){var e=this.shimHost.getScriptFileNames();return this.files=JSON.parse(e)},t.prototype.getScriptSnapshot=function(e){var t=this.shimHost.getScriptSnapshot(e);return t&&new n(t)},t.prototype.getScriptKind=function(e){return"getScriptKind"in this.shimHost?this.shimHost.getScriptKind(e):0},t.prototype.getScriptVersion=function(e){return this.shimHost.getScriptVersion(e)},t.prototype.getLocalizedDiagnosticMessages=function(){var e=this.shimHost.getLocalizedDiagnosticMessages();if(null===e||""===e)return null;try{return JSON.parse(e)}catch(e){return this.log(e.description||"diagnosticMessages.generated.json has invalid JSON format"),null}},t.prototype.getCancellationToken=function(){var t=this.shimHost.getCancellationToken();return new e.ThrottledCancellationToken(t)},t.prototype.getCurrentDirectory=function(){return this.shimHost.getCurrentDirectory()},t.prototype.getDirectories=function(e){return JSON.parse(this.shimHost.getDirectories(e))},t.prototype.getDefaultLibFileName=function(e){return this.shimHost.getDefaultLibFileName(JSON.stringify(e))},t.prototype.readDirectory=function(t,n,r,i,a){var o=e.getFileMatcherPatterns(t,r,i,this.shimHost.useCaseSensitiveFileNames(),this.shimHost.getCurrentDirectory());return JSON.parse(this.shimHost.readDirectory(t,JSON.stringify(n),JSON.stringify(o.basePaths),o.excludePattern,o.includeFilePattern,o.includeDirectoryPattern,a))},t.prototype.readFile=function(e,t){return this.shimHost.readFile(e,t)},t.prototype.fileExists=function(e){return this.shimHost.fileExists(e)},t}();e.LanguageServiceShimHostAdapter=r;var i=function(){function t(e){var t=this;this.shimHost=e,this.useCaseSensitiveFileNames=!!this.shimHost.useCaseSensitiveFileNames&&this.shimHost.useCaseSensitiveFileNames(),"directoryExists"in this.shimHost&&(this.directoryExists=function(e){return t.shimHost.directoryExists(e)}),"realpath"in this.shimHost&&(this.realpath=function(e){return t.shimHost.realpath(e)})}return t.prototype.readDirectory=function(t,n,r,i,a){var o=e.getFileMatcherPatterns(t,r,i,this.shimHost.useCaseSensitiveFileNames(),this.shimHost.getCurrentDirectory());return JSON.parse(this.shimHost.readDirectory(t,JSON.stringify(n),JSON.stringify(o.basePaths),o.excludePattern,o.includeFilePattern,o.includeDirectoryPattern,a))},t.prototype.fileExists=function(e){return this.shimHost.fileExists(e)},t.prototype.readFile=function(e){return this.shimHost.readFile(e)},t.prototype.getDirectories=function(e){return JSON.parse(this.shimHost.getDirectories(e))},t}();function a(e,t,n,r){return o(e,t,!0,n,r)}function o(n,r,i,a,o){try{var s=function(t,n,r,i){var a;i&&(t.log(n),a=e.timestamp());var o=r();if(i){var s=e.timestamp();if(t.log(n+" completed in "+(s-a)+" msec"),e.isString(o)){var c=o;c.length>128&&(c=c.substring(0,128)+"..."),t.log("  result.length="+c.length+", result='"+JSON.stringify(c)+"'")}}return o}(n,r,a,o);return i?JSON.stringify({result:s}):s}catch(i){return i instanceof e.OperationCanceledException?JSON.stringify({canceled:!0}):(t(n,i),i.description=r,JSON.stringify({error:i}))}}e.CoreServicesShimHostAdapter=i;var s=function(){function e(e){this.factory=e,e.registerShim(this)}return e.prototype.dispose=function(e){this.factory.unregisterShim(this)},e}();function c(t,n){return t.map((function(t){return function(t,n){return{message:e.flattenDiagnosticMessageText(t.messageText,n),start:t.start,length:t.length,category:e.DiagnosticCategory[t.category].toLowerCase(),code:t.code}}(t,n)}))}e.realizeDiagnostics=c;var u=function(t){function n(e,n,r){var i=t.call(this,e)||this;return i.host=n,i.languageService=r,i.logPerformance=!1,i.logger=i.host,i}return __extends(n,t),n.prototype.forwardJSONCall=function(e,t){return a(this.logger,e,t,this.logPerformance)},n.prototype.dispose=function(e){this.logger.log("dispose()"),this.languageService.dispose(),this.languageService=null,debugObjectHost&&debugObjectHost.CollectGarbage&&(debugObjectHost.CollectGarbage(),this.logger.log("CollectGarbage()")),this.logger=null,t.prototype.dispose.call(this,e)},n.prototype.refresh=function(e){this.forwardJSONCall("refresh("+e+")",(function(){return null}))},n.prototype.cleanupSemanticCache=function(){var e=this;this.forwardJSONCall("cleanupSemanticCache()",(function(){return e.languageService.cleanupSemanticCache(),null}))},n.prototype.realizeDiagnostics=function(t){var n=e.getNewLineOrDefaultFromHost(this.host);return e.realizeDiagnostics(t,n)},n.prototype.getSyntacticClassifications=function(t,n,r){var i=this;return this.forwardJSONCall("getSyntacticClassifications('"+t+"', "+n+", "+r+")",(function(){return i.languageService.getSyntacticClassifications(t,e.createTextSpan(n,r))}))},n.prototype.getSemanticClassifications=function(t,n,r){var i=this;return this.forwardJSONCall("getSemanticClassifications('"+t+"', "+n+", "+r+")",(function(){return i.languageService.getSemanticClassifications(t,e.createTextSpan(n,r))}))},n.prototype.getEncodedSyntacticClassifications=function(t,n,r){var i=this;return this.forwardJSONCall("getEncodedSyntacticClassifications('"+t+"', "+n+", "+r+")",(function(){return _(i.languageService.getEncodedSyntacticClassifications(t,e.createTextSpan(n,r)))}))},n.prototype.getEncodedSemanticClassifications=function(t,n,r){var i=this;return this.forwardJSONCall("getEncodedSemanticClassifications('"+t+"', "+n+", "+r+")",(function(){return _(i.languageService.getEncodedSemanticClassifications(t,e.createTextSpan(n,r)))}))},n.prototype.getSyntacticDiagnostics=function(e){var t=this;return this.forwardJSONCall("getSyntacticDiagnostics('"+e+"')",(function(){var n=t.languageService.getSyntacticDiagnostics(e);return t.realizeDiagnostics(n)}))},n.prototype.getSemanticDiagnostics=function(e){var t=this;return this.forwardJSONCall("getSemanticDiagnostics('"+e+"')",(function(){var n=t.languageService.getSemanticDiagnostics(e);return t.realizeDiagnostics(n)}))},n.prototype.getCompilerOptionsDiagnostics=function(){var e=this;return this.forwardJSONCall("getCompilerOptionsDiagnostics()",(function(){var t=e.languageService.getCompilerOptionsDiagnostics();return e.realizeDiagnostics(t)}))},n.prototype.getQuickInfoAtPosition=function(e,t){var n=this;return this.forwardJSONCall("getQuickInfoAtPosition('"+e+"', "+t+")",(function(){return n.languageService.getQuickInfoAtPosition(e,t)}))},n.prototype.getNameOrDottedNameSpan=function(e,t,n){var r=this;return this.forwardJSONCall("getNameOrDottedNameSpan('"+e+"', "+t+", "+n+")",(function(){return r.languageService.getNameOrDottedNameSpan(e,t,n)}))},n.prototype.getBreakpointStatementAtPosition=function(e,t){var n=this;return this.forwardJSONCall("getBreakpointStatementAtPosition('"+e+"', "+t+")",(function(){return n.languageService.getBreakpointStatementAtPosition(e,t)}))},n.prototype.getSignatureHelpItems=function(e,t){var n=this;return this.forwardJSONCall("getSignatureHelpItems('"+e+"', "+t+")",(function(){return n.languageService.getSignatureHelpItems(e,t)}))},n.prototype.getDefinitionAtPosition=function(e,t){var n=this;return this.forwardJSONCall("getDefinitionAtPosition('"+e+"', "+t+")",(function(){return n.languageService.getDefinitionAtPosition(e,t)}))},n.prototype.getTypeDefinitionAtPosition=function(e,t){var n=this;return this.forwardJSONCall("getTypeDefinitionAtPosition('"+e+"', "+t+")",(function(){return n.languageService.getTypeDefinitionAtPosition(e,t)}))},n.prototype.getImplementationAtPosition=function(e,t){var n=this;return this.forwardJSONCall("getImplementationAtPosition('"+e+"', "+t+")",(function(){return n.languageService.getImplementationAtPosition(e,t)}))},n.prototype.getRenameInfo=function(e,t){var n=this;return this.forwardJSONCall("getRenameInfo('"+e+"', "+t+")",(function(){return n.languageService.getRenameInfo(e,t)}))},n.prototype.findRenameLocations=function(e,t,n,r){var i=this;return this.forwardJSONCall("findRenameLocations('"+e+"', "+t+", "+n+", "+r+")",(function(){return i.languageService.findRenameLocations(e,t,n,r)}))},n.prototype.getBraceMatchingAtPosition=function(e,t){var n=this;return this.forwardJSONCall("getBraceMatchingAtPosition('"+e+"', "+t+")",(function(){return n.languageService.getBraceMatchingAtPosition(e,t)}))},n.prototype.isValidBraceCompletionAtPosition=function(e,t,n){var r=this;return this.forwardJSONCall("isValidBraceCompletionAtPosition('"+e+"', "+t+", "+n+")",(function(){return r.languageService.isValidBraceCompletionAtPosition(e,t,n)}))},n.prototype.getSpanOfEnclosingComment=function(e,t,n){var r=this;return this.forwardJSONCall("getSpanOfEnclosingComment('"+e+"', "+t+")",(function(){return r.languageService.getSpanOfEnclosingComment(e,t,n)}))},n.prototype.getIndentationAtPosition=function(e,t,n){var r=this;return this.forwardJSONCall("getIndentationAtPosition('"+e+"', "+t+")",(function(){var i=JSON.parse(n);return r.languageService.getIndentationAtPosition(e,t,i)}))},n.prototype.getReferencesAtPosition=function(e,t){var n=this;return this.forwardJSONCall("getReferencesAtPosition('"+e+"', "+t+")",(function(){return n.languageService.getReferencesAtPosition(e,t)}))},n.prototype.findReferences=function(e,t){var n=this;return this.forwardJSONCall("findReferences('"+e+"', "+t+")",(function(){return n.languageService.findReferences(e,t)}))},n.prototype.getOccurrencesAtPosition=function(e,t){var n=this;return this.forwardJSONCall("getOccurrencesAtPosition('"+e+"', "+t+")",(function(){return n.languageService.getOccurrencesAtPosition(e,t)}))},n.prototype.getDocumentHighlights=function(t,n,r){var i=this;return this.forwardJSONCall("getDocumentHighlights('"+t+"', "+n+")",(function(){var a=i.languageService.getDocumentHighlights(t,n,JSON.parse(r)),o=e.normalizeSlashes(t).toLowerCase();return e.filter(a,(function(t){return e.normalizeSlashes(t.fileName).toLowerCase()===o}))}))},n.prototype.getCompletionsAtPosition=function(e,t){var n=this;return this.forwardJSONCall("getCompletionsAtPosition('"+e+"', "+t+")",(function(){return n.languageService.getCompletionsAtPosition(e,t)}))},n.prototype.getCompletionEntryDetails=function(e,t,n,r,i){var a=this;return this.forwardJSONCall("getCompletionEntryDetails('"+e+"', "+t+", '"+n+"')",(function(){var o=JSON.parse(r);return a.languageService.getCompletionEntryDetails(e,t,n,o,i)}))},n.prototype.getFormattingEditsForRange=function(e,t,n,r){var i=this;return this.forwardJSONCall("getFormattingEditsForRange('"+e+"', "+t+", "+n+")",(function(){var a=JSON.parse(r);return i.languageService.getFormattingEditsForRange(e,t,n,a)}))},n.prototype.getFormattingEditsForDocument=function(e,t){var n=this;return this.forwardJSONCall("getFormattingEditsForDocument('"+e+"')",(function(){var r=JSON.parse(t);return n.languageService.getFormattingEditsForDocument(e,r)}))},n.prototype.getFormattingEditsAfterKeystroke=function(e,t,n,r){var i=this;return this.forwardJSONCall("getFormattingEditsAfterKeystroke('"+e+"', "+t+", '"+n+"')",(function(){var a=JSON.parse(r);return i.languageService.getFormattingEditsAfterKeystroke(e,t,n,a)}))},n.prototype.getDocCommentTemplateAtPosition=function(e,t){var n=this;return this.forwardJSONCall("getDocCommentTemplateAtPosition('"+e+"', "+t+")",(function(){return n.languageService.getDocCommentTemplateAtPosition(e,t)}))},n.prototype.getNavigateToItems=function(e,t,n){var r=this;return this.forwardJSONCall("getNavigateToItems('"+e+"', "+t+", "+n+")",(function(){return r.languageService.getNavigateToItems(e,t,n)}))},n.prototype.getNavigationBarItems=function(e){var t=this;return this.forwardJSONCall("getNavigationBarItems('"+e+"')",(function(){return t.languageService.getNavigationBarItems(e)}))},n.prototype.getNavigationTree=function(e){var t=this;return this.forwardJSONCall("getNavigationTree('"+e+"')",(function(){return t.languageService.getNavigationTree(e)}))},n.prototype.getOutliningSpans=function(e){var t=this;return this.forwardJSONCall("getOutliningSpans('"+e+"')",(function(){return t.languageService.getOutliningSpans(e)}))},n.prototype.getTodoComments=function(e,t){var n=this;return this.forwardJSONCall("getTodoComments('"+e+"')",(function(){return n.languageService.getTodoComments(e,JSON.parse(t))}))},n.prototype.getEmitOutput=function(e){var t=this;return this.forwardJSONCall("getEmitOutput('"+e+"')",(function(){return t.languageService.getEmitOutput(e)}))},n.prototype.getEmitOutputObject=function(e){var t=this;return o(this.logger,"getEmitOutput('"+e+"')",!1,(function(){return t.languageService.getEmitOutput(e)}),this.logPerformance)},n}(s);function _(e){return{spans:e.spans.join(","),endOfLineState:e.endOfLineState}}var l=function(t){function n(n,r){var i=t.call(this,n)||this;return i.logger=r,i.logPerformance=!1,i.classifier=e.createClassifier(),i}return __extends(n,t),n.prototype.getEncodedLexicalClassifications=function(e,t,n){var r=this;return a(this.logger,"getEncodedLexicalClassifications",(function(){return _(r.classifier.getEncodedLexicalClassifications(e,t,n))}),this.logPerformance)},n.prototype.getClassificationsForLine=function(e,t,n){for(var r=this.classifier.getClassificationsForLine(e,t,n),i="",a=0,o=r.entries;a<o.length;a++){var s=o[a];i+=s.length+"\n",i+=s.classification+"\n"}return i+=r.finalLexState},n}(s),d=function(t){function n(e,n,r){var i=t.call(this,e)||this;return i.logger=n,i.host=r,i.logPerformance=!1,i}return __extends(n,t),n.prototype.forwardJSONCall=function(e,t){return a(this.logger,e,t,this.logPerformance)},n.prototype.resolveModuleName=function(t,n,r){var i=this;return this.forwardJSONCall("resolveModuleName('"+t+"')",(function(){var a=JSON.parse(r),o=e.resolveModuleName(n,e.normalizeSlashes(t),a,i.host),s=o.resolvedModule?o.resolvedModule.resolvedFileName:void 0;return o.resolvedModule&&".ts"!==o.resolvedModule.extension&&".tsx"!==o.resolvedModule.extension&&".d.ts"!==o.resolvedModule.extension&&(s=void 0),{resolvedFileName:s,failedLookupLocations:o.failedLookupLocations}}))},n.prototype.resolveTypeReferenceDirective=function(t,n,r){var i=this;return this.forwardJSONCall("resolveTypeReferenceDirective("+t+")",(function(){var a=JSON.parse(r),o=e.resolveTypeReferenceDirective(n,e.normalizeSlashes(t),a,i.host);return{resolvedFileName:o.resolvedTypeReferenceDirective?o.resolvedTypeReferenceDirective.resolvedFileName:void 0,primary:!o.resolvedTypeReferenceDirective||o.resolvedTypeReferenceDirective.primary,failedLookupLocations:o.failedLookupLocations}}))},n.prototype.getPreProcessedFileInfo=function(t,n){var r=this;return this.forwardJSONCall("getPreProcessedFileInfo('"+t+"')",(function(){var t=e.preProcessFile(n.getText(0,n.getLength()),!0,!0);return{referencedFiles:r.convertFileReferences(t.referencedFiles),importedFiles:r.convertFileReferences(t.importedFiles),ambientExternalModules:t.ambientExternalModules,isLibFile:t.isLibFile,typeReferenceDirectives:r.convertFileReferences(t.typeReferenceDirectives)}}))},n.prototype.getAutomaticTypeDirectiveNames=function(t){var n=this;return this.forwardJSONCall("getAutomaticTypeDirectiveNames('"+t+"')",(function(){var r=JSON.parse(t);return e.getAutomaticTypeDirectiveNames(r,n.host)}))},n.prototype.convertFileReferences=function(t){if(t){for(var n=[],r=0,i=t;r<i.length;r++){var a=i[r];n.push({path:e.normalizeSlashes(a.fileName),position:a.pos,length:a.end-a.pos})}return n}},n.prototype.getTSConfigFileInfo=function(t,n){var r=this;return this.forwardJSONCall("getTSConfigFileInfo('"+t+"')",(function(){var i=n.getText(0,n.getLength()),a=e.parseJsonText(t,i),o=e.normalizeSlashes(t),s=e.parseJsonSourceFileConfigFileContent(a,r.host,e.getDirectoryPath(o),{},o);return{options:s.options,typeAcquisition:s.typeAcquisition,files:s.fileNames,raw:s.raw,errors:c(a.parseDiagnostics.concat(s.errors),"\r\n")}}))},n.prototype.getDefaultCompilationSettings=function(){return this.forwardJSONCall("getDefaultCompilationSettings()",(function(){return e.getDefaultCompilerOptions()}))},n.prototype.discoverTypings=function(t){var n=this,r=e.createGetCanonicalFileName(!1);return this.forwardJSONCall("discoverTypings()",(function(){var i=JSON.parse(t);return void 0===n.safeList&&(n.safeList=e.JsTyping.loadSafeList(n.host,e.toPath(i.safeListPath,i.safeListPath,r))),e.JsTyping.discoverTypings(n.host,(function(e){return n.logger.log(e)}),i.fileNames,e.toPath(i.projectRootPath,i.projectRootPath,r),n.safeList,i.packageNameToTypingLocation,i.typeAcquisition,i.unresolvedImports)}))},n}(s),p=function(){function n(){this._shims=[]}return n.prototype.getServicesVersion=function(){return e.servicesVersion},n.prototype.createLanguageServiceShim=function(n){try{void 0===this.documentRegistry&&(this.documentRegistry=e.createDocumentRegistry(n.useCaseSensitiveFileNames&&n.useCaseSensitiveFileNames(),n.getCurrentDirectory()));var i=new r(n),a=e.createLanguageService(i,this.documentRegistry);return new u(this,n,a)}catch(e){throw t(n,e),e}},n.prototype.createClassifierShim=function(e){try{return new l(this,e)}catch(n){throw t(e,n),n}},n.prototype.createCoreServicesShim=function(e){try{var n=new i(e);return new d(this,e,n)}catch(n){throw t(e,n),n}},n.prototype.close=function(){e.clear(this._shims),this.documentRegistry=void 0},n.prototype.registerShim=function(e){this._shims.push(e)},n.prototype.unregisterShim=function(e){for(var t=0;t<this._shims.length;t++)if(this._shims[t]===e)return void delete this._shims[t];throw new Error("Invalid operation")},n}();e.TypeScriptServicesFactory=p,"undefined"!=typeof module&&module.exports&&(module.exports=e)}(ts||(ts={})),function(e){!function(e){e.TypeScriptServicesFactory=ts.TypeScriptServicesFactory}(e.Services||(e.Services={}))}(TypeScript||(TypeScript={}));var toolsVersion="2.6";